#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "90f7b6b09a615e8dcda829cbe082fd644f9c0961";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "ast";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"util\" as util",
  "import \"mgcollections\" as collections",
  "",
  "// This module contains pseudo-classes for all the AST nodes used",
  "// in the parser. The module predates the existence of classes in the",
  "// implementation, so they are written as object literals inside methods.",
  "// Each node has a different signature according to its function, but the",
  "// common interface is:",
  "// dtype ASTNode {",
  "//   kind -> String // Used for pseudo-instanceof tests.",
  "//   register -> String // Used later on to hold the LLVM register of",
  "//                      // the resulting object.",
  "//   line -> Number // The source line the node came from.",
  "//   pretty(n:Number) -> String // Pretty-print of node at depth n,",
  "// }",
  "// Most also contain \"value\", with varied dtypes, holding the main value",
  "// in the node. Some contain other fields for their specific use: while has",
  "// both a value (the condition) and a \"body\", for example. None of the nodes",
  "// are particularly notable in any way.",
  "",
  "method listMap(l, b)before(blkBefore)after(blkAfter) {",
  "    def r = collections.list.new",
  "    for (l) do {v->",
  "        def replacement = v.map(b)before(blkBefore)after(blkAfter)",
  "        r.push(replacement)",
  "    }",
  "    r",
  "}",
  "method maybeMap(n, b, before, after) {",
  "    if (n != false) then {",
  "        return n.map(b)before(before)after(after)",
  "    }",
  "    n",
  "}",
  "",
  "class baseNode.new {",
  "    var register := \"\"",
  "    var line := util.linenum",
  "    var linePos := util.linepos",
  "    var lineLength := 0",
  "}",
  "",
  "class forNode.new(over, body') {",
  "    inherits baseNode.new",
  "    def kind = \"for\"",
  "    def value = over",
  "    def body = body'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitFor(self)) then {",
  "            self.value.accept(visitor)",
  "            self.body.accept(visitor)",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"For\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Do:\"",
  "        s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.body.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"for ({self.value.toGrace(0)}) do \"",
  "        s := s ++ self.body.toGrace(depth)",
  "        s",
  "    }",
  "}",
  "class whileNode.new(cond, body') {",
  "    inherits baseNode.new",
  "    def kind = \"while\"",
  "    def value = cond",
  "    def body = body'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitWhile(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.body) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"While\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Do:\"",
  "        for (self.body) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"while \\{{self.value.toGrace(depth + 1)}\\} do \\{\"",
  "        for (self.body) do { x ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class ifNode.new(cond, thenblock', elseblock') {",
  "    inherits baseNode.new",
  "    def kind = \"if\"",
  "    def value = cond",
  "    def thenblock = thenblock'",
  "    def elseblock = elseblock'",
  "    var handledIdentifiers := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIf(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.thenblock) do { ix ->",
  "                ix.accept(visitor)",
  "            }",
  "            for (self.elseblock) do { ix ->",
  "                ix.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        def v = self.value.map(blk)before(blkBefore)after(blkAfter)",
  "        def tb = listMap(self.thenblock, blk)before(blkBefore)after(blkAfter)",
  "        blkAfter.apply(self)",
  "        blkBefore.apply(self)",
  "        def eb = listMap(self.elseblock, blk)before(blkBefore)after(blkAfter)",
  "        var n := ifNode.new(v, tb, eb)",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"If\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Then:\"",
  "        for (self.thenblock) do { ix ->",
  "            s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Else:\"",
  "        for (self.elseblock) do { ix ->",
  "            s := s ++ \"\\n  \"++ spc ++ ix.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"if ({self.value.toGrace(0)}) then \\{\"",
  "        for (self.thenblock) do { ix ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "        }",
  "        if (self.elseblock.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\} else \\{\"",
  "            for (self.elseblock) do { ix ->",
  "                s := s ++ \"\\n\" ++ spc ++ \"    \" ++ ix.toGrace(depth + 1)",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class blockNode.new(params', body') {",
  "    inherits baseNode.new",
  "    def kind = \"block\"",
  "    def value = \"block\"",
  "    def params = params'",
  "    def body = body'",
  "    def selfclosure = true",
  "    var matchingPattern := false",
  "    var extraRuntimeData := false",
  "    for (params') do {p->",
  "        p.accept(patternMarkVisitor)",
  "    }",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitBlock(self)) then {",
  "            for (self.params) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.matchingPattern != false) then {",
  "                self.matchingPattern.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blockNode.new(listMap(params, blk)before(blkBefore)after(blkAfter),",
  "            listMap(body, blk)before(blkBefore)after(blkAfter))",
  "        if (self.matchingPattern != false) then {",
  "            n.matchingPattern := self.matchingPattern.map(blk)",
  "                before(blkBefore)after(blkAfter)",
  "        }",
  "        n := blk.apply(n)",
  "        n.extraRuntimeData := extraRuntimeData",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Block\\n\"",
  "        s := s ++ spc ++ \"Parameters:\"",
  "        for (self.params) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        if (self.matchingPattern != false) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ \"Pattern:\"",
  "            s := s ++ \"\\n  \"++ spc ++ self.matchingPattern.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\\{\"",
  "        if (self.params.size > 0) then {",
  "            s := s ++ \" \"",
  "            for (self.params.indices) do { i ->",
  "                var p := self.params[i]",
  "                if (self.matchingPattern != false) then {",
  "                    s := s ++ \"(\" ++ p.toGrace(0) ++ \")\"",
  "                } else {",
  "                    s := s ++ p.toGrace(0)",
  "                }",
  "                if (i < self.params.size) then {",
  "                    s := s ++ \", \"",
  "                } else {",
  "                    s := s ++ \" ->\"",
  "                }",
  "            }",
  "        }",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class catchCaseNode.new(block, cases', finally') {",
  "    inherits baseNode.new",
  "    def kind = \"catchcase\"",
  "    def value = block",
  "    def cases = cases'",
  "    def finally = finally'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitCatchCase(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.finally != false) then {",
  "                self.finally.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := catchCaseNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(cases, blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(finally, blk, blkBefore, blkAfter))",
  "        n.line := line",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Catch\\n\"",
  "        s := s ++ spc ++ value.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.finally) then {",
  "            s := s ++ \"\\n{spc}Finally:\\n{spc}  {self.finally.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"catch \" ++ self.value.toGrace(0) ++ \" \"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.finally != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"finally \" ++ self.finally.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "}",
  "class matchCaseNode.new(matchee, cases', elsecase') {",
  "    inherits baseNode.new",
  "    def kind = \"matchcase\"",
  "    def value = matchee",
  "    def cases = cases'",
  "    def elsecase = elsecase'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMatchCase(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.cases) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "            if (self.elsecase != false) then {",
  "                self.elsecase.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        def newcases = listMap(cases, blk)before(blkBefore)after(blkAfter)",
  "        var n := matchCaseNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            newcases,",
  "            maybeMap(elsecase, blk, blkBefore, blkAfter))",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Match\\n\"",
  "        s := s ++ spc ++ matchee.pretty(depth + 2)",
  "        for (self.cases) do { mx ->",
  "            s := s ++ \"\\n{spc}Case:\\n{spc}  {mx.pretty(depth+2)}\"",
  "        }",
  "        if (false != self.elsecase) then {",
  "            s := s ++ \"\\n{spc}Else:\\n{spc}  {self.elsecase.pretty(depth+2)}\"",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"match(\" ++ self.value.toGrace(0) ++ \")\"",
  "        for (self.cases) do { case ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"case \" ++ case.toGrace(depth + 2)",
  "        }",
  "        if (self.elsecase != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ \"else \" ++ self.elsecase.toGrace(depth + 2)",
  "        }",
  "        s",
  "    }",
  "}",
  "class methodTypeNode.new(name', signature', rtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"methodtype\"",
  "    def value = name'",
  "    def signature = signature'",
  "    def rtype = rtype'",
  "    var generics := []",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMethodType(self)) then {",
  "            if (self.rtype != false) then {",
  "                self.rtype.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var rt := false",
  "        if (rtype != false) then {",
  "            rt := rtype.map(blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        var n := methodTypeNode.new(value, listMap(signature, blk)before(blkBefore)after(blkAfter),",
  "            rt)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"MethodType\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (rtype != false) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{rtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.rtype != false) then {",
  "            s := s ++ \" -> \" ++ self.rtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "}",
  "class typeNode.new(name', methods') {",
  "    inherits baseNode.new",
  "    def kind = \"type\"",
  "    def value = name'",
  "    def methods = methods'",
  "    def unionTypes = []",
  "    def intersectionTypes = []",
  "    def annotations = collections.list.new",
  "    var generics := []",
  "    var nominal := false",
  "    var anonymous := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitType(self)) then {",
  "            if (self.unionTypes.size > 0) then {",
  "                for (self.unionTypes) do { ut ->",
  "                    ut.accept(visitor)",
  "                }",
  "            }",
  "            if (self.intersectionTypes.size > 0) then {",
  "                for (self.intersectionTypes) do { it ->",
  "                    it.accept(visitor)",
  "                }",
  "            }",
  "            for (self.methods) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := typeNode.new(value, listMap(methods, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.anonymous := self.anonymous",
  "        n.line := line",
  "        for (listMap(unionTypes, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.unionTypes.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(intersectionTypes, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.intersectionTypes.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(generics, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.generics.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Type\\n\"",
  "        s := \"{s}{spc}Name: {value}\\n\"",
  "        if (generics.size > 0) then {",
  "            s := \"{s}{spc}Generic parameters:\\n\"",
  "            for (generics) do {ut->",
  "                s := \"{s}{spc}  {ut.value}\\n\"",
  "            }",
  "        }",
  "        if (unionTypes.size > 0) then {",
  "            s := \"{s}{spc}Union of:\\n\"",
  "            for (unionTypes) do {ut->",
  "                s := \"{s}{spc}  {ut.value}\\n\"",
  "            }",
  "        }",
  "        if (intersectionTypes.size > 0) then {",
  "            s := \"{s}{spc}Intersection of:\\n\"",
  "            for (intersectionTypes) do {it->",
  "                s := \"{s}{spc}  {it.value}\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Methods:\"",
  "        for (methods) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        def isanon = self.value.substringFrom(2)to(6) == \"Anon_\"",
  "        def isadhoc = (self.value.substringFrom(1)to(6) == \"Union<\") ||",
  "                      (self.value.substringFrom(1)to(13) == \"Intersection<\")",
  "        if (!isanon && !isadhoc) then {",
  "            s := \"type {self.value}\"",
  "            if (self.generics.size > 0) then {",
  "                s := s ++ \"<\"",
  "                for (self.generics.indices) do { i ->",
  "                    s := s ++ self.generics[i].value",
  "                    if (i < self.generics.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \">\"",
  "            }",
  "            s := s ++ \" = \"",
  "        }",
  "        if (!isadhoc && (self.unionTypes.size == 0) &&",
  "            (self.intersectionTypes.size == 0)) then {",
  "            s := s ++ \"\\{\"",
  "        }",
  "        // TODO: what about e.g. \"(A & B) | C\"?",
  "        if (self.unionTypes.size > 0) then {",
  "            for (self.unionTypes.indices) do { i ->",
  "                s := s ++ self.unionTypes[i].toGrace(0)",
  "                if (i < self.unionTypes.size) then {",
  "                    s := s ++ \" | \"",
  "                }",
  "            }",
  "        } elseif (self.intersectionTypes.size > 0) then {",
  "            for (self.intersectionTypes.indices) do { i ->",
  "                s := s ++ self.intersectionTypes[i].toGrace(0)",
  "                if (i < self.intersectionTypes.size) then {",
  "                    s := s ++ \" & \"",
  "                }",
  "            }",
  "        }",
  "        for (self.methods) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        if (!isadhoc && (self.unionTypes.size == 0) &&",
  "            (self.intersectionTypes.size == 0)) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        }",
  "        s",
  "    }",
  "}",
  "class methodNode.new(name', signature', body', dtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"method\"",
  "    def value = name'",
  "    def signature = signature'",
  "    def body = body'",
  "    var dtype := dtype'",
  "    var varargs := false",
  "    var generics := []",
  "    var selfclosure := false",
  "    def annotations = collections.list.new",
  "    var properties := collections.map.new",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMethod(self)) then {",
  "            self.value.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "            for (self.body) do { mx ->",
  "                mx.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var dt := false",
  "        if (dtype != false) then {",
  "            dt := dtype.map(blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        var n := methodNode.new(name', signature, listMap(body, blk)before(blkBefore)after(blkAfter), dt)",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        for (listMap(generics, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.generics.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method eachParameter(blk) {",
  "        for (signature) do {s->",
  "            for (s.params) do {p->",
  "                blk.apply(p)",
  "            }",
  "        }",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Method\\n\"",
  "        s := s ++ spc ++ \"Name: \" ++ self.value.pretty(depth+1)",
  "        s := s ++ \"\\n\"",
  "        if (false != self.dtype) then {",
  "            s := s ++ spc ++ \"Returns:\\n\" ++ spc ++ \"  \"",
  "            s := s ++ self.dtype.pretty(depth + 2) ++ \"\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := \"{s}{spc}Generics:\"",
  "            for (generics) do {g->",
  "                s := \"{s}\\n{spc}  {g.pretty(0)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := \"{s}{spc}Annotations:\"",
  "            for (annotations) do {an->",
  "                s := \"{s}\\n{spc}  {an.pretty(depth + 2)}\"",
  "            }",
  "            s := s ++ \"\\n\"",
  "        }",
  "        s := s ++ spc ++ \"Body:\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n  \"++ spc ++ mx.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"method \"",
  "        for (self.signature) do { part ->",
  "            s := s ++ part.name",
  "            if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                s := s ++ \"(\"",
  "                for (part.params.indices) do { pnr ->",
  "                    var p := part.params[pnr]",
  "                    s := s ++ p.toGrace(depth + 1)",
  "                    if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                if (part.vararg != false) then {",
  "                    s := s ++ \"*\" ++ part.vararg.value",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" -> {self.dtype.toGrace(0)}\"",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.body) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class callNode.new(what, with') {",
  "    // [with]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := []",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         args := []",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"call\"",
  "    def value = what",
  "    def with = with'",
  "    var generics := false",
  "    var isPattern := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitCall(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.with) do { part ->",
  "                for (part.args) do { arg ->",
  "                    arg.accept(visitor)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := callNode.new(value.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(with, blk)before(blkBefore)after(blkAfter))",
  "        if (generics != false) then {",
  "            n.generics := listMap(generics, blk)before(blkBefore)after(blkAfter)",
  "        }",
  "        n.isPattern := isPattern",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Call\\n\"",
  "        s := s ++ spc ++ \"Method: {self.value.pretty(depth + 1)}\"",
  "        s := s ++ \"\\n\"",
  "        if (false != generics) then {",
  "            s := s ++ spc ++ \"  Generics:\\n\"",
  "            for (generics) do {g->",
  "                s := s ++ spc ++ \"    \" ++ g.pretty(0) ++ \"\\n\"",
  "            }",
  "        }",
  "        s := s ++ spc ++ \"Arguments:\"",
  "        for (self.with) do { part ->",
  "            s := s ++ \"\\n  \" ++ spc ++ \"Part: \" ++ part.name",
  "            for (part.args) do { arg ->",
  "                s := s ++ \"\\n    \" ++ spc ++ arg.pretty(depth + 3)",
  "            }",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"\"",
  "        // only the last member is the method call we need to handle",
  "        if (self.value.kind == \"member\") then {",
  "            var member := self.value",
  "            if (member.value.substringFrom(1)to(6) == \"prefix\") then {",
  "                s := member.value.substringFrom(7)to(member.value.size)",
  "                return s ++ member.in.toGrace(0)",
  "            }",
  "            s := member.in.toGrace(0) ++ \".\"",
  "        }",
  "        for (self.with) do { part ->",
  "            s := s ++ part.name",
  "            if (part.args.size > 0) then {",
  "                s := s ++ \"(\"",
  "                for (part.args.indices) do { anr ->",
  "                    var arg := part.args[anr]",
  "                    s := s ++ arg.toGrace(depth + 1)",
  "                    if (anr < part.args.size) then {",
  "                        s := s ++ \", \"",
  "                    }",
  "                }",
  "                s := s ++ \")\"",
  "            }",
  "        }",
  "        s",
  "    }",
  "}",
  "class classNode.new(name', signature', body', superclass', constructor', dtype') {",
  "    // [signature]",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     object {",
  "    //         name := \"\"",
  "    //         params := []",
  "    //         vararg := false/identifier",
  "    //     }",
  "    //     ...",
  "    //     object {",
  "    //         ...",
  "    //     }",
  "    inherits baseNode.new",
  "    def kind = \"class\"",
  "    def value = body'",
  "    def name = name'",
  "    def constructor = constructor'",
  "    def signature = signature'",
  "    var dtype := dtype'",
  "    var generics := false",
  "    def superclass = superclass'",
  "    def annotations = collections.list.new",
  "    var instanceMethods := collections.list.new",
  "    var data := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitClass(self)) then {",
  "            self.name.accept(visitor)",
  "            self.constructor.accept(visitor)",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor)",
  "            }",
  "            for (self.signature) do { part ->",
  "                for (part.params) do { p ->",
  "                    p.accept(visitor)",
  "                }",
  "                if (part.vararg != false) then {",
  "                    part.vararg.accept(visitor)",
  "                }",
  "            }",
  "            for (self.value) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := classNode.new(name.map(blk)before(blkBefore)after(blkAfter),",
  "            listMap(signature, blk)before(blkBefore)after(blkAfter), listMap(value, blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(superclass, blk, blkBefore, blkAfter), constructor, dtype)",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Class(\" ++ self.name.pretty(0) ++ \")\"",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 2)",
  "        }",
  "        s := s ++ \"\\n\"",
  "        s := \"{s}{spc}Constructor: {constructor.value}\\n\"",
  "        if(false != dtype) then {",
  "            s := \"{s}{spc}Returns:\\n  {spc}{dtype.pretty(depth + 2)}\\n\"",
  "        }",
  "        s := \"{s}{spc}Signature:\"",
  "        for (signature) do { part ->",
  "            s := \"{s}\\n  {spc}Part: {part.name}\"",
  "            s := \"{s}\\n    {spc}Parameters:\"",
  "            for (part.params) do { p ->",
  "                s := \"{s}\\n      {spc}{p.pretty(depth + 4)}\"",
  "            }",
  "            if (part.vararg != false) then {",
  "                s := \"{s}\\n    {spc}Vararg: {part.vararg.pretty(depth + 3)}\"",
  "            }",
  "        }",
  "        if (false != generics) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Generics:\"",
  "            for (generics) do {g->",
  "                s := s ++ \"\\n  {spc}{g.pretty(0)}\"",
  "            }",
  "        }",
  "        if (annotations.size > 0) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Annotations:\"",
  "            for (annotations) do {a->",
  "                s := s ++ \"\\n  {spc}{a.pretty(depth + 2)}\"",
  "            }",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n  \"++ spc ++ x.pretty(depth+2)",
  "        }",
  "        s",
  "    }",
  "",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"class {self.name.toGrace(0)}\"",
  "        if (self.name.kind != \"generic\") then {",
  "            // TODO generics + new-style constructors aren't possible at the moment",
  "            s := s ++ \".\"",
  "            for (self.signature) do { part ->",
  "                s := s ++ part.name",
  "                if ((part.params.size > 0) || (part.vararg != false)) then {",
  "                    s := s ++ \"(\"",
  "                    for (part.params.indices) do { pnr ->",
  "                        var p := part.params[pnr]",
  "                        s := s ++ p.toGrace(depth + 1)",
  "                        if ((pnr < part.params.size) || (part.vararg != false)) then {",
  "                            s := s ++ \", \"",
  "                        }",
  "                    }",
  "                    if (part.vararg != false) then {",
  "                        s := s ++ \"*\" ++ part.vararg.value",
  "                    }",
  "                    s := s ++ \")\"",
  "                }",
  "            }",
  "        }",
  "        if(false != dtype) then {",
  "            s := \"{s} -> {dtype.toGrace(depth + 1)}\"",
  "        }",
  "        s := s ++ \" \\{\"",
  "        for (self.value) do { mx ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ mx.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class objectNode.new(body, superclass') {",
  "    inherits baseNode.new",
  "    def kind = \"object\"",
  "    def value = body",
  "    def superclass = superclass'",
  "    var otype := false",
  "    var classname := \"object\"",
  "    var data := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitObject(self)) then {",
  "            if (self.superclass != false) then {",
  "                self.superclass.accept(visitor)",
  "            }",
  "            for (self.value) do { x ->",
  "                x.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := objectNode.new(listMap(value,",
  "        blk)before(blkBefore)after(blkAfter), maybeMap(superclass, blk,",
  "        blkBefore, blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth') {",
  "        var depth := depth'",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Object\"",
  "        if (self.superclass != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Superclass:\"",
  "            s := s ++ \"\\n  \" ++ spc ++ self.superclass.pretty(depth + 1)",
  "            s := s ++ \"\\n\" ++ spc ++ \"Body:\"",
  "            depth := depth + 1",
  "        }",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\"++ spc ++ x.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"object \\{\"",
  "        for (self.value) do { x ->",
  "            s := s ++ \"\\n\" ++ spc ++ \"    \" ++ x.toGrace(depth + 1)",
  "        }",
  "        s := s ++ \"\\n\" ++ spc ++ \"\\}\"",
  "        s",
  "    }",
  "}",
  "class arrayNode.new(values) {",
  "    inherits baseNode.new",
  "    def kind = \"array\"",
  "    def value = values",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitArray(self)) then {",
  "            for (self.value) do { ax ->",
  "                ax.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := arrayNode.new(listMap(value, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { ai ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Array\"",
  "        for (self.value) do { ax ->",
  "            s := s ++ \"\\n\"++ spc ++ ax.pretty(depth+1)",
  "        }",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"[\"",
  "        for (self.value.indices) do { i ->",
  "            s := s ++ self.value[i].toGrace(0)",
  "            if (i < self.value.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \"]\"",
  "        s",
  "    }",
  "}",
  "class memberNode.new(what, in') {",
  "    inherits baseNode.new",
  "    def kind = \"member\"",
  "    var value := what",
  "    def in = in'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitMember(self)) then {",
  "            self.in.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := memberNode.new(value, in.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Member(\" ++ self.value ++ \")\\n\"",
  "        s := s ++ spc ++ self.in.pretty(depth+1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if (self.value.substringFrom(1)to(6) == \"prefix\") then {",
  "            s := self.value.substringFrom(7)to(self.value.size)",
  "            s := s ++ \" \" ++ self.in.toGrace(0)",
  "        } else {",
  "            s := self.in.toGrace(depth) ++ \".\" ++ self.value",
  "        }",
  "        s",
  "    }",
  "}",
  "class genericNode.new(base, params') {",
  "    inherits baseNode.new",
  "    def kind = \"generic\"",
  "    def value = base",
  "    def params = params'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitGeneric(self)) then {",
  "            self.value.accept(visitor)",
  "            for (self.params) do { p ->",
  "                p.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := genericNode.new(value.map(blk)before(blkBefore)after(blkAfter), listMap(params, blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var s := \"Generic(\" ++ self.value.value ++ \"<\"",
  "        for (params) do {p->",
  "            s := s ++ p.pretty(0)",
  "            s := s ++ \",\"",
  "        }",
  "        s ++ \">)\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := self.value.value ++ \"<\"",
  "        for (self.params.indices) do { i ->",
  "            s := s ++ self.params[i].toGrace(0)",
  "            if (i < self.params.size) then {",
  "                s := s ++ \", \"",
  "            }",
  "        }",
  "        s := s ++ \">\"",
  "        s",
  "    }",
  "}",
  "class identifierNode.new(name, dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"identifier\"",
  "    var value := name",
  "    var wildcard := false",
  "    var dtype := dtype'",
  "    var inBind := false",
  "    var inRequest := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIdentifier(self)) then {",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        util.setPosition(line, linePos)",
  "        var n := identifierNode.new(value, maybeMap(dtype, blk, blkBefore,",
  "        blkAfter))",
  "        n.wildcard := wildcard",
  "        n.inBind := inBind",
  "        n.inRequest := inRequest",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        if (n.kind == \"identifier\") then {",
  "            n.linePos := linePos",
  "            n.wildcard := wildcard",
  "            n.inBind := inBind",
  "            n.inRequest := inRequest",
  "        }",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s",
  "        if(self.wildcard) then {",
  "            s := \"WildcardIdentifier\"",
  "        } else {",
  "            s := \"Identifier(\" ++ self.value ++ \")\"",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s",
  "        if(self.wildcard) then {",
  "            s := \"_\"",
  "        } else {",
  "            s := self.value",
  "        }",
  "        if (self.dtype != false) then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method asString {",
  "        \"<Identifier[{value}]>\"",
  "    }",
  "}",
  "class octetsNode.new(n) {",
  "    inherits baseNode.new",
  "    def kind = \"octets\"",
  "    def value = n",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitOctets(self)",
  "    }",
  "    method pretty(depth) {",
  "        \"Octets(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value",
  "    }",
  "}",
  "class stringNode.new(v) {",
  "    inherits baseNode.new",
  "    def kind = \"string\"",
  "    var value := v",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitString(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"String(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\\\"\"",
  "        for (self.value) do { c ->",
  "            // TODO: what escapes are missing?",
  "            if (c == \"\\n\") then {",
  "                s := s ++ \"\\\\n\"",
  "            } elseif (c == \"\\t\") then {",
  "                s := s ++ \"\\\\t\"",
  "            } elseif (c == \"\\\"\") then {",
  "                s := s ++ \"\\\\\\\"\"",
  "            } elseif (c == \"\\\\\") then {",
  "                s := s ++ \"\\\\\\\\\"",
  "            } else {",
  "                s := s ++ c",
  "            }",
  "        }",
  "        s := s ++ \"\\\"\"",
  "        s",
  "    }",
  "}",
  "class numNode.new(val) {",
  "    inherits baseNode.new",
  "    def kind = \"num\"",
  "    def value = val",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitNum(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"Num(\" ++ self.value ++ \")\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        self.value.asString",
  "    }",
  "}",
  "class opNode.new(op, l, r) {",
  "    inherits baseNode.new",
  "    def kind = \"op\"",
  "    def value = op",
  "    def left = l",
  "    def right = r",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitOp(self)) then {",
  "            self.left.accept(visitor)",
  "            self.right.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := opNode.new(value, left.map(blk)before(blkBefore)after(blkAfter), right.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Op(\" ++ self.value ++ \")\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.left.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.right.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var s := \"\"",
  "        if ((self.left.kind == \"op\") && (self.left.value != self.value)) then {",
  "            s := \"(\" ++ self.left.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := self.left.toGrace(0)",
  "        }",
  "        if (self.value == \"..\") then {",
  "            s := s ++ self.value",
  "        } else {",
  "            s := s ++ \" \" ++ self.value ++ \" \"",
  "        }",
  "        if ((self.right.kind == \"op\") && (self.right.value != self.value)) then {",
  "            s := s ++ \"(\" ++ self.right.toGrace(0) ++ \")\"",
  "        } else {",
  "            s := s ++ self.right.toGrace(0)",
  "        }",
  "        s",
  "    }",
  "}",
  "class indexNode.new(expr, index') {",
  "    inherits baseNode.new",
  "    def kind = \"index\"",
  "    def value = expr",
  "    def index = index'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitIndex(self)) then {",
  "            self.value.accept(visitor)",
  "            self.index.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := indexNode.new(value.map(blk)before(blkBefore)after(blkAfter), index.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Index\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.index.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.value.toGrace(depth + 1)",
  "        s := s ++ \"[\" ++ self.index.toGrace(depth + 1) ++ \"]\"",
  "        s",
  "    }",
  "}",
  "class bindNode.new(dest', val') {",
  "    inherits baseNode.new",
  "    def kind = \"bind\"",
  "    def dest = dest'",
  "    def value = val'",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitBind(self)) then {",
  "            self.dest.accept(visitor)",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := bindNode.new(dest.map(blk)before(blkBefore)after(blkAfter), value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Bind\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.dest.pretty(depth + 1)",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := self.dest.toGrace(depth + 1)",
  "        s := s ++ \" := \" ++ self.value.toGrace(depth + 1)",
  "        s",
  "    }",
  "}",
  "class defDecNode.new(name', val, dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"defdec\"",
  "    def name = name'",
  "    def value = val",
  "    var dtype := dtype'",
  "    def annotations = collections.list.new",
  "    var data := false",
  "    var startToken := false",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitDefDec(self)) then {",
  "            self.name.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := defDecNode.new(name, value.map(blk)before(blkBefore)after(blkAfter),",
  "            maybeMap(dtype, blk, blkBefore, blkAfter))",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"defdec\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"def {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" = \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "}",
  "class varDecNode.new(name', val', dtype') {",
  "    inherits baseNode.new",
  "    def kind = \"vardec\"",
  "    def name = name'",
  "    def value = val'",
  "    var dtype := dtype'",
  "    def annotations = collections.list.new",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitVarDec(self)) then {",
  "            self.name.accept(visitor)",
  "            if (self.dtype != false) then {",
  "                self.dtype.accept(visitor)",
  "            }",
  "            if (self.value != false) then {",
  "                self.value.accept(visitor)",
  "            }",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := varDecNode.new(name, maybeMap(value, blk,",
  "                blkBefore, blkAfter),",
  "            maybeMap(dtype, blk, blkBefore, blkAfter))",
  "        for (listMap(annotations, blk)before(blkBefore)after(blkAfter)) do {a->",
  "            n.annotations.push(a.map(blk)before(blkBefore)after(blkAfter))",
  "        }",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for ((0..depth)) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"VarDec\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.name.pretty(depth + 1)",
  "        if (self.dtype != false) then {",
  "            s := s ++ \"\\n\" ++ spc ++ \"Type:\"",
  "            s := s ++ \"\\n\" ++ spc ++ \"  \" ++ self.dtype.pretty(depth + 2)",
  "        }",
  "        if (false != self.value) then {",
  "            s := s ++ \"\\n\"",
  "            s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        }",
  "        s",
  "    }",
  "    method decType {",
  "        if (dtype == false) then {",
  "            return identifierNode.new(\"Unknown\", false)",
  "        }",
  "        return dtype",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        var spc := \"\"",
  "        for (0..(depth - 1)) do { i ->",
  "            spc := spc ++ \"    \"",
  "        }",
  "        var s := \"var {self.name.toGrace(0)}\"",
  "        if (self.dtype.value != \"Unknown\") then {",
  "            s := s ++ \" : \" ++ self.dtype.toGrace(0)",
  "        }",
  "        if (self.annotations.size > 0) then {",
  "            s := s ++ \" is \"",
  "            s := s ++ self.annotations.reduce(\"\", { a,b ->",
  "                if (a != \"\") then { a ++ \", \" } else { \"\" } ++ b.toGrace(0) })",
  "        }",
  "        if (self.value != false) then {",
  "            s := s ++ \" := \" ++ self.value.toGrace(depth)",
  "        }",
  "        s",
  "    }",
  "}",
  "class importNode.new(path', name) {",
  "    inherits baseNode.new",
  "    def kind = \"import\"",
  "    def value = name",
  "    def path = path'",
  "    var dtype := false",
  "    def linePos = 1",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitImport(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Import\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.path}\\n\"",
  "        s := s ++ \"{spc}Identifier: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"import \\\"{self.path}\\\" as {self.value}\"",
  "    }",
  "}",
  "class dialectNode.new(path') {",
  "    inherits baseNode.new",
  "    def kind = \"dialect\"",
  "    def value = path'",
  "    method accept(visitor : ASTVisitor) {",
  "        visitor.visitDialect(self)",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := blk.apply(self)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Dialect\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ \"{spc}Path: {self.value}\\n\"",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"dialect \\\"{self.value}\\\"\"",
  "    }",
  "}",
  "class returnNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind = \"return\"",
  "    def value = expr",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitReturn(self)) then {",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := returnNode.new(value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Return\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"return \" ++ self.value.toGrace(depth)",
  "    }",
  "}",
  "class inheritsNode.new(expr) {",
  "    inherits baseNode.new",
  "    def kind = \"inherits\"",
  "    def value = expr",
  "    method accept(visitor : ASTVisitor) {",
  "        if (visitor.visitInherits(self)) then {",
  "            self.value.accept(visitor)",
  "        }",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := inheritsNode.new(value.map(blk)before(blkBefore)after(blkAfter))",
  "        n := blk.apply(n)",
  "        n.line := line",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        var spc := \"\"",
  "        for (0..depth) do { i ->",
  "            spc := spc ++ \"  \"",
  "        }",
  "        var s := \"Inherits\"",
  "        s := s ++ \"\\n\"",
  "        s := s ++ spc ++ self.value.pretty(depth + 1)",
  "        s",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"inherits {self.value.toGrace(0)}\"",
  "    }",
  "}",
  "class blankNode.new {",
  "    inherits baseNode.new",
  "    def kind = \"blank\"",
  "    def value = \"blank\"",
  "    method accept(visitor : ASTVisitor) {",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        self",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "    method pretty(depth) {",
  "        \"Blank\"",
  "    }",
  "    method toGrace(depth : Number) -> String {",
  "        \"\"",
  "    }",
  "}",
  "",
  "class signaturePart.new(*values) {",
  "    inherits baseNode.new",
  "    def kind = \"signaturepart\"",
  "    var name := \"\"",
  "    var params := []",
  "    var vararg := false",
  "    var generics := []",
  "    if (values.size > 0) then {",
  "        name := values[1]",
  "    }",
  "    if (values.size > 1) then {",
  "        params := values[2]",
  "    }",
  "    if (values.size > 2) then {",
  "        vararg := values[3]",
  "    }",
  "    method map(blk)before(blkBefore)after(blkAfter) {",
  "        blkBefore.apply(self)",
  "        var n := signaturePart.new(name, listMap(params, blk)before(blkBefore)after(blkAfter), vararg)",
  "        n := blk.apply(n)",
  "        blkAfter.apply(n)",
  "        n",
  "    }",
  "    method map(blk) {",
  "        map(blk)before {} after {}",
  "    }",
  "}",
  "",
  "method callWithPart {",
  "    object {",
  "        method new(*values) {",
  "            object {",
  "                inherits baseNode.new",
  "                def kind = \"callwithpart\"",
  "                var name := \"\"",
  "                var args := []",
  "                if (values.size > 0) then {",
  "                    name := values[1]",
  "                }",
  "                if (values.size > 1) then {",
  "                    args := values[2]",
  "                }",
  "                method map(blk)before(blkBefore)after(blkAfter) {",
  "                    blkBefore.apply(self)",
  "                    var n := callWithPart.new(name, listMap(args, blk)before(blkBefore)after(blkAfter))",
  "                    n := blk.apply(n)",
  "                    blkAfter.apply(n)",
  "                    n",
  "                }",
  "                method map(blk) {",
  "                    map(blk)before {} after {}",
  "                }",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type ASTVisitor = {",
  "     visitFor(o) -> Boolean",
  "     visitWhile(o) -> Boolean",
  "     visitIf(o) -> Boolean",
  "     visitBlock(o) -> Boolean",
  "     visitMatchCase(o) -> Boolean",
  "     visitCatchCase(o) -> Boolean",
  "     visitMethodType(o) -> Boolean",
  "     visitType(o) -> Boolean",
  "     visitMethod(o) -> Boolean",
  "     visitCall(o) -> Boolean",
  "     visitClass(o) -> Boolean",
  "     visitObject(o) -> Boolean",
  "     visitArray(o) -> Boolean",
  "     visitMember(o) -> Boolean",
  "     visitGeneric(o) -> Boolean",
  "     visitIdentifier(o) -> Boolean",
  "     visitOctets(o) -> Boolean",
  "     visitString(o) -> Boolean",
  "     visitNum(o) -> Boolean",
  "     visitOp(o) -> Boolean",
  "     visitIndex(o) -> Boolean",
  "     visitBind(o) -> Boolean",
  "     visitDefDec(o) -> Boolean",
  "     visitVarDec(o) -> Boolean",
  "     visitImport(o) -> Boolean",
  "     visitReturn(o) -> Boolean",
  "     visitInherits(o) -> Boolean",
  "     visitDialect(o) -> Boolean",
  "}",
  "method baseVisitor -> ASTVisitor {",
  "    object {",
  "        method visitFor(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitWhile(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIf(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitBlock(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMatchCase(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitCatchCase(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMethodType(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitType(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMethod(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitCall(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitClass(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitObject(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitArray(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitMember(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitGeneric(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIdentifier(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitOctets(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitString(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitNum(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitOp(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitIndex(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitBind(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitDefDec(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitVarDec(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitImport(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitReturn(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitInherits(o) -> Boolean {",
  "            true",
  "        }",
  "        method visitDialect(o) -> Boolean {",
  "            true",
  "        }",
  "    }",
  "}",
  "def ast = self",
  "def patternMarkVisitor = object {",
  "    inherits ast.baseVisitor",
  "    method visitCall(c) {",
  "        c.isPattern := true",
  "        true",
  "    }",
  "}",
  "",
  "method findAnnotation(node, annName) {",
  "    for (node.annotations) do {ann->",
  "        if ((ann.kind == \"identifier\").andAlso {",
  "            ann.value == annName }) then {",
  "            return object {",
  "                inherits true",
  "                def value is public = ann",
  "            }",
  "        }",
  "    }",
  "    false",
  "}",
  "",
  "method isPublic(node) {",
  "    if ((node.annotations.size == 0).orElse {",
  "        findAnnotation(node, \"public\")}) then {",
  "        return true",
  "    }",
  "    false",
  "}",
  "",
  "method isWritable(node) {",
  "    if ((node.annotations.size == 0).orElse {",
  "        findAnnotation(node, \"writable\")}) then {",
  "        return true",
  "    }",
  "    false",
  "}",
  NULL
};
static Object type_ASTVisitor;
Object reader_ast_outer_24(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_27(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_28(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_29(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_29(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_args_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_args_30(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_outer_99(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_181(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_value_182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_outer_229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_register_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_ast_register_233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_ast_line_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_line_234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_linePos_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_linePos_235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_lineLength_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_lineLength_236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_outer_246(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_249(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_250(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_body_252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_body_386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_555(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_558(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_559(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_560(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_thenblock_561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_elseblock_562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_handledIdentifiers_563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_handledIdentifiers_563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_875(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_876(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_877(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_878(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_body_879(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_selfclosure_880(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_matchingPattern_881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_matchingPattern_881(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_extraRuntimeData_882(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_extraRuntimeData_882(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_1248(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1251(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1252(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1253(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_cases_1254(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_finally_1255(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_1539(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1542(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1544(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_cases_1545(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_elsecase_1546(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_1830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_1833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_1834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_1835(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_signature_1836(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_rtype_1837(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_generics_1838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_1838(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_2285(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_2288(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_2289(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_2290(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_methods_2291(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_unionTypes_2292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_intersectionTypes_2293(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_annotations_2294(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_ast_generics_2295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_2295(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_nominal_2296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_nominal_2296(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_anonymous_2297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object writer_ast_anonymous_2297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[9] = args[0];
  return done;
}
Object reader_ast_outer_3030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3033(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3034(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_signature_3036(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_body_3037(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_dtype_3038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_dtype_3038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_varargs_3039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_varargs_3039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_3040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_3040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_selfclosure_3041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_ast_selfclosure_3041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_ast_annotations_3042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_properties_3043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_properties_3043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_outer_3848(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_3851(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_3852(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_3853(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_with_3854(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_generics_3855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_generics_3855(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_isPattern_3856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_isPattern_3856(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_4224(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_4227(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_4228(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_4229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_name_4230(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_constructor_4231(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_signature_4232(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_dtype_4233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_dtype_4233(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_generics_4234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_generics_4234(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_superclass_4235(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object reader_ast_annotations_4236(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[9];
}
Object reader_ast_instanceMethods_4237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[10];
}
Object writer_ast_instanceMethods_4237(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[10] = args[0];
  return done;
}
Object reader_ast_data_4238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[11];
}
Object writer_ast_data_4238(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[11] = args[0];
  return done;
}
Object reader_ast_outer_5048(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5051(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5052(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5053(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_superclass_5054(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_otype_5055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_otype_5055(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_classname_5056(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_classname_5056(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_data_5057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_data_5057(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5287(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5290(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5291(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5292(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_5423(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5426(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5427(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5428(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_in_5429(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_5564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5567(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_params_5570(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_5711(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5714(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5715(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5716(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5716(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_wildcard_5717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_wildcard_5717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_dtype_5718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_5718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_inBind_5719(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_inBind_5719(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_inRequest_5720(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_inRequest_5720(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_outer_5950(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5953(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5954(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5955(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_5979(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_5982(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_5983(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_5984(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_value_5984(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_outer_6083(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6086(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6087(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6088(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_6134(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6137(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6138(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6139(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_left_6140(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_right_6141(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_ast_outer_6376(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6379(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_6381(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_index_6382(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_6537(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6540(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6541(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_dest_6542(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_6543(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_outer_6694(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_6697(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_6698(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_6699(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_6700(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_6701(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_6701(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_annotations_6702(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_data_6703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object writer_ast_data_6703(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[6] = args[0];
  return done;
}
Object reader_ast_startToken_6704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_ast_startToken_6704(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_ast_outer_7035(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7038(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7039(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7040(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_value_7041(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_7042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_annotations_7043(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_outer_7380(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7383(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7384(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7385(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_path_7386(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_ast_dtype_7387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_dtype_7387(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_linePos_7388(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object reader_ast_outer_7504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7507(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7593(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7596(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7597(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7598(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7686(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7689(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7690(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7691(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7784(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7787(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_value_7789(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_ast_outer_7812(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_outer_7815(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_ast_kind_7816(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_ast_name_7817(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_ast_name_7817(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_ast_params_7818(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_ast_params_7818(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_ast_vararg_7819(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_ast_vararg_7819(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_ast_generics_7820(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_ast_generics_7820(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_ast_outer_7895(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static ClassData objclass23;
static ClassData objclass26;
static Object strlit68;
static Object strlit69;
static ClassData objclass98;
static Object strlit174;
static ClassData objclass180;
static Object strlit193;
static Object strlit213;
Object module_util;
Object module_util_init();
Object module_mgcollections;
Object module_mgcollections_init();
static ClassData objclass228;
static ClassData objclass231;
static Object strlit237;
static ClassData objclass245;
static ClassData objclass248;
static Object strlit266;
static Object strlit275;
static Object strlit281;
static Object strlit298;
static Object strlit303;
static Object strlit321;
static Object strlit326;
static Object strlit334;
static Object strlit347;
static Object strlit354;
static Object strlit363;
static Object strlit376;
static ClassData objclass379;
static ClassData objclass382;
static Object strlit405;
static Object strlit414;
static Object strlit420;
static Object strlit437;
static Object strlit442;
static Object strlit465;
static Object strlit474;
static Object strlit487;
static Object strlit494;
static Object strlit506;
static Object strlit523;
static Object strlit528;
static Object strlit538;
static Object strlit543;
static Object strlit551;
static ClassData objclass554;
static ClassData objclass557;
static Object strlit638;
static Object strlit647;
static Object strlit653;
static Object strlit670;
static Object strlit675;
static Object strlit698;
static Object strlit707;
static Object strlit712;
static Object strlit735;
static Object strlit744;
static Object strlit757;
static Object strlit764;
static Object strlit773;
static Object strlit790;
static Object strlit795;
static Object strlit814;
static Object strlit819;
static Object strlit839;
static Object strlit844;
static Object strlit854;
static Object strlit859;
static Object strlit867;
static ClassData objclass871;
static ClassData objclass874;
static Object strlit973;
static Object strlit982;
static Object strlit988;
static Object strlit990;
static Object strlit1013;
static Object strlit1022;
static Object strlit1027;
static Object strlit1050;
static Object strlit1066;
static Object strlit1071;
static Object strlit1091;
static Object strlit1098;
static Object strlit1111;
static Object strlit1117;
static Object strlit1128;
static Object strlit1150;
static Object strlit1158;
static Object strlit1180;
static Object strlit1185;
static Object strlit1205;
static Object strlit1210;
static Object strlit1220;
static Object strlit1225;
static Object strlit1233;
static Object strlit1234;
static ClassData objclass1247;
static ClassData objclass1250;
static Object strlit1323;
static Object strlit1332;
static Object strlit1338;
static Object strlit1361;
static Object strlit1372;
static Object strlit1377;
static Object strlit1381;
static Object strlit1402;
static Object strlit1415;
static Object strlit1420;
static Object strlit1424;
static Object strlit1435;
static Object strlit1448;
static Object strlit1455;
static Object strlit1464;
static Object strlit1481;
static Object strlit1484;
static Object strlit1489;
static Object strlit1517;
static Object strlit1520;
static Object strlit1525;
static Object strlit1535;
static ClassData objclass1538;
static ClassData objclass1541;
static Object strlit1616;
static Object strlit1625;
static Object strlit1631;
static Object strlit1652;
static Object strlit1663;
static Object strlit1668;
static Object strlit1672;
static Object strlit1693;
static Object strlit1706;
static Object strlit1711;
static Object strlit1715;
static Object strlit1726;
static Object strlit1739;
static Object strlit1746;
static Object strlit1755;
static Object strlit1772;
static Object strlit1775;
static Object strlit1780;
static Object strlit1808;
static Object strlit1811;
static Object strlit1816;
static Object strlit1826;
static ClassData objclass1829;
static ClassData objclass1832;
static Object strlit1925;
static Object strlit1934;
static Object strlit1940;
static Object strlit1942;
static Object strlit1949;
static Object strlit1954;
static Object strlit1958;
static Object strlit1974;
static Object strlit1987;
static Object strlit1992;
static Object strlit1997;
static Object strlit2001;
static Object strlit2012;
static Object strlit2017;
static Object strlit2021;
static Object strlit2033;
static Object strlit2040;
static Object strlit2045;
static Object strlit2049;
static Object strlit2058;
static Object strlit2063;
static Object strlit2067;
static Object strlit2079;
static Object strlit2090;
static Object strlit2095;
static Object strlit2099;
static Object strlit2117;
static Object strlit2130;
static Object strlit2135;
static Object strlit2139;
static Object strlit2150;
static Object strlit2181;
static Object strlit2223;
static Object strlit2243;
static Object strlit2249;
static Object strlit2273;
static Object strlit2280;
static ClassData objclass2284;
static ClassData objclass2287;
static Object strlit2461;
static Object strlit2470;
static Object strlit2476;
static Object strlit2478;
static Object strlit2485;
static Object strlit2490;
static Object strlit2494;
static Object strlit2512;
static Object strlit2517;
static Object strlit2521;
static Object strlit2533;
static Object strlit2540;
static Object strlit2545;
static Object strlit2549;
static Object strlit2569;
static Object strlit2574;
static Object strlit2578;
static Object strlit2590;
static Object strlit2597;
static Object strlit2602;
static Object strlit2606;
static Object strlit2626;
static Object strlit2631;
static Object strlit2635;
static Object strlit2647;
static Object strlit2654;
static Object strlit2659;
static Object strlit2663;
static Object strlit2674;
static Object strlit2697;
static Object strlit2706;
static Object strlit2711;
static Object strlit2724;
static Object strlit2730;
static Object strlit2732;
static Object strlit2743;
static Object strlit2754;
static Object strlit2773;
static Object strlit2779;
static Object strlit2793;
static Object strlit2822;
static Object strlit2829;
static Object strlit2834;
static Object strlit2864;
static Object strlit2903;
static Object strlit2944;
static Object strlit2964;
static Object strlit2969;
static Object strlit3004;
static Object strlit3009;
static Object strlit3017;
static ClassData objclass3029;
static ClassData objclass3032;
static Object strlit3201;
static Object strlit3210;
static Object strlit3216;
static Object strlit3228;
static Object strlit3237;
static Object strlit3249;
static Object strlit3254;
static Object strlit3264;
static Object strlit3280;
static Object strlit3285;
static Object strlit3289;
static Object strlit3301;
static Object strlit3308;
static Object strlit3313;
static Object strlit3317;
static Object strlit3326;
static Object strlit3331;
static Object strlit3335;
static Object strlit3347;
static Object strlit3358;
static Object strlit3363;
static Object strlit3367;
static Object strlit3385;
static Object strlit3398;
static Object strlit3403;
static Object strlit3407;
static Object strlit3418;
static Object strlit3430;
static Object strlit3435;
static Object strlit3439;
static Object strlit3451;
static Object strlit3459;
static Object strlit3464;
static Object strlit3468;
static Object strlit3479;
static Object strlit3493;
static Object strlit3498;
static Object strlit3502;
static Object strlit3514;
static Object strlit3525;
static Object strlit3530;
static Object strlit3534;
static Object strlit3545;
static Object strlit3550;
static Object strlit3573;
static Object strlit3590;
static Object strlit3596;
static Object strlit3609;
static Object strlit3615;
static Object strlit3646;
static Object strlit3688;
static Object strlit3708;
static Object strlit3714;
static Object strlit3729;
static Object strlit3738;
static Object strlit3754;
static Object strlit3760;
static Object strlit3770;
static Object strlit3774;
static Object strlit3777;
static Object strlit3787;
static Object strlit3805;
static Object strlit3810;
static Object strlit3820;
static Object strlit3825;
static Object strlit3833;
static ClassData objclass3847;
static ClassData objclass3850;
static Object strlit3938;
static Object strlit3947;
static Object strlit3953;
static Object strlit3956;
static Object strlit3968;
static Object strlit3978;
static Object strlit3990;
static Object strlit4003;
static Object strlit4011;
static Object strlit4023;
static Object strlit4040;
static Object strlit4045;
static Object strlit4068;
static Object strlit4079;
static Object strlit4092;
static Object strlit4098;
static Object strlit4101;
static Object strlit4112;
static Object strlit4140;
static Object strlit4170;
static Object strlit4203;
static Object strlit4210;
static Object strlit4218;
static ClassData objclass4223;
static ClassData objclass4226;
static Object strlit4373;
static Object strlit4382;
static Object strlit4389;
static Object strlit4398;
static Object strlit4409;
static Object strlit4414;
static Object strlit4433;
static Object strlit4440;
static Object strlit4445;
static Object strlit4454;
static Object strlit4459;
static Object strlit4463;
static Object strlit4479;
static Object strlit4492;
static Object strlit4497;
static Object strlit4502;
static Object strlit4506;
static Object strlit4517;
static Object strlit4522;
static Object strlit4526;
static Object strlit4538;
static Object strlit4545;
static Object strlit4550;
static Object strlit4554;
static Object strlit4563;
static Object strlit4568;
static Object strlit4572;
static Object strlit4584;
static Object strlit4595;
static Object strlit4600;
static Object strlit4604;
static Object strlit4622;
static Object strlit4635;
static Object strlit4640;
static Object strlit4644;
static Object strlit4662;
static Object strlit4667;
static Object strlit4680;
static Object strlit4688;
static Object strlit4692;
static Object strlit4712;
static Object strlit4717;
static Object strlit4730;
static Object strlit4741;
static Object strlit4745;
static Object strlit4756;
static Object strlit4761;
static Object strlit4783;
static Object strlit4800;
static Object strlit4806;
static Object strlit4819;
static Object strlit4826;
static Object strlit4835;
static Object strlit4840;
static Object strlit4848;
static Object strlit4882;
static Object strlit4924;
static Object strlit4944;
static Object strlit4950;
static Object strlit4964;
static Object strlit4977;
static Object strlit4981;
static Object strlit4988;
static Object strlit5006;
static Object strlit5011;
static Object strlit5021;
static Object strlit5026;
static Object strlit5034;
static ClassData objclass5047;
static ClassData objclass5050;
static Object strlit5122;
static Object strlit5131;
static Object strlit5137;
static Object strlit5146;
static Object strlit5151;
static Object strlit5170;
static Object strlit5177;
static Object strlit5182;
static Object strlit5209;
static Object strlit5218;
static Object strlit5231;
static Object strlit5237;
static Object strlit5252;
static Object strlit5257;
static Object strlit5267;
static Object strlit5272;
static Object strlit5280;
static Object strlit5282;
static ClassData objclass5286;
static ClassData objclass5289;
static Object strlit5338;
static Object strlit5347;
static Object strlit5353;
static Object strlit5370;
static Object strlit5379;
static Object strlit5406;
static Object strlit5413;
static Object strlit5419;
static ClassData objclass5422;
static ClassData objclass5425;
static Object strlit5468;
static Object strlit5477;
static Object strlit5484;
static Object strlit5490;
static Object strlit5509;
static Object strlit5512;
static Object strlit5539;
static Object strlit5549;
static Object strlit5560;
static ClassData objclass5563;
static ClassData objclass5566;
static Object strlit5625;
static Object strlit5633;
static Object strlit5649;
static Object strlit5656;
static Object strlit5661;
static Object strlit5694;
static Object strlit5701;
static Object strlit5707;
static ClassData objclass5710;
static ClassData objclass5713;
static Object strlit5778;
static Object strlit5811;
static Object strlit5820;
static Object strlit5829;
static Object strlit5832;
static Object strlit5838;
static Object strlit5850;
static Object strlit5855;
static Object strlit5872;
static Object strlit5877;
static Object strlit5893;
static Object strlit5902;
static Object strlit5925;
static Object strlit5932;
static Object strlit5938;
static Object strlit5943;
static ClassData objclass5949;
static ClassData objclass5952;
static Object strlit5961;
static Object strlit5967;
static Object strlit5975;
static ClassData objclass5978;
static ClassData objclass5981;
static Object strlit6010;
static Object strlit6016;
static Object strlit6020;
static Object strlit6028;
static Object strlit6032;
static Object strlit6038;
static Object strlit6042;
static Object strlit6048;
static Object strlit6052;
static Object strlit6058;
static Object strlit6062;
static Object strlit6073;
static Object strlit6079;
static ClassData objclass6082;
static ClassData objclass6085;
static Object strlit6114;
static Object strlit6120;
static Object strlit6130;
static ClassData objclass6133;
static ClassData objclass6136;
static Object strlit6188;
static Object strlit6197;
static Object strlit6204;
static Object strlit6210;
static Object strlit6214;
static Object strlit6234;
static Object strlit6254;
static Object strlit6268;
static Object strlit6277;
static Object strlit6286;
static Object strlit6298;
static Object strlit6310;
static Object strlit6317;
static Object strlit6336;
static Object strlit6345;
static Object strlit6355;
static Object strlit6372;
static ClassData objclass6375;
static ClassData objclass6378;
static Object strlit6427;
static Object strlit6436;
static Object strlit6442;
static Object strlit6444;
static Object strlit6464;
static Object strlit6484;
static Object strlit6497;
static Object strlit6512;
static Object strlit6525;
static Object strlit6533;
static ClassData objclass6536;
static ClassData objclass6539;
static Object strlit6588;
static Object strlit6597;
static Object strlit6603;
static Object strlit6605;
static Object strlit6625;
static Object strlit6645;
static Object strlit6658;
static Object strlit6683;
static Object strlit6690;
static ClassData objclass6693;
static ClassData objclass6696;
static Object strlit6792;
static Object strlit6801;
static Object strlit6807;
static Object strlit6809;
static Object strlit6832;
static Object strlit6837;
static Object strlit6854;
static Object strlit6859;
static Object strlit6874;
static Object strlit6902;
static Object strlit6908;
static Object strlit6921;
static Object strlit6928;
static Object strlit6937;
static Object strlit6942;
static Object strlit6957;
static Object strlit6972;
static Object strlit6978;
static Object strlit6988;
static Object strlit6992;
static Object strlit6995;
static Object strlit7018;
static Object strlit7025;
static ClassData objclass7034;
static ClassData objclass7037;
static Object strlit7135;
static Object strlit7144;
static Object strlit7150;
static Object strlit7152;
static Object strlit7179;
static Object strlit7184;
static Object strlit7201;
static Object strlit7206;
static Object strlit7221;
static Object strlit7249;
static Object strlit7255;
static Object strlit7268;
static Object strlit7275;
static Object strlit7284;
static Object strlit7289;
static Object strlit7304;
static Object strlit7319;
static Object strlit7325;
static Object strlit7335;
static Object strlit7339;
static Object strlit7342;
static Object strlit7365;
static Object strlit7372;
static ClassData objclass7379;
static ClassData objclass7382;
static Object strlit7413;
static Object strlit7422;
static Object strlit7428;
static Object strlit7430;
static Object strlit7436;
static Object strlit7443;
static Object strlit7447;
static Object strlit7457;
static Object strlit7464;
static Object strlit7468;
static Object strlit7478;
static Object strlit7485;
static Object strlit7491;
static Object strlit7498;
static ClassData objclass7503;
static ClassData objclass7506;
static Object strlit7534;
static Object strlit7543;
static Object strlit7549;
static Object strlit7551;
static Object strlit7557;
static Object strlit7564;
static Object strlit7568;
static Object strlit7578;
static Object strlit7584;
static Object strlit7589;
static ClassData objclass7592;
static ClassData objclass7595;
static Object strlit7635;
static Object strlit7644;
static Object strlit7650;
static Object strlit7652;
static Object strlit7678;
static Object strlit7682;
static ClassData objclass7685;
static ClassData objclass7688;
static Object strlit7728;
static Object strlit7737;
static Object strlit7743;
static Object strlit7745;
static Object strlit7766;
static Object strlit7775;
static Object strlit7780;
static ClassData objclass7783;
static ClassData objclass7786;
static Object strlit7802;
static Object strlit7804;
static Object strlit7807;
static Object strlit7808;
static ClassData objclass7811;
static ClassData objclass7814;
static Object strlit7854;
static Object strlit7855;
static ClassData objclass7894;
Object meth_ast__apply7(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_b = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_r = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_replacement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "replacement");
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8 = gc_frame_new();
// compilenode returning *var_b
  gc_frame_newslot(*var_b);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_v
  params[0] = *var_b;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9 = callmethod(*var_v, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe8);
// compilenode returning call9
  *var_replacement = call9;
  if (call9 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10 = gc_frame_new();
// compilenode returning *var_replacement
  gc_frame_newslot(*var_replacement);
// compilenode returning *var_r
  params[0] = *var_replacement;
  partcv[0] = 1;
  Object call11 = callmethod(*var_r, "push",
    1, partcv, params);
  gc_frame_end(callframe10);
// compilenode returning call11
  gc_frame_end(frame);
  return call11;
}
Object meth_ast_listMap_40__41_before_40__41_after0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "listMap()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_collections = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for listMap()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for listMap");
  Object *var_blkBefore = &(stackframe->slots[2]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[3]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_r = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "r");
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1 = gc_frame_new();
  int callframe2 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe2);
// compilenode returning call3
// compilenode returning call3
  partcv[0] = 0;
  Object call4 = callmethod(call3, "new",
    1, partcv, params);
  gc_frame_end(callframe1);
// compilenode returning call4
// compilenode returning call4
  *var_r = call4;
  if (call4 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5 = gc_frame_new();
// compilenode returning *var_l
  gc_frame_newslot(*var_l);
  Object block6 = alloc_Block(NULL, NULL, "ast", 24);
  gc_frame_newslot(block6);
  block_savedest(block6);
  Object closure7 = createclosure(5, "_apply");
setclosureframe(closure7, stackframe);
  addtoclosure(closure7, var_b);
  addtoclosure(closure7, var_blkBefore);
  addtoclosure(closure7, var_blkAfter);
  addtoclosure(closure7, var_r);
  addtoclosure(closure7, selfslot);
  struct UserObject *uo7 = (struct UserObject*)block6;
  uo7->data[0] = (Object)closure7;
  Method *meth_meth_ast__apply7 = addmethod2pos(block6, "_apply", &meth_ast__apply7, 0);
int argcv_meth_ast__apply7[] = {1};
meth_meth_ast__apply7->type = alloc_MethodType(1, argcv_meth_ast__apply7);
  meth_meth_ast__apply7->definitionModule = modulename;
  meth_meth_ast__apply7->definitionLine = 23;
// compilenode returning block6
  gc_frame_newslot(block6);
  params[0] = *var_l;
  params[1] = block6;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call13 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5);
// compilenode returning call13
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  gc_frame_end(frame);
  return *var_r;
}
Object meth_ast_maybeMap14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "maybeMap");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for maybeMap (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *var_before = &(stackframe->slots[2]);
  *var_before = args[curarg];
  curarg++;
  Object *var_after = &(stackframe->slots[3]);
  *var_after = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for maybeMap");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool17 = alloc_Boolean(0);
// compilenode returning bool17
  int op_slot_right_16 = gc_frame_newslot(bool17);
// compilenode returning *var_n
  int op_slot_left_16 = gc_frame_newslot(*var_n);
  params[0] = bool17;
  partcv[0] = 1;
  Object opresult19 = callmethod(*var_n, "!=", 1, partcv, params);
// compilenode returning opresult19
  Object if15 = done;
  if (istrue(opresult19)) {
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe20 = gc_frame_new();
// compilenode returning *var_b
  gc_frame_newslot(*var_b);
// compilenode returning *var_before
  gc_frame_newslot(*var_before);
// compilenode returning *var_after
  gc_frame_newslot(*var_after);
// compilenode returning *var_n
  params[0] = *var_b;
  params[1] = *var_before;
  params[2] = *var_after;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call21 = callmethod(*var_n, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe20);
// compilenode returning call21
  return call21;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if15 = undefined;
  } else {
  }
// compilenode returning if15
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast_map_40__41_before_40__41_after31(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe32 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call33 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe32);
// compilenode returning call33
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe34 = gc_frame_new();
  int callframe35 = gc_frame_new();
  partcv[0] = 0;
  Object call36 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe35);
// compilenode returning call36
  gc_frame_newslot(call36);
  int callframe37 = gc_frame_new();
  int callframe38 = gc_frame_new();
  partcv[0] = 0;
  Object call39 = callmethodflags(self, "args", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe38);
// compilenode returning call39
  gc_frame_newslot(call39);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe40 = gc_frame_new();
  int callframe41 = gc_frame_new();
  Object call42 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe41);
// compilenode returning call42
// compilenode returning call42
  partcv[0] = 0;
  Object call43 = callmethodflags(call42, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe40);
// compilenode returning call43
// compilenode returning call43
  params[0] = call39;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call44 = callmethodflags(call43, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe37);
// compilenode returning call44
  gc_frame_newslot(call44);
  int callframe45 = gc_frame_new();
  int callframe46 = gc_frame_new();
  int callframe47 = gc_frame_new();
  Object call48 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe47);
// compilenode returning call48
// compilenode returning call48
  partcv[0] = 0;
  Object call49 = callmethodflags(call48, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe46);
// compilenode returning call49
// compilenode returning call49
  partcv[0] = 0;
  Object call50 = callmethodflags(call49, "callWithPart", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe45);
// compilenode returning call50
  params[0] = call36;
  params[1] = call44;
  partcv[0] = 2;
  Object call51 = callmethod(call50, "new",
    1, partcv, params);
  gc_frame_end(callframe34);
// compilenode returning call51
  *var_n = call51;
  if (call51 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe52 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call53 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe52);
// compilenode returning call53
  *var_n = call53;
  if (call53 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe55 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call56 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe55);
// compilenode returning call56
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply60(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply63(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map57(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe58 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block59 = alloc_Block(NULL, NULL, "ast", 1905);
  gc_frame_newslot(block59);
  block_savedest(block59);
  Object closure60 = createclosure(1, "_apply");
setclosureframe(closure60, stackframe);
  addtoclosure(closure60, selfslot);
  struct UserObject *uo60 = (struct UserObject*)block59;
  uo60->data[0] = (Object)closure60;
  Method *meth_meth_ast__apply60 = addmethod2pos(block59, "_apply", &meth_ast__apply60, 0);
int argcv_meth_ast__apply60[] = {0};
meth_meth_ast__apply60->type = alloc_MethodType(1, argcv_meth_ast__apply60);
  meth_meth_ast__apply60->definitionModule = modulename;
  meth_meth_ast__apply60->definitionLine = 1899;
// compilenode returning block59
  gc_frame_newslot(block59);
  Object block62 = alloc_Block(NULL, NULL, "ast", 1905);
  gc_frame_newslot(block62);
  block_savedest(block62);
  Object closure63 = createclosure(1, "_apply");
setclosureframe(closure63, stackframe);
  addtoclosure(closure63, selfslot);
  struct UserObject *uo63 = (struct UserObject*)block62;
  uo63->data[0] = (Object)closure63;
  Method *meth_meth_ast__apply63 = addmethod2pos(block62, "_apply", &meth_ast__apply63, 0);
int argcv_meth_ast__apply63[] = {0};
meth_meth_ast__apply63->type = alloc_MethodType(1, argcv_meth_ast__apply63);
  meth_meth_ast__apply63->definitionModule = modulename;
  meth_meth_ast__apply63->definitionLine = 1899;
// compilenode returning block62
  gc_frame_newslot(block62);
  params[0] = *var_blk;
  params[1] = block59;
  params[2] = block62;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call65 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe58);
// compilenode returning call65
  gc_frame_end(frame);
  return call65;
}
Object meth_ast_new25(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject26 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj26 = alloc_userobj2(10,9, objclass26);
  gc_frame_newslot(obj26);
// OBJECT OUTER DEC outer
  adddatum2(obj26, self, 0);
  addmethodreal(obj26,"outer", &reader_ast_outer_27);
  Object oldself26 = self;
  struct StackFrameObject *oldstackframe26 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe26);
  gc_frame_newslot((Object)stackframe);
  self = obj26;
  Object *oldselfslot26 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter26 = (*(struct UserObject *)self).data[0], lowerouter26 = thisouter26;
  if (inheritingObject26) {
    struct UserObject *inho26 = (struct UserObject *)inheritingObject26;
    while (inho26->super != GraceDefaultObject) inho26 = (struct UserObject *)inho26->super;
    inho26->super = obj26;
    self = inheritingObject26;
    *selfslot = self;
    lowerouter26 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter26;
  }
if (objclass26 == NULL) {
  Method *reader28 = addmethodrealflags(obj26, "kind",&reader_ast_kind_28, MFLAG_DEF);
  reader28->definitionModule = modulename;
  reader28->definitionLine = 1889;
}
adddatum2(obj26, alloc_Undefined(), 1);
if (objclass26 == NULL) {
  Method *reader29 = addmethodrealflags(obj26, "name",&reader_ast_name_29, 0);
  Method *writer29 = addmethodrealflags(obj26, "name:=",&writer_ast_name_29, 0);
  reader29->definitionModule = modulename;
  writer29->definitionModule = modulename;
  reader29->definitionLine = 1890;
  writer29->definitionLine = 1890;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 2);
if (objclass26 == NULL) {
  Method *reader30 = addmethodrealflags(obj26, "args",&reader_ast_args_30, 0);
  Method *writer30 = addmethodrealflags(obj26, "args:=",&writer_ast_args_30, 0);
  reader30->definitionModule = modulename;
  writer30->definitionModule = modulename;
  reader30->definitionLine = 1891;
  writer30->definitionLine = 1891;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 3);
  struct UserObject *uo31 = (struct UserObject*)obj26;
  uo31->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after31 = addmethod2pos(obj26, "map()before()after", &meth_ast_map_40__41_before_40__41_after31, 4);
int argcv_meth_ast_map_40__41_before_40__41_after31[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after31->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after31);
  meth_meth_ast_map_40__41_before_40__41_after31->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after31->definitionLine = 1897;
  struct UserObject *uo57 = (struct UserObject*)obj26;
  uo57->data[5] = emptyclosure;
  Method *meth_meth_ast_map57 = addmethod2pos(obj26, "map", &meth_ast_map57, 5);
int argcv_meth_ast_map57[] = {1};
meth_meth_ast_map57->type = alloc_MethodType(1, argcv_meth_ast_map57);
  meth_meth_ast_map57->definitionModule = modulename;
  meth_meth_ast_map57->definitionLine = 1904;
  sourceObject = obj26;
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe66 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call67 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe66);
// compilenode returning call67
  struct UserObject *obj26_uo = (struct UserObject *)obj26;
  obj26_uo->super = call67;
  sourceObject = obj26;
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit68 == NULL) {
    strlit68 = alloc_String("callwithpart");
    gc_root(strlit68);
  }
// compilenode returning strlit68
  adddatum2(obj26, strlit68, 1);
  sourceObject = obj26;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit69 == NULL) {
    strlit69 = alloc_String("");
    gc_root(strlit69);
  }
// compilenode returning strlit69
  adddatum2(obj26, strlit69, 2);
  sourceObject = obj26;
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array70 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array70
  adddatum2(obj26, array70, 3);
  sourceObject = obj26;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num73 = alloc_Float64(0);
// compilenode returning num73
  int op_slot_right_72 = gc_frame_newslot(num73);
  int callframe75 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call76 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe75);
// compilenode returning call76
// compilenode returning call76
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = num73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, ">", 1, partcv, params);
// compilenode returning opresult77
  Object if71 = done;
struct StackFrameObject *iftmpstackframe71 = stackframe;
  if (istrue(opresult77)) {
stackframe = alloc_StackFrame(0, iftmpstackframe71);
gc_frame_newslot((Object)stackframe);
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe78 = gc_frame_new();
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num79 = alloc_Float64(1);
// compilenode returning num79
  params[0] = num79;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres80 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres80
  gc_frame_newslot(idxres80);
  params[0] = idxres80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compilenode returning call81
// compilenode returning done
    gc_frame_newslot(done);
    if71 = done;
  } else {
  }
stackframe = iftmpstackframe71;
// compilenode returning if71
  sourceObject = obj26;
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num84 = alloc_Float64(1);
// compilenode returning num84
  int op_slot_right_83 = gc_frame_newslot(num84);
  int callframe86 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call87 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe86);
// compilenode returning call87
// compilenode returning call87
  int op_slot_left_83 = gc_frame_newslot(call87);
  params[0] = num84;
  partcv[0] = 1;
  Object opresult88 = callmethod(call87, ">", 1, partcv, params);
// compilenode returning opresult88
  Object if82 = done;
struct StackFrameObject *iftmpstackframe82 = stackframe;
  if (istrue(opresult88)) {
stackframe = alloc_StackFrame(0, iftmpstackframe82);
gc_frame_newslot((Object)stackframe);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe89 = gc_frame_new();
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num90 = alloc_Float64(2);
// compilenode returning num90
  params[0] = num90;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres91 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres91
  gc_frame_newslot(idxres91);
  params[0] = idxres91;
  partcv[0] = 1;
  Object call92 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe89);
// compilenode returning call92
// compilenode returning done
    gc_frame_newslot(done);
    if82 = done;
  } else {
  }
stackframe = iftmpstackframe82;
// compilenode returning if82
  sourceObject = obj26;
  sourceObject = obj26;
objclass26 = obj26->class;
  objclass26->definitionModule = modulename;
  objclass26->definitionLine = 1886;
  (*(struct UserObject *)self).data[0] = lowerouter26;
  self = oldself26;
  selfslot = oldselfslot26;
  stackframe = oldstackframe26;
  gc_frame_end(frame);
  return obj26;
}
Object meth_ast_new25_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject26 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj26 = alloc_userobj2(10,9, objclass26);
  gc_frame_newslot(obj26);
// OBJECT OUTER DEC outer
  adddatum2(obj26, self, 0);
  addmethodreal(obj26,"outer", &reader_ast_outer_27);
  Object oldself26 = self;
  struct StackFrameObject *oldstackframe26 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe26);
  gc_frame_newslot((Object)stackframe);
  self = obj26;
  Object *oldselfslot26 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter26 = (*(struct UserObject *)self).data[0], lowerouter26 = thisouter26;
  if (inheritingObject26) {
    struct UserObject *inho26 = (struct UserObject *)inheritingObject26;
    while (inho26->super != GraceDefaultObject) inho26 = (struct UserObject *)inho26->super;
    inho26->super = obj26;
    self = inheritingObject26;
    *selfslot = self;
    lowerouter26 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter26;
  }
if (objclass26 == NULL) {
  Method *reader28 = addmethodrealflags(obj26, "kind",&reader_ast_kind_28, MFLAG_DEF);
  reader28->definitionModule = modulename;
  reader28->definitionLine = 1889;
}
adddatum2(obj26, alloc_Undefined(), 1);
if (objclass26 == NULL) {
  Method *reader29 = addmethodrealflags(obj26, "name",&reader_ast_name_29, 0);
  Method *writer29 = addmethodrealflags(obj26, "name:=",&writer_ast_name_29, 0);
  reader29->definitionModule = modulename;
  writer29->definitionModule = modulename;
  reader29->definitionLine = 1890;
  writer29->definitionLine = 1890;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 2);
if (objclass26 == NULL) {
  Method *reader30 = addmethodrealflags(obj26, "args",&reader_ast_args_30, 0);
  Method *writer30 = addmethodrealflags(obj26, "args:=",&writer_ast_args_30, 0);
  reader30->definitionModule = modulename;
  writer30->definitionModule = modulename;
  reader30->definitionLine = 1891;
  writer30->definitionLine = 1891;
}
obj26->flags |= OFLAG_MUTABLE;
adddatum2(obj26, alloc_Undefined(), 3);
  struct UserObject *uo31 = (struct UserObject*)obj26;
  uo31->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after31 = addmethod2pos(obj26, "map()before()after", &meth_ast_map_40__41_before_40__41_after31, 4);
int argcv_meth_ast_map_40__41_before_40__41_after31[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after31->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after31);
  meth_meth_ast_map_40__41_before_40__41_after31->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after31->definitionLine = 1897;
  struct UserObject *uo57 = (struct UserObject*)obj26;
  uo57->data[5] = emptyclosure;
  Method *meth_meth_ast_map57 = addmethod2pos(obj26, "map", &meth_ast_map57, 5);
int argcv_meth_ast_map57[] = {1};
meth_meth_ast_map57->type = alloc_MethodType(1, argcv_meth_ast_map57);
  meth_meth_ast_map57->definitionModule = modulename;
  meth_meth_ast_map57->definitionLine = 1904;
  sourceObject = obj26;
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe66 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call67 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe66);
// compilenode returning call67
  struct UserObject *obj26_uo = (struct UserObject *)obj26;
  obj26_uo->super = call67;
  sourceObject = obj26;
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit68 == NULL) {
    strlit68 = alloc_String("callwithpart");
    gc_root(strlit68);
  }
// compilenode returning strlit68
  adddatum2(obj26, strlit68, 1);
  sourceObject = obj26;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit69 == NULL) {
    strlit69 = alloc_String("");
    gc_root(strlit69);
  }
// compilenode returning strlit69
  adddatum2(obj26, strlit69, 2);
  sourceObject = obj26;
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array70 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array70
  adddatum2(obj26, array70, 3);
  sourceObject = obj26;
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num73 = alloc_Float64(0);
// compilenode returning num73
  int op_slot_right_72 = gc_frame_newslot(num73);
  int callframe75 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call76 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe75);
// compilenode returning call76
// compilenode returning call76
  int op_slot_left_72 = gc_frame_newslot(call76);
  params[0] = num73;
  partcv[0] = 1;
  Object opresult77 = callmethod(call76, ">", 1, partcv, params);
// compilenode returning opresult77
  Object if71 = done;
struct StackFrameObject *iftmpstackframe71 = stackframe;
  if (istrue(opresult77)) {
stackframe = alloc_StackFrame(0, iftmpstackframe71);
gc_frame_newslot((Object)stackframe);
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe78 = gc_frame_new();
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num79 = alloc_Float64(1);
// compilenode returning num79
  params[0] = num79;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres80 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres80
  gc_frame_newslot(idxres80);
  params[0] = idxres80;
  partcv[0] = 1;
  Object call81 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe78);
// compilenode returning call81
// compilenode returning done
    gc_frame_newslot(done);
    if71 = done;
  } else {
  }
stackframe = iftmpstackframe71;
// compilenode returning if71
  sourceObject = obj26;
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num84 = alloc_Float64(1);
// compilenode returning num84
  int op_slot_right_83 = gc_frame_newslot(num84);
  int callframe86 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call87 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe86);
// compilenode returning call87
// compilenode returning call87
  int op_slot_left_83 = gc_frame_newslot(call87);
  params[0] = num84;
  partcv[0] = 1;
  Object opresult88 = callmethod(call87, ">", 1, partcv, params);
// compilenode returning opresult88
  Object if82 = done;
struct StackFrameObject *iftmpstackframe82 = stackframe;
  if (istrue(opresult88)) {
stackframe = alloc_StackFrame(0, iftmpstackframe82);
gc_frame_newslot((Object)stackframe);
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe89 = gc_frame_new();
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num90 = alloc_Float64(2);
// compilenode returning num90
  params[0] = num90;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres91 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres91
  gc_frame_newslot(idxres91);
  params[0] = idxres91;
  partcv[0] = 1;
  Object call92 = callmethodflags(self, "args:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe89);
// compilenode returning call92
// compilenode returning done
    gc_frame_newslot(done);
    if82 = done;
  } else {
  }
stackframe = iftmpstackframe82;
// compilenode returning if82
  sourceObject = obj26;
  sourceObject = obj26;
objclass26 = obj26->class;
  objclass26->definitionModule = modulename;
  objclass26->definitionLine = 1886;
  (*(struct UserObject *)self).data[0] = lowerouter26;
  self = oldself26;
  selfslot = oldselfslot26;
  stackframe = oldstackframe26;
  gc_frame_end(frame);
  return obj26;
}
Object meth_ast_callWithPart22(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject23 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj23 = alloc_userobj2(2,4, objclass23);
  gc_frame_newslot(obj23);
// OBJECT OUTER DEC outer
  adddatum2(obj23, self, 0);
  addmethodreal(obj23,"outer", &reader_ast_outer_24);
  Object oldself23 = self;
  struct StackFrameObject *oldstackframe23 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe23);
  gc_frame_newslot((Object)stackframe);
  self = obj23;
  Object *oldselfslot23 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter23 = (*(struct UserObject *)self).data[0], lowerouter23 = thisouter23;
  if (inheritingObject23) {
    struct UserObject *inho23 = (struct UserObject *)inheritingObject23;
    while (inho23->super != GraceDefaultObject) inho23 = (struct UserObject *)inho23->super;
    inho23->super = obj23;
    self = inheritingObject23;
    *selfslot = self;
    lowerouter23 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter23;
  }
  block_savedest(obj23);
  Object closure25 = createclosure(1, "new");
setclosureframe(closure25, stackframe);
  addtoclosure(closure25, var_baseNode);
  struct UserObject *uo25 = (struct UserObject*)obj23;
  uo25->data[1] = (Object)closure25;
  Method *meth_meth_ast_new25 = addmethod2pos(obj23, "new", &meth_ast_new25, 1);
int argcv_meth_ast_new25[] = {0};
meth_meth_ast_new25->type = alloc_MethodType(1, argcv_meth_ast_new25);
  meth_meth_ast_new25->definitionModule = modulename;
  meth_meth_ast_new25->definitionLine = 1885;
  block_savedest(obj23);
  Object closure93 = createclosure(1, "new()object");
setclosureframe(closure93, stackframe);
  addtoclosure(closure93, var_baseNode);
  Method *meth_meth_ast_new25_object = addmethod2pos(obj23, "new()object", &meth_ast_new25_object, 1);
  meth_meth_ast_new25_object->definitionModule = modulename;
  meth_meth_ast_new25_object->definitionLine = 1885;
  sourceObject = obj23;
objclass23 = obj23->class;
  objclass23->definitionModule = modulename;
  objclass23->definitionLine = 1884;
  (*(struct UserObject *)self).data[0] = lowerouter23;
  self = oldself23;
  selfslot = oldselfslot23;
  stackframe = oldstackframe23;
  gc_frame_end(frame);
  return obj23;
}
Object meth_ast_callWithPart22_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callWithPart()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callWithPart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callWithPart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject23 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj23 = alloc_userobj2(2,4, objclass23);
  gc_frame_newslot(obj23);
// OBJECT OUTER DEC outer
  adddatum2(obj23, self, 0);
  addmethodreal(obj23,"outer", &reader_ast_outer_24);
  Object oldself23 = self;
  struct StackFrameObject *oldstackframe23 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe23);
  gc_frame_newslot((Object)stackframe);
  self = obj23;
  Object *oldselfslot23 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter23 = (*(struct UserObject *)self).data[0], lowerouter23 = thisouter23;
  if (inheritingObject23) {
    struct UserObject *inho23 = (struct UserObject *)inheritingObject23;
    while (inho23->super != GraceDefaultObject) inho23 = (struct UserObject *)inho23->super;
    inho23->super = obj23;
    self = inheritingObject23;
    *selfslot = self;
    lowerouter23 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter23;
  }
  block_savedest(obj23);
  Object closure25 = createclosure(1, "new");
setclosureframe(closure25, stackframe);
  addtoclosure(closure25, var_baseNode);
  struct UserObject *uo25 = (struct UserObject*)obj23;
  uo25->data[1] = (Object)closure25;
  Method *meth_meth_ast_new25 = addmethod2pos(obj23, "new", &meth_ast_new25, 1);
int argcv_meth_ast_new25[] = {0};
meth_meth_ast_new25->type = alloc_MethodType(1, argcv_meth_ast_new25);
  meth_meth_ast_new25->definitionModule = modulename;
  meth_meth_ast_new25->definitionLine = 1885;
  block_savedest(obj23);
  Object closure93 = createclosure(1, "new()object");
setclosureframe(closure93, stackframe);
  addtoclosure(closure93, var_baseNode);
  Method *meth_meth_ast_new25_object = addmethod2pos(obj23, "new()object", &meth_ast_new25_object, 1);
  meth_meth_ast_new25_object->definitionModule = modulename;
  meth_meth_ast_new25_object->definitionLine = 1885;
  sourceObject = obj23;
objclass23 = obj23->class;
  objclass23->definitionModule = modulename;
  objclass23->definitionLine = 1884;
  (*(struct UserObject *)self).data[0] = lowerouter23;
  self = oldself23;
  selfslot = oldselfslot23;
  stackframe = oldstackframe23;
  gc_frame_end(frame);
  return obj23;
}
Object meth_ast_ASTVisitor96(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ASTVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ASTVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ASTVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for ASTVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var_ASTVisitor
  gc_frame_end(frame);
  return *var_ASTVisitor;
}
Object meth_ast_visitFor100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitFor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitFor (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitFor");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool101 = alloc_Boolean(1);
// compilenode returning bool101
  gc_frame_end(frame);
  return bool101;
}
Object meth_ast_visitWhile102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitWhile");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitWhile (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitWhile");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool103 = alloc_Boolean(1);
// compilenode returning bool103
  gc_frame_end(frame);
  return bool103;
}
Object meth_ast_visitIf104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool105 = alloc_Boolean(1);
// compilenode returning bool105
  gc_frame_end(frame);
  return bool105;
}
Object meth_ast_visitBlock106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBlock (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitBlock");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool107 = alloc_Boolean(1);
// compilenode returning bool107
  gc_frame_end(frame);
  return bool107;
}
Object meth_ast_visitMatchCase108(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool109 = alloc_Boolean(1);
// compilenode returning bool109
  gc_frame_end(frame);
  return bool109;
}
Object meth_ast_visitCatchCase110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCatchCase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCatchCase (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCatchCase");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool111 = alloc_Boolean(1);
// compilenode returning bool111
  gc_frame_end(frame);
  return bool111;
}
Object meth_ast_visitMethodType112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethodType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethodType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMethodType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool113 = alloc_Boolean(1);
// compilenode returning bool113
  gc_frame_end(frame);
  return bool113;
}
Object meth_ast_visitType114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitType (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitType");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool115 = alloc_Boolean(1);
// compilenode returning bool115
  gc_frame_end(frame);
  return bool115;
}
Object meth_ast_visitMethod116(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMethod");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMethod (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMethod");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool117 = alloc_Boolean(1);
// compilenode returning bool117
  gc_frame_end(frame);
  return bool117;
}
Object meth_ast_visitCall118(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool119 = alloc_Boolean(1);
// compilenode returning bool119
  gc_frame_end(frame);
  return bool119;
}
Object meth_ast_visitClass120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitClass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitClass (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitClass");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1975
  setline(1975);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool121 = alloc_Boolean(1);
// compilenode returning bool121
  gc_frame_end(frame);
  return bool121;
}
Object meth_ast_visitObject122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitObject (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitObject");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool123 = alloc_Boolean(1);
// compilenode returning bool123
  gc_frame_end(frame);
  return bool123;
}
Object meth_ast_visitArray124(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitArray");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool125 = alloc_Boolean(1);
// compilenode returning bool125
  gc_frame_end(frame);
  return bool125;
}
Object meth_ast_visitMember126(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitMember");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitMember (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitMember");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool127 = alloc_Boolean(1);
// compilenode returning bool127
  gc_frame_end(frame);
  return bool127;
}
Object meth_ast_visitGeneric128(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitGeneric");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitGeneric (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitGeneric");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool129 = alloc_Boolean(1);
// compilenode returning bool129
  gc_frame_end(frame);
  return bool129;
}
Object meth_ast_visitIdentifier130(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIdentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIdentifier (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIdentifier");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool131 = alloc_Boolean(1);
// compilenode returning bool131
  gc_frame_end(frame);
  return bool131;
}
Object meth_ast_visitOctets132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOctets (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitOctets");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool133 = alloc_Boolean(1);
// compilenode returning bool133
  gc_frame_end(frame);
  return bool133;
}
Object meth_ast_visitString134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitString (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitString");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool135 = alloc_Boolean(1);
// compilenode returning bool135
  gc_frame_end(frame);
  return bool135;
}
Object meth_ast_visitNum136(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitNum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitNum (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitNum");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool137 = alloc_Boolean(1);
// compilenode returning bool137
  gc_frame_end(frame);
  return bool137;
}
Object meth_ast_visitOp138(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitOp");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitOp (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitOp");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool139 = alloc_Boolean(1);
// compilenode returning bool139
  gc_frame_end(frame);
  return bool139;
}
Object meth_ast_visitIndex140(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitIndex");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitIndex (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitIndex");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool141 = alloc_Boolean(1);
// compilenode returning bool141
  gc_frame_end(frame);
  return bool141;
}
Object meth_ast_visitBind142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitBind");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitBind (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitBind");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool143 = alloc_Boolean(1);
// compilenode returning bool143
  gc_frame_end(frame);
  return bool143;
}
Object meth_ast_visitDefDec144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDefDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDefDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitDefDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool145 = alloc_Boolean(1);
// compilenode returning bool145
  gc_frame_end(frame);
  return bool145;
}
Object meth_ast_visitVarDec146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitVarDec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitVarDec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitVarDec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool147 = alloc_Boolean(1);
// compilenode returning bool147
  gc_frame_end(frame);
  return bool147;
}
Object meth_ast_visitImport148(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitImport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitImport (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitImport");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool149 = alloc_Boolean(1);
// compilenode returning bool149
  gc_frame_end(frame);
  return bool149;
}
Object meth_ast_visitReturn150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitReturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitReturn (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitReturn");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool151 = alloc_Boolean(1);
// compilenode returning bool151
  gc_frame_end(frame);
  return bool151;
}
Object meth_ast_visitInherits152(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitInherits");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitInherits (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitInherits");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool153 = alloc_Boolean(1);
// compilenode returning bool153
  gc_frame_end(frame);
  return bool153;
}
Object meth_ast_visitDialect154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitDialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitDialect (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitDialect");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool155 = alloc_Boolean(1);
// compilenode returning bool155
  gc_frame_end(frame);
  return bool155;
}
Object meth_ast_baseVisitor97(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(28,29, objclass98);
  gc_frame_newslot(obj98);
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_ast_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  struct UserObject *uo100 = (struct UserObject*)obj98;
  uo100->data[1] = emptyclosure;
  Method *meth_meth_ast_visitFor100 = addmethod2pos(obj98, "visitFor", &meth_ast_visitFor100, 1);
int argcv_meth_ast_visitFor100[] = {1};
meth_meth_ast_visitFor100->type = alloc_MethodType(1, argcv_meth_ast_visitFor100);
  meth_meth_ast_visitFor100->definitionModule = modulename;
  meth_meth_ast_visitFor100->definitionLine = 1944;
  struct UserObject *uo102 = (struct UserObject*)obj98;
  uo102->data[2] = emptyclosure;
  Method *meth_meth_ast_visitWhile102 = addmethod2pos(obj98, "visitWhile", &meth_ast_visitWhile102, 2);
int argcv_meth_ast_visitWhile102[] = {1};
meth_meth_ast_visitWhile102->type = alloc_MethodType(1, argcv_meth_ast_visitWhile102);
  meth_meth_ast_visitWhile102->definitionModule = modulename;
  meth_meth_ast_visitWhile102->definitionLine = 1947;
  struct UserObject *uo104 = (struct UserObject*)obj98;
  uo104->data[3] = emptyclosure;
  Method *meth_meth_ast_visitIf104 = addmethod2pos(obj98, "visitIf", &meth_ast_visitIf104, 3);
int argcv_meth_ast_visitIf104[] = {1};
meth_meth_ast_visitIf104->type = alloc_MethodType(1, argcv_meth_ast_visitIf104);
  meth_meth_ast_visitIf104->definitionModule = modulename;
  meth_meth_ast_visitIf104->definitionLine = 1950;
  struct UserObject *uo106 = (struct UserObject*)obj98;
  uo106->data[4] = emptyclosure;
  Method *meth_meth_ast_visitBlock106 = addmethod2pos(obj98, "visitBlock", &meth_ast_visitBlock106, 4);
int argcv_meth_ast_visitBlock106[] = {1};
meth_meth_ast_visitBlock106->type = alloc_MethodType(1, argcv_meth_ast_visitBlock106);
  meth_meth_ast_visitBlock106->definitionModule = modulename;
  meth_meth_ast_visitBlock106->definitionLine = 1953;
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase108 = addmethod2pos(obj98, "visitMatchCase", &meth_ast_visitMatchCase108, 5);
int argcv_meth_ast_visitMatchCase108[] = {1};
meth_meth_ast_visitMatchCase108->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase108);
  meth_meth_ast_visitMatchCase108->definitionModule = modulename;
  meth_meth_ast_visitMatchCase108->definitionLine = 1956;
  struct UserObject *uo110 = (struct UserObject*)obj98;
  uo110->data[6] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase110 = addmethod2pos(obj98, "visitCatchCase", &meth_ast_visitCatchCase110, 6);
int argcv_meth_ast_visitCatchCase110[] = {1};
meth_meth_ast_visitCatchCase110->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase110);
  meth_meth_ast_visitCatchCase110->definitionModule = modulename;
  meth_meth_ast_visitCatchCase110->definitionLine = 1959;
  struct UserObject *uo112 = (struct UserObject*)obj98;
  uo112->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMethodType112 = addmethod2pos(obj98, "visitMethodType", &meth_ast_visitMethodType112, 7);
int argcv_meth_ast_visitMethodType112[] = {1};
meth_meth_ast_visitMethodType112->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType112);
  meth_meth_ast_visitMethodType112->definitionModule = modulename;
  meth_meth_ast_visitMethodType112->definitionLine = 1962;
  struct UserObject *uo114 = (struct UserObject*)obj98;
  uo114->data[8] = emptyclosure;
  Method *meth_meth_ast_visitType114 = addmethod2pos(obj98, "visitType", &meth_ast_visitType114, 8);
int argcv_meth_ast_visitType114[] = {1};
meth_meth_ast_visitType114->type = alloc_MethodType(1, argcv_meth_ast_visitType114);
  meth_meth_ast_visitType114->definitionModule = modulename;
  meth_meth_ast_visitType114->definitionLine = 1965;
  struct UserObject *uo116 = (struct UserObject*)obj98;
  uo116->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod116 = addmethod2pos(obj98, "visitMethod", &meth_ast_visitMethod116, 9);
int argcv_meth_ast_visitMethod116[] = {1};
meth_meth_ast_visitMethod116->type = alloc_MethodType(1, argcv_meth_ast_visitMethod116);
  meth_meth_ast_visitMethod116->definitionModule = modulename;
  meth_meth_ast_visitMethod116->definitionLine = 1968;
  struct UserObject *uo118 = (struct UserObject*)obj98;
  uo118->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall118 = addmethod2pos(obj98, "visitCall", &meth_ast_visitCall118, 10);
int argcv_meth_ast_visitCall118[] = {1};
meth_meth_ast_visitCall118->type = alloc_MethodType(1, argcv_meth_ast_visitCall118);
  meth_meth_ast_visitCall118->definitionModule = modulename;
  meth_meth_ast_visitCall118->definitionLine = 1971;
  struct UserObject *uo120 = (struct UserObject*)obj98;
  uo120->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass120 = addmethod2pos(obj98, "visitClass", &meth_ast_visitClass120, 11);
int argcv_meth_ast_visitClass120[] = {1};
meth_meth_ast_visitClass120->type = alloc_MethodType(1, argcv_meth_ast_visitClass120);
  meth_meth_ast_visitClass120->definitionModule = modulename;
  meth_meth_ast_visitClass120->definitionLine = 1974;
  struct UserObject *uo122 = (struct UserObject*)obj98;
  uo122->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject122 = addmethod2pos(obj98, "visitObject", &meth_ast_visitObject122, 12);
int argcv_meth_ast_visitObject122[] = {1};
meth_meth_ast_visitObject122->type = alloc_MethodType(1, argcv_meth_ast_visitObject122);
  meth_meth_ast_visitObject122->definitionModule = modulename;
  meth_meth_ast_visitObject122->definitionLine = 1977;
  struct UserObject *uo124 = (struct UserObject*)obj98;
  uo124->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray124 = addmethod2pos(obj98, "visitArray", &meth_ast_visitArray124, 13);
int argcv_meth_ast_visitArray124[] = {1};
meth_meth_ast_visitArray124->type = alloc_MethodType(1, argcv_meth_ast_visitArray124);
  meth_meth_ast_visitArray124->definitionModule = modulename;
  meth_meth_ast_visitArray124->definitionLine = 1980;
  struct UserObject *uo126 = (struct UserObject*)obj98;
  uo126->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember126 = addmethod2pos(obj98, "visitMember", &meth_ast_visitMember126, 14);
int argcv_meth_ast_visitMember126[] = {1};
meth_meth_ast_visitMember126->type = alloc_MethodType(1, argcv_meth_ast_visitMember126);
  meth_meth_ast_visitMember126->definitionModule = modulename;
  meth_meth_ast_visitMember126->definitionLine = 1983;
  struct UserObject *uo128 = (struct UserObject*)obj98;
  uo128->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric128 = addmethod2pos(obj98, "visitGeneric", &meth_ast_visitGeneric128, 15);
int argcv_meth_ast_visitGeneric128[] = {1};
meth_meth_ast_visitGeneric128->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric128);
  meth_meth_ast_visitGeneric128->definitionModule = modulename;
  meth_meth_ast_visitGeneric128->definitionLine = 1986;
  struct UserObject *uo130 = (struct UserObject*)obj98;
  uo130->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier130 = addmethod2pos(obj98, "visitIdentifier", &meth_ast_visitIdentifier130, 16);
int argcv_meth_ast_visitIdentifier130[] = {1};
meth_meth_ast_visitIdentifier130->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier130);
  meth_meth_ast_visitIdentifier130->definitionModule = modulename;
  meth_meth_ast_visitIdentifier130->definitionLine = 1989;
  struct UserObject *uo132 = (struct UserObject*)obj98;
  uo132->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets132 = addmethod2pos(obj98, "visitOctets", &meth_ast_visitOctets132, 17);
int argcv_meth_ast_visitOctets132[] = {1};
meth_meth_ast_visitOctets132->type = alloc_MethodType(1, argcv_meth_ast_visitOctets132);
  meth_meth_ast_visitOctets132->definitionModule = modulename;
  meth_meth_ast_visitOctets132->definitionLine = 1992;
  struct UserObject *uo134 = (struct UserObject*)obj98;
  uo134->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString134 = addmethod2pos(obj98, "visitString", &meth_ast_visitString134, 18);
int argcv_meth_ast_visitString134[] = {1};
meth_meth_ast_visitString134->type = alloc_MethodType(1, argcv_meth_ast_visitString134);
  meth_meth_ast_visitString134->definitionModule = modulename;
  meth_meth_ast_visitString134->definitionLine = 1995;
  struct UserObject *uo136 = (struct UserObject*)obj98;
  uo136->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum136 = addmethod2pos(obj98, "visitNum", &meth_ast_visitNum136, 19);
int argcv_meth_ast_visitNum136[] = {1};
meth_meth_ast_visitNum136->type = alloc_MethodType(1, argcv_meth_ast_visitNum136);
  meth_meth_ast_visitNum136->definitionModule = modulename;
  meth_meth_ast_visitNum136->definitionLine = 1998;
  struct UserObject *uo138 = (struct UserObject*)obj98;
  uo138->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp138 = addmethod2pos(obj98, "visitOp", &meth_ast_visitOp138, 20);
int argcv_meth_ast_visitOp138[] = {1};
meth_meth_ast_visitOp138->type = alloc_MethodType(1, argcv_meth_ast_visitOp138);
  meth_meth_ast_visitOp138->definitionModule = modulename;
  meth_meth_ast_visitOp138->definitionLine = 2001;
  struct UserObject *uo140 = (struct UserObject*)obj98;
  uo140->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex140 = addmethod2pos(obj98, "visitIndex", &meth_ast_visitIndex140, 21);
int argcv_meth_ast_visitIndex140[] = {1};
meth_meth_ast_visitIndex140->type = alloc_MethodType(1, argcv_meth_ast_visitIndex140);
  meth_meth_ast_visitIndex140->definitionModule = modulename;
  meth_meth_ast_visitIndex140->definitionLine = 2004;
  struct UserObject *uo142 = (struct UserObject*)obj98;
  uo142->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind142 = addmethod2pos(obj98, "visitBind", &meth_ast_visitBind142, 22);
int argcv_meth_ast_visitBind142[] = {1};
meth_meth_ast_visitBind142->type = alloc_MethodType(1, argcv_meth_ast_visitBind142);
  meth_meth_ast_visitBind142->definitionModule = modulename;
  meth_meth_ast_visitBind142->definitionLine = 2007;
  struct UserObject *uo144 = (struct UserObject*)obj98;
  uo144->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec144 = addmethod2pos(obj98, "visitDefDec", &meth_ast_visitDefDec144, 23);
int argcv_meth_ast_visitDefDec144[] = {1};
meth_meth_ast_visitDefDec144->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec144);
  meth_meth_ast_visitDefDec144->definitionModule = modulename;
  meth_meth_ast_visitDefDec144->definitionLine = 2010;
  struct UserObject *uo146 = (struct UserObject*)obj98;
  uo146->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec146 = addmethod2pos(obj98, "visitVarDec", &meth_ast_visitVarDec146, 24);
int argcv_meth_ast_visitVarDec146[] = {1};
meth_meth_ast_visitVarDec146->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec146);
  meth_meth_ast_visitVarDec146->definitionModule = modulename;
  meth_meth_ast_visitVarDec146->definitionLine = 2013;
  struct UserObject *uo148 = (struct UserObject*)obj98;
  uo148->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport148 = addmethod2pos(obj98, "visitImport", &meth_ast_visitImport148, 25);
int argcv_meth_ast_visitImport148[] = {1};
meth_meth_ast_visitImport148->type = alloc_MethodType(1, argcv_meth_ast_visitImport148);
  meth_meth_ast_visitImport148->definitionModule = modulename;
  meth_meth_ast_visitImport148->definitionLine = 2016;
  struct UserObject *uo150 = (struct UserObject*)obj98;
  uo150->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn150 = addmethod2pos(obj98, "visitReturn", &meth_ast_visitReturn150, 26);
int argcv_meth_ast_visitReturn150[] = {1};
meth_meth_ast_visitReturn150->type = alloc_MethodType(1, argcv_meth_ast_visitReturn150);
  meth_meth_ast_visitReturn150->definitionModule = modulename;
  meth_meth_ast_visitReturn150->definitionLine = 2019;
  struct UserObject *uo152 = (struct UserObject*)obj98;
  uo152->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits152 = addmethod2pos(obj98, "visitInherits", &meth_ast_visitInherits152, 27);
int argcv_meth_ast_visitInherits152[] = {1};
meth_meth_ast_visitInherits152->type = alloc_MethodType(1, argcv_meth_ast_visitInherits152);
  meth_meth_ast_visitInherits152->definitionModule = modulename;
  meth_meth_ast_visitInherits152->definitionLine = 2022;
  struct UserObject *uo154 = (struct UserObject*)obj98;
  uo154->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect154 = addmethod2pos(obj98, "visitDialect", &meth_ast_visitDialect154, 28);
int argcv_meth_ast_visitDialect154[] = {1};
meth_meth_ast_visitDialect154->type = alloc_MethodType(1, argcv_meth_ast_visitDialect154);
  meth_meth_ast_visitDialect154->definitionModule = modulename;
  meth_meth_ast_visitDialect154->definitionLine = 2025;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 1943;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_ast_baseVisitor97_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "baseVisitor()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseVisitor");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject98 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj98 = alloc_userobj2(28,29, objclass98);
  gc_frame_newslot(obj98);
// OBJECT OUTER DEC outer
  adddatum2(obj98, self, 0);
  addmethodreal(obj98,"outer", &reader_ast_outer_99);
  Object oldself98 = self;
  struct StackFrameObject *oldstackframe98 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe98);
  gc_frame_newslot((Object)stackframe);
  self = obj98;
  Object *oldselfslot98 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter98 = (*(struct UserObject *)self).data[0], lowerouter98 = thisouter98;
  if (inheritingObject98) {
    struct UserObject *inho98 = (struct UserObject *)inheritingObject98;
    while (inho98->super != GraceDefaultObject) inho98 = (struct UserObject *)inho98->super;
    inho98->super = obj98;
    self = inheritingObject98;
    *selfslot = self;
    lowerouter98 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter98;
  }
  struct UserObject *uo100 = (struct UserObject*)obj98;
  uo100->data[1] = emptyclosure;
  Method *meth_meth_ast_visitFor100 = addmethod2pos(obj98, "visitFor", &meth_ast_visitFor100, 1);
int argcv_meth_ast_visitFor100[] = {1};
meth_meth_ast_visitFor100->type = alloc_MethodType(1, argcv_meth_ast_visitFor100);
  meth_meth_ast_visitFor100->definitionModule = modulename;
  meth_meth_ast_visitFor100->definitionLine = 1944;
  struct UserObject *uo102 = (struct UserObject*)obj98;
  uo102->data[2] = emptyclosure;
  Method *meth_meth_ast_visitWhile102 = addmethod2pos(obj98, "visitWhile", &meth_ast_visitWhile102, 2);
int argcv_meth_ast_visitWhile102[] = {1};
meth_meth_ast_visitWhile102->type = alloc_MethodType(1, argcv_meth_ast_visitWhile102);
  meth_meth_ast_visitWhile102->definitionModule = modulename;
  meth_meth_ast_visitWhile102->definitionLine = 1947;
  struct UserObject *uo104 = (struct UserObject*)obj98;
  uo104->data[3] = emptyclosure;
  Method *meth_meth_ast_visitIf104 = addmethod2pos(obj98, "visitIf", &meth_ast_visitIf104, 3);
int argcv_meth_ast_visitIf104[] = {1};
meth_meth_ast_visitIf104->type = alloc_MethodType(1, argcv_meth_ast_visitIf104);
  meth_meth_ast_visitIf104->definitionModule = modulename;
  meth_meth_ast_visitIf104->definitionLine = 1950;
  struct UserObject *uo106 = (struct UserObject*)obj98;
  uo106->data[4] = emptyclosure;
  Method *meth_meth_ast_visitBlock106 = addmethod2pos(obj98, "visitBlock", &meth_ast_visitBlock106, 4);
int argcv_meth_ast_visitBlock106[] = {1};
meth_meth_ast_visitBlock106->type = alloc_MethodType(1, argcv_meth_ast_visitBlock106);
  meth_meth_ast_visitBlock106->definitionModule = modulename;
  meth_meth_ast_visitBlock106->definitionLine = 1953;
  struct UserObject *uo108 = (struct UserObject*)obj98;
  uo108->data[5] = emptyclosure;
  Method *meth_meth_ast_visitMatchCase108 = addmethod2pos(obj98, "visitMatchCase", &meth_ast_visitMatchCase108, 5);
int argcv_meth_ast_visitMatchCase108[] = {1};
meth_meth_ast_visitMatchCase108->type = alloc_MethodType(1, argcv_meth_ast_visitMatchCase108);
  meth_meth_ast_visitMatchCase108->definitionModule = modulename;
  meth_meth_ast_visitMatchCase108->definitionLine = 1956;
  struct UserObject *uo110 = (struct UserObject*)obj98;
  uo110->data[6] = emptyclosure;
  Method *meth_meth_ast_visitCatchCase110 = addmethod2pos(obj98, "visitCatchCase", &meth_ast_visitCatchCase110, 6);
int argcv_meth_ast_visitCatchCase110[] = {1};
meth_meth_ast_visitCatchCase110->type = alloc_MethodType(1, argcv_meth_ast_visitCatchCase110);
  meth_meth_ast_visitCatchCase110->definitionModule = modulename;
  meth_meth_ast_visitCatchCase110->definitionLine = 1959;
  struct UserObject *uo112 = (struct UserObject*)obj98;
  uo112->data[7] = emptyclosure;
  Method *meth_meth_ast_visitMethodType112 = addmethod2pos(obj98, "visitMethodType", &meth_ast_visitMethodType112, 7);
int argcv_meth_ast_visitMethodType112[] = {1};
meth_meth_ast_visitMethodType112->type = alloc_MethodType(1, argcv_meth_ast_visitMethodType112);
  meth_meth_ast_visitMethodType112->definitionModule = modulename;
  meth_meth_ast_visitMethodType112->definitionLine = 1962;
  struct UserObject *uo114 = (struct UserObject*)obj98;
  uo114->data[8] = emptyclosure;
  Method *meth_meth_ast_visitType114 = addmethod2pos(obj98, "visitType", &meth_ast_visitType114, 8);
int argcv_meth_ast_visitType114[] = {1};
meth_meth_ast_visitType114->type = alloc_MethodType(1, argcv_meth_ast_visitType114);
  meth_meth_ast_visitType114->definitionModule = modulename;
  meth_meth_ast_visitType114->definitionLine = 1965;
  struct UserObject *uo116 = (struct UserObject*)obj98;
  uo116->data[9] = emptyclosure;
  Method *meth_meth_ast_visitMethod116 = addmethod2pos(obj98, "visitMethod", &meth_ast_visitMethod116, 9);
int argcv_meth_ast_visitMethod116[] = {1};
meth_meth_ast_visitMethod116->type = alloc_MethodType(1, argcv_meth_ast_visitMethod116);
  meth_meth_ast_visitMethod116->definitionModule = modulename;
  meth_meth_ast_visitMethod116->definitionLine = 1968;
  struct UserObject *uo118 = (struct UserObject*)obj98;
  uo118->data[10] = emptyclosure;
  Method *meth_meth_ast_visitCall118 = addmethod2pos(obj98, "visitCall", &meth_ast_visitCall118, 10);
int argcv_meth_ast_visitCall118[] = {1};
meth_meth_ast_visitCall118->type = alloc_MethodType(1, argcv_meth_ast_visitCall118);
  meth_meth_ast_visitCall118->definitionModule = modulename;
  meth_meth_ast_visitCall118->definitionLine = 1971;
  struct UserObject *uo120 = (struct UserObject*)obj98;
  uo120->data[11] = emptyclosure;
  Method *meth_meth_ast_visitClass120 = addmethod2pos(obj98, "visitClass", &meth_ast_visitClass120, 11);
int argcv_meth_ast_visitClass120[] = {1};
meth_meth_ast_visitClass120->type = alloc_MethodType(1, argcv_meth_ast_visitClass120);
  meth_meth_ast_visitClass120->definitionModule = modulename;
  meth_meth_ast_visitClass120->definitionLine = 1974;
  struct UserObject *uo122 = (struct UserObject*)obj98;
  uo122->data[12] = emptyclosure;
  Method *meth_meth_ast_visitObject122 = addmethod2pos(obj98, "visitObject", &meth_ast_visitObject122, 12);
int argcv_meth_ast_visitObject122[] = {1};
meth_meth_ast_visitObject122->type = alloc_MethodType(1, argcv_meth_ast_visitObject122);
  meth_meth_ast_visitObject122->definitionModule = modulename;
  meth_meth_ast_visitObject122->definitionLine = 1977;
  struct UserObject *uo124 = (struct UserObject*)obj98;
  uo124->data[13] = emptyclosure;
  Method *meth_meth_ast_visitArray124 = addmethod2pos(obj98, "visitArray", &meth_ast_visitArray124, 13);
int argcv_meth_ast_visitArray124[] = {1};
meth_meth_ast_visitArray124->type = alloc_MethodType(1, argcv_meth_ast_visitArray124);
  meth_meth_ast_visitArray124->definitionModule = modulename;
  meth_meth_ast_visitArray124->definitionLine = 1980;
  struct UserObject *uo126 = (struct UserObject*)obj98;
  uo126->data[14] = emptyclosure;
  Method *meth_meth_ast_visitMember126 = addmethod2pos(obj98, "visitMember", &meth_ast_visitMember126, 14);
int argcv_meth_ast_visitMember126[] = {1};
meth_meth_ast_visitMember126->type = alloc_MethodType(1, argcv_meth_ast_visitMember126);
  meth_meth_ast_visitMember126->definitionModule = modulename;
  meth_meth_ast_visitMember126->definitionLine = 1983;
  struct UserObject *uo128 = (struct UserObject*)obj98;
  uo128->data[15] = emptyclosure;
  Method *meth_meth_ast_visitGeneric128 = addmethod2pos(obj98, "visitGeneric", &meth_ast_visitGeneric128, 15);
int argcv_meth_ast_visitGeneric128[] = {1};
meth_meth_ast_visitGeneric128->type = alloc_MethodType(1, argcv_meth_ast_visitGeneric128);
  meth_meth_ast_visitGeneric128->definitionModule = modulename;
  meth_meth_ast_visitGeneric128->definitionLine = 1986;
  struct UserObject *uo130 = (struct UserObject*)obj98;
  uo130->data[16] = emptyclosure;
  Method *meth_meth_ast_visitIdentifier130 = addmethod2pos(obj98, "visitIdentifier", &meth_ast_visitIdentifier130, 16);
int argcv_meth_ast_visitIdentifier130[] = {1};
meth_meth_ast_visitIdentifier130->type = alloc_MethodType(1, argcv_meth_ast_visitIdentifier130);
  meth_meth_ast_visitIdentifier130->definitionModule = modulename;
  meth_meth_ast_visitIdentifier130->definitionLine = 1989;
  struct UserObject *uo132 = (struct UserObject*)obj98;
  uo132->data[17] = emptyclosure;
  Method *meth_meth_ast_visitOctets132 = addmethod2pos(obj98, "visitOctets", &meth_ast_visitOctets132, 17);
int argcv_meth_ast_visitOctets132[] = {1};
meth_meth_ast_visitOctets132->type = alloc_MethodType(1, argcv_meth_ast_visitOctets132);
  meth_meth_ast_visitOctets132->definitionModule = modulename;
  meth_meth_ast_visitOctets132->definitionLine = 1992;
  struct UserObject *uo134 = (struct UserObject*)obj98;
  uo134->data[18] = emptyclosure;
  Method *meth_meth_ast_visitString134 = addmethod2pos(obj98, "visitString", &meth_ast_visitString134, 18);
int argcv_meth_ast_visitString134[] = {1};
meth_meth_ast_visitString134->type = alloc_MethodType(1, argcv_meth_ast_visitString134);
  meth_meth_ast_visitString134->definitionModule = modulename;
  meth_meth_ast_visitString134->definitionLine = 1995;
  struct UserObject *uo136 = (struct UserObject*)obj98;
  uo136->data[19] = emptyclosure;
  Method *meth_meth_ast_visitNum136 = addmethod2pos(obj98, "visitNum", &meth_ast_visitNum136, 19);
int argcv_meth_ast_visitNum136[] = {1};
meth_meth_ast_visitNum136->type = alloc_MethodType(1, argcv_meth_ast_visitNum136);
  meth_meth_ast_visitNum136->definitionModule = modulename;
  meth_meth_ast_visitNum136->definitionLine = 1998;
  struct UserObject *uo138 = (struct UserObject*)obj98;
  uo138->data[20] = emptyclosure;
  Method *meth_meth_ast_visitOp138 = addmethod2pos(obj98, "visitOp", &meth_ast_visitOp138, 20);
int argcv_meth_ast_visitOp138[] = {1};
meth_meth_ast_visitOp138->type = alloc_MethodType(1, argcv_meth_ast_visitOp138);
  meth_meth_ast_visitOp138->definitionModule = modulename;
  meth_meth_ast_visitOp138->definitionLine = 2001;
  struct UserObject *uo140 = (struct UserObject*)obj98;
  uo140->data[21] = emptyclosure;
  Method *meth_meth_ast_visitIndex140 = addmethod2pos(obj98, "visitIndex", &meth_ast_visitIndex140, 21);
int argcv_meth_ast_visitIndex140[] = {1};
meth_meth_ast_visitIndex140->type = alloc_MethodType(1, argcv_meth_ast_visitIndex140);
  meth_meth_ast_visitIndex140->definitionModule = modulename;
  meth_meth_ast_visitIndex140->definitionLine = 2004;
  struct UserObject *uo142 = (struct UserObject*)obj98;
  uo142->data[22] = emptyclosure;
  Method *meth_meth_ast_visitBind142 = addmethod2pos(obj98, "visitBind", &meth_ast_visitBind142, 22);
int argcv_meth_ast_visitBind142[] = {1};
meth_meth_ast_visitBind142->type = alloc_MethodType(1, argcv_meth_ast_visitBind142);
  meth_meth_ast_visitBind142->definitionModule = modulename;
  meth_meth_ast_visitBind142->definitionLine = 2007;
  struct UserObject *uo144 = (struct UserObject*)obj98;
  uo144->data[23] = emptyclosure;
  Method *meth_meth_ast_visitDefDec144 = addmethod2pos(obj98, "visitDefDec", &meth_ast_visitDefDec144, 23);
int argcv_meth_ast_visitDefDec144[] = {1};
meth_meth_ast_visitDefDec144->type = alloc_MethodType(1, argcv_meth_ast_visitDefDec144);
  meth_meth_ast_visitDefDec144->definitionModule = modulename;
  meth_meth_ast_visitDefDec144->definitionLine = 2010;
  struct UserObject *uo146 = (struct UserObject*)obj98;
  uo146->data[24] = emptyclosure;
  Method *meth_meth_ast_visitVarDec146 = addmethod2pos(obj98, "visitVarDec", &meth_ast_visitVarDec146, 24);
int argcv_meth_ast_visitVarDec146[] = {1};
meth_meth_ast_visitVarDec146->type = alloc_MethodType(1, argcv_meth_ast_visitVarDec146);
  meth_meth_ast_visitVarDec146->definitionModule = modulename;
  meth_meth_ast_visitVarDec146->definitionLine = 2013;
  struct UserObject *uo148 = (struct UserObject*)obj98;
  uo148->data[25] = emptyclosure;
  Method *meth_meth_ast_visitImport148 = addmethod2pos(obj98, "visitImport", &meth_ast_visitImport148, 25);
int argcv_meth_ast_visitImport148[] = {1};
meth_meth_ast_visitImport148->type = alloc_MethodType(1, argcv_meth_ast_visitImport148);
  meth_meth_ast_visitImport148->definitionModule = modulename;
  meth_meth_ast_visitImport148->definitionLine = 2016;
  struct UserObject *uo150 = (struct UserObject*)obj98;
  uo150->data[26] = emptyclosure;
  Method *meth_meth_ast_visitReturn150 = addmethod2pos(obj98, "visitReturn", &meth_ast_visitReturn150, 26);
int argcv_meth_ast_visitReturn150[] = {1};
meth_meth_ast_visitReturn150->type = alloc_MethodType(1, argcv_meth_ast_visitReturn150);
  meth_meth_ast_visitReturn150->definitionModule = modulename;
  meth_meth_ast_visitReturn150->definitionLine = 2019;
  struct UserObject *uo152 = (struct UserObject*)obj98;
  uo152->data[27] = emptyclosure;
  Method *meth_meth_ast_visitInherits152 = addmethod2pos(obj98, "visitInherits", &meth_ast_visitInherits152, 27);
int argcv_meth_ast_visitInherits152[] = {1};
meth_meth_ast_visitInherits152->type = alloc_MethodType(1, argcv_meth_ast_visitInherits152);
  meth_meth_ast_visitInherits152->definitionModule = modulename;
  meth_meth_ast_visitInherits152->definitionLine = 2022;
  struct UserObject *uo154 = (struct UserObject*)obj98;
  uo154->data[28] = emptyclosure;
  Method *meth_meth_ast_visitDialect154 = addmethod2pos(obj98, "visitDialect", &meth_ast_visitDialect154, 28);
int argcv_meth_ast_visitDialect154[] = {1};
meth_meth_ast_visitDialect154->type = alloc_MethodType(1, argcv_meth_ast_visitDialect154);
  meth_meth_ast_visitDialect154->definitionModule = modulename;
  meth_meth_ast_visitDialect154->definitionLine = 2025;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
  sourceObject = obj98;
objclass98 = obj98->class;
  objclass98->definitionModule = modulename;
  objclass98->definitionLine = 1943;
  (*(struct UserObject *)self).data[0] = lowerouter98;
  self = oldself98;
  selfslot = oldselfslot98;
  stackframe = oldstackframe98;
  gc_frame_end(frame);
  return obj98;
}
Object meth_ast__apply166(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object *var_ann = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2042
  setline(2042);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_annName
  int op_slot_right_167 = gc_frame_newslot(*var_annName);
  int callframe169 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call170 = callmethod(*var_ann, "value",
    1, partcv, params);
  gc_frame_end(callframe169);
// compilenode returning call170
// compilenode returning call170
  int op_slot_left_167 = gc_frame_newslot(call170);
  params[0] = *var_annName;
  partcv[0] = 1;
  Object opresult171 = callmethod(call170, "==", 1, partcv, params);
// compilenode returning opresult171
  gc_frame_end(frame);
  return opresult171;
}
Object meth_ast__apply162(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_annName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe164 = gc_frame_new();
  Object block165 = alloc_Block(NULL, NULL, "ast", 2041);
  gc_frame_newslot(block165);
  block_savedest(block165);
  Object closure166 = createclosure(3, "_apply");
setclosureframe(closure166, stackframe);
  addtoclosure(closure166, var_annName);
  addtoclosure(closure166, var_ann);
  addtoclosure(closure166, selfslot);
  struct UserObject *uo166 = (struct UserObject*)block165;
  uo166->data[0] = (Object)closure166;
  Method *meth_meth_ast__apply166 = addmethod2pos(block165, "_apply", &meth_ast__apply166, 0);
int argcv_meth_ast__apply166[] = {0};
meth_meth_ast__apply166->type = alloc_MethodType(1, argcv_meth_ast__apply166);
  meth_meth_ast__apply166->definitionModule = modulename;
  meth_meth_ast__apply166->definitionLine = 2040;
// compilenode returning block165
  gc_frame_newslot(block165);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit174 == NULL) {
    strlit174 = alloc_String("identifier");
    gc_root(strlit174);
  }
// compilenode returning strlit174
  int op_slot_right_173 = gc_frame_newslot(strlit174);
  int callframe176 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call177 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe176);
// compilenode returning call177
// compilenode returning call177
  int op_slot_left_173 = gc_frame_newslot(call177);
  params[0] = strlit174;
  partcv[0] = 1;
  Object opresult178 = callmethod(call177, "==", 1, partcv, params);
// compilenode returning opresult178
  params[0] = block165;
  partcv[0] = 1;
  Object call179 = callmethod(opresult178, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe164);
// compilenode returning call179
  Object if163 = done;
  if (istrue(call179)) {
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject180 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj180 = alloc_userobj2(2,4, objclass180);
  gc_frame_newslot(obj180);
// OBJECT OUTER DEC outer
  adddatum2(obj180, self, 0);
  addmethodreal(obj180,"outer", &reader_ast_outer_181);
  Object oldself180 = self;
  struct StackFrameObject *oldstackframe180 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe180);
  gc_frame_newslot((Object)stackframe);
  self = obj180;
  Object *oldselfslot180 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter180 = (*(struct UserObject *)self).data[0], lowerouter180 = thisouter180;
  if (inheritingObject180) {
    struct UserObject *inho180 = (struct UserObject *)inheritingObject180;
    while (inho180->super != GraceDefaultObject) inho180 = (struct UserObject *)inho180->super;
    inho180->super = obj180;
    self = inheritingObject180;
    *selfslot = self;
    lowerouter180 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter180;
  }
if (objclass180 == NULL) {
  Method *reader182 = addmethodrealflags(obj180, "value",&reader_ast_value_182, MFLAG_DEF);
  reader182->definitionModule = modulename;
  reader182->definitionLine = 2046;
}
adddatum2(obj180, alloc_Undefined(), 1);
  sourceObject = obj180;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool183 = alloc_Boolean(1);
// compilenode returning bool183
  struct UserObject *obj180_uo = (struct UserObject *)obj180;
  obj180_uo->super = bool183;
  sourceObject = obj180;
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ann
  adddatum2(obj180, *var_ann, 1);
objclass180 = obj180->class;
  objclass180->definitionModule = modulename;
  objclass180->definitionLine = 2043;
  (*(struct UserObject *)self).data[0] = lowerouter180;
  self = oldself180;
  selfslot = oldselfslot180;
  stackframe = oldstackframe180;
// compilenode returning obj180
  block_return(realself, obj180);
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if163 = undefined;
  } else {
  }
// compilenode returning if163
  gc_frame_end(frame);
  return if163;
}
Object meth_ast_findAnnotation157(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
  Object *var_annName = &(stackframe->slots[1]);
  *var_annName = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for findAnnotation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe158 = gc_frame_new();
  int callframe159 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call160 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe159);
// compilenode returning call160
// compilenode returning call160
  gc_frame_newslot(call160);
  Object block161 = alloc_Block(NULL, NULL, "ast", 2040);
  gc_frame_newslot(block161);
  block_savedest(block161);
  Object closure162 = createclosure(2, "_apply");
setclosureframe(closure162, stackframe);
  addtoclosure(closure162, var_annName);
  addtoclosure(closure162, selfslot);
  struct UserObject *uo162 = (struct UserObject*)block161;
  uo162->data[0] = (Object)closure162;
  Method *meth_meth_ast__apply162 = addmethod2pos(block161, "_apply", &meth_ast__apply162, 0);
int argcv_meth_ast__apply162[] = {1};
meth_meth_ast__apply162->type = alloc_MethodType(1, argcv_meth_ast__apply162);
  meth_meth_ast__apply162->definitionModule = modulename;
  meth_meth_ast__apply162->definitionLine = 2040;
// compilenode returning block161
  gc_frame_newslot(block161);
  params[0] = call160;
  params[1] = block161;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call185 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe158);
// compilenode returning call185
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool186 = alloc_Boolean(0);
// compilenode returning bool186
  gc_frame_end(frame);
  return bool186;
}
Object meth_ast__apply191(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe192 = gc_frame_new();
// compilenode returning *var_node
  gc_frame_newslot(*var_node);
  if (strlit193 == NULL) {
    strlit193 = alloc_String("public");
    gc_root(strlit193);
  }
// compilenode returning strlit193
  gc_frame_newslot(strlit193);
  params[0] = *var_node;
  params[1] = strlit193;
  partcv[0] = 2;
  Object call194 = callmethodflags(self, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe192);
// compilenode returning call194
  gc_frame_end(frame);
  return call194;
}
Object meth_ast_isPublic187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isPublic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isPublic (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for isPublic");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe189 = gc_frame_new();
  Object block190 = alloc_Block(NULL, NULL, "ast", 2053);
  gc_frame_newslot(block190);
  block_savedest(block190);
  Object closure191 = createclosure(2, "_apply");
setclosureframe(closure191, stackframe);
  addtoclosure(closure191, var_node);
  addtoclosure(closure191, selfslot);
  struct UserObject *uo191 = (struct UserObject*)block190;
  uo191->data[0] = (Object)closure191;
  Method *meth_meth_ast__apply191 = addmethod2pos(block190, "_apply", &meth_ast__apply191, 0);
int argcv_meth_ast__apply191[] = {0};
meth_meth_ast__apply191->type = alloc_MethodType(1, argcv_meth_ast__apply191);
  meth_meth_ast__apply191->definitionModule = modulename;
  meth_meth_ast__apply191->definitionLine = 2041;
// compilenode returning block190
  gc_frame_newslot(block190);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num197 = alloc_Float64(0);
// compilenode returning num197
  int op_slot_right_196 = gc_frame_newslot(num197);
  int callframe199 = gc_frame_new();
  int callframe200 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call201 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe200);
// compilenode returning call201
// compilenode returning call201
  partcv[0] = 0;
  Object call202 = callmethod(call201, "size",
    1, partcv, params);
  gc_frame_end(callframe199);
// compilenode returning call202
// compilenode returning call202
  int op_slot_left_196 = gc_frame_newslot(call202);
  params[0] = num197;
  partcv[0] = 1;
  Object opresult203 = callmethod(call202, "==", 1, partcv, params);
// compilenode returning opresult203
  params[0] = block190;
  partcv[0] = 1;
  Object call204 = callmethod(opresult203, "orElse",
    1, partcv, params);
  gc_frame_end(callframe189);
// compilenode returning call204
  Object if188 = done;
  if (istrue(call204)) {
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool205 = alloc_Boolean(1);
// compilenode returning bool205
  return bool205;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if188 = undefined;
  } else {
  }
// compilenode returning if188
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool206 = alloc_Boolean(0);
// compilenode returning bool206
  gc_frame_end(frame);
  return bool206;
}
Object meth_ast__apply211(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_node = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe212 = gc_frame_new();
// compilenode returning *var_node
  gc_frame_newslot(*var_node);
  if (strlit213 == NULL) {
    strlit213 = alloc_String("writable");
    gc_root(strlit213);
  }
// compilenode returning strlit213
  gc_frame_newslot(strlit213);
  params[0] = *var_node;
  params[1] = strlit213;
  partcv[0] = 2;
  Object call214 = callmethodflags(self, "findAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe212);
// compilenode returning call214
  gc_frame_end(frame);
  return call214;
}
Object meth_ast_isWritable207(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isWritable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for isWritable (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_node = &(stackframe->slots[0]);
  *var_node = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for isWritable");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe209 = gc_frame_new();
  Object block210 = alloc_Block(NULL, NULL, "ast", 2061);
  gc_frame_newslot(block210);
  block_savedest(block210);
  Object closure211 = createclosure(2, "_apply");
setclosureframe(closure211, stackframe);
  addtoclosure(closure211, var_node);
  addtoclosure(closure211, selfslot);
  struct UserObject *uo211 = (struct UserObject*)block210;
  uo211->data[0] = (Object)closure211;
  Method *meth_meth_ast__apply211 = addmethod2pos(block210, "_apply", &meth_ast__apply211, 0);
int argcv_meth_ast__apply211[] = {0};
meth_meth_ast__apply211->type = alloc_MethodType(1, argcv_meth_ast__apply211);
  meth_meth_ast__apply211->definitionModule = modulename;
  meth_meth_ast__apply211->definitionLine = 2053;
// compilenode returning block210
  gc_frame_newslot(block210);
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num217 = alloc_Float64(0);
// compilenode returning num217
  int op_slot_right_216 = gc_frame_newslot(num217);
  int callframe219 = gc_frame_new();
  int callframe220 = gc_frame_new();
// compilenode returning *var_node
  partcv[0] = 0;
  Object call221 = callmethod(*var_node, "annotations",
    1, partcv, params);
  gc_frame_end(callframe220);
// compilenode returning call221
// compilenode returning call221
  partcv[0] = 0;
  Object call222 = callmethod(call221, "size",
    1, partcv, params);
  gc_frame_end(callframe219);
// compilenode returning call222
// compilenode returning call222
  int op_slot_left_216 = gc_frame_newslot(call222);
  params[0] = num217;
  partcv[0] = 1;
  Object opresult223 = callmethod(call222, "==", 1, partcv, params);
// compilenode returning opresult223
  params[0] = block210;
  partcv[0] = 1;
  Object call224 = callmethod(opresult223, "orElse",
    1, partcv, params);
  gc_frame_end(callframe209);
// compilenode returning call224
  Object if208 = done;
  if (istrue(call224)) {
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool225 = alloc_Boolean(1);
// compilenode returning bool225
  return bool225;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if208 = undefined;
  } else {
  }
// compilenode returning if208
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool226 = alloc_Boolean(0);
// compilenode returning bool226
  gc_frame_end(frame);
  return bool226;
}
Object meth_ast_baseNode227(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "baseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for baseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for baseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_baseNode
  gc_frame_end(frame);
  return *var_baseNode;
}
Object meth_ast_new230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject231 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj231 = alloc_userobj2(8,5, objclass231);
  gc_frame_newslot(obj231);
if (objclass231 == NULL) {
  glfree(obj231->class->name);
  obj231->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj231, self, 0);
  addmethodreal(obj231,"outer", &reader_ast_outer_232);
  Object oldself231 = self;
  struct StackFrameObject *oldstackframe231 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe231);
  gc_frame_newslot((Object)stackframe);
  self = obj231;
  Object *oldselfslot231 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter231 = (*(struct UserObject *)self).data[0], lowerouter231 = thisouter231;
  if (inheritingObject231) {
    struct UserObject *inho231 = (struct UserObject *)inheritingObject231;
    while (inho231->super != GraceDefaultObject) inho231 = (struct UserObject *)inho231->super;
    inho231->super = obj231;
    self = inheritingObject231;
    *selfslot = self;
    lowerouter231 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter231;
  }
if (objclass231 == NULL) {
  Method *reader233 = addmethodrealflags(obj231, "register",&reader_ast_register_233, 0);
  Method *writer233 = addmethodrealflags(obj231, "register:=",&writer_ast_register_233, 0);
  reader233->definitionModule = modulename;
  writer233->definitionModule = modulename;
  reader233->definitionLine = 39;
  writer233->definitionLine = 39;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 1);
if (objclass231 == NULL) {
  Method *reader234 = addmethodrealflags(obj231, "line",&reader_ast_line_234, 0);
  Method *writer234 = addmethodrealflags(obj231, "line:=",&writer_ast_line_234, 0);
  reader234->definitionModule = modulename;
  writer234->definitionModule = modulename;
  reader234->definitionLine = 40;
  writer234->definitionLine = 40;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 2);
if (objclass231 == NULL) {
  Method *reader235 = addmethodrealflags(obj231, "linePos",&reader_ast_linePos_235, 0);
  Method *writer235 = addmethodrealflags(obj231, "linePos:=",&writer_ast_linePos_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 41;
  writer235->definitionLine = 41;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 3);
if (objclass231 == NULL) {
  Method *reader236 = addmethodrealflags(obj231, "lineLength",&reader_ast_lineLength_236, 0);
  Method *writer236 = addmethodrealflags(obj231, "lineLength:=",&writer_ast_lineLength_236, 0);
  reader236->definitionModule = modulename;
  writer236->definitionModule = modulename;
  reader236->definitionLine = 42;
  writer236->definitionLine = 42;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 4);
  sourceObject = obj231;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit237 == NULL) {
    strlit237 = alloc_String("");
    gc_root(strlit237);
  }
// compilenode returning strlit237
  adddatum2(obj231, strlit237, 1);
  sourceObject = obj231;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe238 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call239 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe238);
// compilenode returning call239
// compilenode returning call239
  adddatum2(obj231, call239, 2);
  sourceObject = obj231;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe240 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call241 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe240);
// compilenode returning call241
// compilenode returning call241
  adddatum2(obj231, call241, 3);
  sourceObject = obj231;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num242 = alloc_Float64(0);
// compilenode returning num242
  adddatum2(obj231, num242, 4);
objclass231 = obj231->class;
  objclass231->definitionModule = modulename;
  objclass231->definitionLine = 2061;
  (*(struct UserObject *)self).data[0] = lowerouter231;
  self = oldself231;
  selfslot = oldselfslot231;
  stackframe = oldstackframe231;
  gc_frame_end(frame);
  return obj231;
}
Object meth_ast_new230_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject231 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj231 = alloc_userobj2(8,5, objclass231);
  gc_frame_newslot(obj231);
if (objclass231 == NULL) {
  glfree(obj231->class->name);
  obj231->class->name = "baseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj231, self, 0);
  addmethodreal(obj231,"outer", &reader_ast_outer_232);
  Object oldself231 = self;
  struct StackFrameObject *oldstackframe231 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe231);
  gc_frame_newslot((Object)stackframe);
  self = obj231;
  Object *oldselfslot231 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter231 = (*(struct UserObject *)self).data[0], lowerouter231 = thisouter231;
  if (inheritingObject231) {
    struct UserObject *inho231 = (struct UserObject *)inheritingObject231;
    while (inho231->super != GraceDefaultObject) inho231 = (struct UserObject *)inho231->super;
    inho231->super = obj231;
    self = inheritingObject231;
    *selfslot = self;
    lowerouter231 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter231;
  }
if (objclass231 == NULL) {
  Method *reader233 = addmethodrealflags(obj231, "register",&reader_ast_register_233, 0);
  Method *writer233 = addmethodrealflags(obj231, "register:=",&writer_ast_register_233, 0);
  reader233->definitionModule = modulename;
  writer233->definitionModule = modulename;
  reader233->definitionLine = 39;
  writer233->definitionLine = 39;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 1);
if (objclass231 == NULL) {
  Method *reader234 = addmethodrealflags(obj231, "line",&reader_ast_line_234, 0);
  Method *writer234 = addmethodrealflags(obj231, "line:=",&writer_ast_line_234, 0);
  reader234->definitionModule = modulename;
  writer234->definitionModule = modulename;
  reader234->definitionLine = 40;
  writer234->definitionLine = 40;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 2);
if (objclass231 == NULL) {
  Method *reader235 = addmethodrealflags(obj231, "linePos",&reader_ast_linePos_235, 0);
  Method *writer235 = addmethodrealflags(obj231, "linePos:=",&writer_ast_linePos_235, 0);
  reader235->definitionModule = modulename;
  writer235->definitionModule = modulename;
  reader235->definitionLine = 41;
  writer235->definitionLine = 41;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 3);
if (objclass231 == NULL) {
  Method *reader236 = addmethodrealflags(obj231, "lineLength",&reader_ast_lineLength_236, 0);
  Method *writer236 = addmethodrealflags(obj231, "lineLength:=",&writer_ast_lineLength_236, 0);
  reader236->definitionModule = modulename;
  writer236->definitionModule = modulename;
  reader236->definitionLine = 42;
  writer236->definitionLine = 42;
}
obj231->flags |= OFLAG_MUTABLE;
adddatum2(obj231, alloc_Undefined(), 4);
  sourceObject = obj231;
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit237 == NULL) {
    strlit237 = alloc_String("");
    gc_root(strlit237);
  }
// compilenode returning strlit237
  adddatum2(obj231, strlit237, 1);
  sourceObject = obj231;
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe238 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call239 = callmethod(*var_util, "linenum",
    1, partcv, params);
  gc_frame_end(callframe238);
// compilenode returning call239
// compilenode returning call239
  adddatum2(obj231, call239, 2);
  sourceObject = obj231;
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe240 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call241 = callmethod(*var_util, "linepos",
    1, partcv, params);
  gc_frame_end(callframe240);
// compilenode returning call241
// compilenode returning call241
  adddatum2(obj231, call241, 3);
  sourceObject = obj231;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num242 = alloc_Float64(0);
// compilenode returning num242
  adddatum2(obj231, num242, 4);
objclass231 = obj231->class;
  objclass231->definitionModule = modulename;
  objclass231->definitionLine = 2061;
  (*(struct UserObject *)self).data[0] = lowerouter231;
  self = oldself231;
  selfslot = oldselfslot231;
  stackframe = oldstackframe231;
  gc_frame_end(frame);
  return obj231;
}
Object meth_ast_forNode244(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "forNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_forNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for forNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for forNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_forNode
  gc_frame_end(frame);
  return *var_forNode;
}
Object meth_ast_accept253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe255 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call256 = callmethod(*var_visitor, "visitFor",
    1, partcv, params);
  gc_frame_end(callframe255);
// compilenode returning call256
  Object if254 = done;
  if (istrue(call256)) {
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe257 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe258 = gc_frame_new();
  partcv[0] = 0;
  Object call259 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe258);
// compilenode returning call259
// compilenode returning call259
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call260 = callmethod(call259, "accept",
    1, partcv, params);
  gc_frame_end(callframe257);
// compilenode returning call260
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe261 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe262 = gc_frame_new();
  partcv[0] = 0;
  Object call263 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe262);
// compilenode returning call263
// compilenode returning call263
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call264 = callmethod(call263, "accept",
    1, partcv, params);
  gc_frame_end(callframe261);
// compilenode returning call264
    gc_frame_newslot(call264);
    if254 = call264;
  } else {
  }
// compilenode returning if254
  gc_frame_end(frame);
  return if254;
}
Object meth_ast__apply273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit275 == NULL) {
    strlit275 = alloc_String("  ");
    gc_root(strlit275);
  }
// compilenode returning strlit275
  int op_slot_right_274 = gc_frame_newslot(strlit275);
// compilenode returning *var_spc
  int op_slot_left_274 = gc_frame_newslot(*var_spc);
  params[0] = strlit275;
  partcv[0] = 1;
  Object opresult277 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult277
  *var_spc = opresult277;
  if (opresult277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty265(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit266 == NULL) {
    strlit266 = alloc_String("");
    gc_root(strlit266);
  }
// compilenode returning strlit266
  *var_spc = strlit266;
  if (strlit266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe267 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_268 = gc_frame_newslot(*var_depth);
  Object num270 = alloc_Float64(0);
// compilenode returning num270
  int op_slot_left_268 = gc_frame_newslot(num270);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult271 = callmethod(num270, "..", 1, partcv, params);
// compilenode returning opresult271
  gc_frame_newslot(opresult271);
  Object block272 = alloc_Block(NULL, NULL, "ast", 57);
  gc_frame_newslot(block272);
  block_savedest(block272);
  Object closure273 = createclosure(2, "_apply");
setclosureframe(closure273, stackframe);
  addtoclosure(closure273, var_spc);
  addtoclosure(closure273, selfslot);
  struct UserObject *uo273 = (struct UserObject*)block272;
  uo273->data[0] = (Object)closure273;
  Method *meth_meth_ast__apply273 = addmethod2pos(block272, "_apply", &meth_ast__apply273, 0);
int argcv_meth_ast__apply273[] = {1};
meth_meth_ast__apply273->type = alloc_MethodType(1, argcv_meth_ast__apply273);
  meth_meth_ast__apply273->definitionModule = modulename;
  meth_meth_ast__apply273->definitionLine = 52;
// compilenode returning block272
  gc_frame_newslot(block272);
  params[0] = opresult271;
  params[1] = block272;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call280 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe267);
// compilenode returning call280
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit281 == NULL) {
    strlit281 = alloc_String("For""\x0a""");
    gc_root(strlit281);
  }
// compilenode returning strlit281
  *var_s = strlit281;
  if (strlit281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe283 = gc_frame_new();
  Object num285 = alloc_Float64(1);
// compilenode returning num285
  int op_slot_right_284 = gc_frame_newslot(num285);
// compilenode returning *var_depth
  int op_slot_left_284 = gc_frame_newslot(*var_depth);
  params[0] = num285;
  partcv[0] = 1;
  Object sum287 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum287
  gc_frame_newslot(sum287);
  int callframe288 = gc_frame_new();
  partcv[0] = 0;
  Object call289 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe288);
// compilenode returning call289
// compilenode returning call289
  params[0] = sum287;
  partcv[0] = 1;
  Object call290 = callmethod(call289, "pretty",
    1, partcv, params);
  gc_frame_end(callframe283);
// compilenode returning call290
  int op_slot_right_282 = gc_frame_newslot(call290);
// compilenode returning *var_spc
  int op_slot_right_292 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_292 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult294 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult294
  int op_slot_left_282 = gc_frame_newslot(opresult294);
  params[0] = call290;
  partcv[0] = 1;
  Object opresult295 = callmethod(opresult294, "++", 1, partcv, params);
// compilenode returning opresult295
  *var_s = opresult295;
  if (opresult295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit298 == NULL) {
    strlit298 = alloc_String("""\x0a""");
    gc_root(strlit298);
  }
// compilenode returning strlit298
  int op_slot_right_297 = gc_frame_newslot(strlit298);
// compilenode returning *var_s
  int op_slot_left_297 = gc_frame_newslot(*var_s);
  params[0] = strlit298;
  partcv[0] = 1;
  Object opresult300 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult300
  *var_s = opresult300;
  if (opresult300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 63
  setline(63);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit303 == NULL) {
    strlit303 = alloc_String("Do:");
    gc_root(strlit303);
  }
// compilenode returning strlit303
  int op_slot_right_302 = gc_frame_newslot(strlit303);
// compilenode returning *var_spc
  int op_slot_right_305 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_305 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult307 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult307
  int op_slot_left_302 = gc_frame_newslot(opresult307);
  params[0] = strlit303;
  partcv[0] = 1;
  Object opresult308 = callmethod(opresult307, "++", 1, partcv, params);
// compilenode returning opresult308
  *var_s = opresult308;
  if (opresult308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe311 = gc_frame_new();
  Object num313 = alloc_Float64(1);
// compilenode returning num313
  int op_slot_right_312 = gc_frame_newslot(num313);
// compilenode returning *var_depth
  int op_slot_left_312 = gc_frame_newslot(*var_depth);
  params[0] = num313;
  partcv[0] = 1;
  Object sum315 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum315
  gc_frame_newslot(sum315);
  int callframe316 = gc_frame_new();
  partcv[0] = 0;
  Object call317 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe316);
// compilenode returning call317
// compilenode returning call317
  params[0] = sum315;
  partcv[0] = 1;
  Object call318 = callmethod(call317, "pretty",
    1, partcv, params);
  gc_frame_end(callframe311);
// compilenode returning call318
  int op_slot_right_310 = gc_frame_newslot(call318);
  if (strlit321 == NULL) {
    strlit321 = alloc_String("  ");
    gc_root(strlit321);
  }
// compilenode returning strlit321
  int op_slot_right_320 = gc_frame_newslot(strlit321);
// compilenode returning *var_spc
  int op_slot_right_323 = gc_frame_newslot(*var_spc);
  if (strlit326 == NULL) {
    strlit326 = alloc_String("""\x0a""");
    gc_root(strlit326);
  }
// compilenode returning strlit326
  int op_slot_right_325 = gc_frame_newslot(strlit326);
// compilenode returning *var_s
  int op_slot_left_325 = gc_frame_newslot(*var_s);
  params[0] = strlit326;
  partcv[0] = 1;
  Object opresult328 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult328
  int op_slot_left_323 = gc_frame_newslot(opresult328);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult329 = callmethod(opresult328, "++", 1, partcv, params);
// compilenode returning opresult329
  int op_slot_left_320 = gc_frame_newslot(opresult329);
  params[0] = strlit321;
  partcv[0] = 1;
  Object opresult330 = callmethod(opresult329, "++", 1, partcv, params);
// compilenode returning opresult330
  int op_slot_left_310 = gc_frame_newslot(opresult330);
  params[0] = call318;
  partcv[0] = 1;
  Object opresult331 = callmethod(opresult330, "++", 1, partcv, params);
// compilenode returning opresult331
  *var_s = opresult331;
  if (opresult331 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit347 == NULL) {
    strlit347 = alloc_String("    ");
    gc_root(strlit347);
  }
// compilenode returning strlit347
  int op_slot_right_346 = gc_frame_newslot(strlit347);
// compilenode returning *var_spc
  int op_slot_left_346 = gc_frame_newslot(*var_spc);
  params[0] = strlit347;
  partcv[0] = 1;
  Object opresult349 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult349
  *var_spc = opresult349;
  if (opresult349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace333(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit334 == NULL) {
    strlit334 = alloc_String("");
    gc_root(strlit334);
  }
// compilenode returning strlit334
  *var_spc = strlit334;
  if (strlit334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe335 = gc_frame_new();
  Object num338 = alloc_Float64(1);
// compilenode returning num338
  int op_slot_right_337 = gc_frame_newslot(num338);
// compilenode returning *var_depth
  int op_slot_left_337 = gc_frame_newslot(*var_depth);
  params[0] = num338;
  partcv[0] = 1;
  Object diff340 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff340
  int op_slot_right_336 = gc_frame_newslot(diff340);
  Object num342 = alloc_Float64(0);
// compilenode returning num342
  int op_slot_left_336 = gc_frame_newslot(num342);
  params[0] = diff340;
  partcv[0] = 1;
  Object opresult343 = callmethod(num342, "..", 1, partcv, params);
// compilenode returning opresult343
  gc_frame_newslot(opresult343);
  Object block344 = alloc_Block(NULL, NULL, "ast", 69);
  gc_frame_newslot(block344);
  block_savedest(block344);
  Object closure345 = createclosure(2, "_apply");
setclosureframe(closure345, stackframe);
  addtoclosure(closure345, var_spc);
  addtoclosure(closure345, selfslot);
  struct UserObject *uo345 = (struct UserObject*)block344;
  uo345->data[0] = (Object)closure345;
  Method *meth_meth_ast__apply345 = addmethod2pos(block344, "_apply", &meth_ast__apply345, 0);
int argcv_meth_ast__apply345[] = {1};
meth_meth_ast__apply345->type = alloc_MethodType(1, argcv_meth_ast__apply345);
  meth_meth_ast__apply345->definitionModule = modulename;
  meth_meth_ast__apply345->definitionLine = 64;
// compilenode returning block344
  gc_frame_newslot(block344);
  params[0] = opresult343;
  params[1] = block344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call352 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe335);
// compilenode returning call352
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit354 == NULL) {
    strlit354 = alloc_String(") do ");
    gc_root(strlit354);
  }
// compilenode returning strlit354
  int op_slot_right_353 = gc_frame_newslot(strlit354);
  int callframe357 = gc_frame_new();
  Object num358 = alloc_Float64(0);
// compilenode returning num358
  gc_frame_newslot(num358);
  int callframe359 = gc_frame_new();
  partcv[0] = 0;
  Object call360 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe359);
// compilenode returning call360
// compilenode returning call360
  params[0] = num358;
  partcv[0] = 1;
  Object call361 = callmethod(call360, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe357);
// compilenode returning call361
  int op_slot_right_356 = gc_frame_newslot(call361);
  if (strlit363 == NULL) {
    strlit363 = alloc_String("for (");
    gc_root(strlit363);
  }
// compilenode returning strlit363
  int op_slot_left_356 = gc_frame_newslot(strlit363);
  params[0] = call361;
  partcv[0] = 1;
  Object opresult364 = callmethod(strlit363, "++", 1, partcv, params);
// compilenode returning opresult364
  int op_slot_left_353 = gc_frame_newslot(opresult364);
  params[0] = strlit354;
  partcv[0] = 1;
  Object opresult365 = callmethod(opresult364, "++", 1, partcv, params);
// compilenode returning opresult365
  *var_s = opresult365;
  if (opresult365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe367 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe368 = gc_frame_new();
  partcv[0] = 0;
  Object call369 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe368);
// compilenode returning call369
// compilenode returning call369
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call370 = callmethod(call369, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe367);
// compilenode returning call370
  int op_slot_right_366 = gc_frame_newslot(call370);
// compilenode returning *var_s
  int op_slot_left_366 = gc_frame_newslot(*var_s);
  params[0] = call370;
  partcv[0] = 1;
  Object opresult372 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult372
  *var_s = opresult372;
  if (opresult372 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new247(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_over = &(stackframe->slots[0]);
  *var_over = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject248 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj248 = alloc_userobj2(7,8, objclass248);
  gc_frame_newslot(obj248);
if (objclass248 == NULL) {
  glfree(obj248->class->name);
  obj248->class->name = "forNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj248, self, 0);
  addmethodreal(obj248,"outer", &reader_ast_outer_249);
  Object oldself248 = self;
  struct StackFrameObject *oldstackframe248 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe248);
  gc_frame_newslot((Object)stackframe);
  self = obj248;
  Object *oldselfslot248 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter248 = (*(struct UserObject *)self).data[0], lowerouter248 = thisouter248;
  if (inheritingObject248) {
    struct UserObject *inho248 = (struct UserObject *)inheritingObject248;
    while (inho248->super != GraceDefaultObject) inho248 = (struct UserObject *)inho248->super;
    inho248->super = obj248;
    self = inheritingObject248;
    *selfslot = self;
    lowerouter248 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter248;
  }
if (objclass248 == NULL) {
  Method *reader250 = addmethodrealflags(obj248, "kind",&reader_ast_kind_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 47;
}
adddatum2(obj248, alloc_Undefined(), 1);
if (objclass248 == NULL) {
  Method *reader251 = addmethodrealflags(obj248, "value",&reader_ast_value_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 48;
}
adddatum2(obj248, alloc_Undefined(), 2);
if (objclass248 == NULL) {
  Method *reader252 = addmethodrealflags(obj248, "body",&reader_ast_body_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 49;
}
adddatum2(obj248, alloc_Undefined(), 3);
  struct UserObject *uo253 = (struct UserObject*)obj248;
  uo253->data[4] = emptyclosure;
  Method *meth_meth_ast_accept253 = addmethod2pos(obj248, "accept", &meth_ast_accept253, 4);
int argcv_meth_ast_accept253[] = {1};
meth_meth_ast_accept253->type = alloc_MethodType(1, argcv_meth_ast_accept253);
meth_meth_ast_accept253->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept253->type->names[0] = "visitor";
  meth_meth_ast_accept253->definitionModule = modulename;
  meth_meth_ast_accept253->definitionLine = 49;
  struct UserObject *uo265 = (struct UserObject*)obj248;
  uo265->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty265 = addmethod2pos(obj248, "pretty", &meth_ast_pretty265, 5);
int argcv_meth_ast_pretty265[] = {1};
meth_meth_ast_pretty265->type = alloc_MethodType(1, argcv_meth_ast_pretty265);
  meth_meth_ast_pretty265->definitionModule = modulename;
  meth_meth_ast_pretty265->definitionLine = 55;
  struct UserObject *uo333 = (struct UserObject*)obj248;
  uo333->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace333 = addmethod2pos(obj248, "toGrace", &meth_ast_toGrace333, 6);
int argcv_meth_ast_toGrace333[] = {1};
meth_meth_ast_toGrace333->type = alloc_MethodType(1, argcv_meth_ast_toGrace333);
meth_meth_ast_toGrace333->type->types[0] = type_Number;
meth_meth_ast_toGrace333->type->names[0] = "depth";
  meth_meth_ast_toGrace333->definitionModule = modulename;
  meth_meth_ast_toGrace333->definitionLine = 67;
  sourceObject = obj248;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe374 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
  struct UserObject *obj248_uo = (struct UserObject *)obj248;
  obj248_uo->super = call375;
  sourceObject = obj248;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit376 == NULL) {
    strlit376 = alloc_String("for");
    gc_root(strlit376);
  }
// compilenode returning strlit376
  adddatum2(obj248, strlit376, 1);
  sourceObject = obj248;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_over
  adddatum2(obj248, *var_over, 2);
  sourceObject = obj248;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj248, *var_body_39_, 3);
  sourceObject = obj248;
  sourceObject = obj248;
  sourceObject = obj248;
objclass248 = obj248->class;
  objclass248->definitionModule = modulename;
  objclass248->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter248;
  self = oldself248;
  selfslot = oldselfslot248;
  stackframe = oldstackframe248;
  gc_frame_end(frame);
  return obj248;
}
Object meth_ast_new247_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_over = &(stackframe->slots[0]);
  *var_over = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject248 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj248 = alloc_userobj2(7,8, objclass248);
  gc_frame_newslot(obj248);
if (objclass248 == NULL) {
  glfree(obj248->class->name);
  obj248->class->name = "forNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj248, self, 0);
  addmethodreal(obj248,"outer", &reader_ast_outer_249);
  Object oldself248 = self;
  struct StackFrameObject *oldstackframe248 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe248);
  gc_frame_newslot((Object)stackframe);
  self = obj248;
  Object *oldselfslot248 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter248 = (*(struct UserObject *)self).data[0], lowerouter248 = thisouter248;
  if (inheritingObject248) {
    struct UserObject *inho248 = (struct UserObject *)inheritingObject248;
    while (inho248->super != GraceDefaultObject) inho248 = (struct UserObject *)inho248->super;
    inho248->super = obj248;
    self = inheritingObject248;
    *selfslot = self;
    lowerouter248 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter248;
  }
if (objclass248 == NULL) {
  Method *reader250 = addmethodrealflags(obj248, "kind",&reader_ast_kind_250, MFLAG_DEF);
  reader250->definitionModule = modulename;
  reader250->definitionLine = 47;
}
adddatum2(obj248, alloc_Undefined(), 1);
if (objclass248 == NULL) {
  Method *reader251 = addmethodrealflags(obj248, "value",&reader_ast_value_251, MFLAG_DEF);
  reader251->definitionModule = modulename;
  reader251->definitionLine = 48;
}
adddatum2(obj248, alloc_Undefined(), 2);
if (objclass248 == NULL) {
  Method *reader252 = addmethodrealflags(obj248, "body",&reader_ast_body_252, MFLAG_DEF);
  reader252->definitionModule = modulename;
  reader252->definitionLine = 49;
}
adddatum2(obj248, alloc_Undefined(), 3);
  struct UserObject *uo253 = (struct UserObject*)obj248;
  uo253->data[4] = emptyclosure;
  Method *meth_meth_ast_accept253 = addmethod2pos(obj248, "accept", &meth_ast_accept253, 4);
int argcv_meth_ast_accept253[] = {1};
meth_meth_ast_accept253->type = alloc_MethodType(1, argcv_meth_ast_accept253);
meth_meth_ast_accept253->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept253->type->names[0] = "visitor";
  meth_meth_ast_accept253->definitionModule = modulename;
  meth_meth_ast_accept253->definitionLine = 49;
  struct UserObject *uo265 = (struct UserObject*)obj248;
  uo265->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty265 = addmethod2pos(obj248, "pretty", &meth_ast_pretty265, 5);
int argcv_meth_ast_pretty265[] = {1};
meth_meth_ast_pretty265->type = alloc_MethodType(1, argcv_meth_ast_pretty265);
  meth_meth_ast_pretty265->definitionModule = modulename;
  meth_meth_ast_pretty265->definitionLine = 55;
  struct UserObject *uo333 = (struct UserObject*)obj248;
  uo333->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace333 = addmethod2pos(obj248, "toGrace", &meth_ast_toGrace333, 6);
int argcv_meth_ast_toGrace333[] = {1};
meth_meth_ast_toGrace333->type = alloc_MethodType(1, argcv_meth_ast_toGrace333);
meth_meth_ast_toGrace333->type->types[0] = type_Number;
meth_meth_ast_toGrace333->type->names[0] = "depth";
  meth_meth_ast_toGrace333->definitionModule = modulename;
  meth_meth_ast_toGrace333->definitionLine = 67;
  sourceObject = obj248;
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe374 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call375 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
  struct UserObject *obj248_uo = (struct UserObject *)obj248;
  obj248_uo->super = call375;
  sourceObject = obj248;
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit376 == NULL) {
    strlit376 = alloc_String("for");
    gc_root(strlit376);
  }
// compilenode returning strlit376
  adddatum2(obj248, strlit376, 1);
  sourceObject = obj248;
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_over
  adddatum2(obj248, *var_over, 2);
  sourceObject = obj248;
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj248, *var_body_39_, 3);
  sourceObject = obj248;
  sourceObject = obj248;
  sourceObject = obj248;
objclass248 = obj248->class;
  objclass248->definitionModule = modulename;
  objclass248->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter248;
  self = oldself248;
  selfslot = oldselfslot248;
  stackframe = oldstackframe248;
  gc_frame_end(frame);
  return obj248;
}
Object meth_ast_whileNode378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "whileNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_whileNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for whileNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for whileNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_whileNode
  gc_frame_end(frame);
  return *var_whileNode;
}
Object meth_ast__apply399(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe400 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call401 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe400);
// compilenode returning call401
  gc_frame_end(frame);
  return call401;
}
Object meth_ast_accept387(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 83
  setline(83);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe389 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call390 = callmethod(*var_visitor, "visitWhile",
    1, partcv, params);
  gc_frame_end(callframe389);
// compilenode returning call390
  Object if388 = done;
  if (istrue(call390)) {
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe391 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe392 = gc_frame_new();
  partcv[0] = 0;
  Object call393 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe392);
// compilenode returning call393
// compilenode returning call393
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call394 = callmethod(call393, "accept",
    1, partcv, params);
  gc_frame_end(callframe391);
// compilenode returning call394
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe395 = gc_frame_new();
  int callframe396 = gc_frame_new();
  partcv[0] = 0;
  Object call397 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe396);
// compilenode returning call397
// compilenode returning call397
  gc_frame_newslot(call397);
  Object block398 = alloc_Block(NULL, NULL, "ast", 85);
  gc_frame_newslot(block398);
  block_savedest(block398);
  Object closure399 = createclosure(2, "_apply");
setclosureframe(closure399, stackframe);
  addtoclosure(closure399, var_visitor);
  addtoclosure(closure399, selfslot);
  struct UserObject *uo399 = (struct UserObject*)block398;
  uo399->data[0] = (Object)closure399;
  Method *meth_meth_ast__apply399 = addmethod2pos(block398, "_apply", &meth_ast__apply399, 0);
int argcv_meth_ast__apply399[] = {1};
meth_meth_ast__apply399->type = alloc_MethodType(1, argcv_meth_ast__apply399);
  meth_meth_ast__apply399->definitionModule = modulename;
  meth_meth_ast__apply399->definitionLine = 85;
// compilenode returning block398
  gc_frame_newslot(block398);
  params[0] = call397;
  params[1] = block398;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call403 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe395);
// compilenode returning call403
    gc_frame_newslot(call403);
    if388 = call403;
  } else {
  }
// compilenode returning if388
  gc_frame_end(frame);
  return if388;
}
Object meth_ast__apply412(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit414 == NULL) {
    strlit414 = alloc_String("  ");
    gc_root(strlit414);
  }
// compilenode returning strlit414
  int op_slot_right_413 = gc_frame_newslot(strlit414);
// compilenode returning *var_spc
  int op_slot_left_413 = gc_frame_newslot(*var_spc);
  params[0] = strlit414;
  partcv[0] = 1;
  Object opresult416 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult416
  *var_spc = opresult416;
  if (opresult416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply453(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe455 = gc_frame_new();
  Object num457 = alloc_Float64(2);
// compilenode returning num457
  int op_slot_right_456 = gc_frame_newslot(num457);
// compilenode returning *var_depth
  int op_slot_left_456 = gc_frame_newslot(*var_depth);
  params[0] = num457;
  partcv[0] = 1;
  Object sum459 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum459
  gc_frame_newslot(sum459);
// compilenode returning *var_x
  params[0] = sum459;
  partcv[0] = 1;
  Object call460 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe455);
// compilenode returning call460
  int op_slot_right_454 = gc_frame_newslot(call460);
// compilenode returning *var_spc
  int op_slot_right_462 = gc_frame_newslot(*var_spc);
  if (strlit465 == NULL) {
    strlit465 = alloc_String("""\x0a""  ");
    gc_root(strlit465);
  }
// compilenode returning strlit465
  int op_slot_right_464 = gc_frame_newslot(strlit465);
// compilenode returning *var_s
  int op_slot_left_464 = gc_frame_newslot(*var_s);
  params[0] = strlit465;
  partcv[0] = 1;
  Object opresult467 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult467
  int op_slot_left_462 = gc_frame_newslot(opresult467);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult468 = callmethod(opresult467, "++", 1, partcv, params);
// compilenode returning opresult468
  int op_slot_left_454 = gc_frame_newslot(opresult468);
  params[0] = call460;
  partcv[0] = 1;
  Object opresult469 = callmethod(opresult468, "++", 1, partcv, params);
// compilenode returning opresult469
  *var_s = opresult469;
  if (opresult469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty404(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit405 == NULL) {
    strlit405 = alloc_String("");
    gc_root(strlit405);
  }
// compilenode returning strlit405
  *var_spc = strlit405;
  if (strlit405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe406 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_407 = gc_frame_newslot(*var_depth);
  Object num409 = alloc_Float64(0);
// compilenode returning num409
  int op_slot_left_407 = gc_frame_newslot(num409);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult410 = callmethod(num409, "..", 1, partcv, params);
// compilenode returning opresult410
  gc_frame_newslot(opresult410);
  Object block411 = alloc_Block(NULL, NULL, "ast", 92);
  gc_frame_newslot(block411);
  block_savedest(block411);
  Object closure412 = createclosure(2, "_apply");
setclosureframe(closure412, stackframe);
  addtoclosure(closure412, var_spc);
  addtoclosure(closure412, selfslot);
  struct UserObject *uo412 = (struct UserObject*)block411;
  uo412->data[0] = (Object)closure412;
  Method *meth_meth_ast__apply412 = addmethod2pos(block411, "_apply", &meth_ast__apply412, 0);
int argcv_meth_ast__apply412[] = {1};
meth_meth_ast__apply412->type = alloc_MethodType(1, argcv_meth_ast__apply412);
  meth_meth_ast__apply412->definitionModule = modulename;
  meth_meth_ast__apply412->definitionLine = 85;
// compilenode returning block411
  gc_frame_newslot(block411);
  params[0] = opresult410;
  params[1] = block411;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call419 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe406);
// compilenode returning call419
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit420 == NULL) {
    strlit420 = alloc_String("While""\x0a""");
    gc_root(strlit420);
  }
// compilenode returning strlit420
  *var_s = strlit420;
  if (strlit420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe422 = gc_frame_new();
  Object num424 = alloc_Float64(1);
// compilenode returning num424
  int op_slot_right_423 = gc_frame_newslot(num424);
// compilenode returning *var_depth
  int op_slot_left_423 = gc_frame_newslot(*var_depth);
  params[0] = num424;
  partcv[0] = 1;
  Object sum426 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum426
  gc_frame_newslot(sum426);
  int callframe427 = gc_frame_new();
  partcv[0] = 0;
  Object call428 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe427);
// compilenode returning call428
// compilenode returning call428
  params[0] = sum426;
  partcv[0] = 1;
  Object call429 = callmethod(call428, "pretty",
    1, partcv, params);
  gc_frame_end(callframe422);
// compilenode returning call429
  int op_slot_right_421 = gc_frame_newslot(call429);
// compilenode returning *var_spc
  int op_slot_right_431 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_431 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult433 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult433
  int op_slot_left_421 = gc_frame_newslot(opresult433);
  params[0] = call429;
  partcv[0] = 1;
  Object opresult434 = callmethod(opresult433, "++", 1, partcv, params);
// compilenode returning opresult434
  *var_s = opresult434;
  if (opresult434 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 97
  setline(97);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit437 == NULL) {
    strlit437 = alloc_String("""\x0a""");
    gc_root(strlit437);
  }
// compilenode returning strlit437
  int op_slot_right_436 = gc_frame_newslot(strlit437);
// compilenode returning *var_s
  int op_slot_left_436 = gc_frame_newslot(*var_s);
  params[0] = strlit437;
  partcv[0] = 1;
  Object opresult439 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult439
  *var_s = opresult439;
  if (opresult439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 98
  setline(98);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit442 == NULL) {
    strlit442 = alloc_String("Do:");
    gc_root(strlit442);
  }
// compilenode returning strlit442
  int op_slot_right_441 = gc_frame_newslot(strlit442);
// compilenode returning *var_spc
  int op_slot_right_444 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_444 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult446 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult446
  int op_slot_left_441 = gc_frame_newslot(opresult446);
  params[0] = strlit442;
  partcv[0] = 1;
  Object opresult447 = callmethod(opresult446, "++", 1, partcv, params);
// compilenode returning opresult447
  *var_s = opresult447;
  if (opresult447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe449 = gc_frame_new();
  int callframe450 = gc_frame_new();
  partcv[0] = 0;
  Object call451 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe450);
// compilenode returning call451
// compilenode returning call451
  gc_frame_newslot(call451);
  Object block452 = alloc_Block(NULL, NULL, "ast", 99);
  gc_frame_newslot(block452);
  block_savedest(block452);
  Object closure453 = createclosure(4, "_apply");
setclosureframe(closure453, stackframe);
  addtoclosure(closure453, var_depth);
  addtoclosure(closure453, var_spc);
  addtoclosure(closure453, var_s);
  addtoclosure(closure453, selfslot);
  struct UserObject *uo453 = (struct UserObject*)block452;
  uo453->data[0] = (Object)closure453;
  Method *meth_meth_ast__apply453 = addmethod2pos(block452, "_apply", &meth_ast__apply453, 0);
int argcv_meth_ast__apply453[] = {1};
meth_meth_ast__apply453->type = alloc_MethodType(1, argcv_meth_ast__apply453);
  meth_meth_ast__apply453->definitionModule = modulename;
  meth_meth_ast__apply453->definitionLine = 99;
// compilenode returning block452
  gc_frame_newslot(block452);
  params[0] = call451;
  params[1] = block452;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call472 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe449);
// compilenode returning call472
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply485(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit487 == NULL) {
    strlit487 = alloc_String("    ");
    gc_root(strlit487);
  }
// compilenode returning strlit487
  int op_slot_right_486 = gc_frame_newslot(strlit487);
// compilenode returning *var_spc
  int op_slot_left_486 = gc_frame_newslot(*var_spc);
  params[0] = strlit487;
  partcv[0] = 1;
  Object opresult489 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult489
  *var_spc = opresult489;
  if (opresult489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply513(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe515 = gc_frame_new();
  Object num517 = alloc_Float64(1);
// compilenode returning num517
  int op_slot_right_516 = gc_frame_newslot(num517);
// compilenode returning *var_depth
  int op_slot_left_516 = gc_frame_newslot(*var_depth);
  params[0] = num517;
  partcv[0] = 1;
  Object sum519 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum519
  gc_frame_newslot(sum519);
// compilenode returning *var_x
  params[0] = sum519;
  partcv[0] = 1;
  Object call520 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe515);
// compilenode returning call520
  int op_slot_right_514 = gc_frame_newslot(call520);
  if (strlit523 == NULL) {
    strlit523 = alloc_String("    ");
    gc_root(strlit523);
  }
// compilenode returning strlit523
  int op_slot_right_522 = gc_frame_newslot(strlit523);
// compilenode returning *var_spc
  int op_slot_right_525 = gc_frame_newslot(*var_spc);
  if (strlit528 == NULL) {
    strlit528 = alloc_String("""\x0a""");
    gc_root(strlit528);
  }
// compilenode returning strlit528
  int op_slot_right_527 = gc_frame_newslot(strlit528);
// compilenode returning *var_s
  int op_slot_left_527 = gc_frame_newslot(*var_s);
  params[0] = strlit528;
  partcv[0] = 1;
  Object opresult530 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult530
  int op_slot_left_525 = gc_frame_newslot(opresult530);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult531 = callmethod(opresult530, "++", 1, partcv, params);
// compilenode returning opresult531
  int op_slot_left_522 = gc_frame_newslot(opresult531);
  params[0] = strlit523;
  partcv[0] = 1;
  Object opresult532 = callmethod(opresult531, "++", 1, partcv, params);
// compilenode returning opresult532
  int op_slot_left_514 = gc_frame_newslot(opresult532);
  params[0] = call520;
  partcv[0] = 1;
  Object opresult533 = callmethod(opresult532, "++", 1, partcv, params);
// compilenode returning opresult533
  *var_s = opresult533;
  if (opresult533 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace473(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit474 == NULL) {
    strlit474 = alloc_String("");
    gc_root(strlit474);
  }
// compilenode returning strlit474
  *var_spc = strlit474;
  if (strlit474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe475 = gc_frame_new();
  Object num478 = alloc_Float64(1);
// compilenode returning num478
  int op_slot_right_477 = gc_frame_newslot(num478);
// compilenode returning *var_depth
  int op_slot_left_477 = gc_frame_newslot(*var_depth);
  params[0] = num478;
  partcv[0] = 1;
  Object diff480 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff480
  int op_slot_right_476 = gc_frame_newslot(diff480);
  Object num482 = alloc_Float64(0);
// compilenode returning num482
  int op_slot_left_476 = gc_frame_newslot(num482);
  params[0] = diff480;
  partcv[0] = 1;
  Object opresult483 = callmethod(num482, "..", 1, partcv, params);
// compilenode returning opresult483
  gc_frame_newslot(opresult483);
  Object block484 = alloc_Block(NULL, NULL, "ast", 106);
  gc_frame_newslot(block484);
  block_savedest(block484);
  Object closure485 = createclosure(2, "_apply");
setclosureframe(closure485, stackframe);
  addtoclosure(closure485, var_spc);
  addtoclosure(closure485, selfslot);
  struct UserObject *uo485 = (struct UserObject*)block484;
  uo485->data[0] = (Object)closure485;
  Method *meth_meth_ast__apply485 = addmethod2pos(block484, "_apply", &meth_ast__apply485, 0);
int argcv_meth_ast__apply485[] = {1};
meth_meth_ast__apply485->type = alloc_MethodType(1, argcv_meth_ast__apply485);
  meth_meth_ast__apply485->definitionModule = modulename;
  meth_meth_ast__apply485->definitionLine = 99;
// compilenode returning block484
  gc_frame_newslot(block484);
  params[0] = opresult483;
  params[1] = block484;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call492 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe475);
// compilenode returning call492
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit494 == NULL) {
    strlit494 = alloc_String("} do {");
    gc_root(strlit494);
  }
// compilenode returning strlit494
  int op_slot_right_493 = gc_frame_newslot(strlit494);
  int callframe497 = gc_frame_new();
  Object num499 = alloc_Float64(1);
// compilenode returning num499
  int op_slot_right_498 = gc_frame_newslot(num499);
// compilenode returning *var_depth
  int op_slot_left_498 = gc_frame_newslot(*var_depth);
  params[0] = num499;
  partcv[0] = 1;
  Object sum501 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum501
  gc_frame_newslot(sum501);
  int callframe502 = gc_frame_new();
  partcv[0] = 0;
  Object call503 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe502);
// compilenode returning call503
// compilenode returning call503
  params[0] = sum501;
  partcv[0] = 1;
  Object call504 = callmethod(call503, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe497);
// compilenode returning call504
  int op_slot_right_496 = gc_frame_newslot(call504);
  if (strlit506 == NULL) {
    strlit506 = alloc_String("while {");
    gc_root(strlit506);
  }
// compilenode returning strlit506
  int op_slot_left_496 = gc_frame_newslot(strlit506);
  params[0] = call504;
  partcv[0] = 1;
  Object opresult507 = callmethod(strlit506, "++", 1, partcv, params);
// compilenode returning opresult507
  int op_slot_left_493 = gc_frame_newslot(opresult507);
  params[0] = strlit494;
  partcv[0] = 1;
  Object opresult508 = callmethod(opresult507, "++", 1, partcv, params);
// compilenode returning opresult508
  *var_s = opresult508;
  if (opresult508 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe509 = gc_frame_new();
  int callframe510 = gc_frame_new();
  partcv[0] = 0;
  Object call511 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe510);
// compilenode returning call511
// compilenode returning call511
  gc_frame_newslot(call511);
  Object block512 = alloc_Block(NULL, NULL, "ast", 110);
  gc_frame_newslot(block512);
  block_savedest(block512);
  Object closure513 = createclosure(4, "_apply");
setclosureframe(closure513, stackframe);
  addtoclosure(closure513, var_depth);
  addtoclosure(closure513, var_spc);
  addtoclosure(closure513, var_s);
  addtoclosure(closure513, selfslot);
  struct UserObject *uo513 = (struct UserObject*)block512;
  uo513->data[0] = (Object)closure513;
  Method *meth_meth_ast__apply513 = addmethod2pos(block512, "_apply", &meth_ast__apply513, 0);
int argcv_meth_ast__apply513[] = {1};
meth_meth_ast__apply513->type = alloc_MethodType(1, argcv_meth_ast__apply513);
  meth_meth_ast__apply513->definitionModule = modulename;
  meth_meth_ast__apply513->definitionLine = 110;
// compilenode returning block512
  gc_frame_newslot(block512);
  params[0] = call511;
  params[1] = block512;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call536 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe509);
// compilenode returning call536
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit538 == NULL) {
    strlit538 = alloc_String("}");
    gc_root(strlit538);
  }
// compilenode returning strlit538
  int op_slot_right_537 = gc_frame_newslot(strlit538);
// compilenode returning *var_spc
  int op_slot_right_540 = gc_frame_newslot(*var_spc);
  if (strlit543 == NULL) {
    strlit543 = alloc_String("""\x0a""");
    gc_root(strlit543);
  }
// compilenode returning strlit543
  int op_slot_right_542 = gc_frame_newslot(strlit543);
// compilenode returning *var_s
  int op_slot_left_542 = gc_frame_newslot(*var_s);
  params[0] = strlit543;
  partcv[0] = 1;
  Object opresult545 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult545
  int op_slot_left_540 = gc_frame_newslot(opresult545);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult546 = callmethod(opresult545, "++", 1, partcv, params);
// compilenode returning opresult546
  int op_slot_left_537 = gc_frame_newslot(opresult546);
  params[0] = strlit538;
  partcv[0] = 1;
  Object opresult547 = callmethod(opresult546, "++", 1, partcv, params);
// compilenode returning opresult547
  *var_s = opresult547;
  if (opresult547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj382 = alloc_userobj2(7,8, objclass382);
  gc_frame_newslot(obj382);
if (objclass382 == NULL) {
  glfree(obj382->class->name);
  obj382->class->name = "whileNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj382, self, 0);
  addmethodreal(obj382,"outer", &reader_ast_outer_383);
  Object oldself382 = self;
  struct StackFrameObject *oldstackframe382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe382);
  gc_frame_newslot((Object)stackframe);
  self = obj382;
  Object *oldselfslot382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter382 = (*(struct UserObject *)self).data[0], lowerouter382 = thisouter382;
  if (inheritingObject382) {
    struct UserObject *inho382 = (struct UserObject *)inheritingObject382;
    while (inho382->super != GraceDefaultObject) inho382 = (struct UserObject *)inho382->super;
    inho382->super = obj382;
    self = inheritingObject382;
    *selfslot = self;
    lowerouter382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter382;
  }
if (objclass382 == NULL) {
  Method *reader384 = addmethodrealflags(obj382, "kind",&reader_ast_kind_384, MFLAG_DEF);
  reader384->definitionModule = modulename;
  reader384->definitionLine = 80;
}
adddatum2(obj382, alloc_Undefined(), 1);
if (objclass382 == NULL) {
  Method *reader385 = addmethodrealflags(obj382, "value",&reader_ast_value_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 81;
}
adddatum2(obj382, alloc_Undefined(), 2);
if (objclass382 == NULL) {
  Method *reader386 = addmethodrealflags(obj382, "body",&reader_ast_body_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 82;
}
adddatum2(obj382, alloc_Undefined(), 3);
  struct UserObject *uo387 = (struct UserObject*)obj382;
  uo387->data[4] = emptyclosure;
  Method *meth_meth_ast_accept387 = addmethod2pos(obj382, "accept", &meth_ast_accept387, 4);
int argcv_meth_ast_accept387[] = {1};
meth_meth_ast_accept387->type = alloc_MethodType(1, argcv_meth_ast_accept387);
meth_meth_ast_accept387->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept387->type->names[0] = "visitor";
  meth_meth_ast_accept387->definitionModule = modulename;
  meth_meth_ast_accept387->definitionLine = 82;
  struct UserObject *uo404 = (struct UserObject*)obj382;
  uo404->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty404 = addmethod2pos(obj382, "pretty", &meth_ast_pretty404, 5);
int argcv_meth_ast_pretty404[] = {1};
meth_meth_ast_pretty404->type = alloc_MethodType(1, argcv_meth_ast_pretty404);
  meth_meth_ast_pretty404->definitionModule = modulename;
  meth_meth_ast_pretty404->definitionLine = 90;
  struct UserObject *uo473 = (struct UserObject*)obj382;
  uo473->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace473 = addmethod2pos(obj382, "toGrace", &meth_ast_toGrace473, 6);
int argcv_meth_ast_toGrace473[] = {1};
meth_meth_ast_toGrace473->type = alloc_MethodType(1, argcv_meth_ast_toGrace473);
meth_meth_ast_toGrace473->type->types[0] = type_Number;
meth_meth_ast_toGrace473->type->names[0] = "depth";
  meth_meth_ast_toGrace473->definitionModule = modulename;
  meth_meth_ast_toGrace473->definitionLine = 104;
  sourceObject = obj382;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe549);
// compilenode returning call550
  struct UserObject *obj382_uo = (struct UserObject *)obj382;
  obj382_uo->super = call550;
  sourceObject = obj382;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit551 == NULL) {
    strlit551 = alloc_String("while");
    gc_root(strlit551);
  }
// compilenode returning strlit551
  adddatum2(obj382, strlit551, 1);
  sourceObject = obj382;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj382, *var_cond, 2);
  sourceObject = obj382;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj382, *var_body_39_, 3);
  sourceObject = obj382;
  sourceObject = obj382;
  sourceObject = obj382;
objclass382 = obj382->class;
  objclass382->definitionModule = modulename;
  objclass382->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter382;
  self = oldself382;
  selfslot = oldselfslot382;
  stackframe = oldstackframe382;
  gc_frame_end(frame);
  return obj382;
}
Object meth_ast_new381_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj382 = alloc_userobj2(7,8, objclass382);
  gc_frame_newslot(obj382);
if (objclass382 == NULL) {
  glfree(obj382->class->name);
  obj382->class->name = "whileNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj382, self, 0);
  addmethodreal(obj382,"outer", &reader_ast_outer_383);
  Object oldself382 = self;
  struct StackFrameObject *oldstackframe382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe382);
  gc_frame_newslot((Object)stackframe);
  self = obj382;
  Object *oldselfslot382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter382 = (*(struct UserObject *)self).data[0], lowerouter382 = thisouter382;
  if (inheritingObject382) {
    struct UserObject *inho382 = (struct UserObject *)inheritingObject382;
    while (inho382->super != GraceDefaultObject) inho382 = (struct UserObject *)inho382->super;
    inho382->super = obj382;
    self = inheritingObject382;
    *selfslot = self;
    lowerouter382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter382;
  }
if (objclass382 == NULL) {
  Method *reader384 = addmethodrealflags(obj382, "kind",&reader_ast_kind_384, MFLAG_DEF);
  reader384->definitionModule = modulename;
  reader384->definitionLine = 80;
}
adddatum2(obj382, alloc_Undefined(), 1);
if (objclass382 == NULL) {
  Method *reader385 = addmethodrealflags(obj382, "value",&reader_ast_value_385, MFLAG_DEF);
  reader385->definitionModule = modulename;
  reader385->definitionLine = 81;
}
adddatum2(obj382, alloc_Undefined(), 2);
if (objclass382 == NULL) {
  Method *reader386 = addmethodrealflags(obj382, "body",&reader_ast_body_386, MFLAG_DEF);
  reader386->definitionModule = modulename;
  reader386->definitionLine = 82;
}
adddatum2(obj382, alloc_Undefined(), 3);
  struct UserObject *uo387 = (struct UserObject*)obj382;
  uo387->data[4] = emptyclosure;
  Method *meth_meth_ast_accept387 = addmethod2pos(obj382, "accept", &meth_ast_accept387, 4);
int argcv_meth_ast_accept387[] = {1};
meth_meth_ast_accept387->type = alloc_MethodType(1, argcv_meth_ast_accept387);
meth_meth_ast_accept387->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept387->type->names[0] = "visitor";
  meth_meth_ast_accept387->definitionModule = modulename;
  meth_meth_ast_accept387->definitionLine = 82;
  struct UserObject *uo404 = (struct UserObject*)obj382;
  uo404->data[5] = emptyclosure;
  Method *meth_meth_ast_pretty404 = addmethod2pos(obj382, "pretty", &meth_ast_pretty404, 5);
int argcv_meth_ast_pretty404[] = {1};
meth_meth_ast_pretty404->type = alloc_MethodType(1, argcv_meth_ast_pretty404);
  meth_meth_ast_pretty404->definitionModule = modulename;
  meth_meth_ast_pretty404->definitionLine = 90;
  struct UserObject *uo473 = (struct UserObject*)obj382;
  uo473->data[6] = emptyclosure;
  Method *meth_meth_ast_toGrace473 = addmethod2pos(obj382, "toGrace", &meth_ast_toGrace473, 6);
int argcv_meth_ast_toGrace473[] = {1};
meth_meth_ast_toGrace473->type = alloc_MethodType(1, argcv_meth_ast_toGrace473);
meth_meth_ast_toGrace473->type->types[0] = type_Number;
meth_meth_ast_toGrace473->type->names[0] = "depth";
  meth_meth_ast_toGrace473->definitionModule = modulename;
  meth_meth_ast_toGrace473->definitionLine = 104;
  sourceObject = obj382;
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call550 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe549);
// compilenode returning call550
  struct UserObject *obj382_uo = (struct UserObject *)obj382;
  obj382_uo->super = call550;
  sourceObject = obj382;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit551 == NULL) {
    strlit551 = alloc_String("while");
    gc_root(strlit551);
  }
// compilenode returning strlit551
  adddatum2(obj382, strlit551, 1);
  sourceObject = obj382;
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj382, *var_cond, 2);
  sourceObject = obj382;
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj382, *var_body_39_, 3);
  sourceObject = obj382;
  sourceObject = obj382;
  sourceObject = obj382;
objclass382 = obj382->class;
  objclass382->definitionModule = modulename;
  objclass382->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter382;
  self = oldself382;
  selfslot = oldselfslot382;
  stackframe = oldstackframe382;
  gc_frame_end(frame);
  return obj382;
}
Object meth_ast_ifNode553(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ifNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for ifNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ifNode
  gc_frame_end(frame);
  return *var_ifNode;
}
Object meth_ast__apply576(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 128
  setline(128);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe577 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ix
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call578 = callmethod(*var_ix, "accept",
    1, partcv, params);
  gc_frame_end(callframe577);
// compilenode returning call578
  gc_frame_end(frame);
  return call578;
}
Object meth_ast__apply585(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe586 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ix
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call587 = callmethod(*var_ix, "accept",
    1, partcv, params);
  gc_frame_end(callframe586);
// compilenode returning call587
  gc_frame_end(frame);
  return call587;
}
Object meth_ast_accept564(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe566 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call567 = callmethod(*var_visitor, "visitIf",
    1, partcv, params);
  gc_frame_end(callframe566);
// compilenode returning call567
  Object if565 = done;
  if (istrue(call567)) {
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe568 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe569 = gc_frame_new();
  partcv[0] = 0;
  Object call570 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe569);
// compilenode returning call570
// compilenode returning call570
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call571 = callmethod(call570, "accept",
    1, partcv, params);
  gc_frame_end(callframe568);
// compilenode returning call571
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe572 = gc_frame_new();
  int callframe573 = gc_frame_new();
  partcv[0] = 0;
  Object call574 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe573);
// compilenode returning call574
// compilenode returning call574
  gc_frame_newslot(call574);
  Object block575 = alloc_Block(NULL, NULL, "ast", 127);
  gc_frame_newslot(block575);
  block_savedest(block575);
  Object closure576 = createclosure(2, "_apply");
setclosureframe(closure576, stackframe);
  addtoclosure(closure576, var_visitor);
  addtoclosure(closure576, selfslot);
  struct UserObject *uo576 = (struct UserObject*)block575;
  uo576->data[0] = (Object)closure576;
  Method *meth_meth_ast__apply576 = addmethod2pos(block575, "_apply", &meth_ast__apply576, 0);
int argcv_meth_ast__apply576[] = {1};
meth_meth_ast__apply576->type = alloc_MethodType(1, argcv_meth_ast__apply576);
  meth_meth_ast__apply576->definitionModule = modulename;
  meth_meth_ast__apply576->definitionLine = 127;
// compilenode returning block575
  gc_frame_newslot(block575);
  params[0] = call574;
  params[1] = block575;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call580 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe572);
// compilenode returning call580
// Begin line 130
  setline(130);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe581 = gc_frame_new();
  int callframe582 = gc_frame_new();
  partcv[0] = 0;
  Object call583 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe582);
// compilenode returning call583
// compilenode returning call583
  gc_frame_newslot(call583);
  Object block584 = alloc_Block(NULL, NULL, "ast", 130);
  gc_frame_newslot(block584);
  block_savedest(block584);
  Object closure585 = createclosure(2, "_apply");
setclosureframe(closure585, stackframe);
  addtoclosure(closure585, var_visitor);
  addtoclosure(closure585, selfslot);
  struct UserObject *uo585 = (struct UserObject*)block584;
  uo585->data[0] = (Object)closure585;
  Method *meth_meth_ast__apply585 = addmethod2pos(block584, "_apply", &meth_ast__apply585, 0);
int argcv_meth_ast__apply585[] = {1};
meth_meth_ast__apply585->type = alloc_MethodType(1, argcv_meth_ast__apply585);
  meth_meth_ast__apply585->definitionModule = modulename;
  meth_meth_ast__apply585->definitionLine = 130;
// compilenode returning block584
  gc_frame_newslot(block584);
  params[0] = call583;
  params[1] = block584;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call589 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe581);
// compilenode returning call589
    gc_frame_newslot(call589);
    if565 = call589;
  } else {
  }
// compilenode returning if565
  gc_frame_end(frame);
  return if565;
}
Object meth_ast_map_40__41_before_40__41_after590(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_ifNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_v = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "v");
  Object *var_tb = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tb");
  Object *var_eb = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "eb");
  Object *var_n = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "n");
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe591 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call592 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe591);
// compilenode returning call592
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe593 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe594 = gc_frame_new();
  partcv[0] = 0;
  Object call595 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe594);
// compilenode returning call595
// compilenode returning call595
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call596 = callmethod(call595, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe593);
// compilenode returning call596
  *var_v = call596;
  if (call596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe597 = gc_frame_new();
  int callframe598 = gc_frame_new();
  partcv[0] = 0;
  Object call599 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe598);
// compilenode returning call599
// compilenode returning call599
  gc_frame_newslot(call599);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe600 = gc_frame_new();
  int callframe601 = gc_frame_new();
  Object call602 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe601);
// compilenode returning call602
// compilenode returning call602
  partcv[0] = 0;
  Object call603 = callmethodflags(call602, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe600);
// compilenode returning call603
// compilenode returning call603
  params[0] = call599;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call604 = callmethodflags(call603, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe597);
// compilenode returning call604
  *var_tb = call604;
  if (call604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe605 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkAfter
  params[0] = self;
  partcv[0] = 1;
  Object call606 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe605);
// compilenode returning call606
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe607 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call608 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe607);
// compilenode returning call608
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe609 = gc_frame_new();
  int callframe610 = gc_frame_new();
  partcv[0] = 0;
  Object call611 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe610);
// compilenode returning call611
// compilenode returning call611
  gc_frame_newslot(call611);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe612 = gc_frame_new();
  int callframe613 = gc_frame_new();
  Object call614 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe613);
// compilenode returning call614
// compilenode returning call614
  partcv[0] = 0;
  Object call615 = callmethodflags(call614, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe612);
// compilenode returning call615
// compilenode returning call615
  params[0] = call611;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call616 = callmethodflags(call615, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe609);
// compilenode returning call616
  *var_eb = call616;
  if (call616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe617 = gc_frame_new();
// compilenode returning *var_v
  gc_frame_newslot(*var_v);
// compilenode returning *var_tb
  gc_frame_newslot(*var_tb);
// compilenode returning *var_eb
  gc_frame_newslot(*var_eb);
// compilenode returning *var_ifNode
  params[0] = *var_v;
  params[1] = *var_tb;
  params[2] = *var_eb;
  partcv[0] = 3;
  Object call618 = callmethod(*var_ifNode, "new",
    1, partcv, params);
  gc_frame_end(callframe617);
// compilenode returning call618
  *var_n = call618;
  if (call618 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe619 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call620 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe619);
// compilenode returning call620
  *var_n = call620;
  if (call620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe622 = gc_frame_new();
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe623 = gc_frame_new();
  partcv[0] = 0;
  Object call624 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe623);
// compilenode returning call624
  gc_frame_newslot(call624);
// compilenode returning *var_n
  params[0] = call624;
  partcv[0] = 1;
  Object call625 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe622);
// compilenode returning call625
// compilenode returning done
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe626 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call627 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe626);
// compilenode returning call627
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply634(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe629 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block630 = alloc_Block(NULL, NULL, "ast", 149);
  gc_frame_newslot(block630);
  block_savedest(block630);
  Object closure631 = createclosure(1, "_apply");
setclosureframe(closure631, stackframe);
  addtoclosure(closure631, selfslot);
  struct UserObject *uo631 = (struct UserObject*)block630;
  uo631->data[0] = (Object)closure631;
  Method *meth_meth_ast__apply631 = addmethod2pos(block630, "_apply", &meth_ast__apply631, 0);
int argcv_meth_ast__apply631[] = {0};
meth_meth_ast__apply631->type = alloc_MethodType(1, argcv_meth_ast__apply631);
  meth_meth_ast__apply631->definitionModule = modulename;
  meth_meth_ast__apply631->definitionLine = 141;
// compilenode returning block630
  gc_frame_newslot(block630);
  Object block633 = alloc_Block(NULL, NULL, "ast", 149);
  gc_frame_newslot(block633);
  block_savedest(block633);
  Object closure634 = createclosure(1, "_apply");
setclosureframe(closure634, stackframe);
  addtoclosure(closure634, selfslot);
  struct UserObject *uo634 = (struct UserObject*)block633;
  uo634->data[0] = (Object)closure634;
  Method *meth_meth_ast__apply634 = addmethod2pos(block633, "_apply", &meth_ast__apply634, 0);
int argcv_meth_ast__apply634[] = {0};
meth_meth_ast__apply634->type = alloc_MethodType(1, argcv_meth_ast__apply634);
  meth_meth_ast__apply634->definitionModule = modulename;
  meth_meth_ast__apply634->definitionLine = 141;
// compilenode returning block633
  gc_frame_newslot(block633);
  params[0] = *var_blk;
  params[1] = block630;
  params[2] = block633;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call636 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe629);
// compilenode returning call636
  gc_frame_end(frame);
  return call636;
}
Object meth_ast__apply645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit647 == NULL) {
    strlit647 = alloc_String("  ");
    gc_root(strlit647);
  }
// compilenode returning strlit647
  int op_slot_right_646 = gc_frame_newslot(strlit647);
// compilenode returning *var_spc
  int op_slot_left_646 = gc_frame_newslot(*var_spc);
  params[0] = strlit647;
  partcv[0] = 1;
  Object opresult649 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult649
  *var_spc = opresult649;
  if (opresult649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply686(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe688 = gc_frame_new();
  Object num690 = alloc_Float64(2);
// compilenode returning num690
  int op_slot_right_689 = gc_frame_newslot(num690);
// compilenode returning *var_depth
  int op_slot_left_689 = gc_frame_newslot(*var_depth);
  params[0] = num690;
  partcv[0] = 1;
  Object sum692 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum692
  gc_frame_newslot(sum692);
// compilenode returning *var_ix
  params[0] = sum692;
  partcv[0] = 1;
  Object call693 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe688);
// compilenode returning call693
  int op_slot_right_687 = gc_frame_newslot(call693);
// compilenode returning *var_spc
  int op_slot_right_695 = gc_frame_newslot(*var_spc);
  if (strlit698 == NULL) {
    strlit698 = alloc_String("""\x0a""  ");
    gc_root(strlit698);
  }
// compilenode returning strlit698
  int op_slot_right_697 = gc_frame_newslot(strlit698);
// compilenode returning *var_s
  int op_slot_left_697 = gc_frame_newslot(*var_s);
  params[0] = strlit698;
  partcv[0] = 1;
  Object opresult700 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult700
  int op_slot_left_695 = gc_frame_newslot(opresult700);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult701 = callmethod(opresult700, "++", 1, partcv, params);
// compilenode returning opresult701
  int op_slot_left_687 = gc_frame_newslot(opresult701);
  params[0] = call693;
  partcv[0] = 1;
  Object opresult702 = callmethod(opresult701, "++", 1, partcv, params);
// compilenode returning opresult702
  *var_s = opresult702;
  if (opresult702 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply723(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe725 = gc_frame_new();
  Object num727 = alloc_Float64(2);
// compilenode returning num727
  int op_slot_right_726 = gc_frame_newslot(num727);
// compilenode returning *var_depth
  int op_slot_left_726 = gc_frame_newslot(*var_depth);
  params[0] = num727;
  partcv[0] = 1;
  Object sum729 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum729
  gc_frame_newslot(sum729);
// compilenode returning *var_ix
  params[0] = sum729;
  partcv[0] = 1;
  Object call730 = callmethod(*var_ix, "pretty",
    1, partcv, params);
  gc_frame_end(callframe725);
// compilenode returning call730
  int op_slot_right_724 = gc_frame_newslot(call730);
// compilenode returning *var_spc
  int op_slot_right_732 = gc_frame_newslot(*var_spc);
  if (strlit735 == NULL) {
    strlit735 = alloc_String("""\x0a""  ");
    gc_root(strlit735);
  }
// compilenode returning strlit735
  int op_slot_right_734 = gc_frame_newslot(strlit735);
// compilenode returning *var_s
  int op_slot_left_734 = gc_frame_newslot(*var_s);
  params[0] = strlit735;
  partcv[0] = 1;
  Object opresult737 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult737
  int op_slot_left_732 = gc_frame_newslot(opresult737);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult738 = callmethod(opresult737, "++", 1, partcv, params);
// compilenode returning opresult738
  int op_slot_left_724 = gc_frame_newslot(opresult738);
  params[0] = call730;
  partcv[0] = 1;
  Object opresult739 = callmethod(opresult738, "++", 1, partcv, params);
// compilenode returning opresult739
  *var_s = opresult739;
  if (opresult739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty637(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit638 == NULL) {
    strlit638 = alloc_String("");
    gc_root(strlit638);
  }
// compilenode returning strlit638
  *var_spc = strlit638;
  if (strlit638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe639 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_640 = gc_frame_newslot(*var_depth);
  Object num642 = alloc_Float64(0);
// compilenode returning num642
  int op_slot_left_640 = gc_frame_newslot(num642);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult643 = callmethod(num642, "..", 1, partcv, params);
// compilenode returning opresult643
  gc_frame_newslot(opresult643);
  Object block644 = alloc_Block(NULL, NULL, "ast", 153);
  gc_frame_newslot(block644);
  block_savedest(block644);
  Object closure645 = createclosure(2, "_apply");
setclosureframe(closure645, stackframe);
  addtoclosure(closure645, var_spc);
  addtoclosure(closure645, selfslot);
  struct UserObject *uo645 = (struct UserObject*)block644;
  uo645->data[0] = (Object)closure645;
  Method *meth_meth_ast__apply645 = addmethod2pos(block644, "_apply", &meth_ast__apply645, 0);
int argcv_meth_ast__apply645[] = {1};
meth_meth_ast__apply645->type = alloc_MethodType(1, argcv_meth_ast__apply645);
  meth_meth_ast__apply645->definitionModule = modulename;
  meth_meth_ast__apply645->definitionLine = 141;
// compilenode returning block644
  gc_frame_newslot(block644);
  params[0] = opresult643;
  params[1] = block644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call652 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe639);
// compilenode returning call652
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 156
  setline(156);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit653 == NULL) {
    strlit653 = alloc_String("If""\x0a""");
    gc_root(strlit653);
  }
// compilenode returning strlit653
  *var_s = strlit653;
  if (strlit653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 157
  setline(157);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe655 = gc_frame_new();
  Object num657 = alloc_Float64(1);
// compilenode returning num657
  int op_slot_right_656 = gc_frame_newslot(num657);
// compilenode returning *var_depth
  int op_slot_left_656 = gc_frame_newslot(*var_depth);
  params[0] = num657;
  partcv[0] = 1;
  Object sum659 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum659
  gc_frame_newslot(sum659);
  int callframe660 = gc_frame_new();
  partcv[0] = 0;
  Object call661 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe660);
// compilenode returning call661
// compilenode returning call661
  params[0] = sum659;
  partcv[0] = 1;
  Object call662 = callmethod(call661, "pretty",
    1, partcv, params);
  gc_frame_end(callframe655);
// compilenode returning call662
  int op_slot_right_654 = gc_frame_newslot(call662);
// compilenode returning *var_spc
  int op_slot_right_664 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_664 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult666 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult666
  int op_slot_left_654 = gc_frame_newslot(opresult666);
  params[0] = call662;
  partcv[0] = 1;
  Object opresult667 = callmethod(opresult666, "++", 1, partcv, params);
// compilenode returning opresult667
  *var_s = opresult667;
  if (opresult667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 158
  setline(158);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit670 == NULL) {
    strlit670 = alloc_String("""\x0a""");
    gc_root(strlit670);
  }
// compilenode returning strlit670
  int op_slot_right_669 = gc_frame_newslot(strlit670);
// compilenode returning *var_s
  int op_slot_left_669 = gc_frame_newslot(*var_s);
  params[0] = strlit670;
  partcv[0] = 1;
  Object opresult672 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult672
  *var_s = opresult672;
  if (opresult672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit675 == NULL) {
    strlit675 = alloc_String("Then:");
    gc_root(strlit675);
  }
// compilenode returning strlit675
  int op_slot_right_674 = gc_frame_newslot(strlit675);
// compilenode returning *var_spc
  int op_slot_right_677 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_677 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult679 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult679
  int op_slot_left_674 = gc_frame_newslot(opresult679);
  params[0] = strlit675;
  partcv[0] = 1;
  Object opresult680 = callmethod(opresult679, "++", 1, partcv, params);
// compilenode returning opresult680
  *var_s = opresult680;
  if (opresult680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe682 = gc_frame_new();
  int callframe683 = gc_frame_new();
  partcv[0] = 0;
  Object call684 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe683);
// compilenode returning call684
// compilenode returning call684
  gc_frame_newslot(call684);
  Object block685 = alloc_Block(NULL, NULL, "ast", 160);
  gc_frame_newslot(block685);
  block_savedest(block685);
  Object closure686 = createclosure(4, "_apply");
setclosureframe(closure686, stackframe);
  addtoclosure(closure686, var_depth);
  addtoclosure(closure686, var_spc);
  addtoclosure(closure686, var_s);
  addtoclosure(closure686, selfslot);
  struct UserObject *uo686 = (struct UserObject*)block685;
  uo686->data[0] = (Object)closure686;
  Method *meth_meth_ast__apply686 = addmethod2pos(block685, "_apply", &meth_ast__apply686, 0);
int argcv_meth_ast__apply686[] = {1};
meth_meth_ast__apply686->type = alloc_MethodType(1, argcv_meth_ast__apply686);
  meth_meth_ast__apply686->definitionModule = modulename;
  meth_meth_ast__apply686->definitionLine = 160;
// compilenode returning block685
  gc_frame_newslot(block685);
  params[0] = call684;
  params[1] = block685;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call705 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe682);
// compilenode returning call705
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 163
  setline(163);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit707 == NULL) {
    strlit707 = alloc_String("""\x0a""");
    gc_root(strlit707);
  }
// compilenode returning strlit707
  int op_slot_right_706 = gc_frame_newslot(strlit707);
// compilenode returning *var_s
  int op_slot_left_706 = gc_frame_newslot(*var_s);
  params[0] = strlit707;
  partcv[0] = 1;
  Object opresult709 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult709
  *var_s = opresult709;
  if (opresult709 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit712 == NULL) {
    strlit712 = alloc_String("Else:");
    gc_root(strlit712);
  }
// compilenode returning strlit712
  int op_slot_right_711 = gc_frame_newslot(strlit712);
// compilenode returning *var_spc
  int op_slot_right_714 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_714 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult716 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult716
  int op_slot_left_711 = gc_frame_newslot(opresult716);
  params[0] = strlit712;
  partcv[0] = 1;
  Object opresult717 = callmethod(opresult716, "++", 1, partcv, params);
// compilenode returning opresult717
  *var_s = opresult717;
  if (opresult717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe719 = gc_frame_new();
  int callframe720 = gc_frame_new();
  partcv[0] = 0;
  Object call721 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe720);
// compilenode returning call721
// compilenode returning call721
  gc_frame_newslot(call721);
  Object block722 = alloc_Block(NULL, NULL, "ast", 165);
  gc_frame_newslot(block722);
  block_savedest(block722);
  Object closure723 = createclosure(4, "_apply");
setclosureframe(closure723, stackframe);
  addtoclosure(closure723, var_depth);
  addtoclosure(closure723, var_spc);
  addtoclosure(closure723, var_s);
  addtoclosure(closure723, selfslot);
  struct UserObject *uo723 = (struct UserObject*)block722;
  uo723->data[0] = (Object)closure723;
  Method *meth_meth_ast__apply723 = addmethod2pos(block722, "_apply", &meth_ast__apply723, 0);
int argcv_meth_ast__apply723[] = {1};
meth_meth_ast__apply723->type = alloc_MethodType(1, argcv_meth_ast__apply723);
  meth_meth_ast__apply723->definitionModule = modulename;
  meth_meth_ast__apply723->definitionLine = 165;
// compilenode returning block722
  gc_frame_newslot(block722);
  params[0] = call721;
  params[1] = block722;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call742 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe719);
// compilenode returning call742
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit757 == NULL) {
    strlit757 = alloc_String("    ");
    gc_root(strlit757);
  }
// compilenode returning strlit757
  int op_slot_right_756 = gc_frame_newslot(strlit757);
// compilenode returning *var_spc
  int op_slot_left_756 = gc_frame_newslot(*var_spc);
  params[0] = strlit757;
  partcv[0] = 1;
  Object opresult759 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult759
  *var_spc = opresult759;
  if (opresult759 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe782 = gc_frame_new();
  Object num784 = alloc_Float64(1);
// compilenode returning num784
  int op_slot_right_783 = gc_frame_newslot(num784);
// compilenode returning *var_depth
  int op_slot_left_783 = gc_frame_newslot(*var_depth);
  params[0] = num784;
  partcv[0] = 1;
  Object sum786 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum786
  gc_frame_newslot(sum786);
// compilenode returning *var_ix
  params[0] = sum786;
  partcv[0] = 1;
  Object call787 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe782);
// compilenode returning call787
  int op_slot_right_781 = gc_frame_newslot(call787);
  if (strlit790 == NULL) {
    strlit790 = alloc_String("    ");
    gc_root(strlit790);
  }
// compilenode returning strlit790
  int op_slot_right_789 = gc_frame_newslot(strlit790);
// compilenode returning *var_spc
  int op_slot_right_792 = gc_frame_newslot(*var_spc);
  if (strlit795 == NULL) {
    strlit795 = alloc_String("""\x0a""");
    gc_root(strlit795);
  }
// compilenode returning strlit795
  int op_slot_right_794 = gc_frame_newslot(strlit795);
// compilenode returning *var_s
  int op_slot_left_794 = gc_frame_newslot(*var_s);
  params[0] = strlit795;
  partcv[0] = 1;
  Object opresult797 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult797
  int op_slot_left_792 = gc_frame_newslot(opresult797);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult798 = callmethod(opresult797, "++", 1, partcv, params);
// compilenode returning opresult798
  int op_slot_left_789 = gc_frame_newslot(opresult798);
  params[0] = strlit790;
  partcv[0] = 1;
  Object opresult799 = callmethod(opresult798, "++", 1, partcv, params);
// compilenode returning opresult799
  int op_slot_left_781 = gc_frame_newslot(opresult799);
  params[0] = call787;
  partcv[0] = 1;
  Object opresult800 = callmethod(opresult799, "++", 1, partcv, params);
// compilenode returning opresult800
  *var_s = opresult800;
  if (opresult800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply829(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe831 = gc_frame_new();
  Object num833 = alloc_Float64(1);
// compilenode returning num833
  int op_slot_right_832 = gc_frame_newslot(num833);
// compilenode returning *var_depth
  int op_slot_left_832 = gc_frame_newslot(*var_depth);
  params[0] = num833;
  partcv[0] = 1;
  Object sum835 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum835
  gc_frame_newslot(sum835);
// compilenode returning *var_ix
  params[0] = sum835;
  partcv[0] = 1;
  Object call836 = callmethod(*var_ix, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe831);
// compilenode returning call836
  int op_slot_right_830 = gc_frame_newslot(call836);
  if (strlit839 == NULL) {
    strlit839 = alloc_String("    ");
    gc_root(strlit839);
  }
// compilenode returning strlit839
  int op_slot_right_838 = gc_frame_newslot(strlit839);
// compilenode returning *var_spc
  int op_slot_right_841 = gc_frame_newslot(*var_spc);
  if (strlit844 == NULL) {
    strlit844 = alloc_String("""\x0a""");
    gc_root(strlit844);
  }
// compilenode returning strlit844
  int op_slot_right_843 = gc_frame_newslot(strlit844);
// compilenode returning *var_s
  int op_slot_left_843 = gc_frame_newslot(*var_s);
  params[0] = strlit844;
  partcv[0] = 1;
  Object opresult846 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult846
  int op_slot_left_841 = gc_frame_newslot(opresult846);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult847 = callmethod(opresult846, "++", 1, partcv, params);
// compilenode returning opresult847
  int op_slot_left_838 = gc_frame_newslot(opresult847);
  params[0] = strlit839;
  partcv[0] = 1;
  Object opresult848 = callmethod(opresult847, "++", 1, partcv, params);
// compilenode returning opresult848
  int op_slot_left_830 = gc_frame_newslot(opresult848);
  params[0] = call836;
  partcv[0] = 1;
  Object opresult849 = callmethod(opresult848, "++", 1, partcv, params);
// compilenode returning opresult849
  *var_s = opresult849;
  if (opresult849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace743(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit744 == NULL) {
    strlit744 = alloc_String("");
    gc_root(strlit744);
  }
// compilenode returning strlit744
  *var_spc = strlit744;
  if (strlit744 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe745 = gc_frame_new();
  Object num748 = alloc_Float64(1);
// compilenode returning num748
  int op_slot_right_747 = gc_frame_newslot(num748);
// compilenode returning *var_depth
  int op_slot_left_747 = gc_frame_newslot(*var_depth);
  params[0] = num748;
  partcv[0] = 1;
  Object diff750 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff750
  int op_slot_right_746 = gc_frame_newslot(diff750);
  Object num752 = alloc_Float64(0);
// compilenode returning num752
  int op_slot_left_746 = gc_frame_newslot(num752);
  params[0] = diff750;
  partcv[0] = 1;
  Object opresult753 = callmethod(num752, "..", 1, partcv, params);
// compilenode returning opresult753
  gc_frame_newslot(opresult753);
  Object block754 = alloc_Block(NULL, NULL, "ast", 172);
  gc_frame_newslot(block754);
  block_savedest(block754);
  Object closure755 = createclosure(2, "_apply");
setclosureframe(closure755, stackframe);
  addtoclosure(closure755, var_spc);
  addtoclosure(closure755, selfslot);
  struct UserObject *uo755 = (struct UserObject*)block754;
  uo755->data[0] = (Object)closure755;
  Method *meth_meth_ast__apply755 = addmethod2pos(block754, "_apply", &meth_ast__apply755, 0);
int argcv_meth_ast__apply755[] = {1};
meth_meth_ast__apply755->type = alloc_MethodType(1, argcv_meth_ast__apply755);
  meth_meth_ast__apply755->definitionModule = modulename;
  meth_meth_ast__apply755->definitionLine = 165;
// compilenode returning block754
  gc_frame_newslot(block754);
  params[0] = opresult753;
  params[1] = block754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call762 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe745);
// compilenode returning call762
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit764 == NULL) {
    strlit764 = alloc_String(") then {");
    gc_root(strlit764);
  }
// compilenode returning strlit764
  int op_slot_right_763 = gc_frame_newslot(strlit764);
  int callframe767 = gc_frame_new();
  Object num768 = alloc_Float64(0);
// compilenode returning num768
  gc_frame_newslot(num768);
  int callframe769 = gc_frame_new();
  partcv[0] = 0;
  Object call770 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe769);
// compilenode returning call770
// compilenode returning call770
  params[0] = num768;
  partcv[0] = 1;
  Object call771 = callmethod(call770, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe767);
// compilenode returning call771
  int op_slot_right_766 = gc_frame_newslot(call771);
  if (strlit773 == NULL) {
    strlit773 = alloc_String("if (");
    gc_root(strlit773);
  }
// compilenode returning strlit773
  int op_slot_left_766 = gc_frame_newslot(strlit773);
  params[0] = call771;
  partcv[0] = 1;
  Object opresult774 = callmethod(strlit773, "++", 1, partcv, params);
// compilenode returning opresult774
  int op_slot_left_763 = gc_frame_newslot(opresult774);
  params[0] = strlit764;
  partcv[0] = 1;
  Object opresult775 = callmethod(opresult774, "++", 1, partcv, params);
// compilenode returning opresult775
  *var_s = opresult775;
  if (opresult775 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe776 = gc_frame_new();
  int callframe777 = gc_frame_new();
  partcv[0] = 0;
  Object call778 = callmethodflags(self, "thenblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe777);
// compilenode returning call778
// compilenode returning call778
  gc_frame_newslot(call778);
  Object block779 = alloc_Block(NULL, NULL, "ast", 176);
  gc_frame_newslot(block779);
  block_savedest(block779);
  Object closure780 = createclosure(4, "_apply");
setclosureframe(closure780, stackframe);
  addtoclosure(closure780, var_depth);
  addtoclosure(closure780, var_spc);
  addtoclosure(closure780, var_s);
  addtoclosure(closure780, selfslot);
  struct UserObject *uo780 = (struct UserObject*)block779;
  uo780->data[0] = (Object)closure780;
  Method *meth_meth_ast__apply780 = addmethod2pos(block779, "_apply", &meth_ast__apply780, 0);
int argcv_meth_ast__apply780[] = {1};
meth_meth_ast__apply780->type = alloc_MethodType(1, argcv_meth_ast__apply780);
  meth_meth_ast__apply780->definitionModule = modulename;
  meth_meth_ast__apply780->definitionLine = 176;
// compilenode returning block779
  gc_frame_newslot(block779);
  params[0] = call778;
  params[1] = block779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call803 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe776);
// compilenode returning call803
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num806 = alloc_Float64(0);
// compilenode returning num806
  int op_slot_right_805 = gc_frame_newslot(num806);
  int callframe808 = gc_frame_new();
  int callframe809 = gc_frame_new();
  partcv[0] = 0;
  Object call810 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe809);
// compilenode returning call810
// compilenode returning call810
  partcv[0] = 0;
  Object call811 = callmethod(call810, "size",
    1, partcv, params);
  gc_frame_end(callframe808);
// compilenode returning call811
// compilenode returning call811
  int op_slot_left_805 = gc_frame_newslot(call811);
  params[0] = num806;
  partcv[0] = 1;
  Object opresult812 = callmethod(call811, ">", 1, partcv, params);
// compilenode returning opresult812
  Object if804 = done;
  if (istrue(opresult812)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit814 == NULL) {
    strlit814 = alloc_String("} else {");
    gc_root(strlit814);
  }
// compilenode returning strlit814
  int op_slot_right_813 = gc_frame_newslot(strlit814);
// compilenode returning *var_spc
  int op_slot_right_816 = gc_frame_newslot(*var_spc);
  if (strlit819 == NULL) {
    strlit819 = alloc_String("""\x0a""");
    gc_root(strlit819);
  }
// compilenode returning strlit819
  int op_slot_right_818 = gc_frame_newslot(strlit819);
// compilenode returning *var_s
  int op_slot_left_818 = gc_frame_newslot(*var_s);
  params[0] = strlit819;
  partcv[0] = 1;
  Object opresult821 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult821
  int op_slot_left_816 = gc_frame_newslot(opresult821);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult822 = callmethod(opresult821, "++", 1, partcv, params);
// compilenode returning opresult822
  int op_slot_left_813 = gc_frame_newslot(opresult822);
  params[0] = strlit814;
  partcv[0] = 1;
  Object opresult823 = callmethod(opresult822, "++", 1, partcv, params);
// compilenode returning opresult823
  *var_s = opresult823;
  if (opresult823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe825 = gc_frame_new();
  int callframe826 = gc_frame_new();
  partcv[0] = 0;
  Object call827 = callmethodflags(self, "elseblock", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe826);
// compilenode returning call827
// compilenode returning call827
  gc_frame_newslot(call827);
  Object block828 = alloc_Block(NULL, NULL, "ast", 181);
  gc_frame_newslot(block828);
  block_savedest(block828);
  Object closure829 = createclosure(4, "_apply");
setclosureframe(closure829, stackframe);
  addtoclosure(closure829, var_depth);
  addtoclosure(closure829, var_spc);
  addtoclosure(closure829, var_s);
  addtoclosure(closure829, selfslot);
  struct UserObject *uo829 = (struct UserObject*)block828;
  uo829->data[0] = (Object)closure829;
  Method *meth_meth_ast__apply829 = addmethod2pos(block828, "_apply", &meth_ast__apply829, 0);
int argcv_meth_ast__apply829[] = {1};
meth_meth_ast__apply829->type = alloc_MethodType(1, argcv_meth_ast__apply829);
  meth_meth_ast__apply829->definitionModule = modulename;
  meth_meth_ast__apply829->definitionLine = 181;
// compilenode returning block828
  gc_frame_newslot(block828);
  params[0] = call827;
  params[1] = block828;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call852 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe825);
// compilenode returning call852
    gc_frame_newslot(call852);
    if804 = call852;
  } else {
  }
// compilenode returning if804
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit854 == NULL) {
    strlit854 = alloc_String("}");
    gc_root(strlit854);
  }
// compilenode returning strlit854
  int op_slot_right_853 = gc_frame_newslot(strlit854);
// compilenode returning *var_spc
  int op_slot_right_856 = gc_frame_newslot(*var_spc);
  if (strlit859 == NULL) {
    strlit859 = alloc_String("""\x0a""");
    gc_root(strlit859);
  }
// compilenode returning strlit859
  int op_slot_right_858 = gc_frame_newslot(strlit859);
// compilenode returning *var_s
  int op_slot_left_858 = gc_frame_newslot(*var_s);
  params[0] = strlit859;
  partcv[0] = 1;
  Object opresult861 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult861
  int op_slot_left_856 = gc_frame_newslot(opresult861);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult862 = callmethod(opresult861, "++", 1, partcv, params);
// compilenode returning opresult862
  int op_slot_left_853 = gc_frame_newslot(opresult862);
  params[0] = strlit854;
  partcv[0] = 1;
  Object opresult863 = callmethod(opresult862, "++", 1, partcv, params);
// compilenode returning opresult863
  *var_s = opresult863;
  if (opresult863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_ifNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(12,12, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_ast_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "kind",&reader_ast_kind_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 120;
}
adddatum2(obj557, alloc_Undefined(), 1);
if (objclass557 == NULL) {
  Method *reader560 = addmethodrealflags(obj557, "value",&reader_ast_value_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 121;
}
adddatum2(obj557, alloc_Undefined(), 2);
if (objclass557 == NULL) {
  Method *reader561 = addmethodrealflags(obj557, "thenblock",&reader_ast_thenblock_561, MFLAG_DEF);
  reader561->definitionModule = modulename;
  reader561->definitionLine = 122;
}
adddatum2(obj557, alloc_Undefined(), 3);
if (objclass557 == NULL) {
  Method *reader562 = addmethodrealflags(obj557, "elseblock",&reader_ast_elseblock_562, MFLAG_DEF);
  reader562->definitionModule = modulename;
  reader562->definitionLine = 123;
}
adddatum2(obj557, alloc_Undefined(), 4);
if (objclass557 == NULL) {
  Method *reader563 = addmethodrealflags(obj557, "handledIdentifiers",&reader_ast_handledIdentifiers_563, 0);
  Method *writer563 = addmethodrealflags(obj557, "handledIdentifiers:=",&writer_ast_handledIdentifiers_563, 0);
  reader563->definitionModule = modulename;
  writer563->definitionModule = modulename;
  reader563->definitionLine = 124;
  writer563->definitionLine = 124;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 5);
  struct UserObject *uo564 = (struct UserObject*)obj557;
  uo564->data[6] = emptyclosure;
  Method *meth_meth_ast_accept564 = addmethod2pos(obj557, "accept", &meth_ast_accept564, 6);
int argcv_meth_ast_accept564[] = {1};
meth_meth_ast_accept564->type = alloc_MethodType(1, argcv_meth_ast_accept564);
meth_meth_ast_accept564->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept564->type->names[0] = "visitor";
  meth_meth_ast_accept564->definitionModule = modulename;
  meth_meth_ast_accept564->definitionLine = 124;
  block_savedest(obj557);
  Object closure590 = createclosure(1, "map()before()after");
setclosureframe(closure590, stackframe);
  addtoclosure(closure590, var_ifNode);
  struct UserObject *uo590 = (struct UserObject*)obj557;
  uo590->data[7] = (Object)closure590;
  Method *meth_meth_ast_map_40__41_before_40__41_after590 = addmethod2pos(obj557, "map()before()after", &meth_ast_map_40__41_before_40__41_after590, 7);
int argcv_meth_ast_map_40__41_before_40__41_after590[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after590->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after590);
  meth_meth_ast_map_40__41_before_40__41_after590->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after590->definitionLine = 135;
  struct UserObject *uo628 = (struct UserObject*)obj557;
  uo628->data[8] = emptyclosure;
  Method *meth_meth_ast_map628 = addmethod2pos(obj557, "map", &meth_ast_map628, 8);
int argcv_meth_ast_map628[] = {1};
meth_meth_ast_map628->type = alloc_MethodType(1, argcv_meth_ast_map628);
  meth_meth_ast_map628->definitionModule = modulename;
  meth_meth_ast_map628->definitionLine = 148;
  struct UserObject *uo637 = (struct UserObject*)obj557;
  uo637->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty637 = addmethod2pos(obj557, "pretty", &meth_ast_pretty637, 9);
int argcv_meth_ast_pretty637[] = {1};
meth_meth_ast_pretty637->type = alloc_MethodType(1, argcv_meth_ast_pretty637);
  meth_meth_ast_pretty637->definitionModule = modulename;
  meth_meth_ast_pretty637->definitionLine = 151;
  struct UserObject *uo743 = (struct UserObject*)obj557;
  uo743->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace743 = addmethod2pos(obj557, "toGrace", &meth_ast_toGrace743, 10);
int argcv_meth_ast_toGrace743[] = {1};
meth_meth_ast_toGrace743->type = alloc_MethodType(1, argcv_meth_ast_toGrace743);
meth_meth_ast_toGrace743->type->types[0] = type_Number;
meth_meth_ast_toGrace743->type->names[0] = "depth";
  meth_meth_ast_toGrace743->definitionModule = modulename;
  meth_meth_ast_toGrace743->definitionLine = 170;
  sourceObject = obj557;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe865 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call866 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe865);
// compilenode returning call866
  struct UserObject *obj557_uo = (struct UserObject *)obj557;
  obj557_uo->super = call866;
  sourceObject = obj557;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit867 == NULL) {
    strlit867 = alloc_String("if");
    gc_root(strlit867);
  }
// compilenode returning strlit867
  adddatum2(obj557, strlit867, 1);
  sourceObject = obj557;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj557, *var_cond, 2);
  sourceObject = obj557;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_thenblock_39_
  adddatum2(obj557, *var_thenblock_39_, 3);
  sourceObject = obj557;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elseblock_39_
  adddatum2(obj557, *var_elseblock_39_, 4);
  sourceObject = obj557;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool868 = alloc_Boolean(0);
// compilenode returning bool868
  adddatum2(obj557, bool868, 5);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_ast_new556_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_ifNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cond = &(stackframe->slots[0]);
  *var_cond = args[curarg];
  curarg++;
  Object *var_thenblock_39_ = &(stackframe->slots[1]);
  *var_thenblock_39_ = args[curarg];
  curarg++;
  Object *var_elseblock_39_ = &(stackframe->slots[2]);
  *var_elseblock_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject557 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj557 = alloc_userobj2(12,12, objclass557);
  gc_frame_newslot(obj557);
if (objclass557 == NULL) {
  glfree(obj557->class->name);
  obj557->class->name = "ifNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj557, self, 0);
  addmethodreal(obj557,"outer", &reader_ast_outer_558);
  Object oldself557 = self;
  struct StackFrameObject *oldstackframe557 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe557);
  gc_frame_newslot((Object)stackframe);
  self = obj557;
  Object *oldselfslot557 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter557 = (*(struct UserObject *)self).data[0], lowerouter557 = thisouter557;
  if (inheritingObject557) {
    struct UserObject *inho557 = (struct UserObject *)inheritingObject557;
    while (inho557->super != GraceDefaultObject) inho557 = (struct UserObject *)inho557->super;
    inho557->super = obj557;
    self = inheritingObject557;
    *selfslot = self;
    lowerouter557 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter557;
  }
if (objclass557 == NULL) {
  Method *reader559 = addmethodrealflags(obj557, "kind",&reader_ast_kind_559, MFLAG_DEF);
  reader559->definitionModule = modulename;
  reader559->definitionLine = 120;
}
adddatum2(obj557, alloc_Undefined(), 1);
if (objclass557 == NULL) {
  Method *reader560 = addmethodrealflags(obj557, "value",&reader_ast_value_560, MFLAG_DEF);
  reader560->definitionModule = modulename;
  reader560->definitionLine = 121;
}
adddatum2(obj557, alloc_Undefined(), 2);
if (objclass557 == NULL) {
  Method *reader561 = addmethodrealflags(obj557, "thenblock",&reader_ast_thenblock_561, MFLAG_DEF);
  reader561->definitionModule = modulename;
  reader561->definitionLine = 122;
}
adddatum2(obj557, alloc_Undefined(), 3);
if (objclass557 == NULL) {
  Method *reader562 = addmethodrealflags(obj557, "elseblock",&reader_ast_elseblock_562, MFLAG_DEF);
  reader562->definitionModule = modulename;
  reader562->definitionLine = 123;
}
adddatum2(obj557, alloc_Undefined(), 4);
if (objclass557 == NULL) {
  Method *reader563 = addmethodrealflags(obj557, "handledIdentifiers",&reader_ast_handledIdentifiers_563, 0);
  Method *writer563 = addmethodrealflags(obj557, "handledIdentifiers:=",&writer_ast_handledIdentifiers_563, 0);
  reader563->definitionModule = modulename;
  writer563->definitionModule = modulename;
  reader563->definitionLine = 124;
  writer563->definitionLine = 124;
}
obj557->flags |= OFLAG_MUTABLE;
adddatum2(obj557, alloc_Undefined(), 5);
  struct UserObject *uo564 = (struct UserObject*)obj557;
  uo564->data[6] = emptyclosure;
  Method *meth_meth_ast_accept564 = addmethod2pos(obj557, "accept", &meth_ast_accept564, 6);
int argcv_meth_ast_accept564[] = {1};
meth_meth_ast_accept564->type = alloc_MethodType(1, argcv_meth_ast_accept564);
meth_meth_ast_accept564->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept564->type->names[0] = "visitor";
  meth_meth_ast_accept564->definitionModule = modulename;
  meth_meth_ast_accept564->definitionLine = 124;
  block_savedest(obj557);
  Object closure590 = createclosure(1, "map()before()after");
setclosureframe(closure590, stackframe);
  addtoclosure(closure590, var_ifNode);
  struct UserObject *uo590 = (struct UserObject*)obj557;
  uo590->data[7] = (Object)closure590;
  Method *meth_meth_ast_map_40__41_before_40__41_after590 = addmethod2pos(obj557, "map()before()after", &meth_ast_map_40__41_before_40__41_after590, 7);
int argcv_meth_ast_map_40__41_before_40__41_after590[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after590->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after590);
  meth_meth_ast_map_40__41_before_40__41_after590->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after590->definitionLine = 135;
  struct UserObject *uo628 = (struct UserObject*)obj557;
  uo628->data[8] = emptyclosure;
  Method *meth_meth_ast_map628 = addmethod2pos(obj557, "map", &meth_ast_map628, 8);
int argcv_meth_ast_map628[] = {1};
meth_meth_ast_map628->type = alloc_MethodType(1, argcv_meth_ast_map628);
  meth_meth_ast_map628->definitionModule = modulename;
  meth_meth_ast_map628->definitionLine = 148;
  struct UserObject *uo637 = (struct UserObject*)obj557;
  uo637->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty637 = addmethod2pos(obj557, "pretty", &meth_ast_pretty637, 9);
int argcv_meth_ast_pretty637[] = {1};
meth_meth_ast_pretty637->type = alloc_MethodType(1, argcv_meth_ast_pretty637);
  meth_meth_ast_pretty637->definitionModule = modulename;
  meth_meth_ast_pretty637->definitionLine = 151;
  struct UserObject *uo743 = (struct UserObject*)obj557;
  uo743->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace743 = addmethod2pos(obj557, "toGrace", &meth_ast_toGrace743, 10);
int argcv_meth_ast_toGrace743[] = {1};
meth_meth_ast_toGrace743->type = alloc_MethodType(1, argcv_meth_ast_toGrace743);
meth_meth_ast_toGrace743->type->types[0] = type_Number;
meth_meth_ast_toGrace743->type->names[0] = "depth";
  meth_meth_ast_toGrace743->definitionModule = modulename;
  meth_meth_ast_toGrace743->definitionLine = 170;
  sourceObject = obj557;
// Begin line 118
  setline(118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe865 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call866 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe865);
// compilenode returning call866
  struct UserObject *obj557_uo = (struct UserObject *)obj557;
  obj557_uo->super = call866;
  sourceObject = obj557;
// Begin line 119
  setline(119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit867 == NULL) {
    strlit867 = alloc_String("if");
    gc_root(strlit867);
  }
// compilenode returning strlit867
  adddatum2(obj557, strlit867, 1);
  sourceObject = obj557;
// Begin line 120
  setline(120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cond
  adddatum2(obj557, *var_cond, 2);
  sourceObject = obj557;
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_thenblock_39_
  adddatum2(obj557, *var_thenblock_39_, 3);
  sourceObject = obj557;
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elseblock_39_
  adddatum2(obj557, *var_elseblock_39_, 4);
  sourceObject = obj557;
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool868 = alloc_Boolean(0);
// compilenode returning bool868
  adddatum2(obj557, bool868, 5);
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
  sourceObject = obj557;
objclass557 = obj557->class;
  objclass557->definitionModule = modulename;
  objclass557->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter557;
  self = oldself557;
  selfslot = oldselfslot557;
  stackframe = oldstackframe557;
  gc_frame_end(frame);
  return obj557;
}
Object meth_ast_blockNode870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blockNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blockNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for blockNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blockNode
  gc_frame_end(frame);
  return *var_blockNode;
}
Object meth_ast__apply891(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe892 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call893 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe892);
// compilenode returning call893
  gc_frame_end(frame);
  return call893;
}
Object meth_ast__apply900(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe901 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call902 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe901);
// compilenode returning call902
  gc_frame_end(frame);
  return call902;
}
Object meth_ast_accept883(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe885 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call886 = callmethod(*var_visitor, "visitBlock",
    1, partcv, params);
  gc_frame_end(callframe885);
// compilenode returning call886
  Object if884 = done;
  if (istrue(call886)) {
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe887 = gc_frame_new();
  int callframe888 = gc_frame_new();
  partcv[0] = 0;
  Object call889 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe888);
// compilenode returning call889
// compilenode returning call889
  gc_frame_newslot(call889);
  Object block890 = alloc_Block(NULL, NULL, "ast", 203);
  gc_frame_newslot(block890);
  block_savedest(block890);
  Object closure891 = createclosure(2, "_apply");
setclosureframe(closure891, stackframe);
  addtoclosure(closure891, var_visitor);
  addtoclosure(closure891, selfslot);
  struct UserObject *uo891 = (struct UserObject*)block890;
  uo891->data[0] = (Object)closure891;
  Method *meth_meth_ast__apply891 = addmethod2pos(block890, "_apply", &meth_ast__apply891, 0);
int argcv_meth_ast__apply891[] = {1};
meth_meth_ast__apply891->type = alloc_MethodType(1, argcv_meth_ast__apply891);
  meth_meth_ast__apply891->definitionModule = modulename;
  meth_meth_ast__apply891->definitionLine = 203;
// compilenode returning block890
  gc_frame_newslot(block890);
  params[0] = call889;
  params[1] = block890;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call895 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe887);
// compilenode returning call895
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe896 = gc_frame_new();
  int callframe897 = gc_frame_new();
  partcv[0] = 0;
  Object call898 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe897);
// compilenode returning call898
// compilenode returning call898
  gc_frame_newslot(call898);
  Object block899 = alloc_Block(NULL, NULL, "ast", 206);
  gc_frame_newslot(block899);
  block_savedest(block899);
  Object closure900 = createclosure(2, "_apply");
setclosureframe(closure900, stackframe);
  addtoclosure(closure900, var_visitor);
  addtoclosure(closure900, selfslot);
  struct UserObject *uo900 = (struct UserObject*)block899;
  uo900->data[0] = (Object)closure900;
  Method *meth_meth_ast__apply900 = addmethod2pos(block899, "_apply", &meth_ast__apply900, 0);
int argcv_meth_ast__apply900[] = {1};
meth_meth_ast__apply900->type = alloc_MethodType(1, argcv_meth_ast__apply900);
  meth_meth_ast__apply900->definitionModule = modulename;
  meth_meth_ast__apply900->definitionLine = 206;
// compilenode returning block899
  gc_frame_newslot(block899);
  params[0] = call898;
  params[1] = block899;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call904 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe896);
// compilenode returning call904
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool907 = alloc_Boolean(0);
// compilenode returning bool907
  int op_slot_right_906 = gc_frame_newslot(bool907);
  int callframe909 = gc_frame_new();
  partcv[0] = 0;
  Object call910 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe909);
// compilenode returning call910
// compilenode returning call910
  int op_slot_left_906 = gc_frame_newslot(call910);
  params[0] = bool907;
  partcv[0] = 1;
  Object opresult911 = callmethod(call910, "!=", 1, partcv, params);
// compilenode returning opresult911
  Object if905 = done;
  if (istrue(opresult911)) {
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe912 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe913 = gc_frame_new();
  partcv[0] = 0;
  Object call914 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe913);
// compilenode returning call914
// compilenode returning call914
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call915 = callmethod(call914, "accept",
    1, partcv, params);
  gc_frame_end(callframe912);
// compilenode returning call915
    gc_frame_newslot(call915);
    if905 = call915;
  } else {
  }
// compilenode returning if905
    gc_frame_newslot(if905);
    if884 = if905;
  } else {
  }
// compilenode returning if884
  gc_frame_end(frame);
  return if884;
}
Object meth_ast_map_40__41_before_40__41_after916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_blockNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe917 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call918 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe917);
// compilenode returning call918
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe919 = gc_frame_new();
  int callframe920 = gc_frame_new();
  int callframe921 = gc_frame_new();
  partcv[0] = 0;
  Object call922 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe921);
// compilenode returning call922
  gc_frame_newslot(call922);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe923 = gc_frame_new();
  int callframe924 = gc_frame_new();
  Object call925 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe924);
// compilenode returning call925
// compilenode returning call925
  partcv[0] = 0;
  Object call926 = callmethodflags(call925, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe923);
// compilenode returning call926
// compilenode returning call926
  params[0] = call922;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call927 = callmethodflags(call926, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compilenode returning call927
  gc_frame_newslot(call927);
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe928 = gc_frame_new();
  int callframe929 = gc_frame_new();
  partcv[0] = 0;
  Object call930 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe929);
// compilenode returning call930
  gc_frame_newslot(call930);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe931 = gc_frame_new();
  int callframe932 = gc_frame_new();
  Object call933 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe932);
// compilenode returning call933
// compilenode returning call933
  partcv[0] = 0;
  Object call934 = callmethodflags(call933, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe931);
// compilenode returning call934
// compilenode returning call934
  params[0] = call930;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call935 = callmethodflags(call934, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe928);
// compilenode returning call935
  gc_frame_newslot(call935);
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blockNode
  params[0] = call927;
  params[1] = call935;
  partcv[0] = 2;
  Object call936 = callmethod(*var_blockNode, "new",
    1, partcv, params);
  gc_frame_end(callframe919);
// compilenode returning call936
  *var_n = call936;
  if (call936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool939 = alloc_Boolean(0);
// compilenode returning bool939
  int op_slot_right_938 = gc_frame_newslot(bool939);
  int callframe941 = gc_frame_new();
  partcv[0] = 0;
  Object call942 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe941);
// compilenode returning call942
// compilenode returning call942
  int op_slot_left_938 = gc_frame_newslot(call942);
  params[0] = bool939;
  partcv[0] = 1;
  Object opresult943 = callmethod(call942, "!=", 1, partcv, params);
// compilenode returning opresult943
  Object if937 = done;
  if (istrue(opresult943)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe944 = gc_frame_new();
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe945 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe946 = gc_frame_new();
  partcv[0] = 0;
  Object call947 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe946);
// compilenode returning call947
// compilenode returning call947
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call948 = callmethod(call947, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe945);
// compilenode returning call948
  gc_frame_newslot(call948);
// compilenode returning *var_n
  params[0] = call948;
  partcv[0] = 1;
  Object call949 = callmethod(*var_n, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe944);
// compilenode returning call949
// compilenode returning done
    gc_frame_newslot(done);
    if937 = done;
  } else {
  }
// compilenode returning if937
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe950 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call951 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe950);
// compilenode returning call951
  *var_n = call951;
  if (call951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe953 = gc_frame_new();
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe954 = gc_frame_new();
  partcv[0] = 0;
  Object call955 = callmethodflags(self, "extraRuntimeData", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe954);
// compilenode returning call955
  gc_frame_newslot(call955);
// compilenode returning *var_n
  params[0] = call955;
  partcv[0] = 1;
  Object call956 = callmethod(*var_n, "extraRuntimeData:=",
    1, partcv, params);
  gc_frame_end(callframe953);
// compilenode returning call956
// compilenode returning done
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe957 = gc_frame_new();
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe958 = gc_frame_new();
  partcv[0] = 0;
  Object call959 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe958);
// compilenode returning call959
  gc_frame_newslot(call959);
// compilenode returning *var_n
  params[0] = call959;
  partcv[0] = 1;
  Object call960 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe957);
// compilenode returning call960
// compilenode returning done
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe961 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call962 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe961);
// compilenode returning call962
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply966(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply969(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe964 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block965 = alloc_Block(NULL, NULL, "ast", 229);
  gc_frame_newslot(block965);
  block_savedest(block965);
  Object closure966 = createclosure(1, "_apply");
setclosureframe(closure966, stackframe);
  addtoclosure(closure966, selfslot);
  struct UserObject *uo966 = (struct UserObject*)block965;
  uo966->data[0] = (Object)closure966;
  Method *meth_meth_ast__apply966 = addmethod2pos(block965, "_apply", &meth_ast__apply966, 0);
int argcv_meth_ast__apply966[] = {0};
meth_meth_ast__apply966->type = alloc_MethodType(1, argcv_meth_ast__apply966);
  meth_meth_ast__apply966->definitionModule = modulename;
  meth_meth_ast__apply966->definitionLine = 219;
// compilenode returning block965
  gc_frame_newslot(block965);
  Object block968 = alloc_Block(NULL, NULL, "ast", 229);
  gc_frame_newslot(block968);
  block_savedest(block968);
  Object closure969 = createclosure(1, "_apply");
setclosureframe(closure969, stackframe);
  addtoclosure(closure969, selfslot);
  struct UserObject *uo969 = (struct UserObject*)block968;
  uo969->data[0] = (Object)closure969;
  Method *meth_meth_ast__apply969 = addmethod2pos(block968, "_apply", &meth_ast__apply969, 0);
int argcv_meth_ast__apply969[] = {0};
meth_meth_ast__apply969->type = alloc_MethodType(1, argcv_meth_ast__apply969);
  meth_meth_ast__apply969->definitionModule = modulename;
  meth_meth_ast__apply969->definitionLine = 219;
// compilenode returning block968
  gc_frame_newslot(block968);
  params[0] = *var_blk;
  params[1] = block965;
  params[2] = block968;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call971 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe964);
// compilenode returning call971
  gc_frame_end(frame);
  return call971;
}
Object meth_ast__apply980(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 235
  setline(235);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit982 == NULL) {
    strlit982 = alloc_String("  ");
    gc_root(strlit982);
  }
// compilenode returning strlit982
  int op_slot_right_981 = gc_frame_newslot(strlit982);
// compilenode returning *var_spc
  int op_slot_left_981 = gc_frame_newslot(*var_spc);
  params[0] = strlit982;
  partcv[0] = 1;
  Object opresult984 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult984
  *var_spc = opresult984;
  if (opresult984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1003 = gc_frame_new();
  Object num1005 = alloc_Float64(2);
// compilenode returning num1005
  int op_slot_right_1004 = gc_frame_newslot(num1005);
// compilenode returning *var_depth
  int op_slot_left_1004 = gc_frame_newslot(*var_depth);
  params[0] = num1005;
  partcv[0] = 1;
  Object sum1007 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1007
  gc_frame_newslot(sum1007);
// compilenode returning *var_mx
  params[0] = sum1007;
  partcv[0] = 1;
  Object call1008 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compilenode returning call1008
  int op_slot_right_1002 = gc_frame_newslot(call1008);
// compilenode returning *var_spc
  int op_slot_right_1010 = gc_frame_newslot(*var_spc);
  if (strlit1013 == NULL) {
    strlit1013 = alloc_String("""\x0a""  ");
    gc_root(strlit1013);
  }
// compilenode returning strlit1013
  int op_slot_right_1012 = gc_frame_newslot(strlit1013);
// compilenode returning *var_s
  int op_slot_left_1012 = gc_frame_newslot(*var_s);
  params[0] = strlit1013;
  partcv[0] = 1;
  Object opresult1015 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1015
  int op_slot_left_1010 = gc_frame_newslot(opresult1015);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1016 = callmethod(opresult1015, "++", 1, partcv, params);
// compilenode returning opresult1016
  int op_slot_left_1002 = gc_frame_newslot(opresult1016);
  params[0] = call1008;
  partcv[0] = 1;
  Object opresult1017 = callmethod(opresult1016, "++", 1, partcv, params);
// compilenode returning opresult1017
  *var_s = opresult1017;
  if (opresult1017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1038(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1040 = gc_frame_new();
  Object num1042 = alloc_Float64(2);
// compilenode returning num1042
  int op_slot_right_1041 = gc_frame_newslot(num1042);
// compilenode returning *var_depth
  int op_slot_left_1041 = gc_frame_newslot(*var_depth);
  params[0] = num1042;
  partcv[0] = 1;
  Object sum1044 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1044
  gc_frame_newslot(sum1044);
// compilenode returning *var_mx
  params[0] = sum1044;
  partcv[0] = 1;
  Object call1045 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1040);
// compilenode returning call1045
  int op_slot_right_1039 = gc_frame_newslot(call1045);
// compilenode returning *var_spc
  int op_slot_right_1047 = gc_frame_newslot(*var_spc);
  if (strlit1050 == NULL) {
    strlit1050 = alloc_String("""\x0a""  ");
    gc_root(strlit1050);
  }
// compilenode returning strlit1050
  int op_slot_right_1049 = gc_frame_newslot(strlit1050);
// compilenode returning *var_s
  int op_slot_left_1049 = gc_frame_newslot(*var_s);
  params[0] = strlit1050;
  partcv[0] = 1;
  Object opresult1052 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1052
  int op_slot_left_1047 = gc_frame_newslot(opresult1052);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1053 = callmethod(opresult1052, "++", 1, partcv, params);
// compilenode returning opresult1053
  int op_slot_left_1039 = gc_frame_newslot(opresult1053);
  params[0] = call1045;
  partcv[0] = 1;
  Object opresult1054 = callmethod(opresult1053, "++", 1, partcv, params);
// compilenode returning opresult1054
  *var_s = opresult1054;
  if (opresult1054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty972(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit973 == NULL) {
    strlit973 = alloc_String("");
    gc_root(strlit973);
  }
// compilenode returning strlit973
  *var_spc = strlit973;
  if (strlit973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe974 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_975 = gc_frame_newslot(*var_depth);
  Object num977 = alloc_Float64(0);
// compilenode returning num977
  int op_slot_left_975 = gc_frame_newslot(num977);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult978 = callmethod(num977, "..", 1, partcv, params);
// compilenode returning opresult978
  gc_frame_newslot(opresult978);
  Object block979 = alloc_Block(NULL, NULL, "ast", 233);
  gc_frame_newslot(block979);
  block_savedest(block979);
  Object closure980 = createclosure(2, "_apply");
setclosureframe(closure980, stackframe);
  addtoclosure(closure980, var_spc);
  addtoclosure(closure980, selfslot);
  struct UserObject *uo980 = (struct UserObject*)block979;
  uo980->data[0] = (Object)closure980;
  Method *meth_meth_ast__apply980 = addmethod2pos(block979, "_apply", &meth_ast__apply980, 0);
int argcv_meth_ast__apply980[] = {1};
meth_meth_ast__apply980->type = alloc_MethodType(1, argcv_meth_ast__apply980);
  meth_meth_ast__apply980->definitionModule = modulename;
  meth_meth_ast__apply980->definitionLine = 219;
// compilenode returning block979
  gc_frame_newslot(block979);
  params[0] = opresult978;
  params[1] = block979;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call987 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe974);
// compilenode returning call987
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit988 == NULL) {
    strlit988 = alloc_String("Block""\x0a""");
    gc_root(strlit988);
  }
// compilenode returning strlit988
  *var_s = strlit988;
  if (strlit988 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit990 == NULL) {
    strlit990 = alloc_String("Parameters:");
    gc_root(strlit990);
  }
// compilenode returning strlit990
  int op_slot_right_989 = gc_frame_newslot(strlit990);
// compilenode returning *var_spc
  int op_slot_right_992 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_992 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult994 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult994
  int op_slot_left_989 = gc_frame_newslot(opresult994);
  params[0] = strlit990;
  partcv[0] = 1;
  Object opresult995 = callmethod(opresult994, "++", 1, partcv, params);
// compilenode returning opresult995
  *var_s = opresult995;
  if (opresult995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe997 = gc_frame_new();
  int callframe998 = gc_frame_new();
  partcv[0] = 0;
  Object call999 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe998);
// compilenode returning call999
// compilenode returning call999
  gc_frame_newslot(call999);
  Object block1000 = alloc_Block(NULL, NULL, "ast", 238);
  gc_frame_newslot(block1000);
  block_savedest(block1000);
  Object closure1001 = createclosure(4, "_apply");
setclosureframe(closure1001, stackframe);
  addtoclosure(closure1001, var_depth);
  addtoclosure(closure1001, var_spc);
  addtoclosure(closure1001, var_s);
  addtoclosure(closure1001, selfslot);
  struct UserObject *uo1001 = (struct UserObject*)block1000;
  uo1001->data[0] = (Object)closure1001;
  Method *meth_meth_ast__apply1001 = addmethod2pos(block1000, "_apply", &meth_ast__apply1001, 0);
int argcv_meth_ast__apply1001[] = {1};
meth_meth_ast__apply1001->type = alloc_MethodType(1, argcv_meth_ast__apply1001);
  meth_meth_ast__apply1001->definitionModule = modulename;
  meth_meth_ast__apply1001->definitionLine = 238;
// compilenode returning block1000
  gc_frame_newslot(block1000);
  params[0] = call999;
  params[1] = block1000;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1020 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe997);
// compilenode returning call1020
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1022 == NULL) {
    strlit1022 = alloc_String("""\x0a""");
    gc_root(strlit1022);
  }
// compilenode returning strlit1022
  int op_slot_right_1021 = gc_frame_newslot(strlit1022);
// compilenode returning *var_s
  int op_slot_left_1021 = gc_frame_newslot(*var_s);
  params[0] = strlit1022;
  partcv[0] = 1;
  Object opresult1024 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1024
  *var_s = opresult1024;
  if (opresult1024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1027 == NULL) {
    strlit1027 = alloc_String("Body:");
    gc_root(strlit1027);
  }
// compilenode returning strlit1027
  int op_slot_right_1026 = gc_frame_newslot(strlit1027);
// compilenode returning *var_spc
  int op_slot_right_1029 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1029 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1031 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1031
  int op_slot_left_1026 = gc_frame_newslot(opresult1031);
  params[0] = strlit1027;
  partcv[0] = 1;
  Object opresult1032 = callmethod(opresult1031, "++", 1, partcv, params);
// compilenode returning opresult1032
  *var_s = opresult1032;
  if (opresult1032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1034 = gc_frame_new();
  int callframe1035 = gc_frame_new();
  partcv[0] = 0;
  Object call1036 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1035);
// compilenode returning call1036
// compilenode returning call1036
  gc_frame_newslot(call1036);
  Object block1037 = alloc_Block(NULL, NULL, "ast", 243);
  gc_frame_newslot(block1037);
  block_savedest(block1037);
  Object closure1038 = createclosure(4, "_apply");
setclosureframe(closure1038, stackframe);
  addtoclosure(closure1038, var_depth);
  addtoclosure(closure1038, var_spc);
  addtoclosure(closure1038, var_s);
  addtoclosure(closure1038, selfslot);
  struct UserObject *uo1038 = (struct UserObject*)block1037;
  uo1038->data[0] = (Object)closure1038;
  Method *meth_meth_ast__apply1038 = addmethod2pos(block1037, "_apply", &meth_ast__apply1038, 0);
int argcv_meth_ast__apply1038[] = {1};
meth_meth_ast__apply1038->type = alloc_MethodType(1, argcv_meth_ast__apply1038);
  meth_meth_ast__apply1038->definitionModule = modulename;
  meth_meth_ast__apply1038->definitionLine = 243;
// compilenode returning block1037
  gc_frame_newslot(block1037);
  params[0] = call1036;
  params[1] = block1037;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1057 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1034);
// compilenode returning call1057
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1060 = alloc_Boolean(0);
// compilenode returning bool1060
  int op_slot_right_1059 = gc_frame_newslot(bool1060);
  int callframe1062 = gc_frame_new();
  partcv[0] = 0;
  Object call1063 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1062);
// compilenode returning call1063
// compilenode returning call1063
  int op_slot_left_1059 = gc_frame_newslot(call1063);
  params[0] = bool1060;
  partcv[0] = 1;
  Object opresult1064 = callmethod(call1063, "!=", 1, partcv, params);
// compilenode returning opresult1064
  Object if1058 = done;
  if (istrue(opresult1064)) {
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1066 == NULL) {
    strlit1066 = alloc_String("""\x0a""");
    gc_root(strlit1066);
  }
// compilenode returning strlit1066
  int op_slot_right_1065 = gc_frame_newslot(strlit1066);
// compilenode returning *var_s
  int op_slot_left_1065 = gc_frame_newslot(*var_s);
  params[0] = strlit1066;
  partcv[0] = 1;
  Object opresult1068 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1068
  *var_s = opresult1068;
  if (opresult1068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1071 == NULL) {
    strlit1071 = alloc_String("Pattern:");
    gc_root(strlit1071);
  }
// compilenode returning strlit1071
  int op_slot_right_1070 = gc_frame_newslot(strlit1071);
// compilenode returning *var_spc
  int op_slot_right_1073 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1073 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1075 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1075
  int op_slot_left_1070 = gc_frame_newslot(opresult1075);
  params[0] = strlit1071;
  partcv[0] = 1;
  Object opresult1076 = callmethod(opresult1075, "++", 1, partcv, params);
// compilenode returning opresult1076
  *var_s = opresult1076;
  if (opresult1076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1079 = gc_frame_new();
  Object num1081 = alloc_Float64(2);
// compilenode returning num1081
  int op_slot_right_1080 = gc_frame_newslot(num1081);
// compilenode returning *var_depth
  int op_slot_left_1080 = gc_frame_newslot(*var_depth);
  params[0] = num1081;
  partcv[0] = 1;
  Object sum1083 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1083
  gc_frame_newslot(sum1083);
  int callframe1084 = gc_frame_new();
  partcv[0] = 0;
  Object call1085 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1084);
// compilenode returning call1085
// compilenode returning call1085
  params[0] = sum1083;
  partcv[0] = 1;
  Object call1086 = callmethod(call1085, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1079);
// compilenode returning call1086
  int op_slot_right_1078 = gc_frame_newslot(call1086);
// compilenode returning *var_spc
  int op_slot_right_1088 = gc_frame_newslot(*var_spc);
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("""\x0a""  ");
    gc_root(strlit1091);
  }
// compilenode returning strlit1091
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
// compilenode returning *var_s
  int op_slot_left_1090 = gc_frame_newslot(*var_s);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1093 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1093
  int op_slot_left_1088 = gc_frame_newslot(opresult1093);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1094 = callmethod(opresult1093, "++", 1, partcv, params);
// compilenode returning opresult1094
  int op_slot_left_1078 = gc_frame_newslot(opresult1094);
  params[0] = call1086;
  partcv[0] = 1;
  Object opresult1095 = callmethod(opresult1094, "++", 1, partcv, params);
// compilenode returning opresult1095
  *var_s = opresult1095;
  if (opresult1095 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1058 = done;
  } else {
  }
// compilenode returning if1058
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1109(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1111 == NULL) {
    strlit1111 = alloc_String("    ");
    gc_root(strlit1111);
  }
// compilenode returning strlit1111
  int op_slot_right_1110 = gc_frame_newslot(strlit1111);
// compilenode returning *var_spc
  int op_slot_left_1110 = gc_frame_newslot(*var_spc);
  params[0] = strlit1111;
  partcv[0] = 1;
  Object opresult1113 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1113
  *var_spc = opresult1113;
  if (opresult1113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1138(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1139 = gc_frame_new();
  partcv[0] = 0;
  Object call1140 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1139);
// compilenode returning call1140
// compilenode returning call1140
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres1141 = callmethod(call1140, "[]", 1, partcv, params);
// compilenode returning idxres1141
  *var_p = idxres1141;
  if (idxres1141 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1144 = alloc_Boolean(0);
// compilenode returning bool1144
  int op_slot_right_1143 = gc_frame_newslot(bool1144);
  int callframe1146 = gc_frame_new();
  partcv[0] = 0;
  Object call1147 = callmethodflags(self, "matchingPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1146);
// compilenode returning call1147
// compilenode returning call1147
  int op_slot_left_1143 = gc_frame_newslot(call1147);
  params[0] = bool1144;
  partcv[0] = 1;
  Object opresult1148 = callmethod(call1147, "!=", 1, partcv, params);
// compilenode returning opresult1148
  Object if1142 = done;
  if (istrue(opresult1148)) {
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1150 == NULL) {
    strlit1150 = alloc_String(")");
    gc_root(strlit1150);
  }
// compilenode returning strlit1150
  int op_slot_right_1149 = gc_frame_newslot(strlit1150);
  int callframe1153 = gc_frame_new();
  Object num1154 = alloc_Float64(0);
// compilenode returning num1154
  gc_frame_newslot(num1154);
// compilenode returning *var_p
  params[0] = num1154;
  partcv[0] = 1;
  Object call1155 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1153);
// compilenode returning call1155
  int op_slot_right_1152 = gc_frame_newslot(call1155);
  if (strlit1158 == NULL) {
    strlit1158 = alloc_String("(");
    gc_root(strlit1158);
  }
// compilenode returning strlit1158
  int op_slot_right_1157 = gc_frame_newslot(strlit1158);
// compilenode returning *var_s
  int op_slot_left_1157 = gc_frame_newslot(*var_s);
  params[0] = strlit1158;
  partcv[0] = 1;
  Object opresult1160 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1160
  int op_slot_left_1152 = gc_frame_newslot(opresult1160);
  params[0] = call1155;
  partcv[0] = 1;
  Object opresult1161 = callmethod(opresult1160, "++", 1, partcv, params);
// compilenode returning opresult1161
  int op_slot_left_1149 = gc_frame_newslot(opresult1161);
  params[0] = strlit1150;
  partcv[0] = 1;
  Object opresult1162 = callmethod(opresult1161, "++", 1, partcv, params);
// compilenode returning opresult1162
  *var_s = opresult1162;
  if (opresult1162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1142 = done;
  } else {
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1165 = gc_frame_new();
  Object num1166 = alloc_Float64(0);
// compilenode returning num1166
  gc_frame_newslot(num1166);
// compilenode returning *var_p
  params[0] = num1166;
  partcv[0] = 1;
  Object call1167 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1165);
// compilenode returning call1167
  int op_slot_right_1164 = gc_frame_newslot(call1167);
// compilenode returning *var_s
  int op_slot_left_1164 = gc_frame_newslot(*var_s);
  params[0] = call1167;
  partcv[0] = 1;
  Object opresult1169 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1169
  *var_s = opresult1169;
  if (opresult1169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1142 = done;
  }
// compilenode returning if1142
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1173 = gc_frame_new();
  int callframe1174 = gc_frame_new();
  partcv[0] = 0;
  Object call1175 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1174);
// compilenode returning call1175
// compilenode returning call1175
  partcv[0] = 0;
  Object call1176 = callmethod(call1175, "size",
    1, partcv, params);
  gc_frame_end(callframe1173);
// compilenode returning call1176
// compilenode returning call1176
  int op_slot_right_1172 = gc_frame_newslot(call1176);
// compilenode returning *var_i
  int op_slot_left_1172 = gc_frame_newslot(*var_i);
  params[0] = call1176;
  partcv[0] = 1;
  Object opresult1178 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult1178
  Object if1171 = done;
  if (istrue(opresult1178)) {
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1180 == NULL) {
    strlit1180 = alloc_String(", ");
    gc_root(strlit1180);
  }
// compilenode returning strlit1180
  int op_slot_right_1179 = gc_frame_newslot(strlit1180);
// compilenode returning *var_s
  int op_slot_left_1179 = gc_frame_newslot(*var_s);
  params[0] = strlit1180;
  partcv[0] = 1;
  Object opresult1182 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1182
  *var_s = opresult1182;
  if (opresult1182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1171 = done;
  } else {
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1185 == NULL) {
    strlit1185 = alloc_String(" ->");
    gc_root(strlit1185);
  }
// compilenode returning strlit1185
  int op_slot_right_1184 = gc_frame_newslot(strlit1185);
// compilenode returning *var_s
  int op_slot_left_1184 = gc_frame_newslot(*var_s);
  params[0] = strlit1185;
  partcv[0] = 1;
  Object opresult1187 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1187
  *var_s = opresult1187;
  if (opresult1187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1171 = done;
  }
// compilenode returning if1171
  gc_frame_end(frame);
  return if1171;
}
Object meth_ast__apply1195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 276
  setline(276);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1197 = gc_frame_new();
  Object num1199 = alloc_Float64(1);
// compilenode returning num1199
  int op_slot_right_1198 = gc_frame_newslot(num1199);
// compilenode returning *var_depth
  int op_slot_left_1198 = gc_frame_newslot(*var_depth);
  params[0] = num1199;
  partcv[0] = 1;
  Object sum1201 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1201
  gc_frame_newslot(sum1201);
// compilenode returning *var_mx
  params[0] = sum1201;
  partcv[0] = 1;
  Object call1202 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1197);
// compilenode returning call1202
  int op_slot_right_1196 = gc_frame_newslot(call1202);
  if (strlit1205 == NULL) {
    strlit1205 = alloc_String("    ");
    gc_root(strlit1205);
  }
// compilenode returning strlit1205
  int op_slot_right_1204 = gc_frame_newslot(strlit1205);
// compilenode returning *var_spc
  int op_slot_right_1207 = gc_frame_newslot(*var_spc);
  if (strlit1210 == NULL) {
    strlit1210 = alloc_String("""\x0a""");
    gc_root(strlit1210);
  }
// compilenode returning strlit1210
  int op_slot_right_1209 = gc_frame_newslot(strlit1210);
// compilenode returning *var_s
  int op_slot_left_1209 = gc_frame_newslot(*var_s);
  params[0] = strlit1210;
  partcv[0] = 1;
  Object opresult1212 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1212
  int op_slot_left_1207 = gc_frame_newslot(opresult1212);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1213 = callmethod(opresult1212, "++", 1, partcv, params);
// compilenode returning opresult1213
  int op_slot_left_1204 = gc_frame_newslot(opresult1213);
  params[0] = strlit1205;
  partcv[0] = 1;
  Object opresult1214 = callmethod(opresult1213, "++", 1, partcv, params);
// compilenode returning opresult1214
  int op_slot_left_1196 = gc_frame_newslot(opresult1214);
  params[0] = call1202;
  partcv[0] = 1;
  Object opresult1215 = callmethod(opresult1214, "++", 1, partcv, params);
// compilenode returning opresult1215
  *var_s = opresult1215;
  if (opresult1215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1097(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1098 == NULL) {
    strlit1098 = alloc_String("");
    gc_root(strlit1098);
  }
// compilenode returning strlit1098
  *var_spc = strlit1098;
  if (strlit1098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1099 = gc_frame_new();
  Object num1102 = alloc_Float64(1);
// compilenode returning num1102
  int op_slot_right_1101 = gc_frame_newslot(num1102);
// compilenode returning *var_depth
  int op_slot_left_1101 = gc_frame_newslot(*var_depth);
  params[0] = num1102;
  partcv[0] = 1;
  Object diff1104 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1104
  int op_slot_right_1100 = gc_frame_newslot(diff1104);
  Object num1106 = alloc_Float64(0);
// compilenode returning num1106
  int op_slot_left_1100 = gc_frame_newslot(num1106);
  params[0] = diff1104;
  partcv[0] = 1;
  Object opresult1107 = callmethod(num1106, "..", 1, partcv, params);
// compilenode returning opresult1107
  gc_frame_newslot(opresult1107);
  Object block1108 = alloc_Block(NULL, NULL, "ast", 255);
  gc_frame_newslot(block1108);
  block_savedest(block1108);
  Object closure1109 = createclosure(2, "_apply");
setclosureframe(closure1109, stackframe);
  addtoclosure(closure1109, var_spc);
  addtoclosure(closure1109, selfslot);
  struct UserObject *uo1109 = (struct UserObject*)block1108;
  uo1109->data[0] = (Object)closure1109;
  Method *meth_meth_ast__apply1109 = addmethod2pos(block1108, "_apply", &meth_ast__apply1109, 0);
int argcv_meth_ast__apply1109[] = {1};
meth_meth_ast__apply1109->type = alloc_MethodType(1, argcv_meth_ast__apply1109);
  meth_meth_ast__apply1109->definitionModule = modulename;
  meth_meth_ast__apply1109->definitionLine = 249;
// compilenode returning block1108
  gc_frame_newslot(block1108);
  params[0] = opresult1107;
  params[1] = block1108;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1116 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1099);
// compilenode returning call1116
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1117 == NULL) {
    strlit1117 = alloc_String("{");
    gc_root(strlit1117);
  }
// compilenode returning strlit1117
  *var_s = strlit1117;
  if (strlit1117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1120 = alloc_Float64(0);
// compilenode returning num1120
  int op_slot_right_1119 = gc_frame_newslot(num1120);
  int callframe1122 = gc_frame_new();
  int callframe1123 = gc_frame_new();
  partcv[0] = 0;
  Object call1124 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1123);
// compilenode returning call1124
// compilenode returning call1124
  partcv[0] = 0;
  Object call1125 = callmethod(call1124, "size",
    1, partcv, params);
  gc_frame_end(callframe1122);
// compilenode returning call1125
// compilenode returning call1125
  int op_slot_left_1119 = gc_frame_newslot(call1125);
  params[0] = num1120;
  partcv[0] = 1;
  Object opresult1126 = callmethod(call1125, ">", 1, partcv, params);
// compilenode returning opresult1126
  Object if1118 = done;
  if (istrue(opresult1126)) {
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1128 == NULL) {
    strlit1128 = alloc_String(" ");
    gc_root(strlit1128);
  }
// compilenode returning strlit1128
  int op_slot_right_1127 = gc_frame_newslot(strlit1128);
// compilenode returning *var_s
  int op_slot_left_1127 = gc_frame_newslot(*var_s);
  params[0] = strlit1128;
  partcv[0] = 1;
  Object opresult1130 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1130
  *var_s = opresult1130;
  if (opresult1130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1132 = gc_frame_new();
  int callframe1133 = gc_frame_new();
  int callframe1134 = gc_frame_new();
  partcv[0] = 0;
  Object call1135 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1134);
// compilenode returning call1135
// compilenode returning call1135
  partcv[0] = 0;
  Object call1136 = callmethod(call1135, "indices",
    1, partcv, params);
  gc_frame_end(callframe1133);
// compilenode returning call1136
// compilenode returning call1136
  gc_frame_newslot(call1136);
  Object block1137 = alloc_Block(NULL, NULL, "ast", 261);
  gc_frame_newslot(block1137);
  block_savedest(block1137);
  Object closure1138 = createclosure(2, "_apply");
setclosureframe(closure1138, stackframe);
  addtoclosure(closure1138, var_s);
  addtoclosure(closure1138, selfslot);
  struct UserObject *uo1138 = (struct UserObject*)block1137;
  uo1138->data[0] = (Object)closure1138;
  Method *meth_meth_ast__apply1138 = addmethod2pos(block1137, "_apply", &meth_ast__apply1138, 0);
int argcv_meth_ast__apply1138[] = {1};
meth_meth_ast__apply1138->type = alloc_MethodType(1, argcv_meth_ast__apply1138);
  meth_meth_ast__apply1138->definitionModule = modulename;
  meth_meth_ast__apply1138->definitionLine = 261;
// compilenode returning block1137
  gc_frame_newslot(block1137);
  params[0] = call1136;
  params[1] = block1137;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1190 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1132);
// compilenode returning call1190
    gc_frame_newslot(call1190);
    if1118 = call1190;
  } else {
  }
// compilenode returning if1118
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1191 = gc_frame_new();
  int callframe1192 = gc_frame_new();
  partcv[0] = 0;
  Object call1193 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1192);
// compilenode returning call1193
// compilenode returning call1193
  gc_frame_newslot(call1193);
  Object block1194 = alloc_Block(NULL, NULL, "ast", 275);
  gc_frame_newslot(block1194);
  block_savedest(block1194);
  Object closure1195 = createclosure(4, "_apply");
setclosureframe(closure1195, stackframe);
  addtoclosure(closure1195, var_depth);
  addtoclosure(closure1195, var_spc);
  addtoclosure(closure1195, var_s);
  addtoclosure(closure1195, selfslot);
  struct UserObject *uo1195 = (struct UserObject*)block1194;
  uo1195->data[0] = (Object)closure1195;
  Method *meth_meth_ast__apply1195 = addmethod2pos(block1194, "_apply", &meth_ast__apply1195, 0);
int argcv_meth_ast__apply1195[] = {1};
meth_meth_ast__apply1195->type = alloc_MethodType(1, argcv_meth_ast__apply1195);
  meth_meth_ast__apply1195->definitionModule = modulename;
  meth_meth_ast__apply1195->definitionLine = 275;
// compilenode returning block1194
  gc_frame_newslot(block1194);
  params[0] = call1193;
  params[1] = block1194;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1218 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compilenode returning call1218
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1220 == NULL) {
    strlit1220 = alloc_String("}");
    gc_root(strlit1220);
  }
// compilenode returning strlit1220
  int op_slot_right_1219 = gc_frame_newslot(strlit1220);
// compilenode returning *var_spc
  int op_slot_right_1222 = gc_frame_newslot(*var_spc);
  if (strlit1225 == NULL) {
    strlit1225 = alloc_String("""\x0a""");
    gc_root(strlit1225);
  }
// compilenode returning strlit1225
  int op_slot_right_1224 = gc_frame_newslot(strlit1225);
// compilenode returning *var_s
  int op_slot_left_1224 = gc_frame_newslot(*var_s);
  params[0] = strlit1225;
  partcv[0] = 1;
  Object opresult1227 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1227
  int op_slot_left_1222 = gc_frame_newslot(opresult1227);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1228 = callmethod(opresult1227, "++", 1, partcv, params);
// compilenode returning opresult1228
  int op_slot_left_1219 = gc_frame_newslot(opresult1228);
  params[0] = strlit1220;
  partcv[0] = 1;
  Object opresult1229 = callmethod(opresult1228, "++", 1, partcv, params);
// compilenode returning opresult1229
  *var_s = opresult1229;
  if (opresult1229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1240(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1241 = gc_frame_new();
// compilenode returning *var_patternMarkVisitor
  gc_frame_newslot(*var_patternMarkVisitor);
// compilenode returning *var_p
  params[0] = *var_patternMarkVisitor;
  partcv[0] = 1;
  Object call1242 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe1241);
// compilenode returning call1242
  gc_frame_end(frame);
  return call1242;
}
Object meth_ast_new873(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject874 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj874 = alloc_userobj2(16,15, objclass874);
  gc_frame_newslot(obj874);
if (objclass874 == NULL) {
  glfree(obj874->class->name);
  obj874->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj874, self, 0);
  addmethodreal(obj874,"outer", &reader_ast_outer_875);
  Object oldself874 = self;
  struct StackFrameObject *oldstackframe874 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe874);
  gc_frame_newslot((Object)stackframe);
  self = obj874;
  Object *oldselfslot874 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter874 = (*(struct UserObject *)self).data[0], lowerouter874 = thisouter874;
  if (inheritingObject874) {
    struct UserObject *inho874 = (struct UserObject *)inheritingObject874;
    while (inho874->super != GraceDefaultObject) inho874 = (struct UserObject *)inho874->super;
    inho874->super = obj874;
    self = inheritingObject874;
    *selfslot = self;
    lowerouter874 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter874;
  }
if (objclass874 == NULL) {
  Method *reader876 = addmethodrealflags(obj874, "kind",&reader_ast_kind_876, MFLAG_DEF);
  reader876->definitionModule = modulename;
  reader876->definitionLine = 192;
}
adddatum2(obj874, alloc_Undefined(), 1);
if (objclass874 == NULL) {
  Method *reader877 = addmethodrealflags(obj874, "value",&reader_ast_value_877, MFLAG_DEF);
  reader877->definitionModule = modulename;
  reader877->definitionLine = 193;
}
adddatum2(obj874, alloc_Undefined(), 2);
if (objclass874 == NULL) {
  Method *reader878 = addmethodrealflags(obj874, "params",&reader_ast_params_878, MFLAG_DEF);
  reader878->definitionModule = modulename;
  reader878->definitionLine = 194;
}
adddatum2(obj874, alloc_Undefined(), 3);
if (objclass874 == NULL) {
  Method *reader879 = addmethodrealflags(obj874, "body",&reader_ast_body_879, MFLAG_DEF);
  reader879->definitionModule = modulename;
  reader879->definitionLine = 195;
}
adddatum2(obj874, alloc_Undefined(), 4);
if (objclass874 == NULL) {
  Method *reader880 = addmethodrealflags(obj874, "selfclosure",&reader_ast_selfclosure_880, MFLAG_DEF);
  reader880->definitionModule = modulename;
  reader880->definitionLine = 196;
}
adddatum2(obj874, alloc_Undefined(), 5);
if (objclass874 == NULL) {
  Method *reader881 = addmethodrealflags(obj874, "matchingPattern",&reader_ast_matchingPattern_881, 0);
  Method *writer881 = addmethodrealflags(obj874, "matchingPattern:=",&writer_ast_matchingPattern_881, 0);
  reader881->definitionModule = modulename;
  writer881->definitionModule = modulename;
  reader881->definitionLine = 197;
  writer881->definitionLine = 197;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 6);
if (objclass874 == NULL) {
  Method *reader882 = addmethodrealflags(obj874, "extraRuntimeData",&reader_ast_extraRuntimeData_882, 0);
  Method *writer882 = addmethodrealflags(obj874, "extraRuntimeData:=",&writer_ast_extraRuntimeData_882, 0);
  reader882->definitionModule = modulename;
  writer882->definitionModule = modulename;
  reader882->definitionLine = 198;
  writer882->definitionLine = 198;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 7);
  struct UserObject *uo883 = (struct UserObject*)obj874;
  uo883->data[8] = emptyclosure;
  Method *meth_meth_ast_accept883 = addmethod2pos(obj874, "accept", &meth_ast_accept883, 8);
int argcv_meth_ast_accept883[] = {1};
meth_meth_ast_accept883->type = alloc_MethodType(1, argcv_meth_ast_accept883);
meth_meth_ast_accept883->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept883->type->names[0] = "visitor";
  meth_meth_ast_accept883->definitionModule = modulename;
  meth_meth_ast_accept883->definitionLine = 201;
  block_savedest(obj874);
  Object closure916 = createclosure(1, "map()before()after");
setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_blockNode);
  struct UserObject *uo916 = (struct UserObject*)obj874;
  uo916->data[9] = (Object)closure916;
  Method *meth_meth_ast_map_40__41_before_40__41_after916 = addmethod2pos(obj874, "map()before()after", &meth_ast_map_40__41_before_40__41_after916, 9);
int argcv_meth_ast_map_40__41_before_40__41_after916[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after916->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after916);
  meth_meth_ast_map_40__41_before_40__41_after916->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after916->definitionLine = 214;
  struct UserObject *uo963 = (struct UserObject*)obj874;
  uo963->data[10] = emptyclosure;
  Method *meth_meth_ast_map963 = addmethod2pos(obj874, "map", &meth_ast_map963, 10);
int argcv_meth_ast_map963[] = {1};
meth_meth_ast_map963->type = alloc_MethodType(1, argcv_meth_ast_map963);
  meth_meth_ast_map963->definitionModule = modulename;
  meth_meth_ast_map963->definitionLine = 228;
  struct UserObject *uo972 = (struct UserObject*)obj874;
  uo972->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty972 = addmethod2pos(obj874, "pretty", &meth_ast_pretty972, 11);
int argcv_meth_ast_pretty972[] = {1};
meth_meth_ast_pretty972->type = alloc_MethodType(1, argcv_meth_ast_pretty972);
  meth_meth_ast_pretty972->definitionModule = modulename;
  meth_meth_ast_pretty972->definitionLine = 231;
  struct UserObject *uo1097 = (struct UserObject*)obj874;
  uo1097->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace1097 = addmethod2pos(obj874, "toGrace", &meth_ast_toGrace1097, 12);
int argcv_meth_ast_toGrace1097[] = {1};
meth_meth_ast_toGrace1097->type = alloc_MethodType(1, argcv_meth_ast_toGrace1097);
meth_meth_ast_toGrace1097->type->types[0] = type_Number;
meth_meth_ast_toGrace1097->type->names[0] = "depth";
  meth_meth_ast_toGrace1097->definitionModule = modulename;
  meth_meth_ast_toGrace1097->definitionLine = 253;
  sourceObject = obj874;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1231 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1232 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1231);
// compilenode returning call1232
  struct UserObject *obj874_uo = (struct UserObject *)obj874;
  obj874_uo->super = call1232;
  sourceObject = obj874;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1233 == NULL) {
    strlit1233 = alloc_String("block");
    gc_root(strlit1233);
  }
// compilenode returning strlit1233
  adddatum2(obj874, strlit1233, 1);
  sourceObject = obj874;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1234 == NULL) {
    strlit1234 = alloc_String("block");
    gc_root(strlit1234);
  }
// compilenode returning strlit1234
  adddatum2(obj874, strlit1234, 2);
  sourceObject = obj874;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj874, *var_params_39_, 3);
  sourceObject = obj874;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj874, *var_body_39_, 4);
  sourceObject = obj874;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1235 = alloc_Boolean(1);
// compilenode returning bool1235
  adddatum2(obj874, bool1235, 5);
  sourceObject = obj874;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1236 = alloc_Boolean(0);
// compilenode returning bool1236
  adddatum2(obj874, bool1236, 6);
  sourceObject = obj874;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1237 = alloc_Boolean(0);
// compilenode returning bool1237
  adddatum2(obj874, bool1237, 7);
  sourceObject = obj874;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1238 = gc_frame_new();
// compilenode returning *var_params_39_
  gc_frame_newslot(*var_params_39_);
  Object block1239 = alloc_Block(NULL, NULL, "ast", 198);
  gc_frame_newslot(block1239);
  block_savedest(block1239);
  Object closure1240 = createclosure(2, "_apply");
setclosureframe(closure1240, stackframe);
  addtoclosure(closure1240, var_patternMarkVisitor);
  addtoclosure(closure1240, selfslot);
  struct UserObject *uo1240 = (struct UserObject*)block1239;
  uo1240->data[0] = (Object)closure1240;
  Method *meth_meth_ast__apply1240 = addmethod2pos(block1239, "_apply", &meth_ast__apply1240, 0);
int argcv_meth_ast__apply1240[] = {1};
meth_meth_ast__apply1240->type = alloc_MethodType(1, argcv_meth_ast__apply1240);
  meth_meth_ast__apply1240->definitionModule = modulename;
  meth_meth_ast__apply1240->definitionLine = 275;
// compilenode returning block1239
  gc_frame_newslot(block1239);
  params[0] = *var_params_39_;
  params[1] = block1239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compilenode returning call1244
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
objclass874 = obj874->class;
  objclass874->definitionModule = modulename;
  objclass874->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter874;
  self = oldself874;
  selfslot = oldselfslot874;
  stackframe = oldstackframe874;
  gc_frame_end(frame);
  return obj874;
}
Object meth_ast_new873_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blockNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_patternMarkVisitor = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_params_39_ = &(stackframe->slots[0]);
  *var_params_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[1]);
  *var_body_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject874 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj874 = alloc_userobj2(16,15, objclass874);
  gc_frame_newslot(obj874);
if (objclass874 == NULL) {
  glfree(obj874->class->name);
  obj874->class->name = "blockNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj874, self, 0);
  addmethodreal(obj874,"outer", &reader_ast_outer_875);
  Object oldself874 = self;
  struct StackFrameObject *oldstackframe874 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe874);
  gc_frame_newslot((Object)stackframe);
  self = obj874;
  Object *oldselfslot874 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter874 = (*(struct UserObject *)self).data[0], lowerouter874 = thisouter874;
  if (inheritingObject874) {
    struct UserObject *inho874 = (struct UserObject *)inheritingObject874;
    while (inho874->super != GraceDefaultObject) inho874 = (struct UserObject *)inho874->super;
    inho874->super = obj874;
    self = inheritingObject874;
    *selfslot = self;
    lowerouter874 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter874;
  }
if (objclass874 == NULL) {
  Method *reader876 = addmethodrealflags(obj874, "kind",&reader_ast_kind_876, MFLAG_DEF);
  reader876->definitionModule = modulename;
  reader876->definitionLine = 192;
}
adddatum2(obj874, alloc_Undefined(), 1);
if (objclass874 == NULL) {
  Method *reader877 = addmethodrealflags(obj874, "value",&reader_ast_value_877, MFLAG_DEF);
  reader877->definitionModule = modulename;
  reader877->definitionLine = 193;
}
adddatum2(obj874, alloc_Undefined(), 2);
if (objclass874 == NULL) {
  Method *reader878 = addmethodrealflags(obj874, "params",&reader_ast_params_878, MFLAG_DEF);
  reader878->definitionModule = modulename;
  reader878->definitionLine = 194;
}
adddatum2(obj874, alloc_Undefined(), 3);
if (objclass874 == NULL) {
  Method *reader879 = addmethodrealflags(obj874, "body",&reader_ast_body_879, MFLAG_DEF);
  reader879->definitionModule = modulename;
  reader879->definitionLine = 195;
}
adddatum2(obj874, alloc_Undefined(), 4);
if (objclass874 == NULL) {
  Method *reader880 = addmethodrealflags(obj874, "selfclosure",&reader_ast_selfclosure_880, MFLAG_DEF);
  reader880->definitionModule = modulename;
  reader880->definitionLine = 196;
}
adddatum2(obj874, alloc_Undefined(), 5);
if (objclass874 == NULL) {
  Method *reader881 = addmethodrealflags(obj874, "matchingPattern",&reader_ast_matchingPattern_881, 0);
  Method *writer881 = addmethodrealflags(obj874, "matchingPattern:=",&writer_ast_matchingPattern_881, 0);
  reader881->definitionModule = modulename;
  writer881->definitionModule = modulename;
  reader881->definitionLine = 197;
  writer881->definitionLine = 197;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 6);
if (objclass874 == NULL) {
  Method *reader882 = addmethodrealflags(obj874, "extraRuntimeData",&reader_ast_extraRuntimeData_882, 0);
  Method *writer882 = addmethodrealflags(obj874, "extraRuntimeData:=",&writer_ast_extraRuntimeData_882, 0);
  reader882->definitionModule = modulename;
  writer882->definitionModule = modulename;
  reader882->definitionLine = 198;
  writer882->definitionLine = 198;
}
obj874->flags |= OFLAG_MUTABLE;
adddatum2(obj874, alloc_Undefined(), 7);
  struct UserObject *uo883 = (struct UserObject*)obj874;
  uo883->data[8] = emptyclosure;
  Method *meth_meth_ast_accept883 = addmethod2pos(obj874, "accept", &meth_ast_accept883, 8);
int argcv_meth_ast_accept883[] = {1};
meth_meth_ast_accept883->type = alloc_MethodType(1, argcv_meth_ast_accept883);
meth_meth_ast_accept883->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept883->type->names[0] = "visitor";
  meth_meth_ast_accept883->definitionModule = modulename;
  meth_meth_ast_accept883->definitionLine = 201;
  block_savedest(obj874);
  Object closure916 = createclosure(1, "map()before()after");
setclosureframe(closure916, stackframe);
  addtoclosure(closure916, var_blockNode);
  struct UserObject *uo916 = (struct UserObject*)obj874;
  uo916->data[9] = (Object)closure916;
  Method *meth_meth_ast_map_40__41_before_40__41_after916 = addmethod2pos(obj874, "map()before()after", &meth_ast_map_40__41_before_40__41_after916, 9);
int argcv_meth_ast_map_40__41_before_40__41_after916[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after916->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after916);
  meth_meth_ast_map_40__41_before_40__41_after916->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after916->definitionLine = 214;
  struct UserObject *uo963 = (struct UserObject*)obj874;
  uo963->data[10] = emptyclosure;
  Method *meth_meth_ast_map963 = addmethod2pos(obj874, "map", &meth_ast_map963, 10);
int argcv_meth_ast_map963[] = {1};
meth_meth_ast_map963->type = alloc_MethodType(1, argcv_meth_ast_map963);
  meth_meth_ast_map963->definitionModule = modulename;
  meth_meth_ast_map963->definitionLine = 228;
  struct UserObject *uo972 = (struct UserObject*)obj874;
  uo972->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty972 = addmethod2pos(obj874, "pretty", &meth_ast_pretty972, 11);
int argcv_meth_ast_pretty972[] = {1};
meth_meth_ast_pretty972->type = alloc_MethodType(1, argcv_meth_ast_pretty972);
  meth_meth_ast_pretty972->definitionModule = modulename;
  meth_meth_ast_pretty972->definitionLine = 231;
  struct UserObject *uo1097 = (struct UserObject*)obj874;
  uo1097->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace1097 = addmethod2pos(obj874, "toGrace", &meth_ast_toGrace1097, 12);
int argcv_meth_ast_toGrace1097[] = {1};
meth_meth_ast_toGrace1097->type = alloc_MethodType(1, argcv_meth_ast_toGrace1097);
meth_meth_ast_toGrace1097->type->types[0] = type_Number;
meth_meth_ast_toGrace1097->type->names[0] = "depth";
  meth_meth_ast_toGrace1097->definitionModule = modulename;
  meth_meth_ast_toGrace1097->definitionLine = 253;
  sourceObject = obj874;
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1231 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1232 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1231);
// compilenode returning call1232
  struct UserObject *obj874_uo = (struct UserObject *)obj874;
  obj874_uo->super = call1232;
  sourceObject = obj874;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1233 == NULL) {
    strlit1233 = alloc_String("block");
    gc_root(strlit1233);
  }
// compilenode returning strlit1233
  adddatum2(obj874, strlit1233, 1);
  sourceObject = obj874;
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1234 == NULL) {
    strlit1234 = alloc_String("block");
    gc_root(strlit1234);
  }
// compilenode returning strlit1234
  adddatum2(obj874, strlit1234, 2);
  sourceObject = obj874;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj874, *var_params_39_, 3);
  sourceObject = obj874;
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj874, *var_body_39_, 4);
  sourceObject = obj874;
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1235 = alloc_Boolean(1);
// compilenode returning bool1235
  adddatum2(obj874, bool1235, 5);
  sourceObject = obj874;
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1236 = alloc_Boolean(0);
// compilenode returning bool1236
  adddatum2(obj874, bool1236, 6);
  sourceObject = obj874;
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1237 = alloc_Boolean(0);
// compilenode returning bool1237
  adddatum2(obj874, bool1237, 7);
  sourceObject = obj874;
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1238 = gc_frame_new();
// compilenode returning *var_params_39_
  gc_frame_newslot(*var_params_39_);
  Object block1239 = alloc_Block(NULL, NULL, "ast", 198);
  gc_frame_newslot(block1239);
  block_savedest(block1239);
  Object closure1240 = createclosure(2, "_apply");
setclosureframe(closure1240, stackframe);
  addtoclosure(closure1240, var_patternMarkVisitor);
  addtoclosure(closure1240, selfslot);
  struct UserObject *uo1240 = (struct UserObject*)block1239;
  uo1240->data[0] = (Object)closure1240;
  Method *meth_meth_ast__apply1240 = addmethod2pos(block1239, "_apply", &meth_ast__apply1240, 0);
int argcv_meth_ast__apply1240[] = {1};
meth_meth_ast__apply1240->type = alloc_MethodType(1, argcv_meth_ast__apply1240);
  meth_meth_ast__apply1240->definitionModule = modulename;
  meth_meth_ast__apply1240->definitionLine = 275;
// compilenode returning block1239
  gc_frame_newslot(block1239);
  params[0] = *var_params_39_;
  params[1] = block1239;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1244 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1238);
// compilenode returning call1244
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
  sourceObject = obj874;
objclass874 = obj874->class;
  objclass874->definitionModule = modulename;
  objclass874->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter874;
  self = oldself874;
  selfslot = oldselfslot874;
  stackframe = oldstackframe874;
  gc_frame_end(frame);
  return obj874;
}
Object meth_ast_catchCaseNode1246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for catchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_catchCaseNode
  gc_frame_end(frame);
  return *var_catchCaseNode;
}
Object meth_ast__apply1268(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1269 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1270 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe1269);
// compilenode returning call1270
  gc_frame_end(frame);
  return call1270;
}
Object meth_ast_accept1256(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1258 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1259 = callmethod(*var_visitor, "visitCatchCase",
    1, partcv, params);
  gc_frame_end(callframe1258);
// compilenode returning call1259
  Object if1257 = done;
  if (istrue(call1259)) {
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1260 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1261 = gc_frame_new();
  partcv[0] = 0;
  Object call1262 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1261);
// compilenode returning call1262
// compilenode returning call1262
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1263 = callmethod(call1262, "accept",
    1, partcv, params);
  gc_frame_end(callframe1260);
// compilenode returning call1263
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1264 = gc_frame_new();
  int callframe1265 = gc_frame_new();
  partcv[0] = 0;
  Object call1266 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1265);
// compilenode returning call1266
// compilenode returning call1266
  gc_frame_newslot(call1266);
  Object block1267 = alloc_Block(NULL, NULL, "ast", 291);
  gc_frame_newslot(block1267);
  block_savedest(block1267);
  Object closure1268 = createclosure(2, "_apply");
setclosureframe(closure1268, stackframe);
  addtoclosure(closure1268, var_visitor);
  addtoclosure(closure1268, selfslot);
  struct UserObject *uo1268 = (struct UserObject*)block1267;
  uo1268->data[0] = (Object)closure1268;
  Method *meth_meth_ast__apply1268 = addmethod2pos(block1267, "_apply", &meth_ast__apply1268, 0);
int argcv_meth_ast__apply1268[] = {1};
meth_meth_ast__apply1268->type = alloc_MethodType(1, argcv_meth_ast__apply1268);
  meth_meth_ast__apply1268->definitionModule = modulename;
  meth_meth_ast__apply1268->definitionLine = 291;
// compilenode returning block1267
  gc_frame_newslot(block1267);
  params[0] = call1266;
  params[1] = block1267;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1272 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1264);
// compilenode returning call1272
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1275 = alloc_Boolean(0);
// compilenode returning bool1275
  int op_slot_right_1274 = gc_frame_newslot(bool1275);
  int callframe1277 = gc_frame_new();
  partcv[0] = 0;
  Object call1278 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1277);
// compilenode returning call1278
// compilenode returning call1278
  int op_slot_left_1274 = gc_frame_newslot(call1278);
  params[0] = bool1275;
  partcv[0] = 1;
  Object opresult1279 = callmethod(call1278, "!=", 1, partcv, params);
// compilenode returning opresult1279
  Object if1273 = done;
  if (istrue(opresult1279)) {
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1280 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1281 = gc_frame_new();
  partcv[0] = 0;
  Object call1282 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1281);
// compilenode returning call1282
// compilenode returning call1282
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1283 = callmethod(call1282, "accept",
    1, partcv, params);
  gc_frame_end(callframe1280);
// compilenode returning call1283
    gc_frame_newslot(call1283);
    if1273 = call1283;
  } else {
  }
// compilenode returning if1273
    gc_frame_newslot(if1273);
    if1257 = if1273;
  } else {
  }
// compilenode returning if1257
  gc_frame_end(frame);
  return if1257;
}
Object meth_ast_map_40__41_before_40__41_after1284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 300
  setline(300);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1285 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1286 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1285);
// compilenode returning call1286
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1287 = gc_frame_new();
  int callframe1288 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1289 = gc_frame_new();
  partcv[0] = 0;
  Object call1290 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1289);
// compilenode returning call1290
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1291 = callmethod(call1290, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1288);
// compilenode returning call1291
  gc_frame_newslot(call1291);
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1292 = gc_frame_new();
  int callframe1293 = gc_frame_new();
  partcv[0] = 0;
  Object call1294 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1293);
// compilenode returning call1294
  gc_frame_newslot(call1294);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1295 = gc_frame_new();
  int callframe1296 = gc_frame_new();
  Object call1297 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1296);
// compilenode returning call1297
// compilenode returning call1297
  partcv[0] = 0;
  Object call1298 = callmethodflags(call1297, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1295);
// compilenode returning call1298
// compilenode returning call1298
  params[0] = call1294;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1299 = callmethodflags(call1298, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1292);
// compilenode returning call1299
  gc_frame_newslot(call1299);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1300 = gc_frame_new();
  int callframe1301 = gc_frame_new();
  partcv[0] = 0;
  Object call1302 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1301);
// compilenode returning call1302
  gc_frame_newslot(call1302);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1303 = gc_frame_new();
  int callframe1304 = gc_frame_new();
  Object call1305 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1304);
// compilenode returning call1305
// compilenode returning call1305
  partcv[0] = 0;
  Object call1306 = callmethodflags(call1305, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compilenode returning call1306
// compilenode returning call1306
  params[0] = call1302;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call1307 = callmethodflags(call1306, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1300);
// compilenode returning call1307
  gc_frame_newslot(call1307);
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_catchCaseNode
  params[0] = call1291;
  params[1] = call1299;
  params[2] = call1307;
  partcv[0] = 3;
  Object call1308 = callmethod(*var_catchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1287);
// compilenode returning call1308
  *var_n = call1308;
  if (call1308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1309 = gc_frame_new();
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1310 = gc_frame_new();
  partcv[0] = 0;
  Object call1311 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1310);
// compilenode returning call1311
  gc_frame_newslot(call1311);
// compilenode returning *var_n
  params[0] = call1311;
  partcv[0] = 1;
  Object call1312 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1309);
// compilenode returning call1312
// compilenode returning done
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1316(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1319(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1314 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1315 = alloc_Block(NULL, NULL, "ast", 308);
  gc_frame_newslot(block1315);
  block_savedest(block1315);
  Object closure1316 = createclosure(1, "_apply");
setclosureframe(closure1316, stackframe);
  addtoclosure(closure1316, selfslot);
  struct UserObject *uo1316 = (struct UserObject*)block1315;
  uo1316->data[0] = (Object)closure1316;
  Method *meth_meth_ast__apply1316 = addmethod2pos(block1315, "_apply", &meth_ast__apply1316, 0);
int argcv_meth_ast__apply1316[] = {0};
meth_meth_ast__apply1316->type = alloc_MethodType(1, argcv_meth_ast__apply1316);
  meth_meth_ast__apply1316->definitionModule = modulename;
  meth_meth_ast__apply1316->definitionLine = 303;
// compilenode returning block1315
  gc_frame_newslot(block1315);
  Object block1318 = alloc_Block(NULL, NULL, "ast", 308);
  gc_frame_newslot(block1318);
  block_savedest(block1318);
  Object closure1319 = createclosure(1, "_apply");
setclosureframe(closure1319, stackframe);
  addtoclosure(closure1319, selfslot);
  struct UserObject *uo1319 = (struct UserObject*)block1318;
  uo1319->data[0] = (Object)closure1319;
  Method *meth_meth_ast__apply1319 = addmethod2pos(block1318, "_apply", &meth_ast__apply1319, 0);
int argcv_meth_ast__apply1319[] = {0};
meth_meth_ast__apply1319->type = alloc_MethodType(1, argcv_meth_ast__apply1319);
  meth_meth_ast__apply1319->definitionModule = modulename;
  meth_meth_ast__apply1319->definitionLine = 303;
// compilenode returning block1318
  gc_frame_newslot(block1318);
  params[0] = *var_blk;
  params[1] = block1315;
  params[2] = block1318;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1321 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1314);
// compilenode returning call1321
  gc_frame_end(frame);
  return call1321;
}
Object meth_ast__apply1330(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1332 == NULL) {
    strlit1332 = alloc_String("  ");
    gc_root(strlit1332);
  }
// compilenode returning strlit1332
  int op_slot_right_1331 = gc_frame_newslot(strlit1332);
// compilenode returning *var_spc
  int op_slot_left_1331 = gc_frame_newslot(*var_spc);
  params[0] = strlit1332;
  partcv[0] = 1;
  Object opresult1334 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1334
  *var_spc = opresult1334;
  if (opresult1334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1361 == NULL) {
    strlit1361 = alloc_String("");
    gc_root(strlit1361);
  }
// compilenode returning strlit1361
  int op_slot_right_1360 = gc_frame_newslot(strlit1361);
  int callframe1364 = gc_frame_new();
  Object num1366 = alloc_Float64(2);
// compilenode returning num1366
  int op_slot_right_1365 = gc_frame_newslot(num1366);
// compilenode returning *var_depth
  int op_slot_left_1365 = gc_frame_newslot(*var_depth);
  params[0] = num1366;
  partcv[0] = 1;
  Object sum1368 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1368
  gc_frame_newslot(sum1368);
// compilenode returning *var_mx
  params[0] = sum1368;
  partcv[0] = 1;
  Object call1369 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compilenode returning call1369
  int op_slot_right_1363 = gc_frame_newslot(call1369);
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("  ");
    gc_root(strlit1372);
  }
// compilenode returning strlit1372
  int op_slot_right_1371 = gc_frame_newslot(strlit1372);
// compilenode returning *var_spc
  int op_slot_right_1374 = gc_frame_newslot(*var_spc);
  if (strlit1377 == NULL) {
    strlit1377 = alloc_String("Case:""\x0a""");
    gc_root(strlit1377);
  }
// compilenode returning strlit1377
  int op_slot_right_1376 = gc_frame_newslot(strlit1377);
// compilenode returning *var_spc
  int op_slot_right_1379 = gc_frame_newslot(*var_spc);
  if (strlit1381 == NULL) {
    strlit1381 = alloc_String("""\x0a""");
    gc_root(strlit1381);
  }
// compilenode returning strlit1381
  int op_slot_left_1379 = gc_frame_newslot(strlit1381);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1382 = callmethod(strlit1381, "++", 1, partcv, params);
// compilenode returning opresult1382
  int op_slot_left_1376 = gc_frame_newslot(opresult1382);
  params[0] = strlit1377;
  partcv[0] = 1;
  Object opresult1383 = callmethod(opresult1382, "++", 1, partcv, params);
// compilenode returning opresult1383
  int op_slot_left_1374 = gc_frame_newslot(opresult1383);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1384 = callmethod(opresult1383, "++", 1, partcv, params);
// compilenode returning opresult1384
  int op_slot_left_1371 = gc_frame_newslot(opresult1384);
  params[0] = strlit1372;
  partcv[0] = 1;
  Object opresult1385 = callmethod(opresult1384, "++", 1, partcv, params);
// compilenode returning opresult1385
  int op_slot_left_1363 = gc_frame_newslot(opresult1385);
  params[0] = call1369;
  partcv[0] = 1;
  Object opresult1386 = callmethod(opresult1385, "++", 1, partcv, params);
// compilenode returning opresult1386
  int op_slot_left_1360 = gc_frame_newslot(opresult1386);
  params[0] = strlit1361;
  partcv[0] = 1;
  Object opresult1387 = callmethod(opresult1386, "++", 1, partcv, params);
// compilenode returning opresult1387
  int op_slot_right_1359 = gc_frame_newslot(opresult1387);
// compilenode returning *var_s
  int op_slot_left_1359 = gc_frame_newslot(*var_s);
  params[0] = opresult1387;
  partcv[0] = 1;
  Object opresult1389 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1389
  *var_s = opresult1389;
  if (opresult1389 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1322(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1323 == NULL) {
    strlit1323 = alloc_String("");
    gc_root(strlit1323);
  }
// compilenode returning strlit1323
  *var_spc = strlit1323;
  if (strlit1323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1324 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1325 = gc_frame_newslot(*var_depth);
  Object num1327 = alloc_Float64(0);
// compilenode returning num1327
  int op_slot_left_1325 = gc_frame_newslot(num1327);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1328 = callmethod(num1327, "..", 1, partcv, params);
// compilenode returning opresult1328
  gc_frame_newslot(opresult1328);
  Object block1329 = alloc_Block(NULL, NULL, "ast", 312);
  gc_frame_newslot(block1329);
  block_savedest(block1329);
  Object closure1330 = createclosure(2, "_apply");
setclosureframe(closure1330, stackframe);
  addtoclosure(closure1330, var_spc);
  addtoclosure(closure1330, selfslot);
  struct UserObject *uo1330 = (struct UserObject*)block1329;
  uo1330->data[0] = (Object)closure1330;
  Method *meth_meth_ast__apply1330 = addmethod2pos(block1329, "_apply", &meth_ast__apply1330, 0);
int argcv_meth_ast__apply1330[] = {1};
meth_meth_ast__apply1330->type = alloc_MethodType(1, argcv_meth_ast__apply1330);
  meth_meth_ast__apply1330->definitionModule = modulename;
  meth_meth_ast__apply1330->definitionLine = 303;
// compilenode returning block1329
  gc_frame_newslot(block1329);
  params[0] = opresult1328;
  params[1] = block1329;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1337 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1324);
// compilenode returning call1337
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1338 == NULL) {
    strlit1338 = alloc_String("Catch""\x0a""");
    gc_root(strlit1338);
  }
// compilenode returning strlit1338
  *var_s = strlit1338;
  if (strlit1338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1340 = gc_frame_new();
  Object num1342 = alloc_Float64(2);
// compilenode returning num1342
  int op_slot_right_1341 = gc_frame_newslot(num1342);
// compilenode returning *var_depth
  int op_slot_left_1341 = gc_frame_newslot(*var_depth);
  params[0] = num1342;
  partcv[0] = 1;
  Object sum1344 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1344
  gc_frame_newslot(sum1344);
  int callframe1345 = gc_frame_new();
  partcv[0] = 0;
  Object call1346 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1345);
// compilenode returning call1346
  params[0] = sum1344;
  partcv[0] = 1;
  Object call1347 = callmethod(call1346, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1340);
// compilenode returning call1347
  int op_slot_right_1339 = gc_frame_newslot(call1347);
// compilenode returning *var_spc
  int op_slot_right_1349 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1349 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1351 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1351
  int op_slot_left_1339 = gc_frame_newslot(opresult1351);
  params[0] = call1347;
  partcv[0] = 1;
  Object opresult1352 = callmethod(opresult1351, "++", 1, partcv, params);
// compilenode returning opresult1352
  *var_s = opresult1352;
  if (opresult1352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1354 = gc_frame_new();
  int callframe1355 = gc_frame_new();
  partcv[0] = 0;
  Object call1356 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1355);
// compilenode returning call1356
// compilenode returning call1356
  gc_frame_newslot(call1356);
  Object block1357 = alloc_Block(NULL, NULL, "ast", 317);
  gc_frame_newslot(block1357);
  block_savedest(block1357);
  Object closure1358 = createclosure(4, "_apply");
setclosureframe(closure1358, stackframe);
  addtoclosure(closure1358, var_depth);
  addtoclosure(closure1358, var_spc);
  addtoclosure(closure1358, var_s);
  addtoclosure(closure1358, selfslot);
  struct UserObject *uo1358 = (struct UserObject*)block1357;
  uo1358->data[0] = (Object)closure1358;
  Method *meth_meth_ast__apply1358 = addmethod2pos(block1357, "_apply", &meth_ast__apply1358, 0);
int argcv_meth_ast__apply1358[] = {1};
meth_meth_ast__apply1358->type = alloc_MethodType(1, argcv_meth_ast__apply1358);
  meth_meth_ast__apply1358->definitionModule = modulename;
  meth_meth_ast__apply1358->definitionLine = 317;
// compilenode returning block1357
  gc_frame_newslot(block1357);
  params[0] = call1356;
  params[1] = block1357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1392 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1354);
// compilenode returning call1392
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1395 = gc_frame_new();
  partcv[0] = 0;
  Object call1396 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compilenode returning call1396
// compilenode returning call1396
  int op_slot_right_1394 = gc_frame_newslot(call1396);
  Object bool1398 = alloc_Boolean(0);
// compilenode returning bool1398
  int op_slot_left_1394 = gc_frame_newslot(bool1398);
  params[0] = call1396;
  partcv[0] = 1;
  Object opresult1399 = callmethod(bool1398, "!=", 1, partcv, params);
// compilenode returning opresult1399
  Object if1393 = done;
  if (istrue(opresult1399)) {
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1402 == NULL) {
    strlit1402 = alloc_String("");
    gc_root(strlit1402);
  }
// compilenode returning strlit1402
  int op_slot_right_1401 = gc_frame_newslot(strlit1402);
  int callframe1405 = gc_frame_new();
  Object num1407 = alloc_Float64(2);
// compilenode returning num1407
  int op_slot_right_1406 = gc_frame_newslot(num1407);
// compilenode returning *var_depth
  int op_slot_left_1406 = gc_frame_newslot(*var_depth);
  params[0] = num1407;
  partcv[0] = 1;
  Object sum1409 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1409
  gc_frame_newslot(sum1409);
  int callframe1410 = gc_frame_new();
  partcv[0] = 0;
  Object call1411 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1410);
// compilenode returning call1411
// compilenode returning call1411
  params[0] = sum1409;
  partcv[0] = 1;
  Object call1412 = callmethod(call1411, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1405);
// compilenode returning call1412
  int op_slot_right_1404 = gc_frame_newslot(call1412);
  if (strlit1415 == NULL) {
    strlit1415 = alloc_String("  ");
    gc_root(strlit1415);
  }
// compilenode returning strlit1415
  int op_slot_right_1414 = gc_frame_newslot(strlit1415);
// compilenode returning *var_spc
  int op_slot_right_1417 = gc_frame_newslot(*var_spc);
  if (strlit1420 == NULL) {
    strlit1420 = alloc_String("Finally:""\x0a""");
    gc_root(strlit1420);
  }
// compilenode returning strlit1420
  int op_slot_right_1419 = gc_frame_newslot(strlit1420);
// compilenode returning *var_spc
  int op_slot_right_1422 = gc_frame_newslot(*var_spc);
  if (strlit1424 == NULL) {
    strlit1424 = alloc_String("""\x0a""");
    gc_root(strlit1424);
  }
// compilenode returning strlit1424
  int op_slot_left_1422 = gc_frame_newslot(strlit1424);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1425 = callmethod(strlit1424, "++", 1, partcv, params);
// compilenode returning opresult1425
  int op_slot_left_1419 = gc_frame_newslot(opresult1425);
  params[0] = strlit1420;
  partcv[0] = 1;
  Object opresult1426 = callmethod(opresult1425, "++", 1, partcv, params);
// compilenode returning opresult1426
  int op_slot_left_1417 = gc_frame_newslot(opresult1426);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1427 = callmethod(opresult1426, "++", 1, partcv, params);
// compilenode returning opresult1427
  int op_slot_left_1414 = gc_frame_newslot(opresult1427);
  params[0] = strlit1415;
  partcv[0] = 1;
  Object opresult1428 = callmethod(opresult1427, "++", 1, partcv, params);
// compilenode returning opresult1428
  int op_slot_left_1404 = gc_frame_newslot(opresult1428);
  params[0] = call1412;
  partcv[0] = 1;
  Object opresult1429 = callmethod(opresult1428, "++", 1, partcv, params);
// compilenode returning opresult1429
  int op_slot_left_1401 = gc_frame_newslot(opresult1429);
  params[0] = strlit1402;
  partcv[0] = 1;
  Object opresult1430 = callmethod(opresult1429, "++", 1, partcv, params);
// compilenode returning opresult1430
  int op_slot_right_1400 = gc_frame_newslot(opresult1430);
// compilenode returning *var_s
  int op_slot_left_1400 = gc_frame_newslot(*var_s);
  params[0] = opresult1430;
  partcv[0] = 1;
  Object opresult1432 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1432
  *var_s = opresult1432;
  if (opresult1432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1393 = done;
  } else {
  }
// compilenode returning if1393
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1446(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1448 == NULL) {
    strlit1448 = alloc_String("    ");
    gc_root(strlit1448);
  }
// compilenode returning strlit1448
  int op_slot_right_1447 = gc_frame_newslot(strlit1448);
// compilenode returning *var_spc
  int op_slot_left_1447 = gc_frame_newslot(*var_spc);
  params[0] = strlit1448;
  partcv[0] = 1;
  Object opresult1450 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1450
  *var_spc = opresult1450;
  if (opresult1450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1473 = gc_frame_new();
  Object num1475 = alloc_Float64(2);
// compilenode returning num1475
  int op_slot_right_1474 = gc_frame_newslot(num1475);
// compilenode returning *var_depth
  int op_slot_left_1474 = gc_frame_newslot(*var_depth);
  params[0] = num1475;
  partcv[0] = 1;
  Object sum1477 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1477
  gc_frame_newslot(sum1477);
// compilenode returning *var_case
  params[0] = sum1477;
  partcv[0] = 1;
  Object call1478 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1473);
// compilenode returning call1478
  int op_slot_right_1472 = gc_frame_newslot(call1478);
  if (strlit1481 == NULL) {
    strlit1481 = alloc_String("case ");
    gc_root(strlit1481);
  }
// compilenode returning strlit1481
  int op_slot_right_1480 = gc_frame_newslot(strlit1481);
  if (strlit1484 == NULL) {
    strlit1484 = alloc_String("    ");
    gc_root(strlit1484);
  }
// compilenode returning strlit1484
  int op_slot_right_1483 = gc_frame_newslot(strlit1484);
// compilenode returning *var_spc
  int op_slot_right_1486 = gc_frame_newslot(*var_spc);
  if (strlit1489 == NULL) {
    strlit1489 = alloc_String("""\x0a""");
    gc_root(strlit1489);
  }
// compilenode returning strlit1489
  int op_slot_right_1488 = gc_frame_newslot(strlit1489);
// compilenode returning *var_s
  int op_slot_left_1488 = gc_frame_newslot(*var_s);
  params[0] = strlit1489;
  partcv[0] = 1;
  Object opresult1491 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1491
  int op_slot_left_1486 = gc_frame_newslot(opresult1491);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1492 = callmethod(opresult1491, "++", 1, partcv, params);
// compilenode returning opresult1492
  int op_slot_left_1483 = gc_frame_newslot(opresult1492);
  params[0] = strlit1484;
  partcv[0] = 1;
  Object opresult1493 = callmethod(opresult1492, "++", 1, partcv, params);
// compilenode returning opresult1493
  int op_slot_left_1480 = gc_frame_newslot(opresult1493);
  params[0] = strlit1481;
  partcv[0] = 1;
  Object opresult1494 = callmethod(opresult1493, "++", 1, partcv, params);
// compilenode returning opresult1494
  int op_slot_left_1472 = gc_frame_newslot(opresult1494);
  params[0] = call1478;
  partcv[0] = 1;
  Object opresult1495 = callmethod(opresult1494, "++", 1, partcv, params);
// compilenode returning opresult1495
  *var_s = opresult1495;
  if (opresult1495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1434(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1435 == NULL) {
    strlit1435 = alloc_String("");
    gc_root(strlit1435);
  }
// compilenode returning strlit1435
  *var_spc = strlit1435;
  if (strlit1435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1436 = gc_frame_new();
  Object num1439 = alloc_Float64(1);
// compilenode returning num1439
  int op_slot_right_1438 = gc_frame_newslot(num1439);
// compilenode returning *var_depth
  int op_slot_left_1438 = gc_frame_newslot(*var_depth);
  params[0] = num1439;
  partcv[0] = 1;
  Object diff1441 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1441
  int op_slot_right_1437 = gc_frame_newslot(diff1441);
  Object num1443 = alloc_Float64(0);
// compilenode returning num1443
  int op_slot_left_1437 = gc_frame_newslot(num1443);
  params[0] = diff1441;
  partcv[0] = 1;
  Object opresult1444 = callmethod(num1443, "..", 1, partcv, params);
// compilenode returning opresult1444
  gc_frame_newslot(opresult1444);
  Object block1445 = alloc_Block(NULL, NULL, "ast", 327);
  gc_frame_newslot(block1445);
  block_savedest(block1445);
  Object closure1446 = createclosure(2, "_apply");
setclosureframe(closure1446, stackframe);
  addtoclosure(closure1446, var_spc);
  addtoclosure(closure1446, selfslot);
  struct UserObject *uo1446 = (struct UserObject*)block1445;
  uo1446->data[0] = (Object)closure1446;
  Method *meth_meth_ast__apply1446 = addmethod2pos(block1445, "_apply", &meth_ast__apply1446, 0);
int argcv_meth_ast__apply1446[] = {1};
meth_meth_ast__apply1446->type = alloc_MethodType(1, argcv_meth_ast__apply1446);
  meth_meth_ast__apply1446->definitionModule = modulename;
  meth_meth_ast__apply1446->definitionLine = 321;
// compilenode returning block1445
  gc_frame_newslot(block1445);
  params[0] = opresult1444;
  params[1] = block1445;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1453 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1436);
// compilenode returning call1453
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1455 == NULL) {
    strlit1455 = alloc_String(" ");
    gc_root(strlit1455);
  }
// compilenode returning strlit1455
  int op_slot_right_1454 = gc_frame_newslot(strlit1455);
  int callframe1458 = gc_frame_new();
  Object num1459 = alloc_Float64(0);
// compilenode returning num1459
  gc_frame_newslot(num1459);
  int callframe1460 = gc_frame_new();
  partcv[0] = 0;
  Object call1461 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1460);
// compilenode returning call1461
// compilenode returning call1461
  params[0] = num1459;
  partcv[0] = 1;
  Object call1462 = callmethod(call1461, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1458);
// compilenode returning call1462
  int op_slot_right_1457 = gc_frame_newslot(call1462);
  if (strlit1464 == NULL) {
    strlit1464 = alloc_String("catch ");
    gc_root(strlit1464);
  }
// compilenode returning strlit1464
  int op_slot_left_1457 = gc_frame_newslot(strlit1464);
  params[0] = call1462;
  partcv[0] = 1;
  Object opresult1465 = callmethod(strlit1464, "++", 1, partcv, params);
// compilenode returning opresult1465
  int op_slot_left_1454 = gc_frame_newslot(opresult1465);
  params[0] = strlit1455;
  partcv[0] = 1;
  Object opresult1466 = callmethod(opresult1465, "++", 1, partcv, params);
// compilenode returning opresult1466
  *var_s = opresult1466;
  if (opresult1466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1467 = gc_frame_new();
  int callframe1468 = gc_frame_new();
  partcv[0] = 0;
  Object call1469 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1468);
// compilenode returning call1469
// compilenode returning call1469
  gc_frame_newslot(call1469);
  Object block1470 = alloc_Block(NULL, NULL, "ast", 331);
  gc_frame_newslot(block1470);
  block_savedest(block1470);
  Object closure1471 = createclosure(4, "_apply");
setclosureframe(closure1471, stackframe);
  addtoclosure(closure1471, var_depth);
  addtoclosure(closure1471, var_spc);
  addtoclosure(closure1471, var_s);
  addtoclosure(closure1471, selfslot);
  struct UserObject *uo1471 = (struct UserObject*)block1470;
  uo1471->data[0] = (Object)closure1471;
  Method *meth_meth_ast__apply1471 = addmethod2pos(block1470, "_apply", &meth_ast__apply1471, 0);
int argcv_meth_ast__apply1471[] = {1};
meth_meth_ast__apply1471->type = alloc_MethodType(1, argcv_meth_ast__apply1471);
  meth_meth_ast__apply1471->definitionModule = modulename;
  meth_meth_ast__apply1471->definitionLine = 331;
// compilenode returning block1470
  gc_frame_newslot(block1470);
  params[0] = call1469;
  params[1] = block1470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1498 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1467);
// compilenode returning call1498
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1501 = alloc_Boolean(0);
// compilenode returning bool1501
  int op_slot_right_1500 = gc_frame_newslot(bool1501);
  int callframe1503 = gc_frame_new();
  partcv[0] = 0;
  Object call1504 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1503);
// compilenode returning call1504
// compilenode returning call1504
  int op_slot_left_1500 = gc_frame_newslot(call1504);
  params[0] = bool1501;
  partcv[0] = 1;
  Object opresult1505 = callmethod(call1504, "!=", 1, partcv, params);
// compilenode returning opresult1505
  Object if1499 = done;
  if (istrue(opresult1505)) {
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1507 = gc_frame_new();
  Object num1509 = alloc_Float64(2);
// compilenode returning num1509
  int op_slot_right_1508 = gc_frame_newslot(num1509);
// compilenode returning *var_depth
  int op_slot_left_1508 = gc_frame_newslot(*var_depth);
  params[0] = num1509;
  partcv[0] = 1;
  Object sum1511 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1511
  gc_frame_newslot(sum1511);
  int callframe1512 = gc_frame_new();
  partcv[0] = 0;
  Object call1513 = callmethodflags(self, "finally", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1512);
// compilenode returning call1513
// compilenode returning call1513
  params[0] = sum1511;
  partcv[0] = 1;
  Object call1514 = callmethod(call1513, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1507);
// compilenode returning call1514
  int op_slot_right_1506 = gc_frame_newslot(call1514);
  if (strlit1517 == NULL) {
    strlit1517 = alloc_String("finally ");
    gc_root(strlit1517);
  }
// compilenode returning strlit1517
  int op_slot_right_1516 = gc_frame_newslot(strlit1517);
  if (strlit1520 == NULL) {
    strlit1520 = alloc_String("    ");
    gc_root(strlit1520);
  }
// compilenode returning strlit1520
  int op_slot_right_1519 = gc_frame_newslot(strlit1520);
// compilenode returning *var_spc
  int op_slot_right_1522 = gc_frame_newslot(*var_spc);
  if (strlit1525 == NULL) {
    strlit1525 = alloc_String("""\x0a""");
    gc_root(strlit1525);
  }
// compilenode returning strlit1525
  int op_slot_right_1524 = gc_frame_newslot(strlit1525);
// compilenode returning *var_s
  int op_slot_left_1524 = gc_frame_newslot(*var_s);
  params[0] = strlit1525;
  partcv[0] = 1;
  Object opresult1527 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1527
  int op_slot_left_1522 = gc_frame_newslot(opresult1527);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1528 = callmethod(opresult1527, "++", 1, partcv, params);
// compilenode returning opresult1528
  int op_slot_left_1519 = gc_frame_newslot(opresult1528);
  params[0] = strlit1520;
  partcv[0] = 1;
  Object opresult1529 = callmethod(opresult1528, "++", 1, partcv, params);
// compilenode returning opresult1529
  int op_slot_left_1516 = gc_frame_newslot(opresult1529);
  params[0] = strlit1517;
  partcv[0] = 1;
  Object opresult1530 = callmethod(opresult1529, "++", 1, partcv, params);
// compilenode returning opresult1530
  int op_slot_left_1506 = gc_frame_newslot(opresult1530);
  params[0] = call1514;
  partcv[0] = 1;
  Object opresult1531 = callmethod(opresult1530, "++", 1, partcv, params);
// compilenode returning opresult1531
  *var_s = opresult1531;
  if (opresult1531 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1499 = done;
  } else {
  }
// compilenode returning if1499
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1249(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1250 = alloc_userobj2(10,11, objclass1250);
  gc_frame_newslot(obj1250);
if (objclass1250 == NULL) {
  glfree(obj1250->class->name);
  obj1250->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1250, self, 0);
  addmethodreal(obj1250,"outer", &reader_ast_outer_1251);
  Object oldself1250 = self;
  struct StackFrameObject *oldstackframe1250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1250);
  gc_frame_newslot((Object)stackframe);
  self = obj1250;
  Object *oldselfslot1250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1250 = (*(struct UserObject *)self).data[0], lowerouter1250 = thisouter1250;
  if (inheritingObject1250) {
    struct UserObject *inho1250 = (struct UserObject *)inheritingObject1250;
    while (inho1250->super != GraceDefaultObject) inho1250 = (struct UserObject *)inho1250->super;
    inho1250->super = obj1250;
    self = inheritingObject1250;
    *selfslot = self;
    lowerouter1250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1250;
  }
if (objclass1250 == NULL) {
  Method *reader1252 = addmethodrealflags(obj1250, "kind",&reader_ast_kind_1252, MFLAG_DEF);
  reader1252->definitionModule = modulename;
  reader1252->definitionLine = 285;
}
adddatum2(obj1250, alloc_Undefined(), 1);
if (objclass1250 == NULL) {
  Method *reader1253 = addmethodrealflags(obj1250, "value",&reader_ast_value_1253, MFLAG_DEF);
  reader1253->definitionModule = modulename;
  reader1253->definitionLine = 286;
}
adddatum2(obj1250, alloc_Undefined(), 2);
if (objclass1250 == NULL) {
  Method *reader1254 = addmethodrealflags(obj1250, "cases",&reader_ast_cases_1254, MFLAG_DEF);
  reader1254->definitionModule = modulename;
  reader1254->definitionLine = 287;
}
adddatum2(obj1250, alloc_Undefined(), 3);
if (objclass1250 == NULL) {
  Method *reader1255 = addmethodrealflags(obj1250, "finally",&reader_ast_finally_1255, MFLAG_DEF);
  reader1255->definitionModule = modulename;
  reader1255->definitionLine = 288;
}
adddatum2(obj1250, alloc_Undefined(), 4);
  struct UserObject *uo1256 = (struct UserObject*)obj1250;
  uo1256->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1256 = addmethod2pos(obj1250, "accept", &meth_ast_accept1256, 5);
int argcv_meth_ast_accept1256[] = {1};
meth_meth_ast_accept1256->type = alloc_MethodType(1, argcv_meth_ast_accept1256);
meth_meth_ast_accept1256->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1256->type->names[0] = "visitor";
  meth_meth_ast_accept1256->definitionModule = modulename;
  meth_meth_ast_accept1256->definitionLine = 288;
  block_savedest(obj1250);
  Object closure1284 = createclosure(1, "map()before()after");
setclosureframe(closure1284, stackframe);
  addtoclosure(closure1284, var_catchCaseNode);
  struct UserObject *uo1284 = (struct UserObject*)obj1250;
  uo1284->data[6] = (Object)closure1284;
  Method *meth_meth_ast_map_40__41_before_40__41_after1284 = addmethod2pos(obj1250, "map()before()after", &meth_ast_map_40__41_before_40__41_after1284, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1284[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1284->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1284);
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionLine = 299;
  struct UserObject *uo1313 = (struct UserObject*)obj1250;
  uo1313->data[7] = emptyclosure;
  Method *meth_meth_ast_map1313 = addmethod2pos(obj1250, "map", &meth_ast_map1313, 7);
int argcv_meth_ast_map1313[] = {1};
meth_meth_ast_map1313->type = alloc_MethodType(1, argcv_meth_ast_map1313);
  meth_meth_ast_map1313->definitionModule = modulename;
  meth_meth_ast_map1313->definitionLine = 307;
  struct UserObject *uo1322 = (struct UserObject*)obj1250;
  uo1322->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1322 = addmethod2pos(obj1250, "pretty", &meth_ast_pretty1322, 8);
int argcv_meth_ast_pretty1322[] = {1};
meth_meth_ast_pretty1322->type = alloc_MethodType(1, argcv_meth_ast_pretty1322);
  meth_meth_ast_pretty1322->definitionModule = modulename;
  meth_meth_ast_pretty1322->definitionLine = 310;
  struct UserObject *uo1434 = (struct UserObject*)obj1250;
  uo1434->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1434 = addmethod2pos(obj1250, "toGrace", &meth_ast_toGrace1434, 9);
int argcv_meth_ast_toGrace1434[] = {1};
meth_meth_ast_toGrace1434->type = alloc_MethodType(1, argcv_meth_ast_toGrace1434);
meth_meth_ast_toGrace1434->type->types[0] = type_Number;
meth_meth_ast_toGrace1434->type->names[0] = "depth";
  meth_meth_ast_toGrace1434->definitionModule = modulename;
  meth_meth_ast_toGrace1434->definitionLine = 325;
  sourceObject = obj1250;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1533 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1534 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1533);
// compilenode returning call1534
  struct UserObject *obj1250_uo = (struct UserObject *)obj1250;
  obj1250_uo->super = call1534;
  sourceObject = obj1250;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("catchcase");
    gc_root(strlit1535);
  }
// compilenode returning strlit1535
  adddatum2(obj1250, strlit1535, 1);
  sourceObject = obj1250;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_block
  adddatum2(obj1250, *var_block, 2);
  sourceObject = obj1250;
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1250, *var_cases_39_, 3);
  sourceObject = obj1250;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_finally_39_
  adddatum2(obj1250, *var_finally_39_, 4);
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
objclass1250 = obj1250->class;
  objclass1250->definitionModule = modulename;
  objclass1250->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1250;
  self = oldself1250;
  selfslot = oldselfslot1250;
  stackframe = oldstackframe1250;
  gc_frame_end(frame);
  return obj1250;
}
Object meth_ast_new1249_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_catchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block = &(stackframe->slots[0]);
  *var_block = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_finally_39_ = &(stackframe->slots[2]);
  *var_finally_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1250 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1250 = alloc_userobj2(10,11, objclass1250);
  gc_frame_newslot(obj1250);
if (objclass1250 == NULL) {
  glfree(obj1250->class->name);
  obj1250->class->name = "catchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1250, self, 0);
  addmethodreal(obj1250,"outer", &reader_ast_outer_1251);
  Object oldself1250 = self;
  struct StackFrameObject *oldstackframe1250 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1250);
  gc_frame_newslot((Object)stackframe);
  self = obj1250;
  Object *oldselfslot1250 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1250 = (*(struct UserObject *)self).data[0], lowerouter1250 = thisouter1250;
  if (inheritingObject1250) {
    struct UserObject *inho1250 = (struct UserObject *)inheritingObject1250;
    while (inho1250->super != GraceDefaultObject) inho1250 = (struct UserObject *)inho1250->super;
    inho1250->super = obj1250;
    self = inheritingObject1250;
    *selfslot = self;
    lowerouter1250 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1250;
  }
if (objclass1250 == NULL) {
  Method *reader1252 = addmethodrealflags(obj1250, "kind",&reader_ast_kind_1252, MFLAG_DEF);
  reader1252->definitionModule = modulename;
  reader1252->definitionLine = 285;
}
adddatum2(obj1250, alloc_Undefined(), 1);
if (objclass1250 == NULL) {
  Method *reader1253 = addmethodrealflags(obj1250, "value",&reader_ast_value_1253, MFLAG_DEF);
  reader1253->definitionModule = modulename;
  reader1253->definitionLine = 286;
}
adddatum2(obj1250, alloc_Undefined(), 2);
if (objclass1250 == NULL) {
  Method *reader1254 = addmethodrealflags(obj1250, "cases",&reader_ast_cases_1254, MFLAG_DEF);
  reader1254->definitionModule = modulename;
  reader1254->definitionLine = 287;
}
adddatum2(obj1250, alloc_Undefined(), 3);
if (objclass1250 == NULL) {
  Method *reader1255 = addmethodrealflags(obj1250, "finally",&reader_ast_finally_1255, MFLAG_DEF);
  reader1255->definitionModule = modulename;
  reader1255->definitionLine = 288;
}
adddatum2(obj1250, alloc_Undefined(), 4);
  struct UserObject *uo1256 = (struct UserObject*)obj1250;
  uo1256->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1256 = addmethod2pos(obj1250, "accept", &meth_ast_accept1256, 5);
int argcv_meth_ast_accept1256[] = {1};
meth_meth_ast_accept1256->type = alloc_MethodType(1, argcv_meth_ast_accept1256);
meth_meth_ast_accept1256->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1256->type->names[0] = "visitor";
  meth_meth_ast_accept1256->definitionModule = modulename;
  meth_meth_ast_accept1256->definitionLine = 288;
  block_savedest(obj1250);
  Object closure1284 = createclosure(1, "map()before()after");
setclosureframe(closure1284, stackframe);
  addtoclosure(closure1284, var_catchCaseNode);
  struct UserObject *uo1284 = (struct UserObject*)obj1250;
  uo1284->data[6] = (Object)closure1284;
  Method *meth_meth_ast_map_40__41_before_40__41_after1284 = addmethod2pos(obj1250, "map()before()after", &meth_ast_map_40__41_before_40__41_after1284, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1284[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1284->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1284);
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1284->definitionLine = 299;
  struct UserObject *uo1313 = (struct UserObject*)obj1250;
  uo1313->data[7] = emptyclosure;
  Method *meth_meth_ast_map1313 = addmethod2pos(obj1250, "map", &meth_ast_map1313, 7);
int argcv_meth_ast_map1313[] = {1};
meth_meth_ast_map1313->type = alloc_MethodType(1, argcv_meth_ast_map1313);
  meth_meth_ast_map1313->definitionModule = modulename;
  meth_meth_ast_map1313->definitionLine = 307;
  struct UserObject *uo1322 = (struct UserObject*)obj1250;
  uo1322->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty1322 = addmethod2pos(obj1250, "pretty", &meth_ast_pretty1322, 8);
int argcv_meth_ast_pretty1322[] = {1};
meth_meth_ast_pretty1322->type = alloc_MethodType(1, argcv_meth_ast_pretty1322);
  meth_meth_ast_pretty1322->definitionModule = modulename;
  meth_meth_ast_pretty1322->definitionLine = 310;
  struct UserObject *uo1434 = (struct UserObject*)obj1250;
  uo1434->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1434 = addmethod2pos(obj1250, "toGrace", &meth_ast_toGrace1434, 9);
int argcv_meth_ast_toGrace1434[] = {1};
meth_meth_ast_toGrace1434->type = alloc_MethodType(1, argcv_meth_ast_toGrace1434);
meth_meth_ast_toGrace1434->type->types[0] = type_Number;
meth_meth_ast_toGrace1434->type->names[0] = "depth";
  meth_meth_ast_toGrace1434->definitionModule = modulename;
  meth_meth_ast_toGrace1434->definitionLine = 325;
  sourceObject = obj1250;
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1533 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1534 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1533);
// compilenode returning call1534
  struct UserObject *obj1250_uo = (struct UserObject *)obj1250;
  obj1250_uo->super = call1534;
  sourceObject = obj1250;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1535 == NULL) {
    strlit1535 = alloc_String("catchcase");
    gc_root(strlit1535);
  }
// compilenode returning strlit1535
  adddatum2(obj1250, strlit1535, 1);
  sourceObject = obj1250;
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_block
  adddatum2(obj1250, *var_block, 2);
  sourceObject = obj1250;
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1250, *var_cases_39_, 3);
  sourceObject = obj1250;
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_finally_39_
  adddatum2(obj1250, *var_finally_39_, 4);
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
  sourceObject = obj1250;
objclass1250 = obj1250->class;
  objclass1250->definitionModule = modulename;
  objclass1250->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1250;
  self = oldself1250;
  selfslot = oldselfslot1250;
  stackframe = oldstackframe1250;
  gc_frame_end(frame);
  return obj1250;
}
Object meth_ast_matchCaseNode1537(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchCaseNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchCaseNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for matchCaseNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchCaseNode
  gc_frame_end(frame);
  return *var_matchCaseNode;
}
Object meth_ast__apply1559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1560 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1561 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe1560);
// compilenode returning call1561
  gc_frame_end(frame);
  return call1561;
}
Object meth_ast_accept1547(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1549 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1550 = callmethod(*var_visitor, "visitMatchCase",
    1, partcv, params);
  gc_frame_end(callframe1549);
// compilenode returning call1550
  Object if1548 = done;
  if (istrue(call1550)) {
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1551 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1552 = gc_frame_new();
  partcv[0] = 0;
  Object call1553 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1552);
// compilenode returning call1553
// compilenode returning call1553
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1554 = callmethod(call1553, "accept",
    1, partcv, params);
  gc_frame_end(callframe1551);
// compilenode returning call1554
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1555 = gc_frame_new();
  int callframe1556 = gc_frame_new();
  partcv[0] = 0;
  Object call1557 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1556);
// compilenode returning call1557
// compilenode returning call1557
  gc_frame_newslot(call1557);
  Object block1558 = alloc_Block(NULL, NULL, "ast", 349);
  gc_frame_newslot(block1558);
  block_savedest(block1558);
  Object closure1559 = createclosure(2, "_apply");
setclosureframe(closure1559, stackframe);
  addtoclosure(closure1559, var_visitor);
  addtoclosure(closure1559, selfslot);
  struct UserObject *uo1559 = (struct UserObject*)block1558;
  uo1559->data[0] = (Object)closure1559;
  Method *meth_meth_ast__apply1559 = addmethod2pos(block1558, "_apply", &meth_ast__apply1559, 0);
int argcv_meth_ast__apply1559[] = {1};
meth_meth_ast__apply1559->type = alloc_MethodType(1, argcv_meth_ast__apply1559);
  meth_meth_ast__apply1559->definitionModule = modulename;
  meth_meth_ast__apply1559->definitionLine = 349;
// compilenode returning block1558
  gc_frame_newslot(block1558);
  params[0] = call1557;
  params[1] = block1558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1563 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1555);
// compilenode returning call1563
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1566 = alloc_Boolean(0);
// compilenode returning bool1566
  int op_slot_right_1565 = gc_frame_newslot(bool1566);
  int callframe1568 = gc_frame_new();
  partcv[0] = 0;
  Object call1569 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1568);
// compilenode returning call1569
// compilenode returning call1569
  int op_slot_left_1565 = gc_frame_newslot(call1569);
  params[0] = bool1566;
  partcv[0] = 1;
  Object opresult1570 = callmethod(call1569, "!=", 1, partcv, params);
// compilenode returning opresult1570
  Object if1564 = done;
  if (istrue(opresult1570)) {
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1571 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1572 = gc_frame_new();
  partcv[0] = 0;
  Object call1573 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1572);
// compilenode returning call1573
// compilenode returning call1573
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1574 = callmethod(call1573, "accept",
    1, partcv, params);
  gc_frame_end(callframe1571);
// compilenode returning call1574
    gc_frame_newslot(call1574);
    if1564 = call1574;
  } else {
  }
// compilenode returning if1564
    gc_frame_newslot(if1564);
    if1548 = if1564;
  } else {
  }
// compilenode returning if1548
  gc_frame_end(frame);
  return if1548;
}
Object meth_ast_map_40__41_before_40__41_after1575(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newcases = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "newcases");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1576 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1577 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1576);
// compilenode returning call1577
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1578 = gc_frame_new();
  int callframe1579 = gc_frame_new();
  partcv[0] = 0;
  Object call1580 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1579);
// compilenode returning call1580
  gc_frame_newslot(call1580);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1581 = gc_frame_new();
  int callframe1582 = gc_frame_new();
  Object call1583 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1582);
// compilenode returning call1583
// compilenode returning call1583
  partcv[0] = 0;
  Object call1584 = callmethodflags(call1583, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1581);
// compilenode returning call1584
// compilenode returning call1584
  params[0] = call1580;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1585 = callmethodflags(call1584, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1578);
// compilenode returning call1585
  *var_newcases = call1585;
  if (call1585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1586 = gc_frame_new();
  int callframe1587 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1588 = gc_frame_new();
  partcv[0] = 0;
  Object call1589 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1588);
// compilenode returning call1589
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1590 = callmethod(call1589, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1587);
// compilenode returning call1590
  gc_frame_newslot(call1590);
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_newcases
  gc_frame_newslot(*var_newcases);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1591 = gc_frame_new();
  int callframe1592 = gc_frame_new();
  partcv[0] = 0;
  Object call1593 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compilenode returning call1593
  gc_frame_newslot(call1593);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1594 = gc_frame_new();
  int callframe1595 = gc_frame_new();
  Object call1596 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1595);
// compilenode returning call1596
// compilenode returning call1596
  partcv[0] = 0;
  Object call1597 = callmethodflags(call1596, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1594);
// compilenode returning call1597
// compilenode returning call1597
  params[0] = call1593;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call1598 = callmethodflags(call1597, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compilenode returning call1598
  gc_frame_newslot(call1598);
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchCaseNode
  params[0] = call1590;
  params[1] = *var_newcases;
  params[2] = call1598;
  partcv[0] = 3;
  Object call1599 = callmethod(*var_matchCaseNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1586);
// compilenode returning call1599
  *var_n = call1599;
  if (call1599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1600 = gc_frame_new();
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1601 = gc_frame_new();
  partcv[0] = 0;
  Object call1602 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1601);
// compilenode returning call1602
  gc_frame_newslot(call1602);
// compilenode returning *var_n
  params[0] = call1602;
  partcv[0] = 1;
  Object call1603 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1600);
// compilenode returning call1603
// compilenode returning done
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1604 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1605 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe1604);
// compilenode returning call1605
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1609(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1612(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1607 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1608 = alloc_Block(NULL, NULL, "ast", 368);
  gc_frame_newslot(block1608);
  block_savedest(block1608);
  Object closure1609 = createclosure(1, "_apply");
setclosureframe(closure1609, stackframe);
  addtoclosure(closure1609, selfslot);
  struct UserObject *uo1609 = (struct UserObject*)block1608;
  uo1609->data[0] = (Object)closure1609;
  Method *meth_meth_ast__apply1609 = addmethod2pos(block1608, "_apply", &meth_ast__apply1609, 0);
int argcv_meth_ast__apply1609[] = {0};
meth_meth_ast__apply1609->type = alloc_MethodType(1, argcv_meth_ast__apply1609);
  meth_meth_ast__apply1609->definitionModule = modulename;
  meth_meth_ast__apply1609->definitionLine = 362;
// compilenode returning block1608
  gc_frame_newslot(block1608);
  Object block1611 = alloc_Block(NULL, NULL, "ast", 368);
  gc_frame_newslot(block1611);
  block_savedest(block1611);
  Object closure1612 = createclosure(1, "_apply");
setclosureframe(closure1612, stackframe);
  addtoclosure(closure1612, selfslot);
  struct UserObject *uo1612 = (struct UserObject*)block1611;
  uo1612->data[0] = (Object)closure1612;
  Method *meth_meth_ast__apply1612 = addmethod2pos(block1611, "_apply", &meth_ast__apply1612, 0);
int argcv_meth_ast__apply1612[] = {0};
meth_meth_ast__apply1612->type = alloc_MethodType(1, argcv_meth_ast__apply1612);
  meth_meth_ast__apply1612->definitionModule = modulename;
  meth_meth_ast__apply1612->definitionLine = 362;
// compilenode returning block1611
  gc_frame_newslot(block1611);
  params[0] = *var_blk;
  params[1] = block1608;
  params[2] = block1611;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1614 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1607);
// compilenode returning call1614
  gc_frame_end(frame);
  return call1614;
}
Object meth_ast__apply1623(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1625 == NULL) {
    strlit1625 = alloc_String("  ");
    gc_root(strlit1625);
  }
// compilenode returning strlit1625
  int op_slot_right_1624 = gc_frame_newslot(strlit1625);
// compilenode returning *var_spc
  int op_slot_left_1624 = gc_frame_newslot(*var_spc);
  params[0] = strlit1625;
  partcv[0] = 1;
  Object opresult1627 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1627
  *var_spc = opresult1627;
  if (opresult1627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1649(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1652 == NULL) {
    strlit1652 = alloc_String("");
    gc_root(strlit1652);
  }
// compilenode returning strlit1652
  int op_slot_right_1651 = gc_frame_newslot(strlit1652);
  int callframe1655 = gc_frame_new();
  Object num1657 = alloc_Float64(2);
// compilenode returning num1657
  int op_slot_right_1656 = gc_frame_newslot(num1657);
// compilenode returning *var_depth
  int op_slot_left_1656 = gc_frame_newslot(*var_depth);
  params[0] = num1657;
  partcv[0] = 1;
  Object sum1659 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1659
  gc_frame_newslot(sum1659);
// compilenode returning *var_mx
  params[0] = sum1659;
  partcv[0] = 1;
  Object call1660 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1655);
// compilenode returning call1660
  int op_slot_right_1654 = gc_frame_newslot(call1660);
  if (strlit1663 == NULL) {
    strlit1663 = alloc_String("  ");
    gc_root(strlit1663);
  }
// compilenode returning strlit1663
  int op_slot_right_1662 = gc_frame_newslot(strlit1663);
// compilenode returning *var_spc
  int op_slot_right_1665 = gc_frame_newslot(*var_spc);
  if (strlit1668 == NULL) {
    strlit1668 = alloc_String("Case:""\x0a""");
    gc_root(strlit1668);
  }
// compilenode returning strlit1668
  int op_slot_right_1667 = gc_frame_newslot(strlit1668);
// compilenode returning *var_spc
  int op_slot_right_1670 = gc_frame_newslot(*var_spc);
  if (strlit1672 == NULL) {
    strlit1672 = alloc_String("""\x0a""");
    gc_root(strlit1672);
  }
// compilenode returning strlit1672
  int op_slot_left_1670 = gc_frame_newslot(strlit1672);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1673 = callmethod(strlit1672, "++", 1, partcv, params);
// compilenode returning opresult1673
  int op_slot_left_1667 = gc_frame_newslot(opresult1673);
  params[0] = strlit1668;
  partcv[0] = 1;
  Object opresult1674 = callmethod(opresult1673, "++", 1, partcv, params);
// compilenode returning opresult1674
  int op_slot_left_1665 = gc_frame_newslot(opresult1674);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1675 = callmethod(opresult1674, "++", 1, partcv, params);
// compilenode returning opresult1675
  int op_slot_left_1662 = gc_frame_newslot(opresult1675);
  params[0] = strlit1663;
  partcv[0] = 1;
  Object opresult1676 = callmethod(opresult1675, "++", 1, partcv, params);
// compilenode returning opresult1676
  int op_slot_left_1654 = gc_frame_newslot(opresult1676);
  params[0] = call1660;
  partcv[0] = 1;
  Object opresult1677 = callmethod(opresult1676, "++", 1, partcv, params);
// compilenode returning opresult1677
  int op_slot_left_1651 = gc_frame_newslot(opresult1677);
  params[0] = strlit1652;
  partcv[0] = 1;
  Object opresult1678 = callmethod(opresult1677, "++", 1, partcv, params);
// compilenode returning opresult1678
  int op_slot_right_1650 = gc_frame_newslot(opresult1678);
// compilenode returning *var_s
  int op_slot_left_1650 = gc_frame_newslot(*var_s);
  params[0] = opresult1678;
  partcv[0] = 1;
  Object opresult1680 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1680
  *var_s = opresult1680;
  if (opresult1680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty1615(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_matchee = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1616 == NULL) {
    strlit1616 = alloc_String("");
    gc_root(strlit1616);
  }
// compilenode returning strlit1616
  *var_spc = strlit1616;
  if (strlit1616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1617 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1618 = gc_frame_newslot(*var_depth);
  Object num1620 = alloc_Float64(0);
// compilenode returning num1620
  int op_slot_left_1618 = gc_frame_newslot(num1620);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1621 = callmethod(num1620, "..", 1, partcv, params);
// compilenode returning opresult1621
  gc_frame_newslot(opresult1621);
  Object block1622 = alloc_Block(NULL, NULL, "ast", 372);
  gc_frame_newslot(block1622);
  block_savedest(block1622);
  Object closure1623 = createclosure(2, "_apply");
setclosureframe(closure1623, stackframe);
  addtoclosure(closure1623, var_spc);
  addtoclosure(closure1623, selfslot);
  struct UserObject *uo1623 = (struct UserObject*)block1622;
  uo1623->data[0] = (Object)closure1623;
  Method *meth_meth_ast__apply1623 = addmethod2pos(block1622, "_apply", &meth_ast__apply1623, 0);
int argcv_meth_ast__apply1623[] = {1};
meth_meth_ast__apply1623->type = alloc_MethodType(1, argcv_meth_ast__apply1623);
  meth_meth_ast__apply1623->definitionModule = modulename;
  meth_meth_ast__apply1623->definitionLine = 362;
// compilenode returning block1622
  gc_frame_newslot(block1622);
  params[0] = opresult1621;
  params[1] = block1622;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1630 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1617);
// compilenode returning call1630
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1631 == NULL) {
    strlit1631 = alloc_String("Match""\x0a""");
    gc_root(strlit1631);
  }
// compilenode returning strlit1631
  *var_s = strlit1631;
  if (strlit1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1633 = gc_frame_new();
  Object num1635 = alloc_Float64(2);
// compilenode returning num1635
  int op_slot_right_1634 = gc_frame_newslot(num1635);
// compilenode returning *var_depth
  int op_slot_left_1634 = gc_frame_newslot(*var_depth);
  params[0] = num1635;
  partcv[0] = 1;
  Object sum1637 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1637
  gc_frame_newslot(sum1637);
// compilenode returning *var_matchee
  params[0] = sum1637;
  partcv[0] = 1;
  Object call1638 = callmethod(*var_matchee, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1633);
// compilenode returning call1638
  int op_slot_right_1632 = gc_frame_newslot(call1638);
// compilenode returning *var_spc
  int op_slot_right_1640 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_1640 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1642 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1642
  int op_slot_left_1632 = gc_frame_newslot(opresult1642);
  params[0] = call1638;
  partcv[0] = 1;
  Object opresult1643 = callmethod(opresult1642, "++", 1, partcv, params);
// compilenode returning opresult1643
  *var_s = opresult1643;
  if (opresult1643 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1645 = gc_frame_new();
  int callframe1646 = gc_frame_new();
  partcv[0] = 0;
  Object call1647 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1646);
// compilenode returning call1647
// compilenode returning call1647
  gc_frame_newslot(call1647);
  Object block1648 = alloc_Block(NULL, NULL, "ast", 377);
  gc_frame_newslot(block1648);
  block_savedest(block1648);
  Object closure1649 = createclosure(4, "_apply");
setclosureframe(closure1649, stackframe);
  addtoclosure(closure1649, var_depth);
  addtoclosure(closure1649, var_spc);
  addtoclosure(closure1649, var_s);
  addtoclosure(closure1649, selfslot);
  struct UserObject *uo1649 = (struct UserObject*)block1648;
  uo1649->data[0] = (Object)closure1649;
  Method *meth_meth_ast__apply1649 = addmethod2pos(block1648, "_apply", &meth_ast__apply1649, 0);
int argcv_meth_ast__apply1649[] = {1};
meth_meth_ast__apply1649->type = alloc_MethodType(1, argcv_meth_ast__apply1649);
  meth_meth_ast__apply1649->definitionModule = modulename;
  meth_meth_ast__apply1649->definitionLine = 377;
// compilenode returning block1648
  gc_frame_newslot(block1648);
  params[0] = call1647;
  params[1] = block1648;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1683 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1645);
// compilenode returning call1683
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1686 = gc_frame_new();
  partcv[0] = 0;
  Object call1687 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1686);
// compilenode returning call1687
// compilenode returning call1687
  int op_slot_right_1685 = gc_frame_newslot(call1687);
  Object bool1689 = alloc_Boolean(0);
// compilenode returning bool1689
  int op_slot_left_1685 = gc_frame_newslot(bool1689);
  params[0] = call1687;
  partcv[0] = 1;
  Object opresult1690 = callmethod(bool1689, "!=", 1, partcv, params);
// compilenode returning opresult1690
  Object if1684 = done;
  if (istrue(opresult1690)) {
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1693 == NULL) {
    strlit1693 = alloc_String("");
    gc_root(strlit1693);
  }
// compilenode returning strlit1693
  int op_slot_right_1692 = gc_frame_newslot(strlit1693);
  int callframe1696 = gc_frame_new();
  Object num1698 = alloc_Float64(2);
// compilenode returning num1698
  int op_slot_right_1697 = gc_frame_newslot(num1698);
// compilenode returning *var_depth
  int op_slot_left_1697 = gc_frame_newslot(*var_depth);
  params[0] = num1698;
  partcv[0] = 1;
  Object sum1700 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1700
  gc_frame_newslot(sum1700);
  int callframe1701 = gc_frame_new();
  partcv[0] = 0;
  Object call1702 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1701);
// compilenode returning call1702
// compilenode returning call1702
  params[0] = sum1700;
  partcv[0] = 1;
  Object call1703 = callmethod(call1702, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1696);
// compilenode returning call1703
  int op_slot_right_1695 = gc_frame_newslot(call1703);
  if (strlit1706 == NULL) {
    strlit1706 = alloc_String("  ");
    gc_root(strlit1706);
  }
// compilenode returning strlit1706
  int op_slot_right_1705 = gc_frame_newslot(strlit1706);
// compilenode returning *var_spc
  int op_slot_right_1708 = gc_frame_newslot(*var_spc);
  if (strlit1711 == NULL) {
    strlit1711 = alloc_String("Else:""\x0a""");
    gc_root(strlit1711);
  }
// compilenode returning strlit1711
  int op_slot_right_1710 = gc_frame_newslot(strlit1711);
// compilenode returning *var_spc
  int op_slot_right_1713 = gc_frame_newslot(*var_spc);
  if (strlit1715 == NULL) {
    strlit1715 = alloc_String("""\x0a""");
    gc_root(strlit1715);
  }
// compilenode returning strlit1715
  int op_slot_left_1713 = gc_frame_newslot(strlit1715);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1716 = callmethod(strlit1715, "++", 1, partcv, params);
// compilenode returning opresult1716
  int op_slot_left_1710 = gc_frame_newslot(opresult1716);
  params[0] = strlit1711;
  partcv[0] = 1;
  Object opresult1717 = callmethod(opresult1716, "++", 1, partcv, params);
// compilenode returning opresult1717
  int op_slot_left_1708 = gc_frame_newslot(opresult1717);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1718 = callmethod(opresult1717, "++", 1, partcv, params);
// compilenode returning opresult1718
  int op_slot_left_1705 = gc_frame_newslot(opresult1718);
  params[0] = strlit1706;
  partcv[0] = 1;
  Object opresult1719 = callmethod(opresult1718, "++", 1, partcv, params);
// compilenode returning opresult1719
  int op_slot_left_1695 = gc_frame_newslot(opresult1719);
  params[0] = call1703;
  partcv[0] = 1;
  Object opresult1720 = callmethod(opresult1719, "++", 1, partcv, params);
// compilenode returning opresult1720
  int op_slot_left_1692 = gc_frame_newslot(opresult1720);
  params[0] = strlit1693;
  partcv[0] = 1;
  Object opresult1721 = callmethod(opresult1720, "++", 1, partcv, params);
// compilenode returning opresult1721
  int op_slot_right_1691 = gc_frame_newslot(opresult1721);
// compilenode returning *var_s
  int op_slot_left_1691 = gc_frame_newslot(*var_s);
  params[0] = opresult1721;
  partcv[0] = 1;
  Object opresult1723 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1723
  *var_s = opresult1723;
  if (opresult1723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1684 = done;
  } else {
  }
// compilenode returning if1684
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply1737(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1739 == NULL) {
    strlit1739 = alloc_String("    ");
    gc_root(strlit1739);
  }
// compilenode returning strlit1739
  int op_slot_right_1738 = gc_frame_newslot(strlit1739);
// compilenode returning *var_spc
  int op_slot_left_1738 = gc_frame_newslot(*var_spc);
  params[0] = strlit1739;
  partcv[0] = 1;
  Object opresult1741 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1741
  *var_spc = opresult1741;
  if (opresult1741 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_case = &(stackframe->slots[0]);
  *var_case = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1764 = gc_frame_new();
  Object num1766 = alloc_Float64(2);
// compilenode returning num1766
  int op_slot_right_1765 = gc_frame_newslot(num1766);
// compilenode returning *var_depth
  int op_slot_left_1765 = gc_frame_newslot(*var_depth);
  params[0] = num1766;
  partcv[0] = 1;
  Object sum1768 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1768
  gc_frame_newslot(sum1768);
// compilenode returning *var_case
  params[0] = sum1768;
  partcv[0] = 1;
  Object call1769 = callmethod(*var_case, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1764);
// compilenode returning call1769
  int op_slot_right_1763 = gc_frame_newslot(call1769);
  if (strlit1772 == NULL) {
    strlit1772 = alloc_String("case ");
    gc_root(strlit1772);
  }
// compilenode returning strlit1772
  int op_slot_right_1771 = gc_frame_newslot(strlit1772);
  if (strlit1775 == NULL) {
    strlit1775 = alloc_String("    ");
    gc_root(strlit1775);
  }
// compilenode returning strlit1775
  int op_slot_right_1774 = gc_frame_newslot(strlit1775);
// compilenode returning *var_spc
  int op_slot_right_1777 = gc_frame_newslot(*var_spc);
  if (strlit1780 == NULL) {
    strlit1780 = alloc_String("""\x0a""");
    gc_root(strlit1780);
  }
// compilenode returning strlit1780
  int op_slot_right_1779 = gc_frame_newslot(strlit1780);
// compilenode returning *var_s
  int op_slot_left_1779 = gc_frame_newslot(*var_s);
  params[0] = strlit1780;
  partcv[0] = 1;
  Object opresult1782 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1782
  int op_slot_left_1777 = gc_frame_newslot(opresult1782);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1783 = callmethod(opresult1782, "++", 1, partcv, params);
// compilenode returning opresult1783
  int op_slot_left_1774 = gc_frame_newslot(opresult1783);
  params[0] = strlit1775;
  partcv[0] = 1;
  Object opresult1784 = callmethod(opresult1783, "++", 1, partcv, params);
// compilenode returning opresult1784
  int op_slot_left_1771 = gc_frame_newslot(opresult1784);
  params[0] = strlit1772;
  partcv[0] = 1;
  Object opresult1785 = callmethod(opresult1784, "++", 1, partcv, params);
// compilenode returning opresult1785
  int op_slot_left_1763 = gc_frame_newslot(opresult1785);
  params[0] = call1769;
  partcv[0] = 1;
  Object opresult1786 = callmethod(opresult1785, "++", 1, partcv, params);
// compilenode returning opresult1786
  *var_s = opresult1786;
  if (opresult1786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace1725(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1726 == NULL) {
    strlit1726 = alloc_String("");
    gc_root(strlit1726);
  }
// compilenode returning strlit1726
  *var_spc = strlit1726;
  if (strlit1726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1727 = gc_frame_new();
  Object num1730 = alloc_Float64(1);
// compilenode returning num1730
  int op_slot_right_1729 = gc_frame_newslot(num1730);
// compilenode returning *var_depth
  int op_slot_left_1729 = gc_frame_newslot(*var_depth);
  params[0] = num1730;
  partcv[0] = 1;
  Object diff1732 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff1732
  int op_slot_right_1728 = gc_frame_newslot(diff1732);
  Object num1734 = alloc_Float64(0);
// compilenode returning num1734
  int op_slot_left_1728 = gc_frame_newslot(num1734);
  params[0] = diff1732;
  partcv[0] = 1;
  Object opresult1735 = callmethod(num1734, "..", 1, partcv, params);
// compilenode returning opresult1735
  gc_frame_newslot(opresult1735);
  Object block1736 = alloc_Block(NULL, NULL, "ast", 387);
  gc_frame_newslot(block1736);
  block_savedest(block1736);
  Object closure1737 = createclosure(2, "_apply");
setclosureframe(closure1737, stackframe);
  addtoclosure(closure1737, var_spc);
  addtoclosure(closure1737, selfslot);
  struct UserObject *uo1737 = (struct UserObject*)block1736;
  uo1737->data[0] = (Object)closure1737;
  Method *meth_meth_ast__apply1737 = addmethod2pos(block1736, "_apply", &meth_ast__apply1737, 0);
int argcv_meth_ast__apply1737[] = {1};
meth_meth_ast__apply1737->type = alloc_MethodType(1, argcv_meth_ast__apply1737);
  meth_meth_ast__apply1737->definitionModule = modulename;
  meth_meth_ast__apply1737->definitionLine = 381;
// compilenode returning block1736
  gc_frame_newslot(block1736);
  params[0] = opresult1735;
  params[1] = block1736;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1744 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1727);
// compilenode returning call1744
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1746 == NULL) {
    strlit1746 = alloc_String(")");
    gc_root(strlit1746);
  }
// compilenode returning strlit1746
  int op_slot_right_1745 = gc_frame_newslot(strlit1746);
  int callframe1749 = gc_frame_new();
  Object num1750 = alloc_Float64(0);
// compilenode returning num1750
  gc_frame_newslot(num1750);
  int callframe1751 = gc_frame_new();
  partcv[0] = 0;
  Object call1752 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1751);
// compilenode returning call1752
// compilenode returning call1752
  params[0] = num1750;
  partcv[0] = 1;
  Object call1753 = callmethod(call1752, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1749);
// compilenode returning call1753
  int op_slot_right_1748 = gc_frame_newslot(call1753);
  if (strlit1755 == NULL) {
    strlit1755 = alloc_String("match(");
    gc_root(strlit1755);
  }
// compilenode returning strlit1755
  int op_slot_left_1748 = gc_frame_newslot(strlit1755);
  params[0] = call1753;
  partcv[0] = 1;
  Object opresult1756 = callmethod(strlit1755, "++", 1, partcv, params);
// compilenode returning opresult1756
  int op_slot_left_1745 = gc_frame_newslot(opresult1756);
  params[0] = strlit1746;
  partcv[0] = 1;
  Object opresult1757 = callmethod(opresult1756, "++", 1, partcv, params);
// compilenode returning opresult1757
  *var_s = opresult1757;
  if (opresult1757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1758 = gc_frame_new();
  int callframe1759 = gc_frame_new();
  partcv[0] = 0;
  Object call1760 = callmethodflags(self, "cases", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1759);
// compilenode returning call1760
// compilenode returning call1760
  gc_frame_newslot(call1760);
  Object block1761 = alloc_Block(NULL, NULL, "ast", 391);
  gc_frame_newslot(block1761);
  block_savedest(block1761);
  Object closure1762 = createclosure(4, "_apply");
setclosureframe(closure1762, stackframe);
  addtoclosure(closure1762, var_depth);
  addtoclosure(closure1762, var_spc);
  addtoclosure(closure1762, var_s);
  addtoclosure(closure1762, selfslot);
  struct UserObject *uo1762 = (struct UserObject*)block1761;
  uo1762->data[0] = (Object)closure1762;
  Method *meth_meth_ast__apply1762 = addmethod2pos(block1761, "_apply", &meth_ast__apply1762, 0);
int argcv_meth_ast__apply1762[] = {1};
meth_meth_ast__apply1762->type = alloc_MethodType(1, argcv_meth_ast__apply1762);
  meth_meth_ast__apply1762->definitionModule = modulename;
  meth_meth_ast__apply1762->definitionLine = 391;
// compilenode returning block1761
  gc_frame_newslot(block1761);
  params[0] = call1760;
  params[1] = block1761;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1789 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1758);
// compilenode returning call1789
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1792 = alloc_Boolean(0);
// compilenode returning bool1792
  int op_slot_right_1791 = gc_frame_newslot(bool1792);
  int callframe1794 = gc_frame_new();
  partcv[0] = 0;
  Object call1795 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compilenode returning call1795
// compilenode returning call1795
  int op_slot_left_1791 = gc_frame_newslot(call1795);
  params[0] = bool1792;
  partcv[0] = 1;
  Object opresult1796 = callmethod(call1795, "!=", 1, partcv, params);
// compilenode returning opresult1796
  Object if1790 = done;
  if (istrue(opresult1796)) {
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1798 = gc_frame_new();
  Object num1800 = alloc_Float64(2);
// compilenode returning num1800
  int op_slot_right_1799 = gc_frame_newslot(num1800);
// compilenode returning *var_depth
  int op_slot_left_1799 = gc_frame_newslot(*var_depth);
  params[0] = num1800;
  partcv[0] = 1;
  Object sum1802 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1802
  gc_frame_newslot(sum1802);
  int callframe1803 = gc_frame_new();
  partcv[0] = 0;
  Object call1804 = callmethodflags(self, "elsecase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1803);
// compilenode returning call1804
// compilenode returning call1804
  params[0] = sum1802;
  partcv[0] = 1;
  Object call1805 = callmethod(call1804, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe1798);
// compilenode returning call1805
  int op_slot_right_1797 = gc_frame_newslot(call1805);
  if (strlit1808 == NULL) {
    strlit1808 = alloc_String("else ");
    gc_root(strlit1808);
  }
// compilenode returning strlit1808
  int op_slot_right_1807 = gc_frame_newslot(strlit1808);
  if (strlit1811 == NULL) {
    strlit1811 = alloc_String("    ");
    gc_root(strlit1811);
  }
// compilenode returning strlit1811
  int op_slot_right_1810 = gc_frame_newslot(strlit1811);
// compilenode returning *var_spc
  int op_slot_right_1813 = gc_frame_newslot(*var_spc);
  if (strlit1816 == NULL) {
    strlit1816 = alloc_String("""\x0a""");
    gc_root(strlit1816);
  }
// compilenode returning strlit1816
  int op_slot_right_1815 = gc_frame_newslot(strlit1816);
// compilenode returning *var_s
  int op_slot_left_1815 = gc_frame_newslot(*var_s);
  params[0] = strlit1816;
  partcv[0] = 1;
  Object opresult1818 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult1818
  int op_slot_left_1813 = gc_frame_newslot(opresult1818);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1819 = callmethod(opresult1818, "++", 1, partcv, params);
// compilenode returning opresult1819
  int op_slot_left_1810 = gc_frame_newslot(opresult1819);
  params[0] = strlit1811;
  partcv[0] = 1;
  Object opresult1820 = callmethod(opresult1819, "++", 1, partcv, params);
// compilenode returning opresult1820
  int op_slot_left_1807 = gc_frame_newslot(opresult1820);
  params[0] = strlit1808;
  partcv[0] = 1;
  Object opresult1821 = callmethod(opresult1820, "++", 1, partcv, params);
// compilenode returning opresult1821
  int op_slot_left_1797 = gc_frame_newslot(opresult1821);
  params[0] = call1805;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "++", 1, partcv, params);
// compilenode returning opresult1822
  *var_s = opresult1822;
  if (opresult1822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1790 = done;
  } else {
  }
// compilenode returning if1790
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee = &(stackframe->slots[0]);
  *var_matchee = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1541 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1541 = alloc_userobj2(10,11, objclass1541);
  gc_frame_newslot(obj1541);
if (objclass1541 == NULL) {
  glfree(obj1541->class->name);
  obj1541->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1541, self, 0);
  addmethodreal(obj1541,"outer", &reader_ast_outer_1542);
  Object oldself1541 = self;
  struct StackFrameObject *oldstackframe1541 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1541);
  gc_frame_newslot((Object)stackframe);
  self = obj1541;
  Object *oldselfslot1541 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1541 = (*(struct UserObject *)self).data[0], lowerouter1541 = thisouter1541;
  if (inheritingObject1541) {
    struct UserObject *inho1541 = (struct UserObject *)inheritingObject1541;
    while (inho1541->super != GraceDefaultObject) inho1541 = (struct UserObject *)inho1541->super;
    inho1541->super = obj1541;
    self = inheritingObject1541;
    *selfslot = self;
    lowerouter1541 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1541;
  }
if (objclass1541 == NULL) {
  Method *reader1543 = addmethodrealflags(obj1541, "kind",&reader_ast_kind_1543, MFLAG_DEF);
  reader1543->definitionModule = modulename;
  reader1543->definitionLine = 343;
}
adddatum2(obj1541, alloc_Undefined(), 1);
if (objclass1541 == NULL) {
  Method *reader1544 = addmethodrealflags(obj1541, "value",&reader_ast_value_1544, MFLAG_DEF);
  reader1544->definitionModule = modulename;
  reader1544->definitionLine = 344;
}
adddatum2(obj1541, alloc_Undefined(), 2);
if (objclass1541 == NULL) {
  Method *reader1545 = addmethodrealflags(obj1541, "cases",&reader_ast_cases_1545, MFLAG_DEF);
  reader1545->definitionModule = modulename;
  reader1545->definitionLine = 345;
}
adddatum2(obj1541, alloc_Undefined(), 3);
if (objclass1541 == NULL) {
  Method *reader1546 = addmethodrealflags(obj1541, "elsecase",&reader_ast_elsecase_1546, MFLAG_DEF);
  reader1546->definitionModule = modulename;
  reader1546->definitionLine = 346;
}
adddatum2(obj1541, alloc_Undefined(), 4);
  struct UserObject *uo1547 = (struct UserObject*)obj1541;
  uo1547->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1547 = addmethod2pos(obj1541, "accept", &meth_ast_accept1547, 5);
int argcv_meth_ast_accept1547[] = {1};
meth_meth_ast_accept1547->type = alloc_MethodType(1, argcv_meth_ast_accept1547);
meth_meth_ast_accept1547->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1547->type->names[0] = "visitor";
  meth_meth_ast_accept1547->definitionModule = modulename;
  meth_meth_ast_accept1547->definitionLine = 346;
  block_savedest(obj1541);
  Object closure1575 = createclosure(1, "map()before()after");
setclosureframe(closure1575, stackframe);
  addtoclosure(closure1575, var_matchCaseNode);
  struct UserObject *uo1575 = (struct UserObject*)obj1541;
  uo1575->data[6] = (Object)closure1575;
  Method *meth_meth_ast_map_40__41_before_40__41_after1575 = addmethod2pos(obj1541, "map()before()after", &meth_ast_map_40__41_before_40__41_after1575, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1575[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1575->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1575);
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionLine = 357;
  struct UserObject *uo1606 = (struct UserObject*)obj1541;
  uo1606->data[7] = emptyclosure;
  Method *meth_meth_ast_map1606 = addmethod2pos(obj1541, "map", &meth_ast_map1606, 7);
int argcv_meth_ast_map1606[] = {1};
meth_meth_ast_map1606->type = alloc_MethodType(1, argcv_meth_ast_map1606);
  meth_meth_ast_map1606->definitionModule = modulename;
  meth_meth_ast_map1606->definitionLine = 367;
  block_savedest(obj1541);
  Object closure1615 = createclosure(1, "pretty");
setclosureframe(closure1615, stackframe);
  addtoclosure(closure1615, var_matchee);
  struct UserObject *uo1615 = (struct UserObject*)obj1541;
  uo1615->data[8] = (Object)closure1615;
  Method *meth_meth_ast_pretty1615 = addmethod2pos(obj1541, "pretty", &meth_ast_pretty1615, 8);
int argcv_meth_ast_pretty1615[] = {1};
meth_meth_ast_pretty1615->type = alloc_MethodType(1, argcv_meth_ast_pretty1615);
  meth_meth_ast_pretty1615->definitionModule = modulename;
  meth_meth_ast_pretty1615->definitionLine = 370;
  struct UserObject *uo1725 = (struct UserObject*)obj1541;
  uo1725->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1725 = addmethod2pos(obj1541, "toGrace", &meth_ast_toGrace1725, 9);
int argcv_meth_ast_toGrace1725[] = {1};
meth_meth_ast_toGrace1725->type = alloc_MethodType(1, argcv_meth_ast_toGrace1725);
meth_meth_ast_toGrace1725->type->types[0] = type_Number;
meth_meth_ast_toGrace1725->type->names[0] = "depth";
  meth_meth_ast_toGrace1725->definitionModule = modulename;
  meth_meth_ast_toGrace1725->definitionLine = 385;
  sourceObject = obj1541;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1824 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1825 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1824);
// compilenode returning call1825
  struct UserObject *obj1541_uo = (struct UserObject *)obj1541;
  obj1541_uo->super = call1825;
  sourceObject = obj1541;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1826 == NULL) {
    strlit1826 = alloc_String("matchcase");
    gc_root(strlit1826);
  }
// compilenode returning strlit1826
  adddatum2(obj1541, strlit1826, 1);
  sourceObject = obj1541;
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchee
  adddatum2(obj1541, *var_matchee, 2);
  sourceObject = obj1541;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1541, *var_cases_39_, 3);
  sourceObject = obj1541;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elsecase_39_
  adddatum2(obj1541, *var_elsecase_39_, 4);
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
objclass1541 = obj1541->class;
  objclass1541->definitionModule = modulename;
  objclass1541->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1541;
  self = oldself1541;
  selfslot = oldselfslot1541;
  stackframe = oldstackframe1541;
  gc_frame_end(frame);
  return obj1541;
}
Object meth_ast_new1540_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_matchCaseNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_matchee = &(stackframe->slots[0]);
  *var_matchee = args[curarg];
  curarg++;
  Object *var_cases_39_ = &(stackframe->slots[1]);
  *var_cases_39_ = args[curarg];
  curarg++;
  Object *var_elsecase_39_ = &(stackframe->slots[2]);
  *var_elsecase_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1541 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1541 = alloc_userobj2(10,11, objclass1541);
  gc_frame_newslot(obj1541);
if (objclass1541 == NULL) {
  glfree(obj1541->class->name);
  obj1541->class->name = "matchCaseNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1541, self, 0);
  addmethodreal(obj1541,"outer", &reader_ast_outer_1542);
  Object oldself1541 = self;
  struct StackFrameObject *oldstackframe1541 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1541);
  gc_frame_newslot((Object)stackframe);
  self = obj1541;
  Object *oldselfslot1541 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1541 = (*(struct UserObject *)self).data[0], lowerouter1541 = thisouter1541;
  if (inheritingObject1541) {
    struct UserObject *inho1541 = (struct UserObject *)inheritingObject1541;
    while (inho1541->super != GraceDefaultObject) inho1541 = (struct UserObject *)inho1541->super;
    inho1541->super = obj1541;
    self = inheritingObject1541;
    *selfslot = self;
    lowerouter1541 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1541;
  }
if (objclass1541 == NULL) {
  Method *reader1543 = addmethodrealflags(obj1541, "kind",&reader_ast_kind_1543, MFLAG_DEF);
  reader1543->definitionModule = modulename;
  reader1543->definitionLine = 343;
}
adddatum2(obj1541, alloc_Undefined(), 1);
if (objclass1541 == NULL) {
  Method *reader1544 = addmethodrealflags(obj1541, "value",&reader_ast_value_1544, MFLAG_DEF);
  reader1544->definitionModule = modulename;
  reader1544->definitionLine = 344;
}
adddatum2(obj1541, alloc_Undefined(), 2);
if (objclass1541 == NULL) {
  Method *reader1545 = addmethodrealflags(obj1541, "cases",&reader_ast_cases_1545, MFLAG_DEF);
  reader1545->definitionModule = modulename;
  reader1545->definitionLine = 345;
}
adddatum2(obj1541, alloc_Undefined(), 3);
if (objclass1541 == NULL) {
  Method *reader1546 = addmethodrealflags(obj1541, "elsecase",&reader_ast_elsecase_1546, MFLAG_DEF);
  reader1546->definitionModule = modulename;
  reader1546->definitionLine = 346;
}
adddatum2(obj1541, alloc_Undefined(), 4);
  struct UserObject *uo1547 = (struct UserObject*)obj1541;
  uo1547->data[5] = emptyclosure;
  Method *meth_meth_ast_accept1547 = addmethod2pos(obj1541, "accept", &meth_ast_accept1547, 5);
int argcv_meth_ast_accept1547[] = {1};
meth_meth_ast_accept1547->type = alloc_MethodType(1, argcv_meth_ast_accept1547);
meth_meth_ast_accept1547->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1547->type->names[0] = "visitor";
  meth_meth_ast_accept1547->definitionModule = modulename;
  meth_meth_ast_accept1547->definitionLine = 346;
  block_savedest(obj1541);
  Object closure1575 = createclosure(1, "map()before()after");
setclosureframe(closure1575, stackframe);
  addtoclosure(closure1575, var_matchCaseNode);
  struct UserObject *uo1575 = (struct UserObject*)obj1541;
  uo1575->data[6] = (Object)closure1575;
  Method *meth_meth_ast_map_40__41_before_40__41_after1575 = addmethod2pos(obj1541, "map()before()after", &meth_ast_map_40__41_before_40__41_after1575, 6);
int argcv_meth_ast_map_40__41_before_40__41_after1575[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1575->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1575);
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1575->definitionLine = 357;
  struct UserObject *uo1606 = (struct UserObject*)obj1541;
  uo1606->data[7] = emptyclosure;
  Method *meth_meth_ast_map1606 = addmethod2pos(obj1541, "map", &meth_ast_map1606, 7);
int argcv_meth_ast_map1606[] = {1};
meth_meth_ast_map1606->type = alloc_MethodType(1, argcv_meth_ast_map1606);
  meth_meth_ast_map1606->definitionModule = modulename;
  meth_meth_ast_map1606->definitionLine = 367;
  block_savedest(obj1541);
  Object closure1615 = createclosure(1, "pretty");
setclosureframe(closure1615, stackframe);
  addtoclosure(closure1615, var_matchee);
  struct UserObject *uo1615 = (struct UserObject*)obj1541;
  uo1615->data[8] = (Object)closure1615;
  Method *meth_meth_ast_pretty1615 = addmethod2pos(obj1541, "pretty", &meth_ast_pretty1615, 8);
int argcv_meth_ast_pretty1615[] = {1};
meth_meth_ast_pretty1615->type = alloc_MethodType(1, argcv_meth_ast_pretty1615);
  meth_meth_ast_pretty1615->definitionModule = modulename;
  meth_meth_ast_pretty1615->definitionLine = 370;
  struct UserObject *uo1725 = (struct UserObject*)obj1541;
  uo1725->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace1725 = addmethod2pos(obj1541, "toGrace", &meth_ast_toGrace1725, 9);
int argcv_meth_ast_toGrace1725[] = {1};
meth_meth_ast_toGrace1725->type = alloc_MethodType(1, argcv_meth_ast_toGrace1725);
meth_meth_ast_toGrace1725->type->types[0] = type_Number;
meth_meth_ast_toGrace1725->type->names[0] = "depth";
  meth_meth_ast_toGrace1725->definitionModule = modulename;
  meth_meth_ast_toGrace1725->definitionLine = 385;
  sourceObject = obj1541;
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1824 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1825 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe1824);
// compilenode returning call1825
  struct UserObject *obj1541_uo = (struct UserObject *)obj1541;
  obj1541_uo->super = call1825;
  sourceObject = obj1541;
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1826 == NULL) {
    strlit1826 = alloc_String("matchcase");
    gc_root(strlit1826);
  }
// compilenode returning strlit1826
  adddatum2(obj1541, strlit1826, 1);
  sourceObject = obj1541;
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_matchee
  adddatum2(obj1541, *var_matchee, 2);
  sourceObject = obj1541;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cases_39_
  adddatum2(obj1541, *var_cases_39_, 3);
  sourceObject = obj1541;
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elsecase_39_
  adddatum2(obj1541, *var_elsecase_39_, 4);
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
  sourceObject = obj1541;
objclass1541 = obj1541->class;
  objclass1541->definitionModule = modulename;
  objclass1541->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1541;
  self = oldself1541;
  selfslot = oldselfslot1541;
  stackframe = oldstackframe1541;
  gc_frame_end(frame);
  return obj1541;
}
Object meth_ast_methodTypeNode1828(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodTypeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodTypeNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for methodTypeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodTypeNode
  gc_frame_end(frame);
  return *var_methodTypeNode;
}
Object meth_ast__apply1863(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1864 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1865 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe1864);
// compilenode returning call1865
  gc_frame_end(frame);
  return call1865;
}
Object meth_ast__apply1858(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1859 = gc_frame_new();
  int callframe1860 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1861 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe1860);
// compilenode returning call1861
// compilenode returning call1861
  gc_frame_newslot(call1861);
  Object block1862 = alloc_Block(NULL, NULL, "ast", 428);
  gc_frame_newslot(block1862);
  block_savedest(block1862);
  Object closure1863 = createclosure(2, "_apply");
setclosureframe(closure1863, stackframe);
  addtoclosure(closure1863, var_visitor);
  addtoclosure(closure1863, selfslot);
  struct UserObject *uo1863 = (struct UserObject*)block1862;
  uo1863->data[0] = (Object)closure1863;
  Method *meth_meth_ast__apply1863 = addmethod2pos(block1862, "_apply", &meth_ast__apply1863, 0);
int argcv_meth_ast__apply1863[] = {1};
meth_meth_ast__apply1863->type = alloc_MethodType(1, argcv_meth_ast__apply1863);
  meth_meth_ast__apply1863->definitionModule = modulename;
  meth_meth_ast__apply1863->definitionLine = 428;
// compilenode returning block1862
  gc_frame_newslot(block1862);
  params[0] = call1861;
  params[1] = block1862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1867 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1859);
// compilenode returning call1867
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1870 = alloc_Boolean(0);
// compilenode returning bool1870
  int op_slot_right_1869 = gc_frame_newslot(bool1870);
  int callframe1872 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1873 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe1872);
// compilenode returning call1873
// compilenode returning call1873
  int op_slot_left_1869 = gc_frame_newslot(call1873);
  params[0] = bool1870;
  partcv[0] = 1;
  Object opresult1874 = callmethod(call1873, "!=", 1, partcv, params);
// compilenode returning opresult1874
  Object if1868 = done;
  if (istrue(opresult1874)) {
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1875 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1876 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call1877 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe1876);
// compilenode returning call1877
// compilenode returning call1877
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1878 = callmethod(call1877, "accept",
    1, partcv, params);
  gc_frame_end(callframe1875);
// compilenode returning call1878
    gc_frame_newslot(call1878);
    if1868 = call1878;
  } else {
  }
// compilenode returning if1868
  gc_frame_end(frame);
  return if1868;
}
Object meth_ast_accept1839(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1841 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call1842 = callmethod(*var_visitor, "visitMethodType",
    1, partcv, params);
  gc_frame_end(callframe1841);
// compilenode returning call1842
  Object if1840 = done;
  if (istrue(call1842)) {
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1845 = alloc_Boolean(0);
// compilenode returning bool1845
  int op_slot_right_1844 = gc_frame_newslot(bool1845);
  int callframe1847 = gc_frame_new();
  partcv[0] = 0;
  Object call1848 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1847);
// compilenode returning call1848
// compilenode returning call1848
  int op_slot_left_1844 = gc_frame_newslot(call1848);
  params[0] = bool1845;
  partcv[0] = 1;
  Object opresult1849 = callmethod(call1848, "!=", 1, partcv, params);
// compilenode returning opresult1849
  Object if1843 = done;
  if (istrue(opresult1849)) {
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1850 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe1851 = gc_frame_new();
  partcv[0] = 0;
  Object call1852 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1851);
// compilenode returning call1852
// compilenode returning call1852
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call1853 = callmethod(call1852, "accept",
    1, partcv, params);
  gc_frame_end(callframe1850);
// compilenode returning call1853
    gc_frame_newslot(call1853);
    if1843 = call1853;
  } else {
  }
// compilenode returning if1843
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1854 = gc_frame_new();
  int callframe1855 = gc_frame_new();
  partcv[0] = 0;
  Object call1856 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1855);
// compilenode returning call1856
// compilenode returning call1856
  gc_frame_newslot(call1856);
  Object block1857 = alloc_Block(NULL, NULL, "ast", 427);
  gc_frame_newslot(block1857);
  block_savedest(block1857);
  Object closure1858 = createclosure(2, "_apply");
setclosureframe(closure1858, stackframe);
  addtoclosure(closure1858, var_visitor);
  addtoclosure(closure1858, selfslot);
  struct UserObject *uo1858 = (struct UserObject*)block1857;
  uo1858->data[0] = (Object)closure1858;
  Method *meth_meth_ast__apply1858 = addmethod2pos(block1857, "_apply", &meth_ast__apply1858, 0);
int argcv_meth_ast__apply1858[] = {1};
meth_meth_ast__apply1858->type = alloc_MethodType(1, argcv_meth_ast__apply1858);
  meth_meth_ast__apply1858->definitionModule = modulename;
  meth_meth_ast__apply1858->definitionLine = 427;
// compilenode returning block1857
  gc_frame_newslot(block1857);
  params[0] = call1856;
  params[1] = block1857;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1854);
// compilenode returning call1880
    gc_frame_newslot(call1880);
    if1840 = call1880;
  } else {
  }
// compilenode returning if1840
  gc_frame_end(frame);
  return if1840;
}
Object meth_ast_map_40__41_before_40__41_after1881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_rt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rt");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1882 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call1883 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe1882);
// compilenode returning call1883
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1884 = alloc_Boolean(0);
// compilenode returning bool1884
  *var_rt = bool1884;
  if (bool1884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1887 = alloc_Boolean(0);
// compilenode returning bool1887
  int op_slot_right_1886 = gc_frame_newslot(bool1887);
  int callframe1889 = gc_frame_new();
  partcv[0] = 0;
  Object call1890 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1889);
// compilenode returning call1890
  int op_slot_left_1886 = gc_frame_newslot(call1890);
  params[0] = bool1887;
  partcv[0] = 1;
  Object opresult1891 = callmethod(call1890, "!=", 1, partcv, params);
// compilenode returning opresult1891
  Object if1885 = done;
  if (istrue(opresult1891)) {
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1892 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1893 = gc_frame_new();
  partcv[0] = 0;
  Object call1894 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1893);
// compilenode returning call1894
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1895 = callmethod(call1894, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe1892);
// compilenode returning call1895
  *var_rt = call1895;
  if (call1895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1885 = done;
  } else {
  }
// compilenode returning if1885
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1897 = gc_frame_new();
  int callframe1898 = gc_frame_new();
  partcv[0] = 0;
  Object call1899 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1898);
// compilenode returning call1899
  gc_frame_newslot(call1899);
  int callframe1900 = gc_frame_new();
  int callframe1901 = gc_frame_new();
  partcv[0] = 0;
  Object call1902 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1901);
// compilenode returning call1902
  gc_frame_newslot(call1902);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe1903 = gc_frame_new();
  int callframe1904 = gc_frame_new();
  Object call1905 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1904);
// compilenode returning call1905
// compilenode returning call1905
  partcv[0] = 0;
  Object call1906 = callmethodflags(call1905, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1903);
// compilenode returning call1906
// compilenode returning call1906
  params[0] = call1902;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1907 = callmethodflags(call1906, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1900);
// compilenode returning call1907
  gc_frame_newslot(call1907);
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rt
  gc_frame_newslot(*var_rt);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodTypeNode
  params[0] = call1899;
  params[1] = call1907;
  params[2] = *var_rt;
  partcv[0] = 3;
  Object call1908 = callmethod(*var_methodTypeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe1897);
// compilenode returning call1908
  *var_n = call1908;
  if (call1908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1909 = gc_frame_new();
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1910 = gc_frame_new();
  partcv[0] = 0;
  Object call1911 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1910);
// compilenode returning call1911
  gc_frame_newslot(call1911);
// compilenode returning *var_n
  params[0] = call1911;
  partcv[0] = 1;
  Object call1912 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe1909);
// compilenode returning call1912
// compilenode returning done
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1913 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1914 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe1913);
// compilenode returning call1914
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply1918(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply1921(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map1915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1916 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block1917 = alloc_Block(NULL, NULL, "ast", 450);
  gc_frame_newslot(block1917);
  block_savedest(block1917);
  Object closure1918 = createclosure(1, "_apply");
setclosureframe(closure1918, stackframe);
  addtoclosure(closure1918, selfslot);
  struct UserObject *uo1918 = (struct UserObject*)block1917;
  uo1918->data[0] = (Object)closure1918;
  Method *meth_meth_ast__apply1918 = addmethod2pos(block1917, "_apply", &meth_ast__apply1918, 0);
int argcv_meth_ast__apply1918[] = {0};
meth_meth_ast__apply1918->type = alloc_MethodType(1, argcv_meth_ast__apply1918);
  meth_meth_ast__apply1918->definitionModule = modulename;
  meth_meth_ast__apply1918->definitionLine = 443;
// compilenode returning block1917
  gc_frame_newslot(block1917);
  Object block1920 = alloc_Block(NULL, NULL, "ast", 450);
  gc_frame_newslot(block1920);
  block_savedest(block1920);
  Object closure1921 = createclosure(1, "_apply");
setclosureframe(closure1921, stackframe);
  addtoclosure(closure1921, selfslot);
  struct UserObject *uo1921 = (struct UserObject*)block1920;
  uo1921->data[0] = (Object)closure1921;
  Method *meth_meth_ast__apply1921 = addmethod2pos(block1920, "_apply", &meth_ast__apply1921, 0);
int argcv_meth_ast__apply1921[] = {0};
meth_meth_ast__apply1921->type = alloc_MethodType(1, argcv_meth_ast__apply1921);
  meth_meth_ast__apply1921->definitionModule = modulename;
  meth_meth_ast__apply1921->definitionLine = 443;
// compilenode returning block1920
  gc_frame_newslot(block1920);
  params[0] = *var_blk;
  params[1] = block1917;
  params[2] = block1920;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1923 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1916);
// compilenode returning call1923
  gc_frame_end(frame);
  return call1923;
}
Object meth_ast__apply1932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 456
  setline(456);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1934 == NULL) {
    strlit1934 = alloc_String("  ");
    gc_root(strlit1934);
  }
// compilenode returning strlit1934
  int op_slot_right_1933 = gc_frame_newslot(strlit1934);
// compilenode returning *var_spc
  int op_slot_left_1933 = gc_frame_newslot(*var_spc);
  params[0] = strlit1934;
  partcv[0] = 1;
  Object opresult1936 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult1936
  *var_spc = opresult1936;
  if (opresult1936 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2079 == NULL) {
    strlit2079 = alloc_String("");
    gc_root(strlit2079);
  }
// compilenode returning strlit2079
  int op_slot_right_2078 = gc_frame_newslot(strlit2079);
  int callframe2082 = gc_frame_new();
  Object num2084 = alloc_Float64(4);
// compilenode returning num2084
  int op_slot_right_2083 = gc_frame_newslot(num2084);
// compilenode returning *var_depth
  int op_slot_left_2083 = gc_frame_newslot(*var_depth);
  params[0] = num2084;
  partcv[0] = 1;
  Object sum2086 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2086
  gc_frame_newslot(sum2086);
// compilenode returning *var_p
  params[0] = sum2086;
  partcv[0] = 1;
  Object call2087 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2082);
// compilenode returning call2087
  int op_slot_right_2081 = gc_frame_newslot(call2087);
  if (strlit2090 == NULL) {
    strlit2090 = alloc_String("");
    gc_root(strlit2090);
  }
// compilenode returning strlit2090
  int op_slot_right_2089 = gc_frame_newslot(strlit2090);
// compilenode returning *var_spc
  int op_slot_right_2092 = gc_frame_newslot(*var_spc);
  if (strlit2095 == NULL) {
    strlit2095 = alloc_String("""\x0a""      ");
    gc_root(strlit2095);
  }
// compilenode returning strlit2095
  int op_slot_right_2094 = gc_frame_newslot(strlit2095);
// compilenode returning *var_s
  int op_slot_right_2097 = gc_frame_newslot(*var_s);
  if (strlit2099 == NULL) {
    strlit2099 = alloc_String("");
    gc_root(strlit2099);
  }
// compilenode returning strlit2099
  int op_slot_left_2097 = gc_frame_newslot(strlit2099);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2100 = callmethod(strlit2099, "++", 1, partcv, params);
// compilenode returning opresult2100
  int op_slot_left_2094 = gc_frame_newslot(opresult2100);
  params[0] = strlit2095;
  partcv[0] = 1;
  Object opresult2101 = callmethod(opresult2100, "++", 1, partcv, params);
// compilenode returning opresult2101
  int op_slot_left_2092 = gc_frame_newslot(opresult2101);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2102 = callmethod(opresult2101, "++", 1, partcv, params);
// compilenode returning opresult2102
  int op_slot_left_2089 = gc_frame_newslot(opresult2102);
  params[0] = strlit2090;
  partcv[0] = 1;
  Object opresult2103 = callmethod(opresult2102, "++", 1, partcv, params);
// compilenode returning opresult2103
  int op_slot_left_2081 = gc_frame_newslot(opresult2103);
  params[0] = call2087;
  partcv[0] = 1;
  Object opresult2104 = callmethod(opresult2103, "++", 1, partcv, params);
// compilenode returning opresult2104
  int op_slot_left_2078 = gc_frame_newslot(opresult2104);
  params[0] = strlit2079;
  partcv[0] = 1;
  Object opresult2105 = callmethod(opresult2104, "++", 1, partcv, params);
// compilenode returning opresult2105
  *var_s = opresult2105;
  if (opresult2105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2031(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2033 == NULL) {
    strlit2033 = alloc_String("");
    gc_root(strlit2033);
  }
// compilenode returning strlit2033
  int op_slot_right_2032 = gc_frame_newslot(strlit2033);
  int callframe2036 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2037 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2036);
// compilenode returning call2037
// compilenode returning call2037
  int op_slot_right_2035 = gc_frame_newslot(call2037);
  if (strlit2040 == NULL) {
    strlit2040 = alloc_String("Part: ");
    gc_root(strlit2040);
  }
// compilenode returning strlit2040
  int op_slot_right_2039 = gc_frame_newslot(strlit2040);
// compilenode returning *var_spc
  int op_slot_right_2042 = gc_frame_newslot(*var_spc);
  if (strlit2045 == NULL) {
    strlit2045 = alloc_String("""\x0a""  ");
    gc_root(strlit2045);
  }
// compilenode returning strlit2045
  int op_slot_right_2044 = gc_frame_newslot(strlit2045);
// compilenode returning *var_s
  int op_slot_right_2047 = gc_frame_newslot(*var_s);
  if (strlit2049 == NULL) {
    strlit2049 = alloc_String("");
    gc_root(strlit2049);
  }
// compilenode returning strlit2049
  int op_slot_left_2047 = gc_frame_newslot(strlit2049);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2050 = callmethod(strlit2049, "++", 1, partcv, params);
// compilenode returning opresult2050
  int op_slot_left_2044 = gc_frame_newslot(opresult2050);
  params[0] = strlit2045;
  partcv[0] = 1;
  Object opresult2051 = callmethod(opresult2050, "++", 1, partcv, params);
// compilenode returning opresult2051
  int op_slot_left_2042 = gc_frame_newslot(opresult2051);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2052 = callmethod(opresult2051, "++", 1, partcv, params);
// compilenode returning opresult2052
  int op_slot_left_2039 = gc_frame_newslot(opresult2052);
  params[0] = strlit2040;
  partcv[0] = 1;
  Object opresult2053 = callmethod(opresult2052, "++", 1, partcv, params);
// compilenode returning opresult2053
  int op_slot_left_2035 = gc_frame_newslot(opresult2053);
  params[0] = call2037;
  partcv[0] = 1;
  Object opresult2054 = callmethod(opresult2053, "++", 1, partcv, params);
// compilenode returning opresult2054
  int op_slot_left_2032 = gc_frame_newslot(opresult2054);
  params[0] = strlit2033;
  partcv[0] = 1;
  Object opresult2055 = callmethod(opresult2054, "++", 1, partcv, params);
// compilenode returning opresult2055
  *var_s = opresult2055;
  if (opresult2055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2058 == NULL) {
    strlit2058 = alloc_String("Parameters:");
    gc_root(strlit2058);
  }
// compilenode returning strlit2058
  int op_slot_right_2057 = gc_frame_newslot(strlit2058);
// compilenode returning *var_spc
  int op_slot_right_2060 = gc_frame_newslot(*var_spc);
  if (strlit2063 == NULL) {
    strlit2063 = alloc_String("""\x0a""    ");
    gc_root(strlit2063);
  }
// compilenode returning strlit2063
  int op_slot_right_2062 = gc_frame_newslot(strlit2063);
// compilenode returning *var_s
  int op_slot_right_2065 = gc_frame_newslot(*var_s);
  if (strlit2067 == NULL) {
    strlit2067 = alloc_String("");
    gc_root(strlit2067);
  }
// compilenode returning strlit2067
  int op_slot_left_2065 = gc_frame_newslot(strlit2067);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2068 = callmethod(strlit2067, "++", 1, partcv, params);
// compilenode returning opresult2068
  int op_slot_left_2062 = gc_frame_newslot(opresult2068);
  params[0] = strlit2063;
  partcv[0] = 1;
  Object opresult2069 = callmethod(opresult2068, "++", 1, partcv, params);
// compilenode returning opresult2069
  int op_slot_left_2060 = gc_frame_newslot(opresult2069);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2070 = callmethod(opresult2069, "++", 1, partcv, params);
// compilenode returning opresult2070
  int op_slot_left_2057 = gc_frame_newslot(opresult2070);
  params[0] = strlit2058;
  partcv[0] = 1;
  Object opresult2071 = callmethod(opresult2070, "++", 1, partcv, params);
// compilenode returning opresult2071
  *var_s = opresult2071;
  if (opresult2071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2073 = gc_frame_new();
  int callframe2074 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2075 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2074);
// compilenode returning call2075
// compilenode returning call2075
  gc_frame_newslot(call2075);
  Object block2076 = alloc_Block(NULL, NULL, "ast", 466);
  gc_frame_newslot(block2076);
  block_savedest(block2076);
  Object closure2077 = createclosure(4, "_apply");
setclosureframe(closure2077, stackframe);
  addtoclosure(closure2077, var_depth);
  addtoclosure(closure2077, var_spc);
  addtoclosure(closure2077, var_s);
  addtoclosure(closure2077, selfslot);
  struct UserObject *uo2077 = (struct UserObject*)block2076;
  uo2077->data[0] = (Object)closure2077;
  Method *meth_meth_ast__apply2077 = addmethod2pos(block2076, "_apply", &meth_ast__apply2077, 0);
int argcv_meth_ast__apply2077[] = {1};
meth_meth_ast__apply2077->type = alloc_MethodType(1, argcv_meth_ast__apply2077);
  meth_meth_ast__apply2077->definitionModule = modulename;
  meth_meth_ast__apply2077->definitionLine = 466;
// compilenode returning block2076
  gc_frame_newslot(block2076);
  params[0] = call2075;
  params[1] = block2076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2108 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2073);
// compilenode returning call2108
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2111 = alloc_Boolean(0);
// compilenode returning bool2111
  int op_slot_right_2110 = gc_frame_newslot(bool2111);
  int callframe2113 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2114 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2113);
// compilenode returning call2114
// compilenode returning call2114
  int op_slot_left_2110 = gc_frame_newslot(call2114);
  params[0] = bool2111;
  partcv[0] = 1;
  Object opresult2115 = callmethod(call2114, "!=", 1, partcv, params);
// compilenode returning opresult2115
  Object if2109 = done;
  if (istrue(opresult2115)) {
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2117 == NULL) {
    strlit2117 = alloc_String("");
    gc_root(strlit2117);
  }
// compilenode returning strlit2117
  int op_slot_right_2116 = gc_frame_newslot(strlit2117);
  int callframe2120 = gc_frame_new();
  Object num2122 = alloc_Float64(3);
// compilenode returning num2122
  int op_slot_right_2121 = gc_frame_newslot(num2122);
// compilenode returning *var_depth
  int op_slot_left_2121 = gc_frame_newslot(*var_depth);
  params[0] = num2122;
  partcv[0] = 1;
  Object sum2124 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2124
  gc_frame_newslot(sum2124);
  int callframe2125 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2126 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2125);
// compilenode returning call2126
// compilenode returning call2126
  params[0] = sum2124;
  partcv[0] = 1;
  Object call2127 = callmethod(call2126, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2120);
// compilenode returning call2127
  int op_slot_right_2119 = gc_frame_newslot(call2127);
  if (strlit2130 == NULL) {
    strlit2130 = alloc_String("Vararg: ");
    gc_root(strlit2130);
  }
// compilenode returning strlit2130
  int op_slot_right_2129 = gc_frame_newslot(strlit2130);
// compilenode returning *var_spc
  int op_slot_right_2132 = gc_frame_newslot(*var_spc);
  if (strlit2135 == NULL) {
    strlit2135 = alloc_String("""\x0a""    ");
    gc_root(strlit2135);
  }
// compilenode returning strlit2135
  int op_slot_right_2134 = gc_frame_newslot(strlit2135);
// compilenode returning *var_s
  int op_slot_right_2137 = gc_frame_newslot(*var_s);
  if (strlit2139 == NULL) {
    strlit2139 = alloc_String("");
    gc_root(strlit2139);
  }
// compilenode returning strlit2139
  int op_slot_left_2137 = gc_frame_newslot(strlit2139);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2140 = callmethod(strlit2139, "++", 1, partcv, params);
// compilenode returning opresult2140
  int op_slot_left_2134 = gc_frame_newslot(opresult2140);
  params[0] = strlit2135;
  partcv[0] = 1;
  Object opresult2141 = callmethod(opresult2140, "++", 1, partcv, params);
// compilenode returning opresult2141
  int op_slot_left_2132 = gc_frame_newslot(opresult2141);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2142 = callmethod(opresult2141, "++", 1, partcv, params);
// compilenode returning opresult2142
  int op_slot_left_2129 = gc_frame_newslot(opresult2142);
  params[0] = strlit2130;
  partcv[0] = 1;
  Object opresult2143 = callmethod(opresult2142, "++", 1, partcv, params);
// compilenode returning opresult2143
  int op_slot_left_2119 = gc_frame_newslot(opresult2143);
  params[0] = call2127;
  partcv[0] = 1;
  Object opresult2144 = callmethod(opresult2143, "++", 1, partcv, params);
// compilenode returning opresult2144
  int op_slot_left_2116 = gc_frame_newslot(opresult2144);
  params[0] = strlit2117;
  partcv[0] = 1;
  Object opresult2145 = callmethod(opresult2144, "++", 1, partcv, params);
// compilenode returning opresult2145
  *var_s = opresult2145;
  if (opresult2145 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2109 = done;
  } else {
  }
// compilenode returning if2109
  gc_frame_end(frame);
  return if2109;
}
Object meth_ast_pretty1924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1925 == NULL) {
    strlit1925 = alloc_String("");
    gc_root(strlit1925);
  }
// compilenode returning strlit1925
  *var_spc = strlit1925;
  if (strlit1925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1926 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_1927 = gc_frame_newslot(*var_depth);
  Object num1929 = alloc_Float64(0);
// compilenode returning num1929
  int op_slot_left_1927 = gc_frame_newslot(num1929);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult1930 = callmethod(num1929, "..", 1, partcv, params);
// compilenode returning opresult1930
  gc_frame_newslot(opresult1930);
  Object block1931 = alloc_Block(NULL, NULL, "ast", 454);
  gc_frame_newslot(block1931);
  block_savedest(block1931);
  Object closure1932 = createclosure(2, "_apply");
setclosureframe(closure1932, stackframe);
  addtoclosure(closure1932, var_spc);
  addtoclosure(closure1932, selfslot);
  struct UserObject *uo1932 = (struct UserObject*)block1931;
  uo1932->data[0] = (Object)closure1932;
  Method *meth_meth_ast__apply1932 = addmethod2pos(block1931, "_apply", &meth_ast__apply1932, 0);
int argcv_meth_ast__apply1932[] = {1};
meth_meth_ast__apply1932->type = alloc_MethodType(1, argcv_meth_ast__apply1932);
  meth_meth_ast__apply1932->definitionModule = modulename;
  meth_meth_ast__apply1932->definitionLine = 443;
// compilenode returning block1931
  gc_frame_newslot(block1931);
  params[0] = opresult1930;
  params[1] = block1931;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1939 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1926);
// compilenode returning call1939
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1940 == NULL) {
    strlit1940 = alloc_String("MethodType""\x0a""");
    gc_root(strlit1940);
  }
// compilenode returning strlit1940
  *var_s = strlit1940;
  if (strlit1940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1942 == NULL) {
    strlit1942 = alloc_String("""\x0a""");
    gc_root(strlit1942);
  }
// compilenode returning strlit1942
  int op_slot_right_1941 = gc_frame_newslot(strlit1942);
  int callframe1945 = gc_frame_new();
  partcv[0] = 0;
  Object call1946 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1945);
// compilenode returning call1946
  int op_slot_right_1944 = gc_frame_newslot(call1946);
  if (strlit1949 == NULL) {
    strlit1949 = alloc_String("Name: ");
    gc_root(strlit1949);
  }
// compilenode returning strlit1949
  int op_slot_right_1948 = gc_frame_newslot(strlit1949);
// compilenode returning *var_spc
  int op_slot_right_1951 = gc_frame_newslot(*var_spc);
  if (strlit1954 == NULL) {
    strlit1954 = alloc_String("");
    gc_root(strlit1954);
  }
// compilenode returning strlit1954
  int op_slot_right_1953 = gc_frame_newslot(strlit1954);
// compilenode returning *var_s
  int op_slot_right_1956 = gc_frame_newslot(*var_s);
  if (strlit1958 == NULL) {
    strlit1958 = alloc_String("");
    gc_root(strlit1958);
  }
// compilenode returning strlit1958
  int op_slot_left_1956 = gc_frame_newslot(strlit1958);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1959 = callmethod(strlit1958, "++", 1, partcv, params);
// compilenode returning opresult1959
  int op_slot_left_1953 = gc_frame_newslot(opresult1959);
  params[0] = strlit1954;
  partcv[0] = 1;
  Object opresult1960 = callmethod(opresult1959, "++", 1, partcv, params);
// compilenode returning opresult1960
  int op_slot_left_1951 = gc_frame_newslot(opresult1960);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult1961 = callmethod(opresult1960, "++", 1, partcv, params);
// compilenode returning opresult1961
  int op_slot_left_1948 = gc_frame_newslot(opresult1961);
  params[0] = strlit1949;
  partcv[0] = 1;
  Object opresult1962 = callmethod(opresult1961, "++", 1, partcv, params);
// compilenode returning opresult1962
  int op_slot_left_1944 = gc_frame_newslot(opresult1962);
  params[0] = call1946;
  partcv[0] = 1;
  Object opresult1963 = callmethod(opresult1962, "++", 1, partcv, params);
// compilenode returning opresult1963
  int op_slot_left_1941 = gc_frame_newslot(opresult1963);
  params[0] = strlit1942;
  partcv[0] = 1;
  Object opresult1964 = callmethod(opresult1963, "++", 1, partcv, params);
// compilenode returning opresult1964
  *var_s = opresult1964;
  if (opresult1964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1968 = alloc_Boolean(0);
// compilenode returning bool1968
  int op_slot_right_1967 = gc_frame_newslot(bool1968);
  int callframe1970 = gc_frame_new();
  partcv[0] = 0;
  Object call1971 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1970);
// compilenode returning call1971
  int op_slot_left_1967 = gc_frame_newslot(call1971);
  params[0] = bool1968;
  partcv[0] = 1;
  Object opresult1972 = callmethod(call1971, "!=", 1, partcv, params);
// compilenode returning opresult1972
  Object if1966 = done;
  if (istrue(opresult1972)) {
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1974 == NULL) {
    strlit1974 = alloc_String("""\x0a""");
    gc_root(strlit1974);
  }
// compilenode returning strlit1974
  int op_slot_right_1973 = gc_frame_newslot(strlit1974);
  int callframe1977 = gc_frame_new();
  Object num1979 = alloc_Float64(2);
// compilenode returning num1979
  int op_slot_right_1978 = gc_frame_newslot(num1979);
// compilenode returning *var_depth
  int op_slot_left_1978 = gc_frame_newslot(*var_depth);
  params[0] = num1979;
  partcv[0] = 1;
  Object sum1981 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum1981
  gc_frame_newslot(sum1981);
  int callframe1982 = gc_frame_new();
  partcv[0] = 0;
  Object call1983 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1982);
// compilenode returning call1983
  params[0] = sum1981;
  partcv[0] = 1;
  Object call1984 = callmethod(call1983, "pretty",
    1, partcv, params);
  gc_frame_end(callframe1977);
// compilenode returning call1984
  int op_slot_right_1976 = gc_frame_newslot(call1984);
  if (strlit1987 == NULL) {
    strlit1987 = alloc_String("");
    gc_root(strlit1987);
  }
// compilenode returning strlit1987
  int op_slot_right_1986 = gc_frame_newslot(strlit1987);
// compilenode returning *var_spc
  int op_slot_right_1989 = gc_frame_newslot(*var_spc);
  if (strlit1992 == NULL) {
    strlit1992 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit1992);
  }
// compilenode returning strlit1992
  int op_slot_right_1991 = gc_frame_newslot(strlit1992);
// compilenode returning *var_spc
  int op_slot_right_1994 = gc_frame_newslot(*var_spc);
  if (strlit1997 == NULL) {
    strlit1997 = alloc_String("");
    gc_root(strlit1997);
  }
// compilenode returning strlit1997
  int op_slot_right_1996 = gc_frame_newslot(strlit1997);
// compilenode returning *var_s
  int op_slot_right_1999 = gc_frame_newslot(*var_s);
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("");
    gc_root(strlit2001);
  }
// compilenode returning strlit2001
  int op_slot_left_1999 = gc_frame_newslot(strlit2001);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2002 = callmethod(strlit2001, "++", 1, partcv, params);
// compilenode returning opresult2002
  int op_slot_left_1996 = gc_frame_newslot(opresult2002);
  params[0] = strlit1997;
  partcv[0] = 1;
  Object opresult2003 = callmethod(opresult2002, "++", 1, partcv, params);
// compilenode returning opresult2003
  int op_slot_left_1994 = gc_frame_newslot(opresult2003);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2004 = callmethod(opresult2003, "++", 1, partcv, params);
// compilenode returning opresult2004
  int op_slot_left_1991 = gc_frame_newslot(opresult2004);
  params[0] = strlit1992;
  partcv[0] = 1;
  Object opresult2005 = callmethod(opresult2004, "++", 1, partcv, params);
// compilenode returning opresult2005
  int op_slot_left_1989 = gc_frame_newslot(opresult2005);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2006 = callmethod(opresult2005, "++", 1, partcv, params);
// compilenode returning opresult2006
  int op_slot_left_1986 = gc_frame_newslot(opresult2006);
  params[0] = strlit1987;
  partcv[0] = 1;
  Object opresult2007 = callmethod(opresult2006, "++", 1, partcv, params);
// compilenode returning opresult2007
  int op_slot_left_1976 = gc_frame_newslot(opresult2007);
  params[0] = call1984;
  partcv[0] = 1;
  Object opresult2008 = callmethod(opresult2007, "++", 1, partcv, params);
// compilenode returning opresult2008
  int op_slot_left_1973 = gc_frame_newslot(opresult2008);
  params[0] = strlit1974;
  partcv[0] = 1;
  Object opresult2009 = callmethod(opresult2008, "++", 1, partcv, params);
// compilenode returning opresult2009
  *var_s = opresult2009;
  if (opresult2009 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1966 = done;
  } else {
  }
// compilenode returning if1966
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2012 == NULL) {
    strlit2012 = alloc_String("Signature:");
    gc_root(strlit2012);
  }
// compilenode returning strlit2012
  int op_slot_right_2011 = gc_frame_newslot(strlit2012);
// compilenode returning *var_spc
  int op_slot_right_2014 = gc_frame_newslot(*var_spc);
  if (strlit2017 == NULL) {
    strlit2017 = alloc_String("");
    gc_root(strlit2017);
  }
// compilenode returning strlit2017
  int op_slot_right_2016 = gc_frame_newslot(strlit2017);
// compilenode returning *var_s
  int op_slot_right_2019 = gc_frame_newslot(*var_s);
  if (strlit2021 == NULL) {
    strlit2021 = alloc_String("");
    gc_root(strlit2021);
  }
// compilenode returning strlit2021
  int op_slot_left_2019 = gc_frame_newslot(strlit2021);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2022 = callmethod(strlit2021, "++", 1, partcv, params);
// compilenode returning opresult2022
  int op_slot_left_2016 = gc_frame_newslot(opresult2022);
  params[0] = strlit2017;
  partcv[0] = 1;
  Object opresult2023 = callmethod(opresult2022, "++", 1, partcv, params);
// compilenode returning opresult2023
  int op_slot_left_2014 = gc_frame_newslot(opresult2023);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2024 = callmethod(opresult2023, "++", 1, partcv, params);
// compilenode returning opresult2024
  int op_slot_left_2011 = gc_frame_newslot(opresult2024);
  params[0] = strlit2012;
  partcv[0] = 1;
  Object opresult2025 = callmethod(opresult2024, "++", 1, partcv, params);
// compilenode returning opresult2025
  *var_s = opresult2025;
  if (opresult2025 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2027 = gc_frame_new();
  int callframe2028 = gc_frame_new();
  partcv[0] = 0;
  Object call2029 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2028);
// compilenode returning call2029
  gc_frame_newslot(call2029);
  Object block2030 = alloc_Block(NULL, NULL, "ast", 463);
  gc_frame_newslot(block2030);
  block_savedest(block2030);
  Object closure2031 = createclosure(4, "_apply");
setclosureframe(closure2031, stackframe);
  addtoclosure(closure2031, var_spc);
  addtoclosure(closure2031, var_s);
  addtoclosure(closure2031, var_depth);
  addtoclosure(closure2031, selfslot);
  struct UserObject *uo2031 = (struct UserObject*)block2030;
  uo2031->data[0] = (Object)closure2031;
  Method *meth_meth_ast__apply2031 = addmethod2pos(block2030, "_apply", &meth_ast__apply2031, 0);
int argcv_meth_ast__apply2031[] = {1};
meth_meth_ast__apply2031->type = alloc_MethodType(1, argcv_meth_ast__apply2031);
  meth_meth_ast__apply2031->definitionModule = modulename;
  meth_meth_ast__apply2031->definitionLine = 443;
// compilenode returning block2030
  gc_frame_newslot(block2030);
  params[0] = call2029;
  params[1] = block2030;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2148 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2027);
// compilenode returning call2148
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2191(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2192 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2193 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2192);
// compilenode returning call2193
// compilenode returning call2193
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2194 = callmethod(call2193, "[]", 1, partcv, params);
// compilenode returning idxres2194
  *var_p = idxres2194;
  if (idxres2194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2196 = gc_frame_new();
  Object num2198 = alloc_Float64(1);
// compilenode returning num2198
  int op_slot_right_2197 = gc_frame_newslot(num2198);
// compilenode returning *var_depth
  int op_slot_left_2197 = gc_frame_newslot(*var_depth);
  params[0] = num2198;
  partcv[0] = 1;
  Object sum2200 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2200
  gc_frame_newslot(sum2200);
// compilenode returning *var_p
  params[0] = sum2200;
  partcv[0] = 1;
  Object call2201 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2196);
// compilenode returning call2201
  int op_slot_right_2195 = gc_frame_newslot(call2201);
// compilenode returning *var_s
  int op_slot_left_2195 = gc_frame_newslot(*var_s);
  params[0] = call2201;
  partcv[0] = 1;
  Object opresult2203 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2203
  *var_s = opresult2203;
  if (opresult2203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2208 = alloc_Boolean(0);
// compilenode returning bool2208
  int op_slot_right_2207 = gc_frame_newslot(bool2208);
  int callframe2210 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2211 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2210);
// compilenode returning call2211
// compilenode returning call2211
  int op_slot_left_2207 = gc_frame_newslot(call2211);
  params[0] = bool2208;
  partcv[0] = 1;
  Object opresult2212 = callmethod(call2211, "!=", 1, partcv, params);
// compilenode returning opresult2212
  int op_slot_right_2206 = gc_frame_newslot(opresult2212);
  int callframe2215 = gc_frame_new();
  int callframe2216 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2217 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2216);
// compilenode returning call2217
// compilenode returning call2217
  partcv[0] = 0;
  Object call2218 = callmethod(call2217, "size",
    1, partcv, params);
  gc_frame_end(callframe2215);
// compilenode returning call2218
// compilenode returning call2218
  int op_slot_right_2214 = gc_frame_newslot(call2218);
// compilenode returning *var_pnr
  int op_slot_left_2214 = gc_frame_newslot(*var_pnr);
  params[0] = call2218;
  partcv[0] = 1;
  Object opresult2220 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult2220
  int op_slot_left_2206 = gc_frame_newslot(opresult2220);
  params[0] = opresult2212;
  partcv[0] = 1;
  Object opresult2221 = callmethod(opresult2220, "||", 1, partcv, params);
// compilenode returning opresult2221
  Object if2205 = done;
  if (istrue(opresult2221)) {
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2223 == NULL) {
    strlit2223 = alloc_String(", ");
    gc_root(strlit2223);
  }
// compilenode returning strlit2223
  int op_slot_right_2222 = gc_frame_newslot(strlit2223);
// compilenode returning *var_s
  int op_slot_left_2222 = gc_frame_newslot(*var_s);
  params[0] = strlit2223;
  partcv[0] = 1;
  Object opresult2225 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2225
  *var_s = opresult2225;
  if (opresult2225 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2205 = done;
  } else {
  }
// compilenode returning if2205
  gc_frame_end(frame);
  return if2205;
}
Object meth_ast__apply2155(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 478
  setline(478);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2157 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2158 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe2157);
// compilenode returning call2158
// compilenode returning call2158
  int op_slot_right_2156 = gc_frame_newslot(call2158);
// compilenode returning *var_s
  int op_slot_left_2156 = gc_frame_newslot(*var_s);
  params[0] = call2158;
  partcv[0] = 1;
  Object opresult2160 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2160
  *var_s = opresult2160;
  if (opresult2160 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2165 = alloc_Boolean(0);
// compilenode returning bool2165
  int op_slot_right_2164 = gc_frame_newslot(bool2165);
  int callframe2167 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2168 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2167);
// compilenode returning call2168
// compilenode returning call2168
  int op_slot_left_2164 = gc_frame_newslot(call2168);
  params[0] = bool2165;
  partcv[0] = 1;
  Object opresult2169 = callmethod(call2168, "!=", 1, partcv, params);
// compilenode returning opresult2169
  int op_slot_right_2163 = gc_frame_newslot(opresult2169);
  Object num2172 = alloc_Float64(0);
// compilenode returning num2172
  int op_slot_right_2171 = gc_frame_newslot(num2172);
  int callframe2174 = gc_frame_new();
  int callframe2175 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2176 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2175);
// compilenode returning call2176
// compilenode returning call2176
  partcv[0] = 0;
  Object call2177 = callmethod(call2176, "size",
    1, partcv, params);
  gc_frame_end(callframe2174);
// compilenode returning call2177
// compilenode returning call2177
  int op_slot_left_2171 = gc_frame_newslot(call2177);
  params[0] = num2172;
  partcv[0] = 1;
  Object opresult2178 = callmethod(call2177, ">", 1, partcv, params);
// compilenode returning opresult2178
  int op_slot_left_2163 = gc_frame_newslot(opresult2178);
  params[0] = opresult2169;
  partcv[0] = 1;
  Object opresult2179 = callmethod(opresult2178, "||", 1, partcv, params);
// compilenode returning opresult2179
  Object if2162 = done;
  if (istrue(opresult2179)) {
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2181 == NULL) {
    strlit2181 = alloc_String("(");
    gc_root(strlit2181);
  }
// compilenode returning strlit2181
  int op_slot_right_2180 = gc_frame_newslot(strlit2181);
// compilenode returning *var_s
  int op_slot_left_2180 = gc_frame_newslot(*var_s);
  params[0] = strlit2181;
  partcv[0] = 1;
  Object opresult2183 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2183
  *var_s = opresult2183;
  if (opresult2183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2185 = gc_frame_new();
  int callframe2186 = gc_frame_new();
  int callframe2187 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2188 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe2187);
// compilenode returning call2188
// compilenode returning call2188
  partcv[0] = 0;
  Object call2189 = callmethod(call2188, "indices",
    1, partcv, params);
  gc_frame_end(callframe2186);
// compilenode returning call2189
// compilenode returning call2189
  gc_frame_newslot(call2189);
  Object block2190 = alloc_Block(NULL, NULL, "ast", 481);
  gc_frame_newslot(block2190);
  block_savedest(block2190);
  Object closure2191 = createclosure(4, "_apply");
setclosureframe(closure2191, stackframe);
  addtoclosure(closure2191, var_part);
  addtoclosure(closure2191, var_depth);
  addtoclosure(closure2191, var_s);
  addtoclosure(closure2191, selfslot);
  struct UserObject *uo2191 = (struct UserObject*)block2190;
  uo2191->data[0] = (Object)closure2191;
  Method *meth_meth_ast__apply2191 = addmethod2pos(block2190, "_apply", &meth_ast__apply2191, 0);
int argcv_meth_ast__apply2191[] = {1};
meth_meth_ast__apply2191->type = alloc_MethodType(1, argcv_meth_ast__apply2191);
  meth_meth_ast__apply2191->definitionModule = modulename;
  meth_meth_ast__apply2191->definitionLine = 481;
// compilenode returning block2190
  gc_frame_newslot(block2190);
  params[0] = call2189;
  params[1] = block2190;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2228 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2185);
// compilenode returning call2228
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2231 = alloc_Boolean(0);
// compilenode returning bool2231
  int op_slot_right_2230 = gc_frame_newslot(bool2231);
  int callframe2233 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2234 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2233);
// compilenode returning call2234
// compilenode returning call2234
  int op_slot_left_2230 = gc_frame_newslot(call2234);
  params[0] = bool2231;
  partcv[0] = 1;
  Object opresult2235 = callmethod(call2234, "!=", 1, partcv, params);
// compilenode returning opresult2235
  Object if2229 = done;
  if (istrue(opresult2235)) {
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2237 = gc_frame_new();
  int callframe2238 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call2239 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe2238);
// compilenode returning call2239
// compilenode returning call2239
  partcv[0] = 0;
  Object call2240 = callmethod(call2239, "value",
    1, partcv, params);
  gc_frame_end(callframe2237);
// compilenode returning call2240
// compilenode returning call2240
  int op_slot_right_2236 = gc_frame_newslot(call2240);
  if (strlit2243 == NULL) {
    strlit2243 = alloc_String("*");
    gc_root(strlit2243);
  }
// compilenode returning strlit2243
  int op_slot_right_2242 = gc_frame_newslot(strlit2243);
// compilenode returning *var_s
  int op_slot_left_2242 = gc_frame_newslot(*var_s);
  params[0] = strlit2243;
  partcv[0] = 1;
  Object opresult2245 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2245
  int op_slot_left_2236 = gc_frame_newslot(opresult2245);
  params[0] = call2240;
  partcv[0] = 1;
  Object opresult2246 = callmethod(opresult2245, "++", 1, partcv, params);
// compilenode returning opresult2246
  *var_s = opresult2246;
  if (opresult2246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2229 = done;
  } else {
  }
// compilenode returning if2229
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2249 == NULL) {
    strlit2249 = alloc_String(")");
    gc_root(strlit2249);
  }
// compilenode returning strlit2249
  int op_slot_right_2248 = gc_frame_newslot(strlit2249);
// compilenode returning *var_s
  int op_slot_left_2248 = gc_frame_newslot(*var_s);
  params[0] = strlit2249;
  partcv[0] = 1;
  Object opresult2251 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2251
  *var_s = opresult2251;
  if (opresult2251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2162 = done;
  } else {
  }
// compilenode returning if2162
  gc_frame_end(frame);
  return if2162;
}
Object meth_ast_toGrace2149(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2150 == NULL) {
    strlit2150 = alloc_String("");
    gc_root(strlit2150);
  }
// compilenode returning strlit2150
  *var_s = strlit2150;
  if (strlit2150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2151 = gc_frame_new();
  int callframe2152 = gc_frame_new();
  partcv[0] = 0;
  Object call2153 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2152);
// compilenode returning call2153
// compilenode returning call2153
  gc_frame_newslot(call2153);
  Object block2154 = alloc_Block(NULL, NULL, "ast", 477);
  gc_frame_newslot(block2154);
  block_savedest(block2154);
  Object closure2155 = createclosure(3, "_apply");
setclosureframe(closure2155, stackframe);
  addtoclosure(closure2155, var_s);
  addtoclosure(closure2155, var_depth);
  addtoclosure(closure2155, selfslot);
  struct UserObject *uo2155 = (struct UserObject*)block2154;
  uo2155->data[0] = (Object)closure2155;
  Method *meth_meth_ast__apply2155 = addmethod2pos(block2154, "_apply", &meth_ast__apply2155, 0);
int argcv_meth_ast__apply2155[] = {1};
meth_meth_ast__apply2155->type = alloc_MethodType(1, argcv_meth_ast__apply2155);
  meth_meth_ast__apply2155->definitionModule = modulename;
  meth_meth_ast__apply2155->definitionLine = 477;
// compilenode returning block2154
  gc_frame_newslot(block2154);
  params[0] = call2153;
  params[1] = block2154;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2254 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2151);
// compilenode returning call2254
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2257 = alloc_Boolean(0);
// compilenode returning bool2257
  int op_slot_right_2256 = gc_frame_newslot(bool2257);
  int callframe2259 = gc_frame_new();
  partcv[0] = 0;
  Object call2260 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2259);
// compilenode returning call2260
// compilenode returning call2260
  int op_slot_left_2256 = gc_frame_newslot(call2260);
  params[0] = bool2257;
  partcv[0] = 1;
  Object opresult2261 = callmethod(call2260, "!=", 1, partcv, params);
// compilenode returning opresult2261
  Object if2255 = done;
  if (istrue(opresult2261)) {
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2263 = gc_frame_new();
  Object num2265 = alloc_Float64(1);
// compilenode returning num2265
  int op_slot_right_2264 = gc_frame_newslot(num2265);
// compilenode returning *var_depth
  int op_slot_left_2264 = gc_frame_newslot(*var_depth);
  params[0] = num2265;
  partcv[0] = 1;
  Object sum2267 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2267
  gc_frame_newslot(sum2267);
  int callframe2268 = gc_frame_new();
  partcv[0] = 0;
  Object call2269 = callmethodflags(self, "rtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2268);
// compilenode returning call2269
// compilenode returning call2269
  params[0] = sum2267;
  partcv[0] = 1;
  Object call2270 = callmethod(call2269, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2263);
// compilenode returning call2270
  int op_slot_right_2262 = gc_frame_newslot(call2270);
  if (strlit2273 == NULL) {
    strlit2273 = alloc_String(" -> ");
    gc_root(strlit2273);
  }
// compilenode returning strlit2273
  int op_slot_right_2272 = gc_frame_newslot(strlit2273);
// compilenode returning *var_s
  int op_slot_left_2272 = gc_frame_newslot(*var_s);
  params[0] = strlit2273;
  partcv[0] = 1;
  Object opresult2275 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2275
  int op_slot_left_2262 = gc_frame_newslot(opresult2275);
  params[0] = call2270;
  partcv[0] = 1;
  Object opresult2276 = callmethod(opresult2275, "++", 1, partcv, params);
// compilenode returning opresult2276
  *var_s = opresult2276;
  if (opresult2276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2255 = done;
  } else {
  }
// compilenode returning if2255
// Begin line 497
  setline(497);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new1831(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1832 = alloc_userobj2(12,12, objclass1832);
  gc_frame_newslot(obj1832);
if (objclass1832 == NULL) {
  glfree(obj1832->class->name);
  obj1832->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1832, self, 0);
  addmethodreal(obj1832,"outer", &reader_ast_outer_1833);
  Object oldself1832 = self;
  struct StackFrameObject *oldstackframe1832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1832);
  gc_frame_newslot((Object)stackframe);
  self = obj1832;
  Object *oldselfslot1832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1832 = (*(struct UserObject *)self).data[0], lowerouter1832 = thisouter1832;
  if (inheritingObject1832) {
    struct UserObject *inho1832 = (struct UserObject *)inheritingObject1832;
    while (inho1832->super != GraceDefaultObject) inho1832 = (struct UserObject *)inho1832->super;
    inho1832->super = obj1832;
    self = inheritingObject1832;
    *selfslot = self;
    lowerouter1832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1832;
  }
if (objclass1832 == NULL) {
  Method *reader1834 = addmethodrealflags(obj1832, "kind",&reader_ast_kind_1834, MFLAG_DEF);
  reader1834->definitionModule = modulename;
  reader1834->definitionLine = 418;
}
adddatum2(obj1832, alloc_Undefined(), 1);
if (objclass1832 == NULL) {
  Method *reader1835 = addmethodrealflags(obj1832, "value",&reader_ast_value_1835, MFLAG_DEF);
  reader1835->definitionModule = modulename;
  reader1835->definitionLine = 419;
}
adddatum2(obj1832, alloc_Undefined(), 2);
if (objclass1832 == NULL) {
  Method *reader1836 = addmethodrealflags(obj1832, "signature",&reader_ast_signature_1836, MFLAG_DEF);
  reader1836->definitionModule = modulename;
  reader1836->definitionLine = 420;
}
adddatum2(obj1832, alloc_Undefined(), 3);
if (objclass1832 == NULL) {
  Method *reader1837 = addmethodrealflags(obj1832, "rtype",&reader_ast_rtype_1837, MFLAG_DEF);
  reader1837->definitionModule = modulename;
  reader1837->definitionLine = 421;
}
adddatum2(obj1832, alloc_Undefined(), 4);
if (objclass1832 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1832, "generics",&reader_ast_generics_1838, 0);
  Method *writer1838 = addmethodrealflags(obj1832, "generics:=",&writer_ast_generics_1838, 0);
  reader1838->definitionModule = modulename;
  writer1838->definitionModule = modulename;
  reader1838->definitionLine = 422;
  writer1838->definitionLine = 422;
}
obj1832->flags |= OFLAG_MUTABLE;
adddatum2(obj1832, alloc_Undefined(), 5);
  struct UserObject *uo1839 = (struct UserObject*)obj1832;
  uo1839->data[6] = emptyclosure;
  Method *meth_meth_ast_accept1839 = addmethod2pos(obj1832, "accept", &meth_ast_accept1839, 6);
int argcv_meth_ast_accept1839[] = {1};
meth_meth_ast_accept1839->type = alloc_MethodType(1, argcv_meth_ast_accept1839);
meth_meth_ast_accept1839->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1839->type->names[0] = "visitor";
  meth_meth_ast_accept1839->definitionModule = modulename;
  meth_meth_ast_accept1839->definitionLine = 422;
  block_savedest(obj1832);
  Object closure1881 = createclosure(1, "map()before()after");
setclosureframe(closure1881, stackframe);
  addtoclosure(closure1881, var_methodTypeNode);
  struct UserObject *uo1881 = (struct UserObject*)obj1832;
  uo1881->data[7] = (Object)closure1881;
  Method *meth_meth_ast_map_40__41_before_40__41_after1881 = addmethod2pos(obj1832, "map()before()after", &meth_ast_map_40__41_before_40__41_after1881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after1881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1881);
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionLine = 437;
  struct UserObject *uo1915 = (struct UserObject*)obj1832;
  uo1915->data[8] = emptyclosure;
  Method *meth_meth_ast_map1915 = addmethod2pos(obj1832, "map", &meth_ast_map1915, 8);
int argcv_meth_ast_map1915[] = {1};
meth_meth_ast_map1915->type = alloc_MethodType(1, argcv_meth_ast_map1915);
  meth_meth_ast_map1915->definitionModule = modulename;
  meth_meth_ast_map1915->definitionLine = 449;
  struct UserObject *uo1924 = (struct UserObject*)obj1832;
  uo1924->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty1924 = addmethod2pos(obj1832, "pretty", &meth_ast_pretty1924, 9);
int argcv_meth_ast_pretty1924[] = {1};
meth_meth_ast_pretty1924->type = alloc_MethodType(1, argcv_meth_ast_pretty1924);
  meth_meth_ast_pretty1924->definitionModule = modulename;
  meth_meth_ast_pretty1924->definitionLine = 452;
  struct UserObject *uo2149 = (struct UserObject*)obj1832;
  uo2149->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2149 = addmethod2pos(obj1832, "toGrace", &meth_ast_toGrace2149, 10);
int argcv_meth_ast_toGrace2149[] = {1};
meth_meth_ast_toGrace2149->type = alloc_MethodType(1, argcv_meth_ast_toGrace2149);
meth_meth_ast_toGrace2149->type->types[0] = type_Number;
meth_meth_ast_toGrace2149->type->names[0] = "depth";
  meth_meth_ast_toGrace2149->definitionModule = modulename;
  meth_meth_ast_toGrace2149->definitionLine = 475;
  sourceObject = obj1832;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2278);
// compilenode returning call2279
  struct UserObject *obj1832_uo = (struct UserObject *)obj1832;
  obj1832_uo->super = call2279;
  sourceObject = obj1832;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("methodtype");
    gc_root(strlit2280);
  }
// compilenode returning strlit2280
  adddatum2(obj1832, strlit2280, 1);
  sourceObject = obj1832;
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj1832, *var_name_39_, 2);
  sourceObject = obj1832;
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj1832, *var_signature_39_, 3);
  sourceObject = obj1832;
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rtype_39_
  adddatum2(obj1832, *var_rtype_39_, 4);
  sourceObject = obj1832;
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2281 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2281
  adddatum2(obj1832, array2281, 5);
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
objclass1832 = obj1832->class;
  objclass1832->definitionModule = modulename;
  objclass1832->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1832;
  self = oldself1832;
  selfslot = oldselfslot1832;
  stackframe = oldstackframe1832;
  gc_frame_end(frame);
  return obj1832;
}
Object meth_ast_new1831_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodTypeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_rtype_39_ = &(stackframe->slots[2]);
  *var_rtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1832 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1832 = alloc_userobj2(12,12, objclass1832);
  gc_frame_newslot(obj1832);
if (objclass1832 == NULL) {
  glfree(obj1832->class->name);
  obj1832->class->name = "methodTypeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1832, self, 0);
  addmethodreal(obj1832,"outer", &reader_ast_outer_1833);
  Object oldself1832 = self;
  struct StackFrameObject *oldstackframe1832 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1832);
  gc_frame_newslot((Object)stackframe);
  self = obj1832;
  Object *oldselfslot1832 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1832 = (*(struct UserObject *)self).data[0], lowerouter1832 = thisouter1832;
  if (inheritingObject1832) {
    struct UserObject *inho1832 = (struct UserObject *)inheritingObject1832;
    while (inho1832->super != GraceDefaultObject) inho1832 = (struct UserObject *)inho1832->super;
    inho1832->super = obj1832;
    self = inheritingObject1832;
    *selfslot = self;
    lowerouter1832 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1832;
  }
if (objclass1832 == NULL) {
  Method *reader1834 = addmethodrealflags(obj1832, "kind",&reader_ast_kind_1834, MFLAG_DEF);
  reader1834->definitionModule = modulename;
  reader1834->definitionLine = 418;
}
adddatum2(obj1832, alloc_Undefined(), 1);
if (objclass1832 == NULL) {
  Method *reader1835 = addmethodrealflags(obj1832, "value",&reader_ast_value_1835, MFLAG_DEF);
  reader1835->definitionModule = modulename;
  reader1835->definitionLine = 419;
}
adddatum2(obj1832, alloc_Undefined(), 2);
if (objclass1832 == NULL) {
  Method *reader1836 = addmethodrealflags(obj1832, "signature",&reader_ast_signature_1836, MFLAG_DEF);
  reader1836->definitionModule = modulename;
  reader1836->definitionLine = 420;
}
adddatum2(obj1832, alloc_Undefined(), 3);
if (objclass1832 == NULL) {
  Method *reader1837 = addmethodrealflags(obj1832, "rtype",&reader_ast_rtype_1837, MFLAG_DEF);
  reader1837->definitionModule = modulename;
  reader1837->definitionLine = 421;
}
adddatum2(obj1832, alloc_Undefined(), 4);
if (objclass1832 == NULL) {
  Method *reader1838 = addmethodrealflags(obj1832, "generics",&reader_ast_generics_1838, 0);
  Method *writer1838 = addmethodrealflags(obj1832, "generics:=",&writer_ast_generics_1838, 0);
  reader1838->definitionModule = modulename;
  writer1838->definitionModule = modulename;
  reader1838->definitionLine = 422;
  writer1838->definitionLine = 422;
}
obj1832->flags |= OFLAG_MUTABLE;
adddatum2(obj1832, alloc_Undefined(), 5);
  struct UserObject *uo1839 = (struct UserObject*)obj1832;
  uo1839->data[6] = emptyclosure;
  Method *meth_meth_ast_accept1839 = addmethod2pos(obj1832, "accept", &meth_ast_accept1839, 6);
int argcv_meth_ast_accept1839[] = {1};
meth_meth_ast_accept1839->type = alloc_MethodType(1, argcv_meth_ast_accept1839);
meth_meth_ast_accept1839->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept1839->type->names[0] = "visitor";
  meth_meth_ast_accept1839->definitionModule = modulename;
  meth_meth_ast_accept1839->definitionLine = 422;
  block_savedest(obj1832);
  Object closure1881 = createclosure(1, "map()before()after");
setclosureframe(closure1881, stackframe);
  addtoclosure(closure1881, var_methodTypeNode);
  struct UserObject *uo1881 = (struct UserObject*)obj1832;
  uo1881->data[7] = (Object)closure1881;
  Method *meth_meth_ast_map_40__41_before_40__41_after1881 = addmethod2pos(obj1832, "map()before()after", &meth_ast_map_40__41_before_40__41_after1881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after1881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after1881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after1881);
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after1881->definitionLine = 437;
  struct UserObject *uo1915 = (struct UserObject*)obj1832;
  uo1915->data[8] = emptyclosure;
  Method *meth_meth_ast_map1915 = addmethod2pos(obj1832, "map", &meth_ast_map1915, 8);
int argcv_meth_ast_map1915[] = {1};
meth_meth_ast_map1915->type = alloc_MethodType(1, argcv_meth_ast_map1915);
  meth_meth_ast_map1915->definitionModule = modulename;
  meth_meth_ast_map1915->definitionLine = 449;
  struct UserObject *uo1924 = (struct UserObject*)obj1832;
  uo1924->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty1924 = addmethod2pos(obj1832, "pretty", &meth_ast_pretty1924, 9);
int argcv_meth_ast_pretty1924[] = {1};
meth_meth_ast_pretty1924->type = alloc_MethodType(1, argcv_meth_ast_pretty1924);
  meth_meth_ast_pretty1924->definitionModule = modulename;
  meth_meth_ast_pretty1924->definitionLine = 452;
  struct UserObject *uo2149 = (struct UserObject*)obj1832;
  uo2149->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace2149 = addmethod2pos(obj1832, "toGrace", &meth_ast_toGrace2149, 10);
int argcv_meth_ast_toGrace2149[] = {1};
meth_meth_ast_toGrace2149->type = alloc_MethodType(1, argcv_meth_ast_toGrace2149);
meth_meth_ast_toGrace2149->type->types[0] = type_Number;
meth_meth_ast_toGrace2149->type->names[0] = "depth";
  meth_meth_ast_toGrace2149->definitionModule = modulename;
  meth_meth_ast_toGrace2149->definitionLine = 475;
  sourceObject = obj1832;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe2278);
// compilenode returning call2279
  struct UserObject *obj1832_uo = (struct UserObject *)obj1832;
  obj1832_uo->super = call2279;
  sourceObject = obj1832;
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("methodtype");
    gc_root(strlit2280);
  }
// compilenode returning strlit2280
  adddatum2(obj1832, strlit2280, 1);
  sourceObject = obj1832;
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj1832, *var_name_39_, 2);
  sourceObject = obj1832;
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj1832, *var_signature_39_, 3);
  sourceObject = obj1832;
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_rtype_39_
  adddatum2(obj1832, *var_rtype_39_, 4);
  sourceObject = obj1832;
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2281 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2281
  adddatum2(obj1832, array2281, 5);
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
  sourceObject = obj1832;
objclass1832 = obj1832->class;
  objclass1832->definitionModule = modulename;
  objclass1832->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1832;
  self = oldself1832;
  selfslot = oldselfslot1832;
  stackframe = oldstackframe1832;
  gc_frame_end(frame);
  return obj1832;
}
Object meth_ast_typeNode2283(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "typeNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_typeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for typeNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for typeNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_typeNode
  gc_frame_end(frame);
  return *var_typeNode;
}
Object meth_ast__apply2315(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2316 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ut
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2317 = callmethod(*var_ut, "accept",
    1, partcv, params);
  gc_frame_end(callframe2316);
// compilenode returning call2317
  gc_frame_end(frame);
  return call2317;
}
Object meth_ast__apply2333(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2334 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_it
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2335 = callmethod(*var_it, "accept",
    1, partcv, params);
  gc_frame_end(callframe2334);
// compilenode returning call2335
  gc_frame_end(frame);
  return call2335;
}
Object meth_ast__apply2342(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2343 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call2344 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe2343);
// compilenode returning call2344
  gc_frame_end(frame);
  return call2344;
}
Object meth_ast_accept2298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2300 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call2301 = callmethod(*var_visitor, "visitType",
    1, partcv, params);
  gc_frame_end(callframe2300);
// compilenode returning call2301
  Object if2299 = done;
  if (istrue(call2301)) {
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2304 = alloc_Float64(0);
// compilenode returning num2304
  int op_slot_right_2303 = gc_frame_newslot(num2304);
  int callframe2306 = gc_frame_new();
  int callframe2307 = gc_frame_new();
  partcv[0] = 0;
  Object call2308 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2307);
// compilenode returning call2308
// compilenode returning call2308
  partcv[0] = 0;
  Object call2309 = callmethod(call2308, "size",
    1, partcv, params);
  gc_frame_end(callframe2306);
// compilenode returning call2309
// compilenode returning call2309
  int op_slot_left_2303 = gc_frame_newslot(call2309);
  params[0] = num2304;
  partcv[0] = 1;
  Object opresult2310 = callmethod(call2309, ">", 1, partcv, params);
// compilenode returning opresult2310
  Object if2302 = done;
  if (istrue(opresult2310)) {
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2311 = gc_frame_new();
  int callframe2312 = gc_frame_new();
  partcv[0] = 0;
  Object call2313 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2312);
// compilenode returning call2313
// compilenode returning call2313
  gc_frame_newslot(call2313);
  Object block2314 = alloc_Block(NULL, NULL, "ast", 514);
  gc_frame_newslot(block2314);
  block_savedest(block2314);
  Object closure2315 = createclosure(2, "_apply");
setclosureframe(closure2315, stackframe);
  addtoclosure(closure2315, var_visitor);
  addtoclosure(closure2315, selfslot);
  struct UserObject *uo2315 = (struct UserObject*)block2314;
  uo2315->data[0] = (Object)closure2315;
  Method *meth_meth_ast__apply2315 = addmethod2pos(block2314, "_apply", &meth_ast__apply2315, 0);
int argcv_meth_ast__apply2315[] = {1};
meth_meth_ast__apply2315->type = alloc_MethodType(1, argcv_meth_ast__apply2315);
  meth_meth_ast__apply2315->definitionModule = modulename;
  meth_meth_ast__apply2315->definitionLine = 514;
// compilenode returning block2314
  gc_frame_newslot(block2314);
  params[0] = call2313;
  params[1] = block2314;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2319 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2311);
// compilenode returning call2319
    gc_frame_newslot(call2319);
    if2302 = call2319;
  } else {
  }
// compilenode returning if2302
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2322 = alloc_Float64(0);
// compilenode returning num2322
  int op_slot_right_2321 = gc_frame_newslot(num2322);
  int callframe2324 = gc_frame_new();
  int callframe2325 = gc_frame_new();
  partcv[0] = 0;
  Object call2326 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2325);
// compilenode returning call2326
// compilenode returning call2326
  partcv[0] = 0;
  Object call2327 = callmethod(call2326, "size",
    1, partcv, params);
  gc_frame_end(callframe2324);
// compilenode returning call2327
// compilenode returning call2327
  int op_slot_left_2321 = gc_frame_newslot(call2327);
  params[0] = num2322;
  partcv[0] = 1;
  Object opresult2328 = callmethod(call2327, ">", 1, partcv, params);
// compilenode returning opresult2328
  Object if2320 = done;
  if (istrue(opresult2328)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2329 = gc_frame_new();
  int callframe2330 = gc_frame_new();
  partcv[0] = 0;
  Object call2331 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2330);
// compilenode returning call2331
// compilenode returning call2331
  gc_frame_newslot(call2331);
  Object block2332 = alloc_Block(NULL, NULL, "ast", 519);
  gc_frame_newslot(block2332);
  block_savedest(block2332);
  Object closure2333 = createclosure(2, "_apply");
setclosureframe(closure2333, stackframe);
  addtoclosure(closure2333, var_visitor);
  addtoclosure(closure2333, selfslot);
  struct UserObject *uo2333 = (struct UserObject*)block2332;
  uo2333->data[0] = (Object)closure2333;
  Method *meth_meth_ast__apply2333 = addmethod2pos(block2332, "_apply", &meth_ast__apply2333, 0);
int argcv_meth_ast__apply2333[] = {1};
meth_meth_ast__apply2333->type = alloc_MethodType(1, argcv_meth_ast__apply2333);
  meth_meth_ast__apply2333->definitionModule = modulename;
  meth_meth_ast__apply2333->definitionLine = 519;
// compilenode returning block2332
  gc_frame_newslot(block2332);
  params[0] = call2331;
  params[1] = block2332;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2337 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2329);
// compilenode returning call2337
    gc_frame_newslot(call2337);
    if2320 = call2337;
  } else {
  }
// compilenode returning if2320
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2338 = gc_frame_new();
  int callframe2339 = gc_frame_new();
  partcv[0] = 0;
  Object call2340 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2339);
// compilenode returning call2340
// compilenode returning call2340
  gc_frame_newslot(call2340);
  Object block2341 = alloc_Block(NULL, NULL, "ast", 523);
  gc_frame_newslot(block2341);
  block_savedest(block2341);
  Object closure2342 = createclosure(2, "_apply");
setclosureframe(closure2342, stackframe);
  addtoclosure(closure2342, var_visitor);
  addtoclosure(closure2342, selfslot);
  struct UserObject *uo2342 = (struct UserObject*)block2341;
  uo2342->data[0] = (Object)closure2342;
  Method *meth_meth_ast__apply2342 = addmethod2pos(block2341, "_apply", &meth_ast__apply2342, 0);
int argcv_meth_ast__apply2342[] = {1};
meth_meth_ast__apply2342->type = alloc_MethodType(1, argcv_meth_ast__apply2342);
  meth_meth_ast__apply2342->definitionModule = modulename;
  meth_meth_ast__apply2342->definitionLine = 523;
// compilenode returning block2341
  gc_frame_newslot(block2341);
  params[0] = call2340;
  params[1] = block2341;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2346 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compilenode returning call2346
    gc_frame_newslot(call2346);
    if2299 = call2346;
  } else {
  }
// compilenode returning if2299
  gc_frame_end(frame);
  return if2299;
}
Object meth_ast__apply2383(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2384 = gc_frame_new();
  int callframe2385 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2386 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2385);
// compilenode returning call2386
  gc_frame_newslot(call2386);
  int callframe2387 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2388 = callmethod(*var_n, "unionTypes",
    1, partcv, params);
  gc_frame_end(callframe2387);
// compilenode returning call2388
// compilenode returning call2388
  params[0] = call2386;
  partcv[0] = 1;
  Object call2389 = callmethod(call2388, "push",
    1, partcv, params);
  gc_frame_end(callframe2384);
// compilenode returning call2389
  gc_frame_end(frame);
  return call2389;
}
Object meth_ast__apply2402(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2403 = gc_frame_new();
  int callframe2404 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2405 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2404);
// compilenode returning call2405
  gc_frame_newslot(call2405);
  int callframe2406 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2407 = callmethod(*var_n, "intersectionTypes",
    1, partcv, params);
  gc_frame_end(callframe2406);
// compilenode returning call2407
// compilenode returning call2407
  params[0] = call2405;
  partcv[0] = 1;
  Object call2408 = callmethod(call2407, "push",
    1, partcv, params);
  gc_frame_end(callframe2403);
// compilenode returning call2408
  gc_frame_end(frame);
  return call2408;
}
Object meth_ast__apply2421(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2422 = gc_frame_new();
  int callframe2423 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2424 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2423);
// compilenode returning call2424
  gc_frame_newslot(call2424);
  int callframe2425 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2426 = callmethod(*var_n, "generics",
    1, partcv, params);
  gc_frame_end(callframe2425);
// compilenode returning call2426
// compilenode returning call2426
  params[0] = call2424;
  partcv[0] = 1;
  Object call2427 = callmethod(call2426, "push",
    1, partcv, params);
  gc_frame_end(callframe2422);
// compilenode returning call2427
  gc_frame_end(frame);
  return call2427;
}
Object meth_ast__apply2440(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2441 = gc_frame_new();
  int callframe2442 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2443 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe2442);
// compilenode returning call2443
  gc_frame_newslot(call2443);
  int callframe2444 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call2445 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe2444);
// compilenode returning call2445
// compilenode returning call2445
  params[0] = call2443;
  partcv[0] = 1;
  Object call2446 = callmethod(call2445, "push",
    1, partcv, params);
  gc_frame_end(callframe2441);
// compilenode returning call2446
  gc_frame_end(frame);
  return call2446;
}
Object meth_ast_map_40__41_before_40__41_after2347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_typeNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2348 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call2349 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe2348);
// compilenode returning call2349
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2350 = gc_frame_new();
  int callframe2351 = gc_frame_new();
  partcv[0] = 0;
  Object call2352 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2351);
// compilenode returning call2352
  gc_frame_newslot(call2352);
  int callframe2353 = gc_frame_new();
  int callframe2354 = gc_frame_new();
  partcv[0] = 0;
  Object call2355 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2354);
// compilenode returning call2355
  gc_frame_newslot(call2355);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2356 = gc_frame_new();
  int callframe2357 = gc_frame_new();
  Object call2358 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2357);
// compilenode returning call2358
// compilenode returning call2358
  partcv[0] = 0;
  Object call2359 = callmethodflags(call2358, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2356);
// compilenode returning call2359
// compilenode returning call2359
  params[0] = call2355;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2360 = callmethodflags(call2359, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compilenode returning call2360
  gc_frame_newslot(call2360);
// compilenode returning *var_typeNode
  params[0] = call2352;
  params[1] = call2360;
  partcv[0] = 2;
  Object call2361 = callmethod(*var_typeNode, "new",
    1, partcv, params);
  gc_frame_end(callframe2350);
// compilenode returning call2361
  *var_n = call2361;
  if (call2361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2362 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2363 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe2362);
// compilenode returning call2363
  *var_n = call2363;
  if (call2363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2365 = gc_frame_new();
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2366 = gc_frame_new();
  partcv[0] = 0;
  Object call2367 = callmethodflags(self, "anonymous", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2366);
// compilenode returning call2367
// compilenode returning call2367
  gc_frame_newslot(call2367);
// compilenode returning *var_n
  params[0] = call2367;
  partcv[0] = 1;
  Object call2368 = callmethod(*var_n, "anonymous:=",
    1, partcv, params);
  gc_frame_end(callframe2365);
// compilenode returning call2368
// compilenode returning done
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2369 = gc_frame_new();
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2370 = gc_frame_new();
  partcv[0] = 0;
  Object call2371 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2370);
// compilenode returning call2371
  gc_frame_newslot(call2371);
// compilenode returning *var_n
  params[0] = call2371;
  partcv[0] = 1;
  Object call2372 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe2369);
// compilenode returning call2372
// compilenode returning done
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2373 = gc_frame_new();
  int callframe2374 = gc_frame_new();
  int callframe2375 = gc_frame_new();
  partcv[0] = 0;
  Object call2376 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2375);
// compilenode returning call2376
  gc_frame_newslot(call2376);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2377 = gc_frame_new();
  int callframe2378 = gc_frame_new();
  Object call2379 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2378);
// compilenode returning call2379
// compilenode returning call2379
  partcv[0] = 0;
  Object call2380 = callmethodflags(call2379, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2377);
// compilenode returning call2380
// compilenode returning call2380
  params[0] = call2376;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2381 = callmethodflags(call2380, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2374);
// compilenode returning call2381
  gc_frame_newslot(call2381);
  Object block2382 = alloc_Block(NULL, NULL, "ast", 534);
  gc_frame_newslot(block2382);
  block_savedest(block2382);
  Object closure2383 = createclosure(5, "_apply");
setclosureframe(closure2383, stackframe);
  addtoclosure(closure2383, var_blk);
  addtoclosure(closure2383, var_blkBefore);
  addtoclosure(closure2383, var_blkAfter);
  addtoclosure(closure2383, var_n);
  addtoclosure(closure2383, selfslot);
  struct UserObject *uo2383 = (struct UserObject*)block2382;
  uo2383->data[0] = (Object)closure2383;
  Method *meth_meth_ast__apply2383 = addmethod2pos(block2382, "_apply", &meth_ast__apply2383, 0);
int argcv_meth_ast__apply2383[] = {1};
meth_meth_ast__apply2383->type = alloc_MethodType(1, argcv_meth_ast__apply2383);
  meth_meth_ast__apply2383->definitionModule = modulename;
  meth_meth_ast__apply2383->definitionLine = 534;
// compilenode returning block2382
  gc_frame_newslot(block2382);
  params[0] = call2381;
  params[1] = block2382;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2391 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2373);
// compilenode returning call2391
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2392 = gc_frame_new();
  int callframe2393 = gc_frame_new();
  int callframe2394 = gc_frame_new();
  partcv[0] = 0;
  Object call2395 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2394);
// compilenode returning call2395
  gc_frame_newslot(call2395);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2396 = gc_frame_new();
  int callframe2397 = gc_frame_new();
  Object call2398 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2397);
// compilenode returning call2398
// compilenode returning call2398
  partcv[0] = 0;
  Object call2399 = callmethodflags(call2398, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2396);
// compilenode returning call2399
// compilenode returning call2399
  params[0] = call2395;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2400 = callmethodflags(call2399, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2393);
// compilenode returning call2400
  gc_frame_newslot(call2400);
  Object block2401 = alloc_Block(NULL, NULL, "ast", 537);
  gc_frame_newslot(block2401);
  block_savedest(block2401);
  Object closure2402 = createclosure(5, "_apply");
setclosureframe(closure2402, stackframe);
  addtoclosure(closure2402, var_blk);
  addtoclosure(closure2402, var_blkBefore);
  addtoclosure(closure2402, var_blkAfter);
  addtoclosure(closure2402, var_n);
  addtoclosure(closure2402, selfslot);
  struct UserObject *uo2402 = (struct UserObject*)block2401;
  uo2402->data[0] = (Object)closure2402;
  Method *meth_meth_ast__apply2402 = addmethod2pos(block2401, "_apply", &meth_ast__apply2402, 0);
int argcv_meth_ast__apply2402[] = {1};
meth_meth_ast__apply2402->type = alloc_MethodType(1, argcv_meth_ast__apply2402);
  meth_meth_ast__apply2402->definitionModule = modulename;
  meth_meth_ast__apply2402->definitionLine = 537;
// compilenode returning block2401
  gc_frame_newslot(block2401);
  params[0] = call2400;
  params[1] = block2401;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2410 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2392);
// compilenode returning call2410
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2411 = gc_frame_new();
  int callframe2412 = gc_frame_new();
  int callframe2413 = gc_frame_new();
  partcv[0] = 0;
  Object call2414 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2413);
// compilenode returning call2414
  gc_frame_newslot(call2414);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2415 = gc_frame_new();
  int callframe2416 = gc_frame_new();
  Object call2417 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2416);
// compilenode returning call2417
// compilenode returning call2417
  partcv[0] = 0;
  Object call2418 = callmethodflags(call2417, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2415);
// compilenode returning call2418
// compilenode returning call2418
  params[0] = call2414;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2419 = callmethodflags(call2418, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2412);
// compilenode returning call2419
  gc_frame_newslot(call2419);
  Object block2420 = alloc_Block(NULL, NULL, "ast", 540);
  gc_frame_newslot(block2420);
  block_savedest(block2420);
  Object closure2421 = createclosure(5, "_apply");
setclosureframe(closure2421, stackframe);
  addtoclosure(closure2421, var_blk);
  addtoclosure(closure2421, var_blkBefore);
  addtoclosure(closure2421, var_blkAfter);
  addtoclosure(closure2421, var_n);
  addtoclosure(closure2421, selfslot);
  struct UserObject *uo2421 = (struct UserObject*)block2420;
  uo2421->data[0] = (Object)closure2421;
  Method *meth_meth_ast__apply2421 = addmethod2pos(block2420, "_apply", &meth_ast__apply2421, 0);
int argcv_meth_ast__apply2421[] = {1};
meth_meth_ast__apply2421->type = alloc_MethodType(1, argcv_meth_ast__apply2421);
  meth_meth_ast__apply2421->definitionModule = modulename;
  meth_meth_ast__apply2421->definitionLine = 540;
// compilenode returning block2420
  gc_frame_newslot(block2420);
  params[0] = call2419;
  params[1] = block2420;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2429 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2411);
// compilenode returning call2429
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2430 = gc_frame_new();
  int callframe2431 = gc_frame_new();
  int callframe2432 = gc_frame_new();
  partcv[0] = 0;
  Object call2433 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2432);
// compilenode returning call2433
  gc_frame_newslot(call2433);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe2434 = gc_frame_new();
  int callframe2435 = gc_frame_new();
  Object call2436 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2435);
// compilenode returning call2436
// compilenode returning call2436
  partcv[0] = 0;
  Object call2437 = callmethodflags(call2436, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2434);
// compilenode returning call2437
// compilenode returning call2437
  params[0] = call2433;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2438 = callmethodflags(call2437, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2431);
// compilenode returning call2438
  gc_frame_newslot(call2438);
  Object block2439 = alloc_Block(NULL, NULL, "ast", 543);
  gc_frame_newslot(block2439);
  block_savedest(block2439);
  Object closure2440 = createclosure(5, "_apply");
setclosureframe(closure2440, stackframe);
  addtoclosure(closure2440, var_blk);
  addtoclosure(closure2440, var_blkBefore);
  addtoclosure(closure2440, var_blkAfter);
  addtoclosure(closure2440, var_n);
  addtoclosure(closure2440, selfslot);
  struct UserObject *uo2440 = (struct UserObject*)block2439;
  uo2440->data[0] = (Object)closure2440;
  Method *meth_meth_ast__apply2440 = addmethod2pos(block2439, "_apply", &meth_ast__apply2440, 0);
int argcv_meth_ast__apply2440[] = {1};
meth_meth_ast__apply2440->type = alloc_MethodType(1, argcv_meth_ast__apply2440);
  meth_meth_ast__apply2440->definitionModule = modulename;
  meth_meth_ast__apply2440->definitionLine = 543;
// compilenode returning block2439
  gc_frame_newslot(block2439);
  params[0] = call2438;
  params[1] = block2439;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2448 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2430);
// compilenode returning call2448
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2449 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2450 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compilenode returning call2450
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply2454(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2457(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map2451(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2452 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block2453 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2453);
  block_savedest(block2453);
  Object closure2454 = createclosure(1, "_apply");
setclosureframe(closure2454, stackframe);
  addtoclosure(closure2454, selfslot);
  struct UserObject *uo2454 = (struct UserObject*)block2453;
  uo2454->data[0] = (Object)closure2454;
  Method *meth_meth_ast__apply2454 = addmethod2pos(block2453, "_apply", &meth_ast__apply2454, 0);
int argcv_meth_ast__apply2454[] = {0};
meth_meth_ast__apply2454->type = alloc_MethodType(1, argcv_meth_ast__apply2454);
  meth_meth_ast__apply2454->definitionModule = modulename;
  meth_meth_ast__apply2454->definitionLine = 544;
// compilenode returning block2453
  gc_frame_newslot(block2453);
  Object block2456 = alloc_Block(NULL, NULL, "ast", 550);
  gc_frame_newslot(block2456);
  block_savedest(block2456);
  Object closure2457 = createclosure(1, "_apply");
setclosureframe(closure2457, stackframe);
  addtoclosure(closure2457, selfslot);
  struct UserObject *uo2457 = (struct UserObject*)block2456;
  uo2457->data[0] = (Object)closure2457;
  Method *meth_meth_ast__apply2457 = addmethod2pos(block2456, "_apply", &meth_ast__apply2457, 0);
int argcv_meth_ast__apply2457[] = {0};
meth_meth_ast__apply2457->type = alloc_MethodType(1, argcv_meth_ast__apply2457);
  meth_meth_ast__apply2457->definitionModule = modulename;
  meth_meth_ast__apply2457->definitionLine = 544;
// compilenode returning block2456
  gc_frame_newslot(block2456);
  params[0] = *var_blk;
  params[1] = block2453;
  params[2] = block2456;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2459 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2452);
// compilenode returning call2459
  gc_frame_end(frame);
  return call2459;
}
Object meth_ast__apply2468(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2470 == NULL) {
    strlit2470 = alloc_String("  ");
    gc_root(strlit2470);
  }
// compilenode returning strlit2470
  int op_slot_right_2469 = gc_frame_newslot(strlit2470);
// compilenode returning *var_spc
  int op_slot_left_2469 = gc_frame_newslot(*var_spc);
  params[0] = strlit2470;
  partcv[0] = 1;
  Object opresult2472 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult2472
  *var_spc = opresult2472;
  if (opresult2472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2531(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 562
  setline(562);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2533 == NULL) {
    strlit2533 = alloc_String("""\x0a""");
    gc_root(strlit2533);
  }
// compilenode returning strlit2533
  int op_slot_right_2532 = gc_frame_newslot(strlit2533);
  int callframe2536 = gc_frame_new();
// compilenode returning *var_ut
  partcv[0] = 0;
  Object call2537 = callmethod(*var_ut, "value",
    1, partcv, params);
  gc_frame_end(callframe2536);
// compilenode returning call2537
// compilenode returning call2537
  int op_slot_right_2535 = gc_frame_newslot(call2537);
  if (strlit2540 == NULL) {
    strlit2540 = alloc_String("  ");
    gc_root(strlit2540);
  }
// compilenode returning strlit2540
  int op_slot_right_2539 = gc_frame_newslot(strlit2540);
// compilenode returning *var_spc
  int op_slot_right_2542 = gc_frame_newslot(*var_spc);
  if (strlit2545 == NULL) {
    strlit2545 = alloc_String("");
    gc_root(strlit2545);
  }
// compilenode returning strlit2545
  int op_slot_right_2544 = gc_frame_newslot(strlit2545);
// compilenode returning *var_s
  int op_slot_right_2547 = gc_frame_newslot(*var_s);
  if (strlit2549 == NULL) {
    strlit2549 = alloc_String("");
    gc_root(strlit2549);
  }
// compilenode returning strlit2549
  int op_slot_left_2547 = gc_frame_newslot(strlit2549);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2550 = callmethod(strlit2549, "++", 1, partcv, params);
// compilenode returning opresult2550
  int op_slot_left_2544 = gc_frame_newslot(opresult2550);
  params[0] = strlit2545;
  partcv[0] = 1;
  Object opresult2551 = callmethod(opresult2550, "++", 1, partcv, params);
// compilenode returning opresult2551
  int op_slot_left_2542 = gc_frame_newslot(opresult2551);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2552 = callmethod(opresult2551, "++", 1, partcv, params);
// compilenode returning opresult2552
  int op_slot_left_2539 = gc_frame_newslot(opresult2552);
  params[0] = strlit2540;
  partcv[0] = 1;
  Object opresult2553 = callmethod(opresult2552, "++", 1, partcv, params);
// compilenode returning opresult2553
  int op_slot_left_2535 = gc_frame_newslot(opresult2553);
  params[0] = call2537;
  partcv[0] = 1;
  Object opresult2554 = callmethod(opresult2553, "++", 1, partcv, params);
// compilenode returning opresult2554
  int op_slot_left_2532 = gc_frame_newslot(opresult2554);
  params[0] = strlit2533;
  partcv[0] = 1;
  Object opresult2555 = callmethod(opresult2554, "++", 1, partcv, params);
// compilenode returning opresult2555
  *var_s = opresult2555;
  if (opresult2555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2588(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2590 == NULL) {
    strlit2590 = alloc_String("""\x0a""");
    gc_root(strlit2590);
  }
// compilenode returning strlit2590
  int op_slot_right_2589 = gc_frame_newslot(strlit2590);
  int callframe2593 = gc_frame_new();
// compilenode returning *var_ut
  partcv[0] = 0;
  Object call2594 = callmethod(*var_ut, "value",
    1, partcv, params);
  gc_frame_end(callframe2593);
// compilenode returning call2594
// compilenode returning call2594
  int op_slot_right_2592 = gc_frame_newslot(call2594);
  if (strlit2597 == NULL) {
    strlit2597 = alloc_String("  ");
    gc_root(strlit2597);
  }
// compilenode returning strlit2597
  int op_slot_right_2596 = gc_frame_newslot(strlit2597);
// compilenode returning *var_spc
  int op_slot_right_2599 = gc_frame_newslot(*var_spc);
  if (strlit2602 == NULL) {
    strlit2602 = alloc_String("");
    gc_root(strlit2602);
  }
// compilenode returning strlit2602
  int op_slot_right_2601 = gc_frame_newslot(strlit2602);
// compilenode returning *var_s
  int op_slot_right_2604 = gc_frame_newslot(*var_s);
  if (strlit2606 == NULL) {
    strlit2606 = alloc_String("");
    gc_root(strlit2606);
  }
// compilenode returning strlit2606
  int op_slot_left_2604 = gc_frame_newslot(strlit2606);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2607 = callmethod(strlit2606, "++", 1, partcv, params);
// compilenode returning opresult2607
  int op_slot_left_2601 = gc_frame_newslot(opresult2607);
  params[0] = strlit2602;
  partcv[0] = 1;
  Object opresult2608 = callmethod(opresult2607, "++", 1, partcv, params);
// compilenode returning opresult2608
  int op_slot_left_2599 = gc_frame_newslot(opresult2608);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2609 = callmethod(opresult2608, "++", 1, partcv, params);
// compilenode returning opresult2609
  int op_slot_left_2596 = gc_frame_newslot(opresult2609);
  params[0] = strlit2597;
  partcv[0] = 1;
  Object opresult2610 = callmethod(opresult2609, "++", 1, partcv, params);
// compilenode returning opresult2610
  int op_slot_left_2592 = gc_frame_newslot(opresult2610);
  params[0] = call2594;
  partcv[0] = 1;
  Object opresult2611 = callmethod(opresult2610, "++", 1, partcv, params);
// compilenode returning opresult2611
  int op_slot_left_2589 = gc_frame_newslot(opresult2611);
  params[0] = strlit2590;
  partcv[0] = 1;
  Object opresult2612 = callmethod(opresult2611, "++", 1, partcv, params);
// compilenode returning opresult2612
  *var_s = opresult2612;
  if (opresult2612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2645(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2647 == NULL) {
    strlit2647 = alloc_String("""\x0a""");
    gc_root(strlit2647);
  }
// compilenode returning strlit2647
  int op_slot_right_2646 = gc_frame_newslot(strlit2647);
  int callframe2650 = gc_frame_new();
// compilenode returning *var_it
  partcv[0] = 0;
  Object call2651 = callmethod(*var_it, "value",
    1, partcv, params);
  gc_frame_end(callframe2650);
// compilenode returning call2651
// compilenode returning call2651
  int op_slot_right_2649 = gc_frame_newslot(call2651);
  if (strlit2654 == NULL) {
    strlit2654 = alloc_String("  ");
    gc_root(strlit2654);
  }
// compilenode returning strlit2654
  int op_slot_right_2653 = gc_frame_newslot(strlit2654);
// compilenode returning *var_spc
  int op_slot_right_2656 = gc_frame_newslot(*var_spc);
  if (strlit2659 == NULL) {
    strlit2659 = alloc_String("");
    gc_root(strlit2659);
  }
// compilenode returning strlit2659
  int op_slot_right_2658 = gc_frame_newslot(strlit2659);
// compilenode returning *var_s
  int op_slot_right_2661 = gc_frame_newslot(*var_s);
  if (strlit2663 == NULL) {
    strlit2663 = alloc_String("");
    gc_root(strlit2663);
  }
// compilenode returning strlit2663
  int op_slot_left_2661 = gc_frame_newslot(strlit2663);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2664 = callmethod(strlit2663, "++", 1, partcv, params);
// compilenode returning opresult2664
  int op_slot_left_2658 = gc_frame_newslot(opresult2664);
  params[0] = strlit2659;
  partcv[0] = 1;
  Object opresult2665 = callmethod(opresult2664, "++", 1, partcv, params);
// compilenode returning opresult2665
  int op_slot_left_2656 = gc_frame_newslot(opresult2665);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2666 = callmethod(opresult2665, "++", 1, partcv, params);
// compilenode returning opresult2666
  int op_slot_left_2653 = gc_frame_newslot(opresult2666);
  params[0] = strlit2654;
  partcv[0] = 1;
  Object opresult2667 = callmethod(opresult2666, "++", 1, partcv, params);
// compilenode returning opresult2667
  int op_slot_left_2649 = gc_frame_newslot(opresult2667);
  params[0] = call2651;
  partcv[0] = 1;
  Object opresult2668 = callmethod(opresult2667, "++", 1, partcv, params);
// compilenode returning opresult2668
  int op_slot_left_2646 = gc_frame_newslot(opresult2668);
  params[0] = strlit2647;
  partcv[0] = 1;
  Object opresult2669 = callmethod(opresult2668, "++", 1, partcv, params);
// compilenode returning opresult2669
  *var_s = opresult2669;
  if (opresult2669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2687 = gc_frame_new();
  Object num2689 = alloc_Float64(2);
// compilenode returning num2689
  int op_slot_right_2688 = gc_frame_newslot(num2689);
// compilenode returning *var_depth
  int op_slot_left_2688 = gc_frame_newslot(*var_depth);
  params[0] = num2689;
  partcv[0] = 1;
  Object sum2691 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2691
  gc_frame_newslot(sum2691);
// compilenode returning *var_mx
  params[0] = sum2691;
  partcv[0] = 1;
  Object call2692 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe2687);
// compilenode returning call2692
  int op_slot_right_2686 = gc_frame_newslot(call2692);
// compilenode returning *var_spc
  int op_slot_right_2694 = gc_frame_newslot(*var_spc);
  if (strlit2697 == NULL) {
    strlit2697 = alloc_String("""\x0a""  ");
    gc_root(strlit2697);
  }
// compilenode returning strlit2697
  int op_slot_right_2696 = gc_frame_newslot(strlit2697);
// compilenode returning *var_s
  int op_slot_left_2696 = gc_frame_newslot(*var_s);
  params[0] = strlit2697;
  partcv[0] = 1;
  Object opresult2699 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2699
  int op_slot_left_2694 = gc_frame_newslot(opresult2699);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2700 = callmethod(opresult2699, "++", 1, partcv, params);
// compilenode returning opresult2700
  int op_slot_left_2686 = gc_frame_newslot(opresult2700);
  params[0] = call2692;
  partcv[0] = 1;
  Object opresult2701 = callmethod(opresult2700, "++", 1, partcv, params);
// compilenode returning opresult2701
  *var_s = opresult2701;
  if (opresult2701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty2460(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2461 == NULL) {
    strlit2461 = alloc_String("");
    gc_root(strlit2461);
  }
// compilenode returning strlit2461
  *var_spc = strlit2461;
  if (strlit2461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2462 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_2463 = gc_frame_newslot(*var_depth);
  Object num2465 = alloc_Float64(0);
// compilenode returning num2465
  int op_slot_left_2463 = gc_frame_newslot(num2465);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult2466 = callmethod(num2465, "..", 1, partcv, params);
// compilenode returning opresult2466
  gc_frame_newslot(opresult2466);
  Object block2467 = alloc_Block(NULL, NULL, "ast", 554);
  gc_frame_newslot(block2467);
  block_savedest(block2467);
  Object closure2468 = createclosure(2, "_apply");
setclosureframe(closure2468, stackframe);
  addtoclosure(closure2468, var_spc);
  addtoclosure(closure2468, selfslot);
  struct UserObject *uo2468 = (struct UserObject*)block2467;
  uo2468->data[0] = (Object)closure2468;
  Method *meth_meth_ast__apply2468 = addmethod2pos(block2467, "_apply", &meth_ast__apply2468, 0);
int argcv_meth_ast__apply2468[] = {1};
meth_meth_ast__apply2468->type = alloc_MethodType(1, argcv_meth_ast__apply2468);
  meth_meth_ast__apply2468->definitionModule = modulename;
  meth_meth_ast__apply2468->definitionLine = 544;
// compilenode returning block2467
  gc_frame_newslot(block2467);
  params[0] = opresult2466;
  params[1] = block2467;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2475 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2462);
// compilenode returning call2475
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2476 == NULL) {
    strlit2476 = alloc_String("Type""\x0a""");
    gc_root(strlit2476);
  }
// compilenode returning strlit2476
  *var_s = strlit2476;
  if (strlit2476 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2478 == NULL) {
    strlit2478 = alloc_String("""\x0a""");
    gc_root(strlit2478);
  }
// compilenode returning strlit2478
  int op_slot_right_2477 = gc_frame_newslot(strlit2478);
  int callframe2481 = gc_frame_new();
  partcv[0] = 0;
  Object call2482 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2481);
// compilenode returning call2482
  int op_slot_right_2480 = gc_frame_newslot(call2482);
  if (strlit2485 == NULL) {
    strlit2485 = alloc_String("Name: ");
    gc_root(strlit2485);
  }
// compilenode returning strlit2485
  int op_slot_right_2484 = gc_frame_newslot(strlit2485);
// compilenode returning *var_spc
  int op_slot_right_2487 = gc_frame_newslot(*var_spc);
  if (strlit2490 == NULL) {
    strlit2490 = alloc_String("");
    gc_root(strlit2490);
  }
// compilenode returning strlit2490
  int op_slot_right_2489 = gc_frame_newslot(strlit2490);
// compilenode returning *var_s
  int op_slot_right_2492 = gc_frame_newslot(*var_s);
  if (strlit2494 == NULL) {
    strlit2494 = alloc_String("");
    gc_root(strlit2494);
  }
// compilenode returning strlit2494
  int op_slot_left_2492 = gc_frame_newslot(strlit2494);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2495 = callmethod(strlit2494, "++", 1, partcv, params);
// compilenode returning opresult2495
  int op_slot_left_2489 = gc_frame_newslot(opresult2495);
  params[0] = strlit2490;
  partcv[0] = 1;
  Object opresult2496 = callmethod(opresult2495, "++", 1, partcv, params);
// compilenode returning opresult2496
  int op_slot_left_2487 = gc_frame_newslot(opresult2496);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2497 = callmethod(opresult2496, "++", 1, partcv, params);
// compilenode returning opresult2497
  int op_slot_left_2484 = gc_frame_newslot(opresult2497);
  params[0] = strlit2485;
  partcv[0] = 1;
  Object opresult2498 = callmethod(opresult2497, "++", 1, partcv, params);
// compilenode returning opresult2498
  int op_slot_left_2480 = gc_frame_newslot(opresult2498);
  params[0] = call2482;
  partcv[0] = 1;
  Object opresult2499 = callmethod(opresult2498, "++", 1, partcv, params);
// compilenode returning opresult2499
  int op_slot_left_2477 = gc_frame_newslot(opresult2499);
  params[0] = strlit2478;
  partcv[0] = 1;
  Object opresult2500 = callmethod(opresult2499, "++", 1, partcv, params);
// compilenode returning opresult2500
  *var_s = opresult2500;
  if (opresult2500 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2504 = alloc_Float64(0);
// compilenode returning num2504
  int op_slot_right_2503 = gc_frame_newslot(num2504);
  int callframe2506 = gc_frame_new();
  int callframe2507 = gc_frame_new();
  partcv[0] = 0;
  Object call2508 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2507);
// compilenode returning call2508
  partcv[0] = 0;
  Object call2509 = callmethod(call2508, "size",
    1, partcv, params);
  gc_frame_end(callframe2506);
// compilenode returning call2509
// compilenode returning call2509
  int op_slot_left_2503 = gc_frame_newslot(call2509);
  params[0] = num2504;
  partcv[0] = 1;
  Object opresult2510 = callmethod(call2509, ">", 1, partcv, params);
// compilenode returning opresult2510
  Object if2502 = done;
  if (istrue(opresult2510)) {
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2512 == NULL) {
    strlit2512 = alloc_String("Generic parameters:""\x0a""");
    gc_root(strlit2512);
  }
// compilenode returning strlit2512
  int op_slot_right_2511 = gc_frame_newslot(strlit2512);
// compilenode returning *var_spc
  int op_slot_right_2514 = gc_frame_newslot(*var_spc);
  if (strlit2517 == NULL) {
    strlit2517 = alloc_String("");
    gc_root(strlit2517);
  }
// compilenode returning strlit2517
  int op_slot_right_2516 = gc_frame_newslot(strlit2517);
// compilenode returning *var_s
  int op_slot_right_2519 = gc_frame_newslot(*var_s);
  if (strlit2521 == NULL) {
    strlit2521 = alloc_String("");
    gc_root(strlit2521);
  }
// compilenode returning strlit2521
  int op_slot_left_2519 = gc_frame_newslot(strlit2521);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2522 = callmethod(strlit2521, "++", 1, partcv, params);
// compilenode returning opresult2522
  int op_slot_left_2516 = gc_frame_newslot(opresult2522);
  params[0] = strlit2517;
  partcv[0] = 1;
  Object opresult2523 = callmethod(opresult2522, "++", 1, partcv, params);
// compilenode returning opresult2523
  int op_slot_left_2514 = gc_frame_newslot(opresult2523);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2524 = callmethod(opresult2523, "++", 1, partcv, params);
// compilenode returning opresult2524
  int op_slot_left_2511 = gc_frame_newslot(opresult2524);
  params[0] = strlit2512;
  partcv[0] = 1;
  Object opresult2525 = callmethod(opresult2524, "++", 1, partcv, params);
// compilenode returning opresult2525
  *var_s = opresult2525;
  if (opresult2525 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2527 = gc_frame_new();
  int callframe2528 = gc_frame_new();
  partcv[0] = 0;
  Object call2529 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2528);
// compilenode returning call2529
  gc_frame_newslot(call2529);
  Object block2530 = alloc_Block(NULL, NULL, "ast", 561);
  gc_frame_newslot(block2530);
  block_savedest(block2530);
  Object closure2531 = createclosure(3, "_apply");
setclosureframe(closure2531, stackframe);
  addtoclosure(closure2531, var_spc);
  addtoclosure(closure2531, var_s);
  addtoclosure(closure2531, selfslot);
  struct UserObject *uo2531 = (struct UserObject*)block2530;
  uo2531->data[0] = (Object)closure2531;
  Method *meth_meth_ast__apply2531 = addmethod2pos(block2530, "_apply", &meth_ast__apply2531, 0);
int argcv_meth_ast__apply2531[] = {1};
meth_meth_ast__apply2531->type = alloc_MethodType(1, argcv_meth_ast__apply2531);
  meth_meth_ast__apply2531->definitionModule = modulename;
  meth_meth_ast__apply2531->definitionLine = 559;
// compilenode returning block2530
  gc_frame_newslot(block2530);
  params[0] = call2529;
  params[1] = block2530;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2558 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compilenode returning call2558
    gc_frame_newslot(call2558);
    if2502 = call2558;
  } else {
  }
// compilenode returning if2502
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2561 = alloc_Float64(0);
// compilenode returning num2561
  int op_slot_right_2560 = gc_frame_newslot(num2561);
  int callframe2563 = gc_frame_new();
  int callframe2564 = gc_frame_new();
  partcv[0] = 0;
  Object call2565 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2564);
// compilenode returning call2565
  partcv[0] = 0;
  Object call2566 = callmethod(call2565, "size",
    1, partcv, params);
  gc_frame_end(callframe2563);
// compilenode returning call2566
// compilenode returning call2566
  int op_slot_left_2560 = gc_frame_newslot(call2566);
  params[0] = num2561;
  partcv[0] = 1;
  Object opresult2567 = callmethod(call2566, ">", 1, partcv, params);
// compilenode returning opresult2567
  Object if2559 = done;
  if (istrue(opresult2567)) {
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2569 == NULL) {
    strlit2569 = alloc_String("Union of:""\x0a""");
    gc_root(strlit2569);
  }
// compilenode returning strlit2569
  int op_slot_right_2568 = gc_frame_newslot(strlit2569);
// compilenode returning *var_spc
  int op_slot_right_2571 = gc_frame_newslot(*var_spc);
  if (strlit2574 == NULL) {
    strlit2574 = alloc_String("");
    gc_root(strlit2574);
  }
// compilenode returning strlit2574
  int op_slot_right_2573 = gc_frame_newslot(strlit2574);
// compilenode returning *var_s
  int op_slot_right_2576 = gc_frame_newslot(*var_s);
  if (strlit2578 == NULL) {
    strlit2578 = alloc_String("");
    gc_root(strlit2578);
  }
// compilenode returning strlit2578
  int op_slot_left_2576 = gc_frame_newslot(strlit2578);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2579 = callmethod(strlit2578, "++", 1, partcv, params);
// compilenode returning opresult2579
  int op_slot_left_2573 = gc_frame_newslot(opresult2579);
  params[0] = strlit2574;
  partcv[0] = 1;
  Object opresult2580 = callmethod(opresult2579, "++", 1, partcv, params);
// compilenode returning opresult2580
  int op_slot_left_2571 = gc_frame_newslot(opresult2580);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2581 = callmethod(opresult2580, "++", 1, partcv, params);
// compilenode returning opresult2581
  int op_slot_left_2568 = gc_frame_newslot(opresult2581);
  params[0] = strlit2569;
  partcv[0] = 1;
  Object opresult2582 = callmethod(opresult2581, "++", 1, partcv, params);
// compilenode returning opresult2582
  *var_s = opresult2582;
  if (opresult2582 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2584 = gc_frame_new();
  int callframe2585 = gc_frame_new();
  partcv[0] = 0;
  Object call2586 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2585);
// compilenode returning call2586
  gc_frame_newslot(call2586);
  Object block2587 = alloc_Block(NULL, NULL, "ast", 567);
  gc_frame_newslot(block2587);
  block_savedest(block2587);
  Object closure2588 = createclosure(3, "_apply");
setclosureframe(closure2588, stackframe);
  addtoclosure(closure2588, var_spc);
  addtoclosure(closure2588, var_s);
  addtoclosure(closure2588, selfslot);
  struct UserObject *uo2588 = (struct UserObject*)block2587;
  uo2588->data[0] = (Object)closure2588;
  Method *meth_meth_ast__apply2588 = addmethod2pos(block2587, "_apply", &meth_ast__apply2588, 0);
int argcv_meth_ast__apply2588[] = {1};
meth_meth_ast__apply2588->type = alloc_MethodType(1, argcv_meth_ast__apply2588);
  meth_meth_ast__apply2588->definitionModule = modulename;
  meth_meth_ast__apply2588->definitionLine = 565;
// compilenode returning block2587
  gc_frame_newslot(block2587);
  params[0] = call2586;
  params[1] = block2587;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2615 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2584);
// compilenode returning call2615
    gc_frame_newslot(call2615);
    if2559 = call2615;
  } else {
  }
// compilenode returning if2559
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2618 = alloc_Float64(0);
// compilenode returning num2618
  int op_slot_right_2617 = gc_frame_newslot(num2618);
  int callframe2620 = gc_frame_new();
  int callframe2621 = gc_frame_new();
  partcv[0] = 0;
  Object call2622 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2621);
// compilenode returning call2622
  partcv[0] = 0;
  Object call2623 = callmethod(call2622, "size",
    1, partcv, params);
  gc_frame_end(callframe2620);
// compilenode returning call2623
// compilenode returning call2623
  int op_slot_left_2617 = gc_frame_newslot(call2623);
  params[0] = num2618;
  partcv[0] = 1;
  Object opresult2624 = callmethod(call2623, ">", 1, partcv, params);
// compilenode returning opresult2624
  Object if2616 = done;
  if (istrue(opresult2624)) {
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2626 == NULL) {
    strlit2626 = alloc_String("Intersection of:""\x0a""");
    gc_root(strlit2626);
  }
// compilenode returning strlit2626
  int op_slot_right_2625 = gc_frame_newslot(strlit2626);
// compilenode returning *var_spc
  int op_slot_right_2628 = gc_frame_newslot(*var_spc);
  if (strlit2631 == NULL) {
    strlit2631 = alloc_String("");
    gc_root(strlit2631);
  }
// compilenode returning strlit2631
  int op_slot_right_2630 = gc_frame_newslot(strlit2631);
// compilenode returning *var_s
  int op_slot_right_2633 = gc_frame_newslot(*var_s);
  if (strlit2635 == NULL) {
    strlit2635 = alloc_String("");
    gc_root(strlit2635);
  }
// compilenode returning strlit2635
  int op_slot_left_2633 = gc_frame_newslot(strlit2635);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult2636 = callmethod(strlit2635, "++", 1, partcv, params);
// compilenode returning opresult2636
  int op_slot_left_2630 = gc_frame_newslot(opresult2636);
  params[0] = strlit2631;
  partcv[0] = 1;
  Object opresult2637 = callmethod(opresult2636, "++", 1, partcv, params);
// compilenode returning opresult2637
  int op_slot_left_2628 = gc_frame_newslot(opresult2637);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2638 = callmethod(opresult2637, "++", 1, partcv, params);
// compilenode returning opresult2638
  int op_slot_left_2625 = gc_frame_newslot(opresult2638);
  params[0] = strlit2626;
  partcv[0] = 1;
  Object opresult2639 = callmethod(opresult2638, "++", 1, partcv, params);
// compilenode returning opresult2639
  *var_s = opresult2639;
  if (opresult2639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2641 = gc_frame_new();
  int callframe2642 = gc_frame_new();
  partcv[0] = 0;
  Object call2643 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2642);
// compilenode returning call2643
  gc_frame_newslot(call2643);
  Object block2644 = alloc_Block(NULL, NULL, "ast", 573);
  gc_frame_newslot(block2644);
  block_savedest(block2644);
  Object closure2645 = createclosure(3, "_apply");
setclosureframe(closure2645, stackframe);
  addtoclosure(closure2645, var_spc);
  addtoclosure(closure2645, var_s);
  addtoclosure(closure2645, selfslot);
  struct UserObject *uo2645 = (struct UserObject*)block2644;
  uo2645->data[0] = (Object)closure2645;
  Method *meth_meth_ast__apply2645 = addmethod2pos(block2644, "_apply", &meth_ast__apply2645, 0);
int argcv_meth_ast__apply2645[] = {1};
meth_meth_ast__apply2645->type = alloc_MethodType(1, argcv_meth_ast__apply2645);
  meth_meth_ast__apply2645->definitionModule = modulename;
  meth_meth_ast__apply2645->definitionLine = 571;
// compilenode returning block2644
  gc_frame_newslot(block2644);
  params[0] = call2643;
  params[1] = block2644;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2672 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2641);
// compilenode returning call2672
    gc_frame_newslot(call2672);
    if2616 = call2672;
  } else {
  }
// compilenode returning if2616
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2674 == NULL) {
    strlit2674 = alloc_String("Methods:");
    gc_root(strlit2674);
  }
// compilenode returning strlit2674
  int op_slot_right_2673 = gc_frame_newslot(strlit2674);
// compilenode returning *var_spc
  int op_slot_right_2676 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_2676 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2678 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2678
  int op_slot_left_2673 = gc_frame_newslot(opresult2678);
  params[0] = strlit2674;
  partcv[0] = 1;
  Object opresult2679 = callmethod(opresult2678, "++", 1, partcv, params);
// compilenode returning opresult2679
  *var_s = opresult2679;
  if (opresult2679 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2681 = gc_frame_new();
  int callframe2682 = gc_frame_new();
  partcv[0] = 0;
  Object call2683 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2682);
// compilenode returning call2683
  gc_frame_newslot(call2683);
  Object block2684 = alloc_Block(NULL, NULL, "ast", 578);
  gc_frame_newslot(block2684);
  block_savedest(block2684);
  Object closure2685 = createclosure(4, "_apply");
setclosureframe(closure2685, stackframe);
  addtoclosure(closure2685, var_depth);
  addtoclosure(closure2685, var_spc);
  addtoclosure(closure2685, var_s);
  addtoclosure(closure2685, selfslot);
  struct UserObject *uo2685 = (struct UserObject*)block2684;
  uo2685->data[0] = (Object)closure2685;
  Method *meth_meth_ast__apply2685 = addmethod2pos(block2684, "_apply", &meth_ast__apply2685, 0);
int argcv_meth_ast__apply2685[] = {1};
meth_meth_ast__apply2685->type = alloc_MethodType(1, argcv_meth_ast__apply2685);
  meth_meth_ast__apply2685->definitionModule = modulename;
  meth_meth_ast__apply2685->definitionLine = 574;
// compilenode returning block2684
  gc_frame_newslot(block2684);
  params[0] = call2683;
  params[1] = block2684;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2704 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2681);
// compilenode returning call2704
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2706 == NULL) {
    strlit2706 = alloc_String("""\x0a""");
    gc_root(strlit2706);
  }
// compilenode returning strlit2706
  int op_slot_right_2705 = gc_frame_newslot(strlit2706);
// compilenode returning *var_s
  int op_slot_left_2705 = gc_frame_newslot(*var_s);
  params[0] = strlit2706;
  partcv[0] = 1;
  Object opresult2708 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2708
  *var_s = opresult2708;
  if (opresult2708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 582
  setline(582);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply2722(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2724 == NULL) {
    strlit2724 = alloc_String("    ");
    gc_root(strlit2724);
  }
// compilenode returning strlit2724
  int op_slot_right_2723 = gc_frame_newslot(strlit2724);
// compilenode returning *var_spc
  int op_slot_left_2723 = gc_frame_newslot(*var_spc);
  params[0] = strlit2724;
  partcv[0] = 1;
  Object opresult2726 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult2726
  *var_spc = opresult2726;
  if (opresult2726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply2803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2805 = gc_frame_new();
  int callframe2806 = gc_frame_new();
  partcv[0] = 0;
  Object call2807 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compilenode returning call2807
// compilenode returning call2807
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2808 = callmethod(call2807, "[]", 1, partcv, params);
// compilenode returning idxres2808
  partcv[0] = 0;
  Object call2809 = callmethod(idxres2808, "value",
    1, partcv, params);
  gc_frame_end(callframe2805);
// compilenode returning call2809
// compilenode returning call2809
  int op_slot_right_2804 = gc_frame_newslot(call2809);
// compilenode returning *var_s
  int op_slot_left_2804 = gc_frame_newslot(*var_s);
  params[0] = call2809;
  partcv[0] = 1;
  Object opresult2811 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2811
  *var_s = opresult2811;
  if (opresult2811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2815 = gc_frame_new();
  int callframe2816 = gc_frame_new();
  partcv[0] = 0;
  Object call2817 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2816);
// compilenode returning call2817
// compilenode returning call2817
  partcv[0] = 0;
  Object call2818 = callmethod(call2817, "size",
    1, partcv, params);
  gc_frame_end(callframe2815);
// compilenode returning call2818
// compilenode returning call2818
  int op_slot_right_2814 = gc_frame_newslot(call2818);
// compilenode returning *var_i
  int op_slot_left_2814 = gc_frame_newslot(*var_i);
  params[0] = call2818;
  partcv[0] = 1;
  Object opresult2820 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2820
  Object if2813 = done;
  if (istrue(opresult2820)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2822 == NULL) {
    strlit2822 = alloc_String(", ");
    gc_root(strlit2822);
  }
// compilenode returning strlit2822
  int op_slot_right_2821 = gc_frame_newslot(strlit2822);
// compilenode returning *var_s
  int op_slot_left_2821 = gc_frame_newslot(*var_s);
  params[0] = strlit2822;
  partcv[0] = 1;
  Object opresult2824 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2824
  *var_s = opresult2824;
  if (opresult2824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2813 = done;
  } else {
  }
// compilenode returning if2813
  gc_frame_end(frame);
  return if2813;
}
Object meth_ast__apply2883(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2885 = gc_frame_new();
  Object num2886 = alloc_Float64(0);
// compilenode returning num2886
  gc_frame_newslot(num2886);
  int callframe2887 = gc_frame_new();
  partcv[0] = 0;
  Object call2888 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2887);
// compilenode returning call2888
// compilenode returning call2888
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2889 = callmethod(call2888, "[]", 1, partcv, params);
// compilenode returning idxres2889
  params[0] = num2886;
  partcv[0] = 1;
  Object call2890 = callmethod(idxres2889, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2885);
// compilenode returning call2890
  int op_slot_right_2884 = gc_frame_newslot(call2890);
// compilenode returning *var_s
  int op_slot_left_2884 = gc_frame_newslot(*var_s);
  params[0] = call2890;
  partcv[0] = 1;
  Object opresult2892 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2892
  *var_s = opresult2892;
  if (opresult2892 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2896 = gc_frame_new();
  int callframe2897 = gc_frame_new();
  partcv[0] = 0;
  Object call2898 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2897);
// compilenode returning call2898
// compilenode returning call2898
  partcv[0] = 0;
  Object call2899 = callmethod(call2898, "size",
    1, partcv, params);
  gc_frame_end(callframe2896);
// compilenode returning call2899
// compilenode returning call2899
  int op_slot_right_2895 = gc_frame_newslot(call2899);
// compilenode returning *var_i
  int op_slot_left_2895 = gc_frame_newslot(*var_i);
  params[0] = call2899;
  partcv[0] = 1;
  Object opresult2901 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2901
  Object if2894 = done;
  if (istrue(opresult2901)) {
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2903 == NULL) {
    strlit2903 = alloc_String(" | ");
    gc_root(strlit2903);
  }
// compilenode returning strlit2903
  int op_slot_right_2902 = gc_frame_newslot(strlit2903);
// compilenode returning *var_s
  int op_slot_left_2902 = gc_frame_newslot(*var_s);
  params[0] = strlit2903;
  partcv[0] = 1;
  Object opresult2905 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2905
  *var_s = opresult2905;
  if (opresult2905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2894 = done;
  } else {
  }
// compilenode returning if2894
  gc_frame_end(frame);
  return if2894;
}
Object meth_ast__apply2924(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2926 = gc_frame_new();
  Object num2927 = alloc_Float64(0);
// compilenode returning num2927
  gc_frame_newslot(num2927);
  int callframe2928 = gc_frame_new();
  partcv[0] = 0;
  Object call2929 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2928);
// compilenode returning call2929
// compilenode returning call2929
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres2930 = callmethod(call2929, "[]", 1, partcv, params);
// compilenode returning idxres2930
  params[0] = num2927;
  partcv[0] = 1;
  Object call2931 = callmethod(idxres2930, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2926);
// compilenode returning call2931
  int op_slot_right_2925 = gc_frame_newslot(call2931);
// compilenode returning *var_s
  int op_slot_left_2925 = gc_frame_newslot(*var_s);
  params[0] = call2931;
  partcv[0] = 1;
  Object opresult2933 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2933
  *var_s = opresult2933;
  if (opresult2933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 622
  setline(622);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2937 = gc_frame_new();
  int callframe2938 = gc_frame_new();
  partcv[0] = 0;
  Object call2939 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2938);
// compilenode returning call2939
// compilenode returning call2939
  partcv[0] = 0;
  Object call2940 = callmethod(call2939, "size",
    1, partcv, params);
  gc_frame_end(callframe2937);
// compilenode returning call2940
// compilenode returning call2940
  int op_slot_right_2936 = gc_frame_newslot(call2940);
// compilenode returning *var_i
  int op_slot_left_2936 = gc_frame_newslot(*var_i);
  params[0] = call2940;
  partcv[0] = 1;
  Object opresult2942 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult2942
  Object if2935 = done;
  if (istrue(opresult2942)) {
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2944 == NULL) {
    strlit2944 = alloc_String(" & ");
    gc_root(strlit2944);
  }
// compilenode returning strlit2944
  int op_slot_right_2943 = gc_frame_newslot(strlit2944);
// compilenode returning *var_s
  int op_slot_left_2943 = gc_frame_newslot(*var_s);
  params[0] = strlit2944;
  partcv[0] = 1;
  Object opresult2946 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2946
  *var_s = opresult2946;
  if (opresult2946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2935 = done;
  } else {
  }
// compilenode returning if2935
  gc_frame_end(frame);
  return if2935;
}
Object meth_ast__apply2954(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 628
  setline(628);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2956 = gc_frame_new();
  Object num2958 = alloc_Float64(1);
// compilenode returning num2958
  int op_slot_right_2957 = gc_frame_newslot(num2958);
// compilenode returning *var_depth
  int op_slot_left_2957 = gc_frame_newslot(*var_depth);
  params[0] = num2958;
  partcv[0] = 1;
  Object sum2960 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum2960
  gc_frame_newslot(sum2960);
// compilenode returning *var_mx
  params[0] = sum2960;
  partcv[0] = 1;
  Object call2961 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe2956);
// compilenode returning call2961
  int op_slot_right_2955 = gc_frame_newslot(call2961);
  if (strlit2964 == NULL) {
    strlit2964 = alloc_String("    ");
    gc_root(strlit2964);
  }
// compilenode returning strlit2964
  int op_slot_right_2963 = gc_frame_newslot(strlit2964);
// compilenode returning *var_spc
  int op_slot_right_2966 = gc_frame_newslot(*var_spc);
  if (strlit2969 == NULL) {
    strlit2969 = alloc_String("""\x0a""");
    gc_root(strlit2969);
  }
// compilenode returning strlit2969
  int op_slot_right_2968 = gc_frame_newslot(strlit2969);
// compilenode returning *var_s
  int op_slot_left_2968 = gc_frame_newslot(*var_s);
  params[0] = strlit2969;
  partcv[0] = 1;
  Object opresult2971 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2971
  int op_slot_left_2966 = gc_frame_newslot(opresult2971);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult2972 = callmethod(opresult2971, "++", 1, partcv, params);
// compilenode returning opresult2972
  int op_slot_left_2963 = gc_frame_newslot(opresult2972);
  params[0] = strlit2964;
  partcv[0] = 1;
  Object opresult2973 = callmethod(opresult2972, "++", 1, partcv, params);
// compilenode returning opresult2973
  int op_slot_left_2955 = gc_frame_newslot(opresult2973);
  params[0] = call2961;
  partcv[0] = 1;
  Object opresult2974 = callmethod(opresult2973, "++", 1, partcv, params);
// compilenode returning opresult2974
  *var_s = opresult2974;
  if (opresult2974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace2710(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_isanon = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "isanon");
  Object *var_isadhoc = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "isadhoc");
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2711 == NULL) {
    strlit2711 = alloc_String("");
    gc_root(strlit2711);
  }
// compilenode returning strlit2711
  *var_spc = strlit2711;
  if (strlit2711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2712 = gc_frame_new();
  Object num2715 = alloc_Float64(1);
// compilenode returning num2715
  int op_slot_right_2714 = gc_frame_newslot(num2715);
// compilenode returning *var_depth
  int op_slot_left_2714 = gc_frame_newslot(*var_depth);
  params[0] = num2715;
  partcv[0] = 1;
  Object diff2717 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff2717
  int op_slot_right_2713 = gc_frame_newslot(diff2717);
  Object num2719 = alloc_Float64(0);
// compilenode returning num2719
  int op_slot_left_2713 = gc_frame_newslot(num2719);
  params[0] = diff2717;
  partcv[0] = 1;
  Object opresult2720 = callmethod(num2719, "..", 1, partcv, params);
// compilenode returning opresult2720
  gc_frame_newslot(opresult2720);
  Object block2721 = alloc_Block(NULL, NULL, "ast", 586);
  gc_frame_newslot(block2721);
  block_savedest(block2721);
  Object closure2722 = createclosure(2, "_apply");
setclosureframe(closure2722, stackframe);
  addtoclosure(closure2722, var_spc);
  addtoclosure(closure2722, selfslot);
  struct UserObject *uo2722 = (struct UserObject*)block2721;
  uo2722->data[0] = (Object)closure2722;
  Method *meth_meth_ast__apply2722 = addmethod2pos(block2721, "_apply", &meth_ast__apply2722, 0);
int argcv_meth_ast__apply2722[] = {1};
meth_meth_ast__apply2722->type = alloc_MethodType(1, argcv_meth_ast__apply2722);
  meth_meth_ast__apply2722->definitionModule = modulename;
  meth_meth_ast__apply2722->definitionLine = 574;
// compilenode returning block2721
  gc_frame_newslot(block2721);
  params[0] = opresult2720;
  params[1] = block2721;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2729 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2712);
// compilenode returning call2729
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2730 == NULL) {
    strlit2730 = alloc_String("");
    gc_root(strlit2730);
  }
// compilenode returning strlit2730
  *var_s = strlit2730;
  if (strlit2730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2732 == NULL) {
    strlit2732 = alloc_String("Anon_");
    gc_root(strlit2732);
  }
// compilenode returning strlit2732
  int op_slot_right_2731 = gc_frame_newslot(strlit2732);
  int callframe2734 = gc_frame_new();
  Object num2735 = alloc_Float64(2);
// compilenode returning num2735
  gc_frame_newslot(num2735);
  Object num2736 = alloc_Float64(6);
// compilenode returning num2736
  gc_frame_newslot(num2736);
  int callframe2737 = gc_frame_new();
  partcv[0] = 0;
  Object call2738 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2737);
// compilenode returning call2738
// compilenode returning call2738
  params[0] = num2735;
  params[1] = num2736;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2739 = callmethod(call2738, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2734);
// compilenode returning call2739
  int op_slot_left_2731 = gc_frame_newslot(call2739);
  params[0] = strlit2732;
  partcv[0] = 1;
  Object opresult2740 = callmethod(call2739, "==", 1, partcv, params);
// compilenode returning opresult2740
  *var_isanon = opresult2740;
  if (opresult2740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2743 == NULL) {
    strlit2743 = alloc_String("Intersection<");
    gc_root(strlit2743);
  }
// compilenode returning strlit2743
  int op_slot_right_2742 = gc_frame_newslot(strlit2743);
  int callframe2745 = gc_frame_new();
  Object num2746 = alloc_Float64(1);
// compilenode returning num2746
  gc_frame_newslot(num2746);
  Object num2747 = alloc_Float64(13);
// compilenode returning num2747
  gc_frame_newslot(num2747);
  int callframe2748 = gc_frame_new();
  partcv[0] = 0;
  Object call2749 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2748);
// compilenode returning call2749
// compilenode returning call2749
  params[0] = num2746;
  params[1] = num2747;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2750 = callmethod(call2749, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2745);
// compilenode returning call2750
  int op_slot_left_2742 = gc_frame_newslot(call2750);
  params[0] = strlit2743;
  partcv[0] = 1;
  Object opresult2751 = callmethod(call2750, "==", 1, partcv, params);
// compilenode returning opresult2751
  int op_slot_right_2741 = gc_frame_newslot(opresult2751);
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2754 == NULL) {
    strlit2754 = alloc_String("Union<");
    gc_root(strlit2754);
  }
// compilenode returning strlit2754
  int op_slot_right_2753 = gc_frame_newslot(strlit2754);
  int callframe2756 = gc_frame_new();
  Object num2757 = alloc_Float64(1);
// compilenode returning num2757
  gc_frame_newslot(num2757);
  Object num2758 = alloc_Float64(6);
// compilenode returning num2758
  gc_frame_newslot(num2758);
  int callframe2759 = gc_frame_new();
  partcv[0] = 0;
  Object call2760 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2759);
// compilenode returning call2760
// compilenode returning call2760
  params[0] = num2757;
  params[1] = num2758;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2761 = callmethod(call2760, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe2756);
// compilenode returning call2761
  int op_slot_left_2753 = gc_frame_newslot(call2761);
  params[0] = strlit2754;
  partcv[0] = 1;
  Object opresult2762 = callmethod(call2761, "==", 1, partcv, params);
// compilenode returning opresult2762
  int op_slot_left_2741 = gc_frame_newslot(opresult2762);
  params[0] = opresult2751;
  partcv[0] = 1;
  Object opresult2763 = callmethod(opresult2762, "||", 1, partcv, params);
// compilenode returning opresult2763
  *var_isadhoc = opresult2763;
  if (opresult2763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2766 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call2767 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2766);
// compilenode returning call2767
  int op_slot_right_2765 = gc_frame_newslot(call2767);
  int callframe2769 = gc_frame_new();
// compilenode returning *var_isanon
  partcv[0] = 0;
  Object call2770 = callmethod(*var_isanon, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2769);
// compilenode returning call2770
  int op_slot_left_2765 = gc_frame_newslot(call2770);
  params[0] = call2767;
  partcv[0] = 1;
  Object opresult2771 = callmethod(call2770, "&&", 1, partcv, params);
// compilenode returning opresult2771
  Object if2764 = done;
  if (istrue(opresult2771)) {
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2773 == NULL) {
    strlit2773 = alloc_String("");
    gc_root(strlit2773);
  }
// compilenode returning strlit2773
  int op_slot_right_2772 = gc_frame_newslot(strlit2773);
  int callframe2776 = gc_frame_new();
  partcv[0] = 0;
  Object call2777 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2776);
// compilenode returning call2777
// compilenode returning call2777
  int op_slot_right_2775 = gc_frame_newslot(call2777);
  if (strlit2779 == NULL) {
    strlit2779 = alloc_String("type ");
    gc_root(strlit2779);
  }
// compilenode returning strlit2779
  int op_slot_left_2775 = gc_frame_newslot(strlit2779);
  params[0] = call2777;
  partcv[0] = 1;
  Object opresult2780 = callmethod(strlit2779, "++", 1, partcv, params);
// compilenode returning opresult2780
  int op_slot_left_2772 = gc_frame_newslot(opresult2780);
  params[0] = strlit2773;
  partcv[0] = 1;
  Object opresult2781 = callmethod(opresult2780, "++", 1, partcv, params);
// compilenode returning opresult2781
  *var_s = opresult2781;
  if (opresult2781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2785 = alloc_Float64(0);
// compilenode returning num2785
  int op_slot_right_2784 = gc_frame_newslot(num2785);
  int callframe2787 = gc_frame_new();
  int callframe2788 = gc_frame_new();
  partcv[0] = 0;
  Object call2789 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2788);
// compilenode returning call2789
// compilenode returning call2789
  partcv[0] = 0;
  Object call2790 = callmethod(call2789, "size",
    1, partcv, params);
  gc_frame_end(callframe2787);
// compilenode returning call2790
// compilenode returning call2790
  int op_slot_left_2784 = gc_frame_newslot(call2790);
  params[0] = num2785;
  partcv[0] = 1;
  Object opresult2791 = callmethod(call2790, ">", 1, partcv, params);
// compilenode returning opresult2791
  Object if2783 = done;
  if (istrue(opresult2791)) {
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2793 == NULL) {
    strlit2793 = alloc_String("<");
    gc_root(strlit2793);
  }
// compilenode returning strlit2793
  int op_slot_right_2792 = gc_frame_newslot(strlit2793);
// compilenode returning *var_s
  int op_slot_left_2792 = gc_frame_newslot(*var_s);
  params[0] = strlit2793;
  partcv[0] = 1;
  Object opresult2795 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2795
  *var_s = opresult2795;
  if (opresult2795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2797 = gc_frame_new();
  int callframe2798 = gc_frame_new();
  int callframe2799 = gc_frame_new();
  partcv[0] = 0;
  Object call2800 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2799);
// compilenode returning call2800
// compilenode returning call2800
  partcv[0] = 0;
  Object call2801 = callmethod(call2800, "indices",
    1, partcv, params);
  gc_frame_end(callframe2798);
// compilenode returning call2801
// compilenode returning call2801
  gc_frame_newslot(call2801);
  Object block2802 = alloc_Block(NULL, NULL, "ast", 597);
  gc_frame_newslot(block2802);
  block_savedest(block2802);
  Object closure2803 = createclosure(2, "_apply");
setclosureframe(closure2803, stackframe);
  addtoclosure(closure2803, var_s);
  addtoclosure(closure2803, selfslot);
  struct UserObject *uo2803 = (struct UserObject*)block2802;
  uo2803->data[0] = (Object)closure2803;
  Method *meth_meth_ast__apply2803 = addmethod2pos(block2802, "_apply", &meth_ast__apply2803, 0);
int argcv_meth_ast__apply2803[] = {1};
meth_meth_ast__apply2803->type = alloc_MethodType(1, argcv_meth_ast__apply2803);
  meth_meth_ast__apply2803->definitionModule = modulename;
  meth_meth_ast__apply2803->definitionLine = 597;
// compilenode returning block2802
  gc_frame_newslot(block2802);
  params[0] = call2801;
  params[1] = block2802;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2827 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2797);
// compilenode returning call2827
// Begin line 604
  setline(604);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2829 == NULL) {
    strlit2829 = alloc_String(">");
    gc_root(strlit2829);
  }
// compilenode returning strlit2829
  int op_slot_right_2828 = gc_frame_newslot(strlit2829);
// compilenode returning *var_s
  int op_slot_left_2828 = gc_frame_newslot(*var_s);
  params[0] = strlit2829;
  partcv[0] = 1;
  Object opresult2831 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2831
  *var_s = opresult2831;
  if (opresult2831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2783 = done;
  } else {
  }
// compilenode returning if2783
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2834 == NULL) {
    strlit2834 = alloc_String(" = ");
    gc_root(strlit2834);
  }
// compilenode returning strlit2834
  int op_slot_right_2833 = gc_frame_newslot(strlit2834);
// compilenode returning *var_s
  int op_slot_left_2833 = gc_frame_newslot(*var_s);
  params[0] = strlit2834;
  partcv[0] = 1;
  Object opresult2836 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2836
  *var_s = opresult2836;
  if (opresult2836 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2764 = done;
  } else {
  }
// compilenode returning if2764
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2841 = alloc_Float64(0);
// compilenode returning num2841
  int op_slot_right_2840 = gc_frame_newslot(num2841);
  int callframe2843 = gc_frame_new();
  int callframe2844 = gc_frame_new();
  partcv[0] = 0;
  Object call2845 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2844);
// compilenode returning call2845
// compilenode returning call2845
  partcv[0] = 0;
  Object call2846 = callmethod(call2845, "size",
    1, partcv, params);
  gc_frame_end(callframe2843);
// compilenode returning call2846
// compilenode returning call2846
  int op_slot_left_2840 = gc_frame_newslot(call2846);
  params[0] = num2841;
  partcv[0] = 1;
  Object opresult2847 = callmethod(call2846, "==", 1, partcv, params);
// compilenode returning opresult2847
  int op_slot_right_2839 = gc_frame_newslot(opresult2847);
// Begin line 607
  setline(607);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2851 = alloc_Float64(0);
// compilenode returning num2851
  int op_slot_right_2850 = gc_frame_newslot(num2851);
  int callframe2853 = gc_frame_new();
  int callframe2854 = gc_frame_new();
  partcv[0] = 0;
  Object call2855 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2854);
// compilenode returning call2855
// compilenode returning call2855
  partcv[0] = 0;
  Object call2856 = callmethod(call2855, "size",
    1, partcv, params);
  gc_frame_end(callframe2853);
// compilenode returning call2856
// compilenode returning call2856
  int op_slot_left_2850 = gc_frame_newslot(call2856);
  params[0] = num2851;
  partcv[0] = 1;
  Object opresult2857 = callmethod(call2856, "==", 1, partcv, params);
// compilenode returning opresult2857
  int op_slot_right_2849 = gc_frame_newslot(opresult2857);
  int callframe2859 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call2860 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2859);
// compilenode returning call2860
  int op_slot_left_2849 = gc_frame_newslot(call2860);
  params[0] = opresult2857;
  partcv[0] = 1;
  Object opresult2861 = callmethod(call2860, "&&", 1, partcv, params);
// compilenode returning opresult2861
  int op_slot_left_2839 = gc_frame_newslot(opresult2861);
  params[0] = opresult2847;
  partcv[0] = 1;
  Object opresult2862 = callmethod(opresult2861, "&&", 1, partcv, params);
// compilenode returning opresult2862
  Object if2838 = done;
  if (istrue(opresult2862)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2864 == NULL) {
    strlit2864 = alloc_String("{");
    gc_root(strlit2864);
  }
// compilenode returning strlit2864
  int op_slot_right_2863 = gc_frame_newslot(strlit2864);
// compilenode returning *var_s
  int op_slot_left_2863 = gc_frame_newslot(*var_s);
  params[0] = strlit2864;
  partcv[0] = 1;
  Object opresult2866 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult2866
  *var_s = opresult2866;
  if (opresult2866 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2838 = done;
  } else {
  }
// compilenode returning if2838
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2870 = alloc_Float64(0);
// compilenode returning num2870
  int op_slot_right_2869 = gc_frame_newslot(num2870);
  int callframe2872 = gc_frame_new();
  int callframe2873 = gc_frame_new();
  partcv[0] = 0;
  Object call2874 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2873);
// compilenode returning call2874
// compilenode returning call2874
  partcv[0] = 0;
  Object call2875 = callmethod(call2874, "size",
    1, partcv, params);
  gc_frame_end(callframe2872);
// compilenode returning call2875
// compilenode returning call2875
  int op_slot_left_2869 = gc_frame_newslot(call2875);
  params[0] = num2870;
  partcv[0] = 1;
  Object opresult2876 = callmethod(call2875, ">", 1, partcv, params);
// compilenode returning opresult2876
  Object if2868 = done;
  if (istrue(opresult2876)) {
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2877 = gc_frame_new();
  int callframe2878 = gc_frame_new();
  int callframe2879 = gc_frame_new();
  partcv[0] = 0;
  Object call2880 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2879);
// compilenode returning call2880
// compilenode returning call2880
  partcv[0] = 0;
  Object call2881 = callmethod(call2880, "indices",
    1, partcv, params);
  gc_frame_end(callframe2878);
// compilenode returning call2881
// compilenode returning call2881
  gc_frame_newslot(call2881);
  Object block2882 = alloc_Block(NULL, NULL, "ast", 613);
  gc_frame_newslot(block2882);
  block_savedest(block2882);
  Object closure2883 = createclosure(2, "_apply");
setclosureframe(closure2883, stackframe);
  addtoclosure(closure2883, var_s);
  addtoclosure(closure2883, selfslot);
  struct UserObject *uo2883 = (struct UserObject*)block2882;
  uo2883->data[0] = (Object)closure2883;
  Method *meth_meth_ast__apply2883 = addmethod2pos(block2882, "_apply", &meth_ast__apply2883, 0);
int argcv_meth_ast__apply2883[] = {1};
meth_meth_ast__apply2883->type = alloc_MethodType(1, argcv_meth_ast__apply2883);
  meth_meth_ast__apply2883->definitionModule = modulename;
  meth_meth_ast__apply2883->definitionLine = 613;
// compilenode returning block2882
  gc_frame_newslot(block2882);
  params[0] = call2881;
  params[1] = block2882;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2908 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2877);
// compilenode returning call2908
    gc_frame_newslot(call2908);
    if2868 = call2908;
  } else {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2911 = alloc_Float64(0);
// compilenode returning num2911
  int op_slot_right_2910 = gc_frame_newslot(num2911);
  int callframe2913 = gc_frame_new();
  int callframe2914 = gc_frame_new();
  partcv[0] = 0;
  Object call2915 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2914);
// compilenode returning call2915
// compilenode returning call2915
  partcv[0] = 0;
  Object call2916 = callmethod(call2915, "size",
    1, partcv, params);
  gc_frame_end(callframe2913);
// compilenode returning call2916
// compilenode returning call2916
  int op_slot_left_2910 = gc_frame_newslot(call2916);
  params[0] = num2911;
  partcv[0] = 1;
  Object opresult2917 = callmethod(call2916, ">", 1, partcv, params);
// compilenode returning opresult2917
  Object if2909 = done;
  if (istrue(opresult2917)) {
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2918 = gc_frame_new();
  int callframe2919 = gc_frame_new();
  int callframe2920 = gc_frame_new();
  partcv[0] = 0;
  Object call2921 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2920);
// compilenode returning call2921
// compilenode returning call2921
  partcv[0] = 0;
  Object call2922 = callmethod(call2921, "indices",
    1, partcv, params);
  gc_frame_end(callframe2919);
// compilenode returning call2922
// compilenode returning call2922
  gc_frame_newslot(call2922);
  Object block2923 = alloc_Block(NULL, NULL, "ast", 620);
  gc_frame_newslot(block2923);
  block_savedest(block2923);
  Object closure2924 = createclosure(2, "_apply");
setclosureframe(closure2924, stackframe);
  addtoclosure(closure2924, var_s);
  addtoclosure(closure2924, selfslot);
  struct UserObject *uo2924 = (struct UserObject*)block2923;
  uo2924->data[0] = (Object)closure2924;
  Method *meth_meth_ast__apply2924 = addmethod2pos(block2923, "_apply", &meth_ast__apply2924, 0);
int argcv_meth_ast__apply2924[] = {1};
meth_meth_ast__apply2924->type = alloc_MethodType(1, argcv_meth_ast__apply2924);
  meth_meth_ast__apply2924->definitionModule = modulename;
  meth_meth_ast__apply2924->definitionLine = 620;
// compilenode returning block2923
  gc_frame_newslot(block2923);
  params[0] = call2922;
  params[1] = block2923;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2949 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2918);
// compilenode returning call2949
    gc_frame_newslot(call2949);
    if2909 = call2949;
  } else {
  }
// compilenode returning if2909
    gc_frame_newslot(if2909);
    if2868 = if2909;
  }
// compilenode returning if2868
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2950 = gc_frame_new();
  int callframe2951 = gc_frame_new();
  partcv[0] = 0;
  Object call2952 = callmethodflags(self, "methods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2951);
// compilenode returning call2952
// compilenode returning call2952
  gc_frame_newslot(call2952);
  Object block2953 = alloc_Block(NULL, NULL, "ast", 627);
  gc_frame_newslot(block2953);
  block_savedest(block2953);
  Object closure2954 = createclosure(4, "_apply");
setclosureframe(closure2954, stackframe);
  addtoclosure(closure2954, var_depth);
  addtoclosure(closure2954, var_spc);
  addtoclosure(closure2954, var_s);
  addtoclosure(closure2954, selfslot);
  struct UserObject *uo2954 = (struct UserObject*)block2953;
  uo2954->data[0] = (Object)closure2954;
  Method *meth_meth_ast__apply2954 = addmethod2pos(block2953, "_apply", &meth_ast__apply2954, 0);
int argcv_meth_ast__apply2954[] = {1};
meth_meth_ast__apply2954->type = alloc_MethodType(1, argcv_meth_ast__apply2954);
  meth_meth_ast__apply2954->definitionModule = modulename;
  meth_meth_ast__apply2954->definitionLine = 627;
// compilenode returning block2953
  gc_frame_newslot(block2953);
  params[0] = call2952;
  params[1] = block2953;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2977 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2950);
// compilenode returning call2977
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2981 = alloc_Float64(0);
// compilenode returning num2981
  int op_slot_right_2980 = gc_frame_newslot(num2981);
  int callframe2983 = gc_frame_new();
  int callframe2984 = gc_frame_new();
  partcv[0] = 0;
  Object call2985 = callmethodflags(self, "intersectionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2984);
// compilenode returning call2985
// compilenode returning call2985
  partcv[0] = 0;
  Object call2986 = callmethod(call2985, "size",
    1, partcv, params);
  gc_frame_end(callframe2983);
// compilenode returning call2986
// compilenode returning call2986
  int op_slot_left_2980 = gc_frame_newslot(call2986);
  params[0] = num2981;
  partcv[0] = 1;
  Object opresult2987 = callmethod(call2986, "==", 1, partcv, params);
// compilenode returning opresult2987
  int op_slot_right_2979 = gc_frame_newslot(opresult2987);
// Begin line 630
  setline(630);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2991 = alloc_Float64(0);
// compilenode returning num2991
  int op_slot_right_2990 = gc_frame_newslot(num2991);
  int callframe2993 = gc_frame_new();
  int callframe2994 = gc_frame_new();
  partcv[0] = 0;
  Object call2995 = callmethodflags(self, "unionTypes", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2994);
// compilenode returning call2995
// compilenode returning call2995
  partcv[0] = 0;
  Object call2996 = callmethod(call2995, "size",
    1, partcv, params);
  gc_frame_end(callframe2993);
// compilenode returning call2996
// compilenode returning call2996
  int op_slot_left_2990 = gc_frame_newslot(call2996);
  params[0] = num2991;
  partcv[0] = 1;
  Object opresult2997 = callmethod(call2996, "==", 1, partcv, params);
// compilenode returning opresult2997
  int op_slot_right_2989 = gc_frame_newslot(opresult2997);
  int callframe2999 = gc_frame_new();
// compilenode returning *var_isadhoc
  partcv[0] = 0;
  Object call3000 = callmethod(*var_isadhoc, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2999);
// compilenode returning call3000
  int op_slot_left_2989 = gc_frame_newslot(call3000);
  params[0] = opresult2997;
  partcv[0] = 1;
  Object opresult3001 = callmethod(call3000, "&&", 1, partcv, params);
// compilenode returning opresult3001
  int op_slot_left_2979 = gc_frame_newslot(opresult3001);
  params[0] = opresult2987;
  partcv[0] = 1;
  Object opresult3002 = callmethod(opresult3001, "&&", 1, partcv, params);
// compilenode returning opresult3002
  Object if2978 = done;
  if (istrue(opresult3002)) {
// Begin line 633
  setline(633);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3004 == NULL) {
    strlit3004 = alloc_String("}");
    gc_root(strlit3004);
  }
// compilenode returning strlit3004
  int op_slot_right_3003 = gc_frame_newslot(strlit3004);
// compilenode returning *var_spc
  int op_slot_right_3006 = gc_frame_newslot(*var_spc);
  if (strlit3009 == NULL) {
    strlit3009 = alloc_String("""\x0a""");
    gc_root(strlit3009);
  }
// compilenode returning strlit3009
  int op_slot_right_3008 = gc_frame_newslot(strlit3009);
// compilenode returning *var_s
  int op_slot_left_3008 = gc_frame_newslot(*var_s);
  params[0] = strlit3009;
  partcv[0] = 1;
  Object opresult3011 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3011
  int op_slot_left_3006 = gc_frame_newslot(opresult3011);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3012 = callmethod(opresult3011, "++", 1, partcv, params);
// compilenode returning opresult3012
  int op_slot_left_3003 = gc_frame_newslot(opresult3012);
  params[0] = strlit3004;
  partcv[0] = 1;
  Object opresult3013 = callmethod(opresult3012, "++", 1, partcv, params);
// compilenode returning opresult3013
  *var_s = opresult3013;
  if (opresult3013 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2978 = done;
  } else {
  }
// compilenode returning if2978
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new2286(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_typeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_methods_39_ = &(stackframe->slots[1]);
  *var_methods_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2287 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2287 = alloc_userobj2(18,16, objclass2287);
  gc_frame_newslot(obj2287);
if (objclass2287 == NULL) {
  glfree(obj2287->class->name);
  obj2287->class->name = "typeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2287, self, 0);
  addmethodreal(obj2287,"outer", &reader_ast_outer_2288);
  Object oldself2287 = self;
  struct StackFrameObject *oldstackframe2287 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2287);
  gc_frame_newslot((Object)stackframe);
  self = obj2287;
  Object *oldselfslot2287 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2287 = (*(struct UserObject *)self).data[0], lowerouter2287 = thisouter2287;
  if (inheritingObject2287) {
    struct UserObject *inho2287 = (struct UserObject *)inheritingObject2287;
    while (inho2287->super != GraceDefaultObject) inho2287 = (struct UserObject *)inho2287->super;
    inho2287->super = obj2287;
    self = inheritingObject2287;
    *selfslot = self;
    lowerouter2287 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2287;
  }
if (objclass2287 == NULL) {
  Method *reader2289 = addmethodrealflags(obj2287, "kind",&reader_ast_kind_2289, MFLAG_DEF);
  reader2289->definitionModule = modulename;
  reader2289->definitionLine = 503;
}
adddatum2(obj2287, alloc_Undefined(), 1);
if (objclass2287 == NULL) {
  Method *reader2290 = addmethodrealflags(obj2287, "value",&reader_ast_value_2290, MFLAG_DEF);
  reader2290->definitionModule = modulename;
  reader2290->definitionLine = 504;
}
adddatum2(obj2287, alloc_Undefined(), 2);
if (objclass2287 == NULL) {
  Method *reader2291 = addmethodrealflags(obj2287, "methods",&reader_ast_methods_2291, MFLAG_DEF);
  reader2291->definitionModule = modulename;
  reader2291->definitionLine = 505;
}
adddatum2(obj2287, alloc_Undefined(), 3);
if (objclass2287 == NULL) {
  Method *reader2292 = addmethodrealflags(obj2287, "unionTypes",&reader_ast_unionTypes_2292, MFLAG_DEF);
  reader2292->definitionModule = modulename;
  reader2292->definitionLine = 506;
}
adddatum2(obj2287, alloc_Undefined(), 4);
if (objclass2287 == NULL) {
  Method *reader2293 = addmethodrealflags(obj2287, "intersectionTypes",&reader_ast_intersectionTypes_2293, MFLAG_DEF);
  reader2293->definitionModule = modulename;
  reader2293->definitionLine = 507;
}
adddatum2(obj2287, alloc_Undefined(), 5);
if (objclass2287 == NULL) {
  Method *reader2294 = addmethodrealflags(obj2287, "annotations",&reader_ast_annotations_2294, MFLAG_DEF);
  reader2294->definitionModule = modulename;
  reader2294->definitionLine = 508;
}
adddatum2(obj2287, alloc_Undefined(), 6);
if (objclass2287 == NULL) {
  Method *reader2295 = addmethodrealflags(obj2287, "generics",&reader_ast_generics_2295, 0);
  Method *writer2295 = addmethodrealflags(obj2287, "generics:=",&writer_ast_generics_2295, 0);
  reader2295->definitionModule = modulename;
  writer2295->definitionModule = modulename;
  reader2295->definitionLine = 509;
  writer2295->definitionLine = 509;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 7);
if (objclass2287 == NULL) {
  Method *reader2296 = addmethodrealflags(obj2287, "nominal",&reader_ast_nominal_2296, 0);
  Method *writer2296 = addmethodrealflags(obj2287, "nominal:=",&writer_ast_nominal_2296, 0);
  reader2296->definitionModule = modulename;
  writer2296->definitionModule = modulename;
  reader2296->definitionLine = 510;
  writer2296->definitionLine = 510;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 8);
if (objclass2287 == NULL) {
  Method *reader2297 = addmethodrealflags(obj2287, "anonymous",&reader_ast_anonymous_2297, 0);
  Method *writer2297 = addmethodrealflags(obj2287, "anonymous:=",&writer_ast_anonymous_2297, 0);
  reader2297->definitionModule = modulename;
  writer2297->definitionModule = modulename;
  reader2297->definitionLine = 511;
  writer2297->definitionLine = 511;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 9);
  struct UserObject *uo2298 = (struct UserObject*)obj2287;
  uo2298->data[10] = emptyclosure;
  Method *meth_meth_ast_accept2298 = addmethod2pos(obj2287, "accept", &meth_ast_accept2298, 10);
int argcv_meth_ast_accept2298[] = {1};
meth_meth_ast_accept2298->type = alloc_MethodType(1, argcv_meth_ast_accept2298);
meth_meth_ast_accept2298->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept2298->type->names[0] = "visitor";
  meth_meth_ast_accept2298->definitionModule = modulename;
  meth_meth_ast_accept2298->definitionLine = 511;
  block_savedest(obj2287);
  Object closure2347 = createclosure(1, "map()before()after");
setclosureframe(closure2347, stackframe);
  addtoclosure(closure2347, var_typeNode);
  struct UserObject *uo2347 = (struct UserObject*)obj2287;
  uo2347->data[11] = (Object)closure2347;
  Method *meth_meth_ast_map_40__41_before_40__41_after2347 = addmethod2pos(obj2287, "map()before()after", &meth_ast_map_40__41_before_40__41_after2347, 11);
int argcv_meth_ast_map_40__41_before_40__41_after2347[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after2347->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after2347);
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionLine = 528;
  struct UserObject *uo2451 = (struct UserObject*)obj2287;
  uo2451->data[12] = emptyclosure;
  Method *meth_meth_ast_map2451 = addmethod2pos(obj2287, "map", &meth_ast_map2451, 12);
int argcv_meth_ast_map2451[] = {1};
meth_meth_ast_map2451->type = alloc_MethodType(1, argcv_meth_ast_map2451);
  meth_meth_ast_map2451->definitionModule = modulename;
  meth_meth_ast_map2451->definitionLine = 549;
  struct UserObject *uo2460 = (struct UserObject*)obj2287;
  uo2460->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2460 = addmethod2pos(obj2287, "pretty", &meth_ast_pretty2460, 13);
int argcv_meth_ast_pretty2460[] = {1};
meth_meth_ast_pretty2460->type = alloc_MethodType(1, argcv_meth_ast_pretty2460);
  meth_meth_ast_pretty2460->definitionModule = modulename;
  meth_meth_ast_pretty2460->definitionLine = 552;
  struct UserObject *uo2710 = (struct UserObject*)obj2287;
  uo2710->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2710 = addmethod2pos(obj2287, "toGrace", &meth_ast_toGrace2710, 14);
int argcv_meth_ast_toGrace2710[] = {1};
meth_meth_ast_toGrace2710->type = alloc_MethodType(1, argcv_meth_ast_toGrace2710);
meth_meth_ast_toGrace2710->type->types[0] = type_Number;
meth_meth_ast_toGrace2710->type->names[0] = "depth";
  meth_meth_ast_toGrace2710->definitionModule = modulename;
  meth_meth_ast_toGrace2710->definitionLine = 584;
  sourceObject = obj2287;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3015 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3016 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3015);
// compilenode returning call3016
  struct UserObject *obj2287_uo = (struct UserObject *)obj2287;
  obj2287_uo->super = call3016;
  sourceObject = obj2287;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3017 == NULL) {
    strlit3017 = alloc_String("type");
    gc_root(strlit3017);
  }
// compilenode returning strlit3017
  adddatum2(obj2287, strlit3017, 1);
  sourceObject = obj2287;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj2287, *var_name_39_, 2);
  sourceObject = obj2287;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methods_39_
  adddatum2(obj2287, *var_methods_39_, 3);
  sourceObject = obj2287;
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3018
  adddatum2(obj2287, array3018, 4);
  sourceObject = obj2287;
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3019 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3019
  adddatum2(obj2287, array3019, 5);
  sourceObject = obj2287;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3020 = gc_frame_new();
  int callframe3021 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3022 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3021);
// compilenode returning call3022
// compilenode returning call3022
  partcv[0] = 0;
  Object call3023 = callmethod(call3022, "new",
    1, partcv, params);
  gc_frame_end(callframe3020);
// compilenode returning call3023
// compilenode returning call3023
  adddatum2(obj2287, call3023, 6);
  sourceObject = obj2287;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3024 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3024
  adddatum2(obj2287, array3024, 7);
  sourceObject = obj2287;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3025 = alloc_Boolean(0);
// compilenode returning bool3025
  adddatum2(obj2287, bool3025, 8);
  sourceObject = obj2287;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3026 = alloc_Boolean(0);
// compilenode returning bool3026
  adddatum2(obj2287, bool3026, 9);
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
objclass2287 = obj2287->class;
  objclass2287->definitionModule = modulename;
  objclass2287->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2287;
  self = oldself2287;
  selfslot = oldselfslot2287;
  stackframe = oldstackframe2287;
  gc_frame_end(frame);
  return obj2287;
}
Object meth_ast_new2286_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_typeNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  Object *var_collections = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_methods_39_ = &(stackframe->slots[1]);
  *var_methods_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2287 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2287 = alloc_userobj2(18,16, objclass2287);
  gc_frame_newslot(obj2287);
if (objclass2287 == NULL) {
  glfree(obj2287->class->name);
  obj2287->class->name = "typeNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2287, self, 0);
  addmethodreal(obj2287,"outer", &reader_ast_outer_2288);
  Object oldself2287 = self;
  struct StackFrameObject *oldstackframe2287 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2287);
  gc_frame_newslot((Object)stackframe);
  self = obj2287;
  Object *oldselfslot2287 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2287 = (*(struct UserObject *)self).data[0], lowerouter2287 = thisouter2287;
  if (inheritingObject2287) {
    struct UserObject *inho2287 = (struct UserObject *)inheritingObject2287;
    while (inho2287->super != GraceDefaultObject) inho2287 = (struct UserObject *)inho2287->super;
    inho2287->super = obj2287;
    self = inheritingObject2287;
    *selfslot = self;
    lowerouter2287 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2287;
  }
if (objclass2287 == NULL) {
  Method *reader2289 = addmethodrealflags(obj2287, "kind",&reader_ast_kind_2289, MFLAG_DEF);
  reader2289->definitionModule = modulename;
  reader2289->definitionLine = 503;
}
adddatum2(obj2287, alloc_Undefined(), 1);
if (objclass2287 == NULL) {
  Method *reader2290 = addmethodrealflags(obj2287, "value",&reader_ast_value_2290, MFLAG_DEF);
  reader2290->definitionModule = modulename;
  reader2290->definitionLine = 504;
}
adddatum2(obj2287, alloc_Undefined(), 2);
if (objclass2287 == NULL) {
  Method *reader2291 = addmethodrealflags(obj2287, "methods",&reader_ast_methods_2291, MFLAG_DEF);
  reader2291->definitionModule = modulename;
  reader2291->definitionLine = 505;
}
adddatum2(obj2287, alloc_Undefined(), 3);
if (objclass2287 == NULL) {
  Method *reader2292 = addmethodrealflags(obj2287, "unionTypes",&reader_ast_unionTypes_2292, MFLAG_DEF);
  reader2292->definitionModule = modulename;
  reader2292->definitionLine = 506;
}
adddatum2(obj2287, alloc_Undefined(), 4);
if (objclass2287 == NULL) {
  Method *reader2293 = addmethodrealflags(obj2287, "intersectionTypes",&reader_ast_intersectionTypes_2293, MFLAG_DEF);
  reader2293->definitionModule = modulename;
  reader2293->definitionLine = 507;
}
adddatum2(obj2287, alloc_Undefined(), 5);
if (objclass2287 == NULL) {
  Method *reader2294 = addmethodrealflags(obj2287, "annotations",&reader_ast_annotations_2294, MFLAG_DEF);
  reader2294->definitionModule = modulename;
  reader2294->definitionLine = 508;
}
adddatum2(obj2287, alloc_Undefined(), 6);
if (objclass2287 == NULL) {
  Method *reader2295 = addmethodrealflags(obj2287, "generics",&reader_ast_generics_2295, 0);
  Method *writer2295 = addmethodrealflags(obj2287, "generics:=",&writer_ast_generics_2295, 0);
  reader2295->definitionModule = modulename;
  writer2295->definitionModule = modulename;
  reader2295->definitionLine = 509;
  writer2295->definitionLine = 509;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 7);
if (objclass2287 == NULL) {
  Method *reader2296 = addmethodrealflags(obj2287, "nominal",&reader_ast_nominal_2296, 0);
  Method *writer2296 = addmethodrealflags(obj2287, "nominal:=",&writer_ast_nominal_2296, 0);
  reader2296->definitionModule = modulename;
  writer2296->definitionModule = modulename;
  reader2296->definitionLine = 510;
  writer2296->definitionLine = 510;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 8);
if (objclass2287 == NULL) {
  Method *reader2297 = addmethodrealflags(obj2287, "anonymous",&reader_ast_anonymous_2297, 0);
  Method *writer2297 = addmethodrealflags(obj2287, "anonymous:=",&writer_ast_anonymous_2297, 0);
  reader2297->definitionModule = modulename;
  writer2297->definitionModule = modulename;
  reader2297->definitionLine = 511;
  writer2297->definitionLine = 511;
}
obj2287->flags |= OFLAG_MUTABLE;
adddatum2(obj2287, alloc_Undefined(), 9);
  struct UserObject *uo2298 = (struct UserObject*)obj2287;
  uo2298->data[10] = emptyclosure;
  Method *meth_meth_ast_accept2298 = addmethod2pos(obj2287, "accept", &meth_ast_accept2298, 10);
int argcv_meth_ast_accept2298[] = {1};
meth_meth_ast_accept2298->type = alloc_MethodType(1, argcv_meth_ast_accept2298);
meth_meth_ast_accept2298->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept2298->type->names[0] = "visitor";
  meth_meth_ast_accept2298->definitionModule = modulename;
  meth_meth_ast_accept2298->definitionLine = 511;
  block_savedest(obj2287);
  Object closure2347 = createclosure(1, "map()before()after");
setclosureframe(closure2347, stackframe);
  addtoclosure(closure2347, var_typeNode);
  struct UserObject *uo2347 = (struct UserObject*)obj2287;
  uo2347->data[11] = (Object)closure2347;
  Method *meth_meth_ast_map_40__41_before_40__41_after2347 = addmethod2pos(obj2287, "map()before()after", &meth_ast_map_40__41_before_40__41_after2347, 11);
int argcv_meth_ast_map_40__41_before_40__41_after2347[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after2347->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after2347);
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after2347->definitionLine = 528;
  struct UserObject *uo2451 = (struct UserObject*)obj2287;
  uo2451->data[12] = emptyclosure;
  Method *meth_meth_ast_map2451 = addmethod2pos(obj2287, "map", &meth_ast_map2451, 12);
int argcv_meth_ast_map2451[] = {1};
meth_meth_ast_map2451->type = alloc_MethodType(1, argcv_meth_ast_map2451);
  meth_meth_ast_map2451->definitionModule = modulename;
  meth_meth_ast_map2451->definitionLine = 549;
  struct UserObject *uo2460 = (struct UserObject*)obj2287;
  uo2460->data[13] = emptyclosure;
  Method *meth_meth_ast_pretty2460 = addmethod2pos(obj2287, "pretty", &meth_ast_pretty2460, 13);
int argcv_meth_ast_pretty2460[] = {1};
meth_meth_ast_pretty2460->type = alloc_MethodType(1, argcv_meth_ast_pretty2460);
  meth_meth_ast_pretty2460->definitionModule = modulename;
  meth_meth_ast_pretty2460->definitionLine = 552;
  struct UserObject *uo2710 = (struct UserObject*)obj2287;
  uo2710->data[14] = emptyclosure;
  Method *meth_meth_ast_toGrace2710 = addmethod2pos(obj2287, "toGrace", &meth_ast_toGrace2710, 14);
int argcv_meth_ast_toGrace2710[] = {1};
meth_meth_ast_toGrace2710->type = alloc_MethodType(1, argcv_meth_ast_toGrace2710);
meth_meth_ast_toGrace2710->type->types[0] = type_Number;
meth_meth_ast_toGrace2710->type->names[0] = "depth";
  meth_meth_ast_toGrace2710->definitionModule = modulename;
  meth_meth_ast_toGrace2710->definitionLine = 584;
  sourceObject = obj2287;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3015 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3016 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3015);
// compilenode returning call3016
  struct UserObject *obj2287_uo = (struct UserObject *)obj2287;
  obj2287_uo->super = call3016;
  sourceObject = obj2287;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3017 == NULL) {
    strlit3017 = alloc_String("type");
    gc_root(strlit3017);
  }
// compilenode returning strlit3017
  adddatum2(obj2287, strlit3017, 1);
  sourceObject = obj2287;
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj2287, *var_name_39_, 2);
  sourceObject = obj2287;
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methods_39_
  adddatum2(obj2287, *var_methods_39_, 3);
  sourceObject = obj2287;
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3018 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3018
  adddatum2(obj2287, array3018, 4);
  sourceObject = obj2287;
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3019 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3019
  adddatum2(obj2287, array3019, 5);
  sourceObject = obj2287;
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3020 = gc_frame_new();
  int callframe3021 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3022 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3021);
// compilenode returning call3022
// compilenode returning call3022
  partcv[0] = 0;
  Object call3023 = callmethod(call3022, "new",
    1, partcv, params);
  gc_frame_end(callframe3020);
// compilenode returning call3023
// compilenode returning call3023
  adddatum2(obj2287, call3023, 6);
  sourceObject = obj2287;
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3024 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3024
  adddatum2(obj2287, array3024, 7);
  sourceObject = obj2287;
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3025 = alloc_Boolean(0);
// compilenode returning bool3025
  adddatum2(obj2287, bool3025, 8);
  sourceObject = obj2287;
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3026 = alloc_Boolean(0);
// compilenode returning bool3026
  adddatum2(obj2287, bool3026, 9);
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
  sourceObject = obj2287;
objclass2287 = obj2287->class;
  objclass2287->definitionModule = modulename;
  objclass2287->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2287;
  self = oldself2287;
  selfslot = oldselfslot2287;
  stackframe = oldstackframe2287;
  gc_frame_end(frame);
  return obj2287;
}
Object meth_ast_methodNode3028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_methodNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for methodNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methodNode
  gc_frame_end(frame);
  return *var_methodNode;
}
Object meth_ast__apply3072(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3073 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3074 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe3073);
// compilenode returning call3074
  gc_frame_end(frame);
  return call3074;
}
Object meth_ast__apply3067(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3068 = gc_frame_new();
  int callframe3069 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3070 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3069);
// compilenode returning call3070
// compilenode returning call3070
  gc_frame_newslot(call3070);
  Object block3071 = alloc_Block(NULL, NULL, "ast", 671);
  gc_frame_newslot(block3071);
  block_savedest(block3071);
  Object closure3072 = createclosure(2, "_apply");
setclosureframe(closure3072, stackframe);
  addtoclosure(closure3072, var_visitor);
  addtoclosure(closure3072, selfslot);
  struct UserObject *uo3072 = (struct UserObject*)block3071;
  uo3072->data[0] = (Object)closure3072;
  Method *meth_meth_ast__apply3072 = addmethod2pos(block3071, "_apply", &meth_ast__apply3072, 0);
int argcv_meth_ast__apply3072[] = {1};
meth_meth_ast__apply3072->type = alloc_MethodType(1, argcv_meth_ast__apply3072);
  meth_meth_ast__apply3072->definitionModule = modulename;
  meth_meth_ast__apply3072->definitionLine = 671;
// compilenode returning block3071
  gc_frame_newslot(block3071);
  params[0] = call3070;
  params[1] = block3071;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3076 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3068);
// compilenode returning call3076
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3079 = alloc_Boolean(0);
// compilenode returning bool3079
  int op_slot_right_3078 = gc_frame_newslot(bool3079);
  int callframe3081 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3082 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3081);
// compilenode returning call3082
// compilenode returning call3082
  int op_slot_left_3078 = gc_frame_newslot(call3082);
  params[0] = bool3079;
  partcv[0] = 1;
  Object opresult3083 = callmethod(call3082, "!=", 1, partcv, params);
// compilenode returning opresult3083
  Object if3077 = done;
  if (istrue(opresult3083)) {
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3084 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3085 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3086 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3085);
// compilenode returning call3086
// compilenode returning call3086
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3087 = callmethod(call3086, "accept",
    1, partcv, params);
  gc_frame_end(callframe3084);
// compilenode returning call3087
    gc_frame_newslot(call3087);
    if3077 = call3087;
  } else {
  }
// compilenode returning if3077
  gc_frame_end(frame);
  return if3077;
}
Object meth_ast__apply3094(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 679
  setline(679);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3095 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_mx
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3096 = callmethod(*var_mx, "accept",
    1, partcv, params);
  gc_frame_end(callframe3095);
// compilenode returning call3096
  gc_frame_end(frame);
  return call3096;
}
Object meth_ast_accept3044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3046 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call3047 = callmethod(*var_visitor, "visitMethod",
    1, partcv, params);
  gc_frame_end(callframe3046);
// compilenode returning call3047
  Object if3045 = done;
  if (istrue(call3047)) {
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3048 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3049 = gc_frame_new();
  partcv[0] = 0;
  Object call3050 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3049);
// compilenode returning call3050
// compilenode returning call3050
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3051 = callmethod(call3050, "accept",
    1, partcv, params);
  gc_frame_end(callframe3048);
// compilenode returning call3051
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3054 = alloc_Boolean(0);
// compilenode returning bool3054
  int op_slot_right_3053 = gc_frame_newslot(bool3054);
  int callframe3056 = gc_frame_new();
  partcv[0] = 0;
  Object call3057 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3056);
// compilenode returning call3057
// compilenode returning call3057
  int op_slot_left_3053 = gc_frame_newslot(call3057);
  params[0] = bool3054;
  partcv[0] = 1;
  Object opresult3058 = callmethod(call3057, "!=", 1, partcv, params);
// compilenode returning opresult3058
  Object if3052 = done;
  if (istrue(opresult3058)) {
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3059 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3060 = gc_frame_new();
  partcv[0] = 0;
  Object call3061 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3060);
// compilenode returning call3061
// compilenode returning call3061
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3062 = callmethod(call3061, "accept",
    1, partcv, params);
  gc_frame_end(callframe3059);
// compilenode returning call3062
    gc_frame_newslot(call3062);
    if3052 = call3062;
  } else {
  }
// compilenode returning if3052
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3063 = gc_frame_new();
  int callframe3064 = gc_frame_new();
  partcv[0] = 0;
  Object call3065 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3064);
// compilenode returning call3065
// compilenode returning call3065
  gc_frame_newslot(call3065);
  Object block3066 = alloc_Block(NULL, NULL, "ast", 670);
  gc_frame_newslot(block3066);
  block_savedest(block3066);
  Object closure3067 = createclosure(2, "_apply");
setclosureframe(closure3067, stackframe);
  addtoclosure(closure3067, var_visitor);
  addtoclosure(closure3067, selfslot);
  struct UserObject *uo3067 = (struct UserObject*)block3066;
  uo3067->data[0] = (Object)closure3067;
  Method *meth_meth_ast__apply3067 = addmethod2pos(block3066, "_apply", &meth_ast__apply3067, 0);
int argcv_meth_ast__apply3067[] = {1};
meth_meth_ast__apply3067->type = alloc_MethodType(1, argcv_meth_ast__apply3067);
  meth_meth_ast__apply3067->definitionModule = modulename;
  meth_meth_ast__apply3067->definitionLine = 670;
// compilenode returning block3066
  gc_frame_newslot(block3066);
  params[0] = call3065;
  params[1] = block3066;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3089 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compilenode returning call3089
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3090 = gc_frame_new();
  int callframe3091 = gc_frame_new();
  partcv[0] = 0;
  Object call3092 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3091);
// compilenode returning call3092
// compilenode returning call3092
  gc_frame_newslot(call3092);
  Object block3093 = alloc_Block(NULL, NULL, "ast", 678);
  gc_frame_newslot(block3093);
  block_savedest(block3093);
  Object closure3094 = createclosure(2, "_apply");
setclosureframe(closure3094, stackframe);
  addtoclosure(closure3094, var_visitor);
  addtoclosure(closure3094, selfslot);
  struct UserObject *uo3094 = (struct UserObject*)block3093;
  uo3094->data[0] = (Object)closure3094;
  Method *meth_meth_ast__apply3094 = addmethod2pos(block3093, "_apply", &meth_ast__apply3094, 0);
int argcv_meth_ast__apply3094[] = {1};
meth_meth_ast__apply3094->type = alloc_MethodType(1, argcv_meth_ast__apply3094);
  meth_meth_ast__apply3094->definitionModule = modulename;
  meth_meth_ast__apply3094->definitionLine = 678;
// compilenode returning block3093
  gc_frame_newslot(block3093);
  params[0] = call3092;
  params[1] = block3093;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3098 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3090);
// compilenode returning call3098
    gc_frame_newslot(call3098);
    if3045 = call3098;
  } else {
  }
// compilenode returning if3045
  gc_frame_end(frame);
  return if3045;
}
Object meth_ast__apply3137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3138 = gc_frame_new();
  int callframe3139 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3140 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3139);
// compilenode returning call3140
  gc_frame_newslot(call3140);
  int callframe3141 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call3142 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe3141);
// compilenode returning call3142
// compilenode returning call3142
  params[0] = call3140;
  partcv[0] = 1;
  Object call3143 = callmethod(call3142, "push",
    1, partcv, params);
  gc_frame_end(callframe3138);
// compilenode returning call3143
  gc_frame_end(frame);
  return call3143;
}
Object meth_ast__apply3156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3157 = gc_frame_new();
  int callframe3158 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3159 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3158);
// compilenode returning call3159
  gc_frame_newslot(call3159);
  int callframe3160 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call3161 = callmethod(*var_n, "generics",
    1, partcv, params);
  gc_frame_end(callframe3160);
// compilenode returning call3161
// compilenode returning call3161
  params[0] = call3159;
  partcv[0] = 1;
  Object call3162 = callmethod(call3161, "push",
    1, partcv, params);
  gc_frame_end(callframe3157);
// compilenode returning call3162
  gc_frame_end(frame);
  return call3162;
}
Object meth_ast_map_40__41_before_40__41_after3099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_name_39_ = getfromclosure(closure, 0);
  Object *var_methodNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dt = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dt");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3100 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call3101 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe3100);
// compilenode returning call3101
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3102 = alloc_Boolean(0);
// compilenode returning bool3102
  *var_dt = bool3102;
  if (bool3102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3105 = alloc_Boolean(0);
// compilenode returning bool3105
  int op_slot_right_3104 = gc_frame_newslot(bool3105);
  int callframe3107 = gc_frame_new();
  partcv[0] = 0;
  Object call3108 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3107);
// compilenode returning call3108
  int op_slot_left_3104 = gc_frame_newslot(call3108);
  params[0] = bool3105;
  partcv[0] = 1;
  Object opresult3109 = callmethod(call3108, "!=", 1, partcv, params);
// compilenode returning opresult3109
  Object if3103 = done;
  if (istrue(opresult3109)) {
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3110 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3111 = gc_frame_new();
  partcv[0] = 0;
  Object call3112 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3111);
// compilenode returning call3112
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3113 = callmethod(call3112, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3110);
// compilenode returning call3113
  *var_dt = call3113;
  if (call3113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3103 = done;
  } else {
  }
// compilenode returning if3103
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3115 = gc_frame_new();
// compilenode returning *var_name_39_
  gc_frame_newslot(*var_name_39_);
  int callframe3116 = gc_frame_new();
  partcv[0] = 0;
  Object call3117 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3116);
// compilenode returning call3117
  gc_frame_newslot(call3117);
  int callframe3118 = gc_frame_new();
  int callframe3119 = gc_frame_new();
  partcv[0] = 0;
  Object call3120 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3119);
// compilenode returning call3120
  gc_frame_newslot(call3120);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3121 = gc_frame_new();
  int callframe3122 = gc_frame_new();
  Object call3123 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3122);
// compilenode returning call3123
// compilenode returning call3123
  partcv[0] = 0;
  Object call3124 = callmethodflags(call3123, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3121);
// compilenode returning call3124
// compilenode returning call3124
  params[0] = call3120;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3125 = callmethodflags(call3124, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compilenode returning call3125
  gc_frame_newslot(call3125);
// compilenode returning *var_dt
  gc_frame_newslot(*var_dt);
// compilenode returning *var_methodNode
  params[0] = *var_name_39_;
  params[1] = call3117;
  params[2] = call3125;
  params[3] = *var_dt;
  partcv[0] = 4;
  Object call3126 = callmethod(*var_methodNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3115);
// compilenode returning call3126
  *var_n = call3126;
  if (call3126 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3127 = gc_frame_new();
  int callframe3128 = gc_frame_new();
  int callframe3129 = gc_frame_new();
  partcv[0] = 0;
  Object call3130 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3129);
// compilenode returning call3130
  gc_frame_newslot(call3130);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3131 = gc_frame_new();
  int callframe3132 = gc_frame_new();
  Object call3133 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3132);
// compilenode returning call3133
// compilenode returning call3133
  partcv[0] = 0;
  Object call3134 = callmethodflags(call3133, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3131);
// compilenode returning call3134
// compilenode returning call3134
  params[0] = call3130;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3135 = callmethodflags(call3134, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3128);
// compilenode returning call3135
  gc_frame_newslot(call3135);
  Object block3136 = alloc_Block(NULL, NULL, "ast", 690);
  gc_frame_newslot(block3136);
  block_savedest(block3136);
  Object closure3137 = createclosure(5, "_apply");
setclosureframe(closure3137, stackframe);
  addtoclosure(closure3137, var_blk);
  addtoclosure(closure3137, var_blkBefore);
  addtoclosure(closure3137, var_blkAfter);
  addtoclosure(closure3137, var_n);
  addtoclosure(closure3137, selfslot);
  struct UserObject *uo3137 = (struct UserObject*)block3136;
  uo3137->data[0] = (Object)closure3137;
  Method *meth_meth_ast__apply3137 = addmethod2pos(block3136, "_apply", &meth_ast__apply3137, 0);
int argcv_meth_ast__apply3137[] = {1};
meth_meth_ast__apply3137->type = alloc_MethodType(1, argcv_meth_ast__apply3137);
  meth_meth_ast__apply3137->definitionModule = modulename;
  meth_meth_ast__apply3137->definitionLine = 690;
// compilenode returning block3136
  gc_frame_newslot(block3136);
  params[0] = call3135;
  params[1] = block3136;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3145 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3127);
// compilenode returning call3145
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3146 = gc_frame_new();
  int callframe3147 = gc_frame_new();
  int callframe3148 = gc_frame_new();
  partcv[0] = 0;
  Object call3149 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3148);
// compilenode returning call3149
  gc_frame_newslot(call3149);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3150 = gc_frame_new();
  int callframe3151 = gc_frame_new();
  Object call3152 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3151);
// compilenode returning call3152
// compilenode returning call3152
  partcv[0] = 0;
  Object call3153 = callmethodflags(call3152, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3150);
// compilenode returning call3153
// compilenode returning call3153
  params[0] = call3149;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3154 = callmethodflags(call3153, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3147);
// compilenode returning call3154
  gc_frame_newslot(call3154);
  Object block3155 = alloc_Block(NULL, NULL, "ast", 693);
  gc_frame_newslot(block3155);
  block_savedest(block3155);
  Object closure3156 = createclosure(5, "_apply");
setclosureframe(closure3156, stackframe);
  addtoclosure(closure3156, var_blk);
  addtoclosure(closure3156, var_blkBefore);
  addtoclosure(closure3156, var_blkAfter);
  addtoclosure(closure3156, var_n);
  addtoclosure(closure3156, selfslot);
  struct UserObject *uo3156 = (struct UserObject*)block3155;
  uo3156->data[0] = (Object)closure3156;
  Method *meth_meth_ast__apply3156 = addmethod2pos(block3155, "_apply", &meth_ast__apply3156, 0);
int argcv_meth_ast__apply3156[] = {1};
meth_meth_ast__apply3156->type = alloc_MethodType(1, argcv_meth_ast__apply3156);
  meth_meth_ast__apply3156->definitionModule = modulename;
  meth_meth_ast__apply3156->definitionLine = 693;
// compilenode returning block3155
  gc_frame_newslot(block3155);
  params[0] = call3154;
  params[1] = block3155;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3164 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3146);
// compilenode returning call3164
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3165 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3166 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3165);
// compilenode returning call3166
  *var_n = call3166;
  if (call3166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3168 = gc_frame_new();
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3169 = gc_frame_new();
  partcv[0] = 0;
  Object call3170 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3169);
// compilenode returning call3170
  gc_frame_newslot(call3170);
// compilenode returning *var_n
  params[0] = call3170;
  partcv[0] = 1;
  Object call3171 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3168);
// compilenode returning call3171
// compilenode returning done
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3172 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3173 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe3172);
// compilenode returning call3173
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map3174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3175 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block3176 = alloc_Block(NULL, NULL, "ast", 702);
  gc_frame_newslot(block3176);
  block_savedest(block3176);
  Object closure3177 = createclosure(1, "_apply");
setclosureframe(closure3177, stackframe);
  addtoclosure(closure3177, selfslot);
  struct UserObject *uo3177 = (struct UserObject*)block3176;
  uo3177->data[0] = (Object)closure3177;
  Method *meth_meth_ast__apply3177 = addmethod2pos(block3176, "_apply", &meth_ast__apply3177, 0);
int argcv_meth_ast__apply3177[] = {0};
meth_meth_ast__apply3177->type = alloc_MethodType(1, argcv_meth_ast__apply3177);
  meth_meth_ast__apply3177->definitionModule = modulename;
  meth_meth_ast__apply3177->definitionLine = 694;
// compilenode returning block3176
  gc_frame_newslot(block3176);
  Object block3179 = alloc_Block(NULL, NULL, "ast", 702);
  gc_frame_newslot(block3179);
  block_savedest(block3179);
  Object closure3180 = createclosure(1, "_apply");
setclosureframe(closure3180, stackframe);
  addtoclosure(closure3180, selfslot);
  struct UserObject *uo3180 = (struct UserObject*)block3179;
  uo3180->data[0] = (Object)closure3180;
  Method *meth_meth_ast__apply3180 = addmethod2pos(block3179, "_apply", &meth_ast__apply3180, 0);
int argcv_meth_ast__apply3180[] = {0};
meth_meth_ast__apply3180->type = alloc_MethodType(1, argcv_meth_ast__apply3180);
  meth_meth_ast__apply3180->definitionModule = modulename;
  meth_meth_ast__apply3180->definitionLine = 694;
// compilenode returning block3179
  gc_frame_newslot(block3179);
  params[0] = *var_blk;
  params[1] = block3176;
  params[2] = block3179;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3182 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3175);
// compilenode returning call3182
  gc_frame_end(frame);
  return call3182;
}
Object meth_ast__apply3193(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_blk = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3194 = gc_frame_new();
// compilenode returning *var_p
  gc_frame_newslot(*var_p);
// compilenode returning *var_blk
  params[0] = *var_p;
  partcv[0] = 1;
  Object call3195 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3194);
// compilenode returning call3195
  gc_frame_end(frame);
  return call3195;
}
Object meth_ast__apply3188(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_blk = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3189 = gc_frame_new();
  int callframe3190 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call3191 = callmethod(*var_s, "params",
    1, partcv, params);
  gc_frame_end(callframe3190);
// compilenode returning call3191
// compilenode returning call3191
  gc_frame_newslot(call3191);
  Object block3192 = alloc_Block(NULL, NULL, "ast", 706);
  gc_frame_newslot(block3192);
  block_savedest(block3192);
  Object closure3193 = createclosure(2, "_apply");
setclosureframe(closure3193, stackframe);
  addtoclosure(closure3193, var_blk);
  addtoclosure(closure3193, selfslot);
  struct UserObject *uo3193 = (struct UserObject*)block3192;
  uo3193->data[0] = (Object)closure3193;
  Method *meth_meth_ast__apply3193 = addmethod2pos(block3192, "_apply", &meth_ast__apply3193, 0);
int argcv_meth_ast__apply3193[] = {1};
meth_meth_ast__apply3193->type = alloc_MethodType(1, argcv_meth_ast__apply3193);
  meth_meth_ast__apply3193->definitionModule = modulename;
  meth_meth_ast__apply3193->definitionLine = 706;
// compilenode returning block3192
  gc_frame_newslot(block3192);
  params[0] = call3191;
  params[1] = block3192;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3197 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3189);
// compilenode returning call3197
  gc_frame_end(frame);
  return call3197;
}
Object meth_ast_eachParameter3183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "eachParameter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for eachParameter (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for eachParameter");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3184 = gc_frame_new();
  int callframe3185 = gc_frame_new();
  partcv[0] = 0;
  Object call3186 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3185);
// compilenode returning call3186
  gc_frame_newslot(call3186);
  Object block3187 = alloc_Block(NULL, NULL, "ast", 705);
  gc_frame_newslot(block3187);
  block_savedest(block3187);
  Object closure3188 = createclosure(2, "_apply");
setclosureframe(closure3188, stackframe);
  addtoclosure(closure3188, var_blk);
  addtoclosure(closure3188, selfslot);
  struct UserObject *uo3188 = (struct UserObject*)block3187;
  uo3188->data[0] = (Object)closure3188;
  Method *meth_meth_ast__apply3188 = addmethod2pos(block3187, "_apply", &meth_ast__apply3188, 0);
int argcv_meth_ast__apply3188[] = {1};
meth_meth_ast__apply3188->type = alloc_MethodType(1, argcv_meth_ast__apply3188);
  meth_meth_ast__apply3188->definitionModule = modulename;
  meth_meth_ast__apply3188->definitionLine = 694;
// compilenode returning block3187
  gc_frame_newslot(block3187);
  params[0] = call3186;
  params[1] = block3187;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3199 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3184);
// compilenode returning call3199
  gc_frame_end(frame);
  return call3199;
}
Object meth_ast__apply3208(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3210 == NULL) {
    strlit3210 = alloc_String("  ");
    gc_root(strlit3210);
  }
// compilenode returning strlit3210
  int op_slot_right_3209 = gc_frame_newslot(strlit3210);
// compilenode returning *var_spc
  int op_slot_left_3209 = gc_frame_newslot(*var_spc);
  params[0] = strlit3210;
  partcv[0] = 1;
  Object opresult3212 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3212
  *var_spc = opresult3212;
  if (opresult3212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3347 == NULL) {
    strlit3347 = alloc_String("");
    gc_root(strlit3347);
  }
// compilenode returning strlit3347
  int op_slot_right_3346 = gc_frame_newslot(strlit3347);
  int callframe3350 = gc_frame_new();
  Object num3352 = alloc_Float64(4);
// compilenode returning num3352
  int op_slot_right_3351 = gc_frame_newslot(num3352);
// compilenode returning *var_depth
  int op_slot_left_3351 = gc_frame_newslot(*var_depth);
  params[0] = num3352;
  partcv[0] = 1;
  Object sum3354 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3354
  gc_frame_newslot(sum3354);
// compilenode returning *var_p
  params[0] = sum3354;
  partcv[0] = 1;
  Object call3355 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3350);
// compilenode returning call3355
  int op_slot_right_3349 = gc_frame_newslot(call3355);
  if (strlit3358 == NULL) {
    strlit3358 = alloc_String("");
    gc_root(strlit3358);
  }
// compilenode returning strlit3358
  int op_slot_right_3357 = gc_frame_newslot(strlit3358);
// compilenode returning *var_spc
  int op_slot_right_3360 = gc_frame_newslot(*var_spc);
  if (strlit3363 == NULL) {
    strlit3363 = alloc_String("""\x0a""      ");
    gc_root(strlit3363);
  }
// compilenode returning strlit3363
  int op_slot_right_3362 = gc_frame_newslot(strlit3363);
// compilenode returning *var_s
  int op_slot_right_3365 = gc_frame_newslot(*var_s);
  if (strlit3367 == NULL) {
    strlit3367 = alloc_String("");
    gc_root(strlit3367);
  }
// compilenode returning strlit3367
  int op_slot_left_3365 = gc_frame_newslot(strlit3367);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3368 = callmethod(strlit3367, "++", 1, partcv, params);
// compilenode returning opresult3368
  int op_slot_left_3362 = gc_frame_newslot(opresult3368);
  params[0] = strlit3363;
  partcv[0] = 1;
  Object opresult3369 = callmethod(opresult3368, "++", 1, partcv, params);
// compilenode returning opresult3369
  int op_slot_left_3360 = gc_frame_newslot(opresult3369);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3370 = callmethod(opresult3369, "++", 1, partcv, params);
// compilenode returning opresult3370
  int op_slot_left_3357 = gc_frame_newslot(opresult3370);
  params[0] = strlit3358;
  partcv[0] = 1;
  Object opresult3371 = callmethod(opresult3370, "++", 1, partcv, params);
// compilenode returning opresult3371
  int op_slot_left_3349 = gc_frame_newslot(opresult3371);
  params[0] = call3355;
  partcv[0] = 1;
  Object opresult3372 = callmethod(opresult3371, "++", 1, partcv, params);
// compilenode returning opresult3372
  int op_slot_left_3346 = gc_frame_newslot(opresult3372);
  params[0] = strlit3347;
  partcv[0] = 1;
  Object opresult3373 = callmethod(opresult3372, "++", 1, partcv, params);
// compilenode returning opresult3373
  *var_s = opresult3373;
  if (opresult3373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3299(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3301 == NULL) {
    strlit3301 = alloc_String("");
    gc_root(strlit3301);
  }
// compilenode returning strlit3301
  int op_slot_right_3300 = gc_frame_newslot(strlit3301);
  int callframe3304 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3305 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compilenode returning call3305
// compilenode returning call3305
  int op_slot_right_3303 = gc_frame_newslot(call3305);
  if (strlit3308 == NULL) {
    strlit3308 = alloc_String("Part: ");
    gc_root(strlit3308);
  }
// compilenode returning strlit3308
  int op_slot_right_3307 = gc_frame_newslot(strlit3308);
// compilenode returning *var_spc
  int op_slot_right_3310 = gc_frame_newslot(*var_spc);
  if (strlit3313 == NULL) {
    strlit3313 = alloc_String("""\x0a""  ");
    gc_root(strlit3313);
  }
// compilenode returning strlit3313
  int op_slot_right_3312 = gc_frame_newslot(strlit3313);
// compilenode returning *var_s
  int op_slot_right_3315 = gc_frame_newslot(*var_s);
  if (strlit3317 == NULL) {
    strlit3317 = alloc_String("");
    gc_root(strlit3317);
  }
// compilenode returning strlit3317
  int op_slot_left_3315 = gc_frame_newslot(strlit3317);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3318 = callmethod(strlit3317, "++", 1, partcv, params);
// compilenode returning opresult3318
  int op_slot_left_3312 = gc_frame_newslot(opresult3318);
  params[0] = strlit3313;
  partcv[0] = 1;
  Object opresult3319 = callmethod(opresult3318, "++", 1, partcv, params);
// compilenode returning opresult3319
  int op_slot_left_3310 = gc_frame_newslot(opresult3319);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3320 = callmethod(opresult3319, "++", 1, partcv, params);
// compilenode returning opresult3320
  int op_slot_left_3307 = gc_frame_newslot(opresult3320);
  params[0] = strlit3308;
  partcv[0] = 1;
  Object opresult3321 = callmethod(opresult3320, "++", 1, partcv, params);
// compilenode returning opresult3321
  int op_slot_left_3303 = gc_frame_newslot(opresult3321);
  params[0] = call3305;
  partcv[0] = 1;
  Object opresult3322 = callmethod(opresult3321, "++", 1, partcv, params);
// compilenode returning opresult3322
  int op_slot_left_3300 = gc_frame_newslot(opresult3322);
  params[0] = strlit3301;
  partcv[0] = 1;
  Object opresult3323 = callmethod(opresult3322, "++", 1, partcv, params);
// compilenode returning opresult3323
  *var_s = opresult3323;
  if (opresult3323 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3326 == NULL) {
    strlit3326 = alloc_String("Parameters:");
    gc_root(strlit3326);
  }
// compilenode returning strlit3326
  int op_slot_right_3325 = gc_frame_newslot(strlit3326);
// compilenode returning *var_spc
  int op_slot_right_3328 = gc_frame_newslot(*var_spc);
  if (strlit3331 == NULL) {
    strlit3331 = alloc_String("""\x0a""    ");
    gc_root(strlit3331);
  }
// compilenode returning strlit3331
  int op_slot_right_3330 = gc_frame_newslot(strlit3331);
// compilenode returning *var_s
  int op_slot_right_3333 = gc_frame_newslot(*var_s);
  if (strlit3335 == NULL) {
    strlit3335 = alloc_String("");
    gc_root(strlit3335);
  }
// compilenode returning strlit3335
  int op_slot_left_3333 = gc_frame_newslot(strlit3335);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3336 = callmethod(strlit3335, "++", 1, partcv, params);
// compilenode returning opresult3336
  int op_slot_left_3330 = gc_frame_newslot(opresult3336);
  params[0] = strlit3331;
  partcv[0] = 1;
  Object opresult3337 = callmethod(opresult3336, "++", 1, partcv, params);
// compilenode returning opresult3337
  int op_slot_left_3328 = gc_frame_newslot(opresult3337);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3338 = callmethod(opresult3337, "++", 1, partcv, params);
// compilenode returning opresult3338
  int op_slot_left_3325 = gc_frame_newslot(opresult3338);
  params[0] = strlit3326;
  partcv[0] = 1;
  Object opresult3339 = callmethod(opresult3338, "++", 1, partcv, params);
// compilenode returning opresult3339
  *var_s = opresult3339;
  if (opresult3339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 727
  setline(727);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3341 = gc_frame_new();
  int callframe3342 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3343 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compilenode returning call3343
// compilenode returning call3343
  gc_frame_newslot(call3343);
  Object block3344 = alloc_Block(NULL, NULL, "ast", 727);
  gc_frame_newslot(block3344);
  block_savedest(block3344);
  Object closure3345 = createclosure(4, "_apply");
setclosureframe(closure3345, stackframe);
  addtoclosure(closure3345, var_depth);
  addtoclosure(closure3345, var_spc);
  addtoclosure(closure3345, var_s);
  addtoclosure(closure3345, selfslot);
  struct UserObject *uo3345 = (struct UserObject*)block3344;
  uo3345->data[0] = (Object)closure3345;
  Method *meth_meth_ast__apply3345 = addmethod2pos(block3344, "_apply", &meth_ast__apply3345, 0);
int argcv_meth_ast__apply3345[] = {1};
meth_meth_ast__apply3345->type = alloc_MethodType(1, argcv_meth_ast__apply3345);
  meth_meth_ast__apply3345->definitionModule = modulename;
  meth_meth_ast__apply3345->definitionLine = 727;
// compilenode returning block3344
  gc_frame_newslot(block3344);
  params[0] = call3343;
  params[1] = block3344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3376 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3341);
// compilenode returning call3376
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3379 = alloc_Boolean(0);
// compilenode returning bool3379
  int op_slot_right_3378 = gc_frame_newslot(bool3379);
  int callframe3381 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3382 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3381);
// compilenode returning call3382
// compilenode returning call3382
  int op_slot_left_3378 = gc_frame_newslot(call3382);
  params[0] = bool3379;
  partcv[0] = 1;
  Object opresult3383 = callmethod(call3382, "!=", 1, partcv, params);
// compilenode returning opresult3383
  Object if3377 = done;
  if (istrue(opresult3383)) {
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3385 == NULL) {
    strlit3385 = alloc_String("");
    gc_root(strlit3385);
  }
// compilenode returning strlit3385
  int op_slot_right_3384 = gc_frame_newslot(strlit3385);
  int callframe3388 = gc_frame_new();
  Object num3390 = alloc_Float64(3);
// compilenode returning num3390
  int op_slot_right_3389 = gc_frame_newslot(num3390);
// compilenode returning *var_depth
  int op_slot_left_3389 = gc_frame_newslot(*var_depth);
  params[0] = num3390;
  partcv[0] = 1;
  Object sum3392 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3392
  gc_frame_newslot(sum3392);
  int callframe3393 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3394 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3393);
// compilenode returning call3394
// compilenode returning call3394
  params[0] = sum3392;
  partcv[0] = 1;
  Object call3395 = callmethod(call3394, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3388);
// compilenode returning call3395
  int op_slot_right_3387 = gc_frame_newslot(call3395);
  if (strlit3398 == NULL) {
    strlit3398 = alloc_String("Vararg: ");
    gc_root(strlit3398);
  }
// compilenode returning strlit3398
  int op_slot_right_3397 = gc_frame_newslot(strlit3398);
// compilenode returning *var_spc
  int op_slot_right_3400 = gc_frame_newslot(*var_spc);
  if (strlit3403 == NULL) {
    strlit3403 = alloc_String("""\x0a""    ");
    gc_root(strlit3403);
  }
// compilenode returning strlit3403
  int op_slot_right_3402 = gc_frame_newslot(strlit3403);
// compilenode returning *var_s
  int op_slot_right_3405 = gc_frame_newslot(*var_s);
  if (strlit3407 == NULL) {
    strlit3407 = alloc_String("");
    gc_root(strlit3407);
  }
// compilenode returning strlit3407
  int op_slot_left_3405 = gc_frame_newslot(strlit3407);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3408 = callmethod(strlit3407, "++", 1, partcv, params);
// compilenode returning opresult3408
  int op_slot_left_3402 = gc_frame_newslot(opresult3408);
  params[0] = strlit3403;
  partcv[0] = 1;
  Object opresult3409 = callmethod(opresult3408, "++", 1, partcv, params);
// compilenode returning opresult3409
  int op_slot_left_3400 = gc_frame_newslot(opresult3409);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3410 = callmethod(opresult3409, "++", 1, partcv, params);
// compilenode returning opresult3410
  int op_slot_left_3397 = gc_frame_newslot(opresult3410);
  params[0] = strlit3398;
  partcv[0] = 1;
  Object opresult3411 = callmethod(opresult3410, "++", 1, partcv, params);
// compilenode returning opresult3411
  int op_slot_left_3387 = gc_frame_newslot(opresult3411);
  params[0] = call3395;
  partcv[0] = 1;
  Object opresult3412 = callmethod(opresult3411, "++", 1, partcv, params);
// compilenode returning opresult3412
  int op_slot_left_3384 = gc_frame_newslot(opresult3412);
  params[0] = strlit3385;
  partcv[0] = 1;
  Object opresult3413 = callmethod(opresult3412, "++", 1, partcv, params);
// compilenode returning opresult3413
  *var_s = opresult3413;
  if (opresult3413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3377 = done;
  } else {
  }
// compilenode returning if3377
  gc_frame_end(frame);
  return if3377;
}
Object meth_ast__apply3449(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3451 == NULL) {
    strlit3451 = alloc_String("");
    gc_root(strlit3451);
  }
// compilenode returning strlit3451
  int op_slot_right_3450 = gc_frame_newslot(strlit3451);
  int callframe3454 = gc_frame_new();
  Object num3455 = alloc_Float64(0);
// compilenode returning num3455
  gc_frame_newslot(num3455);
// compilenode returning *var_g
  params[0] = num3455;
  partcv[0] = 1;
  Object call3456 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3454);
// compilenode returning call3456
  int op_slot_right_3453 = gc_frame_newslot(call3456);
  if (strlit3459 == NULL) {
    strlit3459 = alloc_String("  ");
    gc_root(strlit3459);
  }
// compilenode returning strlit3459
  int op_slot_right_3458 = gc_frame_newslot(strlit3459);
// compilenode returning *var_spc
  int op_slot_right_3461 = gc_frame_newslot(*var_spc);
  if (strlit3464 == NULL) {
    strlit3464 = alloc_String("""\x0a""");
    gc_root(strlit3464);
  }
// compilenode returning strlit3464
  int op_slot_right_3463 = gc_frame_newslot(strlit3464);
// compilenode returning *var_s
  int op_slot_right_3466 = gc_frame_newslot(*var_s);
  if (strlit3468 == NULL) {
    strlit3468 = alloc_String("");
    gc_root(strlit3468);
  }
// compilenode returning strlit3468
  int op_slot_left_3466 = gc_frame_newslot(strlit3468);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3469 = callmethod(strlit3468, "++", 1, partcv, params);
// compilenode returning opresult3469
  int op_slot_left_3463 = gc_frame_newslot(opresult3469);
  params[0] = strlit3464;
  partcv[0] = 1;
  Object opresult3470 = callmethod(opresult3469, "++", 1, partcv, params);
// compilenode returning opresult3470
  int op_slot_left_3461 = gc_frame_newslot(opresult3470);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3471 = callmethod(opresult3470, "++", 1, partcv, params);
// compilenode returning opresult3471
  int op_slot_left_3458 = gc_frame_newslot(opresult3471);
  params[0] = strlit3459;
  partcv[0] = 1;
  Object opresult3472 = callmethod(opresult3471, "++", 1, partcv, params);
// compilenode returning opresult3472
  int op_slot_left_3453 = gc_frame_newslot(opresult3472);
  params[0] = call3456;
  partcv[0] = 1;
  Object opresult3473 = callmethod(opresult3472, "++", 1, partcv, params);
// compilenode returning opresult3473
  int op_slot_left_3450 = gc_frame_newslot(opresult3473);
  params[0] = strlit3451;
  partcv[0] = 1;
  Object opresult3474 = callmethod(opresult3473, "++", 1, partcv, params);
// compilenode returning opresult3474
  *var_s = opresult3474;
  if (opresult3474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3512(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_an = &(stackframe->slots[0]);
  *var_an = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 745
  setline(745);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3514 == NULL) {
    strlit3514 = alloc_String("");
    gc_root(strlit3514);
  }
// compilenode returning strlit3514
  int op_slot_right_3513 = gc_frame_newslot(strlit3514);
  int callframe3517 = gc_frame_new();
  Object num3519 = alloc_Float64(2);
// compilenode returning num3519
  int op_slot_right_3518 = gc_frame_newslot(num3519);
// compilenode returning *var_depth
  int op_slot_left_3518 = gc_frame_newslot(*var_depth);
  params[0] = num3519;
  partcv[0] = 1;
  Object sum3521 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3521
  gc_frame_newslot(sum3521);
// compilenode returning *var_an
  params[0] = sum3521;
  partcv[0] = 1;
  Object call3522 = callmethod(*var_an, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3517);
// compilenode returning call3522
  int op_slot_right_3516 = gc_frame_newslot(call3522);
  if (strlit3525 == NULL) {
    strlit3525 = alloc_String("  ");
    gc_root(strlit3525);
  }
// compilenode returning strlit3525
  int op_slot_right_3524 = gc_frame_newslot(strlit3525);
// compilenode returning *var_spc
  int op_slot_right_3527 = gc_frame_newslot(*var_spc);
  if (strlit3530 == NULL) {
    strlit3530 = alloc_String("""\x0a""");
    gc_root(strlit3530);
  }
// compilenode returning strlit3530
  int op_slot_right_3529 = gc_frame_newslot(strlit3530);
// compilenode returning *var_s
  int op_slot_right_3532 = gc_frame_newslot(*var_s);
  if (strlit3534 == NULL) {
    strlit3534 = alloc_String("");
    gc_root(strlit3534);
  }
// compilenode returning strlit3534
  int op_slot_left_3532 = gc_frame_newslot(strlit3534);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3535 = callmethod(strlit3534, "++", 1, partcv, params);
// compilenode returning opresult3535
  int op_slot_left_3529 = gc_frame_newslot(opresult3535);
  params[0] = strlit3530;
  partcv[0] = 1;
  Object opresult3536 = callmethod(opresult3535, "++", 1, partcv, params);
// compilenode returning opresult3536
  int op_slot_left_3527 = gc_frame_newslot(opresult3536);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3537 = callmethod(opresult3536, "++", 1, partcv, params);
// compilenode returning opresult3537
  int op_slot_left_3524 = gc_frame_newslot(opresult3537);
  params[0] = strlit3525;
  partcv[0] = 1;
  Object opresult3538 = callmethod(opresult3537, "++", 1, partcv, params);
// compilenode returning opresult3538
  int op_slot_left_3516 = gc_frame_newslot(opresult3538);
  params[0] = call3522;
  partcv[0] = 1;
  Object opresult3539 = callmethod(opresult3538, "++", 1, partcv, params);
// compilenode returning opresult3539
  int op_slot_left_3513 = gc_frame_newslot(opresult3539);
  params[0] = strlit3514;
  partcv[0] = 1;
  Object opresult3540 = callmethod(opresult3539, "++", 1, partcv, params);
// compilenode returning opresult3540
  *var_s = opresult3540;
  if (opresult3540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3563 = gc_frame_new();
  Object num3565 = alloc_Float64(2);
// compilenode returning num3565
  int op_slot_right_3564 = gc_frame_newslot(num3565);
// compilenode returning *var_depth
  int op_slot_left_3564 = gc_frame_newslot(*var_depth);
  params[0] = num3565;
  partcv[0] = 1;
  Object sum3567 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3567
  gc_frame_newslot(sum3567);
// compilenode returning *var_mx
  params[0] = sum3567;
  partcv[0] = 1;
  Object call3568 = callmethod(*var_mx, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3563);
// compilenode returning call3568
  int op_slot_right_3562 = gc_frame_newslot(call3568);
// compilenode returning *var_spc
  int op_slot_right_3570 = gc_frame_newslot(*var_spc);
  if (strlit3573 == NULL) {
    strlit3573 = alloc_String("""\x0a""  ");
    gc_root(strlit3573);
  }
// compilenode returning strlit3573
  int op_slot_right_3572 = gc_frame_newslot(strlit3573);
// compilenode returning *var_s
  int op_slot_left_3572 = gc_frame_newslot(*var_s);
  params[0] = strlit3573;
  partcv[0] = 1;
  Object opresult3575 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3575
  int op_slot_left_3570 = gc_frame_newslot(opresult3575);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3576 = callmethod(opresult3575, "++", 1, partcv, params);
// compilenode returning opresult3576
  int op_slot_left_3562 = gc_frame_newslot(opresult3576);
  params[0] = call3568;
  partcv[0] = 1;
  Object opresult3577 = callmethod(opresult3576, "++", 1, partcv, params);
// compilenode returning opresult3577
  *var_s = opresult3577;
  if (opresult3577 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty3200(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3201 == NULL) {
    strlit3201 = alloc_String("");
    gc_root(strlit3201);
  }
// compilenode returning strlit3201
  *var_spc = strlit3201;
  if (strlit3201 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3202 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_3203 = gc_frame_newslot(*var_depth);
  Object num3205 = alloc_Float64(0);
// compilenode returning num3205
  int op_slot_left_3203 = gc_frame_newslot(num3205);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3206 = callmethod(num3205, "..", 1, partcv, params);
// compilenode returning opresult3206
  gc_frame_newslot(opresult3206);
  Object block3207 = alloc_Block(NULL, NULL, "ast", 713);
  gc_frame_newslot(block3207);
  block_savedest(block3207);
  Object closure3208 = createclosure(2, "_apply");
setclosureframe(closure3208, stackframe);
  addtoclosure(closure3208, var_spc);
  addtoclosure(closure3208, selfslot);
  struct UserObject *uo3208 = (struct UserObject*)block3207;
  uo3208->data[0] = (Object)closure3208;
  Method *meth_meth_ast__apply3208 = addmethod2pos(block3207, "_apply", &meth_ast__apply3208, 0);
int argcv_meth_ast__apply3208[] = {1};
meth_meth_ast__apply3208->type = alloc_MethodType(1, argcv_meth_ast__apply3208);
  meth_meth_ast__apply3208->definitionModule = modulename;
  meth_meth_ast__apply3208->definitionLine = 706;
// compilenode returning block3207
  gc_frame_newslot(block3207);
  params[0] = opresult3206;
  params[1] = block3207;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3215 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3202);
// compilenode returning call3215
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 716
  setline(716);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3216 == NULL) {
    strlit3216 = alloc_String("Method""\x0a""");
    gc_root(strlit3216);
  }
// compilenode returning strlit3216
  *var_s = strlit3216;
  if (strlit3216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 717
  setline(717);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3218 = gc_frame_new();
  Object num3220 = alloc_Float64(1);
// compilenode returning num3220
  int op_slot_right_3219 = gc_frame_newslot(num3220);
// compilenode returning *var_depth
  int op_slot_left_3219 = gc_frame_newslot(*var_depth);
  params[0] = num3220;
  partcv[0] = 1;
  Object sum3222 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3222
  gc_frame_newslot(sum3222);
  int callframe3223 = gc_frame_new();
  partcv[0] = 0;
  Object call3224 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compilenode returning call3224
// compilenode returning call3224
  params[0] = sum3222;
  partcv[0] = 1;
  Object call3225 = callmethod(call3224, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3218);
// compilenode returning call3225
  int op_slot_right_3217 = gc_frame_newslot(call3225);
  if (strlit3228 == NULL) {
    strlit3228 = alloc_String("Name: ");
    gc_root(strlit3228);
  }
// compilenode returning strlit3228
  int op_slot_right_3227 = gc_frame_newslot(strlit3228);
// compilenode returning *var_spc
  int op_slot_right_3230 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3230 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3232 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3232
  int op_slot_left_3227 = gc_frame_newslot(opresult3232);
  params[0] = strlit3228;
  partcv[0] = 1;
  Object opresult3233 = callmethod(opresult3232, "++", 1, partcv, params);
// compilenode returning opresult3233
  int op_slot_left_3217 = gc_frame_newslot(opresult3233);
  params[0] = call3225;
  partcv[0] = 1;
  Object opresult3234 = callmethod(opresult3233, "++", 1, partcv, params);
// compilenode returning opresult3234
  *var_s = opresult3234;
  if (opresult3234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3237 == NULL) {
    strlit3237 = alloc_String("""\x0a""");
    gc_root(strlit3237);
  }
// compilenode returning strlit3237
  int op_slot_right_3236 = gc_frame_newslot(strlit3237);
// compilenode returning *var_s
  int op_slot_left_3236 = gc_frame_newslot(*var_s);
  params[0] = strlit3237;
  partcv[0] = 1;
  Object opresult3239 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3239
  *var_s = opresult3239;
  if (opresult3239 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3243 = gc_frame_new();
  partcv[0] = 0;
  Object call3244 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3243);
// compilenode returning call3244
// compilenode returning call3244
  int op_slot_right_3242 = gc_frame_newslot(call3244);
  Object bool3246 = alloc_Boolean(0);
// compilenode returning bool3246
  int op_slot_left_3242 = gc_frame_newslot(bool3246);
  params[0] = call3244;
  partcv[0] = 1;
  Object opresult3247 = callmethod(bool3246, "!=", 1, partcv, params);
// compilenode returning opresult3247
  Object if3241 = done;
  if (istrue(opresult3247)) {
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3249 == NULL) {
    strlit3249 = alloc_String("  ");
    gc_root(strlit3249);
  }
// compilenode returning strlit3249
  int op_slot_right_3248 = gc_frame_newslot(strlit3249);
// compilenode returning *var_spc
  int op_slot_right_3251 = gc_frame_newslot(*var_spc);
  if (strlit3254 == NULL) {
    strlit3254 = alloc_String("Returns:""\x0a""");
    gc_root(strlit3254);
  }
// compilenode returning strlit3254
  int op_slot_right_3253 = gc_frame_newslot(strlit3254);
// compilenode returning *var_spc
  int op_slot_right_3256 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3256 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3258 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3258
  int op_slot_left_3253 = gc_frame_newslot(opresult3258);
  params[0] = strlit3254;
  partcv[0] = 1;
  Object opresult3259 = callmethod(opresult3258, "++", 1, partcv, params);
// compilenode returning opresult3259
  int op_slot_left_3251 = gc_frame_newslot(opresult3259);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3260 = callmethod(opresult3259, "++", 1, partcv, params);
// compilenode returning opresult3260
  int op_slot_left_3248 = gc_frame_newslot(opresult3260);
  params[0] = strlit3249;
  partcv[0] = 1;
  Object opresult3261 = callmethod(opresult3260, "++", 1, partcv, params);
// compilenode returning opresult3261
  *var_s = opresult3261;
  if (opresult3261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3264 == NULL) {
    strlit3264 = alloc_String("""\x0a""");
    gc_root(strlit3264);
  }
// compilenode returning strlit3264
  int op_slot_right_3263 = gc_frame_newslot(strlit3264);
  int callframe3267 = gc_frame_new();
  Object num3269 = alloc_Float64(2);
// compilenode returning num3269
  int op_slot_right_3268 = gc_frame_newslot(num3269);
// compilenode returning *var_depth
  int op_slot_left_3268 = gc_frame_newslot(*var_depth);
  params[0] = num3269;
  partcv[0] = 1;
  Object sum3271 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3271
  gc_frame_newslot(sum3271);
  int callframe3272 = gc_frame_new();
  partcv[0] = 0;
  Object call3273 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3272);
// compilenode returning call3273
// compilenode returning call3273
  params[0] = sum3271;
  partcv[0] = 1;
  Object call3274 = callmethod(call3273, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3267);
// compilenode returning call3274
  int op_slot_right_3266 = gc_frame_newslot(call3274);
// compilenode returning *var_s
  int op_slot_left_3266 = gc_frame_newslot(*var_s);
  params[0] = call3274;
  partcv[0] = 1;
  Object opresult3276 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3276
  int op_slot_left_3263 = gc_frame_newslot(opresult3276);
  params[0] = strlit3264;
  partcv[0] = 1;
  Object opresult3277 = callmethod(opresult3276, "++", 1, partcv, params);
// compilenode returning opresult3277
  *var_s = opresult3277;
  if (opresult3277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3241 = done;
  } else {
  }
// compilenode returning if3241
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3280 == NULL) {
    strlit3280 = alloc_String("Signature:");
    gc_root(strlit3280);
  }
// compilenode returning strlit3280
  int op_slot_right_3279 = gc_frame_newslot(strlit3280);
// compilenode returning *var_spc
  int op_slot_right_3282 = gc_frame_newslot(*var_spc);
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("");
    gc_root(strlit3285);
  }
// compilenode returning strlit3285
  int op_slot_right_3284 = gc_frame_newslot(strlit3285);
// compilenode returning *var_s
  int op_slot_right_3287 = gc_frame_newslot(*var_s);
  if (strlit3289 == NULL) {
    strlit3289 = alloc_String("");
    gc_root(strlit3289);
  }
// compilenode returning strlit3289
  int op_slot_left_3287 = gc_frame_newslot(strlit3289);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3290 = callmethod(strlit3289, "++", 1, partcv, params);
// compilenode returning opresult3290
  int op_slot_left_3284 = gc_frame_newslot(opresult3290);
  params[0] = strlit3285;
  partcv[0] = 1;
  Object opresult3291 = callmethod(opresult3290, "++", 1, partcv, params);
// compilenode returning opresult3291
  int op_slot_left_3282 = gc_frame_newslot(opresult3291);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3292 = callmethod(opresult3291, "++", 1, partcv, params);
// compilenode returning opresult3292
  int op_slot_left_3279 = gc_frame_newslot(opresult3292);
  params[0] = strlit3280;
  partcv[0] = 1;
  Object opresult3293 = callmethod(opresult3292, "++", 1, partcv, params);
// compilenode returning opresult3293
  *var_s = opresult3293;
  if (opresult3293 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3295 = gc_frame_new();
  int callframe3296 = gc_frame_new();
  partcv[0] = 0;
  Object call3297 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3296);
// compilenode returning call3297
  gc_frame_newslot(call3297);
  Object block3298 = alloc_Block(NULL, NULL, "ast", 724);
  gc_frame_newslot(block3298);
  block_savedest(block3298);
  Object closure3299 = createclosure(4, "_apply");
setclosureframe(closure3299, stackframe);
  addtoclosure(closure3299, var_spc);
  addtoclosure(closure3299, var_s);
  addtoclosure(closure3299, var_depth);
  addtoclosure(closure3299, selfslot);
  struct UserObject *uo3299 = (struct UserObject*)block3298;
  uo3299->data[0] = (Object)closure3299;
  Method *meth_meth_ast__apply3299 = addmethod2pos(block3298, "_apply", &meth_ast__apply3299, 0);
int argcv_meth_ast__apply3299[] = {1};
meth_meth_ast__apply3299->type = alloc_MethodType(1, argcv_meth_ast__apply3299);
  meth_meth_ast__apply3299->definitionModule = modulename;
  meth_meth_ast__apply3299->definitionLine = 721;
// compilenode returning block3298
  gc_frame_newslot(block3298);
  params[0] = call3297;
  params[1] = block3298;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3416 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3295);
// compilenode returning call3416
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3418 == NULL) {
    strlit3418 = alloc_String("""\x0a""");
    gc_root(strlit3418);
  }
// compilenode returning strlit3418
  int op_slot_right_3417 = gc_frame_newslot(strlit3418);
// compilenode returning *var_s
  int op_slot_left_3417 = gc_frame_newslot(*var_s);
  params[0] = strlit3418;
  partcv[0] = 1;
  Object opresult3420 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3420
  *var_s = opresult3420;
  if (opresult3420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3424 = gc_frame_new();
  partcv[0] = 0;
  Object call3425 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compilenode returning call3425
  int op_slot_right_3423 = gc_frame_newslot(call3425);
  Object bool3427 = alloc_Boolean(0);
// compilenode returning bool3427
  int op_slot_left_3423 = gc_frame_newslot(bool3427);
  params[0] = call3425;
  partcv[0] = 1;
  Object opresult3428 = callmethod(bool3427, "!=", 1, partcv, params);
// compilenode returning opresult3428
  Object if3422 = done;
  if (istrue(opresult3428)) {
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 736
  setline(736);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3430 == NULL) {
    strlit3430 = alloc_String("Generics:");
    gc_root(strlit3430);
  }
// compilenode returning strlit3430
  int op_slot_right_3429 = gc_frame_newslot(strlit3430);
// compilenode returning *var_spc
  int op_slot_right_3432 = gc_frame_newslot(*var_spc);
  if (strlit3435 == NULL) {
    strlit3435 = alloc_String("");
    gc_root(strlit3435);
  }
// compilenode returning strlit3435
  int op_slot_right_3434 = gc_frame_newslot(strlit3435);
// compilenode returning *var_s
  int op_slot_right_3437 = gc_frame_newslot(*var_s);
  if (strlit3439 == NULL) {
    strlit3439 = alloc_String("");
    gc_root(strlit3439);
  }
// compilenode returning strlit3439
  int op_slot_left_3437 = gc_frame_newslot(strlit3439);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3440 = callmethod(strlit3439, "++", 1, partcv, params);
// compilenode returning opresult3440
  int op_slot_left_3434 = gc_frame_newslot(opresult3440);
  params[0] = strlit3435;
  partcv[0] = 1;
  Object opresult3441 = callmethod(opresult3440, "++", 1, partcv, params);
// compilenode returning opresult3441
  int op_slot_left_3432 = gc_frame_newslot(opresult3441);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3442 = callmethod(opresult3441, "++", 1, partcv, params);
// compilenode returning opresult3442
  int op_slot_left_3429 = gc_frame_newslot(opresult3442);
  params[0] = strlit3430;
  partcv[0] = 1;
  Object opresult3443 = callmethod(opresult3442, "++", 1, partcv, params);
// compilenode returning opresult3443
  *var_s = opresult3443;
  if (opresult3443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3445 = gc_frame_new();
  int callframe3446 = gc_frame_new();
  partcv[0] = 0;
  Object call3447 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3446);
// compilenode returning call3447
  gc_frame_newslot(call3447);
  Object block3448 = alloc_Block(NULL, NULL, "ast", 737);
  gc_frame_newslot(block3448);
  block_savedest(block3448);
  Object closure3449 = createclosure(3, "_apply");
setclosureframe(closure3449, stackframe);
  addtoclosure(closure3449, var_spc);
  addtoclosure(closure3449, var_s);
  addtoclosure(closure3449, selfslot);
  struct UserObject *uo3449 = (struct UserObject*)block3448;
  uo3449->data[0] = (Object)closure3449;
  Method *meth_meth_ast__apply3449 = addmethod2pos(block3448, "_apply", &meth_ast__apply3449, 0);
int argcv_meth_ast__apply3449[] = {1};
meth_meth_ast__apply3449->type = alloc_MethodType(1, argcv_meth_ast__apply3449);
  meth_meth_ast__apply3449->definitionModule = modulename;
  meth_meth_ast__apply3449->definitionLine = 731;
// compilenode returning block3448
  gc_frame_newslot(block3448);
  params[0] = call3447;
  params[1] = block3448;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3477 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3445);
// compilenode returning call3477
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3479 == NULL) {
    strlit3479 = alloc_String("""\x0a""");
    gc_root(strlit3479);
  }
// compilenode returning strlit3479
  int op_slot_right_3478 = gc_frame_newslot(strlit3479);
// compilenode returning *var_s
  int op_slot_left_3478 = gc_frame_newslot(*var_s);
  params[0] = strlit3479;
  partcv[0] = 1;
  Object opresult3481 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3481
  *var_s = opresult3481;
  if (opresult3481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3422 = done;
  } else {
  }
// compilenode returning if3422
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num3485 = alloc_Float64(0);
// compilenode returning num3485
  int op_slot_right_3484 = gc_frame_newslot(num3485);
  int callframe3487 = gc_frame_new();
  int callframe3488 = gc_frame_new();
  partcv[0] = 0;
  Object call3489 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3488);
// compilenode returning call3489
  partcv[0] = 0;
  Object call3490 = callmethod(call3489, "size",
    1, partcv, params);
  gc_frame_end(callframe3487);
// compilenode returning call3490
// compilenode returning call3490
  int op_slot_left_3484 = gc_frame_newslot(call3490);
  params[0] = num3485;
  partcv[0] = 1;
  Object opresult3491 = callmethod(call3490, ">", 1, partcv, params);
// compilenode returning opresult3491
  Object if3483 = done;
  if (istrue(opresult3491)) {
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3493 == NULL) {
    strlit3493 = alloc_String("Annotations:");
    gc_root(strlit3493);
  }
// compilenode returning strlit3493
  int op_slot_right_3492 = gc_frame_newslot(strlit3493);
// compilenode returning *var_spc
  int op_slot_right_3495 = gc_frame_newslot(*var_spc);
  if (strlit3498 == NULL) {
    strlit3498 = alloc_String("");
    gc_root(strlit3498);
  }
// compilenode returning strlit3498
  int op_slot_right_3497 = gc_frame_newslot(strlit3498);
// compilenode returning *var_s
  int op_slot_right_3500 = gc_frame_newslot(*var_s);
  if (strlit3502 == NULL) {
    strlit3502 = alloc_String("");
    gc_root(strlit3502);
  }
// compilenode returning strlit3502
  int op_slot_left_3500 = gc_frame_newslot(strlit3502);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult3503 = callmethod(strlit3502, "++", 1, partcv, params);
// compilenode returning opresult3503
  int op_slot_left_3497 = gc_frame_newslot(opresult3503);
  params[0] = strlit3498;
  partcv[0] = 1;
  Object opresult3504 = callmethod(opresult3503, "++", 1, partcv, params);
// compilenode returning opresult3504
  int op_slot_left_3495 = gc_frame_newslot(opresult3504);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3505 = callmethod(opresult3504, "++", 1, partcv, params);
// compilenode returning opresult3505
  int op_slot_left_3492 = gc_frame_newslot(opresult3505);
  params[0] = strlit3493;
  partcv[0] = 1;
  Object opresult3506 = callmethod(opresult3505, "++", 1, partcv, params);
// compilenode returning opresult3506
  *var_s = opresult3506;
  if (opresult3506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3508 = gc_frame_new();
  int callframe3509 = gc_frame_new();
  partcv[0] = 0;
  Object call3510 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3509);
// compilenode returning call3510
  gc_frame_newslot(call3510);
  Object block3511 = alloc_Block(NULL, NULL, "ast", 744);
  gc_frame_newslot(block3511);
  block_savedest(block3511);
  Object closure3512 = createclosure(4, "_apply");
setclosureframe(closure3512, stackframe);
  addtoclosure(closure3512, var_depth);
  addtoclosure(closure3512, var_spc);
  addtoclosure(closure3512, var_s);
  addtoclosure(closure3512, selfslot);
  struct UserObject *uo3512 = (struct UserObject*)block3511;
  uo3512->data[0] = (Object)closure3512;
  Method *meth_meth_ast__apply3512 = addmethod2pos(block3511, "_apply", &meth_ast__apply3512, 0);
int argcv_meth_ast__apply3512[] = {1};
meth_meth_ast__apply3512->type = alloc_MethodType(1, argcv_meth_ast__apply3512);
  meth_meth_ast__apply3512->definitionModule = modulename;
  meth_meth_ast__apply3512->definitionLine = 742;
// compilenode returning block3511
  gc_frame_newslot(block3511);
  params[0] = call3510;
  params[1] = block3511;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3543 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3508);
// compilenode returning call3543
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3545 == NULL) {
    strlit3545 = alloc_String("""\x0a""");
    gc_root(strlit3545);
  }
// compilenode returning strlit3545
  int op_slot_right_3544 = gc_frame_newslot(strlit3545);
// compilenode returning *var_s
  int op_slot_left_3544 = gc_frame_newslot(*var_s);
  params[0] = strlit3545;
  partcv[0] = 1;
  Object opresult3547 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3547
  *var_s = opresult3547;
  if (opresult3547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3483 = done;
  } else {
  }
// compilenode returning if3483
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 749
  setline(749);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3550 == NULL) {
    strlit3550 = alloc_String("Body:");
    gc_root(strlit3550);
  }
// compilenode returning strlit3550
  int op_slot_right_3549 = gc_frame_newslot(strlit3550);
// compilenode returning *var_spc
  int op_slot_right_3552 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3552 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3554 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3554
  int op_slot_left_3549 = gc_frame_newslot(opresult3554);
  params[0] = strlit3550;
  partcv[0] = 1;
  Object opresult3555 = callmethod(opresult3554, "++", 1, partcv, params);
// compilenode returning opresult3555
  *var_s = opresult3555;
  if (opresult3555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3557 = gc_frame_new();
  int callframe3558 = gc_frame_new();
  partcv[0] = 0;
  Object call3559 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3558);
// compilenode returning call3559
// compilenode returning call3559
  gc_frame_newslot(call3559);
  Object block3560 = alloc_Block(NULL, NULL, "ast", 750);
  gc_frame_newslot(block3560);
  block_savedest(block3560);
  Object closure3561 = createclosure(4, "_apply");
setclosureframe(closure3561, stackframe);
  addtoclosure(closure3561, var_depth);
  addtoclosure(closure3561, var_spc);
  addtoclosure(closure3561, var_s);
  addtoclosure(closure3561, selfslot);
  struct UserObject *uo3561 = (struct UserObject*)block3560;
  uo3561->data[0] = (Object)closure3561;
  Method *meth_meth_ast__apply3561 = addmethod2pos(block3560, "_apply", &meth_ast__apply3561, 0);
int argcv_meth_ast__apply3561[] = {1};
meth_meth_ast__apply3561->type = alloc_MethodType(1, argcv_meth_ast__apply3561);
  meth_meth_ast__apply3561->definitionModule = modulename;
  meth_meth_ast__apply3561->definitionLine = 750;
// compilenode returning block3560
  gc_frame_newslot(block3560);
  params[0] = call3559;
  params[1] = block3560;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3580 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3557);
// compilenode returning call3580
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType3581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3584 = alloc_Boolean(0);
// compilenode returning bool3584
  int op_slot_right_3583 = gc_frame_newslot(bool3584);
  int callframe3586 = gc_frame_new();
  partcv[0] = 0;
  Object call3587 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3586);
// compilenode returning call3587
  int op_slot_left_3583 = gc_frame_newslot(call3587);
  params[0] = bool3584;
  partcv[0] = 1;
  Object opresult3588 = callmethod(call3587, "==", 1, partcv, params);
// compilenode returning opresult3588
  Object if3582 = done;
  if (istrue(opresult3588)) {
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3589 = gc_frame_new();
  if (strlit3590 == NULL) {
    strlit3590 = alloc_String("Unknown");
    gc_root(strlit3590);
  }
// compilenode returning strlit3590
  gc_frame_newslot(strlit3590);
  Object bool3591 = alloc_Boolean(0);
// compilenode returning bool3591
  gc_frame_newslot(bool3591);
// compilenode returning *var_identifierNode
  params[0] = strlit3590;
  params[1] = bool3591;
  partcv[0] = 2;
  Object call3592 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3589);
// compilenode returning call3592
  return call3592;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if3582 = undefined;
  } else {
  }
// compilenode returning if3582
// Begin line 760
  setline(760);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3593 = gc_frame_new();
  partcv[0] = 0;
  Object call3594 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3593);
// compilenode returning call3594
  return call3594;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply3607(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3609 == NULL) {
    strlit3609 = alloc_String("    ");
    gc_root(strlit3609);
  }
// compilenode returning strlit3609
  int op_slot_right_3608 = gc_frame_newslot(strlit3609);
// compilenode returning *var_spc
  int op_slot_left_3608 = gc_frame_newslot(*var_spc);
  params[0] = strlit3609;
  partcv[0] = 1;
  Object opresult3611 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3611
  *var_spc = opresult3611;
  if (opresult3611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3657 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3658 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3657);
// compilenode returning call3658
// compilenode returning call3658
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres3659 = callmethod(call3658, "[]", 1, partcv, params);
// compilenode returning idxres3659
  *var_p = idxres3659;
  if (idxres3659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3661 = gc_frame_new();
  Object num3663 = alloc_Float64(1);
// compilenode returning num3663
  int op_slot_right_3662 = gc_frame_newslot(num3663);
// compilenode returning *var_depth
  int op_slot_left_3662 = gc_frame_newslot(*var_depth);
  params[0] = num3663;
  partcv[0] = 1;
  Object sum3665 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3665
  gc_frame_newslot(sum3665);
// compilenode returning *var_p
  params[0] = sum3665;
  partcv[0] = 1;
  Object call3666 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3661);
// compilenode returning call3666
  int op_slot_right_3660 = gc_frame_newslot(call3666);
// compilenode returning *var_s
  int op_slot_left_3660 = gc_frame_newslot(*var_s);
  params[0] = call3666;
  partcv[0] = 1;
  Object opresult3668 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3668
  *var_s = opresult3668;
  if (opresult3668 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3673 = alloc_Boolean(0);
// compilenode returning bool3673
  int op_slot_right_3672 = gc_frame_newslot(bool3673);
  int callframe3675 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3676 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3675);
// compilenode returning call3676
// compilenode returning call3676
  int op_slot_left_3672 = gc_frame_newslot(call3676);
  params[0] = bool3673;
  partcv[0] = 1;
  Object opresult3677 = callmethod(call3676, "!=", 1, partcv, params);
// compilenode returning opresult3677
  int op_slot_right_3671 = gc_frame_newslot(opresult3677);
  int callframe3680 = gc_frame_new();
  int callframe3681 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3682 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3681);
// compilenode returning call3682
// compilenode returning call3682
  partcv[0] = 0;
  Object call3683 = callmethod(call3682, "size",
    1, partcv, params);
  gc_frame_end(callframe3680);
// compilenode returning call3683
// compilenode returning call3683
  int op_slot_right_3679 = gc_frame_newslot(call3683);
// compilenode returning *var_pnr
  int op_slot_left_3679 = gc_frame_newslot(*var_pnr);
  params[0] = call3683;
  partcv[0] = 1;
  Object opresult3685 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult3685
  int op_slot_left_3671 = gc_frame_newslot(opresult3685);
  params[0] = opresult3677;
  partcv[0] = 1;
  Object opresult3686 = callmethod(opresult3685, "||", 1, partcv, params);
// compilenode returning opresult3686
  Object if3670 = done;
  if (istrue(opresult3686)) {
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3688 == NULL) {
    strlit3688 = alloc_String(", ");
    gc_root(strlit3688);
  }
// compilenode returning strlit3688
  int op_slot_right_3687 = gc_frame_newslot(strlit3688);
// compilenode returning *var_s
  int op_slot_left_3687 = gc_frame_newslot(*var_s);
  params[0] = strlit3688;
  partcv[0] = 1;
  Object opresult3690 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3690
  *var_s = opresult3690;
  if (opresult3690 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3670 = done;
  } else {
  }
// compilenode returning if3670
  gc_frame_end(frame);
  return if3670;
}
Object meth_ast__apply3620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3622 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3623 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe3622);
// compilenode returning call3623
// compilenode returning call3623
  int op_slot_right_3621 = gc_frame_newslot(call3623);
// compilenode returning *var_s
  int op_slot_left_3621 = gc_frame_newslot(*var_s);
  params[0] = call3623;
  partcv[0] = 1;
  Object opresult3625 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3625
  *var_s = opresult3625;
  if (opresult3625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 769
  setline(769);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3630 = alloc_Boolean(0);
// compilenode returning bool3630
  int op_slot_right_3629 = gc_frame_newslot(bool3630);
  int callframe3632 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3633 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3632);
// compilenode returning call3633
// compilenode returning call3633
  int op_slot_left_3629 = gc_frame_newslot(call3633);
  params[0] = bool3630;
  partcv[0] = 1;
  Object opresult3634 = callmethod(call3633, "!=", 1, partcv, params);
// compilenode returning opresult3634
  int op_slot_right_3628 = gc_frame_newslot(opresult3634);
  Object num3637 = alloc_Float64(0);
// compilenode returning num3637
  int op_slot_right_3636 = gc_frame_newslot(num3637);
  int callframe3639 = gc_frame_new();
  int callframe3640 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3641 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3640);
// compilenode returning call3641
// compilenode returning call3641
  partcv[0] = 0;
  Object call3642 = callmethod(call3641, "size",
    1, partcv, params);
  gc_frame_end(callframe3639);
// compilenode returning call3642
// compilenode returning call3642
  int op_slot_left_3636 = gc_frame_newslot(call3642);
  params[0] = num3637;
  partcv[0] = 1;
  Object opresult3643 = callmethod(call3642, ">", 1, partcv, params);
// compilenode returning opresult3643
  int op_slot_left_3628 = gc_frame_newslot(opresult3643);
  params[0] = opresult3634;
  partcv[0] = 1;
  Object opresult3644 = callmethod(opresult3643, "||", 1, partcv, params);
// compilenode returning opresult3644
  Object if3627 = done;
  if (istrue(opresult3644)) {
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3646 == NULL) {
    strlit3646 = alloc_String("(");
    gc_root(strlit3646);
  }
// compilenode returning strlit3646
  int op_slot_right_3645 = gc_frame_newslot(strlit3646);
// compilenode returning *var_s
  int op_slot_left_3645 = gc_frame_newslot(*var_s);
  params[0] = strlit3646;
  partcv[0] = 1;
  Object opresult3648 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3648
  *var_s = opresult3648;
  if (opresult3648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3650 = gc_frame_new();
  int callframe3651 = gc_frame_new();
  int callframe3652 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3653 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe3652);
// compilenode returning call3653
// compilenode returning call3653
  partcv[0] = 0;
  Object call3654 = callmethod(call3653, "indices",
    1, partcv, params);
  gc_frame_end(callframe3651);
// compilenode returning call3654
// compilenode returning call3654
  gc_frame_newslot(call3654);
  Object block3655 = alloc_Block(NULL, NULL, "ast", 771);
  gc_frame_newslot(block3655);
  block_savedest(block3655);
  Object closure3656 = createclosure(4, "_apply");
setclosureframe(closure3656, stackframe);
  addtoclosure(closure3656, var_part);
  addtoclosure(closure3656, var_depth);
  addtoclosure(closure3656, var_s);
  addtoclosure(closure3656, selfslot);
  struct UserObject *uo3656 = (struct UserObject*)block3655;
  uo3656->data[0] = (Object)closure3656;
  Method *meth_meth_ast__apply3656 = addmethod2pos(block3655, "_apply", &meth_ast__apply3656, 0);
int argcv_meth_ast__apply3656[] = {1};
meth_meth_ast__apply3656->type = alloc_MethodType(1, argcv_meth_ast__apply3656);
  meth_meth_ast__apply3656->definitionModule = modulename;
  meth_meth_ast__apply3656->definitionLine = 771;
// compilenode returning block3655
  gc_frame_newslot(block3655);
  params[0] = call3654;
  params[1] = block3655;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3693 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3650);
// compilenode returning call3693
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3696 = alloc_Boolean(0);
// compilenode returning bool3696
  int op_slot_right_3695 = gc_frame_newslot(bool3696);
  int callframe3698 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3699 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3698);
// compilenode returning call3699
// compilenode returning call3699
  int op_slot_left_3695 = gc_frame_newslot(call3699);
  params[0] = bool3696;
  partcv[0] = 1;
  Object opresult3700 = callmethod(call3699, "!=", 1, partcv, params);
// compilenode returning opresult3700
  Object if3694 = done;
  if (istrue(opresult3700)) {
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3702 = gc_frame_new();
  int callframe3703 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3704 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe3703);
// compilenode returning call3704
// compilenode returning call3704
  partcv[0] = 0;
  Object call3705 = callmethod(call3704, "value",
    1, partcv, params);
  gc_frame_end(callframe3702);
// compilenode returning call3705
// compilenode returning call3705
  int op_slot_right_3701 = gc_frame_newslot(call3705);
  if (strlit3708 == NULL) {
    strlit3708 = alloc_String("*");
    gc_root(strlit3708);
  }
// compilenode returning strlit3708
  int op_slot_right_3707 = gc_frame_newslot(strlit3708);
// compilenode returning *var_s
  int op_slot_left_3707 = gc_frame_newslot(*var_s);
  params[0] = strlit3708;
  partcv[0] = 1;
  Object opresult3710 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3710
  int op_slot_left_3701 = gc_frame_newslot(opresult3710);
  params[0] = call3705;
  partcv[0] = 1;
  Object opresult3711 = callmethod(opresult3710, "++", 1, partcv, params);
// compilenode returning opresult3711
  *var_s = opresult3711;
  if (opresult3711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3694 = done;
  } else {
  }
// compilenode returning if3694
// Begin line 782
  setline(782);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3714 == NULL) {
    strlit3714 = alloc_String(")");
    gc_root(strlit3714);
  }
// compilenode returning strlit3714
  int op_slot_right_3713 = gc_frame_newslot(strlit3714);
// compilenode returning *var_s
  int op_slot_left_3713 = gc_frame_newslot(*var_s);
  params[0] = strlit3714;
  partcv[0] = 1;
  Object opresult3716 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3716
  *var_s = opresult3716;
  if (opresult3716 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3627 = done;
  } else {
  }
// compilenode returning if3627
  gc_frame_end(frame);
  return if3627;
}
Object meth_ast__apply3762(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3764 = gc_frame_new();
  Object num3765 = alloc_Float64(0);
// compilenode returning num3765
  gc_frame_newslot(num3765);
// compilenode returning *var_b
  params[0] = num3765;
  partcv[0] = 1;
  Object call3766 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3764);
// compilenode returning call3766
  int op_slot_right_3763 = gc_frame_newslot(call3766);
  if (strlit3770 == NULL) {
    strlit3770 = alloc_String("");
    gc_root(strlit3770);
  }
// compilenode returning strlit3770
  int op_slot_right_3769 = gc_frame_newslot(strlit3770);
// compilenode returning *var_a
  int op_slot_left_3769 = gc_frame_newslot(*var_a);
  params[0] = strlit3770;
  partcv[0] = 1;
  Object opresult3772 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult3772
  Object if3768 = done;
struct StackFrameObject *iftmpstackframe3768 = stackframe;
  if (istrue(opresult3772)) {
stackframe = alloc_StackFrame(0, iftmpstackframe3768);
gc_frame_newslot((Object)stackframe);
  if (strlit3774 == NULL) {
    strlit3774 = alloc_String(", ");
    gc_root(strlit3774);
  }
// compilenode returning strlit3774
  int op_slot_right_3773 = gc_frame_newslot(strlit3774);
// compilenode returning *var_a
  int op_slot_left_3773 = gc_frame_newslot(*var_a);
  params[0] = strlit3774;
  partcv[0] = 1;
  Object opresult3776 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult3776
    gc_frame_newslot(opresult3776);
    if3768 = opresult3776;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe3768);
gc_frame_newslot((Object)stackframe);
  if (strlit3777 == NULL) {
    strlit3777 = alloc_String("");
    gc_root(strlit3777);
  }
// compilenode returning strlit3777
    gc_frame_newslot(strlit3777);
    if3768 = strlit3777;
  }
stackframe = iftmpstackframe3768;
// compilenode returning if3768
  int op_slot_left_3763 = gc_frame_newslot(if3768);
  params[0] = call3766;
  partcv[0] = 1;
  Object opresult3778 = callmethod(if3768, "++", 1, partcv, params);
// compilenode returning opresult3778
  gc_frame_end(frame);
  return opresult3778;
}
Object meth_ast__apply3795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3797 = gc_frame_new();
  Object num3799 = alloc_Float64(1);
// compilenode returning num3799
  int op_slot_right_3798 = gc_frame_newslot(num3799);
// compilenode returning *var_depth
  int op_slot_left_3798 = gc_frame_newslot(*var_depth);
  params[0] = num3799;
  partcv[0] = 1;
  Object sum3801 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3801
  gc_frame_newslot(sum3801);
// compilenode returning *var_mx
  params[0] = sum3801;
  partcv[0] = 1;
  Object call3802 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3797);
// compilenode returning call3802
  int op_slot_right_3796 = gc_frame_newslot(call3802);
  if (strlit3805 == NULL) {
    strlit3805 = alloc_String("    ");
    gc_root(strlit3805);
  }
// compilenode returning strlit3805
  int op_slot_right_3804 = gc_frame_newslot(strlit3805);
// compilenode returning *var_spc
  int op_slot_right_3807 = gc_frame_newslot(*var_spc);
  if (strlit3810 == NULL) {
    strlit3810 = alloc_String("""\x0a""");
    gc_root(strlit3810);
  }
// compilenode returning strlit3810
  int op_slot_right_3809 = gc_frame_newslot(strlit3810);
// compilenode returning *var_s
  int op_slot_left_3809 = gc_frame_newslot(*var_s);
  params[0] = strlit3810;
  partcv[0] = 1;
  Object opresult3812 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3812
  int op_slot_left_3807 = gc_frame_newslot(opresult3812);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3813 = callmethod(opresult3812, "++", 1, partcv, params);
// compilenode returning opresult3813
  int op_slot_left_3804 = gc_frame_newslot(opresult3813);
  params[0] = strlit3805;
  partcv[0] = 1;
  Object opresult3814 = callmethod(opresult3813, "++", 1, partcv, params);
// compilenode returning opresult3814
  int op_slot_left_3796 = gc_frame_newslot(opresult3814);
  params[0] = call3802;
  partcv[0] = 1;
  Object opresult3815 = callmethod(opresult3814, "++", 1, partcv, params);
// compilenode returning opresult3815
  *var_s = opresult3815;
  if (opresult3815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace3595(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3596 == NULL) {
    strlit3596 = alloc_String("");
    gc_root(strlit3596);
  }
// compilenode returning strlit3596
  *var_spc = strlit3596;
  if (strlit3596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3597 = gc_frame_new();
  Object num3600 = alloc_Float64(1);
// compilenode returning num3600
  int op_slot_right_3599 = gc_frame_newslot(num3600);
// compilenode returning *var_depth
  int op_slot_left_3599 = gc_frame_newslot(*var_depth);
  params[0] = num3600;
  partcv[0] = 1;
  Object diff3602 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff3602
  int op_slot_right_3598 = gc_frame_newslot(diff3602);
  Object num3604 = alloc_Float64(0);
// compilenode returning num3604
  int op_slot_left_3598 = gc_frame_newslot(num3604);
  params[0] = diff3602;
  partcv[0] = 1;
  Object opresult3605 = callmethod(num3604, "..", 1, partcv, params);
// compilenode returning opresult3605
  gc_frame_newslot(opresult3605);
  Object block3606 = alloc_Block(NULL, NULL, "ast", 763);
  gc_frame_newslot(block3606);
  block_savedest(block3606);
  Object closure3607 = createclosure(2, "_apply");
setclosureframe(closure3607, stackframe);
  addtoclosure(closure3607, var_spc);
  addtoclosure(closure3607, selfslot);
  struct UserObject *uo3607 = (struct UserObject*)block3606;
  uo3607->data[0] = (Object)closure3607;
  Method *meth_meth_ast__apply3607 = addmethod2pos(block3606, "_apply", &meth_ast__apply3607, 0);
int argcv_meth_ast__apply3607[] = {1};
meth_meth_ast__apply3607->type = alloc_MethodType(1, argcv_meth_ast__apply3607);
  meth_meth_ast__apply3607->definitionModule = modulename;
  meth_meth_ast__apply3607->definitionLine = 750;
// compilenode returning block3606
  gc_frame_newslot(block3606);
  params[0] = opresult3605;
  params[1] = block3606;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3614 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3597);
// compilenode returning call3614
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3615 == NULL) {
    strlit3615 = alloc_String("method ");
    gc_root(strlit3615);
  }
// compilenode returning strlit3615
  *var_s = strlit3615;
  if (strlit3615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3616 = gc_frame_new();
  int callframe3617 = gc_frame_new();
  partcv[0] = 0;
  Object call3618 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3617);
// compilenode returning call3618
// compilenode returning call3618
  gc_frame_newslot(call3618);
  Object block3619 = alloc_Block(NULL, NULL, "ast", 767);
  gc_frame_newslot(block3619);
  block_savedest(block3619);
  Object closure3620 = createclosure(3, "_apply");
setclosureframe(closure3620, stackframe);
  addtoclosure(closure3620, var_s);
  addtoclosure(closure3620, var_depth);
  addtoclosure(closure3620, selfslot);
  struct UserObject *uo3620 = (struct UserObject*)block3619;
  uo3620->data[0] = (Object)closure3620;
  Method *meth_meth_ast__apply3620 = addmethod2pos(block3619, "_apply", &meth_ast__apply3620, 0);
int argcv_meth_ast__apply3620[] = {1};
meth_meth_ast__apply3620->type = alloc_MethodType(1, argcv_meth_ast__apply3620);
  meth_meth_ast__apply3620->definitionModule = modulename;
  meth_meth_ast__apply3620->definitionLine = 767;
// compilenode returning block3619
  gc_frame_newslot(block3619);
  params[0] = call3618;
  params[1] = block3619;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3719 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3616);
// compilenode returning call3719
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3722 = alloc_Boolean(0);
// compilenode returning bool3722
  int op_slot_right_3721 = gc_frame_newslot(bool3722);
  int callframe3724 = gc_frame_new();
  partcv[0] = 0;
  Object call3725 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3724);
// compilenode returning call3725
// compilenode returning call3725
  int op_slot_left_3721 = gc_frame_newslot(call3725);
  params[0] = bool3722;
  partcv[0] = 1;
  Object opresult3726 = callmethod(call3725, "!=", 1, partcv, params);
// compilenode returning opresult3726
  Object if3720 = done;
  if (istrue(opresult3726)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3729 == NULL) {
    strlit3729 = alloc_String("");
    gc_root(strlit3729);
  }
// compilenode returning strlit3729
  int op_slot_right_3728 = gc_frame_newslot(strlit3729);
  int callframe3732 = gc_frame_new();
  Object num3733 = alloc_Float64(0);
// compilenode returning num3733
  gc_frame_newslot(num3733);
  int callframe3734 = gc_frame_new();
  partcv[0] = 0;
  Object call3735 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3734);
// compilenode returning call3735
// compilenode returning call3735
  params[0] = num3733;
  partcv[0] = 1;
  Object call3736 = callmethod(call3735, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe3732);
// compilenode returning call3736
  int op_slot_right_3731 = gc_frame_newslot(call3736);
  if (strlit3738 == NULL) {
    strlit3738 = alloc_String(" -> ");
    gc_root(strlit3738);
  }
// compilenode returning strlit3738
  int op_slot_left_3731 = gc_frame_newslot(strlit3738);
  params[0] = call3736;
  partcv[0] = 1;
  Object opresult3739 = callmethod(strlit3738, "++", 1, partcv, params);
// compilenode returning opresult3739
  int op_slot_left_3728 = gc_frame_newslot(opresult3739);
  params[0] = strlit3729;
  partcv[0] = 1;
  Object opresult3740 = callmethod(opresult3739, "++", 1, partcv, params);
// compilenode returning opresult3740
  int op_slot_right_3727 = gc_frame_newslot(opresult3740);
// compilenode returning *var_s
  int op_slot_left_3727 = gc_frame_newslot(*var_s);
  params[0] = opresult3740;
  partcv[0] = 1;
  Object opresult3742 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3742
  *var_s = opresult3742;
  if (opresult3742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3720 = done;
  } else {
  }
// compilenode returning if3720
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num3746 = alloc_Float64(0);
// compilenode returning num3746
  int op_slot_right_3745 = gc_frame_newslot(num3746);
  int callframe3748 = gc_frame_new();
  int callframe3749 = gc_frame_new();
  partcv[0] = 0;
  Object call3750 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3749);
// compilenode returning call3750
// compilenode returning call3750
  partcv[0] = 0;
  Object call3751 = callmethod(call3750, "size",
    1, partcv, params);
  gc_frame_end(callframe3748);
// compilenode returning call3751
// compilenode returning call3751
  int op_slot_left_3745 = gc_frame_newslot(call3751);
  params[0] = num3746;
  partcv[0] = 1;
  Object opresult3752 = callmethod(call3751, ">", 1, partcv, params);
// compilenode returning opresult3752
  Object if3744 = done;
  if (istrue(opresult3752)) {
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3754 == NULL) {
    strlit3754 = alloc_String(" is ");
    gc_root(strlit3754);
  }
// compilenode returning strlit3754
  int op_slot_right_3753 = gc_frame_newslot(strlit3754);
// compilenode returning *var_s
  int op_slot_left_3753 = gc_frame_newslot(*var_s);
  params[0] = strlit3754;
  partcv[0] = 1;
  Object opresult3756 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3756
  *var_s = opresult3756;
  if (opresult3756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3759 = gc_frame_new();
  if (strlit3760 == NULL) {
    strlit3760 = alloc_String("");
    gc_root(strlit3760);
  }
// compilenode returning strlit3760
  gc_frame_newslot(strlit3760);
  Object block3761 = alloc_Block(NULL, NULL, "ast", 789);
  gc_frame_newslot(block3761);
  block_savedest(block3761);
  Object closure3762 = createclosure(1, "_apply");
setclosureframe(closure3762, stackframe);
  addtoclosure(closure3762, selfslot);
  struct UserObject *uo3762 = (struct UserObject*)block3761;
  uo3762->data[0] = (Object)closure3762;
  Method *meth_meth_ast__apply3762 = addmethod2pos(block3761, "_apply", &meth_ast__apply3762, 0);
int argcv_meth_ast__apply3762[] = {2};
meth_meth_ast__apply3762->type = alloc_MethodType(1, argcv_meth_ast__apply3762);
  meth_meth_ast__apply3762->definitionModule = modulename;
  meth_meth_ast__apply3762->definitionLine = 787;
// compilenode returning block3761
  gc_frame_newslot(block3761);
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3780 = gc_frame_new();
  partcv[0] = 0;
  Object call3781 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3780);
// compilenode returning call3781
// compilenode returning call3781
  params[0] = strlit3760;
  params[1] = block3761;
  partcv[0] = 2;
  Object call3782 = callmethod(call3781, "reduce",
    1, partcv, params);
  gc_frame_end(callframe3759);
// compilenode returning call3782
  int op_slot_right_3758 = gc_frame_newslot(call3782);
// compilenode returning *var_s
  int op_slot_left_3758 = gc_frame_newslot(*var_s);
  params[0] = call3782;
  partcv[0] = 1;
  Object opresult3784 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3784
  *var_s = opresult3784;
  if (opresult3784 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3744 = done;
  } else {
  }
// compilenode returning if3744
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3787 == NULL) {
    strlit3787 = alloc_String(" {");
    gc_root(strlit3787);
  }
// compilenode returning strlit3787
  int op_slot_right_3786 = gc_frame_newslot(strlit3787);
// compilenode returning *var_s
  int op_slot_left_3786 = gc_frame_newslot(*var_s);
  params[0] = strlit3787;
  partcv[0] = 1;
  Object opresult3789 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3789
  *var_s = opresult3789;
  if (opresult3789 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3791 = gc_frame_new();
  int callframe3792 = gc_frame_new();
  partcv[0] = 0;
  Object call3793 = callmethodflags(self, "body", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3792);
// compilenode returning call3793
// compilenode returning call3793
  gc_frame_newslot(call3793);
  Object block3794 = alloc_Block(NULL, NULL, "ast", 793);
  gc_frame_newslot(block3794);
  block_savedest(block3794);
  Object closure3795 = createclosure(4, "_apply");
setclosureframe(closure3795, stackframe);
  addtoclosure(closure3795, var_depth);
  addtoclosure(closure3795, var_spc);
  addtoclosure(closure3795, var_s);
  addtoclosure(closure3795, selfslot);
  struct UserObject *uo3795 = (struct UserObject*)block3794;
  uo3795->data[0] = (Object)closure3795;
  Method *meth_meth_ast__apply3795 = addmethod2pos(block3794, "_apply", &meth_ast__apply3795, 0);
int argcv_meth_ast__apply3795[] = {1};
meth_meth_ast__apply3795->type = alloc_MethodType(1, argcv_meth_ast__apply3795);
  meth_meth_ast__apply3795->definitionModule = modulename;
  meth_meth_ast__apply3795->definitionLine = 793;
// compilenode returning block3794
  gc_frame_newslot(block3794);
  params[0] = call3793;
  params[1] = block3794;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3818 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3791);
// compilenode returning call3818
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3820 == NULL) {
    strlit3820 = alloc_String("}");
    gc_root(strlit3820);
  }
// compilenode returning strlit3820
  int op_slot_right_3819 = gc_frame_newslot(strlit3820);
// compilenode returning *var_spc
  int op_slot_right_3822 = gc_frame_newslot(*var_spc);
  if (strlit3825 == NULL) {
    strlit3825 = alloc_String("""\x0a""");
    gc_root(strlit3825);
  }
// compilenode returning strlit3825
  int op_slot_right_3824 = gc_frame_newslot(strlit3825);
// compilenode returning *var_s
  int op_slot_left_3824 = gc_frame_newslot(*var_s);
  params[0] = strlit3825;
  partcv[0] = 1;
  Object opresult3827 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3827
  int op_slot_left_3822 = gc_frame_newslot(opresult3827);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3828 = callmethod(opresult3827, "++", 1, partcv, params);
// compilenode returning opresult3828
  int op_slot_left_3819 = gc_frame_newslot(opresult3828);
  params[0] = strlit3820;
  partcv[0] = 1;
  Object opresult3829 = callmethod(opresult3828, "++", 1, partcv, params);
// compilenode returning opresult3829
  *var_s = opresult3829;
  if (opresult3829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new3031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3032 = alloc_userobj2(23,19, objclass3032);
  gc_frame_newslot(obj3032);
if (objclass3032 == NULL) {
  glfree(obj3032->class->name);
  obj3032->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3032, self, 0);
  addmethodreal(obj3032,"outer", &reader_ast_outer_3033);
  Object oldself3032 = self;
  struct StackFrameObject *oldstackframe3032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3032);
  gc_frame_newslot((Object)stackframe);
  self = obj3032;
  Object *oldselfslot3032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3032 = (*(struct UserObject *)self).data[0], lowerouter3032 = thisouter3032;
  if (inheritingObject3032) {
    struct UserObject *inho3032 = (struct UserObject *)inheritingObject3032;
    while (inho3032->super != GraceDefaultObject) inho3032 = (struct UserObject *)inho3032->super;
    inho3032->super = obj3032;
    self = inheritingObject3032;
    *selfslot = self;
    lowerouter3032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3032;
  }
if (objclass3032 == NULL) {
  Method *reader3034 = addmethodrealflags(obj3032, "kind",&reader_ast_kind_3034, MFLAG_DEF);
  reader3034->definitionModule = modulename;
  reader3034->definitionLine = 655;
}
adddatum2(obj3032, alloc_Undefined(), 1);
if (objclass3032 == NULL) {
  Method *reader3035 = addmethodrealflags(obj3032, "value",&reader_ast_value_3035, MFLAG_DEF);
  reader3035->definitionModule = modulename;
  reader3035->definitionLine = 656;
}
adddatum2(obj3032, alloc_Undefined(), 2);
if (objclass3032 == NULL) {
  Method *reader3036 = addmethodrealflags(obj3032, "signature",&reader_ast_signature_3036, MFLAG_DEF);
  reader3036->definitionModule = modulename;
  reader3036->definitionLine = 657;
}
adddatum2(obj3032, alloc_Undefined(), 3);
if (objclass3032 == NULL) {
  Method *reader3037 = addmethodrealflags(obj3032, "body",&reader_ast_body_3037, MFLAG_DEF);
  reader3037->definitionModule = modulename;
  reader3037->definitionLine = 658;
}
adddatum2(obj3032, alloc_Undefined(), 4);
if (objclass3032 == NULL) {
  Method *reader3038 = addmethodrealflags(obj3032, "dtype",&reader_ast_dtype_3038, 0);
  Method *writer3038 = addmethodrealflags(obj3032, "dtype:=",&writer_ast_dtype_3038, 0);
  reader3038->definitionModule = modulename;
  writer3038->definitionModule = modulename;
  reader3038->definitionLine = 659;
  writer3038->definitionLine = 659;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 5);
if (objclass3032 == NULL) {
  Method *reader3039 = addmethodrealflags(obj3032, "varargs",&reader_ast_varargs_3039, 0);
  Method *writer3039 = addmethodrealflags(obj3032, "varargs:=",&writer_ast_varargs_3039, 0);
  reader3039->definitionModule = modulename;
  writer3039->definitionModule = modulename;
  reader3039->definitionLine = 660;
  writer3039->definitionLine = 660;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 6);
if (objclass3032 == NULL) {
  Method *reader3040 = addmethodrealflags(obj3032, "generics",&reader_ast_generics_3040, 0);
  Method *writer3040 = addmethodrealflags(obj3032, "generics:=",&writer_ast_generics_3040, 0);
  reader3040->definitionModule = modulename;
  writer3040->definitionModule = modulename;
  reader3040->definitionLine = 661;
  writer3040->definitionLine = 661;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 7);
if (objclass3032 == NULL) {
  Method *reader3041 = addmethodrealflags(obj3032, "selfclosure",&reader_ast_selfclosure_3041, 0);
  Method *writer3041 = addmethodrealflags(obj3032, "selfclosure:=",&writer_ast_selfclosure_3041, 0);
  reader3041->definitionModule = modulename;
  writer3041->definitionModule = modulename;
  reader3041->definitionLine = 662;
  writer3041->definitionLine = 662;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 8);
if (objclass3032 == NULL) {
  Method *reader3042 = addmethodrealflags(obj3032, "annotations",&reader_ast_annotations_3042, MFLAG_DEF);
  reader3042->definitionModule = modulename;
  reader3042->definitionLine = 663;
}
adddatum2(obj3032, alloc_Undefined(), 9);
if (objclass3032 == NULL) {
  Method *reader3043 = addmethodrealflags(obj3032, "properties",&reader_ast_properties_3043, 0);
  Method *writer3043 = addmethodrealflags(obj3032, "properties:=",&writer_ast_properties_3043, 0);
  reader3043->definitionModule = modulename;
  writer3043->definitionModule = modulename;
  reader3043->definitionLine = 664;
  writer3043->definitionLine = 664;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 10);
  struct UserObject *uo3044 = (struct UserObject*)obj3032;
  uo3044->data[11] = emptyclosure;
  Method *meth_meth_ast_accept3044 = addmethod2pos(obj3032, "accept", &meth_ast_accept3044, 11);
int argcv_meth_ast_accept3044[] = {1};
meth_meth_ast_accept3044->type = alloc_MethodType(1, argcv_meth_ast_accept3044);
meth_meth_ast_accept3044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3044->type->names[0] = "visitor";
  meth_meth_ast_accept3044->definitionModule = modulename;
  meth_meth_ast_accept3044->definitionLine = 664;
  block_savedest(obj3032);
  Object closure3099 = createclosure(2, "map()before()after");
setclosureframe(closure3099, stackframe);
  addtoclosure(closure3099, var_name_39_);
  addtoclosure(closure3099, var_methodNode);
  struct UserObject *uo3099 = (struct UserObject*)obj3032;
  uo3099->data[12] = (Object)closure3099;
  Method *meth_meth_ast_map_40__41_before_40__41_after3099 = addmethod2pos(obj3032, "map()before()after", &meth_ast_map_40__41_before_40__41_after3099, 12);
int argcv_meth_ast_map_40__41_before_40__41_after3099[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3099->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3099);
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionLine = 683;
  struct UserObject *uo3174 = (struct UserObject*)obj3032;
  uo3174->data[13] = emptyclosure;
  Method *meth_meth_ast_map3174 = addmethod2pos(obj3032, "map", &meth_ast_map3174, 13);
int argcv_meth_ast_map3174[] = {1};
meth_meth_ast_map3174->type = alloc_MethodType(1, argcv_meth_ast_map3174);
  meth_meth_ast_map3174->definitionModule = modulename;
  meth_meth_ast_map3174->definitionLine = 701;
  struct UserObject *uo3183 = (struct UserObject*)obj3032;
  uo3183->data[14] = emptyclosure;
  Method *meth_meth_ast_eachParameter3183 = addmethod2pos(obj3032, "eachParameter", &meth_ast_eachParameter3183, 14);
int argcv_meth_ast_eachParameter3183[] = {1};
meth_meth_ast_eachParameter3183->type = alloc_MethodType(1, argcv_meth_ast_eachParameter3183);
  meth_meth_ast_eachParameter3183->definitionModule = modulename;
  meth_meth_ast_eachParameter3183->definitionLine = 704;
  struct UserObject *uo3200 = (struct UserObject*)obj3032;
  uo3200->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3200 = addmethod2pos(obj3032, "pretty", &meth_ast_pretty3200, 15);
int argcv_meth_ast_pretty3200[] = {1};
meth_meth_ast_pretty3200->type = alloc_MethodType(1, argcv_meth_ast_pretty3200);
  meth_meth_ast_pretty3200->definitionModule = modulename;
  meth_meth_ast_pretty3200->definitionLine = 711;
  block_savedest(obj3032);
  Object closure3581 = createclosure(1, "decType");
setclosureframe(closure3581, stackframe);
  addtoclosure(closure3581, var_identifierNode);
  struct UserObject *uo3581 = (struct UserObject*)obj3032;
  uo3581->data[16] = (Object)closure3581;
  Method *meth_meth_ast_decType3581 = addmethod2pos(obj3032, "decType", &meth_ast_decType3581, 16);
int argcv_meth_ast_decType3581[] = {0};
meth_meth_ast_decType3581->type = alloc_MethodType(1, argcv_meth_ast_decType3581);
  meth_meth_ast_decType3581->definitionModule = modulename;
  meth_meth_ast_decType3581->definitionLine = 755;
  struct UserObject *uo3595 = (struct UserObject*)obj3032;
  uo3595->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace3595 = addmethod2pos(obj3032, "toGrace", &meth_ast_toGrace3595, 17);
int argcv_meth_ast_toGrace3595[] = {1};
meth_meth_ast_toGrace3595->type = alloc_MethodType(1, argcv_meth_ast_toGrace3595);
meth_meth_ast_toGrace3595->type->types[0] = type_Number;
meth_meth_ast_toGrace3595->type->names[0] = "depth";
  meth_meth_ast_toGrace3595->definitionModule = modulename;
  meth_meth_ast_toGrace3595->definitionLine = 761;
  sourceObject = obj3032;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3831 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3832 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3831);
// compilenode returning call3832
  struct UserObject *obj3032_uo = (struct UserObject *)obj3032;
  obj3032_uo->super = call3832;
  sourceObject = obj3032;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3833 == NULL) {
    strlit3833 = alloc_String("method");
    gc_root(strlit3833);
  }
// compilenode returning strlit3833
  adddatum2(obj3032, strlit3833, 1);
  sourceObject = obj3032;
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj3032, *var_name_39_, 2);
  sourceObject = obj3032;
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj3032, *var_signature_39_, 3);
  sourceObject = obj3032;
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj3032, *var_body_39_, 4);
  sourceObject = obj3032;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj3032, *var_dtype_39_, 5);
  sourceObject = obj3032;
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3834 = alloc_Boolean(0);
// compilenode returning bool3834
  adddatum2(obj3032, bool3834, 6);
  sourceObject = obj3032;
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3835 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3835
  adddatum2(obj3032, array3835, 7);
  sourceObject = obj3032;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3836 = alloc_Boolean(0);
// compilenode returning bool3836
  adddatum2(obj3032, bool3836, 8);
  sourceObject = obj3032;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3837 = gc_frame_new();
  int callframe3838 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3839 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3838);
// compilenode returning call3839
// compilenode returning call3839
  partcv[0] = 0;
  Object call3840 = callmethod(call3839, "new",
    1, partcv, params);
  gc_frame_end(callframe3837);
// compilenode returning call3840
// compilenode returning call3840
  adddatum2(obj3032, call3840, 9);
  sourceObject = obj3032;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3841 = gc_frame_new();
  int callframe3842 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3843 = callmethod(*var_collections, "map",
    1, partcv, params);
  gc_frame_end(callframe3842);
// compilenode returning call3843
// compilenode returning call3843
  partcv[0] = 0;
  Object call3844 = callmethod(call3843, "new",
    1, partcv, params);
  gc_frame_end(callframe3841);
// compilenode returning call3844
// compilenode returning call3844
  adddatum2(obj3032, call3844, 10);
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
objclass3032 = obj3032->class;
  objclass3032->definitionModule = modulename;
  objclass3032->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3032;
  self = oldself3032;
  selfslot = oldselfslot3032;
  stackframe = oldstackframe3032;
  gc_frame_end(frame);
  return obj3032;
}
Object meth_ast_new3031_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 4)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_methodNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[3]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 4)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3032 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3032 = alloc_userobj2(23,19, objclass3032);
  gc_frame_newslot(obj3032);
if (objclass3032 == NULL) {
  glfree(obj3032->class->name);
  obj3032->class->name = "methodNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3032, self, 0);
  addmethodreal(obj3032,"outer", &reader_ast_outer_3033);
  Object oldself3032 = self;
  struct StackFrameObject *oldstackframe3032 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3032);
  gc_frame_newslot((Object)stackframe);
  self = obj3032;
  Object *oldselfslot3032 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3032 = (*(struct UserObject *)self).data[0], lowerouter3032 = thisouter3032;
  if (inheritingObject3032) {
    struct UserObject *inho3032 = (struct UserObject *)inheritingObject3032;
    while (inho3032->super != GraceDefaultObject) inho3032 = (struct UserObject *)inho3032->super;
    inho3032->super = obj3032;
    self = inheritingObject3032;
    *selfslot = self;
    lowerouter3032 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3032;
  }
if (objclass3032 == NULL) {
  Method *reader3034 = addmethodrealflags(obj3032, "kind",&reader_ast_kind_3034, MFLAG_DEF);
  reader3034->definitionModule = modulename;
  reader3034->definitionLine = 655;
}
adddatum2(obj3032, alloc_Undefined(), 1);
if (objclass3032 == NULL) {
  Method *reader3035 = addmethodrealflags(obj3032, "value",&reader_ast_value_3035, MFLAG_DEF);
  reader3035->definitionModule = modulename;
  reader3035->definitionLine = 656;
}
adddatum2(obj3032, alloc_Undefined(), 2);
if (objclass3032 == NULL) {
  Method *reader3036 = addmethodrealflags(obj3032, "signature",&reader_ast_signature_3036, MFLAG_DEF);
  reader3036->definitionModule = modulename;
  reader3036->definitionLine = 657;
}
adddatum2(obj3032, alloc_Undefined(), 3);
if (objclass3032 == NULL) {
  Method *reader3037 = addmethodrealflags(obj3032, "body",&reader_ast_body_3037, MFLAG_DEF);
  reader3037->definitionModule = modulename;
  reader3037->definitionLine = 658;
}
adddatum2(obj3032, alloc_Undefined(), 4);
if (objclass3032 == NULL) {
  Method *reader3038 = addmethodrealflags(obj3032, "dtype",&reader_ast_dtype_3038, 0);
  Method *writer3038 = addmethodrealflags(obj3032, "dtype:=",&writer_ast_dtype_3038, 0);
  reader3038->definitionModule = modulename;
  writer3038->definitionModule = modulename;
  reader3038->definitionLine = 659;
  writer3038->definitionLine = 659;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 5);
if (objclass3032 == NULL) {
  Method *reader3039 = addmethodrealflags(obj3032, "varargs",&reader_ast_varargs_3039, 0);
  Method *writer3039 = addmethodrealflags(obj3032, "varargs:=",&writer_ast_varargs_3039, 0);
  reader3039->definitionModule = modulename;
  writer3039->definitionModule = modulename;
  reader3039->definitionLine = 660;
  writer3039->definitionLine = 660;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 6);
if (objclass3032 == NULL) {
  Method *reader3040 = addmethodrealflags(obj3032, "generics",&reader_ast_generics_3040, 0);
  Method *writer3040 = addmethodrealflags(obj3032, "generics:=",&writer_ast_generics_3040, 0);
  reader3040->definitionModule = modulename;
  writer3040->definitionModule = modulename;
  reader3040->definitionLine = 661;
  writer3040->definitionLine = 661;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 7);
if (objclass3032 == NULL) {
  Method *reader3041 = addmethodrealflags(obj3032, "selfclosure",&reader_ast_selfclosure_3041, 0);
  Method *writer3041 = addmethodrealflags(obj3032, "selfclosure:=",&writer_ast_selfclosure_3041, 0);
  reader3041->definitionModule = modulename;
  writer3041->definitionModule = modulename;
  reader3041->definitionLine = 662;
  writer3041->definitionLine = 662;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 8);
if (objclass3032 == NULL) {
  Method *reader3042 = addmethodrealflags(obj3032, "annotations",&reader_ast_annotations_3042, MFLAG_DEF);
  reader3042->definitionModule = modulename;
  reader3042->definitionLine = 663;
}
adddatum2(obj3032, alloc_Undefined(), 9);
if (objclass3032 == NULL) {
  Method *reader3043 = addmethodrealflags(obj3032, "properties",&reader_ast_properties_3043, 0);
  Method *writer3043 = addmethodrealflags(obj3032, "properties:=",&writer_ast_properties_3043, 0);
  reader3043->definitionModule = modulename;
  writer3043->definitionModule = modulename;
  reader3043->definitionLine = 664;
  writer3043->definitionLine = 664;
}
obj3032->flags |= OFLAG_MUTABLE;
adddatum2(obj3032, alloc_Undefined(), 10);
  struct UserObject *uo3044 = (struct UserObject*)obj3032;
  uo3044->data[11] = emptyclosure;
  Method *meth_meth_ast_accept3044 = addmethod2pos(obj3032, "accept", &meth_ast_accept3044, 11);
int argcv_meth_ast_accept3044[] = {1};
meth_meth_ast_accept3044->type = alloc_MethodType(1, argcv_meth_ast_accept3044);
meth_meth_ast_accept3044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3044->type->names[0] = "visitor";
  meth_meth_ast_accept3044->definitionModule = modulename;
  meth_meth_ast_accept3044->definitionLine = 664;
  block_savedest(obj3032);
  Object closure3099 = createclosure(2, "map()before()after");
setclosureframe(closure3099, stackframe);
  addtoclosure(closure3099, var_name_39_);
  addtoclosure(closure3099, var_methodNode);
  struct UserObject *uo3099 = (struct UserObject*)obj3032;
  uo3099->data[12] = (Object)closure3099;
  Method *meth_meth_ast_map_40__41_before_40__41_after3099 = addmethod2pos(obj3032, "map()before()after", &meth_ast_map_40__41_before_40__41_after3099, 12);
int argcv_meth_ast_map_40__41_before_40__41_after3099[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3099->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3099);
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3099->definitionLine = 683;
  struct UserObject *uo3174 = (struct UserObject*)obj3032;
  uo3174->data[13] = emptyclosure;
  Method *meth_meth_ast_map3174 = addmethod2pos(obj3032, "map", &meth_ast_map3174, 13);
int argcv_meth_ast_map3174[] = {1};
meth_meth_ast_map3174->type = alloc_MethodType(1, argcv_meth_ast_map3174);
  meth_meth_ast_map3174->definitionModule = modulename;
  meth_meth_ast_map3174->definitionLine = 701;
  struct UserObject *uo3183 = (struct UserObject*)obj3032;
  uo3183->data[14] = emptyclosure;
  Method *meth_meth_ast_eachParameter3183 = addmethod2pos(obj3032, "eachParameter", &meth_ast_eachParameter3183, 14);
int argcv_meth_ast_eachParameter3183[] = {1};
meth_meth_ast_eachParameter3183->type = alloc_MethodType(1, argcv_meth_ast_eachParameter3183);
  meth_meth_ast_eachParameter3183->definitionModule = modulename;
  meth_meth_ast_eachParameter3183->definitionLine = 704;
  struct UserObject *uo3200 = (struct UserObject*)obj3032;
  uo3200->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty3200 = addmethod2pos(obj3032, "pretty", &meth_ast_pretty3200, 15);
int argcv_meth_ast_pretty3200[] = {1};
meth_meth_ast_pretty3200->type = alloc_MethodType(1, argcv_meth_ast_pretty3200);
  meth_meth_ast_pretty3200->definitionModule = modulename;
  meth_meth_ast_pretty3200->definitionLine = 711;
  block_savedest(obj3032);
  Object closure3581 = createclosure(1, "decType");
setclosureframe(closure3581, stackframe);
  addtoclosure(closure3581, var_identifierNode);
  struct UserObject *uo3581 = (struct UserObject*)obj3032;
  uo3581->data[16] = (Object)closure3581;
  Method *meth_meth_ast_decType3581 = addmethod2pos(obj3032, "decType", &meth_ast_decType3581, 16);
int argcv_meth_ast_decType3581[] = {0};
meth_meth_ast_decType3581->type = alloc_MethodType(1, argcv_meth_ast_decType3581);
  meth_meth_ast_decType3581->definitionModule = modulename;
  meth_meth_ast_decType3581->definitionLine = 755;
  struct UserObject *uo3595 = (struct UserObject*)obj3032;
  uo3595->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace3595 = addmethod2pos(obj3032, "toGrace", &meth_ast_toGrace3595, 17);
int argcv_meth_ast_toGrace3595[] = {1};
meth_meth_ast_toGrace3595->type = alloc_MethodType(1, argcv_meth_ast_toGrace3595);
meth_meth_ast_toGrace3595->type->types[0] = type_Number;
meth_meth_ast_toGrace3595->type->names[0] = "depth";
  meth_meth_ast_toGrace3595->definitionModule = modulename;
  meth_meth_ast_toGrace3595->definitionLine = 761;
  sourceObject = obj3032;
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3831 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3832 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe3831);
// compilenode returning call3832
  struct UserObject *obj3032_uo = (struct UserObject *)obj3032;
  obj3032_uo->super = call3832;
  sourceObject = obj3032;
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3833 == NULL) {
    strlit3833 = alloc_String("method");
    gc_root(strlit3833);
  }
// compilenode returning strlit3833
  adddatum2(obj3032, strlit3833, 1);
  sourceObject = obj3032;
// Begin line 655
  setline(655);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj3032, *var_name_39_, 2);
  sourceObject = obj3032;
// Begin line 656
  setline(656);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj3032, *var_signature_39_, 3);
  sourceObject = obj3032;
// Begin line 657
  setline(657);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj3032, *var_body_39_, 4);
  sourceObject = obj3032;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj3032, *var_dtype_39_, 5);
  sourceObject = obj3032;
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3834 = alloc_Boolean(0);
// compilenode returning bool3834
  adddatum2(obj3032, bool3834, 6);
  sourceObject = obj3032;
// Begin line 660
  setline(660);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3835 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3835
  adddatum2(obj3032, array3835, 7);
  sourceObject = obj3032;
// Begin line 661
  setline(661);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3836 = alloc_Boolean(0);
// compilenode returning bool3836
  adddatum2(obj3032, bool3836, 8);
  sourceObject = obj3032;
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3837 = gc_frame_new();
  int callframe3838 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3839 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe3838);
// compilenode returning call3839
// compilenode returning call3839
  partcv[0] = 0;
  Object call3840 = callmethod(call3839, "new",
    1, partcv, params);
  gc_frame_end(callframe3837);
// compilenode returning call3840
// compilenode returning call3840
  adddatum2(obj3032, call3840, 9);
  sourceObject = obj3032;
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3841 = gc_frame_new();
  int callframe3842 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call3843 = callmethod(*var_collections, "map",
    1, partcv, params);
  gc_frame_end(callframe3842);
// compilenode returning call3843
// compilenode returning call3843
  partcv[0] = 0;
  Object call3844 = callmethod(call3843, "new",
    1, partcv, params);
  gc_frame_end(callframe3841);
// compilenode returning call3844
// compilenode returning call3844
  adddatum2(obj3032, call3844, 10);
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
  sourceObject = obj3032;
objclass3032 = obj3032->class;
  objclass3032->definitionModule = modulename;
  objclass3032->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3032;
  self = oldself3032;
  selfslot = oldselfslot3032;
  stackframe = oldstackframe3032;
  gc_frame_end(frame);
  return obj3032;
}
Object meth_ast_callNode3846(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_callNode
  gc_frame_end(frame);
  return *var_callNode;
}
Object meth_ast__apply3874(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3875 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_arg
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3876 = callmethod(*var_arg, "accept",
    1, partcv, params);
  gc_frame_end(callframe3875);
// compilenode returning call3876
  gc_frame_end(frame);
  return call3876;
}
Object meth_ast__apply3869(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3870 = gc_frame_new();
  int callframe3871 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call3872 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe3871);
// compilenode returning call3872
// compilenode returning call3872
  gc_frame_newslot(call3872);
  Object block3873 = alloc_Block(NULL, NULL, "ast", 824);
  gc_frame_newslot(block3873);
  block_savedest(block3873);
  Object closure3874 = createclosure(2, "_apply");
setclosureframe(closure3874, stackframe);
  addtoclosure(closure3874, var_visitor);
  addtoclosure(closure3874, selfslot);
  struct UserObject *uo3874 = (struct UserObject*)block3873;
  uo3874->data[0] = (Object)closure3874;
  Method *meth_meth_ast__apply3874 = addmethod2pos(block3873, "_apply", &meth_ast__apply3874, 0);
int argcv_meth_ast__apply3874[] = {1};
meth_meth_ast__apply3874->type = alloc_MethodType(1, argcv_meth_ast__apply3874);
  meth_meth_ast__apply3874->definitionModule = modulename;
  meth_meth_ast__apply3874->definitionLine = 824;
// compilenode returning block3873
  gc_frame_newslot(block3873);
  params[0] = call3872;
  params[1] = block3873;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3878 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3870);
// compilenode returning call3878
  gc_frame_end(frame);
  return call3878;
}
Object meth_ast_accept3857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3859 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call3860 = callmethod(*var_visitor, "visitCall",
    1, partcv, params);
  gc_frame_end(callframe3859);
// compilenode returning call3860
  Object if3858 = done;
  if (istrue(call3860)) {
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3861 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe3862 = gc_frame_new();
  partcv[0] = 0;
  Object call3863 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3862);
// compilenode returning call3863
// compilenode returning call3863
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call3864 = callmethod(call3863, "accept",
    1, partcv, params);
  gc_frame_end(callframe3861);
// compilenode returning call3864
// Begin line 823
  setline(823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3865 = gc_frame_new();
  int callframe3866 = gc_frame_new();
  partcv[0] = 0;
  Object call3867 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3866);
// compilenode returning call3867
// compilenode returning call3867
  gc_frame_newslot(call3867);
  Object block3868 = alloc_Block(NULL, NULL, "ast", 823);
  gc_frame_newslot(block3868);
  block_savedest(block3868);
  Object closure3869 = createclosure(2, "_apply");
setclosureframe(closure3869, stackframe);
  addtoclosure(closure3869, var_visitor);
  addtoclosure(closure3869, selfslot);
  struct UserObject *uo3869 = (struct UserObject*)block3868;
  uo3869->data[0] = (Object)closure3869;
  Method *meth_meth_ast__apply3869 = addmethod2pos(block3868, "_apply", &meth_ast__apply3869, 0);
int argcv_meth_ast__apply3869[] = {1};
meth_meth_ast__apply3869->type = alloc_MethodType(1, argcv_meth_ast__apply3869);
  meth_meth_ast__apply3869->definitionModule = modulename;
  meth_meth_ast__apply3869->definitionLine = 823;
// compilenode returning block3868
  gc_frame_newslot(block3868);
  params[0] = call3867;
  params[1] = block3868;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3880 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3865);
// compilenode returning call3880
    gc_frame_newslot(call3880);
    if3858 = call3880;
  } else {
  }
// compilenode returning if3858
  gc_frame_end(frame);
  return if3858;
}
Object meth_ast_map_40__41_before_40__41_after3881(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_callNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3882 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call3883 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe3882);
// compilenode returning call3883
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3884 = gc_frame_new();
  int callframe3885 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3886 = gc_frame_new();
  partcv[0] = 0;
  Object call3887 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3886);
// compilenode returning call3887
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3888 = callmethod(call3887, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe3885);
// compilenode returning call3888
  gc_frame_newslot(call3888);
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3889 = gc_frame_new();
  int callframe3890 = gc_frame_new();
  partcv[0] = 0;
  Object call3891 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3890);
// compilenode returning call3891
  gc_frame_newslot(call3891);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3892 = gc_frame_new();
  int callframe3893 = gc_frame_new();
  Object call3894 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3893);
// compilenode returning call3894
// compilenode returning call3894
  partcv[0] = 0;
  Object call3895 = callmethodflags(call3894, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3892);
// compilenode returning call3895
// compilenode returning call3895
  params[0] = call3891;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3896 = callmethodflags(call3895, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3889);
// compilenode returning call3896
  gc_frame_newslot(call3896);
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_callNode
  params[0] = call3888;
  params[1] = call3896;
  partcv[0] = 2;
  Object call3897 = callmethod(*var_callNode, "new",
    1, partcv, params);
  gc_frame_end(callframe3884);
// compilenode returning call3897
  *var_n = call3897;
  if (call3897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3900 = alloc_Boolean(0);
// compilenode returning bool3900
  int op_slot_right_3899 = gc_frame_newslot(bool3900);
  int callframe3902 = gc_frame_new();
  partcv[0] = 0;
  Object call3903 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3902);
// compilenode returning call3903
  int op_slot_left_3899 = gc_frame_newslot(call3903);
  params[0] = bool3900;
  partcv[0] = 1;
  Object opresult3904 = callmethod(call3903, "!=", 1, partcv, params);
// compilenode returning opresult3904
  Object if3898 = done;
  if (istrue(opresult3904)) {
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3905 = gc_frame_new();
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3906 = gc_frame_new();
  int callframe3907 = gc_frame_new();
  partcv[0] = 0;
  Object call3908 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3907);
// compilenode returning call3908
  gc_frame_newslot(call3908);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe3909 = gc_frame_new();
  int callframe3910 = gc_frame_new();
  Object call3911 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3910);
// compilenode returning call3911
// compilenode returning call3911
  partcv[0] = 0;
  Object call3912 = callmethodflags(call3911, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3909);
// compilenode returning call3912
// compilenode returning call3912
  params[0] = call3908;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3913 = callmethodflags(call3912, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3906);
// compilenode returning call3913
  gc_frame_newslot(call3913);
// compilenode returning *var_n
  params[0] = call3913;
  partcv[0] = 1;
  Object call3914 = callmethod(*var_n, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe3905);
// compilenode returning call3914
// compilenode returning done
    gc_frame_newslot(done);
    if3898 = done;
  } else {
  }
// compilenode returning if3898
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3915 = gc_frame_new();
// Begin line 837
  setline(837);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3916 = gc_frame_new();
  partcv[0] = 0;
  Object call3917 = callmethodflags(self, "isPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3916);
// compilenode returning call3917
  gc_frame_newslot(call3917);
// compilenode returning *var_n
  params[0] = call3917;
  partcv[0] = 1;
  Object call3918 = callmethod(*var_n, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe3915);
// compilenode returning call3918
// compilenode returning done
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3919 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3920 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe3919);
// compilenode returning call3920
  *var_n = call3920;
  if (call3920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3922 = gc_frame_new();
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3923 = gc_frame_new();
  partcv[0] = 0;
  Object call3924 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3923);
// compilenode returning call3924
  gc_frame_newslot(call3924);
// compilenode returning *var_n
  params[0] = call3924;
  partcv[0] = 1;
  Object call3925 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe3922);
// compilenode returning call3925
// compilenode returning done
// Begin line 840
  setline(840);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3926 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call3927 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe3926);
// compilenode returning call3927
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply3931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply3934(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map3928(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3929 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block3930 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3930);
  block_savedest(block3930);
  Object closure3931 = createclosure(1, "_apply");
setclosureframe(closure3931, stackframe);
  addtoclosure(closure3931, selfslot);
  struct UserObject *uo3931 = (struct UserObject*)block3930;
  uo3931->data[0] = (Object)closure3931;
  Method *meth_meth_ast__apply3931 = addmethod2pos(block3930, "_apply", &meth_ast__apply3931, 0);
int argcv_meth_ast__apply3931[] = {0};
meth_meth_ast__apply3931->type = alloc_MethodType(1, argcv_meth_ast__apply3931);
  meth_meth_ast__apply3931->definitionModule = modulename;
  meth_meth_ast__apply3931->definitionLine = 835;
// compilenode returning block3930
  gc_frame_newslot(block3930);
  Object block3933 = alloc_Block(NULL, NULL, "ast", 844);
  gc_frame_newslot(block3933);
  block_savedest(block3933);
  Object closure3934 = createclosure(1, "_apply");
setclosureframe(closure3934, stackframe);
  addtoclosure(closure3934, selfslot);
  struct UserObject *uo3934 = (struct UserObject*)block3933;
  uo3934->data[0] = (Object)closure3934;
  Method *meth_meth_ast__apply3934 = addmethod2pos(block3933, "_apply", &meth_ast__apply3934, 0);
int argcv_meth_ast__apply3934[] = {0};
meth_meth_ast__apply3934->type = alloc_MethodType(1, argcv_meth_ast__apply3934);
  meth_meth_ast__apply3934->definitionModule = modulename;
  meth_meth_ast__apply3934->definitionLine = 835;
// compilenode returning block3933
  gc_frame_newslot(block3933);
  params[0] = *var_blk;
  params[1] = block3930;
  params[2] = block3933;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3936 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3929);
// compilenode returning call3936
  gc_frame_end(frame);
  return call3936;
}
Object meth_ast__apply3945(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3947 == NULL) {
    strlit3947 = alloc_String("  ");
    gc_root(strlit3947);
  }
// compilenode returning strlit3947
  int op_slot_right_3946 = gc_frame_newslot(strlit3947);
// compilenode returning *var_spc
  int op_slot_left_3946 = gc_frame_newslot(*var_spc);
  params[0] = strlit3947;
  partcv[0] = 1;
  Object opresult3949 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult3949
  *var_spc = opresult3949;
  if (opresult3949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4001(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 857
  setline(857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4003 == NULL) {
    strlit4003 = alloc_String("""\x0a""");
    gc_root(strlit4003);
  }
// compilenode returning strlit4003
  int op_slot_right_4002 = gc_frame_newslot(strlit4003);
  int callframe4006 = gc_frame_new();
  Object num4007 = alloc_Float64(0);
// compilenode returning num4007
  gc_frame_newslot(num4007);
// compilenode returning *var_g
  params[0] = num4007;
  partcv[0] = 1;
  Object call4008 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4006);
// compilenode returning call4008
  int op_slot_right_4005 = gc_frame_newslot(call4008);
  if (strlit4011 == NULL) {
    strlit4011 = alloc_String("    ");
    gc_root(strlit4011);
  }
// compilenode returning strlit4011
  int op_slot_right_4010 = gc_frame_newslot(strlit4011);
// compilenode returning *var_spc
  int op_slot_right_4013 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_4013 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4015 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4015
  int op_slot_left_4010 = gc_frame_newslot(opresult4015);
  params[0] = strlit4011;
  partcv[0] = 1;
  Object opresult4016 = callmethod(opresult4015, "++", 1, partcv, params);
// compilenode returning opresult4016
  int op_slot_left_4005 = gc_frame_newslot(opresult4016);
  params[0] = call4008;
  partcv[0] = 1;
  Object opresult4017 = callmethod(opresult4016, "++", 1, partcv, params);
// compilenode returning opresult4017
  int op_slot_left_4002 = gc_frame_newslot(opresult4017);
  params[0] = strlit4003;
  partcv[0] = 1;
  Object opresult4018 = callmethod(opresult4017, "++", 1, partcv, params);
// compilenode returning opresult4018
  *var_s = opresult4018;
  if (opresult4018 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4056(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 864
  setline(864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4058 = gc_frame_new();
  Object num4060 = alloc_Float64(3);
// compilenode returning num4060
  int op_slot_right_4059 = gc_frame_newslot(num4060);
// compilenode returning *var_depth
  int op_slot_left_4059 = gc_frame_newslot(*var_depth);
  params[0] = num4060;
  partcv[0] = 1;
  Object sum4062 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4062
  gc_frame_newslot(sum4062);
// compilenode returning *var_arg
  params[0] = sum4062;
  partcv[0] = 1;
  Object call4063 = callmethod(*var_arg, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4058);
// compilenode returning call4063
  int op_slot_right_4057 = gc_frame_newslot(call4063);
// compilenode returning *var_spc
  int op_slot_right_4065 = gc_frame_newslot(*var_spc);
  if (strlit4068 == NULL) {
    strlit4068 = alloc_String("""\x0a""    ");
    gc_root(strlit4068);
  }
// compilenode returning strlit4068
  int op_slot_right_4067 = gc_frame_newslot(strlit4068);
// compilenode returning *var_s
  int op_slot_left_4067 = gc_frame_newslot(*var_s);
  params[0] = strlit4068;
  partcv[0] = 1;
  Object opresult4070 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4070
  int op_slot_left_4065 = gc_frame_newslot(opresult4070);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4071 = callmethod(opresult4070, "++", 1, partcv, params);
// compilenode returning opresult4071
  int op_slot_left_4057 = gc_frame_newslot(opresult4071);
  params[0] = call4063;
  partcv[0] = 1;
  Object opresult4072 = callmethod(opresult4071, "++", 1, partcv, params);
// compilenode returning opresult4072
  *var_s = opresult4072;
  if (opresult4072 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4036 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4037 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4036);
// compilenode returning call4037
// compilenode returning call4037
  int op_slot_right_4035 = gc_frame_newslot(call4037);
  if (strlit4040 == NULL) {
    strlit4040 = alloc_String("Part: ");
    gc_root(strlit4040);
  }
// compilenode returning strlit4040
  int op_slot_right_4039 = gc_frame_newslot(strlit4040);
// compilenode returning *var_spc
  int op_slot_right_4042 = gc_frame_newslot(*var_spc);
  if (strlit4045 == NULL) {
    strlit4045 = alloc_String("""\x0a""  ");
    gc_root(strlit4045);
  }
// compilenode returning strlit4045
  int op_slot_right_4044 = gc_frame_newslot(strlit4045);
// compilenode returning *var_s
  int op_slot_left_4044 = gc_frame_newslot(*var_s);
  params[0] = strlit4045;
  partcv[0] = 1;
  Object opresult4047 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4047
  int op_slot_left_4042 = gc_frame_newslot(opresult4047);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4048 = callmethod(opresult4047, "++", 1, partcv, params);
// compilenode returning opresult4048
  int op_slot_left_4039 = gc_frame_newslot(opresult4048);
  params[0] = strlit4040;
  partcv[0] = 1;
  Object opresult4049 = callmethod(opresult4048, "++", 1, partcv, params);
// compilenode returning opresult4049
  int op_slot_left_4035 = gc_frame_newslot(opresult4049);
  params[0] = call4037;
  partcv[0] = 1;
  Object opresult4050 = callmethod(opresult4049, "++", 1, partcv, params);
// compilenode returning opresult4050
  *var_s = opresult4050;
  if (opresult4050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4052 = gc_frame_new();
  int callframe4053 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4054 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4053);
// compilenode returning call4054
// compilenode returning call4054
  gc_frame_newslot(call4054);
  Object block4055 = alloc_Block(NULL, NULL, "ast", 863);
  gc_frame_newslot(block4055);
  block_savedest(block4055);
  Object closure4056 = createclosure(4, "_apply");
setclosureframe(closure4056, stackframe);
  addtoclosure(closure4056, var_depth);
  addtoclosure(closure4056, var_spc);
  addtoclosure(closure4056, var_s);
  addtoclosure(closure4056, selfslot);
  struct UserObject *uo4056 = (struct UserObject*)block4055;
  uo4056->data[0] = (Object)closure4056;
  Method *meth_meth_ast__apply4056 = addmethod2pos(block4055, "_apply", &meth_ast__apply4056, 0);
int argcv_meth_ast__apply4056[] = {1};
meth_meth_ast__apply4056->type = alloc_MethodType(1, argcv_meth_ast__apply4056);
  meth_meth_ast__apply4056->definitionModule = modulename;
  meth_meth_ast__apply4056->definitionLine = 863;
// compilenode returning block4055
  gc_frame_newslot(block4055);
  params[0] = call4054;
  params[1] = block4055;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4075 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4052);
// compilenode returning call4075
  gc_frame_end(frame);
  return call4075;
}
Object meth_ast_pretty3937(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("");
    gc_root(strlit3938);
  }
// compilenode returning strlit3938
  *var_spc = strlit3938;
  if (strlit3938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3939 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_3940 = gc_frame_newslot(*var_depth);
  Object num3942 = alloc_Float64(0);
// compilenode returning num3942
  int op_slot_left_3940 = gc_frame_newslot(num3942);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult3943 = callmethod(num3942, "..", 1, partcv, params);
// compilenode returning opresult3943
  gc_frame_newslot(opresult3943);
  Object block3944 = alloc_Block(NULL, NULL, "ast", 848);
  gc_frame_newslot(block3944);
  block_savedest(block3944);
  Object closure3945 = createclosure(2, "_apply");
setclosureframe(closure3945, stackframe);
  addtoclosure(closure3945, var_spc);
  addtoclosure(closure3945, selfslot);
  struct UserObject *uo3945 = (struct UserObject*)block3944;
  uo3945->data[0] = (Object)closure3945;
  Method *meth_meth_ast__apply3945 = addmethod2pos(block3944, "_apply", &meth_ast__apply3945, 0);
int argcv_meth_ast__apply3945[] = {1};
meth_meth_ast__apply3945->type = alloc_MethodType(1, argcv_meth_ast__apply3945);
  meth_meth_ast__apply3945->definitionModule = modulename;
  meth_meth_ast__apply3945->definitionLine = 835;
// compilenode returning block3944
  gc_frame_newslot(block3944);
  params[0] = opresult3943;
  params[1] = block3944;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3952 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3939);
// compilenode returning call3952
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3953 == NULL) {
    strlit3953 = alloc_String("Call""\x0a""");
    gc_root(strlit3953);
  }
// compilenode returning strlit3953
  *var_s = strlit3953;
  if (strlit3953 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3956 == NULL) {
    strlit3956 = alloc_String("");
    gc_root(strlit3956);
  }
// compilenode returning strlit3956
  int op_slot_right_3955 = gc_frame_newslot(strlit3956);
  int callframe3959 = gc_frame_new();
  Object num3961 = alloc_Float64(1);
// compilenode returning num3961
  int op_slot_right_3960 = gc_frame_newslot(num3961);
// compilenode returning *var_depth
  int op_slot_left_3960 = gc_frame_newslot(*var_depth);
  params[0] = num3961;
  partcv[0] = 1;
  Object sum3963 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum3963
  gc_frame_newslot(sum3963);
  int callframe3964 = gc_frame_new();
  partcv[0] = 0;
  Object call3965 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3964);
// compilenode returning call3965
// compilenode returning call3965
  params[0] = sum3963;
  partcv[0] = 1;
  Object call3966 = callmethod(call3965, "pretty",
    1, partcv, params);
  gc_frame_end(callframe3959);
// compilenode returning call3966
  int op_slot_right_3958 = gc_frame_newslot(call3966);
  if (strlit3968 == NULL) {
    strlit3968 = alloc_String("Method: ");
    gc_root(strlit3968);
  }
// compilenode returning strlit3968
  int op_slot_left_3958 = gc_frame_newslot(strlit3968);
  params[0] = call3966;
  partcv[0] = 1;
  Object opresult3969 = callmethod(strlit3968, "++", 1, partcv, params);
// compilenode returning opresult3969
  int op_slot_left_3955 = gc_frame_newslot(opresult3969);
  params[0] = strlit3956;
  partcv[0] = 1;
  Object opresult3970 = callmethod(opresult3969, "++", 1, partcv, params);
// compilenode returning opresult3970
  int op_slot_right_3954 = gc_frame_newslot(opresult3970);
// compilenode returning *var_spc
  int op_slot_right_3972 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3972 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3974 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3974
  int op_slot_left_3954 = gc_frame_newslot(opresult3974);
  params[0] = opresult3970;
  partcv[0] = 1;
  Object opresult3975 = callmethod(opresult3974, "++", 1, partcv, params);
// compilenode returning opresult3975
  *var_s = opresult3975;
  if (opresult3975 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3978 == NULL) {
    strlit3978 = alloc_String("""\x0a""");
    gc_root(strlit3978);
  }
// compilenode returning strlit3978
  int op_slot_right_3977 = gc_frame_newslot(strlit3978);
// compilenode returning *var_s
  int op_slot_left_3977 = gc_frame_newslot(*var_s);
  params[0] = strlit3978;
  partcv[0] = 1;
  Object opresult3980 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3980
  *var_s = opresult3980;
  if (opresult3980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3984 = gc_frame_new();
  partcv[0] = 0;
  Object call3985 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3984);
// compilenode returning call3985
  int op_slot_right_3983 = gc_frame_newslot(call3985);
  Object bool3987 = alloc_Boolean(0);
// compilenode returning bool3987
  int op_slot_left_3983 = gc_frame_newslot(bool3987);
  params[0] = call3985;
  partcv[0] = 1;
  Object opresult3988 = callmethod(bool3987, "!=", 1, partcv, params);
// compilenode returning opresult3988
  Object if3982 = done;
  if (istrue(opresult3988)) {
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3990 == NULL) {
    strlit3990 = alloc_String("  Generics:""\x0a""");
    gc_root(strlit3990);
  }
// compilenode returning strlit3990
  int op_slot_right_3989 = gc_frame_newslot(strlit3990);
// compilenode returning *var_spc
  int op_slot_right_3992 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_3992 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult3994 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult3994
  int op_slot_left_3989 = gc_frame_newslot(opresult3994);
  params[0] = strlit3990;
  partcv[0] = 1;
  Object opresult3995 = callmethod(opresult3994, "++", 1, partcv, params);
// compilenode returning opresult3995
  *var_s = opresult3995;
  if (opresult3995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3997 = gc_frame_new();
  int callframe3998 = gc_frame_new();
  partcv[0] = 0;
  Object call3999 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compilenode returning call3999
  gc_frame_newslot(call3999);
  Object block4000 = alloc_Block(NULL, NULL, "ast", 856);
  gc_frame_newslot(block4000);
  block_savedest(block4000);
  Object closure4001 = createclosure(3, "_apply");
setclosureframe(closure4001, stackframe);
  addtoclosure(closure4001, var_spc);
  addtoclosure(closure4001, var_s);
  addtoclosure(closure4001, selfslot);
  struct UserObject *uo4001 = (struct UserObject*)block4000;
  uo4001->data[0] = (Object)closure4001;
  Method *meth_meth_ast__apply4001 = addmethod2pos(block4000, "_apply", &meth_ast__apply4001, 0);
int argcv_meth_ast__apply4001[] = {1};
meth_meth_ast__apply4001->type = alloc_MethodType(1, argcv_meth_ast__apply4001);
  meth_meth_ast__apply4001->definitionModule = modulename;
  meth_meth_ast__apply4001->definitionLine = 852;
// compilenode returning block4000
  gc_frame_newslot(block4000);
  params[0] = call3999;
  params[1] = block4000;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4021 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3997);
// compilenode returning call4021
    gc_frame_newslot(call4021);
    if3982 = call4021;
  } else {
  }
// compilenode returning if3982
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4023 == NULL) {
    strlit4023 = alloc_String("Arguments:");
    gc_root(strlit4023);
  }
// compilenode returning strlit4023
  int op_slot_right_4022 = gc_frame_newslot(strlit4023);
// compilenode returning *var_spc
  int op_slot_right_4025 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_4025 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4027 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4027
  int op_slot_left_4022 = gc_frame_newslot(opresult4027);
  params[0] = strlit4023;
  partcv[0] = 1;
  Object opresult4028 = callmethod(opresult4027, "++", 1, partcv, params);
// compilenode returning opresult4028
  *var_s = opresult4028;
  if (opresult4028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4030 = gc_frame_new();
  int callframe4031 = gc_frame_new();
  partcv[0] = 0;
  Object call4032 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4031);
// compilenode returning call4032
// compilenode returning call4032
  gc_frame_newslot(call4032);
  Object block4033 = alloc_Block(NULL, NULL, "ast", 861);
  gc_frame_newslot(block4033);
  block_savedest(block4033);
  Object closure4034 = createclosure(4, "_apply");
setclosureframe(closure4034, stackframe);
  addtoclosure(closure4034, var_spc);
  addtoclosure(closure4034, var_s);
  addtoclosure(closure4034, var_depth);
  addtoclosure(closure4034, selfslot);
  struct UserObject *uo4034 = (struct UserObject*)block4033;
  uo4034->data[0] = (Object)closure4034;
  Method *meth_meth_ast__apply4034 = addmethod2pos(block4033, "_apply", &meth_ast__apply4034, 0);
int argcv_meth_ast__apply4034[] = {1};
meth_meth_ast__apply4034->type = alloc_MethodType(1, argcv_meth_ast__apply4034);
  meth_meth_ast__apply4034->definitionModule = modulename;
  meth_meth_ast__apply4034->definitionLine = 861;
// compilenode returning block4033
  gc_frame_newslot(block4033);
  params[0] = call4032;
  params[1] = block4033;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4077 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4030);
// compilenode returning call4077
// Begin line 867
  setline(867);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply4090(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4092 == NULL) {
    strlit4092 = alloc_String("    ");
    gc_root(strlit4092);
  }
// compilenode returning strlit4092
  int op_slot_right_4091 = gc_frame_newslot(strlit4092);
// compilenode returning *var_spc
  int op_slot_left_4091 = gc_frame_newslot(*var_spc);
  params[0] = strlit4092;
  partcv[0] = 1;
  Object opresult4094 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4094
  *var_spc = opresult4094;
  if (opresult4094 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4180(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_anr = &(stackframe->slots[0]);
  *var_anr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "arg");
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 889
  setline(889);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4181 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4182 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4181);
// compilenode returning call4182
// compilenode returning call4182
// compilenode returning *var_anr
  params[0] = *var_anr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4183 = callmethod(call4182, "[]", 1, partcv, params);
// compilenode returning idxres4183
  *var_arg = idxres4183;
  if (idxres4183 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4185 = gc_frame_new();
  Object num4187 = alloc_Float64(1);
// compilenode returning num4187
  int op_slot_right_4186 = gc_frame_newslot(num4187);
// compilenode returning *var_depth
  int op_slot_left_4186 = gc_frame_newslot(*var_depth);
  params[0] = num4187;
  partcv[0] = 1;
  Object sum4189 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4189
  gc_frame_newslot(sum4189);
// compilenode returning *var_arg
  params[0] = sum4189;
  partcv[0] = 1;
  Object call4190 = callmethod(*var_arg, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4185);
// compilenode returning call4190
  int op_slot_right_4184 = gc_frame_newslot(call4190);
// compilenode returning *var_s
  int op_slot_left_4184 = gc_frame_newslot(*var_s);
  params[0] = call4190;
  partcv[0] = 1;
  Object opresult4192 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4192
  *var_s = opresult4192;
  if (opresult4192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4196 = gc_frame_new();
  int callframe4197 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4198 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4197);
// compilenode returning call4198
// compilenode returning call4198
  partcv[0] = 0;
  Object call4199 = callmethod(call4198, "size",
    1, partcv, params);
  gc_frame_end(callframe4196);
// compilenode returning call4199
// compilenode returning call4199
  int op_slot_right_4195 = gc_frame_newslot(call4199);
// compilenode returning *var_anr
  int op_slot_left_4195 = gc_frame_newslot(*var_anr);
  params[0] = call4199;
  partcv[0] = 1;
  Object opresult4201 = callmethod(*var_anr, "<", 1, partcv, params);
// compilenode returning opresult4201
  Object if4194 = done;
  if (istrue(opresult4201)) {
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4203 == NULL) {
    strlit4203 = alloc_String(", ");
    gc_root(strlit4203);
  }
// compilenode returning strlit4203
  int op_slot_right_4202 = gc_frame_newslot(strlit4203);
// compilenode returning *var_s
  int op_slot_left_4202 = gc_frame_newslot(*var_s);
  params[0] = strlit4203;
  partcv[0] = 1;
  Object opresult4205 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4205
  *var_s = opresult4205;
  if (opresult4205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4194 = done;
  } else {
  }
// compilenode returning if4194
  gc_frame_end(frame);
  return if4194;
}
Object meth_ast__apply4153(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4155 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4156 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4155);
// compilenode returning call4156
// compilenode returning call4156
  int op_slot_right_4154 = gc_frame_newslot(call4156);
// compilenode returning *var_s
  int op_slot_left_4154 = gc_frame_newslot(*var_s);
  params[0] = call4156;
  partcv[0] = 1;
  Object opresult4158 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4158
  *var_s = opresult4158;
  if (opresult4158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4162 = alloc_Float64(0);
// compilenode returning num4162
  int op_slot_right_4161 = gc_frame_newslot(num4162);
  int callframe4164 = gc_frame_new();
  int callframe4165 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4166 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4165);
// compilenode returning call4166
// compilenode returning call4166
  partcv[0] = 0;
  Object call4167 = callmethod(call4166, "size",
    1, partcv, params);
  gc_frame_end(callframe4164);
// compilenode returning call4167
// compilenode returning call4167
  int op_slot_left_4161 = gc_frame_newslot(call4167);
  params[0] = num4162;
  partcv[0] = 1;
  Object opresult4168 = callmethod(call4167, ">", 1, partcv, params);
// compilenode returning opresult4168
  Object if4160 = done;
  if (istrue(opresult4168)) {
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4170 == NULL) {
    strlit4170 = alloc_String("(");
    gc_root(strlit4170);
  }
// compilenode returning strlit4170
  int op_slot_right_4169 = gc_frame_newslot(strlit4170);
// compilenode returning *var_s
  int op_slot_left_4169 = gc_frame_newslot(*var_s);
  params[0] = strlit4170;
  partcv[0] = 1;
  Object opresult4172 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4172
  *var_s = opresult4172;
  if (opresult4172 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4174 = gc_frame_new();
  int callframe4175 = gc_frame_new();
  int callframe4176 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4177 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe4176);
// compilenode returning call4177
// compilenode returning call4177
  partcv[0] = 0;
  Object call4178 = callmethod(call4177, "indices",
    1, partcv, params);
  gc_frame_end(callframe4175);
// compilenode returning call4178
// compilenode returning call4178
  gc_frame_newslot(call4178);
  Object block4179 = alloc_Block(NULL, NULL, "ast", 888);
  gc_frame_newslot(block4179);
  block_savedest(block4179);
  Object closure4180 = createclosure(4, "_apply");
setclosureframe(closure4180, stackframe);
  addtoclosure(closure4180, var_part);
  addtoclosure(closure4180, var_depth);
  addtoclosure(closure4180, var_s);
  addtoclosure(closure4180, selfslot);
  struct UserObject *uo4180 = (struct UserObject*)block4179;
  uo4180->data[0] = (Object)closure4180;
  Method *meth_meth_ast__apply4180 = addmethod2pos(block4179, "_apply", &meth_ast__apply4180, 0);
int argcv_meth_ast__apply4180[] = {1};
meth_meth_ast__apply4180->type = alloc_MethodType(1, argcv_meth_ast__apply4180);
  meth_meth_ast__apply4180->definitionModule = modulename;
  meth_meth_ast__apply4180->definitionLine = 888;
// compilenode returning block4179
  gc_frame_newslot(block4179);
  params[0] = call4178;
  params[1] = block4179;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4208 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4174);
// compilenode returning call4208
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 895
  setline(895);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4210 == NULL) {
    strlit4210 = alloc_String(")");
    gc_root(strlit4210);
  }
// compilenode returning strlit4210
  int op_slot_right_4209 = gc_frame_newslot(strlit4210);
// compilenode returning *var_s
  int op_slot_left_4209 = gc_frame_newslot(*var_s);
  params[0] = strlit4210;
  partcv[0] = 1;
  Object opresult4212 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4212
  *var_s = opresult4212;
  if (opresult4212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4160 = done;
  } else {
  }
// compilenode returning if4160
  gc_frame_end(frame);
  return if4160;
}
Object meth_ast_toGrace4078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_member = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "member");
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String("");
    gc_root(strlit4079);
  }
// compilenode returning strlit4079
  *var_spc = strlit4079;
  if (strlit4079 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 871
  setline(871);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4080 = gc_frame_new();
  Object num4083 = alloc_Float64(1);
// compilenode returning num4083
  int op_slot_right_4082 = gc_frame_newslot(num4083);
// compilenode returning *var_depth
  int op_slot_left_4082 = gc_frame_newslot(*var_depth);
  params[0] = num4083;
  partcv[0] = 1;
  Object diff4085 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff4085
  int op_slot_right_4081 = gc_frame_newslot(diff4085);
  Object num4087 = alloc_Float64(0);
// compilenode returning num4087
  int op_slot_left_4081 = gc_frame_newslot(num4087);
  params[0] = diff4085;
  partcv[0] = 1;
  Object opresult4088 = callmethod(num4087, "..", 1, partcv, params);
// compilenode returning opresult4088
  gc_frame_newslot(opresult4088);
  Object block4089 = alloc_Block(NULL, NULL, "ast", 871);
  gc_frame_newslot(block4089);
  block_savedest(block4089);
  Object closure4090 = createclosure(2, "_apply");
setclosureframe(closure4090, stackframe);
  addtoclosure(closure4090, var_spc);
  addtoclosure(closure4090, selfslot);
  struct UserObject *uo4090 = (struct UserObject*)block4089;
  uo4090->data[0] = (Object)closure4090;
  Method *meth_meth_ast__apply4090 = addmethod2pos(block4089, "_apply", &meth_ast__apply4090, 0);
int argcv_meth_ast__apply4090[] = {1};
meth_meth_ast__apply4090->type = alloc_MethodType(1, argcv_meth_ast__apply4090);
  meth_meth_ast__apply4090->definitionModule = modulename;
  meth_meth_ast__apply4090->definitionLine = 863;
// compilenode returning block4089
  gc_frame_newslot(block4089);
  params[0] = opresult4088;
  params[1] = block4089;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4097 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4080);
// compilenode returning call4097
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 874
  setline(874);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4098 == NULL) {
    strlit4098 = alloc_String("");
    gc_root(strlit4098);
  }
// compilenode returning strlit4098
  *var_s = strlit4098;
  if (strlit4098 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4101 == NULL) {
    strlit4101 = alloc_String("member");
    gc_root(strlit4101);
  }
// compilenode returning strlit4101
  int op_slot_right_4100 = gc_frame_newslot(strlit4101);
  int callframe4103 = gc_frame_new();
  int callframe4104 = gc_frame_new();
  partcv[0] = 0;
  Object call4105 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4104);
// compilenode returning call4105
// compilenode returning call4105
  partcv[0] = 0;
  Object call4106 = callmethod(call4105, "kind",
    1, partcv, params);
  gc_frame_end(callframe4103);
// compilenode returning call4106
// compilenode returning call4106
  int op_slot_left_4100 = gc_frame_newslot(call4106);
  params[0] = strlit4101;
  partcv[0] = 1;
  Object opresult4107 = callmethod(call4106, "==", 1, partcv, params);
// compilenode returning opresult4107
  Object if4099 = done;
  if (istrue(opresult4107)) {
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4108 = gc_frame_new();
  partcv[0] = 0;
  Object call4109 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4108);
// compilenode returning call4109
// compilenode returning call4109
  *var_member = call4109;
  if (call4109 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4112 == NULL) {
    strlit4112 = alloc_String("prefix");
    gc_root(strlit4112);
  }
// compilenode returning strlit4112
  int op_slot_right_4111 = gc_frame_newslot(strlit4112);
  int callframe4114 = gc_frame_new();
  Object num4115 = alloc_Float64(1);
// compilenode returning num4115
  gc_frame_newslot(num4115);
  Object num4116 = alloc_Float64(6);
// compilenode returning num4116
  gc_frame_newslot(num4116);
  int callframe4117 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4118 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4117);
// compilenode returning call4118
// compilenode returning call4118
  params[0] = num4115;
  params[1] = num4116;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4119 = callmethod(call4118, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4114);
// compilenode returning call4119
  int op_slot_left_4111 = gc_frame_newslot(call4119);
  params[0] = strlit4112;
  partcv[0] = 1;
  Object opresult4120 = callmethod(call4119, "==", 1, partcv, params);
// compilenode returning opresult4120
  Object if4110 = done;
  if (istrue(opresult4120)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4121 = gc_frame_new();
  Object num4122 = alloc_Float64(7);
// compilenode returning num4122
  gc_frame_newslot(num4122);
  int callframe4123 = gc_frame_new();
  int callframe4124 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4125 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4124);
// compilenode returning call4125
// compilenode returning call4125
  partcv[0] = 0;
  Object call4126 = callmethod(call4125, "size",
    1, partcv, params);
  gc_frame_end(callframe4123);
// compilenode returning call4126
// compilenode returning call4126
  gc_frame_newslot(call4126);
  int callframe4127 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4128 = callmethod(*var_member, "value",
    1, partcv, params);
  gc_frame_end(callframe4127);
// compilenode returning call4128
// compilenode returning call4128
  params[0] = num4122;
  params[1] = call4126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4129 = callmethod(call4128, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe4121);
// compilenode returning call4129
  *var_s = call4129;
  if (call4129 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4132 = gc_frame_new();
  Object num4133 = alloc_Float64(0);
// compilenode returning num4133
  gc_frame_newslot(num4133);
  int callframe4134 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4135 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4134);
// compilenode returning call4135
// compilenode returning call4135
  params[0] = num4133;
  partcv[0] = 1;
  Object call4136 = callmethod(call4135, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4132);
// compilenode returning call4136
  int op_slot_right_4131 = gc_frame_newslot(call4136);
// compilenode returning *var_s
  int op_slot_left_4131 = gc_frame_newslot(*var_s);
  params[0] = call4136;
  partcv[0] = 1;
  Object opresult4138 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4138
  return opresult4138;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if4110 = undefined;
  } else {
  }
// compilenode returning if4110
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4140 == NULL) {
    strlit4140 = alloc_String(".");
    gc_root(strlit4140);
  }
// compilenode returning strlit4140
  int op_slot_right_4139 = gc_frame_newslot(strlit4140);
  int callframe4142 = gc_frame_new();
  Object num4143 = alloc_Float64(0);
// compilenode returning num4143
  gc_frame_newslot(num4143);
  int callframe4144 = gc_frame_new();
// compilenode returning *var_member
  partcv[0] = 0;
  Object call4145 = callmethod(*var_member, "in",
    1, partcv, params);
  gc_frame_end(callframe4144);
// compilenode returning call4145
// compilenode returning call4145
  params[0] = num4143;
  partcv[0] = 1;
  Object call4146 = callmethod(call4145, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4142);
// compilenode returning call4146
  int op_slot_left_4139 = gc_frame_newslot(call4146);
  params[0] = strlit4140;
  partcv[0] = 1;
  Object opresult4147 = callmethod(call4146, "++", 1, partcv, params);
// compilenode returning opresult4147
  *var_s = opresult4147;
  if (opresult4147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4099 = done;
  } else {
  }
// compilenode returning if4099
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4149 = gc_frame_new();
  int callframe4150 = gc_frame_new();
  partcv[0] = 0;
  Object call4151 = callmethodflags(self, "with", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4150);
// compilenode returning call4151
// compilenode returning call4151
  gc_frame_newslot(call4151);
  Object block4152 = alloc_Block(NULL, NULL, "ast", 884);
  gc_frame_newslot(block4152);
  block_savedest(block4152);
  Object closure4153 = createclosure(3, "_apply");
setclosureframe(closure4153, stackframe);
  addtoclosure(closure4153, var_s);
  addtoclosure(closure4153, var_depth);
  addtoclosure(closure4153, selfslot);
  struct UserObject *uo4153 = (struct UserObject*)block4152;
  uo4153->data[0] = (Object)closure4153;
  Method *meth_meth_ast__apply4153 = addmethod2pos(block4152, "_apply", &meth_ast__apply4153, 0);
int argcv_meth_ast__apply4153[] = {1};
meth_meth_ast__apply4153->type = alloc_MethodType(1, argcv_meth_ast__apply4153);
  meth_meth_ast__apply4153->definitionModule = modulename;
  meth_meth_ast__apply4153->definitionLine = 884;
// compilenode returning block4152
  gc_frame_newslot(block4152);
  params[0] = call4151;
  params[1] = block4152;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4215 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4149);
// compilenode returning call4215
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new3849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3850 = alloc_userobj2(13,12, objclass3850);
  gc_frame_newslot(obj3850);
if (objclass3850 == NULL) {
  glfree(obj3850->class->name);
  obj3850->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3850, self, 0);
  addmethodreal(obj3850,"outer", &reader_ast_outer_3851);
  Object oldself3850 = self;
  struct StackFrameObject *oldstackframe3850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3850);
  gc_frame_newslot((Object)stackframe);
  self = obj3850;
  Object *oldselfslot3850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3850 = (*(struct UserObject *)self).data[0], lowerouter3850 = thisouter3850;
  if (inheritingObject3850) {
    struct UserObject *inho3850 = (struct UserObject *)inheritingObject3850;
    while (inho3850->super != GraceDefaultObject) inho3850 = (struct UserObject *)inho3850->super;
    inho3850->super = obj3850;
    self = inheritingObject3850;
    *selfslot = self;
    lowerouter3850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3850;
  }
if (objclass3850 == NULL) {
  Method *reader3852 = addmethodrealflags(obj3850, "kind",&reader_ast_kind_3852, MFLAG_DEF);
  reader3852->definitionModule = modulename;
  reader3852->definitionLine = 816;
}
adddatum2(obj3850, alloc_Undefined(), 1);
if (objclass3850 == NULL) {
  Method *reader3853 = addmethodrealflags(obj3850, "value",&reader_ast_value_3853, MFLAG_DEF);
  reader3853->definitionModule = modulename;
  reader3853->definitionLine = 817;
}
adddatum2(obj3850, alloc_Undefined(), 2);
if (objclass3850 == NULL) {
  Method *reader3854 = addmethodrealflags(obj3850, "with",&reader_ast_with_3854, MFLAG_DEF);
  reader3854->definitionModule = modulename;
  reader3854->definitionLine = 818;
}
adddatum2(obj3850, alloc_Undefined(), 3);
if (objclass3850 == NULL) {
  Method *reader3855 = addmethodrealflags(obj3850, "generics",&reader_ast_generics_3855, 0);
  Method *writer3855 = addmethodrealflags(obj3850, "generics:=",&writer_ast_generics_3855, 0);
  reader3855->definitionModule = modulename;
  writer3855->definitionModule = modulename;
  reader3855->definitionLine = 819;
  writer3855->definitionLine = 819;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 4);
if (objclass3850 == NULL) {
  Method *reader3856 = addmethodrealflags(obj3850, "isPattern",&reader_ast_isPattern_3856, 0);
  Method *writer3856 = addmethodrealflags(obj3850, "isPattern:=",&writer_ast_isPattern_3856, 0);
  reader3856->definitionModule = modulename;
  writer3856->definitionModule = modulename;
  reader3856->definitionLine = 820;
  writer3856->definitionLine = 820;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 5);
  struct UserObject *uo3857 = (struct UserObject*)obj3850;
  uo3857->data[6] = emptyclosure;
  Method *meth_meth_ast_accept3857 = addmethod2pos(obj3850, "accept", &meth_ast_accept3857, 6);
int argcv_meth_ast_accept3857[] = {1};
meth_meth_ast_accept3857->type = alloc_MethodType(1, argcv_meth_ast_accept3857);
meth_meth_ast_accept3857->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3857->type->names[0] = "visitor";
  meth_meth_ast_accept3857->definitionModule = modulename;
  meth_meth_ast_accept3857->definitionLine = 820;
  block_savedest(obj3850);
  Object closure3881 = createclosure(1, "map()before()after");
setclosureframe(closure3881, stackframe);
  addtoclosure(closure3881, var_callNode);
  struct UserObject *uo3881 = (struct UserObject*)obj3850;
  uo3881->data[7] = (Object)closure3881;
  Method *meth_meth_ast_map_40__41_before_40__41_after3881 = addmethod2pos(obj3850, "map()before()after", &meth_ast_map_40__41_before_40__41_after3881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after3881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3881);
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionLine = 830;
  struct UserObject *uo3928 = (struct UserObject*)obj3850;
  uo3928->data[8] = emptyclosure;
  Method *meth_meth_ast_map3928 = addmethod2pos(obj3850, "map", &meth_ast_map3928, 8);
int argcv_meth_ast_map3928[] = {1};
meth_meth_ast_map3928->type = alloc_MethodType(1, argcv_meth_ast_map3928);
  meth_meth_ast_map3928->definitionModule = modulename;
  meth_meth_ast_map3928->definitionLine = 843;
  struct UserObject *uo3937 = (struct UserObject*)obj3850;
  uo3937->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty3937 = addmethod2pos(obj3850, "pretty", &meth_ast_pretty3937, 9);
int argcv_meth_ast_pretty3937[] = {1};
meth_meth_ast_pretty3937->type = alloc_MethodType(1, argcv_meth_ast_pretty3937);
  meth_meth_ast_pretty3937->definitionModule = modulename;
  meth_meth_ast_pretty3937->definitionLine = 846;
  struct UserObject *uo4078 = (struct UserObject*)obj3850;
  uo4078->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace4078 = addmethod2pos(obj3850, "toGrace", &meth_ast_toGrace4078, 10);
int argcv_meth_ast_toGrace4078[] = {1};
meth_meth_ast_toGrace4078->type = alloc_MethodType(1, argcv_meth_ast_toGrace4078);
meth_meth_ast_toGrace4078->type->types[0] = type_Number;
meth_meth_ast_toGrace4078->type->names[0] = "depth";
  meth_meth_ast_toGrace4078->definitionModule = modulename;
  meth_meth_ast_toGrace4078->definitionLine = 869;
  sourceObject = obj3850;
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4216 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4217 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4216);
// compilenode returning call4217
  struct UserObject *obj3850_uo = (struct UserObject *)obj3850;
  obj3850_uo->super = call4217;
  sourceObject = obj3850;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("call");
    gc_root(strlit4218);
  }
// compilenode returning strlit4218
  adddatum2(obj3850, strlit4218, 1);
  sourceObject = obj3850;
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj3850, *var_what, 2);
  sourceObject = obj3850;
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_with_39_
  adddatum2(obj3850, *var_with_39_, 3);
  sourceObject = obj3850;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4219 = alloc_Boolean(0);
// compilenode returning bool4219
  adddatum2(obj3850, bool4219, 4);
  sourceObject = obj3850;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4220 = alloc_Boolean(0);
// compilenode returning bool4220
  adddatum2(obj3850, bool4220, 5);
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
objclass3850 = obj3850->class;
  objclass3850->definitionModule = modulename;
  objclass3850->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3850;
  self = oldself3850;
  selfslot = oldselfslot3850;
  stackframe = oldstackframe3850;
  gc_frame_end(frame);
  return obj3850;
}
Object meth_ast_new3849_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_callNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_with_39_ = &(stackframe->slots[1]);
  *var_with_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3850 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3850 = alloc_userobj2(13,12, objclass3850);
  gc_frame_newslot(obj3850);
if (objclass3850 == NULL) {
  glfree(obj3850->class->name);
  obj3850->class->name = "callNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3850, self, 0);
  addmethodreal(obj3850,"outer", &reader_ast_outer_3851);
  Object oldself3850 = self;
  struct StackFrameObject *oldstackframe3850 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3850);
  gc_frame_newslot((Object)stackframe);
  self = obj3850;
  Object *oldselfslot3850 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3850 = (*(struct UserObject *)self).data[0], lowerouter3850 = thisouter3850;
  if (inheritingObject3850) {
    struct UserObject *inho3850 = (struct UserObject *)inheritingObject3850;
    while (inho3850->super != GraceDefaultObject) inho3850 = (struct UserObject *)inho3850->super;
    inho3850->super = obj3850;
    self = inheritingObject3850;
    *selfslot = self;
    lowerouter3850 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3850;
  }
if (objclass3850 == NULL) {
  Method *reader3852 = addmethodrealflags(obj3850, "kind",&reader_ast_kind_3852, MFLAG_DEF);
  reader3852->definitionModule = modulename;
  reader3852->definitionLine = 816;
}
adddatum2(obj3850, alloc_Undefined(), 1);
if (objclass3850 == NULL) {
  Method *reader3853 = addmethodrealflags(obj3850, "value",&reader_ast_value_3853, MFLAG_DEF);
  reader3853->definitionModule = modulename;
  reader3853->definitionLine = 817;
}
adddatum2(obj3850, alloc_Undefined(), 2);
if (objclass3850 == NULL) {
  Method *reader3854 = addmethodrealflags(obj3850, "with",&reader_ast_with_3854, MFLAG_DEF);
  reader3854->definitionModule = modulename;
  reader3854->definitionLine = 818;
}
adddatum2(obj3850, alloc_Undefined(), 3);
if (objclass3850 == NULL) {
  Method *reader3855 = addmethodrealflags(obj3850, "generics",&reader_ast_generics_3855, 0);
  Method *writer3855 = addmethodrealflags(obj3850, "generics:=",&writer_ast_generics_3855, 0);
  reader3855->definitionModule = modulename;
  writer3855->definitionModule = modulename;
  reader3855->definitionLine = 819;
  writer3855->definitionLine = 819;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 4);
if (objclass3850 == NULL) {
  Method *reader3856 = addmethodrealflags(obj3850, "isPattern",&reader_ast_isPattern_3856, 0);
  Method *writer3856 = addmethodrealflags(obj3850, "isPattern:=",&writer_ast_isPattern_3856, 0);
  reader3856->definitionModule = modulename;
  writer3856->definitionModule = modulename;
  reader3856->definitionLine = 820;
  writer3856->definitionLine = 820;
}
obj3850->flags |= OFLAG_MUTABLE;
adddatum2(obj3850, alloc_Undefined(), 5);
  struct UserObject *uo3857 = (struct UserObject*)obj3850;
  uo3857->data[6] = emptyclosure;
  Method *meth_meth_ast_accept3857 = addmethod2pos(obj3850, "accept", &meth_ast_accept3857, 6);
int argcv_meth_ast_accept3857[] = {1};
meth_meth_ast_accept3857->type = alloc_MethodType(1, argcv_meth_ast_accept3857);
meth_meth_ast_accept3857->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept3857->type->names[0] = "visitor";
  meth_meth_ast_accept3857->definitionModule = modulename;
  meth_meth_ast_accept3857->definitionLine = 820;
  block_savedest(obj3850);
  Object closure3881 = createclosure(1, "map()before()after");
setclosureframe(closure3881, stackframe);
  addtoclosure(closure3881, var_callNode);
  struct UserObject *uo3881 = (struct UserObject*)obj3850;
  uo3881->data[7] = (Object)closure3881;
  Method *meth_meth_ast_map_40__41_before_40__41_after3881 = addmethod2pos(obj3850, "map()before()after", &meth_ast_map_40__41_before_40__41_after3881, 7);
int argcv_meth_ast_map_40__41_before_40__41_after3881[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after3881->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after3881);
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after3881->definitionLine = 830;
  struct UserObject *uo3928 = (struct UserObject*)obj3850;
  uo3928->data[8] = emptyclosure;
  Method *meth_meth_ast_map3928 = addmethod2pos(obj3850, "map", &meth_ast_map3928, 8);
int argcv_meth_ast_map3928[] = {1};
meth_meth_ast_map3928->type = alloc_MethodType(1, argcv_meth_ast_map3928);
  meth_meth_ast_map3928->definitionModule = modulename;
  meth_meth_ast_map3928->definitionLine = 843;
  struct UserObject *uo3937 = (struct UserObject*)obj3850;
  uo3937->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty3937 = addmethod2pos(obj3850, "pretty", &meth_ast_pretty3937, 9);
int argcv_meth_ast_pretty3937[] = {1};
meth_meth_ast_pretty3937->type = alloc_MethodType(1, argcv_meth_ast_pretty3937);
  meth_meth_ast_pretty3937->definitionModule = modulename;
  meth_meth_ast_pretty3937->definitionLine = 846;
  struct UserObject *uo4078 = (struct UserObject*)obj3850;
  uo4078->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace4078 = addmethod2pos(obj3850, "toGrace", &meth_ast_toGrace4078, 10);
int argcv_meth_ast_toGrace4078[] = {1};
meth_meth_ast_toGrace4078->type = alloc_MethodType(1, argcv_meth_ast_toGrace4078);
meth_meth_ast_toGrace4078->type->types[0] = type_Number;
meth_meth_ast_toGrace4078->type->names[0] = "depth";
  meth_meth_ast_toGrace4078->definitionModule = modulename;
  meth_meth_ast_toGrace4078->definitionLine = 869;
  sourceObject = obj3850;
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4216 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4217 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe4216);
// compilenode returning call4217
  struct UserObject *obj3850_uo = (struct UserObject *)obj3850;
  obj3850_uo->super = call4217;
  sourceObject = obj3850;
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4218 == NULL) {
    strlit4218 = alloc_String("call");
    gc_root(strlit4218);
  }
// compilenode returning strlit4218
  adddatum2(obj3850, strlit4218, 1);
  sourceObject = obj3850;
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj3850, *var_what, 2);
  sourceObject = obj3850;
// Begin line 817
  setline(817);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_with_39_
  adddatum2(obj3850, *var_with_39_, 3);
  sourceObject = obj3850;
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4219 = alloc_Boolean(0);
// compilenode returning bool4219
  adddatum2(obj3850, bool4219, 4);
  sourceObject = obj3850;
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4220 = alloc_Boolean(0);
// compilenode returning bool4220
  adddatum2(obj3850, bool4220, 5);
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
  sourceObject = obj3850;
objclass3850 = obj3850->class;
  objclass3850->definitionModule = modulename;
  objclass3850->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3850;
  self = oldself3850;
  selfslot = oldselfslot3850;
  stackframe = oldstackframe3850;
  gc_frame_end(frame);
  return obj3850;
}
Object meth_ast_classNode4222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "classNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for classNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for classNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_classNode
  gc_frame_end(frame);
  return *var_classNode;
}
Object meth_ast__apply4271(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4272 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4273 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe4272);
// compilenode returning call4273
  gc_frame_end(frame);
  return call4273;
}
Object meth_ast__apply4266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4267 = gc_frame_new();
  int callframe4268 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4269 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4268);
// compilenode returning call4269
// compilenode returning call4269
  gc_frame_newslot(call4269);
  Object block4270 = alloc_Block(NULL, NULL, "ast", 937);
  gc_frame_newslot(block4270);
  block_savedest(block4270);
  Object closure4271 = createclosure(2, "_apply");
setclosureframe(closure4271, stackframe);
  addtoclosure(closure4271, var_visitor);
  addtoclosure(closure4271, selfslot);
  struct UserObject *uo4271 = (struct UserObject*)block4270;
  uo4271->data[0] = (Object)closure4271;
  Method *meth_meth_ast__apply4271 = addmethod2pos(block4270, "_apply", &meth_ast__apply4271, 0);
int argcv_meth_ast__apply4271[] = {1};
meth_meth_ast__apply4271->type = alloc_MethodType(1, argcv_meth_ast__apply4271);
  meth_meth_ast__apply4271->definitionModule = modulename;
  meth_meth_ast__apply4271->definitionLine = 937;
// compilenode returning block4270
  gc_frame_newslot(block4270);
  params[0] = call4269;
  params[1] = block4270;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4275 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4267);
// compilenode returning call4275
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 940
  setline(940);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4278 = alloc_Boolean(0);
// compilenode returning bool4278
  int op_slot_right_4277 = gc_frame_newslot(bool4278);
  int callframe4280 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4281 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4280);
// compilenode returning call4281
// compilenode returning call4281
  int op_slot_left_4277 = gc_frame_newslot(call4281);
  params[0] = bool4278;
  partcv[0] = 1;
  Object opresult4282 = callmethod(call4281, "!=", 1, partcv, params);
// compilenode returning opresult4282
  Object if4276 = done;
  if (istrue(opresult4282)) {
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4283 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4284 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4285 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4284);
// compilenode returning call4285
// compilenode returning call4285
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4286 = callmethod(call4285, "accept",
    1, partcv, params);
  gc_frame_end(callframe4283);
// compilenode returning call4286
    gc_frame_newslot(call4286);
    if4276 = call4286;
  } else {
  }
// compilenode returning if4276
  gc_frame_end(frame);
  return if4276;
}
Object meth_ast__apply4293(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4294 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4295 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe4294);
// compilenode returning call4295
  gc_frame_end(frame);
  return call4295;
}
Object meth_ast_accept4239(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4241 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call4242 = callmethod(*var_visitor, "visitClass",
    1, partcv, params);
  gc_frame_end(callframe4241);
// compilenode returning call4242
  Object if4240 = done;
  if (istrue(call4242)) {
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4243 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4244 = gc_frame_new();
  partcv[0] = 0;
  Object call4245 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4244);
// compilenode returning call4245
// compilenode returning call4245
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4246 = callmethod(call4245, "accept",
    1, partcv, params);
  gc_frame_end(callframe4243);
// compilenode returning call4246
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4247 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4248 = gc_frame_new();
  partcv[0] = 0;
  Object call4249 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4248);
// compilenode returning call4249
// compilenode returning call4249
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4250 = callmethod(call4249, "accept",
    1, partcv, params);
  gc_frame_end(callframe4247);
// compilenode returning call4250
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4253 = alloc_Boolean(0);
// compilenode returning bool4253
  int op_slot_right_4252 = gc_frame_newslot(bool4253);
  int callframe4255 = gc_frame_new();
  partcv[0] = 0;
  Object call4256 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4255);
// compilenode returning call4256
// compilenode returning call4256
  int op_slot_left_4252 = gc_frame_newslot(call4256);
  params[0] = bool4253;
  partcv[0] = 1;
  Object opresult4257 = callmethod(call4256, "!=", 1, partcv, params);
// compilenode returning opresult4257
  Object if4251 = done;
  if (istrue(opresult4257)) {
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4258 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe4259 = gc_frame_new();
  partcv[0] = 0;
  Object call4260 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4259);
// compilenode returning call4260
// compilenode returning call4260
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call4261 = callmethod(call4260, "accept",
    1, partcv, params);
  gc_frame_end(callframe4258);
// compilenode returning call4261
    gc_frame_newslot(call4261);
    if4251 = call4261;
  } else {
  }
// compilenode returning if4251
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4262 = gc_frame_new();
  int callframe4263 = gc_frame_new();
  partcv[0] = 0;
  Object call4264 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4263);
// compilenode returning call4264
// compilenode returning call4264
  gc_frame_newslot(call4264);
  Object block4265 = alloc_Block(NULL, NULL, "ast", 936);
  gc_frame_newslot(block4265);
  block_savedest(block4265);
  Object closure4266 = createclosure(2, "_apply");
setclosureframe(closure4266, stackframe);
  addtoclosure(closure4266, var_visitor);
  addtoclosure(closure4266, selfslot);
  struct UserObject *uo4266 = (struct UserObject*)block4265;
  uo4266->data[0] = (Object)closure4266;
  Method *meth_meth_ast__apply4266 = addmethod2pos(block4265, "_apply", &meth_ast__apply4266, 0);
int argcv_meth_ast__apply4266[] = {1};
meth_meth_ast__apply4266->type = alloc_MethodType(1, argcv_meth_ast__apply4266);
  meth_meth_ast__apply4266->definitionModule = modulename;
  meth_meth_ast__apply4266->definitionLine = 936;
// compilenode returning block4265
  gc_frame_newslot(block4265);
  params[0] = call4264;
  params[1] = block4265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4288 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4262);
// compilenode returning call4288
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4289 = gc_frame_new();
  int callframe4290 = gc_frame_new();
  partcv[0] = 0;
  Object call4291 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4290);
// compilenode returning call4291
// compilenode returning call4291
  gc_frame_newslot(call4291);
  Object block4292 = alloc_Block(NULL, NULL, "ast", 944);
  gc_frame_newslot(block4292);
  block_savedest(block4292);
  Object closure4293 = createclosure(2, "_apply");
setclosureframe(closure4293, stackframe);
  addtoclosure(closure4293, var_visitor);
  addtoclosure(closure4293, selfslot);
  struct UserObject *uo4293 = (struct UserObject*)block4292;
  uo4293->data[0] = (Object)closure4293;
  Method *meth_meth_ast__apply4293 = addmethod2pos(block4292, "_apply", &meth_ast__apply4293, 0);
int argcv_meth_ast__apply4293[] = {1};
meth_meth_ast__apply4293->type = alloc_MethodType(1, argcv_meth_ast__apply4293);
  meth_meth_ast__apply4293->definitionModule = modulename;
  meth_meth_ast__apply4293->definitionLine = 944;
// compilenode returning block4292
  gc_frame_newslot(block4292);
  params[0] = call4291;
  params[1] = block4292;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4297 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4289);
// compilenode returning call4297
    gc_frame_newslot(call4297);
    if4240 = call4297;
  } else {
  }
// compilenode returning if4240
  gc_frame_end(frame);
  return if4240;
}
Object meth_ast__apply4345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4346 = gc_frame_new();
  int callframe4347 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4348 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe4347);
// compilenode returning call4348
  gc_frame_newslot(call4348);
  int callframe4349 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call4350 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe4349);
// compilenode returning call4350
// compilenode returning call4350
  params[0] = call4348;
  partcv[0] = 1;
  Object call4351 = callmethod(call4350, "push",
    1, partcv, params);
  gc_frame_end(callframe4346);
// compilenode returning call4351
  gc_frame_end(frame);
  return call4351;
}
Object meth_ast_map_40__41_before_40__41_after4298(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[6];
  int partcv[3];
  Object *var_classNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4299 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call4300 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe4299);
// compilenode returning call4300
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4301 = gc_frame_new();
  int callframe4302 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4303 = gc_frame_new();
  partcv[0] = 0;
  Object call4304 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4303);
// compilenode returning call4304
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4305 = callmethod(call4304, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe4302);
// compilenode returning call4305
  gc_frame_newslot(call4305);
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4306 = gc_frame_new();
  int callframe4307 = gc_frame_new();
  partcv[0] = 0;
  Object call4308 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4307);
// compilenode returning call4308
  gc_frame_newslot(call4308);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4309 = gc_frame_new();
  int callframe4310 = gc_frame_new();
  Object call4311 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4310);
// compilenode returning call4311
// compilenode returning call4311
  partcv[0] = 0;
  Object call4312 = callmethodflags(call4311, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4309);
// compilenode returning call4312
// compilenode returning call4312
  params[0] = call4308;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4313 = callmethodflags(call4312, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4306);
// compilenode returning call4313
  gc_frame_newslot(call4313);
  int callframe4314 = gc_frame_new();
  int callframe4315 = gc_frame_new();
  partcv[0] = 0;
  Object call4316 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4315);
// compilenode returning call4316
  gc_frame_newslot(call4316);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4317 = gc_frame_new();
  int callframe4318 = gc_frame_new();
  Object call4319 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4318);
// compilenode returning call4319
// compilenode returning call4319
  partcv[0] = 0;
  Object call4320 = callmethodflags(call4319, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4317);
// compilenode returning call4320
// compilenode returning call4320
  params[0] = call4316;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4321 = callmethodflags(call4320, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4314);
// compilenode returning call4321
  gc_frame_newslot(call4321);
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4322 = gc_frame_new();
  int callframe4323 = gc_frame_new();
  partcv[0] = 0;
  Object call4324 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4323);
// compilenode returning call4324
  gc_frame_newslot(call4324);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4325 = gc_frame_new();
  int callframe4326 = gc_frame_new();
  Object call4327 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4326);
// compilenode returning call4327
// compilenode returning call4327
  partcv[0] = 0;
  Object call4328 = callmethodflags(call4327, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4325);
// compilenode returning call4328
// compilenode returning call4328
  params[0] = call4324;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call4329 = callmethodflags(call4328, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4322);
// compilenode returning call4329
  gc_frame_newslot(call4329);
  int callframe4330 = gc_frame_new();
  partcv[0] = 0;
  Object call4331 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4330);
// compilenode returning call4331
  gc_frame_newslot(call4331);
  int callframe4332 = gc_frame_new();
  partcv[0] = 0;
  Object call4333 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4332);
// compilenode returning call4333
  gc_frame_newslot(call4333);
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_classNode
  params[0] = call4305;
  params[1] = call4313;
  params[2] = call4321;
  params[3] = call4329;
  params[4] = call4331;
  params[5] = call4333;
  partcv[0] = 6;
  Object call4334 = callmethod(*var_classNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4301);
// compilenode returning call4334
  *var_n = call4334;
  if (call4334 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4335 = gc_frame_new();
  int callframe4336 = gc_frame_new();
  int callframe4337 = gc_frame_new();
  partcv[0] = 0;
  Object call4338 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4337);
// compilenode returning call4338
  gc_frame_newslot(call4338);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe4339 = gc_frame_new();
  int callframe4340 = gc_frame_new();
  Object call4341 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4340);
// compilenode returning call4341
// compilenode returning call4341
  partcv[0] = 0;
  Object call4342 = callmethodflags(call4341, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4339);
// compilenode returning call4342
// compilenode returning call4342
  params[0] = call4338;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4343 = callmethodflags(call4342, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4336);
// compilenode returning call4343
  gc_frame_newslot(call4343);
  Object block4344 = alloc_Block(NULL, NULL, "ast", 954);
  gc_frame_newslot(block4344);
  block_savedest(block4344);
  Object closure4345 = createclosure(5, "_apply");
setclosureframe(closure4345, stackframe);
  addtoclosure(closure4345, var_blk);
  addtoclosure(closure4345, var_blkBefore);
  addtoclosure(closure4345, var_blkAfter);
  addtoclosure(closure4345, var_n);
  addtoclosure(closure4345, selfslot);
  struct UserObject *uo4345 = (struct UserObject*)block4344;
  uo4345->data[0] = (Object)closure4345;
  Method *meth_meth_ast__apply4345 = addmethod2pos(block4344, "_apply", &meth_ast__apply4345, 0);
int argcv_meth_ast__apply4345[] = {1};
meth_meth_ast__apply4345->type = alloc_MethodType(1, argcv_meth_ast__apply4345);
  meth_meth_ast__apply4345->definitionModule = modulename;
  meth_meth_ast__apply4345->definitionLine = 954;
// compilenode returning block4344
  gc_frame_newslot(block4344);
  params[0] = call4343;
  params[1] = block4344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4353 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4335);
// compilenode returning call4353
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4354 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4355 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe4354);
// compilenode returning call4355
  *var_n = call4355;
  if (call4355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4357 = gc_frame_new();
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4358 = gc_frame_new();
  partcv[0] = 0;
  Object call4359 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4358);
// compilenode returning call4359
  gc_frame_newslot(call4359);
// compilenode returning *var_n
  params[0] = call4359;
  partcv[0] = 1;
  Object call4360 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe4357);
// compilenode returning call4360
// compilenode returning done
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4361 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4362 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe4361);
// compilenode returning call4362
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply4366(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4369(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map4363(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4364 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block4365 = alloc_Block(NULL, NULL, "ast", 963);
  gc_frame_newslot(block4365);
  block_savedest(block4365);
  Object closure4366 = createclosure(1, "_apply");
setclosureframe(closure4366, stackframe);
  addtoclosure(closure4366, selfslot);
  struct UserObject *uo4366 = (struct UserObject*)block4365;
  uo4366->data[0] = (Object)closure4366;
  Method *meth_meth_ast__apply4366 = addmethod2pos(block4365, "_apply", &meth_ast__apply4366, 0);
int argcv_meth_ast__apply4366[] = {0};
meth_meth_ast__apply4366->type = alloc_MethodType(1, argcv_meth_ast__apply4366);
  meth_meth_ast__apply4366->definitionModule = modulename;
  meth_meth_ast__apply4366->definitionLine = 955;
// compilenode returning block4365
  gc_frame_newslot(block4365);
  Object block4368 = alloc_Block(NULL, NULL, "ast", 963);
  gc_frame_newslot(block4368);
  block_savedest(block4368);
  Object closure4369 = createclosure(1, "_apply");
setclosureframe(closure4369, stackframe);
  addtoclosure(closure4369, selfslot);
  struct UserObject *uo4369 = (struct UserObject*)block4368;
  uo4369->data[0] = (Object)closure4369;
  Method *meth_meth_ast__apply4369 = addmethod2pos(block4368, "_apply", &meth_ast__apply4369, 0);
int argcv_meth_ast__apply4369[] = {0};
meth_meth_ast__apply4369->type = alloc_MethodType(1, argcv_meth_ast__apply4369);
  meth_meth_ast__apply4369->definitionModule = modulename;
  meth_meth_ast__apply4369->definitionLine = 955;
// compilenode returning block4368
  gc_frame_newslot(block4368);
  params[0] = *var_blk;
  params[1] = block4365;
  params[2] = block4368;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4371 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4364);
// compilenode returning call4371
  gc_frame_end(frame);
  return call4371;
}
Object meth_ast__apply4380(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4382 == NULL) {
    strlit4382 = alloc_String("  ");
    gc_root(strlit4382);
  }
// compilenode returning strlit4382
  int op_slot_right_4381 = gc_frame_newslot(strlit4382);
// compilenode returning *var_spc
  int op_slot_left_4381 = gc_frame_newslot(*var_spc);
  params[0] = strlit4382;
  partcv[0] = 1;
  Object opresult4384 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4384
  *var_spc = opresult4384;
  if (opresult4384 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4582(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4584 == NULL) {
    strlit4584 = alloc_String("");
    gc_root(strlit4584);
  }
// compilenode returning strlit4584
  int op_slot_right_4583 = gc_frame_newslot(strlit4584);
  int callframe4587 = gc_frame_new();
  Object num4589 = alloc_Float64(4);
// compilenode returning num4589
  int op_slot_right_4588 = gc_frame_newslot(num4589);
// compilenode returning *var_depth
  int op_slot_left_4588 = gc_frame_newslot(*var_depth);
  params[0] = num4589;
  partcv[0] = 1;
  Object sum4591 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4591
  gc_frame_newslot(sum4591);
// compilenode returning *var_p
  params[0] = sum4591;
  partcv[0] = 1;
  Object call4592 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4587);
// compilenode returning call4592
  int op_slot_right_4586 = gc_frame_newslot(call4592);
  if (strlit4595 == NULL) {
    strlit4595 = alloc_String("");
    gc_root(strlit4595);
  }
// compilenode returning strlit4595
  int op_slot_right_4594 = gc_frame_newslot(strlit4595);
// compilenode returning *var_spc
  int op_slot_right_4597 = gc_frame_newslot(*var_spc);
  if (strlit4600 == NULL) {
    strlit4600 = alloc_String("""\x0a""      ");
    gc_root(strlit4600);
  }
// compilenode returning strlit4600
  int op_slot_right_4599 = gc_frame_newslot(strlit4600);
// compilenode returning *var_s
  int op_slot_right_4602 = gc_frame_newslot(*var_s);
  if (strlit4604 == NULL) {
    strlit4604 = alloc_String("");
    gc_root(strlit4604);
  }
// compilenode returning strlit4604
  int op_slot_left_4602 = gc_frame_newslot(strlit4604);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4605 = callmethod(strlit4604, "++", 1, partcv, params);
// compilenode returning opresult4605
  int op_slot_left_4599 = gc_frame_newslot(opresult4605);
  params[0] = strlit4600;
  partcv[0] = 1;
  Object opresult4606 = callmethod(opresult4605, "++", 1, partcv, params);
// compilenode returning opresult4606
  int op_slot_left_4597 = gc_frame_newslot(opresult4606);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4607 = callmethod(opresult4606, "++", 1, partcv, params);
// compilenode returning opresult4607
  int op_slot_left_4594 = gc_frame_newslot(opresult4607);
  params[0] = strlit4595;
  partcv[0] = 1;
  Object opresult4608 = callmethod(opresult4607, "++", 1, partcv, params);
// compilenode returning opresult4608
  int op_slot_left_4586 = gc_frame_newslot(opresult4608);
  params[0] = call4592;
  partcv[0] = 1;
  Object opresult4609 = callmethod(opresult4608, "++", 1, partcv, params);
// compilenode returning opresult4609
  int op_slot_left_4583 = gc_frame_newslot(opresult4609);
  params[0] = strlit4584;
  partcv[0] = 1;
  Object opresult4610 = callmethod(opresult4609, "++", 1, partcv, params);
// compilenode returning opresult4610
  *var_s = opresult4610;
  if (opresult4610 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4536(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object *var_depth = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4538 == NULL) {
    strlit4538 = alloc_String("");
    gc_root(strlit4538);
  }
// compilenode returning strlit4538
  int op_slot_right_4537 = gc_frame_newslot(strlit4538);
  int callframe4541 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4542 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4541);
// compilenode returning call4542
// compilenode returning call4542
  int op_slot_right_4540 = gc_frame_newslot(call4542);
  if (strlit4545 == NULL) {
    strlit4545 = alloc_String("Part: ");
    gc_root(strlit4545);
  }
// compilenode returning strlit4545
  int op_slot_right_4544 = gc_frame_newslot(strlit4545);
// compilenode returning *var_spc
  int op_slot_right_4547 = gc_frame_newslot(*var_spc);
  if (strlit4550 == NULL) {
    strlit4550 = alloc_String("""\x0a""  ");
    gc_root(strlit4550);
  }
// compilenode returning strlit4550
  int op_slot_right_4549 = gc_frame_newslot(strlit4550);
// compilenode returning *var_s
  int op_slot_right_4552 = gc_frame_newslot(*var_s);
  if (strlit4554 == NULL) {
    strlit4554 = alloc_String("");
    gc_root(strlit4554);
  }
// compilenode returning strlit4554
  int op_slot_left_4552 = gc_frame_newslot(strlit4554);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4555 = callmethod(strlit4554, "++", 1, partcv, params);
// compilenode returning opresult4555
  int op_slot_left_4549 = gc_frame_newslot(opresult4555);
  params[0] = strlit4550;
  partcv[0] = 1;
  Object opresult4556 = callmethod(opresult4555, "++", 1, partcv, params);
// compilenode returning opresult4556
  int op_slot_left_4547 = gc_frame_newslot(opresult4556);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4557 = callmethod(opresult4556, "++", 1, partcv, params);
// compilenode returning opresult4557
  int op_slot_left_4544 = gc_frame_newslot(opresult4557);
  params[0] = strlit4545;
  partcv[0] = 1;
  Object opresult4558 = callmethod(opresult4557, "++", 1, partcv, params);
// compilenode returning opresult4558
  int op_slot_left_4540 = gc_frame_newslot(opresult4558);
  params[0] = call4542;
  partcv[0] = 1;
  Object opresult4559 = callmethod(opresult4558, "++", 1, partcv, params);
// compilenode returning opresult4559
  int op_slot_left_4537 = gc_frame_newslot(opresult4559);
  params[0] = strlit4538;
  partcv[0] = 1;
  Object opresult4560 = callmethod(opresult4559, "++", 1, partcv, params);
// compilenode returning opresult4560
  *var_s = opresult4560;
  if (opresult4560 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4563 == NULL) {
    strlit4563 = alloc_String("Parameters:");
    gc_root(strlit4563);
  }
// compilenode returning strlit4563
  int op_slot_right_4562 = gc_frame_newslot(strlit4563);
// compilenode returning *var_spc
  int op_slot_right_4565 = gc_frame_newslot(*var_spc);
  if (strlit4568 == NULL) {
    strlit4568 = alloc_String("""\x0a""    ");
    gc_root(strlit4568);
  }
// compilenode returning strlit4568
  int op_slot_right_4567 = gc_frame_newslot(strlit4568);
// compilenode returning *var_s
  int op_slot_right_4570 = gc_frame_newslot(*var_s);
  if (strlit4572 == NULL) {
    strlit4572 = alloc_String("");
    gc_root(strlit4572);
  }
// compilenode returning strlit4572
  int op_slot_left_4570 = gc_frame_newslot(strlit4572);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4573 = callmethod(strlit4572, "++", 1, partcv, params);
// compilenode returning opresult4573
  int op_slot_left_4567 = gc_frame_newslot(opresult4573);
  params[0] = strlit4568;
  partcv[0] = 1;
  Object opresult4574 = callmethod(opresult4573, "++", 1, partcv, params);
// compilenode returning opresult4574
  int op_slot_left_4565 = gc_frame_newslot(opresult4574);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4575 = callmethod(opresult4574, "++", 1, partcv, params);
// compilenode returning opresult4575
  int op_slot_left_4562 = gc_frame_newslot(opresult4575);
  params[0] = strlit4563;
  partcv[0] = 1;
  Object opresult4576 = callmethod(opresult4575, "++", 1, partcv, params);
// compilenode returning opresult4576
  *var_s = opresult4576;
  if (opresult4576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4578 = gc_frame_new();
  int callframe4579 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4580 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4579);
// compilenode returning call4580
// compilenode returning call4580
  gc_frame_newslot(call4580);
  Object block4581 = alloc_Block(NULL, NULL, "ast", 984);
  gc_frame_newslot(block4581);
  block_savedest(block4581);
  Object closure4582 = createclosure(4, "_apply");
setclosureframe(closure4582, stackframe);
  addtoclosure(closure4582, var_depth);
  addtoclosure(closure4582, var_spc);
  addtoclosure(closure4582, var_s);
  addtoclosure(closure4582, selfslot);
  struct UserObject *uo4582 = (struct UserObject*)block4581;
  uo4582->data[0] = (Object)closure4582;
  Method *meth_meth_ast__apply4582 = addmethod2pos(block4581, "_apply", &meth_ast__apply4582, 0);
int argcv_meth_ast__apply4582[] = {1};
meth_meth_ast__apply4582->type = alloc_MethodType(1, argcv_meth_ast__apply4582);
  meth_meth_ast__apply4582->definitionModule = modulename;
  meth_meth_ast__apply4582->definitionLine = 984;
// compilenode returning block4581
  gc_frame_newslot(block4581);
  params[0] = call4580;
  params[1] = block4581;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4613 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4578);
// compilenode returning call4613
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4616 = alloc_Boolean(0);
// compilenode returning bool4616
  int op_slot_right_4615 = gc_frame_newslot(bool4616);
  int callframe4618 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4619 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4618);
// compilenode returning call4619
// compilenode returning call4619
  int op_slot_left_4615 = gc_frame_newslot(call4619);
  params[0] = bool4616;
  partcv[0] = 1;
  Object opresult4620 = callmethod(call4619, "!=", 1, partcv, params);
// compilenode returning opresult4620
  Object if4614 = done;
  if (istrue(opresult4620)) {
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4622 == NULL) {
    strlit4622 = alloc_String("");
    gc_root(strlit4622);
  }
// compilenode returning strlit4622
  int op_slot_right_4621 = gc_frame_newslot(strlit4622);
  int callframe4625 = gc_frame_new();
  Object num4627 = alloc_Float64(3);
// compilenode returning num4627
  int op_slot_right_4626 = gc_frame_newslot(num4627);
// compilenode returning *var_depth
  int op_slot_left_4626 = gc_frame_newslot(*var_depth);
  params[0] = num4627;
  partcv[0] = 1;
  Object sum4629 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4629
  gc_frame_newslot(sum4629);
  int callframe4630 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4631 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4630);
// compilenode returning call4631
// compilenode returning call4631
  params[0] = sum4629;
  partcv[0] = 1;
  Object call4632 = callmethod(call4631, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4625);
// compilenode returning call4632
  int op_slot_right_4624 = gc_frame_newslot(call4632);
  if (strlit4635 == NULL) {
    strlit4635 = alloc_String("Vararg: ");
    gc_root(strlit4635);
  }
// compilenode returning strlit4635
  int op_slot_right_4634 = gc_frame_newslot(strlit4635);
// compilenode returning *var_spc
  int op_slot_right_4637 = gc_frame_newslot(*var_spc);
  if (strlit4640 == NULL) {
    strlit4640 = alloc_String("""\x0a""    ");
    gc_root(strlit4640);
  }
// compilenode returning strlit4640
  int op_slot_right_4639 = gc_frame_newslot(strlit4640);
// compilenode returning *var_s
  int op_slot_right_4642 = gc_frame_newslot(*var_s);
  if (strlit4644 == NULL) {
    strlit4644 = alloc_String("");
    gc_root(strlit4644);
  }
// compilenode returning strlit4644
  int op_slot_left_4642 = gc_frame_newslot(strlit4644);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4645 = callmethod(strlit4644, "++", 1, partcv, params);
// compilenode returning opresult4645
  int op_slot_left_4639 = gc_frame_newslot(opresult4645);
  params[0] = strlit4640;
  partcv[0] = 1;
  Object opresult4646 = callmethod(opresult4645, "++", 1, partcv, params);
// compilenode returning opresult4646
  int op_slot_left_4637 = gc_frame_newslot(opresult4646);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4647 = callmethod(opresult4646, "++", 1, partcv, params);
// compilenode returning opresult4647
  int op_slot_left_4634 = gc_frame_newslot(opresult4647);
  params[0] = strlit4635;
  partcv[0] = 1;
  Object opresult4648 = callmethod(opresult4647, "++", 1, partcv, params);
// compilenode returning opresult4648
  int op_slot_left_4624 = gc_frame_newslot(opresult4648);
  params[0] = call4632;
  partcv[0] = 1;
  Object opresult4649 = callmethod(opresult4648, "++", 1, partcv, params);
// compilenode returning opresult4649
  int op_slot_left_4621 = gc_frame_newslot(opresult4649);
  params[0] = strlit4622;
  partcv[0] = 1;
  Object opresult4650 = callmethod(opresult4649, "++", 1, partcv, params);
// compilenode returning opresult4650
  *var_s = opresult4650;
  if (opresult4650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4614 = done;
  } else {
  }
// compilenode returning if4614
  gc_frame_end(frame);
  return if4614;
}
Object meth_ast__apply4677(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object *var_s = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_g = &(stackframe->slots[0]);
  *var_g = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4680 == NULL) {
    strlit4680 = alloc_String("");
    gc_root(strlit4680);
  }
// compilenode returning strlit4680
  int op_slot_right_4679 = gc_frame_newslot(strlit4680);
  int callframe4683 = gc_frame_new();
  Object num4684 = alloc_Float64(0);
// compilenode returning num4684
  gc_frame_newslot(num4684);
// compilenode returning *var_g
  params[0] = num4684;
  partcv[0] = 1;
  Object call4685 = callmethod(*var_g, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4683);
// compilenode returning call4685
  int op_slot_right_4682 = gc_frame_newslot(call4685);
  if (strlit4688 == NULL) {
    strlit4688 = alloc_String("");
    gc_root(strlit4688);
  }
// compilenode returning strlit4688
  int op_slot_right_4687 = gc_frame_newslot(strlit4688);
// compilenode returning *var_spc
  int op_slot_right_4690 = gc_frame_newslot(*var_spc);
  if (strlit4692 == NULL) {
    strlit4692 = alloc_String("""\x0a""  ");
    gc_root(strlit4692);
  }
// compilenode returning strlit4692
  int op_slot_left_4690 = gc_frame_newslot(strlit4692);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4693 = callmethod(strlit4692, "++", 1, partcv, params);
// compilenode returning opresult4693
  int op_slot_left_4687 = gc_frame_newslot(opresult4693);
  params[0] = strlit4688;
  partcv[0] = 1;
  Object opresult4694 = callmethod(opresult4693, "++", 1, partcv, params);
// compilenode returning opresult4694
  int op_slot_left_4682 = gc_frame_newslot(opresult4694);
  params[0] = call4685;
  partcv[0] = 1;
  Object opresult4695 = callmethod(opresult4694, "++", 1, partcv, params);
// compilenode returning opresult4695
  int op_slot_left_4679 = gc_frame_newslot(opresult4695);
  params[0] = strlit4680;
  partcv[0] = 1;
  Object opresult4696 = callmethod(opresult4695, "++", 1, partcv, params);
// compilenode returning opresult4696
  int op_slot_right_4678 = gc_frame_newslot(opresult4696);
// compilenode returning *var_s
  int op_slot_left_4678 = gc_frame_newslot(*var_s);
  params[0] = opresult4696;
  partcv[0] = 1;
  Object opresult4698 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4698
  *var_s = opresult4698;
  if (opresult4698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4730 == NULL) {
    strlit4730 = alloc_String("");
    gc_root(strlit4730);
  }
// compilenode returning strlit4730
  int op_slot_right_4729 = gc_frame_newslot(strlit4730);
  int callframe4733 = gc_frame_new();
  Object num4735 = alloc_Float64(2);
// compilenode returning num4735
  int op_slot_right_4734 = gc_frame_newslot(num4735);
// compilenode returning *var_depth
  int op_slot_left_4734 = gc_frame_newslot(*var_depth);
  params[0] = num4735;
  partcv[0] = 1;
  Object sum4737 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4737
  gc_frame_newslot(sum4737);
// compilenode returning *var_a
  params[0] = sum4737;
  partcv[0] = 1;
  Object call4738 = callmethod(*var_a, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compilenode returning call4738
  int op_slot_right_4732 = gc_frame_newslot(call4738);
  if (strlit4741 == NULL) {
    strlit4741 = alloc_String("");
    gc_root(strlit4741);
  }
// compilenode returning strlit4741
  int op_slot_right_4740 = gc_frame_newslot(strlit4741);
// compilenode returning *var_spc
  int op_slot_right_4743 = gc_frame_newslot(*var_spc);
  if (strlit4745 == NULL) {
    strlit4745 = alloc_String("""\x0a""  ");
    gc_root(strlit4745);
  }
// compilenode returning strlit4745
  int op_slot_left_4743 = gc_frame_newslot(strlit4745);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4746 = callmethod(strlit4745, "++", 1, partcv, params);
// compilenode returning opresult4746
  int op_slot_left_4740 = gc_frame_newslot(opresult4746);
  params[0] = strlit4741;
  partcv[0] = 1;
  Object opresult4747 = callmethod(opresult4746, "++", 1, partcv, params);
// compilenode returning opresult4747
  int op_slot_left_4732 = gc_frame_newslot(opresult4747);
  params[0] = call4738;
  partcv[0] = 1;
  Object opresult4748 = callmethod(opresult4747, "++", 1, partcv, params);
// compilenode returning opresult4748
  int op_slot_left_4729 = gc_frame_newslot(opresult4748);
  params[0] = strlit4730;
  partcv[0] = 1;
  Object opresult4749 = callmethod(opresult4748, "++", 1, partcv, params);
// compilenode returning opresult4749
  int op_slot_right_4728 = gc_frame_newslot(opresult4749);
// compilenode returning *var_s
  int op_slot_left_4728 = gc_frame_newslot(*var_s);
  params[0] = opresult4749;
  partcv[0] = 1;
  Object opresult4751 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4751
  *var_s = opresult4751;
  if (opresult4751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4771(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4773 = gc_frame_new();
  Object num4775 = alloc_Float64(2);
// compilenode returning num4775
  int op_slot_right_4774 = gc_frame_newslot(num4775);
// compilenode returning *var_depth
  int op_slot_left_4774 = gc_frame_newslot(*var_depth);
  params[0] = num4775;
  partcv[0] = 1;
  Object sum4777 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4777
  gc_frame_newslot(sum4777);
// compilenode returning *var_x
  params[0] = sum4777;
  partcv[0] = 1;
  Object call4778 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4773);
// compilenode returning call4778
  int op_slot_right_4772 = gc_frame_newslot(call4778);
// compilenode returning *var_spc
  int op_slot_right_4780 = gc_frame_newslot(*var_spc);
  if (strlit4783 == NULL) {
    strlit4783 = alloc_String("""\x0a""  ");
    gc_root(strlit4783);
  }
// compilenode returning strlit4783
  int op_slot_right_4782 = gc_frame_newslot(strlit4783);
// compilenode returning *var_s
  int op_slot_left_4782 = gc_frame_newslot(*var_s);
  params[0] = strlit4783;
  partcv[0] = 1;
  Object opresult4785 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4785
  int op_slot_left_4780 = gc_frame_newslot(opresult4785);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4786 = callmethod(opresult4785, "++", 1, partcv, params);
// compilenode returning opresult4786
  int op_slot_left_4772 = gc_frame_newslot(opresult4786);
  params[0] = call4778;
  partcv[0] = 1;
  Object opresult4787 = callmethod(opresult4786, "++", 1, partcv, params);
// compilenode returning opresult4787
  *var_s = opresult4787;
  if (opresult4787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty4372(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4373 == NULL) {
    strlit4373 = alloc_String("");
    gc_root(strlit4373);
  }
// compilenode returning strlit4373
  *var_spc = strlit4373;
  if (strlit4373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4374 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_4375 = gc_frame_newslot(*var_depth);
  Object num4377 = alloc_Float64(0);
// compilenode returning num4377
  int op_slot_left_4375 = gc_frame_newslot(num4377);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult4378 = callmethod(num4377, "..", 1, partcv, params);
// compilenode returning opresult4378
  gc_frame_newslot(opresult4378);
  Object block4379 = alloc_Block(NULL, NULL, "ast", 967);
  gc_frame_newslot(block4379);
  block_savedest(block4379);
  Object closure4380 = createclosure(2, "_apply");
setclosureframe(closure4380, stackframe);
  addtoclosure(closure4380, var_spc);
  addtoclosure(closure4380, selfslot);
  struct UserObject *uo4380 = (struct UserObject*)block4379;
  uo4380->data[0] = (Object)closure4380;
  Method *meth_meth_ast__apply4380 = addmethod2pos(block4379, "_apply", &meth_ast__apply4380, 0);
int argcv_meth_ast__apply4380[] = {1};
meth_meth_ast__apply4380->type = alloc_MethodType(1, argcv_meth_ast__apply4380);
  meth_meth_ast__apply4380->definitionModule = modulename;
  meth_meth_ast__apply4380->definitionLine = 955;
// compilenode returning block4379
  gc_frame_newslot(block4379);
  params[0] = opresult4378;
  params[1] = block4379;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4387 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4374);
// compilenode returning call4387
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4389 == NULL) {
    strlit4389 = alloc_String(")");
    gc_root(strlit4389);
  }
// compilenode returning strlit4389
  int op_slot_right_4388 = gc_frame_newslot(strlit4389);
  int callframe4392 = gc_frame_new();
  Object num4393 = alloc_Float64(0);
// compilenode returning num4393
  gc_frame_newslot(num4393);
  int callframe4394 = gc_frame_new();
  partcv[0] = 0;
  Object call4395 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compilenode returning call4395
// compilenode returning call4395
  params[0] = num4393;
  partcv[0] = 1;
  Object call4396 = callmethod(call4395, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4392);
// compilenode returning call4396
  int op_slot_right_4391 = gc_frame_newslot(call4396);
  if (strlit4398 == NULL) {
    strlit4398 = alloc_String("Class(");
    gc_root(strlit4398);
  }
// compilenode returning strlit4398
  int op_slot_left_4391 = gc_frame_newslot(strlit4398);
  params[0] = call4396;
  partcv[0] = 1;
  Object opresult4399 = callmethod(strlit4398, "++", 1, partcv, params);
// compilenode returning opresult4399
  int op_slot_left_4388 = gc_frame_newslot(opresult4399);
  params[0] = strlit4389;
  partcv[0] = 1;
  Object opresult4400 = callmethod(opresult4399, "++", 1, partcv, params);
// compilenode returning opresult4400
  *var_s = opresult4400;
  if (opresult4400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4403 = alloc_Boolean(0);
// compilenode returning bool4403
  int op_slot_right_4402 = gc_frame_newslot(bool4403);
  int callframe4405 = gc_frame_new();
  partcv[0] = 0;
  Object call4406 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4405);
// compilenode returning call4406
// compilenode returning call4406
  int op_slot_left_4402 = gc_frame_newslot(call4406);
  params[0] = bool4403;
  partcv[0] = 1;
  Object opresult4407 = callmethod(call4406, "!=", 1, partcv, params);
// compilenode returning opresult4407
  Object if4401 = done;
  if (istrue(opresult4407)) {
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4409 == NULL) {
    strlit4409 = alloc_String("Superclass:");
    gc_root(strlit4409);
  }
// compilenode returning strlit4409
  int op_slot_right_4408 = gc_frame_newslot(strlit4409);
// compilenode returning *var_spc
  int op_slot_right_4411 = gc_frame_newslot(*var_spc);
  if (strlit4414 == NULL) {
    strlit4414 = alloc_String("""\x0a""");
    gc_root(strlit4414);
  }
// compilenode returning strlit4414
  int op_slot_right_4413 = gc_frame_newslot(strlit4414);
// compilenode returning *var_s
  int op_slot_left_4413 = gc_frame_newslot(*var_s);
  params[0] = strlit4414;
  partcv[0] = 1;
  Object opresult4416 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4416
  int op_slot_left_4411 = gc_frame_newslot(opresult4416);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4417 = callmethod(opresult4416, "++", 1, partcv, params);
// compilenode returning opresult4417
  int op_slot_left_4408 = gc_frame_newslot(opresult4417);
  params[0] = strlit4409;
  partcv[0] = 1;
  Object opresult4418 = callmethod(opresult4417, "++", 1, partcv, params);
// compilenode returning opresult4418
  *var_s = opresult4418;
  if (opresult4418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4421 = gc_frame_new();
  Object num4423 = alloc_Float64(2);
// compilenode returning num4423
  int op_slot_right_4422 = gc_frame_newslot(num4423);
// compilenode returning *var_depth
  int op_slot_left_4422 = gc_frame_newslot(*var_depth);
  params[0] = num4423;
  partcv[0] = 1;
  Object sum4425 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4425
  gc_frame_newslot(sum4425);
  int callframe4426 = gc_frame_new();
  partcv[0] = 0;
  Object call4427 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4426);
// compilenode returning call4427
// compilenode returning call4427
  params[0] = sum4425;
  partcv[0] = 1;
  Object call4428 = callmethod(call4427, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4421);
// compilenode returning call4428
  int op_slot_right_4420 = gc_frame_newslot(call4428);
// compilenode returning *var_spc
  int op_slot_right_4430 = gc_frame_newslot(*var_spc);
  if (strlit4433 == NULL) {
    strlit4433 = alloc_String("""\x0a""  ");
    gc_root(strlit4433);
  }
// compilenode returning strlit4433
  int op_slot_right_4432 = gc_frame_newslot(strlit4433);
// compilenode returning *var_s
  int op_slot_left_4432 = gc_frame_newslot(*var_s);
  params[0] = strlit4433;
  partcv[0] = 1;
  Object opresult4435 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4435
  int op_slot_left_4430 = gc_frame_newslot(opresult4435);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4436 = callmethod(opresult4435, "++", 1, partcv, params);
// compilenode returning opresult4436
  int op_slot_left_4420 = gc_frame_newslot(opresult4436);
  params[0] = call4428;
  partcv[0] = 1;
  Object opresult4437 = callmethod(opresult4436, "++", 1, partcv, params);
// compilenode returning opresult4437
  *var_s = opresult4437;
  if (opresult4437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4401 = done;
  } else {
  }
// compilenode returning if4401
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4440 == NULL) {
    strlit4440 = alloc_String("""\x0a""");
    gc_root(strlit4440);
  }
// compilenode returning strlit4440
  int op_slot_right_4439 = gc_frame_newslot(strlit4440);
// compilenode returning *var_s
  int op_slot_left_4439 = gc_frame_newslot(*var_s);
  params[0] = strlit4440;
  partcv[0] = 1;
  Object opresult4442 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4442
  *var_s = opresult4442;
  if (opresult4442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4445 == NULL) {
    strlit4445 = alloc_String("""\x0a""");
    gc_root(strlit4445);
  }
// compilenode returning strlit4445
  int op_slot_right_4444 = gc_frame_newslot(strlit4445);
  int callframe4448 = gc_frame_new();
  int callframe4449 = gc_frame_new();
  partcv[0] = 0;
  Object call4450 = callmethodflags(self, "constructor", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4449);
// compilenode returning call4450
  partcv[0] = 0;
  Object call4451 = callmethod(call4450, "value",
    1, partcv, params);
  gc_frame_end(callframe4448);
// compilenode returning call4451
// compilenode returning call4451
  int op_slot_right_4447 = gc_frame_newslot(call4451);
  if (strlit4454 == NULL) {
    strlit4454 = alloc_String("Constructor: ");
    gc_root(strlit4454);
  }
// compilenode returning strlit4454
  int op_slot_right_4453 = gc_frame_newslot(strlit4454);
// compilenode returning *var_spc
  int op_slot_right_4456 = gc_frame_newslot(*var_spc);
  if (strlit4459 == NULL) {
    strlit4459 = alloc_String("");
    gc_root(strlit4459);
  }
// compilenode returning strlit4459
  int op_slot_right_4458 = gc_frame_newslot(strlit4459);
// compilenode returning *var_s
  int op_slot_right_4461 = gc_frame_newslot(*var_s);
  if (strlit4463 == NULL) {
    strlit4463 = alloc_String("");
    gc_root(strlit4463);
  }
// compilenode returning strlit4463
  int op_slot_left_4461 = gc_frame_newslot(strlit4463);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4464 = callmethod(strlit4463, "++", 1, partcv, params);
// compilenode returning opresult4464
  int op_slot_left_4458 = gc_frame_newslot(opresult4464);
  params[0] = strlit4459;
  partcv[0] = 1;
  Object opresult4465 = callmethod(opresult4464, "++", 1, partcv, params);
// compilenode returning opresult4465
  int op_slot_left_4456 = gc_frame_newslot(opresult4465);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4466 = callmethod(opresult4465, "++", 1, partcv, params);
// compilenode returning opresult4466
  int op_slot_left_4453 = gc_frame_newslot(opresult4466);
  params[0] = strlit4454;
  partcv[0] = 1;
  Object opresult4467 = callmethod(opresult4466, "++", 1, partcv, params);
// compilenode returning opresult4467
  int op_slot_left_4447 = gc_frame_newslot(opresult4467);
  params[0] = call4451;
  partcv[0] = 1;
  Object opresult4468 = callmethod(opresult4467, "++", 1, partcv, params);
// compilenode returning opresult4468
  int op_slot_left_4444 = gc_frame_newslot(opresult4468);
  params[0] = strlit4445;
  partcv[0] = 1;
  Object opresult4469 = callmethod(opresult4468, "++", 1, partcv, params);
// compilenode returning opresult4469
  *var_s = opresult4469;
  if (opresult4469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4473 = gc_frame_new();
  partcv[0] = 0;
  Object call4474 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4473);
// compilenode returning call4474
  int op_slot_right_4472 = gc_frame_newslot(call4474);
  Object bool4476 = alloc_Boolean(0);
// compilenode returning bool4476
  int op_slot_left_4472 = gc_frame_newslot(bool4476);
  params[0] = call4474;
  partcv[0] = 1;
  Object opresult4477 = callmethod(bool4476, "!=", 1, partcv, params);
// compilenode returning opresult4477
  Object if4471 = done;
  if (istrue(opresult4477)) {
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4479 == NULL) {
    strlit4479 = alloc_String("""\x0a""");
    gc_root(strlit4479);
  }
// compilenode returning strlit4479
  int op_slot_right_4478 = gc_frame_newslot(strlit4479);
  int callframe4482 = gc_frame_new();
  Object num4484 = alloc_Float64(2);
// compilenode returning num4484
  int op_slot_right_4483 = gc_frame_newslot(num4484);
// compilenode returning *var_depth
  int op_slot_left_4483 = gc_frame_newslot(*var_depth);
  params[0] = num4484;
  partcv[0] = 1;
  Object sum4486 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4486
  gc_frame_newslot(sum4486);
  int callframe4487 = gc_frame_new();
  partcv[0] = 0;
  Object call4488 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4487);
// compilenode returning call4488
  params[0] = sum4486;
  partcv[0] = 1;
  Object call4489 = callmethod(call4488, "pretty",
    1, partcv, params);
  gc_frame_end(callframe4482);
// compilenode returning call4489
  int op_slot_right_4481 = gc_frame_newslot(call4489);
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String("");
    gc_root(strlit4492);
  }
// compilenode returning strlit4492
  int op_slot_right_4491 = gc_frame_newslot(strlit4492);
// compilenode returning *var_spc
  int op_slot_right_4494 = gc_frame_newslot(*var_spc);
  if (strlit4497 == NULL) {
    strlit4497 = alloc_String("Returns:""\x0a""  ");
    gc_root(strlit4497);
  }
// compilenode returning strlit4497
  int op_slot_right_4496 = gc_frame_newslot(strlit4497);
// compilenode returning *var_spc
  int op_slot_right_4499 = gc_frame_newslot(*var_spc);
  if (strlit4502 == NULL) {
    strlit4502 = alloc_String("");
    gc_root(strlit4502);
  }
// compilenode returning strlit4502
  int op_slot_right_4501 = gc_frame_newslot(strlit4502);
// compilenode returning *var_s
  int op_slot_right_4504 = gc_frame_newslot(*var_s);
  if (strlit4506 == NULL) {
    strlit4506 = alloc_String("");
    gc_root(strlit4506);
  }
// compilenode returning strlit4506
  int op_slot_left_4504 = gc_frame_newslot(strlit4506);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4507 = callmethod(strlit4506, "++", 1, partcv, params);
// compilenode returning opresult4507
  int op_slot_left_4501 = gc_frame_newslot(opresult4507);
  params[0] = strlit4502;
  partcv[0] = 1;
  Object opresult4508 = callmethod(opresult4507, "++", 1, partcv, params);
// compilenode returning opresult4508
  int op_slot_left_4499 = gc_frame_newslot(opresult4508);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4509 = callmethod(opresult4508, "++", 1, partcv, params);
// compilenode returning opresult4509
  int op_slot_left_4496 = gc_frame_newslot(opresult4509);
  params[0] = strlit4497;
  partcv[0] = 1;
  Object opresult4510 = callmethod(opresult4509, "++", 1, partcv, params);
// compilenode returning opresult4510
  int op_slot_left_4494 = gc_frame_newslot(opresult4510);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4511 = callmethod(opresult4510, "++", 1, partcv, params);
// compilenode returning opresult4511
  int op_slot_left_4491 = gc_frame_newslot(opresult4511);
  params[0] = strlit4492;
  partcv[0] = 1;
  Object opresult4512 = callmethod(opresult4511, "++", 1, partcv, params);
// compilenode returning opresult4512
  int op_slot_left_4481 = gc_frame_newslot(opresult4512);
  params[0] = call4489;
  partcv[0] = 1;
  Object opresult4513 = callmethod(opresult4512, "++", 1, partcv, params);
// compilenode returning opresult4513
  int op_slot_left_4478 = gc_frame_newslot(opresult4513);
  params[0] = strlit4479;
  partcv[0] = 1;
  Object opresult4514 = callmethod(opresult4513, "++", 1, partcv, params);
// compilenode returning opresult4514
  *var_s = opresult4514;
  if (opresult4514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4471 = done;
  } else {
  }
// compilenode returning if4471
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4517 == NULL) {
    strlit4517 = alloc_String("Signature:");
    gc_root(strlit4517);
  }
// compilenode returning strlit4517
  int op_slot_right_4516 = gc_frame_newslot(strlit4517);
// compilenode returning *var_spc
  int op_slot_right_4519 = gc_frame_newslot(*var_spc);
  if (strlit4522 == NULL) {
    strlit4522 = alloc_String("");
    gc_root(strlit4522);
  }
// compilenode returning strlit4522
  int op_slot_right_4521 = gc_frame_newslot(strlit4522);
// compilenode returning *var_s
  int op_slot_right_4524 = gc_frame_newslot(*var_s);
  if (strlit4526 == NULL) {
    strlit4526 = alloc_String("");
    gc_root(strlit4526);
  }
// compilenode returning strlit4526
  int op_slot_left_4524 = gc_frame_newslot(strlit4526);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4527 = callmethod(strlit4526, "++", 1, partcv, params);
// compilenode returning opresult4527
  int op_slot_left_4521 = gc_frame_newslot(opresult4527);
  params[0] = strlit4522;
  partcv[0] = 1;
  Object opresult4528 = callmethod(opresult4527, "++", 1, partcv, params);
// compilenode returning opresult4528
  int op_slot_left_4519 = gc_frame_newslot(opresult4528);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4529 = callmethod(opresult4528, "++", 1, partcv, params);
// compilenode returning opresult4529
  int op_slot_left_4516 = gc_frame_newslot(opresult4529);
  params[0] = strlit4517;
  partcv[0] = 1;
  Object opresult4530 = callmethod(opresult4529, "++", 1, partcv, params);
// compilenode returning opresult4530
  *var_s = opresult4530;
  if (opresult4530 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4532 = gc_frame_new();
  int callframe4533 = gc_frame_new();
  partcv[0] = 0;
  Object call4534 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4533);
// compilenode returning call4534
  gc_frame_newslot(call4534);
  Object block4535 = alloc_Block(NULL, NULL, "ast", 981);
  gc_frame_newslot(block4535);
  block_savedest(block4535);
  Object closure4536 = createclosure(4, "_apply");
setclosureframe(closure4536, stackframe);
  addtoclosure(closure4536, var_spc);
  addtoclosure(closure4536, var_s);
  addtoclosure(closure4536, var_depth);
  addtoclosure(closure4536, selfslot);
  struct UserObject *uo4536 = (struct UserObject*)block4535;
  uo4536->data[0] = (Object)closure4536;
  Method *meth_meth_ast__apply4536 = addmethod2pos(block4535, "_apply", &meth_ast__apply4536, 0);
int argcv_meth_ast__apply4536[] = {1};
meth_meth_ast__apply4536->type = alloc_MethodType(1, argcv_meth_ast__apply4536);
  meth_meth_ast__apply4536->definitionModule = modulename;
  meth_meth_ast__apply4536->definitionLine = 976;
// compilenode returning block4535
  gc_frame_newslot(block4535);
  params[0] = call4534;
  params[1] = block4535;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4653 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4532);
// compilenode returning call4653
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4656 = gc_frame_new();
  partcv[0] = 0;
  Object call4657 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4656);
// compilenode returning call4657
  int op_slot_right_4655 = gc_frame_newslot(call4657);
  Object bool4659 = alloc_Boolean(0);
// compilenode returning bool4659
  int op_slot_left_4655 = gc_frame_newslot(bool4659);
  params[0] = call4657;
  partcv[0] = 1;
  Object opresult4660 = callmethod(bool4659, "!=", 1, partcv, params);
// compilenode returning opresult4660
  Object if4654 = done;
  if (istrue(opresult4660)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4662 == NULL) {
    strlit4662 = alloc_String("Generics:");
    gc_root(strlit4662);
  }
// compilenode returning strlit4662
  int op_slot_right_4661 = gc_frame_newslot(strlit4662);
// compilenode returning *var_spc
  int op_slot_right_4664 = gc_frame_newslot(*var_spc);
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("""\x0a""");
    gc_root(strlit4667);
  }
// compilenode returning strlit4667
  int op_slot_right_4666 = gc_frame_newslot(strlit4667);
// compilenode returning *var_s
  int op_slot_left_4666 = gc_frame_newslot(*var_s);
  params[0] = strlit4667;
  partcv[0] = 1;
  Object opresult4669 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4669
  int op_slot_left_4664 = gc_frame_newslot(opresult4669);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4670 = callmethod(opresult4669, "++", 1, partcv, params);
// compilenode returning opresult4670
  int op_slot_left_4661 = gc_frame_newslot(opresult4670);
  params[0] = strlit4662;
  partcv[0] = 1;
  Object opresult4671 = callmethod(opresult4670, "++", 1, partcv, params);
// compilenode returning opresult4671
  *var_s = opresult4671;
  if (opresult4671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4673 = gc_frame_new();
  int callframe4674 = gc_frame_new();
  partcv[0] = 0;
  Object call4675 = callmethodflags(self, "generics", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4674);
// compilenode returning call4675
  gc_frame_newslot(call4675);
  Object block4676 = alloc_Block(NULL, NULL, "ast", 993);
  gc_frame_newslot(block4676);
  block_savedest(block4676);
  Object closure4677 = createclosure(3, "_apply");
setclosureframe(closure4677, stackframe);
  addtoclosure(closure4677, var_spc);
  addtoclosure(closure4677, var_s);
  addtoclosure(closure4677, selfslot);
  struct UserObject *uo4677 = (struct UserObject*)block4676;
  uo4677->data[0] = (Object)closure4677;
  Method *meth_meth_ast__apply4677 = addmethod2pos(block4676, "_apply", &meth_ast__apply4677, 0);
int argcv_meth_ast__apply4677[] = {1};
meth_meth_ast__apply4677->type = alloc_MethodType(1, argcv_meth_ast__apply4677);
  meth_meth_ast__apply4677->definitionModule = modulename;
  meth_meth_ast__apply4677->definitionLine = 988;
// compilenode returning block4676
  gc_frame_newslot(block4676);
  params[0] = call4675;
  params[1] = block4676;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4701 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4673);
// compilenode returning call4701
    gc_frame_newslot(call4701);
    if4654 = call4701;
  } else {
  }
// compilenode returning if4654
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4704 = alloc_Float64(0);
// compilenode returning num4704
  int op_slot_right_4703 = gc_frame_newslot(num4704);
  int callframe4706 = gc_frame_new();
  int callframe4707 = gc_frame_new();
  partcv[0] = 0;
  Object call4708 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4707);
// compilenode returning call4708
  partcv[0] = 0;
  Object call4709 = callmethod(call4708, "size",
    1, partcv, params);
  gc_frame_end(callframe4706);
// compilenode returning call4709
// compilenode returning call4709
  int op_slot_left_4703 = gc_frame_newslot(call4709);
  params[0] = num4704;
  partcv[0] = 1;
  Object opresult4710 = callmethod(call4709, ">", 1, partcv, params);
// compilenode returning opresult4710
  Object if4702 = done;
  if (istrue(opresult4710)) {
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4712 == NULL) {
    strlit4712 = alloc_String("Annotations:");
    gc_root(strlit4712);
  }
// compilenode returning strlit4712
  int op_slot_right_4711 = gc_frame_newslot(strlit4712);
// compilenode returning *var_spc
  int op_slot_right_4714 = gc_frame_newslot(*var_spc);
  if (strlit4717 == NULL) {
    strlit4717 = alloc_String("""\x0a""");
    gc_root(strlit4717);
  }
// compilenode returning strlit4717
  int op_slot_right_4716 = gc_frame_newslot(strlit4717);
// compilenode returning *var_s
  int op_slot_left_4716 = gc_frame_newslot(*var_s);
  params[0] = strlit4717;
  partcv[0] = 1;
  Object opresult4719 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4719
  int op_slot_left_4714 = gc_frame_newslot(opresult4719);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4720 = callmethod(opresult4719, "++", 1, partcv, params);
// compilenode returning opresult4720
  int op_slot_left_4711 = gc_frame_newslot(opresult4720);
  params[0] = strlit4712;
  partcv[0] = 1;
  Object opresult4721 = callmethod(opresult4720, "++", 1, partcv, params);
// compilenode returning opresult4721
  *var_s = opresult4721;
  if (opresult4721 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4723 = gc_frame_new();
  int callframe4724 = gc_frame_new();
  partcv[0] = 0;
  Object call4725 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4724);
// compilenode returning call4725
  gc_frame_newslot(call4725);
  Object block4726 = alloc_Block(NULL, NULL, "ast", 999);
  gc_frame_newslot(block4726);
  block_savedest(block4726);
  Object closure4727 = createclosure(4, "_apply");
setclosureframe(closure4727, stackframe);
  addtoclosure(closure4727, var_depth);
  addtoclosure(closure4727, var_spc);
  addtoclosure(closure4727, var_s);
  addtoclosure(closure4727, selfslot);
  struct UserObject *uo4727 = (struct UserObject*)block4726;
  uo4727->data[0] = (Object)closure4727;
  Method *meth_meth_ast__apply4727 = addmethod2pos(block4726, "_apply", &meth_ast__apply4727, 0);
int argcv_meth_ast__apply4727[] = {1};
meth_meth_ast__apply4727->type = alloc_MethodType(1, argcv_meth_ast__apply4727);
  meth_meth_ast__apply4727->definitionModule = modulename;
  meth_meth_ast__apply4727->definitionLine = 997;
// compilenode returning block4726
  gc_frame_newslot(block4726);
  params[0] = call4725;
  params[1] = block4726;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4754 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4723);
// compilenode returning call4754
    gc_frame_newslot(call4754);
    if4702 = call4754;
  } else {
  }
// compilenode returning if4702
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4756 == NULL) {
    strlit4756 = alloc_String("Body:");
    gc_root(strlit4756);
  }
// compilenode returning strlit4756
  int op_slot_right_4755 = gc_frame_newslot(strlit4756);
// compilenode returning *var_spc
  int op_slot_right_4758 = gc_frame_newslot(*var_spc);
  if (strlit4761 == NULL) {
    strlit4761 = alloc_String("""\x0a""");
    gc_root(strlit4761);
  }
// compilenode returning strlit4761
  int op_slot_right_4760 = gc_frame_newslot(strlit4761);
// compilenode returning *var_s
  int op_slot_left_4760 = gc_frame_newslot(*var_s);
  params[0] = strlit4761;
  partcv[0] = 1;
  Object opresult4763 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4763
  int op_slot_left_4758 = gc_frame_newslot(opresult4763);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult4764 = callmethod(opresult4763, "++", 1, partcv, params);
// compilenode returning opresult4764
  int op_slot_left_4755 = gc_frame_newslot(opresult4764);
  params[0] = strlit4756;
  partcv[0] = 1;
  Object opresult4765 = callmethod(opresult4764, "++", 1, partcv, params);
// compilenode returning opresult4765
  *var_s = opresult4765;
  if (opresult4765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4767 = gc_frame_new();
  int callframe4768 = gc_frame_new();
  partcv[0] = 0;
  Object call4769 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4768);
// compilenode returning call4769
// compilenode returning call4769
  gc_frame_newslot(call4769);
  Object block4770 = alloc_Block(NULL, NULL, "ast", 1004);
  gc_frame_newslot(block4770);
  block_savedest(block4770);
  Object closure4771 = createclosure(4, "_apply");
setclosureframe(closure4771, stackframe);
  addtoclosure(closure4771, var_depth);
  addtoclosure(closure4771, var_spc);
  addtoclosure(closure4771, var_s);
  addtoclosure(closure4771, selfslot);
  struct UserObject *uo4771 = (struct UserObject*)block4770;
  uo4771->data[0] = (Object)closure4771;
  Method *meth_meth_ast__apply4771 = addmethod2pos(block4770, "_apply", &meth_ast__apply4771, 0);
int argcv_meth_ast__apply4771[] = {1};
meth_meth_ast__apply4771->type = alloc_MethodType(1, argcv_meth_ast__apply4771);
  meth_meth_ast__apply4771->definitionModule = modulename;
  meth_meth_ast__apply4771->definitionLine = 1004;
// compilenode returning block4770
  gc_frame_newslot(block4770);
  params[0] = call4769;
  params[1] = block4770;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4790 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4767);
// compilenode returning call4790
// Begin line 1007
  setline(1007);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType4791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4794 = alloc_Boolean(0);
// compilenode returning bool4794
  int op_slot_right_4793 = gc_frame_newslot(bool4794);
  int callframe4796 = gc_frame_new();
  partcv[0] = 0;
  Object call4797 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4796);
// compilenode returning call4797
  int op_slot_left_4793 = gc_frame_newslot(call4797);
  params[0] = bool4794;
  partcv[0] = 1;
  Object opresult4798 = callmethod(call4797, "==", 1, partcv, params);
// compilenode returning opresult4798
  Object if4792 = done;
  if (istrue(opresult4798)) {
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4799 = gc_frame_new();
  if (strlit4800 == NULL) {
    strlit4800 = alloc_String("Unknown");
    gc_root(strlit4800);
  }
// compilenode returning strlit4800
  gc_frame_newslot(strlit4800);
  Object bool4801 = alloc_Boolean(0);
// compilenode returning bool4801
  gc_frame_newslot(bool4801);
// compilenode returning *var_identifierNode
  params[0] = strlit4800;
  params[1] = bool4801;
  partcv[0] = 2;
  Object call4802 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe4799);
// compilenode returning call4802
  return call4802;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if4792 = undefined;
  } else {
  }
// compilenode returning if4792
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4803 = gc_frame_new();
  partcv[0] = 0;
  Object call4804 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4803);
// compilenode returning call4804
  return call4804;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply4817(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4819 == NULL) {
    strlit4819 = alloc_String("    ");
    gc_root(strlit4819);
  }
// compilenode returning strlit4819
  int op_slot_right_4818 = gc_frame_newslot(strlit4819);
// compilenode returning *var_spc
  int op_slot_left_4818 = gc_frame_newslot(*var_spc);
  params[0] = strlit4819;
  partcv[0] = 1;
  Object opresult4821 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult4821
  *var_spc = opresult4821;
  if (opresult4821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply4892(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_part = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_pnr = &(stackframe->slots[0]);
  *var_pnr = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4893 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4894 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4893);
// compilenode returning call4894
// compilenode returning call4894
// compilenode returning *var_pnr
  params[0] = *var_pnr;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres4895 = callmethod(call4894, "[]", 1, partcv, params);
// compilenode returning idxres4895
  *var_p = idxres4895;
  if (idxres4895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4897 = gc_frame_new();
  Object num4899 = alloc_Float64(1);
// compilenode returning num4899
  int op_slot_right_4898 = gc_frame_newslot(num4899);
// compilenode returning *var_depth
  int op_slot_left_4898 = gc_frame_newslot(*var_depth);
  params[0] = num4899;
  partcv[0] = 1;
  Object sum4901 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4901
  gc_frame_newslot(sum4901);
// compilenode returning *var_p
  params[0] = sum4901;
  partcv[0] = 1;
  Object call4902 = callmethod(*var_p, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4897);
// compilenode returning call4902
  int op_slot_right_4896 = gc_frame_newslot(call4902);
// compilenode returning *var_s
  int op_slot_left_4896 = gc_frame_newslot(*var_s);
  params[0] = call4902;
  partcv[0] = 1;
  Object opresult4904 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4904
  *var_s = opresult4904;
  if (opresult4904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4909 = alloc_Boolean(0);
// compilenode returning bool4909
  int op_slot_right_4908 = gc_frame_newslot(bool4909);
  int callframe4911 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4912 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4911);
// compilenode returning call4912
// compilenode returning call4912
  int op_slot_left_4908 = gc_frame_newslot(call4912);
  params[0] = bool4909;
  partcv[0] = 1;
  Object opresult4913 = callmethod(call4912, "!=", 1, partcv, params);
// compilenode returning opresult4913
  int op_slot_right_4907 = gc_frame_newslot(opresult4913);
  int callframe4916 = gc_frame_new();
  int callframe4917 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4918 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4917);
// compilenode returning call4918
// compilenode returning call4918
  partcv[0] = 0;
  Object call4919 = callmethod(call4918, "size",
    1, partcv, params);
  gc_frame_end(callframe4916);
// compilenode returning call4919
// compilenode returning call4919
  int op_slot_right_4915 = gc_frame_newslot(call4919);
// compilenode returning *var_pnr
  int op_slot_left_4915 = gc_frame_newslot(*var_pnr);
  params[0] = call4919;
  partcv[0] = 1;
  Object opresult4921 = callmethod(*var_pnr, "<", 1, partcv, params);
// compilenode returning opresult4921
  int op_slot_left_4907 = gc_frame_newslot(opresult4921);
  params[0] = opresult4913;
  partcv[0] = 1;
  Object opresult4922 = callmethod(opresult4921, "||", 1, partcv, params);
// compilenode returning opresult4922
  Object if4906 = done;
  if (istrue(opresult4922)) {
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4924 == NULL) {
    strlit4924 = alloc_String(", ");
    gc_root(strlit4924);
  }
// compilenode returning strlit4924
  int op_slot_right_4923 = gc_frame_newslot(strlit4924);
// compilenode returning *var_s
  int op_slot_left_4923 = gc_frame_newslot(*var_s);
  params[0] = strlit4924;
  partcv[0] = 1;
  Object opresult4926 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4926
  *var_s = opresult4926;
  if (opresult4926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4906 = done;
  } else {
  }
// compilenode returning if4906
  gc_frame_end(frame);
  return if4906;
}
Object meth_ast__apply4856(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_depth = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_part = &(stackframe->slots[0]);
  *var_part = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4858 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4859 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe4858);
// compilenode returning call4859
// compilenode returning call4859
  int op_slot_right_4857 = gc_frame_newslot(call4859);
// compilenode returning *var_s
  int op_slot_left_4857 = gc_frame_newslot(*var_s);
  params[0] = call4859;
  partcv[0] = 1;
  Object opresult4861 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4861
  *var_s = opresult4861;
  if (opresult4861 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4866 = alloc_Boolean(0);
// compilenode returning bool4866
  int op_slot_right_4865 = gc_frame_newslot(bool4866);
  int callframe4868 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4869 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4868);
// compilenode returning call4869
// compilenode returning call4869
  int op_slot_left_4865 = gc_frame_newslot(call4869);
  params[0] = bool4866;
  partcv[0] = 1;
  Object opresult4870 = callmethod(call4869, "!=", 1, partcv, params);
// compilenode returning opresult4870
  int op_slot_right_4864 = gc_frame_newslot(opresult4870);
  Object num4873 = alloc_Float64(0);
// compilenode returning num4873
  int op_slot_right_4872 = gc_frame_newslot(num4873);
  int callframe4875 = gc_frame_new();
  int callframe4876 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4877 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4876);
// compilenode returning call4877
// compilenode returning call4877
  partcv[0] = 0;
  Object call4878 = callmethod(call4877, "size",
    1, partcv, params);
  gc_frame_end(callframe4875);
// compilenode returning call4878
// compilenode returning call4878
  int op_slot_left_4872 = gc_frame_newslot(call4878);
  params[0] = num4873;
  partcv[0] = 1;
  Object opresult4879 = callmethod(call4878, ">", 1, partcv, params);
// compilenode returning opresult4879
  int op_slot_left_4864 = gc_frame_newslot(opresult4879);
  params[0] = opresult4870;
  partcv[0] = 1;
  Object opresult4880 = callmethod(opresult4879, "||", 1, partcv, params);
// compilenode returning opresult4880
  Object if4863 = done;
  if (istrue(opresult4880)) {
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4882 == NULL) {
    strlit4882 = alloc_String("(");
    gc_root(strlit4882);
  }
// compilenode returning strlit4882
  int op_slot_right_4881 = gc_frame_newslot(strlit4882);
// compilenode returning *var_s
  int op_slot_left_4881 = gc_frame_newslot(*var_s);
  params[0] = strlit4882;
  partcv[0] = 1;
  Object opresult4884 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4884
  *var_s = opresult4884;
  if (opresult4884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1030
  setline(1030);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4886 = gc_frame_new();
  int callframe4887 = gc_frame_new();
  int callframe4888 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4889 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe4888);
// compilenode returning call4889
// compilenode returning call4889
  partcv[0] = 0;
  Object call4890 = callmethod(call4889, "indices",
    1, partcv, params);
  gc_frame_end(callframe4887);
// compilenode returning call4890
// compilenode returning call4890
  gc_frame_newslot(call4890);
  Object block4891 = alloc_Block(NULL, NULL, "ast", 1030);
  gc_frame_newslot(block4891);
  block_savedest(block4891);
  Object closure4892 = createclosure(4, "_apply");
setclosureframe(closure4892, stackframe);
  addtoclosure(closure4892, var_part);
  addtoclosure(closure4892, var_depth);
  addtoclosure(closure4892, var_s);
  addtoclosure(closure4892, selfslot);
  struct UserObject *uo4892 = (struct UserObject*)block4891;
  uo4892->data[0] = (Object)closure4892;
  Method *meth_meth_ast__apply4892 = addmethod2pos(block4891, "_apply", &meth_ast__apply4892, 0);
int argcv_meth_ast__apply4892[] = {1};
meth_meth_ast__apply4892->type = alloc_MethodType(1, argcv_meth_ast__apply4892);
  meth_meth_ast__apply4892->definitionModule = modulename;
  meth_meth_ast__apply4892->definitionLine = 1030;
// compilenode returning block4891
  gc_frame_newslot(block4891);
  params[0] = call4890;
  params[1] = block4891;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4929 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4886);
// compilenode returning call4929
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4932 = alloc_Boolean(0);
// compilenode returning bool4932
  int op_slot_right_4931 = gc_frame_newslot(bool4932);
  int callframe4934 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4935 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4934);
// compilenode returning call4935
// compilenode returning call4935
  int op_slot_left_4931 = gc_frame_newslot(call4935);
  params[0] = bool4932;
  partcv[0] = 1;
  Object opresult4936 = callmethod(call4935, "!=", 1, partcv, params);
// compilenode returning opresult4936
  Object if4930 = done;
  if (istrue(opresult4936)) {
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4938 = gc_frame_new();
  int callframe4939 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call4940 = callmethod(*var_part, "vararg",
    1, partcv, params);
  gc_frame_end(callframe4939);
// compilenode returning call4940
// compilenode returning call4940
  partcv[0] = 0;
  Object call4941 = callmethod(call4940, "value",
    1, partcv, params);
  gc_frame_end(callframe4938);
// compilenode returning call4941
// compilenode returning call4941
  int op_slot_right_4937 = gc_frame_newslot(call4941);
  if (strlit4944 == NULL) {
    strlit4944 = alloc_String("*");
    gc_root(strlit4944);
  }
// compilenode returning strlit4944
  int op_slot_right_4943 = gc_frame_newslot(strlit4944);
// compilenode returning *var_s
  int op_slot_left_4943 = gc_frame_newslot(*var_s);
  params[0] = strlit4944;
  partcv[0] = 1;
  Object opresult4946 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4946
  int op_slot_left_4937 = gc_frame_newslot(opresult4946);
  params[0] = call4941;
  partcv[0] = 1;
  Object opresult4947 = callmethod(opresult4946, "++", 1, partcv, params);
// compilenode returning opresult4947
  *var_s = opresult4947;
  if (opresult4947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4930 = done;
  } else {
  }
// compilenode returning if4930
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4950 == NULL) {
    strlit4950 = alloc_String(")");
    gc_root(strlit4950);
  }
// compilenode returning strlit4950
  int op_slot_right_4949 = gc_frame_newslot(strlit4950);
// compilenode returning *var_s
  int op_slot_left_4949 = gc_frame_newslot(*var_s);
  params[0] = strlit4950;
  partcv[0] = 1;
  Object opresult4952 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4952
  *var_s = opresult4952;
  if (opresult4952 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4863 = done;
  } else {
  }
// compilenode returning if4863
  gc_frame_end(frame);
  return if4863;
}
Object meth_ast__apply4996(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_mx = &(stackframe->slots[0]);
  *var_mx = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4998 = gc_frame_new();
  Object num5000 = alloc_Float64(1);
// compilenode returning num5000
  int op_slot_right_4999 = gc_frame_newslot(num5000);
// compilenode returning *var_depth
  int op_slot_left_4999 = gc_frame_newslot(*var_depth);
  params[0] = num5000;
  partcv[0] = 1;
  Object sum5002 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5002
  gc_frame_newslot(sum5002);
// compilenode returning *var_mx
  params[0] = sum5002;
  partcv[0] = 1;
  Object call5003 = callmethod(*var_mx, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4998);
// compilenode returning call5003
  int op_slot_right_4997 = gc_frame_newslot(call5003);
  if (strlit5006 == NULL) {
    strlit5006 = alloc_String("    ");
    gc_root(strlit5006);
  }
// compilenode returning strlit5006
  int op_slot_right_5005 = gc_frame_newslot(strlit5006);
// compilenode returning *var_spc
  int op_slot_right_5008 = gc_frame_newslot(*var_spc);
  if (strlit5011 == NULL) {
    strlit5011 = alloc_String("""\x0a""");
    gc_root(strlit5011);
  }
// compilenode returning strlit5011
  int op_slot_right_5010 = gc_frame_newslot(strlit5011);
// compilenode returning *var_s
  int op_slot_left_5010 = gc_frame_newslot(*var_s);
  params[0] = strlit5011;
  partcv[0] = 1;
  Object opresult5013 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5013
  int op_slot_left_5008 = gc_frame_newslot(opresult5013);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5014 = callmethod(opresult5013, "++", 1, partcv, params);
// compilenode returning opresult5014
  int op_slot_left_5005 = gc_frame_newslot(opresult5014);
  params[0] = strlit5006;
  partcv[0] = 1;
  Object opresult5015 = callmethod(opresult5014, "++", 1, partcv, params);
// compilenode returning opresult5015
  int op_slot_left_4997 = gc_frame_newslot(opresult5015);
  params[0] = call5003;
  partcv[0] = 1;
  Object opresult5016 = callmethod(opresult5015, "++", 1, partcv, params);
// compilenode returning opresult5016
  *var_s = opresult5016;
  if (opresult5016 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace4805(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4806 == NULL) {
    strlit4806 = alloc_String("");
    gc_root(strlit4806);
  }
// compilenode returning strlit4806
  *var_spc = strlit4806;
  if (strlit4806 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1019
  setline(1019);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4807 = gc_frame_new();
  Object num4810 = alloc_Float64(1);
// compilenode returning num4810
  int op_slot_right_4809 = gc_frame_newslot(num4810);
// compilenode returning *var_depth
  int op_slot_left_4809 = gc_frame_newslot(*var_depth);
  params[0] = num4810;
  partcv[0] = 1;
  Object diff4812 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff4812
  int op_slot_right_4808 = gc_frame_newslot(diff4812);
  Object num4814 = alloc_Float64(0);
// compilenode returning num4814
  int op_slot_left_4808 = gc_frame_newslot(num4814);
  params[0] = diff4812;
  partcv[0] = 1;
  Object opresult4815 = callmethod(num4814, "..", 1, partcv, params);
// compilenode returning opresult4815
  gc_frame_newslot(opresult4815);
  Object block4816 = alloc_Block(NULL, NULL, "ast", 1019);
  gc_frame_newslot(block4816);
  block_savedest(block4816);
  Object closure4817 = createclosure(2, "_apply");
setclosureframe(closure4817, stackframe);
  addtoclosure(closure4817, var_spc);
  addtoclosure(closure4817, selfslot);
  struct UserObject *uo4817 = (struct UserObject*)block4816;
  uo4817->data[0] = (Object)closure4817;
  Method *meth_meth_ast__apply4817 = addmethod2pos(block4816, "_apply", &meth_ast__apply4817, 0);
int argcv_meth_ast__apply4817[] = {1};
meth_meth_ast__apply4817->type = alloc_MethodType(1, argcv_meth_ast__apply4817);
  meth_meth_ast__apply4817->definitionModule = modulename;
  meth_meth_ast__apply4817->definitionLine = 1004;
// compilenode returning block4816
  gc_frame_newslot(block4816);
  params[0] = opresult4815;
  params[1] = block4816;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4824 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4807);
// compilenode returning call4824
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4826 == NULL) {
    strlit4826 = alloc_String("");
    gc_root(strlit4826);
  }
// compilenode returning strlit4826
  int op_slot_right_4825 = gc_frame_newslot(strlit4826);
  int callframe4829 = gc_frame_new();
  Object num4830 = alloc_Float64(0);
// compilenode returning num4830
  gc_frame_newslot(num4830);
  int callframe4831 = gc_frame_new();
  partcv[0] = 0;
  Object call4832 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4831);
// compilenode returning call4832
// compilenode returning call4832
  params[0] = num4830;
  partcv[0] = 1;
  Object call4833 = callmethod(call4832, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4829);
// compilenode returning call4833
  int op_slot_right_4828 = gc_frame_newslot(call4833);
  if (strlit4835 == NULL) {
    strlit4835 = alloc_String("class ");
    gc_root(strlit4835);
  }
// compilenode returning strlit4835
  int op_slot_left_4828 = gc_frame_newslot(strlit4835);
  params[0] = call4833;
  partcv[0] = 1;
  Object opresult4836 = callmethod(strlit4835, "++", 1, partcv, params);
// compilenode returning opresult4836
  int op_slot_left_4825 = gc_frame_newslot(opresult4836);
  params[0] = strlit4826;
  partcv[0] = 1;
  Object opresult4837 = callmethod(opresult4836, "++", 1, partcv, params);
// compilenode returning opresult4837
  *var_s = opresult4837;
  if (opresult4837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String("generic");
    gc_root(strlit4840);
  }
// compilenode returning strlit4840
  int op_slot_right_4839 = gc_frame_newslot(strlit4840);
  int callframe4842 = gc_frame_new();
  int callframe4843 = gc_frame_new();
  partcv[0] = 0;
  Object call4844 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4843);
// compilenode returning call4844
// compilenode returning call4844
  partcv[0] = 0;
  Object call4845 = callmethod(call4844, "kind",
    1, partcv, params);
  gc_frame_end(callframe4842);
// compilenode returning call4845
// compilenode returning call4845
  int op_slot_left_4839 = gc_frame_newslot(call4845);
  params[0] = strlit4840;
  partcv[0] = 1;
  Object opresult4846 = callmethod(call4845, "!=", 1, partcv, params);
// compilenode returning opresult4846
  Object if4838 = done;
  if (istrue(opresult4846)) {
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4848 == NULL) {
    strlit4848 = alloc_String(".");
    gc_root(strlit4848);
  }
// compilenode returning strlit4848
  int op_slot_right_4847 = gc_frame_newslot(strlit4848);
// compilenode returning *var_s
  int op_slot_left_4847 = gc_frame_newslot(*var_s);
  params[0] = strlit4848;
  partcv[0] = 1;
  Object opresult4850 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4850
  *var_s = opresult4850;
  if (opresult4850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4852 = gc_frame_new();
  int callframe4853 = gc_frame_new();
  partcv[0] = 0;
  Object call4854 = callmethodflags(self, "signature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4853);
// compilenode returning call4854
// compilenode returning call4854
  gc_frame_newslot(call4854);
  Object block4855 = alloc_Block(NULL, NULL, "ast", 1026);
  gc_frame_newslot(block4855);
  block_savedest(block4855);
  Object closure4856 = createclosure(3, "_apply");
setclosureframe(closure4856, stackframe);
  addtoclosure(closure4856, var_s);
  addtoclosure(closure4856, var_depth);
  addtoclosure(closure4856, selfslot);
  struct UserObject *uo4856 = (struct UserObject*)block4855;
  uo4856->data[0] = (Object)closure4856;
  Method *meth_meth_ast__apply4856 = addmethod2pos(block4855, "_apply", &meth_ast__apply4856, 0);
int argcv_meth_ast__apply4856[] = {1};
meth_meth_ast__apply4856->type = alloc_MethodType(1, argcv_meth_ast__apply4856);
  meth_meth_ast__apply4856->definitionModule = modulename;
  meth_meth_ast__apply4856->definitionLine = 1026;
// compilenode returning block4855
  gc_frame_newslot(block4855);
  params[0] = call4854;
  params[1] = block4855;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4955 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4852);
// compilenode returning call4955
    gc_frame_newslot(call4955);
    if4838 = call4955;
  } else {
  }
// compilenode returning if4838
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4958 = gc_frame_new();
  partcv[0] = 0;
  Object call4959 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4958);
// compilenode returning call4959
  int op_slot_right_4957 = gc_frame_newslot(call4959);
  Object bool4961 = alloc_Boolean(0);
// compilenode returning bool4961
  int op_slot_left_4957 = gc_frame_newslot(bool4961);
  params[0] = call4959;
  partcv[0] = 1;
  Object opresult4962 = callmethod(bool4961, "!=", 1, partcv, params);
// compilenode returning opresult4962
  Object if4956 = done;
  if (istrue(opresult4962)) {
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4964 == NULL) {
    strlit4964 = alloc_String("");
    gc_root(strlit4964);
  }
// compilenode returning strlit4964
  int op_slot_right_4963 = gc_frame_newslot(strlit4964);
  int callframe4967 = gc_frame_new();
  Object num4969 = alloc_Float64(1);
// compilenode returning num4969
  int op_slot_right_4968 = gc_frame_newslot(num4969);
// compilenode returning *var_depth
  int op_slot_left_4968 = gc_frame_newslot(*var_depth);
  params[0] = num4969;
  partcv[0] = 1;
  Object sum4971 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum4971
  gc_frame_newslot(sum4971);
  int callframe4972 = gc_frame_new();
  partcv[0] = 0;
  Object call4973 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4972);
// compilenode returning call4973
  params[0] = sum4971;
  partcv[0] = 1;
  Object call4974 = callmethod(call4973, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe4967);
// compilenode returning call4974
  int op_slot_right_4966 = gc_frame_newslot(call4974);
  if (strlit4977 == NULL) {
    strlit4977 = alloc_String(" -> ");
    gc_root(strlit4977);
  }
// compilenode returning strlit4977
  int op_slot_right_4976 = gc_frame_newslot(strlit4977);
// compilenode returning *var_s
  int op_slot_right_4979 = gc_frame_newslot(*var_s);
  if (strlit4981 == NULL) {
    strlit4981 = alloc_String("");
    gc_root(strlit4981);
  }
// compilenode returning strlit4981
  int op_slot_left_4979 = gc_frame_newslot(strlit4981);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult4982 = callmethod(strlit4981, "++", 1, partcv, params);
// compilenode returning opresult4982
  int op_slot_left_4976 = gc_frame_newslot(opresult4982);
  params[0] = strlit4977;
  partcv[0] = 1;
  Object opresult4983 = callmethod(opresult4982, "++", 1, partcv, params);
// compilenode returning opresult4983
  int op_slot_left_4966 = gc_frame_newslot(opresult4983);
  params[0] = call4974;
  partcv[0] = 1;
  Object opresult4984 = callmethod(opresult4983, "++", 1, partcv, params);
// compilenode returning opresult4984
  int op_slot_left_4963 = gc_frame_newslot(opresult4984);
  params[0] = strlit4964;
  partcv[0] = 1;
  Object opresult4985 = callmethod(opresult4984, "++", 1, partcv, params);
// compilenode returning opresult4985
  *var_s = opresult4985;
  if (opresult4985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4956 = done;
  } else {
  }
// compilenode returning if4956
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4988 == NULL) {
    strlit4988 = alloc_String(" {");
    gc_root(strlit4988);
  }
// compilenode returning strlit4988
  int op_slot_right_4987 = gc_frame_newslot(strlit4988);
// compilenode returning *var_s
  int op_slot_left_4987 = gc_frame_newslot(*var_s);
  params[0] = strlit4988;
  partcv[0] = 1;
  Object opresult4990 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult4990
  *var_s = opresult4990;
  if (opresult4990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4992 = gc_frame_new();
  int callframe4993 = gc_frame_new();
  partcv[0] = 0;
  Object call4994 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4993);
// compilenode returning call4994
// compilenode returning call4994
  gc_frame_newslot(call4994);
  Object block4995 = alloc_Block(NULL, NULL, "ast", 1048);
  gc_frame_newslot(block4995);
  block_savedest(block4995);
  Object closure4996 = createclosure(4, "_apply");
setclosureframe(closure4996, stackframe);
  addtoclosure(closure4996, var_depth);
  addtoclosure(closure4996, var_spc);
  addtoclosure(closure4996, var_s);
  addtoclosure(closure4996, selfslot);
  struct UserObject *uo4996 = (struct UserObject*)block4995;
  uo4996->data[0] = (Object)closure4996;
  Method *meth_meth_ast__apply4996 = addmethod2pos(block4995, "_apply", &meth_ast__apply4996, 0);
int argcv_meth_ast__apply4996[] = {1};
meth_meth_ast__apply4996->type = alloc_MethodType(1, argcv_meth_ast__apply4996);
  meth_meth_ast__apply4996->definitionModule = modulename;
  meth_meth_ast__apply4996->definitionLine = 1048;
// compilenode returning block4995
  gc_frame_newslot(block4995);
  params[0] = call4994;
  params[1] = block4995;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5019 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4992);
// compilenode returning call5019
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5021 == NULL) {
    strlit5021 = alloc_String("}");
    gc_root(strlit5021);
  }
// compilenode returning strlit5021
  int op_slot_right_5020 = gc_frame_newslot(strlit5021);
// compilenode returning *var_spc
  int op_slot_right_5023 = gc_frame_newslot(*var_spc);
  if (strlit5026 == NULL) {
    strlit5026 = alloc_String("""\x0a""");
    gc_root(strlit5026);
  }
// compilenode returning strlit5026
  int op_slot_right_5025 = gc_frame_newslot(strlit5026);
// compilenode returning *var_s
  int op_slot_left_5025 = gc_frame_newslot(*var_s);
  params[0] = strlit5026;
  partcv[0] = 1;
  Object opresult5028 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5028
  int op_slot_left_5023 = gc_frame_newslot(opresult5028);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5029 = callmethod(opresult5028, "++", 1, partcv, params);
// compilenode returning opresult5029
  int op_slot_left_5020 = gc_frame_newslot(opresult5029);
  params[0] = strlit5021;
  partcv[0] = 1;
  Object opresult5030 = callmethod(opresult5029, "++", 1, partcv, params);
// compilenode returning opresult5030
  *var_s = opresult5030;
  if (opresult5030 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1052
  setline(1052);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new4225(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_classNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 6)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4226 = alloc_userobj2(22,19, objclass4226);
  gc_frame_newslot(obj4226);
if (objclass4226 == NULL) {
  glfree(obj4226->class->name);
  obj4226->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4226, self, 0);
  addmethodreal(obj4226,"outer", &reader_ast_outer_4227);
  Object oldself4226 = self;
  struct StackFrameObject *oldstackframe4226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4226);
  gc_frame_newslot((Object)stackframe);
  self = obj4226;
  Object *oldselfslot4226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4226 = (*(struct UserObject *)self).data[0], lowerouter4226 = thisouter4226;
  if (inheritingObject4226) {
    struct UserObject *inho4226 = (struct UserObject *)inheritingObject4226;
    while (inho4226->super != GraceDefaultObject) inho4226 = (struct UserObject *)inho4226->super;
    inho4226->super = obj4226;
    self = inheritingObject4226;
    *selfslot = self;
    lowerouter4226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4226;
  }
if (objclass4226 == NULL) {
  Method *reader4228 = addmethodrealflags(obj4226, "kind",&reader_ast_kind_4228, MFLAG_DEF);
  reader4228->definitionModule = modulename;
  reader4228->definitionLine = 919;
}
adddatum2(obj4226, alloc_Undefined(), 1);
if (objclass4226 == NULL) {
  Method *reader4229 = addmethodrealflags(obj4226, "value",&reader_ast_value_4229, MFLAG_DEF);
  reader4229->definitionModule = modulename;
  reader4229->definitionLine = 920;
}
adddatum2(obj4226, alloc_Undefined(), 2);
if (objclass4226 == NULL) {
  Method *reader4230 = addmethodrealflags(obj4226, "name",&reader_ast_name_4230, MFLAG_DEF);
  reader4230->definitionModule = modulename;
  reader4230->definitionLine = 921;
}
adddatum2(obj4226, alloc_Undefined(), 3);
if (objclass4226 == NULL) {
  Method *reader4231 = addmethodrealflags(obj4226, "constructor",&reader_ast_constructor_4231, MFLAG_DEF);
  reader4231->definitionModule = modulename;
  reader4231->definitionLine = 922;
}
adddatum2(obj4226, alloc_Undefined(), 4);
if (objclass4226 == NULL) {
  Method *reader4232 = addmethodrealflags(obj4226, "signature",&reader_ast_signature_4232, MFLAG_DEF);
  reader4232->definitionModule = modulename;
  reader4232->definitionLine = 923;
}
adddatum2(obj4226, alloc_Undefined(), 5);
if (objclass4226 == NULL) {
  Method *reader4233 = addmethodrealflags(obj4226, "dtype",&reader_ast_dtype_4233, 0);
  Method *writer4233 = addmethodrealflags(obj4226, "dtype:=",&writer_ast_dtype_4233, 0);
  reader4233->definitionModule = modulename;
  writer4233->definitionModule = modulename;
  reader4233->definitionLine = 924;
  writer4233->definitionLine = 924;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 6);
if (objclass4226 == NULL) {
  Method *reader4234 = addmethodrealflags(obj4226, "generics",&reader_ast_generics_4234, 0);
  Method *writer4234 = addmethodrealflags(obj4226, "generics:=",&writer_ast_generics_4234, 0);
  reader4234->definitionModule = modulename;
  writer4234->definitionModule = modulename;
  reader4234->definitionLine = 925;
  writer4234->definitionLine = 925;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 7);
if (objclass4226 == NULL) {
  Method *reader4235 = addmethodrealflags(obj4226, "superclass",&reader_ast_superclass_4235, MFLAG_DEF);
  reader4235->definitionModule = modulename;
  reader4235->definitionLine = 926;
}
adddatum2(obj4226, alloc_Undefined(), 8);
if (objclass4226 == NULL) {
  Method *reader4236 = addmethodrealflags(obj4226, "annotations",&reader_ast_annotations_4236, MFLAG_DEF);
  reader4236->definitionModule = modulename;
  reader4236->definitionLine = 927;
}
adddatum2(obj4226, alloc_Undefined(), 9);
if (objclass4226 == NULL) {
  Method *reader4237 = addmethodrealflags(obj4226, "instanceMethods",&reader_ast_instanceMethods_4237, 0);
  Method *writer4237 = addmethodrealflags(obj4226, "instanceMethods:=",&writer_ast_instanceMethods_4237, 0);
  reader4237->definitionModule = modulename;
  writer4237->definitionModule = modulename;
  reader4237->definitionLine = 928;
  writer4237->definitionLine = 928;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 10);
if (objclass4226 == NULL) {
  Method *reader4238 = addmethodrealflags(obj4226, "data",&reader_ast_data_4238, 0);
  Method *writer4238 = addmethodrealflags(obj4226, "data:=",&writer_ast_data_4238, 0);
  reader4238->definitionModule = modulename;
  writer4238->definitionModule = modulename;
  reader4238->definitionLine = 929;
  writer4238->definitionLine = 929;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 11);
  struct UserObject *uo4239 = (struct UserObject*)obj4226;
  uo4239->data[12] = emptyclosure;
  Method *meth_meth_ast_accept4239 = addmethod2pos(obj4226, "accept", &meth_ast_accept4239, 12);
int argcv_meth_ast_accept4239[] = {1};
meth_meth_ast_accept4239->type = alloc_MethodType(1, argcv_meth_ast_accept4239);
meth_meth_ast_accept4239->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept4239->type->names[0] = "visitor";
  meth_meth_ast_accept4239->definitionModule = modulename;
  meth_meth_ast_accept4239->definitionLine = 929;
  block_savedest(obj4226);
  Object closure4298 = createclosure(1, "map()before()after");
setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_classNode);
  struct UserObject *uo4298 = (struct UserObject*)obj4226;
  uo4298->data[13] = (Object)closure4298;
  Method *meth_meth_ast_map_40__41_before_40__41_after4298 = addmethod2pos(obj4226, "map()before()after", &meth_ast_map_40__41_before_40__41_after4298, 13);
int argcv_meth_ast_map_40__41_before_40__41_after4298[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after4298->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after4298);
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionLine = 949;
  struct UserObject *uo4363 = (struct UserObject*)obj4226;
  uo4363->data[14] = emptyclosure;
  Method *meth_meth_ast_map4363 = addmethod2pos(obj4226, "map", &meth_ast_map4363, 14);
int argcv_meth_ast_map4363[] = {1};
meth_meth_ast_map4363->type = alloc_MethodType(1, argcv_meth_ast_map4363);
  meth_meth_ast_map4363->definitionModule = modulename;
  meth_meth_ast_map4363->definitionLine = 962;
  struct UserObject *uo4372 = (struct UserObject*)obj4226;
  uo4372->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty4372 = addmethod2pos(obj4226, "pretty", &meth_ast_pretty4372, 15);
int argcv_meth_ast_pretty4372[] = {1};
meth_meth_ast_pretty4372->type = alloc_MethodType(1, argcv_meth_ast_pretty4372);
  meth_meth_ast_pretty4372->definitionModule = modulename;
  meth_meth_ast_pretty4372->definitionLine = 965;
  block_savedest(obj4226);
  Object closure4791 = createclosure(1, "decType");
setclosureframe(closure4791, stackframe);
  addtoclosure(closure4791, var_identifierNode);
  struct UserObject *uo4791 = (struct UserObject*)obj4226;
  uo4791->data[16] = (Object)closure4791;
  Method *meth_meth_ast_decType4791 = addmethod2pos(obj4226, "decType", &meth_ast_decType4791, 16);
int argcv_meth_ast_decType4791[] = {0};
meth_meth_ast_decType4791->type = alloc_MethodType(1, argcv_meth_ast_decType4791);
  meth_meth_ast_decType4791->definitionModule = modulename;
  meth_meth_ast_decType4791->definitionLine = 1010;
  struct UserObject *uo4805 = (struct UserObject*)obj4226;
  uo4805->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace4805 = addmethod2pos(obj4226, "toGrace", &meth_ast_toGrace4805, 17);
int argcv_meth_ast_toGrace4805[] = {1};
meth_meth_ast_toGrace4805->type = alloc_MethodType(1, argcv_meth_ast_toGrace4805);
meth_meth_ast_toGrace4805->type->types[0] = type_Number;
meth_meth_ast_toGrace4805->type->names[0] = "depth";
  meth_meth_ast_toGrace4805->definitionModule = modulename;
  meth_meth_ast_toGrace4805->definitionLine = 1017;
  sourceObject = obj4226;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5032 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5033 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5032);
// compilenode returning call5033
  struct UserObject *obj4226_uo = (struct UserObject *)obj4226;
  obj4226_uo->super = call5033;
  sourceObject = obj4226;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5034 == NULL) {
    strlit5034 = alloc_String("class");
    gc_root(strlit5034);
  }
// compilenode returning strlit5034
  adddatum2(obj4226, strlit5034, 1);
  sourceObject = obj4226;
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj4226, *var_body_39_, 2);
  sourceObject = obj4226;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj4226, *var_name_39_, 3);
  sourceObject = obj4226;
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_constructor_39_
  adddatum2(obj4226, *var_constructor_39_, 4);
  sourceObject = obj4226;
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj4226, *var_signature_39_, 5);
  sourceObject = obj4226;
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj4226, *var_dtype_39_, 6);
  sourceObject = obj4226;
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5035 = alloc_Boolean(0);
// compilenode returning bool5035
  adddatum2(obj4226, bool5035, 7);
  sourceObject = obj4226;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj4226, *var_superclass_39_, 8);
  sourceObject = obj4226;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5036 = gc_frame_new();
  int callframe5037 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5038 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5037);
// compilenode returning call5038
// compilenode returning call5038
  partcv[0] = 0;
  Object call5039 = callmethod(call5038, "new",
    1, partcv, params);
  gc_frame_end(callframe5036);
// compilenode returning call5039
// compilenode returning call5039
  adddatum2(obj4226, call5039, 9);
  sourceObject = obj4226;
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5040 = gc_frame_new();
  int callframe5041 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5042 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5041);
// compilenode returning call5042
// compilenode returning call5042
  partcv[0] = 0;
  Object call5043 = callmethod(call5042, "new",
    1, partcv, params);
  gc_frame_end(callframe5040);
// compilenode returning call5043
// compilenode returning call5043
  adddatum2(obj4226, call5043, 10);
  sourceObject = obj4226;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5044 = alloc_Boolean(0);
// compilenode returning bool5044
  adddatum2(obj4226, bool5044, 11);
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
objclass4226 = obj4226->class;
  objclass4226->definitionModule = modulename;
  objclass4226->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4226;
  self = oldself4226;
  selfslot = oldselfslot4226;
  stackframe = oldstackframe4226;
  gc_frame_end(frame);
  return obj4226;
}
Object meth_ast_new4225_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 6)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_classNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_signature_39_ = &(stackframe->slots[1]);
  *var_signature_39_ = args[curarg];
  curarg++;
  Object *var_body_39_ = &(stackframe->slots[2]);
  *var_body_39_ = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[3]);
  *var_superclass_39_ = args[curarg];
  curarg++;
  Object *var_constructor_39_ = &(stackframe->slots[4]);
  *var_constructor_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[5]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 6)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[6]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4226 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4226 = alloc_userobj2(22,19, objclass4226);
  gc_frame_newslot(obj4226);
if (objclass4226 == NULL) {
  glfree(obj4226->class->name);
  obj4226->class->name = "classNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4226, self, 0);
  addmethodreal(obj4226,"outer", &reader_ast_outer_4227);
  Object oldself4226 = self;
  struct StackFrameObject *oldstackframe4226 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4226);
  gc_frame_newslot((Object)stackframe);
  self = obj4226;
  Object *oldselfslot4226 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4226 = (*(struct UserObject *)self).data[0], lowerouter4226 = thisouter4226;
  if (inheritingObject4226) {
    struct UserObject *inho4226 = (struct UserObject *)inheritingObject4226;
    while (inho4226->super != GraceDefaultObject) inho4226 = (struct UserObject *)inho4226->super;
    inho4226->super = obj4226;
    self = inheritingObject4226;
    *selfslot = self;
    lowerouter4226 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4226;
  }
if (objclass4226 == NULL) {
  Method *reader4228 = addmethodrealflags(obj4226, "kind",&reader_ast_kind_4228, MFLAG_DEF);
  reader4228->definitionModule = modulename;
  reader4228->definitionLine = 919;
}
adddatum2(obj4226, alloc_Undefined(), 1);
if (objclass4226 == NULL) {
  Method *reader4229 = addmethodrealflags(obj4226, "value",&reader_ast_value_4229, MFLAG_DEF);
  reader4229->definitionModule = modulename;
  reader4229->definitionLine = 920;
}
adddatum2(obj4226, alloc_Undefined(), 2);
if (objclass4226 == NULL) {
  Method *reader4230 = addmethodrealflags(obj4226, "name",&reader_ast_name_4230, MFLAG_DEF);
  reader4230->definitionModule = modulename;
  reader4230->definitionLine = 921;
}
adddatum2(obj4226, alloc_Undefined(), 3);
if (objclass4226 == NULL) {
  Method *reader4231 = addmethodrealflags(obj4226, "constructor",&reader_ast_constructor_4231, MFLAG_DEF);
  reader4231->definitionModule = modulename;
  reader4231->definitionLine = 922;
}
adddatum2(obj4226, alloc_Undefined(), 4);
if (objclass4226 == NULL) {
  Method *reader4232 = addmethodrealflags(obj4226, "signature",&reader_ast_signature_4232, MFLAG_DEF);
  reader4232->definitionModule = modulename;
  reader4232->definitionLine = 923;
}
adddatum2(obj4226, alloc_Undefined(), 5);
if (objclass4226 == NULL) {
  Method *reader4233 = addmethodrealflags(obj4226, "dtype",&reader_ast_dtype_4233, 0);
  Method *writer4233 = addmethodrealflags(obj4226, "dtype:=",&writer_ast_dtype_4233, 0);
  reader4233->definitionModule = modulename;
  writer4233->definitionModule = modulename;
  reader4233->definitionLine = 924;
  writer4233->definitionLine = 924;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 6);
if (objclass4226 == NULL) {
  Method *reader4234 = addmethodrealflags(obj4226, "generics",&reader_ast_generics_4234, 0);
  Method *writer4234 = addmethodrealflags(obj4226, "generics:=",&writer_ast_generics_4234, 0);
  reader4234->definitionModule = modulename;
  writer4234->definitionModule = modulename;
  reader4234->definitionLine = 925;
  writer4234->definitionLine = 925;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 7);
if (objclass4226 == NULL) {
  Method *reader4235 = addmethodrealflags(obj4226, "superclass",&reader_ast_superclass_4235, MFLAG_DEF);
  reader4235->definitionModule = modulename;
  reader4235->definitionLine = 926;
}
adddatum2(obj4226, alloc_Undefined(), 8);
if (objclass4226 == NULL) {
  Method *reader4236 = addmethodrealflags(obj4226, "annotations",&reader_ast_annotations_4236, MFLAG_DEF);
  reader4236->definitionModule = modulename;
  reader4236->definitionLine = 927;
}
adddatum2(obj4226, alloc_Undefined(), 9);
if (objclass4226 == NULL) {
  Method *reader4237 = addmethodrealflags(obj4226, "instanceMethods",&reader_ast_instanceMethods_4237, 0);
  Method *writer4237 = addmethodrealflags(obj4226, "instanceMethods:=",&writer_ast_instanceMethods_4237, 0);
  reader4237->definitionModule = modulename;
  writer4237->definitionModule = modulename;
  reader4237->definitionLine = 928;
  writer4237->definitionLine = 928;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 10);
if (objclass4226 == NULL) {
  Method *reader4238 = addmethodrealflags(obj4226, "data",&reader_ast_data_4238, 0);
  Method *writer4238 = addmethodrealflags(obj4226, "data:=",&writer_ast_data_4238, 0);
  reader4238->definitionModule = modulename;
  writer4238->definitionModule = modulename;
  reader4238->definitionLine = 929;
  writer4238->definitionLine = 929;
}
obj4226->flags |= OFLAG_MUTABLE;
adddatum2(obj4226, alloc_Undefined(), 11);
  struct UserObject *uo4239 = (struct UserObject*)obj4226;
  uo4239->data[12] = emptyclosure;
  Method *meth_meth_ast_accept4239 = addmethod2pos(obj4226, "accept", &meth_ast_accept4239, 12);
int argcv_meth_ast_accept4239[] = {1};
meth_meth_ast_accept4239->type = alloc_MethodType(1, argcv_meth_ast_accept4239);
meth_meth_ast_accept4239->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept4239->type->names[0] = "visitor";
  meth_meth_ast_accept4239->definitionModule = modulename;
  meth_meth_ast_accept4239->definitionLine = 929;
  block_savedest(obj4226);
  Object closure4298 = createclosure(1, "map()before()after");
setclosureframe(closure4298, stackframe);
  addtoclosure(closure4298, var_classNode);
  struct UserObject *uo4298 = (struct UserObject*)obj4226;
  uo4298->data[13] = (Object)closure4298;
  Method *meth_meth_ast_map_40__41_before_40__41_after4298 = addmethod2pos(obj4226, "map()before()after", &meth_ast_map_40__41_before_40__41_after4298, 13);
int argcv_meth_ast_map_40__41_before_40__41_after4298[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after4298->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after4298);
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after4298->definitionLine = 949;
  struct UserObject *uo4363 = (struct UserObject*)obj4226;
  uo4363->data[14] = emptyclosure;
  Method *meth_meth_ast_map4363 = addmethod2pos(obj4226, "map", &meth_ast_map4363, 14);
int argcv_meth_ast_map4363[] = {1};
meth_meth_ast_map4363->type = alloc_MethodType(1, argcv_meth_ast_map4363);
  meth_meth_ast_map4363->definitionModule = modulename;
  meth_meth_ast_map4363->definitionLine = 962;
  struct UserObject *uo4372 = (struct UserObject*)obj4226;
  uo4372->data[15] = emptyclosure;
  Method *meth_meth_ast_pretty4372 = addmethod2pos(obj4226, "pretty", &meth_ast_pretty4372, 15);
int argcv_meth_ast_pretty4372[] = {1};
meth_meth_ast_pretty4372->type = alloc_MethodType(1, argcv_meth_ast_pretty4372);
  meth_meth_ast_pretty4372->definitionModule = modulename;
  meth_meth_ast_pretty4372->definitionLine = 965;
  block_savedest(obj4226);
  Object closure4791 = createclosure(1, "decType");
setclosureframe(closure4791, stackframe);
  addtoclosure(closure4791, var_identifierNode);
  struct UserObject *uo4791 = (struct UserObject*)obj4226;
  uo4791->data[16] = (Object)closure4791;
  Method *meth_meth_ast_decType4791 = addmethod2pos(obj4226, "decType", &meth_ast_decType4791, 16);
int argcv_meth_ast_decType4791[] = {0};
meth_meth_ast_decType4791->type = alloc_MethodType(1, argcv_meth_ast_decType4791);
  meth_meth_ast_decType4791->definitionModule = modulename;
  meth_meth_ast_decType4791->definitionLine = 1010;
  struct UserObject *uo4805 = (struct UserObject*)obj4226;
  uo4805->data[17] = emptyclosure;
  Method *meth_meth_ast_toGrace4805 = addmethod2pos(obj4226, "toGrace", &meth_ast_toGrace4805, 17);
int argcv_meth_ast_toGrace4805[] = {1};
meth_meth_ast_toGrace4805->type = alloc_MethodType(1, argcv_meth_ast_toGrace4805);
meth_meth_ast_toGrace4805->type->types[0] = type_Number;
meth_meth_ast_toGrace4805->type->names[0] = "depth";
  meth_meth_ast_toGrace4805->definitionModule = modulename;
  meth_meth_ast_toGrace4805->definitionLine = 1017;
  sourceObject = obj4226;
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5032 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5033 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5032);
// compilenode returning call5033
  struct UserObject *obj4226_uo = (struct UserObject *)obj4226;
  obj4226_uo->super = call5033;
  sourceObject = obj4226;
// Begin line 918
  setline(918);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5034 == NULL) {
    strlit5034 = alloc_String("class");
    gc_root(strlit5034);
  }
// compilenode returning strlit5034
  adddatum2(obj4226, strlit5034, 1);
  sourceObject = obj4226;
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body_39_
  adddatum2(obj4226, *var_body_39_, 2);
  sourceObject = obj4226;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj4226, *var_name_39_, 3);
  sourceObject = obj4226;
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_constructor_39_
  adddatum2(obj4226, *var_constructor_39_, 4);
  sourceObject = obj4226;
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature_39_
  adddatum2(obj4226, *var_signature_39_, 5);
  sourceObject = obj4226;
// Begin line 923
  setline(923);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj4226, *var_dtype_39_, 6);
  sourceObject = obj4226;
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5035 = alloc_Boolean(0);
// compilenode returning bool5035
  adddatum2(obj4226, bool5035, 7);
  sourceObject = obj4226;
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj4226, *var_superclass_39_, 8);
  sourceObject = obj4226;
// Begin line 926
  setline(926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5036 = gc_frame_new();
  int callframe5037 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5038 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5037);
// compilenode returning call5038
// compilenode returning call5038
  partcv[0] = 0;
  Object call5039 = callmethod(call5038, "new",
    1, partcv, params);
  gc_frame_end(callframe5036);
// compilenode returning call5039
// compilenode returning call5039
  adddatum2(obj4226, call5039, 9);
  sourceObject = obj4226;
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5040 = gc_frame_new();
  int callframe5041 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call5042 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe5041);
// compilenode returning call5042
// compilenode returning call5042
  partcv[0] = 0;
  Object call5043 = callmethod(call5042, "new",
    1, partcv, params);
  gc_frame_end(callframe5040);
// compilenode returning call5043
// compilenode returning call5043
  adddatum2(obj4226, call5043, 10);
  sourceObject = obj4226;
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5044 = alloc_Boolean(0);
// compilenode returning bool5044
  adddatum2(obj4226, bool5044, 11);
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
  sourceObject = obj4226;
objclass4226 = obj4226->class;
  objclass4226->definitionModule = modulename;
  objclass4226->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4226;
  self = oldself4226;
  selfslot = oldselfslot4226;
  stackframe = oldstackframe4226;
  gc_frame_end(frame);
  return obj4226;
}
Object meth_ast_objectNode5046(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "objectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for objectNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for objectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_objectNode
  gc_frame_end(frame);
  return *var_objectNode;
}
Object meth_ast__apply5077(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5078 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_x
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5079 = callmethod(*var_x, "accept",
    1, partcv, params);
  gc_frame_end(callframe5078);
// compilenode returning call5079
  gc_frame_end(frame);
  return call5079;
}
Object meth_ast_accept5058(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5060 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5061 = callmethod(*var_visitor, "visitObject",
    1, partcv, params);
  gc_frame_end(callframe5060);
// compilenode returning call5061
  Object if5059 = done;
  if (istrue(call5061)) {
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5064 = alloc_Boolean(0);
// compilenode returning bool5064
  int op_slot_right_5063 = gc_frame_newslot(bool5064);
  int callframe5066 = gc_frame_new();
  partcv[0] = 0;
  Object call5067 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5066);
// compilenode returning call5067
// compilenode returning call5067
  int op_slot_left_5063 = gc_frame_newslot(call5067);
  params[0] = bool5064;
  partcv[0] = 1;
  Object opresult5068 = callmethod(call5067, "!=", 1, partcv, params);
// compilenode returning opresult5068
  Object if5062 = done;
  if (istrue(opresult5068)) {
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5069 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5070 = gc_frame_new();
  partcv[0] = 0;
  Object call5071 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5070);
// compilenode returning call5071
// compilenode returning call5071
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5072 = callmethod(call5071, "accept",
    1, partcv, params);
  gc_frame_end(callframe5069);
// compilenode returning call5072
    gc_frame_newslot(call5072);
    if5062 = call5072;
  } else {
  }
// compilenode returning if5062
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5073 = gc_frame_new();
  int callframe5074 = gc_frame_new();
  partcv[0] = 0;
  Object call5075 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5074);
// compilenode returning call5075
// compilenode returning call5075
  gc_frame_newslot(call5075);
  Object block5076 = alloc_Block(NULL, NULL, "ast", 1068);
  gc_frame_newslot(block5076);
  block_savedest(block5076);
  Object closure5077 = createclosure(2, "_apply");
setclosureframe(closure5077, stackframe);
  addtoclosure(closure5077, var_visitor);
  addtoclosure(closure5077, selfslot);
  struct UserObject *uo5077 = (struct UserObject*)block5076;
  uo5077->data[0] = (Object)closure5077;
  Method *meth_meth_ast__apply5077 = addmethod2pos(block5076, "_apply", &meth_ast__apply5077, 0);
int argcv_meth_ast__apply5077[] = {1};
meth_meth_ast__apply5077->type = alloc_MethodType(1, argcv_meth_ast__apply5077);
  meth_meth_ast__apply5077->definitionModule = modulename;
  meth_meth_ast__apply5077->definitionLine = 1068;
// compilenode returning block5076
  gc_frame_newslot(block5076);
  params[0] = call5075;
  params[1] = block5076;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5081 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5073);
// compilenode returning call5081
    gc_frame_newslot(call5081);
    if5059 = call5081;
  } else {
  }
// compilenode returning if5059
  gc_frame_end(frame);
  return if5059;
}
Object meth_ast_map_40__41_before_40__41_after5082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_objectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5083 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5084 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5083);
// compilenode returning call5084
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5085 = gc_frame_new();
  int callframe5086 = gc_frame_new();
  int callframe5087 = gc_frame_new();
  partcv[0] = 0;
  Object call5088 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5087);
// compilenode returning call5088
  gc_frame_newslot(call5088);
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5089 = gc_frame_new();
  int callframe5090 = gc_frame_new();
  Object call5091 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5090);
// compilenode returning call5091
// compilenode returning call5091
  partcv[0] = 0;
  Object call5092 = callmethodflags(call5091, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5089);
// compilenode returning call5092
// compilenode returning call5092
  params[0] = call5088;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5093 = callmethodflags(call5092, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5086);
// compilenode returning call5093
  gc_frame_newslot(call5093);
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5094 = gc_frame_new();
  int callframe5095 = gc_frame_new();
  partcv[0] = 0;
  Object call5096 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5095);
// compilenode returning call5096
  gc_frame_newslot(call5096);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5097 = gc_frame_new();
  int callframe5098 = gc_frame_new();
  Object call5099 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5098);
// compilenode returning call5099
// compilenode returning call5099
  partcv[0] = 0;
  Object call5100 = callmethodflags(call5099, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5097);
// compilenode returning call5100
// compilenode returning call5100
  params[0] = call5096;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call5101 = callmethodflags(call5100, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5094);
// compilenode returning call5101
  gc_frame_newslot(call5101);
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_objectNode
  params[0] = call5093;
  params[1] = call5101;
  partcv[0] = 2;
  Object call5102 = callmethod(*var_objectNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5085);
// compilenode returning call5102
  *var_n = call5102;
  if (call5102 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5103 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5104 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5103);
// compilenode returning call5104
  *var_n = call5104;
  if (call5104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5106 = gc_frame_new();
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5107 = gc_frame_new();
  partcv[0] = 0;
  Object call5108 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5107);
// compilenode returning call5108
  gc_frame_newslot(call5108);
// compilenode returning *var_n
  params[0] = call5108;
  partcv[0] = 1;
  Object call5109 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5106);
// compilenode returning call5109
// compilenode returning done
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5110 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5111 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5110);
// compilenode returning call5111
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5115(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5118(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5113 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5114 = alloc_Block(NULL, NULL, "ast", 1084);
  gc_frame_newslot(block5114);
  block_savedest(block5114);
  Object closure5115 = createclosure(1, "_apply");
setclosureframe(closure5115, stackframe);
  addtoclosure(closure5115, selfslot);
  struct UserObject *uo5115 = (struct UserObject*)block5114;
  uo5115->data[0] = (Object)closure5115;
  Method *meth_meth_ast__apply5115 = addmethod2pos(block5114, "_apply", &meth_ast__apply5115, 0);
int argcv_meth_ast__apply5115[] = {0};
meth_meth_ast__apply5115->type = alloc_MethodType(1, argcv_meth_ast__apply5115);
  meth_meth_ast__apply5115->definitionModule = modulename;
  meth_meth_ast__apply5115->definitionLine = 1076;
// compilenode returning block5114
  gc_frame_newslot(block5114);
  Object block5117 = alloc_Block(NULL, NULL, "ast", 1084);
  gc_frame_newslot(block5117);
  block_savedest(block5117);
  Object closure5118 = createclosure(1, "_apply");
setclosureframe(closure5118, stackframe);
  addtoclosure(closure5118, selfslot);
  struct UserObject *uo5118 = (struct UserObject*)block5117;
  uo5118->data[0] = (Object)closure5118;
  Method *meth_meth_ast__apply5118 = addmethod2pos(block5117, "_apply", &meth_ast__apply5118, 0);
int argcv_meth_ast__apply5118[] = {0};
meth_meth_ast__apply5118->type = alloc_MethodType(1, argcv_meth_ast__apply5118);
  meth_meth_ast__apply5118->definitionModule = modulename;
  meth_meth_ast__apply5118->definitionLine = 1076;
// compilenode returning block5117
  gc_frame_newslot(block5117);
  params[0] = *var_blk;
  params[1] = block5114;
  params[2] = block5117;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5120 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5113);
// compilenode returning call5120
  gc_frame_end(frame);
  return call5120;
}
Object meth_ast__apply5129(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5131 == NULL) {
    strlit5131 = alloc_String("  ");
    gc_root(strlit5131);
  }
// compilenode returning strlit5131
  int op_slot_right_5130 = gc_frame_newslot(strlit5131);
// compilenode returning *var_spc
  int op_slot_left_5130 = gc_frame_newslot(*var_spc);
  params[0] = strlit5131;
  partcv[0] = 1;
  Object opresult5133 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5133
  *var_spc = opresult5133;
  if (opresult5133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5197(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1100
  setline(1100);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5199 = gc_frame_new();
  Object num5201 = alloc_Float64(1);
// compilenode returning num5201
  int op_slot_right_5200 = gc_frame_newslot(num5201);
// compilenode returning *var_depth
  int op_slot_left_5200 = gc_frame_newslot(*var_depth);
  params[0] = num5201;
  partcv[0] = 1;
  Object sum5203 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5203
  gc_frame_newslot(sum5203);
// compilenode returning *var_x
  params[0] = sum5203;
  partcv[0] = 1;
  Object call5204 = callmethod(*var_x, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5199);
// compilenode returning call5204
  int op_slot_right_5198 = gc_frame_newslot(call5204);
// compilenode returning *var_spc
  int op_slot_right_5206 = gc_frame_newslot(*var_spc);
  if (strlit5209 == NULL) {
    strlit5209 = alloc_String("""\x0a""");
    gc_root(strlit5209);
  }
// compilenode returning strlit5209
  int op_slot_right_5208 = gc_frame_newslot(strlit5209);
// compilenode returning *var_s
  int op_slot_left_5208 = gc_frame_newslot(*var_s);
  params[0] = strlit5209;
  partcv[0] = 1;
  Object opresult5211 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5211
  int op_slot_left_5206 = gc_frame_newslot(opresult5211);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5212 = callmethod(opresult5211, "++", 1, partcv, params);
// compilenode returning opresult5212
  int op_slot_left_5198 = gc_frame_newslot(opresult5212);
  params[0] = call5204;
  partcv[0] = 1;
  Object opresult5213 = callmethod(opresult5212, "++", 1, partcv, params);
// compilenode returning opresult5213
  *var_s = opresult5213;
  if (opresult5213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5121(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth_39_ = &(stackframe->slots[0]);
  *var_depth_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_depth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "depth");
  Object *var_spc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "spc");
  Object *var_s = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "s");
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_depth_39_
  *var_depth = *var_depth_39_;
  if (*var_depth_39_ == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("");
    gc_root(strlit5122);
  }
// compilenode returning strlit5122
  *var_spc = strlit5122;
  if (strlit5122 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5123 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5124 = gc_frame_newslot(*var_depth);
  Object num5126 = alloc_Float64(0);
// compilenode returning num5126
  int op_slot_left_5124 = gc_frame_newslot(num5126);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5127 = callmethod(num5126, "..", 1, partcv, params);
// compilenode returning opresult5127
  gc_frame_newslot(opresult5127);
  Object block5128 = alloc_Block(NULL, NULL, "ast", 1089);
  gc_frame_newslot(block5128);
  block_savedest(block5128);
  Object closure5129 = createclosure(2, "_apply");
setclosureframe(closure5129, stackframe);
  addtoclosure(closure5129, var_spc);
  addtoclosure(closure5129, selfslot);
  struct UserObject *uo5129 = (struct UserObject*)block5128;
  uo5129->data[0] = (Object)closure5129;
  Method *meth_meth_ast__apply5129 = addmethod2pos(block5128, "_apply", &meth_ast__apply5129, 0);
int argcv_meth_ast__apply5129[] = {1};
meth_meth_ast__apply5129->type = alloc_MethodType(1, argcv_meth_ast__apply5129);
  meth_meth_ast__apply5129->definitionModule = modulename;
  meth_meth_ast__apply5129->definitionLine = 1076;
// compilenode returning block5128
  gc_frame_newslot(block5128);
  params[0] = opresult5127;
  params[1] = block5128;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5136 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5123);
// compilenode returning call5136
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5137 == NULL) {
    strlit5137 = alloc_String("Object");
    gc_root(strlit5137);
  }
// compilenode returning strlit5137
  *var_s = strlit5137;
  if (strlit5137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5140 = alloc_Boolean(0);
// compilenode returning bool5140
  int op_slot_right_5139 = gc_frame_newslot(bool5140);
  int callframe5142 = gc_frame_new();
  partcv[0] = 0;
  Object call5143 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5142);
// compilenode returning call5143
// compilenode returning call5143
  int op_slot_left_5139 = gc_frame_newslot(call5143);
  params[0] = bool5140;
  partcv[0] = 1;
  Object opresult5144 = callmethod(call5143, "!=", 1, partcv, params);
// compilenode returning opresult5144
  Object if5138 = done;
  if (istrue(opresult5144)) {
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5146 == NULL) {
    strlit5146 = alloc_String("Superclass:");
    gc_root(strlit5146);
  }
// compilenode returning strlit5146
  int op_slot_right_5145 = gc_frame_newslot(strlit5146);
// compilenode returning *var_spc
  int op_slot_right_5148 = gc_frame_newslot(*var_spc);
  if (strlit5151 == NULL) {
    strlit5151 = alloc_String("""\x0a""");
    gc_root(strlit5151);
  }
// compilenode returning strlit5151
  int op_slot_right_5150 = gc_frame_newslot(strlit5151);
// compilenode returning *var_s
  int op_slot_left_5150 = gc_frame_newslot(*var_s);
  params[0] = strlit5151;
  partcv[0] = 1;
  Object opresult5153 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5153
  int op_slot_left_5148 = gc_frame_newslot(opresult5153);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5154 = callmethod(opresult5153, "++", 1, partcv, params);
// compilenode returning opresult5154
  int op_slot_left_5145 = gc_frame_newslot(opresult5154);
  params[0] = strlit5146;
  partcv[0] = 1;
  Object opresult5155 = callmethod(opresult5154, "++", 1, partcv, params);
// compilenode returning opresult5155
  *var_s = opresult5155;
  if (opresult5155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5158 = gc_frame_new();
  Object num5160 = alloc_Float64(1);
// compilenode returning num5160
  int op_slot_right_5159 = gc_frame_newslot(num5160);
// compilenode returning *var_depth
  int op_slot_left_5159 = gc_frame_newslot(*var_depth);
  params[0] = num5160;
  partcv[0] = 1;
  Object sum5162 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5162
  gc_frame_newslot(sum5162);
  int callframe5163 = gc_frame_new();
  partcv[0] = 0;
  Object call5164 = callmethodflags(self, "superclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5163);
// compilenode returning call5164
// compilenode returning call5164
  params[0] = sum5162;
  partcv[0] = 1;
  Object call5165 = callmethod(call5164, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5158);
// compilenode returning call5165
  int op_slot_right_5157 = gc_frame_newslot(call5165);
// compilenode returning *var_spc
  int op_slot_right_5167 = gc_frame_newslot(*var_spc);
  if (strlit5170 == NULL) {
    strlit5170 = alloc_String("""\x0a""  ");
    gc_root(strlit5170);
  }
// compilenode returning strlit5170
  int op_slot_right_5169 = gc_frame_newslot(strlit5170);
// compilenode returning *var_s
  int op_slot_left_5169 = gc_frame_newslot(*var_s);
  params[0] = strlit5170;
  partcv[0] = 1;
  Object opresult5172 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5172
  int op_slot_left_5167 = gc_frame_newslot(opresult5172);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5173 = callmethod(opresult5172, "++", 1, partcv, params);
// compilenode returning opresult5173
  int op_slot_left_5157 = gc_frame_newslot(opresult5173);
  params[0] = call5165;
  partcv[0] = 1;
  Object opresult5174 = callmethod(opresult5173, "++", 1, partcv, params);
// compilenode returning opresult5174
  *var_s = opresult5174;
  if (opresult5174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5177 == NULL) {
    strlit5177 = alloc_String("Body:");
    gc_root(strlit5177);
  }
// compilenode returning strlit5177
  int op_slot_right_5176 = gc_frame_newslot(strlit5177);
// compilenode returning *var_spc
  int op_slot_right_5179 = gc_frame_newslot(*var_spc);
  if (strlit5182 == NULL) {
    strlit5182 = alloc_String("""\x0a""");
    gc_root(strlit5182);
  }
// compilenode returning strlit5182
  int op_slot_right_5181 = gc_frame_newslot(strlit5182);
// compilenode returning *var_s
  int op_slot_left_5181 = gc_frame_newslot(*var_s);
  params[0] = strlit5182;
  partcv[0] = 1;
  Object opresult5184 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5184
  int op_slot_left_5179 = gc_frame_newslot(opresult5184);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5185 = callmethod(opresult5184, "++", 1, partcv, params);
// compilenode returning opresult5185
  int op_slot_left_5176 = gc_frame_newslot(opresult5185);
  params[0] = strlit5177;
  partcv[0] = 1;
  Object opresult5186 = callmethod(opresult5185, "++", 1, partcv, params);
// compilenode returning opresult5186
  *var_s = opresult5186;
  if (opresult5186 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1097
  setline(1097);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5189 = alloc_Float64(1);
// compilenode returning num5189
  int op_slot_right_5188 = gc_frame_newslot(num5189);
// compilenode returning *var_depth
  int op_slot_left_5188 = gc_frame_newslot(*var_depth);
  params[0] = num5189;
  partcv[0] = 1;
  Object sum5191 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5191
  *var_depth = sum5191;
  if (sum5191 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5138 = done;
  } else {
  }
// compilenode returning if5138
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5193 = gc_frame_new();
  int callframe5194 = gc_frame_new();
  partcv[0] = 0;
  Object call5195 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5194);
// compilenode returning call5195
// compilenode returning call5195
  gc_frame_newslot(call5195);
  Object block5196 = alloc_Block(NULL, NULL, "ast", 1099);
  gc_frame_newslot(block5196);
  block_savedest(block5196);
  Object closure5197 = createclosure(4, "_apply");
setclosureframe(closure5197, stackframe);
  addtoclosure(closure5197, var_depth);
  addtoclosure(closure5197, var_spc);
  addtoclosure(closure5197, var_s);
  addtoclosure(closure5197, selfslot);
  struct UserObject *uo5197 = (struct UserObject*)block5196;
  uo5197->data[0] = (Object)closure5197;
  Method *meth_meth_ast__apply5197 = addmethod2pos(block5196, "_apply", &meth_ast__apply5197, 0);
int argcv_meth_ast__apply5197[] = {1};
meth_meth_ast__apply5197->type = alloc_MethodType(1, argcv_meth_ast__apply5197);
  meth_meth_ast__apply5197->definitionModule = modulename;
  meth_meth_ast__apply5197->definitionLine = 1099;
// compilenode returning block5196
  gc_frame_newslot(block5196);
  params[0] = call5195;
  params[1] = block5196;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5216 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5193);
// compilenode returning call5216
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5229(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5231 == NULL) {
    strlit5231 = alloc_String("    ");
    gc_root(strlit5231);
  }
// compilenode returning strlit5231
  int op_slot_right_5230 = gc_frame_newslot(strlit5231);
// compilenode returning *var_spc
  int op_slot_left_5230 = gc_frame_newslot(*var_spc);
  params[0] = strlit5231;
  partcv[0] = 1;
  Object opresult5233 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5233
  *var_spc = opresult5233;
  if (opresult5233 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5242(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1111
  setline(1111);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5244 = gc_frame_new();
  Object num5246 = alloc_Float64(1);
// compilenode returning num5246
  int op_slot_right_5245 = gc_frame_newslot(num5246);
// compilenode returning *var_depth
  int op_slot_left_5245 = gc_frame_newslot(*var_depth);
  params[0] = num5246;
  partcv[0] = 1;
  Object sum5248 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5248
  gc_frame_newslot(sum5248);
// compilenode returning *var_x
  params[0] = sum5248;
  partcv[0] = 1;
  Object call5249 = callmethod(*var_x, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5244);
// compilenode returning call5249
  int op_slot_right_5243 = gc_frame_newslot(call5249);
  if (strlit5252 == NULL) {
    strlit5252 = alloc_String("    ");
    gc_root(strlit5252);
  }
// compilenode returning strlit5252
  int op_slot_right_5251 = gc_frame_newslot(strlit5252);
// compilenode returning *var_spc
  int op_slot_right_5254 = gc_frame_newslot(*var_spc);
  if (strlit5257 == NULL) {
    strlit5257 = alloc_String("""\x0a""");
    gc_root(strlit5257);
  }
// compilenode returning strlit5257
  int op_slot_right_5256 = gc_frame_newslot(strlit5257);
// compilenode returning *var_s
  int op_slot_left_5256 = gc_frame_newslot(*var_s);
  params[0] = strlit5257;
  partcv[0] = 1;
  Object opresult5259 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5259
  int op_slot_left_5254 = gc_frame_newslot(opresult5259);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5260 = callmethod(opresult5259, "++", 1, partcv, params);
// compilenode returning opresult5260
  int op_slot_left_5251 = gc_frame_newslot(opresult5260);
  params[0] = strlit5252;
  partcv[0] = 1;
  Object opresult5261 = callmethod(opresult5260, "++", 1, partcv, params);
// compilenode returning opresult5261
  int op_slot_left_5243 = gc_frame_newslot(opresult5261);
  params[0] = call5249;
  partcv[0] = 1;
  Object opresult5262 = callmethod(opresult5261, "++", 1, partcv, params);
// compilenode returning opresult5262
  *var_s = opresult5262;
  if (opresult5262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace5217(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5218 == NULL) {
    strlit5218 = alloc_String("");
    gc_root(strlit5218);
  }
// compilenode returning strlit5218
  *var_spc = strlit5218;
  if (strlit5218 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5219 = gc_frame_new();
  Object num5222 = alloc_Float64(1);
// compilenode returning num5222
  int op_slot_right_5221 = gc_frame_newslot(num5222);
// compilenode returning *var_depth
  int op_slot_left_5221 = gc_frame_newslot(*var_depth);
  params[0] = num5222;
  partcv[0] = 1;
  Object diff5224 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff5224
  int op_slot_right_5220 = gc_frame_newslot(diff5224);
  Object num5226 = alloc_Float64(0);
// compilenode returning num5226
  int op_slot_left_5220 = gc_frame_newslot(num5226);
  params[0] = diff5224;
  partcv[0] = 1;
  Object opresult5227 = callmethod(num5226, "..", 1, partcv, params);
// compilenode returning opresult5227
  gc_frame_newslot(opresult5227);
  Object block5228 = alloc_Block(NULL, NULL, "ast", 1106);
  gc_frame_newslot(block5228);
  block_savedest(block5228);
  Object closure5229 = createclosure(2, "_apply");
setclosureframe(closure5229, stackframe);
  addtoclosure(closure5229, var_spc);
  addtoclosure(closure5229, selfslot);
  struct UserObject *uo5229 = (struct UserObject*)block5228;
  uo5229->data[0] = (Object)closure5229;
  Method *meth_meth_ast__apply5229 = addmethod2pos(block5228, "_apply", &meth_ast__apply5229, 0);
int argcv_meth_ast__apply5229[] = {1};
meth_meth_ast__apply5229->type = alloc_MethodType(1, argcv_meth_ast__apply5229);
  meth_meth_ast__apply5229->definitionModule = modulename;
  meth_meth_ast__apply5229->definitionLine = 1099;
// compilenode returning block5228
  gc_frame_newslot(block5228);
  params[0] = opresult5227;
  params[1] = block5228;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5236 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5219);
// compilenode returning call5236
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5237 == NULL) {
    strlit5237 = alloc_String("object {");
    gc_root(strlit5237);
  }
// compilenode returning strlit5237
  *var_s = strlit5237;
  if (strlit5237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5238 = gc_frame_new();
  int callframe5239 = gc_frame_new();
  partcv[0] = 0;
  Object call5240 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5239);
// compilenode returning call5240
// compilenode returning call5240
  gc_frame_newslot(call5240);
  Object block5241 = alloc_Block(NULL, NULL, "ast", 1110);
  gc_frame_newslot(block5241);
  block_savedest(block5241);
  Object closure5242 = createclosure(4, "_apply");
setclosureframe(closure5242, stackframe);
  addtoclosure(closure5242, var_depth);
  addtoclosure(closure5242, var_spc);
  addtoclosure(closure5242, var_s);
  addtoclosure(closure5242, selfslot);
  struct UserObject *uo5242 = (struct UserObject*)block5241;
  uo5242->data[0] = (Object)closure5242;
  Method *meth_meth_ast__apply5242 = addmethod2pos(block5241, "_apply", &meth_ast__apply5242, 0);
int argcv_meth_ast__apply5242[] = {1};
meth_meth_ast__apply5242->type = alloc_MethodType(1, argcv_meth_ast__apply5242);
  meth_meth_ast__apply5242->definitionModule = modulename;
  meth_meth_ast__apply5242->definitionLine = 1110;
// compilenode returning block5241
  gc_frame_newslot(block5241);
  params[0] = call5240;
  params[1] = block5241;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5265 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5238);
// compilenode returning call5265
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1113
  setline(1113);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5267 == NULL) {
    strlit5267 = alloc_String("}");
    gc_root(strlit5267);
  }
// compilenode returning strlit5267
  int op_slot_right_5266 = gc_frame_newslot(strlit5267);
// compilenode returning *var_spc
  int op_slot_right_5269 = gc_frame_newslot(*var_spc);
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("""\x0a""");
    gc_root(strlit5272);
  }
// compilenode returning strlit5272
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// compilenode returning *var_s
  int op_slot_left_5271 = gc_frame_newslot(*var_s);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5274 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5274
  int op_slot_left_5269 = gc_frame_newslot(opresult5274);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5275 = callmethod(opresult5274, "++", 1, partcv, params);
// compilenode returning opresult5275
  int op_slot_left_5266 = gc_frame_newslot(opresult5275);
  params[0] = strlit5267;
  partcv[0] = 1;
  Object opresult5276 = callmethod(opresult5275, "++", 1, partcv, params);
// compilenode returning opresult5276
  *var_s = opresult5276;
  if (opresult5276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5049(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_objectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5050 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5050 = alloc_userobj2(15,13, objclass5050);
  gc_frame_newslot(obj5050);
if (objclass5050 == NULL) {
  glfree(obj5050->class->name);
  obj5050->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5050, self, 0);
  addmethodreal(obj5050,"outer", &reader_ast_outer_5051);
  Object oldself5050 = self;
  struct StackFrameObject *oldstackframe5050 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5050);
  gc_frame_newslot((Object)stackframe);
  self = obj5050;
  Object *oldselfslot5050 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5050 = (*(struct UserObject *)self).data[0], lowerouter5050 = thisouter5050;
  if (inheritingObject5050) {
    struct UserObject *inho5050 = (struct UserObject *)inheritingObject5050;
    while (inho5050->super != GraceDefaultObject) inho5050 = (struct UserObject *)inho5050->super;
    inho5050->super = obj5050;
    self = inheritingObject5050;
    *selfslot = self;
    lowerouter5050 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5050;
  }
if (objclass5050 == NULL) {
  Method *reader5052 = addmethodrealflags(obj5050, "kind",&reader_ast_kind_5052, MFLAG_DEF);
  reader5052->definitionModule = modulename;
  reader5052->definitionLine = 1058;
}
adddatum2(obj5050, alloc_Undefined(), 1);
if (objclass5050 == NULL) {
  Method *reader5053 = addmethodrealflags(obj5050, "value",&reader_ast_value_5053, MFLAG_DEF);
  reader5053->definitionModule = modulename;
  reader5053->definitionLine = 1059;
}
adddatum2(obj5050, alloc_Undefined(), 2);
if (objclass5050 == NULL) {
  Method *reader5054 = addmethodrealflags(obj5050, "superclass",&reader_ast_superclass_5054, MFLAG_DEF);
  reader5054->definitionModule = modulename;
  reader5054->definitionLine = 1060;
}
adddatum2(obj5050, alloc_Undefined(), 3);
if (objclass5050 == NULL) {
  Method *reader5055 = addmethodrealflags(obj5050, "otype",&reader_ast_otype_5055, 0);
  Method *writer5055 = addmethodrealflags(obj5050, "otype:=",&writer_ast_otype_5055, 0);
  reader5055->definitionModule = modulename;
  writer5055->definitionModule = modulename;
  reader5055->definitionLine = 1061;
  writer5055->definitionLine = 1061;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 4);
if (objclass5050 == NULL) {
  Method *reader5056 = addmethodrealflags(obj5050, "classname",&reader_ast_classname_5056, 0);
  Method *writer5056 = addmethodrealflags(obj5050, "classname:=",&writer_ast_classname_5056, 0);
  reader5056->definitionModule = modulename;
  writer5056->definitionModule = modulename;
  reader5056->definitionLine = 1062;
  writer5056->definitionLine = 1062;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 5);
if (objclass5050 == NULL) {
  Method *reader5057 = addmethodrealflags(obj5050, "data",&reader_ast_data_5057, 0);
  Method *writer5057 = addmethodrealflags(obj5050, "data:=",&writer_ast_data_5057, 0);
  reader5057->definitionModule = modulename;
  writer5057->definitionModule = modulename;
  reader5057->definitionLine = 1063;
  writer5057->definitionLine = 1063;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 6);
  struct UserObject *uo5058 = (struct UserObject*)obj5050;
  uo5058->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5058 = addmethod2pos(obj5050, "accept", &meth_ast_accept5058, 7);
int argcv_meth_ast_accept5058[] = {1};
meth_meth_ast_accept5058->type = alloc_MethodType(1, argcv_meth_ast_accept5058);
meth_meth_ast_accept5058->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5058->type->names[0] = "visitor";
  meth_meth_ast_accept5058->definitionModule = modulename;
  meth_meth_ast_accept5058->definitionLine = 1063;
  block_savedest(obj5050);
  Object closure5082 = createclosure(1, "map()before()after");
setclosureframe(closure5082, stackframe);
  addtoclosure(closure5082, var_objectNode);
  struct UserObject *uo5082 = (struct UserObject*)obj5050;
  uo5082->data[8] = (Object)closure5082;
  Method *meth_meth_ast_map_40__41_before_40__41_after5082 = addmethod2pos(obj5050, "map()before()after", &meth_ast_map_40__41_before_40__41_after5082, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5082[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5082->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5082);
  meth_meth_ast_map_40__41_before_40__41_after5082->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5082->definitionLine = 1073;
  struct UserObject *uo5112 = (struct UserObject*)obj5050;
  uo5112->data[9] = emptyclosure;
  Method *meth_meth_ast_map5112 = addmethod2pos(obj5050, "map", &meth_ast_map5112, 9);
int argcv_meth_ast_map5112[] = {1};
meth_meth_ast_map5112->type = alloc_MethodType(1, argcv_meth_ast_map5112);
  meth_meth_ast_map5112->definitionModule = modulename;
  meth_meth_ast_map5112->definitionLine = 1083;
  struct UserObject *uo5121 = (struct UserObject*)obj5050;
  uo5121->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5121 = addmethod2pos(obj5050, "pretty", &meth_ast_pretty5121, 10);
int argcv_meth_ast_pretty5121[] = {1};
meth_meth_ast_pretty5121->type = alloc_MethodType(1, argcv_meth_ast_pretty5121);
  meth_meth_ast_pretty5121->definitionModule = modulename;
  meth_meth_ast_pretty5121->definitionLine = 1086;
  struct UserObject *uo5217 = (struct UserObject*)obj5050;
  uo5217->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace5217 = addmethod2pos(obj5050, "toGrace", &meth_ast_toGrace5217, 11);
int argcv_meth_ast_toGrace5217[] = {1};
meth_meth_ast_toGrace5217->type = alloc_MethodType(1, argcv_meth_ast_toGrace5217);
meth_meth_ast_toGrace5217->type->types[0] = type_Number;
meth_meth_ast_toGrace5217->type->names[0] = "depth";
  meth_meth_ast_toGrace5217->definitionModule = modulename;
  meth_meth_ast_toGrace5217->definitionLine = 1104;
  sourceObject = obj5050;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5278);
// compilenode returning call5279
  struct UserObject *obj5050_uo = (struct UserObject *)obj5050;
  obj5050_uo->super = call5279;
  sourceObject = obj5050;
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5280 == NULL) {
    strlit5280 = alloc_String("object");
    gc_root(strlit5280);
  }
// compilenode returning strlit5280
  adddatum2(obj5050, strlit5280, 1);
  sourceObject = obj5050;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body
  adddatum2(obj5050, *var_body, 2);
  sourceObject = obj5050;
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj5050, *var_superclass_39_, 3);
  sourceObject = obj5050;
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5281 = alloc_Boolean(0);
// compilenode returning bool5281
  adddatum2(obj5050, bool5281, 4);
  sourceObject = obj5050;
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5282 == NULL) {
    strlit5282 = alloc_String("object");
    gc_root(strlit5282);
  }
// compilenode returning strlit5282
  adddatum2(obj5050, strlit5282, 5);
  sourceObject = obj5050;
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5283 = alloc_Boolean(0);
// compilenode returning bool5283
  adddatum2(obj5050, bool5283, 6);
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
objclass5050 = obj5050->class;
  objclass5050->definitionModule = modulename;
  objclass5050->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5050;
  self = oldself5050;
  selfslot = oldselfslot5050;
  stackframe = oldstackframe5050;
  gc_frame_end(frame);
  return obj5050;
}
Object meth_ast_new5049_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_objectNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_body = &(stackframe->slots[0]);
  *var_body = args[curarg];
  curarg++;
  Object *var_superclass_39_ = &(stackframe->slots[1]);
  *var_superclass_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5050 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5050 = alloc_userobj2(15,13, objclass5050);
  gc_frame_newslot(obj5050);
if (objclass5050 == NULL) {
  glfree(obj5050->class->name);
  obj5050->class->name = "objectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5050, self, 0);
  addmethodreal(obj5050,"outer", &reader_ast_outer_5051);
  Object oldself5050 = self;
  struct StackFrameObject *oldstackframe5050 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5050);
  gc_frame_newslot((Object)stackframe);
  self = obj5050;
  Object *oldselfslot5050 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5050 = (*(struct UserObject *)self).data[0], lowerouter5050 = thisouter5050;
  if (inheritingObject5050) {
    struct UserObject *inho5050 = (struct UserObject *)inheritingObject5050;
    while (inho5050->super != GraceDefaultObject) inho5050 = (struct UserObject *)inho5050->super;
    inho5050->super = obj5050;
    self = inheritingObject5050;
    *selfslot = self;
    lowerouter5050 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5050;
  }
if (objclass5050 == NULL) {
  Method *reader5052 = addmethodrealflags(obj5050, "kind",&reader_ast_kind_5052, MFLAG_DEF);
  reader5052->definitionModule = modulename;
  reader5052->definitionLine = 1058;
}
adddatum2(obj5050, alloc_Undefined(), 1);
if (objclass5050 == NULL) {
  Method *reader5053 = addmethodrealflags(obj5050, "value",&reader_ast_value_5053, MFLAG_DEF);
  reader5053->definitionModule = modulename;
  reader5053->definitionLine = 1059;
}
adddatum2(obj5050, alloc_Undefined(), 2);
if (objclass5050 == NULL) {
  Method *reader5054 = addmethodrealflags(obj5050, "superclass",&reader_ast_superclass_5054, MFLAG_DEF);
  reader5054->definitionModule = modulename;
  reader5054->definitionLine = 1060;
}
adddatum2(obj5050, alloc_Undefined(), 3);
if (objclass5050 == NULL) {
  Method *reader5055 = addmethodrealflags(obj5050, "otype",&reader_ast_otype_5055, 0);
  Method *writer5055 = addmethodrealflags(obj5050, "otype:=",&writer_ast_otype_5055, 0);
  reader5055->definitionModule = modulename;
  writer5055->definitionModule = modulename;
  reader5055->definitionLine = 1061;
  writer5055->definitionLine = 1061;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 4);
if (objclass5050 == NULL) {
  Method *reader5056 = addmethodrealflags(obj5050, "classname",&reader_ast_classname_5056, 0);
  Method *writer5056 = addmethodrealflags(obj5050, "classname:=",&writer_ast_classname_5056, 0);
  reader5056->definitionModule = modulename;
  writer5056->definitionModule = modulename;
  reader5056->definitionLine = 1062;
  writer5056->definitionLine = 1062;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 5);
if (objclass5050 == NULL) {
  Method *reader5057 = addmethodrealflags(obj5050, "data",&reader_ast_data_5057, 0);
  Method *writer5057 = addmethodrealflags(obj5050, "data:=",&writer_ast_data_5057, 0);
  reader5057->definitionModule = modulename;
  writer5057->definitionModule = modulename;
  reader5057->definitionLine = 1063;
  writer5057->definitionLine = 1063;
}
obj5050->flags |= OFLAG_MUTABLE;
adddatum2(obj5050, alloc_Undefined(), 6);
  struct UserObject *uo5058 = (struct UserObject*)obj5050;
  uo5058->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5058 = addmethod2pos(obj5050, "accept", &meth_ast_accept5058, 7);
int argcv_meth_ast_accept5058[] = {1};
meth_meth_ast_accept5058->type = alloc_MethodType(1, argcv_meth_ast_accept5058);
meth_meth_ast_accept5058->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5058->type->names[0] = "visitor";
  meth_meth_ast_accept5058->definitionModule = modulename;
  meth_meth_ast_accept5058->definitionLine = 1063;
  block_savedest(obj5050);
  Object closure5082 = createclosure(1, "map()before()after");
setclosureframe(closure5082, stackframe);
  addtoclosure(closure5082, var_objectNode);
  struct UserObject *uo5082 = (struct UserObject*)obj5050;
  uo5082->data[8] = (Object)closure5082;
  Method *meth_meth_ast_map_40__41_before_40__41_after5082 = addmethod2pos(obj5050, "map()before()after", &meth_ast_map_40__41_before_40__41_after5082, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5082[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5082->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5082);
  meth_meth_ast_map_40__41_before_40__41_after5082->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5082->definitionLine = 1073;
  struct UserObject *uo5112 = (struct UserObject*)obj5050;
  uo5112->data[9] = emptyclosure;
  Method *meth_meth_ast_map5112 = addmethod2pos(obj5050, "map", &meth_ast_map5112, 9);
int argcv_meth_ast_map5112[] = {1};
meth_meth_ast_map5112->type = alloc_MethodType(1, argcv_meth_ast_map5112);
  meth_meth_ast_map5112->definitionModule = modulename;
  meth_meth_ast_map5112->definitionLine = 1083;
  struct UserObject *uo5121 = (struct UserObject*)obj5050;
  uo5121->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5121 = addmethod2pos(obj5050, "pretty", &meth_ast_pretty5121, 10);
int argcv_meth_ast_pretty5121[] = {1};
meth_meth_ast_pretty5121->type = alloc_MethodType(1, argcv_meth_ast_pretty5121);
  meth_meth_ast_pretty5121->definitionModule = modulename;
  meth_meth_ast_pretty5121->definitionLine = 1086;
  struct UserObject *uo5217 = (struct UserObject*)obj5050;
  uo5217->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace5217 = addmethod2pos(obj5050, "toGrace", &meth_ast_toGrace5217, 11);
int argcv_meth_ast_toGrace5217[] = {1};
meth_meth_ast_toGrace5217->type = alloc_MethodType(1, argcv_meth_ast_toGrace5217);
meth_meth_ast_toGrace5217->type->types[0] = type_Number;
meth_meth_ast_toGrace5217->type->names[0] = "depth";
  meth_meth_ast_toGrace5217->definitionModule = modulename;
  meth_meth_ast_toGrace5217->definitionLine = 1104;
  sourceObject = obj5050;
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5278 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5279 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5278);
// compilenode returning call5279
  struct UserObject *obj5050_uo = (struct UserObject *)obj5050;
  obj5050_uo->super = call5279;
  sourceObject = obj5050;
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5280 == NULL) {
    strlit5280 = alloc_String("object");
    gc_root(strlit5280);
  }
// compilenode returning strlit5280
  adddatum2(obj5050, strlit5280, 1);
  sourceObject = obj5050;
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_body
  adddatum2(obj5050, *var_body, 2);
  sourceObject = obj5050;
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_superclass_39_
  adddatum2(obj5050, *var_superclass_39_, 3);
  sourceObject = obj5050;
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5281 = alloc_Boolean(0);
// compilenode returning bool5281
  adddatum2(obj5050, bool5281, 4);
  sourceObject = obj5050;
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5282 == NULL) {
    strlit5282 = alloc_String("object");
    gc_root(strlit5282);
  }
// compilenode returning strlit5282
  adddatum2(obj5050, strlit5282, 5);
  sourceObject = obj5050;
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5283 = alloc_Boolean(0);
// compilenode returning bool5283
  adddatum2(obj5050, bool5283, 6);
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
  sourceObject = obj5050;
objclass5050 = obj5050->class;
  objclass5050->definitionModule = modulename;
  objclass5050->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5050;
  self = oldself5050;
  selfslot = oldselfslot5050;
  stackframe = oldstackframe5050;
  gc_frame_end(frame);
  return obj5050;
}
Object meth_ast_arrayNode5285(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "arrayNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for arrayNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for arrayNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_arrayNode
  gc_frame_end(frame);
  return *var_arrayNode;
}
Object meth_ast__apply5301(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5302 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_ax
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5303 = callmethod(*var_ax, "accept",
    1, partcv, params);
  gc_frame_end(callframe5302);
// compilenode returning call5303
  gc_frame_end(frame);
  return call5303;
}
Object meth_ast_accept5293(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5295 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5296 = callmethod(*var_visitor, "visitArray",
    1, partcv, params);
  gc_frame_end(callframe5295);
// compilenode returning call5296
  Object if5294 = done;
  if (istrue(call5296)) {
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5297 = gc_frame_new();
  int callframe5298 = gc_frame_new();
  partcv[0] = 0;
  Object call5299 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5298);
// compilenode returning call5299
// compilenode returning call5299
  gc_frame_newslot(call5299);
  Object block5300 = alloc_Block(NULL, NULL, "ast", 1123);
  gc_frame_newslot(block5300);
  block_savedest(block5300);
  Object closure5301 = createclosure(2, "_apply");
setclosureframe(closure5301, stackframe);
  addtoclosure(closure5301, var_visitor);
  addtoclosure(closure5301, selfslot);
  struct UserObject *uo5301 = (struct UserObject*)block5300;
  uo5301->data[0] = (Object)closure5301;
  Method *meth_meth_ast__apply5301 = addmethod2pos(block5300, "_apply", &meth_ast__apply5301, 0);
int argcv_meth_ast__apply5301[] = {1};
meth_meth_ast__apply5301->type = alloc_MethodType(1, argcv_meth_ast__apply5301);
  meth_meth_ast__apply5301->definitionModule = modulename;
  meth_meth_ast__apply5301->definitionLine = 1123;
// compilenode returning block5300
  gc_frame_newslot(block5300);
  params[0] = call5299;
  params[1] = block5300;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5305 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5297);
// compilenode returning call5305
    gc_frame_newslot(call5305);
    if5294 = call5305;
  } else {
  }
// compilenode returning if5294
  gc_frame_end(frame);
  return if5294;
}
Object meth_ast_map_40__41_before_40__41_after5306(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_arrayNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5307 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5308 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5307);
// compilenode returning call5308
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5309 = gc_frame_new();
  int callframe5310 = gc_frame_new();
  int callframe5311 = gc_frame_new();
  partcv[0] = 0;
  Object call5312 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5311);
// compilenode returning call5312
  gc_frame_newslot(call5312);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5313 = gc_frame_new();
  int callframe5314 = gc_frame_new();
  Object call5315 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5314);
// compilenode returning call5315
// compilenode returning call5315
  partcv[0] = 0;
  Object call5316 = callmethodflags(call5315, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5313);
// compilenode returning call5316
// compilenode returning call5316
  params[0] = call5312;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5317 = callmethodflags(call5316, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5310);
// compilenode returning call5317
  gc_frame_newslot(call5317);
// compilenode returning *var_arrayNode
  params[0] = call5317;
  partcv[0] = 1;
  Object call5318 = callmethod(*var_arrayNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5309);
// compilenode returning call5318
  *var_n = call5318;
  if (call5318 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5319 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5320 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5319);
// compilenode returning call5320
  *var_n = call5320;
  if (call5320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5322 = gc_frame_new();
// Begin line 1132
  setline(1132);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5323 = gc_frame_new();
  partcv[0] = 0;
  Object call5324 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5323);
// compilenode returning call5324
  gc_frame_newslot(call5324);
// compilenode returning *var_n
  params[0] = call5324;
  partcv[0] = 1;
  Object call5325 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5322);
// compilenode returning call5325
// compilenode returning done
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5326 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5327 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5326);
// compilenode returning call5327
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5331(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5334(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5328(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5329 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5330 = alloc_Block(NULL, NULL, "ast", 1137);
  gc_frame_newslot(block5330);
  block_savedest(block5330);
  Object closure5331 = createclosure(1, "_apply");
setclosureframe(closure5331, stackframe);
  addtoclosure(closure5331, selfslot);
  struct UserObject *uo5331 = (struct UserObject*)block5330;
  uo5331->data[0] = (Object)closure5331;
  Method *meth_meth_ast__apply5331 = addmethod2pos(block5330, "_apply", &meth_ast__apply5331, 0);
int argcv_meth_ast__apply5331[] = {0};
meth_meth_ast__apply5331->type = alloc_MethodType(1, argcv_meth_ast__apply5331);
  meth_meth_ast__apply5331->definitionModule = modulename;
  meth_meth_ast__apply5331->definitionLine = 1130;
// compilenode returning block5330
  gc_frame_newslot(block5330);
  Object block5333 = alloc_Block(NULL, NULL, "ast", 1137);
  gc_frame_newslot(block5333);
  block_savedest(block5333);
  Object closure5334 = createclosure(1, "_apply");
setclosureframe(closure5334, stackframe);
  addtoclosure(closure5334, selfslot);
  struct UserObject *uo5334 = (struct UserObject*)block5333;
  uo5334->data[0] = (Object)closure5334;
  Method *meth_meth_ast__apply5334 = addmethod2pos(block5333, "_apply", &meth_ast__apply5334, 0);
int argcv_meth_ast__apply5334[] = {0};
meth_meth_ast__apply5334->type = alloc_MethodType(1, argcv_meth_ast__apply5334);
  meth_meth_ast__apply5334->definitionModule = modulename;
  meth_meth_ast__apply5334->definitionLine = 1130;
// compilenode returning block5333
  gc_frame_newslot(block5333);
  params[0] = *var_blk;
  params[1] = block5330;
  params[2] = block5333;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5336 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5329);
// compilenode returning call5336
  gc_frame_end(frame);
  return call5336;
}
Object meth_ast__apply5345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ai = &(stackframe->slots[0]);
  *var_ai = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5347 == NULL) {
    strlit5347 = alloc_String("  ");
    gc_root(strlit5347);
  }
// compilenode returning strlit5347
  int op_slot_right_5346 = gc_frame_newslot(strlit5347);
// compilenode returning *var_spc
  int op_slot_left_5346 = gc_frame_newslot(*var_spc);
  params[0] = strlit5347;
  partcv[0] = 1;
  Object opresult5349 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5349
  *var_spc = opresult5349;
  if (opresult5349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5358(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_depth = getfromclosure(closure, 0);
  Object *var_spc = getfromclosure(closure, 1);
  Object *var_s = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ax = &(stackframe->slots[0]);
  *var_ax = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5360 = gc_frame_new();
  Object num5362 = alloc_Float64(1);
// compilenode returning num5362
  int op_slot_right_5361 = gc_frame_newslot(num5362);
// compilenode returning *var_depth
  int op_slot_left_5361 = gc_frame_newslot(*var_depth);
  params[0] = num5362;
  partcv[0] = 1;
  Object sum5364 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5364
  gc_frame_newslot(sum5364);
// compilenode returning *var_ax
  params[0] = sum5364;
  partcv[0] = 1;
  Object call5365 = callmethod(*var_ax, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5360);
// compilenode returning call5365
  int op_slot_right_5359 = gc_frame_newslot(call5365);
// compilenode returning *var_spc
  int op_slot_right_5367 = gc_frame_newslot(*var_spc);
  if (strlit5370 == NULL) {
    strlit5370 = alloc_String("""\x0a""");
    gc_root(strlit5370);
  }
// compilenode returning strlit5370
  int op_slot_right_5369 = gc_frame_newslot(strlit5370);
// compilenode returning *var_s
  int op_slot_left_5369 = gc_frame_newslot(*var_s);
  params[0] = strlit5370;
  partcv[0] = 1;
  Object opresult5372 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5372
  int op_slot_left_5367 = gc_frame_newslot(opresult5372);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5373 = callmethod(opresult5372, "++", 1, partcv, params);
// compilenode returning opresult5373
  int op_slot_left_5359 = gc_frame_newslot(opresult5373);
  params[0] = call5365;
  partcv[0] = 1;
  Object opresult5374 = callmethod(opresult5373, "++", 1, partcv, params);
// compilenode returning opresult5374
  *var_s = opresult5374;
  if (opresult5374 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5337(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5338 == NULL) {
    strlit5338 = alloc_String("");
    gc_root(strlit5338);
  }
// compilenode returning strlit5338
  *var_spc = strlit5338;
  if (strlit5338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1141
  setline(1141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5339 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5340 = gc_frame_newslot(*var_depth);
  Object num5342 = alloc_Float64(0);
// compilenode returning num5342
  int op_slot_left_5340 = gc_frame_newslot(num5342);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5343 = callmethod(num5342, "..", 1, partcv, params);
// compilenode returning opresult5343
  gc_frame_newslot(opresult5343);
  Object block5344 = alloc_Block(NULL, NULL, "ast", 1141);
  gc_frame_newslot(block5344);
  block_savedest(block5344);
  Object closure5345 = createclosure(2, "_apply");
setclosureframe(closure5345, stackframe);
  addtoclosure(closure5345, var_spc);
  addtoclosure(closure5345, selfslot);
  struct UserObject *uo5345 = (struct UserObject*)block5344;
  uo5345->data[0] = (Object)closure5345;
  Method *meth_meth_ast__apply5345 = addmethod2pos(block5344, "_apply", &meth_ast__apply5345, 0);
int argcv_meth_ast__apply5345[] = {1};
meth_meth_ast__apply5345->type = alloc_MethodType(1, argcv_meth_ast__apply5345);
  meth_meth_ast__apply5345->definitionModule = modulename;
  meth_meth_ast__apply5345->definitionLine = 1130;
// compilenode returning block5344
  gc_frame_newslot(block5344);
  params[0] = opresult5343;
  params[1] = block5344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5352 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5339);
// compilenode returning call5352
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5353 == NULL) {
    strlit5353 = alloc_String("Array");
    gc_root(strlit5353);
  }
// compilenode returning strlit5353
  *var_s = strlit5353;
  if (strlit5353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5354 = gc_frame_new();
  int callframe5355 = gc_frame_new();
  partcv[0] = 0;
  Object call5356 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5355);
// compilenode returning call5356
// compilenode returning call5356
  gc_frame_newslot(call5356);
  Object block5357 = alloc_Block(NULL, NULL, "ast", 1145);
  gc_frame_newslot(block5357);
  block_savedest(block5357);
  Object closure5358 = createclosure(4, "_apply");
setclosureframe(closure5358, stackframe);
  addtoclosure(closure5358, var_depth);
  addtoclosure(closure5358, var_spc);
  addtoclosure(closure5358, var_s);
  addtoclosure(closure5358, selfslot);
  struct UserObject *uo5358 = (struct UserObject*)block5357;
  uo5358->data[0] = (Object)closure5358;
  Method *meth_meth_ast__apply5358 = addmethod2pos(block5357, "_apply", &meth_ast__apply5358, 0);
int argcv_meth_ast__apply5358[] = {1};
meth_meth_ast__apply5358->type = alloc_MethodType(1, argcv_meth_ast__apply5358);
  meth_meth_ast__apply5358->definitionModule = modulename;
  meth_meth_ast__apply5358->definitionLine = 1145;
// compilenode returning block5357
  gc_frame_newslot(block5357);
  params[0] = call5356;
  params[1] = block5357;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5377 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5354);
// compilenode returning call5377
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply5386(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5388 = gc_frame_new();
  Object num5389 = alloc_Float64(0);
// compilenode returning num5389
  gc_frame_newslot(num5389);
  int callframe5390 = gc_frame_new();
  partcv[0] = 0;
  Object call5391 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5390);
// compilenode returning call5391
// compilenode returning call5391
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5392 = callmethod(call5391, "[]", 1, partcv, params);
// compilenode returning idxres5392
  params[0] = num5389;
  partcv[0] = 1;
  Object call5393 = callmethod(idxres5392, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5388);
// compilenode returning call5393
  int op_slot_right_5387 = gc_frame_newslot(call5393);
// compilenode returning *var_s
  int op_slot_left_5387 = gc_frame_newslot(*var_s);
  params[0] = call5393;
  partcv[0] = 1;
  Object opresult5395 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5395
  *var_s = opresult5395;
  if (opresult5395 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5399 = gc_frame_new();
  int callframe5400 = gc_frame_new();
  partcv[0] = 0;
  Object call5401 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5400);
// compilenode returning call5401
// compilenode returning call5401
  partcv[0] = 0;
  Object call5402 = callmethod(call5401, "size",
    1, partcv, params);
  gc_frame_end(callframe5399);
// compilenode returning call5402
// compilenode returning call5402
  int op_slot_right_5398 = gc_frame_newslot(call5402);
// compilenode returning *var_i
  int op_slot_left_5398 = gc_frame_newslot(*var_i);
  params[0] = call5402;
  partcv[0] = 1;
  Object opresult5404 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult5404
  Object if5397 = done;
  if (istrue(opresult5404)) {
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5406 == NULL) {
    strlit5406 = alloc_String(", ");
    gc_root(strlit5406);
  }
// compilenode returning strlit5406
  int op_slot_right_5405 = gc_frame_newslot(strlit5406);
// compilenode returning *var_s
  int op_slot_left_5405 = gc_frame_newslot(*var_s);
  params[0] = strlit5406;
  partcv[0] = 1;
  Object opresult5408 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5408
  *var_s = opresult5408;
  if (opresult5408 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5397 = done;
  } else {
  }
// compilenode returning if5397
  gc_frame_end(frame);
  return if5397;
}
Object meth_ast_toGrace5378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5379 == NULL) {
    strlit5379 = alloc_String("[");
    gc_root(strlit5379);
  }
// compilenode returning strlit5379
  *var_s = strlit5379;
  if (strlit5379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5380 = gc_frame_new();
  int callframe5381 = gc_frame_new();
  int callframe5382 = gc_frame_new();
  partcv[0] = 0;
  Object call5383 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5382);
// compilenode returning call5383
// compilenode returning call5383
  partcv[0] = 0;
  Object call5384 = callmethod(call5383, "indices",
    1, partcv, params);
  gc_frame_end(callframe5381);
// compilenode returning call5384
// compilenode returning call5384
  gc_frame_newslot(call5384);
  Object block5385 = alloc_Block(NULL, NULL, "ast", 1152);
  gc_frame_newslot(block5385);
  block_savedest(block5385);
  Object closure5386 = createclosure(2, "_apply");
setclosureframe(closure5386, stackframe);
  addtoclosure(closure5386, var_s);
  addtoclosure(closure5386, selfslot);
  struct UserObject *uo5386 = (struct UserObject*)block5385;
  uo5386->data[0] = (Object)closure5386;
  Method *meth_meth_ast__apply5386 = addmethod2pos(block5385, "_apply", &meth_ast__apply5386, 0);
int argcv_meth_ast__apply5386[] = {1};
meth_meth_ast__apply5386->type = alloc_MethodType(1, argcv_meth_ast__apply5386);
  meth_meth_ast__apply5386->definitionModule = modulename;
  meth_meth_ast__apply5386->definitionLine = 1152;
// compilenode returning block5385
  gc_frame_newslot(block5385);
  params[0] = call5384;
  params[1] = block5385;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5411 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5380);
// compilenode returning call5411
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5413 == NULL) {
    strlit5413 = alloc_String("]");
    gc_root(strlit5413);
  }
// compilenode returning strlit5413
  int op_slot_right_5412 = gc_frame_newslot(strlit5413);
// compilenode returning *var_s
  int op_slot_left_5412 = gc_frame_newslot(*var_s);
  params[0] = strlit5413;
  partcv[0] = 1;
  Object opresult5415 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5415
  *var_s = opresult5415;
  if (opresult5415 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5288(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_arrayNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5289 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5289 = alloc_userobj2(8,9, objclass5289);
  gc_frame_newslot(obj5289);
if (objclass5289 == NULL) {
  glfree(obj5289->class->name);
  obj5289->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5289, self, 0);
  addmethodreal(obj5289,"outer", &reader_ast_outer_5290);
  Object oldself5289 = self;
  struct StackFrameObject *oldstackframe5289 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5289);
  gc_frame_newslot((Object)stackframe);
  self = obj5289;
  Object *oldselfslot5289 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5289 = (*(struct UserObject *)self).data[0], lowerouter5289 = thisouter5289;
  if (inheritingObject5289) {
    struct UserObject *inho5289 = (struct UserObject *)inheritingObject5289;
    while (inho5289->super != GraceDefaultObject) inho5289 = (struct UserObject *)inho5289->super;
    inho5289->super = obj5289;
    self = inheritingObject5289;
    *selfslot = self;
    lowerouter5289 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5289;
  }
if (objclass5289 == NULL) {
  Method *reader5291 = addmethodrealflags(obj5289, "kind",&reader_ast_kind_5291, MFLAG_DEF);
  reader5291->definitionModule = modulename;
  reader5291->definitionLine = 1120;
}
adddatum2(obj5289, alloc_Undefined(), 1);
if (objclass5289 == NULL) {
  Method *reader5292 = addmethodrealflags(obj5289, "value",&reader_ast_value_5292, MFLAG_DEF);
  reader5292->definitionModule = modulename;
  reader5292->definitionLine = 1121;
}
adddatum2(obj5289, alloc_Undefined(), 2);
  struct UserObject *uo5293 = (struct UserObject*)obj5289;
  uo5293->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5293 = addmethod2pos(obj5289, "accept", &meth_ast_accept5293, 3);
int argcv_meth_ast_accept5293[] = {1};
meth_meth_ast_accept5293->type = alloc_MethodType(1, argcv_meth_ast_accept5293);
meth_meth_ast_accept5293->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5293->type->names[0] = "visitor";
  meth_meth_ast_accept5293->definitionModule = modulename;
  meth_meth_ast_accept5293->definitionLine = 1121;
  block_savedest(obj5289);
  Object closure5306 = createclosure(1, "map()before()after");
setclosureframe(closure5306, stackframe);
  addtoclosure(closure5306, var_arrayNode);
  struct UserObject *uo5306 = (struct UserObject*)obj5289;
  uo5306->data[4] = (Object)closure5306;
  Method *meth_meth_ast_map_40__41_before_40__41_after5306 = addmethod2pos(obj5289, "map()before()after", &meth_ast_map_40__41_before_40__41_after5306, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5306[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5306->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5306);
  meth_meth_ast_map_40__41_before_40__41_after5306->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5306->definitionLine = 1128;
  struct UserObject *uo5328 = (struct UserObject*)obj5289;
  uo5328->data[5] = emptyclosure;
  Method *meth_meth_ast_map5328 = addmethod2pos(obj5289, "map", &meth_ast_map5328, 5);
int argcv_meth_ast_map5328[] = {1};
meth_meth_ast_map5328->type = alloc_MethodType(1, argcv_meth_ast_map5328);
  meth_meth_ast_map5328->definitionModule = modulename;
  meth_meth_ast_map5328->definitionLine = 1136;
  struct UserObject *uo5337 = (struct UserObject*)obj5289;
  uo5337->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5337 = addmethod2pos(obj5289, "pretty", &meth_ast_pretty5337, 6);
int argcv_meth_ast_pretty5337[] = {1};
meth_meth_ast_pretty5337->type = alloc_MethodType(1, argcv_meth_ast_pretty5337);
  meth_meth_ast_pretty5337->definitionModule = modulename;
  meth_meth_ast_pretty5337->definitionLine = 1139;
  struct UserObject *uo5378 = (struct UserObject*)obj5289;
  uo5378->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace5378 = addmethod2pos(obj5289, "toGrace", &meth_ast_toGrace5378, 7);
int argcv_meth_ast_toGrace5378[] = {1};
meth_meth_ast_toGrace5378->type = alloc_MethodType(1, argcv_meth_ast_toGrace5378);
meth_meth_ast_toGrace5378->type->types[0] = type_Number;
meth_meth_ast_toGrace5378->type->names[0] = "depth";
  meth_meth_ast_toGrace5378->definitionModule = modulename;
  meth_meth_ast_toGrace5378->definitionLine = 1150;
  sourceObject = obj5289;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5417 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5418 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5417);
// compilenode returning call5418
  struct UserObject *obj5289_uo = (struct UserObject *)obj5289;
  obj5289_uo->super = call5418;
  sourceObject = obj5289;
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5419 == NULL) {
    strlit5419 = alloc_String("array");
    gc_root(strlit5419);
  }
// compilenode returning strlit5419
  adddatum2(obj5289, strlit5419, 1);
  sourceObject = obj5289;
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  adddatum2(obj5289, *var_values, 2);
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
objclass5289 = obj5289->class;
  objclass5289->definitionModule = modulename;
  objclass5289->definitionLine = 1110;
  (*(struct UserObject *)self).data[0] = lowerouter5289;
  self = oldself5289;
  selfslot = oldselfslot5289;
  stackframe = oldstackframe5289;
  gc_frame_end(frame);
  return obj5289;
}
Object meth_ast_new5288_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_arrayNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_values = &(stackframe->slots[0]);
  *var_values = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5289 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5289 = alloc_userobj2(8,9, objclass5289);
  gc_frame_newslot(obj5289);
if (objclass5289 == NULL) {
  glfree(obj5289->class->name);
  obj5289->class->name = "arrayNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5289, self, 0);
  addmethodreal(obj5289,"outer", &reader_ast_outer_5290);
  Object oldself5289 = self;
  struct StackFrameObject *oldstackframe5289 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5289);
  gc_frame_newslot((Object)stackframe);
  self = obj5289;
  Object *oldselfslot5289 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5289 = (*(struct UserObject *)self).data[0], lowerouter5289 = thisouter5289;
  if (inheritingObject5289) {
    struct UserObject *inho5289 = (struct UserObject *)inheritingObject5289;
    while (inho5289->super != GraceDefaultObject) inho5289 = (struct UserObject *)inho5289->super;
    inho5289->super = obj5289;
    self = inheritingObject5289;
    *selfslot = self;
    lowerouter5289 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5289;
  }
if (objclass5289 == NULL) {
  Method *reader5291 = addmethodrealflags(obj5289, "kind",&reader_ast_kind_5291, MFLAG_DEF);
  reader5291->definitionModule = modulename;
  reader5291->definitionLine = 1120;
}
adddatum2(obj5289, alloc_Undefined(), 1);
if (objclass5289 == NULL) {
  Method *reader5292 = addmethodrealflags(obj5289, "value",&reader_ast_value_5292, MFLAG_DEF);
  reader5292->definitionModule = modulename;
  reader5292->definitionLine = 1121;
}
adddatum2(obj5289, alloc_Undefined(), 2);
  struct UserObject *uo5293 = (struct UserObject*)obj5289;
  uo5293->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5293 = addmethod2pos(obj5289, "accept", &meth_ast_accept5293, 3);
int argcv_meth_ast_accept5293[] = {1};
meth_meth_ast_accept5293->type = alloc_MethodType(1, argcv_meth_ast_accept5293);
meth_meth_ast_accept5293->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5293->type->names[0] = "visitor";
  meth_meth_ast_accept5293->definitionModule = modulename;
  meth_meth_ast_accept5293->definitionLine = 1121;
  block_savedest(obj5289);
  Object closure5306 = createclosure(1, "map()before()after");
setclosureframe(closure5306, stackframe);
  addtoclosure(closure5306, var_arrayNode);
  struct UserObject *uo5306 = (struct UserObject*)obj5289;
  uo5306->data[4] = (Object)closure5306;
  Method *meth_meth_ast_map_40__41_before_40__41_after5306 = addmethod2pos(obj5289, "map()before()after", &meth_ast_map_40__41_before_40__41_after5306, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5306[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5306->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5306);
  meth_meth_ast_map_40__41_before_40__41_after5306->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5306->definitionLine = 1128;
  struct UserObject *uo5328 = (struct UserObject*)obj5289;
  uo5328->data[5] = emptyclosure;
  Method *meth_meth_ast_map5328 = addmethod2pos(obj5289, "map", &meth_ast_map5328, 5);
int argcv_meth_ast_map5328[] = {1};
meth_meth_ast_map5328->type = alloc_MethodType(1, argcv_meth_ast_map5328);
  meth_meth_ast_map5328->definitionModule = modulename;
  meth_meth_ast_map5328->definitionLine = 1136;
  struct UserObject *uo5337 = (struct UserObject*)obj5289;
  uo5337->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty5337 = addmethod2pos(obj5289, "pretty", &meth_ast_pretty5337, 6);
int argcv_meth_ast_pretty5337[] = {1};
meth_meth_ast_pretty5337->type = alloc_MethodType(1, argcv_meth_ast_pretty5337);
  meth_meth_ast_pretty5337->definitionModule = modulename;
  meth_meth_ast_pretty5337->definitionLine = 1139;
  struct UserObject *uo5378 = (struct UserObject*)obj5289;
  uo5378->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace5378 = addmethod2pos(obj5289, "toGrace", &meth_ast_toGrace5378, 7);
int argcv_meth_ast_toGrace5378[] = {1};
meth_meth_ast_toGrace5378->type = alloc_MethodType(1, argcv_meth_ast_toGrace5378);
meth_meth_ast_toGrace5378->type->types[0] = type_Number;
meth_meth_ast_toGrace5378->type->names[0] = "depth";
  meth_meth_ast_toGrace5378->definitionModule = modulename;
  meth_meth_ast_toGrace5378->definitionLine = 1150;
  sourceObject = obj5289;
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5417 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5418 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5417);
// compilenode returning call5418
  struct UserObject *obj5289_uo = (struct UserObject *)obj5289;
  obj5289_uo->super = call5418;
  sourceObject = obj5289;
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5419 == NULL) {
    strlit5419 = alloc_String("array");
    gc_root(strlit5419);
  }
// compilenode returning strlit5419
  adddatum2(obj5289, strlit5419, 1);
  sourceObject = obj5289;
// Begin line 1120
  setline(1120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  adddatum2(obj5289, *var_values, 2);
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
  sourceObject = obj5289;
objclass5289 = obj5289->class;
  objclass5289->definitionModule = modulename;
  objclass5289->definitionLine = 1110;
  (*(struct UserObject *)self).data[0] = lowerouter5289;
  self = oldself5289;
  selfslot = oldselfslot5289;
  stackframe = oldstackframe5289;
  gc_frame_end(frame);
  return obj5289;
}
Object meth_ast_memberNode5421(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "memberNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for memberNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for memberNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_memberNode
  gc_frame_end(frame);
  return *var_memberNode;
}
Object meth_ast_accept5430(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5432 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5433 = callmethod(*var_visitor, "visitMember",
    1, partcv, params);
  gc_frame_end(callframe5432);
// compilenode returning call5433
  Object if5431 = done;
  if (istrue(call5433)) {
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5434 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5435 = gc_frame_new();
  partcv[0] = 0;
  Object call5436 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5435);
// compilenode returning call5436
// compilenode returning call5436
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5437 = callmethod(call5436, "accept",
    1, partcv, params);
  gc_frame_end(callframe5434);
// compilenode returning call5437
    gc_frame_newslot(call5437);
    if5431 = call5437;
  } else {
  }
// compilenode returning if5431
  gc_frame_end(frame);
  return if5431;
}
Object meth_ast_map_40__41_before_40__41_after5438(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_memberNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5439 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5440 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5439);
// compilenode returning call5440
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5441 = gc_frame_new();
  int callframe5442 = gc_frame_new();
  partcv[0] = 0;
  Object call5443 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5442);
// compilenode returning call5443
  gc_frame_newslot(call5443);
  int callframe5444 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5445 = gc_frame_new();
  partcv[0] = 0;
  Object call5446 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compilenode returning call5446
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5447 = callmethod(call5446, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe5444);
// compilenode returning call5447
  gc_frame_newslot(call5447);
// compilenode returning *var_memberNode
  params[0] = call5443;
  params[1] = call5447;
  partcv[0] = 2;
  Object call5448 = callmethod(*var_memberNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5441);
// compilenode returning call5448
  *var_n = call5448;
  if (call5448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5449 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5450 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5449);
// compilenode returning call5450
  *var_n = call5450;
  if (call5450 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5452 = gc_frame_new();
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5453 = gc_frame_new();
  partcv[0] = 0;
  Object call5454 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5453);
// compilenode returning call5454
  gc_frame_newslot(call5454);
// compilenode returning *var_n
  params[0] = call5454;
  partcv[0] = 1;
  Object call5455 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5452);
// compilenode returning call5455
// compilenode returning done
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5456 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5457 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5456);
// compilenode returning call5457
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5461(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5464(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5458(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5459 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5460 = alloc_Block(NULL, NULL, "ast", 1181);
  gc_frame_newslot(block5460);
  block_savedest(block5460);
  Object closure5461 = createclosure(1, "_apply");
setclosureframe(closure5461, stackframe);
  addtoclosure(closure5461, selfslot);
  struct UserObject *uo5461 = (struct UserObject*)block5460;
  uo5461->data[0] = (Object)closure5461;
  Method *meth_meth_ast__apply5461 = addmethod2pos(block5460, "_apply", &meth_ast__apply5461, 0);
int argcv_meth_ast__apply5461[] = {0};
meth_meth_ast__apply5461->type = alloc_MethodType(1, argcv_meth_ast__apply5461);
  meth_meth_ast__apply5461->definitionModule = modulename;
  meth_meth_ast__apply5461->definitionLine = 1169;
// compilenode returning block5460
  gc_frame_newslot(block5460);
  Object block5463 = alloc_Block(NULL, NULL, "ast", 1181);
  gc_frame_newslot(block5463);
  block_savedest(block5463);
  Object closure5464 = createclosure(1, "_apply");
setclosureframe(closure5464, stackframe);
  addtoclosure(closure5464, selfslot);
  struct UserObject *uo5464 = (struct UserObject*)block5463;
  uo5464->data[0] = (Object)closure5464;
  Method *meth_meth_ast__apply5464 = addmethod2pos(block5463, "_apply", &meth_ast__apply5464, 0);
int argcv_meth_ast__apply5464[] = {0};
meth_meth_ast__apply5464->type = alloc_MethodType(1, argcv_meth_ast__apply5464);
  meth_meth_ast__apply5464->definitionModule = modulename;
  meth_meth_ast__apply5464->definitionLine = 1169;
// compilenode returning block5463
  gc_frame_newslot(block5463);
  params[0] = *var_blk;
  params[1] = block5460;
  params[2] = block5463;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5466 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5459);
// compilenode returning call5466
  gc_frame_end(frame);
  return call5466;
}
Object meth_ast__apply5475(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5477 == NULL) {
    strlit5477 = alloc_String("  ");
    gc_root(strlit5477);
  }
// compilenode returning strlit5477
  int op_slot_right_5476 = gc_frame_newslot(strlit5477);
// compilenode returning *var_spc
  int op_slot_left_5476 = gc_frame_newslot(*var_spc);
  params[0] = strlit5477;
  partcv[0] = 1;
  Object opresult5479 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5479
  *var_spc = opresult5479;
  if (opresult5479 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5468 == NULL) {
    strlit5468 = alloc_String("");
    gc_root(strlit5468);
  }
// compilenode returning strlit5468
  *var_spc = strlit5468;
  if (strlit5468 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5469 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5470 = gc_frame_newslot(*var_depth);
  Object num5472 = alloc_Float64(0);
// compilenode returning num5472
  int op_slot_left_5470 = gc_frame_newslot(num5472);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5473 = callmethod(num5472, "..", 1, partcv, params);
// compilenode returning opresult5473
  gc_frame_newslot(opresult5473);
  Object block5474 = alloc_Block(NULL, NULL, "ast", 1185);
  gc_frame_newslot(block5474);
  block_savedest(block5474);
  Object closure5475 = createclosure(2, "_apply");
setclosureframe(closure5475, stackframe);
  addtoclosure(closure5475, var_spc);
  addtoclosure(closure5475, selfslot);
  struct UserObject *uo5475 = (struct UserObject*)block5474;
  uo5475->data[0] = (Object)closure5475;
  Method *meth_meth_ast__apply5475 = addmethod2pos(block5474, "_apply", &meth_ast__apply5475, 0);
int argcv_meth_ast__apply5475[] = {1};
meth_meth_ast__apply5475->type = alloc_MethodType(1, argcv_meth_ast__apply5475);
  meth_meth_ast__apply5475->definitionModule = modulename;
  meth_meth_ast__apply5475->definitionLine = 1169;
// compilenode returning block5474
  gc_frame_newslot(block5474);
  params[0] = opresult5473;
  params[1] = block5474;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5482 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5469);
// compilenode returning call5482
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5484 == NULL) {
    strlit5484 = alloc_String(")""\x0a""");
    gc_root(strlit5484);
  }
// compilenode returning strlit5484
  int op_slot_right_5483 = gc_frame_newslot(strlit5484);
  int callframe5487 = gc_frame_new();
  partcv[0] = 0;
  Object call5488 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5487);
// compilenode returning call5488
// compilenode returning call5488
  int op_slot_right_5486 = gc_frame_newslot(call5488);
  if (strlit5490 == NULL) {
    strlit5490 = alloc_String("Member(");
    gc_root(strlit5490);
  }
// compilenode returning strlit5490
  int op_slot_left_5486 = gc_frame_newslot(strlit5490);
  params[0] = call5488;
  partcv[0] = 1;
  Object opresult5491 = callmethod(strlit5490, "++", 1, partcv, params);
// compilenode returning opresult5491
  int op_slot_left_5483 = gc_frame_newslot(opresult5491);
  params[0] = strlit5484;
  partcv[0] = 1;
  Object opresult5492 = callmethod(opresult5491, "++", 1, partcv, params);
// compilenode returning opresult5492
  *var_s = opresult5492;
  if (opresult5492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5494 = gc_frame_new();
  Object num5496 = alloc_Float64(1);
// compilenode returning num5496
  int op_slot_right_5495 = gc_frame_newslot(num5496);
// compilenode returning *var_depth
  int op_slot_left_5495 = gc_frame_newslot(*var_depth);
  params[0] = num5496;
  partcv[0] = 1;
  Object sum5498 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5498
  gc_frame_newslot(sum5498);
  int callframe5499 = gc_frame_new();
  partcv[0] = 0;
  Object call5500 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5499);
// compilenode returning call5500
// compilenode returning call5500
  params[0] = sum5498;
  partcv[0] = 1;
  Object call5501 = callmethod(call5500, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5494);
// compilenode returning call5501
  int op_slot_right_5493 = gc_frame_newslot(call5501);
// compilenode returning *var_spc
  int op_slot_right_5503 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_5503 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5505 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5505
  int op_slot_left_5493 = gc_frame_newslot(opresult5505);
  params[0] = call5501;
  partcv[0] = 1;
  Object opresult5506 = callmethod(opresult5505, "++", 1, partcv, params);
// compilenode returning opresult5506
  *var_s = opresult5506;
  if (opresult5506 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace5508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5509 == NULL) {
    strlit5509 = alloc_String("");
    gc_root(strlit5509);
  }
// compilenode returning strlit5509
  *var_s = strlit5509;
  if (strlit5509 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5512 == NULL) {
    strlit5512 = alloc_String("prefix");
    gc_root(strlit5512);
  }
// compilenode returning strlit5512
  int op_slot_right_5511 = gc_frame_newslot(strlit5512);
  int callframe5514 = gc_frame_new();
  Object num5515 = alloc_Float64(1);
// compilenode returning num5515
  gc_frame_newslot(num5515);
  Object num5516 = alloc_Float64(6);
// compilenode returning num5516
  gc_frame_newslot(num5516);
  int callframe5517 = gc_frame_new();
  partcv[0] = 0;
  Object call5518 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5517);
// compilenode returning call5518
// compilenode returning call5518
  params[0] = num5515;
  params[1] = num5516;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5519 = callmethod(call5518, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5514);
// compilenode returning call5519
  int op_slot_left_5511 = gc_frame_newslot(call5519);
  params[0] = strlit5512;
  partcv[0] = 1;
  Object opresult5520 = callmethod(call5519, "==", 1, partcv, params);
// compilenode returning opresult5520
  Object if5510 = done;
  if (istrue(opresult5520)) {
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5521 = gc_frame_new();
  Object num5522 = alloc_Float64(7);
// compilenode returning num5522
  gc_frame_newslot(num5522);
  int callframe5523 = gc_frame_new();
  int callframe5524 = gc_frame_new();
  partcv[0] = 0;
  Object call5525 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5524);
// compilenode returning call5525
// compilenode returning call5525
  partcv[0] = 0;
  Object call5526 = callmethod(call5525, "size",
    1, partcv, params);
  gc_frame_end(callframe5523);
// compilenode returning call5526
// compilenode returning call5526
  gc_frame_newslot(call5526);
  int callframe5527 = gc_frame_new();
  partcv[0] = 0;
  Object call5528 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5527);
// compilenode returning call5528
// compilenode returning call5528
  params[0] = num5522;
  params[1] = call5526;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5529 = callmethod(call5528, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe5521);
// compilenode returning call5529
  *var_s = call5529;
  if (call5529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5532 = gc_frame_new();
  Object num5533 = alloc_Float64(0);
// compilenode returning num5533
  gc_frame_newslot(num5533);
  int callframe5534 = gc_frame_new();
  partcv[0] = 0;
  Object call5535 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5534);
// compilenode returning call5535
// compilenode returning call5535
  params[0] = num5533;
  partcv[0] = 1;
  Object call5536 = callmethod(call5535, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5532);
// compilenode returning call5536
  int op_slot_right_5531 = gc_frame_newslot(call5536);
  if (strlit5539 == NULL) {
    strlit5539 = alloc_String(" ");
    gc_root(strlit5539);
  }
// compilenode returning strlit5539
  int op_slot_right_5538 = gc_frame_newslot(strlit5539);
// compilenode returning *var_s
  int op_slot_left_5538 = gc_frame_newslot(*var_s);
  params[0] = strlit5539;
  partcv[0] = 1;
  Object opresult5541 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5541
  int op_slot_left_5531 = gc_frame_newslot(opresult5541);
  params[0] = call5536;
  partcv[0] = 1;
  Object opresult5542 = callmethod(opresult5541, "++", 1, partcv, params);
// compilenode returning opresult5542
  *var_s = opresult5542;
  if (opresult5542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5510 = done;
  } else {
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5545 = gc_frame_new();
  partcv[0] = 0;
  Object call5546 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5545);
// compilenode returning call5546
// compilenode returning call5546
  int op_slot_right_5544 = gc_frame_newslot(call5546);
  if (strlit5549 == NULL) {
    strlit5549 = alloc_String(".");
    gc_root(strlit5549);
  }
// compilenode returning strlit5549
  int op_slot_right_5548 = gc_frame_newslot(strlit5549);
  int callframe5551 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe5552 = gc_frame_new();
  partcv[0] = 0;
  Object call5553 = callmethodflags(self, "in", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5552);
// compilenode returning call5553
// compilenode returning call5553
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call5554 = callmethod(call5553, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5551);
// compilenode returning call5554
  int op_slot_left_5548 = gc_frame_newslot(call5554);
  params[0] = strlit5549;
  partcv[0] = 1;
  Object opresult5555 = callmethod(call5554, "++", 1, partcv, params);
// compilenode returning opresult5555
  int op_slot_left_5544 = gc_frame_newslot(opresult5555);
  params[0] = call5546;
  partcv[0] = 1;
  Object opresult5556 = callmethod(opresult5555, "++", 1, partcv, params);
// compilenode returning opresult5556
  *var_s = opresult5556;
  if (opresult5556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5510 = done;
  }
// compilenode returning if5510
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_memberNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5425 = alloc_userobj2(10,10, objclass5425);
  gc_frame_newslot(obj5425);
if (objclass5425 == NULL) {
  glfree(obj5425->class->name);
  obj5425->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5425, self, 0);
  addmethodreal(obj5425,"outer", &reader_ast_outer_5426);
  Object oldself5425 = self;
  struct StackFrameObject *oldstackframe5425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5425);
  gc_frame_newslot((Object)stackframe);
  self = obj5425;
  Object *oldselfslot5425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5425 = (*(struct UserObject *)self).data[0], lowerouter5425 = thisouter5425;
  if (inheritingObject5425) {
    struct UserObject *inho5425 = (struct UserObject *)inheritingObject5425;
    while (inho5425->super != GraceDefaultObject) inho5425 = (struct UserObject *)inho5425->super;
    inho5425->super = obj5425;
    self = inheritingObject5425;
    *selfslot = self;
    lowerouter5425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5425;
  }
if (objclass5425 == NULL) {
  Method *reader5427 = addmethodrealflags(obj5425, "kind",&reader_ast_kind_5427, MFLAG_DEF);
  reader5427->definitionModule = modulename;
  reader5427->definitionLine = 1165;
}
adddatum2(obj5425, alloc_Undefined(), 1);
if (objclass5425 == NULL) {
  Method *reader5428 = addmethodrealflags(obj5425, "value",&reader_ast_value_5428, 0);
  Method *writer5428 = addmethodrealflags(obj5425, "value:=",&writer_ast_value_5428, 0);
  reader5428->definitionModule = modulename;
  writer5428->definitionModule = modulename;
  reader5428->definitionLine = 1166;
  writer5428->definitionLine = 1166;
}
obj5425->flags |= OFLAG_MUTABLE;
adddatum2(obj5425, alloc_Undefined(), 2);
if (objclass5425 == NULL) {
  Method *reader5429 = addmethodrealflags(obj5425, "in",&reader_ast_in_5429, MFLAG_DEF);
  reader5429->definitionModule = modulename;
  reader5429->definitionLine = 1167;
}
adddatum2(obj5425, alloc_Undefined(), 3);
  struct UserObject *uo5430 = (struct UserObject*)obj5425;
  uo5430->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5430 = addmethod2pos(obj5425, "accept", &meth_ast_accept5430, 4);
int argcv_meth_ast_accept5430[] = {1};
meth_meth_ast_accept5430->type = alloc_MethodType(1, argcv_meth_ast_accept5430);
meth_meth_ast_accept5430->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5430->type->names[0] = "visitor";
  meth_meth_ast_accept5430->definitionModule = modulename;
  meth_meth_ast_accept5430->definitionLine = 1167;
  block_savedest(obj5425);
  Object closure5438 = createclosure(1, "map()before()after");
setclosureframe(closure5438, stackframe);
  addtoclosure(closure5438, var_memberNode);
  struct UserObject *uo5438 = (struct UserObject*)obj5425;
  uo5438->data[5] = (Object)closure5438;
  Method *meth_meth_ast_map_40__41_before_40__41_after5438 = addmethod2pos(obj5425, "map()before()after", &meth_ast_map_40__41_before_40__41_after5438, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5438[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5438->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5438);
  meth_meth_ast_map_40__41_before_40__41_after5438->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5438->definitionLine = 1172;
  struct UserObject *uo5458 = (struct UserObject*)obj5425;
  uo5458->data[6] = emptyclosure;
  Method *meth_meth_ast_map5458 = addmethod2pos(obj5425, "map", &meth_ast_map5458, 6);
int argcv_meth_ast_map5458[] = {1};
meth_meth_ast_map5458->type = alloc_MethodType(1, argcv_meth_ast_map5458);
  meth_meth_ast_map5458->definitionModule = modulename;
  meth_meth_ast_map5458->definitionLine = 1180;
  struct UserObject *uo5467 = (struct UserObject*)obj5425;
  uo5467->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5467 = addmethod2pos(obj5425, "pretty", &meth_ast_pretty5467, 7);
int argcv_meth_ast_pretty5467[] = {1};
meth_meth_ast_pretty5467->type = alloc_MethodType(1, argcv_meth_ast_pretty5467);
  meth_meth_ast_pretty5467->definitionModule = modulename;
  meth_meth_ast_pretty5467->definitionLine = 1183;
  struct UserObject *uo5508 = (struct UserObject*)obj5425;
  uo5508->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5508 = addmethod2pos(obj5425, "toGrace", &meth_ast_toGrace5508, 8);
int argcv_meth_ast_toGrace5508[] = {1};
meth_meth_ast_toGrace5508->type = alloc_MethodType(1, argcv_meth_ast_toGrace5508);
meth_meth_ast_toGrace5508->type->types[0] = type_Number;
meth_meth_ast_toGrace5508->type->names[0] = "depth";
  meth_meth_ast_toGrace5508->definitionModule = modulename;
  meth_meth_ast_toGrace5508->definitionLine = 1192;
  sourceObject = obj5425;
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5558 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5559 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5558);
// compilenode returning call5559
  struct UserObject *obj5425_uo = (struct UserObject *)obj5425;
  obj5425_uo->super = call5559;
  sourceObject = obj5425;
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5560 == NULL) {
    strlit5560 = alloc_String("member");
    gc_root(strlit5560);
  }
// compilenode returning strlit5560
  adddatum2(obj5425, strlit5560, 1);
  sourceObject = obj5425;
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj5425, *var_what, 2);
  sourceObject = obj5425;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_in_39_
  adddatum2(obj5425, *var_in_39_, 3);
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
objclass5425 = obj5425->class;
  objclass5425->definitionModule = modulename;
  objclass5425->definitionLine = 1154;
  (*(struct UserObject *)self).data[0] = lowerouter5425;
  self = oldself5425;
  selfslot = oldselfslot5425;
  stackframe = oldstackframe5425;
  gc_frame_end(frame);
  return obj5425;
}
Object meth_ast_new5424_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_memberNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_what = &(stackframe->slots[0]);
  *var_what = args[curarg];
  curarg++;
  Object *var_in_39_ = &(stackframe->slots[1]);
  *var_in_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5425 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5425 = alloc_userobj2(10,10, objclass5425);
  gc_frame_newslot(obj5425);
if (objclass5425 == NULL) {
  glfree(obj5425->class->name);
  obj5425->class->name = "memberNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5425, self, 0);
  addmethodreal(obj5425,"outer", &reader_ast_outer_5426);
  Object oldself5425 = self;
  struct StackFrameObject *oldstackframe5425 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5425);
  gc_frame_newslot((Object)stackframe);
  self = obj5425;
  Object *oldselfslot5425 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5425 = (*(struct UserObject *)self).data[0], lowerouter5425 = thisouter5425;
  if (inheritingObject5425) {
    struct UserObject *inho5425 = (struct UserObject *)inheritingObject5425;
    while (inho5425->super != GraceDefaultObject) inho5425 = (struct UserObject *)inho5425->super;
    inho5425->super = obj5425;
    self = inheritingObject5425;
    *selfslot = self;
    lowerouter5425 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5425;
  }
if (objclass5425 == NULL) {
  Method *reader5427 = addmethodrealflags(obj5425, "kind",&reader_ast_kind_5427, MFLAG_DEF);
  reader5427->definitionModule = modulename;
  reader5427->definitionLine = 1165;
}
adddatum2(obj5425, alloc_Undefined(), 1);
if (objclass5425 == NULL) {
  Method *reader5428 = addmethodrealflags(obj5425, "value",&reader_ast_value_5428, 0);
  Method *writer5428 = addmethodrealflags(obj5425, "value:=",&writer_ast_value_5428, 0);
  reader5428->definitionModule = modulename;
  writer5428->definitionModule = modulename;
  reader5428->definitionLine = 1166;
  writer5428->definitionLine = 1166;
}
obj5425->flags |= OFLAG_MUTABLE;
adddatum2(obj5425, alloc_Undefined(), 2);
if (objclass5425 == NULL) {
  Method *reader5429 = addmethodrealflags(obj5425, "in",&reader_ast_in_5429, MFLAG_DEF);
  reader5429->definitionModule = modulename;
  reader5429->definitionLine = 1167;
}
adddatum2(obj5425, alloc_Undefined(), 3);
  struct UserObject *uo5430 = (struct UserObject*)obj5425;
  uo5430->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5430 = addmethod2pos(obj5425, "accept", &meth_ast_accept5430, 4);
int argcv_meth_ast_accept5430[] = {1};
meth_meth_ast_accept5430->type = alloc_MethodType(1, argcv_meth_ast_accept5430);
meth_meth_ast_accept5430->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5430->type->names[0] = "visitor";
  meth_meth_ast_accept5430->definitionModule = modulename;
  meth_meth_ast_accept5430->definitionLine = 1167;
  block_savedest(obj5425);
  Object closure5438 = createclosure(1, "map()before()after");
setclosureframe(closure5438, stackframe);
  addtoclosure(closure5438, var_memberNode);
  struct UserObject *uo5438 = (struct UserObject*)obj5425;
  uo5438->data[5] = (Object)closure5438;
  Method *meth_meth_ast_map_40__41_before_40__41_after5438 = addmethod2pos(obj5425, "map()before()after", &meth_ast_map_40__41_before_40__41_after5438, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5438[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5438->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5438);
  meth_meth_ast_map_40__41_before_40__41_after5438->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5438->definitionLine = 1172;
  struct UserObject *uo5458 = (struct UserObject*)obj5425;
  uo5458->data[6] = emptyclosure;
  Method *meth_meth_ast_map5458 = addmethod2pos(obj5425, "map", &meth_ast_map5458, 6);
int argcv_meth_ast_map5458[] = {1};
meth_meth_ast_map5458->type = alloc_MethodType(1, argcv_meth_ast_map5458);
  meth_meth_ast_map5458->definitionModule = modulename;
  meth_meth_ast_map5458->definitionLine = 1180;
  struct UserObject *uo5467 = (struct UserObject*)obj5425;
  uo5467->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5467 = addmethod2pos(obj5425, "pretty", &meth_ast_pretty5467, 7);
int argcv_meth_ast_pretty5467[] = {1};
meth_meth_ast_pretty5467->type = alloc_MethodType(1, argcv_meth_ast_pretty5467);
  meth_meth_ast_pretty5467->definitionModule = modulename;
  meth_meth_ast_pretty5467->definitionLine = 1183;
  struct UserObject *uo5508 = (struct UserObject*)obj5425;
  uo5508->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5508 = addmethod2pos(obj5425, "toGrace", &meth_ast_toGrace5508, 8);
int argcv_meth_ast_toGrace5508[] = {1};
meth_meth_ast_toGrace5508->type = alloc_MethodType(1, argcv_meth_ast_toGrace5508);
meth_meth_ast_toGrace5508->type->types[0] = type_Number;
meth_meth_ast_toGrace5508->type->names[0] = "depth";
  meth_meth_ast_toGrace5508->definitionModule = modulename;
  meth_meth_ast_toGrace5508->definitionLine = 1192;
  sourceObject = obj5425;
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5558 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5559 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5558);
// compilenode returning call5559
  struct UserObject *obj5425_uo = (struct UserObject *)obj5425;
  obj5425_uo->super = call5559;
  sourceObject = obj5425;
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5560 == NULL) {
    strlit5560 = alloc_String("member");
    gc_root(strlit5560);
  }
// compilenode returning strlit5560
  adddatum2(obj5425, strlit5560, 1);
  sourceObject = obj5425;
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_what
  adddatum2(obj5425, *var_what, 2);
  sourceObject = obj5425;
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_in_39_
  adddatum2(obj5425, *var_in_39_, 3);
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
  sourceObject = obj5425;
objclass5425 = obj5425->class;
  objclass5425->definitionModule = modulename;
  objclass5425->definitionLine = 1154;
  (*(struct UserObject *)self).data[0] = lowerouter5425;
  self = oldself5425;
  selfslot = oldselfslot5425;
  stackframe = oldstackframe5425;
  gc_frame_end(frame);
  return obj5425;
}
Object meth_ast_genericNode5562(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "genericNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for genericNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for genericNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_genericNode
  gc_frame_end(frame);
  return *var_genericNode;
}
Object meth_ast__apply5583(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_visitor = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5584 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
// compilenode returning *var_p
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5585 = callmethod(*var_p, "accept",
    1, partcv, params);
  gc_frame_end(callframe5584);
// compilenode returning call5585
  gc_frame_end(frame);
  return call5585;
}
Object meth_ast_accept5571(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5573 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5574 = callmethod(*var_visitor, "visitGeneric",
    1, partcv, params);
  gc_frame_end(callframe5573);
// compilenode returning call5574
  Object if5572 = done;
  if (istrue(call5574)) {
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5575 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5576 = gc_frame_new();
  partcv[0] = 0;
  Object call5577 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5576);
// compilenode returning call5577
// compilenode returning call5577
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5578 = callmethod(call5577, "accept",
    1, partcv, params);
  gc_frame_end(callframe5575);
// compilenode returning call5578
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5579 = gc_frame_new();
  int callframe5580 = gc_frame_new();
  partcv[0] = 0;
  Object call5581 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5580);
// compilenode returning call5581
// compilenode returning call5581
  gc_frame_newslot(call5581);
  Object block5582 = alloc_Block(NULL, NULL, "ast", 1211);
  gc_frame_newslot(block5582);
  block_savedest(block5582);
  Object closure5583 = createclosure(2, "_apply");
setclosureframe(closure5583, stackframe);
  addtoclosure(closure5583, var_visitor);
  addtoclosure(closure5583, selfslot);
  struct UserObject *uo5583 = (struct UserObject*)block5582;
  uo5583->data[0] = (Object)closure5583;
  Method *meth_meth_ast__apply5583 = addmethod2pos(block5582, "_apply", &meth_ast__apply5583, 0);
int argcv_meth_ast__apply5583[] = {1};
meth_meth_ast__apply5583->type = alloc_MethodType(1, argcv_meth_ast__apply5583);
  meth_meth_ast__apply5583->definitionModule = modulename;
  meth_meth_ast__apply5583->definitionLine = 1211;
// compilenode returning block5582
  gc_frame_newslot(block5582);
  params[0] = call5581;
  params[1] = block5582;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5587 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5579);
// compilenode returning call5587
    gc_frame_newslot(call5587);
    if5572 = call5587;
  } else {
  }
// compilenode returning if5572
  gc_frame_end(frame);
  return if5572;
}
Object meth_ast_map_40__41_before_40__41_after5588(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_genericNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5589 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5590 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5589);
// compilenode returning call5590
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5591 = gc_frame_new();
  int callframe5592 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5593 = gc_frame_new();
  partcv[0] = 0;
  Object call5594 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5593);
// compilenode returning call5594
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5595 = callmethod(call5594, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe5592);
// compilenode returning call5595
  gc_frame_newslot(call5595);
  int callframe5596 = gc_frame_new();
  int callframe5597 = gc_frame_new();
  partcv[0] = 0;
  Object call5598 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5597);
// compilenode returning call5598
  gc_frame_newslot(call5598);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe5599 = gc_frame_new();
  int callframe5600 = gc_frame_new();
  Object call5601 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5600);
// compilenode returning call5601
// compilenode returning call5601
  partcv[0] = 0;
  Object call5602 = callmethodflags(call5601, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5599);
// compilenode returning call5602
// compilenode returning call5602
  params[0] = call5598;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5603 = callmethodflags(call5602, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5596);
// compilenode returning call5603
  gc_frame_newslot(call5603);
// compilenode returning *var_genericNode
  params[0] = call5595;
  params[1] = call5603;
  partcv[0] = 2;
  Object call5604 = callmethod(*var_genericNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5591);
// compilenode returning call5604
  *var_n = call5604;
  if (call5604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1219
  setline(1219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5605 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5606 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5605);
// compilenode returning call5606
  *var_n = call5606;
  if (call5606 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5608 = gc_frame_new();
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5609 = gc_frame_new();
  partcv[0] = 0;
  Object call5610 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5609);
// compilenode returning call5610
  gc_frame_newslot(call5610);
// compilenode returning *var_n
  params[0] = call5610;
  partcv[0] = 1;
  Object call5611 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5608);
// compilenode returning call5611
// compilenode returning done
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5612 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5613 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5612);
// compilenode returning call5613
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5617(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5620(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5614(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5615 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5616 = alloc_Block(NULL, NULL, "ast", 1225);
  gc_frame_newslot(block5616);
  block_savedest(block5616);
  Object closure5617 = createclosure(1, "_apply");
setclosureframe(closure5617, stackframe);
  addtoclosure(closure5617, selfslot);
  struct UserObject *uo5617 = (struct UserObject*)block5616;
  uo5617->data[0] = (Object)closure5617;
  Method *meth_meth_ast__apply5617 = addmethod2pos(block5616, "_apply", &meth_ast__apply5617, 0);
int argcv_meth_ast__apply5617[] = {0};
meth_meth_ast__apply5617->type = alloc_MethodType(1, argcv_meth_ast__apply5617);
  meth_meth_ast__apply5617->definitionModule = modulename;
  meth_meth_ast__apply5617->definitionLine = 1218;
// compilenode returning block5616
  gc_frame_newslot(block5616);
  Object block5619 = alloc_Block(NULL, NULL, "ast", 1225);
  gc_frame_newslot(block5619);
  block_savedest(block5619);
  Object closure5620 = createclosure(1, "_apply");
setclosureframe(closure5620, stackframe);
  addtoclosure(closure5620, selfslot);
  struct UserObject *uo5620 = (struct UserObject*)block5619;
  uo5620->data[0] = (Object)closure5620;
  Method *meth_meth_ast__apply5620 = addmethod2pos(block5619, "_apply", &meth_ast__apply5620, 0);
int argcv_meth_ast__apply5620[] = {0};
meth_meth_ast__apply5620->type = alloc_MethodType(1, argcv_meth_ast__apply5620);
  meth_meth_ast__apply5620->definitionModule = modulename;
  meth_meth_ast__apply5620->definitionLine = 1218;
// compilenode returning block5619
  gc_frame_newslot(block5619);
  params[0] = *var_blk;
  params[1] = block5616;
  params[2] = block5619;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5622 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5615);
// compilenode returning call5622
  gc_frame_end(frame);
  return call5622;
}
Object meth_ast__apply5640(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5642 = gc_frame_new();
  Object num5643 = alloc_Float64(0);
// compilenode returning num5643
  gc_frame_newslot(num5643);
// compilenode returning *var_p
  params[0] = num5643;
  partcv[0] = 1;
  Object call5644 = callmethod(*var_p, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5642);
// compilenode returning call5644
  int op_slot_right_5641 = gc_frame_newslot(call5644);
// compilenode returning *var_s
  int op_slot_left_5641 = gc_frame_newslot(*var_s);
  params[0] = call5644;
  partcv[0] = 1;
  Object opresult5646 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5646
  *var_s = opresult5646;
  if (opresult5646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5649 == NULL) {
    strlit5649 = alloc_String(",");
    gc_root(strlit5649);
  }
// compilenode returning strlit5649
  int op_slot_right_5648 = gc_frame_newslot(strlit5649);
// compilenode returning *var_s
  int op_slot_left_5648 = gc_frame_newslot(*var_s);
  params[0] = strlit5649;
  partcv[0] = 1;
  Object opresult5651 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5651
  *var_s = opresult5651;
  if (opresult5651 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5623(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5625 == NULL) {
    strlit5625 = alloc_String("<");
    gc_root(strlit5625);
  }
// compilenode returning strlit5625
  int op_slot_right_5624 = gc_frame_newslot(strlit5625);
  int callframe5628 = gc_frame_new();
  int callframe5629 = gc_frame_new();
  partcv[0] = 0;
  Object call5630 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5629);
// compilenode returning call5630
// compilenode returning call5630
  partcv[0] = 0;
  Object call5631 = callmethod(call5630, "value",
    1, partcv, params);
  gc_frame_end(callframe5628);
// compilenode returning call5631
// compilenode returning call5631
  int op_slot_right_5627 = gc_frame_newslot(call5631);
  if (strlit5633 == NULL) {
    strlit5633 = alloc_String("Generic(");
    gc_root(strlit5633);
  }
// compilenode returning strlit5633
  int op_slot_left_5627 = gc_frame_newslot(strlit5633);
  params[0] = call5631;
  partcv[0] = 1;
  Object opresult5634 = callmethod(strlit5633, "++", 1, partcv, params);
// compilenode returning opresult5634
  int op_slot_left_5624 = gc_frame_newslot(opresult5634);
  params[0] = strlit5625;
  partcv[0] = 1;
  Object opresult5635 = callmethod(opresult5634, "++", 1, partcv, params);
// compilenode returning opresult5635
  *var_s = opresult5635;
  if (opresult5635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5636 = gc_frame_new();
  int callframe5637 = gc_frame_new();
  partcv[0] = 0;
  Object call5638 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5637);
// compilenode returning call5638
  gc_frame_newslot(call5638);
  Object block5639 = alloc_Block(NULL, NULL, "ast", 1229);
  gc_frame_newslot(block5639);
  block_savedest(block5639);
  Object closure5640 = createclosure(2, "_apply");
setclosureframe(closure5640, stackframe);
  addtoclosure(closure5640, var_s);
  addtoclosure(closure5640, selfslot);
  struct UserObject *uo5640 = (struct UserObject*)block5639;
  uo5640->data[0] = (Object)closure5640;
  Method *meth_meth_ast__apply5640 = addmethod2pos(block5639, "_apply", &meth_ast__apply5640, 0);
int argcv_meth_ast__apply5640[] = {1};
meth_meth_ast__apply5640->type = alloc_MethodType(1, argcv_meth_ast__apply5640);
  meth_meth_ast__apply5640->definitionModule = modulename;
  meth_meth_ast__apply5640->definitionLine = 1228;
// compilenode returning block5639
  gc_frame_newslot(block5639);
  params[0] = call5638;
  params[1] = block5639;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5654 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5636);
// compilenode returning call5654
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5656 == NULL) {
    strlit5656 = alloc_String(">)");
    gc_root(strlit5656);
  }
// compilenode returning strlit5656
  int op_slot_right_5655 = gc_frame_newslot(strlit5656);
// compilenode returning *var_s
  int op_slot_left_5655 = gc_frame_newslot(*var_s);
  params[0] = strlit5656;
  partcv[0] = 1;
  Object opresult5658 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5658
  gc_frame_end(frame);
  return opresult5658;
}
Object meth_ast__apply5674(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5676 = gc_frame_new();
  Object num5677 = alloc_Float64(0);
// compilenode returning num5677
  gc_frame_newslot(num5677);
  int callframe5678 = gc_frame_new();
  partcv[0] = 0;
  Object call5679 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5678);
// compilenode returning call5679
// compilenode returning call5679
// compilenode returning *var_i
  params[0] = *var_i;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5680 = callmethod(call5679, "[]", 1, partcv, params);
// compilenode returning idxres5680
  params[0] = num5677;
  partcv[0] = 1;
  Object call5681 = callmethod(idxres5680, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5676);
// compilenode returning call5681
  int op_slot_right_5675 = gc_frame_newslot(call5681);
// compilenode returning *var_s
  int op_slot_left_5675 = gc_frame_newslot(*var_s);
  params[0] = call5681;
  partcv[0] = 1;
  Object opresult5683 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5683
  *var_s = opresult5683;
  if (opresult5683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5687 = gc_frame_new();
  int callframe5688 = gc_frame_new();
  partcv[0] = 0;
  Object call5689 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5688);
// compilenode returning call5689
// compilenode returning call5689
  partcv[0] = 0;
  Object call5690 = callmethod(call5689, "size",
    1, partcv, params);
  gc_frame_end(callframe5687);
// compilenode returning call5690
// compilenode returning call5690
  int op_slot_right_5686 = gc_frame_newslot(call5690);
// compilenode returning *var_i
  int op_slot_left_5686 = gc_frame_newslot(*var_i);
  params[0] = call5690;
  partcv[0] = 1;
  Object opresult5692 = callmethod(*var_i, "<", 1, partcv, params);
// compilenode returning opresult5692
  Object if5685 = done;
  if (istrue(opresult5692)) {
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5694 == NULL) {
    strlit5694 = alloc_String(", ");
    gc_root(strlit5694);
  }
// compilenode returning strlit5694
  int op_slot_right_5693 = gc_frame_newslot(strlit5694);
// compilenode returning *var_s
  int op_slot_left_5693 = gc_frame_newslot(*var_s);
  params[0] = strlit5694;
  partcv[0] = 1;
  Object opresult5696 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5696
  *var_s = opresult5696;
  if (opresult5696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5685 = done;
  } else {
  }
// compilenode returning if5685
  gc_frame_end(frame);
  return if5685;
}
Object meth_ast_toGrace5659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5661 == NULL) {
    strlit5661 = alloc_String("<");
    gc_root(strlit5661);
  }
// compilenode returning strlit5661
  int op_slot_right_5660 = gc_frame_newslot(strlit5661);
  int callframe5663 = gc_frame_new();
  int callframe5664 = gc_frame_new();
  partcv[0] = 0;
  Object call5665 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5664);
// compilenode returning call5665
// compilenode returning call5665
  partcv[0] = 0;
  Object call5666 = callmethod(call5665, "value",
    1, partcv, params);
  gc_frame_end(callframe5663);
// compilenode returning call5666
// compilenode returning call5666
  int op_slot_left_5660 = gc_frame_newslot(call5666);
  params[0] = strlit5661;
  partcv[0] = 1;
  Object opresult5667 = callmethod(call5666, "++", 1, partcv, params);
// compilenode returning opresult5667
  *var_s = opresult5667;
  if (opresult5667 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5668 = gc_frame_new();
  int callframe5669 = gc_frame_new();
  int callframe5670 = gc_frame_new();
  partcv[0] = 0;
  Object call5671 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5670);
// compilenode returning call5671
// compilenode returning call5671
  partcv[0] = 0;
  Object call5672 = callmethod(call5671, "indices",
    1, partcv, params);
  gc_frame_end(callframe5669);
// compilenode returning call5672
// compilenode returning call5672
  gc_frame_newslot(call5672);
  Object block5673 = alloc_Block(NULL, NULL, "ast", 1237);
  gc_frame_newslot(block5673);
  block_savedest(block5673);
  Object closure5674 = createclosure(2, "_apply");
setclosureframe(closure5674, stackframe);
  addtoclosure(closure5674, var_s);
  addtoclosure(closure5674, selfslot);
  struct UserObject *uo5674 = (struct UserObject*)block5673;
  uo5674->data[0] = (Object)closure5674;
  Method *meth_meth_ast__apply5674 = addmethod2pos(block5673, "_apply", &meth_ast__apply5674, 0);
int argcv_meth_ast__apply5674[] = {1};
meth_meth_ast__apply5674->type = alloc_MethodType(1, argcv_meth_ast__apply5674);
  meth_meth_ast__apply5674->definitionModule = modulename;
  meth_meth_ast__apply5674->definitionLine = 1237;
// compilenode returning block5673
  gc_frame_newslot(block5673);
  params[0] = call5672;
  params[1] = block5673;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5699 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5668);
// compilenode returning call5699
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5701 == NULL) {
    strlit5701 = alloc_String(">");
    gc_root(strlit5701);
  }
// compilenode returning strlit5701
  int op_slot_right_5700 = gc_frame_newslot(strlit5701);
// compilenode returning *var_s
  int op_slot_left_5700 = gc_frame_newslot(*var_s);
  params[0] = strlit5701;
  partcv[0] = 1;
  Object opresult5703 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5703
  *var_s = opresult5703;
  if (opresult5703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5565(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5566 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5566 = alloc_userobj2(9,10, objclass5566);
  gc_frame_newslot(obj5566);
if (objclass5566 == NULL) {
  glfree(obj5566->class->name);
  obj5566->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5566, self, 0);
  addmethodreal(obj5566,"outer", &reader_ast_outer_5567);
  Object oldself5566 = self;
  struct StackFrameObject *oldstackframe5566 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5566);
  gc_frame_newslot((Object)stackframe);
  self = obj5566;
  Object *oldselfslot5566 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5566 = (*(struct UserObject *)self).data[0], lowerouter5566 = thisouter5566;
  if (inheritingObject5566) {
    struct UserObject *inho5566 = (struct UserObject *)inheritingObject5566;
    while (inho5566->super != GraceDefaultObject) inho5566 = (struct UserObject *)inho5566->super;
    inho5566->super = obj5566;
    self = inheritingObject5566;
    *selfslot = self;
    lowerouter5566 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5566;
  }
if (objclass5566 == NULL) {
  Method *reader5568 = addmethodrealflags(obj5566, "kind",&reader_ast_kind_5568, MFLAG_DEF);
  reader5568->definitionModule = modulename;
  reader5568->definitionLine = 1206;
}
adddatum2(obj5566, alloc_Undefined(), 1);
if (objclass5566 == NULL) {
  Method *reader5569 = addmethodrealflags(obj5566, "value",&reader_ast_value_5569, MFLAG_DEF);
  reader5569->definitionModule = modulename;
  reader5569->definitionLine = 1207;
}
adddatum2(obj5566, alloc_Undefined(), 2);
if (objclass5566 == NULL) {
  Method *reader5570 = addmethodrealflags(obj5566, "params",&reader_ast_params_5570, MFLAG_DEF);
  reader5570->definitionModule = modulename;
  reader5570->definitionLine = 1208;
}
adddatum2(obj5566, alloc_Undefined(), 3);
  struct UserObject *uo5571 = (struct UserObject*)obj5566;
  uo5571->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5571 = addmethod2pos(obj5566, "accept", &meth_ast_accept5571, 4);
int argcv_meth_ast_accept5571[] = {1};
meth_meth_ast_accept5571->type = alloc_MethodType(1, argcv_meth_ast_accept5571);
meth_meth_ast_accept5571->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5571->type->names[0] = "visitor";
  meth_meth_ast_accept5571->definitionModule = modulename;
  meth_meth_ast_accept5571->definitionLine = 1208;
  block_savedest(obj5566);
  Object closure5588 = createclosure(1, "map()before()after");
setclosureframe(closure5588, stackframe);
  addtoclosure(closure5588, var_genericNode);
  struct UserObject *uo5588 = (struct UserObject*)obj5566;
  uo5588->data[5] = (Object)closure5588;
  Method *meth_meth_ast_map_40__41_before_40__41_after5588 = addmethod2pos(obj5566, "map()before()after", &meth_ast_map_40__41_before_40__41_after5588, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5588[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5588->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5588);
  meth_meth_ast_map_40__41_before_40__41_after5588->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5588->definitionLine = 1216;
  struct UserObject *uo5614 = (struct UserObject*)obj5566;
  uo5614->data[6] = emptyclosure;
  Method *meth_meth_ast_map5614 = addmethod2pos(obj5566, "map", &meth_ast_map5614, 6);
int argcv_meth_ast_map5614[] = {1};
meth_meth_ast_map5614->type = alloc_MethodType(1, argcv_meth_ast_map5614);
  meth_meth_ast_map5614->definitionModule = modulename;
  meth_meth_ast_map5614->definitionLine = 1224;
  struct UserObject *uo5623 = (struct UserObject*)obj5566;
  uo5623->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5623 = addmethod2pos(obj5566, "pretty", &meth_ast_pretty5623, 7);
int argcv_meth_ast_pretty5623[] = {1};
meth_meth_ast_pretty5623->type = alloc_MethodType(1, argcv_meth_ast_pretty5623);
  meth_meth_ast_pretty5623->definitionModule = modulename;
  meth_meth_ast_pretty5623->definitionLine = 1227;
  struct UserObject *uo5659 = (struct UserObject*)obj5566;
  uo5659->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5659 = addmethod2pos(obj5566, "toGrace", &meth_ast_toGrace5659, 8);
int argcv_meth_ast_toGrace5659[] = {1};
meth_meth_ast_toGrace5659->type = alloc_MethodType(1, argcv_meth_ast_toGrace5659);
meth_meth_ast_toGrace5659->type->types[0] = type_Number;
meth_meth_ast_toGrace5659->type->names[0] = "depth";
  meth_meth_ast_toGrace5659->definitionModule = modulename;
  meth_meth_ast_toGrace5659->definitionLine = 1235;
  sourceObject = obj5566;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5705 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5706 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5705);
// compilenode returning call5706
  struct UserObject *obj5566_uo = (struct UserObject *)obj5566;
  obj5566_uo->super = call5706;
  sourceObject = obj5566;
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5707 == NULL) {
    strlit5707 = alloc_String("generic");
    gc_root(strlit5707);
  }
// compilenode returning strlit5707
  adddatum2(obj5566, strlit5707, 1);
  sourceObject = obj5566;
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_base
  adddatum2(obj5566, *var_base, 2);
  sourceObject = obj5566;
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj5566, *var_params_39_, 3);
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
objclass5566 = obj5566->class;
  objclass5566->definitionModule = modulename;
  objclass5566->definitionLine = 1198;
  (*(struct UserObject *)self).data[0] = lowerouter5566;
  self = oldself5566;
  selfslot = oldselfslot5566;
  stackframe = oldstackframe5566;
  gc_frame_end(frame);
  return obj5566;
}
Object meth_ast_new5565_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_genericNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_base = &(stackframe->slots[0]);
  *var_base = args[curarg];
  curarg++;
  Object *var_params_39_ = &(stackframe->slots[1]);
  *var_params_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5566 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5566 = alloc_userobj2(9,10, objclass5566);
  gc_frame_newslot(obj5566);
if (objclass5566 == NULL) {
  glfree(obj5566->class->name);
  obj5566->class->name = "genericNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5566, self, 0);
  addmethodreal(obj5566,"outer", &reader_ast_outer_5567);
  Object oldself5566 = self;
  struct StackFrameObject *oldstackframe5566 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5566);
  gc_frame_newslot((Object)stackframe);
  self = obj5566;
  Object *oldselfslot5566 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5566 = (*(struct UserObject *)self).data[0], lowerouter5566 = thisouter5566;
  if (inheritingObject5566) {
    struct UserObject *inho5566 = (struct UserObject *)inheritingObject5566;
    while (inho5566->super != GraceDefaultObject) inho5566 = (struct UserObject *)inho5566->super;
    inho5566->super = obj5566;
    self = inheritingObject5566;
    *selfslot = self;
    lowerouter5566 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5566;
  }
if (objclass5566 == NULL) {
  Method *reader5568 = addmethodrealflags(obj5566, "kind",&reader_ast_kind_5568, MFLAG_DEF);
  reader5568->definitionModule = modulename;
  reader5568->definitionLine = 1206;
}
adddatum2(obj5566, alloc_Undefined(), 1);
if (objclass5566 == NULL) {
  Method *reader5569 = addmethodrealflags(obj5566, "value",&reader_ast_value_5569, MFLAG_DEF);
  reader5569->definitionModule = modulename;
  reader5569->definitionLine = 1207;
}
adddatum2(obj5566, alloc_Undefined(), 2);
if (objclass5566 == NULL) {
  Method *reader5570 = addmethodrealflags(obj5566, "params",&reader_ast_params_5570, MFLAG_DEF);
  reader5570->definitionModule = modulename;
  reader5570->definitionLine = 1208;
}
adddatum2(obj5566, alloc_Undefined(), 3);
  struct UserObject *uo5571 = (struct UserObject*)obj5566;
  uo5571->data[4] = emptyclosure;
  Method *meth_meth_ast_accept5571 = addmethod2pos(obj5566, "accept", &meth_ast_accept5571, 4);
int argcv_meth_ast_accept5571[] = {1};
meth_meth_ast_accept5571->type = alloc_MethodType(1, argcv_meth_ast_accept5571);
meth_meth_ast_accept5571->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5571->type->names[0] = "visitor";
  meth_meth_ast_accept5571->definitionModule = modulename;
  meth_meth_ast_accept5571->definitionLine = 1208;
  block_savedest(obj5566);
  Object closure5588 = createclosure(1, "map()before()after");
setclosureframe(closure5588, stackframe);
  addtoclosure(closure5588, var_genericNode);
  struct UserObject *uo5588 = (struct UserObject*)obj5566;
  uo5588->data[5] = (Object)closure5588;
  Method *meth_meth_ast_map_40__41_before_40__41_after5588 = addmethod2pos(obj5566, "map()before()after", &meth_ast_map_40__41_before_40__41_after5588, 5);
int argcv_meth_ast_map_40__41_before_40__41_after5588[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5588->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5588);
  meth_meth_ast_map_40__41_before_40__41_after5588->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5588->definitionLine = 1216;
  struct UserObject *uo5614 = (struct UserObject*)obj5566;
  uo5614->data[6] = emptyclosure;
  Method *meth_meth_ast_map5614 = addmethod2pos(obj5566, "map", &meth_ast_map5614, 6);
int argcv_meth_ast_map5614[] = {1};
meth_meth_ast_map5614->type = alloc_MethodType(1, argcv_meth_ast_map5614);
  meth_meth_ast_map5614->definitionModule = modulename;
  meth_meth_ast_map5614->definitionLine = 1224;
  struct UserObject *uo5623 = (struct UserObject*)obj5566;
  uo5623->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty5623 = addmethod2pos(obj5566, "pretty", &meth_ast_pretty5623, 7);
int argcv_meth_ast_pretty5623[] = {1};
meth_meth_ast_pretty5623->type = alloc_MethodType(1, argcv_meth_ast_pretty5623);
  meth_meth_ast_pretty5623->definitionModule = modulename;
  meth_meth_ast_pretty5623->definitionLine = 1227;
  struct UserObject *uo5659 = (struct UserObject*)obj5566;
  uo5659->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace5659 = addmethod2pos(obj5566, "toGrace", &meth_ast_toGrace5659, 8);
int argcv_meth_ast_toGrace5659[] = {1};
meth_meth_ast_toGrace5659->type = alloc_MethodType(1, argcv_meth_ast_toGrace5659);
meth_meth_ast_toGrace5659->type->types[0] = type_Number;
meth_meth_ast_toGrace5659->type->names[0] = "depth";
  meth_meth_ast_toGrace5659->definitionModule = modulename;
  meth_meth_ast_toGrace5659->definitionLine = 1235;
  sourceObject = obj5566;
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5705 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5706 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5705);
// compilenode returning call5706
  struct UserObject *obj5566_uo = (struct UserObject *)obj5566;
  obj5566_uo->super = call5706;
  sourceObject = obj5566;
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5707 == NULL) {
    strlit5707 = alloc_String("generic");
    gc_root(strlit5707);
  }
// compilenode returning strlit5707
  adddatum2(obj5566, strlit5707, 1);
  sourceObject = obj5566;
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_base
  adddatum2(obj5566, *var_base, 2);
  sourceObject = obj5566;
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_params_39_
  adddatum2(obj5566, *var_params_39_, 3);
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
  sourceObject = obj5566;
objclass5566 = obj5566->class;
  objclass5566->definitionModule = modulename;
  objclass5566->definitionLine = 1198;
  (*(struct UserObject *)self).data[0] = lowerouter5566;
  self = oldself5566;
  selfslot = oldselfslot5566;
  stackframe = oldstackframe5566;
  gc_frame_end(frame);
  return obj5566;
}
Object meth_ast_identifierNode5709(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifierNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifierNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for identifierNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_identifierNode
  gc_frame_end(frame);
  return *var_identifierNode;
}
Object meth_ast_accept5721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5723 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5724 = callmethod(*var_visitor, "visitIdentifier",
    1, partcv, params);
  gc_frame_end(callframe5723);
// compilenode returning call5724
  Object if5722 = done;
  if (istrue(call5724)) {
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5727 = alloc_Boolean(0);
// compilenode returning bool5727
  int op_slot_right_5726 = gc_frame_newslot(bool5727);
  int callframe5729 = gc_frame_new();
  partcv[0] = 0;
  Object call5730 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5729);
// compilenode returning call5730
// compilenode returning call5730
  int op_slot_left_5726 = gc_frame_newslot(call5730);
  params[0] = bool5727;
  partcv[0] = 1;
  Object opresult5731 = callmethod(call5730, "!=", 1, partcv, params);
// compilenode returning opresult5731
  Object if5725 = done;
  if (istrue(opresult5731)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5732 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe5733 = gc_frame_new();
  partcv[0] = 0;
  Object call5734 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5733);
// compilenode returning call5734
// compilenode returning call5734
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call5735 = callmethod(call5734, "accept",
    1, partcv, params);
  gc_frame_end(callframe5732);
// compilenode returning call5735
    gc_frame_newslot(call5735);
    if5725 = call5735;
  } else {
  }
// compilenode returning if5725
    gc_frame_newslot(if5725);
    if5722 = if5725;
  } else {
  }
// compilenode returning if5722
  gc_frame_end(frame);
  return if5722;
}
Object meth_ast_map_40__41_before_40__41_after5736(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5737 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5738 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5737);
// compilenode returning call5738
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5739 = gc_frame_new();
  int callframe5740 = gc_frame_new();
  partcv[0] = 0;
  Object call5741 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5740);
// compilenode returning call5741
  gc_frame_newslot(call5741);
  int callframe5742 = gc_frame_new();
  partcv[0] = 0;
  Object call5743 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5742);
// compilenode returning call5743
  gc_frame_newslot(call5743);
// compilenode returning *var_util
  params[0] = call5741;
  params[1] = call5743;
  partcv[0] = 2;
  Object call5744 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe5739);
// compilenode returning call5744
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5745 = gc_frame_new();
  int callframe5746 = gc_frame_new();
  partcv[0] = 0;
  Object call5747 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5746);
// compilenode returning call5747
  gc_frame_newslot(call5747);
  int callframe5748 = gc_frame_new();
  int callframe5749 = gc_frame_new();
  partcv[0] = 0;
  Object call5750 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5749);
// compilenode returning call5750
  gc_frame_newslot(call5750);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5751 = gc_frame_new();
  int callframe5752 = gc_frame_new();
  Object call5753 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5752);
// compilenode returning call5753
// compilenode returning call5753
  partcv[0] = 0;
  Object call5754 = callmethodflags(call5753, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5751);
// compilenode returning call5754
// compilenode returning call5754
  params[0] = call5750;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call5755 = callmethodflags(call5754, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5748);
// compilenode returning call5755
  gc_frame_newslot(call5755);
// compilenode returning *var_identifierNode
  params[0] = call5747;
  params[1] = call5755;
  partcv[0] = 2;
  Object call5756 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5745);
// compilenode returning call5756
  *var_n = call5756;
  if (call5756 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5757 = gc_frame_new();
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5758 = gc_frame_new();
  partcv[0] = 0;
  Object call5759 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5758);
// compilenode returning call5759
  gc_frame_newslot(call5759);
// compilenode returning *var_n
  params[0] = call5759;
  partcv[0] = 1;
  Object call5760 = callmethod(*var_n, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe5757);
// compilenode returning call5760
// compilenode returning done
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5761 = gc_frame_new();
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5762 = gc_frame_new();
  partcv[0] = 0;
  Object call5763 = callmethodflags(self, "inBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5762);
// compilenode returning call5763
  gc_frame_newslot(call5763);
// compilenode returning *var_n
  params[0] = call5763;
  partcv[0] = 1;
  Object call5764 = callmethod(*var_n, "inBind:=",
    1, partcv, params);
  gc_frame_end(callframe5761);
// compilenode returning call5764
// compilenode returning done
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5765 = gc_frame_new();
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5766 = gc_frame_new();
  partcv[0] = 0;
  Object call5767 = callmethodflags(self, "inRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5766);
// compilenode returning call5767
  gc_frame_newslot(call5767);
// compilenode returning *var_n
  params[0] = call5767;
  partcv[0] = 1;
  Object call5768 = callmethod(*var_n, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe5765);
// compilenode returning call5768
// compilenode returning done
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5769 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5770 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5769);
// compilenode returning call5770
  *var_n = call5770;
  if (call5770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5772 = gc_frame_new();
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5773 = gc_frame_new();
  partcv[0] = 0;
  Object call5774 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5773);
// compilenode returning call5774
  gc_frame_newslot(call5774);
// compilenode returning *var_n
  params[0] = call5774;
  partcv[0] = 1;
  Object call5775 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5772);
// compilenode returning call5775
// compilenode returning done
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5778 == NULL) {
    strlit5778 = alloc_String("identifier");
    gc_root(strlit5778);
  }
// compilenode returning strlit5778
  int op_slot_right_5777 = gc_frame_newslot(strlit5778);
  int callframe5780 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call5781 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe5780);
// compilenode returning call5781
// compilenode returning call5781
  int op_slot_left_5777 = gc_frame_newslot(call5781);
  params[0] = strlit5778;
  partcv[0] = 1;
  Object opresult5782 = callmethod(call5781, "==", 1, partcv, params);
// compilenode returning opresult5782
  Object if5776 = done;
  if (istrue(opresult5782)) {
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5783 = gc_frame_new();
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5784 = gc_frame_new();
  partcv[0] = 0;
  Object call5785 = callmethodflags(self, "linePos", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5784);
// compilenode returning call5785
  gc_frame_newslot(call5785);
// compilenode returning *var_n
  params[0] = call5785;
  partcv[0] = 1;
  Object call5786 = callmethod(*var_n, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe5783);
// compilenode returning call5786
// compilenode returning done
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5787 = gc_frame_new();
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5788 = gc_frame_new();
  partcv[0] = 0;
  Object call5789 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5788);
// compilenode returning call5789
  gc_frame_newslot(call5789);
// compilenode returning *var_n
  params[0] = call5789;
  partcv[0] = 1;
  Object call5790 = callmethod(*var_n, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe5787);
// compilenode returning call5790
// compilenode returning done
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5791 = gc_frame_new();
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5792 = gc_frame_new();
  partcv[0] = 0;
  Object call5793 = callmethodflags(self, "inBind", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5792);
// compilenode returning call5793
  gc_frame_newslot(call5793);
// compilenode returning *var_n
  params[0] = call5793;
  partcv[0] = 1;
  Object call5794 = callmethod(*var_n, "inBind:=",
    1, partcv, params);
  gc_frame_end(callframe5791);
// compilenode returning call5794
// compilenode returning done
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5795 = gc_frame_new();
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5796 = gc_frame_new();
  partcv[0] = 0;
  Object call5797 = callmethodflags(self, "inRequest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compilenode returning call5797
  gc_frame_newslot(call5797);
// compilenode returning *var_n
  params[0] = call5797;
  partcv[0] = 1;
  Object call5798 = callmethod(*var_n, "inRequest:=",
    1, partcv, params);
  gc_frame_end(callframe5795);
// compilenode returning call5798
// compilenode returning done
    gc_frame_newslot(done);
    if5776 = done;
  } else {
  }
// compilenode returning if5776
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5799 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5800 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5799);
// compilenode returning call5800
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply5804(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply5807(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5802 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block5803 = alloc_Block(NULL, NULL, "ast", 1282);
  gc_frame_newslot(block5803);
  block_savedest(block5803);
  Object closure5804 = createclosure(1, "_apply");
setclosureframe(closure5804, stackframe);
  addtoclosure(closure5804, selfslot);
  struct UserObject *uo5804 = (struct UserObject*)block5803;
  uo5804->data[0] = (Object)closure5804;
  Method *meth_meth_ast__apply5804 = addmethod2pos(block5803, "_apply", &meth_ast__apply5804, 0);
int argcv_meth_ast__apply5804[] = {0};
meth_meth_ast__apply5804->type = alloc_MethodType(1, argcv_meth_ast__apply5804);
  meth_meth_ast__apply5804->definitionModule = modulename;
  meth_meth_ast__apply5804->definitionLine = 1272;
// compilenode returning block5803
  gc_frame_newslot(block5803);
  Object block5806 = alloc_Block(NULL, NULL, "ast", 1282);
  gc_frame_newslot(block5806);
  block_savedest(block5806);
  Object closure5807 = createclosure(1, "_apply");
setclosureframe(closure5807, stackframe);
  addtoclosure(closure5807, selfslot);
  struct UserObject *uo5807 = (struct UserObject*)block5806;
  uo5807->data[0] = (Object)closure5807;
  Method *meth_meth_ast__apply5807 = addmethod2pos(block5806, "_apply", &meth_ast__apply5807, 0);
int argcv_meth_ast__apply5807[] = {0};
meth_meth_ast__apply5807->type = alloc_MethodType(1, argcv_meth_ast__apply5807);
  meth_meth_ast__apply5807->definitionModule = modulename;
  meth_meth_ast__apply5807->definitionLine = 1272;
// compilenode returning block5806
  gc_frame_newslot(block5806);
  params[0] = *var_blk;
  params[1] = block5803;
  params[2] = block5806;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5809 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5802);
// compilenode returning call5809
  gc_frame_end(frame);
  return call5809;
}
Object meth_ast__apply5818(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1287
  setline(1287);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5820 == NULL) {
    strlit5820 = alloc_String("  ");
    gc_root(strlit5820);
  }
// compilenode returning strlit5820
  int op_slot_right_5819 = gc_frame_newslot(strlit5820);
// compilenode returning *var_spc
  int op_slot_left_5819 = gc_frame_newslot(*var_spc);
  params[0] = strlit5820;
  partcv[0] = 1;
  Object opresult5822 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult5822
  *var_spc = opresult5822;
  if (opresult5822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty5810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5811 == NULL) {
    strlit5811 = alloc_String("");
    gc_root(strlit5811);
  }
// compilenode returning strlit5811
  *var_spc = strlit5811;
  if (strlit5811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5812 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_5813 = gc_frame_newslot(*var_depth);
  Object num5815 = alloc_Float64(0);
// compilenode returning num5815
  int op_slot_left_5813 = gc_frame_newslot(num5815);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult5816 = callmethod(num5815, "..", 1, partcv, params);
// compilenode returning opresult5816
  gc_frame_newslot(opresult5816);
  Object block5817 = alloc_Block(NULL, NULL, "ast", 1286);
  gc_frame_newslot(block5817);
  block_savedest(block5817);
  Object closure5818 = createclosure(2, "_apply");
setclosureframe(closure5818, stackframe);
  addtoclosure(closure5818, var_spc);
  addtoclosure(closure5818, selfslot);
  struct UserObject *uo5818 = (struct UserObject*)block5817;
  uo5818->data[0] = (Object)closure5818;
  Method *meth_meth_ast__apply5818 = addmethod2pos(block5817, "_apply", &meth_ast__apply5818, 0);
int argcv_meth_ast__apply5818[] = {1};
meth_meth_ast__apply5818->type = alloc_MethodType(1, argcv_meth_ast__apply5818);
  meth_meth_ast__apply5818->definitionModule = modulename;
  meth_meth_ast__apply5818->definitionLine = 1272;
// compilenode returning block5817
  gc_frame_newslot(block5817);
  params[0] = opresult5816;
  params[1] = block5817;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5825 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5812);
// compilenode returning call5825
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_s = undefined;
// compilenode returning done
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5827 = gc_frame_new();
  partcv[0] = 0;
  Object call5828 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5827);
// compilenode returning call5828
// compilenode returning call5828
  Object if5826 = done;
  if (istrue(call5828)) {
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5829 == NULL) {
    strlit5829 = alloc_String("WildcardIdentifier");
    gc_root(strlit5829);
  }
// compilenode returning strlit5829
  *var_s = strlit5829;
  if (strlit5829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5826 = done;
  } else {
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5832 == NULL) {
    strlit5832 = alloc_String(")");
    gc_root(strlit5832);
  }
// compilenode returning strlit5832
  int op_slot_right_5831 = gc_frame_newslot(strlit5832);
  int callframe5835 = gc_frame_new();
  partcv[0] = 0;
  Object call5836 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5835);
// compilenode returning call5836
// compilenode returning call5836
  int op_slot_right_5834 = gc_frame_newslot(call5836);
  if (strlit5838 == NULL) {
    strlit5838 = alloc_String("Identifier(");
    gc_root(strlit5838);
  }
// compilenode returning strlit5838
  int op_slot_left_5834 = gc_frame_newslot(strlit5838);
  params[0] = call5836;
  partcv[0] = 1;
  Object opresult5839 = callmethod(strlit5838, "++", 1, partcv, params);
// compilenode returning opresult5839
  int op_slot_left_5831 = gc_frame_newslot(opresult5839);
  params[0] = strlit5832;
  partcv[0] = 1;
  Object opresult5840 = callmethod(opresult5839, "++", 1, partcv, params);
// compilenode returning opresult5840
  *var_s = opresult5840;
  if (opresult5840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5826 = done;
  }
// compilenode returning if5826
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5844 = alloc_Boolean(0);
// compilenode returning bool5844
  int op_slot_right_5843 = gc_frame_newslot(bool5844);
  int callframe5846 = gc_frame_new();
  partcv[0] = 0;
  Object call5847 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5846);
// compilenode returning call5847
// compilenode returning call5847
  int op_slot_left_5843 = gc_frame_newslot(call5847);
  params[0] = bool5844;
  partcv[0] = 1;
  Object opresult5848 = callmethod(call5847, "!=", 1, partcv, params);
// compilenode returning opresult5848
  Object if5842 = done;
  if (istrue(opresult5848)) {
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5850 == NULL) {
    strlit5850 = alloc_String("Type:");
    gc_root(strlit5850);
  }
// compilenode returning strlit5850
  int op_slot_right_5849 = gc_frame_newslot(strlit5850);
// compilenode returning *var_spc
  int op_slot_right_5852 = gc_frame_newslot(*var_spc);
  if (strlit5855 == NULL) {
    strlit5855 = alloc_String("""\x0a""");
    gc_root(strlit5855);
  }
// compilenode returning strlit5855
  int op_slot_right_5854 = gc_frame_newslot(strlit5855);
// compilenode returning *var_s
  int op_slot_left_5854 = gc_frame_newslot(*var_s);
  params[0] = strlit5855;
  partcv[0] = 1;
  Object opresult5857 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5857
  int op_slot_left_5852 = gc_frame_newslot(opresult5857);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5858 = callmethod(opresult5857, "++", 1, partcv, params);
// compilenode returning opresult5858
  int op_slot_left_5849 = gc_frame_newslot(opresult5858);
  params[0] = strlit5850;
  partcv[0] = 1;
  Object opresult5859 = callmethod(opresult5858, "++", 1, partcv, params);
// compilenode returning opresult5859
  *var_s = opresult5859;
  if (opresult5859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1297
  setline(1297);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5862 = gc_frame_new();
  Object num5864 = alloc_Float64(2);
// compilenode returning num5864
  int op_slot_right_5863 = gc_frame_newslot(num5864);
// compilenode returning *var_depth
  int op_slot_left_5863 = gc_frame_newslot(*var_depth);
  params[0] = num5864;
  partcv[0] = 1;
  Object sum5866 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5866
  gc_frame_newslot(sum5866);
  int callframe5867 = gc_frame_new();
  partcv[0] = 0;
  Object call5868 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5867);
// compilenode returning call5868
// compilenode returning call5868
  params[0] = sum5866;
  partcv[0] = 1;
  Object call5869 = callmethod(call5868, "pretty",
    1, partcv, params);
  gc_frame_end(callframe5862);
// compilenode returning call5869
  int op_slot_right_5861 = gc_frame_newslot(call5869);
  if (strlit5872 == NULL) {
    strlit5872 = alloc_String("  ");
    gc_root(strlit5872);
  }
// compilenode returning strlit5872
  int op_slot_right_5871 = gc_frame_newslot(strlit5872);
// compilenode returning *var_spc
  int op_slot_right_5874 = gc_frame_newslot(*var_spc);
  if (strlit5877 == NULL) {
    strlit5877 = alloc_String("""\x0a""");
    gc_root(strlit5877);
  }
// compilenode returning strlit5877
  int op_slot_right_5876 = gc_frame_newslot(strlit5877);
// compilenode returning *var_s
  int op_slot_left_5876 = gc_frame_newslot(*var_s);
  params[0] = strlit5877;
  partcv[0] = 1;
  Object opresult5879 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5879
  int op_slot_left_5874 = gc_frame_newslot(opresult5879);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult5880 = callmethod(opresult5879, "++", 1, partcv, params);
// compilenode returning opresult5880
  int op_slot_left_5871 = gc_frame_newslot(opresult5880);
  params[0] = strlit5872;
  partcv[0] = 1;
  Object opresult5881 = callmethod(opresult5880, "++", 1, partcv, params);
// compilenode returning opresult5881
  int op_slot_left_5861 = gc_frame_newslot(opresult5881);
  params[0] = call5869;
  partcv[0] = 1;
  Object opresult5882 = callmethod(opresult5881, "++", 1, partcv, params);
// compilenode returning opresult5882
  *var_s = opresult5882;
  if (opresult5882 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5842 = done;
  } else {
  }
// compilenode returning if5842
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType5884(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5887 = alloc_Boolean(0);
// compilenode returning bool5887
  int op_slot_right_5886 = gc_frame_newslot(bool5887);
  int callframe5889 = gc_frame_new();
  partcv[0] = 0;
  Object call5890 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5889);
// compilenode returning call5890
  int op_slot_left_5886 = gc_frame_newslot(call5890);
  params[0] = bool5887;
  partcv[0] = 1;
  Object opresult5891 = callmethod(call5890, "==", 1, partcv, params);
// compilenode returning opresult5891
  Object if5885 = done;
  if (istrue(opresult5891)) {
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5892 = gc_frame_new();
  if (strlit5893 == NULL) {
    strlit5893 = alloc_String("Unknown");
    gc_root(strlit5893);
  }
// compilenode returning strlit5893
  gc_frame_newslot(strlit5893);
  Object bool5894 = alloc_Boolean(0);
// compilenode returning bool5894
  gc_frame_newslot(bool5894);
// compilenode returning *var_identifierNode
  params[0] = strlit5893;
  params[1] = bool5894;
  partcv[0] = 2;
  Object call5895 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe5892);
// compilenode returning call5895
  return call5895;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5885 = undefined;
  } else {
  }
// compilenode returning if5885
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5896 = gc_frame_new();
  partcv[0] = 0;
  Object call5897 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5896);
// compilenode returning call5897
  return call5897;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast_toGrace5898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_s = undefined;
// compilenode returning done
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1309
  setline(1309);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5900 = gc_frame_new();
  partcv[0] = 0;
  Object call5901 = callmethodflags(self, "wildcard", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5900);
// compilenode returning call5901
// compilenode returning call5901
  Object if5899 = done;
  if (istrue(call5901)) {
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5902 == NULL) {
    strlit5902 = alloc_String("_");
    gc_root(strlit5902);
  }
// compilenode returning strlit5902
  *var_s = strlit5902;
  if (strlit5902 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5899 = done;
  } else {
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5904 = gc_frame_new();
  partcv[0] = 0;
  Object call5905 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5904);
// compilenode returning call5905
// compilenode returning call5905
  *var_s = call5905;
  if (call5905 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5899 = done;
  }
// compilenode returning if5899
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5909 = alloc_Boolean(0);
// compilenode returning bool5909
  int op_slot_right_5908 = gc_frame_newslot(bool5909);
  int callframe5911 = gc_frame_new();
  partcv[0] = 0;
  Object call5912 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5911);
// compilenode returning call5912
// compilenode returning call5912
  int op_slot_left_5908 = gc_frame_newslot(call5912);
  params[0] = bool5909;
  partcv[0] = 1;
  Object opresult5913 = callmethod(call5912, "!=", 1, partcv, params);
// compilenode returning opresult5913
  Object if5907 = done;
  if (istrue(opresult5913)) {
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5915 = gc_frame_new();
  Object num5917 = alloc_Float64(1);
// compilenode returning num5917
  int op_slot_right_5916 = gc_frame_newslot(num5917);
// compilenode returning *var_depth
  int op_slot_left_5916 = gc_frame_newslot(*var_depth);
  params[0] = num5917;
  partcv[0] = 1;
  Object sum5919 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum5919
  gc_frame_newslot(sum5919);
  int callframe5920 = gc_frame_new();
  partcv[0] = 0;
  Object call5921 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5920);
// compilenode returning call5921
// compilenode returning call5921
  params[0] = sum5919;
  partcv[0] = 1;
  Object call5922 = callmethod(call5921, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe5915);
// compilenode returning call5922
  int op_slot_right_5914 = gc_frame_newslot(call5922);
  if (strlit5925 == NULL) {
    strlit5925 = alloc_String(" : ");
    gc_root(strlit5925);
  }
// compilenode returning strlit5925
  int op_slot_right_5924 = gc_frame_newslot(strlit5925);
// compilenode returning *var_s
  int op_slot_left_5924 = gc_frame_newslot(*var_s);
  params[0] = strlit5925;
  partcv[0] = 1;
  Object opresult5927 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult5927
  int op_slot_left_5914 = gc_frame_newslot(opresult5927);
  params[0] = call5922;
  partcv[0] = 1;
  Object opresult5928 = callmethod(opresult5927, "++", 1, partcv, params);
// compilenode returning opresult5928
  *var_s = opresult5928;
  if (opresult5928 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5907 = done;
  } else {
  }
// compilenode returning if5907
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_asString5930(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5932 == NULL) {
    strlit5932 = alloc_String("]>");
    gc_root(strlit5932);
  }
// compilenode returning strlit5932
  int op_slot_right_5931 = gc_frame_newslot(strlit5932);
  int callframe5935 = gc_frame_new();
  partcv[0] = 0;
  Object call5936 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5935);
// compilenode returning call5936
  int op_slot_right_5934 = gc_frame_newslot(call5936);
  if (strlit5938 == NULL) {
    strlit5938 = alloc_String("<Identifier[");
    gc_root(strlit5938);
  }
// compilenode returning strlit5938
  int op_slot_left_5934 = gc_frame_newslot(strlit5938);
  params[0] = call5936;
  partcv[0] = 1;
  Object opresult5939 = callmethod(strlit5938, "++", 1, partcv, params);
// compilenode returning opresult5939
  int op_slot_left_5931 = gc_frame_newslot(opresult5939);
  params[0] = strlit5932;
  partcv[0] = 1;
  Object opresult5940 = callmethod(opresult5939, "++", 1, partcv, params);
// compilenode returning opresult5940
  gc_frame_end(frame);
  return opresult5940;
}
Object meth_ast_new5712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5713 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5713 = alloc_userobj2(19,15, objclass5713);
  gc_frame_newslot(obj5713);
if (objclass5713 == NULL) {
  glfree(obj5713->class->name);
  obj5713->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5713, self, 0);
  addmethodreal(obj5713,"outer", &reader_ast_outer_5714);
  Object oldself5713 = self;
  struct StackFrameObject *oldstackframe5713 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5713);
  gc_frame_newslot((Object)stackframe);
  self = obj5713;
  Object *oldselfslot5713 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5713 = (*(struct UserObject *)self).data[0], lowerouter5713 = thisouter5713;
  if (inheritingObject5713) {
    struct UserObject *inho5713 = (struct UserObject *)inheritingObject5713;
    while (inho5713->super != GraceDefaultObject) inho5713 = (struct UserObject *)inho5713->super;
    inho5713->super = obj5713;
    self = inheritingObject5713;
    *selfslot = self;
    lowerouter5713 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5713;
  }
if (objclass5713 == NULL) {
  Method *reader5715 = addmethodrealflags(obj5713, "kind",&reader_ast_kind_5715, MFLAG_DEF);
  reader5715->definitionModule = modulename;
  reader5715->definitionLine = 1250;
}
adddatum2(obj5713, alloc_Undefined(), 1);
if (objclass5713 == NULL) {
  Method *reader5716 = addmethodrealflags(obj5713, "value",&reader_ast_value_5716, 0);
  Method *writer5716 = addmethodrealflags(obj5713, "value:=",&writer_ast_value_5716, 0);
  reader5716->definitionModule = modulename;
  writer5716->definitionModule = modulename;
  reader5716->definitionLine = 1251;
  writer5716->definitionLine = 1251;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 2);
if (objclass5713 == NULL) {
  Method *reader5717 = addmethodrealflags(obj5713, "wildcard",&reader_ast_wildcard_5717, 0);
  Method *writer5717 = addmethodrealflags(obj5713, "wildcard:=",&writer_ast_wildcard_5717, 0);
  reader5717->definitionModule = modulename;
  writer5717->definitionModule = modulename;
  reader5717->definitionLine = 1252;
  writer5717->definitionLine = 1252;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 3);
if (objclass5713 == NULL) {
  Method *reader5718 = addmethodrealflags(obj5713, "dtype",&reader_ast_dtype_5718, 0);
  Method *writer5718 = addmethodrealflags(obj5713, "dtype:=",&writer_ast_dtype_5718, 0);
  reader5718->definitionModule = modulename;
  writer5718->definitionModule = modulename;
  reader5718->definitionLine = 1253;
  writer5718->definitionLine = 1253;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 4);
if (objclass5713 == NULL) {
  Method *reader5719 = addmethodrealflags(obj5713, "inBind",&reader_ast_inBind_5719, 0);
  Method *writer5719 = addmethodrealflags(obj5713, "inBind:=",&writer_ast_inBind_5719, 0);
  reader5719->definitionModule = modulename;
  writer5719->definitionModule = modulename;
  reader5719->definitionLine = 1254;
  writer5719->definitionLine = 1254;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 5);
if (objclass5713 == NULL) {
  Method *reader5720 = addmethodrealflags(obj5713, "inRequest",&reader_ast_inRequest_5720, 0);
  Method *writer5720 = addmethodrealflags(obj5713, "inRequest:=",&writer_ast_inRequest_5720, 0);
  reader5720->definitionModule = modulename;
  writer5720->definitionModule = modulename;
  reader5720->definitionLine = 1255;
  writer5720->definitionLine = 1255;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 6);
  struct UserObject *uo5721 = (struct UserObject*)obj5713;
  uo5721->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5721 = addmethod2pos(obj5713, "accept", &meth_ast_accept5721, 7);
int argcv_meth_ast_accept5721[] = {1};
meth_meth_ast_accept5721->type = alloc_MethodType(1, argcv_meth_ast_accept5721);
meth_meth_ast_accept5721->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5721->type->names[0] = "visitor";
  meth_meth_ast_accept5721->definitionModule = modulename;
  meth_meth_ast_accept5721->definitionLine = 1255;
  block_savedest(obj5713);
  Object closure5736 = createclosure(2, "map()before()after");
setclosureframe(closure5736, stackframe);
  addtoclosure(closure5736, var_util);
  addtoclosure(closure5736, var_identifierNode);
  struct UserObject *uo5736 = (struct UserObject*)obj5713;
  uo5736->data[8] = (Object)closure5736;
  Method *meth_meth_ast_map_40__41_before_40__41_after5736 = addmethod2pos(obj5713, "map()before()after", &meth_ast_map_40__41_before_40__41_after5736, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5736[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5736->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5736);
  meth_meth_ast_map_40__41_before_40__41_after5736->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5736->definitionLine = 1262;
  struct UserObject *uo5801 = (struct UserObject*)obj5713;
  uo5801->data[9] = emptyclosure;
  Method *meth_meth_ast_map5801 = addmethod2pos(obj5713, "map", &meth_ast_map5801, 9);
int argcv_meth_ast_map5801[] = {1};
meth_meth_ast_map5801->type = alloc_MethodType(1, argcv_meth_ast_map5801);
  meth_meth_ast_map5801->definitionModule = modulename;
  meth_meth_ast_map5801->definitionLine = 1281;
  struct UserObject *uo5810 = (struct UserObject*)obj5713;
  uo5810->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5810 = addmethod2pos(obj5713, "pretty", &meth_ast_pretty5810, 10);
int argcv_meth_ast_pretty5810[] = {1};
meth_meth_ast_pretty5810->type = alloc_MethodType(1, argcv_meth_ast_pretty5810);
  meth_meth_ast_pretty5810->definitionModule = modulename;
  meth_meth_ast_pretty5810->definitionLine = 1284;
  block_savedest(obj5713);
  Object closure5884 = createclosure(1, "decType");
setclosureframe(closure5884, stackframe);
  addtoclosure(closure5884, var_identifierNode);
  struct UserObject *uo5884 = (struct UserObject*)obj5713;
  uo5884->data[11] = (Object)closure5884;
  Method *meth_meth_ast_decType5884 = addmethod2pos(obj5713, "decType", &meth_ast_decType5884, 11);
int argcv_meth_ast_decType5884[] = {0};
meth_meth_ast_decType5884->type = alloc_MethodType(1, argcv_meth_ast_decType5884);
  meth_meth_ast_decType5884->definitionModule = modulename;
  meth_meth_ast_decType5884->definitionLine = 1301;
  struct UserObject *uo5898 = (struct UserObject*)obj5713;
  uo5898->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5898 = addmethod2pos(obj5713, "toGrace", &meth_ast_toGrace5898, 12);
int argcv_meth_ast_toGrace5898[] = {1};
meth_meth_ast_toGrace5898->type = alloc_MethodType(1, argcv_meth_ast_toGrace5898);
meth_meth_ast_toGrace5898->type->types[0] = type_Number;
meth_meth_ast_toGrace5898->type->names[0] = "depth";
  meth_meth_ast_toGrace5898->definitionModule = modulename;
  meth_meth_ast_toGrace5898->definitionLine = 1307;
  struct UserObject *uo5930 = (struct UserObject*)obj5713;
  uo5930->data[13] = emptyclosure;
  Method *meth_meth_ast_asString5930 = addmethod2pos(obj5713, "asString", &meth_ast_asString5930, 13);
int argcv_meth_ast_asString5930[] = {0};
meth_meth_ast_asString5930->type = alloc_MethodType(1, argcv_meth_ast_asString5930);
  meth_meth_ast_asString5930->definitionModule = modulename;
  meth_meth_ast_asString5930->definitionLine = 1319;
  sourceObject = obj5713;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5941 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5942 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5941);
// compilenode returning call5942
  struct UserObject *obj5713_uo = (struct UserObject *)obj5713;
  obj5713_uo->super = call5942;
  sourceObject = obj5713;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5943 == NULL) {
    strlit5943 = alloc_String("identifier");
    gc_root(strlit5943);
  }
// compilenode returning strlit5943
  adddatum2(obj5713, strlit5943, 1);
  sourceObject = obj5713;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj5713, *var_name, 2);
  sourceObject = obj5713;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5944 = alloc_Boolean(0);
// compilenode returning bool5944
  adddatum2(obj5713, bool5944, 3);
  sourceObject = obj5713;
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj5713, *var_dtype_39_, 4);
  sourceObject = obj5713;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5945 = alloc_Boolean(0);
// compilenode returning bool5945
  adddatum2(obj5713, bool5945, 5);
  sourceObject = obj5713;
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5946 = alloc_Boolean(0);
// compilenode returning bool5946
  adddatum2(obj5713, bool5946, 6);
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
objclass5713 = obj5713->class;
  objclass5713->definitionModule = modulename;
  objclass5713->definitionLine = 1239;
  (*(struct UserObject *)self).data[0] = lowerouter5713;
  self = oldself5713;
  selfslot = oldselfslot5713;
  stackframe = oldstackframe5713;
  gc_frame_end(frame);
  return obj5713;
}
Object meth_ast_new5712_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name = &(stackframe->slots[0]);
  *var_name = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[1]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5713 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5713 = alloc_userobj2(19,15, objclass5713);
  gc_frame_newslot(obj5713);
if (objclass5713 == NULL) {
  glfree(obj5713->class->name);
  obj5713->class->name = "identifierNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5713, self, 0);
  addmethodreal(obj5713,"outer", &reader_ast_outer_5714);
  Object oldself5713 = self;
  struct StackFrameObject *oldstackframe5713 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5713);
  gc_frame_newslot((Object)stackframe);
  self = obj5713;
  Object *oldselfslot5713 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5713 = (*(struct UserObject *)self).data[0], lowerouter5713 = thisouter5713;
  if (inheritingObject5713) {
    struct UserObject *inho5713 = (struct UserObject *)inheritingObject5713;
    while (inho5713->super != GraceDefaultObject) inho5713 = (struct UserObject *)inho5713->super;
    inho5713->super = obj5713;
    self = inheritingObject5713;
    *selfslot = self;
    lowerouter5713 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5713;
  }
if (objclass5713 == NULL) {
  Method *reader5715 = addmethodrealflags(obj5713, "kind",&reader_ast_kind_5715, MFLAG_DEF);
  reader5715->definitionModule = modulename;
  reader5715->definitionLine = 1250;
}
adddatum2(obj5713, alloc_Undefined(), 1);
if (objclass5713 == NULL) {
  Method *reader5716 = addmethodrealflags(obj5713, "value",&reader_ast_value_5716, 0);
  Method *writer5716 = addmethodrealflags(obj5713, "value:=",&writer_ast_value_5716, 0);
  reader5716->definitionModule = modulename;
  writer5716->definitionModule = modulename;
  reader5716->definitionLine = 1251;
  writer5716->definitionLine = 1251;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 2);
if (objclass5713 == NULL) {
  Method *reader5717 = addmethodrealflags(obj5713, "wildcard",&reader_ast_wildcard_5717, 0);
  Method *writer5717 = addmethodrealflags(obj5713, "wildcard:=",&writer_ast_wildcard_5717, 0);
  reader5717->definitionModule = modulename;
  writer5717->definitionModule = modulename;
  reader5717->definitionLine = 1252;
  writer5717->definitionLine = 1252;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 3);
if (objclass5713 == NULL) {
  Method *reader5718 = addmethodrealflags(obj5713, "dtype",&reader_ast_dtype_5718, 0);
  Method *writer5718 = addmethodrealflags(obj5713, "dtype:=",&writer_ast_dtype_5718, 0);
  reader5718->definitionModule = modulename;
  writer5718->definitionModule = modulename;
  reader5718->definitionLine = 1253;
  writer5718->definitionLine = 1253;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 4);
if (objclass5713 == NULL) {
  Method *reader5719 = addmethodrealflags(obj5713, "inBind",&reader_ast_inBind_5719, 0);
  Method *writer5719 = addmethodrealflags(obj5713, "inBind:=",&writer_ast_inBind_5719, 0);
  reader5719->definitionModule = modulename;
  writer5719->definitionModule = modulename;
  reader5719->definitionLine = 1254;
  writer5719->definitionLine = 1254;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 5);
if (objclass5713 == NULL) {
  Method *reader5720 = addmethodrealflags(obj5713, "inRequest",&reader_ast_inRequest_5720, 0);
  Method *writer5720 = addmethodrealflags(obj5713, "inRequest:=",&writer_ast_inRequest_5720, 0);
  reader5720->definitionModule = modulename;
  writer5720->definitionModule = modulename;
  reader5720->definitionLine = 1255;
  writer5720->definitionLine = 1255;
}
obj5713->flags |= OFLAG_MUTABLE;
adddatum2(obj5713, alloc_Undefined(), 6);
  struct UserObject *uo5721 = (struct UserObject*)obj5713;
  uo5721->data[7] = emptyclosure;
  Method *meth_meth_ast_accept5721 = addmethod2pos(obj5713, "accept", &meth_ast_accept5721, 7);
int argcv_meth_ast_accept5721[] = {1};
meth_meth_ast_accept5721->type = alloc_MethodType(1, argcv_meth_ast_accept5721);
meth_meth_ast_accept5721->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5721->type->names[0] = "visitor";
  meth_meth_ast_accept5721->definitionModule = modulename;
  meth_meth_ast_accept5721->definitionLine = 1255;
  block_savedest(obj5713);
  Object closure5736 = createclosure(2, "map()before()after");
setclosureframe(closure5736, stackframe);
  addtoclosure(closure5736, var_util);
  addtoclosure(closure5736, var_identifierNode);
  struct UserObject *uo5736 = (struct UserObject*)obj5713;
  uo5736->data[8] = (Object)closure5736;
  Method *meth_meth_ast_map_40__41_before_40__41_after5736 = addmethod2pos(obj5713, "map()before()after", &meth_ast_map_40__41_before_40__41_after5736, 8);
int argcv_meth_ast_map_40__41_before_40__41_after5736[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5736->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5736);
  meth_meth_ast_map_40__41_before_40__41_after5736->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5736->definitionLine = 1262;
  struct UserObject *uo5801 = (struct UserObject*)obj5713;
  uo5801->data[9] = emptyclosure;
  Method *meth_meth_ast_map5801 = addmethod2pos(obj5713, "map", &meth_ast_map5801, 9);
int argcv_meth_ast_map5801[] = {1};
meth_meth_ast_map5801->type = alloc_MethodType(1, argcv_meth_ast_map5801);
  meth_meth_ast_map5801->definitionModule = modulename;
  meth_meth_ast_map5801->definitionLine = 1281;
  struct UserObject *uo5810 = (struct UserObject*)obj5713;
  uo5810->data[10] = emptyclosure;
  Method *meth_meth_ast_pretty5810 = addmethod2pos(obj5713, "pretty", &meth_ast_pretty5810, 10);
int argcv_meth_ast_pretty5810[] = {1};
meth_meth_ast_pretty5810->type = alloc_MethodType(1, argcv_meth_ast_pretty5810);
  meth_meth_ast_pretty5810->definitionModule = modulename;
  meth_meth_ast_pretty5810->definitionLine = 1284;
  block_savedest(obj5713);
  Object closure5884 = createclosure(1, "decType");
setclosureframe(closure5884, stackframe);
  addtoclosure(closure5884, var_identifierNode);
  struct UserObject *uo5884 = (struct UserObject*)obj5713;
  uo5884->data[11] = (Object)closure5884;
  Method *meth_meth_ast_decType5884 = addmethod2pos(obj5713, "decType", &meth_ast_decType5884, 11);
int argcv_meth_ast_decType5884[] = {0};
meth_meth_ast_decType5884->type = alloc_MethodType(1, argcv_meth_ast_decType5884);
  meth_meth_ast_decType5884->definitionModule = modulename;
  meth_meth_ast_decType5884->definitionLine = 1301;
  struct UserObject *uo5898 = (struct UserObject*)obj5713;
  uo5898->data[12] = emptyclosure;
  Method *meth_meth_ast_toGrace5898 = addmethod2pos(obj5713, "toGrace", &meth_ast_toGrace5898, 12);
int argcv_meth_ast_toGrace5898[] = {1};
meth_meth_ast_toGrace5898->type = alloc_MethodType(1, argcv_meth_ast_toGrace5898);
meth_meth_ast_toGrace5898->type->types[0] = type_Number;
meth_meth_ast_toGrace5898->type->names[0] = "depth";
  meth_meth_ast_toGrace5898->definitionModule = modulename;
  meth_meth_ast_toGrace5898->definitionLine = 1307;
  struct UserObject *uo5930 = (struct UserObject*)obj5713;
  uo5930->data[13] = emptyclosure;
  Method *meth_meth_ast_asString5930 = addmethod2pos(obj5713, "asString", &meth_ast_asString5930, 13);
int argcv_meth_ast_asString5930[] = {0};
meth_meth_ast_asString5930->type = alloc_MethodType(1, argcv_meth_ast_asString5930);
  meth_meth_ast_asString5930->definitionModule = modulename;
  meth_meth_ast_asString5930->definitionLine = 1319;
  sourceObject = obj5713;
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5941 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5942 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5941);
// compilenode returning call5942
  struct UserObject *obj5713_uo = (struct UserObject *)obj5713;
  obj5713_uo->super = call5942;
  sourceObject = obj5713;
// Begin line 1249
  setline(1249);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5943 == NULL) {
    strlit5943 = alloc_String("identifier");
    gc_root(strlit5943);
  }
// compilenode returning strlit5943
  adddatum2(obj5713, strlit5943, 1);
  sourceObject = obj5713;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj5713, *var_name, 2);
  sourceObject = obj5713;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5944 = alloc_Boolean(0);
// compilenode returning bool5944
  adddatum2(obj5713, bool5944, 3);
  sourceObject = obj5713;
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj5713, *var_dtype_39_, 4);
  sourceObject = obj5713;
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5945 = alloc_Boolean(0);
// compilenode returning bool5945
  adddatum2(obj5713, bool5945, 5);
  sourceObject = obj5713;
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5946 = alloc_Boolean(0);
// compilenode returning bool5946
  adddatum2(obj5713, bool5946, 6);
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
  sourceObject = obj5713;
objclass5713 = obj5713->class;
  objclass5713->definitionModule = modulename;
  objclass5713->definitionLine = 1239;
  (*(struct UserObject *)self).data[0] = lowerouter5713;
  self = oldself5713;
  selfslot = oldselfslot5713;
  stackframe = oldstackframe5713;
  gc_frame_end(frame);
  return obj5713;
}
Object meth_ast_octetsNode5948(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "octetsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_octetsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for octetsNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for octetsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_octetsNode
  gc_frame_end(frame);
  return *var_octetsNode;
}
Object meth_ast_accept5956(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5957 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5958 = callmethod(*var_visitor, "visitOctets",
    1, partcv, params);
  gc_frame_end(callframe5957);
// compilenode returning call5958
  gc_frame_end(frame);
  return call5958;
}
Object meth_ast_pretty5959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1331
  setline(1331);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5961 == NULL) {
    strlit5961 = alloc_String(")");
    gc_root(strlit5961);
  }
// compilenode returning strlit5961
  int op_slot_right_5960 = gc_frame_newslot(strlit5961);
  int callframe5964 = gc_frame_new();
  partcv[0] = 0;
  Object call5965 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5964);
// compilenode returning call5965
// compilenode returning call5965
  int op_slot_right_5963 = gc_frame_newslot(call5965);
  if (strlit5967 == NULL) {
    strlit5967 = alloc_String("Octets(");
    gc_root(strlit5967);
  }
// compilenode returning strlit5967
  int op_slot_left_5963 = gc_frame_newslot(strlit5967);
  params[0] = call5965;
  partcv[0] = 1;
  Object opresult5968 = callmethod(strlit5967, "++", 1, partcv, params);
// compilenode returning opresult5968
  int op_slot_left_5960 = gc_frame_newslot(opresult5968);
  params[0] = strlit5961;
  partcv[0] = 1;
  Object opresult5969 = callmethod(opresult5968, "++", 1, partcv, params);
// compilenode returning opresult5969
  gc_frame_end(frame);
  return opresult5969;
}
Object meth_ast_toGrace5970(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5971 = gc_frame_new();
  partcv[0] = 0;
  Object call5972 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5971);
// compilenode returning call5972
// compilenode returning call5972
  gc_frame_end(frame);
  return call5972;
}
Object meth_ast_new5951(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5952 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5952 = alloc_userobj2(6,7, objclass5952);
  gc_frame_newslot(obj5952);
if (objclass5952 == NULL) {
  glfree(obj5952->class->name);
  obj5952->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5952, self, 0);
  addmethodreal(obj5952,"outer", &reader_ast_outer_5953);
  Object oldself5952 = self;
  struct StackFrameObject *oldstackframe5952 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5952);
  gc_frame_newslot((Object)stackframe);
  self = obj5952;
  Object *oldselfslot5952 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5952 = (*(struct UserObject *)self).data[0], lowerouter5952 = thisouter5952;
  if (inheritingObject5952) {
    struct UserObject *inho5952 = (struct UserObject *)inheritingObject5952;
    while (inho5952->super != GraceDefaultObject) inho5952 = (struct UserObject *)inho5952->super;
    inho5952->super = obj5952;
    self = inheritingObject5952;
    *selfslot = self;
    lowerouter5952 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5952;
  }
if (objclass5952 == NULL) {
  Method *reader5954 = addmethodrealflags(obj5952, "kind",&reader_ast_kind_5954, MFLAG_DEF);
  reader5954->definitionModule = modulename;
  reader5954->definitionLine = 1326;
}
adddatum2(obj5952, alloc_Undefined(), 1);
if (objclass5952 == NULL) {
  Method *reader5955 = addmethodrealflags(obj5952, "value",&reader_ast_value_5955, MFLAG_DEF);
  reader5955->definitionModule = modulename;
  reader5955->definitionLine = 1327;
}
adddatum2(obj5952, alloc_Undefined(), 2);
  struct UserObject *uo5956 = (struct UserObject*)obj5952;
  uo5956->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5956 = addmethod2pos(obj5952, "accept", &meth_ast_accept5956, 3);
int argcv_meth_ast_accept5956[] = {1};
meth_meth_ast_accept5956->type = alloc_MethodType(1, argcv_meth_ast_accept5956);
meth_meth_ast_accept5956->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5956->type->names[0] = "visitor";
  meth_meth_ast_accept5956->definitionModule = modulename;
  meth_meth_ast_accept5956->definitionLine = 1327;
  struct UserObject *uo5959 = (struct UserObject*)obj5952;
  uo5959->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty5959 = addmethod2pos(obj5952, "pretty", &meth_ast_pretty5959, 4);
int argcv_meth_ast_pretty5959[] = {1};
meth_meth_ast_pretty5959->type = alloc_MethodType(1, argcv_meth_ast_pretty5959);
  meth_meth_ast_pretty5959->definitionModule = modulename;
  meth_meth_ast_pretty5959->definitionLine = 1330;
  struct UserObject *uo5970 = (struct UserObject*)obj5952;
  uo5970->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace5970 = addmethod2pos(obj5952, "toGrace", &meth_ast_toGrace5970, 5);
int argcv_meth_ast_toGrace5970[] = {1};
meth_meth_ast_toGrace5970->type = alloc_MethodType(1, argcv_meth_ast_toGrace5970);
meth_meth_ast_toGrace5970->type->types[0] = type_Number;
meth_meth_ast_toGrace5970->type->names[0] = "depth";
  meth_meth_ast_toGrace5970->definitionModule = modulename;
  meth_meth_ast_toGrace5970->definitionLine = 1333;
  sourceObject = obj5952;
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5973 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5974 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5973);
// compilenode returning call5974
  struct UserObject *obj5952_uo = (struct UserObject *)obj5952;
  obj5952_uo->super = call5974;
  sourceObject = obj5952;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String("octets");
    gc_root(strlit5975);
  }
// compilenode returning strlit5975
  adddatum2(obj5952, strlit5975, 1);
  sourceObject = obj5952;
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  adddatum2(obj5952, *var_n, 2);
  sourceObject = obj5952;
  sourceObject = obj5952;
  sourceObject = obj5952;
objclass5952 = obj5952->class;
  objclass5952->definitionModule = modulename;
  objclass5952->definitionLine = 1315;
  (*(struct UserObject *)self).data[0] = lowerouter5952;
  self = oldself5952;
  selfslot = oldselfslot5952;
  stackframe = oldstackframe5952;
  gc_frame_end(frame);
  return obj5952;
}
Object meth_ast_new5951_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5952 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5952 = alloc_userobj2(6,7, objclass5952);
  gc_frame_newslot(obj5952);
if (objclass5952 == NULL) {
  glfree(obj5952->class->name);
  obj5952->class->name = "octetsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5952, self, 0);
  addmethodreal(obj5952,"outer", &reader_ast_outer_5953);
  Object oldself5952 = self;
  struct StackFrameObject *oldstackframe5952 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5952);
  gc_frame_newslot((Object)stackframe);
  self = obj5952;
  Object *oldselfslot5952 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5952 = (*(struct UserObject *)self).data[0], lowerouter5952 = thisouter5952;
  if (inheritingObject5952) {
    struct UserObject *inho5952 = (struct UserObject *)inheritingObject5952;
    while (inho5952->super != GraceDefaultObject) inho5952 = (struct UserObject *)inho5952->super;
    inho5952->super = obj5952;
    self = inheritingObject5952;
    *selfslot = self;
    lowerouter5952 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5952;
  }
if (objclass5952 == NULL) {
  Method *reader5954 = addmethodrealflags(obj5952, "kind",&reader_ast_kind_5954, MFLAG_DEF);
  reader5954->definitionModule = modulename;
  reader5954->definitionLine = 1326;
}
adddatum2(obj5952, alloc_Undefined(), 1);
if (objclass5952 == NULL) {
  Method *reader5955 = addmethodrealflags(obj5952, "value",&reader_ast_value_5955, MFLAG_DEF);
  reader5955->definitionModule = modulename;
  reader5955->definitionLine = 1327;
}
adddatum2(obj5952, alloc_Undefined(), 2);
  struct UserObject *uo5956 = (struct UserObject*)obj5952;
  uo5956->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5956 = addmethod2pos(obj5952, "accept", &meth_ast_accept5956, 3);
int argcv_meth_ast_accept5956[] = {1};
meth_meth_ast_accept5956->type = alloc_MethodType(1, argcv_meth_ast_accept5956);
meth_meth_ast_accept5956->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5956->type->names[0] = "visitor";
  meth_meth_ast_accept5956->definitionModule = modulename;
  meth_meth_ast_accept5956->definitionLine = 1327;
  struct UserObject *uo5959 = (struct UserObject*)obj5952;
  uo5959->data[4] = emptyclosure;
  Method *meth_meth_ast_pretty5959 = addmethod2pos(obj5952, "pretty", &meth_ast_pretty5959, 4);
int argcv_meth_ast_pretty5959[] = {1};
meth_meth_ast_pretty5959->type = alloc_MethodType(1, argcv_meth_ast_pretty5959);
  meth_meth_ast_pretty5959->definitionModule = modulename;
  meth_meth_ast_pretty5959->definitionLine = 1330;
  struct UserObject *uo5970 = (struct UserObject*)obj5952;
  uo5970->data[5] = emptyclosure;
  Method *meth_meth_ast_toGrace5970 = addmethod2pos(obj5952, "toGrace", &meth_ast_toGrace5970, 5);
int argcv_meth_ast_toGrace5970[] = {1};
meth_meth_ast_toGrace5970->type = alloc_MethodType(1, argcv_meth_ast_toGrace5970);
meth_meth_ast_toGrace5970->type->types[0] = type_Number;
meth_meth_ast_toGrace5970->type->names[0] = "depth";
  meth_meth_ast_toGrace5970->definitionModule = modulename;
  meth_meth_ast_toGrace5970->definitionLine = 1333;
  sourceObject = obj5952;
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5973 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5974 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe5973);
// compilenode returning call5974
  struct UserObject *obj5952_uo = (struct UserObject *)obj5952;
  obj5952_uo->super = call5974;
  sourceObject = obj5952;
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5975 == NULL) {
    strlit5975 = alloc_String("octets");
    gc_root(strlit5975);
  }
// compilenode returning strlit5975
  adddatum2(obj5952, strlit5975, 1);
  sourceObject = obj5952;
// Begin line 1326
  setline(1326);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  adddatum2(obj5952, *var_n, 2);
  sourceObject = obj5952;
  sourceObject = obj5952;
  sourceObject = obj5952;
objclass5952 = obj5952->class;
  objclass5952->definitionModule = modulename;
  objclass5952->definitionLine = 1315;
  (*(struct UserObject *)self).data[0] = lowerouter5952;
  self = oldself5952;
  selfslot = oldselfslot5952;
  stackframe = oldstackframe5952;
  gc_frame_end(frame);
  return obj5952;
}
Object meth_ast_stringNode5977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "stringNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_stringNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for stringNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for stringNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_stringNode
  gc_frame_end(frame);
  return *var_stringNode;
}
Object meth_ast_accept5985(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5986 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call5987 = callmethod(*var_visitor, "visitString",
    1, partcv, params);
  gc_frame_end(callframe5986);
// compilenode returning call5987
  gc_frame_end(frame);
  return call5987;
}
Object meth_ast_map_40__41_before_40__41_after5988(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5989 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call5990 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe5989);
// compilenode returning call5990
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5991 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call5992 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5991);
// compilenode returning call5992
  *var_n = call5992;
  if (call5992 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5993 = gc_frame_new();
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5994 = gc_frame_new();
  partcv[0] = 0;
  Object call5995 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5994);
// compilenode returning call5995
  gc_frame_newslot(call5995);
// compilenode returning *var_n
  params[0] = call5995;
  partcv[0] = 1;
  Object call5996 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe5993);
// compilenode returning call5996
// compilenode returning done
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5997 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call5998 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe5997);
// compilenode returning call5998
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6002(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6005(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map5999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6000 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6001 = alloc_Block(NULL, NULL, "ast", 1352);
  gc_frame_newslot(block6001);
  block_savedest(block6001);
  Object closure6002 = createclosure(1, "_apply");
setclosureframe(closure6002, stackframe);
  addtoclosure(closure6002, selfslot);
  struct UserObject *uo6002 = (struct UserObject*)block6001;
  uo6002->data[0] = (Object)closure6002;
  Method *meth_meth_ast__apply6002 = addmethod2pos(block6001, "_apply", &meth_ast__apply6002, 0);
int argcv_meth_ast__apply6002[] = {0};
meth_meth_ast__apply6002->type = alloc_MethodType(1, argcv_meth_ast__apply6002);
  meth_meth_ast__apply6002->definitionModule = modulename;
  meth_meth_ast__apply6002->definitionLine = 1334;
// compilenode returning block6001
  gc_frame_newslot(block6001);
  Object block6004 = alloc_Block(NULL, NULL, "ast", 1352);
  gc_frame_newslot(block6004);
  block_savedest(block6004);
  Object closure6005 = createclosure(1, "_apply");
setclosureframe(closure6005, stackframe);
  addtoclosure(closure6005, selfslot);
  struct UserObject *uo6005 = (struct UserObject*)block6004;
  uo6005->data[0] = (Object)closure6005;
  Method *meth_meth_ast__apply6005 = addmethod2pos(block6004, "_apply", &meth_ast__apply6005, 0);
int argcv_meth_ast__apply6005[] = {0};
meth_meth_ast__apply6005->type = alloc_MethodType(1, argcv_meth_ast__apply6005);
  meth_meth_ast__apply6005->definitionModule = modulename;
  meth_meth_ast__apply6005->definitionLine = 1334;
// compilenode returning block6004
  gc_frame_newslot(block6004);
  params[0] = *var_blk;
  params[1] = block6001;
  params[2] = block6004;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6007 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6000);
// compilenode returning call6007
  gc_frame_end(frame);
  return call6007;
}
Object meth_ast_pretty6008(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6010 == NULL) {
    strlit6010 = alloc_String(")");
    gc_root(strlit6010);
  }
// compilenode returning strlit6010
  int op_slot_right_6009 = gc_frame_newslot(strlit6010);
  int callframe6013 = gc_frame_new();
  partcv[0] = 0;
  Object call6014 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6013);
// compilenode returning call6014
// compilenode returning call6014
  int op_slot_right_6012 = gc_frame_newslot(call6014);
  if (strlit6016 == NULL) {
    strlit6016 = alloc_String("String(");
    gc_root(strlit6016);
  }
// compilenode returning strlit6016
  int op_slot_left_6012 = gc_frame_newslot(strlit6016);
  params[0] = call6014;
  partcv[0] = 1;
  Object opresult6017 = callmethod(strlit6016, "++", 1, partcv, params);
// compilenode returning opresult6017
  int op_slot_left_6009 = gc_frame_newslot(opresult6017);
  params[0] = strlit6010;
  partcv[0] = 1;
  Object opresult6018 = callmethod(opresult6017, "++", 1, partcv, params);
// compilenode returning opresult6018
  gc_frame_end(frame);
  return opresult6018;
}
Object meth_ast__apply6025(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6028 == NULL) {
    strlit6028 = alloc_String("""\x0a""");
    gc_root(strlit6028);
  }
// compilenode returning strlit6028
  int op_slot_right_6027 = gc_frame_newslot(strlit6028);
// compilenode returning *var_c
  int op_slot_left_6027 = gc_frame_newslot(*var_c);
  params[0] = strlit6028;
  partcv[0] = 1;
  Object opresult6030 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6030
  Object if6026 = done;
  if (istrue(opresult6030)) {
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6032 == NULL) {
    strlit6032 = alloc_String("\\n");
    gc_root(strlit6032);
  }
// compilenode returning strlit6032
  int op_slot_right_6031 = gc_frame_newslot(strlit6032);
// compilenode returning *var_s
  int op_slot_left_6031 = gc_frame_newslot(*var_s);
  params[0] = strlit6032;
  partcv[0] = 1;
  Object opresult6034 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6034
  *var_s = opresult6034;
  if (opresult6034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6026 = done;
  } else {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1363
  setline(1363);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6038 == NULL) {
    strlit6038 = alloc_String("""\x09""");
    gc_root(strlit6038);
  }
// compilenode returning strlit6038
  int op_slot_right_6037 = gc_frame_newslot(strlit6038);
// compilenode returning *var_c
  int op_slot_left_6037 = gc_frame_newslot(*var_c);
  params[0] = strlit6038;
  partcv[0] = 1;
  Object opresult6040 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6040
  Object if6036 = done;
  if (istrue(opresult6040)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6042 == NULL) {
    strlit6042 = alloc_String("\\t");
    gc_root(strlit6042);
  }
// compilenode returning strlit6042
  int op_slot_right_6041 = gc_frame_newslot(strlit6042);
// compilenode returning *var_s
  int op_slot_left_6041 = gc_frame_newslot(*var_s);
  params[0] = strlit6042;
  partcv[0] = 1;
  Object opresult6044 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6044
  *var_s = opresult6044;
  if (opresult6044 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6036 = done;
  } else {
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6048 == NULL) {
    strlit6048 = alloc_String("""\x22""");
    gc_root(strlit6048);
  }
// compilenode returning strlit6048
  int op_slot_right_6047 = gc_frame_newslot(strlit6048);
// compilenode returning *var_c
  int op_slot_left_6047 = gc_frame_newslot(*var_c);
  params[0] = strlit6048;
  partcv[0] = 1;
  Object opresult6050 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6050
  Object if6046 = done;
  if (istrue(opresult6050)) {
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String("\\""\x22""");
    gc_root(strlit6052);
  }
// compilenode returning strlit6052
  int op_slot_right_6051 = gc_frame_newslot(strlit6052);
// compilenode returning *var_s
  int op_slot_left_6051 = gc_frame_newslot(*var_s);
  params[0] = strlit6052;
  partcv[0] = 1;
  Object opresult6054 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6054
  *var_s = opresult6054;
  if (opresult6054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6046 = done;
  } else {
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6058 == NULL) {
    strlit6058 = alloc_String("\\");
    gc_root(strlit6058);
  }
// compilenode returning strlit6058
  int op_slot_right_6057 = gc_frame_newslot(strlit6058);
// compilenode returning *var_c
  int op_slot_left_6057 = gc_frame_newslot(*var_c);
  params[0] = strlit6058;
  partcv[0] = 1;
  Object opresult6060 = callmethod(*var_c, "==", 1, partcv, params);
// compilenode returning opresult6060
  Object if6056 = done;
  if (istrue(opresult6060)) {
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6062 == NULL) {
    strlit6062 = alloc_String("\\\\");
    gc_root(strlit6062);
  }
// compilenode returning strlit6062
  int op_slot_right_6061 = gc_frame_newslot(strlit6062);
// compilenode returning *var_s
  int op_slot_left_6061 = gc_frame_newslot(*var_s);
  params[0] = strlit6062;
  partcv[0] = 1;
  Object opresult6064 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6064
  *var_s = opresult6064;
  if (opresult6064 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6056 = done;
  } else {
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_c
  int op_slot_right_6066 = gc_frame_newslot(*var_c);
// compilenode returning *var_s
  int op_slot_left_6066 = gc_frame_newslot(*var_s);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult6068 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6068
  *var_s = opresult6068;
  if (opresult6068 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6056 = done;
  }
// compilenode returning if6056
    gc_frame_newslot(if6056);
    if6046 = if6056;
  }
// compilenode returning if6046
    gc_frame_newslot(if6046);
    if6036 = if6046;
  }
// compilenode returning if6036
    gc_frame_newslot(if6036);
    if6026 = if6036;
  }
// compilenode returning if6026
  gc_frame_end(frame);
  return if6026;
}
Object meth_ast_toGrace6019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6020 == NULL) {
    strlit6020 = alloc_String("""\x22""");
    gc_root(strlit6020);
  }
// compilenode returning strlit6020
  *var_s = strlit6020;
  if (strlit6020 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6021 = gc_frame_new();
  int callframe6022 = gc_frame_new();
  partcv[0] = 0;
  Object call6023 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6022);
// compilenode returning call6023
// compilenode returning call6023
  gc_frame_newslot(call6023);
  Object block6024 = alloc_Block(NULL, NULL, "ast", 1359);
  gc_frame_newslot(block6024);
  block_savedest(block6024);
  Object closure6025 = createclosure(2, "_apply");
setclosureframe(closure6025, stackframe);
  addtoclosure(closure6025, var_s);
  addtoclosure(closure6025, selfslot);
  struct UserObject *uo6025 = (struct UserObject*)block6024;
  uo6025->data[0] = (Object)closure6025;
  Method *meth_meth_ast__apply6025 = addmethod2pos(block6024, "_apply", &meth_ast__apply6025, 0);
int argcv_meth_ast__apply6025[] = {1};
meth_meth_ast__apply6025->type = alloc_MethodType(1, argcv_meth_ast__apply6025);
  meth_meth_ast__apply6025->definitionModule = modulename;
  meth_meth_ast__apply6025->definitionLine = 1359;
// compilenode returning block6024
  gc_frame_newslot(block6024);
  params[0] = call6023;
  params[1] = block6024;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6071 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6021);
// compilenode returning call6071
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6073 == NULL) {
    strlit6073 = alloc_String("""\x22""");
    gc_root(strlit6073);
  }
// compilenode returning strlit6073
  int op_slot_right_6072 = gc_frame_newslot(strlit6073);
// compilenode returning *var_s
  int op_slot_left_6072 = gc_frame_newslot(*var_s);
  params[0] = strlit6073;
  partcv[0] = 1;
  Object opresult6075 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6075
  *var_s = opresult6075;
  if (opresult6075 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new5980(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5981 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5981 = alloc_userobj2(9,9, objclass5981);
  gc_frame_newslot(obj5981);
if (objclass5981 == NULL) {
  glfree(obj5981->class->name);
  obj5981->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5981, self, 0);
  addmethodreal(obj5981,"outer", &reader_ast_outer_5982);
  Object oldself5981 = self;
  struct StackFrameObject *oldstackframe5981 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5981);
  gc_frame_newslot((Object)stackframe);
  self = obj5981;
  Object *oldselfslot5981 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5981 = (*(struct UserObject *)self).data[0], lowerouter5981 = thisouter5981;
  if (inheritingObject5981) {
    struct UserObject *inho5981 = (struct UserObject *)inheritingObject5981;
    while (inho5981->super != GraceDefaultObject) inho5981 = (struct UserObject *)inho5981->super;
    inho5981->super = obj5981;
    self = inheritingObject5981;
    *selfslot = self;
    lowerouter5981 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5981;
  }
if (objclass5981 == NULL) {
  Method *reader5983 = addmethodrealflags(obj5981, "kind",&reader_ast_kind_5983, MFLAG_DEF);
  reader5983->definitionModule = modulename;
  reader5983->definitionLine = 1340;
}
adddatum2(obj5981, alloc_Undefined(), 1);
if (objclass5981 == NULL) {
  Method *reader5984 = addmethodrealflags(obj5981, "value",&reader_ast_value_5984, 0);
  Method *writer5984 = addmethodrealflags(obj5981, "value:=",&writer_ast_value_5984, 0);
  reader5984->definitionModule = modulename;
  writer5984->definitionModule = modulename;
  reader5984->definitionLine = 1341;
  writer5984->definitionLine = 1341;
}
obj5981->flags |= OFLAG_MUTABLE;
adddatum2(obj5981, alloc_Undefined(), 2);
  struct UserObject *uo5985 = (struct UserObject*)obj5981;
  uo5985->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5985 = addmethod2pos(obj5981, "accept", &meth_ast_accept5985, 3);
int argcv_meth_ast_accept5985[] = {1};
meth_meth_ast_accept5985->type = alloc_MethodType(1, argcv_meth_ast_accept5985);
meth_meth_ast_accept5985->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5985->type->names[0] = "visitor";
  meth_meth_ast_accept5985->definitionModule = modulename;
  meth_meth_ast_accept5985->definitionLine = 1341;
  struct UserObject *uo5988 = (struct UserObject*)obj5981;
  uo5988->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after5988 = addmethod2pos(obj5981, "map()before()after", &meth_ast_map_40__41_before_40__41_after5988, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5988[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5988->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5988);
  meth_meth_ast_map_40__41_before_40__41_after5988->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5988->definitionLine = 1344;
  struct UserObject *uo5999 = (struct UserObject*)obj5981;
  uo5999->data[5] = emptyclosure;
  Method *meth_meth_ast_map5999 = addmethod2pos(obj5981, "map", &meth_ast_map5999, 5);
int argcv_meth_ast_map5999[] = {1};
meth_meth_ast_map5999->type = alloc_MethodType(1, argcv_meth_ast_map5999);
  meth_meth_ast_map5999->definitionModule = modulename;
  meth_meth_ast_map5999->definitionLine = 1351;
  struct UserObject *uo6008 = (struct UserObject*)obj5981;
  uo6008->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6008 = addmethod2pos(obj5981, "pretty", &meth_ast_pretty6008, 6);
int argcv_meth_ast_pretty6008[] = {1};
meth_meth_ast_pretty6008->type = alloc_MethodType(1, argcv_meth_ast_pretty6008);
  meth_meth_ast_pretty6008->definitionModule = modulename;
  meth_meth_ast_pretty6008->definitionLine = 1354;
  struct UserObject *uo6019 = (struct UserObject*)obj5981;
  uo6019->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6019 = addmethod2pos(obj5981, "toGrace", &meth_ast_toGrace6019, 7);
int argcv_meth_ast_toGrace6019[] = {1};
meth_meth_ast_toGrace6019->type = alloc_MethodType(1, argcv_meth_ast_toGrace6019);
meth_meth_ast_toGrace6019->type->types[0] = type_Number;
meth_meth_ast_toGrace6019->type->names[0] = "depth";
  meth_meth_ast_toGrace6019->definitionModule = modulename;
  meth_meth_ast_toGrace6019->definitionLine = 1357;
  sourceObject = obj5981;
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6077 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6078 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6077);
// compilenode returning call6078
  struct UserObject *obj5981_uo = (struct UserObject *)obj5981;
  obj5981_uo->super = call6078;
  sourceObject = obj5981;
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6079 == NULL) {
    strlit6079 = alloc_String("string");
    gc_root(strlit6079);
  }
// compilenode returning strlit6079
  adddatum2(obj5981, strlit6079, 1);
  sourceObject = obj5981;
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_v
  adddatum2(obj5981, *var_v, 2);
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
objclass5981 = obj5981->class;
  objclass5981->definitionModule = modulename;
  objclass5981->definitionLine = 1334;
  (*(struct UserObject *)self).data[0] = lowerouter5981;
  self = oldself5981;
  selfslot = oldselfslot5981;
  stackframe = oldstackframe5981;
  gc_frame_end(frame);
  return obj5981;
}
Object meth_ast_new5980_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5981 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5981 = alloc_userobj2(9,9, objclass5981);
  gc_frame_newslot(obj5981);
if (objclass5981 == NULL) {
  glfree(obj5981->class->name);
  obj5981->class->name = "stringNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5981, self, 0);
  addmethodreal(obj5981,"outer", &reader_ast_outer_5982);
  Object oldself5981 = self;
  struct StackFrameObject *oldstackframe5981 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5981);
  gc_frame_newslot((Object)stackframe);
  self = obj5981;
  Object *oldselfslot5981 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5981 = (*(struct UserObject *)self).data[0], lowerouter5981 = thisouter5981;
  if (inheritingObject5981) {
    struct UserObject *inho5981 = (struct UserObject *)inheritingObject5981;
    while (inho5981->super != GraceDefaultObject) inho5981 = (struct UserObject *)inho5981->super;
    inho5981->super = obj5981;
    self = inheritingObject5981;
    *selfslot = self;
    lowerouter5981 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5981;
  }
if (objclass5981 == NULL) {
  Method *reader5983 = addmethodrealflags(obj5981, "kind",&reader_ast_kind_5983, MFLAG_DEF);
  reader5983->definitionModule = modulename;
  reader5983->definitionLine = 1340;
}
adddatum2(obj5981, alloc_Undefined(), 1);
if (objclass5981 == NULL) {
  Method *reader5984 = addmethodrealflags(obj5981, "value",&reader_ast_value_5984, 0);
  Method *writer5984 = addmethodrealflags(obj5981, "value:=",&writer_ast_value_5984, 0);
  reader5984->definitionModule = modulename;
  writer5984->definitionModule = modulename;
  reader5984->definitionLine = 1341;
  writer5984->definitionLine = 1341;
}
obj5981->flags |= OFLAG_MUTABLE;
adddatum2(obj5981, alloc_Undefined(), 2);
  struct UserObject *uo5985 = (struct UserObject*)obj5981;
  uo5985->data[3] = emptyclosure;
  Method *meth_meth_ast_accept5985 = addmethod2pos(obj5981, "accept", &meth_ast_accept5985, 3);
int argcv_meth_ast_accept5985[] = {1};
meth_meth_ast_accept5985->type = alloc_MethodType(1, argcv_meth_ast_accept5985);
meth_meth_ast_accept5985->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept5985->type->names[0] = "visitor";
  meth_meth_ast_accept5985->definitionModule = modulename;
  meth_meth_ast_accept5985->definitionLine = 1341;
  struct UserObject *uo5988 = (struct UserObject*)obj5981;
  uo5988->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after5988 = addmethod2pos(obj5981, "map()before()after", &meth_ast_map_40__41_before_40__41_after5988, 4);
int argcv_meth_ast_map_40__41_before_40__41_after5988[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after5988->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after5988);
  meth_meth_ast_map_40__41_before_40__41_after5988->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after5988->definitionLine = 1344;
  struct UserObject *uo5999 = (struct UserObject*)obj5981;
  uo5999->data[5] = emptyclosure;
  Method *meth_meth_ast_map5999 = addmethod2pos(obj5981, "map", &meth_ast_map5999, 5);
int argcv_meth_ast_map5999[] = {1};
meth_meth_ast_map5999->type = alloc_MethodType(1, argcv_meth_ast_map5999);
  meth_meth_ast_map5999->definitionModule = modulename;
  meth_meth_ast_map5999->definitionLine = 1351;
  struct UserObject *uo6008 = (struct UserObject*)obj5981;
  uo6008->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6008 = addmethod2pos(obj5981, "pretty", &meth_ast_pretty6008, 6);
int argcv_meth_ast_pretty6008[] = {1};
meth_meth_ast_pretty6008->type = alloc_MethodType(1, argcv_meth_ast_pretty6008);
  meth_meth_ast_pretty6008->definitionModule = modulename;
  meth_meth_ast_pretty6008->definitionLine = 1354;
  struct UserObject *uo6019 = (struct UserObject*)obj5981;
  uo6019->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6019 = addmethod2pos(obj5981, "toGrace", &meth_ast_toGrace6019, 7);
int argcv_meth_ast_toGrace6019[] = {1};
meth_meth_ast_toGrace6019->type = alloc_MethodType(1, argcv_meth_ast_toGrace6019);
meth_meth_ast_toGrace6019->type->types[0] = type_Number;
meth_meth_ast_toGrace6019->type->names[0] = "depth";
  meth_meth_ast_toGrace6019->definitionModule = modulename;
  meth_meth_ast_toGrace6019->definitionLine = 1357;
  sourceObject = obj5981;
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6077 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6078 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6077);
// compilenode returning call6078
  struct UserObject *obj5981_uo = (struct UserObject *)obj5981;
  obj5981_uo->super = call6078;
  sourceObject = obj5981;
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6079 == NULL) {
    strlit6079 = alloc_String("string");
    gc_root(strlit6079);
  }
// compilenode returning strlit6079
  adddatum2(obj5981, strlit6079, 1);
  sourceObject = obj5981;
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_v
  adddatum2(obj5981, *var_v, 2);
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
  sourceObject = obj5981;
objclass5981 = obj5981->class;
  objclass5981->definitionModule = modulename;
  objclass5981->definitionLine = 1334;
  (*(struct UserObject *)self).data[0] = lowerouter5981;
  self = oldself5981;
  selfslot = oldselfslot5981;
  stackframe = oldstackframe5981;
  gc_frame_end(frame);
  return obj5981;
}
Object meth_ast_numNode6081(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "numNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_numNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for numNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for numNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_numNode
  gc_frame_end(frame);
  return *var_numNode;
}
Object meth_ast_accept6089(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6090 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6091 = callmethod(*var_visitor, "visitNum",
    1, partcv, params);
  gc_frame_end(callframe6090);
// compilenode returning call6091
  gc_frame_end(frame);
  return call6091;
}
Object meth_ast_map_40__41_before_40__41_after6092(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6093 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6094 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6093);
// compilenode returning call6094
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6095 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call6096 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6095);
// compilenode returning call6096
  *var_n = call6096;
  if (call6096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6097 = gc_frame_new();
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6098 = gc_frame_new();
  partcv[0] = 0;
  Object call6099 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6098);
// compilenode returning call6099
  gc_frame_newslot(call6099);
// compilenode returning *var_n
  params[0] = call6099;
  partcv[0] = 1;
  Object call6100 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6097);
// compilenode returning call6100
// compilenode returning done
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6101 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6102 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6101);
// compilenode returning call6102
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6106(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6109(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6104 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6105 = alloc_Block(NULL, NULL, "ast", 1392);
  gc_frame_newslot(block6105);
  block_savedest(block6105);
  Object closure6106 = createclosure(1, "_apply");
setclosureframe(closure6106, stackframe);
  addtoclosure(closure6106, selfslot);
  struct UserObject *uo6106 = (struct UserObject*)block6105;
  uo6106->data[0] = (Object)closure6106;
  Method *meth_meth_ast__apply6106 = addmethod2pos(block6105, "_apply", &meth_ast__apply6106, 0);
int argcv_meth_ast__apply6106[] = {0};
meth_meth_ast__apply6106->type = alloc_MethodType(1, argcv_meth_ast__apply6106);
  meth_meth_ast__apply6106->definitionModule = modulename;
  meth_meth_ast__apply6106->definitionLine = 1359;
// compilenode returning block6105
  gc_frame_newslot(block6105);
  Object block6108 = alloc_Block(NULL, NULL, "ast", 1392);
  gc_frame_newslot(block6108);
  block_savedest(block6108);
  Object closure6109 = createclosure(1, "_apply");
setclosureframe(closure6109, stackframe);
  addtoclosure(closure6109, selfslot);
  struct UserObject *uo6109 = (struct UserObject*)block6108;
  uo6109->data[0] = (Object)closure6109;
  Method *meth_meth_ast__apply6109 = addmethod2pos(block6108, "_apply", &meth_ast__apply6109, 0);
int argcv_meth_ast__apply6109[] = {0};
meth_meth_ast__apply6109->type = alloc_MethodType(1, argcv_meth_ast__apply6109);
  meth_meth_ast__apply6109->definitionModule = modulename;
  meth_meth_ast__apply6109->definitionLine = 1359;
// compilenode returning block6108
  gc_frame_newslot(block6108);
  params[0] = *var_blk;
  params[1] = block6105;
  params[2] = block6108;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6111 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6104);
// compilenode returning call6111
  gc_frame_end(frame);
  return call6111;
}
Object meth_ast_pretty6112(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6114 == NULL) {
    strlit6114 = alloc_String(")");
    gc_root(strlit6114);
  }
// compilenode returning strlit6114
  int op_slot_right_6113 = gc_frame_newslot(strlit6114);
  int callframe6117 = gc_frame_new();
  partcv[0] = 0;
  Object call6118 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6117);
// compilenode returning call6118
// compilenode returning call6118
  int op_slot_right_6116 = gc_frame_newslot(call6118);
  if (strlit6120 == NULL) {
    strlit6120 = alloc_String("Num(");
    gc_root(strlit6120);
  }
// compilenode returning strlit6120
  int op_slot_left_6116 = gc_frame_newslot(strlit6120);
  params[0] = call6118;
  partcv[0] = 1;
  Object opresult6121 = callmethod(strlit6120, "++", 1, partcv, params);
// compilenode returning opresult6121
  int op_slot_left_6113 = gc_frame_newslot(opresult6121);
  params[0] = strlit6114;
  partcv[0] = 1;
  Object opresult6122 = callmethod(opresult6121, "++", 1, partcv, params);
// compilenode returning opresult6122
  gc_frame_end(frame);
  return opresult6122;
}
Object meth_ast_toGrace6123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6124 = gc_frame_new();
  int callframe6125 = gc_frame_new();
  partcv[0] = 0;
  Object call6126 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6125);
// compilenode returning call6126
// compilenode returning call6126
  partcv[0] = 0;
  Object call6127 = callmethod(call6126, "asString",
    1, partcv, params);
  gc_frame_end(callframe6124);
// compilenode returning call6127
// compilenode returning call6127
  gc_frame_end(frame);
  return call6127;
}
Object meth_ast_new6084(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6085 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6085 = alloc_userobj2(8,9, objclass6085);
  gc_frame_newslot(obj6085);
if (objclass6085 == NULL) {
  glfree(obj6085->class->name);
  obj6085->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6085, self, 0);
  addmethodreal(obj6085,"outer", &reader_ast_outer_6086);
  Object oldself6085 = self;
  struct StackFrameObject *oldstackframe6085 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6085);
  gc_frame_newslot((Object)stackframe);
  self = obj6085;
  Object *oldselfslot6085 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6085 = (*(struct UserObject *)self).data[0], lowerouter6085 = thisouter6085;
  if (inheritingObject6085) {
    struct UserObject *inho6085 = (struct UserObject *)inheritingObject6085;
    while (inho6085->super != GraceDefaultObject) inho6085 = (struct UserObject *)inho6085->super;
    inho6085->super = obj6085;
    self = inheritingObject6085;
    *selfslot = self;
    lowerouter6085 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6085;
  }
if (objclass6085 == NULL) {
  Method *reader6087 = addmethodrealflags(obj6085, "kind",&reader_ast_kind_6087, MFLAG_DEF);
  reader6087->definitionModule = modulename;
  reader6087->definitionLine = 1380;
}
adddatum2(obj6085, alloc_Undefined(), 1);
if (objclass6085 == NULL) {
  Method *reader6088 = addmethodrealflags(obj6085, "value",&reader_ast_value_6088, MFLAG_DEF);
  reader6088->definitionModule = modulename;
  reader6088->definitionLine = 1381;
}
adddatum2(obj6085, alloc_Undefined(), 2);
  struct UserObject *uo6089 = (struct UserObject*)obj6085;
  uo6089->data[3] = emptyclosure;
  Method *meth_meth_ast_accept6089 = addmethod2pos(obj6085, "accept", &meth_ast_accept6089, 3);
int argcv_meth_ast_accept6089[] = {1};
meth_meth_ast_accept6089->type = alloc_MethodType(1, argcv_meth_ast_accept6089);
meth_meth_ast_accept6089->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6089->type->names[0] = "visitor";
  meth_meth_ast_accept6089->definitionModule = modulename;
  meth_meth_ast_accept6089->definitionLine = 1381;
  struct UserObject *uo6092 = (struct UserObject*)obj6085;
  uo6092->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after6092 = addmethod2pos(obj6085, "map()before()after", &meth_ast_map_40__41_before_40__41_after6092, 4);
int argcv_meth_ast_map_40__41_before_40__41_after6092[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6092->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6092);
  meth_meth_ast_map_40__41_before_40__41_after6092->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6092->definitionLine = 1384;
  struct UserObject *uo6103 = (struct UserObject*)obj6085;
  uo6103->data[5] = emptyclosure;
  Method *meth_meth_ast_map6103 = addmethod2pos(obj6085, "map", &meth_ast_map6103, 5);
int argcv_meth_ast_map6103[] = {1};
meth_meth_ast_map6103->type = alloc_MethodType(1, argcv_meth_ast_map6103);
  meth_meth_ast_map6103->definitionModule = modulename;
  meth_meth_ast_map6103->definitionLine = 1391;
  struct UserObject *uo6112 = (struct UserObject*)obj6085;
  uo6112->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6112 = addmethod2pos(obj6085, "pretty", &meth_ast_pretty6112, 6);
int argcv_meth_ast_pretty6112[] = {1};
meth_meth_ast_pretty6112->type = alloc_MethodType(1, argcv_meth_ast_pretty6112);
  meth_meth_ast_pretty6112->definitionModule = modulename;
  meth_meth_ast_pretty6112->definitionLine = 1394;
  struct UserObject *uo6123 = (struct UserObject*)obj6085;
  uo6123->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6123 = addmethod2pos(obj6085, "toGrace", &meth_ast_toGrace6123, 7);
int argcv_meth_ast_toGrace6123[] = {1};
meth_meth_ast_toGrace6123->type = alloc_MethodType(1, argcv_meth_ast_toGrace6123);
meth_meth_ast_toGrace6123->type->types[0] = type_Number;
meth_meth_ast_toGrace6123->type->names[0] = "depth";
  meth_meth_ast_toGrace6123->definitionModule = modulename;
  meth_meth_ast_toGrace6123->definitionLine = 1397;
  sourceObject = obj6085;
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6128 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6129 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6128);
// compilenode returning call6129
  struct UserObject *obj6085_uo = (struct UserObject *)obj6085;
  obj6085_uo->super = call6129;
  sourceObject = obj6085;
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6130 == NULL) {
    strlit6130 = alloc_String("num");
    gc_root(strlit6130);
  }
// compilenode returning strlit6130
  adddatum2(obj6085, strlit6130, 1);
  sourceObject = obj6085;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6085, *var_val, 2);
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
objclass6085 = obj6085->class;
  objclass6085->definitionModule = modulename;
  objclass6085->definitionLine = 1359;
  (*(struct UserObject *)self).data[0] = lowerouter6085;
  self = oldself6085;
  selfslot = oldselfslot6085;
  stackframe = oldstackframe6085;
  gc_frame_end(frame);
  return obj6085;
}
Object meth_ast_new6084_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_val = &(stackframe->slots[0]);
  *var_val = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6085 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6085 = alloc_userobj2(8,9, objclass6085);
  gc_frame_newslot(obj6085);
if (objclass6085 == NULL) {
  glfree(obj6085->class->name);
  obj6085->class->name = "numNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6085, self, 0);
  addmethodreal(obj6085,"outer", &reader_ast_outer_6086);
  Object oldself6085 = self;
  struct StackFrameObject *oldstackframe6085 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6085);
  gc_frame_newslot((Object)stackframe);
  self = obj6085;
  Object *oldselfslot6085 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6085 = (*(struct UserObject *)self).data[0], lowerouter6085 = thisouter6085;
  if (inheritingObject6085) {
    struct UserObject *inho6085 = (struct UserObject *)inheritingObject6085;
    while (inho6085->super != GraceDefaultObject) inho6085 = (struct UserObject *)inho6085->super;
    inho6085->super = obj6085;
    self = inheritingObject6085;
    *selfslot = self;
    lowerouter6085 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6085;
  }
if (objclass6085 == NULL) {
  Method *reader6087 = addmethodrealflags(obj6085, "kind",&reader_ast_kind_6087, MFLAG_DEF);
  reader6087->definitionModule = modulename;
  reader6087->definitionLine = 1380;
}
adddatum2(obj6085, alloc_Undefined(), 1);
if (objclass6085 == NULL) {
  Method *reader6088 = addmethodrealflags(obj6085, "value",&reader_ast_value_6088, MFLAG_DEF);
  reader6088->definitionModule = modulename;
  reader6088->definitionLine = 1381;
}
adddatum2(obj6085, alloc_Undefined(), 2);
  struct UserObject *uo6089 = (struct UserObject*)obj6085;
  uo6089->data[3] = emptyclosure;
  Method *meth_meth_ast_accept6089 = addmethod2pos(obj6085, "accept", &meth_ast_accept6089, 3);
int argcv_meth_ast_accept6089[] = {1};
meth_meth_ast_accept6089->type = alloc_MethodType(1, argcv_meth_ast_accept6089);
meth_meth_ast_accept6089->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6089->type->names[0] = "visitor";
  meth_meth_ast_accept6089->definitionModule = modulename;
  meth_meth_ast_accept6089->definitionLine = 1381;
  struct UserObject *uo6092 = (struct UserObject*)obj6085;
  uo6092->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after6092 = addmethod2pos(obj6085, "map()before()after", &meth_ast_map_40__41_before_40__41_after6092, 4);
int argcv_meth_ast_map_40__41_before_40__41_after6092[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6092->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6092);
  meth_meth_ast_map_40__41_before_40__41_after6092->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6092->definitionLine = 1384;
  struct UserObject *uo6103 = (struct UserObject*)obj6085;
  uo6103->data[5] = emptyclosure;
  Method *meth_meth_ast_map6103 = addmethod2pos(obj6085, "map", &meth_ast_map6103, 5);
int argcv_meth_ast_map6103[] = {1};
meth_meth_ast_map6103->type = alloc_MethodType(1, argcv_meth_ast_map6103);
  meth_meth_ast_map6103->definitionModule = modulename;
  meth_meth_ast_map6103->definitionLine = 1391;
  struct UserObject *uo6112 = (struct UserObject*)obj6085;
  uo6112->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty6112 = addmethod2pos(obj6085, "pretty", &meth_ast_pretty6112, 6);
int argcv_meth_ast_pretty6112[] = {1};
meth_meth_ast_pretty6112->type = alloc_MethodType(1, argcv_meth_ast_pretty6112);
  meth_meth_ast_pretty6112->definitionModule = modulename;
  meth_meth_ast_pretty6112->definitionLine = 1394;
  struct UserObject *uo6123 = (struct UserObject*)obj6085;
  uo6123->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace6123 = addmethod2pos(obj6085, "toGrace", &meth_ast_toGrace6123, 7);
int argcv_meth_ast_toGrace6123[] = {1};
meth_meth_ast_toGrace6123->type = alloc_MethodType(1, argcv_meth_ast_toGrace6123);
meth_meth_ast_toGrace6123->type->types[0] = type_Number;
meth_meth_ast_toGrace6123->type->names[0] = "depth";
  meth_meth_ast_toGrace6123->definitionModule = modulename;
  meth_meth_ast_toGrace6123->definitionLine = 1397;
  sourceObject = obj6085;
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6128 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6129 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6128);
// compilenode returning call6129
  struct UserObject *obj6085_uo = (struct UserObject *)obj6085;
  obj6085_uo->super = call6129;
  sourceObject = obj6085;
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6130 == NULL) {
    strlit6130 = alloc_String("num");
    gc_root(strlit6130);
  }
// compilenode returning strlit6130
  adddatum2(obj6085, strlit6130, 1);
  sourceObject = obj6085;
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6085, *var_val, 2);
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
  sourceObject = obj6085;
objclass6085 = obj6085->class;
  objclass6085->definitionModule = modulename;
  objclass6085->definitionLine = 1359;
  (*(struct UserObject *)self).data[0] = lowerouter6085;
  self = oldself6085;
  selfslot = oldselfslot6085;
  stackframe = oldstackframe6085;
  gc_frame_end(frame);
  return obj6085;
}
Object meth_ast_opNode6132(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "opNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for opNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for opNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_opNode
  gc_frame_end(frame);
  return *var_opNode;
}
Object meth_ast_accept6142(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6144 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6145 = callmethod(*var_visitor, "visitOp",
    1, partcv, params);
  gc_frame_end(callframe6144);
// compilenode returning call6145
  Object if6143 = done;
  if (istrue(call6145)) {
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6146 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6147 = gc_frame_new();
  partcv[0] = 0;
  Object call6148 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6147);
// compilenode returning call6148
// compilenode returning call6148
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6149 = callmethod(call6148, "accept",
    1, partcv, params);
  gc_frame_end(callframe6146);
// compilenode returning call6149
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6150 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6151 = gc_frame_new();
  partcv[0] = 0;
  Object call6152 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6151);
// compilenode returning call6152
// compilenode returning call6152
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6153 = callmethod(call6152, "accept",
    1, partcv, params);
  gc_frame_end(callframe6150);
// compilenode returning call6153
    gc_frame_newslot(call6153);
    if6143 = call6153;
  } else {
  }
// compilenode returning if6143
  gc_frame_end(frame);
  return if6143;
}
Object meth_ast_map_40__41_before_40__41_after6154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_opNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6155 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6156 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6155);
// compilenode returning call6156
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6157 = gc_frame_new();
  int callframe6158 = gc_frame_new();
  partcv[0] = 0;
  Object call6159 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6158);
// compilenode returning call6159
  gc_frame_newslot(call6159);
  int callframe6160 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6161 = gc_frame_new();
  partcv[0] = 0;
  Object call6162 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6161);
// compilenode returning call6162
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6163 = callmethod(call6162, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6160);
// compilenode returning call6163
  gc_frame_newslot(call6163);
  int callframe6164 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6165 = gc_frame_new();
  partcv[0] = 0;
  Object call6166 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6165);
// compilenode returning call6166
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6167 = callmethod(call6166, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6164);
// compilenode returning call6167
  gc_frame_newslot(call6167);
// compilenode returning *var_opNode
  params[0] = call6159;
  params[1] = call6163;
  params[2] = call6167;
  partcv[0] = 3;
  Object call6168 = callmethod(*var_opNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6157);
// compilenode returning call6168
  *var_n = call6168;
  if (call6168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6169 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6170 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6169);
// compilenode returning call6170
  *var_n = call6170;
  if (call6170 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6172 = gc_frame_new();
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6173 = gc_frame_new();
  partcv[0] = 0;
  Object call6174 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6173);
// compilenode returning call6174
  gc_frame_newslot(call6174);
// compilenode returning *var_n
  params[0] = call6174;
  partcv[0] = 1;
  Object call6175 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6172);
// compilenode returning call6175
// compilenode returning done
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6176 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6177 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6176);
// compilenode returning call6177
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6181(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6184(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6178(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6179 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6180 = alloc_Block(NULL, NULL, "ast", 1422);
  gc_frame_newslot(block6180);
  block_savedest(block6180);
  Object closure6181 = createclosure(1, "_apply");
setclosureframe(closure6181, stackframe);
  addtoclosure(closure6181, selfslot);
  struct UserObject *uo6181 = (struct UserObject*)block6180;
  uo6181->data[0] = (Object)closure6181;
  Method *meth_meth_ast__apply6181 = addmethod2pos(block6180, "_apply", &meth_ast__apply6181, 0);
int argcv_meth_ast__apply6181[] = {0};
meth_meth_ast__apply6181->type = alloc_MethodType(1, argcv_meth_ast__apply6181);
  meth_meth_ast__apply6181->definitionModule = modulename;
  meth_meth_ast__apply6181->definitionLine = 1410;
// compilenode returning block6180
  gc_frame_newslot(block6180);
  Object block6183 = alloc_Block(NULL, NULL, "ast", 1422);
  gc_frame_newslot(block6183);
  block_savedest(block6183);
  Object closure6184 = createclosure(1, "_apply");
setclosureframe(closure6184, stackframe);
  addtoclosure(closure6184, selfslot);
  struct UserObject *uo6184 = (struct UserObject*)block6183;
  uo6184->data[0] = (Object)closure6184;
  Method *meth_meth_ast__apply6184 = addmethod2pos(block6183, "_apply", &meth_ast__apply6184, 0);
int argcv_meth_ast__apply6184[] = {0};
meth_meth_ast__apply6184->type = alloc_MethodType(1, argcv_meth_ast__apply6184);
  meth_meth_ast__apply6184->definitionModule = modulename;
  meth_meth_ast__apply6184->definitionLine = 1410;
// compilenode returning block6183
  gc_frame_newslot(block6183);
  params[0] = *var_blk;
  params[1] = block6180;
  params[2] = block6183;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6186 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6179);
// compilenode returning call6186
  gc_frame_end(frame);
  return call6186;
}
Object meth_ast__apply6195(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6197 == NULL) {
    strlit6197 = alloc_String("  ");
    gc_root(strlit6197);
  }
// compilenode returning strlit6197
  int op_slot_right_6196 = gc_frame_newslot(strlit6197);
// compilenode returning *var_spc
  int op_slot_left_6196 = gc_frame_newslot(*var_spc);
  params[0] = strlit6197;
  partcv[0] = 1;
  Object opresult6199 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6199
  *var_spc = opresult6199;
  if (opresult6199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6187(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1425
  setline(1425);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6188 == NULL) {
    strlit6188 = alloc_String("");
    gc_root(strlit6188);
  }
// compilenode returning strlit6188
  *var_spc = strlit6188;
  if (strlit6188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6189 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6190 = gc_frame_newslot(*var_depth);
  Object num6192 = alloc_Float64(0);
// compilenode returning num6192
  int op_slot_left_6190 = gc_frame_newslot(num6192);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6193 = callmethod(num6192, "..", 1, partcv, params);
// compilenode returning opresult6193
  gc_frame_newslot(opresult6193);
  Object block6194 = alloc_Block(NULL, NULL, "ast", 1426);
  gc_frame_newslot(block6194);
  block_savedest(block6194);
  Object closure6195 = createclosure(2, "_apply");
setclosureframe(closure6195, stackframe);
  addtoclosure(closure6195, var_spc);
  addtoclosure(closure6195, selfslot);
  struct UserObject *uo6195 = (struct UserObject*)block6194;
  uo6195->data[0] = (Object)closure6195;
  Method *meth_meth_ast__apply6195 = addmethod2pos(block6194, "_apply", &meth_ast__apply6195, 0);
int argcv_meth_ast__apply6195[] = {1};
meth_meth_ast__apply6195->type = alloc_MethodType(1, argcv_meth_ast__apply6195);
  meth_meth_ast__apply6195->definitionModule = modulename;
  meth_meth_ast__apply6195->definitionLine = 1410;
// compilenode returning block6194
  gc_frame_newslot(block6194);
  params[0] = opresult6193;
  params[1] = block6194;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6202 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6189);
// compilenode returning call6202
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6204 == NULL) {
    strlit6204 = alloc_String(")");
    gc_root(strlit6204);
  }
// compilenode returning strlit6204
  int op_slot_right_6203 = gc_frame_newslot(strlit6204);
  int callframe6207 = gc_frame_new();
  partcv[0] = 0;
  Object call6208 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6207);
// compilenode returning call6208
// compilenode returning call6208
  int op_slot_right_6206 = gc_frame_newslot(call6208);
  if (strlit6210 == NULL) {
    strlit6210 = alloc_String("Op(");
    gc_root(strlit6210);
  }
// compilenode returning strlit6210
  int op_slot_left_6206 = gc_frame_newslot(strlit6210);
  params[0] = call6208;
  partcv[0] = 1;
  Object opresult6211 = callmethod(strlit6210, "++", 1, partcv, params);
// compilenode returning opresult6211
  int op_slot_left_6203 = gc_frame_newslot(opresult6211);
  params[0] = strlit6204;
  partcv[0] = 1;
  Object opresult6212 = callmethod(opresult6211, "++", 1, partcv, params);
// compilenode returning opresult6212
  *var_s = opresult6212;
  if (opresult6212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6214 == NULL) {
    strlit6214 = alloc_String("""\x0a""");
    gc_root(strlit6214);
  }
// compilenode returning strlit6214
  int op_slot_right_6213 = gc_frame_newslot(strlit6214);
// compilenode returning *var_s
  int op_slot_left_6213 = gc_frame_newslot(*var_s);
  params[0] = strlit6214;
  partcv[0] = 1;
  Object opresult6216 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6216
  *var_s = opresult6216;
  if (opresult6216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6219 = gc_frame_new();
  Object num6221 = alloc_Float64(1);
// compilenode returning num6221
  int op_slot_right_6220 = gc_frame_newslot(num6221);
// compilenode returning *var_depth
  int op_slot_left_6220 = gc_frame_newslot(*var_depth);
  params[0] = num6221;
  partcv[0] = 1;
  Object sum6223 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6223
  gc_frame_newslot(sum6223);
  int callframe6224 = gc_frame_new();
  partcv[0] = 0;
  Object call6225 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6224);
// compilenode returning call6225
// compilenode returning call6225
  params[0] = sum6223;
  partcv[0] = 1;
  Object call6226 = callmethod(call6225, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6219);
// compilenode returning call6226
  int op_slot_right_6218 = gc_frame_newslot(call6226);
// compilenode returning *var_spc
  int op_slot_right_6228 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6228 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6230 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6230
  int op_slot_left_6218 = gc_frame_newslot(opresult6230);
  params[0] = call6226;
  partcv[0] = 1;
  Object opresult6231 = callmethod(opresult6230, "++", 1, partcv, params);
// compilenode returning opresult6231
  *var_s = opresult6231;
  if (opresult6231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6234 == NULL) {
    strlit6234 = alloc_String("""\x0a""");
    gc_root(strlit6234);
  }
// compilenode returning strlit6234
  int op_slot_right_6233 = gc_frame_newslot(strlit6234);
// compilenode returning *var_s
  int op_slot_left_6233 = gc_frame_newslot(*var_s);
  params[0] = strlit6234;
  partcv[0] = 1;
  Object opresult6236 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6236
  *var_s = opresult6236;
  if (opresult6236 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1433
  setline(1433);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6239 = gc_frame_new();
  Object num6241 = alloc_Float64(1);
// compilenode returning num6241
  int op_slot_right_6240 = gc_frame_newslot(num6241);
// compilenode returning *var_depth
  int op_slot_left_6240 = gc_frame_newslot(*var_depth);
  params[0] = num6241;
  partcv[0] = 1;
  Object sum6243 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6243
  gc_frame_newslot(sum6243);
  int callframe6244 = gc_frame_new();
  partcv[0] = 0;
  Object call6245 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6244);
// compilenode returning call6245
// compilenode returning call6245
  params[0] = sum6243;
  partcv[0] = 1;
  Object call6246 = callmethod(call6245, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6239);
// compilenode returning call6246
  int op_slot_right_6238 = gc_frame_newslot(call6246);
// compilenode returning *var_spc
  int op_slot_right_6248 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6248 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6250 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6250
  int op_slot_left_6238 = gc_frame_newslot(opresult6250);
  params[0] = call6246;
  partcv[0] = 1;
  Object opresult6251 = callmethod(opresult6250, "++", 1, partcv, params);
// compilenode returning opresult6251
  *var_s = opresult6251;
  if (opresult6251 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace6253(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6254 == NULL) {
    strlit6254 = alloc_String("");
    gc_root(strlit6254);
  }
// compilenode returning strlit6254
  *var_s = strlit6254;
  if (strlit6254 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6258 = gc_frame_new();
  partcv[0] = 0;
  Object call6259 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6258);
// compilenode returning call6259
// compilenode returning call6259
  int op_slot_right_6257 = gc_frame_newslot(call6259);
  int callframe6261 = gc_frame_new();
  int callframe6262 = gc_frame_new();
  partcv[0] = 0;
  Object call6263 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6262);
// compilenode returning call6263
// compilenode returning call6263
  partcv[0] = 0;
  Object call6264 = callmethod(call6263, "value",
    1, partcv, params);
  gc_frame_end(callframe6261);
// compilenode returning call6264
// compilenode returning call6264
  int op_slot_left_6257 = gc_frame_newslot(call6264);
  params[0] = call6259;
  partcv[0] = 1;
  Object opresult6265 = callmethod(call6264, "!=", 1, partcv, params);
// compilenode returning opresult6265
  int op_slot_right_6256 = gc_frame_newslot(opresult6265);
  if (strlit6268 == NULL) {
    strlit6268 = alloc_String("op");
    gc_root(strlit6268);
  }
// compilenode returning strlit6268
  int op_slot_right_6267 = gc_frame_newslot(strlit6268);
  int callframe6270 = gc_frame_new();
  int callframe6271 = gc_frame_new();
  partcv[0] = 0;
  Object call6272 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6271);
// compilenode returning call6272
// compilenode returning call6272
  partcv[0] = 0;
  Object call6273 = callmethod(call6272, "kind",
    1, partcv, params);
  gc_frame_end(callframe6270);
// compilenode returning call6273
// compilenode returning call6273
  int op_slot_left_6267 = gc_frame_newslot(call6273);
  params[0] = strlit6268;
  partcv[0] = 1;
  Object opresult6274 = callmethod(call6273, "==", 1, partcv, params);
// compilenode returning opresult6274
  int op_slot_left_6256 = gc_frame_newslot(opresult6274);
  params[0] = opresult6265;
  partcv[0] = 1;
  Object opresult6275 = callmethod(opresult6274, "&&", 1, partcv, params);
// compilenode returning opresult6275
  Object if6255 = done;
  if (istrue(opresult6275)) {
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1439
  setline(1439);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6277 == NULL) {
    strlit6277 = alloc_String(")");
    gc_root(strlit6277);
  }
// compilenode returning strlit6277
  int op_slot_right_6276 = gc_frame_newslot(strlit6277);
  int callframe6280 = gc_frame_new();
  Object num6281 = alloc_Float64(0);
// compilenode returning num6281
  gc_frame_newslot(num6281);
  int callframe6282 = gc_frame_new();
  partcv[0] = 0;
  Object call6283 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6282);
// compilenode returning call6283
// compilenode returning call6283
  params[0] = num6281;
  partcv[0] = 1;
  Object call6284 = callmethod(call6283, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6280);
// compilenode returning call6284
  int op_slot_right_6279 = gc_frame_newslot(call6284);
  if (strlit6286 == NULL) {
    strlit6286 = alloc_String("(");
    gc_root(strlit6286);
  }
// compilenode returning strlit6286
  int op_slot_left_6279 = gc_frame_newslot(strlit6286);
  params[0] = call6284;
  partcv[0] = 1;
  Object opresult6287 = callmethod(strlit6286, "++", 1, partcv, params);
// compilenode returning opresult6287
  int op_slot_left_6276 = gc_frame_newslot(opresult6287);
  params[0] = strlit6277;
  partcv[0] = 1;
  Object opresult6288 = callmethod(opresult6287, "++", 1, partcv, params);
// compilenode returning opresult6288
  *var_s = opresult6288;
  if (opresult6288 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6255 = done;
  } else {
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6290 = gc_frame_new();
  Object num6291 = alloc_Float64(0);
// compilenode returning num6291
  gc_frame_newslot(num6291);
  int callframe6292 = gc_frame_new();
  partcv[0] = 0;
  Object call6293 = callmethodflags(self, "left", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6292);
// compilenode returning call6293
// compilenode returning call6293
  params[0] = num6291;
  partcv[0] = 1;
  Object call6294 = callmethod(call6293, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6290);
// compilenode returning call6294
  *var_s = call6294;
  if (call6294 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6255 = done;
  }
// compilenode returning if6255
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6298 == NULL) {
    strlit6298 = alloc_String("..");
    gc_root(strlit6298);
  }
// compilenode returning strlit6298
  int op_slot_right_6297 = gc_frame_newslot(strlit6298);
  int callframe6300 = gc_frame_new();
  partcv[0] = 0;
  Object call6301 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6300);
// compilenode returning call6301
// compilenode returning call6301
  int op_slot_left_6297 = gc_frame_newslot(call6301);
  params[0] = strlit6298;
  partcv[0] = 1;
  Object opresult6302 = callmethod(call6301, "==", 1, partcv, params);
// compilenode returning opresult6302
  Object if6296 = done;
  if (istrue(opresult6302)) {
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6304 = gc_frame_new();
  partcv[0] = 0;
  Object call6305 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6304);
// compilenode returning call6305
// compilenode returning call6305
  int op_slot_right_6303 = gc_frame_newslot(call6305);
// compilenode returning *var_s
  int op_slot_left_6303 = gc_frame_newslot(*var_s);
  params[0] = call6305;
  partcv[0] = 1;
  Object opresult6307 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6307
  *var_s = opresult6307;
  if (opresult6307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6296 = done;
  } else {
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6310 == NULL) {
    strlit6310 = alloc_String(" ");
    gc_root(strlit6310);
  }
// compilenode returning strlit6310
  int op_slot_right_6309 = gc_frame_newslot(strlit6310);
  int callframe6313 = gc_frame_new();
  partcv[0] = 0;
  Object call6314 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6313);
// compilenode returning call6314
// compilenode returning call6314
  int op_slot_right_6312 = gc_frame_newslot(call6314);
  if (strlit6317 == NULL) {
    strlit6317 = alloc_String(" ");
    gc_root(strlit6317);
  }
// compilenode returning strlit6317
  int op_slot_right_6316 = gc_frame_newslot(strlit6317);
// compilenode returning *var_s
  int op_slot_left_6316 = gc_frame_newslot(*var_s);
  params[0] = strlit6317;
  partcv[0] = 1;
  Object opresult6319 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6319
  int op_slot_left_6312 = gc_frame_newslot(opresult6319);
  params[0] = call6314;
  partcv[0] = 1;
  Object opresult6320 = callmethod(opresult6319, "++", 1, partcv, params);
// compilenode returning opresult6320
  int op_slot_left_6309 = gc_frame_newslot(opresult6320);
  params[0] = strlit6310;
  partcv[0] = 1;
  Object opresult6321 = callmethod(opresult6320, "++", 1, partcv, params);
// compilenode returning opresult6321
  *var_s = opresult6321;
  if (opresult6321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6296 = done;
  }
// compilenode returning if6296
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6326 = gc_frame_new();
  partcv[0] = 0;
  Object call6327 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6326);
// compilenode returning call6327
// compilenode returning call6327
  int op_slot_right_6325 = gc_frame_newslot(call6327);
  int callframe6329 = gc_frame_new();
  int callframe6330 = gc_frame_new();
  partcv[0] = 0;
  Object call6331 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6330);
// compilenode returning call6331
// compilenode returning call6331
  partcv[0] = 0;
  Object call6332 = callmethod(call6331, "value",
    1, partcv, params);
  gc_frame_end(callframe6329);
// compilenode returning call6332
// compilenode returning call6332
  int op_slot_left_6325 = gc_frame_newslot(call6332);
  params[0] = call6327;
  partcv[0] = 1;
  Object opresult6333 = callmethod(call6332, "!=", 1, partcv, params);
// compilenode returning opresult6333
  int op_slot_right_6324 = gc_frame_newslot(opresult6333);
  if (strlit6336 == NULL) {
    strlit6336 = alloc_String("op");
    gc_root(strlit6336);
  }
// compilenode returning strlit6336
  int op_slot_right_6335 = gc_frame_newslot(strlit6336);
  int callframe6338 = gc_frame_new();
  int callframe6339 = gc_frame_new();
  partcv[0] = 0;
  Object call6340 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6339);
// compilenode returning call6340
// compilenode returning call6340
  partcv[0] = 0;
  Object call6341 = callmethod(call6340, "kind",
    1, partcv, params);
  gc_frame_end(callframe6338);
// compilenode returning call6341
// compilenode returning call6341
  int op_slot_left_6335 = gc_frame_newslot(call6341);
  params[0] = strlit6336;
  partcv[0] = 1;
  Object opresult6342 = callmethod(call6341, "==", 1, partcv, params);
// compilenode returning opresult6342
  int op_slot_left_6324 = gc_frame_newslot(opresult6342);
  params[0] = opresult6333;
  partcv[0] = 1;
  Object opresult6343 = callmethod(opresult6342, "&&", 1, partcv, params);
// compilenode returning opresult6343
  Object if6323 = done;
  if (istrue(opresult6343)) {
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1449
  setline(1449);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6345 == NULL) {
    strlit6345 = alloc_String(")");
    gc_root(strlit6345);
  }
// compilenode returning strlit6345
  int op_slot_right_6344 = gc_frame_newslot(strlit6345);
  int callframe6348 = gc_frame_new();
  Object num6349 = alloc_Float64(0);
// compilenode returning num6349
  gc_frame_newslot(num6349);
  int callframe6350 = gc_frame_new();
  partcv[0] = 0;
  Object call6351 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6350);
// compilenode returning call6351
// compilenode returning call6351
  params[0] = num6349;
  partcv[0] = 1;
  Object call6352 = callmethod(call6351, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6348);
// compilenode returning call6352
  int op_slot_right_6347 = gc_frame_newslot(call6352);
  if (strlit6355 == NULL) {
    strlit6355 = alloc_String("(");
    gc_root(strlit6355);
  }
// compilenode returning strlit6355
  int op_slot_right_6354 = gc_frame_newslot(strlit6355);
// compilenode returning *var_s
  int op_slot_left_6354 = gc_frame_newslot(*var_s);
  params[0] = strlit6355;
  partcv[0] = 1;
  Object opresult6357 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6357
  int op_slot_left_6347 = gc_frame_newslot(opresult6357);
  params[0] = call6352;
  partcv[0] = 1;
  Object opresult6358 = callmethod(opresult6357, "++", 1, partcv, params);
// compilenode returning opresult6358
  int op_slot_left_6344 = gc_frame_newslot(opresult6358);
  params[0] = strlit6345;
  partcv[0] = 1;
  Object opresult6359 = callmethod(opresult6358, "++", 1, partcv, params);
// compilenode returning opresult6359
  *var_s = opresult6359;
  if (opresult6359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6323 = done;
  } else {
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6362 = gc_frame_new();
  Object num6363 = alloc_Float64(0);
// compilenode returning num6363
  gc_frame_newslot(num6363);
  int callframe6364 = gc_frame_new();
  partcv[0] = 0;
  Object call6365 = callmethodflags(self, "right", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6364);
// compilenode returning call6365
// compilenode returning call6365
  params[0] = num6363;
  partcv[0] = 1;
  Object call6366 = callmethod(call6365, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6362);
// compilenode returning call6366
  int op_slot_right_6361 = gc_frame_newslot(call6366);
// compilenode returning *var_s
  int op_slot_left_6361 = gc_frame_newslot(*var_s);
  params[0] = call6366;
  partcv[0] = 1;
  Object opresult6368 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6368
  *var_s = opresult6368;
  if (opresult6368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6323 = done;
  }
// compilenode returning if6323
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6135(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_opNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6136 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6136 = alloc_userobj2(10,11, objclass6136);
  gc_frame_newslot(obj6136);
if (objclass6136 == NULL) {
  glfree(obj6136->class->name);
  obj6136->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6136, self, 0);
  addmethodreal(obj6136,"outer", &reader_ast_outer_6137);
  Object oldself6136 = self;
  struct StackFrameObject *oldstackframe6136 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6136);
  gc_frame_newslot((Object)stackframe);
  self = obj6136;
  Object *oldselfslot6136 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6136 = (*(struct UserObject *)self).data[0], lowerouter6136 = thisouter6136;
  if (inheritingObject6136) {
    struct UserObject *inho6136 = (struct UserObject *)inheritingObject6136;
    while (inho6136->super != GraceDefaultObject) inho6136 = (struct UserObject *)inho6136->super;
    inho6136->super = obj6136;
    self = inheritingObject6136;
    *selfslot = self;
    lowerouter6136 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6136;
  }
if (objclass6136 == NULL) {
  Method *reader6138 = addmethodrealflags(obj6136, "kind",&reader_ast_kind_6138, MFLAG_DEF);
  reader6138->definitionModule = modulename;
  reader6138->definitionLine = 1404;
}
adddatum2(obj6136, alloc_Undefined(), 1);
if (objclass6136 == NULL) {
  Method *reader6139 = addmethodrealflags(obj6136, "value",&reader_ast_value_6139, MFLAG_DEF);
  reader6139->definitionModule = modulename;
  reader6139->definitionLine = 1405;
}
adddatum2(obj6136, alloc_Undefined(), 2);
if (objclass6136 == NULL) {
  Method *reader6140 = addmethodrealflags(obj6136, "left",&reader_ast_left_6140, MFLAG_DEF);
  reader6140->definitionModule = modulename;
  reader6140->definitionLine = 1406;
}
adddatum2(obj6136, alloc_Undefined(), 3);
if (objclass6136 == NULL) {
  Method *reader6141 = addmethodrealflags(obj6136, "right",&reader_ast_right_6141, MFLAG_DEF);
  reader6141->definitionModule = modulename;
  reader6141->definitionLine = 1407;
}
adddatum2(obj6136, alloc_Undefined(), 4);
  struct UserObject *uo6142 = (struct UserObject*)obj6136;
  uo6142->data[5] = emptyclosure;
  Method *meth_meth_ast_accept6142 = addmethod2pos(obj6136, "accept", &meth_ast_accept6142, 5);
int argcv_meth_ast_accept6142[] = {1};
meth_meth_ast_accept6142->type = alloc_MethodType(1, argcv_meth_ast_accept6142);
meth_meth_ast_accept6142->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6142->type->names[0] = "visitor";
  meth_meth_ast_accept6142->definitionModule = modulename;
  meth_meth_ast_accept6142->definitionLine = 1407;
  block_savedest(obj6136);
  Object closure6154 = createclosure(1, "map()before()after");
setclosureframe(closure6154, stackframe);
  addtoclosure(closure6154, var_opNode);
  struct UserObject *uo6154 = (struct UserObject*)obj6136;
  uo6154->data[6] = (Object)closure6154;
  Method *meth_meth_ast_map_40__41_before_40__41_after6154 = addmethod2pos(obj6136, "map()before()after", &meth_ast_map_40__41_before_40__41_after6154, 6);
int argcv_meth_ast_map_40__41_before_40__41_after6154[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6154->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6154);
  meth_meth_ast_map_40__41_before_40__41_after6154->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6154->definitionLine = 1413;
  struct UserObject *uo6178 = (struct UserObject*)obj6136;
  uo6178->data[7] = emptyclosure;
  Method *meth_meth_ast_map6178 = addmethod2pos(obj6136, "map", &meth_ast_map6178, 7);
int argcv_meth_ast_map6178[] = {1};
meth_meth_ast_map6178->type = alloc_MethodType(1, argcv_meth_ast_map6178);
  meth_meth_ast_map6178->definitionModule = modulename;
  meth_meth_ast_map6178->definitionLine = 1421;
  struct UserObject *uo6187 = (struct UserObject*)obj6136;
  uo6187->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6187 = addmethod2pos(obj6136, "pretty", &meth_ast_pretty6187, 8);
int argcv_meth_ast_pretty6187[] = {1};
meth_meth_ast_pretty6187->type = alloc_MethodType(1, argcv_meth_ast_pretty6187);
  meth_meth_ast_pretty6187->definitionModule = modulename;
  meth_meth_ast_pretty6187->definitionLine = 1424;
  struct UserObject *uo6253 = (struct UserObject*)obj6136;
  uo6253->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6253 = addmethod2pos(obj6136, "toGrace", &meth_ast_toGrace6253, 9);
int argcv_meth_ast_toGrace6253[] = {1};
meth_meth_ast_toGrace6253->type = alloc_MethodType(1, argcv_meth_ast_toGrace6253);
meth_meth_ast_toGrace6253->type->types[0] = type_Number;
meth_meth_ast_toGrace6253->type->names[0] = "depth";
  meth_meth_ast_toGrace6253->definitionModule = modulename;
  meth_meth_ast_toGrace6253->definitionLine = 1436;
  sourceObject = obj6136;
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6370 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6371 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6370);
// compilenode returning call6371
  struct UserObject *obj6136_uo = (struct UserObject *)obj6136;
  obj6136_uo->super = call6371;
  sourceObject = obj6136;
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6372 == NULL) {
    strlit6372 = alloc_String("op");
    gc_root(strlit6372);
  }
// compilenode returning strlit6372
  adddatum2(obj6136, strlit6372, 1);
  sourceObject = obj6136;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_op
  adddatum2(obj6136, *var_op, 2);
  sourceObject = obj6136;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_l
  adddatum2(obj6136, *var_l, 3);
  sourceObject = obj6136;
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  adddatum2(obj6136, *var_r, 4);
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
objclass6136 = obj6136->class;
  objclass6136->definitionModule = modulename;
  objclass6136->definitionLine = 1398;
  (*(struct UserObject *)self).data[0] = lowerouter6136;
  self = oldself6136;
  selfslot = oldselfslot6136;
  stackframe = oldstackframe6136;
  gc_frame_end(frame);
  return obj6136;
}
Object meth_ast_new6135_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_opNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_op = &(stackframe->slots[0]);
  *var_op = args[curarg];
  curarg++;
  Object *var_l = &(stackframe->slots[1]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[2]);
  *var_r = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6136 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6136 = alloc_userobj2(10,11, objclass6136);
  gc_frame_newslot(obj6136);
if (objclass6136 == NULL) {
  glfree(obj6136->class->name);
  obj6136->class->name = "opNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6136, self, 0);
  addmethodreal(obj6136,"outer", &reader_ast_outer_6137);
  Object oldself6136 = self;
  struct StackFrameObject *oldstackframe6136 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6136);
  gc_frame_newslot((Object)stackframe);
  self = obj6136;
  Object *oldselfslot6136 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6136 = (*(struct UserObject *)self).data[0], lowerouter6136 = thisouter6136;
  if (inheritingObject6136) {
    struct UserObject *inho6136 = (struct UserObject *)inheritingObject6136;
    while (inho6136->super != GraceDefaultObject) inho6136 = (struct UserObject *)inho6136->super;
    inho6136->super = obj6136;
    self = inheritingObject6136;
    *selfslot = self;
    lowerouter6136 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6136;
  }
if (objclass6136 == NULL) {
  Method *reader6138 = addmethodrealflags(obj6136, "kind",&reader_ast_kind_6138, MFLAG_DEF);
  reader6138->definitionModule = modulename;
  reader6138->definitionLine = 1404;
}
adddatum2(obj6136, alloc_Undefined(), 1);
if (objclass6136 == NULL) {
  Method *reader6139 = addmethodrealflags(obj6136, "value",&reader_ast_value_6139, MFLAG_DEF);
  reader6139->definitionModule = modulename;
  reader6139->definitionLine = 1405;
}
adddatum2(obj6136, alloc_Undefined(), 2);
if (objclass6136 == NULL) {
  Method *reader6140 = addmethodrealflags(obj6136, "left",&reader_ast_left_6140, MFLAG_DEF);
  reader6140->definitionModule = modulename;
  reader6140->definitionLine = 1406;
}
adddatum2(obj6136, alloc_Undefined(), 3);
if (objclass6136 == NULL) {
  Method *reader6141 = addmethodrealflags(obj6136, "right",&reader_ast_right_6141, MFLAG_DEF);
  reader6141->definitionModule = modulename;
  reader6141->definitionLine = 1407;
}
adddatum2(obj6136, alloc_Undefined(), 4);
  struct UserObject *uo6142 = (struct UserObject*)obj6136;
  uo6142->data[5] = emptyclosure;
  Method *meth_meth_ast_accept6142 = addmethod2pos(obj6136, "accept", &meth_ast_accept6142, 5);
int argcv_meth_ast_accept6142[] = {1};
meth_meth_ast_accept6142->type = alloc_MethodType(1, argcv_meth_ast_accept6142);
meth_meth_ast_accept6142->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6142->type->names[0] = "visitor";
  meth_meth_ast_accept6142->definitionModule = modulename;
  meth_meth_ast_accept6142->definitionLine = 1407;
  block_savedest(obj6136);
  Object closure6154 = createclosure(1, "map()before()after");
setclosureframe(closure6154, stackframe);
  addtoclosure(closure6154, var_opNode);
  struct UserObject *uo6154 = (struct UserObject*)obj6136;
  uo6154->data[6] = (Object)closure6154;
  Method *meth_meth_ast_map_40__41_before_40__41_after6154 = addmethod2pos(obj6136, "map()before()after", &meth_ast_map_40__41_before_40__41_after6154, 6);
int argcv_meth_ast_map_40__41_before_40__41_after6154[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6154->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6154);
  meth_meth_ast_map_40__41_before_40__41_after6154->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6154->definitionLine = 1413;
  struct UserObject *uo6178 = (struct UserObject*)obj6136;
  uo6178->data[7] = emptyclosure;
  Method *meth_meth_ast_map6178 = addmethod2pos(obj6136, "map", &meth_ast_map6178, 7);
int argcv_meth_ast_map6178[] = {1};
meth_meth_ast_map6178->type = alloc_MethodType(1, argcv_meth_ast_map6178);
  meth_meth_ast_map6178->definitionModule = modulename;
  meth_meth_ast_map6178->definitionLine = 1421;
  struct UserObject *uo6187 = (struct UserObject*)obj6136;
  uo6187->data[8] = emptyclosure;
  Method *meth_meth_ast_pretty6187 = addmethod2pos(obj6136, "pretty", &meth_ast_pretty6187, 8);
int argcv_meth_ast_pretty6187[] = {1};
meth_meth_ast_pretty6187->type = alloc_MethodType(1, argcv_meth_ast_pretty6187);
  meth_meth_ast_pretty6187->definitionModule = modulename;
  meth_meth_ast_pretty6187->definitionLine = 1424;
  struct UserObject *uo6253 = (struct UserObject*)obj6136;
  uo6253->data[9] = emptyclosure;
  Method *meth_meth_ast_toGrace6253 = addmethod2pos(obj6136, "toGrace", &meth_ast_toGrace6253, 9);
int argcv_meth_ast_toGrace6253[] = {1};
meth_meth_ast_toGrace6253->type = alloc_MethodType(1, argcv_meth_ast_toGrace6253);
meth_meth_ast_toGrace6253->type->types[0] = type_Number;
meth_meth_ast_toGrace6253->type->names[0] = "depth";
  meth_meth_ast_toGrace6253->definitionModule = modulename;
  meth_meth_ast_toGrace6253->definitionLine = 1436;
  sourceObject = obj6136;
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6370 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6371 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6370);
// compilenode returning call6371
  struct UserObject *obj6136_uo = (struct UserObject *)obj6136;
  obj6136_uo->super = call6371;
  sourceObject = obj6136;
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6372 == NULL) {
    strlit6372 = alloc_String("op");
    gc_root(strlit6372);
  }
// compilenode returning strlit6372
  adddatum2(obj6136, strlit6372, 1);
  sourceObject = obj6136;
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_op
  adddatum2(obj6136, *var_op, 2);
  sourceObject = obj6136;
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_l
  adddatum2(obj6136, *var_l, 3);
  sourceObject = obj6136;
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_r
  adddatum2(obj6136, *var_r, 4);
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
  sourceObject = obj6136;
objclass6136 = obj6136->class;
  objclass6136->definitionModule = modulename;
  objclass6136->definitionLine = 1398;
  (*(struct UserObject *)self).data[0] = lowerouter6136;
  self = oldself6136;
  selfslot = oldselfslot6136;
  stackframe = oldstackframe6136;
  gc_frame_end(frame);
  return obj6136;
}
Object meth_ast_indexNode6374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indexNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for indexNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_indexNode
  gc_frame_end(frame);
  return *var_indexNode;
}
Object meth_ast_accept6383(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1462
  setline(1462);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6385 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6386 = callmethod(*var_visitor, "visitIndex",
    1, partcv, params);
  gc_frame_end(callframe6385);
// compilenode returning call6386
  Object if6384 = done;
  if (istrue(call6386)) {
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6387 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6388 = gc_frame_new();
  partcv[0] = 0;
  Object call6389 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6388);
// compilenode returning call6389
// compilenode returning call6389
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6390 = callmethod(call6389, "accept",
    1, partcv, params);
  gc_frame_end(callframe6387);
// compilenode returning call6390
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6391 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6392 = gc_frame_new();
  partcv[0] = 0;
  Object call6393 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6392);
// compilenode returning call6393
// compilenode returning call6393
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6394 = callmethod(call6393, "accept",
    1, partcv, params);
  gc_frame_end(callframe6391);
// compilenode returning call6394
    gc_frame_newslot(call6394);
    if6384 = call6394;
  } else {
  }
// compilenode returning if6384
  gc_frame_end(frame);
  return if6384;
}
Object meth_ast_map_40__41_before_40__41_after6395(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_indexNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6396 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6397 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6396);
// compilenode returning call6397
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6398 = gc_frame_new();
  int callframe6399 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6400 = gc_frame_new();
  partcv[0] = 0;
  Object call6401 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6400);
// compilenode returning call6401
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6402 = callmethod(call6401, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6399);
// compilenode returning call6402
  gc_frame_newslot(call6402);
  int callframe6403 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6404 = gc_frame_new();
  partcv[0] = 0;
  Object call6405 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6404);
// compilenode returning call6405
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6406 = callmethod(call6405, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6403);
// compilenode returning call6406
  gc_frame_newslot(call6406);
// compilenode returning *var_indexNode
  params[0] = call6402;
  params[1] = call6406;
  partcv[0] = 2;
  Object call6407 = callmethod(*var_indexNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6398);
// compilenode returning call6407
  *var_n = call6407;
  if (call6407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6408 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6409 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6408);
// compilenode returning call6409
  *var_n = call6409;
  if (call6409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6411 = gc_frame_new();
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6412 = gc_frame_new();
  partcv[0] = 0;
  Object call6413 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6412);
// compilenode returning call6413
  gc_frame_newslot(call6413);
// compilenode returning *var_n
  params[0] = call6413;
  partcv[0] = 1;
  Object call6414 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6411);
// compilenode returning call6414
// compilenode returning done
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6415 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6416 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6415);
// compilenode returning call6416
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6420(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6423(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6417(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6418 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6419 = alloc_Block(NULL, NULL, "ast", 1476);
  gc_frame_newslot(block6419);
  block_savedest(block6419);
  Object closure6420 = createclosure(1, "_apply");
setclosureframe(closure6420, stackframe);
  addtoclosure(closure6420, selfslot);
  struct UserObject *uo6420 = (struct UserObject*)block6419;
  uo6420->data[0] = (Object)closure6420;
  Method *meth_meth_ast__apply6420 = addmethod2pos(block6419, "_apply", &meth_ast__apply6420, 0);
int argcv_meth_ast__apply6420[] = {0};
meth_meth_ast__apply6420->type = alloc_MethodType(1, argcv_meth_ast__apply6420);
  meth_meth_ast__apply6420->definitionModule = modulename;
  meth_meth_ast__apply6420->definitionLine = 1464;
// compilenode returning block6419
  gc_frame_newslot(block6419);
  Object block6422 = alloc_Block(NULL, NULL, "ast", 1476);
  gc_frame_newslot(block6422);
  block_savedest(block6422);
  Object closure6423 = createclosure(1, "_apply");
setclosureframe(closure6423, stackframe);
  addtoclosure(closure6423, selfslot);
  struct UserObject *uo6423 = (struct UserObject*)block6422;
  uo6423->data[0] = (Object)closure6423;
  Method *meth_meth_ast__apply6423 = addmethod2pos(block6422, "_apply", &meth_ast__apply6423, 0);
int argcv_meth_ast__apply6423[] = {0};
meth_meth_ast__apply6423->type = alloc_MethodType(1, argcv_meth_ast__apply6423);
  meth_meth_ast__apply6423->definitionModule = modulename;
  meth_meth_ast__apply6423->definitionLine = 1464;
// compilenode returning block6422
  gc_frame_newslot(block6422);
  params[0] = *var_blk;
  params[1] = block6419;
  params[2] = block6422;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6425 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6418);
// compilenode returning call6425
  gc_frame_end(frame);
  return call6425;
}
Object meth_ast__apply6434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6436 == NULL) {
    strlit6436 = alloc_String("  ");
    gc_root(strlit6436);
  }
// compilenode returning strlit6436
  int op_slot_right_6435 = gc_frame_newslot(strlit6436);
// compilenode returning *var_spc
  int op_slot_left_6435 = gc_frame_newslot(*var_spc);
  params[0] = strlit6436;
  partcv[0] = 1;
  Object opresult6438 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6438
  *var_spc = opresult6438;
  if (opresult6438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6426(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1479
  setline(1479);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6427 == NULL) {
    strlit6427 = alloc_String("");
    gc_root(strlit6427);
  }
// compilenode returning strlit6427
  *var_spc = strlit6427;
  if (strlit6427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6428 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6429 = gc_frame_newslot(*var_depth);
  Object num6431 = alloc_Float64(0);
// compilenode returning num6431
  int op_slot_left_6429 = gc_frame_newslot(num6431);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6432 = callmethod(num6431, "..", 1, partcv, params);
// compilenode returning opresult6432
  gc_frame_newslot(opresult6432);
  Object block6433 = alloc_Block(NULL, NULL, "ast", 1480);
  gc_frame_newslot(block6433);
  block_savedest(block6433);
  Object closure6434 = createclosure(2, "_apply");
setclosureframe(closure6434, stackframe);
  addtoclosure(closure6434, var_spc);
  addtoclosure(closure6434, selfslot);
  struct UserObject *uo6434 = (struct UserObject*)block6433;
  uo6434->data[0] = (Object)closure6434;
  Method *meth_meth_ast__apply6434 = addmethod2pos(block6433, "_apply", &meth_ast__apply6434, 0);
int argcv_meth_ast__apply6434[] = {1};
meth_meth_ast__apply6434->type = alloc_MethodType(1, argcv_meth_ast__apply6434);
  meth_meth_ast__apply6434->definitionModule = modulename;
  meth_meth_ast__apply6434->definitionLine = 1464;
// compilenode returning block6433
  gc_frame_newslot(block6433);
  params[0] = opresult6432;
  params[1] = block6433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6441 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6428);
// compilenode returning call6441
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6442 == NULL) {
    strlit6442 = alloc_String("Index");
    gc_root(strlit6442);
  }
// compilenode returning strlit6442
  *var_s = strlit6442;
  if (strlit6442 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6444 == NULL) {
    strlit6444 = alloc_String("""\x0a""");
    gc_root(strlit6444);
  }
// compilenode returning strlit6444
  int op_slot_right_6443 = gc_frame_newslot(strlit6444);
// compilenode returning *var_s
  int op_slot_left_6443 = gc_frame_newslot(*var_s);
  params[0] = strlit6444;
  partcv[0] = 1;
  Object opresult6446 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6446
  *var_s = opresult6446;
  if (opresult6446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6449 = gc_frame_new();
  Object num6451 = alloc_Float64(1);
// compilenode returning num6451
  int op_slot_right_6450 = gc_frame_newslot(num6451);
// compilenode returning *var_depth
  int op_slot_left_6450 = gc_frame_newslot(*var_depth);
  params[0] = num6451;
  partcv[0] = 1;
  Object sum6453 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6453
  gc_frame_newslot(sum6453);
  int callframe6454 = gc_frame_new();
  partcv[0] = 0;
  Object call6455 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6454);
// compilenode returning call6455
// compilenode returning call6455
  params[0] = sum6453;
  partcv[0] = 1;
  Object call6456 = callmethod(call6455, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6449);
// compilenode returning call6456
  int op_slot_right_6448 = gc_frame_newslot(call6456);
// compilenode returning *var_spc
  int op_slot_right_6458 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6458 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6460 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6460
  int op_slot_left_6448 = gc_frame_newslot(opresult6460);
  params[0] = call6456;
  partcv[0] = 1;
  Object opresult6461 = callmethod(opresult6460, "++", 1, partcv, params);
// compilenode returning opresult6461
  *var_s = opresult6461;
  if (opresult6461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6464 == NULL) {
    strlit6464 = alloc_String("""\x0a""");
    gc_root(strlit6464);
  }
// compilenode returning strlit6464
  int op_slot_right_6463 = gc_frame_newslot(strlit6464);
// compilenode returning *var_s
  int op_slot_left_6463 = gc_frame_newslot(*var_s);
  params[0] = strlit6464;
  partcv[0] = 1;
  Object opresult6466 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6466
  *var_s = opresult6466;
  if (opresult6466 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6469 = gc_frame_new();
  Object num6471 = alloc_Float64(1);
// compilenode returning num6471
  int op_slot_right_6470 = gc_frame_newslot(num6471);
// compilenode returning *var_depth
  int op_slot_left_6470 = gc_frame_newslot(*var_depth);
  params[0] = num6471;
  partcv[0] = 1;
  Object sum6473 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6473
  gc_frame_newslot(sum6473);
  int callframe6474 = gc_frame_new();
  partcv[0] = 0;
  Object call6475 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6474);
// compilenode returning call6475
// compilenode returning call6475
  params[0] = sum6473;
  partcv[0] = 1;
  Object call6476 = callmethod(call6475, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6469);
// compilenode returning call6476
  int op_slot_right_6468 = gc_frame_newslot(call6476);
// compilenode returning *var_spc
  int op_slot_right_6478 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6478 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6480 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6480
  int op_slot_left_6468 = gc_frame_newslot(opresult6480);
  params[0] = call6476;
  partcv[0] = 1;
  Object opresult6481 = callmethod(opresult6480, "++", 1, partcv, params);
// compilenode returning opresult6481
  *var_s = opresult6481;
  if (opresult6481 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6495(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6497 == NULL) {
    strlit6497 = alloc_String("    ");
    gc_root(strlit6497);
  }
// compilenode returning strlit6497
  int op_slot_right_6496 = gc_frame_newslot(strlit6497);
// compilenode returning *var_spc
  int op_slot_left_6496 = gc_frame_newslot(*var_spc);
  params[0] = strlit6497;
  partcv[0] = 1;
  Object opresult6499 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6499
  *var_spc = opresult6499;
  if (opresult6499 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6484 == NULL) {
    strlit6484 = alloc_String("");
    gc_root(strlit6484);
  }
// compilenode returning strlit6484
  *var_spc = strlit6484;
  if (strlit6484 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6485 = gc_frame_new();
  Object num6488 = alloc_Float64(1);
// compilenode returning num6488
  int op_slot_right_6487 = gc_frame_newslot(num6488);
// compilenode returning *var_depth
  int op_slot_left_6487 = gc_frame_newslot(*var_depth);
  params[0] = num6488;
  partcv[0] = 1;
  Object diff6490 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6490
  int op_slot_right_6486 = gc_frame_newslot(diff6490);
  Object num6492 = alloc_Float64(0);
// compilenode returning num6492
  int op_slot_left_6486 = gc_frame_newslot(num6492);
  params[0] = diff6490;
  partcv[0] = 1;
  Object opresult6493 = callmethod(num6492, "..", 1, partcv, params);
// compilenode returning opresult6493
  gc_frame_newslot(opresult6493);
  Object block6494 = alloc_Block(NULL, NULL, "ast", 1492);
  gc_frame_newslot(block6494);
  block_savedest(block6494);
  Object closure6495 = createclosure(2, "_apply");
setclosureframe(closure6495, stackframe);
  addtoclosure(closure6495, var_spc);
  addtoclosure(closure6495, selfslot);
  struct UserObject *uo6495 = (struct UserObject*)block6494;
  uo6495->data[0] = (Object)closure6495;
  Method *meth_meth_ast__apply6495 = addmethod2pos(block6494, "_apply", &meth_ast__apply6495, 0);
int argcv_meth_ast__apply6495[] = {1};
meth_meth_ast__apply6495->type = alloc_MethodType(1, argcv_meth_ast__apply6495);
  meth_meth_ast__apply6495->definitionModule = modulename;
  meth_meth_ast__apply6495->definitionLine = 1487;
// compilenode returning block6494
  gc_frame_newslot(block6494);
  params[0] = opresult6493;
  params[1] = block6494;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6502 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6485);
// compilenode returning call6502
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6503 = gc_frame_new();
  Object num6505 = alloc_Float64(1);
// compilenode returning num6505
  int op_slot_right_6504 = gc_frame_newslot(num6505);
// compilenode returning *var_depth
  int op_slot_left_6504 = gc_frame_newslot(*var_depth);
  params[0] = num6505;
  partcv[0] = 1;
  Object sum6507 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6507
  gc_frame_newslot(sum6507);
  int callframe6508 = gc_frame_new();
  partcv[0] = 0;
  Object call6509 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6508);
// compilenode returning call6509
// compilenode returning call6509
  params[0] = sum6507;
  partcv[0] = 1;
  Object call6510 = callmethod(call6509, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6503);
// compilenode returning call6510
  *var_s = call6510;
  if (call6510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6512 == NULL) {
    strlit6512 = alloc_String("]");
    gc_root(strlit6512);
  }
// compilenode returning strlit6512
  int op_slot_right_6511 = gc_frame_newslot(strlit6512);
  int callframe6515 = gc_frame_new();
  Object num6517 = alloc_Float64(1);
// compilenode returning num6517
  int op_slot_right_6516 = gc_frame_newslot(num6517);
// compilenode returning *var_depth
  int op_slot_left_6516 = gc_frame_newslot(*var_depth);
  params[0] = num6517;
  partcv[0] = 1;
  Object sum6519 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6519
  gc_frame_newslot(sum6519);
  int callframe6520 = gc_frame_new();
  partcv[0] = 0;
  Object call6521 = callmethodflags(self, "index", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6520);
// compilenode returning call6521
// compilenode returning call6521
  params[0] = sum6519;
  partcv[0] = 1;
  Object call6522 = callmethod(call6521, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6515);
// compilenode returning call6522
  int op_slot_right_6514 = gc_frame_newslot(call6522);
  if (strlit6525 == NULL) {
    strlit6525 = alloc_String("[");
    gc_root(strlit6525);
  }
// compilenode returning strlit6525
  int op_slot_right_6524 = gc_frame_newslot(strlit6525);
// compilenode returning *var_s
  int op_slot_left_6524 = gc_frame_newslot(*var_s);
  params[0] = strlit6525;
  partcv[0] = 1;
  Object opresult6527 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6527
  int op_slot_left_6514 = gc_frame_newslot(opresult6527);
  params[0] = call6522;
  partcv[0] = 1;
  Object opresult6528 = callmethod(opresult6527, "++", 1, partcv, params);
// compilenode returning opresult6528
  int op_slot_left_6511 = gc_frame_newslot(opresult6528);
  params[0] = strlit6512;
  partcv[0] = 1;
  Object opresult6529 = callmethod(opresult6528, "++", 1, partcv, params);
// compilenode returning opresult6529
  *var_s = opresult6529;
  if (opresult6529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6377(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_indexNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6378 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6378 = alloc_userobj2(9,10, objclass6378);
  gc_frame_newslot(obj6378);
if (objclass6378 == NULL) {
  glfree(obj6378->class->name);
  obj6378->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6378, self, 0);
  addmethodreal(obj6378,"outer", &reader_ast_outer_6379);
  Object oldself6378 = self;
  struct StackFrameObject *oldstackframe6378 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6378);
  gc_frame_newslot((Object)stackframe);
  self = obj6378;
  Object *oldselfslot6378 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6378 = (*(struct UserObject *)self).data[0], lowerouter6378 = thisouter6378;
  if (inheritingObject6378) {
    struct UserObject *inho6378 = (struct UserObject *)inheritingObject6378;
    while (inho6378->super != GraceDefaultObject) inho6378 = (struct UserObject *)inho6378->super;
    inho6378->super = obj6378;
    self = inheritingObject6378;
    *selfslot = self;
    lowerouter6378 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6378;
  }
if (objclass6378 == NULL) {
  Method *reader6380 = addmethodrealflags(obj6378, "kind",&reader_ast_kind_6380, MFLAG_DEF);
  reader6380->definitionModule = modulename;
  reader6380->definitionLine = 1459;
}
adddatum2(obj6378, alloc_Undefined(), 1);
if (objclass6378 == NULL) {
  Method *reader6381 = addmethodrealflags(obj6378, "value",&reader_ast_value_6381, MFLAG_DEF);
  reader6381->definitionModule = modulename;
  reader6381->definitionLine = 1460;
}
adddatum2(obj6378, alloc_Undefined(), 2);
if (objclass6378 == NULL) {
  Method *reader6382 = addmethodrealflags(obj6378, "index",&reader_ast_index_6382, MFLAG_DEF);
  reader6382->definitionModule = modulename;
  reader6382->definitionLine = 1461;
}
adddatum2(obj6378, alloc_Undefined(), 3);
  struct UserObject *uo6383 = (struct UserObject*)obj6378;
  uo6383->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6383 = addmethod2pos(obj6378, "accept", &meth_ast_accept6383, 4);
int argcv_meth_ast_accept6383[] = {1};
meth_meth_ast_accept6383->type = alloc_MethodType(1, argcv_meth_ast_accept6383);
meth_meth_ast_accept6383->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6383->type->names[0] = "visitor";
  meth_meth_ast_accept6383->definitionModule = modulename;
  meth_meth_ast_accept6383->definitionLine = 1461;
  block_savedest(obj6378);
  Object closure6395 = createclosure(1, "map()before()after");
setclosureframe(closure6395, stackframe);
  addtoclosure(closure6395, var_indexNode);
  struct UserObject *uo6395 = (struct UserObject*)obj6378;
  uo6395->data[5] = (Object)closure6395;
  Method *meth_meth_ast_map_40__41_before_40__41_after6395 = addmethod2pos(obj6378, "map()before()after", &meth_ast_map_40__41_before_40__41_after6395, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6395[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6395->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6395);
  meth_meth_ast_map_40__41_before_40__41_after6395->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6395->definitionLine = 1467;
  struct UserObject *uo6417 = (struct UserObject*)obj6378;
  uo6417->data[6] = emptyclosure;
  Method *meth_meth_ast_map6417 = addmethod2pos(obj6378, "map", &meth_ast_map6417, 6);
int argcv_meth_ast_map6417[] = {1};
meth_meth_ast_map6417->type = alloc_MethodType(1, argcv_meth_ast_map6417);
  meth_meth_ast_map6417->definitionModule = modulename;
  meth_meth_ast_map6417->definitionLine = 1475;
  struct UserObject *uo6426 = (struct UserObject*)obj6378;
  uo6426->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6426 = addmethod2pos(obj6378, "pretty", &meth_ast_pretty6426, 7);
int argcv_meth_ast_pretty6426[] = {1};
meth_meth_ast_pretty6426->type = alloc_MethodType(1, argcv_meth_ast_pretty6426);
  meth_meth_ast_pretty6426->definitionModule = modulename;
  meth_meth_ast_pretty6426->definitionLine = 1478;
  struct UserObject *uo6483 = (struct UserObject*)obj6378;
  uo6483->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6483 = addmethod2pos(obj6378, "toGrace", &meth_ast_toGrace6483, 8);
int argcv_meth_ast_toGrace6483[] = {1};
meth_meth_ast_toGrace6483->type = alloc_MethodType(1, argcv_meth_ast_toGrace6483);
meth_meth_ast_toGrace6483->type->types[0] = type_Number;
meth_meth_ast_toGrace6483->type->names[0] = "depth";
  meth_meth_ast_toGrace6483->definitionModule = modulename;
  meth_meth_ast_toGrace6483->definitionLine = 1490;
  sourceObject = obj6378;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6531 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6532 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6531);
// compilenode returning call6532
  struct UserObject *obj6378_uo = (struct UserObject *)obj6378;
  obj6378_uo->super = call6532;
  sourceObject = obj6378;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6533 == NULL) {
    strlit6533 = alloc_String("index");
    gc_root(strlit6533);
  }
// compilenode returning strlit6533
  adddatum2(obj6378, strlit6533, 1);
  sourceObject = obj6378;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj6378, *var_expr, 2);
  sourceObject = obj6378;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_index_39_
  adddatum2(obj6378, *var_index_39_, 3);
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
objclass6378 = obj6378->class;
  objclass6378->definitionModule = modulename;
  objclass6378->definitionLine = 1451;
  (*(struct UserObject *)self).data[0] = lowerouter6378;
  self = oldself6378;
  selfslot = oldselfslot6378;
  stackframe = oldstackframe6378;
  gc_frame_end(frame);
  return obj6378;
}
Object meth_ast_new6377_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_indexNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
  Object *var_index_39_ = &(stackframe->slots[1]);
  *var_index_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6378 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6378 = alloc_userobj2(9,10, objclass6378);
  gc_frame_newslot(obj6378);
if (objclass6378 == NULL) {
  glfree(obj6378->class->name);
  obj6378->class->name = "indexNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6378, self, 0);
  addmethodreal(obj6378,"outer", &reader_ast_outer_6379);
  Object oldself6378 = self;
  struct StackFrameObject *oldstackframe6378 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6378);
  gc_frame_newslot((Object)stackframe);
  self = obj6378;
  Object *oldselfslot6378 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6378 = (*(struct UserObject *)self).data[0], lowerouter6378 = thisouter6378;
  if (inheritingObject6378) {
    struct UserObject *inho6378 = (struct UserObject *)inheritingObject6378;
    while (inho6378->super != GraceDefaultObject) inho6378 = (struct UserObject *)inho6378->super;
    inho6378->super = obj6378;
    self = inheritingObject6378;
    *selfslot = self;
    lowerouter6378 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6378;
  }
if (objclass6378 == NULL) {
  Method *reader6380 = addmethodrealflags(obj6378, "kind",&reader_ast_kind_6380, MFLAG_DEF);
  reader6380->definitionModule = modulename;
  reader6380->definitionLine = 1459;
}
adddatum2(obj6378, alloc_Undefined(), 1);
if (objclass6378 == NULL) {
  Method *reader6381 = addmethodrealflags(obj6378, "value",&reader_ast_value_6381, MFLAG_DEF);
  reader6381->definitionModule = modulename;
  reader6381->definitionLine = 1460;
}
adddatum2(obj6378, alloc_Undefined(), 2);
if (objclass6378 == NULL) {
  Method *reader6382 = addmethodrealflags(obj6378, "index",&reader_ast_index_6382, MFLAG_DEF);
  reader6382->definitionModule = modulename;
  reader6382->definitionLine = 1461;
}
adddatum2(obj6378, alloc_Undefined(), 3);
  struct UserObject *uo6383 = (struct UserObject*)obj6378;
  uo6383->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6383 = addmethod2pos(obj6378, "accept", &meth_ast_accept6383, 4);
int argcv_meth_ast_accept6383[] = {1};
meth_meth_ast_accept6383->type = alloc_MethodType(1, argcv_meth_ast_accept6383);
meth_meth_ast_accept6383->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6383->type->names[0] = "visitor";
  meth_meth_ast_accept6383->definitionModule = modulename;
  meth_meth_ast_accept6383->definitionLine = 1461;
  block_savedest(obj6378);
  Object closure6395 = createclosure(1, "map()before()after");
setclosureframe(closure6395, stackframe);
  addtoclosure(closure6395, var_indexNode);
  struct UserObject *uo6395 = (struct UserObject*)obj6378;
  uo6395->data[5] = (Object)closure6395;
  Method *meth_meth_ast_map_40__41_before_40__41_after6395 = addmethod2pos(obj6378, "map()before()after", &meth_ast_map_40__41_before_40__41_after6395, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6395[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6395->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6395);
  meth_meth_ast_map_40__41_before_40__41_after6395->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6395->definitionLine = 1467;
  struct UserObject *uo6417 = (struct UserObject*)obj6378;
  uo6417->data[6] = emptyclosure;
  Method *meth_meth_ast_map6417 = addmethod2pos(obj6378, "map", &meth_ast_map6417, 6);
int argcv_meth_ast_map6417[] = {1};
meth_meth_ast_map6417->type = alloc_MethodType(1, argcv_meth_ast_map6417);
  meth_meth_ast_map6417->definitionModule = modulename;
  meth_meth_ast_map6417->definitionLine = 1475;
  struct UserObject *uo6426 = (struct UserObject*)obj6378;
  uo6426->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6426 = addmethod2pos(obj6378, "pretty", &meth_ast_pretty6426, 7);
int argcv_meth_ast_pretty6426[] = {1};
meth_meth_ast_pretty6426->type = alloc_MethodType(1, argcv_meth_ast_pretty6426);
  meth_meth_ast_pretty6426->definitionModule = modulename;
  meth_meth_ast_pretty6426->definitionLine = 1478;
  struct UserObject *uo6483 = (struct UserObject*)obj6378;
  uo6483->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6483 = addmethod2pos(obj6378, "toGrace", &meth_ast_toGrace6483, 8);
int argcv_meth_ast_toGrace6483[] = {1};
meth_meth_ast_toGrace6483->type = alloc_MethodType(1, argcv_meth_ast_toGrace6483);
meth_meth_ast_toGrace6483->type->types[0] = type_Number;
meth_meth_ast_toGrace6483->type->names[0] = "depth";
  meth_meth_ast_toGrace6483->definitionModule = modulename;
  meth_meth_ast_toGrace6483->definitionLine = 1490;
  sourceObject = obj6378;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6531 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6532 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6531);
// compilenode returning call6532
  struct UserObject *obj6378_uo = (struct UserObject *)obj6378;
  obj6378_uo->super = call6532;
  sourceObject = obj6378;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6533 == NULL) {
    strlit6533 = alloc_String("index");
    gc_root(strlit6533);
  }
// compilenode returning strlit6533
  adddatum2(obj6378, strlit6533, 1);
  sourceObject = obj6378;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj6378, *var_expr, 2);
  sourceObject = obj6378;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_index_39_
  adddatum2(obj6378, *var_index_39_, 3);
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
  sourceObject = obj6378;
objclass6378 = obj6378->class;
  objclass6378->definitionModule = modulename;
  objclass6378->definitionLine = 1451;
  (*(struct UserObject *)self).data[0] = lowerouter6378;
  self = oldself6378;
  selfslot = oldselfslot6378;
  stackframe = oldstackframe6378;
  gc_frame_end(frame);
  return obj6378;
}
Object meth_ast_bindNode6535(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for bindNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for bindNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_bindNode
  gc_frame_end(frame);
  return *var_bindNode;
}
Object meth_ast_accept6544(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6546 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6547 = callmethod(*var_visitor, "visitBind",
    1, partcv, params);
  gc_frame_end(callframe6546);
// compilenode returning call6547
  Object if6545 = done;
  if (istrue(call6547)) {
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6548 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6549 = gc_frame_new();
  partcv[0] = 0;
  Object call6550 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6549);
// compilenode returning call6550
// compilenode returning call6550
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6551 = callmethod(call6550, "accept",
    1, partcv, params);
  gc_frame_end(callframe6548);
// compilenode returning call6551
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6552 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6553 = gc_frame_new();
  partcv[0] = 0;
  Object call6554 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6553);
// compilenode returning call6554
// compilenode returning call6554
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6555 = callmethod(call6554, "accept",
    1, partcv, params);
  gc_frame_end(callframe6552);
// compilenode returning call6555
    gc_frame_newslot(call6555);
    if6545 = call6555;
  } else {
  }
// compilenode returning if6545
  gc_frame_end(frame);
  return if6545;
}
Object meth_ast_map_40__41_before_40__41_after6556(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_bindNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6557 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6558 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6557);
// compilenode returning call6558
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6559 = gc_frame_new();
  int callframe6560 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6561 = gc_frame_new();
  partcv[0] = 0;
  Object call6562 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6561);
// compilenode returning call6562
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6563 = callmethod(call6562, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6560);
// compilenode returning call6563
  gc_frame_newslot(call6563);
  int callframe6564 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6565 = gc_frame_new();
  partcv[0] = 0;
  Object call6566 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6565);
// compilenode returning call6566
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6567 = callmethod(call6566, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6564);
// compilenode returning call6567
  gc_frame_newslot(call6567);
// compilenode returning *var_bindNode
  params[0] = call6563;
  params[1] = call6567;
  partcv[0] = 2;
  Object call6568 = callmethod(*var_bindNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6559);
// compilenode returning call6568
  *var_n = call6568;
  if (call6568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1514
  setline(1514);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6569 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6570 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6569);
// compilenode returning call6570
  *var_n = call6570;
  if (call6570 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6572 = gc_frame_new();
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6573 = gc_frame_new();
  partcv[0] = 0;
  Object call6574 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6573);
// compilenode returning call6574
  gc_frame_newslot(call6574);
// compilenode returning *var_n
  params[0] = call6574;
  partcv[0] = 1;
  Object call6575 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6572);
// compilenode returning call6575
// compilenode returning done
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6576 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6577 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6576);
// compilenode returning call6577
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6584(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6578(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1520
  setline(1520);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6579 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6580 = alloc_Block(NULL, NULL, "ast", 1520);
  gc_frame_newslot(block6580);
  block_savedest(block6580);
  Object closure6581 = createclosure(1, "_apply");
setclosureframe(closure6581, stackframe);
  addtoclosure(closure6581, selfslot);
  struct UserObject *uo6581 = (struct UserObject*)block6580;
  uo6581->data[0] = (Object)closure6581;
  Method *meth_meth_ast__apply6581 = addmethod2pos(block6580, "_apply", &meth_ast__apply6581, 0);
int argcv_meth_ast__apply6581[] = {0};
meth_meth_ast__apply6581->type = alloc_MethodType(1, argcv_meth_ast__apply6581);
  meth_meth_ast__apply6581->definitionModule = modulename;
  meth_meth_ast__apply6581->definitionLine = 1508;
// compilenode returning block6580
  gc_frame_newslot(block6580);
  Object block6583 = alloc_Block(NULL, NULL, "ast", 1520);
  gc_frame_newslot(block6583);
  block_savedest(block6583);
  Object closure6584 = createclosure(1, "_apply");
setclosureframe(closure6584, stackframe);
  addtoclosure(closure6584, selfslot);
  struct UserObject *uo6584 = (struct UserObject*)block6583;
  uo6584->data[0] = (Object)closure6584;
  Method *meth_meth_ast__apply6584 = addmethod2pos(block6583, "_apply", &meth_ast__apply6584, 0);
int argcv_meth_ast__apply6584[] = {0};
meth_meth_ast__apply6584->type = alloc_MethodType(1, argcv_meth_ast__apply6584);
  meth_meth_ast__apply6584->definitionModule = modulename;
  meth_meth_ast__apply6584->definitionLine = 1508;
// compilenode returning block6583
  gc_frame_newslot(block6583);
  params[0] = *var_blk;
  params[1] = block6580;
  params[2] = block6583;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6586 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6579);
// compilenode returning call6586
  gc_frame_end(frame);
  return call6586;
}
Object meth_ast__apply6595(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1525
  setline(1525);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6597 == NULL) {
    strlit6597 = alloc_String("  ");
    gc_root(strlit6597);
  }
// compilenode returning strlit6597
  int op_slot_right_6596 = gc_frame_newslot(strlit6597);
// compilenode returning *var_spc
  int op_slot_left_6596 = gc_frame_newslot(*var_spc);
  params[0] = strlit6597;
  partcv[0] = 1;
  Object opresult6599 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6599
  *var_spc = opresult6599;
  if (opresult6599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6587(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6588 == NULL) {
    strlit6588 = alloc_String("");
    gc_root(strlit6588);
  }
// compilenode returning strlit6588
  *var_spc = strlit6588;
  if (strlit6588 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6589 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6590 = gc_frame_newslot(*var_depth);
  Object num6592 = alloc_Float64(0);
// compilenode returning num6592
  int op_slot_left_6590 = gc_frame_newslot(num6592);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6593 = callmethod(num6592, "..", 1, partcv, params);
// compilenode returning opresult6593
  gc_frame_newslot(opresult6593);
  Object block6594 = alloc_Block(NULL, NULL, "ast", 1524);
  gc_frame_newslot(block6594);
  block_savedest(block6594);
  Object closure6595 = createclosure(2, "_apply");
setclosureframe(closure6595, stackframe);
  addtoclosure(closure6595, var_spc);
  addtoclosure(closure6595, selfslot);
  struct UserObject *uo6595 = (struct UserObject*)block6594;
  uo6595->data[0] = (Object)closure6595;
  Method *meth_meth_ast__apply6595 = addmethod2pos(block6594, "_apply", &meth_ast__apply6595, 0);
int argcv_meth_ast__apply6595[] = {1};
meth_meth_ast__apply6595->type = alloc_MethodType(1, argcv_meth_ast__apply6595);
  meth_meth_ast__apply6595->definitionModule = modulename;
  meth_meth_ast__apply6595->definitionLine = 1508;
// compilenode returning block6594
  gc_frame_newslot(block6594);
  params[0] = opresult6593;
  params[1] = block6594;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6602 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6589);
// compilenode returning call6602
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1527
  setline(1527);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6603 == NULL) {
    strlit6603 = alloc_String("Bind");
    gc_root(strlit6603);
  }
// compilenode returning strlit6603
  *var_s = strlit6603;
  if (strlit6603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1528
  setline(1528);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6605 == NULL) {
    strlit6605 = alloc_String("""\x0a""");
    gc_root(strlit6605);
  }
// compilenode returning strlit6605
  int op_slot_right_6604 = gc_frame_newslot(strlit6605);
// compilenode returning *var_s
  int op_slot_left_6604 = gc_frame_newslot(*var_s);
  params[0] = strlit6605;
  partcv[0] = 1;
  Object opresult6607 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6607
  *var_s = opresult6607;
  if (opresult6607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6610 = gc_frame_new();
  Object num6612 = alloc_Float64(1);
// compilenode returning num6612
  int op_slot_right_6611 = gc_frame_newslot(num6612);
// compilenode returning *var_depth
  int op_slot_left_6611 = gc_frame_newslot(*var_depth);
  params[0] = num6612;
  partcv[0] = 1;
  Object sum6614 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6614
  gc_frame_newslot(sum6614);
  int callframe6615 = gc_frame_new();
  partcv[0] = 0;
  Object call6616 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6615);
// compilenode returning call6616
// compilenode returning call6616
  params[0] = sum6614;
  partcv[0] = 1;
  Object call6617 = callmethod(call6616, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6610);
// compilenode returning call6617
  int op_slot_right_6609 = gc_frame_newslot(call6617);
// compilenode returning *var_spc
  int op_slot_right_6619 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6619 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6621 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6621
  int op_slot_left_6609 = gc_frame_newslot(opresult6621);
  params[0] = call6617;
  partcv[0] = 1;
  Object opresult6622 = callmethod(opresult6621, "++", 1, partcv, params);
// compilenode returning opresult6622
  *var_s = opresult6622;
  if (opresult6622 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6625 == NULL) {
    strlit6625 = alloc_String("""\x0a""");
    gc_root(strlit6625);
  }
// compilenode returning strlit6625
  int op_slot_right_6624 = gc_frame_newslot(strlit6625);
// compilenode returning *var_s
  int op_slot_left_6624 = gc_frame_newslot(*var_s);
  params[0] = strlit6625;
  partcv[0] = 1;
  Object opresult6627 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6627
  *var_s = opresult6627;
  if (opresult6627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6630 = gc_frame_new();
  Object num6632 = alloc_Float64(1);
// compilenode returning num6632
  int op_slot_right_6631 = gc_frame_newslot(num6632);
// compilenode returning *var_depth
  int op_slot_left_6631 = gc_frame_newslot(*var_depth);
  params[0] = num6632;
  partcv[0] = 1;
  Object sum6634 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6634
  gc_frame_newslot(sum6634);
  int callframe6635 = gc_frame_new();
  partcv[0] = 0;
  Object call6636 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6635);
// compilenode returning call6636
// compilenode returning call6636
  params[0] = sum6634;
  partcv[0] = 1;
  Object call6637 = callmethod(call6636, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6630);
// compilenode returning call6637
  int op_slot_right_6629 = gc_frame_newslot(call6637);
// compilenode returning *var_spc
  int op_slot_right_6639 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6639 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6641 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6641
  int op_slot_left_6629 = gc_frame_newslot(opresult6641);
  params[0] = call6637;
  partcv[0] = 1;
  Object opresult6642 = callmethod(opresult6641, "++", 1, partcv, params);
// compilenode returning opresult6642
  *var_s = opresult6642;
  if (opresult6642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1532
  setline(1532);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast__apply6656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6658 == NULL) {
    strlit6658 = alloc_String("    ");
    gc_root(strlit6658);
  }
// compilenode returning strlit6658
  int op_slot_right_6657 = gc_frame_newslot(strlit6658);
// compilenode returning *var_spc
  int op_slot_left_6657 = gc_frame_newslot(*var_spc);
  params[0] = strlit6658;
  partcv[0] = 1;
  Object opresult6660 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6660
  *var_spc = opresult6660;
  if (opresult6660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_toGrace6644(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1535
  setline(1535);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6645 == NULL) {
    strlit6645 = alloc_String("");
    gc_root(strlit6645);
  }
// compilenode returning strlit6645
  *var_spc = strlit6645;
  if (strlit6645 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6646 = gc_frame_new();
  Object num6649 = alloc_Float64(1);
// compilenode returning num6649
  int op_slot_right_6648 = gc_frame_newslot(num6649);
// compilenode returning *var_depth
  int op_slot_left_6648 = gc_frame_newslot(*var_depth);
  params[0] = num6649;
  partcv[0] = 1;
  Object diff6651 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6651
  int op_slot_right_6647 = gc_frame_newslot(diff6651);
  Object num6653 = alloc_Float64(0);
// compilenode returning num6653
  int op_slot_left_6647 = gc_frame_newslot(num6653);
  params[0] = diff6651;
  partcv[0] = 1;
  Object opresult6654 = callmethod(num6653, "..", 1, partcv, params);
// compilenode returning opresult6654
  gc_frame_newslot(opresult6654);
  Object block6655 = alloc_Block(NULL, NULL, "ast", 1536);
  gc_frame_newslot(block6655);
  block_savedest(block6655);
  Object closure6656 = createclosure(2, "_apply");
setclosureframe(closure6656, stackframe);
  addtoclosure(closure6656, var_spc);
  addtoclosure(closure6656, selfslot);
  struct UserObject *uo6656 = (struct UserObject*)block6655;
  uo6656->data[0] = (Object)closure6656;
  Method *meth_meth_ast__apply6656 = addmethod2pos(block6655, "_apply", &meth_ast__apply6656, 0);
int argcv_meth_ast__apply6656[] = {1};
meth_meth_ast__apply6656->type = alloc_MethodType(1, argcv_meth_ast__apply6656);
  meth_meth_ast__apply6656->definitionModule = modulename;
  meth_meth_ast__apply6656->definitionLine = 1531;
// compilenode returning block6655
  gc_frame_newslot(block6655);
  params[0] = opresult6654;
  params[1] = block6655;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6663 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6646);
// compilenode returning call6663
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6664 = gc_frame_new();
  Object num6666 = alloc_Float64(1);
// compilenode returning num6666
  int op_slot_right_6665 = gc_frame_newslot(num6666);
// compilenode returning *var_depth
  int op_slot_left_6665 = gc_frame_newslot(*var_depth);
  params[0] = num6666;
  partcv[0] = 1;
  Object sum6668 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6668
  gc_frame_newslot(sum6668);
  int callframe6669 = gc_frame_new();
  partcv[0] = 0;
  Object call6670 = callmethodflags(self, "dest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6669);
// compilenode returning call6670
// compilenode returning call6670
  params[0] = sum6668;
  partcv[0] = 1;
  Object call6671 = callmethod(call6670, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6664);
// compilenode returning call6671
  *var_s = call6671;
  if (call6671 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6673 = gc_frame_new();
  Object num6675 = alloc_Float64(1);
// compilenode returning num6675
  int op_slot_right_6674 = gc_frame_newslot(num6675);
// compilenode returning *var_depth
  int op_slot_left_6674 = gc_frame_newslot(*var_depth);
  params[0] = num6675;
  partcv[0] = 1;
  Object sum6677 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6677
  gc_frame_newslot(sum6677);
  int callframe6678 = gc_frame_new();
  partcv[0] = 0;
  Object call6679 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6678);
// compilenode returning call6679
// compilenode returning call6679
  params[0] = sum6677;
  partcv[0] = 1;
  Object call6680 = callmethod(call6679, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6673);
// compilenode returning call6680
  int op_slot_right_6672 = gc_frame_newslot(call6680);
  if (strlit6683 == NULL) {
    strlit6683 = alloc_String(" := ");
    gc_root(strlit6683);
  }
// compilenode returning strlit6683
  int op_slot_right_6682 = gc_frame_newslot(strlit6683);
// compilenode returning *var_s
  int op_slot_left_6682 = gc_frame_newslot(*var_s);
  params[0] = strlit6683;
  partcv[0] = 1;
  Object opresult6685 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6685
  int op_slot_left_6672 = gc_frame_newslot(opresult6685);
  params[0] = call6680;
  partcv[0] = 1;
  Object opresult6686 = callmethod(opresult6685, "++", 1, partcv, params);
// compilenode returning opresult6686
  *var_s = opresult6686;
  if (opresult6686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6538(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6539 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6539 = alloc_userobj2(9,10, objclass6539);
  gc_frame_newslot(obj6539);
if (objclass6539 == NULL) {
  glfree(obj6539->class->name);
  obj6539->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6539, self, 0);
  addmethodreal(obj6539,"outer", &reader_ast_outer_6540);
  Object oldself6539 = self;
  struct StackFrameObject *oldstackframe6539 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6539);
  gc_frame_newslot((Object)stackframe);
  self = obj6539;
  Object *oldselfslot6539 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6539 = (*(struct UserObject *)self).data[0], lowerouter6539 = thisouter6539;
  if (inheritingObject6539) {
    struct UserObject *inho6539 = (struct UserObject *)inheritingObject6539;
    while (inho6539->super != GraceDefaultObject) inho6539 = (struct UserObject *)inho6539->super;
    inho6539->super = obj6539;
    self = inheritingObject6539;
    *selfslot = self;
    lowerouter6539 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6539;
  }
if (objclass6539 == NULL) {
  Method *reader6541 = addmethodrealflags(obj6539, "kind",&reader_ast_kind_6541, MFLAG_DEF);
  reader6541->definitionModule = modulename;
  reader6541->definitionLine = 1503;
}
adddatum2(obj6539, alloc_Undefined(), 1);
if (objclass6539 == NULL) {
  Method *reader6542 = addmethodrealflags(obj6539, "dest",&reader_ast_dest_6542, MFLAG_DEF);
  reader6542->definitionModule = modulename;
  reader6542->definitionLine = 1504;
}
adddatum2(obj6539, alloc_Undefined(), 2);
if (objclass6539 == NULL) {
  Method *reader6543 = addmethodrealflags(obj6539, "value",&reader_ast_value_6543, MFLAG_DEF);
  reader6543->definitionModule = modulename;
  reader6543->definitionLine = 1505;
}
adddatum2(obj6539, alloc_Undefined(), 3);
  struct UserObject *uo6544 = (struct UserObject*)obj6539;
  uo6544->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6544 = addmethod2pos(obj6539, "accept", &meth_ast_accept6544, 4);
int argcv_meth_ast_accept6544[] = {1};
meth_meth_ast_accept6544->type = alloc_MethodType(1, argcv_meth_ast_accept6544);
meth_meth_ast_accept6544->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6544->type->names[0] = "visitor";
  meth_meth_ast_accept6544->definitionModule = modulename;
  meth_meth_ast_accept6544->definitionLine = 1505;
  block_savedest(obj6539);
  Object closure6556 = createclosure(1, "map()before()after");
setclosureframe(closure6556, stackframe);
  addtoclosure(closure6556, var_bindNode);
  struct UserObject *uo6556 = (struct UserObject*)obj6539;
  uo6556->data[5] = (Object)closure6556;
  Method *meth_meth_ast_map_40__41_before_40__41_after6556 = addmethod2pos(obj6539, "map()before()after", &meth_ast_map_40__41_before_40__41_after6556, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6556[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6556->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6556);
  meth_meth_ast_map_40__41_before_40__41_after6556->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6556->definitionLine = 1511;
  struct UserObject *uo6578 = (struct UserObject*)obj6539;
  uo6578->data[6] = emptyclosure;
  Method *meth_meth_ast_map6578 = addmethod2pos(obj6539, "map", &meth_ast_map6578, 6);
int argcv_meth_ast_map6578[] = {1};
meth_meth_ast_map6578->type = alloc_MethodType(1, argcv_meth_ast_map6578);
  meth_meth_ast_map6578->definitionModule = modulename;
  meth_meth_ast_map6578->definitionLine = 1519;
  struct UserObject *uo6587 = (struct UserObject*)obj6539;
  uo6587->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6587 = addmethod2pos(obj6539, "pretty", &meth_ast_pretty6587, 7);
int argcv_meth_ast_pretty6587[] = {1};
meth_meth_ast_pretty6587->type = alloc_MethodType(1, argcv_meth_ast_pretty6587);
  meth_meth_ast_pretty6587->definitionModule = modulename;
  meth_meth_ast_pretty6587->definitionLine = 1522;
  struct UserObject *uo6644 = (struct UserObject*)obj6539;
  uo6644->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6644 = addmethod2pos(obj6539, "toGrace", &meth_ast_toGrace6644, 8);
int argcv_meth_ast_toGrace6644[] = {1};
meth_meth_ast_toGrace6644->type = alloc_MethodType(1, argcv_meth_ast_toGrace6644);
meth_meth_ast_toGrace6644->type->types[0] = type_Number;
meth_meth_ast_toGrace6644->type->names[0] = "depth";
  meth_meth_ast_toGrace6644->definitionModule = modulename;
  meth_meth_ast_toGrace6644->definitionLine = 1534;
  sourceObject = obj6539;
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6688 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6689 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6688);
// compilenode returning call6689
  struct UserObject *obj6539_uo = (struct UserObject *)obj6539;
  obj6539_uo->super = call6689;
  sourceObject = obj6539;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6690 == NULL) {
    strlit6690 = alloc_String("bind");
    gc_root(strlit6690);
  }
// compilenode returning strlit6690
  adddatum2(obj6539, strlit6690, 1);
  sourceObject = obj6539;
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dest_39_
  adddatum2(obj6539, *var_dest_39_, 2);
  sourceObject = obj6539;
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj6539, *var_val_39_, 3);
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
objclass6539 = obj6539->class;
  objclass6539->definitionModule = modulename;
  objclass6539->definitionLine = 1496;
  (*(struct UserObject *)self).data[0] = lowerouter6539;
  self = oldself6539;
  selfslot = oldselfslot6539;
  stackframe = oldstackframe6539;
  gc_frame_end(frame);
  return obj6539;
}
Object meth_ast_new6538_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_bindNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_dest_39_ = &(stackframe->slots[0]);
  *var_dest_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6539 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6539 = alloc_userobj2(9,10, objclass6539);
  gc_frame_newslot(obj6539);
if (objclass6539 == NULL) {
  glfree(obj6539->class->name);
  obj6539->class->name = "bindNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6539, self, 0);
  addmethodreal(obj6539,"outer", &reader_ast_outer_6540);
  Object oldself6539 = self;
  struct StackFrameObject *oldstackframe6539 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6539);
  gc_frame_newslot((Object)stackframe);
  self = obj6539;
  Object *oldselfslot6539 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6539 = (*(struct UserObject *)self).data[0], lowerouter6539 = thisouter6539;
  if (inheritingObject6539) {
    struct UserObject *inho6539 = (struct UserObject *)inheritingObject6539;
    while (inho6539->super != GraceDefaultObject) inho6539 = (struct UserObject *)inho6539->super;
    inho6539->super = obj6539;
    self = inheritingObject6539;
    *selfslot = self;
    lowerouter6539 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6539;
  }
if (objclass6539 == NULL) {
  Method *reader6541 = addmethodrealflags(obj6539, "kind",&reader_ast_kind_6541, MFLAG_DEF);
  reader6541->definitionModule = modulename;
  reader6541->definitionLine = 1503;
}
adddatum2(obj6539, alloc_Undefined(), 1);
if (objclass6539 == NULL) {
  Method *reader6542 = addmethodrealflags(obj6539, "dest",&reader_ast_dest_6542, MFLAG_DEF);
  reader6542->definitionModule = modulename;
  reader6542->definitionLine = 1504;
}
adddatum2(obj6539, alloc_Undefined(), 2);
if (objclass6539 == NULL) {
  Method *reader6543 = addmethodrealflags(obj6539, "value",&reader_ast_value_6543, MFLAG_DEF);
  reader6543->definitionModule = modulename;
  reader6543->definitionLine = 1505;
}
adddatum2(obj6539, alloc_Undefined(), 3);
  struct UserObject *uo6544 = (struct UserObject*)obj6539;
  uo6544->data[4] = emptyclosure;
  Method *meth_meth_ast_accept6544 = addmethod2pos(obj6539, "accept", &meth_ast_accept6544, 4);
int argcv_meth_ast_accept6544[] = {1};
meth_meth_ast_accept6544->type = alloc_MethodType(1, argcv_meth_ast_accept6544);
meth_meth_ast_accept6544->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6544->type->names[0] = "visitor";
  meth_meth_ast_accept6544->definitionModule = modulename;
  meth_meth_ast_accept6544->definitionLine = 1505;
  block_savedest(obj6539);
  Object closure6556 = createclosure(1, "map()before()after");
setclosureframe(closure6556, stackframe);
  addtoclosure(closure6556, var_bindNode);
  struct UserObject *uo6556 = (struct UserObject*)obj6539;
  uo6556->data[5] = (Object)closure6556;
  Method *meth_meth_ast_map_40__41_before_40__41_after6556 = addmethod2pos(obj6539, "map()before()after", &meth_ast_map_40__41_before_40__41_after6556, 5);
int argcv_meth_ast_map_40__41_before_40__41_after6556[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6556->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6556);
  meth_meth_ast_map_40__41_before_40__41_after6556->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6556->definitionLine = 1511;
  struct UserObject *uo6578 = (struct UserObject*)obj6539;
  uo6578->data[6] = emptyclosure;
  Method *meth_meth_ast_map6578 = addmethod2pos(obj6539, "map", &meth_ast_map6578, 6);
int argcv_meth_ast_map6578[] = {1};
meth_meth_ast_map6578->type = alloc_MethodType(1, argcv_meth_ast_map6578);
  meth_meth_ast_map6578->definitionModule = modulename;
  meth_meth_ast_map6578->definitionLine = 1519;
  struct UserObject *uo6587 = (struct UserObject*)obj6539;
  uo6587->data[7] = emptyclosure;
  Method *meth_meth_ast_pretty6587 = addmethod2pos(obj6539, "pretty", &meth_ast_pretty6587, 7);
int argcv_meth_ast_pretty6587[] = {1};
meth_meth_ast_pretty6587->type = alloc_MethodType(1, argcv_meth_ast_pretty6587);
  meth_meth_ast_pretty6587->definitionModule = modulename;
  meth_meth_ast_pretty6587->definitionLine = 1522;
  struct UserObject *uo6644 = (struct UserObject*)obj6539;
  uo6644->data[8] = emptyclosure;
  Method *meth_meth_ast_toGrace6644 = addmethod2pos(obj6539, "toGrace", &meth_ast_toGrace6644, 8);
int argcv_meth_ast_toGrace6644[] = {1};
meth_meth_ast_toGrace6644->type = alloc_MethodType(1, argcv_meth_ast_toGrace6644);
meth_meth_ast_toGrace6644->type->types[0] = type_Number;
meth_meth_ast_toGrace6644->type->names[0] = "depth";
  meth_meth_ast_toGrace6644->definitionModule = modulename;
  meth_meth_ast_toGrace6644->definitionLine = 1534;
  sourceObject = obj6539;
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6688 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6689 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe6688);
// compilenode returning call6689
  struct UserObject *obj6539_uo = (struct UserObject *)obj6539;
  obj6539_uo->super = call6689;
  sourceObject = obj6539;
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6690 == NULL) {
    strlit6690 = alloc_String("bind");
    gc_root(strlit6690);
  }
// compilenode returning strlit6690
  adddatum2(obj6539, strlit6690, 1);
  sourceObject = obj6539;
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dest_39_
  adddatum2(obj6539, *var_dest_39_, 2);
  sourceObject = obj6539;
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj6539, *var_val_39_, 3);
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
  sourceObject = obj6539;
objclass6539 = obj6539->class;
  objclass6539->definitionModule = modulename;
  objclass6539->definitionLine = 1496;
  (*(struct UserObject *)self).data[0] = lowerouter6539;
  self = oldself6539;
  selfslot = oldselfslot6539;
  stackframe = oldstackframe6539;
  gc_frame_end(frame);
  return obj6539;
}
Object meth_ast_defDecNode6692(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defDecNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for defDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defDecNode
  gc_frame_end(frame);
  return *var_defDecNode;
}
Object meth_ast_accept6705(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1554
  setline(1554);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6707 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call6708 = callmethod(*var_visitor, "visitDefDec",
    1, partcv, params);
  gc_frame_end(callframe6707);
// compilenode returning call6708
  Object if6706 = done;
  if (istrue(call6708)) {
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6709 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6710 = gc_frame_new();
  partcv[0] = 0;
  Object call6711 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6710);
// compilenode returning call6711
// compilenode returning call6711
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6712 = callmethod(call6711, "accept",
    1, partcv, params);
  gc_frame_end(callframe6709);
// compilenode returning call6712
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1556
  setline(1556);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6715 = alloc_Boolean(0);
// compilenode returning bool6715
  int op_slot_right_6714 = gc_frame_newslot(bool6715);
  int callframe6717 = gc_frame_new();
  partcv[0] = 0;
  Object call6718 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6717);
// compilenode returning call6718
// compilenode returning call6718
  int op_slot_left_6714 = gc_frame_newslot(call6718);
  params[0] = bool6715;
  partcv[0] = 1;
  Object opresult6719 = callmethod(call6718, "!=", 1, partcv, params);
// compilenode returning opresult6719
  Object if6713 = done;
  if (istrue(opresult6719)) {
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6720 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6721 = gc_frame_new();
  partcv[0] = 0;
  Object call6722 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6721);
// compilenode returning call6722
// compilenode returning call6722
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6723 = callmethod(call6722, "accept",
    1, partcv, params);
  gc_frame_end(callframe6720);
// compilenode returning call6723
    gc_frame_newslot(call6723);
    if6713 = call6723;
  } else {
  }
// compilenode returning if6713
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1559
  setline(1559);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6726 = alloc_Boolean(0);
// compilenode returning bool6726
  int op_slot_right_6725 = gc_frame_newslot(bool6726);
  int callframe6728 = gc_frame_new();
  partcv[0] = 0;
  Object call6729 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6728);
// compilenode returning call6729
// compilenode returning call6729
  int op_slot_left_6725 = gc_frame_newslot(call6729);
  params[0] = bool6726;
  partcv[0] = 1;
  Object opresult6730 = callmethod(call6729, "!=", 1, partcv, params);
// compilenode returning opresult6730
  Object if6724 = done;
  if (istrue(opresult6730)) {
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6731 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe6732 = gc_frame_new();
  partcv[0] = 0;
  Object call6733 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6732);
// compilenode returning call6733
// compilenode returning call6733
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call6734 = callmethod(call6733, "accept",
    1, partcv, params);
  gc_frame_end(callframe6731);
// compilenode returning call6734
    gc_frame_newslot(call6734);
    if6724 = call6734;
  } else {
  }
// compilenode returning if6724
    gc_frame_newslot(if6724);
    if6706 = if6724;
  } else {
  }
// compilenode returning if6706
  gc_frame_end(frame);
  return if6706;
}
Object meth_ast__apply6764(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6765 = gc_frame_new();
  int callframe6766 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6767 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6766);
// compilenode returning call6767
  gc_frame_newslot(call6767);
  int callframe6768 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call6769 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe6768);
// compilenode returning call6769
// compilenode returning call6769
  params[0] = call6767;
  partcv[0] = 1;
  Object call6770 = callmethod(call6769, "push",
    1, partcv, params);
  gc_frame_end(callframe6765);
// compilenode returning call6770
  gc_frame_end(frame);
  return call6770;
}
Object meth_ast_map_40__41_before_40__41_after6735(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_defDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6736 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call6737 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe6736);
// compilenode returning call6737
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6738 = gc_frame_new();
  int callframe6739 = gc_frame_new();
  partcv[0] = 0;
  Object call6740 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6739);
// compilenode returning call6740
  gc_frame_newslot(call6740);
  int callframe6741 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6742 = gc_frame_new();
  partcv[0] = 0;
  Object call6743 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6742);
// compilenode returning call6743
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6744 = callmethod(call6743, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe6741);
// compilenode returning call6744
  gc_frame_newslot(call6744);
// Begin line 1567
  setline(1567);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6745 = gc_frame_new();
  int callframe6746 = gc_frame_new();
  partcv[0] = 0;
  Object call6747 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6746);
// compilenode returning call6747
  gc_frame_newslot(call6747);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6748 = gc_frame_new();
  int callframe6749 = gc_frame_new();
  Object call6750 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6749);
// compilenode returning call6750
// compilenode returning call6750
  partcv[0] = 0;
  Object call6751 = callmethodflags(call6750, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6748);
// compilenode returning call6751
// compilenode returning call6751
  params[0] = call6747;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call6752 = callmethodflags(call6751, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6745);
// compilenode returning call6752
  gc_frame_newslot(call6752);
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defDecNode
  params[0] = call6740;
  params[1] = call6744;
  params[2] = call6752;
  partcv[0] = 3;
  Object call6753 = callmethod(*var_defDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6738);
// compilenode returning call6753
  *var_n = call6753;
  if (call6753 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6754 = gc_frame_new();
  int callframe6755 = gc_frame_new();
  int callframe6756 = gc_frame_new();
  partcv[0] = 0;
  Object call6757 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6756);
// compilenode returning call6757
  gc_frame_newslot(call6757);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe6758 = gc_frame_new();
  int callframe6759 = gc_frame_new();
  Object call6760 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe6759);
// compilenode returning call6760
// compilenode returning call6760
  partcv[0] = 0;
  Object call6761 = callmethodflags(call6760, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6758);
// compilenode returning call6761
// compilenode returning call6761
  params[0] = call6757;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6762 = callmethodflags(call6761, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6755);
// compilenode returning call6762
  gc_frame_newslot(call6762);
  Object block6763 = alloc_Block(NULL, NULL, "ast", 1568);
  gc_frame_newslot(block6763);
  block_savedest(block6763);
  Object closure6764 = createclosure(5, "_apply");
setclosureframe(closure6764, stackframe);
  addtoclosure(closure6764, var_blk);
  addtoclosure(closure6764, var_blkBefore);
  addtoclosure(closure6764, var_blkAfter);
  addtoclosure(closure6764, var_n);
  addtoclosure(closure6764, selfslot);
  struct UserObject *uo6764 = (struct UserObject*)block6763;
  uo6764->data[0] = (Object)closure6764;
  Method *meth_meth_ast__apply6764 = addmethod2pos(block6763, "_apply", &meth_ast__apply6764, 0);
int argcv_meth_ast__apply6764[] = {1};
meth_meth_ast__apply6764->type = alloc_MethodType(1, argcv_meth_ast__apply6764);
  meth_meth_ast__apply6764->definitionModule = modulename;
  meth_meth_ast__apply6764->definitionLine = 1568;
// compilenode returning block6763
  gc_frame_newslot(block6763);
  params[0] = call6762;
  params[1] = block6763;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6772 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6754);
// compilenode returning call6772
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6773 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6774 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe6773);
// compilenode returning call6774
  *var_n = call6774;
  if (call6774 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6776 = gc_frame_new();
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6777 = gc_frame_new();
  partcv[0] = 0;
  Object call6778 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6777);
// compilenode returning call6778
  gc_frame_newslot(call6778);
// compilenode returning *var_n
  params[0] = call6778;
  partcv[0] = 1;
  Object call6779 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6776);
// compilenode returning call6779
// compilenode returning done
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6780 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call6781 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe6780);
// compilenode returning call6781
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply6785(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6788(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map6782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6783 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block6784 = alloc_Block(NULL, NULL, "ast", 1577);
  gc_frame_newslot(block6784);
  block_savedest(block6784);
  Object closure6785 = createclosure(1, "_apply");
setclosureframe(closure6785, stackframe);
  addtoclosure(closure6785, selfslot);
  struct UserObject *uo6785 = (struct UserObject*)block6784;
  uo6785->data[0] = (Object)closure6785;
  Method *meth_meth_ast__apply6785 = addmethod2pos(block6784, "_apply", &meth_ast__apply6785, 0);
int argcv_meth_ast__apply6785[] = {0};
meth_meth_ast__apply6785->type = alloc_MethodType(1, argcv_meth_ast__apply6785);
  meth_meth_ast__apply6785->definitionModule = modulename;
  meth_meth_ast__apply6785->definitionLine = 1569;
// compilenode returning block6784
  gc_frame_newslot(block6784);
  Object block6787 = alloc_Block(NULL, NULL, "ast", 1577);
  gc_frame_newslot(block6787);
  block_savedest(block6787);
  Object closure6788 = createclosure(1, "_apply");
setclosureframe(closure6788, stackframe);
  addtoclosure(closure6788, selfslot);
  struct UserObject *uo6788 = (struct UserObject*)block6787;
  uo6788->data[0] = (Object)closure6788;
  Method *meth_meth_ast__apply6788 = addmethod2pos(block6787, "_apply", &meth_ast__apply6788, 0);
int argcv_meth_ast__apply6788[] = {0};
meth_meth_ast__apply6788->type = alloc_MethodType(1, argcv_meth_ast__apply6788);
  meth_meth_ast__apply6788->definitionModule = modulename;
  meth_meth_ast__apply6788->definitionLine = 1569;
// compilenode returning block6787
  gc_frame_newslot(block6787);
  params[0] = *var_blk;
  params[1] = block6784;
  params[2] = block6787;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6790 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6783);
// compilenode returning call6790
  gc_frame_end(frame);
  return call6790;
}
Object meth_ast__apply6799(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6801 == NULL) {
    strlit6801 = alloc_String("  ");
    gc_root(strlit6801);
  }
// compilenode returning strlit6801
  int op_slot_right_6800 = gc_frame_newslot(strlit6801);
// compilenode returning *var_spc
  int op_slot_left_6800 = gc_frame_newslot(*var_spc);
  params[0] = strlit6801;
  partcv[0] = 1;
  Object opresult6803 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6803
  *var_spc = opresult6803;
  if (opresult6803 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty6791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6792 == NULL) {
    strlit6792 = alloc_String("");
    gc_root(strlit6792);
  }
// compilenode returning strlit6792
  *var_spc = strlit6792;
  if (strlit6792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6793 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_6794 = gc_frame_newslot(*var_depth);
  Object num6796 = alloc_Float64(0);
// compilenode returning num6796
  int op_slot_left_6794 = gc_frame_newslot(num6796);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult6797 = callmethod(num6796, "..", 1, partcv, params);
// compilenode returning opresult6797
  gc_frame_newslot(opresult6797);
  Object block6798 = alloc_Block(NULL, NULL, "ast", 1581);
  gc_frame_newslot(block6798);
  block_savedest(block6798);
  Object closure6799 = createclosure(2, "_apply");
setclosureframe(closure6799, stackframe);
  addtoclosure(closure6799, var_spc);
  addtoclosure(closure6799, selfslot);
  struct UserObject *uo6799 = (struct UserObject*)block6798;
  uo6799->data[0] = (Object)closure6799;
  Method *meth_meth_ast__apply6799 = addmethod2pos(block6798, "_apply", &meth_ast__apply6799, 0);
int argcv_meth_ast__apply6799[] = {1};
meth_meth_ast__apply6799->type = alloc_MethodType(1, argcv_meth_ast__apply6799);
  meth_meth_ast__apply6799->definitionModule = modulename;
  meth_meth_ast__apply6799->definitionLine = 1569;
// compilenode returning block6798
  gc_frame_newslot(block6798);
  params[0] = opresult6797;
  params[1] = block6798;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6806 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6793);
// compilenode returning call6806
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6807 == NULL) {
    strlit6807 = alloc_String("defdec");
    gc_root(strlit6807);
  }
// compilenode returning strlit6807
  *var_s = strlit6807;
  if (strlit6807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6809 == NULL) {
    strlit6809 = alloc_String("""\x0a""");
    gc_root(strlit6809);
  }
// compilenode returning strlit6809
  int op_slot_right_6808 = gc_frame_newslot(strlit6809);
// compilenode returning *var_s
  int op_slot_left_6808 = gc_frame_newslot(*var_s);
  params[0] = strlit6809;
  partcv[0] = 1;
  Object opresult6811 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6811
  *var_s = opresult6811;
  if (opresult6811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6814 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe6815 = gc_frame_new();
  partcv[0] = 0;
  Object call6816 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6815);
// compilenode returning call6816
// compilenode returning call6816
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call6817 = callmethod(call6816, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6814);
// compilenode returning call6817
  int op_slot_right_6813 = gc_frame_newslot(call6817);
// compilenode returning *var_spc
  int op_slot_right_6819 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6819 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6821 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6821
  int op_slot_left_6813 = gc_frame_newslot(opresult6821);
  params[0] = call6817;
  partcv[0] = 1;
  Object opresult6822 = callmethod(opresult6821, "++", 1, partcv, params);
// compilenode returning opresult6822
  *var_s = opresult6822;
  if (opresult6822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6826 = alloc_Boolean(0);
// compilenode returning bool6826
  int op_slot_right_6825 = gc_frame_newslot(bool6826);
  int callframe6828 = gc_frame_new();
  partcv[0] = 0;
  Object call6829 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6828);
// compilenode returning call6829
// compilenode returning call6829
  int op_slot_left_6825 = gc_frame_newslot(call6829);
  params[0] = bool6826;
  partcv[0] = 1;
  Object opresult6830 = callmethod(call6829, "!=", 1, partcv, params);
// compilenode returning opresult6830
  Object if6824 = done;
  if (istrue(opresult6830)) {
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6832 == NULL) {
    strlit6832 = alloc_String("Type:");
    gc_root(strlit6832);
  }
// compilenode returning strlit6832
  int op_slot_right_6831 = gc_frame_newslot(strlit6832);
// compilenode returning *var_spc
  int op_slot_right_6834 = gc_frame_newslot(*var_spc);
  if (strlit6837 == NULL) {
    strlit6837 = alloc_String("""\x0a""");
    gc_root(strlit6837);
  }
// compilenode returning strlit6837
  int op_slot_right_6836 = gc_frame_newslot(strlit6837);
// compilenode returning *var_s
  int op_slot_left_6836 = gc_frame_newslot(*var_s);
  params[0] = strlit6837;
  partcv[0] = 1;
  Object opresult6839 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6839
  int op_slot_left_6834 = gc_frame_newslot(opresult6839);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6840 = callmethod(opresult6839, "++", 1, partcv, params);
// compilenode returning opresult6840
  int op_slot_left_6831 = gc_frame_newslot(opresult6840);
  params[0] = strlit6832;
  partcv[0] = 1;
  Object opresult6841 = callmethod(opresult6840, "++", 1, partcv, params);
// compilenode returning opresult6841
  *var_s = opresult6841;
  if (opresult6841 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6844 = gc_frame_new();
  Object num6846 = alloc_Float64(2);
// compilenode returning num6846
  int op_slot_right_6845 = gc_frame_newslot(num6846);
// compilenode returning *var_depth
  int op_slot_left_6845 = gc_frame_newslot(*var_depth);
  params[0] = num6846;
  partcv[0] = 1;
  Object sum6848 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6848
  gc_frame_newslot(sum6848);
  int callframe6849 = gc_frame_new();
  partcv[0] = 0;
  Object call6850 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6849);
// compilenode returning call6850
// compilenode returning call6850
  params[0] = sum6848;
  partcv[0] = 1;
  Object call6851 = callmethod(call6850, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6844);
// compilenode returning call6851
  int op_slot_right_6843 = gc_frame_newslot(call6851);
  if (strlit6854 == NULL) {
    strlit6854 = alloc_String("  ");
    gc_root(strlit6854);
  }
// compilenode returning strlit6854
  int op_slot_right_6853 = gc_frame_newslot(strlit6854);
// compilenode returning *var_spc
  int op_slot_right_6856 = gc_frame_newslot(*var_spc);
  if (strlit6859 == NULL) {
    strlit6859 = alloc_String("""\x0a""");
    gc_root(strlit6859);
  }
// compilenode returning strlit6859
  int op_slot_right_6858 = gc_frame_newslot(strlit6859);
// compilenode returning *var_s
  int op_slot_left_6858 = gc_frame_newslot(*var_s);
  params[0] = strlit6859;
  partcv[0] = 1;
  Object opresult6861 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6861
  int op_slot_left_6856 = gc_frame_newslot(opresult6861);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6862 = callmethod(opresult6861, "++", 1, partcv, params);
// compilenode returning opresult6862
  int op_slot_left_6853 = gc_frame_newslot(opresult6862);
  params[0] = strlit6854;
  partcv[0] = 1;
  Object opresult6863 = callmethod(opresult6862, "++", 1, partcv, params);
// compilenode returning opresult6863
  int op_slot_left_6843 = gc_frame_newslot(opresult6863);
  params[0] = call6851;
  partcv[0] = 1;
  Object opresult6864 = callmethod(opresult6863, "++", 1, partcv, params);
// compilenode returning opresult6864
  *var_s = opresult6864;
  if (opresult6864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6824 = done;
  } else {
  }
// compilenode returning if6824
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6868 = gc_frame_new();
  partcv[0] = 0;
  Object call6869 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6868);
// compilenode returning call6869
// compilenode returning call6869
  int op_slot_right_6867 = gc_frame_newslot(call6869);
  Object bool6871 = alloc_Boolean(0);
// compilenode returning bool6871
  int op_slot_left_6867 = gc_frame_newslot(bool6871);
  params[0] = call6869;
  partcv[0] = 1;
  Object opresult6872 = callmethod(bool6871, "!=", 1, partcv, params);
// compilenode returning opresult6872
  Object if6866 = done;
  if (istrue(opresult6872)) {
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6874 == NULL) {
    strlit6874 = alloc_String("""\x0a""");
    gc_root(strlit6874);
  }
// compilenode returning strlit6874
  int op_slot_right_6873 = gc_frame_newslot(strlit6874);
// compilenode returning *var_s
  int op_slot_left_6873 = gc_frame_newslot(*var_s);
  params[0] = strlit6874;
  partcv[0] = 1;
  Object opresult6876 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6876
  *var_s = opresult6876;
  if (opresult6876 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6879 = gc_frame_new();
  Object num6881 = alloc_Float64(1);
// compilenode returning num6881
  int op_slot_right_6880 = gc_frame_newslot(num6881);
// compilenode returning *var_depth
  int op_slot_left_6880 = gc_frame_newslot(*var_depth);
  params[0] = num6881;
  partcv[0] = 1;
  Object sum6883 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum6883
  gc_frame_newslot(sum6883);
  int callframe6884 = gc_frame_new();
  partcv[0] = 0;
  Object call6885 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6884);
// compilenode returning call6885
// compilenode returning call6885
  params[0] = sum6883;
  partcv[0] = 1;
  Object call6886 = callmethod(call6885, "pretty",
    1, partcv, params);
  gc_frame_end(callframe6879);
// compilenode returning call6886
  int op_slot_right_6878 = gc_frame_newslot(call6886);
// compilenode returning *var_spc
  int op_slot_right_6888 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_6888 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult6890 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6890
  int op_slot_left_6878 = gc_frame_newslot(opresult6890);
  params[0] = call6886;
  partcv[0] = 1;
  Object opresult6891 = callmethod(opresult6890, "++", 1, partcv, params);
// compilenode returning opresult6891
  *var_s = opresult6891;
  if (opresult6891 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6866 = done;
  } else {
  }
// compilenode returning if6866
// Begin line 1595
  setline(1595);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType6893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6896 = alloc_Boolean(0);
// compilenode returning bool6896
  int op_slot_right_6895 = gc_frame_newslot(bool6896);
  int callframe6898 = gc_frame_new();
  partcv[0] = 0;
  Object call6899 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6898);
// compilenode returning call6899
  int op_slot_left_6895 = gc_frame_newslot(call6899);
  params[0] = bool6896;
  partcv[0] = 1;
  Object opresult6900 = callmethod(call6899, "==", 1, partcv, params);
// compilenode returning opresult6900
  Object if6894 = done;
  if (istrue(opresult6900)) {
// Begin line 1599
  setline(1599);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6901 = gc_frame_new();
  if (strlit6902 == NULL) {
    strlit6902 = alloc_String("Unknown");
    gc_root(strlit6902);
  }
// compilenode returning strlit6902
  gc_frame_newslot(strlit6902);
  Object bool6903 = alloc_Boolean(0);
// compilenode returning bool6903
  gc_frame_newslot(bool6903);
// compilenode returning *var_identifierNode
  params[0] = strlit6902;
  params[1] = bool6903;
  partcv[0] = 2;
  Object call6904 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe6901);
// compilenode returning call6904
  return call6904;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if6894 = undefined;
  } else {
  }
// compilenode returning if6894
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1601
  setline(1601);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6905 = gc_frame_new();
  partcv[0] = 0;
  Object call6906 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6905);
// compilenode returning call6906
  return call6906;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply6919(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6921 == NULL) {
    strlit6921 = alloc_String("    ");
    gc_root(strlit6921);
  }
// compilenode returning strlit6921
  int op_slot_right_6920 = gc_frame_newslot(strlit6921);
// compilenode returning *var_spc
  int op_slot_left_6920 = gc_frame_newslot(*var_spc);
  params[0] = strlit6921;
  partcv[0] = 1;
  Object opresult6923 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult6923
  *var_spc = opresult6923;
  if (opresult6923 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply6980(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6982 = gc_frame_new();
  Object num6983 = alloc_Float64(0);
// compilenode returning num6983
  gc_frame_newslot(num6983);
// compilenode returning *var_b
  params[0] = num6983;
  partcv[0] = 1;
  Object call6984 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6982);
// compilenode returning call6984
  int op_slot_right_6981 = gc_frame_newslot(call6984);
  if (strlit6988 == NULL) {
    strlit6988 = alloc_String("");
    gc_root(strlit6988);
  }
// compilenode returning strlit6988
  int op_slot_right_6987 = gc_frame_newslot(strlit6988);
// compilenode returning *var_a
  int op_slot_left_6987 = gc_frame_newslot(*var_a);
  params[0] = strlit6988;
  partcv[0] = 1;
  Object opresult6990 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult6990
  Object if6986 = done;
struct StackFrameObject *iftmpstackframe6986 = stackframe;
  if (istrue(opresult6990)) {
stackframe = alloc_StackFrame(0, iftmpstackframe6986);
gc_frame_newslot((Object)stackframe);
  if (strlit6992 == NULL) {
    strlit6992 = alloc_String(", ");
    gc_root(strlit6992);
  }
// compilenode returning strlit6992
  int op_slot_right_6991 = gc_frame_newslot(strlit6992);
// compilenode returning *var_a
  int op_slot_left_6991 = gc_frame_newslot(*var_a);
  params[0] = strlit6992;
  partcv[0] = 1;
  Object opresult6994 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult6994
    gc_frame_newslot(opresult6994);
    if6986 = opresult6994;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe6986);
gc_frame_newslot((Object)stackframe);
  if (strlit6995 == NULL) {
    strlit6995 = alloc_String("");
    gc_root(strlit6995);
  }
// compilenode returning strlit6995
    gc_frame_newslot(strlit6995);
    if6986 = strlit6995;
  }
stackframe = iftmpstackframe6986;
// compilenode returning if6986
  int op_slot_left_6981 = gc_frame_newslot(if6986);
  params[0] = call6984;
  partcv[0] = 1;
  Object opresult6996 = callmethod(if6986, "++", 1, partcv, params);
// compilenode returning opresult6996
  gc_frame_end(frame);
  return opresult6996;
}
Object meth_ast_toGrace6907(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6908 == NULL) {
    strlit6908 = alloc_String("");
    gc_root(strlit6908);
  }
// compilenode returning strlit6908
  *var_spc = strlit6908;
  if (strlit6908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6909 = gc_frame_new();
  Object num6912 = alloc_Float64(1);
// compilenode returning num6912
  int op_slot_right_6911 = gc_frame_newslot(num6912);
// compilenode returning *var_depth
  int op_slot_left_6911 = gc_frame_newslot(*var_depth);
  params[0] = num6912;
  partcv[0] = 1;
  Object diff6914 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff6914
  int op_slot_right_6910 = gc_frame_newslot(diff6914);
  Object num6916 = alloc_Float64(0);
// compilenode returning num6916
  int op_slot_left_6910 = gc_frame_newslot(num6916);
  params[0] = diff6914;
  partcv[0] = 1;
  Object opresult6917 = callmethod(num6916, "..", 1, partcv, params);
// compilenode returning opresult6917
  gc_frame_newslot(opresult6917);
  Object block6918 = alloc_Block(NULL, NULL, "ast", 1605);
  gc_frame_newslot(block6918);
  block_savedest(block6918);
  Object closure6919 = createclosure(2, "_apply");
setclosureframe(closure6919, stackframe);
  addtoclosure(closure6919, var_spc);
  addtoclosure(closure6919, selfslot);
  struct UserObject *uo6919 = (struct UserObject*)block6918;
  uo6919->data[0] = (Object)closure6919;
  Method *meth_meth_ast__apply6919 = addmethod2pos(block6918, "_apply", &meth_ast__apply6919, 0);
int argcv_meth_ast__apply6919[] = {1};
meth_meth_ast__apply6919->type = alloc_MethodType(1, argcv_meth_ast__apply6919);
  meth_meth_ast__apply6919->definitionModule = modulename;
  meth_meth_ast__apply6919->definitionLine = 1593;
// compilenode returning block6918
  gc_frame_newslot(block6918);
  params[0] = opresult6917;
  params[1] = block6918;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6926 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6909);
// compilenode returning call6926
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6928 == NULL) {
    strlit6928 = alloc_String("");
    gc_root(strlit6928);
  }
// compilenode returning strlit6928
  int op_slot_right_6927 = gc_frame_newslot(strlit6928);
  int callframe6931 = gc_frame_new();
  Object num6932 = alloc_Float64(0);
// compilenode returning num6932
  gc_frame_newslot(num6932);
  int callframe6933 = gc_frame_new();
  partcv[0] = 0;
  Object call6934 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6933);
// compilenode returning call6934
// compilenode returning call6934
  params[0] = num6932;
  partcv[0] = 1;
  Object call6935 = callmethod(call6934, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6931);
// compilenode returning call6935
  int op_slot_right_6930 = gc_frame_newslot(call6935);
  if (strlit6937 == NULL) {
    strlit6937 = alloc_String("def ");
    gc_root(strlit6937);
  }
// compilenode returning strlit6937
  int op_slot_left_6930 = gc_frame_newslot(strlit6937);
  params[0] = call6935;
  partcv[0] = 1;
  Object opresult6938 = callmethod(strlit6937, "++", 1, partcv, params);
// compilenode returning opresult6938
  int op_slot_left_6927 = gc_frame_newslot(opresult6938);
  params[0] = strlit6928;
  partcv[0] = 1;
  Object opresult6939 = callmethod(opresult6938, "++", 1, partcv, params);
// compilenode returning opresult6939
  *var_s = opresult6939;
  if (opresult6939 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6942 == NULL) {
    strlit6942 = alloc_String("Unknown");
    gc_root(strlit6942);
  }
// compilenode returning strlit6942
  int op_slot_right_6941 = gc_frame_newslot(strlit6942);
  int callframe6944 = gc_frame_new();
  int callframe6945 = gc_frame_new();
  partcv[0] = 0;
  Object call6946 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6945);
// compilenode returning call6946
// compilenode returning call6946
  partcv[0] = 0;
  Object call6947 = callmethod(call6946, "value",
    1, partcv, params);
  gc_frame_end(callframe6944);
// compilenode returning call6947
// compilenode returning call6947
  int op_slot_left_6941 = gc_frame_newslot(call6947);
  params[0] = strlit6942;
  partcv[0] = 1;
  Object opresult6948 = callmethod(call6947, "!=", 1, partcv, params);
// compilenode returning opresult6948
  Object if6940 = done;
  if (istrue(opresult6948)) {
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6950 = gc_frame_new();
  Object num6951 = alloc_Float64(0);
// compilenode returning num6951
  gc_frame_newslot(num6951);
  int callframe6952 = gc_frame_new();
  partcv[0] = 0;
  Object call6953 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6952);
// compilenode returning call6953
// compilenode returning call6953
  params[0] = num6951;
  partcv[0] = 1;
  Object call6954 = callmethod(call6953, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe6950);
// compilenode returning call6954
  int op_slot_right_6949 = gc_frame_newslot(call6954);
  if (strlit6957 == NULL) {
    strlit6957 = alloc_String(" : ");
    gc_root(strlit6957);
  }
// compilenode returning strlit6957
  int op_slot_right_6956 = gc_frame_newslot(strlit6957);
// compilenode returning *var_s
  int op_slot_left_6956 = gc_frame_newslot(*var_s);
  params[0] = strlit6957;
  partcv[0] = 1;
  Object opresult6959 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6959
  int op_slot_left_6949 = gc_frame_newslot(opresult6959);
  params[0] = call6954;
  partcv[0] = 1;
  Object opresult6960 = callmethod(opresult6959, "++", 1, partcv, params);
// compilenode returning opresult6960
  *var_s = opresult6960;
  if (opresult6960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6940 = done;
  } else {
  }
// compilenode returning if6940
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num6964 = alloc_Float64(0);
// compilenode returning num6964
  int op_slot_right_6963 = gc_frame_newslot(num6964);
  int callframe6966 = gc_frame_new();
  int callframe6967 = gc_frame_new();
  partcv[0] = 0;
  Object call6968 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6967);
// compilenode returning call6968
// compilenode returning call6968
  partcv[0] = 0;
  Object call6969 = callmethod(call6968, "size",
    1, partcv, params);
  gc_frame_end(callframe6966);
// compilenode returning call6969
// compilenode returning call6969
  int op_slot_left_6963 = gc_frame_newslot(call6969);
  params[0] = num6964;
  partcv[0] = 1;
  Object opresult6970 = callmethod(call6969, ">", 1, partcv, params);
// compilenode returning opresult6970
  Object if6962 = done;
  if (istrue(opresult6970)) {
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6972 == NULL) {
    strlit6972 = alloc_String(" is ");
    gc_root(strlit6972);
  }
// compilenode returning strlit6972
  int op_slot_right_6971 = gc_frame_newslot(strlit6972);
// compilenode returning *var_s
  int op_slot_left_6971 = gc_frame_newslot(*var_s);
  params[0] = strlit6972;
  partcv[0] = 1;
  Object opresult6974 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult6974
  *var_s = opresult6974;
  if (opresult6974 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6977 = gc_frame_new();
  if (strlit6978 == NULL) {
    strlit6978 = alloc_String("");
    gc_root(strlit6978);
  }
// compilenode returning strlit6978
  gc_frame_newslot(strlit6978);
  Object block6979 = alloc_Block(NULL, NULL, "ast", 1614);
  gc_frame_newslot(block6979);
  block_savedest(block6979);
  Object closure6980 = createclosure(1, "_apply");
setclosureframe(closure6980, stackframe);
  addtoclosure(closure6980, selfslot);
  struct UserObject *uo6980 = (struct UserObject*)block6979;
  uo6980->data[0] = (Object)closure6980;
  Method *meth_meth_ast__apply6980 = addmethod2pos(block6979, "_apply", &meth_ast__apply6980, 0);
int argcv_meth_ast__apply6980[] = {2};
meth_meth_ast__apply6980->type = alloc_MethodType(1, argcv_meth_ast__apply6980);
  meth_meth_ast__apply6980->definitionModule = modulename;
  meth_meth_ast__apply6980->definitionLine = 1612;
// compilenode returning block6979
  gc_frame_newslot(block6979);
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6998 = gc_frame_new();
  partcv[0] = 0;
  Object call6999 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6998);
// compilenode returning call6999
// compilenode returning call6999
  params[0] = strlit6978;
  params[1] = block6979;
  partcv[0] = 2;
  Object call7000 = callmethod(call6999, "reduce",
    1, partcv, params);
  gc_frame_end(callframe6977);
// compilenode returning call7000
  int op_slot_right_6976 = gc_frame_newslot(call7000);
// compilenode returning *var_s
  int op_slot_left_6976 = gc_frame_newslot(*var_s);
  params[0] = call7000;
  partcv[0] = 1;
  Object opresult7002 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7002
  *var_s = opresult7002;
  if (opresult7002 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6962 = done;
  } else {
  }
// compilenode returning if6962
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7006 = alloc_Boolean(0);
// compilenode returning bool7006
  int op_slot_right_7005 = gc_frame_newslot(bool7006);
  int callframe7008 = gc_frame_new();
  partcv[0] = 0;
  Object call7009 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7008);
// compilenode returning call7009
// compilenode returning call7009
  int op_slot_left_7005 = gc_frame_newslot(call7009);
  params[0] = bool7006;
  partcv[0] = 1;
  Object opresult7010 = callmethod(call7009, "!=", 1, partcv, params);
// compilenode returning opresult7010
  Object if7004 = done;
  if (istrue(opresult7010)) {
// Begin line 1618
  setline(1618);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7012 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe7013 = gc_frame_new();
  partcv[0] = 0;
  Object call7014 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7013);
// compilenode returning call7014
// compilenode returning call7014
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7015 = callmethod(call7014, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7012);
// compilenode returning call7015
  int op_slot_right_7011 = gc_frame_newslot(call7015);
  if (strlit7018 == NULL) {
    strlit7018 = alloc_String(" = ");
    gc_root(strlit7018);
  }
// compilenode returning strlit7018
  int op_slot_right_7017 = gc_frame_newslot(strlit7018);
// compilenode returning *var_s
  int op_slot_left_7017 = gc_frame_newslot(*var_s);
  params[0] = strlit7018;
  partcv[0] = 1;
  Object opresult7020 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7020
  int op_slot_left_7011 = gc_frame_newslot(opresult7020);
  params[0] = call7015;
  partcv[0] = 1;
  Object opresult7021 = callmethod(opresult7020, "++", 1, partcv, params);
// compilenode returning opresult7021
  *var_s = opresult7021;
  if (opresult7021 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7004 = done;
  } else {
  }
// compilenode returning if7004
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new6695(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6696 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6696 = alloc_userobj2(17,15, objclass6696);
  gc_frame_newslot(obj6696);
if (objclass6696 == NULL) {
  glfree(obj6696->class->name);
  obj6696->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6696, self, 0);
  addmethodreal(obj6696,"outer", &reader_ast_outer_6697);
  Object oldself6696 = self;
  struct StackFrameObject *oldstackframe6696 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6696);
  gc_frame_newslot((Object)stackframe);
  self = obj6696;
  Object *oldselfslot6696 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6696 = (*(struct UserObject *)self).data[0], lowerouter6696 = thisouter6696;
  if (inheritingObject6696) {
    struct UserObject *inho6696 = (struct UserObject *)inheritingObject6696;
    while (inho6696->super != GraceDefaultObject) inho6696 = (struct UserObject *)inho6696->super;
    inho6696->super = obj6696;
    self = inheritingObject6696;
    *selfslot = self;
    lowerouter6696 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6696;
  }
if (objclass6696 == NULL) {
  Method *reader6698 = addmethodrealflags(obj6696, "kind",&reader_ast_kind_6698, MFLAG_DEF);
  reader6698->definitionModule = modulename;
  reader6698->definitionLine = 1547;
}
adddatum2(obj6696, alloc_Undefined(), 1);
if (objclass6696 == NULL) {
  Method *reader6699 = addmethodrealflags(obj6696, "name",&reader_ast_name_6699, MFLAG_DEF);
  reader6699->definitionModule = modulename;
  reader6699->definitionLine = 1548;
}
adddatum2(obj6696, alloc_Undefined(), 2);
if (objclass6696 == NULL) {
  Method *reader6700 = addmethodrealflags(obj6696, "value",&reader_ast_value_6700, MFLAG_DEF);
  reader6700->definitionModule = modulename;
  reader6700->definitionLine = 1549;
}
adddatum2(obj6696, alloc_Undefined(), 3);
if (objclass6696 == NULL) {
  Method *reader6701 = addmethodrealflags(obj6696, "dtype",&reader_ast_dtype_6701, 0);
  Method *writer6701 = addmethodrealflags(obj6696, "dtype:=",&writer_ast_dtype_6701, 0);
  reader6701->definitionModule = modulename;
  writer6701->definitionModule = modulename;
  reader6701->definitionLine = 1550;
  writer6701->definitionLine = 1550;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 4);
if (objclass6696 == NULL) {
  Method *reader6702 = addmethodrealflags(obj6696, "annotations",&reader_ast_annotations_6702, MFLAG_DEF);
  reader6702->definitionModule = modulename;
  reader6702->definitionLine = 1551;
}
adddatum2(obj6696, alloc_Undefined(), 5);
if (objclass6696 == NULL) {
  Method *reader6703 = addmethodrealflags(obj6696, "data",&reader_ast_data_6703, 0);
  Method *writer6703 = addmethodrealflags(obj6696, "data:=",&writer_ast_data_6703, 0);
  reader6703->definitionModule = modulename;
  writer6703->definitionModule = modulename;
  reader6703->definitionLine = 1552;
  writer6703->definitionLine = 1552;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 6);
if (objclass6696 == NULL) {
  Method *reader6704 = addmethodrealflags(obj6696, "startToken",&reader_ast_startToken_6704, 0);
  Method *writer6704 = addmethodrealflags(obj6696, "startToken:=",&writer_ast_startToken_6704, 0);
  reader6704->definitionModule = modulename;
  writer6704->definitionModule = modulename;
  reader6704->definitionLine = 1553;
  writer6704->definitionLine = 1553;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 7);
  struct UserObject *uo6705 = (struct UserObject*)obj6696;
  uo6705->data[8] = emptyclosure;
  Method *meth_meth_ast_accept6705 = addmethod2pos(obj6696, "accept", &meth_ast_accept6705, 8);
int argcv_meth_ast_accept6705[] = {1};
meth_meth_ast_accept6705->type = alloc_MethodType(1, argcv_meth_ast_accept6705);
meth_meth_ast_accept6705->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6705->type->names[0] = "visitor";
  meth_meth_ast_accept6705->definitionModule = modulename;
  meth_meth_ast_accept6705->definitionLine = 1553;
  block_savedest(obj6696);
  Object closure6735 = createclosure(1, "map()before()after");
setclosureframe(closure6735, stackframe);
  addtoclosure(closure6735, var_defDecNode);
  struct UserObject *uo6735 = (struct UserObject*)obj6696;
  uo6735->data[9] = (Object)closure6735;
  Method *meth_meth_ast_map_40__41_before_40__41_after6735 = addmethod2pos(obj6696, "map()before()after", &meth_ast_map_40__41_before_40__41_after6735, 9);
int argcv_meth_ast_map_40__41_before_40__41_after6735[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6735->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6735);
  meth_meth_ast_map_40__41_before_40__41_after6735->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6735->definitionLine = 1564;
  struct UserObject *uo6782 = (struct UserObject*)obj6696;
  uo6782->data[10] = emptyclosure;
  Method *meth_meth_ast_map6782 = addmethod2pos(obj6696, "map", &meth_ast_map6782, 10);
int argcv_meth_ast_map6782[] = {1};
meth_meth_ast_map6782->type = alloc_MethodType(1, argcv_meth_ast_map6782);
  meth_meth_ast_map6782->definitionModule = modulename;
  meth_meth_ast_map6782->definitionLine = 1576;
  struct UserObject *uo6791 = (struct UserObject*)obj6696;
  uo6791->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty6791 = addmethod2pos(obj6696, "pretty", &meth_ast_pretty6791, 11);
int argcv_meth_ast_pretty6791[] = {1};
meth_meth_ast_pretty6791->type = alloc_MethodType(1, argcv_meth_ast_pretty6791);
  meth_meth_ast_pretty6791->definitionModule = modulename;
  meth_meth_ast_pretty6791->definitionLine = 1579;
  block_savedest(obj6696);
  Object closure6893 = createclosure(1, "decType");
setclosureframe(closure6893, stackframe);
  addtoclosure(closure6893, var_identifierNode);
  struct UserObject *uo6893 = (struct UserObject*)obj6696;
  uo6893->data[12] = (Object)closure6893;
  Method *meth_meth_ast_decType6893 = addmethod2pos(obj6696, "decType", &meth_ast_decType6893, 12);
int argcv_meth_ast_decType6893[] = {0};
meth_meth_ast_decType6893->type = alloc_MethodType(1, argcv_meth_ast_decType6893);
  meth_meth_ast_decType6893->definitionModule = modulename;
  meth_meth_ast_decType6893->definitionLine = 1597;
  struct UserObject *uo6907 = (struct UserObject*)obj6696;
  uo6907->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace6907 = addmethod2pos(obj6696, "toGrace", &meth_ast_toGrace6907, 13);
int argcv_meth_ast_toGrace6907[] = {1};
meth_meth_ast_toGrace6907->type = alloc_MethodType(1, argcv_meth_ast_toGrace6907);
meth_meth_ast_toGrace6907->type->types[0] = type_Number;
meth_meth_ast_toGrace6907->type->names[0] = "depth";
  meth_meth_ast_toGrace6907->definitionModule = modulename;
  meth_meth_ast_toGrace6907->definitionLine = 1603;
  sourceObject = obj6696;
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7023 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7024 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7023);
// compilenode returning call7024
  struct UserObject *obj6696_uo = (struct UserObject *)obj6696;
  obj6696_uo->super = call7024;
  sourceObject = obj6696;
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7025 == NULL) {
    strlit7025 = alloc_String("defdec");
    gc_root(strlit7025);
  }
// compilenode returning strlit7025
  adddatum2(obj6696, strlit7025, 1);
  sourceObject = obj6696;
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj6696, *var_name_39_, 2);
  sourceObject = obj6696;
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6696, *var_val, 3);
  sourceObject = obj6696;
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj6696, *var_dtype_39_, 4);
  sourceObject = obj6696;
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7026 = gc_frame_new();
  int callframe7027 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7028 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7027);
// compilenode returning call7028
// compilenode returning call7028
  partcv[0] = 0;
  Object call7029 = callmethod(call7028, "new",
    1, partcv, params);
  gc_frame_end(callframe7026);
// compilenode returning call7029
// compilenode returning call7029
  adddatum2(obj6696, call7029, 5);
  sourceObject = obj6696;
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7030 = alloc_Boolean(0);
// compilenode returning bool7030
  adddatum2(obj6696, bool7030, 6);
  sourceObject = obj6696;
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7031 = alloc_Boolean(0);
// compilenode returning bool7031
  adddatum2(obj6696, bool7031, 7);
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
objclass6696 = obj6696->class;
  objclass6696->definitionModule = modulename;
  objclass6696->definitionLine = 1540;
  (*(struct UserObject *)self).data[0] = lowerouter6696;
  self = oldself6696;
  selfslot = oldselfslot6696;
  stackframe = oldstackframe6696;
  gc_frame_end(frame);
  return obj6696;
}
Object meth_ast_new6695_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_defDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val = &(stackframe->slots[1]);
  *var_val = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6696 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6696 = alloc_userobj2(17,15, objclass6696);
  gc_frame_newslot(obj6696);
if (objclass6696 == NULL) {
  glfree(obj6696->class->name);
  obj6696->class->name = "defDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6696, self, 0);
  addmethodreal(obj6696,"outer", &reader_ast_outer_6697);
  Object oldself6696 = self;
  struct StackFrameObject *oldstackframe6696 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6696);
  gc_frame_newslot((Object)stackframe);
  self = obj6696;
  Object *oldselfslot6696 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6696 = (*(struct UserObject *)self).data[0], lowerouter6696 = thisouter6696;
  if (inheritingObject6696) {
    struct UserObject *inho6696 = (struct UserObject *)inheritingObject6696;
    while (inho6696->super != GraceDefaultObject) inho6696 = (struct UserObject *)inho6696->super;
    inho6696->super = obj6696;
    self = inheritingObject6696;
    *selfslot = self;
    lowerouter6696 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6696;
  }
if (objclass6696 == NULL) {
  Method *reader6698 = addmethodrealflags(obj6696, "kind",&reader_ast_kind_6698, MFLAG_DEF);
  reader6698->definitionModule = modulename;
  reader6698->definitionLine = 1547;
}
adddatum2(obj6696, alloc_Undefined(), 1);
if (objclass6696 == NULL) {
  Method *reader6699 = addmethodrealflags(obj6696, "name",&reader_ast_name_6699, MFLAG_DEF);
  reader6699->definitionModule = modulename;
  reader6699->definitionLine = 1548;
}
adddatum2(obj6696, alloc_Undefined(), 2);
if (objclass6696 == NULL) {
  Method *reader6700 = addmethodrealflags(obj6696, "value",&reader_ast_value_6700, MFLAG_DEF);
  reader6700->definitionModule = modulename;
  reader6700->definitionLine = 1549;
}
adddatum2(obj6696, alloc_Undefined(), 3);
if (objclass6696 == NULL) {
  Method *reader6701 = addmethodrealflags(obj6696, "dtype",&reader_ast_dtype_6701, 0);
  Method *writer6701 = addmethodrealflags(obj6696, "dtype:=",&writer_ast_dtype_6701, 0);
  reader6701->definitionModule = modulename;
  writer6701->definitionModule = modulename;
  reader6701->definitionLine = 1550;
  writer6701->definitionLine = 1550;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 4);
if (objclass6696 == NULL) {
  Method *reader6702 = addmethodrealflags(obj6696, "annotations",&reader_ast_annotations_6702, MFLAG_DEF);
  reader6702->definitionModule = modulename;
  reader6702->definitionLine = 1551;
}
adddatum2(obj6696, alloc_Undefined(), 5);
if (objclass6696 == NULL) {
  Method *reader6703 = addmethodrealflags(obj6696, "data",&reader_ast_data_6703, 0);
  Method *writer6703 = addmethodrealflags(obj6696, "data:=",&writer_ast_data_6703, 0);
  reader6703->definitionModule = modulename;
  writer6703->definitionModule = modulename;
  reader6703->definitionLine = 1552;
  writer6703->definitionLine = 1552;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 6);
if (objclass6696 == NULL) {
  Method *reader6704 = addmethodrealflags(obj6696, "startToken",&reader_ast_startToken_6704, 0);
  Method *writer6704 = addmethodrealflags(obj6696, "startToken:=",&writer_ast_startToken_6704, 0);
  reader6704->definitionModule = modulename;
  writer6704->definitionModule = modulename;
  reader6704->definitionLine = 1553;
  writer6704->definitionLine = 1553;
}
obj6696->flags |= OFLAG_MUTABLE;
adddatum2(obj6696, alloc_Undefined(), 7);
  struct UserObject *uo6705 = (struct UserObject*)obj6696;
  uo6705->data[8] = emptyclosure;
  Method *meth_meth_ast_accept6705 = addmethod2pos(obj6696, "accept", &meth_ast_accept6705, 8);
int argcv_meth_ast_accept6705[] = {1};
meth_meth_ast_accept6705->type = alloc_MethodType(1, argcv_meth_ast_accept6705);
meth_meth_ast_accept6705->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept6705->type->names[0] = "visitor";
  meth_meth_ast_accept6705->definitionModule = modulename;
  meth_meth_ast_accept6705->definitionLine = 1553;
  block_savedest(obj6696);
  Object closure6735 = createclosure(1, "map()before()after");
setclosureframe(closure6735, stackframe);
  addtoclosure(closure6735, var_defDecNode);
  struct UserObject *uo6735 = (struct UserObject*)obj6696;
  uo6735->data[9] = (Object)closure6735;
  Method *meth_meth_ast_map_40__41_before_40__41_after6735 = addmethod2pos(obj6696, "map()before()after", &meth_ast_map_40__41_before_40__41_after6735, 9);
int argcv_meth_ast_map_40__41_before_40__41_after6735[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after6735->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after6735);
  meth_meth_ast_map_40__41_before_40__41_after6735->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after6735->definitionLine = 1564;
  struct UserObject *uo6782 = (struct UserObject*)obj6696;
  uo6782->data[10] = emptyclosure;
  Method *meth_meth_ast_map6782 = addmethod2pos(obj6696, "map", &meth_ast_map6782, 10);
int argcv_meth_ast_map6782[] = {1};
meth_meth_ast_map6782->type = alloc_MethodType(1, argcv_meth_ast_map6782);
  meth_meth_ast_map6782->definitionModule = modulename;
  meth_meth_ast_map6782->definitionLine = 1576;
  struct UserObject *uo6791 = (struct UserObject*)obj6696;
  uo6791->data[11] = emptyclosure;
  Method *meth_meth_ast_pretty6791 = addmethod2pos(obj6696, "pretty", &meth_ast_pretty6791, 11);
int argcv_meth_ast_pretty6791[] = {1};
meth_meth_ast_pretty6791->type = alloc_MethodType(1, argcv_meth_ast_pretty6791);
  meth_meth_ast_pretty6791->definitionModule = modulename;
  meth_meth_ast_pretty6791->definitionLine = 1579;
  block_savedest(obj6696);
  Object closure6893 = createclosure(1, "decType");
setclosureframe(closure6893, stackframe);
  addtoclosure(closure6893, var_identifierNode);
  struct UserObject *uo6893 = (struct UserObject*)obj6696;
  uo6893->data[12] = (Object)closure6893;
  Method *meth_meth_ast_decType6893 = addmethod2pos(obj6696, "decType", &meth_ast_decType6893, 12);
int argcv_meth_ast_decType6893[] = {0};
meth_meth_ast_decType6893->type = alloc_MethodType(1, argcv_meth_ast_decType6893);
  meth_meth_ast_decType6893->definitionModule = modulename;
  meth_meth_ast_decType6893->definitionLine = 1597;
  struct UserObject *uo6907 = (struct UserObject*)obj6696;
  uo6907->data[13] = emptyclosure;
  Method *meth_meth_ast_toGrace6907 = addmethod2pos(obj6696, "toGrace", &meth_ast_toGrace6907, 13);
int argcv_meth_ast_toGrace6907[] = {1};
meth_meth_ast_toGrace6907->type = alloc_MethodType(1, argcv_meth_ast_toGrace6907);
meth_meth_ast_toGrace6907->type->types[0] = type_Number;
meth_meth_ast_toGrace6907->type->names[0] = "depth";
  meth_meth_ast_toGrace6907->definitionModule = modulename;
  meth_meth_ast_toGrace6907->definitionLine = 1603;
  sourceObject = obj6696;
// Begin line 1545
  setline(1545);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7023 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7024 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7023);
// compilenode returning call7024
  struct UserObject *obj6696_uo = (struct UserObject *)obj6696;
  obj6696_uo->super = call7024;
  sourceObject = obj6696;
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7025 == NULL) {
    strlit7025 = alloc_String("defdec");
    gc_root(strlit7025);
  }
// compilenode returning strlit7025
  adddatum2(obj6696, strlit7025, 1);
  sourceObject = obj6696;
// Begin line 1547
  setline(1547);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj6696, *var_name_39_, 2);
  sourceObject = obj6696;
// Begin line 1548
  setline(1548);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val
  adddatum2(obj6696, *var_val, 3);
  sourceObject = obj6696;
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj6696, *var_dtype_39_, 4);
  sourceObject = obj6696;
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7026 = gc_frame_new();
  int callframe7027 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7028 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7027);
// compilenode returning call7028
// compilenode returning call7028
  partcv[0] = 0;
  Object call7029 = callmethod(call7028, "new",
    1, partcv, params);
  gc_frame_end(callframe7026);
// compilenode returning call7029
// compilenode returning call7029
  adddatum2(obj6696, call7029, 5);
  sourceObject = obj6696;
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7030 = alloc_Boolean(0);
// compilenode returning bool7030
  adddatum2(obj6696, bool7030, 6);
  sourceObject = obj6696;
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7031 = alloc_Boolean(0);
// compilenode returning bool7031
  adddatum2(obj6696, bool7031, 7);
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
  sourceObject = obj6696;
objclass6696 = obj6696->class;
  objclass6696->definitionModule = modulename;
  objclass6696->definitionLine = 1540;
  (*(struct UserObject *)self).data[0] = lowerouter6696;
  self = oldself6696;
  selfslot = oldselfslot6696;
  stackframe = oldstackframe6696;
  gc_frame_end(frame);
  return obj6696;
}
Object meth_ast_varDecNode7033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "varDecNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for varDecNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for varDecNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varDecNode
  gc_frame_end(frame);
  return *var_varDecNode;
}
Object meth_ast_accept7044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1640
  setline(1640);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7046 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7047 = callmethod(*var_visitor, "visitVarDec",
    1, partcv, params);
  gc_frame_end(callframe7046);
// compilenode returning call7047
  Object if7045 = done;
  if (istrue(call7047)) {
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7048 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7049 = gc_frame_new();
  partcv[0] = 0;
  Object call7050 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7049);
// compilenode returning call7050
// compilenode returning call7050
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7051 = callmethod(call7050, "accept",
    1, partcv, params);
  gc_frame_end(callframe7048);
// compilenode returning call7051
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7054 = alloc_Boolean(0);
// compilenode returning bool7054
  int op_slot_right_7053 = gc_frame_newslot(bool7054);
  int callframe7056 = gc_frame_new();
  partcv[0] = 0;
  Object call7057 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7056);
// compilenode returning call7057
// compilenode returning call7057
  int op_slot_left_7053 = gc_frame_newslot(call7057);
  params[0] = bool7054;
  partcv[0] = 1;
  Object opresult7058 = callmethod(call7057, "!=", 1, partcv, params);
// compilenode returning opresult7058
  Object if7052 = done;
  if (istrue(opresult7058)) {
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7059 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7060 = gc_frame_new();
  partcv[0] = 0;
  Object call7061 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7060);
// compilenode returning call7061
// compilenode returning call7061
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7062 = callmethod(call7061, "accept",
    1, partcv, params);
  gc_frame_end(callframe7059);
// compilenode returning call7062
    gc_frame_newslot(call7062);
    if7052 = call7062;
  } else {
  }
// compilenode returning if7052
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1636
  setline(1636);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7065 = alloc_Boolean(0);
// compilenode returning bool7065
  int op_slot_right_7064 = gc_frame_newslot(bool7065);
  int callframe7067 = gc_frame_new();
  partcv[0] = 0;
  Object call7068 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7067);
// compilenode returning call7068
// compilenode returning call7068
  int op_slot_left_7064 = gc_frame_newslot(call7068);
  params[0] = bool7065;
  partcv[0] = 1;
  Object opresult7069 = callmethod(call7068, "!=", 1, partcv, params);
// compilenode returning opresult7069
  Object if7063 = done;
  if (istrue(opresult7069)) {
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7070 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7071 = gc_frame_new();
  partcv[0] = 0;
  Object call7072 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7071);
// compilenode returning call7072
// compilenode returning call7072
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7073 = callmethod(call7072, "accept",
    1, partcv, params);
  gc_frame_end(callframe7070);
// compilenode returning call7073
    gc_frame_newslot(call7073);
    if7063 = call7073;
  } else {
  }
// compilenode returning if7063
    gc_frame_newslot(if7063);
    if7045 = if7063;
  } else {
  }
// compilenode returning if7045
  gc_frame_end(frame);
  return if7045;
}
Object meth_ast__apply7107(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_blk = getfromclosure(closure, 0);
  Object *var_blkBefore = getfromclosure(closure, 1);
  Object *var_blkAfter = getfromclosure(closure, 2);
  Object *var_n = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7108 = gc_frame_new();
  int callframe7109 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// compilenode returning *var_a
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7110 = callmethod(*var_a, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7109);
// compilenode returning call7110
  gc_frame_newslot(call7110);
  int callframe7111 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call7112 = callmethod(*var_n, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7111);
// compilenode returning call7112
// compilenode returning call7112
  params[0] = call7110;
  partcv[0] = 1;
  Object call7113 = callmethod(call7112, "push",
    1, partcv, params);
  gc_frame_end(callframe7108);
// compilenode returning call7113
  gc_frame_end(frame);
  return call7113;
}
Object meth_ast_map_40__41_before_40__41_after7074(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_varDecNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7075 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7076 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7075);
// compilenode returning call7076
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7077 = gc_frame_new();
  int callframe7078 = gc_frame_new();
  partcv[0] = 0;
  Object call7079 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7078);
// compilenode returning call7079
  gc_frame_newslot(call7079);
  int callframe7080 = gc_frame_new();
  int callframe7081 = gc_frame_new();
  partcv[0] = 0;
  Object call7082 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7081);
// compilenode returning call7082
  gc_frame_newslot(call7082);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7083 = gc_frame_new();
  int callframe7084 = gc_frame_new();
  Object call7085 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7084);
// compilenode returning call7085
// compilenode returning call7085
  partcv[0] = 0;
  Object call7086 = callmethodflags(call7085, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7083);
// compilenode returning call7086
// compilenode returning call7086
  params[0] = call7082;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call7087 = callmethodflags(call7086, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7080);
// compilenode returning call7087
  gc_frame_newslot(call7087);
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7088 = gc_frame_new();
  int callframe7089 = gc_frame_new();
  partcv[0] = 0;
  Object call7090 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7089);
// compilenode returning call7090
  gc_frame_newslot(call7090);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7091 = gc_frame_new();
  int callframe7092 = gc_frame_new();
  Object call7093 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7092);
// compilenode returning call7093
// compilenode returning call7093
  partcv[0] = 0;
  Object call7094 = callmethodflags(call7093, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7091);
// compilenode returning call7094
// compilenode returning call7094
  params[0] = call7090;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 4;
  Object call7095 = callmethodflags(call7094, "maybeMap", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7088);
// compilenode returning call7095
  gc_frame_newslot(call7095);
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varDecNode
  params[0] = call7079;
  params[1] = call7087;
  params[2] = call7095;
  partcv[0] = 3;
  Object call7096 = callmethod(*var_varDecNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7077);
// compilenode returning call7096
  *var_n = call7096;
  if (call7096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7097 = gc_frame_new();
  int callframe7098 = gc_frame_new();
  int callframe7099 = gc_frame_new();
  partcv[0] = 0;
  Object call7100 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7099);
// compilenode returning call7100
  gc_frame_newslot(call7100);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7101 = gc_frame_new();
  int callframe7102 = gc_frame_new();
  Object call7103 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7102);
// compilenode returning call7103
// compilenode returning call7103
  partcv[0] = 0;
  Object call7104 = callmethodflags(call7103, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7101);
// compilenode returning call7104
// compilenode returning call7104
  params[0] = call7100;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7105 = callmethodflags(call7104, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7098);
// compilenode returning call7105
  gc_frame_newslot(call7105);
  Object block7106 = alloc_Block(NULL, NULL, "ast", 1646);
  gc_frame_newslot(block7106);
  block_savedest(block7106);
  Object closure7107 = createclosure(5, "_apply");
setclosureframe(closure7107, stackframe);
  addtoclosure(closure7107, var_blk);
  addtoclosure(closure7107, var_blkBefore);
  addtoclosure(closure7107, var_blkAfter);
  addtoclosure(closure7107, var_n);
  addtoclosure(closure7107, selfslot);
  struct UserObject *uo7107 = (struct UserObject*)block7106;
  uo7107->data[0] = (Object)closure7107;
  Method *meth_meth_ast__apply7107 = addmethod2pos(block7106, "_apply", &meth_ast__apply7107, 0);
int argcv_meth_ast__apply7107[] = {1};
meth_meth_ast__apply7107->type = alloc_MethodType(1, argcv_meth_ast__apply7107);
  meth_meth_ast__apply7107->definitionModule = modulename;
  meth_meth_ast__apply7107->definitionLine = 1646;
// compilenode returning block7106
  gc_frame_newslot(block7106);
  params[0] = call7105;
  params[1] = block7106;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7115 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7097);
// compilenode returning call7115
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7116 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7117 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7116);
// compilenode returning call7117
  *var_n = call7117;
  if (call7117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7119 = gc_frame_new();
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7120 = gc_frame_new();
  partcv[0] = 0;
  Object call7121 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7120);
// compilenode returning call7121
  gc_frame_newslot(call7121);
// compilenode returning *var_n
  params[0] = call7121;
  partcv[0] = 1;
  Object call7122 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7119);
// compilenode returning call7122
// compilenode returning done
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7123 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7124 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7123);
// compilenode returning call7124
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7128(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7131(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7125(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7126 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7127 = alloc_Block(NULL, NULL, "ast", 1655);
  gc_frame_newslot(block7127);
  block_savedest(block7127);
  Object closure7128 = createclosure(1, "_apply");
setclosureframe(closure7128, stackframe);
  addtoclosure(closure7128, selfslot);
  struct UserObject *uo7128 = (struct UserObject*)block7127;
  uo7128->data[0] = (Object)closure7128;
  Method *meth_meth_ast__apply7128 = addmethod2pos(block7127, "_apply", &meth_ast__apply7128, 0);
int argcv_meth_ast__apply7128[] = {0};
meth_meth_ast__apply7128->type = alloc_MethodType(1, argcv_meth_ast__apply7128);
  meth_meth_ast__apply7128->definitionModule = modulename;
  meth_meth_ast__apply7128->definitionLine = 1647;
// compilenode returning block7127
  gc_frame_newslot(block7127);
  Object block7130 = alloc_Block(NULL, NULL, "ast", 1655);
  gc_frame_newslot(block7130);
  block_savedest(block7130);
  Object closure7131 = createclosure(1, "_apply");
setclosureframe(closure7131, stackframe);
  addtoclosure(closure7131, selfslot);
  struct UserObject *uo7131 = (struct UserObject*)block7130;
  uo7131->data[0] = (Object)closure7131;
  Method *meth_meth_ast__apply7131 = addmethod2pos(block7130, "_apply", &meth_ast__apply7131, 0);
int argcv_meth_ast__apply7131[] = {0};
meth_meth_ast__apply7131->type = alloc_MethodType(1, argcv_meth_ast__apply7131);
  meth_meth_ast__apply7131->definitionModule = modulename;
  meth_meth_ast__apply7131->definitionLine = 1647;
// compilenode returning block7130
  gc_frame_newslot(block7130);
  params[0] = *var_blk;
  params[1] = block7127;
  params[2] = block7130;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7133 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7126);
// compilenode returning call7133
  gc_frame_end(frame);
  return call7133;
}
Object meth_ast__apply7142(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7144 == NULL) {
    strlit7144 = alloc_String("  ");
    gc_root(strlit7144);
  }
// compilenode returning strlit7144
  int op_slot_right_7143 = gc_frame_newslot(strlit7144);
// compilenode returning *var_spc
  int op_slot_left_7143 = gc_frame_newslot(*var_spc);
  params[0] = strlit7144;
  partcv[0] = 1;
  Object opresult7146 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7146
  *var_spc = opresult7146;
  if (opresult7146 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7135 == NULL) {
    strlit7135 = alloc_String("");
    gc_root(strlit7135);
  }
// compilenode returning strlit7135
  *var_spc = strlit7135;
  if (strlit7135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7136 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7137 = gc_frame_newslot(*var_depth);
  Object num7139 = alloc_Float64(0);
// compilenode returning num7139
  int op_slot_left_7137 = gc_frame_newslot(num7139);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7140 = callmethod(num7139, "..", 1, partcv, params);
// compilenode returning opresult7140
  gc_frame_newslot(opresult7140);
  Object block7141 = alloc_Block(NULL, NULL, "ast", 1659);
  gc_frame_newslot(block7141);
  block_savedest(block7141);
  Object closure7142 = createclosure(2, "_apply");
setclosureframe(closure7142, stackframe);
  addtoclosure(closure7142, var_spc);
  addtoclosure(closure7142, selfslot);
  struct UserObject *uo7142 = (struct UserObject*)block7141;
  uo7142->data[0] = (Object)closure7142;
  Method *meth_meth_ast__apply7142 = addmethod2pos(block7141, "_apply", &meth_ast__apply7142, 0);
int argcv_meth_ast__apply7142[] = {1};
meth_meth_ast__apply7142->type = alloc_MethodType(1, argcv_meth_ast__apply7142);
  meth_meth_ast__apply7142->definitionModule = modulename;
  meth_meth_ast__apply7142->definitionLine = 1647;
// compilenode returning block7141
  gc_frame_newslot(block7141);
  params[0] = opresult7140;
  params[1] = block7141;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7149 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7136);
// compilenode returning call7149
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7150 == NULL) {
    strlit7150 = alloc_String("VarDec");
    gc_root(strlit7150);
  }
// compilenode returning strlit7150
  *var_s = strlit7150;
  if (strlit7150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7152 == NULL) {
    strlit7152 = alloc_String("""\x0a""");
    gc_root(strlit7152);
  }
// compilenode returning strlit7152
  int op_slot_right_7151 = gc_frame_newslot(strlit7152);
// compilenode returning *var_s
  int op_slot_left_7151 = gc_frame_newslot(*var_s);
  params[0] = strlit7152;
  partcv[0] = 1;
  Object opresult7154 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7154
  *var_s = opresult7154;
  if (opresult7154 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7157 = gc_frame_new();
  Object num7159 = alloc_Float64(1);
// compilenode returning num7159
  int op_slot_right_7158 = gc_frame_newslot(num7159);
// compilenode returning *var_depth
  int op_slot_left_7158 = gc_frame_newslot(*var_depth);
  params[0] = num7159;
  partcv[0] = 1;
  Object sum7161 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7161
  gc_frame_newslot(sum7161);
  int callframe7162 = gc_frame_new();
  partcv[0] = 0;
  Object call7163 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7162);
// compilenode returning call7163
// compilenode returning call7163
  params[0] = sum7161;
  partcv[0] = 1;
  Object call7164 = callmethod(call7163, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7157);
// compilenode returning call7164
  int op_slot_right_7156 = gc_frame_newslot(call7164);
// compilenode returning *var_spc
  int op_slot_right_7166 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7166 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7168 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7168
  int op_slot_left_7156 = gc_frame_newslot(opresult7168);
  params[0] = call7164;
  partcv[0] = 1;
  Object opresult7169 = callmethod(opresult7168, "++", 1, partcv, params);
// compilenode returning opresult7169
  *var_s = opresult7169;
  if (opresult7169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7173 = alloc_Boolean(0);
// compilenode returning bool7173
  int op_slot_right_7172 = gc_frame_newslot(bool7173);
  int callframe7175 = gc_frame_new();
  partcv[0] = 0;
  Object call7176 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7175);
// compilenode returning call7176
// compilenode returning call7176
  int op_slot_left_7172 = gc_frame_newslot(call7176);
  params[0] = bool7173;
  partcv[0] = 1;
  Object opresult7177 = callmethod(call7176, "!=", 1, partcv, params);
// compilenode returning opresult7177
  Object if7171 = done;
  if (istrue(opresult7177)) {
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7179 == NULL) {
    strlit7179 = alloc_String("Type:");
    gc_root(strlit7179);
  }
// compilenode returning strlit7179
  int op_slot_right_7178 = gc_frame_newslot(strlit7179);
// compilenode returning *var_spc
  int op_slot_right_7181 = gc_frame_newslot(*var_spc);
  if (strlit7184 == NULL) {
    strlit7184 = alloc_String("""\x0a""");
    gc_root(strlit7184);
  }
// compilenode returning strlit7184
  int op_slot_right_7183 = gc_frame_newslot(strlit7184);
// compilenode returning *var_s
  int op_slot_left_7183 = gc_frame_newslot(*var_s);
  params[0] = strlit7184;
  partcv[0] = 1;
  Object opresult7186 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7186
  int op_slot_left_7181 = gc_frame_newslot(opresult7186);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7187 = callmethod(opresult7186, "++", 1, partcv, params);
// compilenode returning opresult7187
  int op_slot_left_7178 = gc_frame_newslot(opresult7187);
  params[0] = strlit7179;
  partcv[0] = 1;
  Object opresult7188 = callmethod(opresult7187, "++", 1, partcv, params);
// compilenode returning opresult7188
  *var_s = opresult7188;
  if (opresult7188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7191 = gc_frame_new();
  Object num7193 = alloc_Float64(2);
// compilenode returning num7193
  int op_slot_right_7192 = gc_frame_newslot(num7193);
// compilenode returning *var_depth
  int op_slot_left_7192 = gc_frame_newslot(*var_depth);
  params[0] = num7193;
  partcv[0] = 1;
  Object sum7195 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7195
  gc_frame_newslot(sum7195);
  int callframe7196 = gc_frame_new();
  partcv[0] = 0;
  Object call7197 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7196);
// compilenode returning call7197
// compilenode returning call7197
  params[0] = sum7195;
  partcv[0] = 1;
  Object call7198 = callmethod(call7197, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7191);
// compilenode returning call7198
  int op_slot_right_7190 = gc_frame_newslot(call7198);
  if (strlit7201 == NULL) {
    strlit7201 = alloc_String("  ");
    gc_root(strlit7201);
  }
// compilenode returning strlit7201
  int op_slot_right_7200 = gc_frame_newslot(strlit7201);
// compilenode returning *var_spc
  int op_slot_right_7203 = gc_frame_newslot(*var_spc);
  if (strlit7206 == NULL) {
    strlit7206 = alloc_String("""\x0a""");
    gc_root(strlit7206);
  }
// compilenode returning strlit7206
  int op_slot_right_7205 = gc_frame_newslot(strlit7206);
// compilenode returning *var_s
  int op_slot_left_7205 = gc_frame_newslot(*var_s);
  params[0] = strlit7206;
  partcv[0] = 1;
  Object opresult7208 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7208
  int op_slot_left_7203 = gc_frame_newslot(opresult7208);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7209 = callmethod(opresult7208, "++", 1, partcv, params);
// compilenode returning opresult7209
  int op_slot_left_7200 = gc_frame_newslot(opresult7209);
  params[0] = strlit7201;
  partcv[0] = 1;
  Object opresult7210 = callmethod(opresult7209, "++", 1, partcv, params);
// compilenode returning opresult7210
  int op_slot_left_7190 = gc_frame_newslot(opresult7210);
  params[0] = call7198;
  partcv[0] = 1;
  Object opresult7211 = callmethod(opresult7210, "++", 1, partcv, params);
// compilenode returning opresult7211
  *var_s = opresult7211;
  if (opresult7211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7171 = done;
  } else {
  }
// compilenode returning if7171
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7215 = gc_frame_new();
  partcv[0] = 0;
  Object call7216 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7215);
// compilenode returning call7216
// compilenode returning call7216
  int op_slot_right_7214 = gc_frame_newslot(call7216);
  Object bool7218 = alloc_Boolean(0);
// compilenode returning bool7218
  int op_slot_left_7214 = gc_frame_newslot(bool7218);
  params[0] = call7216;
  partcv[0] = 1;
  Object opresult7219 = callmethod(bool7218, "!=", 1, partcv, params);
// compilenode returning opresult7219
  Object if7213 = done;
  if (istrue(opresult7219)) {
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7221 == NULL) {
    strlit7221 = alloc_String("""\x0a""");
    gc_root(strlit7221);
  }
// compilenode returning strlit7221
  int op_slot_right_7220 = gc_frame_newslot(strlit7221);
// compilenode returning *var_s
  int op_slot_left_7220 = gc_frame_newslot(*var_s);
  params[0] = strlit7221;
  partcv[0] = 1;
  Object opresult7223 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7223
  *var_s = opresult7223;
  if (opresult7223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7226 = gc_frame_new();
  Object num7228 = alloc_Float64(1);
// compilenode returning num7228
  int op_slot_right_7227 = gc_frame_newslot(num7228);
// compilenode returning *var_depth
  int op_slot_left_7227 = gc_frame_newslot(*var_depth);
  params[0] = num7228;
  partcv[0] = 1;
  Object sum7230 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7230
  gc_frame_newslot(sum7230);
  int callframe7231 = gc_frame_new();
  partcv[0] = 0;
  Object call7232 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7231);
// compilenode returning call7232
// compilenode returning call7232
  params[0] = sum7230;
  partcv[0] = 1;
  Object call7233 = callmethod(call7232, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7226);
// compilenode returning call7233
  int op_slot_right_7225 = gc_frame_newslot(call7233);
// compilenode returning *var_spc
  int op_slot_right_7235 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7235 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7237 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7237
  int op_slot_left_7225 = gc_frame_newslot(opresult7237);
  params[0] = call7233;
  partcv[0] = 1;
  Object opresult7238 = callmethod(opresult7237, "++", 1, partcv, params);
// compilenode returning opresult7238
  *var_s = opresult7238;
  if (opresult7238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7213 = done;
  } else {
  }
// compilenode returning if7213
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_decType7240(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "decType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_identifierNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for decType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for decType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1676
  setline(1676);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7243 = alloc_Boolean(0);
// compilenode returning bool7243
  int op_slot_right_7242 = gc_frame_newslot(bool7243);
  int callframe7245 = gc_frame_new();
  partcv[0] = 0;
  Object call7246 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7245);
// compilenode returning call7246
  int op_slot_left_7242 = gc_frame_newslot(call7246);
  params[0] = bool7243;
  partcv[0] = 1;
  Object opresult7247 = callmethod(call7246, "==", 1, partcv, params);
// compilenode returning opresult7247
  Object if7241 = done;
  if (istrue(opresult7247)) {
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7248 = gc_frame_new();
  if (strlit7249 == NULL) {
    strlit7249 = alloc_String("Unknown");
    gc_root(strlit7249);
  }
// compilenode returning strlit7249
  gc_frame_newslot(strlit7249);
  Object bool7250 = alloc_Boolean(0);
// compilenode returning bool7250
  gc_frame_newslot(bool7250);
// compilenode returning *var_identifierNode
  params[0] = strlit7249;
  params[1] = bool7250;
  partcv[0] = 2;
  Object call7251 = callmethod(*var_identifierNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7248);
// compilenode returning call7251
  return call7251;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if7241 = undefined;
  } else {
  }
// compilenode returning if7241
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1679
  setline(1679);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7252 = gc_frame_new();
  partcv[0] = 0;
  Object call7253 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7252);
// compilenode returning call7253
  return call7253;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_ast__apply7266(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7268 == NULL) {
    strlit7268 = alloc_String("    ");
    gc_root(strlit7268);
  }
// compilenode returning strlit7268
  int op_slot_right_7267 = gc_frame_newslot(strlit7268);
// compilenode returning *var_spc
  int op_slot_left_7267 = gc_frame_newslot(*var_spc);
  params[0] = strlit7268;
  partcv[0] = 1;
  Object opresult7270 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7270
  *var_spc = opresult7270;
  if (opresult7270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7329 = gc_frame_new();
  Object num7330 = alloc_Float64(0);
// compilenode returning num7330
  gc_frame_newslot(num7330);
// compilenode returning *var_b
  params[0] = num7330;
  partcv[0] = 1;
  Object call7331 = callmethod(*var_b, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7329);
// compilenode returning call7331
  int op_slot_right_7328 = gc_frame_newslot(call7331);
  if (strlit7335 == NULL) {
    strlit7335 = alloc_String("");
    gc_root(strlit7335);
  }
// compilenode returning strlit7335
  int op_slot_right_7334 = gc_frame_newslot(strlit7335);
// compilenode returning *var_a
  int op_slot_left_7334 = gc_frame_newslot(*var_a);
  params[0] = strlit7335;
  partcv[0] = 1;
  Object opresult7337 = callmethod(*var_a, "!=", 1, partcv, params);
// compilenode returning opresult7337
  Object if7333 = done;
struct StackFrameObject *iftmpstackframe7333 = stackframe;
  if (istrue(opresult7337)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7333);
gc_frame_newslot((Object)stackframe);
  if (strlit7339 == NULL) {
    strlit7339 = alloc_String(", ");
    gc_root(strlit7339);
  }
// compilenode returning strlit7339
  int op_slot_right_7338 = gc_frame_newslot(strlit7339);
// compilenode returning *var_a
  int op_slot_left_7338 = gc_frame_newslot(*var_a);
  params[0] = strlit7339;
  partcv[0] = 1;
  Object opresult7341 = callmethod(*var_a, "++", 1, partcv, params);
// compilenode returning opresult7341
    gc_frame_newslot(opresult7341);
    if7333 = opresult7341;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe7333);
gc_frame_newslot((Object)stackframe);
  if (strlit7342 == NULL) {
    strlit7342 = alloc_String("");
    gc_root(strlit7342);
  }
// compilenode returning strlit7342
    gc_frame_newslot(strlit7342);
    if7333 = strlit7342;
  }
stackframe = iftmpstackframe7333;
// compilenode returning if7333
  int op_slot_left_7328 = gc_frame_newslot(if7333);
  params[0] = call7331;
  partcv[0] = 1;
  Object opresult7343 = callmethod(if7333, "++", 1, partcv, params);
// compilenode returning opresult7343
  gc_frame_end(frame);
  return opresult7343;
}
Object meth_ast_toGrace7254(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7255 == NULL) {
    strlit7255 = alloc_String("");
    gc_root(strlit7255);
  }
// compilenode returning strlit7255
  *var_spc = strlit7255;
  if (strlit7255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7256 = gc_frame_new();
  Object num7259 = alloc_Float64(1);
// compilenode returning num7259
  int op_slot_right_7258 = gc_frame_newslot(num7259);
// compilenode returning *var_depth
  int op_slot_left_7258 = gc_frame_newslot(*var_depth);
  params[0] = num7259;
  partcv[0] = 1;
  Object diff7261 = callmethod(*var_depth, "-", 1, partcv, params);
// compilenode returning diff7261
  int op_slot_right_7257 = gc_frame_newslot(diff7261);
  Object num7263 = alloc_Float64(0);
// compilenode returning num7263
  int op_slot_left_7257 = gc_frame_newslot(num7263);
  params[0] = diff7261;
  partcv[0] = 1;
  Object opresult7264 = callmethod(num7263, "..", 1, partcv, params);
// compilenode returning opresult7264
  gc_frame_newslot(opresult7264);
  Object block7265 = alloc_Block(NULL, NULL, "ast", 1683);
  gc_frame_newslot(block7265);
  block_savedest(block7265);
  Object closure7266 = createclosure(2, "_apply");
setclosureframe(closure7266, stackframe);
  addtoclosure(closure7266, var_spc);
  addtoclosure(closure7266, selfslot);
  struct UserObject *uo7266 = (struct UserObject*)block7265;
  uo7266->data[0] = (Object)closure7266;
  Method *meth_meth_ast__apply7266 = addmethod2pos(block7265, "_apply", &meth_ast__apply7266, 0);
int argcv_meth_ast__apply7266[] = {1};
meth_meth_ast__apply7266->type = alloc_MethodType(1, argcv_meth_ast__apply7266);
  meth_meth_ast__apply7266->definitionModule = modulename;
  meth_meth_ast__apply7266->definitionLine = 1671;
// compilenode returning block7265
  gc_frame_newslot(block7265);
  params[0] = opresult7264;
  params[1] = block7265;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7273 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7256);
// compilenode returning call7273
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7275 == NULL) {
    strlit7275 = alloc_String("");
    gc_root(strlit7275);
  }
// compilenode returning strlit7275
  int op_slot_right_7274 = gc_frame_newslot(strlit7275);
  int callframe7278 = gc_frame_new();
  Object num7279 = alloc_Float64(0);
// compilenode returning num7279
  gc_frame_newslot(num7279);
  int callframe7280 = gc_frame_new();
  partcv[0] = 0;
  Object call7281 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7280);
// compilenode returning call7281
// compilenode returning call7281
  params[0] = num7279;
  partcv[0] = 1;
  Object call7282 = callmethod(call7281, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7278);
// compilenode returning call7282
  int op_slot_right_7277 = gc_frame_newslot(call7282);
  if (strlit7284 == NULL) {
    strlit7284 = alloc_String("var ");
    gc_root(strlit7284);
  }
// compilenode returning strlit7284
  int op_slot_left_7277 = gc_frame_newslot(strlit7284);
  params[0] = call7282;
  partcv[0] = 1;
  Object opresult7285 = callmethod(strlit7284, "++", 1, partcv, params);
// compilenode returning opresult7285
  int op_slot_left_7274 = gc_frame_newslot(opresult7285);
  params[0] = strlit7275;
  partcv[0] = 1;
  Object opresult7286 = callmethod(opresult7285, "++", 1, partcv, params);
// compilenode returning opresult7286
  *var_s = opresult7286;
  if (opresult7286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7289 == NULL) {
    strlit7289 = alloc_String("Unknown");
    gc_root(strlit7289);
  }
// compilenode returning strlit7289
  int op_slot_right_7288 = gc_frame_newslot(strlit7289);
  int callframe7291 = gc_frame_new();
  int callframe7292 = gc_frame_new();
  partcv[0] = 0;
  Object call7293 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7292);
// compilenode returning call7293
// compilenode returning call7293
  partcv[0] = 0;
  Object call7294 = callmethod(call7293, "value",
    1, partcv, params);
  gc_frame_end(callframe7291);
// compilenode returning call7294
// compilenode returning call7294
  int op_slot_left_7288 = gc_frame_newslot(call7294);
  params[0] = strlit7289;
  partcv[0] = 1;
  Object opresult7295 = callmethod(call7294, "!=", 1, partcv, params);
// compilenode returning opresult7295
  Object if7287 = done;
  if (istrue(opresult7295)) {
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7297 = gc_frame_new();
  Object num7298 = alloc_Float64(0);
// compilenode returning num7298
  gc_frame_newslot(num7298);
  int callframe7299 = gc_frame_new();
  partcv[0] = 0;
  Object call7300 = callmethodflags(self, "dtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7299);
// compilenode returning call7300
// compilenode returning call7300
  params[0] = num7298;
  partcv[0] = 1;
  Object call7301 = callmethod(call7300, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7297);
// compilenode returning call7301
  int op_slot_right_7296 = gc_frame_newslot(call7301);
  if (strlit7304 == NULL) {
    strlit7304 = alloc_String(" : ");
    gc_root(strlit7304);
  }
// compilenode returning strlit7304
  int op_slot_right_7303 = gc_frame_newslot(strlit7304);
// compilenode returning *var_s
  int op_slot_left_7303 = gc_frame_newslot(*var_s);
  params[0] = strlit7304;
  partcv[0] = 1;
  Object opresult7306 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7306
  int op_slot_left_7296 = gc_frame_newslot(opresult7306);
  params[0] = call7301;
  partcv[0] = 1;
  Object opresult7307 = callmethod(opresult7306, "++", 1, partcv, params);
// compilenode returning opresult7307
  *var_s = opresult7307;
  if (opresult7307 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7287 = done;
  } else {
  }
// compilenode returning if7287
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1690
  setline(1690);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7311 = alloc_Float64(0);
// compilenode returning num7311
  int op_slot_right_7310 = gc_frame_newslot(num7311);
  int callframe7313 = gc_frame_new();
  int callframe7314 = gc_frame_new();
  partcv[0] = 0;
  Object call7315 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7314);
// compilenode returning call7315
// compilenode returning call7315
  partcv[0] = 0;
  Object call7316 = callmethod(call7315, "size",
    1, partcv, params);
  gc_frame_end(callframe7313);
// compilenode returning call7316
// compilenode returning call7316
  int op_slot_left_7310 = gc_frame_newslot(call7316);
  params[0] = num7311;
  partcv[0] = 1;
  Object opresult7317 = callmethod(call7316, ">", 1, partcv, params);
// compilenode returning opresult7317
  Object if7309 = done;
  if (istrue(opresult7317)) {
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7319 == NULL) {
    strlit7319 = alloc_String(" is ");
    gc_root(strlit7319);
  }
// compilenode returning strlit7319
  int op_slot_right_7318 = gc_frame_newslot(strlit7319);
// compilenode returning *var_s
  int op_slot_left_7318 = gc_frame_newslot(*var_s);
  params[0] = strlit7319;
  partcv[0] = 1;
  Object opresult7321 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7321
  *var_s = opresult7321;
  if (opresult7321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7324 = gc_frame_new();
  if (strlit7325 == NULL) {
    strlit7325 = alloc_String("");
    gc_root(strlit7325);
  }
// compilenode returning strlit7325
  gc_frame_newslot(strlit7325);
  Object block7326 = alloc_Block(NULL, NULL, "ast", 1692);
  gc_frame_newslot(block7326);
  block_savedest(block7326);
  Object closure7327 = createclosure(1, "_apply");
setclosureframe(closure7327, stackframe);
  addtoclosure(closure7327, selfslot);
  struct UserObject *uo7327 = (struct UserObject*)block7326;
  uo7327->data[0] = (Object)closure7327;
  Method *meth_meth_ast__apply7327 = addmethod2pos(block7326, "_apply", &meth_ast__apply7327, 0);
int argcv_meth_ast__apply7327[] = {2};
meth_meth_ast__apply7327->type = alloc_MethodType(1, argcv_meth_ast__apply7327);
  meth_meth_ast__apply7327->definitionModule = modulename;
  meth_meth_ast__apply7327->definitionLine = 1690;
// compilenode returning block7326
  gc_frame_newslot(block7326);
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7345 = gc_frame_new();
  partcv[0] = 0;
  Object call7346 = callmethodflags(self, "annotations", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7345);
// compilenode returning call7346
// compilenode returning call7346
  params[0] = strlit7325;
  params[1] = block7326;
  partcv[0] = 2;
  Object call7347 = callmethod(call7346, "reduce",
    1, partcv, params);
  gc_frame_end(callframe7324);
// compilenode returning call7347
  int op_slot_right_7323 = gc_frame_newslot(call7347);
// compilenode returning *var_s
  int op_slot_left_7323 = gc_frame_newslot(*var_s);
  params[0] = call7347;
  partcv[0] = 1;
  Object opresult7349 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7349
  *var_s = opresult7349;
  if (opresult7349 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7309 = done;
  } else {
  }
// compilenode returning if7309
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7353 = alloc_Boolean(0);
// compilenode returning bool7353
  int op_slot_right_7352 = gc_frame_newslot(bool7353);
  int callframe7355 = gc_frame_new();
  partcv[0] = 0;
  Object call7356 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7355);
// compilenode returning call7356
// compilenode returning call7356
  int op_slot_left_7352 = gc_frame_newslot(call7356);
  params[0] = bool7353;
  partcv[0] = 1;
  Object opresult7357 = callmethod(call7356, "!=", 1, partcv, params);
// compilenode returning opresult7357
  Object if7351 = done;
  if (istrue(opresult7357)) {
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7359 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe7360 = gc_frame_new();
  partcv[0] = 0;
  Object call7361 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7360);
// compilenode returning call7361
// compilenode returning call7361
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7362 = callmethod(call7361, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7359);
// compilenode returning call7362
  int op_slot_right_7358 = gc_frame_newslot(call7362);
  if (strlit7365 == NULL) {
    strlit7365 = alloc_String(" := ");
    gc_root(strlit7365);
  }
// compilenode returning strlit7365
  int op_slot_right_7364 = gc_frame_newslot(strlit7365);
// compilenode returning *var_s
  int op_slot_left_7364 = gc_frame_newslot(*var_s);
  params[0] = strlit7365;
  partcv[0] = 1;
  Object opresult7367 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7367
  int op_slot_left_7358 = gc_frame_newslot(opresult7367);
  params[0] = call7362;
  partcv[0] = 1;
  Object opresult7368 = callmethod(opresult7367, "++", 1, partcv, params);
// compilenode returning opresult7368
  *var_s = opresult7368;
  if (opresult7368 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7351 = done;
  } else {
  }
// compilenode returning if7351
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_new7036(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7037 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7037 = alloc_userobj2(13,13, objclass7037);
  gc_frame_newslot(obj7037);
if (objclass7037 == NULL) {
  glfree(obj7037->class->name);
  obj7037->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7037, self, 0);
  addmethodreal(obj7037,"outer", &reader_ast_outer_7038);
  Object oldself7037 = self;
  struct StackFrameObject *oldstackframe7037 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7037);
  gc_frame_newslot((Object)stackframe);
  self = obj7037;
  Object *oldselfslot7037 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7037 = (*(struct UserObject *)self).data[0], lowerouter7037 = thisouter7037;
  if (inheritingObject7037) {
    struct UserObject *inho7037 = (struct UserObject *)inheritingObject7037;
    while (inho7037->super != GraceDefaultObject) inho7037 = (struct UserObject *)inho7037->super;
    inho7037->super = obj7037;
    self = inheritingObject7037;
    *selfslot = self;
    lowerouter7037 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7037;
  }
if (objclass7037 == NULL) {
  Method *reader7039 = addmethodrealflags(obj7037, "kind",&reader_ast_kind_7039, MFLAG_DEF);
  reader7039->definitionModule = modulename;
  reader7039->definitionLine = 1626;
}
adddatum2(obj7037, alloc_Undefined(), 1);
if (objclass7037 == NULL) {
  Method *reader7040 = addmethodrealflags(obj7037, "name",&reader_ast_name_7040, MFLAG_DEF);
  reader7040->definitionModule = modulename;
  reader7040->definitionLine = 1627;
}
adddatum2(obj7037, alloc_Undefined(), 2);
if (objclass7037 == NULL) {
  Method *reader7041 = addmethodrealflags(obj7037, "value",&reader_ast_value_7041, MFLAG_DEF);
  reader7041->definitionModule = modulename;
  reader7041->definitionLine = 1628;
}
adddatum2(obj7037, alloc_Undefined(), 3);
if (objclass7037 == NULL) {
  Method *reader7042 = addmethodrealflags(obj7037, "dtype",&reader_ast_dtype_7042, 0);
  Method *writer7042 = addmethodrealflags(obj7037, "dtype:=",&writer_ast_dtype_7042, 0);
  reader7042->definitionModule = modulename;
  writer7042->definitionModule = modulename;
  reader7042->definitionLine = 1629;
  writer7042->definitionLine = 1629;
}
obj7037->flags |= OFLAG_MUTABLE;
adddatum2(obj7037, alloc_Undefined(), 4);
if (objclass7037 == NULL) {
  Method *reader7043 = addmethodrealflags(obj7037, "annotations",&reader_ast_annotations_7043, MFLAG_DEF);
  reader7043->definitionModule = modulename;
  reader7043->definitionLine = 1630;
}
adddatum2(obj7037, alloc_Undefined(), 5);
  struct UserObject *uo7044 = (struct UserObject*)obj7037;
  uo7044->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7044 = addmethod2pos(obj7037, "accept", &meth_ast_accept7044, 6);
int argcv_meth_ast_accept7044[] = {1};
meth_meth_ast_accept7044->type = alloc_MethodType(1, argcv_meth_ast_accept7044);
meth_meth_ast_accept7044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7044->type->names[0] = "visitor";
  meth_meth_ast_accept7044->definitionModule = modulename;
  meth_meth_ast_accept7044->definitionLine = 1630;
  block_savedest(obj7037);
  Object closure7074 = createclosure(1, "map()before()after");
setclosureframe(closure7074, stackframe);
  addtoclosure(closure7074, var_varDecNode);
  struct UserObject *uo7074 = (struct UserObject*)obj7037;
  uo7074->data[7] = (Object)closure7074;
  Method *meth_meth_ast_map_40__41_before_40__41_after7074 = addmethod2pos(obj7037, "map()before()after", &meth_ast_map_40__41_before_40__41_after7074, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7074[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7074->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7074);
  meth_meth_ast_map_40__41_before_40__41_after7074->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7074->definitionLine = 1641;
  struct UserObject *uo7125 = (struct UserObject*)obj7037;
  uo7125->data[8] = emptyclosure;
  Method *meth_meth_ast_map7125 = addmethod2pos(obj7037, "map", &meth_ast_map7125, 8);
int argcv_meth_ast_map7125[] = {1};
meth_meth_ast_map7125->type = alloc_MethodType(1, argcv_meth_ast_map7125);
  meth_meth_ast_map7125->definitionModule = modulename;
  meth_meth_ast_map7125->definitionLine = 1654;
  struct UserObject *uo7134 = (struct UserObject*)obj7037;
  uo7134->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7134 = addmethod2pos(obj7037, "pretty", &meth_ast_pretty7134, 9);
int argcv_meth_ast_pretty7134[] = {1};
meth_meth_ast_pretty7134->type = alloc_MethodType(1, argcv_meth_ast_pretty7134);
  meth_meth_ast_pretty7134->definitionModule = modulename;
  meth_meth_ast_pretty7134->definitionLine = 1657;
  block_savedest(obj7037);
  Object closure7240 = createclosure(1, "decType");
setclosureframe(closure7240, stackframe);
  addtoclosure(closure7240, var_identifierNode);
  struct UserObject *uo7240 = (struct UserObject*)obj7037;
  uo7240->data[10] = (Object)closure7240;
  Method *meth_meth_ast_decType7240 = addmethod2pos(obj7037, "decType", &meth_ast_decType7240, 10);
int argcv_meth_ast_decType7240[] = {0};
meth_meth_ast_decType7240->type = alloc_MethodType(1, argcv_meth_ast_decType7240);
  meth_meth_ast_decType7240->definitionModule = modulename;
  meth_meth_ast_decType7240->definitionLine = 1675;
  struct UserObject *uo7254 = (struct UserObject*)obj7037;
  uo7254->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace7254 = addmethod2pos(obj7037, "toGrace", &meth_ast_toGrace7254, 11);
int argcv_meth_ast_toGrace7254[] = {1};
meth_meth_ast_toGrace7254->type = alloc_MethodType(1, argcv_meth_ast_toGrace7254);
meth_meth_ast_toGrace7254->type->types[0] = type_Number;
meth_meth_ast_toGrace7254->type->names[0] = "depth";
  meth_meth_ast_toGrace7254->definitionModule = modulename;
  meth_meth_ast_toGrace7254->definitionLine = 1681;
  sourceObject = obj7037;
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7370 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7371 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7370);
// compilenode returning call7371
  struct UserObject *obj7037_uo = (struct UserObject *)obj7037;
  obj7037_uo->super = call7371;
  sourceObject = obj7037;
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7372 == NULL) {
    strlit7372 = alloc_String("vardec");
    gc_root(strlit7372);
  }
// compilenode returning strlit7372
  adddatum2(obj7037, strlit7372, 1);
  sourceObject = obj7037;
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj7037, *var_name_39_, 2);
  sourceObject = obj7037;
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj7037, *var_val_39_, 3);
  sourceObject = obj7037;
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj7037, *var_dtype_39_, 4);
  sourceObject = obj7037;
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7373 = gc_frame_new();
  int callframe7374 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7375 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7374);
// compilenode returning call7375
// compilenode returning call7375
  partcv[0] = 0;
  Object call7376 = callmethod(call7375, "new",
    1, partcv, params);
  gc_frame_end(callframe7373);
// compilenode returning call7376
// compilenode returning call7376
  adddatum2(obj7037, call7376, 5);
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
objclass7037 = obj7037->class;
  objclass7037->definitionModule = modulename;
  objclass7037->definitionLine = 1550;
  (*(struct UserObject *)self).data[0] = lowerouter7037;
  self = oldself7037;
  selfslot = oldselfslot7037;
  stackframe = oldstackframe7037;
  gc_frame_end(frame);
  return obj7037;
}
Object meth_ast_new7036_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_varDecNode = getfromclosure(closure, 0);
  Object *var_identifierNode = getfromclosure(closure, 1);
  Object *var_baseNode = getfromclosure(closure, 2);
  Object *var_collections = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_name_39_ = &(stackframe->slots[0]);
  *var_name_39_ = args[curarg];
  curarg++;
  Object *var_val_39_ = &(stackframe->slots[1]);
  *var_val_39_ = args[curarg];
  curarg++;
  Object *var_dtype_39_ = &(stackframe->slots[2]);
  *var_dtype_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7037 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7037 = alloc_userobj2(13,13, objclass7037);
  gc_frame_newslot(obj7037);
if (objclass7037 == NULL) {
  glfree(obj7037->class->name);
  obj7037->class->name = "varDecNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7037, self, 0);
  addmethodreal(obj7037,"outer", &reader_ast_outer_7038);
  Object oldself7037 = self;
  struct StackFrameObject *oldstackframe7037 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7037);
  gc_frame_newslot((Object)stackframe);
  self = obj7037;
  Object *oldselfslot7037 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7037 = (*(struct UserObject *)self).data[0], lowerouter7037 = thisouter7037;
  if (inheritingObject7037) {
    struct UserObject *inho7037 = (struct UserObject *)inheritingObject7037;
    while (inho7037->super != GraceDefaultObject) inho7037 = (struct UserObject *)inho7037->super;
    inho7037->super = obj7037;
    self = inheritingObject7037;
    *selfslot = self;
    lowerouter7037 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7037;
  }
if (objclass7037 == NULL) {
  Method *reader7039 = addmethodrealflags(obj7037, "kind",&reader_ast_kind_7039, MFLAG_DEF);
  reader7039->definitionModule = modulename;
  reader7039->definitionLine = 1626;
}
adddatum2(obj7037, alloc_Undefined(), 1);
if (objclass7037 == NULL) {
  Method *reader7040 = addmethodrealflags(obj7037, "name",&reader_ast_name_7040, MFLAG_DEF);
  reader7040->definitionModule = modulename;
  reader7040->definitionLine = 1627;
}
adddatum2(obj7037, alloc_Undefined(), 2);
if (objclass7037 == NULL) {
  Method *reader7041 = addmethodrealflags(obj7037, "value",&reader_ast_value_7041, MFLAG_DEF);
  reader7041->definitionModule = modulename;
  reader7041->definitionLine = 1628;
}
adddatum2(obj7037, alloc_Undefined(), 3);
if (objclass7037 == NULL) {
  Method *reader7042 = addmethodrealflags(obj7037, "dtype",&reader_ast_dtype_7042, 0);
  Method *writer7042 = addmethodrealflags(obj7037, "dtype:=",&writer_ast_dtype_7042, 0);
  reader7042->definitionModule = modulename;
  writer7042->definitionModule = modulename;
  reader7042->definitionLine = 1629;
  writer7042->definitionLine = 1629;
}
obj7037->flags |= OFLAG_MUTABLE;
adddatum2(obj7037, alloc_Undefined(), 4);
if (objclass7037 == NULL) {
  Method *reader7043 = addmethodrealflags(obj7037, "annotations",&reader_ast_annotations_7043, MFLAG_DEF);
  reader7043->definitionModule = modulename;
  reader7043->definitionLine = 1630;
}
adddatum2(obj7037, alloc_Undefined(), 5);
  struct UserObject *uo7044 = (struct UserObject*)obj7037;
  uo7044->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7044 = addmethod2pos(obj7037, "accept", &meth_ast_accept7044, 6);
int argcv_meth_ast_accept7044[] = {1};
meth_meth_ast_accept7044->type = alloc_MethodType(1, argcv_meth_ast_accept7044);
meth_meth_ast_accept7044->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7044->type->names[0] = "visitor";
  meth_meth_ast_accept7044->definitionModule = modulename;
  meth_meth_ast_accept7044->definitionLine = 1630;
  block_savedest(obj7037);
  Object closure7074 = createclosure(1, "map()before()after");
setclosureframe(closure7074, stackframe);
  addtoclosure(closure7074, var_varDecNode);
  struct UserObject *uo7074 = (struct UserObject*)obj7037;
  uo7074->data[7] = (Object)closure7074;
  Method *meth_meth_ast_map_40__41_before_40__41_after7074 = addmethod2pos(obj7037, "map()before()after", &meth_ast_map_40__41_before_40__41_after7074, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7074[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7074->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7074);
  meth_meth_ast_map_40__41_before_40__41_after7074->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7074->definitionLine = 1641;
  struct UserObject *uo7125 = (struct UserObject*)obj7037;
  uo7125->data[8] = emptyclosure;
  Method *meth_meth_ast_map7125 = addmethod2pos(obj7037, "map", &meth_ast_map7125, 8);
int argcv_meth_ast_map7125[] = {1};
meth_meth_ast_map7125->type = alloc_MethodType(1, argcv_meth_ast_map7125);
  meth_meth_ast_map7125->definitionModule = modulename;
  meth_meth_ast_map7125->definitionLine = 1654;
  struct UserObject *uo7134 = (struct UserObject*)obj7037;
  uo7134->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7134 = addmethod2pos(obj7037, "pretty", &meth_ast_pretty7134, 9);
int argcv_meth_ast_pretty7134[] = {1};
meth_meth_ast_pretty7134->type = alloc_MethodType(1, argcv_meth_ast_pretty7134);
  meth_meth_ast_pretty7134->definitionModule = modulename;
  meth_meth_ast_pretty7134->definitionLine = 1657;
  block_savedest(obj7037);
  Object closure7240 = createclosure(1, "decType");
setclosureframe(closure7240, stackframe);
  addtoclosure(closure7240, var_identifierNode);
  struct UserObject *uo7240 = (struct UserObject*)obj7037;
  uo7240->data[10] = (Object)closure7240;
  Method *meth_meth_ast_decType7240 = addmethod2pos(obj7037, "decType", &meth_ast_decType7240, 10);
int argcv_meth_ast_decType7240[] = {0};
meth_meth_ast_decType7240->type = alloc_MethodType(1, argcv_meth_ast_decType7240);
  meth_meth_ast_decType7240->definitionModule = modulename;
  meth_meth_ast_decType7240->definitionLine = 1675;
  struct UserObject *uo7254 = (struct UserObject*)obj7037;
  uo7254->data[11] = emptyclosure;
  Method *meth_meth_ast_toGrace7254 = addmethod2pos(obj7037, "toGrace", &meth_ast_toGrace7254, 11);
int argcv_meth_ast_toGrace7254[] = {1};
meth_meth_ast_toGrace7254->type = alloc_MethodType(1, argcv_meth_ast_toGrace7254);
meth_meth_ast_toGrace7254->type->types[0] = type_Number;
meth_meth_ast_toGrace7254->type->names[0] = "depth";
  meth_meth_ast_toGrace7254->definitionModule = modulename;
  meth_meth_ast_toGrace7254->definitionLine = 1681;
  sourceObject = obj7037;
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7370 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7371 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7370);
// compilenode returning call7371
  struct UserObject *obj7037_uo = (struct UserObject *)obj7037;
  obj7037_uo->super = call7371;
  sourceObject = obj7037;
// Begin line 1625
  setline(1625);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7372 == NULL) {
    strlit7372 = alloc_String("vardec");
    gc_root(strlit7372);
  }
// compilenode returning strlit7372
  adddatum2(obj7037, strlit7372, 1);
  sourceObject = obj7037;
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name_39_
  adddatum2(obj7037, *var_name_39_, 2);
  sourceObject = obj7037;
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_val_39_
  adddatum2(obj7037, *var_val_39_, 3);
  sourceObject = obj7037;
// Begin line 1628
  setline(1628);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype_39_
  adddatum2(obj7037, *var_dtype_39_, 4);
  sourceObject = obj7037;
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7373 = gc_frame_new();
  int callframe7374 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call7375 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe7374);
// compilenode returning call7375
// compilenode returning call7375
  partcv[0] = 0;
  Object call7376 = callmethod(call7375, "new",
    1, partcv, params);
  gc_frame_end(callframe7373);
// compilenode returning call7376
// compilenode returning call7376
  adddatum2(obj7037, call7376, 5);
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
  sourceObject = obj7037;
objclass7037 = obj7037->class;
  objclass7037->definitionModule = modulename;
  objclass7037->definitionLine = 1550;
  (*(struct UserObject *)self).data[0] = lowerouter7037;
  self = oldself7037;
  selfslot = oldselfslot7037;
  stackframe = oldstackframe7037;
  gc_frame_end(frame);
  return obj7037;
}
Object meth_ast_importNode7378(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "importNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_importNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for importNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for importNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_importNode
  gc_frame_end(frame);
  return *var_importNode;
}
Object meth_ast_accept7389(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7390 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7391 = callmethod(*var_visitor, "visitImport",
    1, partcv, params);
  gc_frame_end(callframe7390);
// compilenode returning call7391
  gc_frame_end(frame);
  return call7391;
}
Object meth_ast_map_40__41_before_40__41_after7392(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7393 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7394 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7393);
// compilenode returning call7394
// Begin line 1713
  setline(1713);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7395 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call7396 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7395);
// compilenode returning call7396
  *var_n = call7396;
  if (call7396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7397 = gc_frame_new();
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7398 = gc_frame_new();
  partcv[0] = 0;
  Object call7399 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7398);
// compilenode returning call7399
  gc_frame_newslot(call7399);
// compilenode returning *var_n
  params[0] = call7399;
  partcv[0] = 1;
  Object call7400 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7397);
// compilenode returning call7400
// compilenode returning done
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7401 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7402 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7401);
// compilenode returning call7402
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7406(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7409(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7403(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7404 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7405 = alloc_Block(NULL, NULL, "ast", 1719);
  gc_frame_newslot(block7405);
  block_savedest(block7405);
  Object closure7406 = createclosure(1, "_apply");
setclosureframe(closure7406, stackframe);
  addtoclosure(closure7406, selfslot);
  struct UserObject *uo7406 = (struct UserObject*)block7405;
  uo7406->data[0] = (Object)closure7406;
  Method *meth_meth_ast__apply7406 = addmethod2pos(block7405, "_apply", &meth_ast__apply7406, 0);
int argcv_meth_ast__apply7406[] = {0};
meth_meth_ast__apply7406->type = alloc_MethodType(1, argcv_meth_ast__apply7406);
  meth_meth_ast__apply7406->definitionModule = modulename;
  meth_meth_ast__apply7406->definitionLine = 1629;
// compilenode returning block7405
  gc_frame_newslot(block7405);
  Object block7408 = alloc_Block(NULL, NULL, "ast", 1719);
  gc_frame_newslot(block7408);
  block_savedest(block7408);
  Object closure7409 = createclosure(1, "_apply");
setclosureframe(closure7409, stackframe);
  addtoclosure(closure7409, selfslot);
  struct UserObject *uo7409 = (struct UserObject*)block7408;
  uo7409->data[0] = (Object)closure7409;
  Method *meth_meth_ast__apply7409 = addmethod2pos(block7408, "_apply", &meth_ast__apply7409, 0);
int argcv_meth_ast__apply7409[] = {0};
meth_meth_ast__apply7409->type = alloc_MethodType(1, argcv_meth_ast__apply7409);
  meth_meth_ast__apply7409->definitionModule = modulename;
  meth_meth_ast__apply7409->definitionLine = 1629;
// compilenode returning block7408
  gc_frame_newslot(block7408);
  params[0] = *var_blk;
  params[1] = block7405;
  params[2] = block7408;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7411 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7404);
// compilenode returning call7411
  gc_frame_end(frame);
  return call7411;
}
Object meth_ast__apply7420(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7422 == NULL) {
    strlit7422 = alloc_String("  ");
    gc_root(strlit7422);
  }
// compilenode returning strlit7422
  int op_slot_right_7421 = gc_frame_newslot(strlit7422);
// compilenode returning *var_spc
  int op_slot_left_7421 = gc_frame_newslot(*var_spc);
  params[0] = strlit7422;
  partcv[0] = 1;
  Object opresult7424 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7424
  *var_spc = opresult7424;
  if (opresult7424 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7413 == NULL) {
    strlit7413 = alloc_String("");
    gc_root(strlit7413);
  }
// compilenode returning strlit7413
  *var_spc = strlit7413;
  if (strlit7413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7414 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7415 = gc_frame_newslot(*var_depth);
  Object num7417 = alloc_Float64(0);
// compilenode returning num7417
  int op_slot_left_7415 = gc_frame_newslot(num7417);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7418 = callmethod(num7417, "..", 1, partcv, params);
// compilenode returning opresult7418
  gc_frame_newslot(opresult7418);
  Object block7419 = alloc_Block(NULL, NULL, "ast", 1723);
  gc_frame_newslot(block7419);
  block_savedest(block7419);
  Object closure7420 = createclosure(2, "_apply");
setclosureframe(closure7420, stackframe);
  addtoclosure(closure7420, var_spc);
  addtoclosure(closure7420, selfslot);
  struct UserObject *uo7420 = (struct UserObject*)block7419;
  uo7420->data[0] = (Object)closure7420;
  Method *meth_meth_ast__apply7420 = addmethod2pos(block7419, "_apply", &meth_ast__apply7420, 0);
int argcv_meth_ast__apply7420[] = {1};
meth_meth_ast__apply7420->type = alloc_MethodType(1, argcv_meth_ast__apply7420);
  meth_meth_ast__apply7420->definitionModule = modulename;
  meth_meth_ast__apply7420->definitionLine = 1629;
// compilenode returning block7419
  gc_frame_newslot(block7419);
  params[0] = opresult7418;
  params[1] = block7419;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7427 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7414);
// compilenode returning call7427
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7428 == NULL) {
    strlit7428 = alloc_String("Import");
    gc_root(strlit7428);
  }
// compilenode returning strlit7428
  *var_s = strlit7428;
  if (strlit7428 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1727
  setline(1727);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7430 == NULL) {
    strlit7430 = alloc_String("""\x0a""");
    gc_root(strlit7430);
  }
// compilenode returning strlit7430
  int op_slot_right_7429 = gc_frame_newslot(strlit7430);
// compilenode returning *var_s
  int op_slot_left_7429 = gc_frame_newslot(*var_s);
  params[0] = strlit7430;
  partcv[0] = 1;
  Object opresult7432 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7432
  *var_s = opresult7432;
  if (opresult7432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1728
  setline(1728);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7436 == NULL) {
    strlit7436 = alloc_String("""\x0a""");
    gc_root(strlit7436);
  }
// compilenode returning strlit7436
  int op_slot_right_7435 = gc_frame_newslot(strlit7436);
  int callframe7439 = gc_frame_new();
  partcv[0] = 0;
  Object call7440 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7439);
// compilenode returning call7440
// compilenode returning call7440
  int op_slot_right_7438 = gc_frame_newslot(call7440);
  if (strlit7443 == NULL) {
    strlit7443 = alloc_String("Path: ");
    gc_root(strlit7443);
  }
// compilenode returning strlit7443
  int op_slot_right_7442 = gc_frame_newslot(strlit7443);
// compilenode returning *var_spc
  int op_slot_right_7445 = gc_frame_newslot(*var_spc);
  if (strlit7447 == NULL) {
    strlit7447 = alloc_String("");
    gc_root(strlit7447);
  }
// compilenode returning strlit7447
  int op_slot_left_7445 = gc_frame_newslot(strlit7447);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7448 = callmethod(strlit7447, "++", 1, partcv, params);
// compilenode returning opresult7448
  int op_slot_left_7442 = gc_frame_newslot(opresult7448);
  params[0] = strlit7443;
  partcv[0] = 1;
  Object opresult7449 = callmethod(opresult7448, "++", 1, partcv, params);
// compilenode returning opresult7449
  int op_slot_left_7438 = gc_frame_newslot(opresult7449);
  params[0] = call7440;
  partcv[0] = 1;
  Object opresult7450 = callmethod(opresult7449, "++", 1, partcv, params);
// compilenode returning opresult7450
  int op_slot_left_7435 = gc_frame_newslot(opresult7450);
  params[0] = strlit7436;
  partcv[0] = 1;
  Object opresult7451 = callmethod(opresult7450, "++", 1, partcv, params);
// compilenode returning opresult7451
  int op_slot_right_7434 = gc_frame_newslot(opresult7451);
// compilenode returning *var_s
  int op_slot_left_7434 = gc_frame_newslot(*var_s);
  params[0] = opresult7451;
  partcv[0] = 1;
  Object opresult7453 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7453
  *var_s = opresult7453;
  if (opresult7453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7457 == NULL) {
    strlit7457 = alloc_String("""\x0a""");
    gc_root(strlit7457);
  }
// compilenode returning strlit7457
  int op_slot_right_7456 = gc_frame_newslot(strlit7457);
  int callframe7460 = gc_frame_new();
  partcv[0] = 0;
  Object call7461 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7460);
// compilenode returning call7461
// compilenode returning call7461
  int op_slot_right_7459 = gc_frame_newslot(call7461);
  if (strlit7464 == NULL) {
    strlit7464 = alloc_String("Identifier: ");
    gc_root(strlit7464);
  }
// compilenode returning strlit7464
  int op_slot_right_7463 = gc_frame_newslot(strlit7464);
// compilenode returning *var_spc
  int op_slot_right_7466 = gc_frame_newslot(*var_spc);
  if (strlit7468 == NULL) {
    strlit7468 = alloc_String("");
    gc_root(strlit7468);
  }
// compilenode returning strlit7468
  int op_slot_left_7466 = gc_frame_newslot(strlit7468);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7469 = callmethod(strlit7468, "++", 1, partcv, params);
// compilenode returning opresult7469
  int op_slot_left_7463 = gc_frame_newslot(opresult7469);
  params[0] = strlit7464;
  partcv[0] = 1;
  Object opresult7470 = callmethod(opresult7469, "++", 1, partcv, params);
// compilenode returning opresult7470
  int op_slot_left_7459 = gc_frame_newslot(opresult7470);
  params[0] = call7461;
  partcv[0] = 1;
  Object opresult7471 = callmethod(opresult7470, "++", 1, partcv, params);
// compilenode returning opresult7471
  int op_slot_left_7456 = gc_frame_newslot(opresult7471);
  params[0] = strlit7457;
  partcv[0] = 1;
  Object opresult7472 = callmethod(opresult7471, "++", 1, partcv, params);
// compilenode returning opresult7472
  int op_slot_right_7455 = gc_frame_newslot(opresult7472);
// compilenode returning *var_s
  int op_slot_left_7455 = gc_frame_newslot(*var_s);
  params[0] = opresult7472;
  partcv[0] = 1;
  Object opresult7474 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7474
  *var_s = opresult7474;
  if (opresult7474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7476(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7478 == NULL) {
    strlit7478 = alloc_String("");
    gc_root(strlit7478);
  }
// compilenode returning strlit7478
  int op_slot_right_7477 = gc_frame_newslot(strlit7478);
  int callframe7481 = gc_frame_new();
  partcv[0] = 0;
  Object call7482 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7481);
// compilenode returning call7482
// compilenode returning call7482
  int op_slot_right_7480 = gc_frame_newslot(call7482);
  if (strlit7485 == NULL) {
    strlit7485 = alloc_String("""\x22"" as ");
    gc_root(strlit7485);
  }
// compilenode returning strlit7485
  int op_slot_right_7484 = gc_frame_newslot(strlit7485);
  int callframe7488 = gc_frame_new();
  partcv[0] = 0;
  Object call7489 = callmethodflags(self, "path", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7488);
// compilenode returning call7489
// compilenode returning call7489
  int op_slot_right_7487 = gc_frame_newslot(call7489);
  if (strlit7491 == NULL) {
    strlit7491 = alloc_String("import ""\x22""");
    gc_root(strlit7491);
  }
// compilenode returning strlit7491
  int op_slot_left_7487 = gc_frame_newslot(strlit7491);
  params[0] = call7489;
  partcv[0] = 1;
  Object opresult7492 = callmethod(strlit7491, "++", 1, partcv, params);
// compilenode returning opresult7492
  int op_slot_left_7484 = gc_frame_newslot(opresult7492);
  params[0] = strlit7485;
  partcv[0] = 1;
  Object opresult7493 = callmethod(opresult7492, "++", 1, partcv, params);
// compilenode returning opresult7493
  int op_slot_left_7480 = gc_frame_newslot(opresult7493);
  params[0] = call7482;
  partcv[0] = 1;
  Object opresult7494 = callmethod(opresult7493, "++", 1, partcv, params);
// compilenode returning opresult7494
  int op_slot_left_7477 = gc_frame_newslot(opresult7494);
  params[0] = strlit7478;
  partcv[0] = 1;
  Object opresult7495 = callmethod(opresult7494, "++", 1, partcv, params);
// compilenode returning opresult7495
  gc_frame_end(frame);
  return opresult7495;
}
Object meth_ast_new7381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name = &(stackframe->slots[1]);
  *var_name = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7382 = alloc_userobj2(12,12, objclass7382);
  gc_frame_newslot(obj7382);
if (objclass7382 == NULL) {
  glfree(obj7382->class->name);
  obj7382->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7382, self, 0);
  addmethodreal(obj7382,"outer", &reader_ast_outer_7383);
  Object oldself7382 = self;
  struct StackFrameObject *oldstackframe7382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7382);
  gc_frame_newslot((Object)stackframe);
  self = obj7382;
  Object *oldselfslot7382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7382 = (*(struct UserObject *)self).data[0], lowerouter7382 = thisouter7382;
  if (inheritingObject7382) {
    struct UserObject *inho7382 = (struct UserObject *)inheritingObject7382;
    while (inho7382->super != GraceDefaultObject) inho7382 = (struct UserObject *)inho7382->super;
    inho7382->super = obj7382;
    self = inheritingObject7382;
    *selfslot = self;
    lowerouter7382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7382;
  }
if (objclass7382 == NULL) {
  Method *reader7384 = addmethodrealflags(obj7382, "kind",&reader_ast_kind_7384, MFLAG_DEF);
  reader7384->definitionModule = modulename;
  reader7384->definitionLine = 1704;
}
adddatum2(obj7382, alloc_Undefined(), 1);
if (objclass7382 == NULL) {
  Method *reader7385 = addmethodrealflags(obj7382, "value",&reader_ast_value_7385, MFLAG_DEF);
  reader7385->definitionModule = modulename;
  reader7385->definitionLine = 1705;
}
adddatum2(obj7382, alloc_Undefined(), 2);
if (objclass7382 == NULL) {
  Method *reader7386 = addmethodrealflags(obj7382, "path",&reader_ast_path_7386, MFLAG_DEF);
  reader7386->definitionModule = modulename;
  reader7386->definitionLine = 1706;
}
adddatum2(obj7382, alloc_Undefined(), 3);
if (objclass7382 == NULL) {
  Method *reader7387 = addmethodrealflags(obj7382, "dtype",&reader_ast_dtype_7387, 0);
  Method *writer7387 = addmethodrealflags(obj7382, "dtype:=",&writer_ast_dtype_7387, 0);
  reader7387->definitionModule = modulename;
  writer7387->definitionModule = modulename;
  reader7387->definitionLine = 1707;
  writer7387->definitionLine = 1707;
}
obj7382->flags |= OFLAG_MUTABLE;
adddatum2(obj7382, alloc_Undefined(), 4);
if (objclass7382 == NULL) {
  Method *reader7388 = addmethodrealflags(obj7382, "linePos",&reader_ast_linePos_7388, MFLAG_DEF);
  reader7388->definitionModule = modulename;
  reader7388->definitionLine = 1708;
}
adddatum2(obj7382, alloc_Undefined(), 5);
  struct UserObject *uo7389 = (struct UserObject*)obj7382;
  uo7389->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7389 = addmethod2pos(obj7382, "accept", &meth_ast_accept7389, 6);
int argcv_meth_ast_accept7389[] = {1};
meth_meth_ast_accept7389->type = alloc_MethodType(1, argcv_meth_ast_accept7389);
meth_meth_ast_accept7389->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7389->type->names[0] = "visitor";
  meth_meth_ast_accept7389->definitionModule = modulename;
  meth_meth_ast_accept7389->definitionLine = 1708;
  struct UserObject *uo7392 = (struct UserObject*)obj7382;
  uo7392->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7392 = addmethod2pos(obj7382, "map()before()after", &meth_ast_map_40__41_before_40__41_after7392, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7392[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7392->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7392);
  meth_meth_ast_map_40__41_before_40__41_after7392->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7392->definitionLine = 1711;
  struct UserObject *uo7403 = (struct UserObject*)obj7382;
  uo7403->data[8] = emptyclosure;
  Method *meth_meth_ast_map7403 = addmethod2pos(obj7382, "map", &meth_ast_map7403, 8);
int argcv_meth_ast_map7403[] = {1};
meth_meth_ast_map7403->type = alloc_MethodType(1, argcv_meth_ast_map7403);
  meth_meth_ast_map7403->definitionModule = modulename;
  meth_meth_ast_map7403->definitionLine = 1718;
  struct UserObject *uo7412 = (struct UserObject*)obj7382;
  uo7412->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7412 = addmethod2pos(obj7382, "pretty", &meth_ast_pretty7412, 9);
int argcv_meth_ast_pretty7412[] = {1};
meth_meth_ast_pretty7412->type = alloc_MethodType(1, argcv_meth_ast_pretty7412);
  meth_meth_ast_pretty7412->definitionModule = modulename;
  meth_meth_ast_pretty7412->definitionLine = 1721;
  struct UserObject *uo7476 = (struct UserObject*)obj7382;
  uo7476->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7476 = addmethod2pos(obj7382, "toGrace", &meth_ast_toGrace7476, 10);
int argcv_meth_ast_toGrace7476[] = {1};
meth_meth_ast_toGrace7476->type = alloc_MethodType(1, argcv_meth_ast_toGrace7476);
meth_meth_ast_toGrace7476->type->types[0] = type_Number;
meth_meth_ast_toGrace7476->type->names[0] = "depth";
  meth_meth_ast_toGrace7476->definitionModule = modulename;
  meth_meth_ast_toGrace7476->definitionLine = 1732;
  sourceObject = obj7382;
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7496 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7497 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7496);
// compilenode returning call7497
  struct UserObject *obj7382_uo = (struct UserObject *)obj7382;
  obj7382_uo->super = call7497;
  sourceObject = obj7382;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7498 == NULL) {
    strlit7498 = alloc_String("import");
    gc_root(strlit7498);
  }
// compilenode returning strlit7498
  adddatum2(obj7382, strlit7498, 1);
  sourceObject = obj7382;
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj7382, *var_name, 2);
  sourceObject = obj7382;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7382, *var_path_39_, 3);
  sourceObject = obj7382;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7499 = alloc_Boolean(0);
// compilenode returning bool7499
  adddatum2(obj7382, bool7499, 4);
  sourceObject = obj7382;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7500 = alloc_Float64(1);
// compilenode returning num7500
  adddatum2(obj7382, num7500, 5);
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
objclass7382 = obj7382->class;
  objclass7382->definitionModule = modulename;
  objclass7382->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7382;
  self = oldself7382;
  selfslot = oldselfslot7382;
  stackframe = oldstackframe7382;
  gc_frame_end(frame);
  return obj7382;
}
Object meth_ast_new7381_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
  Object *var_name = &(stackframe->slots[1]);
  *var_name = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7382 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7382 = alloc_userobj2(12,12, objclass7382);
  gc_frame_newslot(obj7382);
if (objclass7382 == NULL) {
  glfree(obj7382->class->name);
  obj7382->class->name = "importNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7382, self, 0);
  addmethodreal(obj7382,"outer", &reader_ast_outer_7383);
  Object oldself7382 = self;
  struct StackFrameObject *oldstackframe7382 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7382);
  gc_frame_newslot((Object)stackframe);
  self = obj7382;
  Object *oldselfslot7382 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7382 = (*(struct UserObject *)self).data[0], lowerouter7382 = thisouter7382;
  if (inheritingObject7382) {
    struct UserObject *inho7382 = (struct UserObject *)inheritingObject7382;
    while (inho7382->super != GraceDefaultObject) inho7382 = (struct UserObject *)inho7382->super;
    inho7382->super = obj7382;
    self = inheritingObject7382;
    *selfslot = self;
    lowerouter7382 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7382;
  }
if (objclass7382 == NULL) {
  Method *reader7384 = addmethodrealflags(obj7382, "kind",&reader_ast_kind_7384, MFLAG_DEF);
  reader7384->definitionModule = modulename;
  reader7384->definitionLine = 1704;
}
adddatum2(obj7382, alloc_Undefined(), 1);
if (objclass7382 == NULL) {
  Method *reader7385 = addmethodrealflags(obj7382, "value",&reader_ast_value_7385, MFLAG_DEF);
  reader7385->definitionModule = modulename;
  reader7385->definitionLine = 1705;
}
adddatum2(obj7382, alloc_Undefined(), 2);
if (objclass7382 == NULL) {
  Method *reader7386 = addmethodrealflags(obj7382, "path",&reader_ast_path_7386, MFLAG_DEF);
  reader7386->definitionModule = modulename;
  reader7386->definitionLine = 1706;
}
adddatum2(obj7382, alloc_Undefined(), 3);
if (objclass7382 == NULL) {
  Method *reader7387 = addmethodrealflags(obj7382, "dtype",&reader_ast_dtype_7387, 0);
  Method *writer7387 = addmethodrealflags(obj7382, "dtype:=",&writer_ast_dtype_7387, 0);
  reader7387->definitionModule = modulename;
  writer7387->definitionModule = modulename;
  reader7387->definitionLine = 1707;
  writer7387->definitionLine = 1707;
}
obj7382->flags |= OFLAG_MUTABLE;
adddatum2(obj7382, alloc_Undefined(), 4);
if (objclass7382 == NULL) {
  Method *reader7388 = addmethodrealflags(obj7382, "linePos",&reader_ast_linePos_7388, MFLAG_DEF);
  reader7388->definitionModule = modulename;
  reader7388->definitionLine = 1708;
}
adddatum2(obj7382, alloc_Undefined(), 5);
  struct UserObject *uo7389 = (struct UserObject*)obj7382;
  uo7389->data[6] = emptyclosure;
  Method *meth_meth_ast_accept7389 = addmethod2pos(obj7382, "accept", &meth_ast_accept7389, 6);
int argcv_meth_ast_accept7389[] = {1};
meth_meth_ast_accept7389->type = alloc_MethodType(1, argcv_meth_ast_accept7389);
meth_meth_ast_accept7389->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7389->type->names[0] = "visitor";
  meth_meth_ast_accept7389->definitionModule = modulename;
  meth_meth_ast_accept7389->definitionLine = 1708;
  struct UserObject *uo7392 = (struct UserObject*)obj7382;
  uo7392->data[7] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7392 = addmethod2pos(obj7382, "map()before()after", &meth_ast_map_40__41_before_40__41_after7392, 7);
int argcv_meth_ast_map_40__41_before_40__41_after7392[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7392->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7392);
  meth_meth_ast_map_40__41_before_40__41_after7392->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7392->definitionLine = 1711;
  struct UserObject *uo7403 = (struct UserObject*)obj7382;
  uo7403->data[8] = emptyclosure;
  Method *meth_meth_ast_map7403 = addmethod2pos(obj7382, "map", &meth_ast_map7403, 8);
int argcv_meth_ast_map7403[] = {1};
meth_meth_ast_map7403->type = alloc_MethodType(1, argcv_meth_ast_map7403);
  meth_meth_ast_map7403->definitionModule = modulename;
  meth_meth_ast_map7403->definitionLine = 1718;
  struct UserObject *uo7412 = (struct UserObject*)obj7382;
  uo7412->data[9] = emptyclosure;
  Method *meth_meth_ast_pretty7412 = addmethod2pos(obj7382, "pretty", &meth_ast_pretty7412, 9);
int argcv_meth_ast_pretty7412[] = {1};
meth_meth_ast_pretty7412->type = alloc_MethodType(1, argcv_meth_ast_pretty7412);
  meth_meth_ast_pretty7412->definitionModule = modulename;
  meth_meth_ast_pretty7412->definitionLine = 1721;
  struct UserObject *uo7476 = (struct UserObject*)obj7382;
  uo7476->data[10] = emptyclosure;
  Method *meth_meth_ast_toGrace7476 = addmethod2pos(obj7382, "toGrace", &meth_ast_toGrace7476, 10);
int argcv_meth_ast_toGrace7476[] = {1};
meth_meth_ast_toGrace7476->type = alloc_MethodType(1, argcv_meth_ast_toGrace7476);
meth_meth_ast_toGrace7476->type->types[0] = type_Number;
meth_meth_ast_toGrace7476->type->names[0] = "depth";
  meth_meth_ast_toGrace7476->definitionModule = modulename;
  meth_meth_ast_toGrace7476->definitionLine = 1732;
  sourceObject = obj7382;
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7496 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7497 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7496);
// compilenode returning call7497
  struct UserObject *obj7382_uo = (struct UserObject *)obj7382;
  obj7382_uo->super = call7497;
  sourceObject = obj7382;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7498 == NULL) {
    strlit7498 = alloc_String("import");
    gc_root(strlit7498);
  }
// compilenode returning strlit7498
  adddatum2(obj7382, strlit7498, 1);
  sourceObject = obj7382;
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_name
  adddatum2(obj7382, *var_name, 2);
  sourceObject = obj7382;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7382, *var_path_39_, 3);
  sourceObject = obj7382;
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7499 = alloc_Boolean(0);
// compilenode returning bool7499
  adddatum2(obj7382, bool7499, 4);
  sourceObject = obj7382;
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7500 = alloc_Float64(1);
// compilenode returning num7500
  adddatum2(obj7382, num7500, 5);
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
  sourceObject = obj7382;
objclass7382 = obj7382->class;
  objclass7382->definitionModule = modulename;
  objclass7382->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7382;
  self = oldself7382;
  selfslot = oldselfslot7382;
  stackframe = oldstackframe7382;
  gc_frame_end(frame);
  return obj7382;
}
Object meth_ast_dialectNode7502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dialectNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_dialectNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dialectNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dialectNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dialectNode
  gc_frame_end(frame);
  return *var_dialectNode;
}
Object meth_ast_accept7510(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7511 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7512 = callmethod(*var_visitor, "visitDialect",
    1, partcv, params);
  gc_frame_end(callframe7511);
// compilenode returning call7512
  gc_frame_end(frame);
  return call7512;
}
Object meth_ast_map_40__41_before_40__41_after7513(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1744
  setline(1744);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7514 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7515 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7514);
// compilenode returning call7515
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7516 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blk
  params[0] = self;
  partcv[0] = 1;
  Object call7517 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7516);
// compilenode returning call7517
  *var_n = call7517;
  if (call7517 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7518 = gc_frame_new();
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7519 = gc_frame_new();
  partcv[0] = 0;
  Object call7520 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7519);
// compilenode returning call7520
  gc_frame_newslot(call7520);
// compilenode returning *var_n
  params[0] = call7520;
  partcv[0] = 1;
  Object call7521 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7518);
// compilenode returning call7521
// compilenode returning done
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7522 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7523 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7522);
// compilenode returning call7523
// Begin line 1748
  setline(1748);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7530(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7524(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7525 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7526 = alloc_Block(NULL, NULL, "ast", 1751);
  gc_frame_newslot(block7526);
  block_savedest(block7526);
  Object closure7527 = createclosure(1, "_apply");
setclosureframe(closure7527, stackframe);
  addtoclosure(closure7527, selfslot);
  struct UserObject *uo7527 = (struct UserObject*)block7526;
  uo7527->data[0] = (Object)closure7527;
  Method *meth_meth_ast__apply7527 = addmethod2pos(block7526, "_apply", &meth_ast__apply7527, 0);
int argcv_meth_ast__apply7527[] = {0};
meth_meth_ast__apply7527->type = alloc_MethodType(1, argcv_meth_ast__apply7527);
  meth_meth_ast__apply7527->definitionModule = modulename;
  meth_meth_ast__apply7527->definitionLine = 1733;
// compilenode returning block7526
  gc_frame_newslot(block7526);
  Object block7529 = alloc_Block(NULL, NULL, "ast", 1751);
  gc_frame_newslot(block7529);
  block_savedest(block7529);
  Object closure7530 = createclosure(1, "_apply");
setclosureframe(closure7530, stackframe);
  addtoclosure(closure7530, selfslot);
  struct UserObject *uo7530 = (struct UserObject*)block7529;
  uo7530->data[0] = (Object)closure7530;
  Method *meth_meth_ast__apply7530 = addmethod2pos(block7529, "_apply", &meth_ast__apply7530, 0);
int argcv_meth_ast__apply7530[] = {0};
meth_meth_ast__apply7530->type = alloc_MethodType(1, argcv_meth_ast__apply7530);
  meth_meth_ast__apply7530->definitionModule = modulename;
  meth_meth_ast__apply7530->definitionLine = 1733;
// compilenode returning block7529
  gc_frame_newslot(block7529);
  params[0] = *var_blk;
  params[1] = block7526;
  params[2] = block7529;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7532 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7525);
// compilenode returning call7532
  gc_frame_end(frame);
  return call7532;
}
Object meth_ast__apply7541(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1757
  setline(1757);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7543 == NULL) {
    strlit7543 = alloc_String("  ");
    gc_root(strlit7543);
  }
// compilenode returning strlit7543
  int op_slot_right_7542 = gc_frame_newslot(strlit7543);
// compilenode returning *var_spc
  int op_slot_left_7542 = gc_frame_newslot(*var_spc);
  params[0] = strlit7543;
  partcv[0] = 1;
  Object opresult7545 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7545
  *var_spc = opresult7545;
  if (opresult7545 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7533(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7534 == NULL) {
    strlit7534 = alloc_String("");
    gc_root(strlit7534);
  }
// compilenode returning strlit7534
  *var_spc = strlit7534;
  if (strlit7534 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7535 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7536 = gc_frame_newslot(*var_depth);
  Object num7538 = alloc_Float64(0);
// compilenode returning num7538
  int op_slot_left_7536 = gc_frame_newslot(num7538);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7539 = callmethod(num7538, "..", 1, partcv, params);
// compilenode returning opresult7539
  gc_frame_newslot(opresult7539);
  Object block7540 = alloc_Block(NULL, NULL, "ast", 1755);
  gc_frame_newslot(block7540);
  block_savedest(block7540);
  Object closure7541 = createclosure(2, "_apply");
setclosureframe(closure7541, stackframe);
  addtoclosure(closure7541, var_spc);
  addtoclosure(closure7541, selfslot);
  struct UserObject *uo7541 = (struct UserObject*)block7540;
  uo7541->data[0] = (Object)closure7541;
  Method *meth_meth_ast__apply7541 = addmethod2pos(block7540, "_apply", &meth_ast__apply7541, 0);
int argcv_meth_ast__apply7541[] = {1};
meth_meth_ast__apply7541->type = alloc_MethodType(1, argcv_meth_ast__apply7541);
  meth_meth_ast__apply7541->definitionModule = modulename;
  meth_meth_ast__apply7541->definitionLine = 1733;
// compilenode returning block7540
  gc_frame_newslot(block7540);
  params[0] = opresult7539;
  params[1] = block7540;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7548 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7535);
// compilenode returning call7548
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7549 == NULL) {
    strlit7549 = alloc_String("Dialect");
    gc_root(strlit7549);
  }
// compilenode returning strlit7549
  *var_s = strlit7549;
  if (strlit7549 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7551 == NULL) {
    strlit7551 = alloc_String("""\x0a""");
    gc_root(strlit7551);
  }
// compilenode returning strlit7551
  int op_slot_right_7550 = gc_frame_newslot(strlit7551);
// compilenode returning *var_s
  int op_slot_left_7550 = gc_frame_newslot(*var_s);
  params[0] = strlit7551;
  partcv[0] = 1;
  Object opresult7553 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7553
  *var_s = opresult7553;
  if (opresult7553 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7557 == NULL) {
    strlit7557 = alloc_String("""\x0a""");
    gc_root(strlit7557);
  }
// compilenode returning strlit7557
  int op_slot_right_7556 = gc_frame_newslot(strlit7557);
  int callframe7560 = gc_frame_new();
  partcv[0] = 0;
  Object call7561 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7560);
// compilenode returning call7561
// compilenode returning call7561
  int op_slot_right_7559 = gc_frame_newslot(call7561);
  if (strlit7564 == NULL) {
    strlit7564 = alloc_String("Path: ");
    gc_root(strlit7564);
  }
// compilenode returning strlit7564
  int op_slot_right_7563 = gc_frame_newslot(strlit7564);
// compilenode returning *var_spc
  int op_slot_right_7566 = gc_frame_newslot(*var_spc);
  if (strlit7568 == NULL) {
    strlit7568 = alloc_String("");
    gc_root(strlit7568);
  }
// compilenode returning strlit7568
  int op_slot_left_7566 = gc_frame_newslot(strlit7568);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7569 = callmethod(strlit7568, "++", 1, partcv, params);
// compilenode returning opresult7569
  int op_slot_left_7563 = gc_frame_newslot(opresult7569);
  params[0] = strlit7564;
  partcv[0] = 1;
  Object opresult7570 = callmethod(opresult7569, "++", 1, partcv, params);
// compilenode returning opresult7570
  int op_slot_left_7559 = gc_frame_newslot(opresult7570);
  params[0] = call7561;
  partcv[0] = 1;
  Object opresult7571 = callmethod(opresult7570, "++", 1, partcv, params);
// compilenode returning opresult7571
  int op_slot_left_7556 = gc_frame_newslot(opresult7571);
  params[0] = strlit7557;
  partcv[0] = 1;
  Object opresult7572 = callmethod(opresult7571, "++", 1, partcv, params);
// compilenode returning opresult7572
  int op_slot_right_7555 = gc_frame_newslot(opresult7572);
// compilenode returning *var_s
  int op_slot_left_7555 = gc_frame_newslot(*var_s);
  params[0] = opresult7572;
  partcv[0] = 1;
  Object opresult7574 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7574
  *var_s = opresult7574;
  if (opresult7574 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7576(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7578 == NULL) {
    strlit7578 = alloc_String("""\x22""");
    gc_root(strlit7578);
  }
// compilenode returning strlit7578
  int op_slot_right_7577 = gc_frame_newslot(strlit7578);
  int callframe7581 = gc_frame_new();
  partcv[0] = 0;
  Object call7582 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7581);
// compilenode returning call7582
// compilenode returning call7582
  int op_slot_right_7580 = gc_frame_newslot(call7582);
  if (strlit7584 == NULL) {
    strlit7584 = alloc_String("dialect ""\x22""");
    gc_root(strlit7584);
  }
// compilenode returning strlit7584
  int op_slot_left_7580 = gc_frame_newslot(strlit7584);
  params[0] = call7582;
  partcv[0] = 1;
  Object opresult7585 = callmethod(strlit7584, "++", 1, partcv, params);
// compilenode returning opresult7585
  int op_slot_left_7577 = gc_frame_newslot(opresult7585);
  params[0] = strlit7578;
  partcv[0] = 1;
  Object opresult7586 = callmethod(opresult7585, "++", 1, partcv, params);
// compilenode returning opresult7586
  gc_frame_end(frame);
  return opresult7586;
}
Object meth_ast_new7505(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7506 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7506 = alloc_userobj2(8,9, objclass7506);
  gc_frame_newslot(obj7506);
if (objclass7506 == NULL) {
  glfree(obj7506->class->name);
  obj7506->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7506, self, 0);
  addmethodreal(obj7506,"outer", &reader_ast_outer_7507);
  Object oldself7506 = self;
  struct StackFrameObject *oldstackframe7506 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7506);
  gc_frame_newslot((Object)stackframe);
  self = obj7506;
  Object *oldselfslot7506 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7506 = (*(struct UserObject *)self).data[0], lowerouter7506 = thisouter7506;
  if (inheritingObject7506) {
    struct UserObject *inho7506 = (struct UserObject *)inheritingObject7506;
    while (inho7506->super != GraceDefaultObject) inho7506 = (struct UserObject *)inho7506->super;
    inho7506->super = obj7506;
    self = inheritingObject7506;
    *selfslot = self;
    lowerouter7506 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7506;
  }
if (objclass7506 == NULL) {
  Method *reader7508 = addmethodrealflags(obj7506, "kind",&reader_ast_kind_7508, MFLAG_DEF);
  reader7508->definitionModule = modulename;
  reader7508->definitionLine = 1739;
}
adddatum2(obj7506, alloc_Undefined(), 1);
if (objclass7506 == NULL) {
  Method *reader7509 = addmethodrealflags(obj7506, "value",&reader_ast_value_7509, MFLAG_DEF);
  reader7509->definitionModule = modulename;
  reader7509->definitionLine = 1740;
}
adddatum2(obj7506, alloc_Undefined(), 2);
  struct UserObject *uo7510 = (struct UserObject*)obj7506;
  uo7510->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7510 = addmethod2pos(obj7506, "accept", &meth_ast_accept7510, 3);
int argcv_meth_ast_accept7510[] = {1};
meth_meth_ast_accept7510->type = alloc_MethodType(1, argcv_meth_ast_accept7510);
meth_meth_ast_accept7510->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7510->type->names[0] = "visitor";
  meth_meth_ast_accept7510->definitionModule = modulename;
  meth_meth_ast_accept7510->definitionLine = 1740;
  struct UserObject *uo7513 = (struct UserObject*)obj7506;
  uo7513->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7513 = addmethod2pos(obj7506, "map()before()after", &meth_ast_map_40__41_before_40__41_after7513, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7513[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7513->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7513);
  meth_meth_ast_map_40__41_before_40__41_after7513->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7513->definitionLine = 1743;
  struct UserObject *uo7524 = (struct UserObject*)obj7506;
  uo7524->data[5] = emptyclosure;
  Method *meth_meth_ast_map7524 = addmethod2pos(obj7506, "map", &meth_ast_map7524, 5);
int argcv_meth_ast_map7524[] = {1};
meth_meth_ast_map7524->type = alloc_MethodType(1, argcv_meth_ast_map7524);
  meth_meth_ast_map7524->definitionModule = modulename;
  meth_meth_ast_map7524->definitionLine = 1750;
  struct UserObject *uo7533 = (struct UserObject*)obj7506;
  uo7533->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7533 = addmethod2pos(obj7506, "pretty", &meth_ast_pretty7533, 6);
int argcv_meth_ast_pretty7533[] = {1};
meth_meth_ast_pretty7533->type = alloc_MethodType(1, argcv_meth_ast_pretty7533);
  meth_meth_ast_pretty7533->definitionModule = modulename;
  meth_meth_ast_pretty7533->definitionLine = 1753;
  struct UserObject *uo7576 = (struct UserObject*)obj7506;
  uo7576->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7576 = addmethod2pos(obj7506, "toGrace", &meth_ast_toGrace7576, 7);
int argcv_meth_ast_toGrace7576[] = {1};
meth_meth_ast_toGrace7576->type = alloc_MethodType(1, argcv_meth_ast_toGrace7576);
meth_meth_ast_toGrace7576->type->types[0] = type_Number;
meth_meth_ast_toGrace7576->type->names[0] = "depth";
  meth_meth_ast_toGrace7576->definitionModule = modulename;
  meth_meth_ast_toGrace7576->definitionLine = 1763;
  sourceObject = obj7506;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7587 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7588 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7587);
// compilenode returning call7588
  struct UserObject *obj7506_uo = (struct UserObject *)obj7506;
  obj7506_uo->super = call7588;
  sourceObject = obj7506;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7589 == NULL) {
    strlit7589 = alloc_String("dialect");
    gc_root(strlit7589);
  }
// compilenode returning strlit7589
  adddatum2(obj7506, strlit7589, 1);
  sourceObject = obj7506;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7506, *var_path_39_, 2);
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
objclass7506 = obj7506->class;
  objclass7506->definitionModule = modulename;
  objclass7506->definitionLine = 1733;
  (*(struct UserObject *)self).data[0] = lowerouter7506;
  self = oldself7506;
  selfslot = oldselfslot7506;
  stackframe = oldstackframe7506;
  gc_frame_end(frame);
  return obj7506;
}
Object meth_ast_new7505_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_path_39_ = &(stackframe->slots[0]);
  *var_path_39_ = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7506 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7506 = alloc_userobj2(8,9, objclass7506);
  gc_frame_newslot(obj7506);
if (objclass7506 == NULL) {
  glfree(obj7506->class->name);
  obj7506->class->name = "dialectNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7506, self, 0);
  addmethodreal(obj7506,"outer", &reader_ast_outer_7507);
  Object oldself7506 = self;
  struct StackFrameObject *oldstackframe7506 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7506);
  gc_frame_newslot((Object)stackframe);
  self = obj7506;
  Object *oldselfslot7506 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7506 = (*(struct UserObject *)self).data[0], lowerouter7506 = thisouter7506;
  if (inheritingObject7506) {
    struct UserObject *inho7506 = (struct UserObject *)inheritingObject7506;
    while (inho7506->super != GraceDefaultObject) inho7506 = (struct UserObject *)inho7506->super;
    inho7506->super = obj7506;
    self = inheritingObject7506;
    *selfslot = self;
    lowerouter7506 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7506;
  }
if (objclass7506 == NULL) {
  Method *reader7508 = addmethodrealflags(obj7506, "kind",&reader_ast_kind_7508, MFLAG_DEF);
  reader7508->definitionModule = modulename;
  reader7508->definitionLine = 1739;
}
adddatum2(obj7506, alloc_Undefined(), 1);
if (objclass7506 == NULL) {
  Method *reader7509 = addmethodrealflags(obj7506, "value",&reader_ast_value_7509, MFLAG_DEF);
  reader7509->definitionModule = modulename;
  reader7509->definitionLine = 1740;
}
adddatum2(obj7506, alloc_Undefined(), 2);
  struct UserObject *uo7510 = (struct UserObject*)obj7506;
  uo7510->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7510 = addmethod2pos(obj7506, "accept", &meth_ast_accept7510, 3);
int argcv_meth_ast_accept7510[] = {1};
meth_meth_ast_accept7510->type = alloc_MethodType(1, argcv_meth_ast_accept7510);
meth_meth_ast_accept7510->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7510->type->names[0] = "visitor";
  meth_meth_ast_accept7510->definitionModule = modulename;
  meth_meth_ast_accept7510->definitionLine = 1740;
  struct UserObject *uo7513 = (struct UserObject*)obj7506;
  uo7513->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7513 = addmethod2pos(obj7506, "map()before()after", &meth_ast_map_40__41_before_40__41_after7513, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7513[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7513->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7513);
  meth_meth_ast_map_40__41_before_40__41_after7513->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7513->definitionLine = 1743;
  struct UserObject *uo7524 = (struct UserObject*)obj7506;
  uo7524->data[5] = emptyclosure;
  Method *meth_meth_ast_map7524 = addmethod2pos(obj7506, "map", &meth_ast_map7524, 5);
int argcv_meth_ast_map7524[] = {1};
meth_meth_ast_map7524->type = alloc_MethodType(1, argcv_meth_ast_map7524);
  meth_meth_ast_map7524->definitionModule = modulename;
  meth_meth_ast_map7524->definitionLine = 1750;
  struct UserObject *uo7533 = (struct UserObject*)obj7506;
  uo7533->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7533 = addmethod2pos(obj7506, "pretty", &meth_ast_pretty7533, 6);
int argcv_meth_ast_pretty7533[] = {1};
meth_meth_ast_pretty7533->type = alloc_MethodType(1, argcv_meth_ast_pretty7533);
  meth_meth_ast_pretty7533->definitionModule = modulename;
  meth_meth_ast_pretty7533->definitionLine = 1753;
  struct UserObject *uo7576 = (struct UserObject*)obj7506;
  uo7576->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7576 = addmethod2pos(obj7506, "toGrace", &meth_ast_toGrace7576, 7);
int argcv_meth_ast_toGrace7576[] = {1};
meth_meth_ast_toGrace7576->type = alloc_MethodType(1, argcv_meth_ast_toGrace7576);
meth_meth_ast_toGrace7576->type->types[0] = type_Number;
meth_meth_ast_toGrace7576->type->names[0] = "depth";
  meth_meth_ast_toGrace7576->definitionModule = modulename;
  meth_meth_ast_toGrace7576->definitionLine = 1763;
  sourceObject = obj7506;
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7587 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7588 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7587);
// compilenode returning call7588
  struct UserObject *obj7506_uo = (struct UserObject *)obj7506;
  obj7506_uo->super = call7588;
  sourceObject = obj7506;
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7589 == NULL) {
    strlit7589 = alloc_String("dialect");
    gc_root(strlit7589);
  }
// compilenode returning strlit7589
  adddatum2(obj7506, strlit7589, 1);
  sourceObject = obj7506;
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_path_39_
  adddatum2(obj7506, *var_path_39_, 2);
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
  sourceObject = obj7506;
objclass7506 = obj7506->class;
  objclass7506->definitionModule = modulename;
  objclass7506->definitionLine = 1733;
  (*(struct UserObject *)self).data[0] = lowerouter7506;
  self = oldself7506;
  selfslot = oldselfslot7506;
  stackframe = oldstackframe7506;
  gc_frame_end(frame);
  return obj7506;
}
Object meth_ast_returnNode7591(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "returnNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for returnNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for returnNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_returnNode
  gc_frame_end(frame);
  return *var_returnNode;
}
Object meth_ast_accept7599(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7601 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7602 = callmethod(*var_visitor, "visitReturn",
    1, partcv, params);
  gc_frame_end(callframe7601);
// compilenode returning call7602
  Object if7600 = done;
  if (istrue(call7602)) {
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7603 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7604 = gc_frame_new();
  partcv[0] = 0;
  Object call7605 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7604);
// compilenode returning call7605
// compilenode returning call7605
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7606 = callmethod(call7605, "accept",
    1, partcv, params);
  gc_frame_end(callframe7603);
// compilenode returning call7606
    gc_frame_newslot(call7606);
    if7600 = call7606;
  } else {
  }
// compilenode returning if7600
  gc_frame_end(frame);
  return if7600;
}
Object meth_ast_map_40__41_before_40__41_after7607(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_returnNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7608 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7609 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7608);
// compilenode returning call7609
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7610 = gc_frame_new();
  int callframe7611 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7612 = gc_frame_new();
  partcv[0] = 0;
  Object call7613 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7612);
// compilenode returning call7613
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7614 = callmethod(call7613, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7611);
// compilenode returning call7614
  gc_frame_newslot(call7614);
// compilenode returning *var_returnNode
  params[0] = call7614;
  partcv[0] = 1;
  Object call7615 = callmethod(*var_returnNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7610);
// compilenode returning call7615
  *var_n = call7615;
  if (call7615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7616 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7617 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7616);
// compilenode returning call7617
  *var_n = call7617;
  if (call7617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7619 = gc_frame_new();
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7620 = gc_frame_new();
  partcv[0] = 0;
  Object call7621 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7620);
// compilenode returning call7621
  gc_frame_newslot(call7621);
// compilenode returning *var_n
  params[0] = call7621;
  partcv[0] = 1;
  Object call7622 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7619);
// compilenode returning call7622
// compilenode returning done
// Begin line 1781
  setline(1781);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7623 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7624 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7623);
// compilenode returning call7624
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7631(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7626 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7627 = alloc_Block(NULL, NULL, "ast", 1785);
  gc_frame_newslot(block7627);
  block_savedest(block7627);
  Object closure7628 = createclosure(1, "_apply");
setclosureframe(closure7628, stackframe);
  addtoclosure(closure7628, selfslot);
  struct UserObject *uo7628 = (struct UserObject*)block7627;
  uo7628->data[0] = (Object)closure7628;
  Method *meth_meth_ast__apply7628 = addmethod2pos(block7627, "_apply", &meth_ast__apply7628, 0);
int argcv_meth_ast__apply7628[] = {0};
meth_meth_ast__apply7628->type = alloc_MethodType(1, argcv_meth_ast__apply7628);
  meth_meth_ast__apply7628->definitionModule = modulename;
  meth_meth_ast__apply7628->definitionLine = 1773;
// compilenode returning block7627
  gc_frame_newslot(block7627);
  Object block7630 = alloc_Block(NULL, NULL, "ast", 1785);
  gc_frame_newslot(block7630);
  block_savedest(block7630);
  Object closure7631 = createclosure(1, "_apply");
setclosureframe(closure7631, stackframe);
  addtoclosure(closure7631, selfslot);
  struct UserObject *uo7631 = (struct UserObject*)block7630;
  uo7631->data[0] = (Object)closure7631;
  Method *meth_meth_ast__apply7631 = addmethod2pos(block7630, "_apply", &meth_ast__apply7631, 0);
int argcv_meth_ast__apply7631[] = {0};
meth_meth_ast__apply7631->type = alloc_MethodType(1, argcv_meth_ast__apply7631);
  meth_meth_ast__apply7631->definitionModule = modulename;
  meth_meth_ast__apply7631->definitionLine = 1773;
// compilenode returning block7630
  gc_frame_newslot(block7630);
  params[0] = *var_blk;
  params[1] = block7627;
  params[2] = block7630;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7633 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7626);
// compilenode returning call7633
  gc_frame_end(frame);
  return call7633;
}
Object meth_ast__apply7642(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7644 == NULL) {
    strlit7644 = alloc_String("  ");
    gc_root(strlit7644);
  }
// compilenode returning strlit7644
  int op_slot_right_7643 = gc_frame_newslot(strlit7644);
// compilenode returning *var_spc
  int op_slot_left_7643 = gc_frame_newslot(*var_spc);
  params[0] = strlit7644;
  partcv[0] = 1;
  Object opresult7646 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7646
  *var_spc = opresult7646;
  if (opresult7646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7634(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7635 == NULL) {
    strlit7635 = alloc_String("");
    gc_root(strlit7635);
  }
// compilenode returning strlit7635
  *var_spc = strlit7635;
  if (strlit7635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7636 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7637 = gc_frame_newslot(*var_depth);
  Object num7639 = alloc_Float64(0);
// compilenode returning num7639
  int op_slot_left_7637 = gc_frame_newslot(num7639);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7640 = callmethod(num7639, "..", 1, partcv, params);
// compilenode returning opresult7640
  gc_frame_newslot(opresult7640);
  Object block7641 = alloc_Block(NULL, NULL, "ast", 1789);
  gc_frame_newslot(block7641);
  block_savedest(block7641);
  Object closure7642 = createclosure(2, "_apply");
setclosureframe(closure7642, stackframe);
  addtoclosure(closure7642, var_spc);
  addtoclosure(closure7642, selfslot);
  struct UserObject *uo7642 = (struct UserObject*)block7641;
  uo7642->data[0] = (Object)closure7642;
  Method *meth_meth_ast__apply7642 = addmethod2pos(block7641, "_apply", &meth_ast__apply7642, 0);
int argcv_meth_ast__apply7642[] = {1};
meth_meth_ast__apply7642->type = alloc_MethodType(1, argcv_meth_ast__apply7642);
  meth_meth_ast__apply7642->definitionModule = modulename;
  meth_meth_ast__apply7642->definitionLine = 1773;
// compilenode returning block7641
  gc_frame_newslot(block7641);
  params[0] = opresult7640;
  params[1] = block7641;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7649 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7636);
// compilenode returning call7649
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7650 == NULL) {
    strlit7650 = alloc_String("Return");
    gc_root(strlit7650);
  }
// compilenode returning strlit7650
  *var_s = strlit7650;
  if (strlit7650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7652 == NULL) {
    strlit7652 = alloc_String("""\x0a""");
    gc_root(strlit7652);
  }
// compilenode returning strlit7652
  int op_slot_right_7651 = gc_frame_newslot(strlit7652);
// compilenode returning *var_s
  int op_slot_left_7651 = gc_frame_newslot(*var_s);
  params[0] = strlit7652;
  partcv[0] = 1;
  Object opresult7654 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7654
  *var_s = opresult7654;
  if (opresult7654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7657 = gc_frame_new();
  Object num7659 = alloc_Float64(1);
// compilenode returning num7659
  int op_slot_right_7658 = gc_frame_newslot(num7659);
// compilenode returning *var_depth
  int op_slot_left_7658 = gc_frame_newslot(*var_depth);
  params[0] = num7659;
  partcv[0] = 1;
  Object sum7661 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7661
  gc_frame_newslot(sum7661);
  int callframe7662 = gc_frame_new();
  partcv[0] = 0;
  Object call7663 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7662);
// compilenode returning call7663
// compilenode returning call7663
  params[0] = sum7661;
  partcv[0] = 1;
  Object call7664 = callmethod(call7663, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7657);
// compilenode returning call7664
  int op_slot_right_7656 = gc_frame_newslot(call7664);
// compilenode returning *var_spc
  int op_slot_right_7666 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7666 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7668 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7668
  int op_slot_left_7656 = gc_frame_newslot(opresult7668);
  params[0] = call7664;
  partcv[0] = 1;
  Object opresult7669 = callmethod(opresult7668, "++", 1, partcv, params);
// compilenode returning opresult7669
  *var_s = opresult7669;
  if (opresult7669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7671(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7673 = gc_frame_new();
// compilenode returning *var_depth
  gc_frame_newslot(*var_depth);
  int callframe7674 = gc_frame_new();
  partcv[0] = 0;
  Object call7675 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7674);
// compilenode returning call7675
// compilenode returning call7675
  params[0] = *var_depth;
  partcv[0] = 1;
  Object call7676 = callmethod(call7675, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7673);
// compilenode returning call7676
  int op_slot_right_7672 = gc_frame_newslot(call7676);
  if (strlit7678 == NULL) {
    strlit7678 = alloc_String("return ");
    gc_root(strlit7678);
  }
// compilenode returning strlit7678
  int op_slot_left_7672 = gc_frame_newslot(strlit7678);
  params[0] = call7676;
  partcv[0] = 1;
  Object opresult7679 = callmethod(strlit7678, "++", 1, partcv, params);
// compilenode returning opresult7679
  gc_frame_end(frame);
  return opresult7679;
}
Object meth_ast_new7594(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_returnNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7595 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7595 = alloc_userobj2(8,9, objclass7595);
  gc_frame_newslot(obj7595);
if (objclass7595 == NULL) {
  glfree(obj7595->class->name);
  obj7595->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7595, self, 0);
  addmethodreal(obj7595,"outer", &reader_ast_outer_7596);
  Object oldself7595 = self;
  struct StackFrameObject *oldstackframe7595 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7595);
  gc_frame_newslot((Object)stackframe);
  self = obj7595;
  Object *oldselfslot7595 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7595 = (*(struct UserObject *)self).data[0], lowerouter7595 = thisouter7595;
  if (inheritingObject7595) {
    struct UserObject *inho7595 = (struct UserObject *)inheritingObject7595;
    while (inho7595->super != GraceDefaultObject) inho7595 = (struct UserObject *)inho7595->super;
    inho7595->super = obj7595;
    self = inheritingObject7595;
    *selfslot = self;
    lowerouter7595 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7595;
  }
if (objclass7595 == NULL) {
  Method *reader7597 = addmethodrealflags(obj7595, "kind",&reader_ast_kind_7597, MFLAG_DEF);
  reader7597->definitionModule = modulename;
  reader7597->definitionLine = 1770;
}
adddatum2(obj7595, alloc_Undefined(), 1);
if (objclass7595 == NULL) {
  Method *reader7598 = addmethodrealflags(obj7595, "value",&reader_ast_value_7598, MFLAG_DEF);
  reader7598->definitionModule = modulename;
  reader7598->definitionLine = 1771;
}
adddatum2(obj7595, alloc_Undefined(), 2);
  struct UserObject *uo7599 = (struct UserObject*)obj7595;
  uo7599->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7599 = addmethod2pos(obj7595, "accept", &meth_ast_accept7599, 3);
int argcv_meth_ast_accept7599[] = {1};
meth_meth_ast_accept7599->type = alloc_MethodType(1, argcv_meth_ast_accept7599);
meth_meth_ast_accept7599->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7599->type->names[0] = "visitor";
  meth_meth_ast_accept7599->definitionModule = modulename;
  meth_meth_ast_accept7599->definitionLine = 1771;
  block_savedest(obj7595);
  Object closure7607 = createclosure(1, "map()before()after");
setclosureframe(closure7607, stackframe);
  addtoclosure(closure7607, var_returnNode);
  struct UserObject *uo7607 = (struct UserObject*)obj7595;
  uo7607->data[4] = (Object)closure7607;
  Method *meth_meth_ast_map_40__41_before_40__41_after7607 = addmethod2pos(obj7595, "map()before()after", &meth_ast_map_40__41_before_40__41_after7607, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7607[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7607->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7607);
  meth_meth_ast_map_40__41_before_40__41_after7607->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7607->definitionLine = 1776;
  struct UserObject *uo7625 = (struct UserObject*)obj7595;
  uo7625->data[5] = emptyclosure;
  Method *meth_meth_ast_map7625 = addmethod2pos(obj7595, "map", &meth_ast_map7625, 5);
int argcv_meth_ast_map7625[] = {1};
meth_meth_ast_map7625->type = alloc_MethodType(1, argcv_meth_ast_map7625);
  meth_meth_ast_map7625->definitionModule = modulename;
  meth_meth_ast_map7625->definitionLine = 1784;
  struct UserObject *uo7634 = (struct UserObject*)obj7595;
  uo7634->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7634 = addmethod2pos(obj7595, "pretty", &meth_ast_pretty7634, 6);
int argcv_meth_ast_pretty7634[] = {1};
meth_meth_ast_pretty7634->type = alloc_MethodType(1, argcv_meth_ast_pretty7634);
  meth_meth_ast_pretty7634->definitionModule = modulename;
  meth_meth_ast_pretty7634->definitionLine = 1787;
  struct UserObject *uo7671 = (struct UserObject*)obj7595;
  uo7671->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7671 = addmethod2pos(obj7595, "toGrace", &meth_ast_toGrace7671, 7);
int argcv_meth_ast_toGrace7671[] = {1};
meth_meth_ast_toGrace7671->type = alloc_MethodType(1, argcv_meth_ast_toGrace7671);
meth_meth_ast_toGrace7671->type->types[0] = type_Number;
meth_meth_ast_toGrace7671->type->names[0] = "depth";
  meth_meth_ast_toGrace7671->definitionModule = modulename;
  meth_meth_ast_toGrace7671->definitionLine = 1797;
  sourceObject = obj7595;
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7680 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7681 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7680);
// compilenode returning call7681
  struct UserObject *obj7595_uo = (struct UserObject *)obj7595;
  obj7595_uo->super = call7681;
  sourceObject = obj7595;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7682 == NULL) {
    strlit7682 = alloc_String("return");
    gc_root(strlit7682);
  }
// compilenode returning strlit7682
  adddatum2(obj7595, strlit7682, 1);
  sourceObject = obj7595;
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7595, *var_expr, 2);
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
objclass7595 = obj7595->class;
  objclass7595->definitionModule = modulename;
  objclass7595->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter7595;
  self = oldself7595;
  selfslot = oldselfslot7595;
  stackframe = oldstackframe7595;
  gc_frame_end(frame);
  return obj7595;
}
Object meth_ast_new7594_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_returnNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7595 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7595 = alloc_userobj2(8,9, objclass7595);
  gc_frame_newslot(obj7595);
if (objclass7595 == NULL) {
  glfree(obj7595->class->name);
  obj7595->class->name = "returnNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7595, self, 0);
  addmethodreal(obj7595,"outer", &reader_ast_outer_7596);
  Object oldself7595 = self;
  struct StackFrameObject *oldstackframe7595 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7595);
  gc_frame_newslot((Object)stackframe);
  self = obj7595;
  Object *oldselfslot7595 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7595 = (*(struct UserObject *)self).data[0], lowerouter7595 = thisouter7595;
  if (inheritingObject7595) {
    struct UserObject *inho7595 = (struct UserObject *)inheritingObject7595;
    while (inho7595->super != GraceDefaultObject) inho7595 = (struct UserObject *)inho7595->super;
    inho7595->super = obj7595;
    self = inheritingObject7595;
    *selfslot = self;
    lowerouter7595 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7595;
  }
if (objclass7595 == NULL) {
  Method *reader7597 = addmethodrealflags(obj7595, "kind",&reader_ast_kind_7597, MFLAG_DEF);
  reader7597->definitionModule = modulename;
  reader7597->definitionLine = 1770;
}
adddatum2(obj7595, alloc_Undefined(), 1);
if (objclass7595 == NULL) {
  Method *reader7598 = addmethodrealflags(obj7595, "value",&reader_ast_value_7598, MFLAG_DEF);
  reader7598->definitionModule = modulename;
  reader7598->definitionLine = 1771;
}
adddatum2(obj7595, alloc_Undefined(), 2);
  struct UserObject *uo7599 = (struct UserObject*)obj7595;
  uo7599->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7599 = addmethod2pos(obj7595, "accept", &meth_ast_accept7599, 3);
int argcv_meth_ast_accept7599[] = {1};
meth_meth_ast_accept7599->type = alloc_MethodType(1, argcv_meth_ast_accept7599);
meth_meth_ast_accept7599->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7599->type->names[0] = "visitor";
  meth_meth_ast_accept7599->definitionModule = modulename;
  meth_meth_ast_accept7599->definitionLine = 1771;
  block_savedest(obj7595);
  Object closure7607 = createclosure(1, "map()before()after");
setclosureframe(closure7607, stackframe);
  addtoclosure(closure7607, var_returnNode);
  struct UserObject *uo7607 = (struct UserObject*)obj7595;
  uo7607->data[4] = (Object)closure7607;
  Method *meth_meth_ast_map_40__41_before_40__41_after7607 = addmethod2pos(obj7595, "map()before()after", &meth_ast_map_40__41_before_40__41_after7607, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7607[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7607->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7607);
  meth_meth_ast_map_40__41_before_40__41_after7607->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7607->definitionLine = 1776;
  struct UserObject *uo7625 = (struct UserObject*)obj7595;
  uo7625->data[5] = emptyclosure;
  Method *meth_meth_ast_map7625 = addmethod2pos(obj7595, "map", &meth_ast_map7625, 5);
int argcv_meth_ast_map7625[] = {1};
meth_meth_ast_map7625->type = alloc_MethodType(1, argcv_meth_ast_map7625);
  meth_meth_ast_map7625->definitionModule = modulename;
  meth_meth_ast_map7625->definitionLine = 1784;
  struct UserObject *uo7634 = (struct UserObject*)obj7595;
  uo7634->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7634 = addmethod2pos(obj7595, "pretty", &meth_ast_pretty7634, 6);
int argcv_meth_ast_pretty7634[] = {1};
meth_meth_ast_pretty7634->type = alloc_MethodType(1, argcv_meth_ast_pretty7634);
  meth_meth_ast_pretty7634->definitionModule = modulename;
  meth_meth_ast_pretty7634->definitionLine = 1787;
  struct UserObject *uo7671 = (struct UserObject*)obj7595;
  uo7671->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7671 = addmethod2pos(obj7595, "toGrace", &meth_ast_toGrace7671, 7);
int argcv_meth_ast_toGrace7671[] = {1};
meth_meth_ast_toGrace7671->type = alloc_MethodType(1, argcv_meth_ast_toGrace7671);
meth_meth_ast_toGrace7671->type->types[0] = type_Number;
meth_meth_ast_toGrace7671->type->names[0] = "depth";
  meth_meth_ast_toGrace7671->definitionModule = modulename;
  meth_meth_ast_toGrace7671->definitionLine = 1797;
  sourceObject = obj7595;
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7680 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7681 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7680);
// compilenode returning call7681
  struct UserObject *obj7595_uo = (struct UserObject *)obj7595;
  obj7595_uo->super = call7681;
  sourceObject = obj7595;
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7682 == NULL) {
    strlit7682 = alloc_String("return");
    gc_root(strlit7682);
  }
// compilenode returning strlit7682
  adddatum2(obj7595, strlit7682, 1);
  sourceObject = obj7595;
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7595, *var_expr, 2);
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
  sourceObject = obj7595;
objclass7595 = obj7595->class;
  objclass7595->definitionModule = modulename;
  objclass7595->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter7595;
  self = oldself7595;
  selfslot = oldselfslot7595;
  stackframe = oldstackframe7595;
  gc_frame_end(frame);
  return obj7595;
}
Object meth_ast_inheritsNode7684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for inheritsNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_inheritsNode
  gc_frame_end(frame);
  return *var_inheritsNode;
}
Object meth_ast_accept7692(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7694 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_visitor
  params[0] = self;
  partcv[0] = 1;
  Object call7695 = callmethod(*var_visitor, "visitInherits",
    1, partcv, params);
  gc_frame_end(callframe7694);
// compilenode returning call7695
  Object if7693 = done;
  if (istrue(call7695)) {
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7696 = gc_frame_new();
// compilenode returning *var_visitor
  gc_frame_newslot(*var_visitor);
  int callframe7697 = gc_frame_new();
  partcv[0] = 0;
  Object call7698 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7697);
// compilenode returning call7698
// compilenode returning call7698
  params[0] = *var_visitor;
  partcv[0] = 1;
  Object call7699 = callmethod(call7698, "accept",
    1, partcv, params);
  gc_frame_end(callframe7696);
// compilenode returning call7699
    gc_frame_newslot(call7699);
    if7693 = call7699;
  } else {
  }
// compilenode returning if7693
  gc_frame_end(frame);
  return if7693;
}
Object meth_ast_map_40__41_before_40__41_after7700(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7701 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7702 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7701);
// compilenode returning call7702
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7703 = gc_frame_new();
  int callframe7704 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7705 = gc_frame_new();
  partcv[0] = 0;
  Object call7706 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7705);
// compilenode returning call7706
  params[0] = *var_blk;
  params[1] = *var_blkBefore;
  params[2] = *var_blkAfter;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7707 = callmethod(call7706, "map()before()after",
    3, partcv, params);
  gc_frame_end(callframe7704);
// compilenode returning call7707
  gc_frame_newslot(call7707);
// compilenode returning *var_inheritsNode
  params[0] = call7707;
  partcv[0] = 1;
  Object call7708 = callmethod(*var_inheritsNode, "new",
    1, partcv, params);
  gc_frame_end(callframe7703);
// compilenode returning call7708
  *var_n = call7708;
  if (call7708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7709 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7710 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7709);
// compilenode returning call7710
  *var_n = call7710;
  if (call7710 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1807
  setline(1807);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7712 = gc_frame_new();
// Begin line 1814
  setline(1814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7713 = gc_frame_new();
  partcv[0] = 0;
  Object call7714 = callmethodflags(self, "line", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7713);
// compilenode returning call7714
  gc_frame_newslot(call7714);
// compilenode returning *var_n
  params[0] = call7714;
  partcv[0] = 1;
  Object call7715 = callmethod(*var_n, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7712);
// compilenode returning call7715
// compilenode returning done
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7716 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7717 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7716);
// compilenode returning call7717
// Begin line 1816
  setline(1816);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7721(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7724(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7718(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1819
  setline(1819);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7719 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7720 = alloc_Block(NULL, NULL, "ast", 1819);
  gc_frame_newslot(block7720);
  block_savedest(block7720);
  Object closure7721 = createclosure(1, "_apply");
setclosureframe(closure7721, stackframe);
  addtoclosure(closure7721, selfslot);
  struct UserObject *uo7721 = (struct UserObject*)block7720;
  uo7721->data[0] = (Object)closure7721;
  Method *meth_meth_ast__apply7721 = addmethod2pos(block7720, "_apply", &meth_ast__apply7721, 0);
int argcv_meth_ast__apply7721[] = {0};
meth_meth_ast__apply7721->type = alloc_MethodType(1, argcv_meth_ast__apply7721);
  meth_meth_ast__apply7721->definitionModule = modulename;
  meth_meth_ast__apply7721->definitionLine = 1807;
// compilenode returning block7720
  gc_frame_newslot(block7720);
  Object block7723 = alloc_Block(NULL, NULL, "ast", 1819);
  gc_frame_newslot(block7723);
  block_savedest(block7723);
  Object closure7724 = createclosure(1, "_apply");
setclosureframe(closure7724, stackframe);
  addtoclosure(closure7724, selfslot);
  struct UserObject *uo7724 = (struct UserObject*)block7723;
  uo7724->data[0] = (Object)closure7724;
  Method *meth_meth_ast__apply7724 = addmethod2pos(block7723, "_apply", &meth_ast__apply7724, 0);
int argcv_meth_ast__apply7724[] = {0};
meth_meth_ast__apply7724->type = alloc_MethodType(1, argcv_meth_ast__apply7724);
  meth_meth_ast__apply7724->definitionModule = modulename;
  meth_meth_ast__apply7724->definitionLine = 1807;
// compilenode returning block7723
  gc_frame_newslot(block7723);
  params[0] = *var_blk;
  params[1] = block7720;
  params[2] = block7723;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7726 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7719);
// compilenode returning call7726
  gc_frame_end(frame);
  return call7726;
}
Object meth_ast__apply7735(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_spc = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7737 == NULL) {
    strlit7737 = alloc_String("  ");
    gc_root(strlit7737);
  }
// compilenode returning strlit7737
  int op_slot_right_7736 = gc_frame_newslot(strlit7737);
// compilenode returning *var_spc
  int op_slot_left_7736 = gc_frame_newslot(*var_spc);
  params[0] = strlit7737;
  partcv[0] = 1;
  Object opresult7739 = callmethod(*var_spc, "++", 1, partcv, params);
// compilenode returning opresult7739
  *var_spc = opresult7739;
  if (opresult7739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_ast_pretty7727(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_spc = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "spc");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7728 == NULL) {
    strlit7728 = alloc_String("");
    gc_root(strlit7728);
  }
// compilenode returning strlit7728
  *var_spc = strlit7728;
  if (strlit7728 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7729 = gc_frame_new();
// compilenode returning *var_depth
  int op_slot_right_7730 = gc_frame_newslot(*var_depth);
  Object num7732 = alloc_Float64(0);
// compilenode returning num7732
  int op_slot_left_7730 = gc_frame_newslot(num7732);
  params[0] = *var_depth;
  partcv[0] = 1;
  Object opresult7733 = callmethod(num7732, "..", 1, partcv, params);
// compilenode returning opresult7733
  gc_frame_newslot(opresult7733);
  Object block7734 = alloc_Block(NULL, NULL, "ast", 1823);
  gc_frame_newslot(block7734);
  block_savedest(block7734);
  Object closure7735 = createclosure(2, "_apply");
setclosureframe(closure7735, stackframe);
  addtoclosure(closure7735, var_spc);
  addtoclosure(closure7735, selfslot);
  struct UserObject *uo7735 = (struct UserObject*)block7734;
  uo7735->data[0] = (Object)closure7735;
  Method *meth_meth_ast__apply7735 = addmethod2pos(block7734, "_apply", &meth_ast__apply7735, 0);
int argcv_meth_ast__apply7735[] = {1};
meth_meth_ast__apply7735->type = alloc_MethodType(1, argcv_meth_ast__apply7735);
  meth_meth_ast__apply7735->definitionModule = modulename;
  meth_meth_ast__apply7735->definitionLine = 1807;
// compilenode returning block7734
  gc_frame_newslot(block7734);
  params[0] = opresult7733;
  params[1] = block7734;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7742 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7729);
// compilenode returning call7742
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1826
  setline(1826);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7743 == NULL) {
    strlit7743 = alloc_String("Inherits");
    gc_root(strlit7743);
  }
// compilenode returning strlit7743
  *var_s = strlit7743;
  if (strlit7743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7745 == NULL) {
    strlit7745 = alloc_String("""\x0a""");
    gc_root(strlit7745);
  }
// compilenode returning strlit7745
  int op_slot_right_7744 = gc_frame_newslot(strlit7745);
// compilenode returning *var_s
  int op_slot_left_7744 = gc_frame_newslot(*var_s);
  params[0] = strlit7745;
  partcv[0] = 1;
  Object opresult7747 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7747
  *var_s = opresult7747;
  if (opresult7747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1828
  setline(1828);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7750 = gc_frame_new();
  Object num7752 = alloc_Float64(1);
// compilenode returning num7752
  int op_slot_right_7751 = gc_frame_newslot(num7752);
// compilenode returning *var_depth
  int op_slot_left_7751 = gc_frame_newslot(*var_depth);
  params[0] = num7752;
  partcv[0] = 1;
  Object sum7754 = callmethod(*var_depth, "+", 1, partcv, params);
// compilenode returning sum7754
  gc_frame_newslot(sum7754);
  int callframe7755 = gc_frame_new();
  partcv[0] = 0;
  Object call7756 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7755);
// compilenode returning call7756
// compilenode returning call7756
  params[0] = sum7754;
  partcv[0] = 1;
  Object call7757 = callmethod(call7756, "pretty",
    1, partcv, params);
  gc_frame_end(callframe7750);
// compilenode returning call7757
  int op_slot_right_7749 = gc_frame_newslot(call7757);
// compilenode returning *var_spc
  int op_slot_right_7759 = gc_frame_newslot(*var_spc);
// compilenode returning *var_s
  int op_slot_left_7759 = gc_frame_newslot(*var_s);
  params[0] = *var_spc;
  partcv[0] = 1;
  Object opresult7761 = callmethod(*var_s, "++", 1, partcv, params);
// compilenode returning opresult7761
  int op_slot_left_7749 = gc_frame_newslot(opresult7761);
  params[0] = call7757;
  partcv[0] = 1;
  Object opresult7762 = callmethod(opresult7761, "++", 1, partcv, params);
// compilenode returning opresult7762
  *var_s = opresult7762;
  if (opresult7762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_s
  gc_frame_end(frame);
  return *var_s;
}
Object meth_ast_toGrace7764(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7766 == NULL) {
    strlit7766 = alloc_String("");
    gc_root(strlit7766);
  }
// compilenode returning strlit7766
  int op_slot_right_7765 = gc_frame_newslot(strlit7766);
  int callframe7769 = gc_frame_new();
  Object num7770 = alloc_Float64(0);
// compilenode returning num7770
  gc_frame_newslot(num7770);
  int callframe7771 = gc_frame_new();
  partcv[0] = 0;
  Object call7772 = callmethodflags(self, "value", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7771);
// compilenode returning call7772
// compilenode returning call7772
  params[0] = num7770;
  partcv[0] = 1;
  Object call7773 = callmethod(call7772, "toGrace",
    1, partcv, params);
  gc_frame_end(callframe7769);
// compilenode returning call7773
  int op_slot_right_7768 = gc_frame_newslot(call7773);
  if (strlit7775 == NULL) {
    strlit7775 = alloc_String("inherits ");
    gc_root(strlit7775);
  }
// compilenode returning strlit7775
  int op_slot_left_7768 = gc_frame_newslot(strlit7775);
  params[0] = call7773;
  partcv[0] = 1;
  Object opresult7776 = callmethod(strlit7775, "++", 1, partcv, params);
// compilenode returning opresult7776
  int op_slot_left_7765 = gc_frame_newslot(opresult7776);
  params[0] = strlit7766;
  partcv[0] = 1;
  Object opresult7777 = callmethod(opresult7776, "++", 1, partcv, params);
// compilenode returning opresult7777
  gc_frame_end(frame);
  return opresult7777;
}
Object meth_ast_new7687(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7688 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7688 = alloc_userobj2(8,9, objclass7688);
  gc_frame_newslot(obj7688);
if (objclass7688 == NULL) {
  glfree(obj7688->class->name);
  obj7688->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7688, self, 0);
  addmethodreal(obj7688,"outer", &reader_ast_outer_7689);
  Object oldself7688 = self;
  struct StackFrameObject *oldstackframe7688 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7688);
  gc_frame_newslot((Object)stackframe);
  self = obj7688;
  Object *oldselfslot7688 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7688 = (*(struct UserObject *)self).data[0], lowerouter7688 = thisouter7688;
  if (inheritingObject7688) {
    struct UserObject *inho7688 = (struct UserObject *)inheritingObject7688;
    while (inho7688->super != GraceDefaultObject) inho7688 = (struct UserObject *)inho7688->super;
    inho7688->super = obj7688;
    self = inheritingObject7688;
    *selfslot = self;
    lowerouter7688 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7688;
  }
if (objclass7688 == NULL) {
  Method *reader7690 = addmethodrealflags(obj7688, "kind",&reader_ast_kind_7690, MFLAG_DEF);
  reader7690->definitionModule = modulename;
  reader7690->definitionLine = 1804;
}
adddatum2(obj7688, alloc_Undefined(), 1);
if (objclass7688 == NULL) {
  Method *reader7691 = addmethodrealflags(obj7688, "value",&reader_ast_value_7691, MFLAG_DEF);
  reader7691->definitionModule = modulename;
  reader7691->definitionLine = 1805;
}
adddatum2(obj7688, alloc_Undefined(), 2);
  struct UserObject *uo7692 = (struct UserObject*)obj7688;
  uo7692->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7692 = addmethod2pos(obj7688, "accept", &meth_ast_accept7692, 3);
int argcv_meth_ast_accept7692[] = {1};
meth_meth_ast_accept7692->type = alloc_MethodType(1, argcv_meth_ast_accept7692);
meth_meth_ast_accept7692->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7692->type->names[0] = "visitor";
  meth_meth_ast_accept7692->definitionModule = modulename;
  meth_meth_ast_accept7692->definitionLine = 1805;
  block_savedest(obj7688);
  Object closure7700 = createclosure(1, "map()before()after");
setclosureframe(closure7700, stackframe);
  addtoclosure(closure7700, var_inheritsNode);
  struct UserObject *uo7700 = (struct UserObject*)obj7688;
  uo7700->data[4] = (Object)closure7700;
  Method *meth_meth_ast_map_40__41_before_40__41_after7700 = addmethod2pos(obj7688, "map()before()after", &meth_ast_map_40__41_before_40__41_after7700, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7700[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7700->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7700);
  meth_meth_ast_map_40__41_before_40__41_after7700->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7700->definitionLine = 1810;
  struct UserObject *uo7718 = (struct UserObject*)obj7688;
  uo7718->data[5] = emptyclosure;
  Method *meth_meth_ast_map7718 = addmethod2pos(obj7688, "map", &meth_ast_map7718, 5);
int argcv_meth_ast_map7718[] = {1};
meth_meth_ast_map7718->type = alloc_MethodType(1, argcv_meth_ast_map7718);
  meth_meth_ast_map7718->definitionModule = modulename;
  meth_meth_ast_map7718->definitionLine = 1818;
  struct UserObject *uo7727 = (struct UserObject*)obj7688;
  uo7727->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7727 = addmethod2pos(obj7688, "pretty", &meth_ast_pretty7727, 6);
int argcv_meth_ast_pretty7727[] = {1};
meth_meth_ast_pretty7727->type = alloc_MethodType(1, argcv_meth_ast_pretty7727);
  meth_meth_ast_pretty7727->definitionModule = modulename;
  meth_meth_ast_pretty7727->definitionLine = 1821;
  struct UserObject *uo7764 = (struct UserObject*)obj7688;
  uo7764->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7764 = addmethod2pos(obj7688, "toGrace", &meth_ast_toGrace7764, 7);
int argcv_meth_ast_toGrace7764[] = {1};
meth_meth_ast_toGrace7764->type = alloc_MethodType(1, argcv_meth_ast_toGrace7764);
meth_meth_ast_toGrace7764->type->types[0] = type_Number;
meth_meth_ast_toGrace7764->type->names[0] = "depth";
  meth_meth_ast_toGrace7764->definitionModule = modulename;
  meth_meth_ast_toGrace7764->definitionLine = 1831;
  sourceObject = obj7688;
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7778 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7779 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7778);
// compilenode returning call7779
  struct UserObject *obj7688_uo = (struct UserObject *)obj7688;
  obj7688_uo->super = call7779;
  sourceObject = obj7688;
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7780 == NULL) {
    strlit7780 = alloc_String("inherits");
    gc_root(strlit7780);
  }
// compilenode returning strlit7780
  adddatum2(obj7688, strlit7780, 1);
  sourceObject = obj7688;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7688, *var_expr, 2);
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
objclass7688 = obj7688->class;
  objclass7688->definitionModule = modulename;
  objclass7688->definitionLine = 1798;
  (*(struct UserObject *)self).data[0] = lowerouter7688;
  self = oldself7688;
  selfslot = oldselfslot7688;
  stackframe = oldstackframe7688;
  gc_frame_end(frame);
  return obj7688;
}
Object meth_ast_new7687_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[2];
  Object *var_inheritsNode = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_expr = &(stackframe->slots[0]);
  *var_expr = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7688 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7688 = alloc_userobj2(8,9, objclass7688);
  gc_frame_newslot(obj7688);
if (objclass7688 == NULL) {
  glfree(obj7688->class->name);
  obj7688->class->name = "inheritsNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7688, self, 0);
  addmethodreal(obj7688,"outer", &reader_ast_outer_7689);
  Object oldself7688 = self;
  struct StackFrameObject *oldstackframe7688 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7688);
  gc_frame_newslot((Object)stackframe);
  self = obj7688;
  Object *oldselfslot7688 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7688 = (*(struct UserObject *)self).data[0], lowerouter7688 = thisouter7688;
  if (inheritingObject7688) {
    struct UserObject *inho7688 = (struct UserObject *)inheritingObject7688;
    while (inho7688->super != GraceDefaultObject) inho7688 = (struct UserObject *)inho7688->super;
    inho7688->super = obj7688;
    self = inheritingObject7688;
    *selfslot = self;
    lowerouter7688 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7688;
  }
if (objclass7688 == NULL) {
  Method *reader7690 = addmethodrealflags(obj7688, "kind",&reader_ast_kind_7690, MFLAG_DEF);
  reader7690->definitionModule = modulename;
  reader7690->definitionLine = 1804;
}
adddatum2(obj7688, alloc_Undefined(), 1);
if (objclass7688 == NULL) {
  Method *reader7691 = addmethodrealflags(obj7688, "value",&reader_ast_value_7691, MFLAG_DEF);
  reader7691->definitionModule = modulename;
  reader7691->definitionLine = 1805;
}
adddatum2(obj7688, alloc_Undefined(), 2);
  struct UserObject *uo7692 = (struct UserObject*)obj7688;
  uo7692->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7692 = addmethod2pos(obj7688, "accept", &meth_ast_accept7692, 3);
int argcv_meth_ast_accept7692[] = {1};
meth_meth_ast_accept7692->type = alloc_MethodType(1, argcv_meth_ast_accept7692);
meth_meth_ast_accept7692->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7692->type->names[0] = "visitor";
  meth_meth_ast_accept7692->definitionModule = modulename;
  meth_meth_ast_accept7692->definitionLine = 1805;
  block_savedest(obj7688);
  Object closure7700 = createclosure(1, "map()before()after");
setclosureframe(closure7700, stackframe);
  addtoclosure(closure7700, var_inheritsNode);
  struct UserObject *uo7700 = (struct UserObject*)obj7688;
  uo7700->data[4] = (Object)closure7700;
  Method *meth_meth_ast_map_40__41_before_40__41_after7700 = addmethod2pos(obj7688, "map()before()after", &meth_ast_map_40__41_before_40__41_after7700, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7700[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7700->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7700);
  meth_meth_ast_map_40__41_before_40__41_after7700->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7700->definitionLine = 1810;
  struct UserObject *uo7718 = (struct UserObject*)obj7688;
  uo7718->data[5] = emptyclosure;
  Method *meth_meth_ast_map7718 = addmethod2pos(obj7688, "map", &meth_ast_map7718, 5);
int argcv_meth_ast_map7718[] = {1};
meth_meth_ast_map7718->type = alloc_MethodType(1, argcv_meth_ast_map7718);
  meth_meth_ast_map7718->definitionModule = modulename;
  meth_meth_ast_map7718->definitionLine = 1818;
  struct UserObject *uo7727 = (struct UserObject*)obj7688;
  uo7727->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7727 = addmethod2pos(obj7688, "pretty", &meth_ast_pretty7727, 6);
int argcv_meth_ast_pretty7727[] = {1};
meth_meth_ast_pretty7727->type = alloc_MethodType(1, argcv_meth_ast_pretty7727);
  meth_meth_ast_pretty7727->definitionModule = modulename;
  meth_meth_ast_pretty7727->definitionLine = 1821;
  struct UserObject *uo7764 = (struct UserObject*)obj7688;
  uo7764->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7764 = addmethod2pos(obj7688, "toGrace", &meth_ast_toGrace7764, 7);
int argcv_meth_ast_toGrace7764[] = {1};
meth_meth_ast_toGrace7764->type = alloc_MethodType(1, argcv_meth_ast_toGrace7764);
meth_meth_ast_toGrace7764->type->types[0] = type_Number;
meth_meth_ast_toGrace7764->type->names[0] = "depth";
  meth_meth_ast_toGrace7764->definitionModule = modulename;
  meth_meth_ast_toGrace7764->definitionLine = 1831;
  sourceObject = obj7688;
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7778 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7779 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7778);
// compilenode returning call7779
  struct UserObject *obj7688_uo = (struct UserObject *)obj7688;
  obj7688_uo->super = call7779;
  sourceObject = obj7688;
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7780 == NULL) {
    strlit7780 = alloc_String("inherits");
    gc_root(strlit7780);
  }
// compilenode returning strlit7780
  adddatum2(obj7688, strlit7780, 1);
  sourceObject = obj7688;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_expr
  adddatum2(obj7688, *var_expr, 2);
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
  sourceObject = obj7688;
objclass7688 = obj7688->class;
  objclass7688->definitionModule = modulename;
  objclass7688->definitionLine = 1798;
  (*(struct UserObject *)self).data[0] = lowerouter7688;
  self = oldself7688;
  selfslot = oldselfslot7688;
  stackframe = oldstackframe7688;
  gc_frame_end(frame);
  return obj7688;
}
Object meth_ast_blankNode7782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blankNode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_blankNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blankNode (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for blankNode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_blankNode
  gc_frame_end(frame);
  return *var_blankNode;
}
Object meth_ast_accept7790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_visitor = &(stackframe->slots[0]);
  *var_visitor = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map_40__41_before_40__41_after7791(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning self
  gc_frame_end(frame);
  return self;
}
Object meth_ast__apply7795(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7798(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7793 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7794 = alloc_Block(NULL, NULL, "ast", 1845);
  gc_frame_newslot(block7794);
  block_savedest(block7794);
  Object closure7795 = createclosure(1, "_apply");
setclosureframe(closure7795, stackframe);
  addtoclosure(closure7795, selfslot);
  struct UserObject *uo7795 = (struct UserObject*)block7794;
  uo7795->data[0] = (Object)closure7795;
  Method *meth_meth_ast__apply7795 = addmethod2pos(block7794, "_apply", &meth_ast__apply7795, 0);
int argcv_meth_ast__apply7795[] = {0};
meth_meth_ast__apply7795->type = alloc_MethodType(1, argcv_meth_ast__apply7795);
  meth_meth_ast__apply7795->definitionModule = modulename;
  meth_meth_ast__apply7795->definitionLine = 1832;
// compilenode returning block7794
  gc_frame_newslot(block7794);
  Object block7797 = alloc_Block(NULL, NULL, "ast", 1845);
  gc_frame_newslot(block7797);
  block_savedest(block7797);
  Object closure7798 = createclosure(1, "_apply");
setclosureframe(closure7798, stackframe);
  addtoclosure(closure7798, selfslot);
  struct UserObject *uo7798 = (struct UserObject*)block7797;
  uo7798->data[0] = (Object)closure7798;
  Method *meth_meth_ast__apply7798 = addmethod2pos(block7797, "_apply", &meth_ast__apply7798, 0);
int argcv_meth_ast__apply7798[] = {0};
meth_meth_ast__apply7798->type = alloc_MethodType(1, argcv_meth_ast__apply7798);
  meth_meth_ast__apply7798->definitionModule = modulename;
  meth_meth_ast__apply7798->definitionLine = 1832;
// compilenode returning block7797
  gc_frame_newslot(block7797);
  params[0] = *var_blk;
  params[1] = block7794;
  params[2] = block7797;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7800 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7793);
// compilenode returning call7800
  gc_frame_end(frame);
  return call7800;
}
Object meth_ast_pretty7801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pretty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pretty (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for pretty");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7802 == NULL) {
    strlit7802 = alloc_String("Blank");
    gc_root(strlit7802);
  }
// compilenode returning strlit7802
  gc_frame_end(frame);
  return strlit7802;
}
Object meth_ast_toGrace7803(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toGrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toGrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_depth = &(stackframe->slots[0]);
  *var_depth = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toGrace");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7804 == NULL) {
    strlit7804 = alloc_String("");
    gc_root(strlit7804);
  }
// compilenode returning strlit7804
  gc_frame_end(frame);
  return strlit7804;
}
Object meth_ast_new7785(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7786 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7786 = alloc_userobj2(8,9, objclass7786);
  gc_frame_newslot(obj7786);
if (objclass7786 == NULL) {
  glfree(obj7786->class->name);
  obj7786->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7786, self, 0);
  addmethodreal(obj7786,"outer", &reader_ast_outer_7787);
  Object oldself7786 = self;
  struct StackFrameObject *oldstackframe7786 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7786);
  gc_frame_newslot((Object)stackframe);
  self = obj7786;
  Object *oldselfslot7786 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7786 = (*(struct UserObject *)self).data[0], lowerouter7786 = thisouter7786;
  if (inheritingObject7786) {
    struct UserObject *inho7786 = (struct UserObject *)inheritingObject7786;
    while (inho7786->super != GraceDefaultObject) inho7786 = (struct UserObject *)inho7786->super;
    inho7786->super = obj7786;
    self = inheritingObject7786;
    *selfslot = self;
    lowerouter7786 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7786;
  }
if (objclass7786 == NULL) {
  Method *reader7788 = addmethodrealflags(obj7786, "kind",&reader_ast_kind_7788, MFLAG_DEF);
  reader7788->definitionModule = modulename;
  reader7788->definitionLine = 1838;
}
adddatum2(obj7786, alloc_Undefined(), 1);
if (objclass7786 == NULL) {
  Method *reader7789 = addmethodrealflags(obj7786, "value",&reader_ast_value_7789, MFLAG_DEF);
  reader7789->definitionModule = modulename;
  reader7789->definitionLine = 1839;
}
adddatum2(obj7786, alloc_Undefined(), 2);
  struct UserObject *uo7790 = (struct UserObject*)obj7786;
  uo7790->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7790 = addmethod2pos(obj7786, "accept", &meth_ast_accept7790, 3);
int argcv_meth_ast_accept7790[] = {1};
meth_meth_ast_accept7790->type = alloc_MethodType(1, argcv_meth_ast_accept7790);
meth_meth_ast_accept7790->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7790->type->names[0] = "visitor";
  meth_meth_ast_accept7790->definitionModule = modulename;
  meth_meth_ast_accept7790->definitionLine = 1839;
  struct UserObject *uo7791 = (struct UserObject*)obj7786;
  uo7791->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7791 = addmethod2pos(obj7786, "map()before()after", &meth_ast_map_40__41_before_40__41_after7791, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7791[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7791->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7791);
  meth_meth_ast_map_40__41_before_40__41_after7791->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7791->definitionLine = 1841;
  struct UserObject *uo7792 = (struct UserObject*)obj7786;
  uo7792->data[5] = emptyclosure;
  Method *meth_meth_ast_map7792 = addmethod2pos(obj7786, "map", &meth_ast_map7792, 5);
int argcv_meth_ast_map7792[] = {1};
meth_meth_ast_map7792->type = alloc_MethodType(1, argcv_meth_ast_map7792);
  meth_meth_ast_map7792->definitionModule = modulename;
  meth_meth_ast_map7792->definitionLine = 1844;
  struct UserObject *uo7801 = (struct UserObject*)obj7786;
  uo7801->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7801 = addmethod2pos(obj7786, "pretty", &meth_ast_pretty7801, 6);
int argcv_meth_ast_pretty7801[] = {1};
meth_meth_ast_pretty7801->type = alloc_MethodType(1, argcv_meth_ast_pretty7801);
  meth_meth_ast_pretty7801->definitionModule = modulename;
  meth_meth_ast_pretty7801->definitionLine = 1847;
  struct UserObject *uo7803 = (struct UserObject*)obj7786;
  uo7803->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7803 = addmethod2pos(obj7786, "toGrace", &meth_ast_toGrace7803, 7);
int argcv_meth_ast_toGrace7803[] = {1};
meth_meth_ast_toGrace7803->type = alloc_MethodType(1, argcv_meth_ast_toGrace7803);
meth_meth_ast_toGrace7803->type->types[0] = type_Number;
meth_meth_ast_toGrace7803->type->names[0] = "depth";
  meth_meth_ast_toGrace7803->definitionModule = modulename;
  meth_meth_ast_toGrace7803->definitionLine = 1850;
  sourceObject = obj7786;
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7805 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7806 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7805);
// compilenode returning call7806
  struct UserObject *obj7786_uo = (struct UserObject *)obj7786;
  obj7786_uo->super = call7806;
  sourceObject = obj7786;
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7807 == NULL) {
    strlit7807 = alloc_String("blank");
    gc_root(strlit7807);
  }
// compilenode returning strlit7807
  adddatum2(obj7786, strlit7807, 1);
  sourceObject = obj7786;
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7808 == NULL) {
    strlit7808 = alloc_String("blank");
    gc_root(strlit7808);
  }
// compilenode returning strlit7808
  adddatum2(obj7786, strlit7808, 2);
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
objclass7786 = obj7786->class;
  objclass7786->definitionModule = modulename;
  objclass7786->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7786;
  self = oldself7786;
  selfslot = oldselfslot7786;
  stackframe = oldstackframe7786;
  gc_frame_end(frame);
  return obj7786;
}
Object meth_ast_new7785_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_baseNode = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7786 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7786 = alloc_userobj2(8,9, objclass7786);
  gc_frame_newslot(obj7786);
if (objclass7786 == NULL) {
  glfree(obj7786->class->name);
  obj7786->class->name = "blankNode";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7786, self, 0);
  addmethodreal(obj7786,"outer", &reader_ast_outer_7787);
  Object oldself7786 = self;
  struct StackFrameObject *oldstackframe7786 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7786);
  gc_frame_newslot((Object)stackframe);
  self = obj7786;
  Object *oldselfslot7786 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7786 = (*(struct UserObject *)self).data[0], lowerouter7786 = thisouter7786;
  if (inheritingObject7786) {
    struct UserObject *inho7786 = (struct UserObject *)inheritingObject7786;
    while (inho7786->super != GraceDefaultObject) inho7786 = (struct UserObject *)inho7786->super;
    inho7786->super = obj7786;
    self = inheritingObject7786;
    *selfslot = self;
    lowerouter7786 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7786;
  }
if (objclass7786 == NULL) {
  Method *reader7788 = addmethodrealflags(obj7786, "kind",&reader_ast_kind_7788, MFLAG_DEF);
  reader7788->definitionModule = modulename;
  reader7788->definitionLine = 1838;
}
adddatum2(obj7786, alloc_Undefined(), 1);
if (objclass7786 == NULL) {
  Method *reader7789 = addmethodrealflags(obj7786, "value",&reader_ast_value_7789, MFLAG_DEF);
  reader7789->definitionModule = modulename;
  reader7789->definitionLine = 1839;
}
adddatum2(obj7786, alloc_Undefined(), 2);
  struct UserObject *uo7790 = (struct UserObject*)obj7786;
  uo7790->data[3] = emptyclosure;
  Method *meth_meth_ast_accept7790 = addmethod2pos(obj7786, "accept", &meth_ast_accept7790, 3);
int argcv_meth_ast_accept7790[] = {1};
meth_meth_ast_accept7790->type = alloc_MethodType(1, argcv_meth_ast_accept7790);
meth_meth_ast_accept7790->type->types[0] = type_ASTVisitor;
meth_meth_ast_accept7790->type->names[0] = "visitor";
  meth_meth_ast_accept7790->definitionModule = modulename;
  meth_meth_ast_accept7790->definitionLine = 1839;
  struct UserObject *uo7791 = (struct UserObject*)obj7786;
  uo7791->data[4] = emptyclosure;
  Method *meth_meth_ast_map_40__41_before_40__41_after7791 = addmethod2pos(obj7786, "map()before()after", &meth_ast_map_40__41_before_40__41_after7791, 4);
int argcv_meth_ast_map_40__41_before_40__41_after7791[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7791->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7791);
  meth_meth_ast_map_40__41_before_40__41_after7791->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7791->definitionLine = 1841;
  struct UserObject *uo7792 = (struct UserObject*)obj7786;
  uo7792->data[5] = emptyclosure;
  Method *meth_meth_ast_map7792 = addmethod2pos(obj7786, "map", &meth_ast_map7792, 5);
int argcv_meth_ast_map7792[] = {1};
meth_meth_ast_map7792->type = alloc_MethodType(1, argcv_meth_ast_map7792);
  meth_meth_ast_map7792->definitionModule = modulename;
  meth_meth_ast_map7792->definitionLine = 1844;
  struct UserObject *uo7801 = (struct UserObject*)obj7786;
  uo7801->data[6] = emptyclosure;
  Method *meth_meth_ast_pretty7801 = addmethod2pos(obj7786, "pretty", &meth_ast_pretty7801, 6);
int argcv_meth_ast_pretty7801[] = {1};
meth_meth_ast_pretty7801->type = alloc_MethodType(1, argcv_meth_ast_pretty7801);
  meth_meth_ast_pretty7801->definitionModule = modulename;
  meth_meth_ast_pretty7801->definitionLine = 1847;
  struct UserObject *uo7803 = (struct UserObject*)obj7786;
  uo7803->data[7] = emptyclosure;
  Method *meth_meth_ast_toGrace7803 = addmethod2pos(obj7786, "toGrace", &meth_ast_toGrace7803, 7);
int argcv_meth_ast_toGrace7803[] = {1};
meth_meth_ast_toGrace7803->type = alloc_MethodType(1, argcv_meth_ast_toGrace7803);
meth_meth_ast_toGrace7803->type->types[0] = type_Number;
meth_meth_ast_toGrace7803->type->names[0] = "depth";
  meth_meth_ast_toGrace7803->definitionModule = modulename;
  meth_meth_ast_toGrace7803->definitionLine = 1850;
  sourceObject = obj7786;
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7805 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7806 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7805);
// compilenode returning call7806
  struct UserObject *obj7786_uo = (struct UserObject *)obj7786;
  obj7786_uo->super = call7806;
  sourceObject = obj7786;
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7807 == NULL) {
    strlit7807 = alloc_String("blank");
    gc_root(strlit7807);
  }
// compilenode returning strlit7807
  adddatum2(obj7786, strlit7807, 1);
  sourceObject = obj7786;
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7808 == NULL) {
    strlit7808 = alloc_String("blank");
    gc_root(strlit7808);
  }
// compilenode returning strlit7808
  adddatum2(obj7786, strlit7808, 2);
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
  sourceObject = obj7786;
objclass7786 = obj7786->class;
  objclass7786->definitionModule = modulename;
  objclass7786->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7786;
  self = oldself7786;
  selfslot = oldselfslot7786;
  stackframe = oldstackframe7786;
  gc_frame_end(frame);
  return obj7786;
}
Object meth_ast_signaturePart7810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "signaturePart");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for signaturePart (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for signaturePart");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signaturePart
  gc_frame_end(frame);
  return *var_signaturePart;
}
Object meth_ast_map_40__41_before_40__41_after7821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "map()before()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[2] < 1)
    gracedie("insufficient arguments to method");
  Object params[4];
  int partcv[3];
  Object *var_signaturePart = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    gracedie("missing argument list for map()before()after (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *var_blkBefore = &(stackframe->slots[1]);
  *var_blkBefore = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for before");
  Object *var_blkAfter = &(stackframe->slots[2]);
  *var_blkAfter = args[curarg];
  curarg++;
if (argcv && argcv[2] > 1)
  gracedie("too many arguments for after");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "n");
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7822 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_blkBefore
  params[0] = self;
  partcv[0] = 1;
  Object call7823 = callmethod(*var_blkBefore, "apply",
    1, partcv, params);
  gc_frame_end(callframe7822);
// compilenode returning call7823
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7824 = gc_frame_new();
  int callframe7825 = gc_frame_new();
  partcv[0] = 0;
  Object call7826 = callmethodflags(self, "name", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7825);
// compilenode returning call7826
  gc_frame_newslot(call7826);
  int callframe7827 = gc_frame_new();
  int callframe7828 = gc_frame_new();
  partcv[0] = 0;
  Object call7829 = callmethodflags(self, "params", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7828);
// compilenode returning call7829
  gc_frame_newslot(call7829);
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
// compilenode returning *var_blkBefore
  gc_frame_newslot(*var_blkBefore);
// compilenode returning *var_blkAfter
  gc_frame_newslot(*var_blkAfter);
  int callframe7830 = gc_frame_new();
  int callframe7831 = gc_frame_new();
  Object call7832 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe7831);
// compilenode returning call7832
// compilenode returning call7832
  partcv[0] = 0;
  Object call7833 = callmethodflags(call7832, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7830);
// compilenode returning call7833
// compilenode returning call7833
  params[0] = call7829;
  params[1] = *var_blk;
  params[2] = *var_blkBefore;
  params[3] = *var_blkAfter;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7834 = callmethodflags(call7833, "listMap()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7827);
// compilenode returning call7834
  gc_frame_newslot(call7834);
  int callframe7835 = gc_frame_new();
  partcv[0] = 0;
  Object call7836 = callmethodflags(self, "vararg", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7835);
// compilenode returning call7836
  gc_frame_newslot(call7836);
// compilenode returning *var_signaturePart
  params[0] = call7826;
  params[1] = call7834;
  params[2] = call7836;
  partcv[0] = 3;
  Object call7837 = callmethod(*var_signaturePart, "new",
    1, partcv, params);
  gc_frame_end(callframe7824);
// compilenode returning call7837
  *var_n = call7837;
  if (call7837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7838 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blk
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7839 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe7838);
// compilenode returning call7839
  *var_n = call7839;
  if (call7839 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1875
  setline(1875);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7841 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_blkAfter
  params[0] = *var_n;
  partcv[0] = 1;
  Object call7842 = callmethod(*var_blkAfter, "apply",
    1, partcv, params);
  gc_frame_end(callframe7841);
// compilenode returning call7842
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_end(frame);
  return *var_n;
}
Object meth_ast__apply7846(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast__apply7849(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_ast_map7843(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7844 = gc_frame_new();
// compilenode returning *var_blk
  gc_frame_newslot(*var_blk);
  Object block7845 = alloc_Block(NULL, NULL, "ast", 1879);
  gc_frame_newslot(block7845);
  block_savedest(block7845);
  Object closure7846 = createclosure(1, "_apply");
setclosureframe(closure7846, stackframe);
  addtoclosure(closure7846, selfslot);
  struct UserObject *uo7846 = (struct UserObject*)block7845;
  uo7846->data[0] = (Object)closure7846;
  Method *meth_meth_ast__apply7846 = addmethod2pos(block7845, "_apply", &meth_ast__apply7846, 0);
int argcv_meth_ast__apply7846[] = {0};
meth_meth_ast__apply7846->type = alloc_MethodType(1, argcv_meth_ast__apply7846);
  meth_meth_ast__apply7846->definitionModule = modulename;
  meth_meth_ast__apply7846->definitionLine = 1873;
// compilenode returning block7845
  gc_frame_newslot(block7845);
  Object block7848 = alloc_Block(NULL, NULL, "ast", 1879);
  gc_frame_newslot(block7848);
  block_savedest(block7848);
  Object closure7849 = createclosure(1, "_apply");
setclosureframe(closure7849, stackframe);
  addtoclosure(closure7849, selfslot);
  struct UserObject *uo7849 = (struct UserObject*)block7848;
  uo7849->data[0] = (Object)closure7849;
  Method *meth_meth_ast__apply7849 = addmethod2pos(block7848, "_apply", &meth_ast__apply7849, 0);
int argcv_meth_ast__apply7849[] = {0};
meth_meth_ast__apply7849->type = alloc_MethodType(1, argcv_meth_ast__apply7849);
  meth_meth_ast__apply7849->definitionModule = modulename;
  meth_meth_ast__apply7849->definitionLine = 1873;
// compilenode returning block7848
  gc_frame_newslot(block7848);
  params[0] = *var_blk;
  params[1] = block7845;
  params[2] = block7848;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7851 = callmethodflags(self, "map()before()after", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7844);
// compilenode returning call7851
  gc_frame_end(frame);
  return call7851;
}
Object meth_ast_new7813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7814 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7814 = alloc_userobj2(15,12, objclass7814);
  gc_frame_newslot(obj7814);
if (objclass7814 == NULL) {
  glfree(obj7814->class->name);
  obj7814->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7814, self, 0);
  addmethodreal(obj7814,"outer", &reader_ast_outer_7815);
  Object oldself7814 = self;
  struct StackFrameObject *oldstackframe7814 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7814);
  gc_frame_newslot((Object)stackframe);
  self = obj7814;
  Object *oldselfslot7814 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7814 = (*(struct UserObject *)self).data[0], lowerouter7814 = thisouter7814;
  if (inheritingObject7814) {
    struct UserObject *inho7814 = (struct UserObject *)inheritingObject7814;
    while (inho7814->super != GraceDefaultObject) inho7814 = (struct UserObject *)inho7814->super;
    inho7814->super = obj7814;
    self = inheritingObject7814;
    *selfslot = self;
    lowerouter7814 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7814;
  }
if (objclass7814 == NULL) {
  Method *reader7816 = addmethodrealflags(obj7814, "kind",&reader_ast_kind_7816, MFLAG_DEF);
  reader7816->definitionModule = modulename;
  reader7816->definitionLine = 1858;
}
adddatum2(obj7814, alloc_Undefined(), 1);
if (objclass7814 == NULL) {
  Method *reader7817 = addmethodrealflags(obj7814, "name",&reader_ast_name_7817, 0);
  Method *writer7817 = addmethodrealflags(obj7814, "name:=",&writer_ast_name_7817, 0);
  reader7817->definitionModule = modulename;
  writer7817->definitionModule = modulename;
  reader7817->definitionLine = 1859;
  writer7817->definitionLine = 1859;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 2);
if (objclass7814 == NULL) {
  Method *reader7818 = addmethodrealflags(obj7814, "params",&reader_ast_params_7818, 0);
  Method *writer7818 = addmethodrealflags(obj7814, "params:=",&writer_ast_params_7818, 0);
  reader7818->definitionModule = modulename;
  writer7818->definitionModule = modulename;
  reader7818->definitionLine = 1860;
  writer7818->definitionLine = 1860;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 3);
if (objclass7814 == NULL) {
  Method *reader7819 = addmethodrealflags(obj7814, "vararg",&reader_ast_vararg_7819, 0);
  Method *writer7819 = addmethodrealflags(obj7814, "vararg:=",&writer_ast_vararg_7819, 0);
  reader7819->definitionModule = modulename;
  writer7819->definitionModule = modulename;
  reader7819->definitionLine = 1861;
  writer7819->definitionLine = 1861;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 4);
if (objclass7814 == NULL) {
  Method *reader7820 = addmethodrealflags(obj7814, "generics",&reader_ast_generics_7820, 0);
  Method *writer7820 = addmethodrealflags(obj7814, "generics:=",&writer_ast_generics_7820, 0);
  reader7820->definitionModule = modulename;
  writer7820->definitionModule = modulename;
  reader7820->definitionLine = 1862;
  writer7820->definitionLine = 1862;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 5);
  block_savedest(obj7814);
  Object closure7821 = createclosure(1, "map()before()after");
setclosureframe(closure7821, stackframe);
  addtoclosure(closure7821, var_signaturePart);
  struct UserObject *uo7821 = (struct UserObject*)obj7814;
  uo7821->data[6] = (Object)closure7821;
  Method *meth_meth_ast_map_40__41_before_40__41_after7821 = addmethod2pos(obj7814, "map()before()after", &meth_ast_map_40__41_before_40__41_after7821, 6);
int argcv_meth_ast_map_40__41_before_40__41_after7821[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7821->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7821);
  meth_meth_ast_map_40__41_before_40__41_after7821->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7821->definitionLine = 1871;
  struct UserObject *uo7843 = (struct UserObject*)obj7814;
  uo7843->data[7] = emptyclosure;
  Method *meth_meth_ast_map7843 = addmethod2pos(obj7814, "map", &meth_ast_map7843, 7);
int argcv_meth_ast_map7843[] = {1};
meth_meth_ast_map7843->type = alloc_MethodType(1, argcv_meth_ast_map7843);
  meth_meth_ast_map7843->definitionModule = modulename;
  meth_meth_ast_map7843->definitionLine = 1878;
  sourceObject = obj7814;
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7852 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7853 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7852);
// compilenode returning call7853
  struct UserObject *obj7814_uo = (struct UserObject *)obj7814;
  obj7814_uo->super = call7853;
  sourceObject = obj7814;
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7854 == NULL) {
    strlit7854 = alloc_String("signaturepart");
    gc_root(strlit7854);
  }
// compilenode returning strlit7854
  adddatum2(obj7814, strlit7854, 1);
  sourceObject = obj7814;
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7855 == NULL) {
    strlit7855 = alloc_String("");
    gc_root(strlit7855);
  }
// compilenode returning strlit7855
  adddatum2(obj7814, strlit7855, 2);
  sourceObject = obj7814;
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7856 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7856
  adddatum2(obj7814, array7856, 3);
  sourceObject = obj7814;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7857 = alloc_Boolean(0);
// compilenode returning bool7857
  adddatum2(obj7814, bool7857, 4);
  sourceObject = obj7814;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7858 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7858
  adddatum2(obj7814, array7858, 5);
  sourceObject = obj7814;
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7861 = alloc_Float64(0);
// compilenode returning num7861
  int op_slot_right_7860 = gc_frame_newslot(num7861);
  int callframe7863 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7864 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7863);
// compilenode returning call7864
// compilenode returning call7864
  int op_slot_left_7860 = gc_frame_newslot(call7864);
  params[0] = num7861;
  partcv[0] = 1;
  Object opresult7865 = callmethod(call7864, ">", 1, partcv, params);
// compilenode returning opresult7865
  Object if7859 = done;
struct StackFrameObject *iftmpstackframe7859 = stackframe;
  if (istrue(opresult7865)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7859);
gc_frame_newslot((Object)stackframe);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7866 = gc_frame_new();
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7867 = alloc_Float64(1);
// compilenode returning num7867
  params[0] = num7867;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7868 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7868
  gc_frame_newslot(idxres7868);
  params[0] = idxres7868;
  partcv[0] = 1;
  Object call7869 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7866);
// compilenode returning call7869
// compilenode returning done
    gc_frame_newslot(done);
    if7859 = done;
  } else {
  }
stackframe = iftmpstackframe7859;
// compilenode returning if7859
  sourceObject = obj7814;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7872 = alloc_Float64(1);
// compilenode returning num7872
  int op_slot_right_7871 = gc_frame_newslot(num7872);
  int callframe7874 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7875 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7874);
// compilenode returning call7875
// compilenode returning call7875
  int op_slot_left_7871 = gc_frame_newslot(call7875);
  params[0] = num7872;
  partcv[0] = 1;
  Object opresult7876 = callmethod(call7875, ">", 1, partcv, params);
// compilenode returning opresult7876
  Object if7870 = done;
struct StackFrameObject *iftmpstackframe7870 = stackframe;
  if (istrue(opresult7876)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7870);
gc_frame_newslot((Object)stackframe);
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7877 = gc_frame_new();
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7878 = alloc_Float64(2);
// compilenode returning num7878
  params[0] = num7878;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7879 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7879
  gc_frame_newslot(idxres7879);
  params[0] = idxres7879;
  partcv[0] = 1;
  Object call7880 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7877);
// compilenode returning call7880
// compilenode returning done
    gc_frame_newslot(done);
    if7870 = done;
  } else {
  }
stackframe = iftmpstackframe7870;
// compilenode returning if7870
  sourceObject = obj7814;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7883 = alloc_Float64(2);
// compilenode returning num7883
  int op_slot_right_7882 = gc_frame_newslot(num7883);
  int callframe7885 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7886 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7885);
// compilenode returning call7886
// compilenode returning call7886
  int op_slot_left_7882 = gc_frame_newslot(call7886);
  params[0] = num7883;
  partcv[0] = 1;
  Object opresult7887 = callmethod(call7886, ">", 1, partcv, params);
// compilenode returning opresult7887
  Object if7881 = done;
struct StackFrameObject *iftmpstackframe7881 = stackframe;
  if (istrue(opresult7887)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7881);
gc_frame_newslot((Object)stackframe);
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7888 = gc_frame_new();
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7889 = alloc_Float64(3);
// compilenode returning num7889
  params[0] = num7889;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7890 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7890
  gc_frame_newslot(idxres7890);
  params[0] = idxres7890;
  partcv[0] = 1;
  Object call7891 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7888);
// compilenode returning call7891
// compilenode returning done
    gc_frame_newslot(done);
    if7881 = done;
  } else {
  }
stackframe = iftmpstackframe7881;
// compilenode returning if7881
  sourceObject = obj7814;
  sourceObject = obj7814;
objclass7814 = obj7814->class;
  objclass7814->definitionModule = modulename;
  objclass7814->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7814;
  self = oldself7814;
  selfslot = oldselfslot7814;
  stackframe = oldstackframe7814;
  gc_frame_end(frame);
  return obj7814;
}
Object meth_ast_new7813_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_signaturePart = getfromclosure(closure, 0);
  Object *var_baseNode = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_values = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_values, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_values = &(stackframe->slots[0]);
  *var_values = var_init_values;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject7814 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7814 = alloc_userobj2(15,12, objclass7814);
  gc_frame_newslot(obj7814);
if (objclass7814 == NULL) {
  glfree(obj7814->class->name);
  obj7814->class->name = "signaturePart";
}
// OBJECT OUTER DEC outer
  adddatum2(obj7814, self, 0);
  addmethodreal(obj7814,"outer", &reader_ast_outer_7815);
  Object oldself7814 = self;
  struct StackFrameObject *oldstackframe7814 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7814);
  gc_frame_newslot((Object)stackframe);
  self = obj7814;
  Object *oldselfslot7814 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7814 = (*(struct UserObject *)self).data[0], lowerouter7814 = thisouter7814;
  if (inheritingObject7814) {
    struct UserObject *inho7814 = (struct UserObject *)inheritingObject7814;
    while (inho7814->super != GraceDefaultObject) inho7814 = (struct UserObject *)inho7814->super;
    inho7814->super = obj7814;
    self = inheritingObject7814;
    *selfslot = self;
    lowerouter7814 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7814;
  }
if (objclass7814 == NULL) {
  Method *reader7816 = addmethodrealflags(obj7814, "kind",&reader_ast_kind_7816, MFLAG_DEF);
  reader7816->definitionModule = modulename;
  reader7816->definitionLine = 1858;
}
adddatum2(obj7814, alloc_Undefined(), 1);
if (objclass7814 == NULL) {
  Method *reader7817 = addmethodrealflags(obj7814, "name",&reader_ast_name_7817, 0);
  Method *writer7817 = addmethodrealflags(obj7814, "name:=",&writer_ast_name_7817, 0);
  reader7817->definitionModule = modulename;
  writer7817->definitionModule = modulename;
  reader7817->definitionLine = 1859;
  writer7817->definitionLine = 1859;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 2);
if (objclass7814 == NULL) {
  Method *reader7818 = addmethodrealflags(obj7814, "params",&reader_ast_params_7818, 0);
  Method *writer7818 = addmethodrealflags(obj7814, "params:=",&writer_ast_params_7818, 0);
  reader7818->definitionModule = modulename;
  writer7818->definitionModule = modulename;
  reader7818->definitionLine = 1860;
  writer7818->definitionLine = 1860;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 3);
if (objclass7814 == NULL) {
  Method *reader7819 = addmethodrealflags(obj7814, "vararg",&reader_ast_vararg_7819, 0);
  Method *writer7819 = addmethodrealflags(obj7814, "vararg:=",&writer_ast_vararg_7819, 0);
  reader7819->definitionModule = modulename;
  writer7819->definitionModule = modulename;
  reader7819->definitionLine = 1861;
  writer7819->definitionLine = 1861;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 4);
if (objclass7814 == NULL) {
  Method *reader7820 = addmethodrealflags(obj7814, "generics",&reader_ast_generics_7820, 0);
  Method *writer7820 = addmethodrealflags(obj7814, "generics:=",&writer_ast_generics_7820, 0);
  reader7820->definitionModule = modulename;
  writer7820->definitionModule = modulename;
  reader7820->definitionLine = 1862;
  writer7820->definitionLine = 1862;
}
obj7814->flags |= OFLAG_MUTABLE;
adddatum2(obj7814, alloc_Undefined(), 5);
  block_savedest(obj7814);
  Object closure7821 = createclosure(1, "map()before()after");
setclosureframe(closure7821, stackframe);
  addtoclosure(closure7821, var_signaturePart);
  struct UserObject *uo7821 = (struct UserObject*)obj7814;
  uo7821->data[6] = (Object)closure7821;
  Method *meth_meth_ast_map_40__41_before_40__41_after7821 = addmethod2pos(obj7814, "map()before()after", &meth_ast_map_40__41_before_40__41_after7821, 6);
int argcv_meth_ast_map_40__41_before_40__41_after7821[] = {1, 1, 1};
meth_meth_ast_map_40__41_before_40__41_after7821->type = alloc_MethodType(3, argcv_meth_ast_map_40__41_before_40__41_after7821);
  meth_meth_ast_map_40__41_before_40__41_after7821->definitionModule = modulename;
  meth_meth_ast_map_40__41_before_40__41_after7821->definitionLine = 1871;
  struct UserObject *uo7843 = (struct UserObject*)obj7814;
  uo7843->data[7] = emptyclosure;
  Method *meth_meth_ast_map7843 = addmethod2pos(obj7814, "map", &meth_ast_map7843, 7);
int argcv_meth_ast_map7843[] = {1};
meth_meth_ast_map7843->type = alloc_MethodType(1, argcv_meth_ast_map7843);
  meth_meth_ast_map7843->definitionModule = modulename;
  meth_meth_ast_map7843->definitionLine = 1878;
  sourceObject = obj7814;
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7852 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_baseNode
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7853 = callmethod(*var_baseNode, "new()object",
    2, partcv, params);
  gc_frame_end(callframe7852);
// compilenode returning call7853
  struct UserObject *obj7814_uo = (struct UserObject *)obj7814;
  obj7814_uo->super = call7853;
  sourceObject = obj7814;
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7854 == NULL) {
    strlit7854 = alloc_String("signaturepart");
    gc_root(strlit7854);
  }
// compilenode returning strlit7854
  adddatum2(obj7814, strlit7854, 1);
  sourceObject = obj7814;
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7855 == NULL) {
    strlit7855 = alloc_String("");
    gc_root(strlit7855);
  }
// compilenode returning strlit7855
  adddatum2(obj7814, strlit7855, 2);
  sourceObject = obj7814;
// Begin line 1859
  setline(1859);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7856 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7856
  adddatum2(obj7814, array7856, 3);
  sourceObject = obj7814;
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7857 = alloc_Boolean(0);
// compilenode returning bool7857
  adddatum2(obj7814, bool7857, 4);
  sourceObject = obj7814;
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7858 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7858
  adddatum2(obj7814, array7858, 5);
  sourceObject = obj7814;
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7861 = alloc_Float64(0);
// compilenode returning num7861
  int op_slot_right_7860 = gc_frame_newslot(num7861);
  int callframe7863 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7864 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7863);
// compilenode returning call7864
// compilenode returning call7864
  int op_slot_left_7860 = gc_frame_newslot(call7864);
  params[0] = num7861;
  partcv[0] = 1;
  Object opresult7865 = callmethod(call7864, ">", 1, partcv, params);
// compilenode returning opresult7865
  Object if7859 = done;
struct StackFrameObject *iftmpstackframe7859 = stackframe;
  if (istrue(opresult7865)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7859);
gc_frame_newslot((Object)stackframe);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7866 = gc_frame_new();
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7867 = alloc_Float64(1);
// compilenode returning num7867
  params[0] = num7867;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7868 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7868
  gc_frame_newslot(idxres7868);
  params[0] = idxres7868;
  partcv[0] = 1;
  Object call7869 = callmethodflags(self, "name:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7866);
// compilenode returning call7869
// compilenode returning done
    gc_frame_newslot(done);
    if7859 = done;
  } else {
  }
stackframe = iftmpstackframe7859;
// compilenode returning if7859
  sourceObject = obj7814;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7872 = alloc_Float64(1);
// compilenode returning num7872
  int op_slot_right_7871 = gc_frame_newslot(num7872);
  int callframe7874 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7875 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7874);
// compilenode returning call7875
// compilenode returning call7875
  int op_slot_left_7871 = gc_frame_newslot(call7875);
  params[0] = num7872;
  partcv[0] = 1;
  Object opresult7876 = callmethod(call7875, ">", 1, partcv, params);
// compilenode returning opresult7876
  Object if7870 = done;
struct StackFrameObject *iftmpstackframe7870 = stackframe;
  if (istrue(opresult7876)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7870);
gc_frame_newslot((Object)stackframe);
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7877 = gc_frame_new();
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7878 = alloc_Float64(2);
// compilenode returning num7878
  params[0] = num7878;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7879 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7879
  gc_frame_newslot(idxres7879);
  params[0] = idxres7879;
  partcv[0] = 1;
  Object call7880 = callmethodflags(self, "params:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7877);
// compilenode returning call7880
// compilenode returning done
    gc_frame_newslot(done);
    if7870 = done;
  } else {
  }
stackframe = iftmpstackframe7870;
// compilenode returning if7870
  sourceObject = obj7814;
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7883 = alloc_Float64(2);
// compilenode returning num7883
  int op_slot_right_7882 = gc_frame_newslot(num7883);
  int callframe7885 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7886 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe7885);
// compilenode returning call7886
// compilenode returning call7886
  int op_slot_left_7882 = gc_frame_newslot(call7886);
  params[0] = num7883;
  partcv[0] = 1;
  Object opresult7887 = callmethod(call7886, ">", 1, partcv, params);
// compilenode returning opresult7887
  Object if7881 = done;
struct StackFrameObject *iftmpstackframe7881 = stackframe;
  if (istrue(opresult7887)) {
stackframe = alloc_StackFrame(0, iftmpstackframe7881);
gc_frame_newslot((Object)stackframe);
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7888 = gc_frame_new();
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  Object num7889 = alloc_Float64(3);
// compilenode returning num7889
  params[0] = num7889;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres7890 = callmethod(*var_values, "[]", 1, partcv, params);
// compilenode returning idxres7890
  gc_frame_newslot(idxres7890);
  params[0] = idxres7890;
  partcv[0] = 1;
  Object call7891 = callmethodflags(self, "vararg:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7888);
// compilenode returning call7891
// compilenode returning done
    gc_frame_newslot(done);
    if7881 = done;
  } else {
  }
stackframe = iftmpstackframe7881;
// compilenode returning if7881
  sourceObject = obj7814;
  sourceObject = obj7814;
objclass7814 = obj7814->class;
  objclass7814->definitionModule = modulename;
  objclass7814->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7814;
  self = oldself7814;
  selfslot = oldselfslot7814;
  stackframe = oldstackframe7814;
  gc_frame_end(frame);
  return obj7814;
}
Object meth_ast_ast7893(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ast = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for ast (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[ast]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ast
  gc_frame_end(frame);
  return *var_ast;
}
Object meth_ast_visitCall7896(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "visitCall");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for visitCall (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for visitCall");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7897 = gc_frame_new();
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7898 = alloc_Boolean(1);
// compilenode returning bool7898
  gc_frame_newslot(bool7898);
// compilenode returning *var_c
  params[0] = bool7898;
  partcv[0] = 1;
  Object call7899 = callmethod(*var_c, "isPattern:=",
    1, partcv, params);
  gc_frame_end(callframe7897);
// compilenode returning call7899
// compilenode returning done
// Begin line 2035
  setline(2035);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7900 = alloc_Boolean(1);
// compilenode returning bool7900
  gc_frame_end(frame);
  return bool7900;
}
Object meth_ast_patternMarkVisitor7903(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "patternMarkVisitor");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_patternMarkVisitor = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for patternMarkVisitor (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[patternMarkVisitor]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_patternMarkVisitor
  gc_frame_end(frame);
  return *var_patternMarkVisitor;
}
Object module_ast_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(45, 45);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<ast>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(45, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[2];
Object *var_util = alloc_var();
Object *var_collections = alloc_var();
  Object *var_baseNode = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "baseNode");
  Object *var_forNode = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "forNode");
  Object *var_whileNode = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "whileNode");
  Object *var_ifNode = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ifNode");
  Object *var_blockNode = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "blockNode");
  Object *var_catchCaseNode = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "catchCaseNode");
  Object *var_matchCaseNode = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "matchCaseNode");
  Object *var_methodTypeNode = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "methodTypeNode");
  Object *var_typeNode = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "typeNode");
  Object *var_methodNode = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "methodNode");
  Object *var_callNode = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "callNode");
  Object *var_classNode = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "classNode");
  Object *var_objectNode = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "objectNode");
  Object *var_arrayNode = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "arrayNode");
  Object *var_memberNode = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "memberNode");
  Object *var_genericNode = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "genericNode");
  Object *var_identifierNode = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "identifierNode");
  Object *var_octetsNode = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "octetsNode");
  Object *var_stringNode = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "stringNode");
  Object *var_numNode = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "numNode");
  Object *var_opNode = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "opNode");
  Object *var_indexNode = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "indexNode");
  Object *var_bindNode = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "bindNode");
  Object *var_defDecNode = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "defDecNode");
  Object *var_varDecNode = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "varDecNode");
  Object *var_importNode = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "importNode");
  Object *var_dialectNode = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "dialectNode");
  Object *var_returnNode = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "returnNode");
  Object *var_inheritsNode = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "inheritsNode");
  Object *var_blankNode = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "blankNode");
  Object *var_signaturePart = &(stackframe->slots[31]);
  setframeelementname(stackframe, 31, "signaturePart");
  Object *var_ASTVisitor = &(stackframe->slots[32]);
  setframeelementname(stackframe, 32, "ASTVisitor");
  Object *var_ast = &(stackframe->slots[33]);
  setframeelementname(stackframe, 33, "ast");
  Object *var_patternMarkVisitor = &(stackframe->slots[34]);
  setframeelementname(stackframe, 34, "patternMarkVisitor");
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure0 = createclosure(1, "listMap()before()after");
setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_collections);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_ast_listMap_40__41_before_40__41_after0 = addmethod2pos(self, "listMap()before()after", &meth_ast_listMap_40__41_before_40__41_after0, 1);
int argcv_meth_ast_listMap_40__41_before_40__41_after0[] = {2, 1, 1};
meth_meth_ast_listMap_40__41_before_40__41_after0->type = alloc_MethodType(3, argcv_meth_ast_listMap_40__41_before_40__41_after0);
  meth_meth_ast_listMap_40__41_before_40__41_after0->definitionModule = modulename;
  meth_meth_ast_listMap_40__41_before_40__41_after0->definitionLine = 22;
// compilenode returning 
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo14 = (struct UserObject*)self;
  uo14->data[2] = emptyclosure;
  Method *meth_meth_ast_maybeMap14 = addmethod2pos(self, "maybeMap", &meth_ast_maybeMap14, 2);
int argcv_meth_ast_maybeMap14[] = {4};
meth_meth_ast_maybeMap14->type = alloc_MethodType(1, argcv_meth_ast_maybeMap14);
  meth_meth_ast_maybeMap14->definitionModule = modulename;
  meth_meth_ast_maybeMap14->definitionLine = 30;
// compilenode returning 
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure22 = createclosure(1, "callWithPart");
setclosureframe(closure22, stackframe);
  addtoclosure(closure22, var_baseNode);
  struct UserObject *uo22 = (struct UserObject*)self;
  uo22->data[3] = (Object)closure22;
  Method *meth_meth_ast_callWithPart22 = addmethod2pos(self, "callWithPart", &meth_ast_callWithPart22, 3);
int argcv_meth_ast_callWithPart22[] = {0};
meth_meth_ast_callWithPart22->type = alloc_MethodType(1, argcv_meth_ast_callWithPart22);
  meth_meth_ast_callWithPart22->definitionModule = modulename;
  meth_meth_ast_callWithPart22->definitionLine = 1883;
  block_savedest(self);
  Object closure94 = createclosure(1, "callWithPart()object");
setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_baseNode);
  Method *meth_meth_ast_callWithPart22_object = addmethod2pos(self, "callWithPart()object", &meth_ast_callWithPart22_object, 3);
  meth_meth_ast_callWithPart22_object->definitionModule = modulename;
  meth_meth_ast_callWithPart22_object->definitionLine = 1883;
// compilenode returning 
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
// Type ASTVisitor
Object type95 = alloc_Type("ASTVisitor", 28);
*var_ASTVisitor = type95;
add_Method((ClassData)type95, "visitFor", NULL);
add_Method((ClassData)type95, "visitWhile", NULL);
add_Method((ClassData)type95, "visitIf", NULL);
add_Method((ClassData)type95, "visitBlock", NULL);
add_Method((ClassData)type95, "visitMatchCase", NULL);
add_Method((ClassData)type95, "visitCatchCase", NULL);
add_Method((ClassData)type95, "visitMethodType", NULL);
add_Method((ClassData)type95, "visitType", NULL);
add_Method((ClassData)type95, "visitMethod", NULL);
add_Method((ClassData)type95, "visitCall", NULL);
add_Method((ClassData)type95, "visitClass", NULL);
add_Method((ClassData)type95, "visitObject", NULL);
add_Method((ClassData)type95, "visitArray", NULL);
add_Method((ClassData)type95, "visitMember", NULL);
add_Method((ClassData)type95, "visitGeneric", NULL);
add_Method((ClassData)type95, "visitIdentifier", NULL);
add_Method((ClassData)type95, "visitOctets", NULL);
add_Method((ClassData)type95, "visitString", NULL);
add_Method((ClassData)type95, "visitNum", NULL);
add_Method((ClassData)type95, "visitOp", NULL);
add_Method((ClassData)type95, "visitIndex", NULL);
add_Method((ClassData)type95, "visitBind", NULL);
add_Method((ClassData)type95, "visitDefDec", NULL);
add_Method((ClassData)type95, "visitVarDec", NULL);
add_Method((ClassData)type95, "visitImport", NULL);
add_Method((ClassData)type95, "visitReturn", NULL);
add_Method((ClassData)type95, "visitInherits", NULL);
add_Method((ClassData)type95, "visitDialect", NULL);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure96 = createclosure(1, "ASTVisitor");
setclosureframe(closure96, stackframe);
  addtoclosure(closure96, var_ASTVisitor);
  struct UserObject *uo96 = (struct UserObject*)self;
  uo96->data[4] = (Object)closure96;
  Method *meth_meth_ast_ASTVisitor96 = addmethod2pos(self, "ASTVisitor", &meth_ast_ASTVisitor96, 4);
int argcv_meth_ast_ASTVisitor96[] = {0};
meth_meth_ast_ASTVisitor96->type = alloc_MethodType(1, argcv_meth_ast_ASTVisitor96);
  meth_meth_ast_ASTVisitor96->definitionModule = modulename;
  meth_meth_ast_ASTVisitor96->definitionLine = 1894;
// compilenode returning 
// compilenode returning done
type_ASTVisitor = *var_ASTVisitor;
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo97 = (struct UserObject*)self;
  uo97->data[5] = emptyclosure;
  Method *meth_meth_ast_baseVisitor97 = addmethod2pos(self, "baseVisitor", &meth_ast_baseVisitor97, 5);
int argcv_meth_ast_baseVisitor97[] = {0};
meth_meth_ast_baseVisitor97->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor97);
  meth_meth_ast_baseVisitor97->definitionModule = modulename;
  meth_meth_ast_baseVisitor97->definitionLine = 1942;
  Method *meth_meth_ast_baseVisitor97_object = addmethod2pos(self, "baseVisitor()object", &meth_ast_baseVisitor97_object, 5);
int argcv_meth_ast_baseVisitor97_object[] = {0};
meth_meth_ast_baseVisitor97_object->type = alloc_MethodType(1, argcv_meth_ast_baseVisitor97_object);
  meth_meth_ast_baseVisitor97_object->definitionModule = modulename;
  meth_meth_ast_baseVisitor97_object->definitionLine = 1942;
// compilenode returning 
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo157 = (struct UserObject*)self;
  uo157->data[6] = emptyclosure;
  Method *meth_meth_ast_findAnnotation157 = addmethod2pos(self, "findAnnotation", &meth_ast_findAnnotation157, 6);
int argcv_meth_ast_findAnnotation157[] = {2};
meth_meth_ast_findAnnotation157->type = alloc_MethodType(1, argcv_meth_ast_findAnnotation157);
  meth_meth_ast_findAnnotation157->definitionModule = modulename;
  meth_meth_ast_findAnnotation157->definitionLine = 2039;
// compilenode returning 
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo187 = (struct UserObject*)self;
  uo187->data[7] = emptyclosure;
  Method *meth_meth_ast_isPublic187 = addmethod2pos(self, "isPublic", &meth_ast_isPublic187, 7);
int argcv_meth_ast_isPublic187[] = {1};
meth_meth_ast_isPublic187->type = alloc_MethodType(1, argcv_meth_ast_isPublic187);
  meth_meth_ast_isPublic187->definitionModule = modulename;
  meth_meth_ast_isPublic187->definitionLine = 2052;
// compilenode returning 
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo207 = (struct UserObject*)self;
  uo207->data[8] = emptyclosure;
  Method *meth_meth_ast_isWritable207 = addmethod2pos(self, "isWritable", &meth_ast_isWritable207, 8);
int argcv_meth_ast_isWritable207[] = {1};
meth_meth_ast_isWritable207->type = alloc_MethodType(1, argcv_meth_ast_isWritable207);
  meth_meth_ast_isWritable207->definitionModule = modulename;
  meth_meth_ast_isWritable207->definitionLine = 2060;
// compilenode returning 
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compilenode returning done
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compilenode returning done
// compilenode returning 
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure227 = createclosure(1, "baseNode");
setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_baseNode);
  struct UserObject *uo227 = (struct UserObject*)self;
  uo227->data[9] = (Object)closure227;
  Method *meth_meth_ast_baseNode227 = addmethod2pos(self, "baseNode", &meth_ast_baseNode227, 9);
int argcv_meth_ast_baseNode227[] = {0};
meth_meth_ast_baseNode227->type = alloc_MethodType(1, argcv_meth_ast_baseNode227);
  meth_meth_ast_baseNode227->definitionModule = modulename;
  meth_meth_ast_baseNode227->definitionLine = 2061;
// compilenode returning 
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj228 = alloc_userobj2(2,4, objclass228);
  gc_frame_newslot(obj228);
// OBJECT OUTER DEC outer
  adddatum2(obj228, self, 0);
  addmethodreal(obj228,"outer", &reader_ast_outer_229);
  Object oldself228 = self;
  struct StackFrameObject *oldstackframe228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe228);
  gc_frame_newslot((Object)stackframe);
  self = obj228;
  Object *oldselfslot228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter228 = (*(struct UserObject *)self).data[0], lowerouter228 = thisouter228;
  if (inheritingObject228) {
    struct UserObject *inho228 = (struct UserObject *)inheritingObject228;
    while (inho228->super != GraceDefaultObject) inho228 = (struct UserObject *)inho228->super;
    inho228->super = obj228;
    self = inheritingObject228;
    *selfslot = self;
    lowerouter228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter228;
  }
  block_savedest(obj228);
  Object closure230 = createclosure(1, "new");
setclosureframe(closure230, stackframe);
  addtoclosure(closure230, var_util);
  struct UserObject *uo230 = (struct UserObject*)obj228;
  uo230->data[1] = (Object)closure230;
  Method *meth_meth_ast_new230 = addmethod2pos(obj228, "new", &meth_ast_new230, 1);
int argcv_meth_ast_new230[] = {0};
meth_meth_ast_new230->type = alloc_MethodType(1, argcv_meth_ast_new230);
  meth_meth_ast_new230->definitionModule = modulename;
  meth_meth_ast_new230->definitionLine = 2061;
  block_savedest(obj228);
  Object closure243 = createclosure(1, "new()object");
setclosureframe(closure243, stackframe);
  addtoclosure(closure243, var_util);
  Method *meth_meth_ast_new230_object = addmethod2pos(obj228, "new()object", &meth_ast_new230_object, 1);
  meth_meth_ast_new230_object->definitionModule = modulename;
  meth_meth_ast_new230_object->definitionLine = 2061;
  sourceObject = obj228;
objclass228 = obj228->class;
  objclass228->definitionModule = modulename;
  objclass228->definitionLine = 2061;
  (*(struct UserObject *)self).data[0] = lowerouter228;
  self = oldself228;
  selfslot = oldselfslot228;
  stackframe = oldstackframe228;
// compilenode returning obj228
  *var_baseNode = obj228;
  if (obj228 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 37
  setline(37);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure244 = createclosure(1, "forNode");
setclosureframe(closure244, stackframe);
  addtoclosure(closure244, var_forNode);
  struct UserObject *uo244 = (struct UserObject*)self;
  uo244->data[10] = (Object)closure244;
  Method *meth_meth_ast_forNode244 = addmethod2pos(self, "forNode", &meth_ast_forNode244, 10);
int argcv_meth_ast_forNode244[] = {0};
meth_meth_ast_forNode244->type = alloc_MethodType(1, argcv_meth_ast_forNode244);
  meth_meth_ast_forNode244->definitionModule = modulename;
  meth_meth_ast_forNode244->definitionLine = 40;
// compilenode returning 
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject245 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj245 = alloc_userobj2(2,4, objclass245);
  gc_frame_newslot(obj245);
// OBJECT OUTER DEC outer
  adddatum2(obj245, self, 0);
  addmethodreal(obj245,"outer", &reader_ast_outer_246);
  Object oldself245 = self;
  struct StackFrameObject *oldstackframe245 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe245);
  gc_frame_newslot((Object)stackframe);
  self = obj245;
  Object *oldselfslot245 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter245 = (*(struct UserObject *)self).data[0], lowerouter245 = thisouter245;
  if (inheritingObject245) {
    struct UserObject *inho245 = (struct UserObject *)inheritingObject245;
    while (inho245->super != GraceDefaultObject) inho245 = (struct UserObject *)inho245->super;
    inho245->super = obj245;
    self = inheritingObject245;
    *selfslot = self;
    lowerouter245 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter245;
  }
  block_savedest(obj245);
  Object closure247 = createclosure(1, "new");
setclosureframe(closure247, stackframe);
  addtoclosure(closure247, var_baseNode);
  struct UserObject *uo247 = (struct UserObject*)obj245;
  uo247->data[1] = (Object)closure247;
  Method *meth_meth_ast_new247 = addmethod2pos(obj245, "new", &meth_ast_new247, 1);
int argcv_meth_ast_new247[] = {2};
meth_meth_ast_new247->type = alloc_MethodType(1, argcv_meth_ast_new247);
  meth_meth_ast_new247->definitionModule = modulename;
  meth_meth_ast_new247->definitionLine = 40;
  block_savedest(obj245);
  Object closure377 = createclosure(1, "new()object");
setclosureframe(closure377, stackframe);
  addtoclosure(closure377, var_baseNode);
  Method *meth_meth_ast_new247_object = addmethod2pos(obj245, "new()object", &meth_ast_new247_object, 1);
  meth_meth_ast_new247_object->definitionModule = modulename;
  meth_meth_ast_new247_object->definitionLine = 40;
  sourceObject = obj245;
objclass245 = obj245->class;
  objclass245->definitionModule = modulename;
  objclass245->definitionLine = 40;
  (*(struct UserObject *)self).data[0] = lowerouter245;
  self = oldself245;
  selfslot = oldselfslot245;
  stackframe = oldstackframe245;
// compilenode returning obj245
  *var_forNode = obj245;
  if (obj245 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure378 = createclosure(1, "whileNode");
setclosureframe(closure378, stackframe);
  addtoclosure(closure378, var_whileNode);
  struct UserObject *uo378 = (struct UserObject*)self;
  uo378->data[11] = (Object)closure378;
  Method *meth_meth_ast_whileNode378 = addmethod2pos(self, "whileNode", &meth_ast_whileNode378, 11);
int argcv_meth_ast_whileNode378[] = {0};
meth_meth_ast_whileNode378->type = alloc_MethodType(1, argcv_meth_ast_whileNode378);
  meth_meth_ast_whileNode378->definitionModule = modulename;
  meth_meth_ast_whileNode378->definitionLine = 73;
// compilenode returning 
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject379 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj379 = alloc_userobj2(2,4, objclass379);
  gc_frame_newslot(obj379);
// OBJECT OUTER DEC outer
  adddatum2(obj379, self, 0);
  addmethodreal(obj379,"outer", &reader_ast_outer_380);
  Object oldself379 = self;
  struct StackFrameObject *oldstackframe379 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe379);
  gc_frame_newslot((Object)stackframe);
  self = obj379;
  Object *oldselfslot379 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter379 = (*(struct UserObject *)self).data[0], lowerouter379 = thisouter379;
  if (inheritingObject379) {
    struct UserObject *inho379 = (struct UserObject *)inheritingObject379;
    while (inho379->super != GraceDefaultObject) inho379 = (struct UserObject *)inho379->super;
    inho379->super = obj379;
    self = inheritingObject379;
    *selfslot = self;
    lowerouter379 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter379;
  }
  block_savedest(obj379);
  Object closure381 = createclosure(1, "new");
setclosureframe(closure381, stackframe);
  addtoclosure(closure381, var_baseNode);
  struct UserObject *uo381 = (struct UserObject*)obj379;
  uo381->data[1] = (Object)closure381;
  Method *meth_meth_ast_new381 = addmethod2pos(obj379, "new", &meth_ast_new381, 1);
int argcv_meth_ast_new381[] = {2};
meth_meth_ast_new381->type = alloc_MethodType(1, argcv_meth_ast_new381);
  meth_meth_ast_new381->definitionModule = modulename;
  meth_meth_ast_new381->definitionLine = 73;
  block_savedest(obj379);
  Object closure552 = createclosure(1, "new()object");
setclosureframe(closure552, stackframe);
  addtoclosure(closure552, var_baseNode);
  Method *meth_meth_ast_new381_object = addmethod2pos(obj379, "new()object", &meth_ast_new381_object, 1);
  meth_meth_ast_new381_object->definitionModule = modulename;
  meth_meth_ast_new381_object->definitionLine = 73;
  sourceObject = obj379;
objclass379 = obj379->class;
  objclass379->definitionModule = modulename;
  objclass379->definitionLine = 73;
  (*(struct UserObject *)self).data[0] = lowerouter379;
  self = oldself379;
  selfslot = oldselfslot379;
  stackframe = oldstackframe379;
// compilenode returning obj379
  *var_whileNode = obj379;
  if (obj379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure553 = createclosure(1, "ifNode");
setclosureframe(closure553, stackframe);
  addtoclosure(closure553, var_ifNode);
  struct UserObject *uo553 = (struct UserObject*)self;
  uo553->data[12] = (Object)closure553;
  Method *meth_meth_ast_ifNode553 = addmethod2pos(self, "ifNode", &meth_ast_ifNode553, 12);
int argcv_meth_ast_ifNode553[] = {0};
meth_meth_ast_ifNode553->type = alloc_MethodType(1, argcv_meth_ast_ifNode553);
  meth_meth_ast_ifNode553->definitionModule = modulename;
  meth_meth_ast_ifNode553->definitionLine = 110;
// compilenode returning 
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject554 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj554 = alloc_userobj2(2,4, objclass554);
  gc_frame_newslot(obj554);
// OBJECT OUTER DEC outer
  adddatum2(obj554, self, 0);
  addmethodreal(obj554,"outer", &reader_ast_outer_555);
  Object oldself554 = self;
  struct StackFrameObject *oldstackframe554 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe554);
  gc_frame_newslot((Object)stackframe);
  self = obj554;
  Object *oldselfslot554 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter554 = (*(struct UserObject *)self).data[0], lowerouter554 = thisouter554;
  if (inheritingObject554) {
    struct UserObject *inho554 = (struct UserObject *)inheritingObject554;
    while (inho554->super != GraceDefaultObject) inho554 = (struct UserObject *)inho554->super;
    inho554->super = obj554;
    self = inheritingObject554;
    *selfslot = self;
    lowerouter554 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter554;
  }
  block_savedest(obj554);
  Object closure556 = createclosure(2, "new");
setclosureframe(closure556, stackframe);
  addtoclosure(closure556, var_ifNode);
  addtoclosure(closure556, var_baseNode);
  struct UserObject *uo556 = (struct UserObject*)obj554;
  uo556->data[1] = (Object)closure556;
  Method *meth_meth_ast_new556 = addmethod2pos(obj554, "new", &meth_ast_new556, 1);
int argcv_meth_ast_new556[] = {3};
meth_meth_ast_new556->type = alloc_MethodType(1, argcv_meth_ast_new556);
  meth_meth_ast_new556->definitionModule = modulename;
  meth_meth_ast_new556->definitionLine = 110;
  block_savedest(obj554);
  Object closure869 = createclosure(2, "new()object");
setclosureframe(closure869, stackframe);
  addtoclosure(closure869, var_ifNode);
  addtoclosure(closure869, var_baseNode);
  Method *meth_meth_ast_new556_object = addmethod2pos(obj554, "new()object", &meth_ast_new556_object, 1);
  meth_meth_ast_new556_object->definitionModule = modulename;
  meth_meth_ast_new556_object->definitionLine = 110;
  sourceObject = obj554;
objclass554 = obj554->class;
  objclass554->definitionModule = modulename;
  objclass554->definitionLine = 110;
  (*(struct UserObject *)self).data[0] = lowerouter554;
  self = oldself554;
  selfslot = oldselfslot554;
  stackframe = oldstackframe554;
// compilenode returning obj554
  *var_ifNode = obj554;
  if (obj554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure870 = createclosure(1, "blockNode");
setclosureframe(closure870, stackframe);
  addtoclosure(closure870, var_blockNode);
  struct UserObject *uo870 = (struct UserObject*)self;
  uo870->data[13] = (Object)closure870;
  Method *meth_meth_ast_blockNode870 = addmethod2pos(self, "blockNode", &meth_ast_blockNode870, 13);
int argcv_meth_ast_blockNode870[] = {0};
meth_meth_ast_blockNode870->type = alloc_MethodType(1, argcv_meth_ast_blockNode870);
  meth_meth_ast_blockNode870->definitionModule = modulename;
  meth_meth_ast_blockNode870->definitionLine = 181;
// compilenode returning 
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject871 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj871 = alloc_userobj2(2,4, objclass871);
  gc_frame_newslot(obj871);
// OBJECT OUTER DEC outer
  adddatum2(obj871, self, 0);
  addmethodreal(obj871,"outer", &reader_ast_outer_872);
  Object oldself871 = self;
  struct StackFrameObject *oldstackframe871 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe871);
  gc_frame_newslot((Object)stackframe);
  self = obj871;
  Object *oldselfslot871 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter871 = (*(struct UserObject *)self).data[0], lowerouter871 = thisouter871;
  if (inheritingObject871) {
    struct UserObject *inho871 = (struct UserObject *)inheritingObject871;
    while (inho871->super != GraceDefaultObject) inho871 = (struct UserObject *)inho871->super;
    inho871->super = obj871;
    self = inheritingObject871;
    *selfslot = self;
    lowerouter871 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter871;
  }
  block_savedest(obj871);
  Object closure873 = createclosure(3, "new");
setclosureframe(closure873, stackframe);
  addtoclosure(closure873, var_blockNode);
  addtoclosure(closure873, var_baseNode);
  addtoclosure(closure873, var_patternMarkVisitor);
  struct UserObject *uo873 = (struct UserObject*)obj871;
  uo873->data[1] = (Object)closure873;
  Method *meth_meth_ast_new873 = addmethod2pos(obj871, "new", &meth_ast_new873, 1);
int argcv_meth_ast_new873[] = {2};
meth_meth_ast_new873->type = alloc_MethodType(1, argcv_meth_ast_new873);
  meth_meth_ast_new873->definitionModule = modulename;
  meth_meth_ast_new873->definitionLine = 181;
  block_savedest(obj871);
  Object closure1245 = createclosure(3, "new()object");
setclosureframe(closure1245, stackframe);
  addtoclosure(closure1245, var_blockNode);
  addtoclosure(closure1245, var_baseNode);
  addtoclosure(closure1245, var_patternMarkVisitor);
  Method *meth_meth_ast_new873_object = addmethod2pos(obj871, "new()object", &meth_ast_new873_object, 1);
  meth_meth_ast_new873_object->definitionModule = modulename;
  meth_meth_ast_new873_object->definitionLine = 181;
  sourceObject = obj871;
objclass871 = obj871->class;
  objclass871->definitionModule = modulename;
  objclass871->definitionLine = 181;
  (*(struct UserObject *)self).data[0] = lowerouter871;
  self = oldself871;
  selfslot = oldselfslot871;
  stackframe = oldstackframe871;
// compilenode returning obj871
  *var_blockNode = obj871;
  if (obj871 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1246 = createclosure(1, "catchCaseNode");
setclosureframe(closure1246, stackframe);
  addtoclosure(closure1246, var_catchCaseNode);
  struct UserObject *uo1246 = (struct UserObject*)self;
  uo1246->data[14] = (Object)closure1246;
  Method *meth_meth_ast_catchCaseNode1246 = addmethod2pos(self, "catchCaseNode", &meth_ast_catchCaseNode1246, 14);
int argcv_meth_ast_catchCaseNode1246[] = {0};
meth_meth_ast_catchCaseNode1246->type = alloc_MethodType(1, argcv_meth_ast_catchCaseNode1246);
  meth_meth_ast_catchCaseNode1246->definitionModule = modulename;
  meth_meth_ast_catchCaseNode1246->definitionLine = 275;
// compilenode returning 
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1247 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1247 = alloc_userobj2(2,4, objclass1247);
  gc_frame_newslot(obj1247);
// OBJECT OUTER DEC outer
  adddatum2(obj1247, self, 0);
  addmethodreal(obj1247,"outer", &reader_ast_outer_1248);
  Object oldself1247 = self;
  struct StackFrameObject *oldstackframe1247 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1247);
  gc_frame_newslot((Object)stackframe);
  self = obj1247;
  Object *oldselfslot1247 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1247 = (*(struct UserObject *)self).data[0], lowerouter1247 = thisouter1247;
  if (inheritingObject1247) {
    struct UserObject *inho1247 = (struct UserObject *)inheritingObject1247;
    while (inho1247->super != GraceDefaultObject) inho1247 = (struct UserObject *)inho1247->super;
    inho1247->super = obj1247;
    self = inheritingObject1247;
    *selfslot = self;
    lowerouter1247 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1247;
  }
  block_savedest(obj1247);
  Object closure1249 = createclosure(2, "new");
setclosureframe(closure1249, stackframe);
  addtoclosure(closure1249, var_catchCaseNode);
  addtoclosure(closure1249, var_baseNode);
  struct UserObject *uo1249 = (struct UserObject*)obj1247;
  uo1249->data[1] = (Object)closure1249;
  Method *meth_meth_ast_new1249 = addmethod2pos(obj1247, "new", &meth_ast_new1249, 1);
int argcv_meth_ast_new1249[] = {3};
meth_meth_ast_new1249->type = alloc_MethodType(1, argcv_meth_ast_new1249);
  meth_meth_ast_new1249->definitionModule = modulename;
  meth_meth_ast_new1249->definitionLine = 275;
  block_savedest(obj1247);
  Object closure1536 = createclosure(2, "new()object");
setclosureframe(closure1536, stackframe);
  addtoclosure(closure1536, var_catchCaseNode);
  addtoclosure(closure1536, var_baseNode);
  Method *meth_meth_ast_new1249_object = addmethod2pos(obj1247, "new()object", &meth_ast_new1249_object, 1);
  meth_meth_ast_new1249_object->definitionModule = modulename;
  meth_meth_ast_new1249_object->definitionLine = 275;
  sourceObject = obj1247;
objclass1247 = obj1247->class;
  objclass1247->definitionModule = modulename;
  objclass1247->definitionLine = 275;
  (*(struct UserObject *)self).data[0] = lowerouter1247;
  self = oldself1247;
  selfslot = oldselfslot1247;
  stackframe = oldstackframe1247;
// compilenode returning obj1247
  *var_catchCaseNode = obj1247;
  if (obj1247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1537 = createclosure(1, "matchCaseNode");
setclosureframe(closure1537, stackframe);
  addtoclosure(closure1537, var_matchCaseNode);
  struct UserObject *uo1537 = (struct UserObject*)self;
  uo1537->data[15] = (Object)closure1537;
  Method *meth_meth_ast_matchCaseNode1537 = addmethod2pos(self, "matchCaseNode", &meth_ast_matchCaseNode1537, 15);
int argcv_meth_ast_matchCaseNode1537[] = {0};
meth_meth_ast_matchCaseNode1537->type = alloc_MethodType(1, argcv_meth_ast_matchCaseNode1537);
  meth_meth_ast_matchCaseNode1537->definitionModule = modulename;
  meth_meth_ast_matchCaseNode1537->definitionLine = 335;
// compilenode returning 
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1538 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1538 = alloc_userobj2(2,4, objclass1538);
  gc_frame_newslot(obj1538);
// OBJECT OUTER DEC outer
  adddatum2(obj1538, self, 0);
  addmethodreal(obj1538,"outer", &reader_ast_outer_1539);
  Object oldself1538 = self;
  struct StackFrameObject *oldstackframe1538 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1538);
  gc_frame_newslot((Object)stackframe);
  self = obj1538;
  Object *oldselfslot1538 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1538 = (*(struct UserObject *)self).data[0], lowerouter1538 = thisouter1538;
  if (inheritingObject1538) {
    struct UserObject *inho1538 = (struct UserObject *)inheritingObject1538;
    while (inho1538->super != GraceDefaultObject) inho1538 = (struct UserObject *)inho1538->super;
    inho1538->super = obj1538;
    self = inheritingObject1538;
    *selfslot = self;
    lowerouter1538 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1538;
  }
  block_savedest(obj1538);
  Object closure1540 = createclosure(2, "new");
setclosureframe(closure1540, stackframe);
  addtoclosure(closure1540, var_matchCaseNode);
  addtoclosure(closure1540, var_baseNode);
  struct UserObject *uo1540 = (struct UserObject*)obj1538;
  uo1540->data[1] = (Object)closure1540;
  Method *meth_meth_ast_new1540 = addmethod2pos(obj1538, "new", &meth_ast_new1540, 1);
int argcv_meth_ast_new1540[] = {3};
meth_meth_ast_new1540->type = alloc_MethodType(1, argcv_meth_ast_new1540);
  meth_meth_ast_new1540->definitionModule = modulename;
  meth_meth_ast_new1540->definitionLine = 335;
  block_savedest(obj1538);
  Object closure1827 = createclosure(2, "new()object");
setclosureframe(closure1827, stackframe);
  addtoclosure(closure1827, var_matchCaseNode);
  addtoclosure(closure1827, var_baseNode);
  Method *meth_meth_ast_new1540_object = addmethod2pos(obj1538, "new()object", &meth_ast_new1540_object, 1);
  meth_meth_ast_new1540_object->definitionModule = modulename;
  meth_meth_ast_new1540_object->definitionLine = 335;
  sourceObject = obj1538;
objclass1538 = obj1538->class;
  objclass1538->definitionModule = modulename;
  objclass1538->definitionLine = 335;
  (*(struct UserObject *)self).data[0] = lowerouter1538;
  self = oldself1538;
  selfslot = oldselfslot1538;
  stackframe = oldstackframe1538;
// compilenode returning obj1538
  *var_matchCaseNode = obj1538;
  if (obj1538 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1828 = createclosure(1, "methodTypeNode");
setclosureframe(closure1828, stackframe);
  addtoclosure(closure1828, var_methodTypeNode);
  struct UserObject *uo1828 = (struct UserObject*)self;
  uo1828->data[16] = (Object)closure1828;
  Method *meth_meth_ast_methodTypeNode1828 = addmethod2pos(self, "methodTypeNode", &meth_ast_methodTypeNode1828, 16);
int argcv_meth_ast_methodTypeNode1828[] = {0};
meth_meth_ast_methodTypeNode1828->type = alloc_MethodType(1, argcv_meth_ast_methodTypeNode1828);
  meth_meth_ast_methodTypeNode1828->definitionModule = modulename;
  meth_meth_ast_methodTypeNode1828->definitionLine = 395;
// compilenode returning 
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject1829 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1829 = alloc_userobj2(2,4, objclass1829);
  gc_frame_newslot(obj1829);
// OBJECT OUTER DEC outer
  adddatum2(obj1829, self, 0);
  addmethodreal(obj1829,"outer", &reader_ast_outer_1830);
  Object oldself1829 = self;
  struct StackFrameObject *oldstackframe1829 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1829);
  gc_frame_newslot((Object)stackframe);
  self = obj1829;
  Object *oldselfslot1829 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1829 = (*(struct UserObject *)self).data[0], lowerouter1829 = thisouter1829;
  if (inheritingObject1829) {
    struct UserObject *inho1829 = (struct UserObject *)inheritingObject1829;
    while (inho1829->super != GraceDefaultObject) inho1829 = (struct UserObject *)inho1829->super;
    inho1829->super = obj1829;
    self = inheritingObject1829;
    *selfslot = self;
    lowerouter1829 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1829;
  }
  block_savedest(obj1829);
  Object closure1831 = createclosure(2, "new");
setclosureframe(closure1831, stackframe);
  addtoclosure(closure1831, var_methodTypeNode);
  addtoclosure(closure1831, var_baseNode);
  struct UserObject *uo1831 = (struct UserObject*)obj1829;
  uo1831->data[1] = (Object)closure1831;
  Method *meth_meth_ast_new1831 = addmethod2pos(obj1829, "new", &meth_ast_new1831, 1);
int argcv_meth_ast_new1831[] = {3};
meth_meth_ast_new1831->type = alloc_MethodType(1, argcv_meth_ast_new1831);
  meth_meth_ast_new1831->definitionModule = modulename;
  meth_meth_ast_new1831->definitionLine = 395;
  block_savedest(obj1829);
  Object closure2282 = createclosure(2, "new()object");
setclosureframe(closure2282, stackframe);
  addtoclosure(closure2282, var_methodTypeNode);
  addtoclosure(closure2282, var_baseNode);
  Method *meth_meth_ast_new1831_object = addmethod2pos(obj1829, "new()object", &meth_ast_new1831_object, 1);
  meth_meth_ast_new1831_object->definitionModule = modulename;
  meth_meth_ast_new1831_object->definitionLine = 395;
  sourceObject = obj1829;
objclass1829 = obj1829->class;
  objclass1829->definitionModule = modulename;
  objclass1829->definitionLine = 395;
  (*(struct UserObject *)self).data[0] = lowerouter1829;
  self = oldself1829;
  selfslot = oldselfslot1829;
  stackframe = oldstackframe1829;
// compilenode returning obj1829
  *var_methodTypeNode = obj1829;
  if (obj1829 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure2283 = createclosure(1, "typeNode");
setclosureframe(closure2283, stackframe);
  addtoclosure(closure2283, var_typeNode);
  struct UserObject *uo2283 = (struct UserObject*)self;
  uo2283->data[17] = (Object)closure2283;
  Method *meth_meth_ast_typeNode2283 = addmethod2pos(self, "typeNode", &meth_ast_typeNode2283, 17);
int argcv_meth_ast_typeNode2283[] = {0};
meth_meth_ast_typeNode2283->type = alloc_MethodType(1, argcv_meth_ast_typeNode2283);
  meth_meth_ast_typeNode2283->definitionModule = modulename;
  meth_meth_ast_typeNode2283->definitionLine = 495;
// compilenode returning 
// Begin line 495
  setline(495);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject2284 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2284 = alloc_userobj2(2,4, objclass2284);
  gc_frame_newslot(obj2284);
// OBJECT OUTER DEC outer
  adddatum2(obj2284, self, 0);
  addmethodreal(obj2284,"outer", &reader_ast_outer_2285);
  Object oldself2284 = self;
  struct StackFrameObject *oldstackframe2284 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2284);
  gc_frame_newslot((Object)stackframe);
  self = obj2284;
  Object *oldselfslot2284 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2284 = (*(struct UserObject *)self).data[0], lowerouter2284 = thisouter2284;
  if (inheritingObject2284) {
    struct UserObject *inho2284 = (struct UserObject *)inheritingObject2284;
    while (inho2284->super != GraceDefaultObject) inho2284 = (struct UserObject *)inho2284->super;
    inho2284->super = obj2284;
    self = inheritingObject2284;
    *selfslot = self;
    lowerouter2284 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2284;
  }
  block_savedest(obj2284);
  Object closure2286 = createclosure(3, "new");
setclosureframe(closure2286, stackframe);
  addtoclosure(closure2286, var_typeNode);
  addtoclosure(closure2286, var_baseNode);
  addtoclosure(closure2286, var_collections);
  struct UserObject *uo2286 = (struct UserObject*)obj2284;
  uo2286->data[1] = (Object)closure2286;
  Method *meth_meth_ast_new2286 = addmethod2pos(obj2284, "new", &meth_ast_new2286, 1);
int argcv_meth_ast_new2286[] = {2};
meth_meth_ast_new2286->type = alloc_MethodType(1, argcv_meth_ast_new2286);
  meth_meth_ast_new2286->definitionModule = modulename;
  meth_meth_ast_new2286->definitionLine = 495;
  block_savedest(obj2284);
  Object closure3027 = createclosure(3, "new()object");
setclosureframe(closure3027, stackframe);
  addtoclosure(closure3027, var_typeNode);
  addtoclosure(closure3027, var_baseNode);
  addtoclosure(closure3027, var_collections);
  Method *meth_meth_ast_new2286_object = addmethod2pos(obj2284, "new()object", &meth_ast_new2286_object, 1);
  meth_meth_ast_new2286_object->definitionModule = modulename;
  meth_meth_ast_new2286_object->definitionLine = 495;
  sourceObject = obj2284;
objclass2284 = obj2284->class;
  objclass2284->definitionModule = modulename;
  objclass2284->definitionLine = 495;
  (*(struct UserObject *)self).data[0] = lowerouter2284;
  self = oldself2284;
  selfslot = oldselfslot2284;
  stackframe = oldstackframe2284;
// compilenode returning obj2284
  *var_typeNode = obj2284;
  if (obj2284 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3028 = createclosure(1, "methodNode");
setclosureframe(closure3028, stackframe);
  addtoclosure(closure3028, var_methodNode);
  struct UserObject *uo3028 = (struct UserObject*)self;
  uo3028->data[18] = (Object)closure3028;
  Method *meth_meth_ast_methodNode3028 = addmethod2pos(self, "methodNode", &meth_ast_methodNode3028, 18);
int argcv_meth_ast_methodNode3028[] = {0};
meth_meth_ast_methodNode3028->type = alloc_MethodType(1, argcv_meth_ast_methodNode3028);
  meth_meth_ast_methodNode3028->definitionModule = modulename;
  meth_meth_ast_methodNode3028->definitionLine = 507;
// compilenode returning 
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject3029 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3029 = alloc_userobj2(2,4, objclass3029);
  gc_frame_newslot(obj3029);
// OBJECT OUTER DEC outer
  adddatum2(obj3029, self, 0);
  addmethodreal(obj3029,"outer", &reader_ast_outer_3030);
  Object oldself3029 = self;
  struct StackFrameObject *oldstackframe3029 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3029);
  gc_frame_newslot((Object)stackframe);
  self = obj3029;
  Object *oldselfslot3029 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3029 = (*(struct UserObject *)self).data[0], lowerouter3029 = thisouter3029;
  if (inheritingObject3029) {
    struct UserObject *inho3029 = (struct UserObject *)inheritingObject3029;
    while (inho3029->super != GraceDefaultObject) inho3029 = (struct UserObject *)inho3029->super;
    inho3029->super = obj3029;
    self = inheritingObject3029;
    *selfslot = self;
    lowerouter3029 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3029;
  }
  block_savedest(obj3029);
  Object closure3031 = createclosure(4, "new");
setclosureframe(closure3031, stackframe);
  addtoclosure(closure3031, var_methodNode);
  addtoclosure(closure3031, var_identifierNode);
  addtoclosure(closure3031, var_baseNode);
  addtoclosure(closure3031, var_collections);
  struct UserObject *uo3031 = (struct UserObject*)obj3029;
  uo3031->data[1] = (Object)closure3031;
  Method *meth_meth_ast_new3031 = addmethod2pos(obj3029, "new", &meth_ast_new3031, 1);
int argcv_meth_ast_new3031[] = {4};
meth_meth_ast_new3031->type = alloc_MethodType(1, argcv_meth_ast_new3031);
  meth_meth_ast_new3031->definitionModule = modulename;
  meth_meth_ast_new3031->definitionLine = 507;
  block_savedest(obj3029);
  Object closure3845 = createclosure(4, "new()object");
setclosureframe(closure3845, stackframe);
  addtoclosure(closure3845, var_methodNode);
  addtoclosure(closure3845, var_identifierNode);
  addtoclosure(closure3845, var_baseNode);
  addtoclosure(closure3845, var_collections);
  Method *meth_meth_ast_new3031_object = addmethod2pos(obj3029, "new()object", &meth_ast_new3031_object, 1);
  meth_meth_ast_new3031_object->definitionModule = modulename;
  meth_meth_ast_new3031_object->definitionLine = 507;
  sourceObject = obj3029;
objclass3029 = obj3029->class;
  objclass3029->definitionModule = modulename;
  objclass3029->definitionLine = 507;
  (*(struct UserObject *)self).data[0] = lowerouter3029;
  self = oldself3029;
  selfslot = oldselfslot3029;
  stackframe = oldstackframe3029;
// compilenode returning obj3029
  *var_methodNode = obj3029;
  if (obj3029 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3846 = createclosure(1, "callNode");
setclosureframe(closure3846, stackframe);
  addtoclosure(closure3846, var_callNode);
  struct UserObject *uo3846 = (struct UserObject*)self;
  uo3846->data[19] = (Object)closure3846;
  Method *meth_meth_ast_callNode3846 = addmethod2pos(self, "callNode", &meth_ast_callNode3846, 19);
int argcv_meth_ast_callNode3846[] = {0};
meth_meth_ast_callNode3846->type = alloc_MethodType(1, argcv_meth_ast_callNode3846);
  meth_meth_ast_callNode3846->definitionModule = modulename;
  meth_meth_ast_callNode3846->definitionLine = 663;
// compilenode returning 
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject3847 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3847 = alloc_userobj2(2,4, objclass3847);
  gc_frame_newslot(obj3847);
// OBJECT OUTER DEC outer
  adddatum2(obj3847, self, 0);
  addmethodreal(obj3847,"outer", &reader_ast_outer_3848);
  Object oldself3847 = self;
  struct StackFrameObject *oldstackframe3847 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3847);
  gc_frame_newslot((Object)stackframe);
  self = obj3847;
  Object *oldselfslot3847 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3847 = (*(struct UserObject *)self).data[0], lowerouter3847 = thisouter3847;
  if (inheritingObject3847) {
    struct UserObject *inho3847 = (struct UserObject *)inheritingObject3847;
    while (inho3847->super != GraceDefaultObject) inho3847 = (struct UserObject *)inho3847->super;
    inho3847->super = obj3847;
    self = inheritingObject3847;
    *selfslot = self;
    lowerouter3847 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3847;
  }
  block_savedest(obj3847);
  Object closure3849 = createclosure(2, "new");
setclosureframe(closure3849, stackframe);
  addtoclosure(closure3849, var_callNode);
  addtoclosure(closure3849, var_baseNode);
  struct UserObject *uo3849 = (struct UserObject*)obj3847;
  uo3849->data[1] = (Object)closure3849;
  Method *meth_meth_ast_new3849 = addmethod2pos(obj3847, "new", &meth_ast_new3849, 1);
int argcv_meth_ast_new3849[] = {2};
meth_meth_ast_new3849->type = alloc_MethodType(1, argcv_meth_ast_new3849);
  meth_meth_ast_new3849->definitionModule = modulename;
  meth_meth_ast_new3849->definitionLine = 663;
  block_savedest(obj3847);
  Object closure4221 = createclosure(2, "new()object");
setclosureframe(closure4221, stackframe);
  addtoclosure(closure4221, var_callNode);
  addtoclosure(closure4221, var_baseNode);
  Method *meth_meth_ast_new3849_object = addmethod2pos(obj3847, "new()object", &meth_ast_new3849_object, 1);
  meth_meth_ast_new3849_object->definitionModule = modulename;
  meth_meth_ast_new3849_object->definitionLine = 663;
  sourceObject = obj3847;
objclass3847 = obj3847->class;
  objclass3847->definitionModule = modulename;
  objclass3847->definitionLine = 663;
  (*(struct UserObject *)self).data[0] = lowerouter3847;
  self = oldself3847;
  selfslot = oldselfslot3847;
  stackframe = oldstackframe3847;
// compilenode returning obj3847
  *var_callNode = obj3847;
  if (obj3847 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure4222 = createclosure(1, "classNode");
setclosureframe(closure4222, stackframe);
  addtoclosure(closure4222, var_classNode);
  struct UserObject *uo4222 = (struct UserObject*)self;
  uo4222->data[20] = (Object)closure4222;
  Method *meth_meth_ast_classNode4222 = addmethod2pos(self, "classNode", &meth_ast_classNode4222, 20);
int argcv_meth_ast_classNode4222[] = {0};
meth_meth_ast_classNode4222->type = alloc_MethodType(1, argcv_meth_ast_classNode4222);
  meth_meth_ast_classNode4222->definitionModule = modulename;
  meth_meth_ast_classNode4222->definitionLine = 891;
// compilenode returning 
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject4223 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4223 = alloc_userobj2(2,4, objclass4223);
  gc_frame_newslot(obj4223);
// OBJECT OUTER DEC outer
  adddatum2(obj4223, self, 0);
  addmethodreal(obj4223,"outer", &reader_ast_outer_4224);
  Object oldself4223 = self;
  struct StackFrameObject *oldstackframe4223 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4223);
  gc_frame_newslot((Object)stackframe);
  self = obj4223;
  Object *oldselfslot4223 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4223 = (*(struct UserObject *)self).data[0], lowerouter4223 = thisouter4223;
  if (inheritingObject4223) {
    struct UserObject *inho4223 = (struct UserObject *)inheritingObject4223;
    while (inho4223->super != GraceDefaultObject) inho4223 = (struct UserObject *)inho4223->super;
    inho4223->super = obj4223;
    self = inheritingObject4223;
    *selfslot = self;
    lowerouter4223 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4223;
  }
  block_savedest(obj4223);
  Object closure4225 = createclosure(4, "new");
setclosureframe(closure4225, stackframe);
  addtoclosure(closure4225, var_classNode);
  addtoclosure(closure4225, var_identifierNode);
  addtoclosure(closure4225, var_baseNode);
  addtoclosure(closure4225, var_collections);
  struct UserObject *uo4225 = (struct UserObject*)obj4223;
  uo4225->data[1] = (Object)closure4225;
  Method *meth_meth_ast_new4225 = addmethod2pos(obj4223, "new", &meth_ast_new4225, 1);
int argcv_meth_ast_new4225[] = {6};
meth_meth_ast_new4225->type = alloc_MethodType(1, argcv_meth_ast_new4225);
  meth_meth_ast_new4225->definitionModule = modulename;
  meth_meth_ast_new4225->definitionLine = 891;
  block_savedest(obj4223);
  Object closure5045 = createclosure(4, "new()object");
setclosureframe(closure5045, stackframe);
  addtoclosure(closure5045, var_classNode);
  addtoclosure(closure5045, var_identifierNode);
  addtoclosure(closure5045, var_baseNode);
  addtoclosure(closure5045, var_collections);
  Method *meth_meth_ast_new4225_object = addmethod2pos(obj4223, "new()object", &meth_ast_new4225_object, 1);
  meth_meth_ast_new4225_object->definitionModule = modulename;
  meth_meth_ast_new4225_object->definitionLine = 891;
  sourceObject = obj4223;
objclass4223 = obj4223->class;
  objclass4223->definitionModule = modulename;
  objclass4223->definitionLine = 891;
  (*(struct UserObject *)self).data[0] = lowerouter4223;
  self = oldself4223;
  selfslot = oldselfslot4223;
  stackframe = oldstackframe4223;
// compilenode returning obj4223
  *var_classNode = obj4223;
  if (obj4223 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5046 = createclosure(1, "objectNode");
setclosureframe(closure5046, stackframe);
  addtoclosure(closure5046, var_objectNode);
  struct UserObject *uo5046 = (struct UserObject*)self;
  uo5046->data[21] = (Object)closure5046;
  Method *meth_meth_ast_objectNode5046 = addmethod2pos(self, "objectNode", &meth_ast_objectNode5046, 21);
int argcv_meth_ast_objectNode5046[] = {0};
meth_meth_ast_objectNode5046->type = alloc_MethodType(1, argcv_meth_ast_objectNode5046);
  meth_meth_ast_objectNode5046->definitionModule = modulename;
  meth_meth_ast_objectNode5046->definitionLine = 927;
// compilenode returning 
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5047 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5047 = alloc_userobj2(2,4, objclass5047);
  gc_frame_newslot(obj5047);
// OBJECT OUTER DEC outer
  adddatum2(obj5047, self, 0);
  addmethodreal(obj5047,"outer", &reader_ast_outer_5048);
  Object oldself5047 = self;
  struct StackFrameObject *oldstackframe5047 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5047);
  gc_frame_newslot((Object)stackframe);
  self = obj5047;
  Object *oldselfslot5047 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5047 = (*(struct UserObject *)self).data[0], lowerouter5047 = thisouter5047;
  if (inheritingObject5047) {
    struct UserObject *inho5047 = (struct UserObject *)inheritingObject5047;
    while (inho5047->super != GraceDefaultObject) inho5047 = (struct UserObject *)inho5047->super;
    inho5047->super = obj5047;
    self = inheritingObject5047;
    *selfslot = self;
    lowerouter5047 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5047;
  }
  block_savedest(obj5047);
  Object closure5049 = createclosure(2, "new");
setclosureframe(closure5049, stackframe);
  addtoclosure(closure5049, var_objectNode);
  addtoclosure(closure5049, var_baseNode);
  struct UserObject *uo5049 = (struct UserObject*)obj5047;
  uo5049->data[1] = (Object)closure5049;
  Method *meth_meth_ast_new5049 = addmethod2pos(obj5047, "new", &meth_ast_new5049, 1);
int argcv_meth_ast_new5049[] = {2};
meth_meth_ast_new5049->type = alloc_MethodType(1, argcv_meth_ast_new5049);
  meth_meth_ast_new5049->definitionModule = modulename;
  meth_meth_ast_new5049->definitionLine = 927;
  block_savedest(obj5047);
  Object closure5284 = createclosure(2, "new()object");
setclosureframe(closure5284, stackframe);
  addtoclosure(closure5284, var_objectNode);
  addtoclosure(closure5284, var_baseNode);
  Method *meth_meth_ast_new5049_object = addmethod2pos(obj5047, "new()object", &meth_ast_new5049_object, 1);
  meth_meth_ast_new5049_object->definitionModule = modulename;
  meth_meth_ast_new5049_object->definitionLine = 927;
  sourceObject = obj5047;
objclass5047 = obj5047->class;
  objclass5047->definitionModule = modulename;
  objclass5047->definitionLine = 927;
  (*(struct UserObject *)self).data[0] = lowerouter5047;
  self = oldself5047;
  selfslot = oldselfslot5047;
  stackframe = oldstackframe5047;
// compilenode returning obj5047
  *var_objectNode = obj5047;
  if (obj5047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5285 = createclosure(1, "arrayNode");
setclosureframe(closure5285, stackframe);
  addtoclosure(closure5285, var_arrayNode);
  struct UserObject *uo5285 = (struct UserObject*)self;
  uo5285->data[22] = (Object)closure5285;
  Method *meth_meth_ast_arrayNode5285 = addmethod2pos(self, "arrayNode", &meth_ast_arrayNode5285, 22);
int argcv_meth_ast_arrayNode5285[] = {0};
meth_meth_ast_arrayNode5285->type = alloc_MethodType(1, argcv_meth_ast_arrayNode5285);
  meth_meth_ast_arrayNode5285->definitionModule = modulename;
  meth_meth_ast_arrayNode5285->definitionLine = 1110;
// compilenode returning 
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5286 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5286 = alloc_userobj2(2,4, objclass5286);
  gc_frame_newslot(obj5286);
// OBJECT OUTER DEC outer
  adddatum2(obj5286, self, 0);
  addmethodreal(obj5286,"outer", &reader_ast_outer_5287);
  Object oldself5286 = self;
  struct StackFrameObject *oldstackframe5286 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5286);
  gc_frame_newslot((Object)stackframe);
  self = obj5286;
  Object *oldselfslot5286 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5286 = (*(struct UserObject *)self).data[0], lowerouter5286 = thisouter5286;
  if (inheritingObject5286) {
    struct UserObject *inho5286 = (struct UserObject *)inheritingObject5286;
    while (inho5286->super != GraceDefaultObject) inho5286 = (struct UserObject *)inho5286->super;
    inho5286->super = obj5286;
    self = inheritingObject5286;
    *selfslot = self;
    lowerouter5286 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5286;
  }
  block_savedest(obj5286);
  Object closure5288 = createclosure(2, "new");
setclosureframe(closure5288, stackframe);
  addtoclosure(closure5288, var_arrayNode);
  addtoclosure(closure5288, var_baseNode);
  struct UserObject *uo5288 = (struct UserObject*)obj5286;
  uo5288->data[1] = (Object)closure5288;
  Method *meth_meth_ast_new5288 = addmethod2pos(obj5286, "new", &meth_ast_new5288, 1);
int argcv_meth_ast_new5288[] = {1};
meth_meth_ast_new5288->type = alloc_MethodType(1, argcv_meth_ast_new5288);
  meth_meth_ast_new5288->definitionModule = modulename;
  meth_meth_ast_new5288->definitionLine = 1110;
  block_savedest(obj5286);
  Object closure5420 = createclosure(2, "new()object");
setclosureframe(closure5420, stackframe);
  addtoclosure(closure5420, var_arrayNode);
  addtoclosure(closure5420, var_baseNode);
  Method *meth_meth_ast_new5288_object = addmethod2pos(obj5286, "new()object", &meth_ast_new5288_object, 1);
  meth_meth_ast_new5288_object->definitionModule = modulename;
  meth_meth_ast_new5288_object->definitionLine = 1110;
  sourceObject = obj5286;
objclass5286 = obj5286->class;
  objclass5286->definitionModule = modulename;
  objclass5286->definitionLine = 1110;
  (*(struct UserObject *)self).data[0] = lowerouter5286;
  self = oldself5286;
  selfslot = oldselfslot5286;
  stackframe = oldstackframe5286;
// compilenode returning obj5286
  *var_arrayNode = obj5286;
  if (obj5286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5421 = createclosure(1, "memberNode");
setclosureframe(closure5421, stackframe);
  addtoclosure(closure5421, var_memberNode);
  struct UserObject *uo5421 = (struct UserObject*)self;
  uo5421->data[23] = (Object)closure5421;
  Method *meth_meth_ast_memberNode5421 = addmethod2pos(self, "memberNode", &meth_ast_memberNode5421, 23);
int argcv_meth_ast_memberNode5421[] = {0};
meth_meth_ast_memberNode5421->type = alloc_MethodType(1, argcv_meth_ast_memberNode5421);
  meth_meth_ast_memberNode5421->definitionModule = modulename;
  meth_meth_ast_memberNode5421->definitionLine = 1154;
// compilenode returning 
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5422 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5422 = alloc_userobj2(2,4, objclass5422);
  gc_frame_newslot(obj5422);
// OBJECT OUTER DEC outer
  adddatum2(obj5422, self, 0);
  addmethodreal(obj5422,"outer", &reader_ast_outer_5423);
  Object oldself5422 = self;
  struct StackFrameObject *oldstackframe5422 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5422);
  gc_frame_newslot((Object)stackframe);
  self = obj5422;
  Object *oldselfslot5422 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5422 = (*(struct UserObject *)self).data[0], lowerouter5422 = thisouter5422;
  if (inheritingObject5422) {
    struct UserObject *inho5422 = (struct UserObject *)inheritingObject5422;
    while (inho5422->super != GraceDefaultObject) inho5422 = (struct UserObject *)inho5422->super;
    inho5422->super = obj5422;
    self = inheritingObject5422;
    *selfslot = self;
    lowerouter5422 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5422;
  }
  block_savedest(obj5422);
  Object closure5424 = createclosure(2, "new");
setclosureframe(closure5424, stackframe);
  addtoclosure(closure5424, var_memberNode);
  addtoclosure(closure5424, var_baseNode);
  struct UserObject *uo5424 = (struct UserObject*)obj5422;
  uo5424->data[1] = (Object)closure5424;
  Method *meth_meth_ast_new5424 = addmethod2pos(obj5422, "new", &meth_ast_new5424, 1);
int argcv_meth_ast_new5424[] = {2};
meth_meth_ast_new5424->type = alloc_MethodType(1, argcv_meth_ast_new5424);
  meth_meth_ast_new5424->definitionModule = modulename;
  meth_meth_ast_new5424->definitionLine = 1154;
  block_savedest(obj5422);
  Object closure5561 = createclosure(2, "new()object");
setclosureframe(closure5561, stackframe);
  addtoclosure(closure5561, var_memberNode);
  addtoclosure(closure5561, var_baseNode);
  Method *meth_meth_ast_new5424_object = addmethod2pos(obj5422, "new()object", &meth_ast_new5424_object, 1);
  meth_meth_ast_new5424_object->definitionModule = modulename;
  meth_meth_ast_new5424_object->definitionLine = 1154;
  sourceObject = obj5422;
objclass5422 = obj5422->class;
  objclass5422->definitionModule = modulename;
  objclass5422->definitionLine = 1154;
  (*(struct UserObject *)self).data[0] = lowerouter5422;
  self = oldself5422;
  selfslot = oldselfslot5422;
  stackframe = oldstackframe5422;
// compilenode returning obj5422
  *var_memberNode = obj5422;
  if (obj5422 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5562 = createclosure(1, "genericNode");
setclosureframe(closure5562, stackframe);
  addtoclosure(closure5562, var_genericNode);
  struct UserObject *uo5562 = (struct UserObject*)self;
  uo5562->data[24] = (Object)closure5562;
  Method *meth_meth_ast_genericNode5562 = addmethod2pos(self, "genericNode", &meth_ast_genericNode5562, 24);
int argcv_meth_ast_genericNode5562[] = {0};
meth_meth_ast_genericNode5562->type = alloc_MethodType(1, argcv_meth_ast_genericNode5562);
  meth_meth_ast_genericNode5562->definitionModule = modulename;
  meth_meth_ast_genericNode5562->definitionLine = 1198;
// compilenode returning 
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5563 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5563 = alloc_userobj2(2,4, objclass5563);
  gc_frame_newslot(obj5563);
// OBJECT OUTER DEC outer
  adddatum2(obj5563, self, 0);
  addmethodreal(obj5563,"outer", &reader_ast_outer_5564);
  Object oldself5563 = self;
  struct StackFrameObject *oldstackframe5563 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5563);
  gc_frame_newslot((Object)stackframe);
  self = obj5563;
  Object *oldselfslot5563 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5563 = (*(struct UserObject *)self).data[0], lowerouter5563 = thisouter5563;
  if (inheritingObject5563) {
    struct UserObject *inho5563 = (struct UserObject *)inheritingObject5563;
    while (inho5563->super != GraceDefaultObject) inho5563 = (struct UserObject *)inho5563->super;
    inho5563->super = obj5563;
    self = inheritingObject5563;
    *selfslot = self;
    lowerouter5563 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5563;
  }
  block_savedest(obj5563);
  Object closure5565 = createclosure(2, "new");
setclosureframe(closure5565, stackframe);
  addtoclosure(closure5565, var_genericNode);
  addtoclosure(closure5565, var_baseNode);
  struct UserObject *uo5565 = (struct UserObject*)obj5563;
  uo5565->data[1] = (Object)closure5565;
  Method *meth_meth_ast_new5565 = addmethod2pos(obj5563, "new", &meth_ast_new5565, 1);
int argcv_meth_ast_new5565[] = {2};
meth_meth_ast_new5565->type = alloc_MethodType(1, argcv_meth_ast_new5565);
  meth_meth_ast_new5565->definitionModule = modulename;
  meth_meth_ast_new5565->definitionLine = 1198;
  block_savedest(obj5563);
  Object closure5708 = createclosure(2, "new()object");
setclosureframe(closure5708, stackframe);
  addtoclosure(closure5708, var_genericNode);
  addtoclosure(closure5708, var_baseNode);
  Method *meth_meth_ast_new5565_object = addmethod2pos(obj5563, "new()object", &meth_ast_new5565_object, 1);
  meth_meth_ast_new5565_object->definitionModule = modulename;
  meth_meth_ast_new5565_object->definitionLine = 1198;
  sourceObject = obj5563;
objclass5563 = obj5563->class;
  objclass5563->definitionModule = modulename;
  objclass5563->definitionLine = 1198;
  (*(struct UserObject *)self).data[0] = lowerouter5563;
  self = oldself5563;
  selfslot = oldselfslot5563;
  stackframe = oldstackframe5563;
// compilenode returning obj5563
  *var_genericNode = obj5563;
  if (obj5563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5709 = createclosure(1, "identifierNode");
setclosureframe(closure5709, stackframe);
  addtoclosure(closure5709, var_identifierNode);
  struct UserObject *uo5709 = (struct UserObject*)self;
  uo5709->data[25] = (Object)closure5709;
  Method *meth_meth_ast_identifierNode5709 = addmethod2pos(self, "identifierNode", &meth_ast_identifierNode5709, 25);
int argcv_meth_ast_identifierNode5709[] = {0};
meth_meth_ast_identifierNode5709->type = alloc_MethodType(1, argcv_meth_ast_identifierNode5709);
  meth_meth_ast_identifierNode5709->definitionModule = modulename;
  meth_meth_ast_identifierNode5709->definitionLine = 1239;
// compilenode returning 
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5710 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5710 = alloc_userobj2(2,4, objclass5710);
  gc_frame_newslot(obj5710);
// OBJECT OUTER DEC outer
  adddatum2(obj5710, self, 0);
  addmethodreal(obj5710,"outer", &reader_ast_outer_5711);
  Object oldself5710 = self;
  struct StackFrameObject *oldstackframe5710 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5710);
  gc_frame_newslot((Object)stackframe);
  self = obj5710;
  Object *oldselfslot5710 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5710 = (*(struct UserObject *)self).data[0], lowerouter5710 = thisouter5710;
  if (inheritingObject5710) {
    struct UserObject *inho5710 = (struct UserObject *)inheritingObject5710;
    while (inho5710->super != GraceDefaultObject) inho5710 = (struct UserObject *)inho5710->super;
    inho5710->super = obj5710;
    self = inheritingObject5710;
    *selfslot = self;
    lowerouter5710 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5710;
  }
  block_savedest(obj5710);
  Object closure5712 = createclosure(3, "new");
setclosureframe(closure5712, stackframe);
  addtoclosure(closure5712, var_util);
  addtoclosure(closure5712, var_identifierNode);
  addtoclosure(closure5712, var_baseNode);
  struct UserObject *uo5712 = (struct UserObject*)obj5710;
  uo5712->data[1] = (Object)closure5712;
  Method *meth_meth_ast_new5712 = addmethod2pos(obj5710, "new", &meth_ast_new5712, 1);
int argcv_meth_ast_new5712[] = {2};
meth_meth_ast_new5712->type = alloc_MethodType(1, argcv_meth_ast_new5712);
  meth_meth_ast_new5712->definitionModule = modulename;
  meth_meth_ast_new5712->definitionLine = 1239;
  block_savedest(obj5710);
  Object closure5947 = createclosure(3, "new()object");
setclosureframe(closure5947, stackframe);
  addtoclosure(closure5947, var_util);
  addtoclosure(closure5947, var_identifierNode);
  addtoclosure(closure5947, var_baseNode);
  Method *meth_meth_ast_new5712_object = addmethod2pos(obj5710, "new()object", &meth_ast_new5712_object, 1);
  meth_meth_ast_new5712_object->definitionModule = modulename;
  meth_meth_ast_new5712_object->definitionLine = 1239;
  sourceObject = obj5710;
objclass5710 = obj5710->class;
  objclass5710->definitionModule = modulename;
  objclass5710->definitionLine = 1239;
  (*(struct UserObject *)self).data[0] = lowerouter5710;
  self = oldself5710;
  selfslot = oldselfslot5710;
  stackframe = oldstackframe5710;
// compilenode returning obj5710
  *var_identifierNode = obj5710;
  if (obj5710 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5948 = createclosure(1, "octetsNode");
setclosureframe(closure5948, stackframe);
  addtoclosure(closure5948, var_octetsNode);
  struct UserObject *uo5948 = (struct UserObject*)self;
  uo5948->data[26] = (Object)closure5948;
  Method *meth_meth_ast_octetsNode5948 = addmethod2pos(self, "octetsNode", &meth_ast_octetsNode5948, 26);
int argcv_meth_ast_octetsNode5948[] = {0};
meth_meth_ast_octetsNode5948->type = alloc_MethodType(1, argcv_meth_ast_octetsNode5948);
  meth_meth_ast_octetsNode5948->definitionModule = modulename;
  meth_meth_ast_octetsNode5948->definitionLine = 1315;
// compilenode returning 
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5949 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5949 = alloc_userobj2(2,4, objclass5949);
  gc_frame_newslot(obj5949);
// OBJECT OUTER DEC outer
  adddatum2(obj5949, self, 0);
  addmethodreal(obj5949,"outer", &reader_ast_outer_5950);
  Object oldself5949 = self;
  struct StackFrameObject *oldstackframe5949 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5949);
  gc_frame_newslot((Object)stackframe);
  self = obj5949;
  Object *oldselfslot5949 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5949 = (*(struct UserObject *)self).data[0], lowerouter5949 = thisouter5949;
  if (inheritingObject5949) {
    struct UserObject *inho5949 = (struct UserObject *)inheritingObject5949;
    while (inho5949->super != GraceDefaultObject) inho5949 = (struct UserObject *)inho5949->super;
    inho5949->super = obj5949;
    self = inheritingObject5949;
    *selfslot = self;
    lowerouter5949 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5949;
  }
  block_savedest(obj5949);
  Object closure5951 = createclosure(1, "new");
setclosureframe(closure5951, stackframe);
  addtoclosure(closure5951, var_baseNode);
  struct UserObject *uo5951 = (struct UserObject*)obj5949;
  uo5951->data[1] = (Object)closure5951;
  Method *meth_meth_ast_new5951 = addmethod2pos(obj5949, "new", &meth_ast_new5951, 1);
int argcv_meth_ast_new5951[] = {1};
meth_meth_ast_new5951->type = alloc_MethodType(1, argcv_meth_ast_new5951);
  meth_meth_ast_new5951->definitionModule = modulename;
  meth_meth_ast_new5951->definitionLine = 1315;
  block_savedest(obj5949);
  Object closure5976 = createclosure(1, "new()object");
setclosureframe(closure5976, stackframe);
  addtoclosure(closure5976, var_baseNode);
  Method *meth_meth_ast_new5951_object = addmethod2pos(obj5949, "new()object", &meth_ast_new5951_object, 1);
  meth_meth_ast_new5951_object->definitionModule = modulename;
  meth_meth_ast_new5951_object->definitionLine = 1315;
  sourceObject = obj5949;
objclass5949 = obj5949->class;
  objclass5949->definitionModule = modulename;
  objclass5949->definitionLine = 1315;
  (*(struct UserObject *)self).data[0] = lowerouter5949;
  self = oldself5949;
  selfslot = oldselfslot5949;
  stackframe = oldstackframe5949;
// compilenode returning obj5949
  *var_octetsNode = obj5949;
  if (obj5949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5977 = createclosure(1, "stringNode");
setclosureframe(closure5977, stackframe);
  addtoclosure(closure5977, var_stringNode);
  struct UserObject *uo5977 = (struct UserObject*)self;
  uo5977->data[27] = (Object)closure5977;
  Method *meth_meth_ast_stringNode5977 = addmethod2pos(self, "stringNode", &meth_ast_stringNode5977, 27);
int argcv_meth_ast_stringNode5977[] = {0};
meth_meth_ast_stringNode5977->type = alloc_MethodType(1, argcv_meth_ast_stringNode5977);
  meth_meth_ast_stringNode5977->definitionModule = modulename;
  meth_meth_ast_stringNode5977->definitionLine = 1334;
// compilenode returning 
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject5978 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5978 = alloc_userobj2(2,4, objclass5978);
  gc_frame_newslot(obj5978);
// OBJECT OUTER DEC outer
  adddatum2(obj5978, self, 0);
  addmethodreal(obj5978,"outer", &reader_ast_outer_5979);
  Object oldself5978 = self;
  struct StackFrameObject *oldstackframe5978 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5978);
  gc_frame_newslot((Object)stackframe);
  self = obj5978;
  Object *oldselfslot5978 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5978 = (*(struct UserObject *)self).data[0], lowerouter5978 = thisouter5978;
  if (inheritingObject5978) {
    struct UserObject *inho5978 = (struct UserObject *)inheritingObject5978;
    while (inho5978->super != GraceDefaultObject) inho5978 = (struct UserObject *)inho5978->super;
    inho5978->super = obj5978;
    self = inheritingObject5978;
    *selfslot = self;
    lowerouter5978 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5978;
  }
  block_savedest(obj5978);
  Object closure5980 = createclosure(1, "new");
setclosureframe(closure5980, stackframe);
  addtoclosure(closure5980, var_baseNode);
  struct UserObject *uo5980 = (struct UserObject*)obj5978;
  uo5980->data[1] = (Object)closure5980;
  Method *meth_meth_ast_new5980 = addmethod2pos(obj5978, "new", &meth_ast_new5980, 1);
int argcv_meth_ast_new5980[] = {1};
meth_meth_ast_new5980->type = alloc_MethodType(1, argcv_meth_ast_new5980);
  meth_meth_ast_new5980->definitionModule = modulename;
  meth_meth_ast_new5980->definitionLine = 1334;
  block_savedest(obj5978);
  Object closure6080 = createclosure(1, "new()object");
setclosureframe(closure6080, stackframe);
  addtoclosure(closure6080, var_baseNode);
  Method *meth_meth_ast_new5980_object = addmethod2pos(obj5978, "new()object", &meth_ast_new5980_object, 1);
  meth_meth_ast_new5980_object->definitionModule = modulename;
  meth_meth_ast_new5980_object->definitionLine = 1334;
  sourceObject = obj5978;
objclass5978 = obj5978->class;
  objclass5978->definitionModule = modulename;
  objclass5978->definitionLine = 1334;
  (*(struct UserObject *)self).data[0] = lowerouter5978;
  self = oldself5978;
  selfslot = oldselfslot5978;
  stackframe = oldstackframe5978;
// compilenode returning obj5978
  *var_stringNode = obj5978;
  if (obj5978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6081 = createclosure(1, "numNode");
setclosureframe(closure6081, stackframe);
  addtoclosure(closure6081, var_numNode);
  struct UserObject *uo6081 = (struct UserObject*)self;
  uo6081->data[28] = (Object)closure6081;
  Method *meth_meth_ast_numNode6081 = addmethod2pos(self, "numNode", &meth_ast_numNode6081, 28);
int argcv_meth_ast_numNode6081[] = {0};
meth_meth_ast_numNode6081->type = alloc_MethodType(1, argcv_meth_ast_numNode6081);
  meth_meth_ast_numNode6081->definitionModule = modulename;
  meth_meth_ast_numNode6081->definitionLine = 1359;
// compilenode returning 
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6082 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6082 = alloc_userobj2(2,4, objclass6082);
  gc_frame_newslot(obj6082);
// OBJECT OUTER DEC outer
  adddatum2(obj6082, self, 0);
  addmethodreal(obj6082,"outer", &reader_ast_outer_6083);
  Object oldself6082 = self;
  struct StackFrameObject *oldstackframe6082 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6082);
  gc_frame_newslot((Object)stackframe);
  self = obj6082;
  Object *oldselfslot6082 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6082 = (*(struct UserObject *)self).data[0], lowerouter6082 = thisouter6082;
  if (inheritingObject6082) {
    struct UserObject *inho6082 = (struct UserObject *)inheritingObject6082;
    while (inho6082->super != GraceDefaultObject) inho6082 = (struct UserObject *)inho6082->super;
    inho6082->super = obj6082;
    self = inheritingObject6082;
    *selfslot = self;
    lowerouter6082 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6082;
  }
  block_savedest(obj6082);
  Object closure6084 = createclosure(1, "new");
setclosureframe(closure6084, stackframe);
  addtoclosure(closure6084, var_baseNode);
  struct UserObject *uo6084 = (struct UserObject*)obj6082;
  uo6084->data[1] = (Object)closure6084;
  Method *meth_meth_ast_new6084 = addmethod2pos(obj6082, "new", &meth_ast_new6084, 1);
int argcv_meth_ast_new6084[] = {1};
meth_meth_ast_new6084->type = alloc_MethodType(1, argcv_meth_ast_new6084);
  meth_meth_ast_new6084->definitionModule = modulename;
  meth_meth_ast_new6084->definitionLine = 1359;
  block_savedest(obj6082);
  Object closure6131 = createclosure(1, "new()object");
setclosureframe(closure6131, stackframe);
  addtoclosure(closure6131, var_baseNode);
  Method *meth_meth_ast_new6084_object = addmethod2pos(obj6082, "new()object", &meth_ast_new6084_object, 1);
  meth_meth_ast_new6084_object->definitionModule = modulename;
  meth_meth_ast_new6084_object->definitionLine = 1359;
  sourceObject = obj6082;
objclass6082 = obj6082->class;
  objclass6082->definitionModule = modulename;
  objclass6082->definitionLine = 1359;
  (*(struct UserObject *)self).data[0] = lowerouter6082;
  self = oldself6082;
  selfslot = oldselfslot6082;
  stackframe = oldstackframe6082;
// compilenode returning obj6082
  *var_numNode = obj6082;
  if (obj6082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6132 = createclosure(1, "opNode");
setclosureframe(closure6132, stackframe);
  addtoclosure(closure6132, var_opNode);
  struct UserObject *uo6132 = (struct UserObject*)self;
  uo6132->data[29] = (Object)closure6132;
  Method *meth_meth_ast_opNode6132 = addmethod2pos(self, "opNode", &meth_ast_opNode6132, 29);
int argcv_meth_ast_opNode6132[] = {0};
meth_meth_ast_opNode6132->type = alloc_MethodType(1, argcv_meth_ast_opNode6132);
  meth_meth_ast_opNode6132->definitionModule = modulename;
  meth_meth_ast_opNode6132->definitionLine = 1398;
// compilenode returning 
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6133 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6133 = alloc_userobj2(2,4, objclass6133);
  gc_frame_newslot(obj6133);
// OBJECT OUTER DEC outer
  adddatum2(obj6133, self, 0);
  addmethodreal(obj6133,"outer", &reader_ast_outer_6134);
  Object oldself6133 = self;
  struct StackFrameObject *oldstackframe6133 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6133);
  gc_frame_newslot((Object)stackframe);
  self = obj6133;
  Object *oldselfslot6133 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6133 = (*(struct UserObject *)self).data[0], lowerouter6133 = thisouter6133;
  if (inheritingObject6133) {
    struct UserObject *inho6133 = (struct UserObject *)inheritingObject6133;
    while (inho6133->super != GraceDefaultObject) inho6133 = (struct UserObject *)inho6133->super;
    inho6133->super = obj6133;
    self = inheritingObject6133;
    *selfslot = self;
    lowerouter6133 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6133;
  }
  block_savedest(obj6133);
  Object closure6135 = createclosure(2, "new");
setclosureframe(closure6135, stackframe);
  addtoclosure(closure6135, var_opNode);
  addtoclosure(closure6135, var_baseNode);
  struct UserObject *uo6135 = (struct UserObject*)obj6133;
  uo6135->data[1] = (Object)closure6135;
  Method *meth_meth_ast_new6135 = addmethod2pos(obj6133, "new", &meth_ast_new6135, 1);
int argcv_meth_ast_new6135[] = {3};
meth_meth_ast_new6135->type = alloc_MethodType(1, argcv_meth_ast_new6135);
  meth_meth_ast_new6135->definitionModule = modulename;
  meth_meth_ast_new6135->definitionLine = 1398;
  block_savedest(obj6133);
  Object closure6373 = createclosure(2, "new()object");
setclosureframe(closure6373, stackframe);
  addtoclosure(closure6373, var_opNode);
  addtoclosure(closure6373, var_baseNode);
  Method *meth_meth_ast_new6135_object = addmethod2pos(obj6133, "new()object", &meth_ast_new6135_object, 1);
  meth_meth_ast_new6135_object->definitionModule = modulename;
  meth_meth_ast_new6135_object->definitionLine = 1398;
  sourceObject = obj6133;
objclass6133 = obj6133->class;
  objclass6133->definitionModule = modulename;
  objclass6133->definitionLine = 1398;
  (*(struct UserObject *)self).data[0] = lowerouter6133;
  self = oldself6133;
  selfslot = oldselfslot6133;
  stackframe = oldstackframe6133;
// compilenode returning obj6133
  *var_opNode = obj6133;
  if (obj6133 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6374 = createclosure(1, "indexNode");
setclosureframe(closure6374, stackframe);
  addtoclosure(closure6374, var_indexNode);
  struct UserObject *uo6374 = (struct UserObject*)self;
  uo6374->data[30] = (Object)closure6374;
  Method *meth_meth_ast_indexNode6374 = addmethod2pos(self, "indexNode", &meth_ast_indexNode6374, 30);
int argcv_meth_ast_indexNode6374[] = {0};
meth_meth_ast_indexNode6374->type = alloc_MethodType(1, argcv_meth_ast_indexNode6374);
  meth_meth_ast_indexNode6374->definitionModule = modulename;
  meth_meth_ast_indexNode6374->definitionLine = 1451;
// compilenode returning 
// Begin line 1451
  setline(1451);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6375 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6375 = alloc_userobj2(2,4, objclass6375);
  gc_frame_newslot(obj6375);
// OBJECT OUTER DEC outer
  adddatum2(obj6375, self, 0);
  addmethodreal(obj6375,"outer", &reader_ast_outer_6376);
  Object oldself6375 = self;
  struct StackFrameObject *oldstackframe6375 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6375);
  gc_frame_newslot((Object)stackframe);
  self = obj6375;
  Object *oldselfslot6375 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6375 = (*(struct UserObject *)self).data[0], lowerouter6375 = thisouter6375;
  if (inheritingObject6375) {
    struct UserObject *inho6375 = (struct UserObject *)inheritingObject6375;
    while (inho6375->super != GraceDefaultObject) inho6375 = (struct UserObject *)inho6375->super;
    inho6375->super = obj6375;
    self = inheritingObject6375;
    *selfslot = self;
    lowerouter6375 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6375;
  }
  block_savedest(obj6375);
  Object closure6377 = createclosure(2, "new");
setclosureframe(closure6377, stackframe);
  addtoclosure(closure6377, var_indexNode);
  addtoclosure(closure6377, var_baseNode);
  struct UserObject *uo6377 = (struct UserObject*)obj6375;
  uo6377->data[1] = (Object)closure6377;
  Method *meth_meth_ast_new6377 = addmethod2pos(obj6375, "new", &meth_ast_new6377, 1);
int argcv_meth_ast_new6377[] = {2};
meth_meth_ast_new6377->type = alloc_MethodType(1, argcv_meth_ast_new6377);
  meth_meth_ast_new6377->definitionModule = modulename;
  meth_meth_ast_new6377->definitionLine = 1451;
  block_savedest(obj6375);
  Object closure6534 = createclosure(2, "new()object");
setclosureframe(closure6534, stackframe);
  addtoclosure(closure6534, var_indexNode);
  addtoclosure(closure6534, var_baseNode);
  Method *meth_meth_ast_new6377_object = addmethod2pos(obj6375, "new()object", &meth_ast_new6377_object, 1);
  meth_meth_ast_new6377_object->definitionModule = modulename;
  meth_meth_ast_new6377_object->definitionLine = 1451;
  sourceObject = obj6375;
objclass6375 = obj6375->class;
  objclass6375->definitionModule = modulename;
  objclass6375->definitionLine = 1451;
  (*(struct UserObject *)self).data[0] = lowerouter6375;
  self = oldself6375;
  selfslot = oldselfslot6375;
  stackframe = oldstackframe6375;
// compilenode returning obj6375
  *var_indexNode = obj6375;
  if (obj6375 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6535 = createclosure(1, "bindNode");
setclosureframe(closure6535, stackframe);
  addtoclosure(closure6535, var_bindNode);
  struct UserObject *uo6535 = (struct UserObject*)self;
  uo6535->data[31] = (Object)closure6535;
  Method *meth_meth_ast_bindNode6535 = addmethod2pos(self, "bindNode", &meth_ast_bindNode6535, 31);
int argcv_meth_ast_bindNode6535[] = {0};
meth_meth_ast_bindNode6535->type = alloc_MethodType(1, argcv_meth_ast_bindNode6535);
  meth_meth_ast_bindNode6535->definitionModule = modulename;
  meth_meth_ast_bindNode6535->definitionLine = 1496;
// compilenode returning 
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6536 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6536 = alloc_userobj2(2,4, objclass6536);
  gc_frame_newslot(obj6536);
// OBJECT OUTER DEC outer
  adddatum2(obj6536, self, 0);
  addmethodreal(obj6536,"outer", &reader_ast_outer_6537);
  Object oldself6536 = self;
  struct StackFrameObject *oldstackframe6536 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6536);
  gc_frame_newslot((Object)stackframe);
  self = obj6536;
  Object *oldselfslot6536 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6536 = (*(struct UserObject *)self).data[0], lowerouter6536 = thisouter6536;
  if (inheritingObject6536) {
    struct UserObject *inho6536 = (struct UserObject *)inheritingObject6536;
    while (inho6536->super != GraceDefaultObject) inho6536 = (struct UserObject *)inho6536->super;
    inho6536->super = obj6536;
    self = inheritingObject6536;
    *selfslot = self;
    lowerouter6536 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6536;
  }
  block_savedest(obj6536);
  Object closure6538 = createclosure(2, "new");
setclosureframe(closure6538, stackframe);
  addtoclosure(closure6538, var_bindNode);
  addtoclosure(closure6538, var_baseNode);
  struct UserObject *uo6538 = (struct UserObject*)obj6536;
  uo6538->data[1] = (Object)closure6538;
  Method *meth_meth_ast_new6538 = addmethod2pos(obj6536, "new", &meth_ast_new6538, 1);
int argcv_meth_ast_new6538[] = {2};
meth_meth_ast_new6538->type = alloc_MethodType(1, argcv_meth_ast_new6538);
  meth_meth_ast_new6538->definitionModule = modulename;
  meth_meth_ast_new6538->definitionLine = 1496;
  block_savedest(obj6536);
  Object closure6691 = createclosure(2, "new()object");
setclosureframe(closure6691, stackframe);
  addtoclosure(closure6691, var_bindNode);
  addtoclosure(closure6691, var_baseNode);
  Method *meth_meth_ast_new6538_object = addmethod2pos(obj6536, "new()object", &meth_ast_new6538_object, 1);
  meth_meth_ast_new6538_object->definitionModule = modulename;
  meth_meth_ast_new6538_object->definitionLine = 1496;
  sourceObject = obj6536;
objclass6536 = obj6536->class;
  objclass6536->definitionModule = modulename;
  objclass6536->definitionLine = 1496;
  (*(struct UserObject *)self).data[0] = lowerouter6536;
  self = oldself6536;
  selfslot = oldselfslot6536;
  stackframe = oldstackframe6536;
// compilenode returning obj6536
  *var_bindNode = obj6536;
  if (obj6536 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1544
  setline(1544);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6692 = createclosure(1, "defDecNode");
setclosureframe(closure6692, stackframe);
  addtoclosure(closure6692, var_defDecNode);
  struct UserObject *uo6692 = (struct UserObject*)self;
  uo6692->data[32] = (Object)closure6692;
  Method *meth_meth_ast_defDecNode6692 = addmethod2pos(self, "defDecNode", &meth_ast_defDecNode6692, 32);
int argcv_meth_ast_defDecNode6692[] = {0};
meth_meth_ast_defDecNode6692->type = alloc_MethodType(1, argcv_meth_ast_defDecNode6692);
  meth_meth_ast_defDecNode6692->definitionModule = modulename;
  meth_meth_ast_defDecNode6692->definitionLine = 1540;
// compilenode returning 
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject6693 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6693 = alloc_userobj2(2,4, objclass6693);
  gc_frame_newslot(obj6693);
// OBJECT OUTER DEC outer
  adddatum2(obj6693, self, 0);
  addmethodreal(obj6693,"outer", &reader_ast_outer_6694);
  Object oldself6693 = self;
  struct StackFrameObject *oldstackframe6693 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6693);
  gc_frame_newslot((Object)stackframe);
  self = obj6693;
  Object *oldselfslot6693 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6693 = (*(struct UserObject *)self).data[0], lowerouter6693 = thisouter6693;
  if (inheritingObject6693) {
    struct UserObject *inho6693 = (struct UserObject *)inheritingObject6693;
    while (inho6693->super != GraceDefaultObject) inho6693 = (struct UserObject *)inho6693->super;
    inho6693->super = obj6693;
    self = inheritingObject6693;
    *selfslot = self;
    lowerouter6693 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6693;
  }
  block_savedest(obj6693);
  Object closure6695 = createclosure(4, "new");
setclosureframe(closure6695, stackframe);
  addtoclosure(closure6695, var_defDecNode);
  addtoclosure(closure6695, var_identifierNode);
  addtoclosure(closure6695, var_baseNode);
  addtoclosure(closure6695, var_collections);
  struct UserObject *uo6695 = (struct UserObject*)obj6693;
  uo6695->data[1] = (Object)closure6695;
  Method *meth_meth_ast_new6695 = addmethod2pos(obj6693, "new", &meth_ast_new6695, 1);
int argcv_meth_ast_new6695[] = {3};
meth_meth_ast_new6695->type = alloc_MethodType(1, argcv_meth_ast_new6695);
  meth_meth_ast_new6695->definitionModule = modulename;
  meth_meth_ast_new6695->definitionLine = 1540;
  block_savedest(obj6693);
  Object closure7032 = createclosure(4, "new()object");
setclosureframe(closure7032, stackframe);
  addtoclosure(closure7032, var_defDecNode);
  addtoclosure(closure7032, var_identifierNode);
  addtoclosure(closure7032, var_baseNode);
  addtoclosure(closure7032, var_collections);
  Method *meth_meth_ast_new6695_object = addmethod2pos(obj6693, "new()object", &meth_ast_new6695_object, 1);
  meth_meth_ast_new6695_object->definitionModule = modulename;
  meth_meth_ast_new6695_object->definitionLine = 1540;
  sourceObject = obj6693;
objclass6693 = obj6693->class;
  objclass6693->definitionModule = modulename;
  objclass6693->definitionLine = 1540;
  (*(struct UserObject *)self).data[0] = lowerouter6693;
  self = oldself6693;
  selfslot = oldselfslot6693;
  stackframe = oldstackframe6693;
// compilenode returning obj6693
  *var_defDecNode = obj6693;
  if (obj6693 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7033 = createclosure(1, "varDecNode");
setclosureframe(closure7033, stackframe);
  addtoclosure(closure7033, var_varDecNode);
  struct UserObject *uo7033 = (struct UserObject*)self;
  uo7033->data[33] = (Object)closure7033;
  Method *meth_meth_ast_varDecNode7033 = addmethod2pos(self, "varDecNode", &meth_ast_varDecNode7033, 33);
int argcv_meth_ast_varDecNode7033[] = {0};
meth_meth_ast_varDecNode7033->type = alloc_MethodType(1, argcv_meth_ast_varDecNode7033);
  meth_meth_ast_varDecNode7033->definitionModule = modulename;
  meth_meth_ast_varDecNode7033->definitionLine = 1550;
// compilenode returning 
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7034 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7034 = alloc_userobj2(2,4, objclass7034);
  gc_frame_newslot(obj7034);
// OBJECT OUTER DEC outer
  adddatum2(obj7034, self, 0);
  addmethodreal(obj7034,"outer", &reader_ast_outer_7035);
  Object oldself7034 = self;
  struct StackFrameObject *oldstackframe7034 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7034);
  gc_frame_newslot((Object)stackframe);
  self = obj7034;
  Object *oldselfslot7034 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7034 = (*(struct UserObject *)self).data[0], lowerouter7034 = thisouter7034;
  if (inheritingObject7034) {
    struct UserObject *inho7034 = (struct UserObject *)inheritingObject7034;
    while (inho7034->super != GraceDefaultObject) inho7034 = (struct UserObject *)inho7034->super;
    inho7034->super = obj7034;
    self = inheritingObject7034;
    *selfslot = self;
    lowerouter7034 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7034;
  }
  block_savedest(obj7034);
  Object closure7036 = createclosure(4, "new");
setclosureframe(closure7036, stackframe);
  addtoclosure(closure7036, var_varDecNode);
  addtoclosure(closure7036, var_identifierNode);
  addtoclosure(closure7036, var_baseNode);
  addtoclosure(closure7036, var_collections);
  struct UserObject *uo7036 = (struct UserObject*)obj7034;
  uo7036->data[1] = (Object)closure7036;
  Method *meth_meth_ast_new7036 = addmethod2pos(obj7034, "new", &meth_ast_new7036, 1);
int argcv_meth_ast_new7036[] = {3};
meth_meth_ast_new7036->type = alloc_MethodType(1, argcv_meth_ast_new7036);
  meth_meth_ast_new7036->definitionModule = modulename;
  meth_meth_ast_new7036->definitionLine = 1550;
  block_savedest(obj7034);
  Object closure7377 = createclosure(4, "new()object");
setclosureframe(closure7377, stackframe);
  addtoclosure(closure7377, var_varDecNode);
  addtoclosure(closure7377, var_identifierNode);
  addtoclosure(closure7377, var_baseNode);
  addtoclosure(closure7377, var_collections);
  Method *meth_meth_ast_new7036_object = addmethod2pos(obj7034, "new()object", &meth_ast_new7036_object, 1);
  meth_meth_ast_new7036_object->definitionModule = modulename;
  meth_meth_ast_new7036_object->definitionLine = 1550;
  sourceObject = obj7034;
objclass7034 = obj7034->class;
  objclass7034->definitionModule = modulename;
  objclass7034->definitionLine = 1550;
  (*(struct UserObject *)self).data[0] = lowerouter7034;
  self = oldself7034;
  selfslot = oldselfslot7034;
  stackframe = oldstackframe7034;
// compilenode returning obj7034
  *var_varDecNode = obj7034;
  if (obj7034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1701
  setline(1701);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7378 = createclosure(1, "importNode");
setclosureframe(closure7378, stackframe);
  addtoclosure(closure7378, var_importNode);
  struct UserObject *uo7378 = (struct UserObject*)self;
  uo7378->data[34] = (Object)closure7378;
  Method *meth_meth_ast_importNode7378 = addmethod2pos(self, "importNode", &meth_ast_importNode7378, 34);
int argcv_meth_ast_importNode7378[] = {0};
meth_meth_ast_importNode7378->type = alloc_MethodType(1, argcv_meth_ast_importNode7378);
  meth_meth_ast_importNode7378->definitionModule = modulename;
  meth_meth_ast_importNode7378->definitionLine = 1629;
// compilenode returning 
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7379 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7379 = alloc_userobj2(2,4, objclass7379);
  gc_frame_newslot(obj7379);
// OBJECT OUTER DEC outer
  adddatum2(obj7379, self, 0);
  addmethodreal(obj7379,"outer", &reader_ast_outer_7380);
  Object oldself7379 = self;
  struct StackFrameObject *oldstackframe7379 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7379);
  gc_frame_newslot((Object)stackframe);
  self = obj7379;
  Object *oldselfslot7379 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7379 = (*(struct UserObject *)self).data[0], lowerouter7379 = thisouter7379;
  if (inheritingObject7379) {
    struct UserObject *inho7379 = (struct UserObject *)inheritingObject7379;
    while (inho7379->super != GraceDefaultObject) inho7379 = (struct UserObject *)inho7379->super;
    inho7379->super = obj7379;
    self = inheritingObject7379;
    *selfslot = self;
    lowerouter7379 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7379;
  }
  block_savedest(obj7379);
  Object closure7381 = createclosure(1, "new");
setclosureframe(closure7381, stackframe);
  addtoclosure(closure7381, var_baseNode);
  struct UserObject *uo7381 = (struct UserObject*)obj7379;
  uo7381->data[1] = (Object)closure7381;
  Method *meth_meth_ast_new7381 = addmethod2pos(obj7379, "new", &meth_ast_new7381, 1);
int argcv_meth_ast_new7381[] = {2};
meth_meth_ast_new7381->type = alloc_MethodType(1, argcv_meth_ast_new7381);
  meth_meth_ast_new7381->definitionModule = modulename;
  meth_meth_ast_new7381->definitionLine = 1629;
  block_savedest(obj7379);
  Object closure7501 = createclosure(1, "new()object");
setclosureframe(closure7501, stackframe);
  addtoclosure(closure7501, var_baseNode);
  Method *meth_meth_ast_new7381_object = addmethod2pos(obj7379, "new()object", &meth_ast_new7381_object, 1);
  meth_meth_ast_new7381_object->definitionModule = modulename;
  meth_meth_ast_new7381_object->definitionLine = 1629;
  sourceObject = obj7379;
objclass7379 = obj7379->class;
  objclass7379->definitionModule = modulename;
  objclass7379->definitionLine = 1629;
  (*(struct UserObject *)self).data[0] = lowerouter7379;
  self = oldself7379;
  selfslot = oldselfslot7379;
  stackframe = oldstackframe7379;
// compilenode returning obj7379
  *var_importNode = obj7379;
  if (obj7379 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7502 = createclosure(1, "dialectNode");
setclosureframe(closure7502, stackframe);
  addtoclosure(closure7502, var_dialectNode);
  struct UserObject *uo7502 = (struct UserObject*)self;
  uo7502->data[35] = (Object)closure7502;
  Method *meth_meth_ast_dialectNode7502 = addmethod2pos(self, "dialectNode", &meth_ast_dialectNode7502, 35);
int argcv_meth_ast_dialectNode7502[] = {0};
meth_meth_ast_dialectNode7502->type = alloc_MethodType(1, argcv_meth_ast_dialectNode7502);
  meth_meth_ast_dialectNode7502->definitionModule = modulename;
  meth_meth_ast_dialectNode7502->definitionLine = 1733;
// compilenode returning 
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7503 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7503 = alloc_userobj2(2,4, objclass7503);
  gc_frame_newslot(obj7503);
// OBJECT OUTER DEC outer
  adddatum2(obj7503, self, 0);
  addmethodreal(obj7503,"outer", &reader_ast_outer_7504);
  Object oldself7503 = self;
  struct StackFrameObject *oldstackframe7503 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7503);
  gc_frame_newslot((Object)stackframe);
  self = obj7503;
  Object *oldselfslot7503 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7503 = (*(struct UserObject *)self).data[0], lowerouter7503 = thisouter7503;
  if (inheritingObject7503) {
    struct UserObject *inho7503 = (struct UserObject *)inheritingObject7503;
    while (inho7503->super != GraceDefaultObject) inho7503 = (struct UserObject *)inho7503->super;
    inho7503->super = obj7503;
    self = inheritingObject7503;
    *selfslot = self;
    lowerouter7503 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7503;
  }
  block_savedest(obj7503);
  Object closure7505 = createclosure(1, "new");
setclosureframe(closure7505, stackframe);
  addtoclosure(closure7505, var_baseNode);
  struct UserObject *uo7505 = (struct UserObject*)obj7503;
  uo7505->data[1] = (Object)closure7505;
  Method *meth_meth_ast_new7505 = addmethod2pos(obj7503, "new", &meth_ast_new7505, 1);
int argcv_meth_ast_new7505[] = {1};
meth_meth_ast_new7505->type = alloc_MethodType(1, argcv_meth_ast_new7505);
  meth_meth_ast_new7505->definitionModule = modulename;
  meth_meth_ast_new7505->definitionLine = 1733;
  block_savedest(obj7503);
  Object closure7590 = createclosure(1, "new()object");
setclosureframe(closure7590, stackframe);
  addtoclosure(closure7590, var_baseNode);
  Method *meth_meth_ast_new7505_object = addmethod2pos(obj7503, "new()object", &meth_ast_new7505_object, 1);
  meth_meth_ast_new7505_object->definitionModule = modulename;
  meth_meth_ast_new7505_object->definitionLine = 1733;
  sourceObject = obj7503;
objclass7503 = obj7503->class;
  objclass7503->definitionModule = modulename;
  objclass7503->definitionLine = 1733;
  (*(struct UserObject *)self).data[0] = lowerouter7503;
  self = oldself7503;
  selfslot = oldselfslot7503;
  stackframe = oldstackframe7503;
// compilenode returning obj7503
  *var_dialectNode = obj7503;
  if (obj7503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7591 = createclosure(1, "returnNode");
setclosureframe(closure7591, stackframe);
  addtoclosure(closure7591, var_returnNode);
  struct UserObject *uo7591 = (struct UserObject*)self;
  uo7591->data[36] = (Object)closure7591;
  Method *meth_meth_ast_returnNode7591 = addmethod2pos(self, "returnNode", &meth_ast_returnNode7591, 36);
int argcv_meth_ast_returnNode7591[] = {0};
meth_meth_ast_returnNode7591->type = alloc_MethodType(1, argcv_meth_ast_returnNode7591);
  meth_meth_ast_returnNode7591->definitionModule = modulename;
  meth_meth_ast_returnNode7591->definitionLine = 1764;
// compilenode returning 
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7592 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7592 = alloc_userobj2(2,4, objclass7592);
  gc_frame_newslot(obj7592);
// OBJECT OUTER DEC outer
  adddatum2(obj7592, self, 0);
  addmethodreal(obj7592,"outer", &reader_ast_outer_7593);
  Object oldself7592 = self;
  struct StackFrameObject *oldstackframe7592 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7592);
  gc_frame_newslot((Object)stackframe);
  self = obj7592;
  Object *oldselfslot7592 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7592 = (*(struct UserObject *)self).data[0], lowerouter7592 = thisouter7592;
  if (inheritingObject7592) {
    struct UserObject *inho7592 = (struct UserObject *)inheritingObject7592;
    while (inho7592->super != GraceDefaultObject) inho7592 = (struct UserObject *)inho7592->super;
    inho7592->super = obj7592;
    self = inheritingObject7592;
    *selfslot = self;
    lowerouter7592 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7592;
  }
  block_savedest(obj7592);
  Object closure7594 = createclosure(2, "new");
setclosureframe(closure7594, stackframe);
  addtoclosure(closure7594, var_returnNode);
  addtoclosure(closure7594, var_baseNode);
  struct UserObject *uo7594 = (struct UserObject*)obj7592;
  uo7594->data[1] = (Object)closure7594;
  Method *meth_meth_ast_new7594 = addmethod2pos(obj7592, "new", &meth_ast_new7594, 1);
int argcv_meth_ast_new7594[] = {1};
meth_meth_ast_new7594->type = alloc_MethodType(1, argcv_meth_ast_new7594);
  meth_meth_ast_new7594->definitionModule = modulename;
  meth_meth_ast_new7594->definitionLine = 1764;
  block_savedest(obj7592);
  Object closure7683 = createclosure(2, "new()object");
setclosureframe(closure7683, stackframe);
  addtoclosure(closure7683, var_returnNode);
  addtoclosure(closure7683, var_baseNode);
  Method *meth_meth_ast_new7594_object = addmethod2pos(obj7592, "new()object", &meth_ast_new7594_object, 1);
  meth_meth_ast_new7594_object->definitionModule = modulename;
  meth_meth_ast_new7594_object->definitionLine = 1764;
  sourceObject = obj7592;
objclass7592 = obj7592->class;
  objclass7592->definitionModule = modulename;
  objclass7592->definitionLine = 1764;
  (*(struct UserObject *)self).data[0] = lowerouter7592;
  self = oldself7592;
  selfslot = oldselfslot7592;
  stackframe = oldstackframe7592;
// compilenode returning obj7592
  *var_returnNode = obj7592;
  if (obj7592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7684 = createclosure(1, "inheritsNode");
setclosureframe(closure7684, stackframe);
  addtoclosure(closure7684, var_inheritsNode);
  struct UserObject *uo7684 = (struct UserObject*)self;
  uo7684->data[37] = (Object)closure7684;
  Method *meth_meth_ast_inheritsNode7684 = addmethod2pos(self, "inheritsNode", &meth_ast_inheritsNode7684, 37);
int argcv_meth_ast_inheritsNode7684[] = {0};
meth_meth_ast_inheritsNode7684->type = alloc_MethodType(1, argcv_meth_ast_inheritsNode7684);
  meth_meth_ast_inheritsNode7684->definitionModule = modulename;
  meth_meth_ast_inheritsNode7684->definitionLine = 1798;
// compilenode returning 
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7685 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7685 = alloc_userobj2(2,4, objclass7685);
  gc_frame_newslot(obj7685);
// OBJECT OUTER DEC outer
  adddatum2(obj7685, self, 0);
  addmethodreal(obj7685,"outer", &reader_ast_outer_7686);
  Object oldself7685 = self;
  struct StackFrameObject *oldstackframe7685 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7685);
  gc_frame_newslot((Object)stackframe);
  self = obj7685;
  Object *oldselfslot7685 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7685 = (*(struct UserObject *)self).data[0], lowerouter7685 = thisouter7685;
  if (inheritingObject7685) {
    struct UserObject *inho7685 = (struct UserObject *)inheritingObject7685;
    while (inho7685->super != GraceDefaultObject) inho7685 = (struct UserObject *)inho7685->super;
    inho7685->super = obj7685;
    self = inheritingObject7685;
    *selfslot = self;
    lowerouter7685 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7685;
  }
  block_savedest(obj7685);
  Object closure7687 = createclosure(2, "new");
setclosureframe(closure7687, stackframe);
  addtoclosure(closure7687, var_inheritsNode);
  addtoclosure(closure7687, var_baseNode);
  struct UserObject *uo7687 = (struct UserObject*)obj7685;
  uo7687->data[1] = (Object)closure7687;
  Method *meth_meth_ast_new7687 = addmethod2pos(obj7685, "new", &meth_ast_new7687, 1);
int argcv_meth_ast_new7687[] = {1};
meth_meth_ast_new7687->type = alloc_MethodType(1, argcv_meth_ast_new7687);
  meth_meth_ast_new7687->definitionModule = modulename;
  meth_meth_ast_new7687->definitionLine = 1798;
  block_savedest(obj7685);
  Object closure7781 = createclosure(2, "new()object");
setclosureframe(closure7781, stackframe);
  addtoclosure(closure7781, var_inheritsNode);
  addtoclosure(closure7781, var_baseNode);
  Method *meth_meth_ast_new7687_object = addmethod2pos(obj7685, "new()object", &meth_ast_new7687_object, 1);
  meth_meth_ast_new7687_object->definitionModule = modulename;
  meth_meth_ast_new7687_object->definitionLine = 1798;
  sourceObject = obj7685;
objclass7685 = obj7685->class;
  objclass7685->definitionModule = modulename;
  objclass7685->definitionLine = 1798;
  (*(struct UserObject *)self).data[0] = lowerouter7685;
  self = oldself7685;
  selfslot = oldselfslot7685;
  stackframe = oldstackframe7685;
// compilenode returning obj7685
  *var_inheritsNode = obj7685;
  if (obj7685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7782 = createclosure(1, "blankNode");
setclosureframe(closure7782, stackframe);
  addtoclosure(closure7782, var_blankNode);
  struct UserObject *uo7782 = (struct UserObject*)self;
  uo7782->data[38] = (Object)closure7782;
  Method *meth_meth_ast_blankNode7782 = addmethod2pos(self, "blankNode", &meth_ast_blankNode7782, 38);
int argcv_meth_ast_blankNode7782[] = {0};
meth_meth_ast_blankNode7782->type = alloc_MethodType(1, argcv_meth_ast_blankNode7782);
  meth_meth_ast_blankNode7782->definitionModule = modulename;
  meth_meth_ast_blankNode7782->definitionLine = 1832;
// compilenode returning 
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7783 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7783 = alloc_userobj2(2,4, objclass7783);
  gc_frame_newslot(obj7783);
// OBJECT OUTER DEC outer
  adddatum2(obj7783, self, 0);
  addmethodreal(obj7783,"outer", &reader_ast_outer_7784);
  Object oldself7783 = self;
  struct StackFrameObject *oldstackframe7783 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7783);
  gc_frame_newslot((Object)stackframe);
  self = obj7783;
  Object *oldselfslot7783 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7783 = (*(struct UserObject *)self).data[0], lowerouter7783 = thisouter7783;
  if (inheritingObject7783) {
    struct UserObject *inho7783 = (struct UserObject *)inheritingObject7783;
    while (inho7783->super != GraceDefaultObject) inho7783 = (struct UserObject *)inho7783->super;
    inho7783->super = obj7783;
    self = inheritingObject7783;
    *selfslot = self;
    lowerouter7783 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7783;
  }
  block_savedest(obj7783);
  Object closure7785 = createclosure(1, "new");
setclosureframe(closure7785, stackframe);
  addtoclosure(closure7785, var_baseNode);
  struct UserObject *uo7785 = (struct UserObject*)obj7783;
  uo7785->data[1] = (Object)closure7785;
  Method *meth_meth_ast_new7785 = addmethod2pos(obj7783, "new", &meth_ast_new7785, 1);
int argcv_meth_ast_new7785[] = {0};
meth_meth_ast_new7785->type = alloc_MethodType(1, argcv_meth_ast_new7785);
  meth_meth_ast_new7785->definitionModule = modulename;
  meth_meth_ast_new7785->definitionLine = 1832;
  block_savedest(obj7783);
  Object closure7809 = createclosure(1, "new()object");
setclosureframe(closure7809, stackframe);
  addtoclosure(closure7809, var_baseNode);
  Method *meth_meth_ast_new7785_object = addmethod2pos(obj7783, "new()object", &meth_ast_new7785_object, 1);
  meth_meth_ast_new7785_object->definitionModule = modulename;
  meth_meth_ast_new7785_object->definitionLine = 1832;
  sourceObject = obj7783;
objclass7783 = obj7783->class;
  objclass7783->definitionModule = modulename;
  objclass7783->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7783;
  self = oldself7783;
  selfslot = oldselfslot7783;
  stackframe = oldstackframe7783;
// compilenode returning obj7783
  *var_blankNode = obj7783;
  if (obj7783 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7810 = createclosure(1, "signaturePart");
setclosureframe(closure7810, stackframe);
  addtoclosure(closure7810, var_signaturePart);
  struct UserObject *uo7810 = (struct UserObject*)self;
  uo7810->data[39] = (Object)closure7810;
  Method *meth_meth_ast_signaturePart7810 = addmethod2pos(self, "signaturePart", &meth_ast_signaturePart7810, 39);
int argcv_meth_ast_signaturePart7810[] = {0};
meth_meth_ast_signaturePart7810->type = alloc_MethodType(1, argcv_meth_ast_signaturePart7810);
  meth_meth_ast_signaturePart7810->definitionModule = modulename;
  meth_meth_ast_signaturePart7810->definitionLine = 1832;
// compilenode returning 
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7811 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7811 = alloc_userobj2(2,4, objclass7811);
  gc_frame_newslot(obj7811);
// OBJECT OUTER DEC outer
  adddatum2(obj7811, self, 0);
  addmethodreal(obj7811,"outer", &reader_ast_outer_7812);
  Object oldself7811 = self;
  struct StackFrameObject *oldstackframe7811 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7811);
  gc_frame_newslot((Object)stackframe);
  self = obj7811;
  Object *oldselfslot7811 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7811 = (*(struct UserObject *)self).data[0], lowerouter7811 = thisouter7811;
  if (inheritingObject7811) {
    struct UserObject *inho7811 = (struct UserObject *)inheritingObject7811;
    while (inho7811->super != GraceDefaultObject) inho7811 = (struct UserObject *)inho7811->super;
    inho7811->super = obj7811;
    self = inheritingObject7811;
    *selfslot = self;
    lowerouter7811 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7811;
  }
  block_savedest(obj7811);
  Object closure7813 = createclosure(2, "new");
setclosureframe(closure7813, stackframe);
  addtoclosure(closure7813, var_signaturePart);
  addtoclosure(closure7813, var_baseNode);
  struct UserObject *uo7813 = (struct UserObject*)obj7811;
  uo7813->data[1] = (Object)closure7813;
  Method *meth_meth_ast_new7813 = addmethod2pos(obj7811, "new", &meth_ast_new7813, 1);
int argcv_meth_ast_new7813[] = {0};
meth_meth_ast_new7813->type = alloc_MethodType(1, argcv_meth_ast_new7813);
  meth_meth_ast_new7813->definitionModule = modulename;
  meth_meth_ast_new7813->definitionLine = 1832;
  block_savedest(obj7811);
  Object closure7892 = createclosure(2, "new()object");
setclosureframe(closure7892, stackframe);
  addtoclosure(closure7892, var_signaturePart);
  addtoclosure(closure7892, var_baseNode);
  Method *meth_meth_ast_new7813_object = addmethod2pos(obj7811, "new()object", &meth_ast_new7813_object, 1);
  meth_meth_ast_new7813_object->definitionModule = modulename;
  meth_meth_ast_new7813_object->definitionLine = 1832;
  sourceObject = obj7811;
objclass7811 = obj7811->class;
  objclass7811->definitionModule = modulename;
  objclass7811->definitionLine = 1832;
  (*(struct UserObject *)self).data[0] = lowerouter7811;
  self = oldself7811;
  selfslot = oldselfslot7811;
  stackframe = oldstackframe7811;
// compilenode returning obj7811
  *var_signaturePart = obj7811;
  if (obj7811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// compilenode returning done
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning self
  *var_ast = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7893 = createclosure(1, "ast");
setclosureframe(closure7893, stackframe);
  addtoclosure(closure7893, var_ast);
  struct UserObject *uo7893 = (struct UserObject*)self;
  uo7893->data[40] = (Object)closure7893;
  Method *meth_meth_ast_ast7893 = addmethod2pos(self, "ast", &meth_ast_ast7893, 40);
int argcv_meth_ast_ast7893[] = {0};
meth_meth_ast_ast7893->type = alloc_MethodType(1, argcv_meth_ast_ast7893);
  meth_meth_ast_ast7893->definitionModule = modulename;
  meth_meth_ast_ast7893->definitionLine = 1868;
// compilenode returning 
// compilenode returning done
// Begin line 2031
  setline(2031);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject7894 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj7894 = alloc_userobj2(2,4, objclass7894);
  gc_frame_newslot(obj7894);
// OBJECT OUTER DEC outer
  adddatum2(obj7894, self, 0);
  addmethodreal(obj7894,"outer", &reader_ast_outer_7895);
  Object oldself7894 = self;
  struct StackFrameObject *oldstackframe7894 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe7894);
  gc_frame_newslot((Object)stackframe);
  self = obj7894;
  Object *oldselfslot7894 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter7894 = (*(struct UserObject *)self).data[0], lowerouter7894 = thisouter7894;
  if (inheritingObject7894) {
    struct UserObject *inho7894 = (struct UserObject *)inheritingObject7894;
    while (inho7894->super != GraceDefaultObject) inho7894 = (struct UserObject *)inho7894->super;
    inho7894->super = obj7894;
    self = inheritingObject7894;
    *selfslot = self;
    lowerouter7894 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter7894;
  }
  struct UserObject *uo7896 = (struct UserObject*)obj7894;
  uo7896->data[1] = emptyclosure;
  Method *meth_meth_ast_visitCall7896 = addmethod2pos(obj7894, "visitCall", &meth_ast_visitCall7896, 1);
int argcv_meth_ast_visitCall7896[] = {1};
meth_meth_ast_visitCall7896->type = alloc_MethodType(1, argcv_meth_ast_visitCall7896);
  meth_meth_ast_visitCall7896->definitionModule = modulename;
  meth_meth_ast_visitCall7896->definitionLine = 2033;
  sourceObject = obj7894;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7901 = gc_frame_new();
// compilenode returning self
  gc_frame_newslot(self);
// compilenode returning *var_ast
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call7902 = callmethod(*var_ast, "baseVisitor()object",
    2, partcv, params);
  gc_frame_end(callframe7901);
// compilenode returning call7902
  struct UserObject *obj7894_uo = (struct UserObject *)obj7894;
  obj7894_uo->super = call7902;
  sourceObject = obj7894;
objclass7894 = obj7894->class;
  objclass7894->definitionModule = modulename;
  objclass7894->definitionLine = 2031;
  (*(struct UserObject *)self).data[0] = lowerouter7894;
  self = oldself7894;
  selfslot = oldselfslot7894;
  stackframe = oldstackframe7894;
// compilenode returning obj7894
  *var_patternMarkVisitor = obj7894;
  if (obj7894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7903 = createclosure(1, "patternMarkVisitor");
setclosureframe(closure7903, stackframe);
  addtoclosure(closure7903, var_patternMarkVisitor);
  struct UserObject *uo7903 = (struct UserObject*)self;
  uo7903->data[41] = (Object)closure7903;
  Method *meth_meth_ast_patternMarkVisitor7903 = addmethod2pos(self, "patternMarkVisitor", &meth_ast_patternMarkVisitor7903, 41);
int argcv_meth_ast_patternMarkVisitor7903[] = {0};
meth_meth_ast_patternMarkVisitor7903->type = alloc_MethodType(1, argcv_meth_ast_patternMarkVisitor7903);
  meth_meth_ast_patternMarkVisitor7903->definitionModule = modulename;
  meth_meth_ast_patternMarkVisitor7903->definitionLine = 1868;
// compilenode returning 
// compilenode returning done
// compilenode returning 
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
  gc_frame_end(frame);
  return self;
}
