#include <gracelib.h>
#include <stdlib.h>
static char compilerRevision[] = "90f7b6b09a615e8dcda829cbe082fd644f9c0961";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "parser";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma DefaultVisibility=public",
  "import \"io\" as io",
  "import \"ast\" as ast",
  "import \"util\" as util",
  "import \"mgcollections\" as collections",
  "import \"errormessages\" as errormessages",
  "",
  "def don'tBreak = true",
  "var lastline := 0",
  "var linenum := 0",
  "var lastIndent := 0",
  "var indentFreePass := false",
  "var minIndentLevel := 0",
  "var statementIndent := 0",
  "var statementToken",
  "var tokens := false",
  "var values := []",
  "var auto_count := 0",
  "var don'tTakeBlock := false",
  "var braceIsType := false",
  "var defaultDefVisibility := \"confidential\"",
  "var defaultVarVisibility := \"confidential\"",
  "var defaultMethodVisibility := \"public\"",
  "",
  "// Global object containing the current token",
  "var sym",
  "var lastToken := object {",
  "    var kind := \"start\"",
  "    var line := 1",
  "    var linePos := 0",
  "    var indent := 0",
  "    var value := \"\"",
  "    def size = 0",
  "}",
  "",
  "var comment := false",
  "",
  "// Advance to the next token in the stream, with special handling",
  "// so the magic \"line\" tokens update the line number for error output.",
  "method next {",
  "    lastToken := sym",
  "    if (tokens.size > 0) then {",
  "        lastline := linenum",
  "        lastIndent := sym.indent",
  "        sym := tokens.poll",
  "        if (sym.kind == \"comment\") then {",
  "            comment := \"\"",
  "            while {(sym.kind == \"comment\").andAlso {tokens.size > 0}} do {",
  "                comment := comment ++ sym.value",
  "                sym := tokens.poll",
  "            }",
  "        }",
  "        linenum := sym.line",
  "        util.setPosition(sym.line, sym.linePos)",
  "    } else {",
  "        sym := object {",
  "            var kind := \"eof\"",
  "            var line := lastToken.line",
  "            var linePos := util.lines[lastToken.line].size + 1",
  "            var indent := 0",
  "            var value := \"\"",
  "            def size = 0",
  "        }",
  "    }",
  "}",
  "",
  "// Search for the next token that the given block returns true for.",
  "// Used for generating suggestions.",
  "method findNextToken(tokenMatcher) {",
  "    if(tokenMatcher.apply(sym)) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }.andAlso { n.indent >= lastToken.indent }} do {",
  "        if(tokenMatcher.apply(n)) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextTokenIndentedAt(tok) {",
  "    if(((sym.line > tok.line) && (sym.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "        return sym",
  "    }",
  "    var nextTok := false",
  "    var n := sym",
  "    while {(n != false).andAlso { nextTok == false }} do {",
  "        if(((n.line > tok.line) && (n.indent <= tok.indent)) || (sym.kind == \"eof\")) then {",
  "            nextTok := n",
  "        }",
  "        n := n.next",
  "    }",
  "    nextTok",
  "}",
  "",
  "method findNextValidToken(*validFollowTokens) {",
  "    // Tokens that cannot start an expression.",
  "    def invalidTokens = [\"dot\", \"comma\", \"colon\", \"rparen\", \"rbrace\", \"rsquare\", \"arrow\", \"bind\"];",
  "    var validToken := sym",
  "    while {validToken.kind != \"eof\"} do {",
  "        // If the token is a valid follow token, then return that token.",
  "        if(validFollowTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // If the token is not an invalid token for starting an expression, return that token.",
  "        if(!invalidTokens.contains(validToken.kind)) then {",
  "            return validToken",
  "        }",
  "        // The token is invalid, go to the next one.",
  "        validToken := validToken.next",
  "    }",
  "    return validToken",
  "}",
  "",
  "// Finds the closing brace for a given token (that is the beginning of a control",
  "// structure with an opening brace. Returns an object with two fields: found",
  "// and tok. If a closing brace is found, found is set to true, and tok is set to",
  "// the closing brace. Otherwise found is set to false, and tok is set to the",
  "// token that the closing brace should appear after.",
  "method findClosingBrace(tok, inserted) {",
  "    var n := sym",
  "    var numOpening := if(inserted) then {1} else {0}",
  "    var numClosing := 0",
  "    def result = object {",
  "        var found",
  "        var tok",
  "    }",
  "    // Skip all tokens on the same line first.",
  "    while {(n.kind != \"eof\") && (n.line == tok.line)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    // Skip all tokens that have greater indent than the target closing brace.",
  "    while {(n.kind != \"eof\") && (n.indent > tok.indent)} do {",
  "        if(n.kind == \"lbrace\") then { numOpening := numOpening + 1 }",
  "        elseif(n.kind == \"rbrace\") then { numClosing := numClosing + 1 }",
  "        n := n.next",
  "    }",
  "    if(n.kind == \"rbrace\") then {",
  "        result.found := true",
  "        result.tok := n",
  "    } elseif((n.prev.kind == \"rbrace\") && (numOpening == numClosing)) then {",
  "        // Check that the number of opening and closing braces matches.",
  "        result.found := true",
  "        result.tok := n.prev",
  "    } else {",
  "        result.found := false",
  "        result.tok := n.prev",
  "    }",
  "    result",
  "}",
  "",
  "// True if the current token (next to be processed) is a t, where",
  "// t is \"num\", \"string\", \"method\", etc.",
  "method accept(t) {",
  "    sym.kind == t",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line (either because it's on the same physical line, or because",
  "// it's on an indented continuation line).",
  "method acceptSameLine(t) {",
  "    (sym.kind == t) && ((lastline == sym.line) ||",
  "        (sym.indent > lastIndent))",
  "}",
  "",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOf(other) {",
  "    (sym.kind == t) && ((other.line == sym.line) ||",
  "        (sym.indent > other.indent))",
  "}",
  "// True if the current token is a t, and it is on the same logical",
  "// line as a provided token.",
  "method accept(t)onLineOfLastOr(other) {",
  "    (sym.kind == t) && (((other.line == sym.line) ||",
  "        (sym.indent > other.indent)) || (lastToken.line == sym.line))",
  "}",
  "// True if there is a token on the same logical line",
  "method tokenOnSameLine {",
  "    (lastline == sym.line) || (sym.indent > lastIndent)",
  "}",
  "// Check if block did consume at least one token.",
  "method didConsume(ablock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    tokens.size != sz",
  "}",
  "// Expect block to consume at least one token, or call fallback code.",
  "method ifConsume(ablock)then(tblock) {",
  "    var sz := tokens.size",
  "    ablock.apply",
  "    if (tokens.size != sz) then {",
  "        tblock.apply",
  "    }",
  "}",
  "",
  "// Push the current token onto the output stack as a number",
  "method pushnum {",
  "    var o := ast.numNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an octet literal",
  "method pushoctets {",
  "    var o := ast.octetsNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as a string",
  "method pushstring {",
  "    var o := ast.stringNode.new(sym.value)",
  "    values.push(o)",
  "    next",
  "}",
  "",
  "// Push the current token onto the output stack as an identifier.",
  "// false means that this identifier has not been assigned a dtype (yet).",
  "method pushidentifier {",
  "    util.setline(sym.line)",
  "    var o := ast.identifierNode.new(sym.value, false)",
  "    if (o.value == \"_\") then {",
  "        o.value := \"__\" ++ auto_count",
  "        o.wildcard := true",
  "        auto_count := auto_count + 1",
  "    }",
  "    values.push(o)",
  "    next",
  "}",
  "method checkAnnotation(ann) {",
  "    if (ann.kind == \"call\") then {",
  "        for (ann.with) do {p->",
  "            for (p.args) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {a.dtype != false}) then {",
  "                    var tok := sym",
  "                    // Look back from the current token to try and find the tokens that cause this error.",
  "                    while {tok.value != \":\"} do { tok := tok.prev }",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(tok, tok.next)leading(true)trailing(false)",
  "                    errormessages.syntaxError(\"An argument to an annotation cannot have a type.\")atRange(",
  "                        tok.line, tok.linePos, tok.next.linePos + tok.next.size - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "    }",
  "    ann",
  "}",
  "method doannotation {",
  "    if ((!accept(\"keyword\")).orElse {sym.value != \"is\"}) then {",
  "        return false",
  "    }",
  "    next",
  "    def anns = collections.list.new",
  "    don'tTakeBlock := true",
  "    if(didConsume({expression}).not) then {",
  "        def suggestions = []",
  "        var suggestion := errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"bind\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "        }",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "    }",
  "    while {accept(\"comma\")} do {",
  "        anns.push(checkAnnotation(values.pop))",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"bind\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «annotation»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «annotation»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"One or more annotations separated by commas must follow 'is'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "    }",
  "    don'tTakeBlock := false",
  "    anns.push(checkAnnotation(values.pop))",
  "    anns",
  "}",
  "",
  "method blank {",
  "    if (sym.line > (lastToken.line + 1)) then {",
  "        if (values.size > 0) then {",
  "            if (values.last.kind != \"blank\") then {",
  "                values.push(ast.blankNode.new)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method dotypeterm {",
  "    if (accept(\"identifier\")) then {",
  "        pushidentifier",
  "        generic",
  "        don'tTakeBlock := true",
  "        dotrest",
  "        don'tTakeBlock := false",
  "    } else {",
  "        if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "            doanontype",
  "        }",
  "    }",
  "}",
  "",
  "method dotyperef {",
  "    var overallType := false",
  "    var tp := false",
  "    var op := false",
  "    def unionTypes = []",
  "    if(didConsume({dotypeterm}).not) then {",
  "        checkBadAnonymousType",
  "        def suggestions = []",
  "        var suggestion := errormessages.suggestion.new",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.deleteToken(lastToken)",
  "        suggestions.push(suggestion)",
  "        suggestion := errormessages.suggestion.new",
  "        suggestion.replaceToken(lastToken)with(\":=\")",
  "        suggestions.push(suggestion)",
  "        errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestions(suggestions)",
  "    }",
  "    overallType := values.pop",
  "    while {acceptSameLine(\"op\") && (sym.value == \"|\")} do {",
  "        if (unionTypes.size == 0) then {",
  "            unionTypes.push(overallType)",
  "        }",
  "        next",
  "        if(didConsume({dotypeterm}).not) then {",
  "            checkBadAnonymousType",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A type name or type expression must follow '|'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        unionTypes.push(values.pop)",
  "    }",
  "    if (unionTypes.size > 0) then {",
  "        var unionName := \"Union<\"",
  "        for (unionTypes) do {ut->",
  "            unionName := \"{unionName}|{ut.value}\"",
  "        }",
  "        unionName := \"{unionName}|>\"",
  "        overallType := ast.typeNode.new(unionName, [])",
  "        for (unionTypes) do {ut->",
  "            overallType.unionTypes.push(ut)",
  "        }",
  "    }",
  "    def intersectionTypes = []",
  "    while {acceptSameLine(\"op\") && (sym.value == \"&\")} do {",
  "        if (intersectionTypes.size == 0) then {",
  "            intersectionTypes.push(overallType)",
  "        }",
  "        next",
  "        if(didConsume({dotypeterm}).not) then {",
  "            checkBadAnonymousType",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A type name or type expression must follow '&'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        intersectionTypes.push(values.pop)",
  "    }",
  "    if (intersectionTypes.size > 0) then {",
  "        var intersectionName := \"Intersection<\"",
  "        for (intersectionTypes) do {it->",
  "            intersectionName := \"{intersectionName}&{it.value}\"",
  "        }",
  "        intersectionName := intersectionName ++ \"&>\"",
  "        overallType := ast.typeNode.new(intersectionName, [])",
  "        for (intersectionTypes) do {it->",
  "            overallType.intersectionTypes.push(it)",
  "        }",
  "    }",
  "    values.push(overallType)",
  "}",
  "",
  "// Accept a block",
  "method block {",
  "    if (accept(\"lbrace\")) then {",
  "        def btok = sym",
  "        next",
  "        var minInd := statementIndent + 1",
  "        var startIndent := statementIndent",
  "        var ident1",
  "        var s := sym",
  "        var tmp",
  "        var params := []",
  "        var body := []",
  "        var havearrow := true",
  "        var found := false",
  "        var i := 0",
  "        var isMatchingBlock := false",
  "        statementToken := sym",
  "        if (sym.kind == \"lparen\") then {",
  "            isMatchingBlock := true",
  "        }",
  "        ifConsume {expression} then {",
  "            if (accept(\"comma\") || accept(\"arrow\") || accept(\"colon\")) then {",
  "                // This block has parameters",
  "                ident1 := values.pop",
  "                if (accept(\"colon\")) then {",
  "                    // We allow an expression here for the case of v : T",
  "                    // patterns, where T may be \"Pair(hd, tl)\" or similar.",
  "                    next",
  "                    braceIsType := true",
  "                    if(didConsume({expression}).not) then {",
  "                        def suggestions = []",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken(\"arrow\", \"rbrace\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"A block must have an expression after the ':'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestions(suggestions)",
  "                    }",
  "                    braceIsType := false",
  "                    ident1.dtype := values.pop",
  "                }",
  "                params.push(ident1)",
  "                if (ident1.kind != \"identifier\") then {",
  "                    isMatchingBlock := true",
  "                }",
  "                if (isMatchingBlock && {accept(\"comma\")}) then {",
  "                    def suggestions = []",
  "                    var suggestion",
  "                    def arrow = findNextToken({ t -> t.kind == \"arrow\" })",
  "                    if(arrow != false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, arrow.prev)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" |\")",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A matching block may only have one parameter.\")atRange(",
  "                        sym.line, sym.linePos, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                while {accept(\"comma\")} do {",
  "                    // Keep doing the above for the rest of the parameters.",
  "                    next",
  "                    pushidentifier",
  "                    ident1 := values.pop",
  "                    if (accept(\"colon\")) then {",
  "                        next",
  "                        dotyperef",
  "                        ident1.dtype := values.pop",
  "                    }",
  "                    params.push(ident1)",
  "                }",
  "                if ((accept(\"arrow\")).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if((sym.kind == \"bind\") || (sym.value == \"=\")) then {",
  "                        suggestion.replaceToken(sym)with(\"->\")",
  "                    } else {",
  "                        suggestion.insert(\" ->\")afterToken(lastToken)",
  "                    }",
  "                    errormessages.syntaxError(\"A block must have one or more parameters followed by '->' and an expression.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } elseif (accept(\"semicolon\")) then {",
  "                body.push(values.pop)",
  "                next",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } elseif (((values.last.kind == \"member\")",
  "                || (values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var lhs := values.pop",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var rhs := values.pop",
  "                body.push(ast.bindNode.new(lhs, rhs))",
  "                if (accept(\"semicolon\")) then {",
  "                    next",
  "                    if (sym.line == lastToken.line) then {",
  "                        indentFreePass := true",
  "                    }",
  "                }",
  "            } else {",
  "                checkUnexpectedTokenAfterStatement",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        if (accept(\"arrow\")) then {",
  "            next",
  "        }",
  "        var ln := values.size",
  "        if (sym.line == lastToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := minInd",
  "        }",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // Take the body of the block",
  "            if(didConsume({statement}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"}\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A block must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            tmp := values.pop",
  "            body.push(tmp)",
  "        }",
  "        minIndentLevel := minInd - 1",
  "        statementIndent := startIndent",
  "        next",
  "        util.setline(btok.line)",
  "        var o := ast.blockNode.new(params, body)",
  "        if (isMatchingBlock) then {",
  "            if (params.size > 0) then {",
  "                o.matchingPattern := params.first",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept an \"if\" statement. This is a special syntactic case, rather",
  "// than just a call with a multi-part method name - it might be possible",
  "// to change that and compensate later on.",
  "method doif {",
  "    if (accept(\"identifier\") && (sym.value == \"if\")) then {",
  "        def btok = sym",
  "        next",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen or then.",
  "            def nextTok = findNextToken({ t -> (t.line == btok.line)",
  "                && ((t.kind == \"rparen\") || (t.kind == \"lbrace\")",
  "                || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" («expression») then \\{\")afterToken(btok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                }",
  "            } elseif(nextTok.kind == \"lbrace\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" («expression») then\")afterToken(btok)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                } else {",
  "                    suggestion.insert(\"(\")beforeToken(sym)",
  "                    suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rparen.",
  "            var nextTok := findNextToken({ t -> (t.line == lastToken.line) && (t.kind == \"rparen\") })",
  "            if(nextTok == false) then {",
  "                nextTok := findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                    errormessages.syntaxError(\"An if statement must have an expression in parentheses after the 'if'.\")atRange(",
  "                        sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var cond := values.pop",
  "        var body := []",
  "",
  "        // These two are for else/elseif handling. elseif is turned into",
  "        // nested if statements for the AST, so curelse points to the",
  "        // most deeply-nested of those (where any eventual \"else\" block's",
  "        // statements will go). elseblock contains the statements of the",
  "        // top-level \"else\" block - if there are any elseifs, that",
  "        // consists of only one statement, another if.",
  "        var elseblock := []",
  "        var curelse := elseblock",
  "        var v",
  "        def localMin = minIndentLevel",
  "        def localStatementIndent = statementIndent",
  "        var minInd := statementIndent + 1",
  "        if (accept(\"identifier\") && (sym.value == \"then\")) then {",
  "            next",
  "            if(sym.kind != \"lbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                }",
  "                errormessages.syntaxError(\"An if statement must have a '\\{' after the 'then'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            if (sym.line == lastToken.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := minInd",
  "            }",
  "            while {(accept(\"rbrace\")).not} do {",
  "                if(didConsume({statement}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, false)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.insert(\"}\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                        }",
  "                    }",
  "                    suggestion.deleteToken(sym)",
  "                    errormessages.syntaxError(\"An if statement must end with a '}'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                v := values.pop",
  "                body.push(v)",
  "            }",
  "            next",
  "            var econd",
  "            var eif",
  "            var newelse",
  "            var ebody",
  "            while {accept(\"identifier\") && (sym.value == \"elseif\")} do {",
  "                // Currently, the parser just accepts arbitrarily many",
  "                // \"elseifs\", turning them into ifs inside the else.",
  "                // TODO: allow blocks after elseif to contain a sequence of expressions.",
  "                statementToken := sym",
  "                next",
  "                def opener = if ((sym.kind == \"lparen\").orElse{sym.kind == \"lbrace\"}) ",
  "                                then { sym.value } else { \"-missing-\" }",
  "                def closer = if (opener == \"(\") then { \")\" }",
  "                                else { if (opener == \"\\{\") then { \"\\}\" } else { \"-nothing-\" } }",
  "                if (opener == \"-missing-\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    def nextTok = findNextToken({ t -> (t.line == statementToken.line)",
  "                        && ((t.kind == \"rparen\") || (t.kind == \"rbrace\") || (t.kind == \"lbrace\")",
  "                        || ((t.kind == \"identifier\") && (t.value == \"then\"))) })",
  "                    if(nextTok == false) then {",
  "                        suggestion.insert(\" («expression») then \\{\")afterToken(statementToken)",
  "                    } elseif(nextTok.kind == \"rparen\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                        }",
  "                    } elseif(nextTok.kind == \"lbrace\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" («expression») then\")afterToken(statementToken)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\") then\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    } elseif(nextTok.kind == \"identifier\") then {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"(«expression») \")beforeToken(sym)",
  "                        } else {",
  "                            suggestion.insert(\"(\")beforeToken(sym)",
  "                            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"1: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    // Look ahead for a rparen or then.",
  "                    var nextTok := findNextToken({ t -> (t.line == lastToken.line) && ",
  "                        ((t.kind == \"rparen\") || (t.kind == \"rbrace\"))})",
  "                    if(nextTok == false) then {",
  "                        nextTok := findNextValidToken(\"rparen\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression») then \\{\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression») then \\{\")",
  "                        }",
  "                        errormessages.syntaxError(\"2: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    } else {",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                            errormessages.syntaxError(\"3: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atPosition(",
  "                                sym.line, sym.linePos)withSuggestion(suggestion)",
  "                        } else {",
  "                            //checkInvalidExpression",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(false)trailing(true)with(\"«expression»\")",
  "                            errormessages.syntaxError(\"4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.\")atRange(",
  "                                sym.line, sym.linePos, nextTok.linePos - 1)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                }",
  "                if(sym.value != closer) then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An expression beginning with a '{opener}' must end with a '{closer}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                econd := values.pop",
  "                if ((accept(\"identifier\") &&",
  "                    (sym.value == \"then\"))) then {",
  "                    next",
  "                    ebody := []",
  "                } else {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.kind == \"lbrace\") then {",
  "                        def closingBrace = findClosingBrace(statementToken, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == sym) then {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                            } else {",
  "                                suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        }",
  "                    } else {",
  "                        def closingBrace = findClosingBrace(statementToken, true)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        } else {",
  "                            suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        }",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"then \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An elseif statement must have a '\\{' after the 'then'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An elseif statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    ebody.push(v)",
  "                }",
  "                next",
  "                newelse := []",
  "                eif := ast.ifNode.new(econd, ebody, newelse)",
  "                // Construct the inner \"if\" AST node, and then push it",
  "                // inside the current \"else\" block.",
  "                curelse.push(eif)",
  "                // Update curelse to point to the new, empty, nested",
  "                // else block.",
  "                curelse := newelse",
  "            }",
  "            if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "                next",
  "                if(sym.kind != \"lbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def closingBrace = findClosingBrace(btok, true)",
  "                    if(closingBrace.found == false) then {",
  "                        if(closingBrace.tok == lastToken) then {",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{}\")",
  "                        } else {",
  "                            suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                        }",
  "                    } else {",
  "                        suggestion.replaceToken(lastToken)leading(false)trailing(true)with(\"else \\{\")",
  "                    }",
  "                    errormessages.syntaxError(\"An else statement must have a '\\{' after the 'else'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "                // Just take all the statements and put them into",
  "                // curelse.",
  "                if (sym.line == lastToken.line) then {",
  "                    minIndentLevel := sym.linePos - 1",
  "                } else {",
  "                    minIndentLevel := minInd",
  "                }",
  "                while {(accept(\"rbrace\")).not} do {",
  "                    if(didConsume({statement}).not) then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        def closingBrace = findClosingBrace(btok, false)",
  "                        if(closingBrace.found == false) then {",
  "                            if(closingBrace.tok == lastToken) then {",
  "                                suggestion.insert(\"}\")afterToken(lastToken)",
  "                            } else {",
  "                                suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                            }",
  "                        }",
  "                        suggestion.deleteToken(sym)",
  "                        errormessages.syntaxError(\"An else statement must end with a '}'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                    v := values.pop",
  "                    curelse.push(v)",
  "                }",
  "                next",
  "            }",
  "            var o := ast.ifNode.new(cond, body, elseblock)",
  "            values.push(o)",
  "        } else {",
  "            // Raise an error here, or it will spin nastily forever.",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"lbrace\") then {",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{}\")",
  "                    } else {",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.replaceToken(sym)leading(true)trailing(false)with(\" then \\{\")",
  "                }",
  "            } else {",
  "                def closingBrace = findClosingBrace(btok, true)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == lastToken) then {",
  "                        suggestion.insert(\" then \\{}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                } else {",
  "                    suggestion.insert(\" then \\{\")afterToken(lastToken)",
  "                }",
  "            }",
  "            errormessages.syntaxError(\"An if statement must have 'then' after the expression in parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        minIndentLevel := localMin",
  "        statementIndent := localStatementIndent",
  "    }",
  "}",
  "",
  "// Accept an identifier. Handle \"if\", \"while\", and \"for\" specially by",
  "// passing them on to the appropriate method above.",
  "method identifier {",
  "    if (accept(\"identifier\")) then {",
  "        if (sym.value == \"if\") then {",
  "            doif",
  "        } else {",
  "            pushidentifier",
  "        }",
  "    }",
  "}",
  "",
  "method prefixop {",
  "    if (accept(\"op\")) then {",
  "        var op := sym.value",
  "        var val",
  "        next",
  "        if (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            if(didConsume({term}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                if(lastToken.prev.kind == \"bind\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestion.deleteToken(lastToken.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A prefix operator must be followed by an expression.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "        }",
  "        dotrest",
  "        callrest",
  "        postfixsquare",
  "        val := values.pop",
  "        var mem := ast.memberNode.new(\"prefix\" ++ op, val)",
  "        var call := ast.callNode.new(mem, [ast.callWithPart.new(mem.value)])",
  "        values.push(call)",
  "    }",
  "}",
  "",
  "method generic {",
  "    if (accept(\"lgeneric\")) then {",
  "        def id = values.pop",
  "        def gens = []",
  "        def startToken = sym",
  "        next",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            while {accept(\"dot\")} do {",
  "                next",
  "                def memberIn = values.pop",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name must follow the '.'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + 1)withSuggestions(suggestions)",
  "                }",
  "                identifier",
  "                def memberName = values.pop",
  "                values.push(ast.memberNode.new(memberName.value, memberIn))",
  "            }",
  "            generic",
  "            gens.push(values.pop)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            } else {",
  "                if(sym.kind != \"rgeneric\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\">\")afterToken(lastToken)",
  "                    def suggestion2 = errormessages.suggestion.new",
  "                    suggestion2.insert(\" \")beforeToken(startToken)",
  "                    def suggestions = [suggestion, suggestion2]",
  "                    errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)",
  "                        withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"A type containing a '<' must end with a '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "        values.push(ast.genericNode.new(id, gens))",
  "    }",
  "}",
  "method trycatch {",
  "    if (!(accept(\"identifier\") && (sym.value == \"try\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or catch.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"catch\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"catch\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\")onLineOf(catchTok) && (sym.value == \"case\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.replaceToken(sym)with(\"catch\")",
  "        errormessages.syntaxError(\"A try-catch statement starts with a \"",
  "                ++ \"'try' and then zero or more 'catch' blocks; there \"",
  "                ++ \"are no 'case' blocks.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos + 3)",
  "            withSuggestion(suggestion)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A try-finally statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method catchcase { // TODO: This construct is DEPRECATED. Remove it.",
  "    if (!(accept(\"identifier\") && (sym.value == \"catch\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def catchTok = sym",
  "    next",
  "    util.warning(\"The catch-case statement is deprecated and will be \"",
  "        ++ \"removed in a future version of the compiler. Use try-catch \"",
  "        ++ \"instead.\")",
  "    if (accept(\"lbrace\")) then {",
  "        block",
  "    } else {",
  "        if(sym.kind != \"lparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            // Look ahead for a rbrace, rparen, or case.",
  "            def nextTok = findNextToken({ t -> (t.kind == \"rbrace\")",
  "                || ((t.kind == \"rparen\") && (t.line == catchTok.line))",
  "                || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rbrace\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "            } elseif(nextTok.kind == \"rparen\") then {",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"(«expression»\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.insert(\"(\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } elseif(nextTok.kind == \"identifier\") then {",
  "                suggestion.insert(\" \\{\")afterToken(catchTok)",
  "                suggestion.insert(\"\\} \")beforeToken(nextTok)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                catchTok.line, catchTok.linePos + catchTok.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'catch'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    def mainblock = values.pop",
  "    def cases = []",
  "    var finally := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "    if (accept(\"identifier\") && (sym.value == \"finally\")) then {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.first)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A catch statement must have either a block or an expression in parentheses after the 'finally'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        finally := values.pop",
  "    }",
  "    values.push(ast.catchCaseNode.new(mainblock, cases, finally))",
  "    minIndentLevel := localmin",
  "}",
  "method matchcase {",
  "    if (!(accept(\"identifier\") && (sym.value == \"match\"))) then {",
  "        return 0",
  "    }",
  "    def localmin = minIndentLevel",
  "    def matchTok = sym",
  "    next",
  "    if(sym.kind != \"lparen\") then {",
  "        def suggestion = errormessages.suggestion.new",
  "        // Look ahead for a rparen or case.",
  "        def nextTok = findNextToken({ t -> ((t.kind == \"rparen\") && (t.line == matchTok.line))",
  "            || ((t.kind == \"identifier\") && (t.value == \"case\")) })",
  "        if(nextTok == false) then {",
  "            suggestion.insert(\"(«expression»)\")afterToken(matchTok)",
  "        } elseif(nextTok.kind == \"rparen\") then {",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"(«expression»\")beforeToken(sym)",
  "            } else {",
  "                suggestion.insert(\"(\")beforeToken(sym)",
  "            }",
  "        } elseif(nextTok.kind == \"identifier\") then {",
  "            suggestion.insert(\"(\")beforeToken(sym)",
  "            suggestion.insert(\")\")afterToken(nextTok.prev)andTrailingSpace(true)",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            matchTok.line, matchTok.linePos + matchTok.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    if(didConsume({expression}).not) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        def nextTok = findNextValidToken(\"rparen\")",
  "        if(nextTok == sym) then {",
  "            suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "        } else {",
  "            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "        }",
  "        errormessages.syntaxError(\"A match statement must have an expression in parentheses after the 'match'.\")atPosition(",
  "            sym.line, sym.linePos)withSuggestion(suggestion)",
  "    }",
  "    def matchee = values.pop",
  "    if(sym.kind != \"rparen\") then {",
  "        checkBadOperators",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\")\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    next",
  "    def cases = []",
  "    var elsecase := false",
  "    while {accept(\"identifier\") && (sym.value == \"case\")} do {",
  "        next",
  "        if (accept(\"lbrace\")) then {",
  "            block",
  "        } elseif (accept(\"lparen\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rparen\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            next",
  "        } else {",
  "            def suggestions = []",
  "            def nextTok = findNextTokenIndentedAt(lastToken)",
  "            var suggestion := errormessages.suggestion.new",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" }\")afterToken(tokens.last)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } elseif(nextTok == sym) then {",
  "                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" \\{ «match expression» }\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A match statement must have either a matching block or an expression in parentheses after the 'case'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        cases.push(values.pop)",
  "    }",
  "//    if (accept(\"identifier\") && (sym.value == \"else\")) then {",
  "//        next",
  "//        if (accept(\"lbrace\")) then {",
  "//            block",
  "//        } elseif (accept(\"lparen\")) then {",
  "//            next",
  "//            if(didConsume({expression}).not) then {",
  "//                def suggestion = errormessages.suggestion.new",
  "//                def nextTok = findNextValidToken(\"rparen\")",
  "//                if(nextTok == sym) then {",
  "//                    suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "//                } else {",
  "//                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "//                }",
  "//                errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "//            }",
  "//            if(sym.kind != \"rparen\") then {",
  "//                checkBadOperators",
  "//                def suggestion = errormessages.suggestion.new",
  "//                suggestion.insert(\")\")afterToken(lastToken)",
  "//                errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "//                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "//            }",
  "//            next",
  "//        } else {",
  "//            def suggestions = []",
  "//            def nextTok = findNextTokenIndentedAt(lastToken)",
  "//            var suggestion := errormessages.suggestion.new",
  "//            if(nextTok == false) then {",
  "//                suggestion.insert(\" }\")afterToken(tokens.first)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } elseif(nextTok == sym) then {",
  "//                suggestion.insert(\" («expression»)\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//                suggestion := errormessages.suggestion.new",
  "//                suggestion.insert(\" \\{ «expression» }\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            } else {",
  "//                suggestion.insert(\" }\")afterToken(nextTok.prev)",
  "//                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "//                suggestions.push(suggestion)",
  "//            }",
  "//            errormessages.syntaxError(\"A match statement must have either a block or an expression in parentheses after the 'else'.\")atPosition(",
  "//                sym.line, sym.linePos)withSuggestions(suggestions)",
  "//        }",
  "//        elsecase := values.pop",
  "//    }",
  "    values.push(ast.matchCaseNode.new(matchee, cases, elsecase))",
  "    minIndentLevel := localmin",
  "}",
  "// Accept a term. Terms consist only of single syntactic units and",
  "// do not contain any operators or parentheses, unlike expression.",
  "method term {",
  "    if (accept(\"num\")) then {",
  "        pushnum",
  "    } elseif (accept(\"string\")) then {",
  "        pushstring",
  "    } elseif (accept(\"octets\")) then {",
  "        pushoctets",
  "    } elseif(accept(\"identifier\") && (sym.value == \"match\")) then {",
  "        matchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"catch\")) then {",
  "        catchcase",
  "    } elseif(accept(\"identifier\") && (sym.value == \"try\")) then {",
  "        trycatch",
  "    } elseif (accept(\"identifier\")) then {",
  "        identifier",
  "    } elseif (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        doobject",
  "    } elseif (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        doanontype",
  "    } elseif (accept(\"lbrace\")) then {",
  "        block",
  "    } elseif (accept(\"lsquare\")) then {",
  "        doarray",
  "    } elseif (accept(\"op\")) then {",
  "        // Prefix operator",
  "        prefixop",
  "    }",
  "}",
  "",
  "// Accept an expression. Expressions may consist of parenthesised",
  "// subexpressions or terms, which may be followed by method invocations",
  "// (dotrest), postcircumfix square brackets, the rest of a method call,",
  "// or an operator expression.",
  "method expression {",
  "    var sz := values.size",
  "    if (accept(\"lparen\")) then {",
  "        def tmpStatementToken = statementToken",
  "        statementToken := sym",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rparen\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "            }",
  "            errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        statementToken := tmpStatementToken",
  "        next",
  "    } else {",
  "        term",
  "    }",
  "    if (values.size > sz) then {",
  "        dotrest",
  "        callrest",
  "        postfixsquare",
  "        expressionrest",
  "    }",
  "}",
  "",
  "// Accept postcircumfix square brackets (as in x[y]) and replace the",
  "// preceding expression with an index node into itself.",
  "method postfixsquare {",
  "    if (acceptSameLine(\"lsquare\")) then {",
  "        next",
  "        var expr := values.pop",
  "        if(didConsume({expression}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\"«index»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«index»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            if(nextTok.kind == \"rsquare\") then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var index := values.pop",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A '[' in an expression must be followed by another expression and a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var o := ast.indexNode.new(expr, index)",
  "        values.push(o)",
  "        dotrest",
  "        callrest",
  "        postfixsquare",
  "    }",
  "}",
  "",
  "// Calculate the precedence of an operator. In this case, only",
  "// multiplication and division have nontrivial precedence. Used in",
  "// expressionrest.",
  "method oprec(o) {",
  "    if (o == \"*\") then {",
  "        return 10",
  "    } elseif (o == \"/\") then {",
  "        return 10",
  "    }",
  "    return 5",
  "}",
  "",
  "// Return the precedence of the operator at the top of the \"ops\" stack.",
  "method toprec(ops) {",
  "    if (ops.size > 0) then {",
  "        var o := ops.last",
  "        return oprec(o)",
  "    }",
  "    0",
  "}",
  "",
  "// Process the rest of an operator expression using the shunting-yard",
  "// algorithm. This method uses the oprec and toprec methods above to",
  "// ensure the correct precedence, and treats all operators as",
  "// left-associative.",
  "method expressionrest {",
  "    if (accept(\"op\")) then {",
  "        var terms := [] // List of operands yet to be used",
  "        var ops := [] // Operator stack",
  "        var o",
  "        var o2",
  "        var tmp2",
  "        var tmp := values.pop",
  "        terms.push(tmp)",
  "        var prec",
  "        var allarith := true // Consists only of arithmetic operators",
  "        var opcount := 0",
  "        var opdtype := \"\" // The single operator being used in this expression",
  "        while {accept(\"op\")onLineOfLastOr(statementToken).andAlso",
  "                {sym.value != \"=\"}} do {",
  "            opcount := opcount + 1",
  "            o := sym.value",
  "            next",
  "            prec := oprec(o)",
  "            if ((o != \"*\") && (o != \"/\") && (o != \"+\") && (o != \"-\")) then {",
  "                allarith := false",
  "            }",
  "            if ((opdtype != \"\") && (opdtype != o) && (allarith.not)) then {",
  "                // If: this is not the first operator, it is not the same",
  "                // as the last operator, and the expression has not been",
  "                // entirely arithmetic, raise a syntax error.",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(sym)",
  "                suggestion.insert(\"(\")beforeToken(lastToken.prev)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken.prev)",
  "                suggestion.insert(\"(\")beforeToken(lastToken.prev.prev.prev)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"An expression containing both mathematical and non-mathematical operators requires parentheses.\")atPosition(",
  "                    lastToken.prev.line, lastToken.prev.linePos)withSuggestions(suggestions)",
  "            }",
  "            opdtype := o",
  "            while {(ops.size > 0) && (prec <= toprec(ops))} do {",
  "                // Do the shunting: for as long as the current operator",
  "                // has lesser or equal precedence than the one on the",
  "                // top of the stack, take the operator off the stack and",
  "                // replace its two operands with the combined operator node.",
  "                // This corresponds to left-associative operators only.",
  "                o2 := ops.pop",
  "                tmp2 := terms.pop",
  "                tmp := terms.pop",
  "                tmp := ast.opNode.new(o2, tmp, tmp2)",
  "                terms.push(tmp)",
  "            }",
  "            ops.push(o)",
  "            if (accept(\"lparen\")) then {",
  "                // When a parenthesis is found, take an expression from",
  "                // *within* the parentheses and add it to the stack. Do",
  "                // not delegate entirely to expression, because it will",
  "                // then consume all the following operators and break",
  "                // precedence. Possibly parenthesised expressions could",
  "                // be allowed in term above?",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                    }",
  "                    errormessages.syntaxError(\"Parentheses must contain a valid expression.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                if(sym.kind != \"rparen\") then {",
  "                    checkBadOperators",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An expression beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "                next",
  "            } else {",
  "                if (!tokenOnSameLine) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\" \" ++ util.lines[sym.line])afterToken(lastToken)",
  "                    suggestion.deleteLine(sym.line)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "                if(didConsume({term}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"comma\", \"rparen\", \"rsquare\", \"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow '{lastToken.value}'. This is often caused by a new line in the middle of an expression.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "            }",
  "",
  "            // Regardless of where the last value came from, it may have",
  "            // method invocations, indexes, or method call happening to it,",
  "            // which should be applied and the result put into the operands",
  "            // list.",
  "            dotrest",
  "            callrest",
  "            postfixsquare",
  "            tmp := values.pop",
  "            terms.push(tmp)",
  "        }",
  "        while {ops.size > 0} do {",
  "            // Shunt off any remaining operators at the end",
  "            o := ops.pop",
  "            tmp2 := terms.pop",
  "            tmp := terms.pop",
  "            tmp := ast.opNode.new(o, tmp, tmp2)",
  "            terms.push(tmp)",
  "        }",
  "        tmp := terms.pop",
  "        values.push(tmp)",
  "        if (terms.size > 0) then {",
  "            errormessages.syntaxError(\"Values left on term stack.\")atPosition(sym.line, sym.linePos)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a member lookup with \".\". This consumes the dot and",
  "// a following identifier, and will pass along to further lookups or",
  "// method calls on the result.",
  "method dotrest {",
  "    if (acceptSameLine(\"dot\")) then {",
  "        var lookuptarget := values.pop",
  "        next",
  "        if (accept(\"identifier\")) then {",
  "            var dro := ast.memberNode.new(sym.value, lookuptarget)",
  "            values.push(dro)",
  "            next",
  "            if (accept(\"dot\")) then {",
  "                dotrest",
  "            } elseif (accept(\"lparen\") || accept(\"lbrace\")",
  "                || accept(\"num\") || accept(\"string\") || accept(\"lsquare\")",
  "                || accept(\"lgeneric\")",
  "                ) then {",
  "                callrest",
  "            }",
  "        } else {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.deleteToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\"«method name»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A field or method name must follow a '.'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Accept a method invocation indicated by parentheses. Unparenthesised",
  "// method calls are left as \"member\" AST nodes and processed correctly at",
  "// a later stage.",
  "method callrest {",
  "    if (values.size == 0) then {",
  "        return 0",
  "    }",
  "    var meth := values.pop",
  "    var lnum := linenum",
  "    var lpos := 1",
  "    if (meth.kind != \"identifier\") then {",
  "        if (meth.kind != \"member\") then {",
  "            values.push(meth)",
  "            return 0",
  "        }",
  "    }",
  "    if (meth.kind == \"identifier\") then {",
  "        lnum := meth.line",
  "        lpos := meth.linePos",
  "    }",
  "    var methn",
  "    def btok = sym",
  "    var tmp",
  "    var ln := false",
  "    var signature := []",
  "    var part := ast.callWithPart.new",
  "    signature.push(part)",
  "    var hadcall := false",
  "    var tok := lastToken",
  "    var startInd := minIndentLevel",
  "    var genericIdents := false",
  "    if (acceptSameLine \"lgeneric\") then {",
  "        // Generic!",
  "        def startToken = sym",
  "        next",
  "        genericIdents := collections.list.new",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            genericIdents.push(values.pop)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            def suggestion2 = errormessages.suggestion.new",
  "            suggestion2.insert(\" \")beforeToken(startToken)",
  "            def suggestions = [suggestion, suggestion2]",
  "            errormessages.syntaxError(\"A method request containing a '<' must have a matching '>', or the '<' operator must have a space before it.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)",
  "                withSuggestions(suggestions)",
  "        }",
  "        next",
  "    }",
  "    if (acceptSameLine(\"lparen\")) then {",
  "        part.line := sym.line",
  "        part.linePos := sym.linePos",
  "        tok := sym",
  "        hadcall := true",
  "        methn := meth.value",
  "        part.name := methn",
  "        next",
  "        ifConsume {expression} then {",
  "            // For matching blocks - same as below",
  "            if (accept(\"colon\")) then {",
  "                tmp := values.pop",
  "                if (tmp.kind != \"identifier\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    if(sym.next.kind == \"identifier\") then {",
  "                        suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                            sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    checkBadAnonymousType",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                tmp.dtype := values.pop",
  "                values.push(tmp)",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                part.args.push(tmp)",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                // For matching blocks - same as above",
  "                if (accept(\"colon\")) then {",
  "                    tmp := values.pop",
  "                    if (tmp.kind != \"identifier\") then {",
  "                        def suggestion = errormessages.suggestion.new",
  "                        if(sym.next.kind == \"identifier\") then {",
  "                            suggestion.deleteTokenRange(sym, sym.next)leading(true)trailing(false)",
  "                            errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                                sym.line, sym.linePos, sym.next.linePos + sym.next.size - 1)withSuggestion(suggestion)",
  "                        } else {",
  "                            suggestion.deleteToken(sym)",
  "                            errormessages.syntaxError(\"Only variables and constants may be followed by a ':' and a type.\")atRange(",
  "                                sym.line, sym.linePos, sym.linePos)withSuggestion(suggestion)",
  "                        }",
  "                    }",
  "                    next",
  "                    if(didConsume({expression}).not) then {",
  "                        checkBadAnonymousType",
  "                        def suggestions = []",
  "                        var suggestion := errormessages.suggestion.new",
  "                        def nextTok = findNextValidToken(\"rparen\")",
  "                        if(nextTok == sym) then {",
  "                            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                        } else {",
  "                            suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «type name»\")",
  "                        }",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                        suggestions.push(suggestion)",
  "                        errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                            sym.line, sym.linePos)withSuggestions(suggestions)",
  "                    }",
  "                    tmp.dtype := values.pop",
  "                    values.push(tmp)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            part.args.push(tmp)",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            checkBadOperators",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        ln := linenum",
  "        next",
  "    } elseif (don'tTakeBlock && {accept(\"lbrace\")onLineOf(tok)}) then {",
  "        values.push(meth)",
  "    } elseif (accept(\"string\")onLineOf(tok) || accept(\"num\")onLineOf(tok)",
  "        || accept(\"lbrace\")onLineOf(tok)",
  "        || (accept(\"identifier\")onLineOf(tok) && ((sym.value == \"true\")",
  "                                   || (sym.value == \"false\")))) then {",
  "        tok := sym",
  "        hadcall := true",
  "        methn := meth.value",
  "        part.name := methn",
  "        ln := linenum",
  "        term",
  "        var ar := values.pop",
  "        part.args.push(ar)",
  "    } elseif (meth.kind == \"identifier\") then {",
  "        values.push(meth)",
  "    } elseif (meth.kind == \"member\") then {",
  "        var root := meth.in",
  "        var outroot := meth",
  "        while {root.kind == \"member\"} do {",
  "            outroot := root",
  "            root := root.in",
  "        }",
  "        if (root.kind == \"identifier\") then {",
  "            values.push(meth)",
  "        } else {",
  "            values.push(meth)",
  "        }",
  "    } else {",
  "        values.push(meth)",
  "    }",
  "    if (hadcall) then {",
  "        if (accept(\"identifier\")onLineOfLastOr(tok)) then {",
  "            // Multi-part method name",
  "            def meth' = ast.identifierNode.new(methn, false)",
  "            meth'.line := lnum",
  "            meth'.linePos := lpos",
  "            methn := callmprest(meth', signature, tok)",
  "            if (meth.kind == \"member\") then {",
  "                // callmprest loses this information, so restore",
  "                // the member lookup (for x.between(3)and(10)-type",
  "                // calls).",
  "                meth := ast.memberNode.new(methn.value, meth.in)",
  "            } else {",
  "                meth := methn",
  "            }",
  "        }",
  "        util.setline(lnum)",
  "        tmp := ast.callNode.new(meth, signature)",
  "        tmp.generics := genericIdents",
  "        values.push(tmp)",
  "    }",
  "    minIndentLevel := startInd",
  "    dotrest",
  "}",
  "",
  "// Process the rest of a multi-part method name. Returns an identifier",
  "// to replace the one passed in, in which each word is joined by \"\",",
  "// and updates params in place.",
  "method callmprest(meth, signature, tok) {",
  "    var methname := meth.value",
  "    var nxt",
  "    var ln := linenum",
  "    var lp := meth.linePos",
  "    var part",
  "    while {accept(\"identifier\")onLineOf(tok)",
  "           || accept(\"identifier\")onLineOf(lastToken)} do {",
  "        // Each word must start on the same line as the preceding parameter",
  "        // ended.",
  "        part := ast.callWithPart.new",
  "        signature.push(part)",
  "        methname := methname ++ \"()\"",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var isTerm := false",
  "        if ((accept(\"lparen\")).not && (accept(\"lbrace\")).not",
  "            && accept(\"string\").not && accept(\"num\").not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            if(sym.kind == \"identifier\") then {",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                if(methname == \"while()do\") then {",
  "                    errormessages.syntaxError(\"A while loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    errormessages.syntaxError(\"A for loop must have either a loop body in braces, or a block in parentheses.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A multi-part method request must have parentheses around each part of the method.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            } else {",
  "                if(methname == \"while()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A while loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } elseif(methname == \"for()do\") then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A for loop must have a body.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                } else {",
  "                    suggestion.insert(\"()\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A multi-part method request must end with '()'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if (accept(\"lbrace\")onLineOfLastOr(tok)",
  "            || accept(\"string\")onLineOfLastOr(tok)",
  "            || accept(\"num\")onLineOfLastOr(tok)",
  "            || (accept(\"identifier\")onLineOfLastOr(tok)",
  "                && ((sym.value == \"true\")",
  "                    || (sym.value == \"false\")))) then {",
  "            isTerm := true",
  "        } else {",
  "            next",
  "        }",
  "        var isEmpty := false",
  "        if (accept \"rparen\") then {",
  "            isEmpty := true",
  "        }",
  "        if (isTerm) then {",
  "            ln := lastline",
  "            term",
  "        } else {",
  "            if(sym.kind != \"rparen\") then {",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\"«expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\"«expression»\")",
  "                        suggestions.push(suggestion)",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression or a ')' after a '('.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            while {accept(\"comma\")} do {",
  "                nxt := values.pop",
  "                part.args.push(nxt)",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rparen\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A method request must have an expression after a ','.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "        }",
  "        if (!isEmpty) then {",
  "            nxt := values.pop",
  "            part.args.push(nxt)",
  "        }",
  "        if (isTerm.not) then {",
  "            if(sym.kind != \"rparen\") then {",
  "                checkBadOperators",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\")\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A part of a multi-part method request beginning with a '(' must end with a ')'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        if (accept(\"rparen\") && isTerm.not) then {",
  "            ln := lastline",
  "            next",
  "        }",
  "    }",
  "    def meth' = ast.identifierNode.new(methname, false)",
  "    meth'.line := meth.line",
  "    meth'.linePos := meth.linePos",
  "    meth'",
  "}",
  "",
  "// Accept a const declaration",
  "method defdec {",
  "    if (accept(\"keyword\") && (sym.value == \"def\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def defTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"op\")",
  "                && (t.value == \"=\") && (t.line == sym.line)})",
  "            if(nextToken == false) then {",
  "                suggestion.insert(\" «name» =\")afterToken(lastToken)",
  "            } elseif(nextToken == sym) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A constant declaration must have a name, a '=', and a value after the 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var dtype := ast.identifierNode.new(\"Unknown\", false)",
  "        var name := values.pop",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            dotyperef",
  "            dtype := values.pop",
  "        }",
  "        def anns = doannotation",
  "        if (accept(\"op\") && (sym.value == \"=\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                errormessages.syntaxError(\"A constant declaration must have a value after the '='.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "            val := values.pop",
  "        } elseif (accept(\"bind\")) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(sym)with(\"=\")",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A constant declaration must use '=' instead of ':='. A variable declaration uses 'var' and ':='.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + 1)withSuggestions(suggestions)",
  "        } else {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            suggestion.insert(\" = «expression»\")afterToken(lastToken)",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.replaceToken(defTok)with(\"var\")",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"A constant declaration must have a '=' and a value after the name. \"",
  "                ++ \"A variable declaration does not require a value and uses 'var' instead of 'def'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "        var o := ast.defDecNode.new(name, val, dtype)",
  "        var hasVisibility := false",
  "        var hasAccessibility := false",
  "        if (anns != false) then {",
  "            for (anns) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {",
  "                    (a.value == \"public\")",
  "                     || (a.value == \"confidential\")}) then {",
  "                    hasVisibility := true",
  "                }",
  "                if ((a.kind == \"identifier\").andAlso {",
  "                    (a.value == \"readable\")",
  "                     || (a.value == \"writable\")}) then {",
  "                    hasAccessibility := true",
  "                }",
  "            }",
  "            o.annotations.extend(anns)",
  "        }",
  "        if ((!hasVisibility) && (!hasAccessibility)) then {",
  "            if (defaultDefVisibility == \"public\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"public\", false))",
  "            }",
  "        }",
  "        o.startToken := defTok",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a var declaration",
  "method vardec {",
  "    if (accept(\"keyword\") && (sym.value == \"var\")) then {",
  "        def line = sym.line",
  "        def pos = sym.linePos",
  "        def varTok = sym",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextToken = findNextToken({ t -> (t.kind == \"bind\")",
  "                && (t.line == sym.line)})",
  "            if((nextToken == false).orElse({nextToken == sym})) then {",
  "                suggestion.insert(\" «name»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextToken.prev)leading(false)trailing(true)with(\"«name» \")",
  "            }",
  "            errormessages.syntaxError(\"A variable declaration must have a name after the 'var'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        var val := false",
  "        var dtype := ast.identifierNode.new(\"Unknown\", false)",
  "        var name := values.pop",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            dotyperef",
  "            dtype := values.pop",
  "        }",
  "        def anns = doannotation",
  "        if (accept(\"bind\")) then {",
  "            next",
  "            if(didConsume({expression}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken()",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                }",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must have a value after the ':='. \"",
  "                    ++ \"A variable without a value can be declared with 'var' followed only by the variable name.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            }",
  "            val := values.pop",
  "        } else {",
  "            if (accept(\"op\") && (sym.value == \"=\")) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)with(\":=\")",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(varTok)with(\"def\")",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A variable declaration must use ':=' instead of '='. A constant declaration uses 'def' and '='.\")",
  "                    atRange(sym.line, sym.linePos, sym.linePos)",
  "                    withSuggestions(suggestions)",
  "            }",
  "        }",
  "        var o := ast.varDecNode.new(name, val, dtype)",
  "        var hasVisibility := false",
  "        var hasAccessibility := false",
  "        if (anns != false) then {",
  "            for (anns) do {a->",
  "                if ((a.kind == \"identifier\").andAlso {",
  "                    (a.value == \"public\")",
  "                     || (a.value == \"confidential\")}) then {",
  "                    hasVisibility := true",
  "                }",
  "                if ((a.kind == \"identifier\").andAlso {",
  "                    (a.value == \"readable\")",
  "                     || (a.value == \"writable\")}) then {",
  "                    hasAccessibility := true",
  "                }",
  "            }",
  "            o.annotations.extend(anns)",
  "        }",
  "        if ((!hasVisibility) && (!hasAccessibility)) then {",
  "            if (defaultVarVisibility == \"public\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"readable\",",
  "                    false))",
  "                o.annotations.push(ast.identifierNode.new(\"writable\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a square-bracketed list literal like [1,2,3].",
  "method doarray {",
  "    if (accept(\"lsquare\")) then {",
  "        next",
  "        var tmp",
  "        var params := []",
  "        ifConsume {expression} then {",
  "            while {accept(\"comma\")} do {",
  "                tmp := values.pop",
  "                params.push(tmp)",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rsquare\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A list must contain zero or more valid expressions separated by commas.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            tmp := values.pop",
  "            params.push(tmp)",
  "        }",
  "        if(sym.kind != \"rsquare\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"]\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A list beginning with a '[' must end with a ']'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        var o := ast.arrayNode.new(params)",
  "        values.push(o)",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"dialect \"X\"\"",
  "method dodialect {",
  "    if (accept(\"keyword\") && (sym.value == \"dialect\")) then {",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«dialect name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"A dialect statement must have the name of the dialect in quotes after the 'dialect'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        values.push(ast.dialectNode.new(sym.value))",
  "        next",
  "    }",
  "}",
  "",
  "// Accept \"inherits X.new\"",
  "method inheritsdec {",
  "    if (accept(\"keyword\") && (sym.value == \"inherits\")) then {",
  "        checkIndent",
  "        next",
  "        if(didConsume({expression}).not) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextValidToken(\"rsquare\")",
  "            if(nextTok == sym) then {",
  "                suggestion.insert(\" «parent»\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «parent»\")",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"An inheritance statement must have the object being inherited from after the 'inherits'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        var tmp := values.pop",
  "        values.push(ast.inheritsNode.new(tmp))",
  "    }",
  "}",
  "",
  "// Accept an object literal.",
  "method doobject {",
  "    // doobject because \"object\" is a keyword",
  "    if (accept(\"keyword\") && (sym.value == \"object\")) then {",
  "        def btok = sym",
  "        def localMinIndentLevel = minIndentLevel",
  "        next",
  "        var superclass := false",
  "        if(sym.kind != \"lbrace\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"rbrace\" })",
  "            if(nextTok == false) then {",
  "                suggestion.insert(\" \\{}\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An object must have a '\\{' afer the 'object'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        values.push(object {",
  "            var kind := \"lbrace\"",
  "            var register := \"\"",
  "        })",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        var sz := values.size",
  "        while {(accept(\"rbrace\")).not} do {",
  "            // An object body contains zero or more var declarations,",
  "            // const declarations, and method declarations. If anything",
  "            // else appears before the closing brace, it is a syntax error.",
  "            methoddec",
  "            inheritsdec",
  "            statement",
  "            if (sym.kind == \"eof\") then {",
  "                if(sym.kind != \"rbrace\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\"}\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"An object must end with a '}'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } elseif ((values.size == sz) && (lastToken.kind != \"semicolon\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"An object can only contain variable, constant, and method declarations; and statements.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "            }",
  "            sz := values.size",
  "        }",
  "        next",
  "        var rbody := []",
  "        var n := values.pop",
  "        while {n.kind != \"lbrace\"} do {",
  "            rbody.push(n)",
  "            n := values.pop",
  "        }",
  "        var body := []",
  "        for (rbody.indices) do { x ->",
  "            // Reorder the list",
  "            var p := rbody.pop",
  "            body.push(p)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.objectNode.new(body, superclass)",
  "        values.push(o)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a class declaration",
  "// Class declarations are currently of the form:",
  "//   class classname [extends Foo.new(...)] { param1, param2 ->",
  "//     var x",
  "//     method y(z) { ... }",
  "//   }",
  "method doclass {",
  "    if (accept(\"keyword\") && (sym.value == \"class\")) then {",
  "        def btok = sym",
  "        next",
  "        def localMinIndentLevel = minIndentLevel",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestions = []",
  "            if(sym.kind == \"lbrace\") then {",
  "                var suggestion := errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(lastToken)with(\"object\")",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\" «class name».new \\{}\")afterToken(lastToken)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"A class must have a name after the 'class'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestions(suggestions)",
  "        }",
  "        def cname = if (tokens.first.kind == \"dot\") then {",
  "            pushidentifier // A class currently cannot be anonymous",
  "            def cname' = values.pop",
  "            if (!accept(\"dot\")) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.replaceToken(sym) with(\".\")",
  "                errormessages.syntaxError \"A class must have a dot after the object name.\"",
  "                    atPosition(lastToken.line, lastToken.linePos + lastToken.size + 1)",
  "                    withSuggestion(suggestion)",
  "            }",
  "            next",
  "            cname'",
  "        } else {",
  "            false",
  "        }",
  "        var s := methodsignature(false)",
  "        var csig := s.sig",
  "        var constructorName := s.m",
  "        var dtype := s.rtype",
  "        def anns = doannotation",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" \\{\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A class must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if (sym.line == statementToken.line) then {",
  "            minIndentLevel := sym.linePos - 1",
  "        } else {",
  "            minIndentLevel := statementToken.indent + 1",
  "        }",
  "        def body = []",
  "        while {(accept(\"rbrace\")).not} do {",
  "            ifConsume {methoddec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {inheritsdec} then {",
  "                body.push(values.pop)",
  "            }",
  "            ifConsume {statement} then {",
  "                body.push(values.pop)",
  "            }",
  "        }",
  "        next",
  "        util.setline(btok.line)",
  "        def o = if (false == cname) then {",
  "            ast.methodNode.new(constructorName, csig,",
  "                [ast.objectNode.new(body, false)], false)",
  "        } else {",
  "            ast.classNode.new(cname, csig, body, false, constructorName, dtype)",
  "        }",
  "        o.generics := s.generics",
  "        if (false != anns) then {",
  "            o.annotations.extend(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(o)",
  "        minIndentLevel := localMinIndentLevel",
  "    }",
  "}",
  "",
  "// Accept a method declaration",
  "method methoddec {",
  "    if (accept(\"keyword\") && (sym.value == \"method\")) then {",
  "        def btok = sym",
  "        checkIndent",
  "        var stok := sym",
  "        next",
  "        var m := methodsignature(false)",
  "        var meth := m.m",
  "        var signature := m.sig",
  "        var dtype := m.rtype",
  "        var varargs := m.v",
  "        var generics := m.generics",
  "        var body := []",
  "        var localMin",
  "        def anns = doannotation",
  "        if (accept(\"lbrace\")) then {",
  "            next",
  "            localMin := minIndentLevel",
  "            if (sym.line == stok.line) then {",
  "                minIndentLevel := sym.linePos - 1",
  "            } else {",
  "                minIndentLevel := stok.indent + 1",
  "            }",
  "            values.push(object {",
  "                var kind := \"lbrace\"",
  "                var register := \"\"",
  "            })",
  "            statement",
  "            var s := values.pop",
  "            while {s.kind != \"lbrace\"} do {",
  "                // The body is a sequence of statements, and",
  "                // the method ends when no further statement",
  "                // is found.",
  "                body.push(s)",
  "                statement",
  "                s := values.pop",
  "            }",
  "            if(sym.kind != \"rbrace\") then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def closingBrace = findClosingBrace(btok, false)",
  "                if(closingBrace.found == false) then {",
  "                    if(closingBrace.tok == sym) then {",
  "                        suggestion.insert(\"}\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    }",
  "                }",
  "                suggestion.deleteToken(sym)",
  "                errormessages.syntaxError(\"A method must end with a '}'.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "            next",
  "            minIndentLevel := localMin",
  "        } else {",
  "            def suggestion = errormessages.suggestion.new",
  "            def closingBrace = findClosingBrace(btok, true)",
  "            if(closingBrace.found == false) then {",
  "                if(closingBrace.tok == lastToken) then {",
  "                    suggestion.insert(\" \\{}\")afterToken(lastToken)andTrailingSpace(true)",
  "                } else {",
  "                    suggestion.addLine(closingBrace.tok.line + 0.1, \"}\")",
  "                    suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "                }",
  "            } else {",
  "                suggestion.insert(\" \\{\")afterToken(lastToken)andTrailingSpace(true)",
  "            }",
  "            errormessages.syntaxError(\"A method must have a '\\{' after the name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        util.setline(btok.line)",
  "        var o := ast.methodNode.new(meth, signature, body, dtype)",
  "        if (varargs) then {",
  "            o.varargs := true",
  "        }",
  "        o.generics := generics",
  "        if (false != anns) then {",
  "            o.annotations.extend(anns)",
  "        } else {",
  "            if (defaultMethodVisibility == \"confidential\") then {",
  "                o.annotations.push(ast.identifierNode.new(\"confidential\",",
  "                    false))",
  "            }",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Process the declaration of a multi-part method name. These follow",
  "// mostly the same rules as calls, but aren't strictly enforced to be on",
  "// a single line (because they are ended by \"{\" or \"->\"). This method",
  "// returns a replacement method name identifier and modifies params in",
  "// place.",
  "method parsempmndecrest(tm, sameline) {",
  "    var methname := tm.value.value",
  "    var signature := tm.signature",
  "    var nxt",
  "    while {(!sameline && accept(\"identifier\")) || acceptSameLine(\"identifier\")} do {",
  "        methname := methname ++ \"()\"",
  "        var part := ast.signaturePart.new",
  "        pushidentifier",
  "        nxt := values.pop",
  "        methname := methname ++ nxt.value",
  "        part.name := nxt.value",
  "        var vararg := false",
  "        if ((accept(\"lparen\")).not) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\"()\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A multi-part method must have parentheses around each part of the method.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        var comma := false",
  "        while {accept(\"identifier\")",
  "                || (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            if (accept(\"op\")) then {",
  "                next",
  "                vararg := true",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            pushidentifier",
  "            nxt := values.pop",
  "            if (accept(\"colon\")) then {",
  "                next",
  "                dotyperef",
  "                var tp := values.pop",
  "                nxt.dtype := tp",
  "            }",
  "            if (vararg) then {",
  "                part.vararg := nxt",
  "                tm.varargs := true",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            } else {",
  "                part.params.push(nxt)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\")\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A part of a multi-part method beginning with a '(' must end with a ')'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        signature.push(part)",
  "    }",
  "    ast.identifierNode.new(methname, false)",
  "}",
  "",
  "// Accept a method signature",
  "method methodsignature(sameline) {",
  "    if((sym.kind != \"identifier\") && (sym.kind != \"op\") && (sym.kind != \"lsquare\")) then {",
  "        def suggestion = errormessages.suggestion.new",
  "        suggestion.insert(\" «method name»\")afterToken(lastToken)",
  "        errormessages.syntaxError(\"A method name must either start with an identifier or '[]'.\")atPosition(",
  "            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "    }",
  "    pushidentifier",
  "    var meth := values.pop",
  "    var signature := []",
  "    var part := ast.signaturePart.new(meth.value)",
  "    var genericIdents := []",
  "    signature.push(part)",
  "    if (meth.value == \"[\") then {",
  "        if(sym.kind != \"rsquare\") then {",
  "            if((sym.kind == \"identifier\") && ((tokens.size == 0).orElse",
  "                {tokens.first.kind == \"rsquare\"})) then {",
  "                def suggestions = []",
  "                def suggestion = errormessages.suggestion.new",
  "                if(tokens.size == 0) then {",
  "                    suggestion.replaceToken(sym)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                } elseif(tokens.first.line == meth.line) then {",
  "                    suggestion.replaceTokenRange(sym, tokens.first)with(\"]({sym.value})\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "                errormessages.syntaxError(\"A method name beginning with '[]' must have the parameter name in parentheses after the '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "            } else {",
  "                def suggestion = errormessages.suggestion.new",
  "                suggestion.insert(\"]\")afterToken(lastToken)",
  "                errormessages.syntaxError(\"A method name must either start with an identifier or '[]'.\")atPosition(",
  "                    lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "            }",
  "        }",
  "        next",
  "        meth.value := \"[]\"",
  "    }",
  "    if (accept(\"lgeneric\")) then {",
  "        // Generic!",
  "        next",
  "        genericIdents := part.generics",
  "        while {accept(\"identifier\")} do {",
  "            identifier",
  "            genericIdents.push(values.pop)",
  "            if (accept(\"comma\")) then {",
  "                next",
  "            }",
  "        }",
  "        if(sym.kind != \"rgeneric\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\">\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type containing a '<' must end with a '>'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "        }",
  "        next",
  "    }",
  "    if (accept(\"bind\")) then {",
  "        next",
  "        meth.value := meth.value ++ \":=\"",
  "        part.name := part.name ++ \":=\"",
  "    } elseif (accept(\"op\") && (meth.value == \"prefix\")) then {",
  "        meth.value := meth.value ++ sym.value",
  "        part.name := part.name ++ sym.value",
  "        next",
  "    }",
  "    var dtype := false",
  "    var varargs := false",
  "    var vararg := false",
  "    if (accept(\"lparen\")) then {",
  "        def lparen = sym",
  "        part.linePos := sym.linePos",
  "        next",
  "        var id",
  "        var comma := false",
  "        while {accept(\"identifier\") ||",
  "                (accept(\"op\") && (sym.value == \"*\"))} do {",
  "            // Parse the parameter list, including optional dtype",
  "            // annotations.",
  "            if (accept(\"op\")) then {",
  "                next",
  "                if(sym.kind != \"identifier\") then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\"«parameter name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    if(comma == false) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteToken(lastToken)",
  "                        suggestions.push(suggestion)",
  "                    } else {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.deleteTokenRange(comma, lastToken)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                    errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestions(suggestions)",
  "                }",
  "                vararg := true",
  "                varargs := true",
  "            }",
  "            pushidentifier",
  "            id := values.pop",
  "            dtype := false",
  "            if (accept(\"colon\")) then {",
  "                next",
  "                if (didConsume { dotyperef }) then {",
  "                    dtype := values.pop",
  "                } else {",
  "                    checkBadAnonymousType",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(lastToken)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A type name or type expression must follow ':'.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "            }",
  "            id.dtype := dtype",
  "            if (vararg) then {",
  "                part.vararg := id",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == sym.line) })",
  "                    if((sym.kind == \"comma\") && (rparen != false)) then {",
  "                        suggestion.insert(\",*{id.value}\")beforeToken(rparen)",
  "                        suggestion.deleteTokenRange(lparen.next, sym)leading(true)trailing(false)",
  "                        errormessages.syntaxError(\"A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.\")atRange(",
  "                            lastToken.line, sym.linePos, rparen.linePos - 1)withSuggestion(suggestion)",
  "                    } else {",
  "                        suggestion.insert(\")\")afterToken(lastToken)",
  "                        errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                            lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                    }",
  "                }",
  "            } else {",
  "                part.params.push(id)",
  "            }",
  "            if (accept(\"comma\")) then {",
  "                comma := sym",
  "                next",
  "            } elseif (sym.kind != \"rparen\") then {",
  "                if(sym.kind != \"rparen\") then {",
  "                    def suggestion = errormessages.suggestion.new",
  "                    suggestion.insert(\")\")afterToken(lastToken)",
  "                    errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atPosition(",
  "                        lastToken.line, lastToken.linePos + lastToken.size)withSuggestion(suggestion)",
  "                }",
  "            }",
  "        }",
  "        if(sym.kind != \"rparen\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            def rparen = findNextToken({ t -> (t.kind == \"rparen\") && (t.line == lastToken.line) })",
  "            if(rparen == false) then {",
  "                suggestion.replaceToken(lastToken)with(\")\")",
  "            } else {",
  "                suggestion.deleteToken(sym)",
  "            }",
  "            errormessages.syntaxError(\"A part of a method beginning with a '(' must end with a ')'.\")atRange(",
  "                lastToken.line, lastToken.linePos, lastToken.linePos)withSuggestion(suggestion)",
  "        }",
  "        if (sym.line == part.line) then {",
  "            part.lineLength := sym.linePos - part.linePos",
  "        }",
  "        next",
  "        if ((!sameline && accept(\"identifier\")) ||",
  "            acceptSameLine(\"identifier\")) then {",
  "            // The presence of an identifier here means",
  "            // a multi-part method name.",
  "            var tm := ast.methodNode.new(meth, signature, [], false)",
  "            meth := parsempmndecrest(tm, sameline)",
  "            varargs := varargs || tm.varargs",
  "        }",
  "    }",
  "    if (accept(\"arrow\")) then {",
  "        // Return dtype",
  "        next",
  "        dotyperef",
  "        dtype := values.pop",
  "    } else {",
  "        dtype := false",
  "    }",
  "    var o := object {",
  "        var m := meth",
  "        var sig := signature",
  "        var rtype := dtype",
  "        var v := varargs",
  "        var generics := genericIdents",
  "    }",
  "    o",
  "}",
  "",
  "// Accept an import statement. import takes a single identifier",
  "// following, as in \"import parser\".",
  "method doimport {",
  "    if (accept(\"keyword\") && (sym.value == \"import\")) then {",
  "        def importline = sym.line",
  "        next",
  "        if(sym.kind != \"string\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"\\\"{sym.value}\\\"\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" \\\"«module name»\\\"\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushstring",
  "        def p = values.pop",
  "        if((sym.kind != \"identifier\") || (sym.value != \"as\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            if((sym.kind == \"identifier\") && (sym.line == lastToken.line)) then {",
  "                suggestion.insert(\" as\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.insert(\" as {p.value}\")afterToken(lastToken)",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have 'as', and an identifier after the name of the module in quotes.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            var suggestion := errormessages.suggestion.new",
  "            var errorPos",
  "            if((sym.kind == \"string\") && (sym.line == lastToken.line)) then {",
  "                suggestion.replaceToken(sym)with(\"{sym.value}\")",
  "                errorPos := sym.linePos",
  "            } else {",
  "                suggestion.insert(\" {p.value}\")afterToken(lastToken)",
  "                errorPos := lastToken.linePos + lastToken.size + 1",
  "            }",
  "            errormessages.syntaxError(\"An import statement must have an identifier after 'as'.\")atPosition(",
  "                lastToken.line, errorPos)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        def n = values.pop",
  "        util.setline(importline)",
  "        def o = ast.importNode.new(p.value, n.value)",
  "        if (accept(\"colon\")) then {",
  "            next",
  "            dotypeterm",
  "            o.dtype := values.pop",
  "        }",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "// Accept a return statement. return takes a mandatory argument,",
  "// of the form \"return x\". x may be any expression.",
  "method doreturn {",
  "    if (accept(\"keyword\") && (sym.value == \"return\")) then {",
  "        next",
  "        var retval",
  "        if (tokenOnSameLine) then {",
  "            if(didConsume({expression}).not) then {",
  "                def suggestions = []",
  "                var suggestion := errormessages.suggestion.new",
  "                def nextTok = findNextValidToken(\"rbrace\")",
  "                if(nextTok == sym) then {",
  "                    suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteToken(sym)leading(true)trailing(false)",
  "                } else {",
  "                    suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                }",
  "                suggestions.push(suggestion)",
  "                errormessages.syntaxError(\"A return statement must have either an expression or a new-line after 'return'.\")atRange(",
  "                    sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestions(suggestions)",
  "            }",
  "            retval := values.pop",
  "        } else {",
  "            retval := ast.identifierNode.new(\"done\", false)",
  "        }",
  "        var o := ast.returnNode.new(retval)",
  "        values.push(o)",
  "    }",
  "}",
  "",
  "method domethodtype {",
  "    var m := methodsignature(true)",
  "    var meth := m.m",
  "    var signature := m.sig",
  "    var dtype := m.rtype",
  "    var varargs := m.v",
  "    if (dtype == false) then {",
  "        dtype := ast.identifierNode.new(\"Done\", false)",
  "    }",
  "    var o := ast.methodTypeNode.new(meth.value, signature, dtype)",
  "    o.generics := m.generics",
  "    values.push(o)",
  "    if (accept(\"semicolon\")) then {",
  "        next",
  "    } else {",
  "        if (!accept(\"rbrace\")) then {",
  "            if (lastToken.line == sym.line) then {",
  "                def suggestion = errormessages.suggestion.new",
  "                def newLine = util.lines[sym.line].substringFrom(1)to(lastToken.linePos - 1) ++ sym.value",
  "                suggestion.addLine(sym.line + 0.1, newLine)",
  "                suggestion.deleteToken(sym)leading(true)trailing(true)",
  "                errormessages.syntaxError(\"Each method must be on a separate line in a type.\")atPosition(",
  "                    sym.line, sym.linePos)withSuggestion(suggestion)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "method doanontype {",
  "    // parses a type expression between braces, with the leading type keyword.",
  "    if (accept(\"keyword\").andAlso { sym.value == \"type\" }) then {",
  "        next",
  "        if (!accept(\"lbrace\")) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.replaceToken(sym) with(\"\\{\")",
  "            errormessages.syntaxError \"Anonymous types must open with braces.\"",
  "                atPosition(sym.line, sym.linePos) withSuggestion(suggestion)",
  "        }",
  "        def methods = []",
  "        def mc = auto_count",
  "        auto_count := auto_count + 1",
  "        next",
  "        while {accept(\"rbrace\").not} do {",
  "            domethodtype",
  "            methods.push(values.pop)",
  "        }",
  "        next",
  "        def t = ast.typeNode.new(\"<Anon_{mc}>\", methods)",
  "        t.anonymous := true",
  "        values.push(t)",
  "    }",
  "}",
  "// Accept a type declaration.",
  "method dotype {",
  "    if (accept(\"keyword\") && (sym.value == \"type\")) then {",
  "        next",
  "        if(sym.kind != \"identifier\") then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.insert(\" «type name»\")afterToken(lastToken)",
  "            errormessages.syntaxError(\"A type declaration must have a name after the 'type'.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        pushidentifier",
  "        generic",
  "        var p := values.pop",
  "        var gens := []",
  "        if (p.kind == \"generic\") then {",
  "            gens := p.params",
  "            p := p.value",
  "        }",
  "        def anns = doannotation",
  "        if((sym.kind != \"op\") || (sym.value != \"=\")) then {",
  "            var suggestion := errormessages.suggestion.new",
  "            def nextTok = findNextToken({ t -> t.kind == \"lbrace\" })",
  "            if((nextTok == false).orElse({nextTok == sym})) then {",
  "                suggestion.insert(\" =\")afterToken(lastToken)",
  "            } else {",
  "                suggestion.replaceTokenRange(sym, nextTok.prev)with(\"=\")",
  "            }",
  "            errormessages.syntaxError(\"A type declaration must have a '=' after the type name.\")atPosition(",
  "                lastToken.line, lastToken.linePos + lastToken.size + 1)withSuggestion(suggestion)",
  "        }",
  "        next",
  "        def methods = []",
  "        // Special case for type declarations.",
  "        if (accept(\"lbrace\")) then {",
  "            next",
  "            while {accept(\"rbrace\").not} do {",
  "                domethodtype",
  "                methods.push(values.pop)",
  "            }",
  "            next",
  "            def t = ast.typeNode.new(p.value, methods)",
  "            t.generics := gens",
  "            if (false != anns) then {",
  "                t.annotations.extend(anns)",
  "            }",
  "            values.push(t)",
  "        } else {",
  "            dotyperef",
  "            def ot = values.pop",
  "            var nt",
  "            if (ot.kind == \"type\") then {",
  "                nt := ast.typeNode.new(p.value, ot.methods)",
  "                nt.generics := nt.generics",
  "                for (ot.unionTypes) do {ut->",
  "                    nt.unionTypes.push(ut)",
  "                }",
  "                for (ot.intersectionTypes) do {ut->",
  "                    nt.intersectionTypes.push(ut)",
  "                }",
  "                nt.generics := gens",
  "            } else {",
  "                nt := ast.typeNode.new(p.value, [])",
  "            }",
  "            if (false != anns) then {",
  "                nt.annotations.extend(anns)",
  "            }",
  "            values.push(nt)",
  "        }",
  "    }",
  "}",
  "",
  "method checkIndent {",
  "    if (indentFreePass) then {",
  "        indentFreePass := false",
  "    } elseif (sym.kind == \"semicolon\") then {",
  "        // pass",
  "    } elseif ((sym.kind == \"rbrace\") || (sym.kind == \"rparen\")",
  "        || (sym.kind == \"rsquare\")) then {",
  "        // pass",
  "    } elseif (sym.kind == \"eof\") then {",
  "    } elseif (sym.indent < minIndentLevel) then {",
  "        if ((sym.linePos - 1) != minIndentLevel) then {",
  "            def suggestions = []",
  "            var suggestion := errormessages.suggestion.new",
  "            for(1..(minIndentLevel - (sym.linePos - 1))) do { _ ->",
  "                suggestion.insert(\" \")atPosition(1)onLine(sym.line)",
  "            }",
  "            suggestions.push(suggestion)",
  "            suggestion := errormessages.suggestion.new",
  "            // Find the indent level for the opening brace.",
  "            var tok := lastToken",
  "            while {(tok.linePos != (tok.indent + 1)) || (tok.indent >= minIndentLevel)} do { tok := tok.prev }",
  "            var line := \"\"",
  "            for(1..(tok.indent)) do { _ ->",
  "                line := line ++ \" \"",
  "            }",
  "            line := line ++ \"}\"",
  "            suggestion.addLine(sym.line - 0.9, line)",
  "            suggestions.push(suggestion)",
  "            errormessages.syntaxError(\"The indentation for this line must be at least {minIndentLevel}. This is often caused by a missing '}'.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    } elseif (sym.indent > minIndentLevel) then {",
  "        minIndentLevel := sym.indent",
  "    }",
  "}",
  "",
  "// Accept a statement. A statement is any of the above that may exist",
  "// at the top level, and includes expressions.",
  "// A statement may also be a bind statement x := y, which creates a",
  "// bind AST node out of the expressions on either side (which at this point",
  "// can be any arbitrary expression).",
  "method statement {",
  "    statementIndent := sym.indent",
  "    statementToken := sym",
  "    checkIndent",
  "    if (accept(\"keyword\")) then {",
  "        if (sym.value == \"var\") then {",
  "            vardec",
  "        } elseif (sym.value == \"def\") then {",
  "            defdec",
  "        } elseif (sym.value == \"import\") then {",
  "            doimport",
  "        } elseif (sym.value == \"dialect\") then {",
  "            dodialect",
  "        } elseif (sym.value == \"type\") then {",
  "            dotype",
  "        } elseif (sym.value == \"class\") then {",
  "            doclass",
  "        } elseif (sym.value == \"return\") then {",
  "            doreturn",
  "        } else {",
  "            expression",
  "        }",
  "    } else {",
  "        ifConsume {expression} then {",
  "            if (((values.last.kind == \"identifier\")",
  "                || (values.last.kind == \"member\")",
  "                || (values.last.kind == \"index\"))",
  "                && accept(\"bind\")) then {",
  "                var dest := values.pop",
  "                next",
  "                if(didConsume({expression}).not) then {",
  "                    def suggestions = []",
  "                    var suggestion := errormessages.suggestion.new",
  "                    def nextTok = findNextValidToken(\"rbrace\")",
  "                    if(nextTok == sym) then {",
  "                        suggestion.insert(\" «expression»\")afterToken(lastToken)",
  "                    } else {",
  "                        suggestion.replaceTokenRange(sym, nextTok.prev)leading(true)trailing(false)with(\" «expression»\")",
  "                    }",
  "                    suggestions.push(suggestion)",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.deleteTokenRange(lastToken, nextTok.prev)leading(true)trailing(false)",
  "                    suggestions.push(suggestion)",
  "                    errormessages.syntaxError(\"A valid expression must follow ':='.\")atPosition(",
  "                        sym.line, sym.linePos)withSuggestions(suggestions)",
  "                }",
  "                var val := values.pop",
  "                var o := ast.bindNode.new(dest, val)",
  "                values.push(o)",
  "            }",
  "        }",
  "    }",
  "    if (accept(\"eof\")) then {",
  "        return true",
  "    }",
  "    if (accept(\"semicolon\")) then {",
  "        def oldLine = sym.line",
  "        next",
  "        if (sym.line == oldLine) then {",
  "            indentFreePass := true",
  "        }",
  "    } else {",
  "        checkUnexpectedTokenAfterStatement",
  "    }",
  "}",
  "",
  "method checkBadOperators {",
  "    if (sym.value == \"=\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"=\")afterToken(sym)",
  "        errormessages.syntaxError(\"Use '==' to test equality, not '='.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "    if (sym.kind == \"rgeneric\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\" \")beforeToken(sym)",
  "        errormessages.syntaxError(\"The '>' operator requires a space before it.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkBadAnonymousType {",
  "    if (sym.kind == \"lbrace\") then {",
  "        def sugg = errormessages.suggestion.new",
  "        sugg.insert(\"type \") beforeToken(sym)",
  "        errormessages.syntaxError(\"Anonymous type literals must be written with the 'type' keyword'.\")",
  "            atRange(sym.line, sym.linePos, sym.linePos)",
  "            withSuggestion(sugg)",
  "    }",
  "}",
  "",
  "method checkUnexpectedTokenAfterStatement {",
  "    if (sym.line == lastToken.line) then {",
  "        if ((sym.kind == \"op\") && (sym.value == \"=\")",
  "            && (lastToken.kind == \"identifier\")) then {",
  "            def sugg = errormessages.suggestion.new",
  "            def suggestions = []",
  "            sugg.replaceToken(sym)leading(false)trailing(false)with(\":=\")",
  "            suggestions.push(sugg)",
  "            def sugg2 = errormessages.suggestion.new",
  "            sugg2.replaceToken(sym)leading(false)trailing(false)with \"==\"",
  "            suggestions.push(sugg2)",
  "            errormessages.syntaxError(\"Assignment uses ':=', not '='.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestions (suggestions)",
  "        }",
  "        if (sym.kind == \"rgeneric\") then {",
  "            def sugg = errormessages.suggestion.new",
  "            sugg.insert(\" \")atPosition(sym.linePos)onLine(sym.line)",
  "            errormessages.syntaxError(",
  "                    \"The '>' operator must have a space before it.\")",
  "                atRange(sym.line, sym.linePos, sym.linePos)",
  "                withSuggestion(sugg)",
  "        }",
  "        if (sym.kind != \"rbrace\") then {",
  "            def suggestions = []",
  "            var suggestion",
  "            if ((values.size > 0).andAlso {",
  "                    (values.last.kind == \"identifier\").orElse {",
  "                        values.last.kind == \"member\"",
  "                    }.andAlso {",
  "                        sym.kind == \"identifier\"",
  "                    }",
  "                }) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value})\")",
  "                suggestions.push(suggestion)",
  "                if (false != sym.next) then {",
  "                    def n = sym.next",
  "                    if (n.line == sym.line) then {",
  "                        suggestion := errormessages.suggestion.new",
  "                        suggestion.replaceToken(sym)leading(true)trailing(false)with(\"({sym.value}\")",
  "                        suggestion.append \")\" onLine(sym.line)",
  "                        suggestions.push(suggestion)",
  "                    }",
  "                }",
  "                if (values.last.kind == \"identifier\") then {",
  "                    suggestion := errormessages.suggestion.new",
  "                    suggestion.replaceToken(sym)leading(false)trailing(false)with(\"\\\"{sym.value}\\\"\")",
  "                    suggestions.push(suggestion)",
  "                }",
  "            }",
  "            def nextTok = findNextValidToken(\"rbrace\")",
  "            if(nextTok == sym) then {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.addLine(lastToken.line, util.lines[lastToken.line].substringFrom(1)to(lastToken.linePos + lastToken.size - 1))",
  "                def newLine = util.lines[sym.line].substringFrom(sym.linePos)to(util.lines[sym.line].size)",
  "                suggestion.addLine(lastToken.line + 0.1, newLine)",
  "                suggestions.push(suggestion)",
  "            } else {",
  "                suggestion := errormessages.suggestion.new",
  "                suggestion.deleteTokenRange(sym, nextTok.prev)leading(true)trailing(false)",
  "                suggestions.push(suggestion)",
  "            }",
  "            errormessages.syntaxError(\"Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.\")atPosition(",
  "                sym.line, sym.linePos)withSuggestions(suggestions)",
  "        }",
  "    }",
  "}",
  "",
  "// Parse the given list of tokens, returning a list of AST nodes",
  "// corresponding to it.",
  "method parse(toks) {",
  "    util.log_verbose(\"processing tokens.\")",
  "    values := []",
  "    if (util.extensions.contains(\"DefaultVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVisibility\")",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultDefVisibility\")) then {",
  "        defaultDefVisibility := util.extensions.get(\"DefaultDefVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultVarVisibility\")) then {",
  "        defaultVarVisibility := util.extensions.get(\"DefaultVarVisibility\")",
  "    }",
  "    if (util.extensions.contains(\"DefaultMethodVisibility\")) then {",
  "        defaultMethodVisibility := util.extensions.get(\"DefaultMethodVisibility\")",
  "    }",
  "    if (toks.size == 0) then {",
  "        return []",
  "    }",
  "    tokens := toks",
  "    sym := tokens.first",
  "    sym.prev := lastToken",
  "// TODO: Do this in lexer.",
  "    tokens.push(object {",
  "        var kind := \"eof\"",
  "        var line := tokens.last.line",
  "        var linePos := util.lines[tokens.last.line].size + 1",
  "        var indent := 0",
  "        var value := \"\"",
  "        def size = 0",
  "        var next := false",
  "        var prev := false",
  "    })",
  "    util.log_verbose(\"parsing.\")",
  "    linenum := 1",
  "    next",
  "    var oldlength := tokens.size",
  "    while {tokens.size > 0} do {",
  "        blank",
  "        methoddec",
  "        blank",
  "        inheritsdec",
  "        blank",
  "        statement",
  "        if (tokens.size == oldlength) then {",
  "            def suggestion = errormessages.suggestion.new",
  "            suggestion.deleteToken(sym)",
  "            errormessages.syntaxError(\"Invalid statement. This is often caused by an extra '}', ')', or ']'.\")atRange(",
  "                sym.line, sym.linePos, sym.linePos + sym.size - 1)withSuggestion(suggestion)",
  "        }",
  "        oldlength := tokens.size",
  "    }",
  "    statement",
  "    values",
  "}",
  NULL
};
Object reader_parser_outer_69(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_70(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_70(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_71(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_71(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_72(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_72(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_73(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_73(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_74(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_74(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_75(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_parser_outer_265(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_found_266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_found_266(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_tok_267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_tok_267(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8140(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8141(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_8141(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_register_8142(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8142(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_8676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_8677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_8677(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_register_8678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_register_8678(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_outer_9829(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_m_9830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_m_9830(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_sig_9831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_sig_9831(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_rtype_9832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_rtype_9832(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_v_9833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_v_9833(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_generics_9834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_generics_9834(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_outer_11501(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_11502(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_11503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_11503(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_11504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_11504(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_11505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_11505(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_11506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_11506(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_11507(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
Object reader_parser_next_11508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[7];
}
Object writer_parser_next_11508(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[7] = args[0];
  return done;
}
Object reader_parser_prev_11509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[8];
}
Object writer_parser_prev_11509(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[8] = args[0];
  return done;
}
Object reader_parser_outer_11670(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_parser_kind_11671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_parser_kind_11671(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_parser_line_11672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_parser_line_11672(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_parser_linePos_11673(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_parser_linePos_11673(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_parser_indent_11674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_parser_indent_11674(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_parser_value_11675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_parser_value_11675(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_parser_size_11676(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[6];
}
static Object strlit18;
static Object strlit23;
static Object strlit39;
static ClassData objclass68;
static Object strlit76;
static Object strlit91;
static Object strlit143;
static Object strlit190;
static Object strlit222;
static Object strlit223;
static Object strlit224;
static Object strlit225;
static Object strlit226;
static Object strlit227;
static Object strlit228;
static Object strlit229;
static Object strlit234;
static ClassData objclass264;
static Object strlit281;
static Object strlit292;
static Object strlit304;
static Object strlit332;
static Object strlit343;
static Object strlit355;
static Object strlit372;
static Object strlit389;
static Object strlit586;
static Object strlit594;
static Object strlit612;
static Object strlit639;
static Object strlit649;
static Object strlit673;
static Object strlit704;
static Object strlit712;
static Object strlit741;
static Object strlit748;
static Object strlit755;
static Object strlit773;
static Object strlit792;
static Object strlit821;
static Object strlit828;
static Object strlit835;
static Object strlit853;
static Object strlit900;
static Object strlit916;
static Object strlit933;
static Object strlit940;
static Object strlit973;
static Object strlit992;
static Object strlit997;
static Object strlit1011;
static Object strlit1018;
static Object strlit1053;
static Object strlit1067;
static Object strlit1086;
static Object strlit1091;
static Object strlit1098;
static Object strlit1102;
static Object strlit1111;
static Object strlit1115;
static Object strlit1140;
static Object strlit1147;
static Object strlit1182;
static Object strlit1196;
static Object strlit1215;
static Object strlit1220;
static Object strlit1227;
static Object strlit1231;
static Object strlit1240;
static Object strlit1264;
static Object strlit1281;
static Object strlit1299;
static Object strlit1304;
static Object strlit1308;
static Object strlit1317;
static Object strlit1339;
static Object strlit1340;
static Object strlit1347;
static Object strlit1354;
static Object strlit1372;
static Object strlit1388;
static Object strlit1400;
static Object strlit1410;
static Object strlit1441;
static Object strlit1446;
static Object strlit1458;
static Object strlit1472;
static Object strlit1489;
static Object strlit1499;
static Object strlit1506;
static Object strlit1513;
static Object strlit1516;
static Object strlit1519;
static Object strlit1529;
static Object strlit1539;
static Object strlit1556;
static Object strlit1561;
static Object strlit1571;
static Object strlit1580;
static Object strlit1610;
static Object strlit1617;
static Object strlit1624;
static Object strlit1642;
static Object strlit1658;
static Object strlit1682;
static Object strlit1709;
static Object strlit1730;
static Object strlit1733;
static Object strlit1780;
static Object strlit1787;
static Object strlit1794;
static Object strlit1810;
static Object strlit1817;
static Object strlit1826;
static Object strlit1833;
static Object strlit1857;
static Object strlit1861;
static Object strlit1871;
static Object strlit1874;
static Object strlit1878;
static Object strlit1888;
static Object strlit1891;
static Object strlit1894;
static Object strlit1901;
static Object strlit1911;
static Object strlit1914;
static Object strlit1917;
static Object strlit1923;
static Object strlit1950;
static Object strlit1972;
static Object strlit1980;
static Object strlit1987;
static Object strlit1990;
static Object strlit2001;
static Object strlit2004;
static Object strlit2015;
static Object strlit2018;
static Object strlit2032;
static Object strlit2044;
static Object strlit2047;
static Object strlit2071;
static Object strlit2078;
static Object strlit2085;
static Object strlit2113;
static Object strlit2124;
static Object strlit2129;
static Object strlit2134;
static Object strlit2137;
static Object strlit2171;
static Object strlit2208;
static Object strlit2219;
static Object strlit2224;
static Object strlit2244;
static Object strlit2251;
static Object strlit2265;
static Object strlit2272;
static Object strlit2280;
static Object strlit2283;
static Object strlit2286;
static Object strlit2289;
static Object strlit2292;
static Object strlit2293;
static Object strlit2296;
static Object strlit2310;
static Object strlit2317;
static Object strlit2326;
static Object strlit2334;
static Object strlit2341;
static Object strlit2366;
static Object strlit2370;
static Object strlit2380;
static Object strlit2383;
static Object strlit2387;
static Object strlit2397;
static Object strlit2400;
static Object strlit2403;
static Object strlit2410;
static Object strlit2420;
static Object strlit2423;
static Object strlit2426;
static Object strlit2432;
static Object strlit2460;
static Object strlit2467;
static Object strlit2490;
static Object strlit2498;
static Object strlit2505;
static Object strlit2508;
static Object strlit2519;
static Object strlit2522;
static Object strlit2533;
static Object strlit2536;
static Object strlit2561;
static Object strlit2565;
static Object strlit2570;
static Object strlit2574;
static Object strlit2597;
static Object strlit2604;
static Object strlit2617;
static Object strlit2641;
static Object strlit2646;
static Object strlit2657;
static Object strlit2662;
static Object strlit2681;
static Object strlit2684;
static Object strlit2695;
static Object strlit2698;
static Object strlit2701;
static Object strlit2709;
static Object strlit2737;
static Object strlit2748;
static Object strlit2753;
static Object strlit2758;
static Object strlit2761;
static Object strlit2795;
static Object strlit2832;
static Object strlit2843;
static Object strlit2848;
static Object strlit2878;
static Object strlit2885;
static Object strlit2892;
static Object strlit2920;
static Object strlit2931;
static Object strlit2936;
static Object strlit2941;
static Object strlit2944;
static Object strlit2978;
static Object strlit3015;
static Object strlit3026;
static Object strlit3031;
static Object strlit3058;
static Object strlit3082;
static Object strlit3087;
static Object strlit3098;
static Object strlit3103;
static Object strlit3122;
static Object strlit3125;
static Object strlit3136;
static Object strlit3139;
static Object strlit3142;
static Object strlit3153;
static Object strlit3157;
static Object strlit3169;
static Object strlit3177;
static Object strlit3196;
static Object strlit3203;
static Object strlit3210;
static Object strlit3213;
static Object strlit3221;
static Object strlit3233;
static Object strlit3236;
static Object strlit3265;
static Object strlit3272;
static Object strlit3279;
static Object strlit3285;
static Object strlit3312;
static Object strlit3335;
static Object strlit3356;
static Object strlit3367;
static Object strlit3378;
static Object strlit3389;
static Object strlit3400;
static Object strlit3414;
static Object strlit3446;
static Object strlit3452;
static Object strlit3462;
static Object strlit3469;
static Object strlit3473;
static Object strlit3488;
static Object strlit3498;
static Object strlit3505;
static Object strlit3509;
static Object strlit3533;
static Object strlit3540;
static Object strlit3549;
static Object strlit3555;
static Object strlit3570;
static Object strlit3577;
static Object strlit3595;
static Object strlit3603;
static Object strlit3618;
static Object strlit3622;
static Object strlit3628;
static Object strlit3632;
static Object strlit3642;
static Object strlit3646;
static Object strlit3651;
static Object strlit3657;
static Object strlit3660;
static Object strlit3663;
static Object strlit3695;
static Object strlit3702;
static Object strlit3709;
static Object strlit3712;
static Object strlit3720;
static Object strlit3732;
static Object strlit3735;
static Object strlit3757;
static Object strlit3764;
static Object strlit3774;
static Object strlit3780;
static Object strlit3799;
static Object strlit3806;
static Object strlit3813;
static Object strlit3816;
static Object strlit3824;
static Object strlit3836;
static Object strlit3839;
static Object strlit3865;
static Object strlit3870;
static Object strlit3879;
static Object strlit3889;
static Object strlit3894;
static Object strlit3899;
static Object strlit3904;
static Object strlit3919;
static Object strlit3926;
static Object strlit3934;
static Object strlit3938;
static Object strlit3941;
static Object strlit3943;
static Object strlit3960;
static Object strlit3967;
static Object strlit3974;
static Object strlit3980;
static Object strlit3999;
static Object strlit4006;
static Object strlit4013;
static Object strlit4016;
static Object strlit4024;
static Object strlit4036;
static Object strlit4039;
static Object strlit4065;
static Object strlit4070;
static Object strlit4079;
static Object strlit4089;
static Object strlit4094;
static Object strlit4099;
static Object strlit4104;
static Object strlit4125;
static Object strlit4132;
static Object strlit4141;
static Object strlit4144;
static Object strlit4146;
static Object strlit4152;
static Object strlit4158;
static Object strlit4173;
static Object strlit4180;
static Object strlit4198;
static Object strlit4206;
static Object strlit4221;
static Object strlit4225;
static Object strlit4231;
static Object strlit4235;
static Object strlit4245;
static Object strlit4249;
static Object strlit4254;
static Object strlit4260;
static Object strlit4263;
static Object strlit4266;
static Object strlit4298;
static Object strlit4305;
static Object strlit4312;
static Object strlit4315;
static Object strlit4323;
static Object strlit4335;
static Object strlit4338;
static Object strlit4360;
static Object strlit4367;
static Object strlit4377;
static Object strlit4383;
static Object strlit4402;
static Object strlit4409;
static Object strlit4416;
static Object strlit4419;
static Object strlit4427;
static Object strlit4439;
static Object strlit4442;
static Object strlit4468;
static Object strlit4473;
static Object strlit4482;
static Object strlit4492;
static Object strlit4497;
static Object strlit4502;
static Object strlit4507;
static Object strlit4522;
static Object strlit4529;
static Object strlit4536;
static Object strlit4542;
static Object strlit4561;
static Object strlit4568;
static Object strlit4575;
static Object strlit4578;
static Object strlit4586;
static Object strlit4598;
static Object strlit4601;
static Object strlit4627;
static Object strlit4632;
static Object strlit4641;
static Object strlit4651;
static Object strlit4656;
static Object strlit4661;
static Object strlit4666;
static Object strlit4687;
static Object strlit4694;
static Object strlit4703;
static Object strlit4718;
static Object strlit4725;
static Object strlit4742;
static Object strlit4757;
static Object strlit4761;
static Object strlit4771;
static Object strlit4774;
static Object strlit4778;
static Object strlit4784;
static Object strlit4787;
static Object strlit4793;
static Object strlit4821;
static Object strlit4828;
static Object strlit4835;
static Object strlit4838;
static Object strlit4848;
static Object strlit4860;
static Object strlit4863;
static Object strlit4883;
static Object strlit4890;
static Object strlit4900;
static Object strlit4906;
static Object strlit4925;
static Object strlit4932;
static Object strlit4939;
static Object strlit4942;
static Object strlit4950;
static Object strlit4962;
static Object strlit4965;
static Object strlit4991;
static Object strlit4996;
static Object strlit5005;
static Object strlit5015;
static Object strlit5020;
static Object strlit5025;
static Object strlit5030;
static Object strlit5052;
static Object strlit5058;
static Object strlit5064;
static Object strlit5071;
static Object strlit5078;
static Object strlit5086;
static Object strlit5093;
static Object strlit5101;
static Object strlit5108;
static Object strlit5115;
static Object strlit5122;
static Object strlit5129;
static Object strlit5139;
static Object strlit5146;
static Object strlit5153;
static Object strlit5159;
static Object strlit5165;
static Object strlit5174;
static Object strlit5194;
static Object strlit5201;
static Object strlit5208;
static Object strlit5211;
static Object strlit5219;
static Object strlit5231;
static Object strlit5234;
static Object strlit5267;
static Object strlit5289;
static Object strlit5296;
static Object strlit5303;
static Object strlit5309;
static Object strlit5326;
static Object strlit5336;
static Object strlit5346;
static Object strlit5349;
static Object strlit5377;
static Object strlit5383;
static Object strlit5404;
static Object strlit5414;
static Object strlit5422;
static Object strlit5429;
static Object strlit5451;
static Object strlit5457;
static Object strlit5463;
static Object strlit5468;
static Object strlit5487;
static Object strlit5498;
static Object strlit5501;
static Object strlit5513;
static Object strlit5518;
static Object strlit5529;
static Object strlit5582;
static Object strlit5601;
static Object strlit5608;
static Object strlit5615;
static Object strlit5618;
static Object strlit5626;
static Object strlit5638;
static Object strlit5641;
static Object strlit5676;
static Object strlit5693;
static Object strlit5704;
static Object strlit5710;
static Object strlit5739;
static Object strlit5740;
static Object strlit5741;
static Object strlit5742;
static Object strlit5749;
static Object strlit5756;
static Object strlit5775;
static Object strlit5781;
static Object strlit5850;
static Object strlit5859;
static Object strlit5867;
static Object strlit5881;
static Object strlit5888;
static Object strlit5893;
static Object strlit5898;
static Object strlit5903;
static Object strlit5908;
static Object strlit5912;
static Object strlit5936;
static Object strlit5941;
static Object strlit5961;
static Object strlit5968;
static Object strlit5978;
static Object strlit6001;
static Object strlit6014;
static Object strlit6027;
static Object strlit6035;
static Object strlit6045;
static Object strlit6052;
static Object strlit6056;
static Object strlit6071;
static Object strlit6101;
static Object strlit6108;
static Object strlit6119;
static Object strlit6133;
static Object strlit6159;
static Object strlit6187;
static Object strlit6194;
static Object strlit6201;
static Object strlit6219;
static Object strlit6235;
static Object strlit6265;
static Object strlit6272;
static Object strlit6279;
static Object strlit6297;
static Object strlit6305;
static Object strlit6312;
static Object strlit6323;
static Object strlit6337;
static Object strlit6361;
static Object strlit6389;
static Object strlit6396;
static Object strlit6403;
static Object strlit6421;
static Object strlit6446;
static Object strlit6458;
static Object strlit6461;
static Object strlit6497;
static Object strlit6509;
static Object strlit6516;
static Object strlit6524;
static Object strlit6530;
static Object strlit6535;
static Object strlit6539;
static Object strlit6563;
static Object strlit6572;
static Object strlit6583;
static Object strlit6599;
static Object strlit6613;
static Object strlit6629;
static Object strlit6668;
static Object strlit6672;
static Object strlit6686;
static Object strlit6710;
static Object strlit6717;
static Object strlit6724;
static Object strlit6730;
static Object strlit6742;
static Object strlit6751;
static Object strlit6757;
static Object strlit6763;
static Object strlit6767;
static Object strlit6775;
static Object strlit6779;
static Object strlit6786;
static Object strlit6794;
static Object strlit6798;
static Object strlit6801;
static Object strlit6809;
static Object strlit6813;
static Object strlit6816;
static Object strlit6823;
static Object strlit6826;
static Object strlit6837;
static Object strlit6844;
static Object strlit6852;
static Object strlit6858;
static Object strlit6863;
static Object strlit6867;
static Object strlit6879;
static Object strlit6889;
static Object strlit6910;
static Object strlit6917;
static Object strlit6924;
static Object strlit6942;
static Object strlit6952;
static Object strlit6982;
static Object strlit6989;
static Object strlit6996;
static Object strlit7014;
static Object strlit7037;
static Object strlit7049;
static Object strlit7052;
static Object strlit7069;
static Object strlit7094;
static Object strlit7101;
static Object strlit7112;
static Object strlit7135;
static Object strlit7142;
static Object strlit7157;
static Object strlit7164;
static Object strlit7171;
static Object strlit7174;
static Object strlit7184;
static Object strlit7193;
static Object strlit7207;
static Object strlit7214;
static Object strlit7240;
static Object strlit7247;
static Object strlit7250;
static Object strlit7266;
static Object strlit7274;
static Object strlit7284;
static Object strlit7289;
static Object strlit7307;
static Object strlit7317;
static Object strlit7323;
static Object strlit7325;
static Object strlit7352;
static Object strlit7359;
static Object strlit7367;
static Object strlit7381;
static Object strlit7388;
static Object strlit7396;
static Object strlit7420;
static Object strlit7425;
static Object strlit7441;
static Object strlit7448;
static Object strlit7459;
static Object strlit7481;
static Object strlit7503;
static Object strlit7510;
static Object strlit7513;
static Object strlit7523;
static Object strlit7532;
static Object strlit7545;
static Object strlit7571;
static Object strlit7578;
static Object strlit7597;
static Object strlit7599;
static Object strlit7617;
static Object strlit7624;
static Object strlit7633;
static Object strlit7643;
static Object strlit7648;
static Object strlit7676;
static Object strlit7683;
static Object strlit7691;
static Object strlit7705;
static Object strlit7712;
static Object strlit7720;
static Object strlit7744;
static Object strlit7749;
static Object strlit7759;
static Object strlit7772;
static Object strlit7789;
static Object strlit7817;
static Object strlit7824;
static Object strlit7831;
static Object strlit7849;
static Object strlit7866;
static Object strlit7876;
static Object strlit7879;
static Object strlit7902;
static Object strlit7909;
static Object strlit7916;
static Object strlit7936;
static Object strlit7944;
static Object strlit7950;
static Object strlit7958;
static Object strlit7973;
static Object strlit7991;
static Object strlit7998;
static Object strlit8021;
static Object strlit8028;
static Object strlit8035;
static Object strlit8053;
static Object strlit8080;
static Object strlit8087;
static Object strlit8095;
static Object strlit8108;
static Object strlit8121;
static Object strlit8124;
static Object strlit8127;
static ClassData objclass8139;
static Object strlit8143;
static Object strlit8144;
static Object strlit8177;
static Object strlit8191;
static Object strlit8198;
static Object strlit8208;
static Object strlit8211;
static Object strlit8225;
static Object strlit8244;
static Object strlit8275;
static Object strlit8317;
static Object strlit8324;
static Object strlit8331;
static Object strlit8339;
static Object strlit8349;
static Object strlit8359;
static Object strlit8368;
static Object strlit8373;
static Object strlit8390;
static Object strlit8404;
static Object strlit8412;
static Object strlit8415;
static Object strlit8447;
static Object strlit8455;
static Object strlit8458;
static Object strlit8503;
static Object strlit8595;
static Object strlit8600;
static Object strlit8615;
static Object strlit8622;
static Object strlit8647;
static ClassData objclass8675;
static Object strlit8679;
static Object strlit8680;
static Object strlit8690;
static Object strlit8709;
static Object strlit8735;
static Object strlit8746;
static Object strlit8751;
static Object strlit8781;
static Object strlit8793;
static Object strlit8796;
static Object strlit8800;
static Object strlit8804;
static Object strlit8840;
static Object strlit8845;
static Object strlit8867;
static Object strlit8872;
static Object strlit8883;
static Object strlit8910;
static Object strlit8918;
static Object strlit8921;
static Object strlit8936;
static Object strlit8943;
static Object strlit8948;
static Object strlit8956;
static Object strlit8964;
static Object strlit8975;
static Object strlit9003;
static Object strlit9021;
static Object strlit9039;
static Object strlit9049;
static Object strlit9052;
static Object strlit9069;
static Object strlit9078;
static Object strlit9088;
static Object strlit9091;
static Object strlit9117;
static Object strlit9125;
static Object strlit9132;
static Object strlit9144;
static Object strlit9147;
static Object strlit9174;
static Object strlit9181;
static Object strlit9192;
static Object strlit9209;
static Object strlit9229;
static Object strlit9235;
static Object strlit9255;
static Object strlit9261;
static Object strlit9268;
static Object strlit9284;
static Object strlit9287;
static Object strlit9301;
static Object strlit9305;
static Object strlit9316;
static Object strlit9329;
static Object strlit9337;
static Object strlit9347;
static Object strlit9350;
static Object strlit9365;
static Object strlit9371;
static Object strlit9379;
static Object strlit9388;
static Object strlit9395;
static Object strlit9423;
static Object strlit9438;
static Object strlit9445;
static Object strlit9450;
static Object strlit9458;
static Object strlit9464;
static Object strlit9475;
static Object strlit9503;
static Object strlit9527;
static Object strlit9550;
static Object strlit9566;
static Object strlit9579;
static Object strlit9601;
static Object strlit9617;
static Object strlit9625;
static Object strlit9631;
static Object strlit9642;
static Object strlit9655;
static Object strlit9658;
static Object strlit9675;
static Object strlit9682;
static Object strlit9689;
static Object strlit9699;
static Object strlit9702;
static Object strlit9717;
static Object strlit9739;
static Object strlit9753;
static Object strlit9758;
static Object strlit9788;
static Object strlit9793;
static Object strlit9817;
static ClassData objclass9828;
static Object strlit9840;
static Object strlit9847;
static Object strlit9856;
static Object strlit9876;
static Object strlit9884;
static Object strlit9890;
static Object strlit9898;
static Object strlit9913;
static Object strlit9924;
static Object strlit9931;
static Object strlit9952;
static Object strlit9959;
static Object strlit9963;
static Object strlit9969;
static Object strlit9974;
static Object strlit9993;
static Object strlit10013;
static Object strlit10021;
static Object strlit10027;
static Object strlit10036;
static Object strlit10042;
static Object strlit10059;
static Object strlit10079;
static Object strlit10095;
static Object strlit10102;
static Object strlit10126;
static Object strlit10133;
static Object strlit10151;
static Object strlit10169;
static Object strlit10190;
static Object strlit10220;
static Object strlit10240;
static Object strlit10247;
static Object strlit10294;
static Object strlit10306;
static Object strlit10313;
static Object strlit10321;
static Object strlit10329;
static Object strlit10332;
static Object strlit10351;
static Object strlit10369;
static Object strlit10373;
static Object strlit10388;
static Object strlit10395;
static Object strlit10402;
static Object strlit10412;
static Object strlit10415;
static Object strlit10439;
static Object strlit10455;
static Object strlit10462;
static Object strlit10476;
static Object strlit10497;
static Object strlit10502;
static Object strlit10505;
static Object strlit10525;
static Object strlit10534;
static Object strlit10575;
static Object strlit10642;
static Object strlit10650;
static Object strlit10658;
static Object strlit10665;
static Object strlit10674;
static Object strlit10717;
static Object strlit10761;
static Object strlit10772;
static Object strlit10779;
static Object strlit10795;
static Object strlit10799;
static Object strlit10825;
static Object strlit10829;
static Object strlit10838;
static Object strlit10847;
static Object strlit10856;
static Object strlit10865;
static Object strlit10874;
static Object strlit10883;
static Object strlit10903;
static Object strlit10908;
static Object strlit10918;
static Object strlit10927;
static Object strlit10957;
static Object strlit10964;
static Object strlit10971;
static Object strlit10989;
static Object strlit11007;
static Object strlit11012;
static Object strlit11031;
static Object strlit11041;
static Object strlit11044;
static Object strlit11054;
static Object strlit11064;
static Object strlit11067;
static Object strlit11078;
static Object strlit11088;
static Object strlit11091;
static Object strlit11111;
static Object strlit11119;
static Object strlit11126;
static Object strlit11141;
static Object strlit11152;
static Object strlit11157;
static Object strlit11167;
static Object strlit11177;
static Object strlit11184;
static Object strlit11194;
static Object strlit11208;
static Object strlit11218;
static Object strlit11227;
static Object strlit11253;
static Object strlit11259;
static Object strlit11291;
static Object strlit11297;
static Object strlit11302;
static Object strlit11310;
static Object strlit11326;
static Object strlit11332;
static Object strlit11339;
static Object strlit11413;
static Object strlit11421;
static Object strlit11427;
static Object strlit11432;
static Object strlit11438;
static Object strlit11444;
static Object strlit11451;
static Object strlit11456;
static Object strlit11463;
static Object strlit11468;
static Object strlit11475;
static Object strlit11480;
static ClassData objclass11500;
static Object strlit11510;
static Object strlit11529;
static Object strlit11535;
static Object strlit11580;
Object module_io;
Object module_io_init();
Object module_ast;
Object module_ast_init();
Object module_util;
Object module_util_init();
Object module_mgcollections;
Object module_mgcollections_init();
Object module_errormessages;
Object module_errormessages_init();
static Object strlit11654;
static Object strlit11658;
static Object strlit11662;
static ClassData objclass11669;
static Object strlit11677;
static Object strlit11681;
Object meth_parser__apply30(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object num32 = alloc_Float64(0);
// compilenode returning num32
  int op_slot_right_31 = gc_frame_newslot(num32);
  int callframe34 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call35 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe34);
// compilenode returning call35
// compilenode returning call35
  int op_slot_left_31 = gc_frame_newslot(call35);
  params[0] = num32;
  partcv[0] = 1;
  Object opresult36 = callmethod(call35, ">", 1, partcv, params);
// compilenode returning opresult36
  gc_frame_end(frame);
  return opresult36;
}
Object meth_parser__apply27(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe28 = gc_frame_new();
  Object block29 = alloc_Block(NULL, NULL, "parser", 48);
  gc_frame_newslot(block29);
  block_savedest(block29);
  Object closure30 = createclosure(2, "_apply");
setclosureframe(closure30, stackframe);
  addtoclosure(closure30, var_tokens);
  addtoclosure(closure30, selfslot);
  struct UserObject *uo30 = (struct UserObject*)block29;
  uo30->data[0] = (Object)closure30;
  Method *meth_meth_parser__apply30 = addmethod2pos(block29, "_apply", &meth_parser__apply30, 0);
int argcv_meth_parser__apply30[] = {0};
meth_meth_parser__apply30->type = alloc_MethodType(1, argcv_meth_parser__apply30);
  meth_meth_parser__apply30->definitionModule = modulename;
  meth_meth_parser__apply30->definitionLine = 46;
// compilenode returning block29
  gc_frame_newslot(block29);
  if (strlit39 == NULL) {
    strlit39 = alloc_String("comment");
    gc_root(strlit39);
  }
// compilenode returning strlit39
  int op_slot_right_38 = gc_frame_newslot(strlit39);
  int callframe41 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call42 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe41);
// compilenode returning call42
// compilenode returning call42
  int op_slot_left_38 = gc_frame_newslot(call42);
  params[0] = strlit39;
  partcv[0] = 1;
  Object opresult43 = callmethod(call42, "==", 1, partcv, params);
// compilenode returning opresult43
  params[0] = block29;
  partcv[0] = 1;
  Object call44 = callmethod(opresult43, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe28);
// compilenode returning call44
  gc_frame_end(frame);
  return call44;
}
Object meth_parser__apply47(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_comment = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 49
  setline(49);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe49 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call50 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe49);
// compilenode returning call50
// compilenode returning call50
  int op_slot_right_48 = gc_frame_newslot(call50);
// compilenode returning *var_comment
  int op_slot_left_48 = gc_frame_newslot(*var_comment);
  params[0] = call50;
  partcv[0] = 1;
  Object opresult52 = callmethod(*var_comment, "++", 1, partcv, params);
// compilenode returning opresult52
  *var_comment = opresult52;
  if (opresult52 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe54 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call55 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe54);
// compilenode returning call55
// compilenode returning call55
  *var_sym = call55;
  if (call55 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_next0(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_tokens = getfromclosure(closure, 2);
  Object *var_linenum = getfromclosure(closure, 3);
  Object *var_lastline = getfromclosure(closure, 4);
  Object *var_lastIndent = getfromclosure(closure, 5);
  Object *var_comment = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_lastToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 65
  setline(65);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4 = alloc_Float64(0);
// compilenode returning num4
  int op_slot_right_3 = gc_frame_newslot(num4);
  int callframe6 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call7 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe6);
// compilenode returning call7
// compilenode returning call7
  int op_slot_left_3 = gc_frame_newslot(call7);
  params[0] = num4;
  partcv[0] = 1;
  Object opresult8 = callmethod(call7, ">", 1, partcv, params);
// compilenode returning opresult8
  Object if2 = done;
  if (istrue(opresult8)) {
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  *var_lastline = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 44
  setline(44);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10);
// compilenode returning call11
// compilenode returning call11
  *var_lastIndent = call11;
  if (call11 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 45
  setline(45);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe13 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call14 = callmethod(*var_tokens, "poll",
    1, partcv, params);
  gc_frame_end(callframe13);
// compilenode returning call14
// compilenode returning call14
  *var_sym = call14;
  if (call14 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit18 == NULL) {
    strlit18 = alloc_String("comment");
    gc_root(strlit18);
  }
// compilenode returning strlit18
  int op_slot_right_17 = gc_frame_newslot(strlit18);
  int callframe20 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call21 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe20);
// compilenode returning call21
// compilenode returning call21
  int op_slot_left_17 = gc_frame_newslot(call21);
  params[0] = strlit18;
  partcv[0] = 1;
  Object opresult22 = callmethod(call21, "==", 1, partcv, params);
// compilenode returning opresult22
  Object if16 = done;
  if (istrue(opresult22)) {
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 47
  setline(47);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit23 == NULL) {
    strlit23 = alloc_String("");
    gc_root(strlit23);
  }
// compilenode returning strlit23
  *var_comment = strlit23;
  if (strlit23 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 48
  setline(48);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe25 = gc_frame_new();
  Object block26 = alloc_Block(NULL, NULL, "parser", 48);
  gc_frame_newslot(block26);
  block_savedest(block26);
  Object closure27 = createclosure(3, "_apply");
setclosureframe(closure27, stackframe);
  addtoclosure(closure27, var_tokens);
  addtoclosure(closure27, var_sym);
  addtoclosure(closure27, selfslot);
  struct UserObject *uo27 = (struct UserObject*)block26;
  uo27->data[0] = (Object)closure27;
  Method *meth_meth_parser__apply27 = addmethod2pos(block26, "_apply", &meth_parser__apply27, 0);
int argcv_meth_parser__apply27[] = {0};
meth_meth_parser__apply27->type = alloc_MethodType(1, argcv_meth_parser__apply27);
  meth_meth_parser__apply27->definitionModule = modulename;
  meth_meth_parser__apply27->definitionLine = 46;
// compilenode returning block26
  gc_frame_newslot(block26);
  Object block46 = alloc_Block(NULL, NULL, "parser", 48);
  gc_frame_newslot(block46);
  block_savedest(block46);
  Object closure47 = createclosure(4, "_apply");
setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_sym);
  addtoclosure(closure47, var_comment);
  addtoclosure(closure47, var_tokens);
  addtoclosure(closure47, selfslot);
  struct UserObject *uo47 = (struct UserObject*)block46;
  uo47->data[0] = (Object)closure47;
  Method *meth_meth_parser__apply47 = addmethod2pos(block46, "_apply", &meth_parser__apply47, 0);
int argcv_meth_parser__apply47[] = {0};
meth_meth_parser__apply47->type = alloc_MethodType(1, argcv_meth_parser__apply47);
  meth_meth_parser__apply47->definitionModule = modulename;
  meth_meth_parser__apply47->definitionLine = 48;
// compilenode returning block46
  gc_frame_newslot(block46);
  params[0] = block26;
  params[1] = block46;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call58 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe25);
// compilenode returning call58
    gc_frame_newslot(call58);
    if16 = call58;
  } else {
  }
// compilenode returning if16
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 53
  setline(53);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe59 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call60 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe59);
// compilenode returning call60
// compilenode returning call60
  *var_linenum = call60;
  if (call60 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe62 = gc_frame_new();
  int callframe63 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call64 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe63);
// compilenode returning call64
// compilenode returning call64
  gc_frame_newslot(call64);
  int callframe65 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call66 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe65);
// compilenode returning call66
// compilenode returning call66
  gc_frame_newslot(call66);
// compilenode returning *var_util
  params[0] = call64;
  params[1] = call66;
  partcv[0] = 2;
  Object call67 = callmethod(*var_util, "setPosition",
    1, partcv, params);
  gc_frame_end(callframe62);
// compilenode returning call67
    gc_frame_newslot(call67);
    if2 = call67;
  } else {
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject68 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj68 = alloc_userobj2(11,7, objclass68);
  gc_frame_newslot(obj68);
// OBJECT OUTER DEC outer
  adddatum2(obj68, self, 0);
  addmethodreal(obj68,"outer", &reader_parser_outer_69);
  Object oldself68 = self;
  struct StackFrameObject *oldstackframe68 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe68);
  gc_frame_newslot((Object)stackframe);
  self = obj68;
  Object *oldselfslot68 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter68 = (*(struct UserObject *)self).data[0], lowerouter68 = thisouter68;
  if (inheritingObject68) {
    struct UserObject *inho68 = (struct UserObject *)inheritingObject68;
    while (inho68->super != GraceDefaultObject) inho68 = (struct UserObject *)inho68->super;
    inho68->super = obj68;
    self = inheritingObject68;
    *selfslot = self;
    lowerouter68 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter68;
  }
if (objclass68 == NULL) {
  Method *reader70 = addmethodrealflags(obj68, "kind",&reader_parser_kind_70, 0);
  Method *writer70 = addmethodrealflags(obj68, "kind:=",&writer_parser_kind_70, 0);
  reader70->definitionModule = modulename;
  writer70->definitionModule = modulename;
  reader70->definitionLine = 58;
  writer70->definitionLine = 58;
}
obj68->flags |= OFLAG_MUTABLE;
adddatum2(obj68, alloc_Undefined(), 1);
if (objclass68 == NULL) {
  Method *reader71 = addmethodrealflags(obj68, "line",&reader_parser_line_71, 0);
  Method *writer71 = addmethodrealflags(obj68, "line:=",&writer_parser_line_71, 0);
  reader71->definitionModule = modulename;
  writer71->definitionModule = modulename;
  reader71->definitionLine = 59;
  writer71->definitionLine = 59;
}
obj68->flags |= OFLAG_MUTABLE;
adddatum2(obj68, alloc_Undefined(), 2);
if (objclass68 == NULL) {
  Method *reader72 = addmethodrealflags(obj68, "linePos",&reader_parser_linePos_72, 0);
  Method *writer72 = addmethodrealflags(obj68, "linePos:=",&writer_parser_linePos_72, 0);
  reader72->definitionModule = modulename;
  writer72->definitionModule = modulename;
  reader72->definitionLine = 60;
  writer72->definitionLine = 60;
}
obj68->flags |= OFLAG_MUTABLE;
adddatum2(obj68, alloc_Undefined(), 3);
if (objclass68 == NULL) {
  Method *reader73 = addmethodrealflags(obj68, "indent",&reader_parser_indent_73, 0);
  Method *writer73 = addmethodrealflags(obj68, "indent:=",&writer_parser_indent_73, 0);
  reader73->definitionModule = modulename;
  writer73->definitionModule = modulename;
  reader73->definitionLine = 61;
  writer73->definitionLine = 61;
}
obj68->flags |= OFLAG_MUTABLE;
adddatum2(obj68, alloc_Undefined(), 4);
if (objclass68 == NULL) {
  Method *reader74 = addmethodrealflags(obj68, "value",&reader_parser_value_74, 0);
  Method *writer74 = addmethodrealflags(obj68, "value:=",&writer_parser_value_74, 0);
  reader74->definitionModule = modulename;
  writer74->definitionModule = modulename;
  reader74->definitionLine = 62;
  writer74->definitionLine = 62;
}
obj68->flags |= OFLAG_MUTABLE;
adddatum2(obj68, alloc_Undefined(), 5);
if (objclass68 == NULL) {
  Method *reader75 = addmethodrealflags(obj68, "size",&reader_parser_size_75, MFLAG_DEF);
  reader75->definitionModule = modulename;
  reader75->definitionLine = 63;
}
adddatum2(obj68, alloc_Undefined(), 6);
  sourceObject = obj68;
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit76 == NULL) {
    strlit76 = alloc_String("eof");
    gc_root(strlit76);
  }
// compilenode returning strlit76
  adddatum2(obj68, strlit76, 1);
  sourceObject = obj68;
// Begin line 58
  setline(58);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe77 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call78 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe77);
// compilenode returning call78
// compilenode returning call78
  adddatum2(obj68, call78, 2);
  sourceObject = obj68;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 59
  setline(59);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num80 = alloc_Float64(1);
// compilenode returning num80
  int op_slot_right_79 = gc_frame_newslot(num80);
  int callframe82 = gc_frame_new();
  int callframe83 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call84 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe83);
// compilenode returning call84
// compilenode returning call84
  int callframe85 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call86 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe85);
// compilenode returning call86
// compilenode returning call86
  params[0] = call86;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres87 = callmethod(call84, "[]", 1, partcv, params);
// compilenode returning idxres87
  partcv[0] = 0;
  Object call88 = callmethod(idxres87, "size",
    1, partcv, params);
  gc_frame_end(callframe82);
// compilenode returning call88
// compilenode returning call88
  int op_slot_left_79 = gc_frame_newslot(call88);
  params[0] = num80;
  partcv[0] = 1;
  Object sum89 = callmethod(call88, "+", 1, partcv, params);
// compilenode returning sum89
  adddatum2(obj68, sum89, 3);
  sourceObject = obj68;
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num90 = alloc_Float64(0);
// compilenode returning num90
  adddatum2(obj68, num90, 4);
  sourceObject = obj68;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit91 == NULL) {
    strlit91 = alloc_String("");
    gc_root(strlit91);
  }
// compilenode returning strlit91
  adddatum2(obj68, strlit91, 5);
  sourceObject = obj68;
// Begin line 62
  setline(62);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num92 = alloc_Float64(0);
// compilenode returning num92
  adddatum2(obj68, num92, 6);
objclass68 = obj68->class;
  objclass68->definitionModule = modulename;
  objclass68->definitionLine = 56;
  (*(struct UserObject *)self).data[0] = lowerouter68;
  self = oldself68;
  selfslot = oldselfslot68;
  stackframe = oldstackframe68;
// compilenode returning obj68
  *var_sym = obj68;
  if (obj68 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2 = done;
  }
// compilenode returning if2
  gc_frame_end(frame);
  return if2;
}
Object meth_parser__apply104(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe106 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call107 = callmethod(*var_lastToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe106);
// compilenode returning call107
// compilenode returning call107
  int op_slot_right_105 = gc_frame_newslot(call107);
  int callframe109 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call110 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe109);
// compilenode returning call110
// compilenode returning call110
  int op_slot_left_105 = gc_frame_newslot(call110);
  params[0] = call107;
  partcv[0] = 1;
  Object opresult111 = callmethod(call110, ">=", 1, partcv, params);
// compilenode returning opresult111
  gc_frame_end(frame);
  return opresult111;
}
Object meth_parser__apply115(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object bool117 = alloc_Boolean(0);
// compilenode returning bool117
  int op_slot_right_116 = gc_frame_newslot(bool117);
// compilenode returning *var_nextTok
  int op_slot_left_116 = gc_frame_newslot(*var_nextTok);
  params[0] = bool117;
  partcv[0] = 1;
  Object opresult119 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult119
  gc_frame_end(frame);
  return opresult119;
}
Object meth_parser__apply101(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe102 = gc_frame_new();
  Object block103 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block103);
  block_savedest(block103);
  Object closure104 = createclosure(3, "_apply");
setclosureframe(closure104, stackframe);
  addtoclosure(closure104, var_lastToken);
  addtoclosure(closure104, var_n);
  addtoclosure(closure104, selfslot);
  struct UserObject *uo104 = (struct UserObject*)block103;
  uo104->data[0] = (Object)closure104;
  Method *meth_meth_parser__apply104 = addmethod2pos(block103, "_apply", &meth_parser__apply104, 0);
int argcv_meth_parser__apply104[] = {0};
meth_meth_parser__apply104->type = alloc_MethodType(1, argcv_meth_parser__apply104);
  meth_meth_parser__apply104->definitionModule = modulename;
  meth_meth_parser__apply104->definitionLine = 59;
// compilenode returning block103
  gc_frame_newslot(block103);
  int callframe113 = gc_frame_new();
  Object block114 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block114);
  block_savedest(block114);
  Object closure115 = createclosure(2, "_apply");
setclosureframe(closure115, stackframe);
  addtoclosure(closure115, var_nextTok);
  addtoclosure(closure115, selfslot);
  struct UserObject *uo115 = (struct UserObject*)block114;
  uo115->data[0] = (Object)closure115;
  Method *meth_meth_parser__apply115 = addmethod2pos(block114, "_apply", &meth_parser__apply115, 0);
int argcv_meth_parser__apply115[] = {0};
meth_meth_parser__apply115->type = alloc_MethodType(1, argcv_meth_parser__apply115);
  meth_meth_parser__apply115->definitionModule = modulename;
  meth_meth_parser__apply115->definitionLine = 75;
// compilenode returning block114
  gc_frame_newslot(block114);
  Object bool122 = alloc_Boolean(0);
// compilenode returning bool122
  int op_slot_right_121 = gc_frame_newslot(bool122);
// compilenode returning *var_n
  int op_slot_left_121 = gc_frame_newslot(*var_n);
  params[0] = bool122;
  partcv[0] = 1;
  Object opresult124 = callmethod(*var_n, "!=", 1, partcv, params);
// compilenode returning opresult124
  params[0] = block114;
  partcv[0] = 1;
  Object call125 = callmethod(opresult124, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe113);
// compilenode returning call125
  params[0] = block103;
  partcv[0] = 1;
  Object call126 = callmethod(call125, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe102);
// compilenode returning call126
  gc_frame_end(frame);
  return call126;
}
Object meth_parser__apply129(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_tokenMatcher = getfromclosure(closure, 1);
  Object *var_nextTok = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe131 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_tokenMatcher
  params[0] = *var_n;
  partcv[0] = 1;
  Object call132 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe131);
// compilenode returning call132
  Object if130 = done;
  if (istrue(call132)) {
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if130 = done;
  } else {
  }
// compilenode returning if130
// Begin line 80
  setline(80);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe134 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call135 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe134);
// compilenode returning call135
// compilenode returning call135
  *var_n = call135;
  if (call135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextToken94(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tokenMatcher = &(stackframe->slots[0]);
  *var_tokenMatcher = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for findNextToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 70
  setline(70);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe96 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_tokenMatcher
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call97 = callmethod(*var_tokenMatcher, "apply",
    1, partcv, params);
  gc_frame_end(callframe96);
// compilenode returning call97
  Object if95 = done;
  if (istrue(call97)) {
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 71
  setline(71);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  return *var_sym;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if95 = undefined;
  } else {
  }
// compilenode returning if95
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool98 = alloc_Boolean(0);
// compilenode returning bool98
  *var_nextTok = bool98;
  if (bool98 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 74
  setline(74);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe99 = gc_frame_new();
  Object block100 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block100);
  block_savedest(block100);
  Object closure101 = createclosure(4, "_apply");
setclosureframe(closure101, stackframe);
  addtoclosure(closure101, var_lastToken);
  addtoclosure(closure101, var_n);
  addtoclosure(closure101, var_nextTok);
  addtoclosure(closure101, selfslot);
  struct UserObject *uo101 = (struct UserObject*)block100;
  uo101->data[0] = (Object)closure101;
  Method *meth_meth_parser__apply101 = addmethod2pos(block100, "_apply", &meth_parser__apply101, 0);
int argcv_meth_parser__apply101[] = {0};
meth_meth_parser__apply101->type = alloc_MethodType(1, argcv_meth_parser__apply101);
  meth_meth_parser__apply101->definitionModule = modulename;
  meth_meth_parser__apply101->definitionLine = 59;
// compilenode returning block100
  gc_frame_newslot(block100);
  Object block128 = alloc_Block(NULL, NULL, "parser", 75);
  gc_frame_newslot(block128);
  block_savedest(block128);
  Object closure129 = createclosure(4, "_apply");
setclosureframe(closure129, stackframe);
  addtoclosure(closure129, var_n);
  addtoclosure(closure129, var_tokenMatcher);
  addtoclosure(closure129, var_nextTok);
  addtoclosure(closure129, selfslot);
  struct UserObject *uo129 = (struct UserObject*)block128;
  uo129->data[0] = (Object)closure129;
  Method *meth_meth_parser__apply129 = addmethod2pos(block128, "_apply", &meth_parser__apply129, 0);
int argcv_meth_parser__apply129[] = {0};
meth_meth_parser__apply129->type = alloc_MethodType(1, argcv_meth_parser__apply129);
  meth_meth_parser__apply129->definitionModule = modulename;
  meth_meth_parser__apply129->definitionLine = 75;
// compilenode returning block128
  gc_frame_newslot(block128);
  params[0] = block100;
  params[1] = block128;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call138 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe99);
// compilenode returning call138
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_nextTok
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply173(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object bool175 = alloc_Boolean(0);
// compilenode returning bool175
  int op_slot_right_174 = gc_frame_newslot(bool175);
// compilenode returning *var_nextTok
  int op_slot_left_174 = gc_frame_newslot(*var_nextTok);
  params[0] = bool175;
  partcv[0] = 1;
  Object opresult177 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult177
  gc_frame_end(frame);
  return opresult177;
}
Object meth_parser__apply170(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_nextTok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe171 = gc_frame_new();
  Object block172 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block172);
  block_savedest(block172);
  Object closure173 = createclosure(2, "_apply");
setclosureframe(closure173, stackframe);
  addtoclosure(closure173, var_nextTok);
  addtoclosure(closure173, selfslot);
  struct UserObject *uo173 = (struct UserObject*)block172;
  uo173->data[0] = (Object)closure173;
  Method *meth_meth_parser__apply173 = addmethod2pos(block172, "_apply", &meth_parser__apply173, 0);
int argcv_meth_parser__apply173[] = {0};
meth_meth_parser__apply173->type = alloc_MethodType(1, argcv_meth_parser__apply173);
  meth_meth_parser__apply173->definitionModule = modulename;
  meth_meth_parser__apply173->definitionLine = 85;
// compilenode returning block172
  gc_frame_newslot(block172);
  Object bool180 = alloc_Boolean(0);
// compilenode returning bool180
  int op_slot_right_179 = gc_frame_newslot(bool180);
// compilenode returning *var_n
  int op_slot_left_179 = gc_frame_newslot(*var_n);
  params[0] = bool180;
  partcv[0] = 1;
  Object opresult182 = callmethod(*var_n, "!=", 1, partcv, params);
// compilenode returning opresult182
  params[0] = block172;
  partcv[0] = 1;
  Object call183 = callmethod(opresult182, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe171);
// compilenode returning call183
  gc_frame_end(frame);
  return call183;
}
Object meth_parser__apply186(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_n = getfromclosure(closure, 2);
  Object *var_nextTok = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit190 == NULL) {
    strlit190 = alloc_String("eof");
    gc_root(strlit190);
  }
// compilenode returning strlit190
  int op_slot_right_189 = gc_frame_newslot(strlit190);
  int callframe192 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call193 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe192);
// compilenode returning call193
// compilenode returning call193
  int op_slot_left_189 = gc_frame_newslot(call193);
  params[0] = strlit190;
  partcv[0] = 1;
  Object opresult194 = callmethod(call193, "==", 1, partcv, params);
// compilenode returning opresult194
  int op_slot_right_188 = gc_frame_newslot(opresult194);
  int callframe198 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call199 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe198);
// compilenode returning call199
// compilenode returning call199
  int op_slot_right_197 = gc_frame_newslot(call199);
  int callframe201 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call202 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe201);
// compilenode returning call202
// compilenode returning call202
  int op_slot_left_197 = gc_frame_newslot(call202);
  params[0] = call199;
  partcv[0] = 1;
  Object opresult203 = callmethod(call202, "<=", 1, partcv, params);
// compilenode returning opresult203
  int op_slot_right_196 = gc_frame_newslot(opresult203);
  int callframe206 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call207 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe206);
// compilenode returning call207
// compilenode returning call207
  int op_slot_right_205 = gc_frame_newslot(call207);
  int callframe209 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call210 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe209);
// compilenode returning call210
// compilenode returning call210
  int op_slot_left_205 = gc_frame_newslot(call210);
  params[0] = call207;
  partcv[0] = 1;
  Object opresult211 = callmethod(call210, ">", 1, partcv, params);
// compilenode returning opresult211
  int op_slot_left_196 = gc_frame_newslot(opresult211);
  params[0] = opresult203;
  partcv[0] = 1;
  Object opresult212 = callmethod(opresult211, "&&", 1, partcv, params);
// compilenode returning opresult212
  int op_slot_left_188 = gc_frame_newslot(opresult212);
  params[0] = opresult194;
  partcv[0] = 1;
  Object opresult213 = callmethod(opresult212, "||", 1, partcv, params);
// compilenode returning opresult213
  Object if187 = done;
  if (istrue(opresult213)) {
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  *var_nextTok = *var_n;
  if (*var_n == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if187 = done;
  } else {
  }
// compilenode returning if187
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe215 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call216 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe215);
// compilenode returning call216
// compilenode returning call216
  *var_n = call216;
  if (call216 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextTokenIndentedAt139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextTokenIndentedAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextTokenIndentedAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for findNextTokenIndentedAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 85
  setline(85);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit143 == NULL) {
    strlit143 = alloc_String("eof");
    gc_root(strlit143);
  }
// compilenode returning strlit143
  int op_slot_right_142 = gc_frame_newslot(strlit143);
  int callframe145 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call146 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe145);
// compilenode returning call146
// compilenode returning call146
  int op_slot_left_142 = gc_frame_newslot(call146);
  params[0] = strlit143;
  partcv[0] = 1;
  Object opresult147 = callmethod(call146, "==", 1, partcv, params);
// compilenode returning opresult147
  int op_slot_right_141 = gc_frame_newslot(opresult147);
  int callframe151 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call152 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe151);
// compilenode returning call152
// compilenode returning call152
  int op_slot_right_150 = gc_frame_newslot(call152);
  int callframe154 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call155 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe154);
// compilenode returning call155
// compilenode returning call155
  int op_slot_left_150 = gc_frame_newslot(call155);
  params[0] = call152;
  partcv[0] = 1;
  Object opresult156 = callmethod(call155, "<=", 1, partcv, params);
// compilenode returning opresult156
  int op_slot_right_149 = gc_frame_newslot(opresult156);
  int callframe159 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call160 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe159);
// compilenode returning call160
// compilenode returning call160
  int op_slot_right_158 = gc_frame_newslot(call160);
  int callframe162 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call163 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe162);
// compilenode returning call163
// compilenode returning call163
  int op_slot_left_158 = gc_frame_newslot(call163);
  params[0] = call160;
  partcv[0] = 1;
  Object opresult164 = callmethod(call163, ">", 1, partcv, params);
// compilenode returning opresult164
  int op_slot_left_149 = gc_frame_newslot(opresult164);
  params[0] = opresult156;
  partcv[0] = 1;
  Object opresult165 = callmethod(opresult164, "&&", 1, partcv, params);
// compilenode returning opresult165
  int op_slot_left_141 = gc_frame_newslot(opresult165);
  params[0] = opresult147;
  partcv[0] = 1;
  Object opresult166 = callmethod(opresult165, "||", 1, partcv, params);
// compilenode returning opresult166
  Object if140 = done;
  if (istrue(opresult166)) {
// Begin line 87
  setline(87);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 86
  setline(86);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  return *var_sym;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if140 = undefined;
  } else {
  }
// compilenode returning if140
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 88
  setline(88);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool167 = alloc_Boolean(0);
// compilenode returning bool167
  *var_nextTok = bool167;
  if (bool167 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 89
  setline(89);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 90
  setline(90);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe168 = gc_frame_new();
  Object block169 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block169);
  block_savedest(block169);
  Object closure170 = createclosure(3, "_apply");
setclosureframe(closure170, stackframe);
  addtoclosure(closure170, var_nextTok);
  addtoclosure(closure170, var_n);
  addtoclosure(closure170, selfslot);
  struct UserObject *uo170 = (struct UserObject*)block169;
  uo170->data[0] = (Object)closure170;
  Method *meth_meth_parser__apply170 = addmethod2pos(block169, "_apply", &meth_parser__apply170, 0);
int argcv_meth_parser__apply170[] = {0};
meth_meth_parser__apply170->type = alloc_MethodType(1, argcv_meth_parser__apply170);
  meth_meth_parser__apply170->definitionModule = modulename;
  meth_meth_parser__apply170->definitionLine = 85;
// compilenode returning block169
  gc_frame_newslot(block169);
  Object block185 = alloc_Block(NULL, NULL, "parser", 90);
  gc_frame_newslot(block185);
  block_savedest(block185);
  Object closure186 = createclosure(5, "_apply");
setclosureframe(closure186, stackframe);
  addtoclosure(closure186, var_sym);
  addtoclosure(closure186, var_tok);
  addtoclosure(closure186, var_n);
  addtoclosure(closure186, var_nextTok);
  addtoclosure(closure186, selfslot);
  struct UserObject *uo186 = (struct UserObject*)block185;
  uo186->data[0] = (Object)closure186;
  Method *meth_meth_parser__apply186 = addmethod2pos(block185, "_apply", &meth_parser__apply186, 0);
int argcv_meth_parser__apply186[] = {0};
meth_meth_parser__apply186->type = alloc_MethodType(1, argcv_meth_parser__apply186);
  meth_meth_parser__apply186->definitionModule = modulename;
  meth_meth_parser__apply186->definitionLine = 85;
// compilenode returning block185
  gc_frame_newslot(block185);
  params[0] = block169;
  params[1] = block185;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call219 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe168);
// compilenode returning call219
// Begin line 96
  setline(96);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_nextTok
  gc_frame_end(frame);
  return *var_nextTok;
}
Object meth_parser__apply232(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit234 == NULL) {
    strlit234 = alloc_String("eof");
    gc_root(strlit234);
  }
// compilenode returning strlit234
  int op_slot_right_233 = gc_frame_newslot(strlit234);
  int callframe236 = gc_frame_new();
// compilenode returning *var_validToken
  partcv[0] = 0;
  Object call237 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe236);
// compilenode returning call237
// compilenode returning call237
  int op_slot_left_233 = gc_frame_newslot(call237);
  params[0] = strlit234;
  partcv[0] = 1;
  Object opresult238 = callmethod(call237, "!=", 1, partcv, params);
// compilenode returning opresult238
  gc_frame_end(frame);
  return opresult238;
}
Object meth_parser__apply241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_validToken = getfromclosure(closure, 0);
  Object *var_validFollowTokens = getfromclosure(closure, 1);
  Object *var_invalidTokens = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 105
  setline(105);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe243 = gc_frame_new();
  int callframe244 = gc_frame_new();
// compilenode returning *var_validToken
  partcv[0] = 0;
  Object call245 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe244);
// compilenode returning call245
// compilenode returning call245
  gc_frame_newslot(call245);
// compilenode returning *var_validFollowTokens
  params[0] = call245;
  partcv[0] = 1;
  Object call246 = callmethod(*var_validFollowTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe243);
// compilenode returning call246
  Object if242 = done;
  if (istrue(call246)) {
// Begin line 107
  setline(107);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 106
  setline(106);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_validToken
  block_return(realself, *var_validToken);
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if242 = undefined;
  } else {
  }
// compilenode returning if242
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 109
  setline(109);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe248 = gc_frame_new();
  int callframe249 = gc_frame_new();
  int callframe250 = gc_frame_new();
// compilenode returning *var_validToken
  partcv[0] = 0;
  Object call251 = callmethod(*var_validToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe250);
// compilenode returning call251
// compilenode returning call251
  gc_frame_newslot(call251);
// compilenode returning *var_invalidTokens
  params[0] = call251;
  partcv[0] = 1;
  Object call252 = callmethod(*var_invalidTokens, "contains",
    1, partcv, params);
  gc_frame_end(callframe249);
// compilenode returning call252
  partcv[0] = 0;
  Object call253 = callmethod(call252, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe248);
// compilenode returning call253
  Object if247 = done;
  if (istrue(call253)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_validToken
  block_return(realself, *var_validToken);
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if247 = undefined;
  } else {
  }
// compilenode returning if247
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 113
  setline(113);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe254 = gc_frame_new();
// compilenode returning *var_validToken
  partcv[0] = 0;
  Object call255 = callmethod(*var_validToken, "next",
    1, partcv, params);
  gc_frame_end(callframe254);
// compilenode returning call255
// compilenode returning call255
  *var_validToken = call255;
  if (call255 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findNextValidToken220(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findNextValidToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findNextValidToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object var_init_validFollowTokens = alloc_BuiltinList();
  for (i = 0; i < argcv[0]; i++) {
    callmethod(var_init_validFollowTokens, "push", 1, pushcv, &args[curarg]);
    curarg++;
  }
  Object *var_validFollowTokens = &(stackframe->slots[0]);
  *var_validFollowTokens = var_init_validFollowTokens;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_invalidTokens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "invalidTokens");
  Object *var_validToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "validToken");
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array221 = alloc_BuiltinList();
  gc_pause();
  if (strlit222 == NULL) {
    strlit222 = alloc_String("dot");
    gc_root(strlit222);
  }
// compilenode returning strlit222
  params[0] = strlit222;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit223 == NULL) {
    strlit223 = alloc_String("comma");
    gc_root(strlit223);
  }
// compilenode returning strlit223
  params[0] = strlit223;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit224 == NULL) {
    strlit224 = alloc_String("colon");
    gc_root(strlit224);
  }
// compilenode returning strlit224
  params[0] = strlit224;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit225 == NULL) {
    strlit225 = alloc_String("rparen");
    gc_root(strlit225);
  }
// compilenode returning strlit225
  params[0] = strlit225;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit226 == NULL) {
    strlit226 = alloc_String("rbrace");
    gc_root(strlit226);
  }
// compilenode returning strlit226
  params[0] = strlit226;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit227 == NULL) {
    strlit227 = alloc_String("rsquare");
    gc_root(strlit227);
  }
// compilenode returning strlit227
  params[0] = strlit227;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit228 == NULL) {
    strlit228 = alloc_String("arrow");
    gc_root(strlit228);
  }
// compilenode returning strlit228
  params[0] = strlit228;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  if (strlit229 == NULL) {
    strlit229 = alloc_String("bind");
    gc_root(strlit229);
  }
// compilenode returning strlit229
  params[0] = strlit229;
  partcv[0] = 1;
  callmethod(array221, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array221
  *var_invalidTokens = array221;
  if (array221 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 102
  setline(102);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_validToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 103
  setline(103);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe230 = gc_frame_new();
  Object block231 = alloc_Block(NULL, NULL, "parser", 103);
  gc_frame_newslot(block231);
  block_savedest(block231);
  Object closure232 = createclosure(2, "_apply");
setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_validToken);
  addtoclosure(closure232, selfslot);
  struct UserObject *uo232 = (struct UserObject*)block231;
  uo232->data[0] = (Object)closure232;
  Method *meth_meth_parser__apply232 = addmethod2pos(block231, "_apply", &meth_parser__apply232, 0);
int argcv_meth_parser__apply232[] = {0};
meth_meth_parser__apply232->type = alloc_MethodType(1, argcv_meth_parser__apply232);
  meth_meth_parser__apply232->definitionModule = modulename;
  meth_meth_parser__apply232->definitionLine = 94;
// compilenode returning block231
  gc_frame_newslot(block231);
  Object block240 = alloc_Block(NULL, NULL, "parser", 103);
  gc_frame_newslot(block240);
  block_savedest(block240);
  Object closure241 = createclosure(4, "_apply");
setclosureframe(closure241, stackframe);
  addtoclosure(closure241, var_validToken);
  addtoclosure(closure241, var_validFollowTokens);
  addtoclosure(closure241, var_invalidTokens);
  addtoclosure(closure241, selfslot);
  struct UserObject *uo241 = (struct UserObject*)block240;
  uo241->data[0] = (Object)closure241;
  Method *meth_meth_parser__apply241 = addmethod2pos(block240, "_apply", &meth_parser__apply241, 0);
int argcv_meth_parser__apply241[] = {0};
meth_meth_parser__apply241->type = alloc_MethodType(1, argcv_meth_parser__apply241);
  meth_meth_parser__apply241->definitionModule = modulename;
  meth_meth_parser__apply241->definitionLine = 103;
// compilenode returning block240
  gc_frame_newslot(block240);
  params[0] = block231;
  params[1] = block240;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call258 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe230);
// compilenode returning call258
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_validToken
  return *var_validToken;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser__apply270(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe273 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call274 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe273);
// compilenode returning call274
// compilenode returning call274
  int op_slot_right_272 = gc_frame_newslot(call274);
  int callframe276 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call277 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe276);
// compilenode returning call277
// compilenode returning call277
  int op_slot_left_272 = gc_frame_newslot(call277);
  params[0] = call274;
  partcv[0] = 1;
  Object opresult278 = callmethod(call277, "==", 1, partcv, params);
// compilenode returning opresult278
  int op_slot_right_271 = gc_frame_newslot(opresult278);
  if (strlit281 == NULL) {
    strlit281 = alloc_String("eof");
    gc_root(strlit281);
  }
// compilenode returning strlit281
  int op_slot_right_280 = gc_frame_newslot(strlit281);
  int callframe283 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call284 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe283);
// compilenode returning call284
// compilenode returning call284
  int op_slot_left_280 = gc_frame_newslot(call284);
  params[0] = strlit281;
  partcv[0] = 1;
  Object opresult285 = callmethod(call284, "!=", 1, partcv, params);
// compilenode returning opresult285
  int op_slot_left_271 = gc_frame_newslot(opresult285);
  params[0] = opresult278;
  partcv[0] = 1;
  Object opresult286 = callmethod(opresult285, "&&", 1, partcv, params);
// compilenode returning opresult286
  gc_frame_end(frame);
  return opresult286;
}
Object meth_parser__apply289(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 133
  setline(133);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit292 == NULL) {
    strlit292 = alloc_String("lbrace");
    gc_root(strlit292);
  }
// compilenode returning strlit292
  int op_slot_right_291 = gc_frame_newslot(strlit292);
  int callframe294 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call295 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe294);
// compilenode returning call295
// compilenode returning call295
  int op_slot_left_291 = gc_frame_newslot(call295);
  params[0] = strlit292;
  partcv[0] = 1;
  Object opresult296 = callmethod(call295, "==", 1, partcv, params);
// compilenode returning opresult296
  Object if290 = done;
  if (istrue(opresult296)) {
  Object num298 = alloc_Float64(1);
// compilenode returning num298
  int op_slot_right_297 = gc_frame_newslot(num298);
// compilenode returning *var_numOpening
  int op_slot_left_297 = gc_frame_newslot(*var_numOpening);
  params[0] = num298;
  partcv[0] = 1;
  Object sum300 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compilenode returning sum300
  *var_numOpening = sum300;
  if (sum300 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if290 = done;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 134
  setline(134);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit304 == NULL) {
    strlit304 = alloc_String("rbrace");
    gc_root(strlit304);
  }
// compilenode returning strlit304
  int op_slot_right_303 = gc_frame_newslot(strlit304);
  int callframe306 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call307 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe306);
// compilenode returning call307
// compilenode returning call307
  int op_slot_left_303 = gc_frame_newslot(call307);
  params[0] = strlit304;
  partcv[0] = 1;
  Object opresult308 = callmethod(call307, "==", 1, partcv, params);
// compilenode returning opresult308
  Object if302 = done;
  if (istrue(opresult308)) {
  Object num310 = alloc_Float64(1);
// compilenode returning num310
  int op_slot_right_309 = gc_frame_newslot(num310);
// compilenode returning *var_numClosing
  int op_slot_left_309 = gc_frame_newslot(*var_numClosing);
  params[0] = num310;
  partcv[0] = 1;
  Object sum312 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compilenode returning sum312
  *var_numClosing = sum312;
  if (sum312 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if302 = done;
  } else {
  }
// compilenode returning if302
    gc_frame_newslot(if302);
    if290 = if302;
  }
// compilenode returning if290
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe314 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call315 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe314);
// compilenode returning call315
// compilenode returning call315
  *var_n = call315;
  if (call315 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply321(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object *var_n = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe324 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call325 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe324);
// compilenode returning call325
// compilenode returning call325
  int op_slot_right_323 = gc_frame_newslot(call325);
  int callframe327 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call328 = callmethod(*var_n, "indent",
    1, partcv, params);
  gc_frame_end(callframe327);
// compilenode returning call328
// compilenode returning call328
  int op_slot_left_323 = gc_frame_newslot(call328);
  params[0] = call325;
  partcv[0] = 1;
  Object opresult329 = callmethod(call328, ">", 1, partcv, params);
// compilenode returning opresult329
  int op_slot_right_322 = gc_frame_newslot(opresult329);
  if (strlit332 == NULL) {
    strlit332 = alloc_String("eof");
    gc_root(strlit332);
  }
// compilenode returning strlit332
  int op_slot_right_331 = gc_frame_newslot(strlit332);
  int callframe334 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call335 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe334);
// compilenode returning call335
// compilenode returning call335
  int op_slot_left_331 = gc_frame_newslot(call335);
  params[0] = strlit332;
  partcv[0] = 1;
  Object opresult336 = callmethod(call335, "!=", 1, partcv, params);
// compilenode returning opresult336
  int op_slot_left_322 = gc_frame_newslot(opresult336);
  params[0] = opresult329;
  partcv[0] = 1;
  Object opresult337 = callmethod(opresult336, "&&", 1, partcv, params);
// compilenode returning opresult337
  gc_frame_end(frame);
  return opresult337;
}
Object meth_parser__apply340(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_numOpening = getfromclosure(closure, 1);
  Object *var_numClosing = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit343 == NULL) {
    strlit343 = alloc_String("lbrace");
    gc_root(strlit343);
  }
// compilenode returning strlit343
  int op_slot_right_342 = gc_frame_newslot(strlit343);
  int callframe345 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call346 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe345);
// compilenode returning call346
// compilenode returning call346
  int op_slot_left_342 = gc_frame_newslot(call346);
  params[0] = strlit343;
  partcv[0] = 1;
  Object opresult347 = callmethod(call346, "==", 1, partcv, params);
// compilenode returning opresult347
  Object if341 = done;
  if (istrue(opresult347)) {
  Object num349 = alloc_Float64(1);
// compilenode returning num349
  int op_slot_right_348 = gc_frame_newslot(num349);
// compilenode returning *var_numOpening
  int op_slot_left_348 = gc_frame_newslot(*var_numOpening);
  params[0] = num349;
  partcv[0] = 1;
  Object sum351 = callmethod(*var_numOpening, "+", 1, partcv, params);
// compilenode returning sum351
  *var_numOpening = sum351;
  if (sum351 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if341 = done;
  } else {
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit355 == NULL) {
    strlit355 = alloc_String("rbrace");
    gc_root(strlit355);
  }
// compilenode returning strlit355
  int op_slot_right_354 = gc_frame_newslot(strlit355);
  int callframe357 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call358 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe357);
// compilenode returning call358
// compilenode returning call358
  int op_slot_left_354 = gc_frame_newslot(call358);
  params[0] = strlit355;
  partcv[0] = 1;
  Object opresult359 = callmethod(call358, "==", 1, partcv, params);
// compilenode returning opresult359
  Object if353 = done;
  if (istrue(opresult359)) {
  Object num361 = alloc_Float64(1);
// compilenode returning num361
  int op_slot_right_360 = gc_frame_newslot(num361);
// compilenode returning *var_numClosing
  int op_slot_left_360 = gc_frame_newslot(*var_numClosing);
  params[0] = num361;
  partcv[0] = 1;
  Object sum363 = callmethod(*var_numClosing, "+", 1, partcv, params);
// compilenode returning sum363
  *var_numClosing = sum363;
  if (sum363 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if353 = done;
  } else {
  }
// compilenode returning if353
    gc_frame_newslot(if353);
    if341 = if353;
  }
// compilenode returning if341
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 141
  setline(141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe365 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call366 = callmethod(*var_n, "next",
    1, partcv, params);
  gc_frame_end(callframe365);
// compilenode returning call366
// compilenode returning call366
  *var_n = call366;
  if (call366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_findClosingBrace259(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_inserted
  Object if260 = done;
struct StackFrameObject *iftmpstackframe260 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe260);
gc_frame_newslot((Object)stackframe);
  Object num261 = alloc_Float64(1);
// compilenode returning num261
    gc_frame_newslot(num261);
    if260 = num261;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe260);
gc_frame_newslot((Object)stackframe);
  Object num262 = alloc_Float64(0);
// compilenode returning num262
    gc_frame_newslot(num262);
    if260 = num262;
  }
stackframe = iftmpstackframe260;
// compilenode returning if260
  *var_numOpening = if260;
  if (if260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num263 = alloc_Float64(0);
// compilenode returning num263
  *var_numClosing = num263;
  if (num263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject264 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj264 = alloc_userobj2(4,4, objclass264);
  gc_frame_newslot(obj264);
// OBJECT OUTER DEC outer
  adddatum2(obj264, self, 0);
  addmethodreal(obj264,"outer", &reader_parser_outer_265);
  Object oldself264 = self;
  struct StackFrameObject *oldstackframe264 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe264);
  gc_frame_newslot((Object)stackframe);
  self = obj264;
  Object *oldselfslot264 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter264 = (*(struct UserObject *)self).data[0], lowerouter264 = thisouter264;
  if (inheritingObject264) {
    struct UserObject *inho264 = (struct UserObject *)inheritingObject264;
    while (inho264->super != GraceDefaultObject) inho264 = (struct UserObject *)inho264->super;
    inho264->super = obj264;
    self = inheritingObject264;
    *selfslot = self;
    lowerouter264 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter264;
  }
if (objclass264 == NULL) {
  Method *reader266 = addmethodrealflags(obj264, "found",&reader_parser_found_266, 0);
  Method *writer266 = addmethodrealflags(obj264, "found:=",&writer_parser_found_266, 0);
  reader266->definitionModule = modulename;
  writer266->definitionModule = modulename;
  reader266->definitionLine = 129;
  writer266->definitionLine = 129;
}
obj264->flags |= OFLAG_MUTABLE;
adddatum2(obj264, alloc_Undefined(), 1);
if (objclass264 == NULL) {
  Method *reader267 = addmethodrealflags(obj264, "tok",&reader_parser_tok_267, 0);
  Method *writer267 = addmethodrealflags(obj264, "tok:=",&writer_parser_tok_267, 0);
  reader267->definitionModule = modulename;
  writer267->definitionModule = modulename;
  reader267->definitionLine = 130;
  writer267->definitionLine = 130;
}
obj264->flags |= OFLAG_MUTABLE;
adddatum2(obj264, alloc_Undefined(), 2);
  sourceObject = obj264;
  adddatum2(obj264, undefined, 1);
  sourceObject = obj264;
  adddatum2(obj264, undefined, 2);
objclass264 = obj264->class;
  objclass264->definitionModule = modulename;
  objclass264->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter264;
  self = oldself264;
  selfslot = oldselfslot264;
  stackframe = oldstackframe264;
// compilenode returning obj264
  *var_result = obj264;
  if (obj264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe268 = gc_frame_new();
  Object block269 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block269);
  block_savedest(block269);
  Object closure270 = createclosure(3, "_apply");
setclosureframe(closure270, stackframe);
  addtoclosure(closure270, var_tok);
  addtoclosure(closure270, var_n);
  addtoclosure(closure270, selfslot);
  struct UserObject *uo270 = (struct UserObject*)block269;
  uo270->data[0] = (Object)closure270;
  Method *meth_meth_parser__apply270 = addmethod2pos(block269, "_apply", &meth_parser__apply270, 0);
int argcv_meth_parser__apply270[] = {0};
meth_meth_parser__apply270->type = alloc_MethodType(1, argcv_meth_parser__apply270);
  meth_meth_parser__apply270->definitionModule = modulename;
  meth_meth_parser__apply270->definitionLine = 113;
// compilenode returning block269
  gc_frame_newslot(block269);
  Object block288 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block288);
  block_savedest(block288);
  Object closure289 = createclosure(4, "_apply");
setclosureframe(closure289, stackframe);
  addtoclosure(closure289, var_n);
  addtoclosure(closure289, var_numOpening);
  addtoclosure(closure289, var_numClosing);
  addtoclosure(closure289, selfslot);
  struct UserObject *uo289 = (struct UserObject*)block288;
  uo289->data[0] = (Object)closure289;
  Method *meth_meth_parser__apply289 = addmethod2pos(block288, "_apply", &meth_parser__apply289, 0);
int argcv_meth_parser__apply289[] = {0};
meth_meth_parser__apply289->type = alloc_MethodType(1, argcv_meth_parser__apply289);
  meth_meth_parser__apply289->definitionModule = modulename;
  meth_meth_parser__apply289->definitionLine = 132;
// compilenode returning block288
  gc_frame_newslot(block288);
  params[0] = block269;
  params[1] = block288;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call318 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe268);
// compilenode returning call318
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe319 = gc_frame_new();
  Object block320 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block320);
  block_savedest(block320);
  Object closure321 = createclosure(3, "_apply");
setclosureframe(closure321, stackframe);
  addtoclosure(closure321, var_tok);
  addtoclosure(closure321, var_n);
  addtoclosure(closure321, selfslot);
  struct UserObject *uo321 = (struct UserObject*)block320;
  uo321->data[0] = (Object)closure321;
  Method *meth_meth_parser__apply321 = addmethod2pos(block320, "_apply", &meth_parser__apply321, 0);
int argcv_meth_parser__apply321[] = {0};
meth_meth_parser__apply321->type = alloc_MethodType(1, argcv_meth_parser__apply321);
  meth_meth_parser__apply321->definitionModule = modulename;
  meth_meth_parser__apply321->definitionLine = 135;
// compilenode returning block320
  gc_frame_newslot(block320);
  Object block339 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block339);
  block_savedest(block339);
  Object closure340 = createclosure(4, "_apply");
setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_n);
  addtoclosure(closure340, var_numOpening);
  addtoclosure(closure340, var_numClosing);
  addtoclosure(closure340, selfslot);
  struct UserObject *uo340 = (struct UserObject*)block339;
  uo340->data[0] = (Object)closure340;
  Method *meth_meth_parser__apply340 = addmethod2pos(block339, "_apply", &meth_parser__apply340, 0);
int argcv_meth_parser__apply340[] = {0};
meth_meth_parser__apply340->type = alloc_MethodType(1, argcv_meth_parser__apply340);
  meth_meth_parser__apply340->definitionModule = modulename;
  meth_meth_parser__apply340->definitionLine = 138;
// compilenode returning block339
  gc_frame_newslot(block339);
  params[0] = block320;
  params[1] = block339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call369 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe319);
// compilenode returning call369
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit372 == NULL) {
    strlit372 = alloc_String("rbrace");
    gc_root(strlit372);
  }
// compilenode returning strlit372
  int op_slot_right_371 = gc_frame_newslot(strlit372);
  int callframe374 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call375 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
// compilenode returning call375
  int op_slot_left_371 = gc_frame_newslot(call375);
  params[0] = strlit372;
  partcv[0] = 1;
  Object opresult376 = callmethod(call375, "==", 1, partcv, params);
// compilenode returning opresult376
  Object if370 = done;
  if (istrue(opresult376)) {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe377 = gc_frame_new();
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool378 = alloc_Boolean(1);
// compilenode returning bool378
  gc_frame_newslot(bool378);
// compilenode returning *var_result
  params[0] = bool378;
  partcv[0] = 1;
  Object call379 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe377);
// compilenode returning call379
// compilenode returning done
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe380 = gc_frame_new();
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_result
  params[0] = *var_n;
  partcv[0] = 1;
  Object call381 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe380);
// compilenode returning call381
// compilenode returning done
    gc_frame_newslot(done);
    if370 = done;
  } else {
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_numClosing
  int op_slot_right_384 = gc_frame_newslot(*var_numClosing);
// compilenode returning *var_numOpening
  int op_slot_left_384 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult386 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compilenode returning opresult386
  int op_slot_right_383 = gc_frame_newslot(opresult386);
  if (strlit389 == NULL) {
    strlit389 = alloc_String("rbrace");
    gc_root(strlit389);
  }
// compilenode returning strlit389
  int op_slot_right_388 = gc_frame_newslot(strlit389);
  int callframe391 = gc_frame_new();
  int callframe392 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call393 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe392);
// compilenode returning call393
// compilenode returning call393
  partcv[0] = 0;
  Object call394 = callmethod(call393, "kind",
    1, partcv, params);
  gc_frame_end(callframe391);
// compilenode returning call394
// compilenode returning call394
  int op_slot_left_388 = gc_frame_newslot(call394);
  params[0] = strlit389;
  partcv[0] = 1;
  Object opresult395 = callmethod(call394, "==", 1, partcv, params);
// compilenode returning opresult395
  int op_slot_left_383 = gc_frame_newslot(opresult395);
  params[0] = opresult386;
  partcv[0] = 1;
  Object opresult396 = callmethod(opresult395, "&&", 1, partcv, params);
// compilenode returning opresult396
  Object if382 = done;
  if (istrue(opresult396)) {
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe397 = gc_frame_new();
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool398 = alloc_Boolean(1);
// compilenode returning bool398
  gc_frame_newslot(bool398);
// compilenode returning *var_result
  params[0] = bool398;
  partcv[0] = 1;
  Object call399 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe397);
// compilenode returning call399
// compilenode returning done
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe400 = gc_frame_new();
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe401 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call402 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe401);
// compilenode returning call402
// compilenode returning call402
  gc_frame_newslot(call402);
// compilenode returning *var_result
  params[0] = call402;
  partcv[0] = 1;
  Object call403 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe400);
// compilenode returning call403
// compilenode returning done
    gc_frame_newslot(done);
    if382 = done;
  } else {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe404 = gc_frame_new();
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool405 = alloc_Boolean(0);
// compilenode returning bool405
  gc_frame_newslot(bool405);
// compilenode returning *var_result
  params[0] = bool405;
  partcv[0] = 1;
  Object call406 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe404);
// compilenode returning call406
// compilenode returning done
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe407 = gc_frame_new();
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe408 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call409 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe408);
// compilenode returning call409
// compilenode returning call409
  gc_frame_newslot(call409);
// compilenode returning *var_result
  params[0] = call409;
  partcv[0] = 1;
  Object call410 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe407);
// compilenode returning call410
// compilenode returning done
    gc_frame_newslot(done);
    if382 = done;
  }
// compilenode returning if382
    gc_frame_newslot(if382);
    if370 = if382;
  }
// compilenode returning if370
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_result
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_findClosingBrace259_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findClosingBrace()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for findClosingBrace (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tok = &(stackframe->slots[0]);
  *var_tok = args[curarg];
  curarg++;
  Object *var_inserted = &(stackframe->slots[1]);
  *var_inserted = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for findClosingBrace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_n = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "n");
  Object *var_numOpening = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "numOpening");
  Object *var_numClosing = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "numClosing");
  Object *var_result = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "result");
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 124
  setline(124);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_n = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 125
  setline(125);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_inserted
  Object if260 = done;
struct StackFrameObject *iftmpstackframe260 = stackframe;
  if (istrue(*var_inserted)) {
stackframe = alloc_StackFrame(0, iftmpstackframe260);
gc_frame_newslot((Object)stackframe);
  Object num261 = alloc_Float64(1);
// compilenode returning num261
    gc_frame_newslot(num261);
    if260 = num261;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe260);
gc_frame_newslot((Object)stackframe);
  Object num262 = alloc_Float64(0);
// compilenode returning num262
    gc_frame_newslot(num262);
    if260 = num262;
  }
stackframe = iftmpstackframe260;
// compilenode returning if260
  *var_numOpening = if260;
  if (if260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 126
  setline(126);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num263 = alloc_Float64(0);
// compilenode returning num263
  *var_numClosing = num263;
  if (num263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject264 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj264 = alloc_userobj2(4,4, objclass264);
  gc_frame_newslot(obj264);
// OBJECT OUTER DEC outer
  adddatum2(obj264, self, 0);
  addmethodreal(obj264,"outer", &reader_parser_outer_265);
  Object oldself264 = self;
  struct StackFrameObject *oldstackframe264 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe264);
  gc_frame_newslot((Object)stackframe);
  self = obj264;
  Object *oldselfslot264 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter264 = (*(struct UserObject *)self).data[0], lowerouter264 = thisouter264;
  if (inheritingObject264) {
    struct UserObject *inho264 = (struct UserObject *)inheritingObject264;
    while (inho264->super != GraceDefaultObject) inho264 = (struct UserObject *)inho264->super;
    inho264->super = obj264;
    self = inheritingObject264;
    *selfslot = self;
    lowerouter264 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter264;
  }
if (objclass264 == NULL) {
  Method *reader266 = addmethodrealflags(obj264, "found",&reader_parser_found_266, 0);
  Method *writer266 = addmethodrealflags(obj264, "found:=",&writer_parser_found_266, 0);
  reader266->definitionModule = modulename;
  writer266->definitionModule = modulename;
  reader266->definitionLine = 129;
  writer266->definitionLine = 129;
}
obj264->flags |= OFLAG_MUTABLE;
adddatum2(obj264, alloc_Undefined(), 1);
if (objclass264 == NULL) {
  Method *reader267 = addmethodrealflags(obj264, "tok",&reader_parser_tok_267, 0);
  Method *writer267 = addmethodrealflags(obj264, "tok:=",&writer_parser_tok_267, 0);
  reader267->definitionModule = modulename;
  writer267->definitionModule = modulename;
  reader267->definitionLine = 130;
  writer267->definitionLine = 130;
}
obj264->flags |= OFLAG_MUTABLE;
adddatum2(obj264, alloc_Undefined(), 2);
  sourceObject = obj264;
  adddatum2(obj264, undefined, 1);
  sourceObject = obj264;
  adddatum2(obj264, undefined, 2);
objclass264 = obj264->class;
  objclass264->definitionModule = modulename;
  objclass264->definitionLine = 127;
  (*(struct UserObject *)self).data[0] = lowerouter264;
  self = oldself264;
  selfslot = oldselfslot264;
  stackframe = oldstackframe264;
// compilenode returning obj264
  *var_result = obj264;
  if (obj264 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe268 = gc_frame_new();
  Object block269 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block269);
  block_savedest(block269);
  Object closure270 = createclosure(3, "_apply");
setclosureframe(closure270, stackframe);
  addtoclosure(closure270, var_tok);
  addtoclosure(closure270, var_n);
  addtoclosure(closure270, selfslot);
  struct UserObject *uo270 = (struct UserObject*)block269;
  uo270->data[0] = (Object)closure270;
  Method *meth_meth_parser__apply270 = addmethod2pos(block269, "_apply", &meth_parser__apply270, 0);
int argcv_meth_parser__apply270[] = {0};
meth_meth_parser__apply270->type = alloc_MethodType(1, argcv_meth_parser__apply270);
  meth_meth_parser__apply270->definitionModule = modulename;
  meth_meth_parser__apply270->definitionLine = 113;
// compilenode returning block269
  gc_frame_newslot(block269);
  Object block288 = alloc_Block(NULL, NULL, "parser", 132);
  gc_frame_newslot(block288);
  block_savedest(block288);
  Object closure289 = createclosure(4, "_apply");
setclosureframe(closure289, stackframe);
  addtoclosure(closure289, var_n);
  addtoclosure(closure289, var_numOpening);
  addtoclosure(closure289, var_numClosing);
  addtoclosure(closure289, selfslot);
  struct UserObject *uo289 = (struct UserObject*)block288;
  uo289->data[0] = (Object)closure289;
  Method *meth_meth_parser__apply289 = addmethod2pos(block288, "_apply", &meth_parser__apply289, 0);
int argcv_meth_parser__apply289[] = {0};
meth_meth_parser__apply289->type = alloc_MethodType(1, argcv_meth_parser__apply289);
  meth_meth_parser__apply289->definitionModule = modulename;
  meth_meth_parser__apply289->definitionLine = 132;
// compilenode returning block288
  gc_frame_newslot(block288);
  params[0] = block269;
  params[1] = block288;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call318 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe268);
// compilenode returning call318
// Begin line 138
  setline(138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe319 = gc_frame_new();
  Object block320 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block320);
  block_savedest(block320);
  Object closure321 = createclosure(3, "_apply");
setclosureframe(closure321, stackframe);
  addtoclosure(closure321, var_tok);
  addtoclosure(closure321, var_n);
  addtoclosure(closure321, selfslot);
  struct UserObject *uo321 = (struct UserObject*)block320;
  uo321->data[0] = (Object)closure321;
  Method *meth_meth_parser__apply321 = addmethod2pos(block320, "_apply", &meth_parser__apply321, 0);
int argcv_meth_parser__apply321[] = {0};
meth_meth_parser__apply321->type = alloc_MethodType(1, argcv_meth_parser__apply321);
  meth_meth_parser__apply321->definitionModule = modulename;
  meth_meth_parser__apply321->definitionLine = 135;
// compilenode returning block320
  gc_frame_newslot(block320);
  Object block339 = alloc_Block(NULL, NULL, "parser", 138);
  gc_frame_newslot(block339);
  block_savedest(block339);
  Object closure340 = createclosure(4, "_apply");
setclosureframe(closure340, stackframe);
  addtoclosure(closure340, var_n);
  addtoclosure(closure340, var_numOpening);
  addtoclosure(closure340, var_numClosing);
  addtoclosure(closure340, selfslot);
  struct UserObject *uo340 = (struct UserObject*)block339;
  uo340->data[0] = (Object)closure340;
  Method *meth_meth_parser__apply340 = addmethod2pos(block339, "_apply", &meth_parser__apply340, 0);
int argcv_meth_parser__apply340[] = {0};
meth_meth_parser__apply340->type = alloc_MethodType(1, argcv_meth_parser__apply340);
  meth_meth_parser__apply340->definitionModule = modulename;
  meth_meth_parser__apply340->definitionLine = 138;
// compilenode returning block339
  gc_frame_newslot(block339);
  params[0] = block320;
  params[1] = block339;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call369 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe319);
// compilenode returning call369
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit372 == NULL) {
    strlit372 = alloc_String("rbrace");
    gc_root(strlit372);
  }
// compilenode returning strlit372
  int op_slot_right_371 = gc_frame_newslot(strlit372);
  int callframe374 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call375 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe374);
// compilenode returning call375
// compilenode returning call375
  int op_slot_left_371 = gc_frame_newslot(call375);
  params[0] = strlit372;
  partcv[0] = 1;
  Object opresult376 = callmethod(call375, "==", 1, partcv, params);
// compilenode returning opresult376
  Object if370 = done;
  if (istrue(opresult376)) {
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe377 = gc_frame_new();
// Begin line 144
  setline(144);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool378 = alloc_Boolean(1);
// compilenode returning bool378
  gc_frame_newslot(bool378);
// compilenode returning *var_result
  params[0] = bool378;
  partcv[0] = 1;
  Object call379 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe377);
// compilenode returning call379
// compilenode returning done
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 143
  setline(143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe380 = gc_frame_new();
// Begin line 145
  setline(145);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_result
  params[0] = *var_n;
  partcv[0] = 1;
  Object call381 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe380);
// compilenode returning call381
// compilenode returning done
    gc_frame_newslot(done);
    if370 = done;
  } else {
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_numClosing
  int op_slot_right_384 = gc_frame_newslot(*var_numClosing);
// compilenode returning *var_numOpening
  int op_slot_left_384 = gc_frame_newslot(*var_numOpening);
  params[0] = *var_numClosing;
  partcv[0] = 1;
  Object opresult386 = callmethod(*var_numOpening, "==", 1, partcv, params);
// compilenode returning opresult386
  int op_slot_right_383 = gc_frame_newslot(opresult386);
  if (strlit389 == NULL) {
    strlit389 = alloc_String("rbrace");
    gc_root(strlit389);
  }
// compilenode returning strlit389
  int op_slot_right_388 = gc_frame_newslot(strlit389);
  int callframe391 = gc_frame_new();
  int callframe392 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call393 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe392);
// compilenode returning call393
// compilenode returning call393
  partcv[0] = 0;
  Object call394 = callmethod(call393, "kind",
    1, partcv, params);
  gc_frame_end(callframe391);
// compilenode returning call394
// compilenode returning call394
  int op_slot_left_388 = gc_frame_newslot(call394);
  params[0] = strlit389;
  partcv[0] = 1;
  Object opresult395 = callmethod(call394, "==", 1, partcv, params);
// compilenode returning opresult395
  int op_slot_left_383 = gc_frame_newslot(opresult395);
  params[0] = opresult386;
  partcv[0] = 1;
  Object opresult396 = callmethod(opresult395, "&&", 1, partcv, params);
// compilenode returning opresult396
  Object if382 = done;
  if (istrue(opresult396)) {
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe397 = gc_frame_new();
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool398 = alloc_Boolean(1);
// compilenode returning bool398
  gc_frame_newslot(bool398);
// compilenode returning *var_result
  params[0] = bool398;
  partcv[0] = 1;
  Object call399 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe397);
// compilenode returning call399
// compilenode returning done
// Begin line 150
  setline(150);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 146
  setline(146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe400 = gc_frame_new();
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe401 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call402 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe401);
// compilenode returning call402
// compilenode returning call402
  gc_frame_newslot(call402);
// compilenode returning *var_result
  params[0] = call402;
  partcv[0] = 1;
  Object call403 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe400);
// compilenode returning call403
// compilenode returning done
    gc_frame_newslot(done);
    if382 = done;
  } else {
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe404 = gc_frame_new();
// Begin line 151
  setline(151);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool405 = alloc_Boolean(0);
// compilenode returning bool405
  gc_frame_newslot(bool405);
// compilenode returning *var_result
  params[0] = bool405;
  partcv[0] = 1;
  Object call406 = callmethod(*var_result, "found:=",
    1, partcv, params);
  gc_frame_end(callframe404);
// compilenode returning call406
// compilenode returning done
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 149
  setline(149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe407 = gc_frame_new();
// Begin line 152
  setline(152);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe408 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call409 = callmethod(*var_n, "prev",
    1, partcv, params);
  gc_frame_end(callframe408);
// compilenode returning call409
// compilenode returning call409
  gc_frame_newslot(call409);
// compilenode returning *var_result
  params[0] = call409;
  partcv[0] = 1;
  Object call410 = callmethod(*var_result, "tok:=",
    1, partcv, params);
  gc_frame_end(callframe407);
// compilenode returning call410
// compilenode returning done
    gc_frame_newslot(done);
    if382 = done;
  }
// compilenode returning if382
    gc_frame_newslot(if382);
    if370 = if382;
  }
// compilenode returning if370
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_result
  gc_frame_end(frame);
  return *var_result;
}
Object meth_parser_accept412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for accept (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_t
  int op_slot_right_413 = gc_frame_newslot(*var_t);
  int callframe415 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call416 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe415);
// compilenode returning call416
// compilenode returning call416
  int op_slot_left_413 = gc_frame_newslot(call416);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult417 = callmethod(call416, "==", 1, partcv, params);
// compilenode returning opresult417
  gc_frame_end(frame);
  return opresult417;
}
Object meth_parser_acceptSameLine418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "acceptSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastline = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for acceptSameLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for acceptSameLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastIndent
  int op_slot_right_421 = gc_frame_newslot(*var_lastIndent);
  int callframe423 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call424 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe423);
// compilenode returning call424
// compilenode returning call424
  int op_slot_left_421 = gc_frame_newslot(call424);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult425 = callmethod(call424, ">", 1, partcv, params);
// compilenode returning opresult425
  int op_slot_right_420 = gc_frame_newslot(opresult425);
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe428 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call429 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe428);
// compilenode returning call429
// compilenode returning call429
  int op_slot_right_427 = gc_frame_newslot(call429);
// compilenode returning *var_lastline
  int op_slot_left_427 = gc_frame_newslot(*var_lastline);
  params[0] = call429;
  partcv[0] = 1;
  Object opresult431 = callmethod(*var_lastline, "==", 1, partcv, params);
// compilenode returning opresult431
  int op_slot_left_420 = gc_frame_newslot(opresult431);
  params[0] = opresult425;
  partcv[0] = 1;
  Object opresult432 = callmethod(opresult431, "||", 1, partcv, params);
// compilenode returning opresult432
  int op_slot_right_419 = gc_frame_newslot(opresult432);
// compilenode returning *var_t
  int op_slot_right_434 = gc_frame_newslot(*var_t);
  int callframe436 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call437 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe436);
// compilenode returning call437
// compilenode returning call437
  int op_slot_left_434 = gc_frame_newslot(call437);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult438 = callmethod(call437, "==", 1, partcv, params);
// compilenode returning opresult438
  int op_slot_left_419 = gc_frame_newslot(opresult438);
  params[0] = opresult432;
  partcv[0] = 1;
  Object opresult439 = callmethod(opresult438, "&&", 1, partcv, params);
// compilenode returning opresult439
  gc_frame_end(frame);
  return opresult439;
}
Object meth_parser_accept_40__41_onLineOf440(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOf (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for onLineOf");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe444 = gc_frame_new();
// compilenode returning *var_other
  partcv[0] = 0;
  Object call445 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe444);
// compilenode returning call445
// compilenode returning call445
  int op_slot_right_443 = gc_frame_newslot(call445);
  int callframe447 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call448 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe447);
// compilenode returning call448
// compilenode returning call448
  int op_slot_left_443 = gc_frame_newslot(call448);
  params[0] = call445;
  partcv[0] = 1;
  Object opresult449 = callmethod(call448, ">", 1, partcv, params);
// compilenode returning opresult449
  int op_slot_right_442 = gc_frame_newslot(opresult449);
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe452 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call453 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe452);
// compilenode returning call453
// compilenode returning call453
  int op_slot_right_451 = gc_frame_newslot(call453);
  int callframe455 = gc_frame_new();
// compilenode returning *var_other
  partcv[0] = 0;
  Object call456 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe455);
// compilenode returning call456
// compilenode returning call456
  int op_slot_left_451 = gc_frame_newslot(call456);
  params[0] = call453;
  partcv[0] = 1;
  Object opresult457 = callmethod(call456, "==", 1, partcv, params);
// compilenode returning opresult457
  int op_slot_left_442 = gc_frame_newslot(opresult457);
  params[0] = opresult449;
  partcv[0] = 1;
  Object opresult458 = callmethod(opresult457, "||", 1, partcv, params);
// compilenode returning opresult458
  int op_slot_right_441 = gc_frame_newslot(opresult458);
// compilenode returning *var_t
  int op_slot_right_460 = gc_frame_newslot(*var_t);
  int callframe462 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call463 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe462);
// compilenode returning call463
// compilenode returning call463
  int op_slot_left_460 = gc_frame_newslot(call463);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult464 = callmethod(call463, "==", 1, partcv, params);
// compilenode returning opresult464
  int op_slot_left_441 = gc_frame_newslot(opresult464);
  params[0] = opresult458;
  partcv[0] = 1;
  Object opresult465 = callmethod(opresult464, "&&", 1, partcv, params);
// compilenode returning opresult465
  gc_frame_end(frame);
  return opresult465;
}
Object meth_parser_accept_40__41_onLineOfLastOr466(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "accept()onLineOfLastOr");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for accept()onLineOfLastOr (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for accept");
  Object *var_other = &(stackframe->slots[1]);
  *var_other = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for onLineOfLastOr");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe470 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call471 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe470);
// compilenode returning call471
// compilenode returning call471
  int op_slot_right_469 = gc_frame_newslot(call471);
  int callframe473 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call474 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe473);
// compilenode returning call474
// compilenode returning call474
  int op_slot_left_469 = gc_frame_newslot(call474);
  params[0] = call471;
  partcv[0] = 1;
  Object opresult475 = callmethod(call474, "==", 1, partcv, params);
// compilenode returning opresult475
  int op_slot_right_468 = gc_frame_newslot(opresult475);
  int callframe479 = gc_frame_new();
// compilenode returning *var_other
  partcv[0] = 0;
  Object call480 = callmethod(*var_other, "indent",
    1, partcv, params);
  gc_frame_end(callframe479);
// compilenode returning call480
// compilenode returning call480
  int op_slot_right_478 = gc_frame_newslot(call480);
  int callframe482 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call483 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe482);
// compilenode returning call483
// compilenode returning call483
  int op_slot_left_478 = gc_frame_newslot(call483);
  params[0] = call480;
  partcv[0] = 1;
  Object opresult484 = callmethod(call483, ">", 1, partcv, params);
// compilenode returning opresult484
  int op_slot_right_477 = gc_frame_newslot(opresult484);
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe487 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call488 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe487);
// compilenode returning call488
// compilenode returning call488
  int op_slot_right_486 = gc_frame_newslot(call488);
  int callframe490 = gc_frame_new();
// compilenode returning *var_other
  partcv[0] = 0;
  Object call491 = callmethod(*var_other, "line",
    1, partcv, params);
  gc_frame_end(callframe490);
// compilenode returning call491
// compilenode returning call491
  int op_slot_left_486 = gc_frame_newslot(call491);
  params[0] = call488;
  partcv[0] = 1;
  Object opresult492 = callmethod(call491, "==", 1, partcv, params);
// compilenode returning opresult492
  int op_slot_left_477 = gc_frame_newslot(opresult492);
  params[0] = opresult484;
  partcv[0] = 1;
  Object opresult493 = callmethod(opresult492, "||", 1, partcv, params);
// compilenode returning opresult493
  int op_slot_left_468 = gc_frame_newslot(opresult493);
  params[0] = opresult475;
  partcv[0] = 1;
  Object opresult494 = callmethod(opresult493, "||", 1, partcv, params);
// compilenode returning opresult494
  int op_slot_right_467 = gc_frame_newslot(opresult494);
// compilenode returning *var_t
  int op_slot_right_496 = gc_frame_newslot(*var_t);
  int callframe498 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call499 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe498);
// compilenode returning call499
// compilenode returning call499
  int op_slot_left_496 = gc_frame_newslot(call499);
  params[0] = *var_t;
  partcv[0] = 1;
  Object opresult500 = callmethod(call499, "==", 1, partcv, params);
// compilenode returning opresult500
  int op_slot_left_467 = gc_frame_newslot(opresult500);
  params[0] = opresult494;
  partcv[0] = 1;
  Object opresult501 = callmethod(opresult500, "&&", 1, partcv, params);
// compilenode returning opresult501
  gc_frame_end(frame);
  return opresult501;
}
Object meth_parser_tokenOnSameLine502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokenOnSameLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastline = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokenOnSameLine (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for tokenOnSameLine");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastIndent
  int op_slot_right_504 = gc_frame_newslot(*var_lastIndent);
  int callframe506 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call507 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe506);
// compilenode returning call507
// compilenode returning call507
  int op_slot_left_504 = gc_frame_newslot(call507);
  params[0] = *var_lastIndent;
  partcv[0] = 1;
  Object opresult508 = callmethod(call507, ">", 1, partcv, params);
// compilenode returning opresult508
  int op_slot_right_503 = gc_frame_newslot(opresult508);
  int callframe511 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call512 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe511);
// compilenode returning call512
// compilenode returning call512
  int op_slot_right_510 = gc_frame_newslot(call512);
// compilenode returning *var_lastline
  int op_slot_left_510 = gc_frame_newslot(*var_lastline);
  params[0] = call512;
  partcv[0] = 1;
  Object opresult514 = callmethod(*var_lastline, "==", 1, partcv, params);
// compilenode returning opresult514
  int op_slot_left_503 = gc_frame_newslot(opresult514);
  params[0] = opresult508;
  partcv[0] = 1;
  Object opresult515 = callmethod(opresult514, "||", 1, partcv, params);
// compilenode returning opresult515
  gc_frame_end(frame);
  return opresult515;
}
Object meth_parser_didConsume516(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "didConsume");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for didConsume (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for didConsume");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sz");
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe517 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call518 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe517);
// compilenode returning call518
// compilenode returning call518
  *var_sz = call518;
  if (call518 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 190
  setline(190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe519 = gc_frame_new();
// compilenode returning *var_ablock
  partcv[0] = 0;
  Object call520 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe519);
// compilenode returning call520
// compilenode returning call520
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sz
  int op_slot_right_521 = gc_frame_newslot(*var_sz);
  int callframe523 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call524 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe523);
// compilenode returning call524
// compilenode returning call524
  int op_slot_left_521 = gc_frame_newslot(call524);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult525 = callmethod(call524, "!=", 1, partcv, params);
// compilenode returning opresult525
  gc_frame_end(frame);
  return opresult525;
}
Object meth_parser_ifConsume_40__41_then526(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ifConsume()then");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  if (nparts > 0 && argcv[1] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    gracedie("missing argument list for ifConsume()then (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_ablock = &(stackframe->slots[0]);
  *var_ablock = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for ifConsume");
  Object *var_tblock = &(stackframe->slots[1]);
  *var_tblock = args[curarg];
  curarg++;
if (argcv && argcv[1] > 1)
  gracedie("too many arguments for then");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sz");
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe527 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call528 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe527);
// compilenode returning call528
// compilenode returning call528
  *var_sz = call528;
  if (call528 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe529 = gc_frame_new();
// compilenode returning *var_ablock
  partcv[0] = 0;
  Object call530 = callmethod(*var_ablock, "apply",
    1, partcv, params);
  gc_frame_end(callframe529);
// compilenode returning call530
// compilenode returning call530
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sz
  int op_slot_right_532 = gc_frame_newslot(*var_sz);
  int callframe534 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call535 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe534);
// compilenode returning call535
// compilenode returning call535
  int op_slot_left_532 = gc_frame_newslot(call535);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult536 = callmethod(call535, "!=", 1, partcv, params);
// compilenode returning opresult536
  Object if531 = done;
  if (istrue(opresult536)) {
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe537 = gc_frame_new();
// compilenode returning *var_tblock
  partcv[0] = 0;
  Object call538 = callmethod(*var_tblock, "apply",
    1, partcv, params);
  gc_frame_end(callframe537);
// compilenode returning call538
// compilenode returning call538
    gc_frame_newslot(call538);
    if531 = call538;
  } else {
  }
// compilenode returning if531
  gc_frame_end(frame);
  return if531;
}
Object meth_parser_pushnum539(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushnum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushnum (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for pushnum");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 204
  setline(204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe540 = gc_frame_new();
  int callframe541 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call542 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe541);
// compilenode returning call542
// compilenode returning call542
  gc_frame_newslot(call542);
  int callframe543 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call544 = callmethod(*var_ast, "numNode",
    1, partcv, params);
  gc_frame_end(callframe543);
// compilenode returning call544
// compilenode returning call544
  params[0] = call542;
  partcv[0] = 1;
  Object call545 = callmethod(call544, "new",
    1, partcv, params);
  gc_frame_end(callframe540);
// compilenode returning call545
  *var_o = call545;
  if (call545 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 205
  setline(205);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe546 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call547 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe546);
// compilenode returning call547
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe548 = gc_frame_new();
  partcv[0] = 0;
  Object call549 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe548);
// compilenode returning call549
  gc_frame_end(frame);
  return call549;
}
Object meth_parser_pushoctets550(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushoctets");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushoctets (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for pushoctets");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe551 = gc_frame_new();
  int callframe552 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call553 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe552);
// compilenode returning call553
// compilenode returning call553
  gc_frame_newslot(call553);
  int callframe554 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call555 = callmethod(*var_ast, "octetsNode",
    1, partcv, params);
  gc_frame_end(callframe554);
// compilenode returning call555
// compilenode returning call555
  params[0] = call553;
  partcv[0] = 1;
  Object call556 = callmethod(call555, "new",
    1, partcv, params);
  gc_frame_end(callframe551);
// compilenode returning call556
  *var_o = call556;
  if (call556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 212
  setline(212);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe557 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call558 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe557);
// compilenode returning call558
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe559 = gc_frame_new();
  partcv[0] = 0;
  Object call560 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe559);
// compilenode returning call560
  gc_frame_end(frame);
  return call560;
}
Object meth_parser_pushstring561(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushstring");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushstring (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for pushstring");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe562 = gc_frame_new();
  int callframe563 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call564 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe563);
// compilenode returning call564
// compilenode returning call564
  gc_frame_newslot(call564);
  int callframe565 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call566 = callmethod(*var_ast, "stringNode",
    1, partcv, params);
  gc_frame_end(callframe565);
// compilenode returning call566
// compilenode returning call566
  params[0] = call564;
  partcv[0] = 1;
  Object call567 = callmethod(call566, "new",
    1, partcv, params);
  gc_frame_end(callframe562);
// compilenode returning call567
  *var_o = call567;
  if (call567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe568 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call569 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe568);
// compilenode returning call569
// Begin line 220
  setline(220);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe570 = gc_frame_new();
  partcv[0] = 0;
  Object call571 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe570);
// compilenode returning call571
  gc_frame_end(frame);
  return call571;
}
Object meth_parser_pushidentifier572(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "pushidentifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_util = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_auto_count = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for pushidentifier (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for pushidentifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "o");
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe573 = gc_frame_new();
  int callframe574 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call575 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe574);
// compilenode returning call575
// compilenode returning call575
  gc_frame_newslot(call575);
// compilenode returning *var_util
  params[0] = call575;
  partcv[0] = 1;
  Object call576 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe573);
// compilenode returning call576
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe577 = gc_frame_new();
  int callframe578 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call579 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe578);
// compilenode returning call579
// compilenode returning call579
  gc_frame_newslot(call579);
  Object bool580 = alloc_Boolean(0);
// compilenode returning bool580
  gc_frame_newslot(bool580);
  int callframe581 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call582 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe581);
// compilenode returning call582
// compilenode returning call582
  params[0] = call579;
  params[1] = bool580;
  partcv[0] = 2;
  Object call583 = callmethod(call582, "new",
    1, partcv, params);
  gc_frame_end(callframe577);
// compilenode returning call583
  *var_o = call583;
  if (call583 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit586 == NULL) {
    strlit586 = alloc_String("_");
    gc_root(strlit586);
  }
// compilenode returning strlit586
  int op_slot_right_585 = gc_frame_newslot(strlit586);
  int callframe588 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call589 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe588);
// compilenode returning call589
// compilenode returning call589
  int op_slot_left_585 = gc_frame_newslot(call589);
  params[0] = strlit586;
  partcv[0] = 1;
  Object opresult590 = callmethod(call589, "==", 1, partcv, params);
// compilenode returning opresult590
  Object if584 = done;
  if (istrue(opresult590)) {
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe591 = gc_frame_new();
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_auto_count
  int op_slot_right_592 = gc_frame_newslot(*var_auto_count);
  if (strlit594 == NULL) {
    strlit594 = alloc_String("__");
    gc_root(strlit594);
  }
// compilenode returning strlit594
  int op_slot_left_592 = gc_frame_newslot(strlit594);
  params[0] = *var_auto_count;
  partcv[0] = 1;
  Object opresult595 = callmethod(strlit594, "++", 1, partcv, params);
// compilenode returning opresult595
  gc_frame_newslot(opresult595);
// compilenode returning *var_o
  params[0] = opresult595;
  partcv[0] = 1;
  Object call596 = callmethod(*var_o, "value:=",
    1, partcv, params);
  gc_frame_end(callframe591);
// compilenode returning call596
// compilenode returning done
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe597 = gc_frame_new();
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool598 = alloc_Boolean(1);
// compilenode returning bool598
  gc_frame_newslot(bool598);
// compilenode returning *var_o
  params[0] = bool598;
  partcv[0] = 1;
  Object call599 = callmethod(*var_o, "wildcard:=",
    1, partcv, params);
  gc_frame_end(callframe597);
// compilenode returning call599
// compilenode returning done
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num601 = alloc_Float64(1);
// compilenode returning num601
  int op_slot_right_600 = gc_frame_newslot(num601);
// compilenode returning *var_auto_count
  int op_slot_left_600 = gc_frame_newslot(*var_auto_count);
  params[0] = num601;
  partcv[0] = 1;
  Object sum603 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compilenode returning sum603
  *var_auto_count = sum603;
  if (sum603 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if584 = done;
  } else {
  }
// compilenode returning if584
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe605 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call606 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe605);
// compilenode returning call606
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe607 = gc_frame_new();
  partcv[0] = 0;
  Object call608 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe607);
// compilenode returning call608
  gc_frame_end(frame);
  return call608;
}
Object meth_parser__apply630(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object bool632 = alloc_Boolean(0);
// compilenode returning bool632
  int op_slot_right_631 = gc_frame_newslot(bool632);
  int callframe634 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call635 = callmethod(*var_a, "dtype",
    1, partcv, params);
  gc_frame_end(callframe634);
// compilenode returning call635
// compilenode returning call635
  int op_slot_left_631 = gc_frame_newslot(call635);
  params[0] = bool632;
  partcv[0] = 1;
  Object opresult636 = callmethod(call635, "!=", 1, partcv, params);
// compilenode returning opresult636
  gc_frame_end(frame);
  return opresult636;
}
Object meth_parser__apply647(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit649 == NULL) {
    strlit649 = alloc_String(":");
    gc_root(strlit649);
  }
// compilenode returning strlit649
  int op_slot_right_648 = gc_frame_newslot(strlit649);
  int callframe651 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call652 = callmethod(*var_tok, "value",
    1, partcv, params);
  gc_frame_end(callframe651);
// compilenode returning call652
// compilenode returning call652
  int op_slot_left_648 = gc_frame_newslot(call652);
  params[0] = strlit649;
  partcv[0] = 1;
  Object opresult653 = callmethod(call652, "!=", 1, partcv, params);
// compilenode returning opresult653
  gc_frame_end(frame);
  return opresult653;
}
Object meth_parser__apply656(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe657 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call658 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe657);
// compilenode returning call658
// compilenode returning call658
  *var_tok = call658;
  if (call658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply626(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
// Begin line 249
  setline(249);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe628 = gc_frame_new();
  Object block629 = alloc_Block(NULL, NULL, "parser", 240);
  gc_frame_newslot(block629);
  block_savedest(block629);
  Object closure630 = createclosure(2, "_apply");
setclosureframe(closure630, stackframe);
  addtoclosure(closure630, var_a);
  addtoclosure(closure630, selfslot);
  struct UserObject *uo630 = (struct UserObject*)block629;
  uo630->data[0] = (Object)closure630;
  Method *meth_meth_parser__apply630 = addmethod2pos(block629, "_apply", &meth_parser__apply630, 0);
int argcv_meth_parser__apply630[] = {0};
meth_meth_parser__apply630->type = alloc_MethodType(1, argcv_meth_parser__apply630);
  meth_meth_parser__apply630->definitionModule = modulename;
  meth_meth_parser__apply630->definitionLine = 239;
// compilenode returning block629
  gc_frame_newslot(block629);
  if (strlit639 == NULL) {
    strlit639 = alloc_String("identifier");
    gc_root(strlit639);
  }
// compilenode returning strlit639
  int op_slot_right_638 = gc_frame_newslot(strlit639);
  int callframe641 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call642 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe641);
// compilenode returning call642
// compilenode returning call642
  int op_slot_left_638 = gc_frame_newslot(call642);
  params[0] = strlit639;
  partcv[0] = 1;
  Object opresult643 = callmethod(call642, "==", 1, partcv, params);
// compilenode returning opresult643
  params[0] = block629;
  partcv[0] = 1;
  Object call644 = callmethod(opresult643, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe628);
// compilenode returning call644
  Object if627 = done;
  if (istrue(call644)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe645 = gc_frame_new();
  Object block646 = alloc_Block(NULL, NULL, "parser", 243);
  gc_frame_newslot(block646);
  block_savedest(block646);
  Object closure647 = createclosure(2, "_apply");
setclosureframe(closure647, stackframe);
  addtoclosure(closure647, var_tok);
  addtoclosure(closure647, selfslot);
  struct UserObject *uo647 = (struct UserObject*)block646;
  uo647->data[0] = (Object)closure647;
  Method *meth_meth_parser__apply647 = addmethod2pos(block646, "_apply", &meth_parser__apply647, 0);
int argcv_meth_parser__apply647[] = {0};
meth_meth_parser__apply647->type = alloc_MethodType(1, argcv_meth_parser__apply647);
  meth_meth_parser__apply647->definitionModule = modulename;
  meth_meth_parser__apply647->definitionLine = 240;
// compilenode returning block646
  gc_frame_newslot(block646);
  Object block655 = alloc_Block(NULL, NULL, "parser", 243);
  gc_frame_newslot(block655);
  block_savedest(block655);
  Object closure656 = createclosure(2, "_apply");
setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_tok);
  addtoclosure(closure656, selfslot);
  struct UserObject *uo656 = (struct UserObject*)block655;
  uo656->data[0] = (Object)closure656;
  Method *meth_meth_parser__apply656 = addmethod2pos(block655, "_apply", &meth_parser__apply656, 0);
int argcv_meth_parser__apply656[] = {0};
meth_meth_parser__apply656->type = alloc_MethodType(1, argcv_meth_parser__apply656);
  meth_meth_parser__apply656->definitionModule = modulename;
  meth_meth_parser__apply656->definitionLine = 243;
// compilenode returning block655
  gc_frame_newslot(block655);
  params[0] = block646;
  params[1] = block655;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call661 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe645);
// compilenode returning call661
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 244
  setline(244);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe662 = gc_frame_new();
  int callframe663 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call664 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe663);
// compilenode returning call664
// compilenode returning call664
  partcv[0] = 0;
  Object call665 = callmethod(call664, "new",
    1, partcv, params);
  gc_frame_end(callframe662);
// compilenode returning call665
// compilenode returning call665
  *var_suggestion = call665;
  if (call665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe666 = gc_frame_new();
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  int callframe667 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call668 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe667);
// compilenode returning call668
// compilenode returning call668
  gc_frame_newslot(call668);
  Object bool669 = alloc_Boolean(1);
// compilenode returning bool669
  gc_frame_newslot(bool669);
  Object bool670 = alloc_Boolean(0);
// compilenode returning bool670
  gc_frame_newslot(bool670);
// compilenode returning *var_suggestion
  params[0] = *var_tok;
  params[1] = call668;
  params[2] = bool669;
  params[3] = bool670;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call671 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe666);
// compilenode returning call671
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe672 = gc_frame_new();
  if (strlit673 == NULL) {
    strlit673 = alloc_String("An argument to an annotation cannot have a type.");
    gc_root(strlit673);
  }
// compilenode returning strlit673
  gc_frame_newslot(strlit673);
// Begin line 247
  setline(247);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe674 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call675 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe674);
// compilenode returning call675
// compilenode returning call675
  gc_frame_newslot(call675);
  int callframe676 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call677 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe676);
// compilenode returning call677
// compilenode returning call677
  gc_frame_newslot(call677);
  Object num679 = alloc_Float64(1);
// compilenode returning num679
  int op_slot_right_678 = gc_frame_newslot(num679);
  int callframe682 = gc_frame_new();
  int callframe683 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call684 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe683);
// compilenode returning call684
// compilenode returning call684
  partcv[0] = 0;
  Object call685 = callmethod(call684, "size",
    1, partcv, params);
  gc_frame_end(callframe682);
// compilenode returning call685
// compilenode returning call685
  int op_slot_right_681 = gc_frame_newslot(call685);
  int callframe687 = gc_frame_new();
  int callframe688 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call689 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe688);
// compilenode returning call689
// compilenode returning call689
  partcv[0] = 0;
  Object call690 = callmethod(call689, "linePos",
    1, partcv, params);
  gc_frame_end(callframe687);
// compilenode returning call690
// compilenode returning call690
  int op_slot_left_681 = gc_frame_newslot(call690);
  params[0] = call685;
  partcv[0] = 1;
  Object sum691 = callmethod(call690, "+", 1, partcv, params);
// compilenode returning sum691
  int op_slot_left_678 = gc_frame_newslot(sum691);
  params[0] = num679;
  partcv[0] = 1;
  Object diff692 = callmethod(sum691, "-", 1, partcv, params);
// compilenode returning diff692
  gc_frame_newslot(diff692);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit673;
  params[1] = call675;
  params[2] = call677;
  params[3] = diff692;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call693 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe672);
// compilenode returning call693
    gc_frame_newslot(call693);
    if627 = call693;
  } else {
  }
// compilenode returning if627
  gc_frame_end(frame);
  return if627;
}
Object meth_parser__apply621(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 239
  setline(239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe622 = gc_frame_new();
  int callframe623 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call624 = callmethod(*var_p, "args",
    1, partcv, params);
  gc_frame_end(callframe623);
// compilenode returning call624
// compilenode returning call624
  gc_frame_newslot(call624);
  Object block625 = alloc_Block(NULL, NULL, "parser", 239);
  gc_frame_newslot(block625);
  block_savedest(block625);
  Object closure626 = createclosure(3, "_apply");
setclosureframe(closure626, stackframe);
  addtoclosure(closure626, var_sym);
  addtoclosure(closure626, var_errormessages);
  addtoclosure(closure626, selfslot);
  struct UserObject *uo626 = (struct UserObject*)block625;
  uo626->data[0] = (Object)closure626;
  Method *meth_meth_parser__apply626 = addmethod2pos(block625, "_apply", &meth_parser__apply626, 0);
int argcv_meth_parser__apply626[] = {1};
meth_meth_parser__apply626->type = alloc_MethodType(1, argcv_meth_parser__apply626);
  meth_meth_parser__apply626->definitionModule = modulename;
  meth_meth_parser__apply626->definitionLine = 239;
// compilenode returning block625
  gc_frame_newslot(block625);
  params[0] = call624;
  params[1] = block625;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call695 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe622);
// compilenode returning call695
  gc_frame_end(frame);
  return call695;
}
Object meth_parser_checkAnnotation609(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkAnnotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkAnnotation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ann = &(stackframe->slots[0]);
  *var_ann = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for checkAnnotation");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit612 == NULL) {
    strlit612 = alloc_String("call");
    gc_root(strlit612);
  }
// compilenode returning strlit612
  int op_slot_right_611 = gc_frame_newslot(strlit612);
  int callframe614 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call615 = callmethod(*var_ann, "kind",
    1, partcv, params);
  gc_frame_end(callframe614);
// compilenode returning call615
// compilenode returning call615
  int op_slot_left_611 = gc_frame_newslot(call615);
  params[0] = strlit612;
  partcv[0] = 1;
  Object opresult616 = callmethod(call615, "==", 1, partcv, params);
// compilenode returning opresult616
  Object if610 = done;
  if (istrue(opresult616)) {
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe617 = gc_frame_new();
  int callframe618 = gc_frame_new();
// compilenode returning *var_ann
  partcv[0] = 0;
  Object call619 = callmethod(*var_ann, "with",
    1, partcv, params);
  gc_frame_end(callframe618);
// compilenode returning call619
// compilenode returning call619
  gc_frame_newslot(call619);
  Object block620 = alloc_Block(NULL, NULL, "parser", 238);
  gc_frame_newslot(block620);
  block_savedest(block620);
  Object closure621 = createclosure(3, "_apply");
setclosureframe(closure621, stackframe);
  addtoclosure(closure621, var_sym);
  addtoclosure(closure621, var_errormessages);
  addtoclosure(closure621, selfslot);
  struct UserObject *uo621 = (struct UserObject*)block620;
  uo621->data[0] = (Object)closure621;
  Method *meth_meth_parser__apply621 = addmethod2pos(block620, "_apply", &meth_parser__apply621, 0);
int argcv_meth_parser__apply621[] = {1};
meth_meth_parser__apply621->type = alloc_MethodType(1, argcv_meth_parser__apply621);
  meth_meth_parser__apply621->definitionModule = modulename;
  meth_meth_parser__apply621->definitionLine = 238;
// compilenode returning block620
  gc_frame_newslot(block620);
  params[0] = call619;
  params[1] = block620;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call697 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe617);
// compilenode returning call697
    gc_frame_newslot(call697);
    if610 = call697;
  } else {
  }
// compilenode returning if610
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_ann
  gc_frame_end(frame);
  return *var_ann;
}
Object meth_parser__apply702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit704 == NULL) {
    strlit704 = alloc_String("is");
    gc_root(strlit704);
  }
// compilenode returning strlit704
  int op_slot_right_703 = gc_frame_newslot(strlit704);
  int callframe706 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call707 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe706);
// compilenode returning call707
// compilenode returning call707
  int op_slot_left_703 = gc_frame_newslot(call707);
  params[0] = strlit704;
  partcv[0] = 1;
  Object opresult708 = callmethod(call707, "!=", 1, partcv, params);
// compilenode returning opresult708
  gc_frame_end(frame);
  return opresult708;
}
Object meth_parser__apply729(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe730 = gc_frame_new();
  partcv[0] = 0;
  Object call731 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe730);
// compilenode returning call731
  gc_frame_end(frame);
  return call731;
}
Object meth_parser__apply790(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe791 = gc_frame_new();
  if (strlit792 == NULL) {
    strlit792 = alloc_String("comma");
    gc_root(strlit792);
  }
// compilenode returning strlit792
  gc_frame_newslot(strlit792);
  params[0] = strlit792;
  partcv[0] = 1;
  Object call793 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe791);
// compilenode returning call793
  gc_frame_end(frame);
  return call793;
}
Object meth_parser__apply809(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe810 = gc_frame_new();
  partcv[0] = 0;
  Object call811 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe810);
// compilenode returning call811
  gc_frame_end(frame);
  return call811;
}
Object meth_parser__apply796(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_anns = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 278
  setline(278);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe797 = gc_frame_new();
  int callframe798 = gc_frame_new();
  int callframe799 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call800 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe799);
// compilenode returning call800
// compilenode returning call800
  gc_frame_newslot(call800);
  params[0] = call800;
  partcv[0] = 1;
  Object call801 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe798);
// compilenode returning call801
  gc_frame_newslot(call801);
// compilenode returning *var_anns
  params[0] = call801;
  partcv[0] = 1;
  Object call802 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe797);
// compilenode returning call802
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe803 = gc_frame_new();
  partcv[0] = 0;
  Object call804 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe803);
// compilenode returning call804
// Begin line 296
  setline(296);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe806 = gc_frame_new();
  int callframe807 = gc_frame_new();
  Object block808 = alloc_Block(NULL, NULL, "parser", 280);
  gc_frame_newslot(block808);
  block_savedest(block808);
  Object closure809 = createclosure(1, "_apply");
setclosureframe(closure809, stackframe);
  addtoclosure(closure809, selfslot);
  struct UserObject *uo809 = (struct UserObject*)block808;
  uo809->data[0] = (Object)closure809;
  Method *meth_meth_parser__apply809 = addmethod2pos(block808, "_apply", &meth_parser__apply809, 0);
int argcv_meth_parser__apply809[] = {0};
meth_meth_parser__apply809->type = alloc_MethodType(1, argcv_meth_parser__apply809);
  meth_meth_parser__apply809->definitionModule = modulename;
  meth_meth_parser__apply809->definitionLine = 280;
// compilenode returning block808
  gc_frame_newslot(block808);
  params[0] = block808;
  partcv[0] = 1;
  Object call813 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe807);
// compilenode returning call813
  partcv[0] = 0;
  Object call814 = callmethod(call813, "not",
    1, partcv, params);
  gc_frame_end(callframe806);
// compilenode returning call814
// compilenode returning call814
  Object if805 = done;
  if (istrue(call814)) {
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 281
  setline(281);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array815 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array815
  *var_suggestions = array815;
  if (array815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe816 = gc_frame_new();
  int callframe817 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call818 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe817);
// compilenode returning call818
// compilenode returning call818
  partcv[0] = 0;
  Object call819 = callmethod(call818, "new",
    1, partcv, params);
  gc_frame_end(callframe816);
// compilenode returning call819
// compilenode returning call819
  *var_suggestion = call819;
  if (call819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe820 = gc_frame_new();
  if (strlit821 == NULL) {
    strlit821 = alloc_String("bind");
    gc_root(strlit821);
  }
// compilenode returning strlit821
  gc_frame_newslot(strlit821);
  params[0] = strlit821;
  partcv[0] = 1;
  Object call822 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe820);
// compilenode returning call822
  *var_nextTok = call822;
  if (call822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_824 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_824 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult826 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult826
  Object if823 = done;
  if (istrue(opresult826)) {
// Begin line 285
  setline(285);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe827 = gc_frame_new();
  if (strlit828 == NULL) {
    strlit828 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit828);
  }
// compilenode returning strlit828
  gc_frame_newslot(strlit828);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit828;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call829 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe827);
// compilenode returning call829
    gc_frame_newslot(call829);
    if823 = call829;
  } else {
// Begin line 287
  setline(287);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe830 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe831 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call832 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe831);
// compilenode returning call832
// compilenode returning call832
  gc_frame_newslot(call832);
  Object bool833 = alloc_Boolean(1);
// compilenode returning bool833
  gc_frame_newslot(bool833);
  Object bool834 = alloc_Boolean(0);
// compilenode returning bool834
  gc_frame_newslot(bool834);
  if (strlit835 == NULL) {
    strlit835 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit835);
  }
// compilenode returning strlit835
  gc_frame_newslot(strlit835);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call832;
  params[2] = bool833;
  params[3] = bool834;
  params[4] = strlit835;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call836 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe830);
// compilenode returning call836
    gc_frame_newslot(call836);
    if823 = call836;
  }
// compilenode returning if823
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe837 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call838 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe837);
// compilenode returning call838
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 290
  setline(290);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe839 = gc_frame_new();
  int callframe840 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call841 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe840);
// compilenode returning call841
// compilenode returning call841
  partcv[0] = 0;
  Object call842 = callmethod(call841, "new",
    1, partcv, params);
  gc_frame_end(callframe839);
// compilenode returning call842
// compilenode returning call842
  *var_suggestion = call842;
  if (call842 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 291
  setline(291);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe844 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe845 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call846 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe845);
// compilenode returning call846
// compilenode returning call846
  gc_frame_newslot(call846);
  Object bool847 = alloc_Boolean(1);
// compilenode returning bool847
  gc_frame_newslot(bool847);
  Object bool848 = alloc_Boolean(0);
// compilenode returning bool848
  gc_frame_newslot(bool848);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call846;
  params[2] = bool847;
  params[3] = bool848;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call849 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe844);
// compilenode returning call849
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe850 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call851 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe850);
// compilenode returning call851
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe852 = gc_frame_new();
  if (strlit853 == NULL) {
    strlit853 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit853);
  }
// compilenode returning strlit853
  gc_frame_newslot(strlit853);
// Begin line 294
  setline(294);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe854 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call855 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe854);
// compilenode returning call855
// compilenode returning call855
  gc_frame_newslot(call855);
  Object num857 = alloc_Float64(1);
// compilenode returning num857
  int op_slot_right_856 = gc_frame_newslot(num857);
  int callframe860 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call861 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe860);
// compilenode returning call861
// compilenode returning call861
  int op_slot_right_859 = gc_frame_newslot(call861);
  int callframe863 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call864 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe863);
// compilenode returning call864
// compilenode returning call864
  int op_slot_left_859 = gc_frame_newslot(call864);
  params[0] = call861;
  partcv[0] = 1;
  Object sum865 = callmethod(call864, "+", 1, partcv, params);
// compilenode returning sum865
  int op_slot_left_856 = gc_frame_newslot(sum865);
  params[0] = num857;
  partcv[0] = 1;
  Object sum866 = callmethod(sum865, "+", 1, partcv, params);
// compilenode returning sum866
  gc_frame_newslot(sum866);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 293
  setline(293);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit853;
  params[1] = call855;
  params[2] = sum866;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call867 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe852);
// compilenode returning call867
    gc_frame_newslot(call867);
    if805 = call867;
  } else {
  }
// compilenode returning if805
  gc_frame_end(frame);
  return if805;
}
Object meth_parser_doannotation698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doannotation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_collections = getfromclosure(closure, 1);
  Object *var_don_39_tTakeBlock = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doannotation (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doannotation");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_anns = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "anns");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 255
  setline(255);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe700 = gc_frame_new();
  Object block701 = alloc_Block(NULL, NULL, "parser", 255);
  gc_frame_newslot(block701);
  block_savedest(block701);
  Object closure702 = createclosure(2, "_apply");
setclosureframe(closure702, stackframe);
  addtoclosure(closure702, var_sym);
  addtoclosure(closure702, selfslot);
  struct UserObject *uo702 = (struct UserObject*)block701;
  uo702->data[0] = (Object)closure702;
  Method *meth_meth_parser__apply702 = addmethod2pos(block701, "_apply", &meth_parser__apply702, 0);
int argcv_meth_parser__apply702[] = {0};
meth_meth_parser__apply702->type = alloc_MethodType(1, argcv_meth_parser__apply702);
  meth_meth_parser__apply702->definitionModule = modulename;
  meth_meth_parser__apply702->definitionLine = 247;
// compilenode returning block701
  gc_frame_newslot(block701);
  int callframe710 = gc_frame_new();
  int callframe711 = gc_frame_new();
  if (strlit712 == NULL) {
    strlit712 = alloc_String("keyword");
    gc_root(strlit712);
  }
// compilenode returning strlit712
  gc_frame_newslot(strlit712);
  params[0] = strlit712;
  partcv[0] = 1;
  Object call713 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe711);
// compilenode returning call713
  partcv[0] = 0;
  Object call714 = callmethod(call713, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe710);
// compilenode returning call714
  params[0] = block701;
  partcv[0] = 1;
  Object call715 = callmethod(call714, "orElse",
    1, partcv, params);
  gc_frame_end(callframe700);
// compilenode returning call715
  Object if699 = done;
  if (istrue(call715)) {
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool716 = alloc_Boolean(0);
// compilenode returning bool716
  return bool716;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if699 = undefined;
  } else {
  }
// compilenode returning if699
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe717 = gc_frame_new();
  partcv[0] = 0;
  Object call718 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe717);
// compilenode returning call718
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe719 = gc_frame_new();
  int callframe720 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call721 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe720);
// compilenode returning call721
// compilenode returning call721
  partcv[0] = 0;
  Object call722 = callmethod(call721, "new",
    1, partcv, params);
  gc_frame_end(callframe719);
// compilenode returning call722
// compilenode returning call722
  *var_anns = call722;
  if (call722 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 260
  setline(260);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool723 = alloc_Boolean(1);
// compilenode returning bool723
  *var_don_39_tTakeBlock = bool723;
  if (bool723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe726 = gc_frame_new();
  int callframe727 = gc_frame_new();
  Object block728 = alloc_Block(NULL, NULL, "parser", 261);
  gc_frame_newslot(block728);
  block_savedest(block728);
  Object closure729 = createclosure(1, "_apply");
setclosureframe(closure729, stackframe);
  addtoclosure(closure729, selfslot);
  struct UserObject *uo729 = (struct UserObject*)block728;
  uo729->data[0] = (Object)closure729;
  Method *meth_meth_parser__apply729 = addmethod2pos(block728, "_apply", &meth_parser__apply729, 0);
int argcv_meth_parser__apply729[] = {0};
meth_meth_parser__apply729->type = alloc_MethodType(1, argcv_meth_parser__apply729);
  meth_meth_parser__apply729->definitionModule = modulename;
  meth_meth_parser__apply729->definitionLine = 261;
// compilenode returning block728
  gc_frame_newslot(block728);
  params[0] = block728;
  partcv[0] = 1;
  Object call733 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe727);
// compilenode returning call733
  partcv[0] = 0;
  Object call734 = callmethod(call733, "not",
    1, partcv, params);
  gc_frame_end(callframe726);
// compilenode returning call734
// compilenode returning call734
  Object if725 = done;
  if (istrue(call734)) {
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array735 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array735
  *var_suggestions = array735;
  if (array735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe736 = gc_frame_new();
  int callframe737 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call738 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe737);
// compilenode returning call738
// compilenode returning call738
  partcv[0] = 0;
  Object call739 = callmethod(call738, "new",
    1, partcv, params);
  gc_frame_end(callframe736);
// compilenode returning call739
// compilenode returning call739
  *var_suggestion = call739;
  if (call739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe740 = gc_frame_new();
  if (strlit741 == NULL) {
    strlit741 = alloc_String("bind");
    gc_root(strlit741);
  }
// compilenode returning strlit741
  gc_frame_newslot(strlit741);
  params[0] = strlit741;
  partcv[0] = 1;
  Object call742 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe740);
// compilenode returning call742
  *var_nextTok = call742;
  if (call742 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_744 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_744 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult746 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult746
  Object if743 = done;
  if (istrue(opresult746)) {
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe747 = gc_frame_new();
  if (strlit748 == NULL) {
    strlit748 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit748);
  }
// compilenode returning strlit748
  gc_frame_newslot(strlit748);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit748;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call749 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe747);
// compilenode returning call749
    gc_frame_newslot(call749);
    if743 = call749;
  } else {
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe750 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe751 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call752 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe751);
// compilenode returning call752
// compilenode returning call752
  gc_frame_newslot(call752);
  Object bool753 = alloc_Boolean(1);
// compilenode returning bool753
  gc_frame_newslot(bool753);
  Object bool754 = alloc_Boolean(0);
// compilenode returning bool754
  gc_frame_newslot(bool754);
  if (strlit755 == NULL) {
    strlit755 = alloc_String(" ""\xc2""""\xab""annotation""\xc2""""\xbb""");
    gc_root(strlit755);
  }
// compilenode returning strlit755
  gc_frame_newslot(strlit755);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call752;
  params[2] = bool753;
  params[3] = bool754;
  params[4] = strlit755;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call756 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe750);
// compilenode returning call756
    gc_frame_newslot(call756);
    if743 = call756;
  }
// compilenode returning if743
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe757 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call758 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe757);
// compilenode returning call758
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe759 = gc_frame_new();
  int callframe760 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call761 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe760);
// compilenode returning call761
// compilenode returning call761
  partcv[0] = 0;
  Object call762 = callmethod(call761, "new",
    1, partcv, params);
  gc_frame_end(callframe759);
// compilenode returning call762
// compilenode returning call762
  *var_suggestion = call762;
  if (call762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 272
  setline(272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe764 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe765 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call766 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe765);
// compilenode returning call766
// compilenode returning call766
  gc_frame_newslot(call766);
  Object bool767 = alloc_Boolean(1);
// compilenode returning bool767
  gc_frame_newslot(bool767);
  Object bool768 = alloc_Boolean(0);
// compilenode returning bool768
  gc_frame_newslot(bool768);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call766;
  params[2] = bool767;
  params[3] = bool768;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call769 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe764);
// compilenode returning call769
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe770 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call771 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe770);
// compilenode returning call771
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe772 = gc_frame_new();
  if (strlit773 == NULL) {
    strlit773 = alloc_String("One or more annotations separated by commas must follow 'is'.");
    gc_root(strlit773);
  }
// compilenode returning strlit773
  gc_frame_newslot(strlit773);
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe774 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call775 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe774);
// compilenode returning call775
// compilenode returning call775
  gc_frame_newslot(call775);
  Object num777 = alloc_Float64(1);
// compilenode returning num777
  int op_slot_right_776 = gc_frame_newslot(num777);
  int callframe780 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call781 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe780);
// compilenode returning call781
// compilenode returning call781
  int op_slot_right_779 = gc_frame_newslot(call781);
  int callframe783 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call784 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe783);
// compilenode returning call784
// compilenode returning call784
  int op_slot_left_779 = gc_frame_newslot(call784);
  params[0] = call781;
  partcv[0] = 1;
  Object sum785 = callmethod(call784, "+", 1, partcv, params);
// compilenode returning sum785
  int op_slot_left_776 = gc_frame_newslot(sum785);
  params[0] = num777;
  partcv[0] = 1;
  Object sum786 = callmethod(sum785, "+", 1, partcv, params);
// compilenode returning sum786
  gc_frame_newslot(sum786);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 274
  setline(274);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit773;
  params[1] = call775;
  params[2] = sum786;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call787 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe772);
// compilenode returning call787
    gc_frame_newslot(call787);
    if725 = call787;
  } else {
  }
// compilenode returning if725
// Begin line 277
  setline(277);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe788 = gc_frame_new();
  Object block789 = alloc_Block(NULL, NULL, "parser", 277);
  gc_frame_newslot(block789);
  block_savedest(block789);
  Object closure790 = createclosure(1, "_apply");
setclosureframe(closure790, stackframe);
  addtoclosure(closure790, selfslot);
  struct UserObject *uo790 = (struct UserObject*)block789;
  uo790->data[0] = (Object)closure790;
  Method *meth_meth_parser__apply790 = addmethod2pos(block789, "_apply", &meth_parser__apply790, 0);
int argcv_meth_parser__apply790[] = {0};
meth_meth_parser__apply790->type = alloc_MethodType(1, argcv_meth_parser__apply790);
  meth_meth_parser__apply790->definitionModule = modulename;
  meth_meth_parser__apply790->definitionLine = 275;
// compilenode returning block789
  gc_frame_newslot(block789);
  Object block795 = alloc_Block(NULL, NULL, "parser", 277);
  gc_frame_newslot(block795);
  block_savedest(block795);
  Object closure796 = createclosure(6, "_apply");
setclosureframe(closure796, stackframe);
  addtoclosure(closure796, var_values);
  addtoclosure(closure796, var_anns);
  addtoclosure(closure796, var_errormessages);
  addtoclosure(closure796, var_sym);
  addtoclosure(closure796, var_lastToken);
  addtoclosure(closure796, selfslot);
  struct UserObject *uo796 = (struct UserObject*)block795;
  uo796->data[0] = (Object)closure796;
  Method *meth_meth_parser__apply796 = addmethod2pos(block795, "_apply", &meth_parser__apply796, 0);
int argcv_meth_parser__apply796[] = {0};
meth_meth_parser__apply796->type = alloc_MethodType(1, argcv_meth_parser__apply796);
  meth_meth_parser__apply796->definitionModule = modulename;
  meth_meth_parser__apply796->definitionLine = 275;
// compilenode returning block795
  gc_frame_newslot(block795);
  params[0] = block789;
  params[1] = block795;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call869 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe788);
// compilenode returning call869
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 297
  setline(297);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool870 = alloc_Boolean(0);
// compilenode returning bool870
  *var_don_39_tTakeBlock = bool870;
  if (bool870 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe872 = gc_frame_new();
  int callframe873 = gc_frame_new();
  int callframe874 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call875 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe874);
// compilenode returning call875
// compilenode returning call875
  gc_frame_newslot(call875);
  params[0] = call875;
  partcv[0] = 1;
  Object call876 = callmethodflags(self, "checkAnnotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe873);
// compilenode returning call876
  gc_frame_newslot(call876);
// compilenode returning *var_anns
  params[0] = call876;
  partcv[0] = 1;
  Object call877 = callmethod(*var_anns, "push",
    1, partcv, params);
  gc_frame_end(callframe872);
// compilenode returning call877
// Begin line 299
  setline(299);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_anns
  gc_frame_end(frame);
  return *var_anns;
}
Object meth_parser_blank878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "blank");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for blank (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for blank");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num882 = alloc_Float64(1);
// compilenode returning num882
  int op_slot_right_881 = gc_frame_newslot(num882);
  int callframe884 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call885 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe884);
// compilenode returning call885
// compilenode returning call885
  int op_slot_left_881 = gc_frame_newslot(call885);
  params[0] = num882;
  partcv[0] = 1;
  Object sum886 = callmethod(call885, "+", 1, partcv, params);
// compilenode returning sum886
  int op_slot_right_880 = gc_frame_newslot(sum886);
  int callframe888 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call889 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe888);
// compilenode returning call889
// compilenode returning call889
  int op_slot_left_880 = gc_frame_newslot(call889);
  params[0] = sum886;
  partcv[0] = 1;
  Object opresult890 = callmethod(call889, ">", 1, partcv, params);
// compilenode returning opresult890
  Object if879 = done;
  if (istrue(opresult890)) {
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num893 = alloc_Float64(0);
// compilenode returning num893
  int op_slot_right_892 = gc_frame_newslot(num893);
  int callframe895 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call896 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe895);
// compilenode returning call896
// compilenode returning call896
  int op_slot_left_892 = gc_frame_newslot(call896);
  params[0] = num893;
  partcv[0] = 1;
  Object opresult897 = callmethod(call896, ">", 1, partcv, params);
// compilenode returning opresult897
  Object if891 = done;
  if (istrue(opresult897)) {
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit900 == NULL) {
    strlit900 = alloc_String("blank");
    gc_root(strlit900);
  }
// compilenode returning strlit900
  int op_slot_right_899 = gc_frame_newslot(strlit900);
  int callframe902 = gc_frame_new();
  int callframe903 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call904 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe903);
// compilenode returning call904
// compilenode returning call904
  partcv[0] = 0;
  Object call905 = callmethod(call904, "kind",
    1, partcv, params);
  gc_frame_end(callframe902);
// compilenode returning call905
// compilenode returning call905
  int op_slot_left_899 = gc_frame_newslot(call905);
  params[0] = strlit900;
  partcv[0] = 1;
  Object opresult906 = callmethod(call905, "!=", 1, partcv, params);
// compilenode returning opresult906
  Object if898 = done;
  if (istrue(opresult906)) {
// Begin line 306
  setline(306);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe907 = gc_frame_new();
  int callframe908 = gc_frame_new();
  int callframe909 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call910 = callmethod(*var_ast, "blankNode",
    1, partcv, params);
  gc_frame_end(callframe909);
// compilenode returning call910
// compilenode returning call910
  partcv[0] = 0;
  Object call911 = callmethod(call910, "new",
    1, partcv, params);
  gc_frame_end(callframe908);
// compilenode returning call911
// compilenode returning call911
  gc_frame_newslot(call911);
// compilenode returning *var_values
  params[0] = call911;
  partcv[0] = 1;
  Object call912 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe907);
// compilenode returning call912
    gc_frame_newslot(call912);
    if898 = call912;
  } else {
  }
// compilenode returning if898
    gc_frame_newslot(if898);
    if891 = if898;
  } else {
  }
// compilenode returning if891
    gc_frame_newslot(if891);
    if879 = if891;
  } else {
  }
// compilenode returning if879
  gc_frame_end(frame);
  return if879;
}
Object meth_parser__apply931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit933 == NULL) {
    strlit933 = alloc_String("type");
    gc_root(strlit933);
  }
// compilenode returning strlit933
  int op_slot_right_932 = gc_frame_newslot(strlit933);
  int callframe935 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call936 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe935);
// compilenode returning call936
// compilenode returning call936
  int op_slot_left_932 = gc_frame_newslot(call936);
  params[0] = strlit933;
  partcv[0] = 1;
  Object opresult937 = callmethod(call936, "==", 1, partcv, params);
// compilenode returning opresult937
  gc_frame_end(frame);
  return opresult937;
}
Object meth_parser_dotypeterm913(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotypeterm");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_don_39_tTakeBlock = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotypeterm (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dotypeterm");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe915 = gc_frame_new();
  if (strlit916 == NULL) {
    strlit916 = alloc_String("identifier");
    gc_root(strlit916);
  }
// compilenode returning strlit916
  gc_frame_newslot(strlit916);
  params[0] = strlit916;
  partcv[0] = 1;
  Object call917 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe915);
// compilenode returning call917
  Object if914 = done;
  if (istrue(call917)) {
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe918 = gc_frame_new();
  partcv[0] = 0;
  Object call919 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe918);
// compilenode returning call919
// Begin line 315
  setline(315);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe920 = gc_frame_new();
  partcv[0] = 0;
  Object call921 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compilenode returning call921
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool922 = alloc_Boolean(1);
// compilenode returning bool922
  *var_don_39_tTakeBlock = bool922;
  if (bool922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe924 = gc_frame_new();
  partcv[0] = 0;
  Object call925 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe924);
// compilenode returning call925
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool926 = alloc_Boolean(0);
// compilenode returning bool926
  *var_don_39_tTakeBlock = bool926;
  if (bool926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if914 = done;
  } else {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe929 = gc_frame_new();
  Object block930 = alloc_Block(NULL, NULL, "parser", 320);
  gc_frame_newslot(block930);
  block_savedest(block930);
  Object closure931 = createclosure(2, "_apply");
setclosureframe(closure931, stackframe);
  addtoclosure(closure931, var_sym);
  addtoclosure(closure931, selfslot);
  struct UserObject *uo931 = (struct UserObject*)block930;
  uo931->data[0] = (Object)closure931;
  Method *meth_meth_parser__apply931 = addmethod2pos(block930, "_apply", &meth_parser__apply931, 0);
int argcv_meth_parser__apply931[] = {0};
meth_meth_parser__apply931->type = alloc_MethodType(1, argcv_meth_parser__apply931);
  meth_meth_parser__apply931->definitionModule = modulename;
  meth_meth_parser__apply931->definitionLine = 306;
// compilenode returning block930
  gc_frame_newslot(block930);
  int callframe939 = gc_frame_new();
  if (strlit940 == NULL) {
    strlit940 = alloc_String("keyword");
    gc_root(strlit940);
  }
// compilenode returning strlit940
  gc_frame_newslot(strlit940);
  params[0] = strlit940;
  partcv[0] = 1;
  Object call941 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe939);
// compilenode returning call941
  params[0] = block930;
  partcv[0] = 1;
  Object call942 = callmethod(call941, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe929);
// compilenode returning call942
  Object if928 = done;
  if (istrue(call942)) {
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe943 = gc_frame_new();
  partcv[0] = 0;
  Object call944 = callmethodflags(self, "doanontype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe943);
// compilenode returning call944
    gc_frame_newslot(call944);
    if928 = call944;
  } else {
  }
// compilenode returning if928
    gc_frame_newslot(if928);
    if914 = if928;
  }
// compilenode returning if914
  gc_frame_end(frame);
  return if914;
}
Object meth_parser__apply954(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe955 = gc_frame_new();
  partcv[0] = 0;
  Object call956 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compilenode returning call956
  gc_frame_end(frame);
  return call956;
}
Object meth_parser__apply1008(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit1011 == NULL) {
    strlit1011 = alloc_String("|");
    gc_root(strlit1011);
  }
// compilenode returning strlit1011
  int op_slot_right_1010 = gc_frame_newslot(strlit1011);
  int callframe1013 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1014 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1013);
// compilenode returning call1014
// compilenode returning call1014
  int op_slot_left_1010 = gc_frame_newslot(call1014);
  params[0] = strlit1011;
  partcv[0] = 1;
  Object opresult1015 = callmethod(call1014, "==", 1, partcv, params);
// compilenode returning opresult1015
  int op_slot_right_1009 = gc_frame_newslot(opresult1015);
  int callframe1017 = gc_frame_new();
  if (strlit1018 == NULL) {
    strlit1018 = alloc_String("op");
    gc_root(strlit1018);
  }
// compilenode returning strlit1018
  gc_frame_newslot(strlit1018);
  params[0] = strlit1018;
  partcv[0] = 1;
  Object call1019 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1017);
// compilenode returning call1019
  int op_slot_left_1009 = gc_frame_newslot(call1019);
  params[0] = opresult1015;
  partcv[0] = 1;
  Object opresult1020 = callmethod(call1019, "&&", 1, partcv, params);
// compilenode returning opresult1020
  gc_frame_end(frame);
  return opresult1020;
}
Object meth_parser__apply1039(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1040 = gc_frame_new();
  partcv[0] = 0;
  Object call1041 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1040);
// compilenode returning call1041
  gc_frame_end(frame);
  return call1041;
}
Object meth_parser__apply1023(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_unionTypes = getfromclosure(closure, 0);
  Object *var_overallType = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1026 = alloc_Float64(0);
// compilenode returning num1026
  int op_slot_right_1025 = gc_frame_newslot(num1026);
  int callframe1028 = gc_frame_new();
// compilenode returning *var_unionTypes
  partcv[0] = 0;
  Object call1029 = callmethod(*var_unionTypes, "size",
    1, partcv, params);
  gc_frame_end(callframe1028);
// compilenode returning call1029
// compilenode returning call1029
  int op_slot_left_1025 = gc_frame_newslot(call1029);
  params[0] = num1026;
  partcv[0] = 1;
  Object opresult1030 = callmethod(call1029, "==", 1, partcv, params);
// compilenode returning opresult1030
  Object if1024 = done;
  if (istrue(opresult1030)) {
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1031 = gc_frame_new();
// compilenode returning *var_overallType
  gc_frame_newslot(*var_overallType);
// compilenode returning *var_unionTypes
  params[0] = *var_overallType;
  partcv[0] = 1;
  Object call1032 = callmethod(*var_unionTypes, "push",
    1, partcv, params);
  gc_frame_end(callframe1031);
// compilenode returning call1032
    gc_frame_newslot(call1032);
    if1024 = call1032;
  } else {
  }
// compilenode returning if1024
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1033 = gc_frame_new();
  partcv[0] = 0;
  Object call1034 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1033);
// compilenode returning call1034
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1036 = gc_frame_new();
  int callframe1037 = gc_frame_new();
  Object block1038 = alloc_Block(NULL, NULL, "parser", 353);
  gc_frame_newslot(block1038);
  block_savedest(block1038);
  Object closure1039 = createclosure(1, "_apply");
setclosureframe(closure1039, stackframe);
  addtoclosure(closure1039, selfslot);
  struct UserObject *uo1039 = (struct UserObject*)block1038;
  uo1039->data[0] = (Object)closure1039;
  Method *meth_meth_parser__apply1039 = addmethod2pos(block1038, "_apply", &meth_parser__apply1039, 0);
int argcv_meth_parser__apply1039[] = {0};
meth_meth_parser__apply1039->type = alloc_MethodType(1, argcv_meth_parser__apply1039);
  meth_meth_parser__apply1039->definitionModule = modulename;
  meth_meth_parser__apply1039->definitionLine = 353;
// compilenode returning block1038
  gc_frame_newslot(block1038);
  params[0] = block1038;
  partcv[0] = 1;
  Object call1043 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1037);
// compilenode returning call1043
  partcv[0] = 0;
  Object call1044 = callmethod(call1043, "not",
    1, partcv, params);
  gc_frame_end(callframe1036);
// compilenode returning call1044
// compilenode returning call1044
  Object if1035 = done;
  if (istrue(call1044)) {
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1045 = gc_frame_new();
  partcv[0] = 0;
  Object call1046 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1045);
// compilenode returning call1046
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1047 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1047
  *var_suggestions = array1047;
  if (array1047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1048 = gc_frame_new();
  int callframe1049 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1050 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1049);
// compilenode returning call1050
// compilenode returning call1050
  partcv[0] = 0;
  Object call1051 = callmethod(call1050, "new",
    1, partcv, params);
  gc_frame_end(callframe1048);
// compilenode returning call1051
// compilenode returning call1051
  *var_suggestion = call1051;
  if (call1051 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 357
  setline(357);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1052 = gc_frame_new();
  if (strlit1053 == NULL) {
    strlit1053 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit1053);
  }
// compilenode returning strlit1053
  gc_frame_newslot(strlit1053);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1053;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1054 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1052);
// compilenode returning call1054
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1055 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1056 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1055);
// compilenode returning call1056
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1057 = gc_frame_new();
  int callframe1058 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1059 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1058);
// compilenode returning call1059
// compilenode returning call1059
  partcv[0] = 0;
  Object call1060 = callmethod(call1059, "new",
    1, partcv, params);
  gc_frame_end(callframe1057);
// compilenode returning call1060
// compilenode returning call1060
  *var_suggestion = call1060;
  if (call1060 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1062 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call1063 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe1062);
// compilenode returning call1063
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1064 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1065 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1064);
// compilenode returning call1065
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1066 = gc_frame_new();
  if (strlit1067 == NULL) {
    strlit1067 = alloc_String("A type name or type expression must follow '|'.");
    gc_root(strlit1067);
  }
// compilenode returning strlit1067
  gc_frame_newslot(strlit1067);
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1068 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1069 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1068);
// compilenode returning call1069
// compilenode returning call1069
  gc_frame_newslot(call1069);
  int callframe1070 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1071 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1070);
// compilenode returning call1071
// compilenode returning call1071
  gc_frame_newslot(call1071);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1067;
  params[1] = call1069;
  params[2] = call1071;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1072 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1066);
// compilenode returning call1072
    gc_frame_newslot(call1072);
    if1035 = call1072;
  } else {
  }
// compilenode returning if1035
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1073 = gc_frame_new();
  int callframe1074 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1075 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1074);
// compilenode returning call1075
// compilenode returning call1075
  gc_frame_newslot(call1075);
// compilenode returning *var_unionTypes
  params[0] = call1075;
  partcv[0] = 1;
  Object call1076 = callmethod(*var_unionTypes, "push",
    1, partcv, params);
  gc_frame_end(callframe1073);
// compilenode returning call1076
  gc_frame_end(frame);
  return call1076;
}
Object meth_parser__apply1089(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_unionName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("");
    gc_root(strlit1091);
  }
// compilenode returning strlit1091
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
  int callframe1094 = gc_frame_new();
// compilenode returning *var_ut
  partcv[0] = 0;
  Object call1095 = callmethod(*var_ut, "value",
    1, partcv, params);
  gc_frame_end(callframe1094);
// compilenode returning call1095
// compilenode returning call1095
  int op_slot_right_1093 = gc_frame_newslot(call1095);
  if (strlit1098 == NULL) {
    strlit1098 = alloc_String("|");
    gc_root(strlit1098);
  }
// compilenode returning strlit1098
  int op_slot_right_1097 = gc_frame_newslot(strlit1098);
// compilenode returning *var_unionName
  int op_slot_right_1100 = gc_frame_newslot(*var_unionName);
  if (strlit1102 == NULL) {
    strlit1102 = alloc_String("");
    gc_root(strlit1102);
  }
// compilenode returning strlit1102
  int op_slot_left_1100 = gc_frame_newslot(strlit1102);
  params[0] = *var_unionName;
  partcv[0] = 1;
  Object opresult1103 = callmethod(strlit1102, "++", 1, partcv, params);
// compilenode returning opresult1103
  int op_slot_left_1097 = gc_frame_newslot(opresult1103);
  params[0] = strlit1098;
  partcv[0] = 1;
  Object opresult1104 = callmethod(opresult1103, "++", 1, partcv, params);
// compilenode returning opresult1104
  int op_slot_left_1093 = gc_frame_newslot(opresult1104);
  params[0] = call1095;
  partcv[0] = 1;
  Object opresult1105 = callmethod(opresult1104, "++", 1, partcv, params);
// compilenode returning opresult1105
  int op_slot_left_1090 = gc_frame_newslot(opresult1105);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1106 = callmethod(opresult1105, "++", 1, partcv, params);
// compilenode returning opresult1106
  *var_unionName = opresult1106;
  if (opresult1106 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply1127(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_overallType = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1128 = gc_frame_new();
// compilenode returning *var_ut
  gc_frame_newslot(*var_ut);
  int callframe1129 = gc_frame_new();
// compilenode returning *var_overallType
  partcv[0] = 0;
  Object call1130 = callmethod(*var_overallType, "unionTypes",
    1, partcv, params);
  gc_frame_end(callframe1129);
// compilenode returning call1130
// compilenode returning call1130
  params[0] = *var_ut;
  partcv[0] = 1;
  Object call1131 = callmethod(call1130, "push",
    1, partcv, params);
  gc_frame_end(callframe1128);
// compilenode returning call1131
  gc_frame_end(frame);
  return call1131;
}
Object meth_parser__apply1137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit1140 == NULL) {
    strlit1140 = alloc_String("&");
    gc_root(strlit1140);
  }
// compilenode returning strlit1140
  int op_slot_right_1139 = gc_frame_newslot(strlit1140);
  int callframe1142 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1143 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1142);
// compilenode returning call1143
// compilenode returning call1143
  int op_slot_left_1139 = gc_frame_newslot(call1143);
  params[0] = strlit1140;
  partcv[0] = 1;
  Object opresult1144 = callmethod(call1143, "==", 1, partcv, params);
// compilenode returning opresult1144
  int op_slot_right_1138 = gc_frame_newslot(opresult1144);
  int callframe1146 = gc_frame_new();
  if (strlit1147 == NULL) {
    strlit1147 = alloc_String("op");
    gc_root(strlit1147);
  }
// compilenode returning strlit1147
  gc_frame_newslot(strlit1147);
  params[0] = strlit1147;
  partcv[0] = 1;
  Object call1148 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1146);
// compilenode returning call1148
  int op_slot_left_1138 = gc_frame_newslot(call1148);
  params[0] = opresult1144;
  partcv[0] = 1;
  Object opresult1149 = callmethod(call1148, "&&", 1, partcv, params);
// compilenode returning opresult1149
  gc_frame_end(frame);
  return opresult1149;
}
Object meth_parser__apply1168(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1169 = gc_frame_new();
  partcv[0] = 0;
  Object call1170 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1169);
// compilenode returning call1170
  gc_frame_end(frame);
  return call1170;
}
Object meth_parser__apply1152(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_intersectionTypes = getfromclosure(closure, 0);
  Object *var_overallType = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1155 = alloc_Float64(0);
// compilenode returning num1155
  int op_slot_right_1154 = gc_frame_newslot(num1155);
  int callframe1157 = gc_frame_new();
// compilenode returning *var_intersectionTypes
  partcv[0] = 0;
  Object call1158 = callmethod(*var_intersectionTypes, "size",
    1, partcv, params);
  gc_frame_end(callframe1157);
// compilenode returning call1158
// compilenode returning call1158
  int op_slot_left_1154 = gc_frame_newslot(call1158);
  params[0] = num1155;
  partcv[0] = 1;
  Object opresult1159 = callmethod(call1158, "==", 1, partcv, params);
// compilenode returning opresult1159
  Object if1153 = done;
  if (istrue(opresult1159)) {
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1160 = gc_frame_new();
// compilenode returning *var_overallType
  gc_frame_newslot(*var_overallType);
// compilenode returning *var_intersectionTypes
  params[0] = *var_overallType;
  partcv[0] = 1;
  Object call1161 = callmethod(*var_intersectionTypes, "push",
    1, partcv, params);
  gc_frame_end(callframe1160);
// compilenode returning call1161
    gc_frame_newslot(call1161);
    if1153 = call1161;
  } else {
  }
// compilenode returning if1153
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1162 = gc_frame_new();
  partcv[0] = 0;
  Object call1163 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1162);
// compilenode returning call1163
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1165 = gc_frame_new();
  int callframe1166 = gc_frame_new();
  Object block1167 = alloc_Block(NULL, NULL, "parser", 384);
  gc_frame_newslot(block1167);
  block_savedest(block1167);
  Object closure1168 = createclosure(1, "_apply");
setclosureframe(closure1168, stackframe);
  addtoclosure(closure1168, selfslot);
  struct UserObject *uo1168 = (struct UserObject*)block1167;
  uo1168->data[0] = (Object)closure1168;
  Method *meth_meth_parser__apply1168 = addmethod2pos(block1167, "_apply", &meth_parser__apply1168, 0);
int argcv_meth_parser__apply1168[] = {0};
meth_meth_parser__apply1168->type = alloc_MethodType(1, argcv_meth_parser__apply1168);
  meth_meth_parser__apply1168->definitionModule = modulename;
  meth_meth_parser__apply1168->definitionLine = 384;
// compilenode returning block1167
  gc_frame_newslot(block1167);
  params[0] = block1167;
  partcv[0] = 1;
  Object call1172 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1166);
// compilenode returning call1172
  partcv[0] = 0;
  Object call1173 = callmethod(call1172, "not",
    1, partcv, params);
  gc_frame_end(callframe1165);
// compilenode returning call1173
// compilenode returning call1173
  Object if1164 = done;
  if (istrue(call1173)) {
// Begin line 385
  setline(385);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1174 = gc_frame_new();
  partcv[0] = 0;
  Object call1175 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1174);
// compilenode returning call1175
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1176 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1176
  *var_suggestions = array1176;
  if (array1176 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1177 = gc_frame_new();
  int callframe1178 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1179 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1178);
// compilenode returning call1179
// compilenode returning call1179
  partcv[0] = 0;
  Object call1180 = callmethod(call1179, "new",
    1, partcv, params);
  gc_frame_end(callframe1177);
// compilenode returning call1180
// compilenode returning call1180
  *var_suggestion = call1180;
  if (call1180 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1181 = gc_frame_new();
  if (strlit1182 == NULL) {
    strlit1182 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit1182);
  }
// compilenode returning strlit1182
  gc_frame_newslot(strlit1182);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1182;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1183 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1181);
// compilenode returning call1183
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1184 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1185 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1184);
// compilenode returning call1185
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1186 = gc_frame_new();
  int callframe1187 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1188 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1187);
// compilenode returning call1188
// compilenode returning call1188
  partcv[0] = 0;
  Object call1189 = callmethod(call1188, "new",
    1, partcv, params);
  gc_frame_end(callframe1186);
// compilenode returning call1189
// compilenode returning call1189
  *var_suggestion = call1189;
  if (call1189 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1191 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call1192 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe1191);
// compilenode returning call1192
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1193 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1194 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1193);
// compilenode returning call1194
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1195 = gc_frame_new();
  if (strlit1196 == NULL) {
    strlit1196 = alloc_String("A type name or type expression must follow '&'.");
    gc_root(strlit1196);
  }
// compilenode returning strlit1196
  gc_frame_newslot(strlit1196);
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1197 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1198 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1197);
// compilenode returning call1198
// compilenode returning call1198
  gc_frame_newslot(call1198);
  int callframe1199 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1200 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1199);
// compilenode returning call1200
// compilenode returning call1200
  gc_frame_newslot(call1200);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1196;
  params[1] = call1198;
  params[2] = call1200;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1201 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1195);
// compilenode returning call1201
    gc_frame_newslot(call1201);
    if1164 = call1201;
  } else {
  }
// compilenode returning if1164
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1202 = gc_frame_new();
  int callframe1203 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1204 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1203);
// compilenode returning call1204
// compilenode returning call1204
  gc_frame_newslot(call1204);
// compilenode returning *var_intersectionTypes
  params[0] = call1204;
  partcv[0] = 1;
  Object call1205 = callmethod(*var_intersectionTypes, "push",
    1, partcv, params);
  gc_frame_end(callframe1202);
// compilenode returning call1205
  gc_frame_end(frame);
  return call1205;
}
Object meth_parser__apply1218(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_intersectionName = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 401
  setline(401);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1220 == NULL) {
    strlit1220 = alloc_String("");
    gc_root(strlit1220);
  }
// compilenode returning strlit1220
  int op_slot_right_1219 = gc_frame_newslot(strlit1220);
  int callframe1223 = gc_frame_new();
// compilenode returning *var_it
  partcv[0] = 0;
  Object call1224 = callmethod(*var_it, "value",
    1, partcv, params);
  gc_frame_end(callframe1223);
// compilenode returning call1224
// compilenode returning call1224
  int op_slot_right_1222 = gc_frame_newslot(call1224);
  if (strlit1227 == NULL) {
    strlit1227 = alloc_String("&");
    gc_root(strlit1227);
  }
// compilenode returning strlit1227
  int op_slot_right_1226 = gc_frame_newslot(strlit1227);
// compilenode returning *var_intersectionName
  int op_slot_right_1229 = gc_frame_newslot(*var_intersectionName);
  if (strlit1231 == NULL) {
    strlit1231 = alloc_String("");
    gc_root(strlit1231);
  }
// compilenode returning strlit1231
  int op_slot_left_1229 = gc_frame_newslot(strlit1231);
  params[0] = *var_intersectionName;
  partcv[0] = 1;
  Object opresult1232 = callmethod(strlit1231, "++", 1, partcv, params);
// compilenode returning opresult1232
  int op_slot_left_1226 = gc_frame_newslot(opresult1232);
  params[0] = strlit1227;
  partcv[0] = 1;
  Object opresult1233 = callmethod(opresult1232, "++", 1, partcv, params);
// compilenode returning opresult1233
  int op_slot_left_1222 = gc_frame_newslot(opresult1233);
  params[0] = call1224;
  partcv[0] = 1;
  Object opresult1234 = callmethod(opresult1233, "++", 1, partcv, params);
// compilenode returning opresult1234
  int op_slot_left_1219 = gc_frame_newslot(opresult1234);
  params[0] = strlit1220;
  partcv[0] = 1;
  Object opresult1235 = callmethod(opresult1234, "++", 1, partcv, params);
// compilenode returning opresult1235
  *var_intersectionName = opresult1235;
  if (opresult1235 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply1252(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_overallType = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1253 = gc_frame_new();
// compilenode returning *var_it
  gc_frame_newslot(*var_it);
  int callframe1254 = gc_frame_new();
// compilenode returning *var_overallType
  partcv[0] = 0;
  Object call1255 = callmethod(*var_overallType, "intersectionTypes",
    1, partcv, params);
  gc_frame_end(callframe1254);
// compilenode returning call1255
// compilenode returning call1255
  params[0] = *var_it;
  partcv[0] = 1;
  Object call1256 = callmethod(call1255, "push",
    1, partcv, params);
  gc_frame_end(callframe1253);
// compilenode returning call1256
  gc_frame_end(frame);
  return call1256;
}
Object meth_parser_dotyperef945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotyperef");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotyperef (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dotyperef");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_overallType = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "overallType");
  Object *var_tp = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tp");
  Object *var_op = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "op");
  Object *var_unionTypes = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "unionTypes");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_suggestion = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestion");
  Object *var_unionName = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "unionName");
  Object *var_intersectionTypes = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "intersectionTypes");
  Object *var_intersectionName = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "intersectionName");
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool946 = alloc_Boolean(0);
// compilenode returning bool946
  *var_overallType = bool946;
  if (bool946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool947 = alloc_Boolean(0);
// compilenode returning bool947
  *var_tp = bool947;
  if (bool947 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool948 = alloc_Boolean(0);
// compilenode returning bool948
  *var_op = bool948;
  if (bool948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array949 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array949
  *var_unionTypes = array949;
  if (array949 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe951 = gc_frame_new();
  int callframe952 = gc_frame_new();
  Object block953 = alloc_Block(NULL, NULL, "parser", 331);
  gc_frame_newslot(block953);
  block_savedest(block953);
  Object closure954 = createclosure(1, "_apply");
setclosureframe(closure954, stackframe);
  addtoclosure(closure954, selfslot);
  struct UserObject *uo954 = (struct UserObject*)block953;
  uo954->data[0] = (Object)closure954;
  Method *meth_meth_parser__apply954 = addmethod2pos(block953, "_apply", &meth_parser__apply954, 0);
int argcv_meth_parser__apply954[] = {0};
meth_meth_parser__apply954->type = alloc_MethodType(1, argcv_meth_parser__apply954);
  meth_meth_parser__apply954->definitionModule = modulename;
  meth_meth_parser__apply954->definitionLine = 331;
// compilenode returning block953
  gc_frame_newslot(block953);
  params[0] = block953;
  partcv[0] = 1;
  Object call958 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe952);
// compilenode returning call958
  partcv[0] = 0;
  Object call959 = callmethod(call958, "not",
    1, partcv, params);
  gc_frame_end(callframe951);
// compilenode returning call959
// compilenode returning call959
  Object if950 = done;
  if (istrue(call959)) {
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe960 = gc_frame_new();
  partcv[0] = 0;
  Object call961 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe960);
// compilenode returning call961
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array962 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array962
  *var_suggestions = array962;
  if (array962 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe963 = gc_frame_new();
  int callframe964 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call965 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe964);
// compilenode returning call965
// compilenode returning call965
  partcv[0] = 0;
  Object call966 = callmethod(call965, "new",
    1, partcv, params);
  gc_frame_end(callframe963);
// compilenode returning call966
// compilenode returning call966
  *var_suggestion = call966;
  if (call966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe967 = gc_frame_new();
  int callframe968 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call969 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe968);
// compilenode returning call969
// compilenode returning call969
  partcv[0] = 0;
  Object call970 = callmethod(call969, "new",
    1, partcv, params);
  gc_frame_end(callframe967);
// compilenode returning call970
// compilenode returning call970
  *var_suggestion = call970;
  if (call970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 336
  setline(336);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe972 = gc_frame_new();
  if (strlit973 == NULL) {
    strlit973 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit973);
  }
// compilenode returning strlit973
  gc_frame_newslot(strlit973);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit973;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call974 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe972);
// compilenode returning call974
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe975 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call976 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe975);
// compilenode returning call976
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 338
  setline(338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe977 = gc_frame_new();
  int callframe978 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call979 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe978);
// compilenode returning call979
// compilenode returning call979
  partcv[0] = 0;
  Object call980 = callmethod(call979, "new",
    1, partcv, params);
  gc_frame_end(callframe977);
// compilenode returning call980
// compilenode returning call980
  *var_suggestion = call980;
  if (call980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe982 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call983 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe982);
// compilenode returning call983
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe984 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call985 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe984);
// compilenode returning call985
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe986 = gc_frame_new();
  int callframe987 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call988 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe987);
// compilenode returning call988
// compilenode returning call988
  partcv[0] = 0;
  Object call989 = callmethod(call988, "new",
    1, partcv, params);
  gc_frame_end(callframe986);
// compilenode returning call989
// compilenode returning call989
  *var_suggestion = call989;
  if (call989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe991 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  if (strlit992 == NULL) {
    strlit992 = alloc_String(":=");
    gc_root(strlit992);
  }
// compilenode returning strlit992
  gc_frame_newslot(strlit992);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = strlit992;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call993 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe991);
// compilenode returning call993
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe994 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call995 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe994);
// compilenode returning call995
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe996 = gc_frame_new();
  if (strlit997 == NULL) {
    strlit997 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit997);
  }
// compilenode returning strlit997
  gc_frame_newslot(strlit997);
// Begin line 345
  setline(345);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe998 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call999 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe998);
// compilenode returning call999
// compilenode returning call999
  gc_frame_newslot(call999);
  int callframe1000 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1001 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1000);
// compilenode returning call1001
// compilenode returning call1001
  gc_frame_newslot(call1001);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit997;
  params[1] = call999;
  params[2] = call1001;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1002 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe996);
// compilenode returning call1002
    gc_frame_newslot(call1002);
    if950 = call1002;
  } else {
  }
// compilenode returning if950
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1003 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1004 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1003);
// compilenode returning call1004
// compilenode returning call1004
  *var_overallType = call1004;
  if (call1004 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1006 = gc_frame_new();
  Object block1007 = alloc_Block(NULL, NULL, "parser", 348);
  gc_frame_newslot(block1007);
  block_savedest(block1007);
  Object closure1008 = createclosure(2, "_apply");
setclosureframe(closure1008, stackframe);
  addtoclosure(closure1008, var_sym);
  addtoclosure(closure1008, selfslot);
  struct UserObject *uo1008 = (struct UserObject*)block1007;
  uo1008->data[0] = (Object)closure1008;
  Method *meth_meth_parser__apply1008 = addmethod2pos(block1007, "_apply", &meth_parser__apply1008, 0);
int argcv_meth_parser__apply1008[] = {0};
meth_meth_parser__apply1008->type = alloc_MethodType(1, argcv_meth_parser__apply1008);
  meth_meth_parser__apply1008->definitionModule = modulename;
  meth_meth_parser__apply1008->definitionLine = 347;
// compilenode returning block1007
  gc_frame_newslot(block1007);
  Object block1022 = alloc_Block(NULL, NULL, "parser", 348);
  gc_frame_newslot(block1022);
  block_savedest(block1022);
  Object closure1023 = createclosure(7, "_apply");
setclosureframe(closure1023, stackframe);
  addtoclosure(closure1023, var_unionTypes);
  addtoclosure(closure1023, var_overallType);
  addtoclosure(closure1023, var_errormessages);
  addtoclosure(closure1023, var_lastToken);
  addtoclosure(closure1023, var_sym);
  addtoclosure(closure1023, var_values);
  addtoclosure(closure1023, selfslot);
  struct UserObject *uo1023 = (struct UserObject*)block1022;
  uo1023->data[0] = (Object)closure1023;
  Method *meth_meth_parser__apply1023 = addmethod2pos(block1022, "_apply", &meth_parser__apply1023, 0);
int argcv_meth_parser__apply1023[] = {0};
meth_meth_parser__apply1023->type = alloc_MethodType(1, argcv_meth_parser__apply1023);
  meth_meth_parser__apply1023->definitionModule = modulename;
  meth_meth_parser__apply1023->definitionLine = 348;
// compilenode returning block1022
  gc_frame_newslot(block1022);
  params[0] = block1007;
  params[1] = block1022;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1078 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1006);
// compilenode returning call1078
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1081 = alloc_Float64(0);
// compilenode returning num1081
  int op_slot_right_1080 = gc_frame_newslot(num1081);
  int callframe1083 = gc_frame_new();
// compilenode returning *var_unionTypes
  partcv[0] = 0;
  Object call1084 = callmethod(*var_unionTypes, "size",
    1, partcv, params);
  gc_frame_end(callframe1083);
// compilenode returning call1084
// compilenode returning call1084
  int op_slot_left_1080 = gc_frame_newslot(call1084);
  params[0] = num1081;
  partcv[0] = 1;
  Object opresult1085 = callmethod(call1084, ">", 1, partcv, params);
// compilenode returning opresult1085
  Object if1079 = done;
  if (istrue(opresult1085)) {
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1086 == NULL) {
    strlit1086 = alloc_String("Union<");
    gc_root(strlit1086);
  }
// compilenode returning strlit1086
  *var_unionName = strlit1086;
  if (strlit1086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1087 = gc_frame_new();
// compilenode returning *var_unionTypes
  gc_frame_newslot(*var_unionTypes);
  Object block1088 = alloc_Block(NULL, NULL, "parser", 369);
  gc_frame_newslot(block1088);
  block_savedest(block1088);
  Object closure1089 = createclosure(2, "_apply");
setclosureframe(closure1089, stackframe);
  addtoclosure(closure1089, var_unionName);
  addtoclosure(closure1089, selfslot);
  struct UserObject *uo1089 = (struct UserObject*)block1088;
  uo1089->data[0] = (Object)closure1089;
  Method *meth_meth_parser__apply1089 = addmethod2pos(block1088, "_apply", &meth_parser__apply1089, 0);
int argcv_meth_parser__apply1089[] = {1};
meth_meth_parser__apply1089->type = alloc_MethodType(1, argcv_meth_parser__apply1089);
  meth_meth_parser__apply1089->definitionModule = modulename;
  meth_meth_parser__apply1089->definitionLine = 367;
// compilenode returning block1088
  gc_frame_newslot(block1088);
  params[0] = *var_unionTypes;
  params[1] = block1088;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1109 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compilenode returning call1109
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1111 == NULL) {
    strlit1111 = alloc_String("|>");
    gc_root(strlit1111);
  }
// compilenode returning strlit1111
  int op_slot_right_1110 = gc_frame_newslot(strlit1111);
// compilenode returning *var_unionName
  int op_slot_right_1113 = gc_frame_newslot(*var_unionName);
  if (strlit1115 == NULL) {
    strlit1115 = alloc_String("");
    gc_root(strlit1115);
  }
// compilenode returning strlit1115
  int op_slot_left_1113 = gc_frame_newslot(strlit1115);
  params[0] = *var_unionName;
  partcv[0] = 1;
  Object opresult1116 = callmethod(strlit1115, "++", 1, partcv, params);
// compilenode returning opresult1116
  int op_slot_left_1110 = gc_frame_newslot(opresult1116);
  params[0] = strlit1111;
  partcv[0] = 1;
  Object opresult1117 = callmethod(opresult1116, "++", 1, partcv, params);
// compilenode returning opresult1117
  *var_unionName = opresult1117;
  if (opresult1117 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1119 = gc_frame_new();
// compilenode returning *var_unionName
  gc_frame_newslot(*var_unionName);
  Object array1120 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1120
  gc_frame_newslot(array1120);
  int callframe1121 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call1122 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe1121);
// compilenode returning call1122
// compilenode returning call1122
  params[0] = *var_unionName;
  params[1] = array1120;
  partcv[0] = 2;
  Object call1123 = callmethod(call1122, "new",
    1, partcv, params);
  gc_frame_end(callframe1119);
// compilenode returning call1123
  *var_overallType = call1123;
  if (call1123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1125 = gc_frame_new();
// compilenode returning *var_unionTypes
  gc_frame_newslot(*var_unionTypes);
  Object block1126 = alloc_Block(NULL, NULL, "parser", 374);
  gc_frame_newslot(block1126);
  block_savedest(block1126);
  Object closure1127 = createclosure(2, "_apply");
setclosureframe(closure1127, stackframe);
  addtoclosure(closure1127, var_overallType);
  addtoclosure(closure1127, selfslot);
  struct UserObject *uo1127 = (struct UserObject*)block1126;
  uo1127->data[0] = (Object)closure1127;
  Method *meth_meth_parser__apply1127 = addmethod2pos(block1126, "_apply", &meth_parser__apply1127, 0);
int argcv_meth_parser__apply1127[] = {1};
meth_meth_parser__apply1127->type = alloc_MethodType(1, argcv_meth_parser__apply1127);
  meth_meth_parser__apply1127->definitionModule = modulename;
  meth_meth_parser__apply1127->definitionLine = 373;
// compilenode returning block1126
  gc_frame_newslot(block1126);
  params[0] = *var_unionTypes;
  params[1] = block1126;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1133 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1125);
// compilenode returning call1133
    gc_frame_newslot(call1133);
    if1079 = call1133;
  } else {
  }
// compilenode returning if1079
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1134 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1134
  *var_intersectionTypes = array1134;
  if (array1134 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1135 = gc_frame_new();
  Object block1136 = alloc_Block(NULL, NULL, "parser", 379);
  gc_frame_newslot(block1136);
  block_savedest(block1136);
  Object closure1137 = createclosure(2, "_apply");
setclosureframe(closure1137, stackframe);
  addtoclosure(closure1137, var_sym);
  addtoclosure(closure1137, selfslot);
  struct UserObject *uo1137 = (struct UserObject*)block1136;
  uo1137->data[0] = (Object)closure1137;
  Method *meth_meth_parser__apply1137 = addmethod2pos(block1136, "_apply", &meth_parser__apply1137, 0);
int argcv_meth_parser__apply1137[] = {0};
meth_meth_parser__apply1137->type = alloc_MethodType(1, argcv_meth_parser__apply1137);
  meth_meth_parser__apply1137->definitionModule = modulename;
  meth_meth_parser__apply1137->definitionLine = 375;
// compilenode returning block1136
  gc_frame_newslot(block1136);
  Object block1151 = alloc_Block(NULL, NULL, "parser", 379);
  gc_frame_newslot(block1151);
  block_savedest(block1151);
  Object closure1152 = createclosure(7, "_apply");
setclosureframe(closure1152, stackframe);
  addtoclosure(closure1152, var_intersectionTypes);
  addtoclosure(closure1152, var_overallType);
  addtoclosure(closure1152, var_errormessages);
  addtoclosure(closure1152, var_lastToken);
  addtoclosure(closure1152, var_sym);
  addtoclosure(closure1152, var_values);
  addtoclosure(closure1152, selfslot);
  struct UserObject *uo1152 = (struct UserObject*)block1151;
  uo1152->data[0] = (Object)closure1152;
  Method *meth_meth_parser__apply1152 = addmethod2pos(block1151, "_apply", &meth_parser__apply1152, 0);
int argcv_meth_parser__apply1152[] = {0};
meth_meth_parser__apply1152->type = alloc_MethodType(1, argcv_meth_parser__apply1152);
  meth_meth_parser__apply1152->definitionModule = modulename;
  meth_meth_parser__apply1152->definitionLine = 379;
// compilenode returning block1151
  gc_frame_newslot(block1151);
  params[0] = block1136;
  params[1] = block1151;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1207 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1135);
// compilenode returning call1207
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1210 = alloc_Float64(0);
// compilenode returning num1210
  int op_slot_right_1209 = gc_frame_newslot(num1210);
  int callframe1212 = gc_frame_new();
// compilenode returning *var_intersectionTypes
  partcv[0] = 0;
  Object call1213 = callmethod(*var_intersectionTypes, "size",
    1, partcv, params);
  gc_frame_end(callframe1212);
// compilenode returning call1213
// compilenode returning call1213
  int op_slot_left_1209 = gc_frame_newslot(call1213);
  params[0] = num1210;
  partcv[0] = 1;
  Object opresult1214 = callmethod(call1213, ">", 1, partcv, params);
// compilenode returning opresult1214
  Object if1208 = done;
  if (istrue(opresult1214)) {
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1215 == NULL) {
    strlit1215 = alloc_String("Intersection<");
    gc_root(strlit1215);
  }
// compilenode returning strlit1215
  *var_intersectionName = strlit1215;
  if (strlit1215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1216 = gc_frame_new();
// compilenode returning *var_intersectionTypes
  gc_frame_newslot(*var_intersectionTypes);
  Object block1217 = alloc_Block(NULL, NULL, "parser", 400);
  gc_frame_newslot(block1217);
  block_savedest(block1217);
  Object closure1218 = createclosure(2, "_apply");
setclosureframe(closure1218, stackframe);
  addtoclosure(closure1218, var_intersectionName);
  addtoclosure(closure1218, selfslot);
  struct UserObject *uo1218 = (struct UserObject*)block1217;
  uo1218->data[0] = (Object)closure1218;
  Method *meth_meth_parser__apply1218 = addmethod2pos(block1217, "_apply", &meth_parser__apply1218, 0);
int argcv_meth_parser__apply1218[] = {1};
meth_meth_parser__apply1218->type = alloc_MethodType(1, argcv_meth_parser__apply1218);
  meth_meth_parser__apply1218->definitionModule = modulename;
  meth_meth_parser__apply1218->definitionLine = 398;
// compilenode returning block1217
  gc_frame_newslot(block1217);
  params[0] = *var_intersectionTypes;
  params[1] = block1217;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1238 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1216);
// compilenode returning call1238
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1240 == NULL) {
    strlit1240 = alloc_String("&>");
    gc_root(strlit1240);
  }
// compilenode returning strlit1240
  int op_slot_right_1239 = gc_frame_newslot(strlit1240);
// compilenode returning *var_intersectionName
  int op_slot_left_1239 = gc_frame_newslot(*var_intersectionName);
  params[0] = strlit1240;
  partcv[0] = 1;
  Object opresult1242 = callmethod(*var_intersectionName, "++", 1, partcv, params);
// compilenode returning opresult1242
  *var_intersectionName = opresult1242;
  if (opresult1242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1244 = gc_frame_new();
// compilenode returning *var_intersectionName
  gc_frame_newslot(*var_intersectionName);
  Object array1245 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1245
  gc_frame_newslot(array1245);
  int callframe1246 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call1247 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe1246);
// compilenode returning call1247
// compilenode returning call1247
  params[0] = *var_intersectionName;
  params[1] = array1245;
  partcv[0] = 2;
  Object call1248 = callmethod(call1247, "new",
    1, partcv, params);
  gc_frame_end(callframe1244);
// compilenode returning call1248
  *var_overallType = call1248;
  if (call1248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1250 = gc_frame_new();
// compilenode returning *var_intersectionTypes
  gc_frame_newslot(*var_intersectionTypes);
  Object block1251 = alloc_Block(NULL, NULL, "parser", 405);
  gc_frame_newslot(block1251);
  block_savedest(block1251);
  Object closure1252 = createclosure(2, "_apply");
setclosureframe(closure1252, stackframe);
  addtoclosure(closure1252, var_overallType);
  addtoclosure(closure1252, selfslot);
  struct UserObject *uo1252 = (struct UserObject*)block1251;
  uo1252->data[0] = (Object)closure1252;
  Method *meth_meth_parser__apply1252 = addmethod2pos(block1251, "_apply", &meth_parser__apply1252, 0);
int argcv_meth_parser__apply1252[] = {1};
meth_meth_parser__apply1252->type = alloc_MethodType(1, argcv_meth_parser__apply1252);
  meth_meth_parser__apply1252->definitionModule = modulename;
  meth_meth_parser__apply1252->definitionLine = 404;
// compilenode returning block1251
  gc_frame_newslot(block1251);
  params[0] = *var_intersectionTypes;
  params[1] = block1251;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1258 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1250);
// compilenode returning call1258
    gc_frame_newslot(call1258);
    if1208 = call1258;
  } else {
  }
// compilenode returning if1208
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1259 = gc_frame_new();
// compilenode returning *var_overallType
  gc_frame_newslot(*var_overallType);
// compilenode returning *var_values
  params[0] = *var_overallType;
  partcv[0] = 1;
  Object call1260 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1259);
// compilenode returning call1260
  gc_frame_end(frame);
  return call1260;
}
Object meth_parser__apply1290(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1291 = gc_frame_new();
  partcv[0] = 0;
  Object call1292 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1291);
// compilenode returning call1292
  gc_frame_end(frame);
  return call1292;
}
Object meth_parser__apply1327(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1328 = gc_frame_new();
  partcv[0] = 0;
  Object call1329 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1328);
// compilenode returning call1329
  gc_frame_end(frame);
  return call1329;
}
Object meth_parser__apply1398(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1399 = gc_frame_new();
  if (strlit1400 == NULL) {
    strlit1400 = alloc_String("comma");
    gc_root(strlit1400);
  }
// compilenode returning strlit1400
  gc_frame_newslot(strlit1400);
  params[0] = strlit1400;
  partcv[0] = 1;
  Object call1401 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1399);
// compilenode returning call1401
  gc_frame_end(frame);
  return call1401;
}
Object meth_parser__apply1408(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit1410 == NULL) {
    strlit1410 = alloc_String("arrow");
    gc_root(strlit1410);
  }
// compilenode returning strlit1410
  int op_slot_right_1409 = gc_frame_newslot(strlit1410);
  int callframe1412 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1413 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1412);
// compilenode returning call1413
// compilenode returning call1413
  int op_slot_left_1409 = gc_frame_newslot(call1413);
  params[0] = strlit1410;
  partcv[0] = 1;
  Object opresult1414 = callmethod(call1413, "==", 1, partcv, params);
// compilenode returning opresult1414
  gc_frame_end(frame);
  return opresult1414;
}
Object meth_parser__apply1456(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1457 = gc_frame_new();
  if (strlit1458 == NULL) {
    strlit1458 = alloc_String("comma");
    gc_root(strlit1458);
  }
// compilenode returning strlit1458
  gc_frame_newslot(strlit1458);
  params[0] = strlit1458;
  partcv[0] = 1;
  Object call1459 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1457);
// compilenode returning call1459
  gc_frame_end(frame);
  return call1459;
}
Object meth_parser__apply1462(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ident1 = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1463 = gc_frame_new();
  partcv[0] = 0;
  Object call1464 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1463);
// compilenode returning call1464
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1465 = gc_frame_new();
  partcv[0] = 0;
  Object call1466 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1465);
// compilenode returning call1466
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1467 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1468 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1467);
// compilenode returning call1468
// compilenode returning call1468
  *var_ident1 = call1468;
  if (call1468 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1471 = gc_frame_new();
  if (strlit1472 == NULL) {
    strlit1472 = alloc_String("colon");
    gc_root(strlit1472);
  }
// compilenode returning strlit1472
  gc_frame_newslot(strlit1472);
  params[0] = strlit1472;
  partcv[0] = 1;
  Object call1473 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1471);
// compilenode returning call1473
  Object if1470 = done;
  if (istrue(call1473)) {
// Begin line 485
  setline(485);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1474 = gc_frame_new();
  partcv[0] = 0;
  Object call1475 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1474);
// compilenode returning call1475
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1476 = gc_frame_new();
  partcv[0] = 0;
  Object call1477 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1476);
// compilenode returning call1477
// Begin line 488
  setline(488);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1478 = gc_frame_new();
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1479 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1480 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1479);
// compilenode returning call1480
// compilenode returning call1480
  gc_frame_newslot(call1480);
// compilenode returning *var_ident1
  params[0] = call1480;
  partcv[0] = 1;
  Object call1481 = callmethod(*var_ident1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1478);
// compilenode returning call1481
// compilenode returning done
    gc_frame_newslot(done);
    if1470 = done;
  } else {
  }
// compilenode returning if1470
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1482 = gc_frame_new();
// compilenode returning *var_ident1
  gc_frame_newslot(*var_ident1);
// compilenode returning *var_params
  params[0] = *var_ident1;
  partcv[0] = 1;
  Object call1483 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1482);
// compilenode returning call1483
  gc_frame_end(frame);
  return call1483;
}
Object meth_parser__apply1598(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1599 = gc_frame_new();
  partcv[0] = 0;
  Object call1600 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1599);
// compilenode returning call1600
  gc_frame_end(frame);
  return call1600;
}
Object meth_parser__apply1295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_ident1 = getfromclosure(closure, 1);
  Object *var_braceIsType = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_params = getfromclosure(closure, 6);
  Object *var_isMatchingBlock = getfromclosure(closure, 7);
  Object *var_body = getfromclosure(closure, 8);
  Object *var_indentFreePass = getfromclosure(closure, 9);
  Object *var_ast = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_arrow = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arrow");
  Object *var_lhs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "lhs");
  Object *var_rhs = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "rhs");
// Begin line 545
  setline(545);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1298 = gc_frame_new();
  if (strlit1299 == NULL) {
    strlit1299 = alloc_String("colon");
    gc_root(strlit1299);
  }
// compilenode returning strlit1299
  gc_frame_newslot(strlit1299);
  params[0] = strlit1299;
  partcv[0] = 1;
  Object call1300 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1298);
// compilenode returning call1300
  int op_slot_right_1297 = gc_frame_newslot(call1300);
  int callframe1303 = gc_frame_new();
  if (strlit1304 == NULL) {
    strlit1304 = alloc_String("arrow");
    gc_root(strlit1304);
  }
// compilenode returning strlit1304
  gc_frame_newslot(strlit1304);
  params[0] = strlit1304;
  partcv[0] = 1;
  Object call1305 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1303);
// compilenode returning call1305
  int op_slot_right_1302 = gc_frame_newslot(call1305);
  int callframe1307 = gc_frame_new();
  if (strlit1308 == NULL) {
    strlit1308 = alloc_String("comma");
    gc_root(strlit1308);
  }
// compilenode returning strlit1308
  gc_frame_newslot(strlit1308);
  params[0] = strlit1308;
  partcv[0] = 1;
  Object call1309 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1307);
// compilenode returning call1309
  int op_slot_left_1302 = gc_frame_newslot(call1309);
  params[0] = call1305;
  partcv[0] = 1;
  Object opresult1310 = callmethod(call1309, "||", 1, partcv, params);
// compilenode returning opresult1310
  int op_slot_left_1297 = gc_frame_newslot(opresult1310);
  params[0] = call1300;
  partcv[0] = 1;
  Object opresult1311 = callmethod(opresult1310, "||", 1, partcv, params);
// compilenode returning opresult1311
  Object if1296 = done;
  if (istrue(opresult1311)) {
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1312 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1313 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1312);
// compilenode returning call1313
// compilenode returning call1313
  *var_ident1 = call1313;
  if (call1313 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1316 = gc_frame_new();
  if (strlit1317 == NULL) {
    strlit1317 = alloc_String("colon");
    gc_root(strlit1317);
  }
// compilenode returning strlit1317
  gc_frame_newslot(strlit1317);
  params[0] = strlit1317;
  partcv[0] = 1;
  Object call1318 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1316);
// compilenode returning call1318
  Object if1315 = done;
  if (istrue(call1318)) {
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1319 = gc_frame_new();
  partcv[0] = 0;
  Object call1320 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1319);
// compilenode returning call1320
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1321 = alloc_Boolean(1);
// compilenode returning bool1321
  *var_braceIsType = bool1321;
  if (bool1321 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1324 = gc_frame_new();
  int callframe1325 = gc_frame_new();
  Object block1326 = alloc_Block(NULL, NULL, "parser", 441);
  gc_frame_newslot(block1326);
  block_savedest(block1326);
  Object closure1327 = createclosure(1, "_apply");
setclosureframe(closure1327, stackframe);
  addtoclosure(closure1327, selfslot);
  struct UserObject *uo1327 = (struct UserObject*)block1326;
  uo1327->data[0] = (Object)closure1327;
  Method *meth_meth_parser__apply1327 = addmethod2pos(block1326, "_apply", &meth_parser__apply1327, 0);
int argcv_meth_parser__apply1327[] = {0};
meth_meth_parser__apply1327->type = alloc_MethodType(1, argcv_meth_parser__apply1327);
  meth_meth_parser__apply1327->definitionModule = modulename;
  meth_meth_parser__apply1327->definitionLine = 441;
// compilenode returning block1326
  gc_frame_newslot(block1326);
  params[0] = block1326;
  partcv[0] = 1;
  Object call1331 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1325);
// compilenode returning call1331
  partcv[0] = 0;
  Object call1332 = callmethod(call1331, "not",
    1, partcv, params);
  gc_frame_end(callframe1324);
// compilenode returning call1332
// compilenode returning call1332
  Object if1323 = done;
  if (istrue(call1332)) {
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 442
  setline(442);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1333 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1333
  *var_suggestions = array1333;
  if (array1333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 443
  setline(443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1334 = gc_frame_new();
  int callframe1335 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1336 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1335);
// compilenode returning call1336
// compilenode returning call1336
  partcv[0] = 0;
  Object call1337 = callmethod(call1336, "new",
    1, partcv, params);
  gc_frame_end(callframe1334);
// compilenode returning call1337
// compilenode returning call1337
  *var_suggestion = call1337;
  if (call1337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 444
  setline(444);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1338 = gc_frame_new();
  if (strlit1339 == NULL) {
    strlit1339 = alloc_String("arrow");
    gc_root(strlit1339);
  }
// compilenode returning strlit1339
  gc_frame_newslot(strlit1339);
  if (strlit1340 == NULL) {
    strlit1340 = alloc_String("rbrace");
    gc_root(strlit1340);
  }
// compilenode returning strlit1340
  gc_frame_newslot(strlit1340);
  params[0] = strlit1339;
  params[1] = strlit1340;
  partcv[0] = 2;
  Object call1341 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1338);
// compilenode returning call1341
  *var_nextTok = call1341;
  if (call1341 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1343 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1343 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1345 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1345
  Object if1342 = done;
  if (istrue(opresult1345)) {
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1346 = gc_frame_new();
  if (strlit1347 == NULL) {
    strlit1347 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1347);
  }
// compilenode returning strlit1347
  gc_frame_newslot(strlit1347);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1347;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1348 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1346);
// compilenode returning call1348
    gc_frame_newslot(call1348);
    if1342 = call1348;
  } else {
// Begin line 448
  setline(448);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1349 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe1350 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1351 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1350);
// compilenode returning call1351
// compilenode returning call1351
  gc_frame_newslot(call1351);
  Object bool1352 = alloc_Boolean(1);
// compilenode returning bool1352
  gc_frame_newslot(bool1352);
  Object bool1353 = alloc_Boolean(0);
// compilenode returning bool1353
  gc_frame_newslot(bool1353);
  if (strlit1354 == NULL) {
    strlit1354 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1354);
  }
// compilenode returning strlit1354
  gc_frame_newslot(strlit1354);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call1351;
  params[2] = bool1352;
  params[3] = bool1353;
  params[4] = strlit1354;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1355 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1349);
// compilenode returning call1355
    gc_frame_newslot(call1355);
    if1342 = call1355;
  }
// compilenode returning if1342
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1356 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1357 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1356);
// compilenode returning call1357
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 451
  setline(451);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1358 = gc_frame_new();
  int callframe1359 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1360 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1359);
// compilenode returning call1360
// compilenode returning call1360
  partcv[0] = 0;
  Object call1361 = callmethod(call1360, "new",
    1, partcv, params);
  gc_frame_end(callframe1358);
// compilenode returning call1361
// compilenode returning call1361
  *var_suggestion = call1361;
  if (call1361 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1363 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe1364 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1365 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1364);
// compilenode returning call1365
// compilenode returning call1365
  gc_frame_newslot(call1365);
  Object bool1366 = alloc_Boolean(1);
// compilenode returning bool1366
  gc_frame_newslot(bool1366);
  Object bool1367 = alloc_Boolean(0);
// compilenode returning bool1367
  gc_frame_newslot(bool1367);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call1365;
  params[2] = bool1366;
  params[3] = bool1367;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1368 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1363);
// compilenode returning call1368
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1369 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1370 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1369);
// compilenode returning call1370
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1371 = gc_frame_new();
  if (strlit1372 == NULL) {
    strlit1372 = alloc_String("A block must have an expression after the ':'.");
    gc_root(strlit1372);
  }
// compilenode returning strlit1372
  gc_frame_newslot(strlit1372);
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1373 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1374 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1373);
// compilenode returning call1374
// compilenode returning call1374
  gc_frame_newslot(call1374);
  int callframe1375 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1376 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1375);
// compilenode returning call1376
// compilenode returning call1376
  gc_frame_newslot(call1376);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 454
  setline(454);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1372;
  params[1] = call1374;
  params[2] = call1376;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1377 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1371);
// compilenode returning call1377
    gc_frame_newslot(call1377);
    if1323 = call1377;
  } else {
  }
// compilenode returning if1323
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 457
  setline(457);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1378 = alloc_Boolean(0);
// compilenode returning bool1378
  *var_braceIsType = bool1378;
  if (bool1378 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1380 = gc_frame_new();
// Begin line 458
  setline(458);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1381 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1382 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1381);
// compilenode returning call1382
// compilenode returning call1382
  gc_frame_newslot(call1382);
// compilenode returning *var_ident1
  params[0] = call1382;
  partcv[0] = 1;
  Object call1383 = callmethod(*var_ident1, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe1380);
// compilenode returning call1383
// compilenode returning done
    gc_frame_newslot(done);
    if1315 = done;
  } else {
  }
// compilenode returning if1315
// Begin line 460
  setline(460);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1384 = gc_frame_new();
// compilenode returning *var_ident1
  gc_frame_newslot(*var_ident1);
// compilenode returning *var_params
  params[0] = *var_ident1;
  partcv[0] = 1;
  Object call1385 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe1384);
// compilenode returning call1385
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 461
  setline(461);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1388 == NULL) {
    strlit1388 = alloc_String("identifier");
    gc_root(strlit1388);
  }
// compilenode returning strlit1388
  int op_slot_right_1387 = gc_frame_newslot(strlit1388);
  int callframe1390 = gc_frame_new();
// compilenode returning *var_ident1
  partcv[0] = 0;
  Object call1391 = callmethod(*var_ident1, "kind",
    1, partcv, params);
  gc_frame_end(callframe1390);
// compilenode returning call1391
// compilenode returning call1391
  int op_slot_left_1387 = gc_frame_newslot(call1391);
  params[0] = strlit1388;
  partcv[0] = 1;
  Object opresult1392 = callmethod(call1391, "!=", 1, partcv, params);
// compilenode returning opresult1392
  Object if1386 = done;
  if (istrue(opresult1392)) {
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 462
  setline(462);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1393 = alloc_Boolean(1);
// compilenode returning bool1393
  *var_isMatchingBlock = bool1393;
  if (bool1393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1386 = done;
  } else {
  }
// compilenode returning if1386
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 464
  setline(464);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block1397 = alloc_Block(NULL, NULL, "parser", 464);
  gc_frame_newslot(block1397);
  block_savedest(block1397);
  Object closure1398 = createclosure(1, "_apply");
setclosureframe(closure1398, stackframe);
  addtoclosure(closure1398, selfslot);
  struct UserObject *uo1398 = (struct UserObject*)block1397;
  uo1398->data[0] = (Object)closure1398;
  Method *meth_meth_parser__apply1398 = addmethod2pos(block1397, "_apply", &meth_parser__apply1398, 0);
int argcv_meth_parser__apply1398[] = {0};
meth_meth_parser__apply1398->type = alloc_MethodType(1, argcv_meth_parser__apply1398);
  meth_meth_parser__apply1398->definitionModule = modulename;
  meth_meth_parser__apply1398->definitionLine = 461;
// compilenode returning block1397
  int op_slot_right_1396 = gc_frame_newslot(block1397);
// compilenode returning *var_isMatchingBlock
  int op_slot_left_1396 = gc_frame_newslot(*var_isMatchingBlock);
  params[0] = block1397;
  partcv[0] = 1;
  Object opresult1404 = callmethod(*var_isMatchingBlock, "&&", 1, partcv, params);
// compilenode returning opresult1404
  Object if1395 = done;
  if (istrue(opresult1404)) {
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1405 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1405
  *var_suggestions = array1405;
  if (array1405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_suggestion = undefined;
// compilenode returning done
  int callframe1406 = gc_frame_new();
  Object block1407 = alloc_Block(NULL, NULL, "parser", 467);
  gc_frame_newslot(block1407);
  block_savedest(block1407);
  Object closure1408 = createclosure(1, "_apply");
setclosureframe(closure1408, stackframe);
  addtoclosure(closure1408, selfslot);
  struct UserObject *uo1408 = (struct UserObject*)block1407;
  uo1408->data[0] = (Object)closure1408;
  Method *meth_meth_parser__apply1408 = addmethod2pos(block1407, "_apply", &meth_parser__apply1408, 0);
int argcv_meth_parser__apply1408[] = {1};
meth_meth_parser__apply1408->type = alloc_MethodType(1, argcv_meth_parser__apply1408);
  meth_meth_parser__apply1408->definitionModule = modulename;
  meth_meth_parser__apply1408->definitionLine = 461;
// compilenode returning block1407
  gc_frame_newslot(block1407);
  params[0] = block1407;
  partcv[0] = 1;
  Object call1416 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1406);
// compilenode returning call1416
  *var_arrow = call1416;
  if (call1416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 468
  setline(468);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1419 = alloc_Boolean(0);
// compilenode returning bool1419
  int op_slot_right_1418 = gc_frame_newslot(bool1419);
// compilenode returning *var_arrow
  int op_slot_left_1418 = gc_frame_newslot(*var_arrow);
  params[0] = bool1419;
  partcv[0] = 1;
  Object opresult1421 = callmethod(*var_arrow, "!=", 1, partcv, params);
// compilenode returning opresult1421
  Object if1417 = done;
  if (istrue(opresult1421)) {
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1422 = gc_frame_new();
  int callframe1423 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1424 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1423);
// compilenode returning call1424
// compilenode returning call1424
  partcv[0] = 0;
  Object call1425 = callmethod(call1424, "new",
    1, partcv, params);
  gc_frame_end(callframe1422);
// compilenode returning call1425
// compilenode returning call1425
  *var_suggestion = call1425;
  if (call1425 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1427 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe1428 = gc_frame_new();
// compilenode returning *var_arrow
  partcv[0] = 0;
  Object call1429 = callmethod(*var_arrow, "prev",
    1, partcv, params);
  gc_frame_end(callframe1428);
// compilenode returning call1429
// compilenode returning call1429
  gc_frame_newslot(call1429);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call1429;
  partcv[0] = 2;
  Object call1430 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe1427);
// compilenode returning call1430
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1431 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1432 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1431);
// compilenode returning call1432
    gc_frame_newslot(call1432);
    if1417 = call1432;
  } else {
  }
// compilenode returning if1417
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 473
  setline(473);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1433 = gc_frame_new();
  int callframe1434 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1435 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1434);
// compilenode returning call1435
// compilenode returning call1435
  partcv[0] = 0;
  Object call1436 = callmethod(call1435, "new",
    1, partcv, params);
  gc_frame_end(callframe1433);
// compilenode returning call1436
// compilenode returning call1436
  *var_suggestion = call1436;
  if (call1436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1438 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool1439 = alloc_Boolean(1);
// compilenode returning bool1439
  gc_frame_newslot(bool1439);
  Object bool1440 = alloc_Boolean(0);
// compilenode returning bool1440
  gc_frame_newslot(bool1440);
  if (strlit1441 == NULL) {
    strlit1441 = alloc_String(" |");
    gc_root(strlit1441);
  }
// compilenode returning strlit1441
  gc_frame_newslot(strlit1441);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool1439;
  params[2] = bool1440;
  params[3] = strlit1441;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1442 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1438);
// compilenode returning call1442
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1443 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1444 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1443);
// compilenode returning call1444
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1445 = gc_frame_new();
  if (strlit1446 == NULL) {
    strlit1446 = alloc_String("A matching block may only have one parameter.");
    gc_root(strlit1446);
  }
// compilenode returning strlit1446
  gc_frame_newslot(strlit1446);
// Begin line 477
  setline(477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1447 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1448 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1447);
// compilenode returning call1448
// compilenode returning call1448
  gc_frame_newslot(call1448);
  int callframe1449 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1450 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1449);
// compilenode returning call1450
// compilenode returning call1450
  gc_frame_newslot(call1450);
  int callframe1451 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1452 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1451);
// compilenode returning call1452
// compilenode returning call1452
  gc_frame_newslot(call1452);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1446;
  params[1] = call1448;
  params[2] = call1450;
  params[3] = call1452;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call1453 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1445);
// compilenode returning call1453
    gc_frame_newslot(call1453);
    if1395 = call1453;
  } else {
  }
// compilenode returning if1395
// Begin line 479
  setline(479);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1454 = gc_frame_new();
  Object block1455 = alloc_Block(NULL, NULL, "parser", 479);
  gc_frame_newslot(block1455);
  block_savedest(block1455);
  Object closure1456 = createclosure(1, "_apply");
setclosureframe(closure1456, stackframe);
  addtoclosure(closure1456, selfslot);
  struct UserObject *uo1456 = (struct UserObject*)block1455;
  uo1456->data[0] = (Object)closure1456;
  Method *meth_meth_parser__apply1456 = addmethod2pos(block1455, "_apply", &meth_parser__apply1456, 0);
int argcv_meth_parser__apply1456[] = {0};
meth_meth_parser__apply1456->type = alloc_MethodType(1, argcv_meth_parser__apply1456);
  meth_meth_parser__apply1456->definitionModule = modulename;
  meth_meth_parser__apply1456->definitionLine = 477;
// compilenode returning block1455
  gc_frame_newslot(block1455);
  Object block1461 = alloc_Block(NULL, NULL, "parser", 479);
  gc_frame_newslot(block1461);
  block_savedest(block1461);
  Object closure1462 = createclosure(4, "_apply");
setclosureframe(closure1462, stackframe);
  addtoclosure(closure1462, var_values);
  addtoclosure(closure1462, var_ident1);
  addtoclosure(closure1462, var_params);
  addtoclosure(closure1462, selfslot);
  struct UserObject *uo1462 = (struct UserObject*)block1461;
  uo1462->data[0] = (Object)closure1462;
  Method *meth_meth_parser__apply1462 = addmethod2pos(block1461, "_apply", &meth_parser__apply1462, 0);
int argcv_meth_parser__apply1462[] = {0};
meth_meth_parser__apply1462->type = alloc_MethodType(1, argcv_meth_parser__apply1462);
  meth_meth_parser__apply1462->definitionModule = modulename;
  meth_meth_parser__apply1462->definitionLine = 477;
// compilenode returning block1461
  gc_frame_newslot(block1461);
  params[0] = block1455;
  params[1] = block1461;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1485 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1454);
// compilenode returning call1485
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 491
  setline(491);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1487 = gc_frame_new();
  int callframe1488 = gc_frame_new();
  if (strlit1489 == NULL) {
    strlit1489 = alloc_String("arrow");
    gc_root(strlit1489);
  }
// compilenode returning strlit1489
  gc_frame_newslot(strlit1489);
  params[0] = strlit1489;
  partcv[0] = 1;
  Object call1490 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compilenode returning call1490
  partcv[0] = 0;
  Object call1491 = callmethod(call1490, "not",
    1, partcv, params);
  gc_frame_end(callframe1487);
// compilenode returning call1491
// compilenode returning call1491
  Object if1486 = done;
  if (istrue(call1491)) {
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 492
  setline(492);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1492 = gc_frame_new();
  int callframe1493 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1494 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1493);
// compilenode returning call1494
// compilenode returning call1494
  partcv[0] = 0;
  Object call1495 = callmethod(call1494, "new",
    1, partcv, params);
  gc_frame_end(callframe1492);
// compilenode returning call1495
// compilenode returning call1495
  *var_suggestion = call1495;
  if (call1495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1499 == NULL) {
    strlit1499 = alloc_String("=");
    gc_root(strlit1499);
  }
// compilenode returning strlit1499
  int op_slot_right_1498 = gc_frame_newslot(strlit1499);
  int callframe1501 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1502 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1501);
// compilenode returning call1502
// compilenode returning call1502
  int op_slot_left_1498 = gc_frame_newslot(call1502);
  params[0] = strlit1499;
  partcv[0] = 1;
  Object opresult1503 = callmethod(call1502, "==", 1, partcv, params);
// compilenode returning opresult1503
  int op_slot_right_1497 = gc_frame_newslot(opresult1503);
  if (strlit1506 == NULL) {
    strlit1506 = alloc_String("bind");
    gc_root(strlit1506);
  }
// compilenode returning strlit1506
  int op_slot_right_1505 = gc_frame_newslot(strlit1506);
  int callframe1508 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1509 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1508);
// compilenode returning call1509
// compilenode returning call1509
  int op_slot_left_1505 = gc_frame_newslot(call1509);
  params[0] = strlit1506;
  partcv[0] = 1;
  Object opresult1510 = callmethod(call1509, "==", 1, partcv, params);
// compilenode returning opresult1510
  int op_slot_left_1497 = gc_frame_newslot(opresult1510);
  params[0] = opresult1503;
  partcv[0] = 1;
  Object opresult1511 = callmethod(opresult1510, "||", 1, partcv, params);
// compilenode returning opresult1511
  Object if1496 = done;
  if (istrue(opresult1511)) {
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1512 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit1513 == NULL) {
    strlit1513 = alloc_String("->");
    gc_root(strlit1513);
  }
// compilenode returning strlit1513
  gc_frame_newslot(strlit1513);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit1513;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1514 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe1512);
// compilenode returning call1514
    gc_frame_newslot(call1514);
    if1496 = call1514;
  } else {
// Begin line 496
  setline(496);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1515 = gc_frame_new();
  if (strlit1516 == NULL) {
    strlit1516 = alloc_String(" ->");
    gc_root(strlit1516);
  }
// compilenode returning strlit1516
  gc_frame_newslot(strlit1516);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1516;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1517 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1515);
// compilenode returning call1517
    gc_frame_newslot(call1517);
    if1496 = call1517;
  }
// compilenode returning if1496
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1518 = gc_frame_new();
  if (strlit1519 == NULL) {
    strlit1519 = alloc_String("A block must have one or more parameters followed by '->' and an expression.");
    gc_root(strlit1519);
  }
// compilenode returning strlit1519
  gc_frame_newslot(strlit1519);
// Begin line 499
  setline(499);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1520 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1521 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1520);
// compilenode returning call1521
// compilenode returning call1521
  gc_frame_newslot(call1521);
  int callframe1522 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1523 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1522);
// compilenode returning call1523
// compilenode returning call1523
  gc_frame_newslot(call1523);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 498
  setline(498);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1519;
  params[1] = call1521;
  params[2] = call1523;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1524 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1518);
// compilenode returning call1524
    gc_frame_newslot(call1524);
    if1486 = call1524;
  } else {
  }
// compilenode returning if1486
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1525 = gc_frame_new();
  partcv[0] = 0;
  Object call1526 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1525);
// compilenode returning call1526
    gc_frame_newslot(call1526);
    if1296 = call1526;
  } else {
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1528 = gc_frame_new();
  if (strlit1529 == NULL) {
    strlit1529 = alloc_String("semicolon");
    gc_root(strlit1529);
  }
// compilenode returning strlit1529
  gc_frame_newslot(strlit1529);
  params[0] = strlit1529;
  partcv[0] = 1;
  Object call1530 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1528);
// compilenode returning call1530
  Object if1527 = done;
  if (istrue(call1530)) {
// Begin line 503
  setline(503);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1531 = gc_frame_new();
  int callframe1532 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1533 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1532);
// compilenode returning call1533
// compilenode returning call1533
  gc_frame_newslot(call1533);
// compilenode returning *var_body
  params[0] = call1533;
  partcv[0] = 1;
  Object call1534 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1531);
// compilenode returning call1534
// Begin line 504
  setline(504);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1535 = gc_frame_new();
  partcv[0] = 0;
  Object call1536 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1535);
// compilenode returning call1536
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1538 = gc_frame_new();
  if (strlit1539 == NULL) {
    strlit1539 = alloc_String("semicolon");
    gc_root(strlit1539);
  }
// compilenode returning strlit1539
  gc_frame_newslot(strlit1539);
  params[0] = strlit1539;
  partcv[0] = 1;
  Object call1540 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1538);
// compilenode returning call1540
  Object if1537 = done;
  if (istrue(call1540)) {
// Begin line 506
  setline(506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1541 = gc_frame_new();
  partcv[0] = 0;
  Object call1542 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1541);
// compilenode returning call1542
// Begin line 510
  setline(510);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 507
  setline(507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1545 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call1546 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1545);
// compilenode returning call1546
// compilenode returning call1546
  int op_slot_right_1544 = gc_frame_newslot(call1546);
  int callframe1548 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1549 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1548);
// compilenode returning call1549
// compilenode returning call1549
  int op_slot_left_1544 = gc_frame_newslot(call1549);
  params[0] = call1546;
  partcv[0] = 1;
  Object opresult1550 = callmethod(call1549, "==", 1, partcv, params);
// compilenode returning opresult1550
  Object if1543 = done;
  if (istrue(opresult1550)) {
// Begin line 509
  setline(509);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1551 = alloc_Boolean(1);
// compilenode returning bool1551
  *var_indentFreePass = bool1551;
  if (bool1551 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1543 = done;
  } else {
  }
// compilenode returning if1543
    gc_frame_newslot(if1543);
    if1537 = if1543;
  } else {
  }
// compilenode returning if1537
    gc_frame_newslot(if1537);
    if1527 = if1537;
  } else {
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 514
  setline(514);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1555 = gc_frame_new();
  if (strlit1556 == NULL) {
    strlit1556 = alloc_String("bind");
    gc_root(strlit1556);
  }
// compilenode returning strlit1556
  gc_frame_newslot(strlit1556);
  params[0] = strlit1556;
  partcv[0] = 1;
  Object call1557 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1555);
// compilenode returning call1557
  int op_slot_right_1554 = gc_frame_newslot(call1557);
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1561 == NULL) {
    strlit1561 = alloc_String("index");
    gc_root(strlit1561);
  }
// compilenode returning strlit1561
  int op_slot_right_1560 = gc_frame_newslot(strlit1561);
  int callframe1563 = gc_frame_new();
  int callframe1564 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1565 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1564);
// compilenode returning call1565
// compilenode returning call1565
  partcv[0] = 0;
  Object call1566 = callmethod(call1565, "kind",
    1, partcv, params);
  gc_frame_end(callframe1563);
// compilenode returning call1566
// compilenode returning call1566
  int op_slot_left_1560 = gc_frame_newslot(call1566);
  params[0] = strlit1561;
  partcv[0] = 1;
  Object opresult1567 = callmethod(call1566, "==", 1, partcv, params);
// compilenode returning opresult1567
  int op_slot_right_1559 = gc_frame_newslot(opresult1567);
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1571 == NULL) {
    strlit1571 = alloc_String("identifier");
    gc_root(strlit1571);
  }
// compilenode returning strlit1571
  int op_slot_right_1570 = gc_frame_newslot(strlit1571);
  int callframe1573 = gc_frame_new();
  int callframe1574 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1575 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1574);
// compilenode returning call1575
// compilenode returning call1575
  partcv[0] = 0;
  Object call1576 = callmethod(call1575, "kind",
    1, partcv, params);
  gc_frame_end(callframe1573);
// compilenode returning call1576
// compilenode returning call1576
  int op_slot_left_1570 = gc_frame_newslot(call1576);
  params[0] = strlit1571;
  partcv[0] = 1;
  Object opresult1577 = callmethod(call1576, "==", 1, partcv, params);
// compilenode returning opresult1577
  int op_slot_right_1569 = gc_frame_newslot(opresult1577);
// Begin line 511
  setline(511);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1580 == NULL) {
    strlit1580 = alloc_String("member");
    gc_root(strlit1580);
  }
// compilenode returning strlit1580
  int op_slot_right_1579 = gc_frame_newslot(strlit1580);
  int callframe1582 = gc_frame_new();
  int callframe1583 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1584 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe1583);
// compilenode returning call1584
// compilenode returning call1584
  partcv[0] = 0;
  Object call1585 = callmethod(call1584, "kind",
    1, partcv, params);
  gc_frame_end(callframe1582);
// compilenode returning call1585
// compilenode returning call1585
  int op_slot_left_1579 = gc_frame_newslot(call1585);
  params[0] = strlit1580;
  partcv[0] = 1;
  Object opresult1586 = callmethod(call1585, "==", 1, partcv, params);
// compilenode returning opresult1586
  int op_slot_left_1569 = gc_frame_newslot(opresult1586);
  params[0] = opresult1577;
  partcv[0] = 1;
  Object opresult1587 = callmethod(opresult1586, "||", 1, partcv, params);
// compilenode returning opresult1587
  int op_slot_left_1559 = gc_frame_newslot(opresult1587);
  params[0] = opresult1567;
  partcv[0] = 1;
  Object opresult1588 = callmethod(opresult1587, "||", 1, partcv, params);
// compilenode returning opresult1588
  int op_slot_left_1554 = gc_frame_newslot(opresult1588);
  params[0] = call1557;
  partcv[0] = 1;
  Object opresult1589 = callmethod(opresult1588, "&&", 1, partcv, params);
// compilenode returning opresult1589
  Object if1553 = done;
  if (istrue(opresult1589)) {
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 515
  setline(515);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1590 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1591 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1590);
// compilenode returning call1591
// compilenode returning call1591
  *var_lhs = call1591;
  if (call1591 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1592 = gc_frame_new();
  partcv[0] = 0;
  Object call1593 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1592);
// compilenode returning call1593
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 517
  setline(517);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1595 = gc_frame_new();
  int callframe1596 = gc_frame_new();
  Object block1597 = alloc_Block(NULL, NULL, "parser", 517);
  gc_frame_newslot(block1597);
  block_savedest(block1597);
  Object closure1598 = createclosure(1, "_apply");
setclosureframe(closure1598, stackframe);
  addtoclosure(closure1598, selfslot);
  struct UserObject *uo1598 = (struct UserObject*)block1597;
  uo1598->data[0] = (Object)closure1598;
  Method *meth_meth_parser__apply1598 = addmethod2pos(block1597, "_apply", &meth_parser__apply1598, 0);
int argcv_meth_parser__apply1598[] = {0};
meth_meth_parser__apply1598->type = alloc_MethodType(1, argcv_meth_parser__apply1598);
  meth_meth_parser__apply1598->definitionModule = modulename;
  meth_meth_parser__apply1598->definitionLine = 517;
// compilenode returning block1597
  gc_frame_newslot(block1597);
  params[0] = block1597;
  partcv[0] = 1;
  Object call1602 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1596);
// compilenode returning call1602
  partcv[0] = 0;
  Object call1603 = callmethod(call1602, "not",
    1, partcv, params);
  gc_frame_end(callframe1595);
// compilenode returning call1603
// compilenode returning call1603
  Object if1594 = done;
  if (istrue(call1603)) {
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 518
  setline(518);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1604 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1604
  *var_suggestions = array1604;
  if (array1604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1605 = gc_frame_new();
  int callframe1606 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1607 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1606);
// compilenode returning call1607
// compilenode returning call1607
  partcv[0] = 0;
  Object call1608 = callmethod(call1607, "new",
    1, partcv, params);
  gc_frame_end(callframe1605);
// compilenode returning call1608
// compilenode returning call1608
  *var_suggestion = call1608;
  if (call1608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 520
  setline(520);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1609 = gc_frame_new();
  if (strlit1610 == NULL) {
    strlit1610 = alloc_String("rbrace");
    gc_root(strlit1610);
  }
// compilenode returning strlit1610
  gc_frame_newslot(strlit1610);
  params[0] = strlit1610;
  partcv[0] = 1;
  Object call1611 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1609);
// compilenode returning call1611
  *var_nextTok = call1611;
  if (call1611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 521
  setline(521);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1613 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1613 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1615 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1615
  Object if1612 = done;
  if (istrue(opresult1615)) {
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1616 = gc_frame_new();
  if (strlit1617 == NULL) {
    strlit1617 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1617);
  }
// compilenode returning strlit1617
  gc_frame_newslot(strlit1617);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1617;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1618 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1616);
// compilenode returning call1618
    gc_frame_newslot(call1618);
    if1612 = call1618;
  } else {
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1619 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe1620 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1621 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1620);
// compilenode returning call1621
// compilenode returning call1621
  gc_frame_newslot(call1621);
  Object bool1622 = alloc_Boolean(1);
// compilenode returning bool1622
  gc_frame_newslot(bool1622);
  Object bool1623 = alloc_Boolean(0);
// compilenode returning bool1623
  gc_frame_newslot(bool1623);
  if (strlit1624 == NULL) {
    strlit1624 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1624);
  }
// compilenode returning strlit1624
  gc_frame_newslot(strlit1624);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call1621;
  params[2] = bool1622;
  params[3] = bool1623;
  params[4] = strlit1624;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1625 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1619);
// compilenode returning call1625
    gc_frame_newslot(call1625);
    if1612 = call1625;
  }
// compilenode returning if1612
// Begin line 526
  setline(526);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1626 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1627 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1626);
// compilenode returning call1627
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 527
  setline(527);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1628 = gc_frame_new();
  int callframe1629 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1630 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1629);
// compilenode returning call1630
// compilenode returning call1630
  partcv[0] = 0;
  Object call1631 = callmethod(call1630, "new",
    1, partcv, params);
  gc_frame_end(callframe1628);
// compilenode returning call1631
// compilenode returning call1631
  *var_suggestion = call1631;
  if (call1631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 528
  setline(528);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1633 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe1634 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1635 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1634);
// compilenode returning call1635
// compilenode returning call1635
  gc_frame_newslot(call1635);
  Object bool1636 = alloc_Boolean(1);
// compilenode returning bool1636
  gc_frame_newslot(bool1636);
  Object bool1637 = alloc_Boolean(0);
// compilenode returning bool1637
  gc_frame_newslot(bool1637);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call1635;
  params[2] = bool1636;
  params[3] = bool1637;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1638 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe1633);
// compilenode returning call1638
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1639 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call1640 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe1639);
// compilenode returning call1640
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1641 = gc_frame_new();
  if (strlit1642 == NULL) {
    strlit1642 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit1642);
  }
// compilenode returning strlit1642
  gc_frame_newslot(strlit1642);
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1643 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1644 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1643);
// compilenode returning call1644
// compilenode returning call1644
  gc_frame_newslot(call1644);
  int callframe1645 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1646 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1645);
// compilenode returning call1646
// compilenode returning call1646
  gc_frame_newslot(call1646);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1642;
  params[1] = call1644;
  params[2] = call1646;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1647 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe1641);
// compilenode returning call1647
    gc_frame_newslot(call1647);
    if1594 = call1647;
  } else {
  }
// compilenode returning if1594
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1648 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1649 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1648);
// compilenode returning call1649
// compilenode returning call1649
  *var_rhs = call1649;
  if (call1649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 534
  setline(534);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1650 = gc_frame_new();
  int callframe1651 = gc_frame_new();
// compilenode returning *var_lhs
  gc_frame_newslot(*var_lhs);
// compilenode returning *var_rhs
  gc_frame_newslot(*var_rhs);
  int callframe1652 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call1653 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe1652);
// compilenode returning call1653
// compilenode returning call1653
  params[0] = *var_lhs;
  params[1] = *var_rhs;
  partcv[0] = 2;
  Object call1654 = callmethod(call1653, "new",
    1, partcv, params);
  gc_frame_end(callframe1651);
// compilenode returning call1654
  gc_frame_newslot(call1654);
// compilenode returning *var_body
  params[0] = call1654;
  partcv[0] = 1;
  Object call1655 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1650);
// compilenode returning call1655
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1657 = gc_frame_new();
  if (strlit1658 == NULL) {
    strlit1658 = alloc_String("semicolon");
    gc_root(strlit1658);
  }
// compilenode returning strlit1658
  gc_frame_newslot(strlit1658);
  params[0] = strlit1658;
  partcv[0] = 1;
  Object call1659 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1657);
// compilenode returning call1659
  Object if1656 = done;
  if (istrue(call1659)) {
// Begin line 536
  setline(536);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1660 = gc_frame_new();
  partcv[0] = 0;
  Object call1661 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1660);
// compilenode returning call1661
// Begin line 540
  setline(540);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 537
  setline(537);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1664 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call1665 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1664);
// compilenode returning call1665
// compilenode returning call1665
  int op_slot_right_1663 = gc_frame_newslot(call1665);
  int callframe1667 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1668 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1667);
// compilenode returning call1668
// compilenode returning call1668
  int op_slot_left_1663 = gc_frame_newslot(call1668);
  params[0] = call1665;
  partcv[0] = 1;
  Object opresult1669 = callmethod(call1668, "==", 1, partcv, params);
// compilenode returning opresult1669
  Object if1662 = done;
  if (istrue(opresult1669)) {
// Begin line 539
  setline(539);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1670 = alloc_Boolean(1);
// compilenode returning bool1670
  *var_indentFreePass = bool1670;
  if (bool1670 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1662 = done;
  } else {
  }
// compilenode returning if1662
    gc_frame_newslot(if1662);
    if1656 = if1662;
  } else {
  }
// compilenode returning if1656
    gc_frame_newslot(if1656);
    if1553 = if1656;
  } else {
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1672 = gc_frame_new();
  partcv[0] = 0;
  Object call1673 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1672);
// compilenode returning call1673
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1674 = gc_frame_new();
  int callframe1675 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1676 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1675);
// compilenode returning call1676
// compilenode returning call1676
  gc_frame_newslot(call1676);
// compilenode returning *var_body
  params[0] = call1676;
  partcv[0] = 1;
  Object call1677 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1674);
// compilenode returning call1677
    gc_frame_newslot(call1677);
    if1553 = call1677;
  }
// compilenode returning if1553
    gc_frame_newslot(if1553);
    if1527 = if1553;
  }
// compilenode returning if1527
    gc_frame_newslot(if1527);
    if1296 = if1527;
  }
// compilenode returning if1296
  gc_frame_end(frame);
  return if1296;
}
Object meth_parser__apply1706(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1707 = gc_frame_new();
  int callframe1708 = gc_frame_new();
  if (strlit1709 == NULL) {
    strlit1709 = alloc_String("rbrace");
    gc_root(strlit1709);
  }
// compilenode returning strlit1709
  gc_frame_newslot(strlit1709);
  params[0] = strlit1709;
  partcv[0] = 1;
  Object call1710 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1708);
// compilenode returning call1710
  partcv[0] = 0;
  Object call1711 = callmethod(call1710, "not",
    1, partcv, params);
  gc_frame_end(callframe1707);
// compilenode returning call1711
// compilenode returning call1711
  gc_frame_end(frame);
  return call1711;
}
Object meth_parser__apply1719(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1720 = gc_frame_new();
  partcv[0] = 0;
  Object call1721 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1720);
// compilenode returning call1721
  gc_frame_end(frame);
  return call1721;
}
Object meth_parser__apply1714(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_body = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 557
  setline(557);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1716 = gc_frame_new();
  int callframe1717 = gc_frame_new();
  Object block1718 = alloc_Block(NULL, NULL, "parser", 557);
  gc_frame_newslot(block1718);
  block_savedest(block1718);
  Object closure1719 = createclosure(1, "_apply");
setclosureframe(closure1719, stackframe);
  addtoclosure(closure1719, selfslot);
  struct UserObject *uo1719 = (struct UserObject*)block1718;
  uo1719->data[0] = (Object)closure1719;
  Method *meth_meth_parser__apply1719 = addmethod2pos(block1718, "_apply", &meth_parser__apply1719, 0);
int argcv_meth_parser__apply1719[] = {0};
meth_meth_parser__apply1719->type = alloc_MethodType(1, argcv_meth_parser__apply1719);
  meth_meth_parser__apply1719->definitionModule = modulename;
  meth_meth_parser__apply1719->definitionLine = 557;
// compilenode returning block1718
  gc_frame_newslot(block1718);
  params[0] = block1718;
  partcv[0] = 1;
  Object call1723 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1717);
// compilenode returning call1723
  partcv[0] = 0;
  Object call1724 = callmethod(call1723, "not",
    1, partcv, params);
  gc_frame_end(callframe1716);
// compilenode returning call1724
// compilenode returning call1724
  Object if1715 = done;
  if (istrue(call1724)) {
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 558
  setline(558);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1725 = gc_frame_new();
  int callframe1726 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1727 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1726);
// compilenode returning call1727
// compilenode returning call1727
  partcv[0] = 0;
  Object call1728 = callmethod(call1727, "new",
    1, partcv, params);
  gc_frame_end(callframe1725);
// compilenode returning call1728
// compilenode returning call1728
  *var_suggestion = call1728;
  if (call1728 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 559
  setline(559);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1729 = gc_frame_new();
  if (strlit1730 == NULL) {
    strlit1730 = alloc_String("}");
    gc_root(strlit1730);
  }
// compilenode returning strlit1730
  gc_frame_newslot(strlit1730);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1730;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1731 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1729);
// compilenode returning call1731
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1732 = gc_frame_new();
  if (strlit1733 == NULL) {
    strlit1733 = alloc_String("A block must end with a '}'.");
    gc_root(strlit1733);
  }
// compilenode returning strlit1733
  gc_frame_newslot(strlit1733);
// Begin line 561
  setline(561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1734 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1735 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1734);
// compilenode returning call1735
// compilenode returning call1735
  gc_frame_newslot(call1735);
  int callframe1736 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1737 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1736);
// compilenode returning call1737
// compilenode returning call1737
  gc_frame_newslot(call1737);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1733;
  params[1] = call1735;
  params[2] = call1737;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1738 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1732);
// compilenode returning call1738
    gc_frame_newslot(call1738);
    if1715 = call1738;
  } else {
  }
// compilenode returning if1715
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 563
  setline(563);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1739 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1740 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe1739);
// compilenode returning call1740
// compilenode returning call1740
  *var_tmp = call1740;
  if (call1740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1742 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_body
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call1743 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe1742);
// compilenode returning call1743
  gc_frame_end(frame);
  return call1743;
}
Object meth_parser_block1261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "block");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_braceIsType = getfromclosure(closure, 4);
  Object *var_errormessages = getfromclosure(closure, 5);
  Object *var_lastToken = getfromclosure(closure, 6);
  Object *var_indentFreePass = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_minIndentLevel = getfromclosure(closure, 9);
  Object *var_util = getfromclosure(closure, 10);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for block (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for block");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_minInd = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "minInd");
  Object *var_startIndent = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startIndent");
  Object *var_ident1 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "ident1");
  Object *var_s = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "s");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_params = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "params");
  Object *var_body = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "body");
  Object *var_havearrow = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "havearrow");
  Object *var_found = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "found");
  Object *var_i = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "i");
  Object *var_isMatchingBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "isMatchingBlock");
  Object *var_ln = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "ln");
  Object *var_o = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "o");
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1263 = gc_frame_new();
  if (strlit1264 == NULL) {
    strlit1264 = alloc_String("lbrace");
    gc_root(strlit1264);
  }
// compilenode returning strlit1264
  gc_frame_newslot(strlit1264);
  params[0] = strlit1264;
  partcv[0] = 1;
  Object call1265 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1263);
// compilenode returning call1265
  Object if1262 = done;
  if (istrue(call1265)) {
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1266 = gc_frame_new();
  partcv[0] = 0;
  Object call1267 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1266);
// compilenode returning call1267
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1269 = alloc_Float64(1);
// compilenode returning num1269
  int op_slot_right_1268 = gc_frame_newslot(num1269);
// compilenode returning *var_statementIndent
  int op_slot_left_1268 = gc_frame_newslot(*var_statementIndent);
  params[0] = num1269;
  partcv[0] = 1;
  Object sum1271 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compilenode returning sum1271
  *var_minInd = sum1271;
  if (sum1271 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_statementIndent
  *var_startIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_ident1 = undefined;
// compilenode returning done
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_s = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_tmp = undefined;
// compilenode returning done
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1272 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1272
  *var_params = array1272;
  if (array1272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array1273 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array1273
  *var_body = array1273;
  if (array1273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1274 = alloc_Boolean(1);
// compilenode returning bool1274
  *var_havearrow = bool1274;
  if (bool1274 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1275 = alloc_Boolean(0);
// compilenode returning bool1275
  *var_found = bool1275;
  if (bool1275 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1276 = alloc_Float64(0);
// compilenode returning num1276
  *var_i = num1276;
  if (num1276 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1277 = alloc_Boolean(0);
// compilenode returning bool1277
  *var_isMatchingBlock = bool1277;
  if (bool1277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1281 == NULL) {
    strlit1281 = alloc_String("lparen");
    gc_root(strlit1281);
  }
// compilenode returning strlit1281
  int op_slot_right_1280 = gc_frame_newslot(strlit1281);
  int callframe1283 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1284 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1283);
// compilenode returning call1284
// compilenode returning call1284
  int op_slot_left_1280 = gc_frame_newslot(call1284);
  params[0] = strlit1281;
  partcv[0] = 1;
  Object opresult1285 = callmethod(call1284, "==", 1, partcv, params);
// compilenode returning opresult1285
  Object if1279 = done;
  if (istrue(opresult1285)) {
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1286 = alloc_Boolean(1);
// compilenode returning bool1286
  *var_isMatchingBlock = bool1286;
  if (bool1286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1279 = done;
  } else {
  }
// compilenode returning if1279
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1288 = gc_frame_new();
  Object block1289 = alloc_Block(NULL, NULL, "parser", 432);
  gc_frame_newslot(block1289);
  block_savedest(block1289);
  Object closure1290 = createclosure(1, "_apply");
setclosureframe(closure1290, stackframe);
  addtoclosure(closure1290, selfslot);
  struct UserObject *uo1290 = (struct UserObject*)block1289;
  uo1290->data[0] = (Object)closure1290;
  Method *meth_meth_parser__apply1290 = addmethod2pos(block1289, "_apply", &meth_parser__apply1290, 0);
int argcv_meth_parser__apply1290[] = {0};
meth_meth_parser__apply1290->type = alloc_MethodType(1, argcv_meth_parser__apply1290);
  meth_meth_parser__apply1290->definitionModule = modulename;
  meth_meth_parser__apply1290->definitionLine = 429;
// compilenode returning block1289
  gc_frame_newslot(block1289);
  Object block1294 = alloc_Block(NULL, NULL, "parser", 432);
  gc_frame_newslot(block1294);
  block_savedest(block1294);
  Object closure1295 = createclosure(12, "_apply");
setclosureframe(closure1295, stackframe);
  addtoclosure(closure1295, var_values);
  addtoclosure(closure1295, var_ident1);
  addtoclosure(closure1295, var_braceIsType);
  addtoclosure(closure1295, var_errormessages);
  addtoclosure(closure1295, var_sym);
  addtoclosure(closure1295, var_lastToken);
  addtoclosure(closure1295, var_params);
  addtoclosure(closure1295, var_isMatchingBlock);
  addtoclosure(closure1295, var_body);
  addtoclosure(closure1295, var_indentFreePass);
  addtoclosure(closure1295, var_ast);
  addtoclosure(closure1295, selfslot);
  struct UserObject *uo1295 = (struct UserObject*)block1294;
  uo1295->data[0] = (Object)closure1295;
  Method *meth_meth_parser__apply1295 = addmethod2pos(block1294, "_apply", &meth_parser__apply1295, 0);
int argcv_meth_parser__apply1295[] = {0};
meth_meth_parser__apply1295->type = alloc_MethodType(1, argcv_meth_parser__apply1295);
  meth_meth_parser__apply1295->definitionModule = modulename;
  meth_meth_parser__apply1295->definitionLine = 429;
// compilenode returning block1294
  gc_frame_newslot(block1294);
  params[0] = block1289;
  params[1] = block1294;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1679 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1288);
// compilenode returning call1679
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1681 = gc_frame_new();
  if (strlit1682 == NULL) {
    strlit1682 = alloc_String("arrow");
    gc_root(strlit1682);
  }
// compilenode returning strlit1682
  gc_frame_newslot(strlit1682);
  params[0] = strlit1682;
  partcv[0] = 1;
  Object call1683 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1681);
// compilenode returning call1683
  Object if1680 = done;
  if (istrue(call1683)) {
// Begin line 547
  setline(547);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1684 = gc_frame_new();
  partcv[0] = 0;
  Object call1685 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1684);
// compilenode returning call1685
    gc_frame_newslot(call1685);
    if1680 = call1685;
  } else {
  }
// compilenode returning if1680
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1686 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call1687 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe1686);
// compilenode returning call1687
// compilenode returning call1687
  *var_ln = call1687;
  if (call1687 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1690 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call1691 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1690);
// compilenode returning call1691
// compilenode returning call1691
  int op_slot_right_1689 = gc_frame_newslot(call1691);
  int callframe1693 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1694 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1693);
// compilenode returning call1694
// compilenode returning call1694
  int op_slot_left_1689 = gc_frame_newslot(call1694);
  params[0] = call1691;
  partcv[0] = 1;
  Object opresult1695 = callmethod(call1694, "==", 1, partcv, params);
// compilenode returning opresult1695
  Object if1688 = done;
  if (istrue(opresult1695)) {
// Begin line 552
  setline(552);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 551
  setline(551);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1697 = alloc_Float64(1);
// compilenode returning num1697
  int op_slot_right_1696 = gc_frame_newslot(num1697);
  int callframe1699 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1700 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1699);
// compilenode returning call1700
// compilenode returning call1700
  int op_slot_left_1696 = gc_frame_newslot(call1700);
  params[0] = num1697;
  partcv[0] = 1;
  Object diff1701 = callmethod(call1700, "-", 1, partcv, params);
// compilenode returning diff1701
  *var_minIndentLevel = diff1701;
  if (diff1701 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1688 = done;
  } else {
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minInd
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1688 = done;
  }
// compilenode returning if1688
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1704 = gc_frame_new();
  Object block1705 = alloc_Block(NULL, NULL, "parser", 555);
  gc_frame_newslot(block1705);
  block_savedest(block1705);
  Object closure1706 = createclosure(1, "_apply");
setclosureframe(closure1706, stackframe);
  addtoclosure(closure1706, selfslot);
  struct UserObject *uo1706 = (struct UserObject*)block1705;
  uo1706->data[0] = (Object)closure1706;
  Method *meth_meth_parser__apply1706 = addmethod2pos(block1705, "_apply", &meth_parser__apply1706, 0);
int argcv_meth_parser__apply1706[] = {0};
meth_meth_parser__apply1706->type = alloc_MethodType(1, argcv_meth_parser__apply1706);
  meth_meth_parser__apply1706->definitionModule = modulename;
  meth_meth_parser__apply1706->definitionLine = 551;
// compilenode returning block1705
  gc_frame_newslot(block1705);
  Object block1713 = alloc_Block(NULL, NULL, "parser", 555);
  gc_frame_newslot(block1713);
  block_savedest(block1713);
  Object closure1714 = createclosure(7, "_apply");
setclosureframe(closure1714, stackframe);
  addtoclosure(closure1714, var_errormessages);
  addtoclosure(closure1714, var_lastToken);
  addtoclosure(closure1714, var_sym);
  addtoclosure(closure1714, var_values);
  addtoclosure(closure1714, var_tmp);
  addtoclosure(closure1714, var_body);
  addtoclosure(closure1714, selfslot);
  struct UserObject *uo1714 = (struct UserObject*)block1713;
  uo1714->data[0] = (Object)closure1714;
  Method *meth_meth_parser__apply1714 = addmethod2pos(block1713, "_apply", &meth_parser__apply1714, 0);
int argcv_meth_parser__apply1714[] = {0};
meth_meth_parser__apply1714->type = alloc_MethodType(1, argcv_meth_parser__apply1714);
  meth_meth_parser__apply1714->definitionModule = modulename;
  meth_meth_parser__apply1714->definitionLine = 555;
// compilenode returning block1713
  gc_frame_newslot(block1713);
  params[0] = block1705;
  params[1] = block1713;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1745 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1704);
// compilenode returning call1745
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1747 = alloc_Float64(1);
// compilenode returning num1747
  int op_slot_right_1746 = gc_frame_newslot(num1747);
// compilenode returning *var_minInd
  int op_slot_left_1746 = gc_frame_newslot(*var_minInd);
  params[0] = num1747;
  partcv[0] = 1;
  Object diff1749 = callmethod(*var_minInd, "-", 1, partcv, params);
// compilenode returning diff1749
  *var_minIndentLevel = diff1749;
  if (diff1749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_startIndent
  *var_statementIndent = *var_startIndent;
  if (*var_startIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 568
  setline(568);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1752 = gc_frame_new();
  partcv[0] = 0;
  Object call1753 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1752);
// compilenode returning call1753
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1754 = gc_frame_new();
  int callframe1755 = gc_frame_new();
// compilenode returning *var_btok
  partcv[0] = 0;
  Object call1756 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1755);
// compilenode returning call1756
// compilenode returning call1756
  gc_frame_newslot(call1756);
// compilenode returning *var_util
  params[0] = call1756;
  partcv[0] = 1;
  Object call1757 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe1754);
// compilenode returning call1757
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1758 = gc_frame_new();
// compilenode returning *var_params
  gc_frame_newslot(*var_params);
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
  int callframe1759 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call1760 = callmethod(*var_ast, "blockNode",
    1, partcv, params);
  gc_frame_end(callframe1759);
// compilenode returning call1760
// compilenode returning call1760
  params[0] = *var_params;
  params[1] = *var_body;
  partcv[0] = 2;
  Object call1761 = callmethod(call1760, "new",
    1, partcv, params);
  gc_frame_end(callframe1758);
// compilenode returning call1761
  *var_o = call1761;
  if (call1761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_isMatchingBlock
  Object if1762 = done;
  if (istrue(*var_isMatchingBlock)) {
// Begin line 575
  setline(575);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num1765 = alloc_Float64(0);
// compilenode returning num1765
  int op_slot_right_1764 = gc_frame_newslot(num1765);
  int callframe1767 = gc_frame_new();
// compilenode returning *var_params
  partcv[0] = 0;
  Object call1768 = callmethod(*var_params, "size",
    1, partcv, params);
  gc_frame_end(callframe1767);
// compilenode returning call1768
// compilenode returning call1768
  int op_slot_left_1764 = gc_frame_newslot(call1768);
  params[0] = num1765;
  partcv[0] = 1;
  Object opresult1769 = callmethod(call1768, ">", 1, partcv, params);
// compilenode returning opresult1769
  Object if1763 = done;
  if (istrue(opresult1769)) {
// Begin line 574
  setline(574);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1770 = gc_frame_new();
// Begin line 573
  setline(573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1771 = gc_frame_new();
// compilenode returning *var_params
  partcv[0] = 0;
  Object call1772 = callmethod(*var_params, "first",
    1, partcv, params);
  gc_frame_end(callframe1771);
// compilenode returning call1772
// compilenode returning call1772
  gc_frame_newslot(call1772);
// compilenode returning *var_o
  params[0] = call1772;
  partcv[0] = 1;
  Object call1773 = callmethod(*var_o, "matchingPattern:=",
    1, partcv, params);
  gc_frame_end(callframe1770);
// compilenode returning call1773
// compilenode returning done
    gc_frame_newslot(done);
    if1763 = done;
  } else {
  }
// compilenode returning if1763
    gc_frame_newslot(if1763);
    if1762 = if1763;
  } else {
  }
// compilenode returning if1762
// Begin line 576
  setline(576);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1774 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1775 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe1774);
// compilenode returning call1775
    gc_frame_newslot(call1775);
    if1262 = call1775;
  } else {
  }
// compilenode returning if1262
  gc_frame_end(frame);
  return if1262;
}
Object meth_parser__apply1805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_btok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 592
  setline(592);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1810 == NULL) {
    strlit1810 = alloc_String("then");
    gc_root(strlit1810);
  }
// compilenode returning strlit1810
  int op_slot_right_1809 = gc_frame_newslot(strlit1810);
  int callframe1812 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1813 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe1812);
// compilenode returning call1813
// compilenode returning call1813
  int op_slot_left_1809 = gc_frame_newslot(call1813);
  params[0] = strlit1810;
  partcv[0] = 1;
  Object opresult1814 = callmethod(call1813, "==", 1, partcv, params);
// compilenode returning opresult1814
  int op_slot_right_1808 = gc_frame_newslot(opresult1814);
  if (strlit1817 == NULL) {
    strlit1817 = alloc_String("identifier");
    gc_root(strlit1817);
  }
// compilenode returning strlit1817
  int op_slot_right_1816 = gc_frame_newslot(strlit1817);
  int callframe1819 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1820 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1819);
// compilenode returning call1820
// compilenode returning call1820
  int op_slot_left_1816 = gc_frame_newslot(call1820);
  params[0] = strlit1817;
  partcv[0] = 1;
  Object opresult1821 = callmethod(call1820, "==", 1, partcv, params);
// compilenode returning opresult1821
  int op_slot_left_1808 = gc_frame_newslot(opresult1821);
  params[0] = opresult1814;
  partcv[0] = 1;
  Object opresult1822 = callmethod(opresult1821, "&&", 1, partcv, params);
// compilenode returning opresult1822
  int op_slot_right_1807 = gc_frame_newslot(opresult1822);
// Begin line 591
  setline(591);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1826 == NULL) {
    strlit1826 = alloc_String("lbrace");
    gc_root(strlit1826);
  }
// compilenode returning strlit1826
  int op_slot_right_1825 = gc_frame_newslot(strlit1826);
  int callframe1828 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1829 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1828);
// compilenode returning call1829
// compilenode returning call1829
  int op_slot_left_1825 = gc_frame_newslot(call1829);
  params[0] = strlit1826;
  partcv[0] = 1;
  Object opresult1830 = callmethod(call1829, "==", 1, partcv, params);
// compilenode returning opresult1830
  int op_slot_right_1824 = gc_frame_newslot(opresult1830);
  if (strlit1833 == NULL) {
    strlit1833 = alloc_String("rparen");
    gc_root(strlit1833);
  }
// compilenode returning strlit1833
  int op_slot_right_1832 = gc_frame_newslot(strlit1833);
  int callframe1835 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1836 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1835);
// compilenode returning call1836
// compilenode returning call1836
  int op_slot_left_1832 = gc_frame_newslot(call1836);
  params[0] = strlit1833;
  partcv[0] = 1;
  Object opresult1837 = callmethod(call1836, "==", 1, partcv, params);
// compilenode returning opresult1837
  int op_slot_left_1824 = gc_frame_newslot(opresult1837);
  params[0] = opresult1830;
  partcv[0] = 1;
  Object opresult1838 = callmethod(opresult1837, "||", 1, partcv, params);
// compilenode returning opresult1838
  int op_slot_left_1807 = gc_frame_newslot(opresult1838);
  params[0] = opresult1822;
  partcv[0] = 1;
  Object opresult1839 = callmethod(opresult1838, "||", 1, partcv, params);
// compilenode returning opresult1839
  int op_slot_right_1806 = gc_frame_newslot(opresult1839);
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1842 = gc_frame_new();
// compilenode returning *var_btok
  partcv[0] = 0;
  Object call1843 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe1842);
// compilenode returning call1843
// compilenode returning call1843
  int op_slot_right_1841 = gc_frame_newslot(call1843);
  int callframe1845 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1846 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1845);
// compilenode returning call1846
// compilenode returning call1846
  int op_slot_left_1841 = gc_frame_newslot(call1846);
  params[0] = call1843;
  partcv[0] = 1;
  Object opresult1847 = callmethod(call1846, "==", 1, partcv, params);
// compilenode returning opresult1847
  int op_slot_left_1806 = gc_frame_newslot(opresult1847);
  params[0] = opresult1839;
  partcv[0] = 1;
  Object opresult1848 = callmethod(opresult1847, "&&", 1, partcv, params);
// compilenode returning opresult1848
  gc_frame_end(frame);
  return opresult1848;
}
Object meth_parser__apply1935(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe1936 = gc_frame_new();
  partcv[0] = 0;
  Object call1937 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1936);
// compilenode returning call1937
  gc_frame_end(frame);
  return call1937;
}
Object meth_parser__apply1947(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit1950 == NULL) {
    strlit1950 = alloc_String("rparen");
    gc_root(strlit1950);
  }
// compilenode returning strlit1950
  int op_slot_right_1949 = gc_frame_newslot(strlit1950);
  int callframe1952 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1953 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe1952);
// compilenode returning call1953
// compilenode returning call1953
  int op_slot_left_1949 = gc_frame_newslot(call1953);
  params[0] = strlit1950;
  partcv[0] = 1;
  Object opresult1954 = callmethod(call1953, "==", 1, partcv, params);
// compilenode returning opresult1954
  int op_slot_right_1948 = gc_frame_newslot(opresult1954);
  int callframe1957 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call1958 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe1957);
// compilenode returning call1958
// compilenode returning call1958
  int op_slot_right_1956 = gc_frame_newslot(call1958);
  int callframe1960 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call1961 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe1960);
// compilenode returning call1961
// compilenode returning call1961
  int op_slot_left_1956 = gc_frame_newslot(call1961);
  params[0] = call1958;
  partcv[0] = 1;
  Object opresult1962 = callmethod(call1961, "==", 1, partcv, params);
// compilenode returning opresult1962
  int op_slot_left_1948 = gc_frame_newslot(opresult1962);
  params[0] = opresult1954;
  partcv[0] = 1;
  Object opresult1963 = callmethod(opresult1962, "&&", 1, partcv, params);
// compilenode returning opresult1963
  gc_frame_end(frame);
  return opresult1963;
}
Object meth_parser__apply2168(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2169 = gc_frame_new();
  int callframe2170 = gc_frame_new();
  if (strlit2171 == NULL) {
    strlit2171 = alloc_String("rbrace");
    gc_root(strlit2171);
  }
// compilenode returning strlit2171
  gc_frame_newslot(strlit2171);
  params[0] = strlit2171;
  partcv[0] = 1;
  Object call2172 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2170);
// compilenode returning call2172
  partcv[0] = 0;
  Object call2173 = callmethod(call2172, "not",
    1, partcv, params);
  gc_frame_end(callframe2169);
// compilenode returning call2173
// compilenode returning call2173
  gc_frame_end(frame);
  return call2173;
}
Object meth_parser__apply2181(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2182 = gc_frame_new();
  partcv[0] = 0;
  Object call2183 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2182);
// compilenode returning call2183
  gc_frame_end(frame);
  return call2183;
}
Object meth_parser__apply2176(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_body = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2178 = gc_frame_new();
  int callframe2179 = gc_frame_new();
  Object block2180 = alloc_Block(NULL, NULL, "parser", 693);
  gc_frame_newslot(block2180);
  block_savedest(block2180);
  Object closure2181 = createclosure(1, "_apply");
setclosureframe(closure2181, stackframe);
  addtoclosure(closure2181, selfslot);
  struct UserObject *uo2181 = (struct UserObject*)block2180;
  uo2181->data[0] = (Object)closure2181;
  Method *meth_meth_parser__apply2181 = addmethod2pos(block2180, "_apply", &meth_parser__apply2181, 0);
int argcv_meth_parser__apply2181[] = {0};
meth_meth_parser__apply2181->type = alloc_MethodType(1, argcv_meth_parser__apply2181);
  meth_meth_parser__apply2181->definitionModule = modulename;
  meth_meth_parser__apply2181->definitionLine = 693;
// compilenode returning block2180
  gc_frame_newslot(block2180);
  params[0] = block2180;
  partcv[0] = 1;
  Object call2185 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2179);
// compilenode returning call2185
  partcv[0] = 0;
  Object call2186 = callmethod(call2185, "not",
    1, partcv, params);
  gc_frame_end(callframe2178);
// compilenode returning call2186
// compilenode returning call2186
  Object if2177 = done;
  if (istrue(call2186)) {
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2187 = gc_frame_new();
  int callframe2188 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2189 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2188);
// compilenode returning call2189
// compilenode returning call2189
  partcv[0] = 0;
  Object call2190 = callmethod(call2189, "new",
    1, partcv, params);
  gc_frame_end(callframe2187);
// compilenode returning call2190
// compilenode returning call2190
  *var_suggestion = call2190;
  if (call2190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 695
  setline(695);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2191 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2192 = alloc_Boolean(0);
// compilenode returning bool2192
  gc_frame_newslot(bool2192);
  params[0] = *var_btok;
  params[1] = bool2192;
  partcv[0] = 2;
  Object call2193 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2191);
// compilenode returning call2193
  *var_closingBrace = call2193;
  if (call2193 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 696
  setline(696);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2196 = alloc_Boolean(0);
// compilenode returning bool2196
  int op_slot_right_2195 = gc_frame_newslot(bool2196);
  int callframe2198 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2199 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2198);
// compilenode returning call2199
// compilenode returning call2199
  int op_slot_left_2195 = gc_frame_newslot(call2199);
  params[0] = bool2196;
  partcv[0] = 1;
  Object opresult2200 = callmethod(call2199, "==", 1, partcv, params);
// compilenode returning opresult2200
  Object if2194 = done;
  if (istrue(opresult2200)) {
// Begin line 702
  setline(702);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 697
  setline(697);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2202 = gc_frame_newslot(*var_lastToken);
  int callframe2204 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2205 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2204);
// compilenode returning call2205
// compilenode returning call2205
  int op_slot_left_2202 = gc_frame_newslot(call2205);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2206 = callmethod(call2205, "==", 1, partcv, params);
// compilenode returning opresult2206
  Object if2201 = done;
  if (istrue(opresult2206)) {
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2207 = gc_frame_new();
  if (strlit2208 == NULL) {
    strlit2208 = alloc_String("}");
    gc_root(strlit2208);
  }
// compilenode returning strlit2208
  gc_frame_newslot(strlit2208);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2208;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2209 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2207);
// compilenode returning call2209
    gc_frame_newslot(call2209);
    if2201 = call2209;
  } else {
// Begin line 700
  setline(700);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2210 = gc_frame_new();
  Object num2212 = alloc_Float64(0.1);
// compilenode returning num2212
  int op_slot_right_2211 = gc_frame_newslot(num2212);
  int callframe2214 = gc_frame_new();
  int callframe2215 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2216 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2215);
// compilenode returning call2216
// compilenode returning call2216
  partcv[0] = 0;
  Object call2217 = callmethod(call2216, "line",
    1, partcv, params);
  gc_frame_end(callframe2214);
// compilenode returning call2217
// compilenode returning call2217
  int op_slot_left_2211 = gc_frame_newslot(call2217);
  params[0] = num2212;
  partcv[0] = 1;
  Object sum2218 = callmethod(call2217, "+", 1, partcv, params);
// compilenode returning sum2218
  gc_frame_newslot(sum2218);
  if (strlit2219 == NULL) {
    strlit2219 = alloc_String("}");
    gc_root(strlit2219);
  }
// compilenode returning strlit2219
  gc_frame_newslot(strlit2219);
// compilenode returning *var_suggestion
  params[0] = sum2218;
  params[1] = strlit2219;
  partcv[0] = 2;
  Object call2220 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2210);
// compilenode returning call2220
    gc_frame_newslot(call2220);
    if2201 = call2220;
  }
// compilenode returning if2201
    gc_frame_newslot(if2201);
    if2194 = if2201;
  } else {
  }
// compilenode returning if2194
// Begin line 703
  setline(703);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2221 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2222 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2221);
// compilenode returning call2222
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2223 = gc_frame_new();
  if (strlit2224 == NULL) {
    strlit2224 = alloc_String("An if statement must end with a '}'.");
    gc_root(strlit2224);
  }
// compilenode returning strlit2224
  gc_frame_newslot(strlit2224);
// Begin line 705
  setline(705);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2225 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2226 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2225);
// compilenode returning call2226
// compilenode returning call2226
  gc_frame_newslot(call2226);
  int callframe2227 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2228 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2227);
// compilenode returning call2228
// compilenode returning call2228
  gc_frame_newslot(call2228);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 704
  setline(704);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2224;
  params[1] = call2226;
  params[2] = call2228;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2229 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2223);
// compilenode returning call2229
    gc_frame_newslot(call2229);
    if2177 = call2229;
  } else {
  }
// compilenode returning if2177
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 707
  setline(707);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2230 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call2231 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2230);
// compilenode returning call2231
// compilenode returning call2231
  *var_v = call2231;
  if (call2231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 708
  setline(708);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2233 = gc_frame_new();
// compilenode returning *var_v
  gc_frame_newslot(*var_v);
// compilenode returning *var_body
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2234 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe2233);
// compilenode returning call2234
  gc_frame_end(frame);
  return call2234;
}
Object meth_parser__apply2241(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit2244 == NULL) {
    strlit2244 = alloc_String("elseif");
    gc_root(strlit2244);
  }
// compilenode returning strlit2244
  int op_slot_right_2243 = gc_frame_newslot(strlit2244);
  int callframe2246 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2247 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2246);
// compilenode returning call2247
// compilenode returning call2247
  int op_slot_left_2243 = gc_frame_newslot(call2247);
  params[0] = strlit2244;
  partcv[0] = 1;
  Object opresult2248 = callmethod(call2247, "==", 1, partcv, params);
// compilenode returning opresult2248
  int op_slot_right_2242 = gc_frame_newslot(opresult2248);
  int callframe2250 = gc_frame_new();
  if (strlit2251 == NULL) {
    strlit2251 = alloc_String("identifier");
    gc_root(strlit2251);
  }
// compilenode returning strlit2251
  gc_frame_newslot(strlit2251);
  params[0] = strlit2251;
  partcv[0] = 1;
  Object call2252 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2250);
// compilenode returning call2252
  int op_slot_left_2242 = gc_frame_newslot(call2252);
  params[0] = opresult2248;
  partcv[0] = 1;
  Object opresult2253 = callmethod(call2252, "&&", 1, partcv, params);
// compilenode returning opresult2253
  gc_frame_end(frame);
  return opresult2253;
}
Object meth_parser__apply2263(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit2265 == NULL) {
    strlit2265 = alloc_String("lbrace");
    gc_root(strlit2265);
  }
// compilenode returning strlit2265
  int op_slot_right_2264 = gc_frame_newslot(strlit2265);
  int callframe2267 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2268 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2267);
// compilenode returning call2268
// compilenode returning call2268
  int op_slot_left_2264 = gc_frame_newslot(call2268);
  params[0] = strlit2265;
  partcv[0] = 1;
  Object opresult2269 = callmethod(call2268, "==", 1, partcv, params);
// compilenode returning opresult2269
  gc_frame_end(frame);
  return opresult2269;
}
Object meth_parser__apply2305(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2310 == NULL) {
    strlit2310 = alloc_String("then");
    gc_root(strlit2310);
  }
// compilenode returning strlit2310
  int op_slot_right_2309 = gc_frame_newslot(strlit2310);
  int callframe2312 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2313 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe2312);
// compilenode returning call2313
// compilenode returning call2313
  int op_slot_left_2309 = gc_frame_newslot(call2313);
  params[0] = strlit2310;
  partcv[0] = 1;
  Object opresult2314 = callmethod(call2313, "==", 1, partcv, params);
// compilenode returning opresult2314
  int op_slot_right_2308 = gc_frame_newslot(opresult2314);
  if (strlit2317 == NULL) {
    strlit2317 = alloc_String("identifier");
    gc_root(strlit2317);
  }
// compilenode returning strlit2317
  int op_slot_right_2316 = gc_frame_newslot(strlit2317);
  int callframe2319 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2320 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2319);
// compilenode returning call2320
// compilenode returning call2320
  int op_slot_left_2316 = gc_frame_newslot(call2320);
  params[0] = strlit2317;
  partcv[0] = 1;
  Object opresult2321 = callmethod(call2320, "==", 1, partcv, params);
// compilenode returning opresult2321
  int op_slot_left_2308 = gc_frame_newslot(opresult2321);
  params[0] = opresult2314;
  partcv[0] = 1;
  Object opresult2322 = callmethod(opresult2321, "&&", 1, partcv, params);
// compilenode returning opresult2322
  int op_slot_right_2307 = gc_frame_newslot(opresult2322);
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2326 == NULL) {
    strlit2326 = alloc_String("lbrace");
    gc_root(strlit2326);
  }
// compilenode returning strlit2326
  int op_slot_right_2325 = gc_frame_newslot(strlit2326);
  int callframe2328 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2329 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2328);
// compilenode returning call2329
// compilenode returning call2329
  int op_slot_left_2325 = gc_frame_newslot(call2329);
  params[0] = strlit2326;
  partcv[0] = 1;
  Object opresult2330 = callmethod(call2329, "==", 1, partcv, params);
// compilenode returning opresult2330
  int op_slot_right_2324 = gc_frame_newslot(opresult2330);
  if (strlit2334 == NULL) {
    strlit2334 = alloc_String("rbrace");
    gc_root(strlit2334);
  }
// compilenode returning strlit2334
  int op_slot_right_2333 = gc_frame_newslot(strlit2334);
  int callframe2336 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2337 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2336);
// compilenode returning call2337
// compilenode returning call2337
  int op_slot_left_2333 = gc_frame_newslot(call2337);
  params[0] = strlit2334;
  partcv[0] = 1;
  Object opresult2338 = callmethod(call2337, "==", 1, partcv, params);
// compilenode returning opresult2338
  int op_slot_right_2332 = gc_frame_newslot(opresult2338);
  if (strlit2341 == NULL) {
    strlit2341 = alloc_String("rparen");
    gc_root(strlit2341);
  }
// compilenode returning strlit2341
  int op_slot_right_2340 = gc_frame_newslot(strlit2341);
  int callframe2343 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2344 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2343);
// compilenode returning call2344
// compilenode returning call2344
  int op_slot_left_2340 = gc_frame_newslot(call2344);
  params[0] = strlit2341;
  partcv[0] = 1;
  Object opresult2345 = callmethod(call2344, "==", 1, partcv, params);
// compilenode returning opresult2345
  int op_slot_left_2332 = gc_frame_newslot(opresult2345);
  params[0] = opresult2338;
  partcv[0] = 1;
  Object opresult2346 = callmethod(opresult2345, "||", 1, partcv, params);
// compilenode returning opresult2346
  int op_slot_left_2324 = gc_frame_newslot(opresult2346);
  params[0] = opresult2330;
  partcv[0] = 1;
  Object opresult2347 = callmethod(opresult2346, "||", 1, partcv, params);
// compilenode returning opresult2347
  int op_slot_left_2307 = gc_frame_newslot(opresult2347);
  params[0] = opresult2322;
  partcv[0] = 1;
  Object opresult2348 = callmethod(opresult2347, "||", 1, partcv, params);
// compilenode returning opresult2348
  int op_slot_right_2306 = gc_frame_newslot(opresult2348);
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2351 = gc_frame_new();
// compilenode returning *var_statementToken
  partcv[0] = 0;
  Object call2352 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2351);
// compilenode returning call2352
// compilenode returning call2352
  int op_slot_right_2350 = gc_frame_newslot(call2352);
  int callframe2354 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2355 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2354);
// compilenode returning call2355
// compilenode returning call2355
  int op_slot_left_2350 = gc_frame_newslot(call2355);
  params[0] = call2352;
  partcv[0] = 1;
  Object opresult2356 = callmethod(call2355, "==", 1, partcv, params);
// compilenode returning opresult2356
  int op_slot_left_2306 = gc_frame_newslot(opresult2356);
  params[0] = opresult2348;
  partcv[0] = 1;
  Object opresult2357 = callmethod(opresult2356, "&&", 1, partcv, params);
// compilenode returning opresult2357
  gc_frame_end(frame);
  return opresult2357;
}
Object meth_parser__apply2444(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2445 = gc_frame_new();
  partcv[0] = 0;
  Object call2446 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2445);
// compilenode returning call2446
  gc_frame_end(frame);
  return call2446;
}
Object meth_parser__apply2456(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2460 == NULL) {
    strlit2460 = alloc_String("rbrace");
    gc_root(strlit2460);
  }
// compilenode returning strlit2460
  int op_slot_right_2459 = gc_frame_newslot(strlit2460);
  int callframe2462 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2463 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2462);
// compilenode returning call2463
// compilenode returning call2463
  int op_slot_left_2459 = gc_frame_newslot(call2463);
  params[0] = strlit2460;
  partcv[0] = 1;
  Object opresult2464 = callmethod(call2463, "==", 1, partcv, params);
// compilenode returning opresult2464
  int op_slot_right_2458 = gc_frame_newslot(opresult2464);
  if (strlit2467 == NULL) {
    strlit2467 = alloc_String("rparen");
    gc_root(strlit2467);
  }
// compilenode returning strlit2467
  int op_slot_right_2466 = gc_frame_newslot(strlit2467);
  int callframe2469 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2470 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe2469);
// compilenode returning call2470
// compilenode returning call2470
  int op_slot_left_2466 = gc_frame_newslot(call2470);
  params[0] = strlit2467;
  partcv[0] = 1;
  Object opresult2471 = callmethod(call2470, "==", 1, partcv, params);
// compilenode returning opresult2471
  int op_slot_left_2458 = gc_frame_newslot(opresult2471);
  params[0] = opresult2464;
  partcv[0] = 1;
  Object opresult2472 = callmethod(opresult2471, "||", 1, partcv, params);
// compilenode returning opresult2472
  int op_slot_right_2457 = gc_frame_newslot(opresult2472);
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2475 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2476 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2475);
// compilenode returning call2476
// compilenode returning call2476
  int op_slot_right_2474 = gc_frame_newslot(call2476);
  int callframe2478 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call2479 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe2478);
// compilenode returning call2479
// compilenode returning call2479
  int op_slot_left_2474 = gc_frame_newslot(call2479);
  params[0] = call2476;
  partcv[0] = 1;
  Object opresult2480 = callmethod(call2479, "==", 1, partcv, params);
// compilenode returning opresult2480
  int op_slot_left_2457 = gc_frame_newslot(opresult2480);
  params[0] = opresult2472;
  partcv[0] = 1;
  Object opresult2481 = callmethod(opresult2480, "&&", 1, partcv, params);
// compilenode returning opresult2481
  gc_frame_end(frame);
  return opresult2481;
}
Object meth_parser__apply2792(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2793 = gc_frame_new();
  int callframe2794 = gc_frame_new();
  if (strlit2795 == NULL) {
    strlit2795 = alloc_String("rbrace");
    gc_root(strlit2795);
  }
// compilenode returning strlit2795
  gc_frame_newslot(strlit2795);
  params[0] = strlit2795;
  partcv[0] = 1;
  Object call2796 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2794);
// compilenode returning call2796
  partcv[0] = 0;
  Object call2797 = callmethod(call2796, "not",
    1, partcv, params);
  gc_frame_end(callframe2793);
// compilenode returning call2797
// compilenode returning call2797
  gc_frame_end(frame);
  return call2797;
}
Object meth_parser__apply2805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2806 = gc_frame_new();
  partcv[0] = 0;
  Object call2807 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2806);
// compilenode returning call2807
  gc_frame_end(frame);
  return call2807;
}
Object meth_parser__apply2800(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 851
  setline(851);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2802 = gc_frame_new();
  int callframe2803 = gc_frame_new();
  Object block2804 = alloc_Block(NULL, NULL, "parser", 851);
  gc_frame_newslot(block2804);
  block_savedest(block2804);
  Object closure2805 = createclosure(1, "_apply");
setclosureframe(closure2805, stackframe);
  addtoclosure(closure2805, selfslot);
  struct UserObject *uo2805 = (struct UserObject*)block2804;
  uo2805->data[0] = (Object)closure2805;
  Method *meth_meth_parser__apply2805 = addmethod2pos(block2804, "_apply", &meth_parser__apply2805, 0);
int argcv_meth_parser__apply2805[] = {0};
meth_meth_parser__apply2805->type = alloc_MethodType(1, argcv_meth_parser__apply2805);
  meth_meth_parser__apply2805->definitionModule = modulename;
  meth_meth_parser__apply2805->definitionLine = 851;
// compilenode returning block2804
  gc_frame_newslot(block2804);
  params[0] = block2804;
  partcv[0] = 1;
  Object call2809 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2803);
// compilenode returning call2809
  partcv[0] = 0;
  Object call2810 = callmethod(call2809, "not",
    1, partcv, params);
  gc_frame_end(callframe2802);
// compilenode returning call2810
// compilenode returning call2810
  Object if2801 = done;
  if (istrue(call2810)) {
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 852
  setline(852);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2811 = gc_frame_new();
  int callframe2812 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2813 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2812);
// compilenode returning call2813
// compilenode returning call2813
  partcv[0] = 0;
  Object call2814 = callmethod(call2813, "new",
    1, partcv, params);
  gc_frame_end(callframe2811);
// compilenode returning call2814
// compilenode returning call2814
  *var_suggestion = call2814;
  if (call2814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 853
  setline(853);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2815 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2816 = alloc_Boolean(0);
// compilenode returning bool2816
  gc_frame_newslot(bool2816);
  params[0] = *var_btok;
  params[1] = bool2816;
  partcv[0] = 2;
  Object call2817 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2815);
// compilenode returning call2817
  *var_closingBrace = call2817;
  if (call2817 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2820 = alloc_Boolean(0);
// compilenode returning bool2820
  int op_slot_right_2819 = gc_frame_newslot(bool2820);
  int callframe2822 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2823 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2822);
// compilenode returning call2823
// compilenode returning call2823
  int op_slot_left_2819 = gc_frame_newslot(call2823);
  params[0] = bool2820;
  partcv[0] = 1;
  Object opresult2824 = callmethod(call2823, "==", 1, partcv, params);
// compilenode returning opresult2824
  Object if2818 = done;
  if (istrue(opresult2824)) {
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 855
  setline(855);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2826 = gc_frame_newslot(*var_lastToken);
  int callframe2828 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2829 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2828);
// compilenode returning call2829
// compilenode returning call2829
  int op_slot_left_2826 = gc_frame_newslot(call2829);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2830 = callmethod(call2829, "==", 1, partcv, params);
// compilenode returning opresult2830
  Object if2825 = done;
  if (istrue(opresult2830)) {
// Begin line 856
  setline(856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2831 = gc_frame_new();
  if (strlit2832 == NULL) {
    strlit2832 = alloc_String("}");
    gc_root(strlit2832);
  }
// compilenode returning strlit2832
  gc_frame_newslot(strlit2832);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2832;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2833 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2831);
// compilenode returning call2833
    gc_frame_newslot(call2833);
    if2825 = call2833;
  } else {
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2834 = gc_frame_new();
  Object num2836 = alloc_Float64(0.1);
// compilenode returning num2836
  int op_slot_right_2835 = gc_frame_newslot(num2836);
  int callframe2838 = gc_frame_new();
  int callframe2839 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2840 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2839);
// compilenode returning call2840
// compilenode returning call2840
  partcv[0] = 0;
  Object call2841 = callmethod(call2840, "line",
    1, partcv, params);
  gc_frame_end(callframe2838);
// compilenode returning call2841
// compilenode returning call2841
  int op_slot_left_2835 = gc_frame_newslot(call2841);
  params[0] = num2836;
  partcv[0] = 1;
  Object sum2842 = callmethod(call2841, "+", 1, partcv, params);
// compilenode returning sum2842
  gc_frame_newslot(sum2842);
  if (strlit2843 == NULL) {
    strlit2843 = alloc_String("}");
    gc_root(strlit2843);
  }
// compilenode returning strlit2843
  gc_frame_newslot(strlit2843);
// compilenode returning *var_suggestion
  params[0] = sum2842;
  params[1] = strlit2843;
  partcv[0] = 2;
  Object call2844 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2834);
// compilenode returning call2844
    gc_frame_newslot(call2844);
    if2825 = call2844;
  }
// compilenode returning if2825
    gc_frame_newslot(if2825);
    if2818 = if2825;
  } else {
  }
// compilenode returning if2818
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2845 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call2846 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe2845);
// compilenode returning call2846
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2847 = gc_frame_new();
  if (strlit2848 == NULL) {
    strlit2848 = alloc_String("An elseif statement must end with a '}'.");
    gc_root(strlit2848);
  }
// compilenode returning strlit2848
  gc_frame_newslot(strlit2848);
// Begin line 863
  setline(863);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2849 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2850 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2849);
// compilenode returning call2850
// compilenode returning call2850
  gc_frame_newslot(call2850);
  int callframe2851 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2852 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2851);
// compilenode returning call2852
// compilenode returning call2852
  gc_frame_newslot(call2852);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2848;
  params[1] = call2850;
  params[2] = call2852;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2853 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2847);
// compilenode returning call2853
    gc_frame_newslot(call2853);
    if2801 = call2853;
  } else {
  }
// compilenode returning if2801
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 865
  setline(865);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2854 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call2855 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2854);
// compilenode returning call2855
// compilenode returning call2855
  *var_v = call2855;
  if (call2855 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2857 = gc_frame_new();
// compilenode returning *var_v
  gc_frame_newslot(*var_v);
// compilenode returning *var_ebody
  params[0] = *var_v;
  partcv[0] = 1;
  Object call2858 = callmethod(*var_ebody, "push",
    1, partcv, params);
  gc_frame_end(callframe2857);
// compilenode returning call2858
  gc_frame_end(frame);
  return call2858;
}
Object meth_parser__apply2256(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(13, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_econd = getfromclosure(closure, 5);
  Object *var_ebody = getfromclosure(closure, 6);
  Object *var_btok = getfromclosure(closure, 7);
  Object *var_minIndentLevel = getfromclosure(closure, 8);
  Object *var_minInd = getfromclosure(closure, 9);
  Object *var_v = getfromclosure(closure, 10);
  Object *var_newelse = getfromclosure(closure, 11);
  Object *var_ast = getfromclosure(closure, 12);
  Object *var_eif = getfromclosure(closure, 13);
  Object *var_curelse = getfromclosure(closure, 14);
  Object self = *(getfromclosure(closure, 15));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_opener = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "opener");
  Object *var_closer = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closer");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_closingBrace = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "closingBrace");
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2258 = gc_frame_new();
  partcv[0] = 0;
  Object call2259 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2258);
// compilenode returning call2259
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 721
  setline(721);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2261 = gc_frame_new();
  Object block2262 = alloc_Block(NULL, NULL, "parser", 721);
  gc_frame_newslot(block2262);
  block_savedest(block2262);
  Object closure2263 = createclosure(2, "_apply");
setclosureframe(closure2263, stackframe);
  addtoclosure(closure2263, var_sym);
  addtoclosure(closure2263, selfslot);
  struct UserObject *uo2263 = (struct UserObject*)block2262;
  uo2263->data[0] = (Object)closure2263;
  Method *meth_meth_parser__apply2263 = addmethod2pos(block2262, "_apply", &meth_parser__apply2263, 0);
int argcv_meth_parser__apply2263[] = {0};
meth_meth_parser__apply2263->type = alloc_MethodType(1, argcv_meth_parser__apply2263);
  meth_meth_parser__apply2263->definitionModule = modulename;
  meth_meth_parser__apply2263->definitionLine = 715;
// compilenode returning block2262
  gc_frame_newslot(block2262);
  if (strlit2272 == NULL) {
    strlit2272 = alloc_String("lparen");
    gc_root(strlit2272);
  }
// compilenode returning strlit2272
  int op_slot_right_2271 = gc_frame_newslot(strlit2272);
  int callframe2274 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2275 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2274);
// compilenode returning call2275
// compilenode returning call2275
  int op_slot_left_2271 = gc_frame_newslot(call2275);
  params[0] = strlit2272;
  partcv[0] = 1;
  Object opresult2276 = callmethod(call2275, "==", 1, partcv, params);
// compilenode returning opresult2276
  params[0] = block2262;
  partcv[0] = 1;
  Object call2277 = callmethod(opresult2276, "orElse",
    1, partcv, params);
  gc_frame_end(callframe2261);
// compilenode returning call2277
  Object if2260 = done;
struct StackFrameObject *iftmpstackframe2260 = stackframe;
  if (istrue(call2277)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2260);
gc_frame_newslot((Object)stackframe);
// Begin line 722
  setline(722);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2278 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2279 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2278);
// compilenode returning call2279
// compilenode returning call2279
    gc_frame_newslot(call2279);
    if2260 = call2279;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe2260);
gc_frame_newslot((Object)stackframe);
  if (strlit2280 == NULL) {
    strlit2280 = alloc_String("-missing-");
    gc_root(strlit2280);
  }
// compilenode returning strlit2280
    gc_frame_newslot(strlit2280);
    if2260 = strlit2280;
  }
stackframe = iftmpstackframe2260;
// compilenode returning if2260
  *var_opener = if2260;
  if (if2260 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 723
  setline(723);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2283 == NULL) {
    strlit2283 = alloc_String("(");
    gc_root(strlit2283);
  }
// compilenode returning strlit2283
  int op_slot_right_2282 = gc_frame_newslot(strlit2283);
// compilenode returning *var_opener
  int op_slot_left_2282 = gc_frame_newslot(*var_opener);
  params[0] = strlit2283;
  partcv[0] = 1;
  Object opresult2285 = callmethod(*var_opener, "==", 1, partcv, params);
// compilenode returning opresult2285
  Object if2281 = done;
struct StackFrameObject *iftmpstackframe2281 = stackframe;
  if (istrue(opresult2285)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2281);
gc_frame_newslot((Object)stackframe);
  if (strlit2286 == NULL) {
    strlit2286 = alloc_String(")");
    gc_root(strlit2286);
  }
// compilenode returning strlit2286
    gc_frame_newslot(strlit2286);
    if2281 = strlit2286;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe2281);
gc_frame_newslot((Object)stackframe);
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2289 == NULL) {
    strlit2289 = alloc_String("{");
    gc_root(strlit2289);
  }
// compilenode returning strlit2289
  int op_slot_right_2288 = gc_frame_newslot(strlit2289);
// compilenode returning *var_opener
  int op_slot_left_2288 = gc_frame_newslot(*var_opener);
  params[0] = strlit2289;
  partcv[0] = 1;
  Object opresult2291 = callmethod(*var_opener, "==", 1, partcv, params);
// compilenode returning opresult2291
  Object if2287 = done;
  if (istrue(opresult2291)) {
  if (strlit2292 == NULL) {
    strlit2292 = alloc_String("}");
    gc_root(strlit2292);
  }
// compilenode returning strlit2292
    gc_frame_newslot(strlit2292);
    if2287 = strlit2292;
  } else {
  if (strlit2293 == NULL) {
    strlit2293 = alloc_String("-nothing-");
    gc_root(strlit2293);
  }
// compilenode returning strlit2293
    gc_frame_newslot(strlit2293);
    if2287 = strlit2293;
  }
// compilenode returning if2287
    gc_frame_newslot(if2287);
    if2281 = if2287;
  }
stackframe = iftmpstackframe2281;
// compilenode returning if2281
  *var_closer = if2281;
  if (if2281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 725
  setline(725);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2296 == NULL) {
    strlit2296 = alloc_String("-missing-");
    gc_root(strlit2296);
  }
// compilenode returning strlit2296
  int op_slot_right_2295 = gc_frame_newslot(strlit2296);
// compilenode returning *var_opener
  int op_slot_left_2295 = gc_frame_newslot(*var_opener);
  params[0] = strlit2296;
  partcv[0] = 1;
  Object opresult2298 = callmethod(*var_opener, "==", 1, partcv, params);
// compilenode returning opresult2298
  Object if2294 = done;
  if (istrue(opresult2298)) {
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 726
  setline(726);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2299 = gc_frame_new();
  int callframe2300 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2301 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2300);
// compilenode returning call2301
// compilenode returning call2301
  partcv[0] = 0;
  Object call2302 = callmethod(call2301, "new",
    1, partcv, params);
  gc_frame_end(callframe2299);
// compilenode returning call2302
// compilenode returning call2302
  *var_suggestion = call2302;
  if (call2302 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 728
  setline(728);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2303 = gc_frame_new();
  Object block2304 = alloc_Block(NULL, NULL, "parser", 728);
  gc_frame_newslot(block2304);
  block_savedest(block2304);
  Object closure2305 = createclosure(2, "_apply");
setclosureframe(closure2305, stackframe);
  addtoclosure(closure2305, var_statementToken);
  addtoclosure(closure2305, selfslot);
  struct UserObject *uo2305 = (struct UserObject*)block2304;
  uo2305->data[0] = (Object)closure2305;
  Method *meth_meth_parser__apply2305 = addmethod2pos(block2304, "_apply", &meth_parser__apply2305, 0);
int argcv_meth_parser__apply2305[] = {1};
meth_meth_parser__apply2305->type = alloc_MethodType(1, argcv_meth_parser__apply2305);
  meth_meth_parser__apply2305->definitionModule = modulename;
  meth_meth_parser__apply2305->definitionLine = 726;
// compilenode returning block2304
  gc_frame_newslot(block2304);
  params[0] = block2304;
  partcv[0] = 1;
  Object call2359 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2303);
// compilenode returning call2359
  *var_nextTok = call2359;
  if (call2359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 731
  setline(731);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2362 = alloc_Boolean(0);
// compilenode returning bool2362
  int op_slot_right_2361 = gc_frame_newslot(bool2362);
// compilenode returning *var_nextTok
  int op_slot_left_2361 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2362;
  partcv[0] = 1;
  Object opresult2364 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2364
  Object if2360 = done;
  if (istrue(opresult2364)) {
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2365 = gc_frame_new();
  if (strlit2366 == NULL) {
    strlit2366 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2366);
  }
// compilenode returning strlit2366
  gc_frame_newslot(strlit2366);
// compilenode returning *var_statementToken
  gc_frame_newslot(*var_statementToken);
// compilenode returning *var_suggestion
  params[0] = strlit2366;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2367 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2365);
// compilenode returning call2367
    gc_frame_newslot(call2367);
    if2360 = call2367;
  } else {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2370 == NULL) {
    strlit2370 = alloc_String("rparen");
    gc_root(strlit2370);
  }
// compilenode returning strlit2370
  int op_slot_right_2369 = gc_frame_newslot(strlit2370);
  int callframe2372 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2373 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2372);
// compilenode returning call2373
// compilenode returning call2373
  int op_slot_left_2369 = gc_frame_newslot(call2373);
  params[0] = strlit2370;
  partcv[0] = 1;
  Object opresult2374 = callmethod(call2373, "==", 1, partcv, params);
// compilenode returning opresult2374
  Object if2368 = done;
  if (istrue(opresult2374)) {
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 734
  setline(734);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2376 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_2376 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2378 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2378
  Object if2375 = done;
  if (istrue(opresult2378)) {
// Begin line 735
  setline(735);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2379 = gc_frame_new();
  if (strlit2380 == NULL) {
    strlit2380 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2380);
  }
// compilenode returning strlit2380
  gc_frame_newslot(strlit2380);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit2380;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2381 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2379);
// compilenode returning call2381
    gc_frame_newslot(call2381);
    if2375 = call2381;
  } else {
// Begin line 737
  setline(737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2382 = gc_frame_new();
  if (strlit2383 == NULL) {
    strlit2383 = alloc_String("(");
    gc_root(strlit2383);
  }
// compilenode returning strlit2383
  gc_frame_newslot(strlit2383);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit2383;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2384 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2382);
// compilenode returning call2384
    gc_frame_newslot(call2384);
    if2375 = call2384;
  }
// compilenode returning if2375
    gc_frame_newslot(if2375);
    if2368 = if2375;
  } else {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2387 == NULL) {
    strlit2387 = alloc_String("lbrace");
    gc_root(strlit2387);
  }
// compilenode returning strlit2387
  int op_slot_right_2386 = gc_frame_newslot(strlit2387);
  int callframe2389 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2390 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2389);
// compilenode returning call2390
// compilenode returning call2390
  int op_slot_left_2386 = gc_frame_newslot(call2390);
  params[0] = strlit2387;
  partcv[0] = 1;
  Object opresult2391 = callmethod(call2390, "==", 1, partcv, params);
// compilenode returning opresult2391
  Object if2385 = done;
  if (istrue(opresult2391)) {
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 740
  setline(740);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2393 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_2393 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2395 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2395
  Object if2392 = done;
  if (istrue(opresult2395)) {
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2396 = gc_frame_new();
  if (strlit2397 == NULL) {
    strlit2397 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit2397);
  }
// compilenode returning strlit2397
  gc_frame_newslot(strlit2397);
// compilenode returning *var_statementToken
  gc_frame_newslot(*var_statementToken);
// compilenode returning *var_suggestion
  params[0] = strlit2397;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2398 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2396);
// compilenode returning call2398
    gc_frame_newslot(call2398);
    if2392 = call2398;
  } else {
// Begin line 743
  setline(743);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2399 = gc_frame_new();
  if (strlit2400 == NULL) {
    strlit2400 = alloc_String("(");
    gc_root(strlit2400);
  }
// compilenode returning strlit2400
  gc_frame_newslot(strlit2400);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit2400;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2401 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2399);
// compilenode returning call2401
// Begin line 744
  setline(744);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2402 = gc_frame_new();
  if (strlit2403 == NULL) {
    strlit2403 = alloc_String(") then");
    gc_root(strlit2403);
  }
// compilenode returning strlit2403
  gc_frame_newslot(strlit2403);
  int callframe2404 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2405 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2404);
// compilenode returning call2405
// compilenode returning call2405
  gc_frame_newslot(call2405);
  Object bool2406 = alloc_Boolean(1);
// compilenode returning bool2406
  gc_frame_newslot(bool2406);
// compilenode returning *var_suggestion
  params[0] = strlit2403;
  params[1] = call2405;
  params[2] = bool2406;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2407 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2402);
// compilenode returning call2407
    gc_frame_newslot(call2407);
    if2392 = call2407;
  }
// compilenode returning if2392
    gc_frame_newslot(if2392);
    if2385 = if2392;
  } else {
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2410 == NULL) {
    strlit2410 = alloc_String("identifier");
    gc_root(strlit2410);
  }
// compilenode returning strlit2410
  int op_slot_right_2409 = gc_frame_newslot(strlit2410);
  int callframe2412 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2413 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe2412);
// compilenode returning call2413
// compilenode returning call2413
  int op_slot_left_2409 = gc_frame_newslot(call2413);
  params[0] = strlit2410;
  partcv[0] = 1;
  Object opresult2414 = callmethod(call2413, "==", 1, partcv, params);
// compilenode returning opresult2414
  Object if2408 = done;
  if (istrue(opresult2414)) {
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 747
  setline(747);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2416 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_2416 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2418 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2418
  Object if2415 = done;
  if (istrue(opresult2418)) {
// Begin line 748
  setline(748);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2419 = gc_frame_new();
  if (strlit2420 == NULL) {
    strlit2420 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit2420);
  }
// compilenode returning strlit2420
  gc_frame_newslot(strlit2420);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit2420;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2421 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2419);
// compilenode returning call2421
    gc_frame_newslot(call2421);
    if2415 = call2421;
  } else {
// Begin line 750
  setline(750);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2422 = gc_frame_new();
  if (strlit2423 == NULL) {
    strlit2423 = alloc_String("(");
    gc_root(strlit2423);
  }
// compilenode returning strlit2423
  gc_frame_newslot(strlit2423);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit2423;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2424 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe2422);
// compilenode returning call2424
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2425 = gc_frame_new();
  if (strlit2426 == NULL) {
    strlit2426 = alloc_String(")");
    gc_root(strlit2426);
  }
// compilenode returning strlit2426
  gc_frame_newslot(strlit2426);
  int callframe2427 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2428 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2427);
// compilenode returning call2428
// compilenode returning call2428
  gc_frame_newslot(call2428);
  Object bool2429 = alloc_Boolean(1);
// compilenode returning bool2429
  gc_frame_newslot(bool2429);
// compilenode returning *var_suggestion
  params[0] = strlit2426;
  params[1] = call2428;
  params[2] = bool2429;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call2430 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe2425);
// compilenode returning call2430
    gc_frame_newslot(call2430);
    if2415 = call2430;
  }
// compilenode returning if2415
    gc_frame_newslot(if2415);
    if2408 = if2415;
  } else {
  }
// compilenode returning if2408
    gc_frame_newslot(if2408);
    if2385 = if2408;
  }
// compilenode returning if2385
    gc_frame_newslot(if2385);
    if2368 = if2385;
  }
// compilenode returning if2368
    gc_frame_newslot(if2368);
    if2360 = if2368;
  }
// compilenode returning if2360
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2431 = gc_frame_new();
  if (strlit2432 == NULL) {
    strlit2432 = alloc_String("1: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2432);
  }
// compilenode returning strlit2432
  gc_frame_newslot(strlit2432);
// Begin line 755
  setline(755);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2433 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2434 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2433);
// compilenode returning call2434
// compilenode returning call2434
  gc_frame_newslot(call2434);
  int callframe2435 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2436 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2435);
// compilenode returning call2436
// compilenode returning call2436
  gc_frame_newslot(call2436);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2432;
  params[1] = call2434;
  params[2] = call2436;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2437 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2431);
// compilenode returning call2437
    gc_frame_newslot(call2437);
    if2294 = call2437;
  } else {
  }
// compilenode returning if2294
// Begin line 757
  setline(757);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2438 = gc_frame_new();
  partcv[0] = 0;
  Object call2439 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2438);
// compilenode returning call2439
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 758
  setline(758);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2441 = gc_frame_new();
  int callframe2442 = gc_frame_new();
  Object block2443 = alloc_Block(NULL, NULL, "parser", 758);
  gc_frame_newslot(block2443);
  block_savedest(block2443);
  Object closure2444 = createclosure(1, "_apply");
setclosureframe(closure2444, stackframe);
  addtoclosure(closure2444, selfslot);
  struct UserObject *uo2444 = (struct UserObject*)block2443;
  uo2444->data[0] = (Object)closure2444;
  Method *meth_meth_parser__apply2444 = addmethod2pos(block2443, "_apply", &meth_parser__apply2444, 0);
int argcv_meth_parser__apply2444[] = {0};
meth_meth_parser__apply2444->type = alloc_MethodType(1, argcv_meth_parser__apply2444);
  meth_meth_parser__apply2444->definitionModule = modulename;
  meth_meth_parser__apply2444->definitionLine = 758;
// compilenode returning block2443
  gc_frame_newslot(block2443);
  params[0] = block2443;
  partcv[0] = 1;
  Object call2448 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2442);
// compilenode returning call2448
  partcv[0] = 0;
  Object call2449 = callmethod(call2448, "not",
    1, partcv, params);
  gc_frame_end(callframe2441);
// compilenode returning call2449
// compilenode returning call2449
  Object if2440 = done;
  if (istrue(call2449)) {
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2450 = gc_frame_new();
  int callframe2451 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2452 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2451);
// compilenode returning call2452
// compilenode returning call2452
  partcv[0] = 0;
  Object call2453 = callmethod(call2452, "new",
    1, partcv, params);
  gc_frame_end(callframe2450);
// compilenode returning call2453
// compilenode returning call2453
  *var_suggestion = call2453;
  if (call2453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 761
  setline(761);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2454 = gc_frame_new();
  Object block2455 = alloc_Block(NULL, NULL, "parser", 761);
  gc_frame_newslot(block2455);
  block_savedest(block2455);
  Object closure2456 = createclosure(2, "_apply");
setclosureframe(closure2456, stackframe);
  addtoclosure(closure2456, var_lastToken);
  addtoclosure(closure2456, selfslot);
  struct UserObject *uo2456 = (struct UserObject*)block2455;
  uo2456->data[0] = (Object)closure2456;
  Method *meth_meth_parser__apply2456 = addmethod2pos(block2455, "_apply", &meth_parser__apply2456, 0);
int argcv_meth_parser__apply2456[] = {1};
meth_meth_parser__apply2456->type = alloc_MethodType(1, argcv_meth_parser__apply2456);
  meth_meth_parser__apply2456->definitionModule = modulename;
  meth_meth_parser__apply2456->definitionLine = 759;
// compilenode returning block2455
  gc_frame_newslot(block2455);
  params[0] = block2455;
  partcv[0] = 1;
  Object call2483 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2454);
// compilenode returning call2483
  *var_nextTok = call2483;
  if (call2483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 763
  setline(763);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2486 = alloc_Boolean(0);
// compilenode returning bool2486
  int op_slot_right_2485 = gc_frame_newslot(bool2486);
// compilenode returning *var_nextTok
  int op_slot_left_2485 = gc_frame_newslot(*var_nextTok);
  params[0] = bool2486;
  partcv[0] = 1;
  Object opresult2488 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2488
  Object if2484 = done;
  if (istrue(opresult2488)) {
// Begin line 764
  setline(764);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2489 = gc_frame_new();
  if (strlit2490 == NULL) {
    strlit2490 = alloc_String("rparen");
    gc_root(strlit2490);
  }
// compilenode returning strlit2490
  gc_frame_newslot(strlit2490);
  params[0] = strlit2490;
  partcv[0] = 1;
  Object call2491 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2489);
// compilenode returning call2491
  *var_nextTok = call2491;
  if (call2491 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2494 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_2494 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2496 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2496
  Object if2493 = done;
  if (istrue(opresult2496)) {
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2497 = gc_frame_new();
  if (strlit2498 == NULL) {
    strlit2498 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2498);
  }
// compilenode returning strlit2498
  gc_frame_newslot(strlit2498);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2498;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2499 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2497);
// compilenode returning call2499
    gc_frame_newslot(call2499);
    if2493 = call2499;
  } else {
// Begin line 768
  setline(768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2500 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe2501 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2502 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2501);
// compilenode returning call2502
// compilenode returning call2502
  gc_frame_newslot(call2502);
  Object bool2503 = alloc_Boolean(1);
// compilenode returning bool2503
  gc_frame_newslot(bool2503);
  Object bool2504 = alloc_Boolean(0);
// compilenode returning bool2504
  gc_frame_newslot(bool2504);
  if (strlit2505 == NULL) {
    strlit2505 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit2505);
  }
// compilenode returning strlit2505
  gc_frame_newslot(strlit2505);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call2502;
  params[2] = bool2503;
  params[3] = bool2504;
  params[4] = strlit2505;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2506 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2500);
// compilenode returning call2506
    gc_frame_newslot(call2506);
    if2493 = call2506;
  }
// compilenode returning if2493
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2507 = gc_frame_new();
  if (strlit2508 == NULL) {
    strlit2508 = alloc_String("2: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2508);
  }
// compilenode returning strlit2508
  gc_frame_newslot(strlit2508);
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2509 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2510 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2509);
// compilenode returning call2510
// compilenode returning call2510
  gc_frame_newslot(call2510);
  int callframe2511 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2512 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2511);
// compilenode returning call2512
// compilenode returning call2512
  gc_frame_newslot(call2512);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2508;
  params[1] = call2510;
  params[2] = call2512;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2513 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2507);
// compilenode returning call2513
    gc_frame_newslot(call2513);
    if2484 = call2513;
  } else {
// Begin line 783
  setline(783);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2515 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_2515 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2517 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult2517
  Object if2514 = done;
  if (istrue(opresult2517)) {
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2518 = gc_frame_new();
  if (strlit2519 == NULL) {
    strlit2519 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2519);
  }
// compilenode returning strlit2519
  gc_frame_newslot(strlit2519);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2519;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2520 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2518);
// compilenode returning call2520
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2521 = gc_frame_new();
  if (strlit2522 == NULL) {
    strlit2522 = alloc_String("3: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2522);
  }
// compilenode returning strlit2522
  gc_frame_newslot(strlit2522);
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2523 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2524 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2523);
// compilenode returning call2524
// compilenode returning call2524
  gc_frame_newslot(call2524);
  int callframe2525 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2526 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2525);
// compilenode returning call2526
// compilenode returning call2526
  gc_frame_newslot(call2526);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2522;
  params[1] = call2524;
  params[2] = call2526;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2527 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2521);
// compilenode returning call2527
    gc_frame_newslot(call2527);
    if2514 = call2527;
  } else {
// Begin line 779
  setline(779);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2528 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe2529 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2530 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2529);
// compilenode returning call2530
// compilenode returning call2530
  gc_frame_newslot(call2530);
  Object bool2531 = alloc_Boolean(0);
// compilenode returning bool2531
  gc_frame_newslot(bool2531);
  Object bool2532 = alloc_Boolean(1);
// compilenode returning bool2532
  gc_frame_newslot(bool2532);
  if (strlit2533 == NULL) {
    strlit2533 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2533);
  }
// compilenode returning strlit2533
  gc_frame_newslot(strlit2533);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call2530;
  params[2] = bool2531;
  params[3] = bool2532;
  params[4] = strlit2533;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2534 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2528);
// compilenode returning call2534
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2535 = gc_frame_new();
  if (strlit2536 == NULL) {
    strlit2536 = alloc_String("4: An elseif statement must have an expression in parentheses or braces after the 'elseif'.");
    gc_root(strlit2536);
  }
// compilenode returning strlit2536
  gc_frame_newslot(strlit2536);
// Begin line 781
  setline(781);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2537 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2538 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2537);
// compilenode returning call2538
// compilenode returning call2538
  gc_frame_newslot(call2538);
  int callframe2539 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2540 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2539);
// compilenode returning call2540
// compilenode returning call2540
  gc_frame_newslot(call2540);
  Object num2542 = alloc_Float64(1);
// compilenode returning num2542
  int op_slot_right_2541 = gc_frame_newslot(num2542);
  int callframe2544 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2545 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2544);
// compilenode returning call2545
// compilenode returning call2545
  int op_slot_left_2541 = gc_frame_newslot(call2545);
  params[0] = num2542;
  partcv[0] = 1;
  Object diff2546 = callmethod(call2545, "-", 1, partcv, params);
// compilenode returning diff2546
  gc_frame_newslot(diff2546);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2536;
  params[1] = call2538;
  params[2] = call2540;
  params[3] = diff2546;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2547 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2535);
// compilenode returning call2547
    gc_frame_newslot(call2547);
    if2514 = call2547;
  }
// compilenode returning if2514
    gc_frame_newslot(if2514);
    if2484 = if2514;
  }
// compilenode returning if2484
    gc_frame_newslot(if2484);
    if2440 = if2484;
  } else {
  }
// compilenode returning if2440
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_closer
  int op_slot_right_2549 = gc_frame_newslot(*var_closer);
  int callframe2551 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2552 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2551);
// compilenode returning call2552
// compilenode returning call2552
  int op_slot_left_2549 = gc_frame_newslot(call2552);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2553 = callmethod(call2552, "!=", 1, partcv, params);
// compilenode returning opresult2553
  Object if2548 = done;
  if (istrue(opresult2553)) {
// Begin line 786
  setline(786);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2554 = gc_frame_new();
  partcv[0] = 0;
  Object call2555 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2554);
// compilenode returning call2555
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 787
  setline(787);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2556 = gc_frame_new();
  int callframe2557 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2558 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2557);
// compilenode returning call2558
// compilenode returning call2558
  partcv[0] = 0;
  Object call2559 = callmethod(call2558, "new",
    1, partcv, params);
  gc_frame_end(callframe2556);
// compilenode returning call2559
// compilenode returning call2559
  *var_suggestion = call2559;
  if (call2559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 788
  setline(788);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2560 = gc_frame_new();
  if (strlit2561 == NULL) {
    strlit2561 = alloc_String(")");
    gc_root(strlit2561);
  }
// compilenode returning strlit2561
  gc_frame_newslot(strlit2561);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2561;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2562 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2560);
// compilenode returning call2562
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2563 = gc_frame_new();
  if (strlit2565 == NULL) {
    strlit2565 = alloc_String("'.");
    gc_root(strlit2565);
  }
// compilenode returning strlit2565
  int op_slot_right_2564 = gc_frame_newslot(strlit2565);
// compilenode returning *var_closer
  int op_slot_right_2567 = gc_frame_newslot(*var_closer);
  if (strlit2570 == NULL) {
    strlit2570 = alloc_String("' must end with a '");
    gc_root(strlit2570);
  }
// compilenode returning strlit2570
  int op_slot_right_2569 = gc_frame_newslot(strlit2570);
// compilenode returning *var_opener
  int op_slot_right_2572 = gc_frame_newslot(*var_opener);
  if (strlit2574 == NULL) {
    strlit2574 = alloc_String("An expression beginning with a '");
    gc_root(strlit2574);
  }
// compilenode returning strlit2574
  int op_slot_left_2572 = gc_frame_newslot(strlit2574);
  params[0] = *var_opener;
  partcv[0] = 1;
  Object opresult2575 = callmethod(strlit2574, "++", 1, partcv, params);
// compilenode returning opresult2575
  int op_slot_left_2569 = gc_frame_newslot(opresult2575);
  params[0] = strlit2570;
  partcv[0] = 1;
  Object opresult2576 = callmethod(opresult2575, "++", 1, partcv, params);
// compilenode returning opresult2576
  int op_slot_left_2567 = gc_frame_newslot(opresult2576);
  params[0] = *var_closer;
  partcv[0] = 1;
  Object opresult2577 = callmethod(opresult2576, "++", 1, partcv, params);
// compilenode returning opresult2577
  int op_slot_left_2564 = gc_frame_newslot(opresult2577);
  params[0] = strlit2565;
  partcv[0] = 1;
  Object opresult2578 = callmethod(opresult2577, "++", 1, partcv, params);
// compilenode returning opresult2578
  gc_frame_newslot(opresult2578);
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2579 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2580 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2579);
// compilenode returning call2580
// compilenode returning call2580
  gc_frame_newslot(call2580);
  int callframe2582 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2583 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2582);
// compilenode returning call2583
// compilenode returning call2583
  int op_slot_right_2581 = gc_frame_newslot(call2583);
  int callframe2585 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2586 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2585);
// compilenode returning call2586
// compilenode returning call2586
  int op_slot_left_2581 = gc_frame_newslot(call2586);
  params[0] = call2583;
  partcv[0] = 1;
  Object sum2587 = callmethod(call2586, "+", 1, partcv, params);
// compilenode returning sum2587
  gc_frame_newslot(sum2587);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 789
  setline(789);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult2578;
  params[1] = call2580;
  params[2] = sum2587;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2588 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2563);
// compilenode returning call2588
    gc_frame_newslot(call2588);
    if2548 = call2588;
  } else {
  }
// compilenode returning if2548
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2589 = gc_frame_new();
  partcv[0] = 0;
  Object call2590 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2589);
// compilenode returning call2590
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2591 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call2592 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2591);
// compilenode returning call2592
// compilenode returning call2592
  *var_econd = call2592;
  if (call2592 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 795
  setline(795);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2597 == NULL) {
    strlit2597 = alloc_String("then");
    gc_root(strlit2597);
  }
// compilenode returning strlit2597
  int op_slot_right_2596 = gc_frame_newslot(strlit2597);
  int callframe2599 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2600 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2599);
// compilenode returning call2600
// compilenode returning call2600
  int op_slot_left_2596 = gc_frame_newslot(call2600);
  params[0] = strlit2597;
  partcv[0] = 1;
  Object opresult2601 = callmethod(call2600, "==", 1, partcv, params);
// compilenode returning opresult2601
  int op_slot_right_2595 = gc_frame_newslot(opresult2601);
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2603 = gc_frame_new();
  if (strlit2604 == NULL) {
    strlit2604 = alloc_String("identifier");
    gc_root(strlit2604);
  }
// compilenode returning strlit2604
  gc_frame_newslot(strlit2604);
  params[0] = strlit2604;
  partcv[0] = 1;
  Object call2605 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2603);
// compilenode returning call2605
  int op_slot_left_2595 = gc_frame_newslot(call2605);
  params[0] = opresult2601;
  partcv[0] = 1;
  Object opresult2606 = callmethod(call2605, "&&", 1, partcv, params);
// compilenode returning opresult2606
  Object if2594 = done;
  if (istrue(opresult2606)) {
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2607 = gc_frame_new();
  partcv[0] = 0;
  Object call2608 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2607);
// compilenode returning call2608
// Begin line 798
  setline(798);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 797
  setline(797);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2609 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2609
  *var_ebody = array2609;
  if (array2609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2594 = done;
  } else {
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 799
  setline(799);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2611 = gc_frame_new();
  int callframe2612 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2613 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2612);
// compilenode returning call2613
// compilenode returning call2613
  partcv[0] = 0;
  Object call2614 = callmethod(call2613, "new",
    1, partcv, params);
  gc_frame_end(callframe2611);
// compilenode returning call2614
// compilenode returning call2614
  *var_suggestion = call2614;
  if (call2614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2617 == NULL) {
    strlit2617 = alloc_String("lbrace");
    gc_root(strlit2617);
  }
// compilenode returning strlit2617
  int op_slot_right_2616 = gc_frame_newslot(strlit2617);
  int callframe2619 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2620 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2619);
// compilenode returning call2620
// compilenode returning call2620
  int op_slot_left_2616 = gc_frame_newslot(call2620);
  params[0] = strlit2617;
  partcv[0] = 1;
  Object opresult2621 = callmethod(call2620, "==", 1, partcv, params);
// compilenode returning opresult2621
  Object if2615 = done;
  if (istrue(opresult2621)) {
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2622 = gc_frame_new();
// compilenode returning *var_statementToken
  gc_frame_newslot(*var_statementToken);
  Object bool2623 = alloc_Boolean(0);
// compilenode returning bool2623
  gc_frame_newslot(bool2623);
  params[0] = *var_statementToken;
  params[1] = bool2623;
  partcv[0] = 2;
  Object call2624 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2622);
// compilenode returning call2624
  *var_closingBrace = call2624;
  if (call2624 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 812
  setline(812);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2627 = alloc_Boolean(0);
// compilenode returning bool2627
  int op_slot_right_2626 = gc_frame_newslot(bool2627);
  int callframe2629 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2630 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2629);
// compilenode returning call2630
// compilenode returning call2630
  int op_slot_left_2626 = gc_frame_newslot(call2630);
  params[0] = bool2627;
  partcv[0] = 1;
  Object opresult2631 = callmethod(call2630, "==", 1, partcv, params);
// compilenode returning opresult2631
  Object if2625 = done;
  if (istrue(opresult2631)) {
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_2633 = gc_frame_newslot(*var_sym);
  int callframe2635 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2636 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2635);
// compilenode returning call2636
// compilenode returning call2636
  int op_slot_left_2633 = gc_frame_newslot(call2636);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult2637 = callmethod(call2636, "==", 1, partcv, params);
// compilenode returning opresult2637
  Object if2632 = done;
  if (istrue(opresult2637)) {
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2638 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool2639 = alloc_Boolean(1);
// compilenode returning bool2639
  gc_frame_newslot(bool2639);
  Object bool2640 = alloc_Boolean(0);
// compilenode returning bool2640
  gc_frame_newslot(bool2640);
  if (strlit2641 == NULL) {
    strlit2641 = alloc_String(" then {}");
    gc_root(strlit2641);
  }
// compilenode returning strlit2641
  gc_frame_newslot(strlit2641);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool2639;
  params[2] = bool2640;
  params[3] = strlit2641;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2642 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2638);
// compilenode returning call2642
    gc_frame_newslot(call2642);
    if2632 = call2642;
  } else {
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2643 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool2644 = alloc_Boolean(1);
// compilenode returning bool2644
  gc_frame_newslot(bool2644);
  Object bool2645 = alloc_Boolean(0);
// compilenode returning bool2645
  gc_frame_newslot(bool2645);
  if (strlit2646 == NULL) {
    strlit2646 = alloc_String(" then {");
    gc_root(strlit2646);
  }
// compilenode returning strlit2646
  gc_frame_newslot(strlit2646);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool2644;
  params[2] = bool2645;
  params[3] = strlit2646;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2647 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2643);
// compilenode returning call2647
// Begin line 807
  setline(807);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2648 = gc_frame_new();
  Object num2650 = alloc_Float64(0.1);
// compilenode returning num2650
  int op_slot_right_2649 = gc_frame_newslot(num2650);
  int callframe2652 = gc_frame_new();
  int callframe2653 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2654 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2653);
// compilenode returning call2654
// compilenode returning call2654
  partcv[0] = 0;
  Object call2655 = callmethod(call2654, "line",
    1, partcv, params);
  gc_frame_end(callframe2652);
// compilenode returning call2655
// compilenode returning call2655
  int op_slot_left_2649 = gc_frame_newslot(call2655);
  params[0] = num2650;
  partcv[0] = 1;
  Object sum2656 = callmethod(call2655, "+", 1, partcv, params);
// compilenode returning sum2656
  gc_frame_newslot(sum2656);
  if (strlit2657 == NULL) {
    strlit2657 = alloc_String("}");
    gc_root(strlit2657);
  }
// compilenode returning strlit2657
  gc_frame_newslot(strlit2657);
// compilenode returning *var_suggestion
  params[0] = sum2656;
  params[1] = strlit2657;
  partcv[0] = 2;
  Object call2658 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2648);
// compilenode returning call2658
    gc_frame_newslot(call2658);
    if2632 = call2658;
  }
// compilenode returning if2632
    gc_frame_newslot(if2632);
    if2625 = if2632;
  } else {
// Begin line 810
  setline(810);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2659 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool2660 = alloc_Boolean(1);
// compilenode returning bool2660
  gc_frame_newslot(bool2660);
  Object bool2661 = alloc_Boolean(0);
// compilenode returning bool2661
  gc_frame_newslot(bool2661);
  if (strlit2662 == NULL) {
    strlit2662 = alloc_String(" then {");
    gc_root(strlit2662);
  }
// compilenode returning strlit2662
  gc_frame_newslot(strlit2662);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool2660;
  params[2] = bool2661;
  params[3] = strlit2662;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2663 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2659);
// compilenode returning call2663
    gc_frame_newslot(call2663);
    if2625 = call2663;
  }
// compilenode returning if2625
    gc_frame_newslot(if2625);
    if2615 = if2625;
  } else {
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2664 = gc_frame_new();
// compilenode returning *var_statementToken
  gc_frame_newslot(*var_statementToken);
  Object bool2665 = alloc_Boolean(1);
// compilenode returning bool2665
  gc_frame_newslot(bool2665);
  params[0] = *var_statementToken;
  params[1] = bool2665;
  partcv[0] = 2;
  Object call2666 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2664);
// compilenode returning call2666
  *var_closingBrace = call2666;
  if (call2666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 824
  setline(824);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2669 = alloc_Boolean(0);
// compilenode returning bool2669
  int op_slot_right_2668 = gc_frame_newslot(bool2669);
  int callframe2671 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2672 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2671);
// compilenode returning call2672
// compilenode returning call2672
  int op_slot_left_2668 = gc_frame_newslot(call2672);
  params[0] = bool2669;
  partcv[0] = 1;
  Object opresult2673 = callmethod(call2672, "==", 1, partcv, params);
// compilenode returning opresult2673
  Object if2667 = done;
  if (istrue(opresult2673)) {
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 815
  setline(815);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2675 = gc_frame_newslot(*var_lastToken);
  int callframe2677 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2678 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2677);
// compilenode returning call2678
// compilenode returning call2678
  int op_slot_left_2675 = gc_frame_newslot(call2678);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2679 = callmethod(call2678, "==", 1, partcv, params);
// compilenode returning opresult2679
  Object if2674 = done;
  if (istrue(opresult2679)) {
// Begin line 816
  setline(816);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2680 = gc_frame_new();
  if (strlit2681 == NULL) {
    strlit2681 = alloc_String(" then {}");
    gc_root(strlit2681);
  }
// compilenode returning strlit2681
  gc_frame_newslot(strlit2681);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2681;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2682 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2680);
// compilenode returning call2682
    gc_frame_newslot(call2682);
    if2674 = call2682;
  } else {
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2683 = gc_frame_new();
  if (strlit2684 == NULL) {
    strlit2684 = alloc_String(" then {");
    gc_root(strlit2684);
  }
// compilenode returning strlit2684
  gc_frame_newslot(strlit2684);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2684;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2685 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2683);
// compilenode returning call2685
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2686 = gc_frame_new();
  Object num2688 = alloc_Float64(0.1);
// compilenode returning num2688
  int op_slot_right_2687 = gc_frame_newslot(num2688);
  int callframe2690 = gc_frame_new();
  int callframe2691 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2692 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2691);
// compilenode returning call2692
// compilenode returning call2692
  partcv[0] = 0;
  Object call2693 = callmethod(call2692, "line",
    1, partcv, params);
  gc_frame_end(callframe2690);
// compilenode returning call2693
// compilenode returning call2693
  int op_slot_left_2687 = gc_frame_newslot(call2693);
  params[0] = num2688;
  partcv[0] = 1;
  Object sum2694 = callmethod(call2693, "+", 1, partcv, params);
// compilenode returning sum2694
  gc_frame_newslot(sum2694);
  if (strlit2695 == NULL) {
    strlit2695 = alloc_String("}");
    gc_root(strlit2695);
  }
// compilenode returning strlit2695
  gc_frame_newslot(strlit2695);
// compilenode returning *var_suggestion
  params[0] = sum2694;
  params[1] = strlit2695;
  partcv[0] = 2;
  Object call2696 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2686);
// compilenode returning call2696
    gc_frame_newslot(call2696);
    if2674 = call2696;
  }
// compilenode returning if2674
    gc_frame_newslot(if2674);
    if2667 = if2674;
  } else {
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2697 = gc_frame_new();
  if (strlit2698 == NULL) {
    strlit2698 = alloc_String(" then {");
    gc_root(strlit2698);
  }
// compilenode returning strlit2698
  gc_frame_newslot(strlit2698);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2698;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2699 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2697);
// compilenode returning call2699
    gc_frame_newslot(call2699);
    if2667 = call2699;
  }
// compilenode returning if2667
    gc_frame_newslot(if2667);
    if2615 = if2667;
  }
// compilenode returning if2615
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2700 = gc_frame_new();
  if (strlit2701 == NULL) {
    strlit2701 = alloc_String("An elseif statement must have 'then' after the expression in parentheses.");
    gc_root(strlit2701);
  }
// compilenode returning strlit2701
  gc_frame_newslot(strlit2701);
// Begin line 826
  setline(826);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2702 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2703 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2702);
// compilenode returning call2703
// compilenode returning call2703
  gc_frame_newslot(call2703);
  int callframe2704 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2705 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2704);
// compilenode returning call2705
// compilenode returning call2705
  gc_frame_newslot(call2705);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 825
  setline(825);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2701;
  params[1] = call2703;
  params[2] = call2705;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2706 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2700);
// compilenode returning call2706
    gc_frame_newslot(call2706);
    if2594 = call2706;
  }
// compilenode returning if2594
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 828
  setline(828);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2709 == NULL) {
    strlit2709 = alloc_String("lbrace");
    gc_root(strlit2709);
  }
// compilenode returning strlit2709
  int op_slot_right_2708 = gc_frame_newslot(strlit2709);
  int callframe2711 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2712 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2711);
// compilenode returning call2712
// compilenode returning call2712
  int op_slot_left_2708 = gc_frame_newslot(call2712);
  params[0] = strlit2709;
  partcv[0] = 1;
  Object opresult2713 = callmethod(call2712, "!=", 1, partcv, params);
// compilenode returning opresult2713
  Object if2707 = done;
  if (istrue(opresult2713)) {
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 829
  setline(829);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2714 = gc_frame_new();
  int callframe2715 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2716 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2715);
// compilenode returning call2716
// compilenode returning call2716
  partcv[0] = 0;
  Object call2717 = callmethod(call2716, "new",
    1, partcv, params);
  gc_frame_end(callframe2714);
// compilenode returning call2717
// compilenode returning call2717
  *var_suggestion = call2717;
  if (call2717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 830
  setline(830);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2718 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2719 = alloc_Boolean(1);
// compilenode returning bool2719
  gc_frame_newslot(bool2719);
  params[0] = *var_btok;
  params[1] = bool2719;
  partcv[0] = 2;
  Object call2720 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2718);
// compilenode returning call2720
  *var_closingBrace = call2720;
  if (call2720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 831
  setline(831);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2723 = alloc_Boolean(0);
// compilenode returning bool2723
  int op_slot_right_2722 = gc_frame_newslot(bool2723);
  int callframe2725 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2726 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2725);
// compilenode returning call2726
// compilenode returning call2726
  int op_slot_left_2722 = gc_frame_newslot(call2726);
  params[0] = bool2723;
  partcv[0] = 1;
  Object opresult2727 = callmethod(call2726, "==", 1, partcv, params);
// compilenode returning opresult2727
  Object if2721 = done;
  if (istrue(opresult2727)) {
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2729 = gc_frame_newslot(*var_lastToken);
  int callframe2731 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2732 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2731);
// compilenode returning call2732
// compilenode returning call2732
  int op_slot_left_2729 = gc_frame_newslot(call2732);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2733 = callmethod(call2732, "==", 1, partcv, params);
// compilenode returning opresult2733
  Object if2728 = done;
  if (istrue(opresult2733)) {
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2734 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2735 = alloc_Boolean(0);
// compilenode returning bool2735
  gc_frame_newslot(bool2735);
  Object bool2736 = alloc_Boolean(1);
// compilenode returning bool2736
  gc_frame_newslot(bool2736);
  if (strlit2737 == NULL) {
    strlit2737 = alloc_String("then {}");
    gc_root(strlit2737);
  }
// compilenode returning strlit2737
  gc_frame_newslot(strlit2737);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2735;
  params[2] = bool2736;
  params[3] = strlit2737;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2738 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2734);
// compilenode returning call2738
    gc_frame_newslot(call2738);
    if2728 = call2738;
  } else {
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2739 = gc_frame_new();
  Object num2741 = alloc_Float64(0.1);
// compilenode returning num2741
  int op_slot_right_2740 = gc_frame_newslot(num2741);
  int callframe2743 = gc_frame_new();
  int callframe2744 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2745 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2744);
// compilenode returning call2745
// compilenode returning call2745
  partcv[0] = 0;
  Object call2746 = callmethod(call2745, "line",
    1, partcv, params);
  gc_frame_end(callframe2743);
// compilenode returning call2746
// compilenode returning call2746
  int op_slot_left_2740 = gc_frame_newslot(call2746);
  params[0] = num2741;
  partcv[0] = 1;
  Object sum2747 = callmethod(call2746, "+", 1, partcv, params);
// compilenode returning sum2747
  gc_frame_newslot(sum2747);
  if (strlit2748 == NULL) {
    strlit2748 = alloc_String("}");
    gc_root(strlit2748);
  }
// compilenode returning strlit2748
  gc_frame_newslot(strlit2748);
// compilenode returning *var_suggestion
  params[0] = sum2747;
  params[1] = strlit2748;
  partcv[0] = 2;
  Object call2749 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2739);
// compilenode returning call2749
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2750 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2751 = alloc_Boolean(0);
// compilenode returning bool2751
  gc_frame_newslot(bool2751);
  Object bool2752 = alloc_Boolean(1);
// compilenode returning bool2752
  gc_frame_newslot(bool2752);
  if (strlit2753 == NULL) {
    strlit2753 = alloc_String("then {");
    gc_root(strlit2753);
  }
// compilenode returning strlit2753
  gc_frame_newslot(strlit2753);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2751;
  params[2] = bool2752;
  params[3] = strlit2753;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2754 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2750);
// compilenode returning call2754
    gc_frame_newslot(call2754);
    if2728 = call2754;
  }
// compilenode returning if2728
    gc_frame_newslot(if2728);
    if2721 = if2728;
  } else {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2755 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2756 = alloc_Boolean(0);
// compilenode returning bool2756
  gc_frame_newslot(bool2756);
  Object bool2757 = alloc_Boolean(1);
// compilenode returning bool2757
  gc_frame_newslot(bool2757);
  if (strlit2758 == NULL) {
    strlit2758 = alloc_String("then {");
    gc_root(strlit2758);
  }
// compilenode returning strlit2758
  gc_frame_newslot(strlit2758);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2756;
  params[2] = bool2757;
  params[3] = strlit2758;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2759 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2755);
// compilenode returning call2759
    gc_frame_newslot(call2759);
    if2721 = call2759;
  }
// compilenode returning if2721
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2760 = gc_frame_new();
  if (strlit2761 == NULL) {
    strlit2761 = alloc_String("An elseif statement must have a '{' after the 'then'.");
    gc_root(strlit2761);
  }
// compilenode returning strlit2761
  gc_frame_newslot(strlit2761);
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2762 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2763 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2762);
// compilenode returning call2763
// compilenode returning call2763
  gc_frame_newslot(call2763);
  int callframe2765 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2766 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2765);
// compilenode returning call2766
// compilenode returning call2766
  int op_slot_right_2764 = gc_frame_newslot(call2766);
  int callframe2768 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2769 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2768);
// compilenode returning call2769
// compilenode returning call2769
  int op_slot_left_2764 = gc_frame_newslot(call2769);
  params[0] = call2766;
  partcv[0] = 1;
  Object sum2770 = callmethod(call2769, "+", 1, partcv, params);
// compilenode returning sum2770
  gc_frame_newslot(sum2770);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2761;
  params[1] = call2763;
  params[2] = sum2770;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2771 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2760);
// compilenode returning call2771
    gc_frame_newslot(call2771);
    if2707 = call2771;
  } else {
  }
// compilenode returning if2707
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2772 = gc_frame_new();
  partcv[0] = 0;
  Object call2773 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2772);
// compilenode returning call2773
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 845
  setline(845);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2776 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2777 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2776);
// compilenode returning call2777
// compilenode returning call2777
  int op_slot_right_2775 = gc_frame_newslot(call2777);
  int callframe2779 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2780 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2779);
// compilenode returning call2780
// compilenode returning call2780
  int op_slot_left_2775 = gc_frame_newslot(call2780);
  params[0] = call2777;
  partcv[0] = 1;
  Object opresult2781 = callmethod(call2780, "==", 1, partcv, params);
// compilenode returning opresult2781
  Object if2774 = done;
  if (istrue(opresult2781)) {
// Begin line 847
  setline(847);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 846
  setline(846);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2783 = alloc_Float64(1);
// compilenode returning num2783
  int op_slot_right_2782 = gc_frame_newslot(num2783);
  int callframe2785 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2786 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2785);
// compilenode returning call2786
// compilenode returning call2786
  int op_slot_left_2782 = gc_frame_newslot(call2786);
  params[0] = num2783;
  partcv[0] = 1;
  Object diff2787 = callmethod(call2786, "-", 1, partcv, params);
// compilenode returning diff2787
  *var_minIndentLevel = diff2787;
  if (diff2787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2774 = done;
  } else {
// Begin line 849
  setline(849);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 848
  setline(848);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minInd
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2774 = done;
  }
// compilenode returning if2774
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2790 = gc_frame_new();
  Object block2791 = alloc_Block(NULL, NULL, "parser", 850);
  gc_frame_newslot(block2791);
  block_savedest(block2791);
  Object closure2792 = createclosure(1, "_apply");
setclosureframe(closure2792, stackframe);
  addtoclosure(closure2792, selfslot);
  struct UserObject *uo2792 = (struct UserObject*)block2791;
  uo2792->data[0] = (Object)closure2792;
  Method *meth_meth_parser__apply2792 = addmethod2pos(block2791, "_apply", &meth_parser__apply2792, 0);
int argcv_meth_parser__apply2792[] = {0};
meth_meth_parser__apply2792->type = alloc_MethodType(1, argcv_meth_parser__apply2792);
  meth_meth_parser__apply2792->definitionModule = modulename;
  meth_meth_parser__apply2792->definitionLine = 846;
// compilenode returning block2791
  gc_frame_newslot(block2791);
  Object block2799 = alloc_Block(NULL, NULL, "parser", 850);
  gc_frame_newslot(block2799);
  block_savedest(block2799);
  Object closure2800 = createclosure(8, "_apply");
setclosureframe(closure2800, stackframe);
  addtoclosure(closure2800, var_errormessages);
  addtoclosure(closure2800, var_btok);
  addtoclosure(closure2800, var_lastToken);
  addtoclosure(closure2800, var_sym);
  addtoclosure(closure2800, var_values);
  addtoclosure(closure2800, var_v);
  addtoclosure(closure2800, var_ebody);
  addtoclosure(closure2800, selfslot);
  struct UserObject *uo2800 = (struct UserObject*)block2799;
  uo2800->data[0] = (Object)closure2800;
  Method *meth_meth_parser__apply2800 = addmethod2pos(block2799, "_apply", &meth_parser__apply2800, 0);
int argcv_meth_parser__apply2800[] = {0};
meth_meth_parser__apply2800->type = alloc_MethodType(1, argcv_meth_parser__apply2800);
  meth_meth_parser__apply2800->definitionModule = modulename;
  meth_meth_parser__apply2800->definitionLine = 850;
// compilenode returning block2799
  gc_frame_newslot(block2799);
  params[0] = block2791;
  params[1] = block2799;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2860 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2790);
// compilenode returning call2860
// Begin line 868
  setline(868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2861 = gc_frame_new();
  partcv[0] = 0;
  Object call2862 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2861);
// compilenode returning call2862
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2863 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2863
  *var_newelse = array2863;
  if (array2863 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 870
  setline(870);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2865 = gc_frame_new();
// compilenode returning *var_econd
  gc_frame_newslot(*var_econd);
// compilenode returning *var_ebody
  gc_frame_newslot(*var_ebody);
// compilenode returning *var_newelse
  gc_frame_newslot(*var_newelse);
  int callframe2866 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call2867 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe2866);
// compilenode returning call2867
// compilenode returning call2867
  params[0] = *var_econd;
  params[1] = *var_ebody;
  params[2] = *var_newelse;
  partcv[0] = 3;
  Object call2868 = callmethod(call2867, "new",
    1, partcv, params);
  gc_frame_end(callframe2865);
// compilenode returning call2868
  *var_eif = call2868;
  if (call2868 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 873
  setline(873);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2870 = gc_frame_new();
// compilenode returning *var_eif
  gc_frame_newslot(*var_eif);
// compilenode returning *var_curelse
  params[0] = *var_eif;
  partcv[0] = 1;
  Object call2871 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe2870);
// compilenode returning call2871
// Begin line 877
  setline(877);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 876
  setline(876);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_newelse
  *var_curelse = *var_newelse;
  if (*var_newelse == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply2975(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2976 = gc_frame_new();
  int callframe2977 = gc_frame_new();
  if (strlit2978 == NULL) {
    strlit2978 = alloc_String("rbrace");
    gc_root(strlit2978);
  }
// compilenode returning strlit2978
  gc_frame_newslot(strlit2978);
  params[0] = strlit2978;
  partcv[0] = 1;
  Object call2979 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2977);
// compilenode returning call2979
  partcv[0] = 0;
  Object call2980 = callmethod(call2979, "not",
    1, partcv, params);
  gc_frame_end(callframe2976);
// compilenode returning call2980
// compilenode returning call2980
  gc_frame_end(frame);
  return call2980;
}
Object meth_parser__apply2988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe2989 = gc_frame_new();
  partcv[0] = 0;
  Object call2990 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2989);
// compilenode returning call2990
  gc_frame_end(frame);
  return call2990;
}
Object meth_parser__apply2983(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_btok = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_v = getfromclosure(closure, 5);
  Object *var_curelse = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "closingBrace");
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 905
  setline(905);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2985 = gc_frame_new();
  int callframe2986 = gc_frame_new();
  Object block2987 = alloc_Block(NULL, NULL, "parser", 905);
  gc_frame_newslot(block2987);
  block_savedest(block2987);
  Object closure2988 = createclosure(1, "_apply");
setclosureframe(closure2988, stackframe);
  addtoclosure(closure2988, selfslot);
  struct UserObject *uo2988 = (struct UserObject*)block2987;
  uo2988->data[0] = (Object)closure2988;
  Method *meth_meth_parser__apply2988 = addmethod2pos(block2987, "_apply", &meth_parser__apply2988, 0);
int argcv_meth_parser__apply2988[] = {0};
meth_meth_parser__apply2988->type = alloc_MethodType(1, argcv_meth_parser__apply2988);
  meth_meth_parser__apply2988->definitionModule = modulename;
  meth_meth_parser__apply2988->definitionLine = 905;
// compilenode returning block2987
  gc_frame_newslot(block2987);
  params[0] = block2987;
  partcv[0] = 1;
  Object call2992 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2986);
// compilenode returning call2992
  partcv[0] = 0;
  Object call2993 = callmethod(call2992, "not",
    1, partcv, params);
  gc_frame_end(callframe2985);
// compilenode returning call2993
// compilenode returning call2993
  Object if2984 = done;
  if (istrue(call2993)) {
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2994 = gc_frame_new();
  int callframe2995 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2996 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2995);
// compilenode returning call2996
// compilenode returning call2996
  partcv[0] = 0;
  Object call2997 = callmethod(call2996, "new",
    1, partcv, params);
  gc_frame_end(callframe2994);
// compilenode returning call2997
// compilenode returning call2997
  *var_suggestion = call2997;
  if (call2997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2998 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2999 = alloc_Boolean(0);
// compilenode returning bool2999
  gc_frame_newslot(bool2999);
  params[0] = *var_btok;
  params[1] = bool2999;
  partcv[0] = 2;
  Object call3000 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2998);
// compilenode returning call3000
  *var_closingBrace = call3000;
  if (call3000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 908
  setline(908);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3003 = alloc_Boolean(0);
// compilenode returning bool3003
  int op_slot_right_3002 = gc_frame_newslot(bool3003);
  int callframe3005 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3006 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3005);
// compilenode returning call3006
// compilenode returning call3006
  int op_slot_left_3002 = gc_frame_newslot(call3006);
  params[0] = bool3003;
  partcv[0] = 1;
  Object opresult3007 = callmethod(call3006, "==", 1, partcv, params);
// compilenode returning opresult3007
  Object if3001 = done;
  if (istrue(opresult3007)) {
// Begin line 914
  setline(914);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 909
  setline(909);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_3009 = gc_frame_newslot(*var_lastToken);
  int callframe3011 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3012 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3011);
// compilenode returning call3012
// compilenode returning call3012
  int op_slot_left_3009 = gc_frame_newslot(call3012);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3013 = callmethod(call3012, "==", 1, partcv, params);
// compilenode returning opresult3013
  Object if3008 = done;
  if (istrue(opresult3013)) {
// Begin line 910
  setline(910);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3014 = gc_frame_new();
  if (strlit3015 == NULL) {
    strlit3015 = alloc_String("}");
    gc_root(strlit3015);
  }
// compilenode returning strlit3015
  gc_frame_newslot(strlit3015);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3015;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3016 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3014);
// compilenode returning call3016
    gc_frame_newslot(call3016);
    if3008 = call3016;
  } else {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3017 = gc_frame_new();
  Object num3019 = alloc_Float64(0.1);
// compilenode returning num3019
  int op_slot_right_3018 = gc_frame_newslot(num3019);
  int callframe3021 = gc_frame_new();
  int callframe3022 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3023 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3022);
// compilenode returning call3023
// compilenode returning call3023
  partcv[0] = 0;
  Object call3024 = callmethod(call3023, "line",
    1, partcv, params);
  gc_frame_end(callframe3021);
// compilenode returning call3024
// compilenode returning call3024
  int op_slot_left_3018 = gc_frame_newslot(call3024);
  params[0] = num3019;
  partcv[0] = 1;
  Object sum3025 = callmethod(call3024, "+", 1, partcv, params);
// compilenode returning sum3025
  gc_frame_newslot(sum3025);
  if (strlit3026 == NULL) {
    strlit3026 = alloc_String("}");
    gc_root(strlit3026);
  }
// compilenode returning strlit3026
  gc_frame_newslot(strlit3026);
// compilenode returning *var_suggestion
  params[0] = sum3025;
  params[1] = strlit3026;
  partcv[0] = 2;
  Object call3027 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3017);
// compilenode returning call3027
    gc_frame_newslot(call3027);
    if3008 = call3027;
  }
// compilenode returning if3008
    gc_frame_newslot(if3008);
    if3001 = if3008;
  } else {
  }
// compilenode returning if3001
// Begin line 915
  setline(915);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3028 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call3029 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3028);
// compilenode returning call3029
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3030 = gc_frame_new();
  if (strlit3031 == NULL) {
    strlit3031 = alloc_String("An else statement must end with a '}'.");
    gc_root(strlit3031);
  }
// compilenode returning strlit3031
  gc_frame_newslot(strlit3031);
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3032 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3033 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3032);
// compilenode returning call3033
// compilenode returning call3033
  gc_frame_newslot(call3033);
  int callframe3034 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3035 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3034);
// compilenode returning call3035
// compilenode returning call3035
  gc_frame_newslot(call3035);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3031;
  params[1] = call3033;
  params[2] = call3035;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3036 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3030);
// compilenode returning call3036
    gc_frame_newslot(call3036);
    if2984 = call3036;
  } else {
  }
// compilenode returning if2984
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 919
  setline(919);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3037 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3038 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3037);
// compilenode returning call3038
// compilenode returning call3038
  *var_v = call3038;
  if (call3038 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3040 = gc_frame_new();
// compilenode returning *var_v
  gc_frame_newslot(*var_v);
// compilenode returning *var_curelse
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3041 = callmethod(*var_curelse, "push",
    1, partcv, params);
  gc_frame_end(callframe3040);
// compilenode returning call3041
  gc_frame_end(frame);
  return call3041;
}
Object meth_parser_doif1776(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(27, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doif");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_minIndentLevel = getfromclosure(closure, 4);
  Object *var_statementIndent = getfromclosure(closure, 5);
  Object *var_statementToken = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doif (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doif");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_cond = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "cond");
  Object *var_body = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "body");
  Object *var_elseblock = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "elseblock");
  Object *var_curelse = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "curelse");
  Object *var_v = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "v");
  Object *var_localMin = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "localMin");
  Object *var_localStatementIndent = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localStatementIndent");
  Object *var_minInd = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "minInd");
  Object *var_closingBrace = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "closingBrace");
  Object *var_econd = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "econd");
  Object *var_eif = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "eif");
  Object *var_newelse = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "newelse");
  Object *var_ebody = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "ebody");
  Object *var_o = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "o");
// Begin line 960
  setline(960);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1780 == NULL) {
    strlit1780 = alloc_String("if");
    gc_root(strlit1780);
  }
// compilenode returning strlit1780
  int op_slot_right_1779 = gc_frame_newslot(strlit1780);
  int callframe1782 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1783 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe1782);
// compilenode returning call1783
// compilenode returning call1783
  int op_slot_left_1779 = gc_frame_newslot(call1783);
  params[0] = strlit1780;
  partcv[0] = 1;
  Object opresult1784 = callmethod(call1783, "==", 1, partcv, params);
// compilenode returning opresult1784
  int op_slot_right_1778 = gc_frame_newslot(opresult1784);
  int callframe1786 = gc_frame_new();
  if (strlit1787 == NULL) {
    strlit1787 = alloc_String("identifier");
    gc_root(strlit1787);
  }
// compilenode returning strlit1787
  gc_frame_newslot(strlit1787);
  params[0] = strlit1787;
  partcv[0] = 1;
  Object call1788 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1786);
// compilenode returning call1788
  int op_slot_left_1778 = gc_frame_newslot(call1788);
  params[0] = opresult1784;
  partcv[0] = 1;
  Object opresult1789 = callmethod(call1788, "&&", 1, partcv, params);
// compilenode returning opresult1789
  Object if1777 = done;
  if (istrue(opresult1789)) {
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 585
  setline(585);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 586
  setline(586);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1790 = gc_frame_new();
  partcv[0] = 0;
  Object call1791 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compilenode returning call1791
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 587
  setline(587);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1794 == NULL) {
    strlit1794 = alloc_String("lparen");
    gc_root(strlit1794);
  }
// compilenode returning strlit1794
  int op_slot_right_1793 = gc_frame_newslot(strlit1794);
  int callframe1796 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1797 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe1796);
// compilenode returning call1797
// compilenode returning call1797
  int op_slot_left_1793 = gc_frame_newslot(call1797);
  params[0] = strlit1794;
  partcv[0] = 1;
  Object opresult1798 = callmethod(call1797, "!=", 1, partcv, params);
// compilenode returning opresult1798
  Object if1792 = done;
  if (istrue(opresult1798)) {
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 588
  setline(588);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1799 = gc_frame_new();
  int callframe1800 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1801 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1800);
// compilenode returning call1801
// compilenode returning call1801
  partcv[0] = 0;
  Object call1802 = callmethod(call1801, "new",
    1, partcv, params);
  gc_frame_end(callframe1799);
// compilenode returning call1802
// compilenode returning call1802
  *var_suggestion = call1802;
  if (call1802 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1803 = gc_frame_new();
  Object block1804 = alloc_Block(NULL, NULL, "parser", 590);
  gc_frame_newslot(block1804);
  block_savedest(block1804);
  Object closure1805 = createclosure(2, "_apply");
setclosureframe(closure1805, stackframe);
  addtoclosure(closure1805, var_btok);
  addtoclosure(closure1805, selfslot);
  struct UserObject *uo1805 = (struct UserObject*)block1804;
  uo1805->data[0] = (Object)closure1805;
  Method *meth_meth_parser__apply1805 = addmethod2pos(block1804, "_apply", &meth_parser__apply1805, 0);
int argcv_meth_parser__apply1805[] = {1};
meth_meth_parser__apply1805->type = alloc_MethodType(1, argcv_meth_parser__apply1805);
  meth_meth_parser__apply1805->definitionModule = modulename;
  meth_meth_parser__apply1805->definitionLine = 588;
// compilenode returning block1804
  gc_frame_newslot(block1804);
  params[0] = block1804;
  partcv[0] = 1;
  Object call1850 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1803);
// compilenode returning call1850
  *var_nextTok = call1850;
  if (call1850 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1853 = alloc_Boolean(0);
// compilenode returning bool1853
  int op_slot_right_1852 = gc_frame_newslot(bool1853);
// compilenode returning *var_nextTok
  int op_slot_left_1852 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1853;
  partcv[0] = 1;
  Object opresult1855 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1855
  Object if1851 = done;
  if (istrue(opresult1855)) {
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1856 = gc_frame_new();
  if (strlit1857 == NULL) {
    strlit1857 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1857);
  }
// compilenode returning strlit1857
  gc_frame_newslot(strlit1857);
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
// compilenode returning *var_suggestion
  params[0] = strlit1857;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1858 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1856);
// compilenode returning call1858
    gc_frame_newslot(call1858);
    if1851 = call1858;
  } else {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1861 == NULL) {
    strlit1861 = alloc_String("rparen");
    gc_root(strlit1861);
  }
// compilenode returning strlit1861
  int op_slot_right_1860 = gc_frame_newslot(strlit1861);
  int callframe1863 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1864 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1863);
// compilenode returning call1864
// compilenode returning call1864
  int op_slot_left_1860 = gc_frame_newslot(call1864);
  params[0] = strlit1861;
  partcv[0] = 1;
  Object opresult1865 = callmethod(call1864, "==", 1, partcv, params);
// compilenode returning opresult1865
  Object if1859 = done;
  if (istrue(opresult1865)) {
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1867 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1867 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1869 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1869
  Object if1866 = done;
  if (istrue(opresult1869)) {
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1870 = gc_frame_new();
  if (strlit1871 == NULL) {
    strlit1871 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit1871);
  }
// compilenode returning strlit1871
  gc_frame_newslot(strlit1871);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit1871;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1872 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1870);
// compilenode returning call1872
    gc_frame_newslot(call1872);
    if1866 = call1872;
  } else {
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1873 = gc_frame_new();
  if (strlit1874 == NULL) {
    strlit1874 = alloc_String("(");
    gc_root(strlit1874);
  }
// compilenode returning strlit1874
  gc_frame_newslot(strlit1874);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit1874;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1875 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1873);
// compilenode returning call1875
    gc_frame_newslot(call1875);
    if1866 = call1875;
  }
// compilenode returning if1866
    gc_frame_newslot(if1866);
    if1859 = if1866;
  } else {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 601
  setline(601);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1878 == NULL) {
    strlit1878 = alloc_String("lbrace");
    gc_root(strlit1878);
  }
// compilenode returning strlit1878
  int op_slot_right_1877 = gc_frame_newslot(strlit1878);
  int callframe1880 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1881 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1880);
// compilenode returning call1881
// compilenode returning call1881
  int op_slot_left_1877 = gc_frame_newslot(call1881);
  params[0] = strlit1878;
  partcv[0] = 1;
  Object opresult1882 = callmethod(call1881, "==", 1, partcv, params);
// compilenode returning opresult1882
  Object if1876 = done;
  if (istrue(opresult1882)) {
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 602
  setline(602);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1884 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1884 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1886 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1886
  Object if1883 = done;
  if (istrue(opresult1886)) {
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1887 = gc_frame_new();
  if (strlit1888 == NULL) {
    strlit1888 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"") then");
    gc_root(strlit1888);
  }
// compilenode returning strlit1888
  gc_frame_newslot(strlit1888);
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
// compilenode returning *var_suggestion
  params[0] = strlit1888;
  params[1] = *var_btok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1889 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1887);
// compilenode returning call1889
    gc_frame_newslot(call1889);
    if1883 = call1889;
  } else {
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1890 = gc_frame_new();
  if (strlit1891 == NULL) {
    strlit1891 = alloc_String("(");
    gc_root(strlit1891);
  }
// compilenode returning strlit1891
  gc_frame_newslot(strlit1891);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit1891;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1892 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1890);
// compilenode returning call1892
// Begin line 606
  setline(606);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1893 = gc_frame_new();
  if (strlit1894 == NULL) {
    strlit1894 = alloc_String(") then");
    gc_root(strlit1894);
  }
// compilenode returning strlit1894
  gc_frame_newslot(strlit1894);
  int callframe1895 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1896 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1895);
// compilenode returning call1896
// compilenode returning call1896
  gc_frame_newslot(call1896);
  Object bool1897 = alloc_Boolean(1);
// compilenode returning bool1897
  gc_frame_newslot(bool1897);
// compilenode returning *var_suggestion
  params[0] = strlit1894;
  params[1] = call1896;
  params[2] = bool1897;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1898 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1893);
// compilenode returning call1898
    gc_frame_newslot(call1898);
    if1883 = call1898;
  }
// compilenode returning if1883
    gc_frame_newslot(if1883);
    if1876 = if1883;
  } else {
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit1901 == NULL) {
    strlit1901 = alloc_String("identifier");
    gc_root(strlit1901);
  }
// compilenode returning strlit1901
  int op_slot_right_1900 = gc_frame_newslot(strlit1901);
  int callframe1903 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1904 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compilenode returning call1904
// compilenode returning call1904
  int op_slot_left_1900 = gc_frame_newslot(call1904);
  params[0] = strlit1901;
  partcv[0] = 1;
  Object opresult1905 = callmethod(call1904, "==", 1, partcv, params);
// compilenode returning opresult1905
  Object if1899 = done;
  if (istrue(opresult1905)) {
// Begin line 615
  setline(615);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1907 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1907 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1909 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1909
  Object if1906 = done;
  if (istrue(opresult1909)) {
// Begin line 610
  setline(610);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1910 = gc_frame_new();
  if (strlit1911 == NULL) {
    strlit1911 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"") ");
    gc_root(strlit1911);
  }
// compilenode returning strlit1911
  gc_frame_newslot(strlit1911);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit1911;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1912 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1910);
// compilenode returning call1912
    gc_frame_newslot(call1912);
    if1906 = call1912;
  } else {
// Begin line 612
  setline(612);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1913 = gc_frame_new();
  if (strlit1914 == NULL) {
    strlit1914 = alloc_String("(");
    gc_root(strlit1914);
  }
// compilenode returning strlit1914
  gc_frame_newslot(strlit1914);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit1914;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1915 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe1913);
// compilenode returning call1915
// Begin line 613
  setline(613);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1916 = gc_frame_new();
  if (strlit1917 == NULL) {
    strlit1917 = alloc_String(")");
    gc_root(strlit1917);
  }
// compilenode returning strlit1917
  gc_frame_newslot(strlit1917);
  int callframe1918 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1919 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1918);
// compilenode returning call1919
// compilenode returning call1919
  gc_frame_newslot(call1919);
  Object bool1920 = alloc_Boolean(1);
// compilenode returning bool1920
  gc_frame_newslot(bool1920);
// compilenode returning *var_suggestion
  params[0] = strlit1917;
  params[1] = call1919;
  params[2] = bool1920;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1921 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe1916);
// compilenode returning call1921
    gc_frame_newslot(call1921);
    if1906 = call1921;
  }
// compilenode returning if1906
    gc_frame_newslot(if1906);
    if1899 = if1906;
  } else {
  }
// compilenode returning if1899
    gc_frame_newslot(if1899);
    if1876 = if1899;
  }
// compilenode returning if1876
    gc_frame_newslot(if1876);
    if1859 = if1876;
  }
// compilenode returning if1859
    gc_frame_newslot(if1859);
    if1851 = if1859;
  }
// compilenode returning if1851
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1922 = gc_frame_new();
  if (strlit1923 == NULL) {
    strlit1923 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1923);
  }
// compilenode returning strlit1923
  gc_frame_newslot(strlit1923);
// Begin line 617
  setline(617);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1924 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1925 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1924);
// compilenode returning call1925
// compilenode returning call1925
  gc_frame_newslot(call1925);
  int callframe1926 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1927 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1926);
// compilenode returning call1927
// compilenode returning call1927
  gc_frame_newslot(call1927);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 616
  setline(616);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1923;
  params[1] = call1925;
  params[2] = call1927;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1928 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1922);
// compilenode returning call1928
    gc_frame_newslot(call1928);
    if1792 = call1928;
  } else {
  }
// compilenode returning if1792
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1929 = gc_frame_new();
  partcv[0] = 0;
  Object call1930 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1929);
// compilenode returning call1930
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1932 = gc_frame_new();
  int callframe1933 = gc_frame_new();
  Object block1934 = alloc_Block(NULL, NULL, "parser", 620);
  gc_frame_newslot(block1934);
  block_savedest(block1934);
  Object closure1935 = createclosure(1, "_apply");
setclosureframe(closure1935, stackframe);
  addtoclosure(closure1935, selfslot);
  struct UserObject *uo1935 = (struct UserObject*)block1934;
  uo1935->data[0] = (Object)closure1935;
  Method *meth_meth_parser__apply1935 = addmethod2pos(block1934, "_apply", &meth_parser__apply1935, 0);
int argcv_meth_parser__apply1935[] = {0};
meth_meth_parser__apply1935->type = alloc_MethodType(1, argcv_meth_parser__apply1935);
  meth_meth_parser__apply1935->definitionModule = modulename;
  meth_meth_parser__apply1935->definitionLine = 620;
// compilenode returning block1934
  gc_frame_newslot(block1934);
  params[0] = block1934;
  partcv[0] = 1;
  Object call1939 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1933);
// compilenode returning call1939
  partcv[0] = 0;
  Object call1940 = callmethod(call1939, "not",
    1, partcv, params);
  gc_frame_end(callframe1932);
// compilenode returning call1940
// compilenode returning call1940
  Object if1931 = done;
  if (istrue(call1940)) {
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1941 = gc_frame_new();
  int callframe1942 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call1943 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe1942);
// compilenode returning call1943
// compilenode returning call1943
  partcv[0] = 0;
  Object call1944 = callmethod(call1943, "new",
    1, partcv, params);
  gc_frame_end(callframe1941);
// compilenode returning call1944
// compilenode returning call1944
  *var_suggestion = call1944;
  if (call1944 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1945 = gc_frame_new();
  Object block1946 = alloc_Block(NULL, NULL, "parser", 623);
  gc_frame_newslot(block1946);
  block_savedest(block1946);
  Object closure1947 = createclosure(2, "_apply");
setclosureframe(closure1947, stackframe);
  addtoclosure(closure1947, var_lastToken);
  addtoclosure(closure1947, selfslot);
  struct UserObject *uo1947 = (struct UserObject*)block1946;
  uo1947->data[0] = (Object)closure1947;
  Method *meth_meth_parser__apply1947 = addmethod2pos(block1946, "_apply", &meth_parser__apply1947, 0);
int argcv_meth_parser__apply1947[] = {1};
meth_meth_parser__apply1947->type = alloc_MethodType(1, argcv_meth_parser__apply1947);
  meth_meth_parser__apply1947->definitionModule = modulename;
  meth_meth_parser__apply1947->definitionLine = 621;
// compilenode returning block1946
  gc_frame_newslot(block1946);
  params[0] = block1946;
  partcv[0] = 1;
  Object call1965 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1945);
// compilenode returning call1965
  *var_nextTok = call1965;
  if (call1965 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 644
  setline(644);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool1968 = alloc_Boolean(0);
// compilenode returning bool1968
  int op_slot_right_1967 = gc_frame_newslot(bool1968);
// compilenode returning *var_nextTok
  int op_slot_left_1967 = gc_frame_newslot(*var_nextTok);
  params[0] = bool1968;
  partcv[0] = 1;
  Object opresult1970 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1970
  Object if1966 = done;
  if (istrue(opresult1970)) {
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1971 = gc_frame_new();
  if (strlit1972 == NULL) {
    strlit1972 = alloc_String("rparen");
    gc_root(strlit1972);
  }
// compilenode returning strlit1972
  gc_frame_newslot(strlit1972);
  params[0] = strlit1972;
  partcv[0] = 1;
  Object call1973 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1971);
// compilenode returning call1973
  *var_nextTok = call1973;
  if (call1973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1976 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1976 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1978 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1978
  Object if1975 = done;
  if (istrue(opresult1978)) {
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1979 = gc_frame_new();
  if (strlit1980 == NULL) {
    strlit1980 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1980);
  }
// compilenode returning strlit1980
  gc_frame_newslot(strlit1980);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit1980;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1981 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe1979);
// compilenode returning call1981
    gc_frame_newslot(call1981);
    if1975 = call1981;
  } else {
// Begin line 629
  setline(629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1982 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe1983 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call1984 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe1983);
// compilenode returning call1984
// compilenode returning call1984
  gc_frame_newslot(call1984);
  Object bool1985 = alloc_Boolean(1);
// compilenode returning bool1985
  gc_frame_newslot(bool1985);
  Object bool1986 = alloc_Boolean(0);
// compilenode returning bool1986
  gc_frame_newslot(bool1986);
  if (strlit1987 == NULL) {
    strlit1987 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb"") then {");
    gc_root(strlit1987);
  }
// compilenode returning strlit1987
  gc_frame_newslot(strlit1987);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call1984;
  params[2] = bool1985;
  params[3] = bool1986;
  params[4] = strlit1987;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call1988 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe1982);
// compilenode returning call1988
    gc_frame_newslot(call1988);
    if1975 = call1988;
  }
// compilenode returning if1975
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1989 = gc_frame_new();
  if (strlit1990 == NULL) {
    strlit1990 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit1990);
  }
// compilenode returning strlit1990
  gc_frame_newslot(strlit1990);
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe1991 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1992 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe1991);
// compilenode returning call1992
// compilenode returning call1992
  gc_frame_newslot(call1992);
  int callframe1993 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call1994 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe1993);
// compilenode returning call1994
// compilenode returning call1994
  gc_frame_newslot(call1994);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit1990;
  params[1] = call1992;
  params[2] = call1994;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call1995 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe1989);
// compilenode returning call1995
    gc_frame_newslot(call1995);
    if1966 = call1995;
  } else {
// Begin line 643
  setline(643);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 634
  setline(634);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_1997 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_1997 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult1999 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult1999
  Object if1996 = done;
  if (istrue(opresult1999)) {
// Begin line 635
  setline(635);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2000 = gc_frame_new();
  if (strlit2001 == NULL) {
    strlit2001 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2001);
  }
// compilenode returning strlit2001
  gc_frame_newslot(strlit2001);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2001;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2002 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2000);
// compilenode returning call2002
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2003 = gc_frame_new();
  if (strlit2004 == NULL) {
    strlit2004 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit2004);
  }
// compilenode returning strlit2004
  gc_frame_newslot(strlit2004);
// Begin line 637
  setline(637);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2005 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2006 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2005);
// compilenode returning call2006
// compilenode returning call2006
  gc_frame_newslot(call2006);
  int callframe2007 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2008 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2007);
// compilenode returning call2008
// compilenode returning call2008
  gc_frame_newslot(call2008);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2004;
  params[1] = call2006;
  params[2] = call2008;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2009 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2003);
// compilenode returning call2009
    gc_frame_newslot(call2009);
    if1996 = call2009;
  } else {
// Begin line 639
  setline(639);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2010 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe2011 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2012 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe2011);
// compilenode returning call2012
// compilenode returning call2012
  gc_frame_newslot(call2012);
  Object bool2013 = alloc_Boolean(0);
// compilenode returning bool2013
  gc_frame_newslot(bool2013);
  Object bool2014 = alloc_Boolean(1);
// compilenode returning bool2014
  gc_frame_newslot(bool2014);
  if (strlit2015 == NULL) {
    strlit2015 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit2015);
  }
// compilenode returning strlit2015
  gc_frame_newslot(strlit2015);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call2012;
  params[2] = bool2013;
  params[3] = bool2014;
  params[4] = strlit2015;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2016 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2010);
// compilenode returning call2016
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2017 = gc_frame_new();
  if (strlit2018 == NULL) {
    strlit2018 = alloc_String("An if statement must have an expression in parentheses after the 'if'.");
    gc_root(strlit2018);
  }
// compilenode returning strlit2018
  gc_frame_newslot(strlit2018);
// Begin line 641
  setline(641);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2019 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2020 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2019);
// compilenode returning call2020
// compilenode returning call2020
  gc_frame_newslot(call2020);
  int callframe2021 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2022 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2021);
// compilenode returning call2022
// compilenode returning call2022
  gc_frame_newslot(call2022);
  Object num2024 = alloc_Float64(1);
// compilenode returning num2024
  int op_slot_right_2023 = gc_frame_newslot(num2024);
  int callframe2026 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call2027 = callmethod(*var_nextTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2026);
// compilenode returning call2027
// compilenode returning call2027
  int op_slot_left_2023 = gc_frame_newslot(call2027);
  params[0] = num2024;
  partcv[0] = 1;
  Object diff2028 = callmethod(call2027, "-", 1, partcv, params);
// compilenode returning diff2028
  gc_frame_newslot(diff2028);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 640
  setline(640);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2018;
  params[1] = call2020;
  params[2] = call2022;
  params[3] = diff2028;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call2029 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2017);
// compilenode returning call2029
    gc_frame_newslot(call2029);
    if1996 = call2029;
  }
// compilenode returning if1996
    gc_frame_newslot(if1996);
    if1966 = if1996;
  }
// compilenode returning if1966
    gc_frame_newslot(if1966);
    if1931 = if1966;
  } else {
  }
// compilenode returning if1931
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 645
  setline(645);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2032 == NULL) {
    strlit2032 = alloc_String("rparen");
    gc_root(strlit2032);
  }
// compilenode returning strlit2032
  int op_slot_right_2031 = gc_frame_newslot(strlit2032);
  int callframe2034 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2035 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2034);
// compilenode returning call2035
// compilenode returning call2035
  int op_slot_left_2031 = gc_frame_newslot(call2035);
  params[0] = strlit2032;
  partcv[0] = 1;
  Object opresult2036 = callmethod(call2035, "!=", 1, partcv, params);
// compilenode returning opresult2036
  Object if2030 = done;
  if (istrue(opresult2036)) {
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2037 = gc_frame_new();
  partcv[0] = 0;
  Object call2038 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2037);
// compilenode returning call2038
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2039 = gc_frame_new();
  int callframe2040 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2041 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2040);
// compilenode returning call2041
// compilenode returning call2041
  partcv[0] = 0;
  Object call2042 = callmethod(call2041, "new",
    1, partcv, params);
  gc_frame_end(callframe2039);
// compilenode returning call2042
// compilenode returning call2042
  *var_suggestion = call2042;
  if (call2042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 648
  setline(648);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2043 = gc_frame_new();
  if (strlit2044 == NULL) {
    strlit2044 = alloc_String(")");
    gc_root(strlit2044);
  }
// compilenode returning strlit2044
  gc_frame_newslot(strlit2044);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit2044;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2045 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe2043);
// compilenode returning call2045
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2046 = gc_frame_new();
  if (strlit2047 == NULL) {
    strlit2047 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit2047);
  }
// compilenode returning strlit2047
  gc_frame_newslot(strlit2047);
// Begin line 650
  setline(650);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2048 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2049 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2048);
// compilenode returning call2049
// compilenode returning call2049
  gc_frame_newslot(call2049);
  int callframe2051 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2052 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2051);
// compilenode returning call2052
// compilenode returning call2052
  int op_slot_right_2050 = gc_frame_newslot(call2052);
  int callframe2054 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2055 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2054);
// compilenode returning call2055
// compilenode returning call2055
  int op_slot_left_2050 = gc_frame_newslot(call2055);
  params[0] = call2052;
  partcv[0] = 1;
  Object sum2056 = callmethod(call2055, "+", 1, partcv, params);
// compilenode returning sum2056
  gc_frame_newslot(sum2056);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 649
  setline(649);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2047;
  params[1] = call2049;
  params[2] = sum2056;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2057 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2046);
// compilenode returning call2057
    gc_frame_newslot(call2057);
    if2030 = call2057;
  } else {
  }
// compilenode returning if2030
// Begin line 652
  setline(652);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2058 = gc_frame_new();
  partcv[0] = 0;
  Object call2059 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2058);
// compilenode returning call2059
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 653
  setline(653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2060 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call2061 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe2060);
// compilenode returning call2061
// compilenode returning call2061
  *var_cond = call2061;
  if (call2061 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 654
  setline(654);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2062 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2062
  *var_body = array2062;
  if (array2062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 662
  setline(662);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array2063 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array2063
  *var_elseblock = array2063;
  if (array2063 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 663
  setline(663);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_elseblock
  *var_curelse = *var_elseblock;
  if (*var_elseblock == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_v = undefined;
// compilenode returning done
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 666
  setline(666);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_statementIndent
  *var_localStatementIndent = *var_statementIndent;
  if (*var_statementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 667
  setline(667);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2065 = alloc_Float64(1);
// compilenode returning num2065
  int op_slot_right_2064 = gc_frame_newslot(num2065);
// compilenode returning *var_statementIndent
  int op_slot_left_2064 = gc_frame_newslot(*var_statementIndent);
  params[0] = num2065;
  partcv[0] = 1;
  Object sum2067 = callmethod(*var_statementIndent, "+", 1, partcv, params);
// compilenode returning sum2067
  *var_minInd = sum2067;
  if (sum2067 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 668
  setline(668);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2071 == NULL) {
    strlit2071 = alloc_String("then");
    gc_root(strlit2071);
  }
// compilenode returning strlit2071
  int op_slot_right_2070 = gc_frame_newslot(strlit2071);
  int callframe2073 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2074 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2073);
// compilenode returning call2074
// compilenode returning call2074
  int op_slot_left_2070 = gc_frame_newslot(call2074);
  params[0] = strlit2071;
  partcv[0] = 1;
  Object opresult2075 = callmethod(call2074, "==", 1, partcv, params);
// compilenode returning opresult2075
  int op_slot_right_2069 = gc_frame_newslot(opresult2075);
  int callframe2077 = gc_frame_new();
  if (strlit2078 == NULL) {
    strlit2078 = alloc_String("identifier");
    gc_root(strlit2078);
  }
// compilenode returning strlit2078
  gc_frame_newslot(strlit2078);
  params[0] = strlit2078;
  partcv[0] = 1;
  Object call2079 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2077);
// compilenode returning call2079
  int op_slot_left_2069 = gc_frame_newslot(call2079);
  params[0] = opresult2075;
  partcv[0] = 1;
  Object opresult2080 = callmethod(call2079, "&&", 1, partcv, params);
// compilenode returning opresult2080
  Object if2068 = done;
  if (istrue(opresult2080)) {
// Begin line 669
  setline(669);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2081 = gc_frame_new();
  partcv[0] = 0;
  Object call2082 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2081);
// compilenode returning call2082
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2085 == NULL) {
    strlit2085 = alloc_String("lbrace");
    gc_root(strlit2085);
  }
// compilenode returning strlit2085
  int op_slot_right_2084 = gc_frame_newslot(strlit2085);
  int callframe2087 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2088 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2087);
// compilenode returning call2088
// compilenode returning call2088
  int op_slot_left_2084 = gc_frame_newslot(call2088);
  params[0] = strlit2085;
  partcv[0] = 1;
  Object opresult2089 = callmethod(call2088, "!=", 1, partcv, params);
// compilenode returning opresult2089
  Object if2083 = done;
  if (istrue(opresult2089)) {
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2090 = gc_frame_new();
  int callframe2091 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2092 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2091);
// compilenode returning call2092
// compilenode returning call2092
  partcv[0] = 0;
  Object call2093 = callmethod(call2092, "new",
    1, partcv, params);
  gc_frame_end(callframe2090);
// compilenode returning call2093
// compilenode returning call2093
  *var_suggestion = call2093;
  if (call2093 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 672
  setline(672);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2094 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2095 = alloc_Boolean(1);
// compilenode returning bool2095
  gc_frame_newslot(bool2095);
  params[0] = *var_btok;
  params[1] = bool2095;
  partcv[0] = 2;
  Object call2096 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2094);
// compilenode returning call2096
  *var_closingBrace = call2096;
  if (call2096 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 673
  setline(673);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2099 = alloc_Boolean(0);
// compilenode returning bool2099
  int op_slot_right_2098 = gc_frame_newslot(bool2099);
  int callframe2101 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2102 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2101);
// compilenode returning call2102
// compilenode returning call2102
  int op_slot_left_2098 = gc_frame_newslot(call2102);
  params[0] = bool2099;
  partcv[0] = 1;
  Object opresult2103 = callmethod(call2102, "==", 1, partcv, params);
// compilenode returning opresult2103
  Object if2097 = done;
  if (istrue(opresult2103)) {
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 674
  setline(674);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2105 = gc_frame_newslot(*var_lastToken);
  int callframe2107 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2108 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2107);
// compilenode returning call2108
// compilenode returning call2108
  int op_slot_left_2105 = gc_frame_newslot(call2108);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2109 = callmethod(call2108, "==", 1, partcv, params);
// compilenode returning opresult2109
  Object if2104 = done;
  if (istrue(opresult2109)) {
// Begin line 675
  setline(675);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2110 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2111 = alloc_Boolean(0);
// compilenode returning bool2111
  gc_frame_newslot(bool2111);
  Object bool2112 = alloc_Boolean(1);
// compilenode returning bool2112
  gc_frame_newslot(bool2112);
  if (strlit2113 == NULL) {
    strlit2113 = alloc_String("then {}");
    gc_root(strlit2113);
  }
// compilenode returning strlit2113
  gc_frame_newslot(strlit2113);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2111;
  params[2] = bool2112;
  params[3] = strlit2113;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2114 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2110);
// compilenode returning call2114
    gc_frame_newslot(call2114);
    if2104 = call2114;
  } else {
// Begin line 677
  setline(677);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2115 = gc_frame_new();
  Object num2117 = alloc_Float64(0.1);
// compilenode returning num2117
  int op_slot_right_2116 = gc_frame_newslot(num2117);
  int callframe2119 = gc_frame_new();
  int callframe2120 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2121 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2120);
// compilenode returning call2121
// compilenode returning call2121
  partcv[0] = 0;
  Object call2122 = callmethod(call2121, "line",
    1, partcv, params);
  gc_frame_end(callframe2119);
// compilenode returning call2122
// compilenode returning call2122
  int op_slot_left_2116 = gc_frame_newslot(call2122);
  params[0] = num2117;
  partcv[0] = 1;
  Object sum2123 = callmethod(call2122, "+", 1, partcv, params);
// compilenode returning sum2123
  gc_frame_newslot(sum2123);
  if (strlit2124 == NULL) {
    strlit2124 = alloc_String("}");
    gc_root(strlit2124);
  }
// compilenode returning strlit2124
  gc_frame_newslot(strlit2124);
// compilenode returning *var_suggestion
  params[0] = sum2123;
  params[1] = strlit2124;
  partcv[0] = 2;
  Object call2125 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2115);
// compilenode returning call2125
// Begin line 678
  setline(678);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2126 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2127 = alloc_Boolean(0);
// compilenode returning bool2127
  gc_frame_newslot(bool2127);
  Object bool2128 = alloc_Boolean(1);
// compilenode returning bool2128
  gc_frame_newslot(bool2128);
  if (strlit2129 == NULL) {
    strlit2129 = alloc_String("then {");
    gc_root(strlit2129);
  }
// compilenode returning strlit2129
  gc_frame_newslot(strlit2129);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2127;
  params[2] = bool2128;
  params[3] = strlit2129;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2130 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2126);
// compilenode returning call2130
    gc_frame_newslot(call2130);
    if2104 = call2130;
  }
// compilenode returning if2104
    gc_frame_newslot(if2104);
    if2097 = if2104;
  } else {
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2131 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2132 = alloc_Boolean(0);
// compilenode returning bool2132
  gc_frame_newslot(bool2132);
  Object bool2133 = alloc_Boolean(1);
// compilenode returning bool2133
  gc_frame_newslot(bool2133);
  if (strlit2134 == NULL) {
    strlit2134 = alloc_String("then {");
    gc_root(strlit2134);
  }
// compilenode returning strlit2134
  gc_frame_newslot(strlit2134);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2132;
  params[2] = bool2133;
  params[3] = strlit2134;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2135 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2131);
// compilenode returning call2135
    gc_frame_newslot(call2135);
    if2097 = call2135;
  }
// compilenode returning if2097
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2136 = gc_frame_new();
  if (strlit2137 == NULL) {
    strlit2137 = alloc_String("An if statement must have a '{' after the 'then'.");
    gc_root(strlit2137);
  }
// compilenode returning strlit2137
  gc_frame_newslot(strlit2137);
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2138 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2139 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2138);
// compilenode returning call2139
// compilenode returning call2139
  gc_frame_newslot(call2139);
  int callframe2141 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2142 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2141);
// compilenode returning call2142
// compilenode returning call2142
  int op_slot_right_2140 = gc_frame_newslot(call2142);
  int callframe2144 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2145 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2144);
// compilenode returning call2145
// compilenode returning call2145
  int op_slot_left_2140 = gc_frame_newslot(call2145);
  params[0] = call2142;
  partcv[0] = 1;
  Object sum2146 = callmethod(call2145, "+", 1, partcv, params);
// compilenode returning sum2146
  gc_frame_newslot(sum2146);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2137;
  params[1] = call2139;
  params[2] = sum2146;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2147 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2136);
// compilenode returning call2147
    gc_frame_newslot(call2147);
    if2083 = call2147;
  } else {
  }
// compilenode returning if2083
// Begin line 686
  setline(686);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2148 = gc_frame_new();
  partcv[0] = 0;
  Object call2149 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2148);
// compilenode returning call2149
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2152 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2153 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2152);
// compilenode returning call2153
// compilenode returning call2153
  int op_slot_right_2151 = gc_frame_newslot(call2153);
  int callframe2155 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2156 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2155);
// compilenode returning call2156
// compilenode returning call2156
  int op_slot_left_2151 = gc_frame_newslot(call2156);
  params[0] = call2153;
  partcv[0] = 1;
  Object opresult2157 = callmethod(call2156, "==", 1, partcv, params);
// compilenode returning opresult2157
  Object if2150 = done;
  if (istrue(opresult2157)) {
// Begin line 689
  setline(689);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 688
  setline(688);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2159 = alloc_Float64(1);
// compilenode returning num2159
  int op_slot_right_2158 = gc_frame_newslot(num2159);
  int callframe2161 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2162 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2161);
// compilenode returning call2162
// compilenode returning call2162
  int op_slot_left_2158 = gc_frame_newslot(call2162);
  params[0] = num2159;
  partcv[0] = 1;
  Object diff2163 = callmethod(call2162, "-", 1, partcv, params);
// compilenode returning diff2163
  *var_minIndentLevel = diff2163;
  if (diff2163 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2150 = done;
  } else {
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 690
  setline(690);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minInd
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2150 = done;
  }
// compilenode returning if2150
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2166 = gc_frame_new();
  Object block2167 = alloc_Block(NULL, NULL, "parser", 692);
  gc_frame_newslot(block2167);
  block_savedest(block2167);
  Object closure2168 = createclosure(1, "_apply");
setclosureframe(closure2168, stackframe);
  addtoclosure(closure2168, selfslot);
  struct UserObject *uo2168 = (struct UserObject*)block2167;
  uo2168->data[0] = (Object)closure2168;
  Method *meth_meth_parser__apply2168 = addmethod2pos(block2167, "_apply", &meth_parser__apply2168, 0);
int argcv_meth_parser__apply2168[] = {0};
meth_meth_parser__apply2168->type = alloc_MethodType(1, argcv_meth_parser__apply2168);
  meth_meth_parser__apply2168->definitionModule = modulename;
  meth_meth_parser__apply2168->definitionLine = 688;
// compilenode returning block2167
  gc_frame_newslot(block2167);
  Object block2175 = alloc_Block(NULL, NULL, "parser", 692);
  gc_frame_newslot(block2175);
  block_savedest(block2175);
  Object closure2176 = createclosure(8, "_apply");
setclosureframe(closure2176, stackframe);
  addtoclosure(closure2176, var_errormessages);
  addtoclosure(closure2176, var_btok);
  addtoclosure(closure2176, var_lastToken);
  addtoclosure(closure2176, var_sym);
  addtoclosure(closure2176, var_values);
  addtoclosure(closure2176, var_v);
  addtoclosure(closure2176, var_body);
  addtoclosure(closure2176, selfslot);
  struct UserObject *uo2176 = (struct UserObject*)block2175;
  uo2176->data[0] = (Object)closure2176;
  Method *meth_meth_parser__apply2176 = addmethod2pos(block2175, "_apply", &meth_parser__apply2176, 0);
int argcv_meth_parser__apply2176[] = {0};
meth_meth_parser__apply2176->type = alloc_MethodType(1, argcv_meth_parser__apply2176);
  meth_meth_parser__apply2176->definitionModule = modulename;
  meth_meth_parser__apply2176->definitionLine = 692;
// compilenode returning block2175
  gc_frame_newslot(block2175);
  params[0] = block2167;
  params[1] = block2175;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2236 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2166);
// compilenode returning call2236
// Begin line 710
  setline(710);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2237 = gc_frame_new();
  partcv[0] = 0;
  Object call2238 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2237);
// compilenode returning call2238
// Begin line 712
  setline(712);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_econd = undefined;
// compilenode returning done
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_eif = undefined;
// compilenode returning done
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_newelse = undefined;
// compilenode returning done
// Begin line 715
  setline(715);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_ebody = undefined;
// compilenode returning done
  int callframe2239 = gc_frame_new();
  Object block2240 = alloc_Block(NULL, NULL, "parser", 715);
  gc_frame_newslot(block2240);
  block_savedest(block2240);
  Object closure2241 = createclosure(2, "_apply");
setclosureframe(closure2241, stackframe);
  addtoclosure(closure2241, var_sym);
  addtoclosure(closure2241, selfslot);
  struct UserObject *uo2241 = (struct UserObject*)block2240;
  uo2241->data[0] = (Object)closure2241;
  Method *meth_meth_parser__apply2241 = addmethod2pos(block2240, "_apply", &meth_parser__apply2241, 0);
int argcv_meth_parser__apply2241[] = {0};
meth_meth_parser__apply2241->type = alloc_MethodType(1, argcv_meth_parser__apply2241);
  meth_meth_parser__apply2241->definitionModule = modulename;
  meth_meth_parser__apply2241->definitionLine = 707;
// compilenode returning block2240
  gc_frame_newslot(block2240);
  Object block2255 = alloc_Block(NULL, NULL, "parser", 715);
  gc_frame_newslot(block2255);
  block_savedest(block2255);
  Object closure2256 = createclosure(16, "_apply");
setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_sym);
  addtoclosure(closure2256, var_statementToken);
  addtoclosure(closure2256, var_errormessages);
  addtoclosure(closure2256, var_lastToken);
  addtoclosure(closure2256, var_values);
  addtoclosure(closure2256, var_econd);
  addtoclosure(closure2256, var_ebody);
  addtoclosure(closure2256, var_btok);
  addtoclosure(closure2256, var_minIndentLevel);
  addtoclosure(closure2256, var_minInd);
  addtoclosure(closure2256, var_v);
  addtoclosure(closure2256, var_newelse);
  addtoclosure(closure2256, var_ast);
  addtoclosure(closure2256, var_eif);
  addtoclosure(closure2256, var_curelse);
  addtoclosure(closure2256, selfslot);
  struct UserObject *uo2256 = (struct UserObject*)block2255;
  uo2256->data[0] = (Object)closure2256;
  Method *meth_meth_parser__apply2256 = addmethod2pos(block2255, "_apply", &meth_parser__apply2256, 0);
int argcv_meth_parser__apply2256[] = {0};
meth_meth_parser__apply2256->type = alloc_MethodType(1, argcv_meth_parser__apply2256);
  meth_meth_parser__apply2256->definitionModule = modulename;
  meth_meth_parser__apply2256->definitionLine = 715;
// compilenode returning block2255
  gc_frame_newslot(block2255);
  params[0] = block2240;
  params[1] = block2255;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2874 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2239);
// compilenode returning call2874
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 878
  setline(878);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2878 == NULL) {
    strlit2878 = alloc_String("else");
    gc_root(strlit2878);
  }
// compilenode returning strlit2878
  int op_slot_right_2877 = gc_frame_newslot(strlit2878);
  int callframe2880 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2881 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe2880);
// compilenode returning call2881
// compilenode returning call2881
  int op_slot_left_2877 = gc_frame_newslot(call2881);
  params[0] = strlit2878;
  partcv[0] = 1;
  Object opresult2882 = callmethod(call2881, "==", 1, partcv, params);
// compilenode returning opresult2882
  int op_slot_right_2876 = gc_frame_newslot(opresult2882);
  int callframe2884 = gc_frame_new();
  if (strlit2885 == NULL) {
    strlit2885 = alloc_String("identifier");
    gc_root(strlit2885);
  }
// compilenode returning strlit2885
  gc_frame_newslot(strlit2885);
  params[0] = strlit2885;
  partcv[0] = 1;
  Object call2886 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2884);
// compilenode returning call2886
  int op_slot_left_2876 = gc_frame_newslot(call2886);
  params[0] = opresult2882;
  partcv[0] = 1;
  Object opresult2887 = callmethod(call2886, "&&", 1, partcv, params);
// compilenode returning opresult2887
  Object if2875 = done;
  if (istrue(opresult2887)) {
// Begin line 879
  setline(879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2888 = gc_frame_new();
  partcv[0] = 0;
  Object call2889 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2888);
// compilenode returning call2889
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit2892 == NULL) {
    strlit2892 = alloc_String("lbrace");
    gc_root(strlit2892);
  }
// compilenode returning strlit2892
  int op_slot_right_2891 = gc_frame_newslot(strlit2892);
  int callframe2894 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2895 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe2894);
// compilenode returning call2895
// compilenode returning call2895
  int op_slot_left_2891 = gc_frame_newslot(call2895);
  params[0] = strlit2892;
  partcv[0] = 1;
  Object opresult2896 = callmethod(call2895, "!=", 1, partcv, params);
// compilenode returning opresult2896
  Object if2890 = done;
  if (istrue(opresult2896)) {
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 881
  setline(881);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2897 = gc_frame_new();
  int callframe2898 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call2899 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe2898);
// compilenode returning call2899
// compilenode returning call2899
  partcv[0] = 0;
  Object call2900 = callmethod(call2899, "new",
    1, partcv, params);
  gc_frame_end(callframe2897);
// compilenode returning call2900
// compilenode returning call2900
  *var_suggestion = call2900;
  if (call2900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2901 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool2902 = alloc_Boolean(1);
// compilenode returning bool2902
  gc_frame_newslot(bool2902);
  params[0] = *var_btok;
  params[1] = bool2902;
  partcv[0] = 2;
  Object call2903 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2901);
// compilenode returning call2903
  *var_closingBrace = call2903;
  if (call2903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool2906 = alloc_Boolean(0);
// compilenode returning bool2906
  int op_slot_right_2905 = gc_frame_newslot(bool2906);
  int callframe2908 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2909 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe2908);
// compilenode returning call2909
// compilenode returning call2909
  int op_slot_left_2905 = gc_frame_newslot(call2909);
  params[0] = bool2906;
  partcv[0] = 1;
  Object opresult2910 = callmethod(call2909, "==", 1, partcv, params);
// compilenode returning opresult2910
  Object if2904 = done;
  if (istrue(opresult2910)) {
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 884
  setline(884);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_2912 = gc_frame_newslot(*var_lastToken);
  int callframe2914 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2915 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2914);
// compilenode returning call2915
// compilenode returning call2915
  int op_slot_left_2912 = gc_frame_newslot(call2915);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult2916 = callmethod(call2915, "==", 1, partcv, params);
// compilenode returning opresult2916
  Object if2911 = done;
  if (istrue(opresult2916)) {
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2917 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2918 = alloc_Boolean(0);
// compilenode returning bool2918
  gc_frame_newslot(bool2918);
  Object bool2919 = alloc_Boolean(1);
// compilenode returning bool2919
  gc_frame_newslot(bool2919);
  if (strlit2920 == NULL) {
    strlit2920 = alloc_String("else {}");
    gc_root(strlit2920);
  }
// compilenode returning strlit2920
  gc_frame_newslot(strlit2920);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2918;
  params[2] = bool2919;
  params[3] = strlit2920;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2921 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2917);
// compilenode returning call2921
    gc_frame_newslot(call2921);
    if2911 = call2921;
  } else {
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2922 = gc_frame_new();
  Object num2924 = alloc_Float64(0.1);
// compilenode returning num2924
  int op_slot_right_2923 = gc_frame_newslot(num2924);
  int callframe2926 = gc_frame_new();
  int callframe2927 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call2928 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe2927);
// compilenode returning call2928
// compilenode returning call2928
  partcv[0] = 0;
  Object call2929 = callmethod(call2928, "line",
    1, partcv, params);
  gc_frame_end(callframe2926);
// compilenode returning call2929
// compilenode returning call2929
  int op_slot_left_2923 = gc_frame_newslot(call2929);
  params[0] = num2924;
  partcv[0] = 1;
  Object sum2930 = callmethod(call2929, "+", 1, partcv, params);
// compilenode returning sum2930
  gc_frame_newslot(sum2930);
  if (strlit2931 == NULL) {
    strlit2931 = alloc_String("}");
    gc_root(strlit2931);
  }
// compilenode returning strlit2931
  gc_frame_newslot(strlit2931);
// compilenode returning *var_suggestion
  params[0] = sum2930;
  params[1] = strlit2931;
  partcv[0] = 2;
  Object call2932 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe2922);
// compilenode returning call2932
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2933 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2934 = alloc_Boolean(0);
// compilenode returning bool2934
  gc_frame_newslot(bool2934);
  Object bool2935 = alloc_Boolean(1);
// compilenode returning bool2935
  gc_frame_newslot(bool2935);
  if (strlit2936 == NULL) {
    strlit2936 = alloc_String("else {");
    gc_root(strlit2936);
  }
// compilenode returning strlit2936
  gc_frame_newslot(strlit2936);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2934;
  params[2] = bool2935;
  params[3] = strlit2936;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2937 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2933);
// compilenode returning call2937
    gc_frame_newslot(call2937);
    if2911 = call2937;
  }
// compilenode returning if2911
    gc_frame_newslot(if2911);
    if2904 = if2911;
  } else {
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2938 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool2939 = alloc_Boolean(0);
// compilenode returning bool2939
  gc_frame_newslot(bool2939);
  Object bool2940 = alloc_Boolean(1);
// compilenode returning bool2940
  gc_frame_newslot(bool2940);
  if (strlit2941 == NULL) {
    strlit2941 = alloc_String("else {");
    gc_root(strlit2941);
  }
// compilenode returning strlit2941
  gc_frame_newslot(strlit2941);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool2939;
  params[2] = bool2940;
  params[3] = strlit2941;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call2942 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe2938);
// compilenode returning call2942
    gc_frame_newslot(call2942);
    if2904 = call2942;
  }
// compilenode returning if2904
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2943 = gc_frame_new();
  if (strlit2944 == NULL) {
    strlit2944 = alloc_String("An else statement must have a '{' after the 'else'.");
    gc_root(strlit2944);
  }
// compilenode returning strlit2944
  gc_frame_newslot(strlit2944);
// Begin line 894
  setline(894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2945 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2946 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2945);
// compilenode returning call2946
// compilenode returning call2946
  gc_frame_newslot(call2946);
  int callframe2948 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2949 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe2948);
// compilenode returning call2949
// compilenode returning call2949
  int op_slot_right_2947 = gc_frame_newslot(call2949);
  int callframe2951 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2952 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2951);
// compilenode returning call2952
// compilenode returning call2952
  int op_slot_left_2947 = gc_frame_newslot(call2952);
  params[0] = call2949;
  partcv[0] = 1;
  Object sum2953 = callmethod(call2952, "+", 1, partcv, params);
// compilenode returning sum2953
  gc_frame_newslot(sum2953);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 893
  setline(893);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit2944;
  params[1] = call2946;
  params[2] = sum2953;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call2954 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe2943);
// compilenode returning call2954
    gc_frame_newslot(call2954);
    if2890 = call2954;
  } else {
  }
// compilenode returning if2890
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2955 = gc_frame_new();
  partcv[0] = 0;
  Object call2956 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2955);
// compilenode returning call2956
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2959 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call2960 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe2959);
// compilenode returning call2960
// compilenode returning call2960
  int op_slot_right_2958 = gc_frame_newslot(call2960);
  int callframe2962 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2963 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe2962);
// compilenode returning call2963
// compilenode returning call2963
  int op_slot_left_2958 = gc_frame_newslot(call2963);
  params[0] = call2960;
  partcv[0] = 1;
  Object opresult2964 = callmethod(call2963, "==", 1, partcv, params);
// compilenode returning opresult2964
  Object if2957 = done;
  if (istrue(opresult2964)) {
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num2966 = alloc_Float64(1);
// compilenode returning num2966
  int op_slot_right_2965 = gc_frame_newslot(num2966);
  int callframe2968 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call2969 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe2968);
// compilenode returning call2969
// compilenode returning call2969
  int op_slot_left_2965 = gc_frame_newslot(call2969);
  params[0] = num2966;
  partcv[0] = 1;
  Object diff2970 = callmethod(call2969, "-", 1, partcv, params);
// compilenode returning diff2970
  *var_minIndentLevel = diff2970;
  if (diff2970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2957 = done;
  } else {
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 902
  setline(902);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minInd
  *var_minIndentLevel = *var_minInd;
  if (*var_minInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if2957 = done;
  }
// compilenode returning if2957
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe2973 = gc_frame_new();
  Object block2974 = alloc_Block(NULL, NULL, "parser", 904);
  gc_frame_newslot(block2974);
  block_savedest(block2974);
  Object closure2975 = createclosure(1, "_apply");
setclosureframe(closure2975, stackframe);
  addtoclosure(closure2975, selfslot);
  struct UserObject *uo2975 = (struct UserObject*)block2974;
  uo2975->data[0] = (Object)closure2975;
  Method *meth_meth_parser__apply2975 = addmethod2pos(block2974, "_apply", &meth_parser__apply2975, 0);
int argcv_meth_parser__apply2975[] = {0};
meth_meth_parser__apply2975->type = alloc_MethodType(1, argcv_meth_parser__apply2975);
  meth_meth_parser__apply2975->definitionModule = modulename;
  meth_meth_parser__apply2975->definitionLine = 900;
// compilenode returning block2974
  gc_frame_newslot(block2974);
  Object block2982 = alloc_Block(NULL, NULL, "parser", 904);
  gc_frame_newslot(block2982);
  block_savedest(block2982);
  Object closure2983 = createclosure(8, "_apply");
setclosureframe(closure2983, stackframe);
  addtoclosure(closure2983, var_errormessages);
  addtoclosure(closure2983, var_btok);
  addtoclosure(closure2983, var_lastToken);
  addtoclosure(closure2983, var_sym);
  addtoclosure(closure2983, var_values);
  addtoclosure(closure2983, var_v);
  addtoclosure(closure2983, var_curelse);
  addtoclosure(closure2983, selfslot);
  struct UserObject *uo2983 = (struct UserObject*)block2982;
  uo2983->data[0] = (Object)closure2983;
  Method *meth_meth_parser__apply2983 = addmethod2pos(block2982, "_apply", &meth_parser__apply2983, 0);
int argcv_meth_parser__apply2983[] = {0};
meth_meth_parser__apply2983->type = alloc_MethodType(1, argcv_meth_parser__apply2983);
  meth_meth_parser__apply2983->definitionModule = modulename;
  meth_meth_parser__apply2983->definitionLine = 904;
// compilenode returning block2982
  gc_frame_newslot(block2982);
  params[0] = block2974;
  params[1] = block2982;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3043 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2973);
// compilenode returning call3043
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3044 = gc_frame_new();
  partcv[0] = 0;
  Object call3045 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3044);
// compilenode returning call3045
    gc_frame_newslot(call3045);
    if2875 = call3045;
  } else {
  }
// compilenode returning if2875
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3046 = gc_frame_new();
// compilenode returning *var_cond
  gc_frame_newslot(*var_cond);
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
// compilenode returning *var_elseblock
  gc_frame_newslot(*var_elseblock);
  int callframe3047 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3048 = callmethod(*var_ast, "ifNode",
    1, partcv, params);
  gc_frame_end(callframe3047);
// compilenode returning call3048
// compilenode returning call3048
  params[0] = *var_cond;
  params[1] = *var_body;
  params[2] = *var_elseblock;
  partcv[0] = 3;
  Object call3049 = callmethod(call3048, "new",
    1, partcv, params);
  gc_frame_end(callframe3046);
// compilenode returning call3049
  *var_o = call3049;
  if (call3049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3050 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call3051 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3050);
// compilenode returning call3051
    gc_frame_newslot(call3051);
    if2068 = call3051;
  } else {
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 928
  setline(928);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3052 = gc_frame_new();
  int callframe3053 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3054 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3053);
// compilenode returning call3054
// compilenode returning call3054
  partcv[0] = 0;
  Object call3055 = callmethod(call3054, "new",
    1, partcv, params);
  gc_frame_end(callframe3052);
// compilenode returning call3055
// compilenode returning call3055
  *var_suggestion = call3055;
  if (call3055 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 929
  setline(929);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3058 == NULL) {
    strlit3058 = alloc_String("lbrace");
    gc_root(strlit3058);
  }
// compilenode returning strlit3058
  int op_slot_right_3057 = gc_frame_newslot(strlit3058);
  int callframe3060 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3061 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compilenode returning call3061
// compilenode returning call3061
  int op_slot_left_3057 = gc_frame_newslot(call3061);
  params[0] = strlit3058;
  partcv[0] = 1;
  Object opresult3062 = callmethod(call3061, "==", 1, partcv, params);
// compilenode returning opresult3062
  Object if3056 = done;
  if (istrue(opresult3062)) {
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3063 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool3064 = alloc_Boolean(0);
// compilenode returning bool3064
  gc_frame_newslot(bool3064);
  params[0] = *var_btok;
  params[1] = bool3064;
  partcv[0] = 2;
  Object call3065 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3063);
// compilenode returning call3065
  *var_closingBrace = call3065;
  if (call3065 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3068 = alloc_Boolean(0);
// compilenode returning bool3068
  int op_slot_right_3067 = gc_frame_newslot(bool3068);
  int callframe3070 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3071 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3070);
// compilenode returning call3071
// compilenode returning call3071
  int op_slot_left_3067 = gc_frame_newslot(call3071);
  params[0] = bool3068;
  partcv[0] = 1;
  Object opresult3072 = callmethod(call3071, "==", 1, partcv, params);
// compilenode returning opresult3072
  Object if3066 = done;
  if (istrue(opresult3072)) {
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3074 = gc_frame_newslot(*var_sym);
  int callframe3076 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3077 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3076);
// compilenode returning call3077
// compilenode returning call3077
  int op_slot_left_3074 = gc_frame_newslot(call3077);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3078 = callmethod(call3077, "==", 1, partcv, params);
// compilenode returning opresult3078
  Object if3073 = done;
  if (istrue(opresult3078)) {
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3079 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool3080 = alloc_Boolean(1);
// compilenode returning bool3080
  gc_frame_newslot(bool3080);
  Object bool3081 = alloc_Boolean(0);
// compilenode returning bool3081
  gc_frame_newslot(bool3081);
  if (strlit3082 == NULL) {
    strlit3082 = alloc_String(" then {}");
    gc_root(strlit3082);
  }
// compilenode returning strlit3082
  gc_frame_newslot(strlit3082);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool3080;
  params[2] = bool3081;
  params[3] = strlit3082;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3083 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3079);
// compilenode returning call3083
    gc_frame_newslot(call3083);
    if3073 = call3083;
  } else {
// Begin line 935
  setline(935);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3084 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool3085 = alloc_Boolean(1);
// compilenode returning bool3085
  gc_frame_newslot(bool3085);
  Object bool3086 = alloc_Boolean(0);
// compilenode returning bool3086
  gc_frame_newslot(bool3086);
  if (strlit3087 == NULL) {
    strlit3087 = alloc_String(" then {");
    gc_root(strlit3087);
  }
// compilenode returning strlit3087
  gc_frame_newslot(strlit3087);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool3085;
  params[2] = bool3086;
  params[3] = strlit3087;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3088 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3084);
// compilenode returning call3088
// Begin line 936
  setline(936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3089 = gc_frame_new();
  Object num3091 = alloc_Float64(0.1);
// compilenode returning num3091
  int op_slot_right_3090 = gc_frame_newslot(num3091);
  int callframe3093 = gc_frame_new();
  int callframe3094 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3095 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3094);
// compilenode returning call3095
// compilenode returning call3095
  partcv[0] = 0;
  Object call3096 = callmethod(call3095, "line",
    1, partcv, params);
  gc_frame_end(callframe3093);
// compilenode returning call3096
// compilenode returning call3096
  int op_slot_left_3090 = gc_frame_newslot(call3096);
  params[0] = num3091;
  partcv[0] = 1;
  Object sum3097 = callmethod(call3096, "+", 1, partcv, params);
// compilenode returning sum3097
  gc_frame_newslot(sum3097);
  if (strlit3098 == NULL) {
    strlit3098 = alloc_String("}");
    gc_root(strlit3098);
  }
// compilenode returning strlit3098
  gc_frame_newslot(strlit3098);
// compilenode returning *var_suggestion
  params[0] = sum3097;
  params[1] = strlit3098;
  partcv[0] = 2;
  Object call3099 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3089);
// compilenode returning call3099
    gc_frame_newslot(call3099);
    if3073 = call3099;
  }
// compilenode returning if3073
    gc_frame_newslot(if3073);
    if3066 = if3073;
  } else {
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3100 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool3101 = alloc_Boolean(1);
// compilenode returning bool3101
  gc_frame_newslot(bool3101);
  Object bool3102 = alloc_Boolean(0);
// compilenode returning bool3102
  gc_frame_newslot(bool3102);
  if (strlit3103 == NULL) {
    strlit3103 = alloc_String(" then {");
    gc_root(strlit3103);
  }
// compilenode returning strlit3103
  gc_frame_newslot(strlit3103);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool3101;
  params[2] = bool3102;
  params[3] = strlit3103;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3104 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3100);
// compilenode returning call3104
    gc_frame_newslot(call3104);
    if3066 = call3104;
  }
// compilenode returning if3066
    gc_frame_newslot(if3066);
    if3056 = if3066;
  } else {
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3105 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool3106 = alloc_Boolean(1);
// compilenode returning bool3106
  gc_frame_newslot(bool3106);
  params[0] = *var_btok;
  params[1] = bool3106;
  partcv[0] = 2;
  Object call3107 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3105);
// compilenode returning call3107
  *var_closingBrace = call3107;
  if (call3107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 953
  setline(953);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3110 = alloc_Boolean(0);
// compilenode returning bool3110
  int op_slot_right_3109 = gc_frame_newslot(bool3110);
  int callframe3112 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3113 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe3112);
// compilenode returning call3113
// compilenode returning call3113
  int op_slot_left_3109 = gc_frame_newslot(call3113);
  params[0] = bool3110;
  partcv[0] = 1;
  Object opresult3114 = callmethod(call3113, "==", 1, partcv, params);
// compilenode returning opresult3114
  Object if3108 = done;
  if (istrue(opresult3114)) {
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 944
  setline(944);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_3116 = gc_frame_newslot(*var_lastToken);
  int callframe3118 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3119 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3118);
// compilenode returning call3119
// compilenode returning call3119
  int op_slot_left_3116 = gc_frame_newslot(call3119);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult3120 = callmethod(call3119, "==", 1, partcv, params);
// compilenode returning opresult3120
  Object if3115 = done;
  if (istrue(opresult3120)) {
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3121 = gc_frame_new();
  if (strlit3122 == NULL) {
    strlit3122 = alloc_String(" then {}");
    gc_root(strlit3122);
  }
// compilenode returning strlit3122
  gc_frame_newslot(strlit3122);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3122;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3123 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3121);
// compilenode returning call3123
    gc_frame_newslot(call3123);
    if3115 = call3123;
  } else {
// Begin line 947
  setline(947);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3124 = gc_frame_new();
  if (strlit3125 == NULL) {
    strlit3125 = alloc_String(" then {");
    gc_root(strlit3125);
  }
// compilenode returning strlit3125
  gc_frame_newslot(strlit3125);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3125;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3126 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3124);
// compilenode returning call3126
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3127 = gc_frame_new();
  Object num3129 = alloc_Float64(0.1);
// compilenode returning num3129
  int op_slot_right_3128 = gc_frame_newslot(num3129);
  int callframe3131 = gc_frame_new();
  int callframe3132 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call3133 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe3132);
// compilenode returning call3133
// compilenode returning call3133
  partcv[0] = 0;
  Object call3134 = callmethod(call3133, "line",
    1, partcv, params);
  gc_frame_end(callframe3131);
// compilenode returning call3134
// compilenode returning call3134
  int op_slot_left_3128 = gc_frame_newslot(call3134);
  params[0] = num3129;
  partcv[0] = 1;
  Object sum3135 = callmethod(call3134, "+", 1, partcv, params);
// compilenode returning sum3135
  gc_frame_newslot(sum3135);
  if (strlit3136 == NULL) {
    strlit3136 = alloc_String("}");
    gc_root(strlit3136);
  }
// compilenode returning strlit3136
  gc_frame_newslot(strlit3136);
// compilenode returning *var_suggestion
  params[0] = sum3135;
  params[1] = strlit3136;
  partcv[0] = 2;
  Object call3137 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe3127);
// compilenode returning call3137
    gc_frame_newslot(call3137);
    if3115 = call3137;
  }
// compilenode returning if3115
    gc_frame_newslot(if3115);
    if3108 = if3115;
  } else {
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3138 = gc_frame_new();
  if (strlit3139 == NULL) {
    strlit3139 = alloc_String(" then {");
    gc_root(strlit3139);
  }
// compilenode returning strlit3139
  gc_frame_newslot(strlit3139);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3139;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3140 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3138);
// compilenode returning call3140
    gc_frame_newslot(call3140);
    if3108 = call3140;
  }
// compilenode returning if3108
    gc_frame_newslot(if3108);
    if3056 = if3108;
  }
// compilenode returning if3056
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3141 = gc_frame_new();
  if (strlit3142 == NULL) {
    strlit3142 = alloc_String("An if statement must have 'then' after the expression in parentheses.");
    gc_root(strlit3142);
  }
// compilenode returning strlit3142
  gc_frame_newslot(strlit3142);
// Begin line 955
  setline(955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3143 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3144 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3143);
// compilenode returning call3144
// compilenode returning call3144
  gc_frame_newslot(call3144);
  int callframe3145 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3146 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3145);
// compilenode returning call3146
// compilenode returning call3146
  gc_frame_newslot(call3146);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3142;
  params[1] = call3144;
  params[2] = call3146;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3147 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3141);
// compilenode returning call3147
    gc_frame_newslot(call3147);
    if2068 = call3147;
  }
// compilenode returning if2068
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localMin
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localStatementIndent
  *var_statementIndent = *var_localStatementIndent;
  if (*var_localStatementIndent == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if1777 = done;
  } else {
  }
// compilenode returning if1777
  gc_frame_end(frame);
  return if1777;
}
Object meth_parser_identifier3150(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "identifier");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for identifier (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for identifier");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3152 = gc_frame_new();
  if (strlit3153 == NULL) {
    strlit3153 = alloc_String("identifier");
    gc_root(strlit3153);
  }
// compilenode returning strlit3153
  gc_frame_newslot(strlit3153);
  params[0] = strlit3153;
  partcv[0] = 1;
  Object call3154 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3152);
// compilenode returning call3154
  Object if3151 = done;
  if (istrue(call3154)) {
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 966
  setline(966);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3157 == NULL) {
    strlit3157 = alloc_String("if");
    gc_root(strlit3157);
  }
// compilenode returning strlit3157
  int op_slot_right_3156 = gc_frame_newslot(strlit3157);
  int callframe3159 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3160 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3159);
// compilenode returning call3160
// compilenode returning call3160
  int op_slot_left_3156 = gc_frame_newslot(call3160);
  params[0] = strlit3157;
  partcv[0] = 1;
  Object opresult3161 = callmethod(call3160, "==", 1, partcv, params);
// compilenode returning opresult3161
  Object if3155 = done;
  if (istrue(opresult3161)) {
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3162 = gc_frame_new();
  partcv[0] = 0;
  Object call3163 = callmethodflags(self, "doif", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3162);
// compilenode returning call3163
    gc_frame_newslot(call3163);
    if3155 = call3163;
  } else {
// Begin line 969
  setline(969);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3164 = gc_frame_new();
  partcv[0] = 0;
  Object call3165 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3164);
// compilenode returning call3165
    gc_frame_newslot(call3165);
    if3155 = call3165;
  }
// compilenode returning if3155
    gc_frame_newslot(if3155);
    if3151 = if3155;
  } else {
  }
// compilenode returning if3151
  gc_frame_end(frame);
  return if3151;
}
Object meth_parser__apply3185(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3186 = gc_frame_new();
  partcv[0] = 0;
  Object call3187 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3186);
// compilenode returning call3187
  gc_frame_end(frame);
  return call3187;
}
Object meth_parser__apply3253(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3254 = gc_frame_new();
  partcv[0] = 0;
  Object call3255 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3254);
// compilenode returning call3255
  gc_frame_end(frame);
  return call3255;
}
Object meth_parser_prefixop3166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "prefixop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for prefixop (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for prefixop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_op = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "op");
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_suggestions = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestions");
  Object *var_mem = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "mem");
  Object *var_call = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "call");
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3168 = gc_frame_new();
  if (strlit3169 == NULL) {
    strlit3169 = alloc_String("op");
    gc_root(strlit3169);
  }
// compilenode returning strlit3169
  gc_frame_newslot(strlit3169);
  params[0] = strlit3169;
  partcv[0] = 1;
  Object call3170 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3168);
// compilenode returning call3170
  Object if3167 = done;
  if (istrue(call3170)) {
// Begin line 977
  setline(977);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3171 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3172 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3171);
// compilenode returning call3172
// compilenode returning call3172
  *var_op = call3172;
  if (call3172 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 978
  setline(978);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_val = undefined;
// compilenode returning done
  int callframe3173 = gc_frame_new();
  partcv[0] = 0;
  Object call3174 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3173);
// compilenode returning call3174
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3176 = gc_frame_new();
  if (strlit3177 == NULL) {
    strlit3177 = alloc_String("lparen");
    gc_root(strlit3177);
  }
// compilenode returning strlit3177
  gc_frame_newslot(strlit3177);
  params[0] = strlit3177;
  partcv[0] = 1;
  Object call3178 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3176);
// compilenode returning call3178
  Object if3175 = done;
  if (istrue(call3178)) {
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3179 = gc_frame_new();
  partcv[0] = 0;
  Object call3180 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3179);
// compilenode returning call3180
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3182 = gc_frame_new();
  int callframe3183 = gc_frame_new();
  Object block3184 = alloc_Block(NULL, NULL, "parser", 981);
  gc_frame_newslot(block3184);
  block_savedest(block3184);
  Object closure3185 = createclosure(1, "_apply");
setclosureframe(closure3185, stackframe);
  addtoclosure(closure3185, selfslot);
  struct UserObject *uo3185 = (struct UserObject*)block3184;
  uo3185->data[0] = (Object)closure3185;
  Method *meth_meth_parser__apply3185 = addmethod2pos(block3184, "_apply", &meth_parser__apply3185, 0);
int argcv_meth_parser__apply3185[] = {0};
meth_meth_parser__apply3185->type = alloc_MethodType(1, argcv_meth_parser__apply3185);
  meth_meth_parser__apply3185->definitionModule = modulename;
  meth_meth_parser__apply3185->definitionLine = 981;
// compilenode returning block3184
  gc_frame_newslot(block3184);
  params[0] = block3184;
  partcv[0] = 1;
  Object call3189 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3183);
// compilenode returning call3189
  partcv[0] = 0;
  Object call3190 = callmethod(call3189, "not",
    1, partcv, params);
  gc_frame_end(callframe3182);
// compilenode returning call3190
// compilenode returning call3190
  Object if3181 = done;
  if (istrue(call3190)) {
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 982
  setline(982);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3191 = gc_frame_new();
  int callframe3192 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3193 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3192);
// compilenode returning call3193
// compilenode returning call3193
  partcv[0] = 0;
  Object call3194 = callmethod(call3193, "new",
    1, partcv, params);
  gc_frame_end(callframe3191);
// compilenode returning call3194
// compilenode returning call3194
  *var_suggestion = call3194;
  if (call3194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3195 = gc_frame_new();
  if (strlit3196 == NULL) {
    strlit3196 = alloc_String("rparen");
    gc_root(strlit3196);
  }
// compilenode returning strlit3196
  gc_frame_newslot(strlit3196);
  params[0] = strlit3196;
  partcv[0] = 1;
  Object call3197 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3195);
// compilenode returning call3197
  *var_nextTok = call3197;
  if (call3197 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3199 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3199 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3201 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3201
  Object if3198 = done;
  if (istrue(opresult3201)) {
// Begin line 985
  setline(985);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3202 = gc_frame_new();
  if (strlit3203 == NULL) {
    strlit3203 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3203);
  }
// compilenode returning strlit3203
  gc_frame_newslot(strlit3203);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3203;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3204 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3202);
// compilenode returning call3204
    gc_frame_newslot(call3204);
    if3198 = call3204;
  } else {
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3205 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe3206 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3207 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3206);
// compilenode returning call3207
// compilenode returning call3207
  gc_frame_newslot(call3207);
  Object bool3208 = alloc_Boolean(1);
// compilenode returning bool3208
  gc_frame_newslot(bool3208);
  Object bool3209 = alloc_Boolean(0);
// compilenode returning bool3209
  gc_frame_newslot(bool3209);
  if (strlit3210 == NULL) {
    strlit3210 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3210);
  }
// compilenode returning strlit3210
  gc_frame_newslot(strlit3210);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call3207;
  params[2] = bool3208;
  params[3] = bool3209;
  params[4] = strlit3210;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3211 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3205);
// compilenode returning call3211
    gc_frame_newslot(call3211);
    if3198 = call3211;
  }
// compilenode returning if3198
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3212 = gc_frame_new();
  if (strlit3213 == NULL) {
    strlit3213 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit3213);
  }
// compilenode returning strlit3213
  gc_frame_newslot(strlit3213);
// Begin line 990
  setline(990);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3214 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3215 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3214);
// compilenode returning call3215
// compilenode returning call3215
  gc_frame_newslot(call3215);
  int callframe3216 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3217 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3216);
// compilenode returning call3217
// compilenode returning call3217
  gc_frame_newslot(call3217);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 989
  setline(989);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3213;
  params[1] = call3215;
  params[2] = call3217;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3218 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3212);
// compilenode returning call3218
    gc_frame_newslot(call3218);
    if3181 = call3218;
  } else {
  }
// compilenode returning if3181
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 992
  setline(992);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3221 == NULL) {
    strlit3221 = alloc_String("rparen");
    gc_root(strlit3221);
  }
// compilenode returning strlit3221
  int op_slot_right_3220 = gc_frame_newslot(strlit3221);
  int callframe3223 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3224 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3223);
// compilenode returning call3224
// compilenode returning call3224
  int op_slot_left_3220 = gc_frame_newslot(call3224);
  params[0] = strlit3221;
  partcv[0] = 1;
  Object opresult3225 = callmethod(call3224, "!=", 1, partcv, params);
// compilenode returning opresult3225
  Object if3219 = done;
  if (istrue(opresult3225)) {
// Begin line 993
  setline(993);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3226 = gc_frame_new();
  partcv[0] = 0;
  Object call3227 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3226);
// compilenode returning call3227
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3228 = gc_frame_new();
  int callframe3229 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3230 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3229);
// compilenode returning call3230
// compilenode returning call3230
  partcv[0] = 0;
  Object call3231 = callmethod(call3230, "new",
    1, partcv, params);
  gc_frame_end(callframe3228);
// compilenode returning call3231
// compilenode returning call3231
  *var_suggestion = call3231;
  if (call3231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3232 = gc_frame_new();
  if (strlit3233 == NULL) {
    strlit3233 = alloc_String(")");
    gc_root(strlit3233);
  }
// compilenode returning strlit3233
  gc_frame_newslot(strlit3233);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3233;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3234 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3232);
// compilenode returning call3234
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3235 = gc_frame_new();
  if (strlit3236 == NULL) {
    strlit3236 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3236);
  }
// compilenode returning strlit3236
  gc_frame_newslot(strlit3236);
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3237 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3238 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3237);
// compilenode returning call3238
// compilenode returning call3238
  gc_frame_newslot(call3238);
  int callframe3240 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3241 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3240);
// compilenode returning call3241
// compilenode returning call3241
  int op_slot_right_3239 = gc_frame_newslot(call3241);
  int callframe3243 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3244 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3243);
// compilenode returning call3244
// compilenode returning call3244
  int op_slot_left_3239 = gc_frame_newslot(call3244);
  params[0] = call3241;
  partcv[0] = 1;
  Object sum3245 = callmethod(call3244, "+", 1, partcv, params);
// compilenode returning sum3245
  gc_frame_newslot(sum3245);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3236;
  params[1] = call3238;
  params[2] = sum3245;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3246 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3235);
// compilenode returning call3246
    gc_frame_newslot(call3246);
    if3219 = call3246;
  } else {
  }
// compilenode returning if3219
// Begin line 999
  setline(999);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3247 = gc_frame_new();
  partcv[0] = 0;
  Object call3248 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3247);
// compilenode returning call3248
    gc_frame_newslot(call3248);
    if3175 = call3248;
  } else {
// Begin line 1020
  setline(1020);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3250 = gc_frame_new();
  int callframe3251 = gc_frame_new();
  Object block3252 = alloc_Block(NULL, NULL, "parser", 1001);
  gc_frame_newslot(block3252);
  block_savedest(block3252);
  Object closure3253 = createclosure(1, "_apply");
setclosureframe(closure3253, stackframe);
  addtoclosure(closure3253, selfslot);
  struct UserObject *uo3253 = (struct UserObject*)block3252;
  uo3253->data[0] = (Object)closure3253;
  Method *meth_meth_parser__apply3253 = addmethod2pos(block3252, "_apply", &meth_parser__apply3253, 0);
int argcv_meth_parser__apply3253[] = {0};
meth_meth_parser__apply3253->type = alloc_MethodType(1, argcv_meth_parser__apply3253);
  meth_meth_parser__apply3253->definitionModule = modulename;
  meth_meth_parser__apply3253->definitionLine = 1001;
// compilenode returning block3252
  gc_frame_newslot(block3252);
  params[0] = block3252;
  partcv[0] = 1;
  Object call3257 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3251);
// compilenode returning call3257
  partcv[0] = 0;
  Object call3258 = callmethod(call3257, "not",
    1, partcv, params);
  gc_frame_end(callframe3250);
// compilenode returning call3258
// compilenode returning call3258
  Object if3249 = done;
  if (istrue(call3258)) {
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1002
  setline(1002);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3259 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3259
  *var_suggestions = array3259;
  if (array3259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1003
  setline(1003);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3260 = gc_frame_new();
  int callframe3261 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3262 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3261);
// compilenode returning call3262
// compilenode returning call3262
  partcv[0] = 0;
  Object call3263 = callmethod(call3262, "new",
    1, partcv, params);
  gc_frame_end(callframe3260);
// compilenode returning call3263
// compilenode returning call3263
  *var_suggestion = call3263;
  if (call3263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1004
  setline(1004);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3264 = gc_frame_new();
  if (strlit3265 == NULL) {
    strlit3265 = alloc_String("rparen");
    gc_root(strlit3265);
  }
// compilenode returning strlit3265
  gc_frame_newslot(strlit3265);
  params[0] = strlit3265;
  partcv[0] = 1;
  Object call3266 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3264);
// compilenode returning call3266
  *var_nextTok = call3266;
  if (call3266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3268 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3268 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3270 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3270
  Object if3267 = done;
  if (istrue(opresult3270)) {
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3271 = gc_frame_new();
  if (strlit3272 == NULL) {
    strlit3272 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3272);
  }
// compilenode returning strlit3272
  gc_frame_newslot(strlit3272);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3272;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3273 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3271);
// compilenode returning call3273
    gc_frame_newslot(call3273);
    if3267 = call3273;
  } else {
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3274 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe3275 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3276 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3275);
// compilenode returning call3276
// compilenode returning call3276
  gc_frame_newslot(call3276);
  Object bool3277 = alloc_Boolean(1);
// compilenode returning bool3277
  gc_frame_newslot(bool3277);
  Object bool3278 = alloc_Boolean(0);
// compilenode returning bool3278
  gc_frame_newslot(bool3278);
  if (strlit3279 == NULL) {
    strlit3279 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3279);
  }
// compilenode returning strlit3279
  gc_frame_newslot(strlit3279);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call3276;
  params[2] = bool3277;
  params[3] = bool3278;
  params[4] = strlit3279;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3280 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3274);
// compilenode returning call3280
    gc_frame_newslot(call3280);
    if3267 = call3280;
  }
// compilenode returning if3267
// Begin line 1010
  setline(1010);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3281 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3282 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3281);
// compilenode returning call3282
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1011
  setline(1011);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3285 == NULL) {
    strlit3285 = alloc_String("bind");
    gc_root(strlit3285);
  }
// compilenode returning strlit3285
  int op_slot_right_3284 = gc_frame_newslot(strlit3285);
  int callframe3287 = gc_frame_new();
  int callframe3288 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3289 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3288);
// compilenode returning call3289
// compilenode returning call3289
  partcv[0] = 0;
  Object call3290 = callmethod(call3289, "kind",
    1, partcv, params);
  gc_frame_end(callframe3287);
// compilenode returning call3290
// compilenode returning call3290
  int op_slot_left_3284 = gc_frame_newslot(call3290);
  params[0] = strlit3285;
  partcv[0] = 1;
  Object opresult3291 = callmethod(call3290, "==", 1, partcv, params);
// compilenode returning opresult3291
  Object if3283 = done;
  if (istrue(opresult3291)) {
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1012
  setline(1012);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3292 = gc_frame_new();
  int callframe3293 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3294 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3293);
// compilenode returning call3294
// compilenode returning call3294
  partcv[0] = 0;
  Object call3295 = callmethod(call3294, "new",
    1, partcv, params);
  gc_frame_end(callframe3292);
// compilenode returning call3295
// compilenode returning call3295
  *var_suggestion = call3295;
  if (call3295 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3297 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe3298 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3299 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3298);
// compilenode returning call3299
// compilenode returning call3299
  gc_frame_newslot(call3299);
  Object bool3300 = alloc_Boolean(1);
// compilenode returning bool3300
  gc_frame_newslot(bool3300);
  Object bool3301 = alloc_Boolean(0);
// compilenode returning bool3301
  gc_frame_newslot(bool3301);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call3299;
  params[2] = bool3300;
  params[3] = bool3301;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3302 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3297);
// compilenode returning call3302
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3303 = gc_frame_new();
  int callframe3304 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3305 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe3304);
// compilenode returning call3305
// compilenode returning call3305
  gc_frame_newslot(call3305);
  Object bool3306 = alloc_Boolean(1);
// compilenode returning bool3306
  gc_frame_newslot(bool3306);
  Object bool3307 = alloc_Boolean(0);
// compilenode returning bool3307
  gc_frame_newslot(bool3307);
// compilenode returning *var_suggestion
  params[0] = call3305;
  params[1] = bool3306;
  params[2] = bool3307;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3308 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe3303);
// compilenode returning call3308
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3309 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3310 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3309);
// compilenode returning call3310
    gc_frame_newslot(call3310);
    if3283 = call3310;
  } else {
  }
// compilenode returning if3283
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3311 = gc_frame_new();
  if (strlit3312 == NULL) {
    strlit3312 = alloc_String("A prefix operator must be followed by an expression.");
    gc_root(strlit3312);
  }
// compilenode returning strlit3312
  gc_frame_newslot(strlit3312);
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3313 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3314 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3313);
// compilenode returning call3314
// compilenode returning call3314
  gc_frame_newslot(call3314);
  int callframe3316 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3317 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3316);
// compilenode returning call3317
// compilenode returning call3317
  int op_slot_right_3315 = gc_frame_newslot(call3317);
  int callframe3319 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3320 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3319);
// compilenode returning call3320
// compilenode returning call3320
  int op_slot_left_3315 = gc_frame_newslot(call3320);
  params[0] = call3317;
  partcv[0] = 1;
  Object sum3321 = callmethod(call3320, "+", 1, partcv, params);
// compilenode returning sum3321
  gc_frame_newslot(sum3321);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3312;
  params[1] = call3314;
  params[2] = sum3321;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3322 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3311);
// compilenode returning call3322
    gc_frame_newslot(call3322);
    if3249 = call3322;
  } else {
  }
// compilenode returning if3249
    gc_frame_newslot(if3249);
    if3175 = if3249;
  }
// compilenode returning if3175
// Begin line 1021
  setline(1021);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3323 = gc_frame_new();
  partcv[0] = 0;
  Object call3324 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3323);
// compilenode returning call3324
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3325 = gc_frame_new();
  partcv[0] = 0;
  Object call3326 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3325);
// compilenode returning call3326
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3327 = gc_frame_new();
  partcv[0] = 0;
  Object call3328 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3327);
// compilenode returning call3328
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1024
  setline(1024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3329 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3330 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3329);
// compilenode returning call3330
// compilenode returning call3330
  *var_val = call3330;
  if (call3330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1025
  setline(1025);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3332 = gc_frame_new();
// compilenode returning *var_op
  int op_slot_right_3333 = gc_frame_newslot(*var_op);
  if (strlit3335 == NULL) {
    strlit3335 = alloc_String("prefix");
    gc_root(strlit3335);
  }
// compilenode returning strlit3335
  int op_slot_left_3333 = gc_frame_newslot(strlit3335);
  params[0] = *var_op;
  partcv[0] = 1;
  Object opresult3336 = callmethod(strlit3335, "++", 1, partcv, params);
// compilenode returning opresult3336
  gc_frame_newslot(opresult3336);
// compilenode returning *var_val
  gc_frame_newslot(*var_val);
  int callframe3337 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3338 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3337);
// compilenode returning call3338
// compilenode returning call3338
  params[0] = opresult3336;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call3339 = callmethod(call3338, "new",
    1, partcv, params);
  gc_frame_end(callframe3332);
// compilenode returning call3339
  *var_mem = call3339;
  if (call3339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3340 = gc_frame_new();
// compilenode returning *var_mem
  gc_frame_newslot(*var_mem);
  Object array3341 = alloc_BuiltinList();
  gc_pause();
  int callframe3342 = gc_frame_new();
  int callframe3343 = gc_frame_new();
// compilenode returning *var_mem
  partcv[0] = 0;
  Object call3344 = callmethod(*var_mem, "value",
    1, partcv, params);
  gc_frame_end(callframe3343);
// compilenode returning call3344
// compilenode returning call3344
  gc_frame_newslot(call3344);
  int callframe3345 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3346 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe3345);
// compilenode returning call3346
// compilenode returning call3346
  params[0] = call3344;
  partcv[0] = 1;
  Object call3347 = callmethod(call3346, "new",
    1, partcv, params);
  gc_frame_end(callframe3342);
// compilenode returning call3347
  params[0] = call3347;
  partcv[0] = 1;
  callmethod(array3341, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array3341
  gc_frame_newslot(array3341);
  int callframe3348 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3349 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe3348);
// compilenode returning call3349
// compilenode returning call3349
  params[0] = *var_mem;
  params[1] = array3341;
  partcv[0] = 2;
  Object call3350 = callmethod(call3349, "new",
    1, partcv, params);
  gc_frame_end(callframe3340);
// compilenode returning call3350
  *var_call = call3350;
  if (call3350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3351 = gc_frame_new();
// compilenode returning *var_call
  gc_frame_newslot(*var_call);
// compilenode returning *var_values
  params[0] = *var_call;
  partcv[0] = 1;
  Object call3352 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3351);
// compilenode returning call3352
    gc_frame_newslot(call3352);
    if3167 = call3352;
  } else {
  }
// compilenode returning if3167
  gc_frame_end(frame);
  return if3167;
}
Object meth_parser__apply3365(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3366 = gc_frame_new();
  if (strlit3367 == NULL) {
    strlit3367 = alloc_String("identifier");
    gc_root(strlit3367);
  }
// compilenode returning strlit3367
  gc_frame_newslot(strlit3367);
  params[0] = strlit3367;
  partcv[0] = 1;
  Object call3368 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3366);
// compilenode returning call3368
  gc_frame_end(frame);
  return call3368;
}
Object meth_parser__apply3376(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3377 = gc_frame_new();
  if (strlit3378 == NULL) {
    strlit3378 = alloc_String("dot");
    gc_root(strlit3378);
  }
// compilenode returning strlit3378
  gc_frame_newslot(strlit3378);
  params[0] = strlit3378;
  partcv[0] = 1;
  Object call3379 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3377);
// compilenode returning call3379
  gc_frame_end(frame);
  return call3379;
}
Object meth_parser__apply3382(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_memberIn = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "memberIn");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_memberName = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "memberName");
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3383 = gc_frame_new();
  partcv[0] = 0;
  Object call3384 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3383);
// compilenode returning call3384
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1041
  setline(1041);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3385 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3386 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3385);
// compilenode returning call3386
// compilenode returning call3386
  *var_memberIn = call3386;
  if (call3386 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1042
  setline(1042);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3389 == NULL) {
    strlit3389 = alloc_String("identifier");
    gc_root(strlit3389);
  }
// compilenode returning strlit3389
  int op_slot_right_3388 = gc_frame_newslot(strlit3389);
  int callframe3391 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3392 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3391);
// compilenode returning call3392
// compilenode returning call3392
  int op_slot_left_3388 = gc_frame_newslot(call3392);
  params[0] = strlit3389;
  partcv[0] = 1;
  Object opresult3393 = callmethod(call3392, "!=", 1, partcv, params);
// compilenode returning opresult3393
  Object if3387 = done;
  if (istrue(opresult3393)) {
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3394 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3394
  *var_suggestions = array3394;
  if (array3394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3395 = gc_frame_new();
  int callframe3396 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3397 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3396);
// compilenode returning call3397
// compilenode returning call3397
  partcv[0] = 0;
  Object call3398 = callmethod(call3397, "new",
    1, partcv, params);
  gc_frame_end(callframe3395);
// compilenode returning call3398
// compilenode returning call3398
  *var_suggestion = call3398;
  if (call3398 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3399 = gc_frame_new();
  if (strlit3400 == NULL) {
    strlit3400 = alloc_String("""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit3400);
  }
// compilenode returning strlit3400
  gc_frame_newslot(strlit3400);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3400;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3401 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3399);
// compilenode returning call3401
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3402 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3403 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3402);
// compilenode returning call3403
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3404 = gc_frame_new();
  int callframe3405 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3406 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3405);
// compilenode returning call3406
// compilenode returning call3406
  partcv[0] = 0;
  Object call3407 = callmethod(call3406, "new",
    1, partcv, params);
  gc_frame_end(callframe3404);
// compilenode returning call3407
// compilenode returning call3407
  *var_suggestion = call3407;
  if (call3407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3409 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3410 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe3409);
// compilenode returning call3410
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3411 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3412 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3411);
// compilenode returning call3412
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3413 = gc_frame_new();
  if (strlit3414 == NULL) {
    strlit3414 = alloc_String("A type name must follow the '.'.");
    gc_root(strlit3414);
  }
// compilenode returning strlit3414
  gc_frame_newslot(strlit3414);
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3415 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3416 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3415);
// compilenode returning call3416
// compilenode returning call3416
  gc_frame_newslot(call3416);
  Object num3418 = alloc_Float64(1);
// compilenode returning num3418
  int op_slot_right_3417 = gc_frame_newslot(num3418);
  int callframe3420 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3421 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3420);
// compilenode returning call3421
// compilenode returning call3421
  int op_slot_left_3417 = gc_frame_newslot(call3421);
  params[0] = num3418;
  partcv[0] = 1;
  Object sum3422 = callmethod(call3421, "+", 1, partcv, params);
// compilenode returning sum3422
  gc_frame_newslot(sum3422);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3414;
  params[1] = call3416;
  params[2] = sum3422;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3423 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3413);
// compilenode returning call3423
    gc_frame_newslot(call3423);
    if3387 = call3423;
  } else {
  }
// compilenode returning if3387
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3424 = gc_frame_new();
  partcv[0] = 0;
  Object call3425 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3424);
// compilenode returning call3425
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1054
  setline(1054);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3426 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3427 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3426);
// compilenode returning call3427
// compilenode returning call3427
  *var_memberName = call3427;
  if (call3427 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1055
  setline(1055);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3428 = gc_frame_new();
  int callframe3429 = gc_frame_new();
  int callframe3430 = gc_frame_new();
// compilenode returning *var_memberName
  partcv[0] = 0;
  Object call3431 = callmethod(*var_memberName, "value",
    1, partcv, params);
  gc_frame_end(callframe3430);
// compilenode returning call3431
// compilenode returning call3431
  gc_frame_newslot(call3431);
// compilenode returning *var_memberIn
  gc_frame_newslot(*var_memberIn);
  int callframe3432 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3433 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe3432);
// compilenode returning call3433
// compilenode returning call3433
  params[0] = call3431;
  params[1] = *var_memberIn;
  partcv[0] = 2;
  Object call3434 = callmethod(call3433, "new",
    1, partcv, params);
  gc_frame_end(callframe3429);
// compilenode returning call3434
  gc_frame_newslot(call3434);
// compilenode returning *var_values
  params[0] = call3434;
  partcv[0] = 1;
  Object call3435 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3428);
// compilenode returning call3435
  gc_frame_end(frame);
  return call3435;
}
Object meth_parser__apply3371(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_gens = getfromclosure(closure, 5);
  Object *var_startToken = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3372 = gc_frame_new();
  partcv[0] = 0;
  Object call3373 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3372);
// compilenode returning call3373
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3374 = gc_frame_new();
  Object block3375 = alloc_Block(NULL, NULL, "parser", 1039);
  gc_frame_newslot(block3375);
  block_savedest(block3375);
  Object closure3376 = createclosure(1, "_apply");
setclosureframe(closure3376, stackframe);
  addtoclosure(closure3376, selfslot);
  struct UserObject *uo3376 = (struct UserObject*)block3375;
  uo3376->data[0] = (Object)closure3376;
  Method *meth_meth_parser__apply3376 = addmethod2pos(block3375, "_apply", &meth_parser__apply3376, 0);
int argcv_meth_parser__apply3376[] = {0};
meth_meth_parser__apply3376->type = alloc_MethodType(1, argcv_meth_parser__apply3376);
  meth_meth_parser__apply3376->definitionModule = modulename;
  meth_meth_parser__apply3376->definitionLine = 1033;
// compilenode returning block3375
  gc_frame_newslot(block3375);
  Object block3381 = alloc_Block(NULL, NULL, "parser", 1039);
  gc_frame_newslot(block3381);
  block_savedest(block3381);
  Object closure3382 = createclosure(6, "_apply");
setclosureframe(closure3382, stackframe);
  addtoclosure(closure3382, var_values);
  addtoclosure(closure3382, var_sym);
  addtoclosure(closure3382, var_errormessages);
  addtoclosure(closure3382, var_lastToken);
  addtoclosure(closure3382, var_ast);
  addtoclosure(closure3382, selfslot);
  struct UserObject *uo3382 = (struct UserObject*)block3381;
  uo3382->data[0] = (Object)closure3382;
  Method *meth_meth_parser__apply3382 = addmethod2pos(block3381, "_apply", &meth_parser__apply3382, 0);
int argcv_meth_parser__apply3382[] = {0};
meth_meth_parser__apply3382->type = alloc_MethodType(1, argcv_meth_parser__apply3382);
  meth_meth_parser__apply3382->definitionModule = modulename;
  meth_meth_parser__apply3382->definitionLine = 1033;
// compilenode returning block3381
  gc_frame_newslot(block3381);
  params[0] = block3375;
  params[1] = block3381;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3437 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3374);
// compilenode returning call3437
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3438 = gc_frame_new();
  partcv[0] = 0;
  Object call3439 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3438);
// compilenode returning call3439
// Begin line 1058
  setline(1058);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3440 = gc_frame_new();
  int callframe3441 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3442 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3441);
// compilenode returning call3442
// compilenode returning call3442
  gc_frame_newslot(call3442);
// compilenode returning *var_gens
  params[0] = call3442;
  partcv[0] = 1;
  Object call3443 = callmethod(*var_gens, "push",
    1, partcv, params);
  gc_frame_end(callframe3440);
// compilenode returning call3443
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1059
  setline(1059);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3445 = gc_frame_new();
  if (strlit3446 == NULL) {
    strlit3446 = alloc_String("comma");
    gc_root(strlit3446);
  }
// compilenode returning strlit3446
  gc_frame_newslot(strlit3446);
  params[0] = strlit3446;
  partcv[0] = 1;
  Object call3447 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3445);
// compilenode returning call3447
  Object if3444 = done;
  if (istrue(call3447)) {
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3448 = gc_frame_new();
  partcv[0] = 0;
  Object call3449 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3448);
// compilenode returning call3449
    gc_frame_newslot(call3449);
    if3444 = call3449;
  } else {
// Begin line 1072
  setline(1072);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3452 == NULL) {
    strlit3452 = alloc_String("rgeneric");
    gc_root(strlit3452);
  }
// compilenode returning strlit3452
  int op_slot_right_3451 = gc_frame_newslot(strlit3452);
  int callframe3454 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3455 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3454);
// compilenode returning call3455
// compilenode returning call3455
  int op_slot_left_3451 = gc_frame_newslot(call3455);
  params[0] = strlit3452;
  partcv[0] = 1;
  Object opresult3456 = callmethod(call3455, "!=", 1, partcv, params);
// compilenode returning opresult3456
  Object if3450 = done;
  if (istrue(opresult3456)) {
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3457 = gc_frame_new();
  int callframe3458 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3459 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3458);
// compilenode returning call3459
// compilenode returning call3459
  partcv[0] = 0;
  Object call3460 = callmethod(call3459, "new",
    1, partcv, params);
  gc_frame_end(callframe3457);
// compilenode returning call3460
// compilenode returning call3460
  *var_suggestion = call3460;
  if (call3460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1064
  setline(1064);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3461 = gc_frame_new();
  if (strlit3462 == NULL) {
    strlit3462 = alloc_String(">");
    gc_root(strlit3462);
  }
// compilenode returning strlit3462
  gc_frame_newslot(strlit3462);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3462;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3463 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3461);
// compilenode returning call3463
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3464 = gc_frame_new();
  int callframe3465 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3466 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3465);
// compilenode returning call3466
// compilenode returning call3466
  partcv[0] = 0;
  Object call3467 = callmethod(call3466, "new",
    1, partcv, params);
  gc_frame_end(callframe3464);
// compilenode returning call3467
// compilenode returning call3467
  *var_suggestion2 = call3467;
  if (call3467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1066
  setline(1066);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3468 = gc_frame_new();
  if (strlit3469 == NULL) {
    strlit3469 = alloc_String(" ");
    gc_root(strlit3469);
  }
// compilenode returning strlit3469
  gc_frame_newslot(strlit3469);
// compilenode returning *var_startToken
  gc_frame_newslot(*var_startToken);
// compilenode returning *var_suggestion2
  params[0] = strlit3469;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3470 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3468);
// compilenode returning call3470
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1067
  setline(1067);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3471 = alloc_BuiltinList();
  gc_pause();
// compilenode returning *var_suggestion
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3471, "push", 1, partcv, params);
// compilenode returning *var_suggestion2
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3471, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array3471
  *var_suggestions = array3471;
  if (array3471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3472 = gc_frame_new();
  if (strlit3473 == NULL) {
    strlit3473 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3473);
  }
// compilenode returning strlit3473
  gc_frame_newslot(strlit3473);
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3474 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3475 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3474);
// compilenode returning call3475
// compilenode returning call3475
  gc_frame_newslot(call3475);
  int callframe3477 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3478 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3477);
// compilenode returning call3478
// compilenode returning call3478
  int op_slot_right_3476 = gc_frame_newslot(call3478);
  int callframe3480 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3481 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3480);
// compilenode returning call3481
// compilenode returning call3481
  int op_slot_left_3476 = gc_frame_newslot(call3481);
  params[0] = call3478;
  partcv[0] = 1;
  Object sum3482 = callmethod(call3481, "+", 1, partcv, params);
// compilenode returning sum3482
  gc_frame_newslot(sum3482);
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3473;
  params[1] = call3475;
  params[2] = sum3482;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3483 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3472);
// compilenode returning call3483
    gc_frame_newslot(call3483);
    if3450 = call3483;
  } else {
  }
// compilenode returning if3450
    gc_frame_newslot(if3450);
    if3444 = if3450;
  }
// compilenode returning if3444
  gc_frame_end(frame);
  return if3444;
}
Object meth_parser_generic3353(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "generic");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for generic (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for generic");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_id = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "id");
  Object *var_gens = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "gens");
  Object *var_startToken = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "startToken");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "suggestions");
// Begin line 1087
  setline(1087);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1032
  setline(1032);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3355 = gc_frame_new();
  if (strlit3356 == NULL) {
    strlit3356 = alloc_String("lgeneric");
    gc_root(strlit3356);
  }
// compilenode returning strlit3356
  gc_frame_newslot(strlit3356);
  params[0] = strlit3356;
  partcv[0] = 1;
  Object call3357 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3355);
// compilenode returning call3357
  Object if3354 = done;
  if (istrue(call3357)) {
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1033
  setline(1033);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3358 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3359 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3358);
// compilenode returning call3359
// compilenode returning call3359
  *var_id = call3359;
  if (call3359 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3360 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3360
  *var_gens = array3360;
  if (array3360 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1035
  setline(1035);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3361 = gc_frame_new();
  partcv[0] = 0;
  Object call3362 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3361);
// compilenode returning call3362
// Begin line 1037
  setline(1037);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3363 = gc_frame_new();
  Object block3364 = alloc_Block(NULL, NULL, "parser", 1037);
  gc_frame_newslot(block3364);
  block_savedest(block3364);
  Object closure3365 = createclosure(1, "_apply");
setclosureframe(closure3365, stackframe);
  addtoclosure(closure3365, selfslot);
  struct UserObject *uo3365 = (struct UserObject*)block3364;
  uo3365->data[0] = (Object)closure3365;
  Method *meth_meth_parser__apply3365 = addmethod2pos(block3364, "_apply", &meth_parser__apply3365, 0);
int argcv_meth_parser__apply3365[] = {0};
meth_meth_parser__apply3365->type = alloc_MethodType(1, argcv_meth_parser__apply3365);
  meth_meth_parser__apply3365->definitionModule = modulename;
  meth_meth_parser__apply3365->definitionLine = 1033;
// compilenode returning block3364
  gc_frame_newslot(block3364);
  Object block3370 = alloc_Block(NULL, NULL, "parser", 1037);
  gc_frame_newslot(block3370);
  block_savedest(block3370);
  Object closure3371 = createclosure(8, "_apply");
setclosureframe(closure3371, stackframe);
  addtoclosure(closure3371, var_values);
  addtoclosure(closure3371, var_sym);
  addtoclosure(closure3371, var_errormessages);
  addtoclosure(closure3371, var_lastToken);
  addtoclosure(closure3371, var_ast);
  addtoclosure(closure3371, var_gens);
  addtoclosure(closure3371, var_startToken);
  addtoclosure(closure3371, selfslot);
  struct UserObject *uo3371 = (struct UserObject*)block3370;
  uo3371->data[0] = (Object)closure3371;
  Method *meth_meth_parser__apply3371 = addmethod2pos(block3370, "_apply", &meth_parser__apply3371, 0);
int argcv_meth_parser__apply3371[] = {0};
meth_meth_parser__apply3371->type = alloc_MethodType(1, argcv_meth_parser__apply3371);
  meth_meth_parser__apply3371->definitionModule = modulename;
  meth_meth_parser__apply3371->definitionLine = 1033;
// compilenode returning block3370
  gc_frame_newslot(block3370);
  params[0] = block3364;
  params[1] = block3370;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3485 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3363);
// compilenode returning call3485
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1074
  setline(1074);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3488 == NULL) {
    strlit3488 = alloc_String("rgeneric");
    gc_root(strlit3488);
  }
// compilenode returning strlit3488
  int op_slot_right_3487 = gc_frame_newslot(strlit3488);
  int callframe3490 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3491 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3490);
// compilenode returning call3491
// compilenode returning call3491
  int op_slot_left_3487 = gc_frame_newslot(call3491);
  params[0] = strlit3488;
  partcv[0] = 1;
  Object opresult3492 = callmethod(call3491, "!=", 1, partcv, params);
// compilenode returning opresult3492
  Object if3486 = done;
  if (istrue(opresult3492)) {
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1075
  setline(1075);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3493 = gc_frame_new();
  int callframe3494 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3495 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3494);
// compilenode returning call3495
// compilenode returning call3495
  partcv[0] = 0;
  Object call3496 = callmethod(call3495, "new",
    1, partcv, params);
  gc_frame_end(callframe3493);
// compilenode returning call3496
// compilenode returning call3496
  *var_suggestion = call3496;
  if (call3496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3497 = gc_frame_new();
  if (strlit3498 == NULL) {
    strlit3498 = alloc_String(">");
    gc_root(strlit3498);
  }
// compilenode returning strlit3498
  gc_frame_newslot(strlit3498);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3498;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3499 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3497);
// compilenode returning call3499
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3500 = gc_frame_new();
  int callframe3501 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3502 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3501);
// compilenode returning call3502
// compilenode returning call3502
  partcv[0] = 0;
  Object call3503 = callmethod(call3502, "new",
    1, partcv, params);
  gc_frame_end(callframe3500);
// compilenode returning call3503
// compilenode returning call3503
  *var_suggestion2 = call3503;
  if (call3503 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1078
  setline(1078);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3504 = gc_frame_new();
  if (strlit3505 == NULL) {
    strlit3505 = alloc_String(" ");
    gc_root(strlit3505);
  }
// compilenode returning strlit3505
  gc_frame_newslot(strlit3505);
// compilenode returning *var_startToken
  gc_frame_newslot(*var_startToken);
// compilenode returning *var_suggestion2
  params[0] = strlit3505;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3506 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3504);
// compilenode returning call3506
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1079
  setline(1079);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3507 = alloc_BuiltinList();
  gc_pause();
// compilenode returning *var_suggestion
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array3507, "push", 1, partcv, params);
// compilenode returning *var_suggestion2
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array3507, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array3507
  *var_suggestions = array3507;
  if (array3507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3508 = gc_frame_new();
  if (strlit3509 == NULL) {
    strlit3509 = alloc_String("A type containing a '<' must end with a '>', or the '<' operator must have a space before it.");
    gc_root(strlit3509);
  }
// compilenode returning strlit3509
  gc_frame_newslot(strlit3509);
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3510 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3511 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3510);
// compilenode returning call3511
// compilenode returning call3511
  gc_frame_newslot(call3511);
  int callframe3513 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3514 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3513);
// compilenode returning call3514
// compilenode returning call3514
  int op_slot_right_3512 = gc_frame_newslot(call3514);
  int callframe3516 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3517 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3516);
// compilenode returning call3517
// compilenode returning call3517
  int op_slot_left_3512 = gc_frame_newslot(call3517);
  params[0] = call3514;
  partcv[0] = 1;
  Object sum3518 = callmethod(call3517, "+", 1, partcv, params);
// compilenode returning sum3518
  gc_frame_newslot(sum3518);
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3509;
  params[1] = call3511;
  params[2] = sum3518;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3519 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3508);
// compilenode returning call3519
    gc_frame_newslot(call3519);
    if3486 = call3519;
  } else {
  }
// compilenode returning if3486
// Begin line 1084
  setline(1084);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3520 = gc_frame_new();
  partcv[0] = 0;
  Object call3521 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3520);
// compilenode returning call3521
// Begin line 1085
  setline(1085);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3522 = gc_frame_new();
  int callframe3523 = gc_frame_new();
// compilenode returning *var_id
  gc_frame_newslot(*var_id);
// compilenode returning *var_gens
  gc_frame_newslot(*var_gens);
  int callframe3524 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call3525 = callmethod(*var_ast, "genericNode",
    1, partcv, params);
  gc_frame_end(callframe3524);
// compilenode returning call3525
// compilenode returning call3525
  params[0] = *var_id;
  params[1] = *var_gens;
  partcv[0] = 2;
  Object call3526 = callmethod(call3525, "new",
    1, partcv, params);
  gc_frame_end(callframe3523);
// compilenode returning call3526
  gc_frame_newslot(call3526);
// compilenode returning *var_values
  params[0] = call3526;
  partcv[0] = 1;
  Object call3527 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe3522);
// compilenode returning call3527
    gc_frame_newslot(call3527);
    if3354 = call3527;
  } else {
  }
// compilenode returning if3354
  gc_frame_end(frame);
  return if3354;
}
Object meth_parser__apply3566(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3570 == NULL) {
    strlit3570 = alloc_String("catch");
    gc_root(strlit3570);
  }
// compilenode returning strlit3570
  int op_slot_right_3569 = gc_frame_newslot(strlit3570);
  int callframe3572 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call3573 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe3572);
// compilenode returning call3573
// compilenode returning call3573
  int op_slot_left_3569 = gc_frame_newslot(call3573);
  params[0] = strlit3570;
  partcv[0] = 1;
  Object opresult3574 = callmethod(call3573, "==", 1, partcv, params);
// compilenode returning opresult3574
  int op_slot_right_3568 = gc_frame_newslot(opresult3574);
  if (strlit3577 == NULL) {
    strlit3577 = alloc_String("identifier");
    gc_root(strlit3577);
  }
// compilenode returning strlit3577
  int op_slot_right_3576 = gc_frame_newslot(strlit3577);
  int callframe3579 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call3580 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3579);
// compilenode returning call3580
// compilenode returning call3580
  int op_slot_left_3576 = gc_frame_newslot(call3580);
  params[0] = strlit3577;
  partcv[0] = 1;
  Object opresult3581 = callmethod(call3580, "==", 1, partcv, params);
// compilenode returning opresult3581
  int op_slot_left_3568 = gc_frame_newslot(opresult3581);
  params[0] = opresult3574;
  partcv[0] = 1;
  Object opresult3582 = callmethod(opresult3581, "&&", 1, partcv, params);
// compilenode returning opresult3582
  int op_slot_right_3567 = gc_frame_newslot(opresult3582);
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3587 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call3588 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3587);
// compilenode returning call3588
// compilenode returning call3588
  int op_slot_right_3586 = gc_frame_newslot(call3588);
  int callframe3590 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call3591 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe3590);
// compilenode returning call3591
// compilenode returning call3591
  int op_slot_left_3586 = gc_frame_newslot(call3591);
  params[0] = call3588;
  partcv[0] = 1;
  Object opresult3592 = callmethod(call3591, "==", 1, partcv, params);
// compilenode returning opresult3592
  int op_slot_right_3585 = gc_frame_newslot(opresult3592);
  if (strlit3595 == NULL) {
    strlit3595 = alloc_String("rparen");
    gc_root(strlit3595);
  }
// compilenode returning strlit3595
  int op_slot_right_3594 = gc_frame_newslot(strlit3595);
  int callframe3597 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call3598 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3597);
// compilenode returning call3598
// compilenode returning call3598
  int op_slot_left_3594 = gc_frame_newslot(call3598);
  params[0] = strlit3595;
  partcv[0] = 1;
  Object opresult3599 = callmethod(call3598, "==", 1, partcv, params);
// compilenode returning opresult3599
  int op_slot_left_3585 = gc_frame_newslot(opresult3599);
  params[0] = opresult3592;
  partcv[0] = 1;
  Object opresult3600 = callmethod(opresult3599, "&&", 1, partcv, params);
// compilenode returning opresult3600
  int op_slot_right_3584 = gc_frame_newslot(opresult3600);
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3603 == NULL) {
    strlit3603 = alloc_String("rbrace");
    gc_root(strlit3603);
  }
// compilenode returning strlit3603
  int op_slot_right_3602 = gc_frame_newslot(strlit3603);
  int callframe3605 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call3606 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe3605);
// compilenode returning call3606
// compilenode returning call3606
  int op_slot_left_3602 = gc_frame_newslot(call3606);
  params[0] = strlit3603;
  partcv[0] = 1;
  Object opresult3607 = callmethod(call3606, "==", 1, partcv, params);
// compilenode returning opresult3607
  int op_slot_left_3584 = gc_frame_newslot(opresult3607);
  params[0] = opresult3600;
  partcv[0] = 1;
  Object opresult3608 = callmethod(opresult3607, "||", 1, partcv, params);
// compilenode returning opresult3608
  int op_slot_left_3567 = gc_frame_newslot(opresult3608);
  params[0] = opresult3582;
  partcv[0] = 1;
  Object opresult3609 = callmethod(opresult3608, "||", 1, partcv, params);
// compilenode returning opresult3609
  gc_frame_end(frame);
  return opresult3609;
}
Object meth_parser__apply3684(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3685 = gc_frame_new();
  partcv[0] = 0;
  Object call3686 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3685);
// compilenode returning call3686
  gc_frame_end(frame);
  return call3686;
}
Object meth_parser__apply3754(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit3757 == NULL) {
    strlit3757 = alloc_String("catch");
    gc_root(strlit3757);
  }
// compilenode returning strlit3757
  int op_slot_right_3756 = gc_frame_newslot(strlit3757);
  int callframe3759 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3760 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3759);
// compilenode returning call3760
// compilenode returning call3760
  int op_slot_left_3756 = gc_frame_newslot(call3760);
  params[0] = strlit3757;
  partcv[0] = 1;
  Object opresult3761 = callmethod(call3760, "==", 1, partcv, params);
// compilenode returning opresult3761
  int op_slot_right_3755 = gc_frame_newslot(opresult3761);
  int callframe3763 = gc_frame_new();
  if (strlit3764 == NULL) {
    strlit3764 = alloc_String("identifier");
    gc_root(strlit3764);
  }
// compilenode returning strlit3764
  gc_frame_newslot(strlit3764);
  params[0] = strlit3764;
  partcv[0] = 1;
  Object call3765 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3763);
// compilenode returning call3765
  int op_slot_left_3755 = gc_frame_newslot(call3765);
  params[0] = opresult3761;
  partcv[0] = 1;
  Object opresult3766 = callmethod(call3765, "&&", 1, partcv, params);
// compilenode returning opresult3766
  gc_frame_end(frame);
  return opresult3766;
}
Object meth_parser__apply3788(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3789 = gc_frame_new();
  partcv[0] = 0;
  Object call3790 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3789);
// compilenode returning call3790
  gc_frame_end(frame);
  return call3790;
}
Object meth_parser__apply3769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_tokens = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_cases = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3770 = gc_frame_new();
  partcv[0] = 0;
  Object call3771 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3770);
// compilenode returning call3771
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3773 = gc_frame_new();
  if (strlit3774 == NULL) {
    strlit3774 = alloc_String("lbrace");
    gc_root(strlit3774);
  }
// compilenode returning strlit3774
  gc_frame_newslot(strlit3774);
  params[0] = strlit3774;
  partcv[0] = 1;
  Object call3775 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3773);
// compilenode returning call3775
  Object if3772 = done;
  if (istrue(call3775)) {
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3776 = gc_frame_new();
  partcv[0] = 0;
  Object call3777 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3776);
// compilenode returning call3777
    gc_frame_newslot(call3777);
    if3772 = call3777;
  } else {
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3779 = gc_frame_new();
  if (strlit3780 == NULL) {
    strlit3780 = alloc_String("lparen");
    gc_root(strlit3780);
  }
// compilenode returning strlit3780
  gc_frame_newslot(strlit3780);
  params[0] = strlit3780;
  partcv[0] = 1;
  Object call3781 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3779);
// compilenode returning call3781
  Object if3778 = done;
  if (istrue(call3781)) {
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3782 = gc_frame_new();
  partcv[0] = 0;
  Object call3783 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3782);
// compilenode returning call3783
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3785 = gc_frame_new();
  int callframe3786 = gc_frame_new();
  Object block3787 = alloc_Block(NULL, NULL, "parser", 1151);
  gc_frame_newslot(block3787);
  block_savedest(block3787);
  Object closure3788 = createclosure(1, "_apply");
setclosureframe(closure3788, stackframe);
  addtoclosure(closure3788, selfslot);
  struct UserObject *uo3788 = (struct UserObject*)block3787;
  uo3788->data[0] = (Object)closure3788;
  Method *meth_meth_parser__apply3788 = addmethod2pos(block3787, "_apply", &meth_parser__apply3788, 0);
int argcv_meth_parser__apply3788[] = {0};
meth_meth_parser__apply3788->type = alloc_MethodType(1, argcv_meth_parser__apply3788);
  meth_meth_parser__apply3788->definitionModule = modulename;
  meth_meth_parser__apply3788->definitionLine = 1151;
// compilenode returning block3787
  gc_frame_newslot(block3787);
  params[0] = block3787;
  partcv[0] = 1;
  Object call3792 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3786);
// compilenode returning call3792
  partcv[0] = 0;
  Object call3793 = callmethod(call3792, "not",
    1, partcv, params);
  gc_frame_end(callframe3785);
// compilenode returning call3793
// compilenode returning call3793
  Object if3784 = done;
  if (istrue(call3793)) {
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3794 = gc_frame_new();
  int callframe3795 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3796 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3795);
// compilenode returning call3796
// compilenode returning call3796
  partcv[0] = 0;
  Object call3797 = callmethod(call3796, "new",
    1, partcv, params);
  gc_frame_end(callframe3794);
// compilenode returning call3797
// compilenode returning call3797
  *var_suggestion = call3797;
  if (call3797 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1153
  setline(1153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3798 = gc_frame_new();
  if (strlit3799 == NULL) {
    strlit3799 = alloc_String("rparen");
    gc_root(strlit3799);
  }
// compilenode returning strlit3799
  gc_frame_newslot(strlit3799);
  params[0] = strlit3799;
  partcv[0] = 1;
  Object call3800 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3798);
// compilenode returning call3800
  *var_nextTok = call3800;
  if (call3800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3802 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3802 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3804 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3804
  Object if3801 = done;
  if (istrue(opresult3804)) {
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3805 = gc_frame_new();
  if (strlit3806 == NULL) {
    strlit3806 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3806);
  }
// compilenode returning strlit3806
  gc_frame_newslot(strlit3806);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3806;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3807 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3805);
// compilenode returning call3807
    gc_frame_newslot(call3807);
    if3801 = call3807;
  } else {
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3808 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe3809 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3810 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3809);
// compilenode returning call3810
// compilenode returning call3810
  gc_frame_newslot(call3810);
  Object bool3811 = alloc_Boolean(1);
// compilenode returning bool3811
  gc_frame_newslot(bool3811);
  Object bool3812 = alloc_Boolean(0);
// compilenode returning bool3812
  gc_frame_newslot(bool3812);
  if (strlit3813 == NULL) {
    strlit3813 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3813);
  }
// compilenode returning strlit3813
  gc_frame_newslot(strlit3813);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call3810;
  params[2] = bool3811;
  params[3] = bool3812;
  params[4] = strlit3813;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3814 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3808);
// compilenode returning call3814
    gc_frame_newslot(call3814);
    if3801 = call3814;
  }
// compilenode returning if3801
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3815 = gc_frame_new();
  if (strlit3816 == NULL) {
    strlit3816 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3816);
  }
// compilenode returning strlit3816
  gc_frame_newslot(strlit3816);
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3817 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3818 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3817);
// compilenode returning call3818
// compilenode returning call3818
  gc_frame_newslot(call3818);
  int callframe3819 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3820 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3819);
// compilenode returning call3820
// compilenode returning call3820
  gc_frame_newslot(call3820);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3816;
  params[1] = call3818;
  params[2] = call3820;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3821 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3815);
// compilenode returning call3821
    gc_frame_newslot(call3821);
    if3784 = call3821;
  } else {
  }
// compilenode returning if3784
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3824 == NULL) {
    strlit3824 = alloc_String("rparen");
    gc_root(strlit3824);
  }
// compilenode returning strlit3824
  int op_slot_right_3823 = gc_frame_newslot(strlit3824);
  int callframe3826 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3827 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3826);
// compilenode returning call3827
// compilenode returning call3827
  int op_slot_left_3823 = gc_frame_newslot(call3827);
  params[0] = strlit3824;
  partcv[0] = 1;
  Object opresult3828 = callmethod(call3827, "!=", 1, partcv, params);
// compilenode returning opresult3828
  Object if3822 = done;
  if (istrue(opresult3828)) {
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3829 = gc_frame_new();
  partcv[0] = 0;
  Object call3830 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3829);
// compilenode returning call3830
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1164
  setline(1164);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3831 = gc_frame_new();
  int callframe3832 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3833 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3832);
// compilenode returning call3833
// compilenode returning call3833
  partcv[0] = 0;
  Object call3834 = callmethod(call3833, "new",
    1, partcv, params);
  gc_frame_end(callframe3831);
// compilenode returning call3834
// compilenode returning call3834
  *var_suggestion = call3834;
  if (call3834 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3835 = gc_frame_new();
  if (strlit3836 == NULL) {
    strlit3836 = alloc_String(")");
    gc_root(strlit3836);
  }
// compilenode returning strlit3836
  gc_frame_newslot(strlit3836);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3836;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3837 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3835);
// compilenode returning call3837
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3838 = gc_frame_new();
  if (strlit3839 == NULL) {
    strlit3839 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3839);
  }
// compilenode returning strlit3839
  gc_frame_newslot(strlit3839);
// Begin line 1167
  setline(1167);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3840 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3841 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3840);
// compilenode returning call3841
// compilenode returning call3841
  gc_frame_newslot(call3841);
  int callframe3843 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3844 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3843);
// compilenode returning call3844
// compilenode returning call3844
  int op_slot_right_3842 = gc_frame_newslot(call3844);
  int callframe3846 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3847 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3846);
// compilenode returning call3847
// compilenode returning call3847
  int op_slot_left_3842 = gc_frame_newslot(call3847);
  params[0] = call3844;
  partcv[0] = 1;
  Object sum3848 = callmethod(call3847, "+", 1, partcv, params);
// compilenode returning sum3848
  gc_frame_newslot(sum3848);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1166
  setline(1166);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3839;
  params[1] = call3841;
  params[2] = sum3848;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3849 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3838);
// compilenode returning call3849
    gc_frame_newslot(call3849);
    if3822 = call3849;
  } else {
  }
// compilenode returning if3822
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3850 = gc_frame_new();
  partcv[0] = 0;
  Object call3851 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3850);
// compilenode returning call3851
    gc_frame_newslot(call3851);
    if3778 = call3851;
  } else {
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3852 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3852
  *var_suggestions = array3852;
  if (array3852 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1172
  setline(1172);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3853 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call3854 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3853);
// compilenode returning call3854
  *var_nextTok = call3854;
  if (call3854 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1173
  setline(1173);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3855 = gc_frame_new();
  int callframe3856 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3857 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3856);
// compilenode returning call3857
// compilenode returning call3857
  partcv[0] = 0;
  Object call3858 = callmethod(call3857, "new",
    1, partcv, params);
  gc_frame_end(callframe3855);
// compilenode returning call3858
// compilenode returning call3858
  *var_suggestion = call3858;
  if (call3858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1174
  setline(1174);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3861 = alloc_Boolean(0);
// compilenode returning bool3861
  int op_slot_right_3860 = gc_frame_newslot(bool3861);
// compilenode returning *var_nextTok
  int op_slot_left_3860 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3861;
  partcv[0] = 1;
  Object opresult3863 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3863
  Object if3859 = done;
  if (istrue(opresult3863)) {
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3864 = gc_frame_new();
  if (strlit3865 == NULL) {
    strlit3865 = alloc_String(" }");
    gc_root(strlit3865);
  }
// compilenode returning strlit3865
  gc_frame_newslot(strlit3865);
  int callframe3866 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call3867 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe3866);
// compilenode returning call3867
// compilenode returning call3867
  gc_frame_newslot(call3867);
// compilenode returning *var_suggestion
  params[0] = strlit3865;
  params[1] = call3867;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3868 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3864);
// compilenode returning call3868
// Begin line 1176
  setline(1176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3869 = gc_frame_new();
  if (strlit3870 == NULL) {
    strlit3870 = alloc_String(" {");
    gc_root(strlit3870);
  }
// compilenode returning strlit3870
  gc_frame_newslot(strlit3870);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3870;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3871 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3869);
// compilenode returning call3871
// Begin line 1177
  setline(1177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3872 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3873 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3872);
// compilenode returning call3873
    gc_frame_newslot(call3873);
    if3859 = call3873;
  } else {
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1178
  setline(1178);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3875 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3875 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3877 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3877
  Object if3874 = done;
  if (istrue(opresult3877)) {
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3878 = gc_frame_new();
  if (strlit3879 == NULL) {
    strlit3879 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit3879);
  }
// compilenode returning strlit3879
  gc_frame_newslot(strlit3879);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3879;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3880 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3878);
// compilenode returning call3880
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3881 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3882 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3881);
// compilenode returning call3882
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3883 = gc_frame_new();
  int callframe3884 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3885 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3884);
// compilenode returning call3885
// compilenode returning call3885
  partcv[0] = 0;
  Object call3886 = callmethod(call3885, "new",
    1, partcv, params);
  gc_frame_end(callframe3883);
// compilenode returning call3886
// compilenode returning call3886
  *var_suggestion = call3886;
  if (call3886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3888 = gc_frame_new();
  if (strlit3889 == NULL) {
    strlit3889 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit3889);
  }
// compilenode returning strlit3889
  gc_frame_newslot(strlit3889);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3889;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3890 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3888);
// compilenode returning call3890
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3891 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3892 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3891);
// compilenode returning call3892
    gc_frame_newslot(call3892);
    if3874 = call3892;
  } else {
// Begin line 1185
  setline(1185);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3893 = gc_frame_new();
  if (strlit3894 == NULL) {
    strlit3894 = alloc_String(" }");
    gc_root(strlit3894);
  }
// compilenode returning strlit3894
  gc_frame_newslot(strlit3894);
  int callframe3895 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3896 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3895);
// compilenode returning call3896
// compilenode returning call3896
  gc_frame_newslot(call3896);
// compilenode returning *var_suggestion
  params[0] = strlit3894;
  params[1] = call3896;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3897 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3893);
// compilenode returning call3897
// Begin line 1186
  setline(1186);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3898 = gc_frame_new();
  if (strlit3899 == NULL) {
    strlit3899 = alloc_String(" {");
    gc_root(strlit3899);
  }
// compilenode returning strlit3899
  gc_frame_newslot(strlit3899);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3899;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3900 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3898);
// compilenode returning call3900
// Begin line 1187
  setline(1187);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3901 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call3902 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe3901);
// compilenode returning call3902
    gc_frame_newslot(call3902);
    if3874 = call3902;
  }
// compilenode returning if3874
    gc_frame_newslot(if3874);
    if3859 = if3874;
  }
// compilenode returning if3859
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3903 = gc_frame_new();
  if (strlit3904 == NULL) {
    strlit3904 = alloc_String("A try-catch statement must have either a matching block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3904);
  }
// compilenode returning strlit3904
  gc_frame_newslot(strlit3904);
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3905 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3906 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3905);
// compilenode returning call3906
// compilenode returning call3906
  gc_frame_newslot(call3906);
  int callframe3907 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3908 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3907);
// compilenode returning call3908
// compilenode returning call3908
  gc_frame_newslot(call3908);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3904;
  params[1] = call3906;
  params[2] = call3908;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3909 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe3903);
// compilenode returning call3909
    gc_frame_newslot(call3909);
    if3778 = call3909;
  }
// compilenode returning if3778
    gc_frame_newslot(if3778);
    if3772 = if3778;
  }
// compilenode returning if3772
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3910 = gc_frame_new();
  int callframe3911 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3912 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3911);
// compilenode returning call3912
// compilenode returning call3912
  gc_frame_newslot(call3912);
// compilenode returning *var_cases
  params[0] = call3912;
  partcv[0] = 1;
  Object call3913 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe3910);
// compilenode returning call3913
  gc_frame_end(frame);
  return call3913;
}
Object meth_parser__apply3988(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe3989 = gc_frame_new();
  partcv[0] = 0;
  Object call3990 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3989);
// compilenode returning call3990
  gc_frame_end(frame);
  return call3990;
}
Object meth_parser_trycatch3528(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "trycatch");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for trycatch (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for trycatch");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1089
  setline(1089);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3530 = gc_frame_new();
  if (strlit3533 == NULL) {
    strlit3533 = alloc_String("try");
    gc_root(strlit3533);
  }
// compilenode returning strlit3533
  int op_slot_right_3532 = gc_frame_newslot(strlit3533);
  int callframe3535 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3536 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3535);
// compilenode returning call3536
// compilenode returning call3536
  int op_slot_left_3532 = gc_frame_newslot(call3536);
  params[0] = strlit3533;
  partcv[0] = 1;
  Object opresult3537 = callmethod(call3536, "==", 1, partcv, params);
// compilenode returning opresult3537
  int op_slot_right_3531 = gc_frame_newslot(opresult3537);
  int callframe3539 = gc_frame_new();
  if (strlit3540 == NULL) {
    strlit3540 = alloc_String("identifier");
    gc_root(strlit3540);
  }
// compilenode returning strlit3540
  gc_frame_newslot(strlit3540);
  params[0] = strlit3540;
  partcv[0] = 1;
  Object call3541 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3539);
// compilenode returning call3541
  int op_slot_left_3531 = gc_frame_newslot(call3541);
  params[0] = opresult3537;
  partcv[0] = 1;
  Object opresult3542 = callmethod(call3541, "&&", 1, partcv, params);
// compilenode returning opresult3542
  partcv[0] = 0;
  Object call3543 = callmethod(opresult3542, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3530);
// compilenode returning call3543
  Object if3529 = done;
  if (istrue(call3543)) {
// Begin line 1091
  setline(1091);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1090
  setline(1090);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num3544 = alloc_Float64(0);
// compilenode returning num3544
  return num3544;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if3529 = undefined;
  } else {
  }
// compilenode returning if3529
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3545 = gc_frame_new();
  partcv[0] = 0;
  Object call3546 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3545);
// compilenode returning call3546
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3548 = gc_frame_new();
  if (strlit3549 == NULL) {
    strlit3549 = alloc_String("lbrace");
    gc_root(strlit3549);
  }
// compilenode returning strlit3549
  gc_frame_newslot(strlit3549);
  params[0] = strlit3549;
  partcv[0] = 1;
  Object call3550 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3548);
// compilenode returning call3550
  Object if3547 = done;
  if (istrue(call3550)) {
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3551 = gc_frame_new();
  partcv[0] = 0;
  Object call3552 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3551);
// compilenode returning call3552
    gc_frame_newslot(call3552);
    if3547 = call3552;
  } else {
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3555 == NULL) {
    strlit3555 = alloc_String("lparen");
    gc_root(strlit3555);
  }
// compilenode returning strlit3555
  int op_slot_right_3554 = gc_frame_newslot(strlit3555);
  int callframe3557 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3558 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3557);
// compilenode returning call3558
// compilenode returning call3558
  int op_slot_left_3554 = gc_frame_newslot(call3558);
  params[0] = strlit3555;
  partcv[0] = 1;
  Object opresult3559 = callmethod(call3558, "!=", 1, partcv, params);
// compilenode returning opresult3559
  Object if3553 = done;
  if (istrue(opresult3559)) {
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3560 = gc_frame_new();
  int callframe3561 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3562 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3561);
// compilenode returning call3562
// compilenode returning call3562
  partcv[0] = 0;
  Object call3563 = callmethod(call3562, "new",
    1, partcv, params);
  gc_frame_end(callframe3560);
// compilenode returning call3563
// compilenode returning call3563
  *var_suggestion = call3563;
  if (call3563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3564 = gc_frame_new();
  Object block3565 = alloc_Block(NULL, NULL, "parser", 1101);
  gc_frame_newslot(block3565);
  block_savedest(block3565);
  Object closure3566 = createclosure(2, "_apply");
setclosureframe(closure3566, stackframe);
  addtoclosure(closure3566, var_catchTok);
  addtoclosure(closure3566, selfslot);
  struct UserObject *uo3566 = (struct UserObject*)block3565;
  uo3566->data[0] = (Object)closure3566;
  Method *meth_meth_parser__apply3566 = addmethod2pos(block3565, "_apply", &meth_parser__apply3566, 0);
int argcv_meth_parser__apply3566[] = {1};
meth_meth_parser__apply3566->type = alloc_MethodType(1, argcv_meth_parser__apply3566);
  meth_meth_parser__apply3566->definitionModule = modulename;
  meth_meth_parser__apply3566->definitionLine = 1099;
// compilenode returning block3565
  gc_frame_newslot(block3565);
  params[0] = block3565;
  partcv[0] = 1;
  Object call3611 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3564);
// compilenode returning call3611
  *var_nextTok = call3611;
  if (call3611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3614 = alloc_Boolean(0);
// compilenode returning bool3614
  int op_slot_right_3613 = gc_frame_newslot(bool3614);
// compilenode returning *var_nextTok
  int op_slot_left_3613 = gc_frame_newslot(*var_nextTok);
  params[0] = bool3614;
  partcv[0] = 1;
  Object opresult3616 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3616
  Object if3612 = done;
  if (istrue(opresult3616)) {
// Begin line 1105
  setline(1105);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3617 = gc_frame_new();
  if (strlit3618 == NULL) {
    strlit3618 = alloc_String(" {}");
    gc_root(strlit3618);
  }
// compilenode returning strlit3618
  gc_frame_newslot(strlit3618);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit3618;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3619 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3617);
// compilenode returning call3619
    gc_frame_newslot(call3619);
    if3612 = call3619;
  } else {
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1106
  setline(1106);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3622 == NULL) {
    strlit3622 = alloc_String("rbrace");
    gc_root(strlit3622);
  }
// compilenode returning strlit3622
  int op_slot_right_3621 = gc_frame_newslot(strlit3622);
  int callframe3624 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3625 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3624);
// compilenode returning call3625
// compilenode returning call3625
  int op_slot_left_3621 = gc_frame_newslot(call3625);
  params[0] = strlit3622;
  partcv[0] = 1;
  Object opresult3626 = callmethod(call3625, "==", 1, partcv, params);
// compilenode returning opresult3626
  Object if3620 = done;
  if (istrue(opresult3626)) {
// Begin line 1107
  setline(1107);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3627 = gc_frame_new();
  if (strlit3628 == NULL) {
    strlit3628 = alloc_String(" {");
    gc_root(strlit3628);
  }
// compilenode returning strlit3628
  gc_frame_newslot(strlit3628);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit3628;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3629 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3627);
// compilenode returning call3629
    gc_frame_newslot(call3629);
    if3620 = call3629;
  } else {
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1108
  setline(1108);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3632 == NULL) {
    strlit3632 = alloc_String("rparen");
    gc_root(strlit3632);
  }
// compilenode returning strlit3632
  int op_slot_right_3631 = gc_frame_newslot(strlit3632);
  int callframe3634 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3635 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3634);
// compilenode returning call3635
// compilenode returning call3635
  int op_slot_left_3631 = gc_frame_newslot(call3635);
  params[0] = strlit3632;
  partcv[0] = 1;
  Object opresult3636 = callmethod(call3635, "==", 1, partcv, params);
// compilenode returning opresult3636
  Object if3630 = done;
  if (istrue(opresult3636)) {
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3638 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3638 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3640 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3640
  Object if3637 = done;
  if (istrue(opresult3640)) {
// Begin line 1110
  setline(1110);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3641 = gc_frame_new();
  if (strlit3642 == NULL) {
    strlit3642 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3642);
  }
// compilenode returning strlit3642
  gc_frame_newslot(strlit3642);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool3643 = alloc_Boolean(1);
// compilenode returning bool3643
  gc_frame_newslot(bool3643);
// compilenode returning *var_suggestion
  params[0] = strlit3642;
  params[1] = *var_lastToken;
  params[2] = bool3643;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3644 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3641);
// compilenode returning call3644
    gc_frame_newslot(call3644);
    if3637 = call3644;
  } else {
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3645 = gc_frame_new();
  if (strlit3646 == NULL) {
    strlit3646 = alloc_String("(");
    gc_root(strlit3646);
  }
// compilenode returning strlit3646
  gc_frame_newslot(strlit3646);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool3647 = alloc_Boolean(1);
// compilenode returning bool3647
  gc_frame_newslot(bool3647);
// compilenode returning *var_suggestion
  params[0] = strlit3646;
  params[1] = *var_lastToken;
  params[2] = bool3647;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call3648 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe3645);
// compilenode returning call3648
    gc_frame_newslot(call3648);
    if3637 = call3648;
  }
// compilenode returning if3637
    gc_frame_newslot(if3637);
    if3630 = if3637;
  } else {
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1114
  setline(1114);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3651 == NULL) {
    strlit3651 = alloc_String("identifier");
    gc_root(strlit3651);
  }
// compilenode returning strlit3651
  int op_slot_right_3650 = gc_frame_newslot(strlit3651);
  int callframe3653 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3654 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe3653);
// compilenode returning call3654
// compilenode returning call3654
  int op_slot_left_3650 = gc_frame_newslot(call3654);
  params[0] = strlit3651;
  partcv[0] = 1;
  Object opresult3655 = callmethod(call3654, "==", 1, partcv, params);
// compilenode returning opresult3655
  Object if3649 = done;
  if (istrue(opresult3655)) {
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3656 = gc_frame_new();
  if (strlit3657 == NULL) {
    strlit3657 = alloc_String(" {");
    gc_root(strlit3657);
  }
// compilenode returning strlit3657
  gc_frame_newslot(strlit3657);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit3657;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3658 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3656);
// compilenode returning call3658
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3659 = gc_frame_new();
  if (strlit3660 == NULL) {
    strlit3660 = alloc_String("} ");
    gc_root(strlit3660);
  }
// compilenode returning strlit3660
  gc_frame_newslot(strlit3660);
// compilenode returning *var_nextTok
  gc_frame_newslot(*var_nextTok);
// compilenode returning *var_suggestion
  params[0] = strlit3660;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3661 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe3659);
// compilenode returning call3661
    gc_frame_newslot(call3661);
    if3649 = call3661;
  } else {
  }
// compilenode returning if3649
    gc_frame_newslot(if3649);
    if3630 = if3649;
  }
// compilenode returning if3630
    gc_frame_newslot(if3630);
    if3620 = if3630;
  }
// compilenode returning if3620
    gc_frame_newslot(if3620);
    if3612 = if3620;
  }
// compilenode returning if3612
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3662 = gc_frame_new();
  if (strlit3663 == NULL) {
    strlit3663 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3663);
  }
// compilenode returning strlit3663
  gc_frame_newslot(strlit3663);
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3664 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call3665 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe3664);
// compilenode returning call3665
// compilenode returning call3665
  gc_frame_newslot(call3665);
  Object num3667 = alloc_Float64(1);
// compilenode returning num3667
  int op_slot_right_3666 = gc_frame_newslot(num3667);
  int callframe3670 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call3671 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe3670);
// compilenode returning call3671
// compilenode returning call3671
  int op_slot_right_3669 = gc_frame_newslot(call3671);
  int callframe3673 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call3674 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3673);
// compilenode returning call3674
// compilenode returning call3674
  int op_slot_left_3669 = gc_frame_newslot(call3674);
  params[0] = call3671;
  partcv[0] = 1;
  Object sum3675 = callmethod(call3674, "+", 1, partcv, params);
// compilenode returning sum3675
  int op_slot_left_3666 = gc_frame_newslot(sum3675);
  params[0] = num3667;
  partcv[0] = 1;
  Object sum3676 = callmethod(sum3675, "+", 1, partcv, params);
// compilenode returning sum3676
  gc_frame_newslot(sum3676);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1118
  setline(1118);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3663;
  params[1] = call3665;
  params[2] = sum3676;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3677 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3662);
// compilenode returning call3677
    gc_frame_newslot(call3677);
    if3553 = call3677;
  } else {
  }
// compilenode returning if3553
// Begin line 1121
  setline(1121);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3678 = gc_frame_new();
  partcv[0] = 0;
  Object call3679 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3678);
// compilenode returning call3679
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3681 = gc_frame_new();
  int callframe3682 = gc_frame_new();
  Object block3683 = alloc_Block(NULL, NULL, "parser", 1122);
  gc_frame_newslot(block3683);
  block_savedest(block3683);
  Object closure3684 = createclosure(1, "_apply");
setclosureframe(closure3684, stackframe);
  addtoclosure(closure3684, selfslot);
  struct UserObject *uo3684 = (struct UserObject*)block3683;
  uo3684->data[0] = (Object)closure3684;
  Method *meth_meth_parser__apply3684 = addmethod2pos(block3683, "_apply", &meth_parser__apply3684, 0);
int argcv_meth_parser__apply3684[] = {0};
meth_meth_parser__apply3684->type = alloc_MethodType(1, argcv_meth_parser__apply3684);
  meth_meth_parser__apply3684->definitionModule = modulename;
  meth_meth_parser__apply3684->definitionLine = 1122;
// compilenode returning block3683
  gc_frame_newslot(block3683);
  params[0] = block3683;
  partcv[0] = 1;
  Object call3688 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3682);
// compilenode returning call3688
  partcv[0] = 0;
  Object call3689 = callmethod(call3688, "not",
    1, partcv, params);
  gc_frame_end(callframe3681);
// compilenode returning call3689
// compilenode returning call3689
  Object if3680 = done;
  if (istrue(call3689)) {
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3690 = gc_frame_new();
  int callframe3691 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3692 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3691);
// compilenode returning call3692
// compilenode returning call3692
  partcv[0] = 0;
  Object call3693 = callmethod(call3692, "new",
    1, partcv, params);
  gc_frame_end(callframe3690);
// compilenode returning call3693
// compilenode returning call3693
  *var_suggestion = call3693;
  if (call3693 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3694 = gc_frame_new();
  if (strlit3695 == NULL) {
    strlit3695 = alloc_String("rparen");
    gc_root(strlit3695);
  }
// compilenode returning strlit3695
  gc_frame_newslot(strlit3695);
  params[0] = strlit3695;
  partcv[0] = 1;
  Object call3696 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3694);
// compilenode returning call3696
  *var_nextTok = call3696;
  if (call3696 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1125
  setline(1125);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_3698 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_3698 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult3700 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult3700
  Object if3697 = done;
  if (istrue(opresult3700)) {
// Begin line 1126
  setline(1126);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3701 = gc_frame_new();
  if (strlit3702 == NULL) {
    strlit3702 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3702);
  }
// compilenode returning strlit3702
  gc_frame_newslot(strlit3702);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3702;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3703 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3701);
// compilenode returning call3703
    gc_frame_newslot(call3703);
    if3697 = call3703;
  } else {
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3704 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe3705 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call3706 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe3705);
// compilenode returning call3706
// compilenode returning call3706
  gc_frame_newslot(call3706);
  Object bool3707 = alloc_Boolean(1);
// compilenode returning bool3707
  gc_frame_newslot(bool3707);
  Object bool3708 = alloc_Boolean(0);
// compilenode returning bool3708
  gc_frame_newslot(bool3708);
  if (strlit3709 == NULL) {
    strlit3709 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit3709);
  }
// compilenode returning strlit3709
  gc_frame_newslot(strlit3709);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call3706;
  params[2] = bool3707;
  params[3] = bool3708;
  params[4] = strlit3709;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call3710 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe3704);
// compilenode returning call3710
    gc_frame_newslot(call3710);
    if3697 = call3710;
  }
// compilenode returning if3697
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3711 = gc_frame_new();
  if (strlit3712 == NULL) {
    strlit3712 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit3712);
  }
// compilenode returning strlit3712
  gc_frame_newslot(strlit3712);
// Begin line 1131
  setline(1131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3713 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3714 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3713);
// compilenode returning call3714
// compilenode returning call3714
  gc_frame_newslot(call3714);
  int callframe3715 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3716 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3715);
// compilenode returning call3716
// compilenode returning call3716
  gc_frame_newslot(call3716);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3712;
  params[1] = call3714;
  params[2] = call3716;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3717 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3711);
// compilenode returning call3717
    gc_frame_newslot(call3717);
    if3680 = call3717;
  } else {
  }
// compilenode returning if3680
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1133
  setline(1133);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3720 == NULL) {
    strlit3720 = alloc_String("rparen");
    gc_root(strlit3720);
  }
// compilenode returning strlit3720
  int op_slot_right_3719 = gc_frame_newslot(strlit3720);
  int callframe3722 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3723 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe3722);
// compilenode returning call3723
// compilenode returning call3723
  int op_slot_left_3719 = gc_frame_newslot(call3723);
  params[0] = strlit3720;
  partcv[0] = 1;
  Object opresult3724 = callmethod(call3723, "!=", 1, partcv, params);
// compilenode returning opresult3724
  Object if3718 = done;
  if (istrue(opresult3724)) {
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3725 = gc_frame_new();
  partcv[0] = 0;
  Object call3726 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3725);
// compilenode returning call3726
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1135
  setline(1135);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3727 = gc_frame_new();
  int callframe3728 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3729 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3728);
// compilenode returning call3729
// compilenode returning call3729
  partcv[0] = 0;
  Object call3730 = callmethod(call3729, "new",
    1, partcv, params);
  gc_frame_end(callframe3727);
// compilenode returning call3730
// compilenode returning call3730
  *var_suggestion = call3730;
  if (call3730 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1136
  setline(1136);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3731 = gc_frame_new();
  if (strlit3732 == NULL) {
    strlit3732 = alloc_String(")");
    gc_root(strlit3732);
  }
// compilenode returning strlit3732
  gc_frame_newslot(strlit3732);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit3732;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3733 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe3731);
// compilenode returning call3733
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3734 = gc_frame_new();
  if (strlit3735 == NULL) {
    strlit3735 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit3735);
  }
// compilenode returning strlit3735
  gc_frame_newslot(strlit3735);
// Begin line 1138
  setline(1138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3736 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3737 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe3736);
// compilenode returning call3737
// compilenode returning call3737
  gc_frame_newslot(call3737);
  int callframe3739 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3740 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe3739);
// compilenode returning call3740
// compilenode returning call3740
  int op_slot_right_3738 = gc_frame_newslot(call3740);
  int callframe3742 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call3743 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3742);
// compilenode returning call3743
// compilenode returning call3743
  int op_slot_left_3738 = gc_frame_newslot(call3743);
  params[0] = call3740;
  partcv[0] = 1;
  Object sum3744 = callmethod(call3743, "+", 1, partcv, params);
// compilenode returning sum3744
  gc_frame_newslot(sum3744);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit3735;
  params[1] = call3737;
  params[2] = sum3744;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call3745 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3734);
// compilenode returning call3745
    gc_frame_newslot(call3745);
    if3718 = call3745;
  } else {
  }
// compilenode returning if3718
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3746 = gc_frame_new();
  partcv[0] = 0;
  Object call3747 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3746);
// compilenode returning call3747
    gc_frame_newslot(call3747);
    if3547 = call3747;
  }
// compilenode returning if3547
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1142
  setline(1142);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3748 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call3749 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe3748);
// compilenode returning call3749
// compilenode returning call3749
  *var_mainblock = call3749;
  if (call3749 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1143
  setline(1143);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array3750 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array3750
  *var_cases = array3750;
  if (array3750 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1144
  setline(1144);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool3751 = alloc_Boolean(0);
// compilenode returning bool3751
  *var_finally = bool3751;
  if (bool3751 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1145
  setline(1145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3752 = gc_frame_new();
  Object block3753 = alloc_Block(NULL, NULL, "parser", 1145);
  gc_frame_newslot(block3753);
  block_savedest(block3753);
  Object closure3754 = createclosure(2, "_apply");
setclosureframe(closure3754, stackframe);
  addtoclosure(closure3754, var_sym);
  addtoclosure(closure3754, selfslot);
  struct UserObject *uo3754 = (struct UserObject*)block3753;
  uo3754->data[0] = (Object)closure3754;
  Method *meth_meth_parser__apply3754 = addmethod2pos(block3753, "_apply", &meth_parser__apply3754, 0);
int argcv_meth_parser__apply3754[] = {0};
meth_meth_parser__apply3754->type = alloc_MethodType(1, argcv_meth_parser__apply3754);
  meth_meth_parser__apply3754->definitionModule = modulename;
  meth_meth_parser__apply3754->definitionLine = 1142;
// compilenode returning block3753
  gc_frame_newslot(block3753);
  Object block3768 = alloc_Block(NULL, NULL, "parser", 1145);
  gc_frame_newslot(block3768);
  block_savedest(block3768);
  Object closure3769 = createclosure(7, "_apply");
setclosureframe(closure3769, stackframe);
  addtoclosure(closure3769, var_errormessages);
  addtoclosure(closure3769, var_sym);
  addtoclosure(closure3769, var_lastToken);
  addtoclosure(closure3769, var_tokens);
  addtoclosure(closure3769, var_values);
  addtoclosure(closure3769, var_cases);
  addtoclosure(closure3769, selfslot);
  struct UserObject *uo3769 = (struct UserObject*)block3768;
  uo3769->data[0] = (Object)closure3769;
  Method *meth_meth_parser__apply3769 = addmethod2pos(block3768, "_apply", &meth_parser__apply3769, 0);
int argcv_meth_parser__apply3769[] = {0};
meth_meth_parser__apply3769->type = alloc_MethodType(1, argcv_meth_parser__apply3769);
  meth_meth_parser__apply3769->definitionModule = modulename;
  meth_meth_parser__apply3769->definitionLine = 1145;
// compilenode returning block3768
  gc_frame_newslot(block3768);
  params[0] = block3753;
  params[1] = block3768;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3915 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3752);
// compilenode returning call3915
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3919 == NULL) {
    strlit3919 = alloc_String("case");
    gc_root(strlit3919);
  }
// compilenode returning strlit3919
  int op_slot_right_3918 = gc_frame_newslot(strlit3919);
  int callframe3921 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3922 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3921);
// compilenode returning call3922
// compilenode returning call3922
  int op_slot_left_3918 = gc_frame_newslot(call3922);
  params[0] = strlit3919;
  partcv[0] = 1;
  Object opresult3923 = callmethod(call3922, "==", 1, partcv, params);
// compilenode returning opresult3923
  int op_slot_right_3917 = gc_frame_newslot(opresult3923);
  int callframe3925 = gc_frame_new();
  if (strlit3926 == NULL) {
    strlit3926 = alloc_String("identifier");
    gc_root(strlit3926);
  }
// compilenode returning strlit3926
  gc_frame_newslot(strlit3926);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
  params[0] = strlit3926;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3927 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3925);
// compilenode returning call3927
  int op_slot_left_3917 = gc_frame_newslot(call3927);
  params[0] = opresult3923;
  partcv[0] = 1;
  Object opresult3928 = callmethod(call3927, "&&", 1, partcv, params);
// compilenode returning opresult3928
  Object if3916 = done;
  if (istrue(opresult3928)) {
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3929 = gc_frame_new();
  int callframe3930 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3931 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3930);
// compilenode returning call3931
// compilenode returning call3931
  partcv[0] = 0;
  Object call3932 = callmethod(call3931, "new",
    1, partcv, params);
  gc_frame_end(callframe3929);
// compilenode returning call3932
// compilenode returning call3932
  *var_suggestion = call3932;
  if (call3932 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1196
  setline(1196);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3933 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit3934 == NULL) {
    strlit3934 = alloc_String("catch");
    gc_root(strlit3934);
  }
// compilenode returning strlit3934
  gc_frame_newslot(strlit3934);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit3934;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3935 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe3933);
// compilenode returning call3935
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3936 = gc_frame_new();
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3938 == NULL) {
    strlit3938 = alloc_String("are no 'case' blocks.");
    gc_root(strlit3938);
  }
// compilenode returning strlit3938
  int op_slot_right_3937 = gc_frame_newslot(strlit3938);
// Begin line 1198
  setline(1198);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3941 == NULL) {
    strlit3941 = alloc_String("'try' and then zero or more 'catch' blocks; there ");
    gc_root(strlit3941);
  }
// compilenode returning strlit3941
  int op_slot_right_3940 = gc_frame_newslot(strlit3941);
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3943 == NULL) {
    strlit3943 = alloc_String("A try-catch statement starts with a ");
    gc_root(strlit3943);
  }
// compilenode returning strlit3943
  int op_slot_left_3940 = gc_frame_newslot(strlit3943);
  params[0] = strlit3941;
  partcv[0] = 1;
  Object opresult3944 = callmethod(strlit3943, "++", 1, partcv, params);
// compilenode returning opresult3944
  int op_slot_left_3937 = gc_frame_newslot(opresult3944);
  params[0] = strlit3938;
  partcv[0] = 1;
  Object opresult3945 = callmethod(opresult3944, "++", 1, partcv, params);
// compilenode returning opresult3945
  gc_frame_newslot(opresult3945);
// Begin line 1200
  setline(1200);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3946 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3947 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe3946);
// compilenode returning call3947
// compilenode returning call3947
  gc_frame_newslot(call3947);
  int callframe3948 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3949 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3948);
// compilenode returning call3949
// compilenode returning call3949
  gc_frame_newslot(call3949);
  Object num3951 = alloc_Float64(3);
// compilenode returning num3951
  int op_slot_right_3950 = gc_frame_newslot(num3951);
  int callframe3953 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3954 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe3953);
// compilenode returning call3954
// compilenode returning call3954
  int op_slot_left_3950 = gc_frame_newslot(call3954);
  params[0] = num3951;
  partcv[0] = 1;
  Object sum3955 = callmethod(call3954, "+", 1, partcv, params);
// compilenode returning sum3955
  gc_frame_newslot(sum3955);
// Begin line 1201
  setline(1201);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1197
  setline(1197);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult3945;
  params[1] = call3947;
  params[2] = call3949;
  params[3] = sum3955;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call3956 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe3936);
// compilenode returning call3956
    gc_frame_newslot(call3956);
    if3916 = call3956;
  } else {
  }
// compilenode returning if3916
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit3960 == NULL) {
    strlit3960 = alloc_String("finally");
    gc_root(strlit3960);
  }
// compilenode returning strlit3960
  int op_slot_right_3959 = gc_frame_newslot(strlit3960);
  int callframe3962 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call3963 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe3962);
// compilenode returning call3963
// compilenode returning call3963
  int op_slot_left_3959 = gc_frame_newslot(call3963);
  params[0] = strlit3960;
  partcv[0] = 1;
  Object opresult3964 = callmethod(call3963, "==", 1, partcv, params);
// compilenode returning opresult3964
  int op_slot_right_3958 = gc_frame_newslot(opresult3964);
  int callframe3966 = gc_frame_new();
  if (strlit3967 == NULL) {
    strlit3967 = alloc_String("identifier");
    gc_root(strlit3967);
  }
// compilenode returning strlit3967
  gc_frame_newslot(strlit3967);
  params[0] = strlit3967;
  partcv[0] = 1;
  Object call3968 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3966);
// compilenode returning call3968
  int op_slot_left_3958 = gc_frame_newslot(call3968);
  params[0] = opresult3964;
  partcv[0] = 1;
  Object opresult3969 = callmethod(call3968, "&&", 1, partcv, params);
// compilenode returning opresult3969
  Object if3957 = done;
  if (istrue(opresult3969)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3970 = gc_frame_new();
  partcv[0] = 0;
  Object call3971 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3970);
// compilenode returning call3971
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3973 = gc_frame_new();
  if (strlit3974 == NULL) {
    strlit3974 = alloc_String("lbrace");
    gc_root(strlit3974);
  }
// compilenode returning strlit3974
  gc_frame_newslot(strlit3974);
  params[0] = strlit3974;
  partcv[0] = 1;
  Object call3975 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3973);
// compilenode returning call3975
  Object if3972 = done;
  if (istrue(call3975)) {
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3976 = gc_frame_new();
  partcv[0] = 0;
  Object call3977 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3976);
// compilenode returning call3977
    gc_frame_newslot(call3977);
    if3972 = call3977;
  } else {
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3979 = gc_frame_new();
  if (strlit3980 == NULL) {
    strlit3980 = alloc_String("lparen");
    gc_root(strlit3980);
  }
// compilenode returning strlit3980
  gc_frame_newslot(strlit3980);
  params[0] = strlit3980;
  partcv[0] = 1;
  Object call3981 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3979);
// compilenode returning call3981
  Object if3978 = done;
  if (istrue(call3981)) {
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3982 = gc_frame_new();
  partcv[0] = 0;
  Object call3983 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3982);
// compilenode returning call3983
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3985 = gc_frame_new();
  int callframe3986 = gc_frame_new();
  Object block3987 = alloc_Block(NULL, NULL, "parser", 1209);
  gc_frame_newslot(block3987);
  block_savedest(block3987);
  Object closure3988 = createclosure(1, "_apply");
setclosureframe(closure3988, stackframe);
  addtoclosure(closure3988, selfslot);
  struct UserObject *uo3988 = (struct UserObject*)block3987;
  uo3988->data[0] = (Object)closure3988;
  Method *meth_meth_parser__apply3988 = addmethod2pos(block3987, "_apply", &meth_parser__apply3988, 0);
int argcv_meth_parser__apply3988[] = {0};
meth_meth_parser__apply3988->type = alloc_MethodType(1, argcv_meth_parser__apply3988);
  meth_meth_parser__apply3988->definitionModule = modulename;
  meth_meth_parser__apply3988->definitionLine = 1209;
// compilenode returning block3987
  gc_frame_newslot(block3987);
  params[0] = block3987;
  partcv[0] = 1;
  Object call3992 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3986);
// compilenode returning call3992
  partcv[0] = 0;
  Object call3993 = callmethod(call3992, "not",
    1, partcv, params);
  gc_frame_end(callframe3985);
// compilenode returning call3993
// compilenode returning call3993
  Object if3984 = done;
  if (istrue(call3993)) {
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1210
  setline(1210);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3994 = gc_frame_new();
  int callframe3995 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call3996 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe3995);
// compilenode returning call3996
// compilenode returning call3996
  partcv[0] = 0;
  Object call3997 = callmethod(call3996, "new",
    1, partcv, params);
  gc_frame_end(callframe3994);
// compilenode returning call3997
// compilenode returning call3997
  *var_suggestion = call3997;
  if (call3997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1211
  setline(1211);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe3998 = gc_frame_new();
  if (strlit3999 == NULL) {
    strlit3999 = alloc_String("rparen");
    gc_root(strlit3999);
  }
// compilenode returning strlit3999
  gc_frame_newslot(strlit3999);
  params[0] = strlit3999;
  partcv[0] = 1;
  Object call4000 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3998);
// compilenode returning call4000
  *var_nextTok = call4000;
  if (call4000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4002 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4002 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4004 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4004
  Object if4001 = done;
  if (istrue(opresult4004)) {
// Begin line 1213
  setline(1213);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4005 = gc_frame_new();
  if (strlit4006 == NULL) {
    strlit4006 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4006);
  }
// compilenode returning strlit4006
  gc_frame_newslot(strlit4006);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4006;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4007 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4005);
// compilenode returning call4007
    gc_frame_newslot(call4007);
    if4001 = call4007;
  } else {
// Begin line 1215
  setline(1215);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4008 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4009 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4010 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4009);
// compilenode returning call4010
// compilenode returning call4010
  gc_frame_newslot(call4010);
  Object bool4011 = alloc_Boolean(1);
// compilenode returning bool4011
  gc_frame_newslot(bool4011);
  Object bool4012 = alloc_Boolean(0);
// compilenode returning bool4012
  gc_frame_newslot(bool4012);
  if (strlit4013 == NULL) {
    strlit4013 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4013);
  }
// compilenode returning strlit4013
  gc_frame_newslot(strlit4013);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4010;
  params[2] = bool4011;
  params[3] = bool4012;
  params[4] = strlit4013;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4014 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4008);
// compilenode returning call4014
    gc_frame_newslot(call4014);
    if4001 = call4014;
  }
// compilenode returning if4001
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4015 = gc_frame_new();
  if (strlit4016 == NULL) {
    strlit4016 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4016);
  }
// compilenode returning strlit4016
  gc_frame_newslot(strlit4016);
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4017 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4018 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4017);
// compilenode returning call4018
// compilenode returning call4018
  gc_frame_newslot(call4018);
  int callframe4019 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4020 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4019);
// compilenode returning call4020
// compilenode returning call4020
  gc_frame_newslot(call4020);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4016;
  params[1] = call4018;
  params[2] = call4020;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4021 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4015);
// compilenode returning call4021
    gc_frame_newslot(call4021);
    if3984 = call4021;
  } else {
  }
// compilenode returning if3984
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1220
  setline(1220);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4024 == NULL) {
    strlit4024 = alloc_String("rparen");
    gc_root(strlit4024);
  }
// compilenode returning strlit4024
  int op_slot_right_4023 = gc_frame_newslot(strlit4024);
  int callframe4026 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4027 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4026);
// compilenode returning call4027
// compilenode returning call4027
  int op_slot_left_4023 = gc_frame_newslot(call4027);
  params[0] = strlit4024;
  partcv[0] = 1;
  Object opresult4028 = callmethod(call4027, "!=", 1, partcv, params);
// compilenode returning opresult4028
  Object if4022 = done;
  if (istrue(opresult4028)) {
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4029 = gc_frame_new();
  partcv[0] = 0;
  Object call4030 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4029);
// compilenode returning call4030
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1222
  setline(1222);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4031 = gc_frame_new();
  int callframe4032 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4033 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4032);
// compilenode returning call4033
// compilenode returning call4033
  partcv[0] = 0;
  Object call4034 = callmethod(call4033, "new",
    1, partcv, params);
  gc_frame_end(callframe4031);
// compilenode returning call4034
// compilenode returning call4034
  *var_suggestion = call4034;
  if (call4034 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1223
  setline(1223);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4035 = gc_frame_new();
  if (strlit4036 == NULL) {
    strlit4036 = alloc_String(")");
    gc_root(strlit4036);
  }
// compilenode returning strlit4036
  gc_frame_newslot(strlit4036);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4036;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4037 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4035);
// compilenode returning call4037
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4038 = gc_frame_new();
  if (strlit4039 == NULL) {
    strlit4039 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4039);
  }
// compilenode returning strlit4039
  gc_frame_newslot(strlit4039);
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4040 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4041 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4040);
// compilenode returning call4041
// compilenode returning call4041
  gc_frame_newslot(call4041);
  int callframe4043 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4044 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4043);
// compilenode returning call4044
// compilenode returning call4044
  int op_slot_right_4042 = gc_frame_newslot(call4044);
  int callframe4046 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4047 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4046);
// compilenode returning call4047
// compilenode returning call4047
  int op_slot_left_4042 = gc_frame_newslot(call4047);
  params[0] = call4044;
  partcv[0] = 1;
  Object sum4048 = callmethod(call4047, "+", 1, partcv, params);
// compilenode returning sum4048
  gc_frame_newslot(sum4048);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4039;
  params[1] = call4041;
  params[2] = sum4048;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4049 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4038);
// compilenode returning call4049
    gc_frame_newslot(call4049);
    if4022 = call4049;
  } else {
  }
// compilenode returning if4022
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4050 = gc_frame_new();
  partcv[0] = 0;
  Object call4051 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4050);
// compilenode returning call4051
    gc_frame_newslot(call4051);
    if3978 = call4051;
  } else {
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4052 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4052
  *var_suggestions = array4052;
  if (array4052 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1230
  setline(1230);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4053 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4054 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4053);
// compilenode returning call4054
  *var_nextTok = call4054;
  if (call4054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4055 = gc_frame_new();
  int callframe4056 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4057 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4056);
// compilenode returning call4057
// compilenode returning call4057
  partcv[0] = 0;
  Object call4058 = callmethod(call4057, "new",
    1, partcv, params);
  gc_frame_end(callframe4055);
// compilenode returning call4058
// compilenode returning call4058
  *var_suggestion = call4058;
  if (call4058 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1232
  setline(1232);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4061 = alloc_Boolean(0);
// compilenode returning bool4061
  int op_slot_right_4060 = gc_frame_newslot(bool4061);
// compilenode returning *var_nextTok
  int op_slot_left_4060 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4061;
  partcv[0] = 1;
  Object opresult4063 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4063
  Object if4059 = done;
  if (istrue(opresult4063)) {
// Begin line 1233
  setline(1233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4064 = gc_frame_new();
  if (strlit4065 == NULL) {
    strlit4065 = alloc_String(" }");
    gc_root(strlit4065);
  }
// compilenode returning strlit4065
  gc_frame_newslot(strlit4065);
  int callframe4066 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call4067 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4066);
// compilenode returning call4067
// compilenode returning call4067
  gc_frame_newslot(call4067);
// compilenode returning *var_suggestion
  params[0] = strlit4065;
  params[1] = call4067;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4068 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4064);
// compilenode returning call4068
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4069 = gc_frame_new();
  if (strlit4070 == NULL) {
    strlit4070 = alloc_String(" {");
    gc_root(strlit4070);
  }
// compilenode returning strlit4070
  gc_frame_newslot(strlit4070);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4070;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4071 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4069);
// compilenode returning call4071
// Begin line 1235
  setline(1235);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4072 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4073 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4072);
// compilenode returning call4073
    gc_frame_newslot(call4073);
    if4059 = call4073;
  } else {
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1236
  setline(1236);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4075 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4075 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4077 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4077
  Object if4074 = done;
  if (istrue(opresult4077)) {
// Begin line 1237
  setline(1237);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4078 = gc_frame_new();
  if (strlit4079 == NULL) {
    strlit4079 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4079);
  }
// compilenode returning strlit4079
  gc_frame_newslot(strlit4079);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4079;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4080 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4078);
// compilenode returning call4080
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4081 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4082 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4081);
// compilenode returning call4082
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4083 = gc_frame_new();
  int callframe4084 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4085 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4084);
// compilenode returning call4085
// compilenode returning call4085
  partcv[0] = 0;
  Object call4086 = callmethod(call4085, "new",
    1, partcv, params);
  gc_frame_end(callframe4083);
// compilenode returning call4086
// compilenode returning call4086
  *var_suggestion = call4086;
  if (call4086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4088 = gc_frame_new();
  if (strlit4089 == NULL) {
    strlit4089 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4089);
  }
// compilenode returning strlit4089
  gc_frame_newslot(strlit4089);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4089;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4090 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4088);
// compilenode returning call4090
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4091 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4092 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4091);
// compilenode returning call4092
    gc_frame_newslot(call4092);
    if4074 = call4092;
  } else {
// Begin line 1243
  setline(1243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4093 = gc_frame_new();
  if (strlit4094 == NULL) {
    strlit4094 = alloc_String(" }");
    gc_root(strlit4094);
  }
// compilenode returning strlit4094
  gc_frame_newslot(strlit4094);
  int callframe4095 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4096 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4095);
// compilenode returning call4096
// compilenode returning call4096
  gc_frame_newslot(call4096);
// compilenode returning *var_suggestion
  params[0] = strlit4094;
  params[1] = call4096;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4097 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4093);
// compilenode returning call4097
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4098 = gc_frame_new();
  if (strlit4099 == NULL) {
    strlit4099 = alloc_String(" {");
    gc_root(strlit4099);
  }
// compilenode returning strlit4099
  gc_frame_newslot(strlit4099);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4099;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4100 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4098);
// compilenode returning call4100
// Begin line 1245
  setline(1245);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4101 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4102 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4101);
// compilenode returning call4102
    gc_frame_newslot(call4102);
    if4074 = call4102;
  }
// compilenode returning if4074
    gc_frame_newslot(if4074);
    if4059 = if4074;
  }
// compilenode returning if4059
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4103 = gc_frame_new();
  if (strlit4104 == NULL) {
    strlit4104 = alloc_String("A try-finally statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4104);
  }
// compilenode returning strlit4104
  gc_frame_newslot(strlit4104);
// Begin line 1248
  setline(1248);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4105 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4106 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4105);
// compilenode returning call4106
// compilenode returning call4106
  gc_frame_newslot(call4106);
  int callframe4107 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4108 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4107);
// compilenode returning call4108
// compilenode returning call4108
  gc_frame_newslot(call4108);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1247
  setline(1247);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4104;
  params[1] = call4106;
  params[2] = call4108;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4109 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4103);
// compilenode returning call4109
    gc_frame_newslot(call4109);
    if3978 = call4109;
  }
// compilenode returning if3978
    gc_frame_newslot(if3978);
    if3972 = if3978;
  }
// compilenode returning if3972
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4110 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call4111 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4110);
// compilenode returning call4111
// compilenode returning call4111
  *var_finally = call4111;
  if (call4111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if3957 = done;
  } else {
  }
// compilenode returning if3957
// Begin line 1252
  setline(1252);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4113 = gc_frame_new();
  int callframe4114 = gc_frame_new();
// compilenode returning *var_mainblock
  gc_frame_newslot(*var_mainblock);
// compilenode returning *var_cases
  gc_frame_newslot(*var_cases);
// compilenode returning *var_finally
  gc_frame_newslot(*var_finally);
  int callframe4115 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call4116 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4115);
// compilenode returning call4116
// compilenode returning call4116
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4117 = callmethod(call4116, "new",
    1, partcv, params);
  gc_frame_end(callframe4114);
// compilenode returning call4117
  gc_frame_newslot(call4117);
// compilenode returning *var_values
  params[0] = call4117;
  partcv[0] = 1;
  Object call4118 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4113);
// compilenode returning call4118
// Begin line 1254
  setline(1254);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localmin
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4169(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_catchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4173 == NULL) {
    strlit4173 = alloc_String("case");
    gc_root(strlit4173);
  }
// compilenode returning strlit4173
  int op_slot_right_4172 = gc_frame_newslot(strlit4173);
  int callframe4175 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4176 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4175);
// compilenode returning call4176
// compilenode returning call4176
  int op_slot_left_4172 = gc_frame_newslot(call4176);
  params[0] = strlit4173;
  partcv[0] = 1;
  Object opresult4177 = callmethod(call4176, "==", 1, partcv, params);
// compilenode returning opresult4177
  int op_slot_right_4171 = gc_frame_newslot(opresult4177);
  if (strlit4180 == NULL) {
    strlit4180 = alloc_String("identifier");
    gc_root(strlit4180);
  }
// compilenode returning strlit4180
  int op_slot_right_4179 = gc_frame_newslot(strlit4180);
  int callframe4182 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4183 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4182);
// compilenode returning call4183
// compilenode returning call4183
  int op_slot_left_4179 = gc_frame_newslot(call4183);
  params[0] = strlit4180;
  partcv[0] = 1;
  Object opresult4184 = callmethod(call4183, "==", 1, partcv, params);
// compilenode returning opresult4184
  int op_slot_left_4171 = gc_frame_newslot(opresult4184);
  params[0] = opresult4177;
  partcv[0] = 1;
  Object opresult4185 = callmethod(opresult4184, "&&", 1, partcv, params);
// compilenode returning opresult4185
  int op_slot_right_4170 = gc_frame_newslot(opresult4185);
// Begin line 1272
  setline(1272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4190 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call4191 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4190);
// compilenode returning call4191
// compilenode returning call4191
  int op_slot_right_4189 = gc_frame_newslot(call4191);
  int callframe4193 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4194 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4193);
// compilenode returning call4194
// compilenode returning call4194
  int op_slot_left_4189 = gc_frame_newslot(call4194);
  params[0] = call4191;
  partcv[0] = 1;
  Object opresult4195 = callmethod(call4194, "==", 1, partcv, params);
// compilenode returning opresult4195
  int op_slot_right_4188 = gc_frame_newslot(opresult4195);
  if (strlit4198 == NULL) {
    strlit4198 = alloc_String("rparen");
    gc_root(strlit4198);
  }
// compilenode returning strlit4198
  int op_slot_right_4197 = gc_frame_newslot(strlit4198);
  int callframe4200 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4201 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4200);
// compilenode returning call4201
// compilenode returning call4201
  int op_slot_left_4197 = gc_frame_newslot(call4201);
  params[0] = strlit4198;
  partcv[0] = 1;
  Object opresult4202 = callmethod(call4201, "==", 1, partcv, params);
// compilenode returning opresult4202
  int op_slot_left_4188 = gc_frame_newslot(opresult4202);
  params[0] = opresult4195;
  partcv[0] = 1;
  Object opresult4203 = callmethod(opresult4202, "&&", 1, partcv, params);
// compilenode returning opresult4203
  int op_slot_right_4187 = gc_frame_newslot(opresult4203);
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4206 == NULL) {
    strlit4206 = alloc_String("rbrace");
    gc_root(strlit4206);
  }
// compilenode returning strlit4206
  int op_slot_right_4205 = gc_frame_newslot(strlit4206);
  int callframe4208 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4209 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4208);
// compilenode returning call4209
// compilenode returning call4209
  int op_slot_left_4205 = gc_frame_newslot(call4209);
  params[0] = strlit4206;
  partcv[0] = 1;
  Object opresult4210 = callmethod(call4209, "==", 1, partcv, params);
// compilenode returning opresult4210
  int op_slot_left_4187 = gc_frame_newslot(opresult4210);
  params[0] = opresult4203;
  partcv[0] = 1;
  Object opresult4211 = callmethod(opresult4210, "||", 1, partcv, params);
// compilenode returning opresult4211
  int op_slot_left_4170 = gc_frame_newslot(opresult4211);
  params[0] = opresult4185;
  partcv[0] = 1;
  Object opresult4212 = callmethod(opresult4211, "||", 1, partcv, params);
// compilenode returning opresult4212
  gc_frame_end(frame);
  return opresult4212;
}
Object meth_parser__apply4287(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe4288 = gc_frame_new();
  partcv[0] = 0;
  Object call4289 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4288);
// compilenode returning call4289
  gc_frame_end(frame);
  return call4289;
}
Object meth_parser__apply4357(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit4360 == NULL) {
    strlit4360 = alloc_String("case");
    gc_root(strlit4360);
  }
// compilenode returning strlit4360
  int op_slot_right_4359 = gc_frame_newslot(strlit4360);
  int callframe4362 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4363 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4362);
// compilenode returning call4363
// compilenode returning call4363
  int op_slot_left_4359 = gc_frame_newslot(call4363);
  params[0] = strlit4360;
  partcv[0] = 1;
  Object opresult4364 = callmethod(call4363, "==", 1, partcv, params);
// compilenode returning opresult4364
  int op_slot_right_4358 = gc_frame_newslot(opresult4364);
  int callframe4366 = gc_frame_new();
  if (strlit4367 == NULL) {
    strlit4367 = alloc_String("identifier");
    gc_root(strlit4367);
  }
// compilenode returning strlit4367
  gc_frame_newslot(strlit4367);
  params[0] = strlit4367;
  partcv[0] = 1;
  Object call4368 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4366);
// compilenode returning call4368
  int op_slot_left_4358 = gc_frame_newslot(call4368);
  params[0] = opresult4364;
  partcv[0] = 1;
  Object opresult4369 = callmethod(call4368, "&&", 1, partcv, params);
// compilenode returning opresult4369
  gc_frame_end(frame);
  return opresult4369;
}
Object meth_parser__apply4391(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe4392 = gc_frame_new();
  partcv[0] = 0;
  Object call4393 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4392);
// compilenode returning call4393
  gc_frame_end(frame);
  return call4393;
}
Object meth_parser__apply4372(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_tokens = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_cases = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1316
  setline(1316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4373 = gc_frame_new();
  partcv[0] = 0;
  Object call4374 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4373);
// compilenode returning call4374
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4376 = gc_frame_new();
  if (strlit4377 == NULL) {
    strlit4377 = alloc_String("lbrace");
    gc_root(strlit4377);
  }
// compilenode returning strlit4377
  gc_frame_newslot(strlit4377);
  params[0] = strlit4377;
  partcv[0] = 1;
  Object call4378 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4376);
// compilenode returning call4378
  Object if4375 = done;
  if (istrue(call4378)) {
// Begin line 1318
  setline(1318);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4379 = gc_frame_new();
  partcv[0] = 0;
  Object call4380 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4379);
// compilenode returning call4380
    gc_frame_newslot(call4380);
    if4375 = call4380;
  } else {
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1319
  setline(1319);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4382 = gc_frame_new();
  if (strlit4383 == NULL) {
    strlit4383 = alloc_String("lparen");
    gc_root(strlit4383);
  }
// compilenode returning strlit4383
  gc_frame_newslot(strlit4383);
  params[0] = strlit4383;
  partcv[0] = 1;
  Object call4384 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4382);
// compilenode returning call4384
  Object if4381 = done;
  if (istrue(call4384)) {
// Begin line 1320
  setline(1320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4385 = gc_frame_new();
  partcv[0] = 0;
  Object call4386 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4385);
// compilenode returning call4386
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4388 = gc_frame_new();
  int callframe4389 = gc_frame_new();
  Object block4390 = alloc_Block(NULL, NULL, "parser", 1321);
  gc_frame_newslot(block4390);
  block_savedest(block4390);
  Object closure4391 = createclosure(1, "_apply");
setclosureframe(closure4391, stackframe);
  addtoclosure(closure4391, selfslot);
  struct UserObject *uo4391 = (struct UserObject*)block4390;
  uo4391->data[0] = (Object)closure4391;
  Method *meth_meth_parser__apply4391 = addmethod2pos(block4390, "_apply", &meth_parser__apply4391, 0);
int argcv_meth_parser__apply4391[] = {0};
meth_meth_parser__apply4391->type = alloc_MethodType(1, argcv_meth_parser__apply4391);
  meth_meth_parser__apply4391->definitionModule = modulename;
  meth_meth_parser__apply4391->definitionLine = 1321;
// compilenode returning block4390
  gc_frame_newslot(block4390);
  params[0] = block4390;
  partcv[0] = 1;
  Object call4395 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4389);
// compilenode returning call4395
  partcv[0] = 0;
  Object call4396 = callmethod(call4395, "not",
    1, partcv, params);
  gc_frame_end(callframe4388);
// compilenode returning call4396
// compilenode returning call4396
  Object if4387 = done;
  if (istrue(call4396)) {
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4397 = gc_frame_new();
  int callframe4398 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4399 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4398);
// compilenode returning call4399
// compilenode returning call4399
  partcv[0] = 0;
  Object call4400 = callmethod(call4399, "new",
    1, partcv, params);
  gc_frame_end(callframe4397);
// compilenode returning call4400
// compilenode returning call4400
  *var_suggestion = call4400;
  if (call4400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4401 = gc_frame_new();
  if (strlit4402 == NULL) {
    strlit4402 = alloc_String("rparen");
    gc_root(strlit4402);
  }
// compilenode returning strlit4402
  gc_frame_newslot(strlit4402);
  params[0] = strlit4402;
  partcv[0] = 1;
  Object call4403 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4401);
// compilenode returning call4403
  *var_nextTok = call4403;
  if (call4403 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4405 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4405 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4407 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4407
  Object if4404 = done;
  if (istrue(opresult4407)) {
// Begin line 1325
  setline(1325);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4408 = gc_frame_new();
  if (strlit4409 == NULL) {
    strlit4409 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4409);
  }
// compilenode returning strlit4409
  gc_frame_newslot(strlit4409);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4409;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4410 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4408);
// compilenode returning call4410
    gc_frame_newslot(call4410);
    if4404 = call4410;
  } else {
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4411 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4412 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4413 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4412);
// compilenode returning call4413
// compilenode returning call4413
  gc_frame_newslot(call4413);
  Object bool4414 = alloc_Boolean(1);
// compilenode returning bool4414
  gc_frame_newslot(bool4414);
  Object bool4415 = alloc_Boolean(0);
// compilenode returning bool4415
  gc_frame_newslot(bool4415);
  if (strlit4416 == NULL) {
    strlit4416 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4416);
  }
// compilenode returning strlit4416
  gc_frame_newslot(strlit4416);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4413;
  params[2] = bool4414;
  params[3] = bool4415;
  params[4] = strlit4416;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4417 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4411);
// compilenode returning call4417
    gc_frame_newslot(call4417);
    if4404 = call4417;
  }
// compilenode returning if4404
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4418 = gc_frame_new();
  if (strlit4419 == NULL) {
    strlit4419 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4419);
  }
// compilenode returning strlit4419
  gc_frame_newslot(strlit4419);
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4420 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4421 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4420);
// compilenode returning call4421
// compilenode returning call4421
  gc_frame_newslot(call4421);
  int callframe4422 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4423 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4422);
// compilenode returning call4423
// compilenode returning call4423
  gc_frame_newslot(call4423);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4419;
  params[1] = call4421;
  params[2] = call4423;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4424 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4418);
// compilenode returning call4424
    gc_frame_newslot(call4424);
    if4387 = call4424;
  } else {
  }
// compilenode returning if4387
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1332
  setline(1332);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4427 == NULL) {
    strlit4427 = alloc_String("rparen");
    gc_root(strlit4427);
  }
// compilenode returning strlit4427
  int op_slot_right_4426 = gc_frame_newslot(strlit4427);
  int callframe4429 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4430 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4429);
// compilenode returning call4430
// compilenode returning call4430
  int op_slot_left_4426 = gc_frame_newslot(call4430);
  params[0] = strlit4427;
  partcv[0] = 1;
  Object opresult4431 = callmethod(call4430, "!=", 1, partcv, params);
// compilenode returning opresult4431
  Object if4425 = done;
  if (istrue(opresult4431)) {
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4432 = gc_frame_new();
  partcv[0] = 0;
  Object call4433 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4432);
// compilenode returning call4433
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4434 = gc_frame_new();
  int callframe4435 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4436 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4435);
// compilenode returning call4436
// compilenode returning call4436
  partcv[0] = 0;
  Object call4437 = callmethod(call4436, "new",
    1, partcv, params);
  gc_frame_end(callframe4434);
// compilenode returning call4437
// compilenode returning call4437
  *var_suggestion = call4437;
  if (call4437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1335
  setline(1335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4438 = gc_frame_new();
  if (strlit4439 == NULL) {
    strlit4439 = alloc_String(")");
    gc_root(strlit4439);
  }
// compilenode returning strlit4439
  gc_frame_newslot(strlit4439);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4439;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4440 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4438);
// compilenode returning call4440
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4441 = gc_frame_new();
  if (strlit4442 == NULL) {
    strlit4442 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4442);
  }
// compilenode returning strlit4442
  gc_frame_newslot(strlit4442);
// Begin line 1337
  setline(1337);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4443 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4444 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4443);
// compilenode returning call4444
// compilenode returning call4444
  gc_frame_newslot(call4444);
  int callframe4446 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4447 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4446);
// compilenode returning call4447
// compilenode returning call4447
  int op_slot_right_4445 = gc_frame_newslot(call4447);
  int callframe4449 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4450 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4449);
// compilenode returning call4450
// compilenode returning call4450
  int op_slot_left_4445 = gc_frame_newslot(call4450);
  params[0] = call4447;
  partcv[0] = 1;
  Object sum4451 = callmethod(call4450, "+", 1, partcv, params);
// compilenode returning sum4451
  gc_frame_newslot(sum4451);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1336
  setline(1336);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4442;
  params[1] = call4444;
  params[2] = sum4451;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4452 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4441);
// compilenode returning call4452
    gc_frame_newslot(call4452);
    if4425 = call4452;
  } else {
  }
// compilenode returning if4425
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4453 = gc_frame_new();
  partcv[0] = 0;
  Object call4454 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4453);
// compilenode returning call4454
    gc_frame_newslot(call4454);
    if4381 = call4454;
  } else {
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4455 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4455
  *var_suggestions = array4455;
  if (array4455 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4456 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4457 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4456);
// compilenode returning call4457
  *var_nextTok = call4457;
  if (call4457 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4458 = gc_frame_new();
  int callframe4459 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4460 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4459);
// compilenode returning call4460
// compilenode returning call4460
  partcv[0] = 0;
  Object call4461 = callmethod(call4460, "new",
    1, partcv, params);
  gc_frame_end(callframe4458);
// compilenode returning call4461
// compilenode returning call4461
  *var_suggestion = call4461;
  if (call4461 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4464 = alloc_Boolean(0);
// compilenode returning bool4464
  int op_slot_right_4463 = gc_frame_newslot(bool4464);
// compilenode returning *var_nextTok
  int op_slot_left_4463 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4464;
  partcv[0] = 1;
  Object opresult4466 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4466
  Object if4462 = done;
  if (istrue(opresult4466)) {
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4467 = gc_frame_new();
  if (strlit4468 == NULL) {
    strlit4468 = alloc_String(" }");
    gc_root(strlit4468);
  }
// compilenode returning strlit4468
  gc_frame_newslot(strlit4468);
  int callframe4469 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call4470 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4469);
// compilenode returning call4470
// compilenode returning call4470
  gc_frame_newslot(call4470);
// compilenode returning *var_suggestion
  params[0] = strlit4468;
  params[1] = call4470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4471 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4467);
// compilenode returning call4471
// Begin line 1346
  setline(1346);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4472 = gc_frame_new();
  if (strlit4473 == NULL) {
    strlit4473 = alloc_String(" {");
    gc_root(strlit4473);
  }
// compilenode returning strlit4473
  gc_frame_newslot(strlit4473);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4473;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4474 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4472);
// compilenode returning call4474
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4475 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4476 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4475);
// compilenode returning call4476
    gc_frame_newslot(call4476);
    if4462 = call4476;
  } else {
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1348
  setline(1348);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4478 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4478 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4480 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4480
  Object if4477 = done;
  if (istrue(opresult4480)) {
// Begin line 1349
  setline(1349);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4481 = gc_frame_new();
  if (strlit4482 == NULL) {
    strlit4482 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4482);
  }
// compilenode returning strlit4482
  gc_frame_newslot(strlit4482);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4482;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4483 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4481);
// compilenode returning call4483
// Begin line 1350
  setline(1350);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4484 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4485 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4484);
// compilenode returning call4485
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1351
  setline(1351);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4486 = gc_frame_new();
  int callframe4487 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4488 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4487);
// compilenode returning call4488
// compilenode returning call4488
  partcv[0] = 0;
  Object call4489 = callmethod(call4488, "new",
    1, partcv, params);
  gc_frame_end(callframe4486);
// compilenode returning call4489
// compilenode returning call4489
  *var_suggestion = call4489;
  if (call4489 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4491 = gc_frame_new();
  if (strlit4492 == NULL) {
    strlit4492 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit4492);
  }
// compilenode returning strlit4492
  gc_frame_newslot(strlit4492);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4492;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4493 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4491);
// compilenode returning call4493
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4494 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4495 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4494);
// compilenode returning call4495
    gc_frame_newslot(call4495);
    if4477 = call4495;
  } else {
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4496 = gc_frame_new();
  if (strlit4497 == NULL) {
    strlit4497 = alloc_String(" }");
    gc_root(strlit4497);
  }
// compilenode returning strlit4497
  gc_frame_newslot(strlit4497);
  int callframe4498 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4499 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4498);
// compilenode returning call4499
// compilenode returning call4499
  gc_frame_newslot(call4499);
// compilenode returning *var_suggestion
  params[0] = strlit4497;
  params[1] = call4499;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4500 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4496);
// compilenode returning call4500
// Begin line 1356
  setline(1356);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4501 = gc_frame_new();
  if (strlit4502 == NULL) {
    strlit4502 = alloc_String(" {");
    gc_root(strlit4502);
  }
// compilenode returning strlit4502
  gc_frame_newslot(strlit4502);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4502;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4503 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4501);
// compilenode returning call4503
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4504 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4505 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4504);
// compilenode returning call4505
    gc_frame_newslot(call4505);
    if4477 = call4505;
  }
// compilenode returning if4477
    gc_frame_newslot(if4477);
    if4462 = if4477;
  }
// compilenode returning if4462
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4506 = gc_frame_new();
  if (strlit4507 == NULL) {
    strlit4507 = alloc_String("A catch statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4507);
  }
// compilenode returning strlit4507
  gc_frame_newslot(strlit4507);
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4508 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4509 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4508);
// compilenode returning call4509
// compilenode returning call4509
  gc_frame_newslot(call4509);
  int callframe4510 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4511 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4510);
// compilenode returning call4511
// compilenode returning call4511
  gc_frame_newslot(call4511);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4507;
  params[1] = call4509;
  params[2] = call4511;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4512 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4506);
// compilenode returning call4512
    gc_frame_newslot(call4512);
    if4381 = call4512;
  }
// compilenode returning if4381
    gc_frame_newslot(if4381);
    if4375 = if4381;
  }
// compilenode returning if4375
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4513 = gc_frame_new();
  int callframe4514 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call4515 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4514);
// compilenode returning call4515
// compilenode returning call4515
  gc_frame_newslot(call4515);
// compilenode returning *var_cases
  params[0] = call4515;
  partcv[0] = 1;
  Object call4516 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe4513);
// compilenode returning call4516
  gc_frame_end(frame);
  return call4516;
}
Object meth_parser__apply4550(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe4551 = gc_frame_new();
  partcv[0] = 0;
  Object call4552 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4551);
// compilenode returning call4552
  gc_frame_end(frame);
  return call4552;
}
Object meth_parser_catchcase4120(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(17, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "catchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_util = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_tokens = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for catchcase (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for catchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_catchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "catchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_mainblock = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "mainblock");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_finally = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "finally");
  Object *var_suggestions = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "suggestions");
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1256
  setline(1256);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4122 = gc_frame_new();
  if (strlit4125 == NULL) {
    strlit4125 = alloc_String("catch");
    gc_root(strlit4125);
  }
// compilenode returning strlit4125
  int op_slot_right_4124 = gc_frame_newslot(strlit4125);
  int callframe4127 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4128 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4127);
// compilenode returning call4128
// compilenode returning call4128
  int op_slot_left_4124 = gc_frame_newslot(call4128);
  params[0] = strlit4125;
  partcv[0] = 1;
  Object opresult4129 = callmethod(call4128, "==", 1, partcv, params);
// compilenode returning opresult4129
  int op_slot_right_4123 = gc_frame_newslot(opresult4129);
  int callframe4131 = gc_frame_new();
  if (strlit4132 == NULL) {
    strlit4132 = alloc_String("identifier");
    gc_root(strlit4132);
  }
// compilenode returning strlit4132
  gc_frame_newslot(strlit4132);
  params[0] = strlit4132;
  partcv[0] = 1;
  Object call4133 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4131);
// compilenode returning call4133
  int op_slot_left_4123 = gc_frame_newslot(call4133);
  params[0] = opresult4129;
  partcv[0] = 1;
  Object opresult4134 = callmethod(call4133, "&&", 1, partcv, params);
// compilenode returning opresult4134
  partcv[0] = 0;
  Object call4135 = callmethod(opresult4134, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4122);
// compilenode returning call4135
  Object if4121 = done;
  if (istrue(call4135)) {
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4136 = alloc_Float64(0);
// compilenode returning num4136
  return num4136;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if4121 = undefined;
  } else {
  }
// compilenode returning if4121
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1260
  setline(1260);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_catchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4137 = gc_frame_new();
  partcv[0] = 0;
  Object call4138 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4137);
// compilenode returning call4138
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4139 = gc_frame_new();
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4141 == NULL) {
    strlit4141 = alloc_String("instead.");
    gc_root(strlit4141);
  }
// compilenode returning strlit4141
  int op_slot_right_4140 = gc_frame_newslot(strlit4141);
// Begin line 1263
  setline(1263);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4144 == NULL) {
    strlit4144 = alloc_String("removed in a future version of the compiler. Use try-catch ");
    gc_root(strlit4144);
  }
// compilenode returning strlit4144
  int op_slot_right_4143 = gc_frame_newslot(strlit4144);
// Begin line 1262
  setline(1262);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4146 == NULL) {
    strlit4146 = alloc_String("The catch-case statement is deprecated and will be ");
    gc_root(strlit4146);
  }
// compilenode returning strlit4146
  int op_slot_left_4143 = gc_frame_newslot(strlit4146);
  params[0] = strlit4144;
  partcv[0] = 1;
  Object opresult4147 = callmethod(strlit4146, "++", 1, partcv, params);
// compilenode returning opresult4147
  int op_slot_left_4140 = gc_frame_newslot(opresult4147);
  params[0] = strlit4141;
  partcv[0] = 1;
  Object opresult4148 = callmethod(opresult4147, "++", 1, partcv, params);
// compilenode returning opresult4148
  gc_frame_newslot(opresult4148);
// compilenode returning *var_util
  params[0] = opresult4148;
  partcv[0] = 1;
  Object call4149 = callmethod(*var_util, "warning",
    1, partcv, params);
  gc_frame_end(callframe4139);
// compilenode returning call4149
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4151 = gc_frame_new();
  if (strlit4152 == NULL) {
    strlit4152 = alloc_String("lbrace");
    gc_root(strlit4152);
  }
// compilenode returning strlit4152
  gc_frame_newslot(strlit4152);
  params[0] = strlit4152;
  partcv[0] = 1;
  Object call4153 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4151);
// compilenode returning call4153
  Object if4150 = done;
  if (istrue(call4153)) {
// Begin line 1266
  setline(1266);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4154 = gc_frame_new();
  partcv[0] = 0;
  Object call4155 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4154);
// compilenode returning call4155
    gc_frame_newslot(call4155);
    if4150 = call4155;
  } else {
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1268
  setline(1268);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4158 == NULL) {
    strlit4158 = alloc_String("lparen");
    gc_root(strlit4158);
  }
// compilenode returning strlit4158
  int op_slot_right_4157 = gc_frame_newslot(strlit4158);
  int callframe4160 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4161 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4160);
// compilenode returning call4161
// compilenode returning call4161
  int op_slot_left_4157 = gc_frame_newslot(call4161);
  params[0] = strlit4158;
  partcv[0] = 1;
  Object opresult4162 = callmethod(call4161, "!=", 1, partcv, params);
// compilenode returning opresult4162
  Object if4156 = done;
  if (istrue(opresult4162)) {
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1269
  setline(1269);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4163 = gc_frame_new();
  int callframe4164 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4165 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4164);
// compilenode returning call4165
// compilenode returning call4165
  partcv[0] = 0;
  Object call4166 = callmethod(call4165, "new",
    1, partcv, params);
  gc_frame_end(callframe4163);
// compilenode returning call4166
// compilenode returning call4166
  *var_suggestion = call4166;
  if (call4166 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4167 = gc_frame_new();
  Object block4168 = alloc_Block(NULL, NULL, "parser", 1271);
  gc_frame_newslot(block4168);
  block_savedest(block4168);
  Object closure4169 = createclosure(2, "_apply");
setclosureframe(closure4169, stackframe);
  addtoclosure(closure4169, var_catchTok);
  addtoclosure(closure4169, selfslot);
  struct UserObject *uo4169 = (struct UserObject*)block4168;
  uo4169->data[0] = (Object)closure4169;
  Method *meth_meth_parser__apply4169 = addmethod2pos(block4168, "_apply", &meth_parser__apply4169, 0);
int argcv_meth_parser__apply4169[] = {1};
meth_meth_parser__apply4169->type = alloc_MethodType(1, argcv_meth_parser__apply4169);
  meth_meth_parser__apply4169->definitionModule = modulename;
  meth_meth_parser__apply4169->definitionLine = 1269;
// compilenode returning block4168
  gc_frame_newslot(block4168);
  params[0] = block4168;
  partcv[0] = 1;
  Object call4214 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4167);
// compilenode returning call4214
  *var_nextTok = call4214;
  if (call4214 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1274
  setline(1274);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4217 = alloc_Boolean(0);
// compilenode returning bool4217
  int op_slot_right_4216 = gc_frame_newslot(bool4217);
// compilenode returning *var_nextTok
  int op_slot_left_4216 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4217;
  partcv[0] = 1;
  Object opresult4219 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4219
  Object if4215 = done;
  if (istrue(opresult4219)) {
// Begin line 1275
  setline(1275);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4220 = gc_frame_new();
  if (strlit4221 == NULL) {
    strlit4221 = alloc_String(" {}");
    gc_root(strlit4221);
  }
// compilenode returning strlit4221
  gc_frame_newslot(strlit4221);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit4221;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4222 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4220);
// compilenode returning call4222
    gc_frame_newslot(call4222);
    if4215 = call4222;
  } else {
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4225 == NULL) {
    strlit4225 = alloc_String("rbrace");
    gc_root(strlit4225);
  }
// compilenode returning strlit4225
  int op_slot_right_4224 = gc_frame_newslot(strlit4225);
  int callframe4227 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4228 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4227);
// compilenode returning call4228
// compilenode returning call4228
  int op_slot_left_4224 = gc_frame_newslot(call4228);
  params[0] = strlit4225;
  partcv[0] = 1;
  Object opresult4229 = callmethod(call4228, "==", 1, partcv, params);
// compilenode returning opresult4229
  Object if4223 = done;
  if (istrue(opresult4229)) {
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4230 = gc_frame_new();
  if (strlit4231 == NULL) {
    strlit4231 = alloc_String(" {");
    gc_root(strlit4231);
  }
// compilenode returning strlit4231
  gc_frame_newslot(strlit4231);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit4231;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4232 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4230);
// compilenode returning call4232
    gc_frame_newslot(call4232);
    if4223 = call4232;
  } else {
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4235 == NULL) {
    strlit4235 = alloc_String("rparen");
    gc_root(strlit4235);
  }
// compilenode returning strlit4235
  int op_slot_right_4234 = gc_frame_newslot(strlit4235);
  int callframe4237 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4238 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4237);
// compilenode returning call4238
// compilenode returning call4238
  int op_slot_left_4234 = gc_frame_newslot(call4238);
  params[0] = strlit4235;
  partcv[0] = 1;
  Object opresult4239 = callmethod(call4238, "==", 1, partcv, params);
// compilenode returning opresult4239
  Object if4233 = done;
  if (istrue(opresult4239)) {
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4241 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4241 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4243 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4243
  Object if4240 = done;
  if (istrue(opresult4243)) {
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4244 = gc_frame_new();
  if (strlit4245 == NULL) {
    strlit4245 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4245);
  }
// compilenode returning strlit4245
  gc_frame_newslot(strlit4245);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool4246 = alloc_Boolean(1);
// compilenode returning bool4246
  gc_frame_newslot(bool4246);
// compilenode returning *var_suggestion
  params[0] = strlit4245;
  params[1] = *var_lastToken;
  params[2] = bool4246;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4247 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4244);
// compilenode returning call4247
    gc_frame_newslot(call4247);
    if4240 = call4247;
  } else {
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4248 = gc_frame_new();
  if (strlit4249 == NULL) {
    strlit4249 = alloc_String("(");
    gc_root(strlit4249);
  }
// compilenode returning strlit4249
  gc_frame_newslot(strlit4249);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool4250 = alloc_Boolean(1);
// compilenode returning bool4250
  gc_frame_newslot(bool4250);
// compilenode returning *var_suggestion
  params[0] = strlit4249;
  params[1] = *var_lastToken;
  params[2] = bool4250;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4251 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4248);
// compilenode returning call4251
    gc_frame_newslot(call4251);
    if4240 = call4251;
  }
// compilenode returning if4240
    gc_frame_newslot(if4240);
    if4233 = if4240;
  } else {
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4254 == NULL) {
    strlit4254 = alloc_String("identifier");
    gc_root(strlit4254);
  }
// compilenode returning strlit4254
  int op_slot_right_4253 = gc_frame_newslot(strlit4254);
  int callframe4256 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4257 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4256);
// compilenode returning call4257
// compilenode returning call4257
  int op_slot_left_4253 = gc_frame_newslot(call4257);
  params[0] = strlit4254;
  partcv[0] = 1;
  Object opresult4258 = callmethod(call4257, "==", 1, partcv, params);
// compilenode returning opresult4258
  Object if4252 = done;
  if (istrue(opresult4258)) {
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4259 = gc_frame_new();
  if (strlit4260 == NULL) {
    strlit4260 = alloc_String(" {");
    gc_root(strlit4260);
  }
// compilenode returning strlit4260
  gc_frame_newslot(strlit4260);
// compilenode returning *var_catchTok
  gc_frame_newslot(*var_catchTok);
// compilenode returning *var_suggestion
  params[0] = strlit4260;
  params[1] = *var_catchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4261 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4259);
// compilenode returning call4261
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4262 = gc_frame_new();
  if (strlit4263 == NULL) {
    strlit4263 = alloc_String("} ");
    gc_root(strlit4263);
  }
// compilenode returning strlit4263
  gc_frame_newslot(strlit4263);
// compilenode returning *var_nextTok
  gc_frame_newslot(*var_nextTok);
// compilenode returning *var_suggestion
  params[0] = strlit4263;
  params[1] = *var_nextTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4264 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4262);
// compilenode returning call4264
    gc_frame_newslot(call4264);
    if4252 = call4264;
  } else {
  }
// compilenode returning if4252
    gc_frame_newslot(if4252);
    if4233 = if4252;
  }
// compilenode returning if4233
    gc_frame_newslot(if4233);
    if4223 = if4233;
  }
// compilenode returning if4223
    gc_frame_newslot(if4223);
    if4215 = if4223;
  }
// compilenode returning if4215
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4265 = gc_frame_new();
  if (strlit4266 == NULL) {
    strlit4266 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4266);
  }
// compilenode returning strlit4266
  gc_frame_newslot(strlit4266);
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4267 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call4268 = callmethod(*var_catchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4267);
// compilenode returning call4268
// compilenode returning call4268
  gc_frame_newslot(call4268);
  Object num4270 = alloc_Float64(1);
// compilenode returning num4270
  int op_slot_right_4269 = gc_frame_newslot(num4270);
  int callframe4273 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call4274 = callmethod(*var_catchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4273);
// compilenode returning call4274
// compilenode returning call4274
  int op_slot_right_4272 = gc_frame_newslot(call4274);
  int callframe4276 = gc_frame_new();
// compilenode returning *var_catchTok
  partcv[0] = 0;
  Object call4277 = callmethod(*var_catchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4276);
// compilenode returning call4277
// compilenode returning call4277
  int op_slot_left_4272 = gc_frame_newslot(call4277);
  params[0] = call4274;
  partcv[0] = 1;
  Object sum4278 = callmethod(call4277, "+", 1, partcv, params);
// compilenode returning sum4278
  int op_slot_left_4269 = gc_frame_newslot(sum4278);
  params[0] = num4270;
  partcv[0] = 1;
  Object sum4279 = callmethod(sum4278, "+", 1, partcv, params);
// compilenode returning sum4279
  gc_frame_newslot(sum4279);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4266;
  params[1] = call4268;
  params[2] = sum4279;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4280 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4265);
// compilenode returning call4280
    gc_frame_newslot(call4280);
    if4156 = call4280;
  } else {
  }
// compilenode returning if4156
// Begin line 1291
  setline(1291);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4281 = gc_frame_new();
  partcv[0] = 0;
  Object call4282 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4281);
// compilenode returning call4282
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4284 = gc_frame_new();
  int callframe4285 = gc_frame_new();
  Object block4286 = alloc_Block(NULL, NULL, "parser", 1292);
  gc_frame_newslot(block4286);
  block_savedest(block4286);
  Object closure4287 = createclosure(1, "_apply");
setclosureframe(closure4287, stackframe);
  addtoclosure(closure4287, selfslot);
  struct UserObject *uo4287 = (struct UserObject*)block4286;
  uo4287->data[0] = (Object)closure4287;
  Method *meth_meth_parser__apply4287 = addmethod2pos(block4286, "_apply", &meth_parser__apply4287, 0);
int argcv_meth_parser__apply4287[] = {0};
meth_meth_parser__apply4287->type = alloc_MethodType(1, argcv_meth_parser__apply4287);
  meth_meth_parser__apply4287->definitionModule = modulename;
  meth_meth_parser__apply4287->definitionLine = 1292;
// compilenode returning block4286
  gc_frame_newslot(block4286);
  params[0] = block4286;
  partcv[0] = 1;
  Object call4291 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4285);
// compilenode returning call4291
  partcv[0] = 0;
  Object call4292 = callmethod(call4291, "not",
    1, partcv, params);
  gc_frame_end(callframe4284);
// compilenode returning call4292
// compilenode returning call4292
  Object if4283 = done;
  if (istrue(call4292)) {
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1293
  setline(1293);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4293 = gc_frame_new();
  int callframe4294 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4295 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4294);
// compilenode returning call4295
// compilenode returning call4295
  partcv[0] = 0;
  Object call4296 = callmethod(call4295, "new",
    1, partcv, params);
  gc_frame_end(callframe4293);
// compilenode returning call4296
// compilenode returning call4296
  *var_suggestion = call4296;
  if (call4296 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1294
  setline(1294);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4297 = gc_frame_new();
  if (strlit4298 == NULL) {
    strlit4298 = alloc_String("rparen");
    gc_root(strlit4298);
  }
// compilenode returning strlit4298
  gc_frame_newslot(strlit4298);
  params[0] = strlit4298;
  partcv[0] = 1;
  Object call4299 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4297);
// compilenode returning call4299
  *var_nextTok = call4299;
  if (call4299 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4301 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4301 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4303 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4303
  Object if4300 = done;
  if (istrue(opresult4303)) {
// Begin line 1296
  setline(1296);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4304 = gc_frame_new();
  if (strlit4305 == NULL) {
    strlit4305 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4305);
  }
// compilenode returning strlit4305
  gc_frame_newslot(strlit4305);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4305;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4306 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4304);
// compilenode returning call4306
    gc_frame_newslot(call4306);
    if4300 = call4306;
  } else {
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4307 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4308 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4309 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4308);
// compilenode returning call4309
// compilenode returning call4309
  gc_frame_newslot(call4309);
  Object bool4310 = alloc_Boolean(1);
// compilenode returning bool4310
  gc_frame_newslot(bool4310);
  Object bool4311 = alloc_Boolean(0);
// compilenode returning bool4311
  gc_frame_newslot(bool4311);
  if (strlit4312 == NULL) {
    strlit4312 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4312);
  }
// compilenode returning strlit4312
  gc_frame_newslot(strlit4312);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4309;
  params[2] = bool4310;
  params[3] = bool4311;
  params[4] = strlit4312;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4313 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4307);
// compilenode returning call4313
    gc_frame_newslot(call4313);
    if4300 = call4313;
  }
// compilenode returning if4300
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4314 = gc_frame_new();
  if (strlit4315 == NULL) {
    strlit4315 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'catch'.");
    gc_root(strlit4315);
  }
// compilenode returning strlit4315
  gc_frame_newslot(strlit4315);
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4316 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4317 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4316);
// compilenode returning call4317
// compilenode returning call4317
  gc_frame_newslot(call4317);
  int callframe4318 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4319 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4318);
// compilenode returning call4319
// compilenode returning call4319
  gc_frame_newslot(call4319);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4315;
  params[1] = call4317;
  params[2] = call4319;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4320 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4314);
// compilenode returning call4320
    gc_frame_newslot(call4320);
    if4283 = call4320;
  } else {
  }
// compilenode returning if4283
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4323 == NULL) {
    strlit4323 = alloc_String("rparen");
    gc_root(strlit4323);
  }
// compilenode returning strlit4323
  int op_slot_right_4322 = gc_frame_newslot(strlit4323);
  int callframe4325 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4326 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4325);
// compilenode returning call4326
// compilenode returning call4326
  int op_slot_left_4322 = gc_frame_newslot(call4326);
  params[0] = strlit4323;
  partcv[0] = 1;
  Object opresult4327 = callmethod(call4326, "!=", 1, partcv, params);
// compilenode returning opresult4327
  Object if4321 = done;
  if (istrue(opresult4327)) {
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4328 = gc_frame_new();
  partcv[0] = 0;
  Object call4329 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4328);
// compilenode returning call4329
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4330 = gc_frame_new();
  int callframe4331 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4332 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4331);
// compilenode returning call4332
// compilenode returning call4332
  partcv[0] = 0;
  Object call4333 = callmethod(call4332, "new",
    1, partcv, params);
  gc_frame_end(callframe4330);
// compilenode returning call4333
// compilenode returning call4333
  *var_suggestion = call4333;
  if (call4333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4334 = gc_frame_new();
  if (strlit4335 == NULL) {
    strlit4335 = alloc_String(")");
    gc_root(strlit4335);
  }
// compilenode returning strlit4335
  gc_frame_newslot(strlit4335);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4335;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4336 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4334);
// compilenode returning call4336
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4337 = gc_frame_new();
  if (strlit4338 == NULL) {
    strlit4338 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4338);
  }
// compilenode returning strlit4338
  gc_frame_newslot(strlit4338);
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4339 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4340 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4339);
// compilenode returning call4340
// compilenode returning call4340
  gc_frame_newslot(call4340);
  int callframe4342 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4343 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4342);
// compilenode returning call4343
// compilenode returning call4343
  int op_slot_right_4341 = gc_frame_newslot(call4343);
  int callframe4345 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4346 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4345);
// compilenode returning call4346
// compilenode returning call4346
  int op_slot_left_4341 = gc_frame_newslot(call4346);
  params[0] = call4343;
  partcv[0] = 1;
  Object sum4347 = callmethod(call4346, "+", 1, partcv, params);
// compilenode returning sum4347
  gc_frame_newslot(sum4347);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4338;
  params[1] = call4340;
  params[2] = sum4347;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4348 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4337);
// compilenode returning call4348
    gc_frame_newslot(call4348);
    if4321 = call4348;
  } else {
  }
// compilenode returning if4321
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4349 = gc_frame_new();
  partcv[0] = 0;
  Object call4350 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4349);
// compilenode returning call4350
    gc_frame_newslot(call4350);
    if4150 = call4350;
  }
// compilenode returning if4150
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4351 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call4352 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4351);
// compilenode returning call4352
// compilenode returning call4352
  *var_mainblock = call4352;
  if (call4352 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1313
  setline(1313);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4353 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4353
  *var_cases = array4353;
  if (array4353 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4354 = alloc_Boolean(0);
// compilenode returning bool4354
  *var_finally = bool4354;
  if (bool4354 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1315
  setline(1315);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4355 = gc_frame_new();
  Object block4356 = alloc_Block(NULL, NULL, "parser", 1315);
  gc_frame_newslot(block4356);
  block_savedest(block4356);
  Object closure4357 = createclosure(2, "_apply");
setclosureframe(closure4357, stackframe);
  addtoclosure(closure4357, var_sym);
  addtoclosure(closure4357, selfslot);
  struct UserObject *uo4357 = (struct UserObject*)block4356;
  uo4357->data[0] = (Object)closure4357;
  Method *meth_meth_parser__apply4357 = addmethod2pos(block4356, "_apply", &meth_parser__apply4357, 0);
int argcv_meth_parser__apply4357[] = {0};
meth_meth_parser__apply4357->type = alloc_MethodType(1, argcv_meth_parser__apply4357);
  meth_meth_parser__apply4357->definitionModule = modulename;
  meth_meth_parser__apply4357->definitionLine = 1312;
// compilenode returning block4356
  gc_frame_newslot(block4356);
  Object block4371 = alloc_Block(NULL, NULL, "parser", 1315);
  gc_frame_newslot(block4371);
  block_savedest(block4371);
  Object closure4372 = createclosure(7, "_apply");
setclosureframe(closure4372, stackframe);
  addtoclosure(closure4372, var_errormessages);
  addtoclosure(closure4372, var_sym);
  addtoclosure(closure4372, var_lastToken);
  addtoclosure(closure4372, var_tokens);
  addtoclosure(closure4372, var_values);
  addtoclosure(closure4372, var_cases);
  addtoclosure(closure4372, selfslot);
  struct UserObject *uo4372 = (struct UserObject*)block4371;
  uo4372->data[0] = (Object)closure4372;
  Method *meth_meth_parser__apply4372 = addmethod2pos(block4371, "_apply", &meth_parser__apply4372, 0);
int argcv_meth_parser__apply4372[] = {0};
meth_meth_parser__apply4372->type = alloc_MethodType(1, argcv_meth_parser__apply4372);
  meth_meth_parser__apply4372->definitionModule = modulename;
  meth_meth_parser__apply4372->definitionLine = 1315;
// compilenode returning block4371
  gc_frame_newslot(block4371);
  params[0] = block4356;
  params[1] = block4371;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4518 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4355);
// compilenode returning call4518
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4522 == NULL) {
    strlit4522 = alloc_String("finally");
    gc_root(strlit4522);
  }
// compilenode returning strlit4522
  int op_slot_right_4521 = gc_frame_newslot(strlit4522);
  int callframe4524 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4525 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4524);
// compilenode returning call4525
// compilenode returning call4525
  int op_slot_left_4521 = gc_frame_newslot(call4525);
  params[0] = strlit4522;
  partcv[0] = 1;
  Object opresult4526 = callmethod(call4525, "==", 1, partcv, params);
// compilenode returning opresult4526
  int op_slot_right_4520 = gc_frame_newslot(opresult4526);
  int callframe4528 = gc_frame_new();
  if (strlit4529 == NULL) {
    strlit4529 = alloc_String("identifier");
    gc_root(strlit4529);
  }
// compilenode returning strlit4529
  gc_frame_newslot(strlit4529);
  params[0] = strlit4529;
  partcv[0] = 1;
  Object call4530 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4528);
// compilenode returning call4530
  int op_slot_left_4520 = gc_frame_newslot(call4530);
  params[0] = opresult4526;
  partcv[0] = 1;
  Object opresult4531 = callmethod(call4530, "&&", 1, partcv, params);
// compilenode returning opresult4531
  Object if4519 = done;
  if (istrue(opresult4531)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4532 = gc_frame_new();
  partcv[0] = 0;
  Object call4533 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4532);
// compilenode returning call4533
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1366
  setline(1366);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4535 = gc_frame_new();
  if (strlit4536 == NULL) {
    strlit4536 = alloc_String("lbrace");
    gc_root(strlit4536);
  }
// compilenode returning strlit4536
  gc_frame_newslot(strlit4536);
  params[0] = strlit4536;
  partcv[0] = 1;
  Object call4537 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4535);
// compilenode returning call4537
  Object if4534 = done;
  if (istrue(call4537)) {
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4538 = gc_frame_new();
  partcv[0] = 0;
  Object call4539 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4538);
// compilenode returning call4539
    gc_frame_newslot(call4539);
    if4534 = call4539;
  } else {
// Begin line 1389
  setline(1389);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4541 = gc_frame_new();
  if (strlit4542 == NULL) {
    strlit4542 = alloc_String("lparen");
    gc_root(strlit4542);
  }
// compilenode returning strlit4542
  gc_frame_newslot(strlit4542);
  params[0] = strlit4542;
  partcv[0] = 1;
  Object call4543 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4541);
// compilenode returning call4543
  Object if4540 = done;
  if (istrue(call4543)) {
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4544 = gc_frame_new();
  partcv[0] = 0;
  Object call4545 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4544);
// compilenode returning call4545
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4547 = gc_frame_new();
  int callframe4548 = gc_frame_new();
  Object block4549 = alloc_Block(NULL, NULL, "parser", 1370);
  gc_frame_newslot(block4549);
  block_savedest(block4549);
  Object closure4550 = createclosure(1, "_apply");
setclosureframe(closure4550, stackframe);
  addtoclosure(closure4550, selfslot);
  struct UserObject *uo4550 = (struct UserObject*)block4549;
  uo4550->data[0] = (Object)closure4550;
  Method *meth_meth_parser__apply4550 = addmethod2pos(block4549, "_apply", &meth_parser__apply4550, 0);
int argcv_meth_parser__apply4550[] = {0};
meth_meth_parser__apply4550->type = alloc_MethodType(1, argcv_meth_parser__apply4550);
  meth_meth_parser__apply4550->definitionModule = modulename;
  meth_meth_parser__apply4550->definitionLine = 1370;
// compilenode returning block4549
  gc_frame_newslot(block4549);
  params[0] = block4549;
  partcv[0] = 1;
  Object call4554 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4548);
// compilenode returning call4554
  partcv[0] = 0;
  Object call4555 = callmethod(call4554, "not",
    1, partcv, params);
  gc_frame_end(callframe4547);
// compilenode returning call4555
// compilenode returning call4555
  Object if4546 = done;
  if (istrue(call4555)) {
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4556 = gc_frame_new();
  int callframe4557 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4558 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4557);
// compilenode returning call4558
// compilenode returning call4558
  partcv[0] = 0;
  Object call4559 = callmethod(call4558, "new",
    1, partcv, params);
  gc_frame_end(callframe4556);
// compilenode returning call4559
// compilenode returning call4559
  *var_suggestion = call4559;
  if (call4559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1372
  setline(1372);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4560 = gc_frame_new();
  if (strlit4561 == NULL) {
    strlit4561 = alloc_String("rparen");
    gc_root(strlit4561);
  }
// compilenode returning strlit4561
  gc_frame_newslot(strlit4561);
  params[0] = strlit4561;
  partcv[0] = 1;
  Object call4562 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4560);
// compilenode returning call4562
  *var_nextTok = call4562;
  if (call4562 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1373
  setline(1373);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4564 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4564 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4566 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4566
  Object if4563 = done;
  if (istrue(opresult4566)) {
// Begin line 1374
  setline(1374);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4567 = gc_frame_new();
  if (strlit4568 == NULL) {
    strlit4568 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4568);
  }
// compilenode returning strlit4568
  gc_frame_newslot(strlit4568);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4568;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4569 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4567);
// compilenode returning call4569
    gc_frame_newslot(call4569);
    if4563 = call4569;
  } else {
// Begin line 1376
  setline(1376);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4570 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4571 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4572 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4571);
// compilenode returning call4572
// compilenode returning call4572
  gc_frame_newslot(call4572);
  Object bool4573 = alloc_Boolean(1);
// compilenode returning bool4573
  gc_frame_newslot(bool4573);
  Object bool4574 = alloc_Boolean(0);
// compilenode returning bool4574
  gc_frame_newslot(bool4574);
  if (strlit4575 == NULL) {
    strlit4575 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4575);
  }
// compilenode returning strlit4575
  gc_frame_newslot(strlit4575);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4572;
  params[2] = bool4573;
  params[3] = bool4574;
  params[4] = strlit4575;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4576 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4570);
// compilenode returning call4576
    gc_frame_newslot(call4576);
    if4563 = call4576;
  }
// compilenode returning if4563
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4577 = gc_frame_new();
  if (strlit4578 == NULL) {
    strlit4578 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4578);
  }
// compilenode returning strlit4578
  gc_frame_newslot(strlit4578);
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4579 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4580 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4579);
// compilenode returning call4580
// compilenode returning call4580
  gc_frame_newslot(call4580);
  int callframe4581 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4582 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4581);
// compilenode returning call4582
// compilenode returning call4582
  gc_frame_newslot(call4582);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4578;
  params[1] = call4580;
  params[2] = call4582;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4583 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4577);
// compilenode returning call4583
    gc_frame_newslot(call4583);
    if4546 = call4583;
  } else {
  }
// compilenode returning if4546
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4586 == NULL) {
    strlit4586 = alloc_String("rparen");
    gc_root(strlit4586);
  }
// compilenode returning strlit4586
  int op_slot_right_4585 = gc_frame_newslot(strlit4586);
  int callframe4588 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4589 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4588);
// compilenode returning call4589
// compilenode returning call4589
  int op_slot_left_4585 = gc_frame_newslot(call4589);
  params[0] = strlit4586;
  partcv[0] = 1;
  Object opresult4590 = callmethod(call4589, "!=", 1, partcv, params);
// compilenode returning opresult4590
  Object if4584 = done;
  if (istrue(opresult4590)) {
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4591 = gc_frame_new();
  partcv[0] = 0;
  Object call4592 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4591);
// compilenode returning call4592
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4593 = gc_frame_new();
  int callframe4594 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4595 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4594);
// compilenode returning call4595
// compilenode returning call4595
  partcv[0] = 0;
  Object call4596 = callmethod(call4595, "new",
    1, partcv, params);
  gc_frame_end(callframe4593);
// compilenode returning call4596
// compilenode returning call4596
  *var_suggestion = call4596;
  if (call4596 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1384
  setline(1384);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4597 = gc_frame_new();
  if (strlit4598 == NULL) {
    strlit4598 = alloc_String(")");
    gc_root(strlit4598);
  }
// compilenode returning strlit4598
  gc_frame_newslot(strlit4598);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4598;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4599 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4597);
// compilenode returning call4599
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4600 = gc_frame_new();
  if (strlit4601 == NULL) {
    strlit4601 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4601);
  }
// compilenode returning strlit4601
  gc_frame_newslot(strlit4601);
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4602 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4603 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4602);
// compilenode returning call4603
// compilenode returning call4603
  gc_frame_newslot(call4603);
  int callframe4605 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4606 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4605);
// compilenode returning call4606
// compilenode returning call4606
  int op_slot_right_4604 = gc_frame_newslot(call4606);
  int callframe4608 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4609 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4608);
// compilenode returning call4609
// compilenode returning call4609
  int op_slot_left_4604 = gc_frame_newslot(call4609);
  params[0] = call4606;
  partcv[0] = 1;
  Object sum4610 = callmethod(call4609, "+", 1, partcv, params);
// compilenode returning sum4610
  gc_frame_newslot(sum4610);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4601;
  params[1] = call4603;
  params[2] = sum4610;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4611 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4600);
// compilenode returning call4611
    gc_frame_newslot(call4611);
    if4584 = call4611;
  } else {
  }
// compilenode returning if4584
// Begin line 1388
  setline(1388);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4612 = gc_frame_new();
  partcv[0] = 0;
  Object call4613 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4612);
// compilenode returning call4613
    gc_frame_newslot(call4613);
    if4540 = call4613;
  } else {
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1390
  setline(1390);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4614 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4614
  *var_suggestions = array4614;
  if (array4614 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1391
  setline(1391);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4615 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4616 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4615);
// compilenode returning call4616
  *var_nextTok = call4616;
  if (call4616 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4617 = gc_frame_new();
  int callframe4618 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4619 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4618);
// compilenode returning call4619
// compilenode returning call4619
  partcv[0] = 0;
  Object call4620 = callmethod(call4619, "new",
    1, partcv, params);
  gc_frame_end(callframe4617);
// compilenode returning call4620
// compilenode returning call4620
  *var_suggestion = call4620;
  if (call4620 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4623 = alloc_Boolean(0);
// compilenode returning bool4623
  int op_slot_right_4622 = gc_frame_newslot(bool4623);
// compilenode returning *var_nextTok
  int op_slot_left_4622 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4623;
  partcv[0] = 1;
  Object opresult4625 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4625
  Object if4621 = done;
  if (istrue(opresult4625)) {
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4626 = gc_frame_new();
  if (strlit4627 == NULL) {
    strlit4627 = alloc_String(" }");
    gc_root(strlit4627);
  }
// compilenode returning strlit4627
  gc_frame_newslot(strlit4627);
  int callframe4628 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call4629 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe4628);
// compilenode returning call4629
// compilenode returning call4629
  gc_frame_newslot(call4629);
// compilenode returning *var_suggestion
  params[0] = strlit4627;
  params[1] = call4629;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4630 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4626);
// compilenode returning call4630
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4631 = gc_frame_new();
  if (strlit4632 == NULL) {
    strlit4632 = alloc_String(" {");
    gc_root(strlit4632);
  }
// compilenode returning strlit4632
  gc_frame_newslot(strlit4632);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4632;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4633 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4631);
// compilenode returning call4633
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4634 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4635 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4634);
// compilenode returning call4635
    gc_frame_newslot(call4635);
    if4621 = call4635;
  } else {
// Begin line 1403
  setline(1403);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4637 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4637 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4639 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4639
  Object if4636 = done;
  if (istrue(opresult4639)) {
// Begin line 1398
  setline(1398);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4640 = gc_frame_new();
  if (strlit4641 == NULL) {
    strlit4641 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4641);
  }
// compilenode returning strlit4641
  gc_frame_newslot(strlit4641);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4641;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4642 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4640);
// compilenode returning call4642
// Begin line 1399
  setline(1399);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4643 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4644 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4643);
// compilenode returning call4644
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4645 = gc_frame_new();
  int callframe4646 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4647 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4646);
// compilenode returning call4647
// compilenode returning call4647
  partcv[0] = 0;
  Object call4648 = callmethod(call4647, "new",
    1, partcv, params);
  gc_frame_end(callframe4645);
// compilenode returning call4648
// compilenode returning call4648
  *var_suggestion = call4648;
  if (call4648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1401
  setline(1401);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4650 = gc_frame_new();
  if (strlit4651 == NULL) {
    strlit4651 = alloc_String(" { ""\xc2""""\xab""expression""\xc2""""\xbb"" }");
    gc_root(strlit4651);
  }
// compilenode returning strlit4651
  gc_frame_newslot(strlit4651);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4651;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4652 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4650);
// compilenode returning call4652
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4653 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4654 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4653);
// compilenode returning call4654
    gc_frame_newslot(call4654);
    if4636 = call4654;
  } else {
// Begin line 1404
  setline(1404);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4655 = gc_frame_new();
  if (strlit4656 == NULL) {
    strlit4656 = alloc_String(" }");
    gc_root(strlit4656);
  }
// compilenode returning strlit4656
  gc_frame_newslot(strlit4656);
  int callframe4657 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4658 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4657);
// compilenode returning call4658
// compilenode returning call4658
  gc_frame_newslot(call4658);
// compilenode returning *var_suggestion
  params[0] = strlit4656;
  params[1] = call4658;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4659 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4655);
// compilenode returning call4659
// Begin line 1405
  setline(1405);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4660 = gc_frame_new();
  if (strlit4661 == NULL) {
    strlit4661 = alloc_String(" {");
    gc_root(strlit4661);
  }
// compilenode returning strlit4661
  gc_frame_newslot(strlit4661);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4661;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4662 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4660);
// compilenode returning call4662
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4663 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4664 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4663);
// compilenode returning call4664
    gc_frame_newslot(call4664);
    if4636 = call4664;
  }
// compilenode returning if4636
    gc_frame_newslot(if4636);
    if4621 = if4636;
  }
// compilenode returning if4621
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4665 = gc_frame_new();
  if (strlit4666 == NULL) {
    strlit4666 = alloc_String("A catch statement must have either a block or an expression in parentheses after the 'finally'.");
    gc_root(strlit4666);
  }
// compilenode returning strlit4666
  gc_frame_newslot(strlit4666);
// Begin line 1409
  setline(1409);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4667 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4668 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4667);
// compilenode returning call4668
// compilenode returning call4668
  gc_frame_newslot(call4668);
  int callframe4669 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4670 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4669);
// compilenode returning call4670
// compilenode returning call4670
  gc_frame_newslot(call4670);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1408
  setline(1408);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4666;
  params[1] = call4668;
  params[2] = call4670;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4671 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe4665);
// compilenode returning call4671
    gc_frame_newslot(call4671);
    if4540 = call4671;
  }
// compilenode returning if4540
    gc_frame_newslot(if4540);
    if4534 = if4540;
  }
// compilenode returning if4534
// Begin line 1412
  setline(1412);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1411
  setline(1411);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4672 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call4673 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4672);
// compilenode returning call4673
// compilenode returning call4673
  *var_finally = call4673;
  if (call4673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if4519 = done;
  } else {
  }
// compilenode returning if4519
// Begin line 1413
  setline(1413);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4675 = gc_frame_new();
  int callframe4676 = gc_frame_new();
// compilenode returning *var_mainblock
  gc_frame_newslot(*var_mainblock);
// compilenode returning *var_cases
  gc_frame_newslot(*var_cases);
// compilenode returning *var_finally
  gc_frame_newslot(*var_finally);
  int callframe4677 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call4678 = callmethod(*var_ast, "catchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe4677);
// compilenode returning call4678
// compilenode returning call4678
  params[0] = *var_mainblock;
  params[1] = *var_cases;
  params[2] = *var_finally;
  partcv[0] = 3;
  Object call4679 = callmethod(call4678, "new",
    1, partcv, params);
  gc_frame_end(callframe4676);
// compilenode returning call4679
  gc_frame_newslot(call4679);
// compilenode returning *var_values
  params[0] = call4679;
  partcv[0] = 1;
  Object call4680 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe4675);
// compilenode returning call4680
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localmin
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply4714(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_matchTok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4718 == NULL) {
    strlit4718 = alloc_String("case");
    gc_root(strlit4718);
  }
// compilenode returning strlit4718
  int op_slot_right_4717 = gc_frame_newslot(strlit4718);
  int callframe4720 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4721 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe4720);
// compilenode returning call4721
// compilenode returning call4721
  int op_slot_left_4717 = gc_frame_newslot(call4721);
  params[0] = strlit4718;
  partcv[0] = 1;
  Object opresult4722 = callmethod(call4721, "==", 1, partcv, params);
// compilenode returning opresult4722
  int op_slot_right_4716 = gc_frame_newslot(opresult4722);
  if (strlit4725 == NULL) {
    strlit4725 = alloc_String("identifier");
    gc_root(strlit4725);
  }
// compilenode returning strlit4725
  int op_slot_right_4724 = gc_frame_newslot(strlit4725);
  int callframe4727 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4728 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4727);
// compilenode returning call4728
// compilenode returning call4728
  int op_slot_left_4724 = gc_frame_newslot(call4728);
  params[0] = strlit4725;
  partcv[0] = 1;
  Object opresult4729 = callmethod(call4728, "==", 1, partcv, params);
// compilenode returning opresult4729
  int op_slot_left_4716 = gc_frame_newslot(opresult4729);
  params[0] = opresult4722;
  partcv[0] = 1;
  Object opresult4730 = callmethod(opresult4729, "&&", 1, partcv, params);
// compilenode returning opresult4730
  int op_slot_right_4715 = gc_frame_newslot(opresult4730);
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4734 = gc_frame_new();
// compilenode returning *var_matchTok
  partcv[0] = 0;
  Object call4735 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4734);
// compilenode returning call4735
// compilenode returning call4735
  int op_slot_right_4733 = gc_frame_newslot(call4735);
  int callframe4737 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4738 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe4737);
// compilenode returning call4738
// compilenode returning call4738
  int op_slot_left_4733 = gc_frame_newslot(call4738);
  params[0] = call4735;
  partcv[0] = 1;
  Object opresult4739 = callmethod(call4738, "==", 1, partcv, params);
// compilenode returning opresult4739
  int op_slot_right_4732 = gc_frame_newslot(opresult4739);
  if (strlit4742 == NULL) {
    strlit4742 = alloc_String("rparen");
    gc_root(strlit4742);
  }
// compilenode returning strlit4742
  int op_slot_right_4741 = gc_frame_newslot(strlit4742);
  int callframe4744 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call4745 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe4744);
// compilenode returning call4745
// compilenode returning call4745
  int op_slot_left_4741 = gc_frame_newslot(call4745);
  params[0] = strlit4742;
  partcv[0] = 1;
  Object opresult4746 = callmethod(call4745, "==", 1, partcv, params);
// compilenode returning opresult4746
  int op_slot_left_4732 = gc_frame_newslot(opresult4746);
  params[0] = opresult4739;
  partcv[0] = 1;
  Object opresult4747 = callmethod(opresult4746, "&&", 1, partcv, params);
// compilenode returning opresult4747
  int op_slot_left_4715 = gc_frame_newslot(opresult4747);
  params[0] = opresult4730;
  partcv[0] = 1;
  Object opresult4748 = callmethod(opresult4747, "||", 1, partcv, params);
// compilenode returning opresult4748
  gc_frame_end(frame);
  return opresult4748;
}
Object meth_parser__apply4810(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe4811 = gc_frame_new();
  partcv[0] = 0;
  Object call4812 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4811);
// compilenode returning call4812
  gc_frame_end(frame);
  return call4812;
}
Object meth_parser__apply4880(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit4883 == NULL) {
    strlit4883 = alloc_String("case");
    gc_root(strlit4883);
  }
// compilenode returning strlit4883
  int op_slot_right_4882 = gc_frame_newslot(strlit4883);
  int callframe4885 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4886 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4885);
// compilenode returning call4886
// compilenode returning call4886
  int op_slot_left_4882 = gc_frame_newslot(call4886);
  params[0] = strlit4883;
  partcv[0] = 1;
  Object opresult4887 = callmethod(call4886, "==", 1, partcv, params);
// compilenode returning opresult4887
  int op_slot_right_4881 = gc_frame_newslot(opresult4887);
  int callframe4889 = gc_frame_new();
  if (strlit4890 == NULL) {
    strlit4890 = alloc_String("identifier");
    gc_root(strlit4890);
  }
// compilenode returning strlit4890
  gc_frame_newslot(strlit4890);
  params[0] = strlit4890;
  partcv[0] = 1;
  Object call4891 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4889);
// compilenode returning call4891
  int op_slot_left_4881 = gc_frame_newslot(call4891);
  params[0] = opresult4887;
  partcv[0] = 1;
  Object opresult4892 = callmethod(call4891, "&&", 1, partcv, params);
// compilenode returning opresult4892
  gc_frame_end(frame);
  return opresult4892;
}
Object meth_parser__apply4914(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe4915 = gc_frame_new();
  partcv[0] = 0;
  Object call4916 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4915);
// compilenode returning call4916
  gc_frame_end(frame);
  return call4916;
}
Object meth_parser__apply4895(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_errormessages = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_tokens = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_cases = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_nextTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "nextTok");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
// Begin line 1467
  setline(1467);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4896 = gc_frame_new();
  partcv[0] = 0;
  Object call4897 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4896);
// compilenode returning call4897
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1468
  setline(1468);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4899 = gc_frame_new();
  if (strlit4900 == NULL) {
    strlit4900 = alloc_String("lbrace");
    gc_root(strlit4900);
  }
// compilenode returning strlit4900
  gc_frame_newslot(strlit4900);
  params[0] = strlit4900;
  partcv[0] = 1;
  Object call4901 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4899);
// compilenode returning call4901
  Object if4898 = done;
  if (istrue(call4901)) {
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4902 = gc_frame_new();
  partcv[0] = 0;
  Object call4903 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4902);
// compilenode returning call4903
    gc_frame_newslot(call4903);
    if4898 = call4903;
  } else {
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4905 = gc_frame_new();
  if (strlit4906 == NULL) {
    strlit4906 = alloc_String("lparen");
    gc_root(strlit4906);
  }
// compilenode returning strlit4906
  gc_frame_newslot(strlit4906);
  params[0] = strlit4906;
  partcv[0] = 1;
  Object call4907 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4905);
// compilenode returning call4907
  Object if4904 = done;
  if (istrue(call4907)) {
// Begin line 1471
  setline(1471);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4908 = gc_frame_new();
  partcv[0] = 0;
  Object call4909 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4908);
// compilenode returning call4909
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1472
  setline(1472);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4911 = gc_frame_new();
  int callframe4912 = gc_frame_new();
  Object block4913 = alloc_Block(NULL, NULL, "parser", 1472);
  gc_frame_newslot(block4913);
  block_savedest(block4913);
  Object closure4914 = createclosure(1, "_apply");
setclosureframe(closure4914, stackframe);
  addtoclosure(closure4914, selfslot);
  struct UserObject *uo4914 = (struct UserObject*)block4913;
  uo4914->data[0] = (Object)closure4914;
  Method *meth_meth_parser__apply4914 = addmethod2pos(block4913, "_apply", &meth_parser__apply4914, 0);
int argcv_meth_parser__apply4914[] = {0};
meth_meth_parser__apply4914->type = alloc_MethodType(1, argcv_meth_parser__apply4914);
  meth_meth_parser__apply4914->definitionModule = modulename;
  meth_meth_parser__apply4914->definitionLine = 1472;
// compilenode returning block4913
  gc_frame_newslot(block4913);
  params[0] = block4913;
  partcv[0] = 1;
  Object call4918 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4912);
// compilenode returning call4918
  partcv[0] = 0;
  Object call4919 = callmethod(call4918, "not",
    1, partcv, params);
  gc_frame_end(callframe4911);
// compilenode returning call4919
// compilenode returning call4919
  Object if4910 = done;
  if (istrue(call4919)) {
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1473
  setline(1473);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4920 = gc_frame_new();
  int callframe4921 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4922 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4921);
// compilenode returning call4922
// compilenode returning call4922
  partcv[0] = 0;
  Object call4923 = callmethod(call4922, "new",
    1, partcv, params);
  gc_frame_end(callframe4920);
// compilenode returning call4923
// compilenode returning call4923
  *var_suggestion = call4923;
  if (call4923 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4924 = gc_frame_new();
  if (strlit4925 == NULL) {
    strlit4925 = alloc_String("rparen");
    gc_root(strlit4925);
  }
// compilenode returning strlit4925
  gc_frame_newslot(strlit4925);
  params[0] = strlit4925;
  partcv[0] = 1;
  Object call4926 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4924);
// compilenode returning call4926
  *var_nextTok = call4926;
  if (call4926 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4928 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4928 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4930 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4930
  Object if4927 = done;
  if (istrue(opresult4930)) {
// Begin line 1476
  setline(1476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4931 = gc_frame_new();
  if (strlit4932 == NULL) {
    strlit4932 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4932);
  }
// compilenode returning strlit4932
  gc_frame_newslot(strlit4932);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4932;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4933 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4931);
// compilenode returning call4933
    gc_frame_newslot(call4933);
    if4927 = call4933;
  } else {
// Begin line 1478
  setline(1478);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4934 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4935 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4936 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4935);
// compilenode returning call4936
// compilenode returning call4936
  gc_frame_newslot(call4936);
  Object bool4937 = alloc_Boolean(1);
// compilenode returning bool4937
  gc_frame_newslot(bool4937);
  Object bool4938 = alloc_Boolean(0);
// compilenode returning bool4938
  gc_frame_newslot(bool4938);
  if (strlit4939 == NULL) {
    strlit4939 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4939);
  }
// compilenode returning strlit4939
  gc_frame_newslot(strlit4939);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4936;
  params[2] = bool4937;
  params[3] = bool4938;
  params[4] = strlit4939;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4940 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4934);
// compilenode returning call4940
    gc_frame_newslot(call4940);
    if4927 = call4940;
  }
// compilenode returning if4927
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4941 = gc_frame_new();
  if (strlit4942 == NULL) {
    strlit4942 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit4942);
  }
// compilenode returning strlit4942
  gc_frame_newslot(strlit4942);
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4943 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4944 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4943);
// compilenode returning call4944
// compilenode returning call4944
  gc_frame_newslot(call4944);
  int callframe4945 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4946 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4945);
// compilenode returning call4946
// compilenode returning call4946
  gc_frame_newslot(call4946);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4942;
  params[1] = call4944;
  params[2] = call4946;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4947 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4941);
// compilenode returning call4947
    gc_frame_newslot(call4947);
    if4910 = call4947;
  } else {
  }
// compilenode returning if4910
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1483
  setline(1483);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4950 == NULL) {
    strlit4950 = alloc_String("rparen");
    gc_root(strlit4950);
  }
// compilenode returning strlit4950
  int op_slot_right_4949 = gc_frame_newslot(strlit4950);
  int callframe4952 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4953 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4952);
// compilenode returning call4953
// compilenode returning call4953
  int op_slot_left_4949 = gc_frame_newslot(call4953);
  params[0] = strlit4950;
  partcv[0] = 1;
  Object opresult4954 = callmethod(call4953, "!=", 1, partcv, params);
// compilenode returning opresult4954
  Object if4948 = done;
  if (istrue(opresult4954)) {
// Begin line 1484
  setline(1484);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4955 = gc_frame_new();
  partcv[0] = 0;
  Object call4956 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4955);
// compilenode returning call4956
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1485
  setline(1485);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4957 = gc_frame_new();
  int callframe4958 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4959 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4958);
// compilenode returning call4959
// compilenode returning call4959
  partcv[0] = 0;
  Object call4960 = callmethod(call4959, "new",
    1, partcv, params);
  gc_frame_end(callframe4957);
// compilenode returning call4960
// compilenode returning call4960
  *var_suggestion = call4960;
  if (call4960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4961 = gc_frame_new();
  if (strlit4962 == NULL) {
    strlit4962 = alloc_String(")");
    gc_root(strlit4962);
  }
// compilenode returning strlit4962
  gc_frame_newslot(strlit4962);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4962;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4963 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4961);
// compilenode returning call4963
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4964 = gc_frame_new();
  if (strlit4965 == NULL) {
    strlit4965 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4965);
  }
// compilenode returning strlit4965
  gc_frame_newslot(strlit4965);
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4966 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4967 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4966);
// compilenode returning call4967
// compilenode returning call4967
  gc_frame_newslot(call4967);
  int callframe4969 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4970 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4969);
// compilenode returning call4970
// compilenode returning call4970
  int op_slot_right_4968 = gc_frame_newslot(call4970);
  int callframe4972 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4973 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4972);
// compilenode returning call4973
// compilenode returning call4973
  int op_slot_left_4968 = gc_frame_newslot(call4973);
  params[0] = call4970;
  partcv[0] = 1;
  Object sum4974 = callmethod(call4973, "+", 1, partcv, params);
// compilenode returning sum4974
  gc_frame_newslot(sum4974);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4965;
  params[1] = call4967;
  params[2] = sum4974;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4975 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4964);
// compilenode returning call4975
    gc_frame_newslot(call4975);
    if4948 = call4975;
  } else {
  }
// compilenode returning if4948
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4976 = gc_frame_new();
  partcv[0] = 0;
  Object call4977 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4976);
// compilenode returning call4977
    gc_frame_newslot(call4977);
    if4904 = call4977;
  } else {
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1492
  setline(1492);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4978 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4978
  *var_suggestions = array4978;
  if (array4978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4979 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call4980 = callmethodflags(self, "findNextTokenIndentedAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4979);
// compilenode returning call4980
  *var_nextTok = call4980;
  if (call4980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1494
  setline(1494);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4981 = gc_frame_new();
  int callframe4982 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4983 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4982);
// compilenode returning call4983
// compilenode returning call4983
  partcv[0] = 0;
  Object call4984 = callmethod(call4983, "new",
    1, partcv, params);
  gc_frame_end(callframe4981);
// compilenode returning call4984
// compilenode returning call4984
  *var_suggestion = call4984;
  if (call4984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4987 = alloc_Boolean(0);
// compilenode returning bool4987
  int op_slot_right_4986 = gc_frame_newslot(bool4987);
// compilenode returning *var_nextTok
  int op_slot_left_4986 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4987;
  partcv[0] = 1;
  Object opresult4989 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4989
  Object if4985 = done;
  if (istrue(opresult4989)) {
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4990 = gc_frame_new();
  if (strlit4991 == NULL) {
    strlit4991 = alloc_String(" }");
    gc_root(strlit4991);
  }
// compilenode returning strlit4991
  gc_frame_newslot(strlit4991);
  int callframe4992 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call4993 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe4992);
// compilenode returning call4993
// compilenode returning call4993
  gc_frame_newslot(call4993);
// compilenode returning *var_suggestion
  params[0] = strlit4991;
  params[1] = call4993;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4994 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4990);
// compilenode returning call4994
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4995 = gc_frame_new();
  if (strlit4996 == NULL) {
    strlit4996 = alloc_String(" {");
    gc_root(strlit4996);
  }
// compilenode returning strlit4996
  gc_frame_newslot(strlit4996);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4996;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4997 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4995);
// compilenode returning call4997
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4998 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call4999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe4998);
// compilenode returning call4999
    gc_frame_newslot(call4999);
    if4985 = call4999;
  } else {
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1499
  setline(1499);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_5001 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_5001 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5003 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult5003
  Object if5000 = done;
  if (istrue(opresult5003)) {
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5004 = gc_frame_new();
  if (strlit5005 == NULL) {
    strlit5005 = alloc_String(" (""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit5005);
  }
// compilenode returning strlit5005
  gc_frame_newslot(strlit5005);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5005;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5006 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5004);
// compilenode returning call5006
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5007 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5008 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5007);
// compilenode returning call5008
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5009 = gc_frame_new();
  int callframe5010 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5011 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5010);
// compilenode returning call5011
// compilenode returning call5011
  partcv[0] = 0;
  Object call5012 = callmethod(call5011, "new",
    1, partcv, params);
  gc_frame_end(callframe5009);
// compilenode returning call5012
// compilenode returning call5012
  *var_suggestion = call5012;
  if (call5012 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1503
  setline(1503);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5014 = gc_frame_new();
  if (strlit5015 == NULL) {
    strlit5015 = alloc_String(" { ""\xc2""""\xab""match expression""\xc2""""\xbb"" }");
    gc_root(strlit5015);
  }
// compilenode returning strlit5015
  gc_frame_newslot(strlit5015);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5015;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5016 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5014);
// compilenode returning call5016
// Begin line 1504
  setline(1504);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5017 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5018 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5017);
// compilenode returning call5018
    gc_frame_newslot(call5018);
    if5000 = call5018;
  } else {
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5019 = gc_frame_new();
  if (strlit5020 == NULL) {
    strlit5020 = alloc_String(" }");
    gc_root(strlit5020);
  }
// compilenode returning strlit5020
  gc_frame_newslot(strlit5020);
  int callframe5021 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5022 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5021);
// compilenode returning call5022
// compilenode returning call5022
  gc_frame_newslot(call5022);
// compilenode returning *var_suggestion
  params[0] = strlit5020;
  params[1] = call5022;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5023 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5019);
// compilenode returning call5023
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5024 = gc_frame_new();
  if (strlit5025 == NULL) {
    strlit5025 = alloc_String(" {");
    gc_root(strlit5025);
  }
// compilenode returning strlit5025
  gc_frame_newslot(strlit5025);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5025;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5026 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5024);
// compilenode returning call5026
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5027 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5028 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5027);
// compilenode returning call5028
    gc_frame_newslot(call5028);
    if5000 = call5028;
  }
// compilenode returning if5000
    gc_frame_newslot(if5000);
    if4985 = if5000;
  }
// compilenode returning if4985
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5029 = gc_frame_new();
  if (strlit5030 == NULL) {
    strlit5030 = alloc_String("A match statement must have either a matching block or an expression in parentheses after the 'case'.");
    gc_root(strlit5030);
  }
// compilenode returning strlit5030
  gc_frame_newslot(strlit5030);
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5031 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5032 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5031);
// compilenode returning call5032
// compilenode returning call5032
  gc_frame_newslot(call5032);
  int callframe5033 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5034 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5033);
// compilenode returning call5034
// compilenode returning call5034
  gc_frame_newslot(call5034);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5030;
  params[1] = call5032;
  params[2] = call5034;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5035 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5029);
// compilenode returning call5035
    gc_frame_newslot(call5035);
    if4904 = call5035;
  }
// compilenode returning if4904
    gc_frame_newslot(if4904);
    if4898 = if4904;
  }
// compilenode returning if4898
// Begin line 1513
  setline(1513);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5036 = gc_frame_new();
  int callframe5037 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5038 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5037);
// compilenode returning call5038
// compilenode returning call5038
  gc_frame_newslot(call5038);
// compilenode returning *var_cases
  params[0] = call5038;
  partcv[0] = 1;
  Object call5039 = callmethod(*var_cases, "push",
    1, partcv, params);
  gc_frame_end(callframe5036);
// compilenode returning call5039
  gc_frame_end(frame);
  return call5039;
}
Object meth_parser_matchcase4682(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "matchcase");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for matchcase (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for matchcase");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_localmin = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "localmin");
  Object *var_matchTok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "matchTok");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_matchee = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "matchee");
  Object *var_cases = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "cases");
  Object *var_elsecase = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "elsecase");
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4684 = gc_frame_new();
  if (strlit4687 == NULL) {
    strlit4687 = alloc_String("match");
    gc_root(strlit4687);
  }
// compilenode returning strlit4687
  int op_slot_right_4686 = gc_frame_newslot(strlit4687);
  int callframe4689 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4690 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe4689);
// compilenode returning call4690
// compilenode returning call4690
  int op_slot_left_4686 = gc_frame_newslot(call4690);
  params[0] = strlit4687;
  partcv[0] = 1;
  Object opresult4691 = callmethod(call4690, "==", 1, partcv, params);
// compilenode returning opresult4691
  int op_slot_right_4685 = gc_frame_newslot(opresult4691);
  int callframe4693 = gc_frame_new();
  if (strlit4694 == NULL) {
    strlit4694 = alloc_String("identifier");
    gc_root(strlit4694);
  }
// compilenode returning strlit4694
  gc_frame_newslot(strlit4694);
  params[0] = strlit4694;
  partcv[0] = 1;
  Object call4695 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4693);
// compilenode returning call4695
  int op_slot_left_4685 = gc_frame_newslot(call4695);
  params[0] = opresult4691;
  partcv[0] = 1;
  Object opresult4696 = callmethod(call4695, "&&", 1, partcv, params);
// compilenode returning opresult4696
  partcv[0] = 0;
  Object call4697 = callmethod(opresult4696, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4684);
// compilenode returning call4697
  Object if4683 = done;
  if (istrue(call4697)) {
// Begin line 1419
  setline(1419);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1418
  setline(1418);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num4698 = alloc_Float64(0);
// compilenode returning num4698
  return num4698;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if4683 = undefined;
  } else {
  }
// compilenode returning if4683
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localmin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1421
  setline(1421);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_matchTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1422
  setline(1422);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4699 = gc_frame_new();
  partcv[0] = 0;
  Object call4700 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4699);
// compilenode returning call4700
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1423
  setline(1423);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4703 == NULL) {
    strlit4703 = alloc_String("lparen");
    gc_root(strlit4703);
  }
// compilenode returning strlit4703
  int op_slot_right_4702 = gc_frame_newslot(strlit4703);
  int callframe4705 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4706 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4705);
// compilenode returning call4706
// compilenode returning call4706
  int op_slot_left_4702 = gc_frame_newslot(call4706);
  params[0] = strlit4703;
  partcv[0] = 1;
  Object opresult4707 = callmethod(call4706, "!=", 1, partcv, params);
// compilenode returning opresult4707
  Object if4701 = done;
  if (istrue(opresult4707)) {
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4708 = gc_frame_new();
  int callframe4709 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4710 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4709);
// compilenode returning call4710
// compilenode returning call4710
  partcv[0] = 0;
  Object call4711 = callmethod(call4710, "new",
    1, partcv, params);
  gc_frame_end(callframe4708);
// compilenode returning call4711
// compilenode returning call4711
  *var_suggestion = call4711;
  if (call4711 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1426
  setline(1426);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4712 = gc_frame_new();
  Object block4713 = alloc_Block(NULL, NULL, "parser", 1426);
  gc_frame_newslot(block4713);
  block_savedest(block4713);
  Object closure4714 = createclosure(2, "_apply");
setclosureframe(closure4714, stackframe);
  addtoclosure(closure4714, var_matchTok);
  addtoclosure(closure4714, selfslot);
  struct UserObject *uo4714 = (struct UserObject*)block4713;
  uo4714->data[0] = (Object)closure4714;
  Method *meth_meth_parser__apply4714 = addmethod2pos(block4713, "_apply", &meth_parser__apply4714, 0);
int argcv_meth_parser__apply4714[] = {1};
meth_meth_parser__apply4714->type = alloc_MethodType(1, argcv_meth_parser__apply4714);
  meth_meth_parser__apply4714->definitionModule = modulename;
  meth_meth_parser__apply4714->definitionLine = 1424;
// compilenode returning block4713
  gc_frame_newslot(block4713);
  params[0] = block4713;
  partcv[0] = 1;
  Object call4750 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4712);
// compilenode returning call4750
  *var_nextTok = call4750;
  if (call4750 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4753 = alloc_Boolean(0);
// compilenode returning bool4753
  int op_slot_right_4752 = gc_frame_newslot(bool4753);
// compilenode returning *var_nextTok
  int op_slot_left_4752 = gc_frame_newslot(*var_nextTok);
  params[0] = bool4753;
  partcv[0] = 1;
  Object opresult4755 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4755
  Object if4751 = done;
  if (istrue(opresult4755)) {
// Begin line 1429
  setline(1429);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4756 = gc_frame_new();
  if (strlit4757 == NULL) {
    strlit4757 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb"")");
    gc_root(strlit4757);
  }
// compilenode returning strlit4757
  gc_frame_newslot(strlit4757);
// compilenode returning *var_matchTok
  gc_frame_newslot(*var_matchTok);
// compilenode returning *var_suggestion
  params[0] = strlit4757;
  params[1] = *var_matchTok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4758 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4756);
// compilenode returning call4758
    gc_frame_newslot(call4758);
    if4751 = call4758;
  } else {
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4761 == NULL) {
    strlit4761 = alloc_String("rparen");
    gc_root(strlit4761);
  }
// compilenode returning strlit4761
  int op_slot_right_4760 = gc_frame_newslot(strlit4761);
  int callframe4763 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4764 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4763);
// compilenode returning call4764
// compilenode returning call4764
  int op_slot_left_4760 = gc_frame_newslot(call4764);
  params[0] = strlit4761;
  partcv[0] = 1;
  Object opresult4765 = callmethod(call4764, "==", 1, partcv, params);
// compilenode returning opresult4765
  Object if4759 = done;
  if (istrue(opresult4765)) {
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1431
  setline(1431);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4767 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4767 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4769 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4769
  Object if4766 = done;
  if (istrue(opresult4769)) {
// Begin line 1432
  setline(1432);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4770 = gc_frame_new();
  if (strlit4771 == NULL) {
    strlit4771 = alloc_String("(""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4771);
  }
// compilenode returning strlit4771
  gc_frame_newslot(strlit4771);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit4771;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4772 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4770);
// compilenode returning call4772
    gc_frame_newslot(call4772);
    if4766 = call4772;
  } else {
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4773 = gc_frame_new();
  if (strlit4774 == NULL) {
    strlit4774 = alloc_String("(");
    gc_root(strlit4774);
  }
// compilenode returning strlit4774
  gc_frame_newslot(strlit4774);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit4774;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4775 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4773);
// compilenode returning call4775
    gc_frame_newslot(call4775);
    if4766 = call4775;
  }
// compilenode returning if4766
    gc_frame_newslot(if4766);
    if4759 = if4766;
  } else {
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1436
  setline(1436);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4778 == NULL) {
    strlit4778 = alloc_String("identifier");
    gc_root(strlit4778);
  }
// compilenode returning strlit4778
  int op_slot_right_4777 = gc_frame_newslot(strlit4778);
  int callframe4780 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4781 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe4780);
// compilenode returning call4781
// compilenode returning call4781
  int op_slot_left_4777 = gc_frame_newslot(call4781);
  params[0] = strlit4778;
  partcv[0] = 1;
  Object opresult4782 = callmethod(call4781, "==", 1, partcv, params);
// compilenode returning opresult4782
  Object if4776 = done;
  if (istrue(opresult4782)) {
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4783 = gc_frame_new();
  if (strlit4784 == NULL) {
    strlit4784 = alloc_String("(");
    gc_root(strlit4784);
  }
// compilenode returning strlit4784
  gc_frame_newslot(strlit4784);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit4784;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4785 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe4783);
// compilenode returning call4785
// Begin line 1438
  setline(1438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4786 = gc_frame_new();
  if (strlit4787 == NULL) {
    strlit4787 = alloc_String(")");
    gc_root(strlit4787);
  }
// compilenode returning strlit4787
  gc_frame_newslot(strlit4787);
  int callframe4788 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4789 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4788);
// compilenode returning call4789
// compilenode returning call4789
  gc_frame_newslot(call4789);
  Object bool4790 = alloc_Boolean(1);
// compilenode returning bool4790
  gc_frame_newslot(bool4790);
// compilenode returning *var_suggestion
  params[0] = strlit4787;
  params[1] = call4789;
  params[2] = bool4790;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call4791 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe4786);
// compilenode returning call4791
    gc_frame_newslot(call4791);
    if4776 = call4791;
  } else {
  }
// compilenode returning if4776
    gc_frame_newslot(if4776);
    if4759 = if4776;
  }
// compilenode returning if4759
    gc_frame_newslot(if4759);
    if4751 = if4759;
  }
// compilenode returning if4751
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4792 = gc_frame_new();
  if (strlit4793 == NULL) {
    strlit4793 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4793);
  }
// compilenode returning strlit4793
  gc_frame_newslot(strlit4793);
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4794 = gc_frame_new();
// compilenode returning *var_matchTok
  partcv[0] = 0;
  Object call4795 = callmethod(*var_matchTok, "line",
    1, partcv, params);
  gc_frame_end(callframe4794);
// compilenode returning call4795
// compilenode returning call4795
  gc_frame_newslot(call4795);
  int callframe4797 = gc_frame_new();
// compilenode returning *var_matchTok
  partcv[0] = 0;
  Object call4798 = callmethod(*var_matchTok, "size",
    1, partcv, params);
  gc_frame_end(callframe4797);
// compilenode returning call4798
// compilenode returning call4798
  int op_slot_right_4796 = gc_frame_newslot(call4798);
  int callframe4800 = gc_frame_new();
// compilenode returning *var_matchTok
  partcv[0] = 0;
  Object call4801 = callmethod(*var_matchTok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4800);
// compilenode returning call4801
// compilenode returning call4801
  int op_slot_left_4796 = gc_frame_newslot(call4801);
  params[0] = call4798;
  partcv[0] = 1;
  Object sum4802 = callmethod(call4801, "+", 1, partcv, params);
// compilenode returning sum4802
  gc_frame_newslot(sum4802);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4793;
  params[1] = call4795;
  params[2] = sum4802;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4803 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4792);
// compilenode returning call4803
    gc_frame_newslot(call4803);
    if4701 = call4803;
  } else {
  }
// compilenode returning if4701
// Begin line 1443
  setline(1443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4804 = gc_frame_new();
  partcv[0] = 0;
  Object call4805 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4804);
// compilenode returning call4805
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1444
  setline(1444);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4807 = gc_frame_new();
  int callframe4808 = gc_frame_new();
  Object block4809 = alloc_Block(NULL, NULL, "parser", 1444);
  gc_frame_newslot(block4809);
  block_savedest(block4809);
  Object closure4810 = createclosure(1, "_apply");
setclosureframe(closure4810, stackframe);
  addtoclosure(closure4810, selfslot);
  struct UserObject *uo4810 = (struct UserObject*)block4809;
  uo4810->data[0] = (Object)closure4810;
  Method *meth_meth_parser__apply4810 = addmethod2pos(block4809, "_apply", &meth_parser__apply4810, 0);
int argcv_meth_parser__apply4810[] = {0};
meth_meth_parser__apply4810->type = alloc_MethodType(1, argcv_meth_parser__apply4810);
  meth_meth_parser__apply4810->definitionModule = modulename;
  meth_meth_parser__apply4810->definitionLine = 1444;
// compilenode returning block4809
  gc_frame_newslot(block4809);
  params[0] = block4809;
  partcv[0] = 1;
  Object call4814 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4808);
// compilenode returning call4814
  partcv[0] = 0;
  Object call4815 = callmethod(call4814, "not",
    1, partcv, params);
  gc_frame_end(callframe4807);
// compilenode returning call4815
// compilenode returning call4815
  Object if4806 = done;
  if (istrue(call4815)) {
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4816 = gc_frame_new();
  int callframe4817 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4818 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4817);
// compilenode returning call4818
// compilenode returning call4818
  partcv[0] = 0;
  Object call4819 = callmethod(call4818, "new",
    1, partcv, params);
  gc_frame_end(callframe4816);
// compilenode returning call4819
// compilenode returning call4819
  *var_suggestion = call4819;
  if (call4819 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4820 = gc_frame_new();
  if (strlit4821 == NULL) {
    strlit4821 = alloc_String("rparen");
    gc_root(strlit4821);
  }
// compilenode returning strlit4821
  gc_frame_newslot(strlit4821);
  params[0] = strlit4821;
  partcv[0] = 1;
  Object call4822 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4820);
// compilenode returning call4822
  *var_nextTok = call4822;
  if (call4822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1447
  setline(1447);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_4824 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_4824 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult4826 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult4826
  Object if4823 = done;
  if (istrue(opresult4826)) {
// Begin line 1448
  setline(1448);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4827 = gc_frame_new();
  if (strlit4828 == NULL) {
    strlit4828 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4828);
  }
// compilenode returning strlit4828
  gc_frame_newslot(strlit4828);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4828;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4829 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4827);
// compilenode returning call4829
    gc_frame_newslot(call4829);
    if4823 = call4829;
  } else {
// Begin line 1450
  setline(1450);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4830 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe4831 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call4832 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe4831);
// compilenode returning call4832
// compilenode returning call4832
  gc_frame_newslot(call4832);
  Object bool4833 = alloc_Boolean(1);
// compilenode returning bool4833
  gc_frame_newslot(bool4833);
  Object bool4834 = alloc_Boolean(0);
// compilenode returning bool4834
  gc_frame_newslot(bool4834);
  if (strlit4835 == NULL) {
    strlit4835 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit4835);
  }
// compilenode returning strlit4835
  gc_frame_newslot(strlit4835);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call4832;
  params[2] = bool4833;
  params[3] = bool4834;
  params[4] = strlit4835;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call4836 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe4830);
// compilenode returning call4836
    gc_frame_newslot(call4836);
    if4823 = call4836;
  }
// compilenode returning if4823
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4837 = gc_frame_new();
  if (strlit4838 == NULL) {
    strlit4838 = alloc_String("A match statement must have an expression in parentheses after the 'match'.");
    gc_root(strlit4838);
  }
// compilenode returning strlit4838
  gc_frame_newslot(strlit4838);
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4839 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4840 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe4839);
// compilenode returning call4840
// compilenode returning call4840
  gc_frame_newslot(call4840);
  int callframe4841 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4842 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4841);
// compilenode returning call4842
// compilenode returning call4842
  gc_frame_newslot(call4842);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4838;
  params[1] = call4840;
  params[2] = call4842;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4843 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4837);
// compilenode returning call4843
    gc_frame_newslot(call4843);
    if4806 = call4843;
  } else {
  }
// compilenode returning if4806
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1455
  setline(1455);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4844 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call4845 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe4844);
// compilenode returning call4845
// compilenode returning call4845
  *var_matchee = call4845;
  if (call4845 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1456
  setline(1456);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit4848 == NULL) {
    strlit4848 = alloc_String("rparen");
    gc_root(strlit4848);
  }
// compilenode returning strlit4848
  int op_slot_right_4847 = gc_frame_newslot(strlit4848);
  int callframe4850 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call4851 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe4850);
// compilenode returning call4851
// compilenode returning call4851
  int op_slot_left_4847 = gc_frame_newslot(call4851);
  params[0] = strlit4848;
  partcv[0] = 1;
  Object opresult4852 = callmethod(call4851, "!=", 1, partcv, params);
// compilenode returning opresult4852
  Object if4846 = done;
  if (istrue(opresult4852)) {
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4853 = gc_frame_new();
  partcv[0] = 0;
  Object call4854 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4853);
// compilenode returning call4854
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4855 = gc_frame_new();
  int callframe4856 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call4857 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe4856);
// compilenode returning call4857
// compilenode returning call4857
  partcv[0] = 0;
  Object call4858 = callmethod(call4857, "new",
    1, partcv, params);
  gc_frame_end(callframe4855);
// compilenode returning call4858
// compilenode returning call4858
  *var_suggestion = call4858;
  if (call4858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4859 = gc_frame_new();
  if (strlit4860 == NULL) {
    strlit4860 = alloc_String(")");
    gc_root(strlit4860);
  }
// compilenode returning strlit4860
  gc_frame_newslot(strlit4860);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit4860;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4861 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe4859);
// compilenode returning call4861
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4862 = gc_frame_new();
  if (strlit4863 == NULL) {
    strlit4863 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit4863);
  }
// compilenode returning strlit4863
  gc_frame_newslot(strlit4863);
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4864 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4865 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe4864);
// compilenode returning call4865
// compilenode returning call4865
  gc_frame_newslot(call4865);
  int callframe4867 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4868 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe4867);
// compilenode returning call4868
// compilenode returning call4868
  int op_slot_right_4866 = gc_frame_newslot(call4868);
  int callframe4870 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call4871 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe4870);
// compilenode returning call4871
// compilenode returning call4871
  int op_slot_left_4866 = gc_frame_newslot(call4871);
  params[0] = call4868;
  partcv[0] = 1;
  Object sum4872 = callmethod(call4871, "+", 1, partcv, params);
// compilenode returning sum4872
  gc_frame_newslot(sum4872);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit4863;
  params[1] = call4865;
  params[2] = sum4872;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call4873 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe4862);
// compilenode returning call4873
    gc_frame_newslot(call4873);
    if4846 = call4873;
  } else {
  }
// compilenode returning if4846
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4874 = gc_frame_new();
  partcv[0] = 0;
  Object call4875 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4874);
// compilenode returning call4875
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array4876 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array4876
  *var_cases = array4876;
  if (array4876 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool4877 = alloc_Boolean(0);
// compilenode returning bool4877
  *var_elsecase = bool4877;
  if (bool4877 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1466
  setline(1466);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe4878 = gc_frame_new();
  Object block4879 = alloc_Block(NULL, NULL, "parser", 1466);
  gc_frame_newslot(block4879);
  block_savedest(block4879);
  Object closure4880 = createclosure(2, "_apply");
setclosureframe(closure4880, stackframe);
  addtoclosure(closure4880, var_sym);
  addtoclosure(closure4880, selfslot);
  struct UserObject *uo4880 = (struct UserObject*)block4879;
  uo4880->data[0] = (Object)closure4880;
  Method *meth_meth_parser__apply4880 = addmethod2pos(block4879, "_apply", &meth_parser__apply4880, 0);
int argcv_meth_parser__apply4880[] = {0};
meth_meth_parser__apply4880->type = alloc_MethodType(1, argcv_meth_parser__apply4880);
  meth_meth_parser__apply4880->definitionModule = modulename;
  meth_meth_parser__apply4880->definitionLine = 1461;
// compilenode returning block4879
  gc_frame_newslot(block4879);
  Object block4894 = alloc_Block(NULL, NULL, "parser", 1466);
  gc_frame_newslot(block4894);
  block_savedest(block4894);
  Object closure4895 = createclosure(7, "_apply");
setclosureframe(closure4895, stackframe);
  addtoclosure(closure4895, var_errormessages);
  addtoclosure(closure4895, var_sym);
  addtoclosure(closure4895, var_lastToken);
  addtoclosure(closure4895, var_tokens);
  addtoclosure(closure4895, var_values);
  addtoclosure(closure4895, var_cases);
  addtoclosure(closure4895, selfslot);
  struct UserObject *uo4895 = (struct UserObject*)block4894;
  uo4895->data[0] = (Object)closure4895;
  Method *meth_meth_parser__apply4895 = addmethod2pos(block4894, "_apply", &meth_parser__apply4895, 0);
int argcv_meth_parser__apply4895[] = {0};
meth_meth_parser__apply4895->type = alloc_MethodType(1, argcv_meth_parser__apply4895);
  meth_meth_parser__apply4895->definitionModule = modulename;
  meth_meth_parser__apply4895->definitionLine = 1466;
// compilenode returning block4894
  gc_frame_newslot(block4894);
  params[0] = block4879;
  params[1] = block4894;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5041 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4878);
// compilenode returning call5041
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5042 = gc_frame_new();
  int callframe5043 = gc_frame_new();
// compilenode returning *var_matchee
  gc_frame_newslot(*var_matchee);
// compilenode returning *var_cases
  gc_frame_newslot(*var_cases);
// compilenode returning *var_elsecase
  gc_frame_newslot(*var_elsecase);
  int callframe5044 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5045 = callmethod(*var_ast, "matchCaseNode",
    1, partcv, params);
  gc_frame_end(callframe5044);
// compilenode returning call5045
// compilenode returning call5045
  params[0] = *var_matchee;
  params[1] = *var_cases;
  params[2] = *var_elsecase;
  partcv[0] = 3;
  Object call5046 = callmethod(call5045, "new",
    1, partcv, params);
  gc_frame_end(callframe5043);
// compilenode returning call5046
  gc_frame_newslot(call5046);
// compilenode returning *var_values
  params[0] = call5046;
  partcv[0] = 1;
  Object call5047 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5042);
// compilenode returning call5047
// Begin line 1566
  setline(1566);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localmin
  *var_minIndentLevel = *var_localmin;
  if (*var_localmin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply5137(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit5139 == NULL) {
    strlit5139 = alloc_String("type");
    gc_root(strlit5139);
  }
// compilenode returning strlit5139
  int op_slot_right_5138 = gc_frame_newslot(strlit5139);
  int callframe5141 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5142 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5141);
// compilenode returning call5142
// compilenode returning call5142
  int op_slot_left_5138 = gc_frame_newslot(call5142);
  params[0] = strlit5139;
  partcv[0] = 1;
  Object opresult5143 = callmethod(call5142, "==", 1, partcv, params);
// compilenode returning opresult5143
  gc_frame_end(frame);
  return opresult5143;
}
Object meth_parser_term5049(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "term");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for term (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for term");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1570
  setline(1570);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5051 = gc_frame_new();
  if (strlit5052 == NULL) {
    strlit5052 = alloc_String("num");
    gc_root(strlit5052);
  }
// compilenode returning strlit5052
  gc_frame_newslot(strlit5052);
  params[0] = strlit5052;
  partcv[0] = 1;
  Object call5053 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5051);
// compilenode returning call5053
  Object if5050 = done;
  if (istrue(call5053)) {
// Begin line 1571
  setline(1571);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5054 = gc_frame_new();
  partcv[0] = 0;
  Object call5055 = callmethodflags(self, "pushnum", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5054);
// compilenode returning call5055
    gc_frame_newslot(call5055);
    if5050 = call5055;
  } else {
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5057 = gc_frame_new();
  if (strlit5058 == NULL) {
    strlit5058 = alloc_String("string");
    gc_root(strlit5058);
  }
// compilenode returning strlit5058
  gc_frame_newslot(strlit5058);
  params[0] = strlit5058;
  partcv[0] = 1;
  Object call5059 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5057);
// compilenode returning call5059
  Object if5056 = done;
  if (istrue(call5059)) {
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5060 = gc_frame_new();
  partcv[0] = 0;
  Object call5061 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5060);
// compilenode returning call5061
    gc_frame_newslot(call5061);
    if5056 = call5061;
  } else {
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5063 = gc_frame_new();
  if (strlit5064 == NULL) {
    strlit5064 = alloc_String("octets");
    gc_root(strlit5064);
  }
// compilenode returning strlit5064
  gc_frame_newslot(strlit5064);
  params[0] = strlit5064;
  partcv[0] = 1;
  Object call5065 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5063);
// compilenode returning call5065
  Object if5062 = done;
  if (istrue(call5065)) {
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5066 = gc_frame_new();
  partcv[0] = 0;
  Object call5067 = callmethodflags(self, "pushoctets", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5066);
// compilenode returning call5067
    gc_frame_newslot(call5067);
    if5062 = call5067;
  } else {
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5071 == NULL) {
    strlit5071 = alloc_String("match");
    gc_root(strlit5071);
  }
// compilenode returning strlit5071
  int op_slot_right_5070 = gc_frame_newslot(strlit5071);
  int callframe5073 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5074 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5073);
// compilenode returning call5074
// compilenode returning call5074
  int op_slot_left_5070 = gc_frame_newslot(call5074);
  params[0] = strlit5071;
  partcv[0] = 1;
  Object opresult5075 = callmethod(call5074, "==", 1, partcv, params);
// compilenode returning opresult5075
  int op_slot_right_5069 = gc_frame_newslot(opresult5075);
  int callframe5077 = gc_frame_new();
  if (strlit5078 == NULL) {
    strlit5078 = alloc_String("identifier");
    gc_root(strlit5078);
  }
// compilenode returning strlit5078
  gc_frame_newslot(strlit5078);
  params[0] = strlit5078;
  partcv[0] = 1;
  Object call5079 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5077);
// compilenode returning call5079
  int op_slot_left_5069 = gc_frame_newslot(call5079);
  params[0] = opresult5075;
  partcv[0] = 1;
  Object opresult5080 = callmethod(call5079, "&&", 1, partcv, params);
// compilenode returning opresult5080
  Object if5068 = done;
  if (istrue(opresult5080)) {
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5081 = gc_frame_new();
  partcv[0] = 0;
  Object call5082 = callmethodflags(self, "matchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5081);
// compilenode returning call5082
    gc_frame_newslot(call5082);
    if5068 = call5082;
  } else {
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5086 == NULL) {
    strlit5086 = alloc_String("catch");
    gc_root(strlit5086);
  }
// compilenode returning strlit5086
  int op_slot_right_5085 = gc_frame_newslot(strlit5086);
  int callframe5088 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5089 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5088);
// compilenode returning call5089
// compilenode returning call5089
  int op_slot_left_5085 = gc_frame_newslot(call5089);
  params[0] = strlit5086;
  partcv[0] = 1;
  Object opresult5090 = callmethod(call5089, "==", 1, partcv, params);
// compilenode returning opresult5090
  int op_slot_right_5084 = gc_frame_newslot(opresult5090);
  int callframe5092 = gc_frame_new();
  if (strlit5093 == NULL) {
    strlit5093 = alloc_String("identifier");
    gc_root(strlit5093);
  }
// compilenode returning strlit5093
  gc_frame_newslot(strlit5093);
  params[0] = strlit5093;
  partcv[0] = 1;
  Object call5094 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5092);
// compilenode returning call5094
  int op_slot_left_5084 = gc_frame_newslot(call5094);
  params[0] = opresult5090;
  partcv[0] = 1;
  Object opresult5095 = callmethod(call5094, "&&", 1, partcv, params);
// compilenode returning opresult5095
  Object if5083 = done;
  if (istrue(opresult5095)) {
// Begin line 1579
  setline(1579);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5096 = gc_frame_new();
  partcv[0] = 0;
  Object call5097 = callmethodflags(self, "catchcase", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5096);
// compilenode returning call5097
    gc_frame_newslot(call5097);
    if5083 = call5097;
  } else {
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1580
  setline(1580);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5101 == NULL) {
    strlit5101 = alloc_String("try");
    gc_root(strlit5101);
  }
// compilenode returning strlit5101
  int op_slot_right_5100 = gc_frame_newslot(strlit5101);
  int callframe5103 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5104 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5103);
// compilenode returning call5104
// compilenode returning call5104
  int op_slot_left_5100 = gc_frame_newslot(call5104);
  params[0] = strlit5101;
  partcv[0] = 1;
  Object opresult5105 = callmethod(call5104, "==", 1, partcv, params);
// compilenode returning opresult5105
  int op_slot_right_5099 = gc_frame_newslot(opresult5105);
  int callframe5107 = gc_frame_new();
  if (strlit5108 == NULL) {
    strlit5108 = alloc_String("identifier");
    gc_root(strlit5108);
  }
// compilenode returning strlit5108
  gc_frame_newslot(strlit5108);
  params[0] = strlit5108;
  partcv[0] = 1;
  Object call5109 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5107);
// compilenode returning call5109
  int op_slot_left_5099 = gc_frame_newslot(call5109);
  params[0] = opresult5105;
  partcv[0] = 1;
  Object opresult5110 = callmethod(call5109, "&&", 1, partcv, params);
// compilenode returning opresult5110
  Object if5098 = done;
  if (istrue(opresult5110)) {
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5111 = gc_frame_new();
  partcv[0] = 0;
  Object call5112 = callmethodflags(self, "trycatch", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5111);
// compilenode returning call5112
    gc_frame_newslot(call5112);
    if5098 = call5112;
  } else {
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5114 = gc_frame_new();
  if (strlit5115 == NULL) {
    strlit5115 = alloc_String("identifier");
    gc_root(strlit5115);
  }
// compilenode returning strlit5115
  gc_frame_newslot(strlit5115);
  params[0] = strlit5115;
  partcv[0] = 1;
  Object call5116 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5114);
// compilenode returning call5116
  Object if5113 = done;
  if (istrue(call5116)) {
// Begin line 1583
  setline(1583);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5117 = gc_frame_new();
  partcv[0] = 0;
  Object call5118 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5117);
// compilenode returning call5118
    gc_frame_newslot(call5118);
    if5113 = call5118;
  } else {
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5122 == NULL) {
    strlit5122 = alloc_String("object");
    gc_root(strlit5122);
  }
// compilenode returning strlit5122
  int op_slot_right_5121 = gc_frame_newslot(strlit5122);
  int callframe5124 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5125 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5124);
// compilenode returning call5125
// compilenode returning call5125
  int op_slot_left_5121 = gc_frame_newslot(call5125);
  params[0] = strlit5122;
  partcv[0] = 1;
  Object opresult5126 = callmethod(call5125, "==", 1, partcv, params);
// compilenode returning opresult5126
  int op_slot_right_5120 = gc_frame_newslot(opresult5126);
  int callframe5128 = gc_frame_new();
  if (strlit5129 == NULL) {
    strlit5129 = alloc_String("keyword");
    gc_root(strlit5129);
  }
// compilenode returning strlit5129
  gc_frame_newslot(strlit5129);
  params[0] = strlit5129;
  partcv[0] = 1;
  Object call5130 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5128);
// compilenode returning call5130
  int op_slot_left_5120 = gc_frame_newslot(call5130);
  params[0] = opresult5126;
  partcv[0] = 1;
  Object opresult5131 = callmethod(call5130, "&&", 1, partcv, params);
// compilenode returning opresult5131
  Object if5119 = done;
  if (istrue(opresult5131)) {
// Begin line 1585
  setline(1585);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5132 = gc_frame_new();
  partcv[0] = 0;
  Object call5133 = callmethodflags(self, "doobject", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5132);
// compilenode returning call5133
    gc_frame_newslot(call5133);
    if5119 = call5133;
  } else {
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1586
  setline(1586);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5135 = gc_frame_new();
  Object block5136 = alloc_Block(NULL, NULL, "parser", 1586);
  gc_frame_newslot(block5136);
  block_savedest(block5136);
  Object closure5137 = createclosure(2, "_apply");
setclosureframe(closure5137, stackframe);
  addtoclosure(closure5137, var_sym);
  addtoclosure(closure5137, selfslot);
  struct UserObject *uo5137 = (struct UserObject*)block5136;
  uo5137->data[0] = (Object)closure5137;
  Method *meth_meth_parser__apply5137 = addmethod2pos(block5136, "_apply", &meth_parser__apply5137, 0);
int argcv_meth_parser__apply5137[] = {0};
meth_meth_parser__apply5137->type = alloc_MethodType(1, argcv_meth_parser__apply5137);
  meth_meth_parser__apply5137->definitionModule = modulename;
  meth_meth_parser__apply5137->definitionLine = 1584;
// compilenode returning block5136
  gc_frame_newslot(block5136);
  int callframe5145 = gc_frame_new();
  if (strlit5146 == NULL) {
    strlit5146 = alloc_String("keyword");
    gc_root(strlit5146);
  }
// compilenode returning strlit5146
  gc_frame_newslot(strlit5146);
  params[0] = strlit5146;
  partcv[0] = 1;
  Object call5147 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5145);
// compilenode returning call5147
  params[0] = block5136;
  partcv[0] = 1;
  Object call5148 = callmethod(call5147, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5135);
// compilenode returning call5148
  Object if5134 = done;
  if (istrue(call5148)) {
// Begin line 1587
  setline(1587);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5149 = gc_frame_new();
  partcv[0] = 0;
  Object call5150 = callmethodflags(self, "doanontype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5149);
// compilenode returning call5150
    gc_frame_newslot(call5150);
    if5134 = call5150;
  } else {
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5152 = gc_frame_new();
  if (strlit5153 == NULL) {
    strlit5153 = alloc_String("lbrace");
    gc_root(strlit5153);
  }
// compilenode returning strlit5153
  gc_frame_newslot(strlit5153);
  params[0] = strlit5153;
  partcv[0] = 1;
  Object call5154 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compilenode returning call5154
  Object if5151 = done;
  if (istrue(call5154)) {
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5155 = gc_frame_new();
  partcv[0] = 0;
  Object call5156 = callmethodflags(self, "block", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5155);
// compilenode returning call5156
    gc_frame_newslot(call5156);
    if5151 = call5156;
  } else {
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5158 = gc_frame_new();
  if (strlit5159 == NULL) {
    strlit5159 = alloc_String("lsquare");
    gc_root(strlit5159);
  }
// compilenode returning strlit5159
  gc_frame_newslot(strlit5159);
  params[0] = strlit5159;
  partcv[0] = 1;
  Object call5160 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5158);
// compilenode returning call5160
  Object if5157 = done;
  if (istrue(call5160)) {
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5161 = gc_frame_new();
  partcv[0] = 0;
  Object call5162 = callmethodflags(self, "doarray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5161);
// compilenode returning call5162
    gc_frame_newslot(call5162);
    if5157 = call5162;
  } else {
// Begin line 1596
  setline(1596);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5164 = gc_frame_new();
  if (strlit5165 == NULL) {
    strlit5165 = alloc_String("op");
    gc_root(strlit5165);
  }
// compilenode returning strlit5165
  gc_frame_newslot(strlit5165);
  params[0] = strlit5165;
  partcv[0] = 1;
  Object call5166 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5164);
// compilenode returning call5166
  Object if5163 = done;
  if (istrue(call5166)) {
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5167 = gc_frame_new();
  partcv[0] = 0;
  Object call5168 = callmethodflags(self, "prefixop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5167);
// compilenode returning call5168
    gc_frame_newslot(call5168);
    if5163 = call5168;
  } else {
  }
// compilenode returning if5163
    gc_frame_newslot(if5163);
    if5157 = if5163;
  }
// compilenode returning if5157
    gc_frame_newslot(if5157);
    if5151 = if5157;
  }
// compilenode returning if5151
    gc_frame_newslot(if5151);
    if5134 = if5151;
  }
// compilenode returning if5134
    gc_frame_newslot(if5134);
    if5119 = if5134;
  }
// compilenode returning if5119
    gc_frame_newslot(if5119);
    if5113 = if5119;
  }
// compilenode returning if5113
    gc_frame_newslot(if5113);
    if5098 = if5113;
  }
// compilenode returning if5098
    gc_frame_newslot(if5098);
    if5083 = if5098;
  }
// compilenode returning if5083
    gc_frame_newslot(if5083);
    if5068 = if5083;
  }
// compilenode returning if5068
    gc_frame_newslot(if5068);
    if5062 = if5068;
  }
// compilenode returning if5062
    gc_frame_newslot(if5062);
    if5056 = if5062;
  }
// compilenode returning if5056
    gc_frame_newslot(if5056);
    if5050 = if5056;
  }
// compilenode returning if5050
  gc_frame_end(frame);
  return if5050;
}
Object meth_parser__apply5183(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe5184 = gc_frame_new();
  partcv[0] = 0;
  Object call5185 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5184);
// compilenode returning call5185
  gc_frame_end(frame);
  return call5185;
}
Object meth_parser_expression5169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expression");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expression (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for expression");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sz");
  Object *var_tmpStatementToken = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "tmpStatementToken");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5170 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5171 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5170);
// compilenode returning call5171
// compilenode returning call5171
  *var_sz = call5171;
  if (call5171 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5173 = gc_frame_new();
  if (strlit5174 == NULL) {
    strlit5174 = alloc_String("lparen");
    gc_root(strlit5174);
  }
// compilenode returning strlit5174
  gc_frame_newslot(strlit5174);
  params[0] = strlit5174;
  partcv[0] = 1;
  Object call5175 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5173);
// compilenode returning call5175
  Object if5172 = done;
  if (istrue(call5175)) {
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1605
  setline(1605);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_statementToken
  *var_tmpStatementToken = *var_statementToken;
  if (*var_statementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1607
  setline(1607);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5177 = gc_frame_new();
  partcv[0] = 0;
  Object call5178 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5177);
// compilenode returning call5178
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5180 = gc_frame_new();
  int callframe5181 = gc_frame_new();
  Object block5182 = alloc_Block(NULL, NULL, "parser", 1608);
  gc_frame_newslot(block5182);
  block_savedest(block5182);
  Object closure5183 = createclosure(1, "_apply");
setclosureframe(closure5183, stackframe);
  addtoclosure(closure5183, selfslot);
  struct UserObject *uo5183 = (struct UserObject*)block5182;
  uo5183->data[0] = (Object)closure5183;
  Method *meth_meth_parser__apply5183 = addmethod2pos(block5182, "_apply", &meth_parser__apply5183, 0);
int argcv_meth_parser__apply5183[] = {0};
meth_meth_parser__apply5183->type = alloc_MethodType(1, argcv_meth_parser__apply5183);
  meth_meth_parser__apply5183->definitionModule = modulename;
  meth_meth_parser__apply5183->definitionLine = 1608;
// compilenode returning block5182
  gc_frame_newslot(block5182);
  params[0] = block5182;
  partcv[0] = 1;
  Object call5187 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5181);
// compilenode returning call5187
  partcv[0] = 0;
  Object call5188 = callmethod(call5187, "not",
    1, partcv, params);
  gc_frame_end(callframe5180);
// compilenode returning call5188
// compilenode returning call5188
  Object if5179 = done;
  if (istrue(call5188)) {
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1609
  setline(1609);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5189 = gc_frame_new();
  int callframe5190 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5191 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5190);
// compilenode returning call5191
// compilenode returning call5191
  partcv[0] = 0;
  Object call5192 = callmethod(call5191, "new",
    1, partcv, params);
  gc_frame_end(callframe5189);
// compilenode returning call5192
// compilenode returning call5192
  *var_suggestion = call5192;
  if (call5192 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1610
  setline(1610);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5193 = gc_frame_new();
  if (strlit5194 == NULL) {
    strlit5194 = alloc_String("rparen");
    gc_root(strlit5194);
  }
// compilenode returning strlit5194
  gc_frame_newslot(strlit5194);
  params[0] = strlit5194;
  partcv[0] = 1;
  Object call5195 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5193);
// compilenode returning call5195
  *var_nextTok = call5195;
  if (call5195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_5197 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_5197 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5199 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult5199
  Object if5196 = done;
  if (istrue(opresult5199)) {
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5200 = gc_frame_new();
  if (strlit5201 == NULL) {
    strlit5201 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5201);
  }
// compilenode returning strlit5201
  gc_frame_newslot(strlit5201);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5201;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5202 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5200);
// compilenode returning call5202
    gc_frame_newslot(call5202);
    if5196 = call5202;
  } else {
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5203 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe5204 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5205 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5204);
// compilenode returning call5205
// compilenode returning call5205
  gc_frame_newslot(call5205);
  Object bool5206 = alloc_Boolean(1);
// compilenode returning bool5206
  gc_frame_newslot(bool5206);
  Object bool5207 = alloc_Boolean(0);
// compilenode returning bool5207
  gc_frame_newslot(bool5207);
  if (strlit5208 == NULL) {
    strlit5208 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5208);
  }
// compilenode returning strlit5208
  gc_frame_newslot(strlit5208);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call5205;
  params[2] = bool5206;
  params[3] = bool5207;
  params[4] = strlit5208;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5209 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5203);
// compilenode returning call5209
    gc_frame_newslot(call5209);
    if5196 = call5209;
  }
// compilenode returning if5196
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5210 = gc_frame_new();
  if (strlit5211 == NULL) {
    strlit5211 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit5211);
  }
// compilenode returning strlit5211
  gc_frame_newslot(strlit5211);
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5212 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5213 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5212);
// compilenode returning call5213
// compilenode returning call5213
  gc_frame_newslot(call5213);
  int callframe5214 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5215 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5214);
// compilenode returning call5215
// compilenode returning call5215
  gc_frame_newslot(call5215);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5211;
  params[1] = call5213;
  params[2] = call5215;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5216 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5210);
// compilenode returning call5216
    gc_frame_newslot(call5216);
    if5179 = call5216;
  } else {
  }
// compilenode returning if5179
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5219 == NULL) {
    strlit5219 = alloc_String("rparen");
    gc_root(strlit5219);
  }
// compilenode returning strlit5219
  int op_slot_right_5218 = gc_frame_newslot(strlit5219);
  int callframe5221 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5222 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5221);
// compilenode returning call5222
// compilenode returning call5222
  int op_slot_left_5218 = gc_frame_newslot(call5222);
  params[0] = strlit5219;
  partcv[0] = 1;
  Object opresult5223 = callmethod(call5222, "!=", 1, partcv, params);
// compilenode returning opresult5223
  Object if5217 = done;
  if (istrue(opresult5223)) {
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5224 = gc_frame_new();
  partcv[0] = 0;
  Object call5225 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5224);
// compilenode returning call5225
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5226 = gc_frame_new();
  int callframe5227 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5228 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5227);
// compilenode returning call5228
// compilenode returning call5228
  partcv[0] = 0;
  Object call5229 = callmethod(call5228, "new",
    1, partcv, params);
  gc_frame_end(callframe5226);
// compilenode returning call5229
// compilenode returning call5229
  *var_suggestion = call5229;
  if (call5229 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1622
  setline(1622);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5230 = gc_frame_new();
  if (strlit5231 == NULL) {
    strlit5231 = alloc_String(")");
    gc_root(strlit5231);
  }
// compilenode returning strlit5231
  gc_frame_newslot(strlit5231);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5231;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5232 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5230);
// compilenode returning call5232
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5233 = gc_frame_new();
  if (strlit5234 == NULL) {
    strlit5234 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5234);
  }
// compilenode returning strlit5234
  gc_frame_newslot(strlit5234);
// Begin line 1624
  setline(1624);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5235 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5236 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5235);
// compilenode returning call5236
// compilenode returning call5236
  gc_frame_newslot(call5236);
  int callframe5238 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5239 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5238);
// compilenode returning call5239
// compilenode returning call5239
  int op_slot_right_5237 = gc_frame_newslot(call5239);
  int callframe5241 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5242 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5241);
// compilenode returning call5242
// compilenode returning call5242
  int op_slot_left_5237 = gc_frame_newslot(call5242);
  params[0] = call5239;
  partcv[0] = 1;
  Object sum5243 = callmethod(call5242, "+", 1, partcv, params);
// compilenode returning sum5243
  gc_frame_newslot(sum5243);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5234;
  params[1] = call5236;
  params[2] = sum5243;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5244 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5233);
// compilenode returning call5244
    gc_frame_newslot(call5244);
    if5217 = call5244;
  } else {
  }
// compilenode returning if5217
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_tmpStatementToken
  *var_statementToken = *var_tmpStatementToken;
  if (*var_tmpStatementToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1627
  setline(1627);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5246 = gc_frame_new();
  partcv[0] = 0;
  Object call5247 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5246);
// compilenode returning call5247
    gc_frame_newslot(call5247);
    if5172 = call5247;
  } else {
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5248 = gc_frame_new();
  partcv[0] = 0;
  Object call5249 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5248);
// compilenode returning call5249
    gc_frame_newslot(call5249);
    if5172 = call5249;
  }
// compilenode returning if5172
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sz
  int op_slot_right_5251 = gc_frame_newslot(*var_sz);
  int callframe5253 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5254 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5253);
// compilenode returning call5254
// compilenode returning call5254
  int op_slot_left_5251 = gc_frame_newslot(call5254);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult5255 = callmethod(call5254, ">", 1, partcv, params);
// compilenode returning opresult5255
  Object if5250 = done;
  if (istrue(opresult5255)) {
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5256 = gc_frame_new();
  partcv[0] = 0;
  Object call5257 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5256);
// compilenode returning call5257
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5258 = gc_frame_new();
  partcv[0] = 0;
  Object call5259 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5258);
// compilenode returning call5259
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5260 = gc_frame_new();
  partcv[0] = 0;
  Object call5261 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5260);
// compilenode returning call5261
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5262 = gc_frame_new();
  partcv[0] = 0;
  Object call5263 = callmethodflags(self, "expressionrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5262);
// compilenode returning call5263
    gc_frame_newslot(call5263);
    if5250 = call5263;
  } else {
  }
// compilenode returning if5250
  gc_frame_end(frame);
  return if5250;
}
Object meth_parser__apply5277(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe5278 = gc_frame_new();
  partcv[0] = 0;
  Object call5279 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5278);
// compilenode returning call5279
  gc_frame_end(frame);
  return call5279;
}
Object meth_parser_postfixsquare5264(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "postfixsquare");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for postfixsquare (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for postfixsquare");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_expr = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "expr");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_index = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "index");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 1677
  setline(1677);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1642
  setline(1642);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5266 = gc_frame_new();
  if (strlit5267 == NULL) {
    strlit5267 = alloc_String("lsquare");
    gc_root(strlit5267);
  }
// compilenode returning strlit5267
  gc_frame_newslot(strlit5267);
  params[0] = strlit5267;
  partcv[0] = 1;
  Object call5268 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5266);
// compilenode returning call5268
  Object if5265 = done;
  if (istrue(call5268)) {
// Begin line 1643
  setline(1643);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5269 = gc_frame_new();
  partcv[0] = 0;
  Object call5270 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5269);
// compilenode returning call5270
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5271 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5272 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5271);
// compilenode returning call5272
// compilenode returning call5272
  *var_expr = call5272;
  if (call5272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1645
  setline(1645);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5274 = gc_frame_new();
  int callframe5275 = gc_frame_new();
  Object block5276 = alloc_Block(NULL, NULL, "parser", 1645);
  gc_frame_newslot(block5276);
  block_savedest(block5276);
  Object closure5277 = createclosure(1, "_apply");
setclosureframe(closure5277, stackframe);
  addtoclosure(closure5277, selfslot);
  struct UserObject *uo5277 = (struct UserObject*)block5276;
  uo5277->data[0] = (Object)closure5277;
  Method *meth_meth_parser__apply5277 = addmethod2pos(block5276, "_apply", &meth_parser__apply5277, 0);
int argcv_meth_parser__apply5277[] = {0};
meth_meth_parser__apply5277->type = alloc_MethodType(1, argcv_meth_parser__apply5277);
  meth_meth_parser__apply5277->definitionModule = modulename;
  meth_meth_parser__apply5277->definitionLine = 1645;
// compilenode returning block5276
  gc_frame_newslot(block5276);
  params[0] = block5276;
  partcv[0] = 1;
  Object call5281 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5275);
// compilenode returning call5281
  partcv[0] = 0;
  Object call5282 = callmethod(call5281, "not",
    1, partcv, params);
  gc_frame_end(callframe5274);
// compilenode returning call5282
// compilenode returning call5282
  Object if5273 = done;
  if (istrue(call5282)) {
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1646
  setline(1646);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5283 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5283
  *var_suggestions = array5283;
  if (array5283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1647
  setline(1647);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5284 = gc_frame_new();
  int callframe5285 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5286 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5285);
// compilenode returning call5286
// compilenode returning call5286
  partcv[0] = 0;
  Object call5287 = callmethod(call5286, "new",
    1, partcv, params);
  gc_frame_end(callframe5284);
// compilenode returning call5287
// compilenode returning call5287
  *var_suggestion = call5287;
  if (call5287 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1648
  setline(1648);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5288 = gc_frame_new();
  if (strlit5289 == NULL) {
    strlit5289 = alloc_String("rsquare");
    gc_root(strlit5289);
  }
// compilenode returning strlit5289
  gc_frame_newslot(strlit5289);
  params[0] = strlit5289;
  partcv[0] = 1;
  Object call5290 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5288);
// compilenode returning call5290
  *var_nextTok = call5290;
  if (call5290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_5292 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_5292 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5294 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult5294
  Object if5291 = done;
  if (istrue(opresult5294)) {
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5295 = gc_frame_new();
  if (strlit5296 == NULL) {
    strlit5296 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5296);
  }
// compilenode returning strlit5296
  gc_frame_newslot(strlit5296);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5296;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5297 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5295);
// compilenode returning call5297
    gc_frame_newslot(call5297);
    if5291 = call5297;
  } else {
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5298 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe5299 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5300 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5299);
// compilenode returning call5300
// compilenode returning call5300
  gc_frame_newslot(call5300);
  Object bool5301 = alloc_Boolean(1);
// compilenode returning bool5301
  gc_frame_newslot(bool5301);
  Object bool5302 = alloc_Boolean(0);
// compilenode returning bool5302
  gc_frame_newslot(bool5302);
  if (strlit5303 == NULL) {
    strlit5303 = alloc_String("""\xc2""""\xab""index""\xc2""""\xbb""");
    gc_root(strlit5303);
  }
// compilenode returning strlit5303
  gc_frame_newslot(strlit5303);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call5300;
  params[2] = bool5301;
  params[3] = bool5302;
  params[4] = strlit5303;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5304 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5298);
// compilenode returning call5304
    gc_frame_newslot(call5304);
    if5291 = call5304;
  }
// compilenode returning if5291
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5305 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5306 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5305);
// compilenode returning call5306
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5309 == NULL) {
    strlit5309 = alloc_String("rsquare");
    gc_root(strlit5309);
  }
// compilenode returning strlit5309
  int op_slot_right_5308 = gc_frame_newslot(strlit5309);
  int callframe5311 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5312 = callmethod(*var_nextTok, "kind",
    1, partcv, params);
  gc_frame_end(callframe5311);
// compilenode returning call5312
// compilenode returning call5312
  int op_slot_left_5308 = gc_frame_newslot(call5312);
  params[0] = strlit5309;
  partcv[0] = 1;
  Object opresult5313 = callmethod(call5312, "==", 1, partcv, params);
// compilenode returning opresult5313
  Object if5307 = done;
  if (istrue(opresult5313)) {
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1656
  setline(1656);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5314 = gc_frame_new();
  int callframe5315 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5316 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5315);
// compilenode returning call5316
// compilenode returning call5316
  partcv[0] = 0;
  Object call5317 = callmethod(call5316, "new",
    1, partcv, params);
  gc_frame_end(callframe5314);
// compilenode returning call5317
// compilenode returning call5317
  *var_suggestion = call5317;
  if (call5317 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5319 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_nextTok
  gc_frame_newslot(*var_nextTok);
  Object bool5320 = alloc_Boolean(1);
// compilenode returning bool5320
  gc_frame_newslot(bool5320);
  Object bool5321 = alloc_Boolean(0);
// compilenode returning bool5321
  gc_frame_newslot(bool5321);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = *var_nextTok;
  params[2] = bool5320;
  params[3] = bool5321;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5322 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5319);
// compilenode returning call5322
// Begin line 1658
  setline(1658);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5323 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5324 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5323);
// compilenode returning call5324
    gc_frame_newslot(call5324);
    if5307 = call5324;
  } else {
  }
// compilenode returning if5307
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5325 = gc_frame_new();
  if (strlit5326 == NULL) {
    strlit5326 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5326);
  }
// compilenode returning strlit5326
  gc_frame_newslot(strlit5326);
// Begin line 1661
  setline(1661);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5327 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5328 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5327);
// compilenode returning call5328
// compilenode returning call5328
  gc_frame_newslot(call5328);
  int callframe5329 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5330 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5329);
// compilenode returning call5330
// compilenode returning call5330
  gc_frame_newslot(call5330);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1660
  setline(1660);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5326;
  params[1] = call5328;
  params[2] = call5330;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5331 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5325);
// compilenode returning call5331
    gc_frame_newslot(call5331);
    if5273 = call5331;
  } else {
  }
// compilenode returning if5273
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1663
  setline(1663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5332 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5333 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5332);
// compilenode returning call5333
// compilenode returning call5333
  *var_index = call5333;
  if (call5333 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1664
  setline(1664);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5336 == NULL) {
    strlit5336 = alloc_String("rsquare");
    gc_root(strlit5336);
  }
// compilenode returning strlit5336
  int op_slot_right_5335 = gc_frame_newslot(strlit5336);
  int callframe5338 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5339 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5338);
// compilenode returning call5339
// compilenode returning call5339
  int op_slot_left_5335 = gc_frame_newslot(call5339);
  params[0] = strlit5336;
  partcv[0] = 1;
  Object opresult5340 = callmethod(call5339, "!=", 1, partcv, params);
// compilenode returning opresult5340
  Object if5334 = done;
  if (istrue(opresult5340)) {
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5341 = gc_frame_new();
  int callframe5342 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5343 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5342);
// compilenode returning call5343
// compilenode returning call5343
  partcv[0] = 0;
  Object call5344 = callmethod(call5343, "new",
    1, partcv, params);
  gc_frame_end(callframe5341);
// compilenode returning call5344
// compilenode returning call5344
  *var_suggestion = call5344;
  if (call5344 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5345 = gc_frame_new();
  if (strlit5346 == NULL) {
    strlit5346 = alloc_String("]");
    gc_root(strlit5346);
  }
// compilenode returning strlit5346
  gc_frame_newslot(strlit5346);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5346;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5347 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5345);
// compilenode returning call5347
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5348 = gc_frame_new();
  if (strlit5349 == NULL) {
    strlit5349 = alloc_String("A '[' in an expression must be followed by another expression and a ']'.");
    gc_root(strlit5349);
  }
// compilenode returning strlit5349
  gc_frame_newslot(strlit5349);
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5350 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5351 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5350);
// compilenode returning call5351
// compilenode returning call5351
  gc_frame_newslot(call5351);
  int callframe5353 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5354 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5353);
// compilenode returning call5354
// compilenode returning call5354
  int op_slot_right_5352 = gc_frame_newslot(call5354);
  int callframe5356 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5357 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5356);
// compilenode returning call5357
// compilenode returning call5357
  int op_slot_left_5352 = gc_frame_newslot(call5357);
  params[0] = call5354;
  partcv[0] = 1;
  Object sum5358 = callmethod(call5357, "+", 1, partcv, params);
// compilenode returning sum5358
  gc_frame_newslot(sum5358);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5349;
  params[1] = call5351;
  params[2] = sum5358;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5359 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5348);
// compilenode returning call5359
    gc_frame_newslot(call5359);
    if5334 = call5359;
  } else {
  }
// compilenode returning if5334
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5360 = gc_frame_new();
  partcv[0] = 0;
  Object call5361 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5360);
// compilenode returning call5361
// Begin line 1671
  setline(1671);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5362 = gc_frame_new();
// compilenode returning *var_expr
  gc_frame_newslot(*var_expr);
// compilenode returning *var_index
  gc_frame_newslot(*var_index);
  int callframe5363 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5364 = callmethod(*var_ast, "indexNode",
    1, partcv, params);
  gc_frame_end(callframe5363);
// compilenode returning call5364
// compilenode returning call5364
  params[0] = *var_expr;
  params[1] = *var_index;
  partcv[0] = 2;
  Object call5365 = callmethod(call5364, "new",
    1, partcv, params);
  gc_frame_end(callframe5362);
// compilenode returning call5365
  *var_o = call5365;
  if (call5365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5366 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5367 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5366);
// compilenode returning call5367
// Begin line 1673
  setline(1673);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5368 = gc_frame_new();
  partcv[0] = 0;
  Object call5369 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5368);
// compilenode returning call5369
// Begin line 1674
  setline(1674);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5370 = gc_frame_new();
  partcv[0] = 0;
  Object call5371 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5370);
// compilenode returning call5371
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5372 = gc_frame_new();
  partcv[0] = 0;
  Object call5373 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5372);
// compilenode returning call5373
    gc_frame_newslot(call5373);
    if5265 = call5373;
  } else {
  }
// compilenode returning if5265
  gc_frame_end(frame);
  return if5265;
}
Object meth_parser_oprec5374(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "oprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for oprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for oprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5377 == NULL) {
    strlit5377 = alloc_String("*");
    gc_root(strlit5377);
  }
// compilenode returning strlit5377
  int op_slot_right_5376 = gc_frame_newslot(strlit5377);
// compilenode returning *var_o
  int op_slot_left_5376 = gc_frame_newslot(*var_o);
  params[0] = strlit5377;
  partcv[0] = 1;
  Object opresult5379 = callmethod(*var_o, "==", 1, partcv, params);
// compilenode returning opresult5379
  Object if5375 = done;
  if (istrue(opresult5379)) {
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5380 = alloc_Float64(10);
// compilenode returning num5380
  return num5380;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5375 = undefined;
  } else {
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1685
  setline(1685);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5383 == NULL) {
    strlit5383 = alloc_String("/");
    gc_root(strlit5383);
  }
// compilenode returning strlit5383
  int op_slot_right_5382 = gc_frame_newslot(strlit5383);
// compilenode returning *var_o
  int op_slot_left_5382 = gc_frame_newslot(*var_o);
  params[0] = strlit5383;
  partcv[0] = 1;
  Object opresult5385 = callmethod(*var_o, "==", 1, partcv, params);
// compilenode returning opresult5385
  Object if5381 = done;
  if (istrue(opresult5385)) {
// Begin line 1687
  setline(1687);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5386 = alloc_Float64(10);
// compilenode returning num5386
  return num5386;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5381 = undefined;
  } else {
  }
// compilenode returning if5381
    gc_frame_newslot(if5381);
    if5375 = if5381;
  }
// compilenode returning if5375
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1688
  setline(1688);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5387 = alloc_Float64(5);
// compilenode returning num5387
  return num5387;
// compilenode returning undefined
  gc_frame_end(frame);
  return undefined;
}
Object meth_parser_toprec5388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "toprec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for toprec (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ops = &(stackframe->slots[0]);
  *var_ops = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for toprec");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_o = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "o");
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1693
  setline(1693);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5391 = alloc_Float64(0);
// compilenode returning num5391
  int op_slot_right_5390 = gc_frame_newslot(num5391);
  int callframe5393 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5394 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5393);
// compilenode returning call5394
// compilenode returning call5394
  int op_slot_left_5390 = gc_frame_newslot(call5394);
  params[0] = num5391;
  partcv[0] = 1;
  Object opresult5395 = callmethod(call5394, ">", 1, partcv, params);
// compilenode returning opresult5395
  Object if5389 = done;
  if (istrue(opresult5395)) {
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1694
  setline(1694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5396 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5397 = callmethod(*var_ops, "last",
    1, partcv, params);
  gc_frame_end(callframe5396);
// compilenode returning call5397
// compilenode returning call5397
  *var_o = call5397;
  if (call5397 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1695
  setline(1695);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5398 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5399 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5398);
// compilenode returning call5399
  return call5399;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5389 = undefined;
  } else {
  }
// compilenode returning if5389
// Begin line 1697
  setline(1697);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5400 = alloc_Float64(0);
// compilenode returning num5400
  gc_frame_end(frame);
  return num5400;
}
Object meth_parser__apply5420(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit5422 == NULL) {
    strlit5422 = alloc_String("=");
    gc_root(strlit5422);
  }
// compilenode returning strlit5422
  int op_slot_right_5421 = gc_frame_newslot(strlit5422);
  int callframe5424 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5425 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5424);
// compilenode returning call5425
// compilenode returning call5425
  int op_slot_left_5421 = gc_frame_newslot(call5425);
  params[0] = strlit5422;
  partcv[0] = 1;
  Object opresult5426 = callmethod(call5425, "!=", 1, partcv, params);
// compilenode returning opresult5426
  gc_frame_end(frame);
  return opresult5426;
}
Object meth_parser__apply5417(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5418 = gc_frame_new();
  Object block5419 = alloc_Block(NULL, NULL, "parser", 1718);
  gc_frame_newslot(block5419);
  block_savedest(block5419);
  Object closure5420 = createclosure(2, "_apply");
setclosureframe(closure5420, stackframe);
  addtoclosure(closure5420, var_sym);
  addtoclosure(closure5420, selfslot);
  struct UserObject *uo5420 = (struct UserObject*)block5419;
  uo5420->data[0] = (Object)closure5420;
  Method *meth_meth_parser__apply5420 = addmethod2pos(block5419, "_apply", &meth_parser__apply5420, 0);
int argcv_meth_parser__apply5420[] = {0};
meth_meth_parser__apply5420->type = alloc_MethodType(1, argcv_meth_parser__apply5420);
  meth_meth_parser__apply5420->definitionModule = modulename;
  meth_meth_parser__apply5420->definitionLine = 1711;
// compilenode returning block5419
  gc_frame_newslot(block5419);
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5428 = gc_frame_new();
  if (strlit5429 == NULL) {
    strlit5429 = alloc_String("op");
    gc_root(strlit5429);
  }
// compilenode returning strlit5429
  gc_frame_newslot(strlit5429);
// compilenode returning *var_statementToken
  gc_frame_newslot(*var_statementToken);
  params[0] = strlit5429;
  params[1] = *var_statementToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5430 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5428);
// compilenode returning call5430
  params[0] = block5419;
  partcv[0] = 1;
  Object call5431 = callmethod(call5430, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe5418);
// compilenode returning call5431
  gc_frame_end(frame);
  return call5431;
}
Object meth_parser__apply5542(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_prec = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe5545 = gc_frame_new();
// compilenode returning *var_ops
  gc_frame_newslot(*var_ops);
  params[0] = *var_ops;
  partcv[0] = 1;
  Object call5546 = callmethodflags(self, "toprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5545);
// compilenode returning call5546
  int op_slot_right_5544 = gc_frame_newslot(call5546);
// compilenode returning *var_prec
  int op_slot_left_5544 = gc_frame_newslot(*var_prec);
  params[0] = call5546;
  partcv[0] = 1;
  Object opresult5548 = callmethod(*var_prec, "<=", 1, partcv, params);
// compilenode returning opresult5548
  int op_slot_right_5543 = gc_frame_newslot(opresult5548);
  Object num5551 = alloc_Float64(0);
// compilenode returning num5551
  int op_slot_right_5550 = gc_frame_newslot(num5551);
  int callframe5553 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5554 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5553);
// compilenode returning call5554
// compilenode returning call5554
  int op_slot_left_5550 = gc_frame_newslot(call5554);
  params[0] = num5551;
  partcv[0] = 1;
  Object opresult5555 = callmethod(call5554, ">", 1, partcv, params);
// compilenode returning opresult5555
  int op_slot_left_5543 = gc_frame_newslot(opresult5555);
  params[0] = opresult5548;
  partcv[0] = 1;
  Object opresult5556 = callmethod(opresult5555, "&&", 1, partcv, params);
// compilenode returning opresult5556
  gc_frame_end(frame);
  return opresult5556;
}
Object meth_parser__apply5559(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o2 = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1749
  setline(1749);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5560 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5561 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5560);
// compilenode returning call5561
// compilenode returning call5561
  *var_o2 = call5561;
  if (call5561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1750
  setline(1750);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5563 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5564 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5563);
// compilenode returning call5564
// compilenode returning call5564
  *var_tmp2 = call5564;
  if (call5564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5566 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5567 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5566);
// compilenode returning call5567
// compilenode returning call5567
  *var_tmp = call5567;
  if (call5567 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5569 = gc_frame_new();
// compilenode returning *var_o2
  gc_frame_newslot(*var_o2);
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_tmp2
  gc_frame_newslot(*var_tmp2);
  int callframe5570 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5571 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5570);
// compilenode returning call5571
// compilenode returning call5571
  params[0] = *var_o2;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5572 = callmethod(call5571, "new",
    1, partcv, params);
  gc_frame_end(callframe5569);
// compilenode returning call5572
  *var_tmp = call5572;
  if (call5572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5574 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_terms
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5575 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5574);
// compilenode returning call5575
  gc_frame_end(frame);
  return call5575;
}
Object meth_parser__apply5590(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe5591 = gc_frame_new();
  partcv[0] = 0;
  Object call5592 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5591);
// compilenode returning call5592
  gc_frame_end(frame);
  return call5592;
}
Object meth_parser__apply5727(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe5728 = gc_frame_new();
  partcv[0] = 0;
  Object call5729 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5728);
// compilenode returning call5729
  gc_frame_end(frame);
  return call5729;
}
Object meth_parser__apply5434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_opcount = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_o = getfromclosure(closure, 2);
  Object *var_prec = getfromclosure(closure, 3);
  Object *var_allarith = getfromclosure(closure, 4);
  Object *var_opdtype = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_ops = getfromclosure(closure, 8);
  Object *var_o2 = getfromclosure(closure, 9);
  Object *var_terms = getfromclosure(closure, 10);
  Object *var_tmp2 = getfromclosure(closure, 11);
  Object *var_tmp = getfromclosure(closure, 12);
  Object *var_ast = getfromclosure(closure, 13);
  Object *var_util = getfromclosure(closure, 14);
  Object *var_values = getfromclosure(closure, 15);
  Object self = *(getfromclosure(closure, 16));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1719
  setline(1719);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5436 = alloc_Float64(1);
// compilenode returning num5436
  int op_slot_right_5435 = gc_frame_newslot(num5436);
// compilenode returning *var_opcount
  int op_slot_left_5435 = gc_frame_newslot(*var_opcount);
  params[0] = num5436;
  partcv[0] = 1;
  Object sum5438 = callmethod(*var_opcount, "+", 1, partcv, params);
// compilenode returning sum5438
  *var_opcount = sum5438;
  if (sum5438 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5440 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5441 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5440);
// compilenode returning call5441
// compilenode returning call5441
  *var_o = call5441;
  if (call5441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1721
  setline(1721);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5443 = gc_frame_new();
  partcv[0] = 0;
  Object call5444 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5443);
// compilenode returning call5444
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5445 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5446 = callmethodflags(self, "oprec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5445);
// compilenode returning call5446
  *var_prec = call5446;
  if (call5446 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1723
  setline(1723);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5451 == NULL) {
    strlit5451 = alloc_String("-");
    gc_root(strlit5451);
  }
// compilenode returning strlit5451
  int op_slot_right_5450 = gc_frame_newslot(strlit5451);
// compilenode returning *var_o
  int op_slot_left_5450 = gc_frame_newslot(*var_o);
  params[0] = strlit5451;
  partcv[0] = 1;
  Object opresult5453 = callmethod(*var_o, "!=", 1, partcv, params);
// compilenode returning opresult5453
  int op_slot_right_5449 = gc_frame_newslot(opresult5453);
  if (strlit5457 == NULL) {
    strlit5457 = alloc_String("+");
    gc_root(strlit5457);
  }
// compilenode returning strlit5457
  int op_slot_right_5456 = gc_frame_newslot(strlit5457);
// compilenode returning *var_o
  int op_slot_left_5456 = gc_frame_newslot(*var_o);
  params[0] = strlit5457;
  partcv[0] = 1;
  Object opresult5459 = callmethod(*var_o, "!=", 1, partcv, params);
// compilenode returning opresult5459
  int op_slot_right_5455 = gc_frame_newslot(opresult5459);
  if (strlit5463 == NULL) {
    strlit5463 = alloc_String("/");
    gc_root(strlit5463);
  }
// compilenode returning strlit5463
  int op_slot_right_5462 = gc_frame_newslot(strlit5463);
// compilenode returning *var_o
  int op_slot_left_5462 = gc_frame_newslot(*var_o);
  params[0] = strlit5463;
  partcv[0] = 1;
  Object opresult5465 = callmethod(*var_o, "!=", 1, partcv, params);
// compilenode returning opresult5465
  int op_slot_right_5461 = gc_frame_newslot(opresult5465);
  if (strlit5468 == NULL) {
    strlit5468 = alloc_String("*");
    gc_root(strlit5468);
  }
// compilenode returning strlit5468
  int op_slot_right_5467 = gc_frame_newslot(strlit5468);
// compilenode returning *var_o
  int op_slot_left_5467 = gc_frame_newslot(*var_o);
  params[0] = strlit5468;
  partcv[0] = 1;
  Object opresult5470 = callmethod(*var_o, "!=", 1, partcv, params);
// compilenode returning opresult5470
  int op_slot_left_5461 = gc_frame_newslot(opresult5470);
  params[0] = opresult5465;
  partcv[0] = 1;
  Object opresult5471 = callmethod(opresult5470, "&&", 1, partcv, params);
// compilenode returning opresult5471
  int op_slot_left_5455 = gc_frame_newslot(opresult5471);
  params[0] = opresult5459;
  partcv[0] = 1;
  Object opresult5472 = callmethod(opresult5471, "&&", 1, partcv, params);
// compilenode returning opresult5472
  int op_slot_left_5449 = gc_frame_newslot(opresult5472);
  params[0] = opresult5453;
  partcv[0] = 1;
  Object opresult5473 = callmethod(opresult5472, "&&", 1, partcv, params);
// compilenode returning opresult5473
  Object if5448 = done;
  if (istrue(opresult5473)) {
// Begin line 1725
  setline(1725);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1724
  setline(1724);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5474 = alloc_Boolean(0);
// compilenode returning bool5474
  *var_allarith = bool5474;
  if (bool5474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5448 = done;
  } else {
  }
// compilenode returning if5448
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5478 = gc_frame_new();
// compilenode returning *var_allarith
  partcv[0] = 0;
  Object call5479 = callmethod(*var_allarith, "not",
    1, partcv, params);
  gc_frame_end(callframe5478);
// compilenode returning call5479
// compilenode returning call5479
  int op_slot_right_5477 = gc_frame_newslot(call5479);
// compilenode returning *var_o
  int op_slot_right_5482 = gc_frame_newslot(*var_o);
// compilenode returning *var_opdtype
  int op_slot_left_5482 = gc_frame_newslot(*var_opdtype);
  params[0] = *var_o;
  partcv[0] = 1;
  Object opresult5484 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compilenode returning opresult5484
  int op_slot_right_5481 = gc_frame_newslot(opresult5484);
  if (strlit5487 == NULL) {
    strlit5487 = alloc_String("");
    gc_root(strlit5487);
  }
// compilenode returning strlit5487
  int op_slot_right_5486 = gc_frame_newslot(strlit5487);
// compilenode returning *var_opdtype
  int op_slot_left_5486 = gc_frame_newslot(*var_opdtype);
  params[0] = strlit5487;
  partcv[0] = 1;
  Object opresult5489 = callmethod(*var_opdtype, "!=", 1, partcv, params);
// compilenode returning opresult5489
  int op_slot_left_5481 = gc_frame_newslot(opresult5489);
  params[0] = opresult5484;
  partcv[0] = 1;
  Object opresult5490 = callmethod(opresult5489, "&&", 1, partcv, params);
// compilenode returning opresult5490
  int op_slot_left_5477 = gc_frame_newslot(opresult5490);
  params[0] = call5479;
  partcv[0] = 1;
  Object opresult5491 = callmethod(opresult5490, "&&", 1, partcv, params);
// compilenode returning opresult5491
  Object if5476 = done;
  if (istrue(opresult5491)) {
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5492 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5492
  *var_suggestions = array5492;
  if (array5492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5493 = gc_frame_new();
  int callframe5494 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5495 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5494);
// compilenode returning call5495
// compilenode returning call5495
  partcv[0] = 0;
  Object call5496 = callmethod(call5495, "new",
    1, partcv, params);
  gc_frame_end(callframe5493);
// compilenode returning call5496
// compilenode returning call5496
  *var_suggestion = call5496;
  if (call5496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1732
  setline(1732);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5497 = gc_frame_new();
  if (strlit5498 == NULL) {
    strlit5498 = alloc_String(")");
    gc_root(strlit5498);
  }
// compilenode returning strlit5498
  gc_frame_newslot(strlit5498);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = strlit5498;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5499 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5497);
// compilenode returning call5499
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5500 = gc_frame_new();
  if (strlit5501 == NULL) {
    strlit5501 = alloc_String("(");
    gc_root(strlit5501);
  }
// compilenode returning strlit5501
  gc_frame_newslot(strlit5501);
  int callframe5502 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5503 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5502);
// compilenode returning call5503
// compilenode returning call5503
  gc_frame_newslot(call5503);
// compilenode returning *var_suggestion
  params[0] = strlit5501;
  params[1] = call5503;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5504 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5500);
// compilenode returning call5504
// Begin line 1734
  setline(1734);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5505 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5506 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5505);
// compilenode returning call5506
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5507 = gc_frame_new();
  int callframe5508 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5509 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5508);
// compilenode returning call5509
// compilenode returning call5509
  partcv[0] = 0;
  Object call5510 = callmethod(call5509, "new",
    1, partcv, params);
  gc_frame_end(callframe5507);
// compilenode returning call5510
// compilenode returning call5510
  *var_suggestion = call5510;
  if (call5510 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5512 = gc_frame_new();
  if (strlit5513 == NULL) {
    strlit5513 = alloc_String(")");
    gc_root(strlit5513);
  }
// compilenode returning strlit5513
  gc_frame_newslot(strlit5513);
  int callframe5514 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5515 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5514);
// compilenode returning call5515
// compilenode returning call5515
  gc_frame_newslot(call5515);
// compilenode returning *var_suggestion
  params[0] = strlit5513;
  params[1] = call5515;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5516 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5512);
// compilenode returning call5516
// Begin line 1737
  setline(1737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5517 = gc_frame_new();
  if (strlit5518 == NULL) {
    strlit5518 = alloc_String("(");
    gc_root(strlit5518);
  }
// compilenode returning strlit5518
  gc_frame_newslot(strlit5518);
  int callframe5519 = gc_frame_new();
  int callframe5520 = gc_frame_new();
  int callframe5521 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5522 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5521);
// compilenode returning call5522
// compilenode returning call5522
  partcv[0] = 0;
  Object call5523 = callmethod(call5522, "prev",
    1, partcv, params);
  gc_frame_end(callframe5520);
// compilenode returning call5523
// compilenode returning call5523
  partcv[0] = 0;
  Object call5524 = callmethod(call5523, "prev",
    1, partcv, params);
  gc_frame_end(callframe5519);
// compilenode returning call5524
// compilenode returning call5524
  gc_frame_newslot(call5524);
// compilenode returning *var_suggestion
  params[0] = strlit5518;
  params[1] = call5524;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5525 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe5517);
// compilenode returning call5525
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5526 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5527 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5526);
// compilenode returning call5527
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5528 = gc_frame_new();
  if (strlit5529 == NULL) {
    strlit5529 = alloc_String("An expression containing both mathematical and non-mathematical operators requires parentheses.");
    gc_root(strlit5529);
  }
// compilenode returning strlit5529
  gc_frame_newslot(strlit5529);
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5530 = gc_frame_new();
  int callframe5531 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5532 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5531);
// compilenode returning call5532
// compilenode returning call5532
  partcv[0] = 0;
  Object call5533 = callmethod(call5532, "line",
    1, partcv, params);
  gc_frame_end(callframe5530);
// compilenode returning call5533
// compilenode returning call5533
  gc_frame_newslot(call5533);
  int callframe5534 = gc_frame_new();
  int callframe5535 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5536 = callmethod(*var_lastToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe5535);
// compilenode returning call5536
// compilenode returning call5536
  partcv[0] = 0;
  Object call5537 = callmethod(call5536, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5534);
// compilenode returning call5537
// compilenode returning call5537
  gc_frame_newslot(call5537);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5529;
  params[1] = call5533;
  params[2] = call5537;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5538 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5528);
// compilenode returning call5538
    gc_frame_newslot(call5538);
    if5476 = call5538;
  } else {
  }
// compilenode returning if5476
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_o
  *var_opdtype = *var_o;
  if (*var_o == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5540 = gc_frame_new();
  Object block5541 = alloc_Block(NULL, NULL, "parser", 1743);
  gc_frame_newslot(block5541);
  block_savedest(block5541);
  Object closure5542 = createclosure(3, "_apply");
setclosureframe(closure5542, stackframe);
  addtoclosure(closure5542, var_ops);
  addtoclosure(closure5542, var_prec);
  addtoclosure(closure5542, selfslot);
  struct UserObject *uo5542 = (struct UserObject*)block5541;
  uo5542->data[0] = (Object)closure5542;
  Method *meth_meth_parser__apply5542 = addmethod2pos(block5541, "_apply", &meth_parser__apply5542, 0);
int argcv_meth_parser__apply5542[] = {0};
meth_meth_parser__apply5542->type = alloc_MethodType(1, argcv_meth_parser__apply5542);
  meth_meth_parser__apply5542->definitionModule = modulename;
  meth_meth_parser__apply5542->definitionLine = 1740;
// compilenode returning block5541
  gc_frame_newslot(block5541);
  Object block5558 = alloc_Block(NULL, NULL, "parser", 1743);
  gc_frame_newslot(block5558);
  block_savedest(block5558);
  Object closure5559 = createclosure(7, "_apply");
setclosureframe(closure5559, stackframe);
  addtoclosure(closure5559, var_ops);
  addtoclosure(closure5559, var_o2);
  addtoclosure(closure5559, var_terms);
  addtoclosure(closure5559, var_tmp2);
  addtoclosure(closure5559, var_tmp);
  addtoclosure(closure5559, var_ast);
  addtoclosure(closure5559, selfslot);
  struct UserObject *uo5559 = (struct UserObject*)block5558;
  uo5559->data[0] = (Object)closure5559;
  Method *meth_meth_parser__apply5559 = addmethod2pos(block5558, "_apply", &meth_parser__apply5559, 0);
int argcv_meth_parser__apply5559[] = {0};
meth_meth_parser__apply5559->type = alloc_MethodType(1, argcv_meth_parser__apply5559);
  meth_meth_parser__apply5559->definitionModule = modulename;
  meth_meth_parser__apply5559->definitionLine = 1743;
// compilenode returning block5558
  gc_frame_newslot(block5558);
  params[0] = block5541;
  params[1] = block5558;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5577 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5540);
// compilenode returning call5577
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5578 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_ops
  params[0] = *var_o;
  partcv[0] = 1;
  Object call5579 = callmethod(*var_ops, "push",
    1, partcv, params);
  gc_frame_end(callframe5578);
// compilenode returning call5579
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5581 = gc_frame_new();
  if (strlit5582 == NULL) {
    strlit5582 = alloc_String("lparen");
    gc_root(strlit5582);
  }
// compilenode returning strlit5582
  gc_frame_newslot(strlit5582);
  params[0] = strlit5582;
  partcv[0] = 1;
  Object call5583 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5581);
// compilenode returning call5583
  Object if5580 = done;
  if (istrue(call5583)) {
// Begin line 1763
  setline(1763);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5584 = gc_frame_new();
  partcv[0] = 0;
  Object call5585 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5584);
// compilenode returning call5585
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1764
  setline(1764);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5587 = gc_frame_new();
  int callframe5588 = gc_frame_new();
  Object block5589 = alloc_Block(NULL, NULL, "parser", 1764);
  gc_frame_newslot(block5589);
  block_savedest(block5589);
  Object closure5590 = createclosure(1, "_apply");
setclosureframe(closure5590, stackframe);
  addtoclosure(closure5590, selfslot);
  struct UserObject *uo5590 = (struct UserObject*)block5589;
  uo5590->data[0] = (Object)closure5590;
  Method *meth_meth_parser__apply5590 = addmethod2pos(block5589, "_apply", &meth_parser__apply5590, 0);
int argcv_meth_parser__apply5590[] = {0};
meth_meth_parser__apply5590->type = alloc_MethodType(1, argcv_meth_parser__apply5590);
  meth_meth_parser__apply5590->definitionModule = modulename;
  meth_meth_parser__apply5590->definitionLine = 1764;
// compilenode returning block5589
  gc_frame_newslot(block5589);
  params[0] = block5589;
  partcv[0] = 1;
  Object call5594 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5588);
// compilenode returning call5594
  partcv[0] = 0;
  Object call5595 = callmethod(call5594, "not",
    1, partcv, params);
  gc_frame_end(callframe5587);
// compilenode returning call5595
// compilenode returning call5595
  Object if5586 = done;
  if (istrue(call5595)) {
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1765
  setline(1765);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5596 = gc_frame_new();
  int callframe5597 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5598 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5597);
// compilenode returning call5598
// compilenode returning call5598
  partcv[0] = 0;
  Object call5599 = callmethod(call5598, "new",
    1, partcv, params);
  gc_frame_end(callframe5596);
// compilenode returning call5599
// compilenode returning call5599
  *var_suggestion = call5599;
  if (call5599 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1766
  setline(1766);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5600 = gc_frame_new();
  if (strlit5601 == NULL) {
    strlit5601 = alloc_String("rparen");
    gc_root(strlit5601);
  }
// compilenode returning strlit5601
  gc_frame_newslot(strlit5601);
  params[0] = strlit5601;
  partcv[0] = 1;
  Object call5602 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5600);
// compilenode returning call5602
  *var_nextTok = call5602;
  if (call5602 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_5604 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_5604 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5606 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult5606
  Object if5603 = done;
  if (istrue(opresult5606)) {
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5607 = gc_frame_new();
  if (strlit5608 == NULL) {
    strlit5608 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5608);
  }
// compilenode returning strlit5608
  gc_frame_newslot(strlit5608);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5608;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5609 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5607);
// compilenode returning call5609
    gc_frame_newslot(call5609);
    if5603 = call5609;
  } else {
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5610 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe5611 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5612 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5611);
// compilenode returning call5612
// compilenode returning call5612
  gc_frame_newslot(call5612);
  Object bool5613 = alloc_Boolean(1);
// compilenode returning bool5613
  gc_frame_newslot(bool5613);
  Object bool5614 = alloc_Boolean(0);
// compilenode returning bool5614
  gc_frame_newslot(bool5614);
  if (strlit5615 == NULL) {
    strlit5615 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5615);
  }
// compilenode returning strlit5615
  gc_frame_newslot(strlit5615);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call5612;
  params[2] = bool5613;
  params[3] = bool5614;
  params[4] = strlit5615;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5616 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5610);
// compilenode returning call5616
    gc_frame_newslot(call5616);
    if5603 = call5616;
  }
// compilenode returning if5603
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5617 = gc_frame_new();
  if (strlit5618 == NULL) {
    strlit5618 = alloc_String("Parentheses must contain a valid expression.");
    gc_root(strlit5618);
  }
// compilenode returning strlit5618
  gc_frame_newslot(strlit5618);
// Begin line 1773
  setline(1773);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5619 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5620 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5619);
// compilenode returning call5620
// compilenode returning call5620
  gc_frame_newslot(call5620);
  int callframe5621 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5622 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5621);
// compilenode returning call5622
// compilenode returning call5622
  gc_frame_newslot(call5622);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1772
  setline(1772);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5618;
  params[1] = call5620;
  params[2] = call5622;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5623 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5617);
// compilenode returning call5623
    gc_frame_newslot(call5623);
    if5586 = call5623;
  } else {
  }
// compilenode returning if5586
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5626 == NULL) {
    strlit5626 = alloc_String("rparen");
    gc_root(strlit5626);
  }
// compilenode returning strlit5626
  int op_slot_right_5625 = gc_frame_newslot(strlit5626);
  int callframe5628 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5629 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe5628);
// compilenode returning call5629
// compilenode returning call5629
  int op_slot_left_5625 = gc_frame_newslot(call5629);
  params[0] = strlit5626;
  partcv[0] = 1;
  Object opresult5630 = callmethod(call5629, "!=", 1, partcv, params);
// compilenode returning opresult5630
  Object if5624 = done;
  if (istrue(opresult5630)) {
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5631 = gc_frame_new();
  partcv[0] = 0;
  Object call5632 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5631);
// compilenode returning call5632
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5633 = gc_frame_new();
  int callframe5634 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5635 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5634);
// compilenode returning call5635
// compilenode returning call5635
  partcv[0] = 0;
  Object call5636 = callmethod(call5635, "new",
    1, partcv, params);
  gc_frame_end(callframe5633);
// compilenode returning call5636
// compilenode returning call5636
  *var_suggestion = call5636;
  if (call5636 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5637 = gc_frame_new();
  if (strlit5638 == NULL) {
    strlit5638 = alloc_String(")");
    gc_root(strlit5638);
  }
// compilenode returning strlit5638
  gc_frame_newslot(strlit5638);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5638;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5639 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5637);
// compilenode returning call5639
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5640 = gc_frame_new();
  if (strlit5641 == NULL) {
    strlit5641 = alloc_String("An expression beginning with a '(' must end with a ')'.");
    gc_root(strlit5641);
  }
// compilenode returning strlit5641
  gc_frame_newslot(strlit5641);
// Begin line 1780
  setline(1780);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5642 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5643 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5642);
// compilenode returning call5643
// compilenode returning call5643
  gc_frame_newslot(call5643);
  int callframe5645 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5646 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5645);
// compilenode returning call5646
// compilenode returning call5646
  int op_slot_right_5644 = gc_frame_newslot(call5646);
  int callframe5648 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5649 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5648);
// compilenode returning call5649
// compilenode returning call5649
  int op_slot_left_5644 = gc_frame_newslot(call5649);
  params[0] = call5646;
  partcv[0] = 1;
  Object sum5650 = callmethod(call5649, "+", 1, partcv, params);
// compilenode returning sum5650
  gc_frame_newslot(sum5650);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1779
  setline(1779);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5641;
  params[1] = call5643;
  params[2] = sum5650;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5651 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe5640);
// compilenode returning call5651
    gc_frame_newslot(call5651);
    if5624 = call5651;
  } else {
  }
// compilenode returning if5624
// Begin line 1782
  setline(1782);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5652 = gc_frame_new();
  partcv[0] = 0;
  Object call5653 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5652);
// compilenode returning call5653
    gc_frame_newslot(call5653);
    if5580 = call5653;
  } else {
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5655 = gc_frame_new();
  int callframe5656 = gc_frame_new();
  partcv[0] = 0;
  Object call5657 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5656);
// compilenode returning call5657
  partcv[0] = 0;
  Object call5658 = callmethod(call5657, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5655);
// compilenode returning call5658
  Object if5654 = done;
  if (istrue(call5658)) {
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5659 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5659
  *var_suggestions = array5659;
  if (array5659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5660 = gc_frame_new();
  int callframe5661 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5662 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5661);
// compilenode returning call5662
// compilenode returning call5662
  partcv[0] = 0;
  Object call5663 = callmethod(call5662, "new",
    1, partcv, params);
  gc_frame_end(callframe5660);
// compilenode returning call5663
// compilenode returning call5663
  *var_suggestion = call5663;
  if (call5663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1787
  setline(1787);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5664 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool5665 = alloc_Boolean(1);
// compilenode returning bool5665
  gc_frame_newslot(bool5665);
  Object bool5666 = alloc_Boolean(0);
// compilenode returning bool5666
  gc_frame_newslot(bool5666);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool5665;
  params[2] = bool5666;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5667 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5664);
// compilenode returning call5667
// Begin line 1788
  setline(1788);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5668 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5669 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5668);
// compilenode returning call5669
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1789
  setline(1789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5670 = gc_frame_new();
  int callframe5671 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5672 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5671);
// compilenode returning call5672
// compilenode returning call5672
  partcv[0] = 0;
  Object call5673 = callmethod(call5672, "new",
    1, partcv, params);
  gc_frame_end(callframe5670);
// compilenode returning call5673
// compilenode returning call5673
  *var_suggestion = call5673;
  if (call5673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5675 = gc_frame_new();
  if (strlit5676 == NULL) {
    strlit5676 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5676);
  }
// compilenode returning strlit5676
  gc_frame_newslot(strlit5676);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5676;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5677 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5675);
// compilenode returning call5677
// Begin line 1791
  setline(1791);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5678 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5679 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5678);
// compilenode returning call5679
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1792
  setline(1792);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5680 = gc_frame_new();
  int callframe5681 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5682 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5681);
// compilenode returning call5682
// compilenode returning call5682
  partcv[0] = 0;
  Object call5683 = callmethod(call5682, "new",
    1, partcv, params);
  gc_frame_end(callframe5680);
// compilenode returning call5683
// compilenode returning call5683
  *var_suggestion = call5683;
  if (call5683 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5685 = gc_frame_new();
  int callframe5687 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call5688 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe5687);
// compilenode returning call5688
// compilenode returning call5688
  int callframe5689 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5690 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5689);
// compilenode returning call5690
// compilenode returning call5690
  params[0] = call5690;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres5691 = callmethod(call5688, "[]", 1, partcv, params);
// compilenode returning idxres5691
  int op_slot_right_5686 = gc_frame_newslot(idxres5691);
  if (strlit5693 == NULL) {
    strlit5693 = alloc_String(" ");
    gc_root(strlit5693);
  }
// compilenode returning strlit5693
  int op_slot_left_5686 = gc_frame_newslot(strlit5693);
  params[0] = idxres5691;
  partcv[0] = 1;
  Object opresult5694 = callmethod(strlit5693, "++", 1, partcv, params);
// compilenode returning opresult5694
  gc_frame_newslot(opresult5694);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = opresult5694;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5695 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5685);
// compilenode returning call5695
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5696 = gc_frame_new();
  int callframe5697 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5698 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5697);
// compilenode returning call5698
// compilenode returning call5698
  gc_frame_newslot(call5698);
// compilenode returning *var_suggestion
  params[0] = call5698;
  partcv[0] = 1;
  Object call5699 = callmethod(*var_suggestion, "deleteLine",
    1, partcv, params);
  gc_frame_end(callframe5696);
// compilenode returning call5699
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5700 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5701 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5700);
// compilenode returning call5701
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5702 = gc_frame_new();
  if (strlit5704 == NULL) {
    strlit5704 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5704);
  }
// compilenode returning strlit5704
  int op_slot_right_5703 = gc_frame_newslot(strlit5704);
  int callframe5707 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5708 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5707);
// compilenode returning call5708
// compilenode returning call5708
  int op_slot_right_5706 = gc_frame_newslot(call5708);
  if (strlit5710 == NULL) {
    strlit5710 = alloc_String("A valid expression must follow '");
    gc_root(strlit5710);
  }
// compilenode returning strlit5710
  int op_slot_left_5706 = gc_frame_newslot(strlit5710);
  params[0] = call5708;
  partcv[0] = 1;
  Object opresult5711 = callmethod(strlit5710, "++", 1, partcv, params);
// compilenode returning opresult5711
  int op_slot_left_5703 = gc_frame_newslot(opresult5711);
  params[0] = strlit5704;
  partcv[0] = 1;
  Object opresult5712 = callmethod(opresult5711, "++", 1, partcv, params);
// compilenode returning opresult5712
  gc_frame_newslot(opresult5712);
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5713 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5714 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5713);
// compilenode returning call5714
// compilenode returning call5714
  gc_frame_newslot(call5714);
  int callframe5716 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5717 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5716);
// compilenode returning call5717
// compilenode returning call5717
  int op_slot_right_5715 = gc_frame_newslot(call5717);
  int callframe5719 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5720 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5719);
// compilenode returning call5720
// compilenode returning call5720
  int op_slot_left_5715 = gc_frame_newslot(call5720);
  params[0] = call5717;
  partcv[0] = 1;
  Object sum5721 = callmethod(call5720, "+", 1, partcv, params);
// compilenode returning sum5721
  gc_frame_newslot(sum5721);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult5712;
  params[1] = call5714;
  params[2] = sum5721;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5722 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5702);
// compilenode returning call5722
    gc_frame_newslot(call5722);
    if5654 = call5722;
  } else {
  }
// compilenode returning if5654
// Begin line 1815
  setline(1815);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1799
  setline(1799);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5724 = gc_frame_new();
  int callframe5725 = gc_frame_new();
  Object block5726 = alloc_Block(NULL, NULL, "parser", 1799);
  gc_frame_newslot(block5726);
  block_savedest(block5726);
  Object closure5727 = createclosure(1, "_apply");
setclosureframe(closure5727, stackframe);
  addtoclosure(closure5727, selfslot);
  struct UserObject *uo5727 = (struct UserObject*)block5726;
  uo5727->data[0] = (Object)closure5727;
  Method *meth_meth_parser__apply5727 = addmethod2pos(block5726, "_apply", &meth_parser__apply5727, 0);
int argcv_meth_parser__apply5727[] = {0};
meth_meth_parser__apply5727->type = alloc_MethodType(1, argcv_meth_parser__apply5727);
  meth_meth_parser__apply5727->definitionModule = modulename;
  meth_meth_parser__apply5727->definitionLine = 1799;
// compilenode returning block5726
  gc_frame_newslot(block5726);
  params[0] = block5726;
  partcv[0] = 1;
  Object call5731 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5725);
// compilenode returning call5731
  partcv[0] = 0;
  Object call5732 = callmethod(call5731, "not",
    1, partcv, params);
  gc_frame_end(callframe5724);
// compilenode returning call5732
// compilenode returning call5732
  Object if5723 = done;
  if (istrue(call5732)) {
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1800
  setline(1800);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5733 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5733
  *var_suggestions = array5733;
  if (array5733 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5734 = gc_frame_new();
  int callframe5735 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5736 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5735);
// compilenode returning call5736
// compilenode returning call5736
  partcv[0] = 0;
  Object call5737 = callmethod(call5736, "new",
    1, partcv, params);
  gc_frame_end(callframe5734);
// compilenode returning call5737
// compilenode returning call5737
  *var_suggestion = call5737;
  if (call5737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1802
  setline(1802);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5738 = gc_frame_new();
  if (strlit5739 == NULL) {
    strlit5739 = alloc_String("comma");
    gc_root(strlit5739);
  }
// compilenode returning strlit5739
  gc_frame_newslot(strlit5739);
  if (strlit5740 == NULL) {
    strlit5740 = alloc_String("rparen");
    gc_root(strlit5740);
  }
// compilenode returning strlit5740
  gc_frame_newslot(strlit5740);
  if (strlit5741 == NULL) {
    strlit5741 = alloc_String("rsquare");
    gc_root(strlit5741);
  }
// compilenode returning strlit5741
  gc_frame_newslot(strlit5741);
  if (strlit5742 == NULL) {
    strlit5742 = alloc_String("rbrace");
    gc_root(strlit5742);
  }
// compilenode returning strlit5742
  gc_frame_newslot(strlit5742);
  params[0] = strlit5739;
  params[1] = strlit5740;
  params[2] = strlit5741;
  params[3] = strlit5742;
  partcv[0] = 4;
  Object call5743 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5738);
// compilenode returning call5743
  *var_nextTok = call5743;
  if (call5743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_5745 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_5745 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult5747 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult5747
  Object if5744 = done;
  if (istrue(opresult5747)) {
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5748 = gc_frame_new();
  if (strlit5749 == NULL) {
    strlit5749 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5749);
  }
// compilenode returning strlit5749
  gc_frame_newslot(strlit5749);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5749;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5750 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5748);
// compilenode returning call5750
    gc_frame_newslot(call5750);
    if5744 = call5750;
  } else {
// Begin line 1806
  setline(1806);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5751 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe5752 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5753 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5752);
// compilenode returning call5753
// compilenode returning call5753
  gc_frame_newslot(call5753);
  Object bool5754 = alloc_Boolean(1);
// compilenode returning bool5754
  gc_frame_newslot(bool5754);
  Object bool5755 = alloc_Boolean(0);
// compilenode returning bool5755
  gc_frame_newslot(bool5755);
  if (strlit5756 == NULL) {
    strlit5756 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit5756);
  }
// compilenode returning strlit5756
  gc_frame_newslot(strlit5756);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call5753;
  params[2] = bool5754;
  params[3] = bool5755;
  params[4] = strlit5756;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call5757 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe5751);
// compilenode returning call5757
    gc_frame_newslot(call5757);
    if5744 = call5757;
  }
// compilenode returning if5744
// Begin line 1808
  setline(1808);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5758 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5759 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5758);
// compilenode returning call5759
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5760 = gc_frame_new();
  int callframe5761 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5762 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5761);
// compilenode returning call5762
// compilenode returning call5762
  partcv[0] = 0;
  Object call5763 = callmethod(call5762, "new",
    1, partcv, params);
  gc_frame_end(callframe5760);
// compilenode returning call5763
// compilenode returning call5763
  *var_suggestion = call5763;
  if (call5763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5765 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe5766 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call5767 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe5766);
// compilenode returning call5767
// compilenode returning call5767
  gc_frame_newslot(call5767);
  Object bool5768 = alloc_Boolean(1);
// compilenode returning bool5768
  gc_frame_newslot(bool5768);
  Object bool5769 = alloc_Boolean(0);
// compilenode returning bool5769
  gc_frame_newslot(bool5769);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call5767;
  params[2] = bool5768;
  params[3] = bool5769;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call5770 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe5765);
// compilenode returning call5770
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5771 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5772 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5771);
// compilenode returning call5772
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5773 = gc_frame_new();
  if (strlit5775 == NULL) {
    strlit5775 = alloc_String("'. This is often caused by a new line in the middle of an expression.");
    gc_root(strlit5775);
  }
// compilenode returning strlit5775
  int op_slot_right_5774 = gc_frame_newslot(strlit5775);
  int callframe5778 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5779 = callmethod(*var_lastToken, "value",
    1, partcv, params);
  gc_frame_end(callframe5778);
// compilenode returning call5779
// compilenode returning call5779
  int op_slot_right_5777 = gc_frame_newslot(call5779);
  if (strlit5781 == NULL) {
    strlit5781 = alloc_String("A valid expression must follow '");
    gc_root(strlit5781);
  }
// compilenode returning strlit5781
  int op_slot_left_5777 = gc_frame_newslot(strlit5781);
  params[0] = call5779;
  partcv[0] = 1;
  Object opresult5782 = callmethod(strlit5781, "++", 1, partcv, params);
// compilenode returning opresult5782
  int op_slot_left_5774 = gc_frame_newslot(opresult5782);
  params[0] = strlit5775;
  partcv[0] = 1;
  Object opresult5783 = callmethod(opresult5782, "++", 1, partcv, params);
// compilenode returning opresult5783
  gc_frame_newslot(opresult5783);
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5784 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5785 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe5784);
// compilenode returning call5785
// compilenode returning call5785
  gc_frame_newslot(call5785);
  int callframe5787 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5788 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe5787);
// compilenode returning call5788
// compilenode returning call5788
  int op_slot_right_5786 = gc_frame_newslot(call5788);
  int callframe5790 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call5791 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5790);
// compilenode returning call5791
// compilenode returning call5791
  int op_slot_left_5786 = gc_frame_newslot(call5791);
  params[0] = call5788;
  partcv[0] = 1;
  Object sum5792 = callmethod(call5791, "+", 1, partcv, params);
// compilenode returning sum5792
  gc_frame_newslot(sum5792);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1812
  setline(1812);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult5783;
  params[1] = call5785;
  params[2] = sum5792;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5793 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5773);
// compilenode returning call5793
    gc_frame_newslot(call5793);
    if5723 = call5793;
  } else {
  }
// compilenode returning if5723
    gc_frame_newslot(if5723);
    if5580 = if5723;
  }
// compilenode returning if5580
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5794 = gc_frame_new();
  partcv[0] = 0;
  Object call5795 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5794);
// compilenode returning call5795
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5796 = gc_frame_new();
  partcv[0] = 0;
  Object call5797 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5796);
// compilenode returning call5797
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5798 = gc_frame_new();
  partcv[0] = 0;
  Object call5799 = callmethodflags(self, "postfixsquare", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5798);
// compilenode returning call5799
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1824
  setline(1824);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5800 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5801 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5800);
// compilenode returning call5801
// compilenode returning call5801
  *var_tmp = call5801;
  if (call5801 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5803 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_terms
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5804 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5803);
// compilenode returning call5804
  gc_frame_end(frame);
  return call5804;
}
Object meth_parser__apply5809(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object num5811 = alloc_Float64(0);
// compilenode returning num5811
  int op_slot_right_5810 = gc_frame_newslot(num5811);
  int callframe5813 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5814 = callmethod(*var_ops, "size",
    1, partcv, params);
  gc_frame_end(callframe5813);
// compilenode returning call5814
// compilenode returning call5814
  int op_slot_left_5810 = gc_frame_newslot(call5814);
  params[0] = num5811;
  partcv[0] = 1;
  Object opresult5815 = callmethod(call5814, ">", 1, partcv, params);
// compilenode returning opresult5815
  gc_frame_end(frame);
  return opresult5815;
}
Object meth_parser__apply5818(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[1];
  Object *var_ops = getfromclosure(closure, 0);
  Object *var_o = getfromclosure(closure, 1);
  Object *var_terms = getfromclosure(closure, 2);
  Object *var_tmp2 = getfromclosure(closure, 3);
  Object *var_tmp = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5819 = gc_frame_new();
// compilenode returning *var_ops
  partcv[0] = 0;
  Object call5820 = callmethod(*var_ops, "pop",
    1, partcv, params);
  gc_frame_end(callframe5819);
// compilenode returning call5820
// compilenode returning call5820
  *var_o = call5820;
  if (call5820 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5822 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5823 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5822);
// compilenode returning call5823
// compilenode returning call5823
  *var_tmp2 = call5823;
  if (call5823 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5825 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5826 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5825);
// compilenode returning call5826
// compilenode returning call5826
  *var_tmp = call5826;
  if (call5826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5828 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_tmp2
  gc_frame_newslot(*var_tmp2);
  int callframe5829 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5830 = callmethod(*var_ast, "opNode",
    1, partcv, params);
  gc_frame_end(callframe5829);
// compilenode returning call5830
// compilenode returning call5830
  params[0] = *var_o;
  params[1] = *var_tmp;
  params[2] = *var_tmp2;
  partcv[0] = 3;
  Object call5831 = callmethod(call5830, "new",
    1, partcv, params);
  gc_frame_end(callframe5828);
// compilenode returning call5831
  *var_tmp = call5831;
  if (call5831 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1833
  setline(1833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5833 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_terms
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5834 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5833);
// compilenode returning call5834
  gc_frame_end(frame);
  return call5834;
}
Object meth_parser_expressionrest5401(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expressionrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for expressionrest (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for expressionrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_terms = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "terms");
  Object *var_ops = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ops");
  Object *var_o = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "o");
  Object *var_o2 = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o2");
  Object *var_tmp2 = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "tmp2");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_prec = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "prec");
  Object *var_allarith = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "allarith");
  Object *var_opcount = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "opcount");
  Object *var_opdtype = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "opdtype");
// Begin line 1841
  setline(1841);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5403 = gc_frame_new();
  if (strlit5404 == NULL) {
    strlit5404 = alloc_String("op");
    gc_root(strlit5404);
  }
// compilenode returning strlit5404
  gc_frame_newslot(strlit5404);
  params[0] = strlit5404;
  partcv[0] = 1;
  Object call5405 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5403);
// compilenode returning call5405
  Object if5402 = done;
  if (istrue(call5405)) {
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1706
  setline(1706);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5406 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5406
  *var_terms = array5406;
  if (array5406 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1707
  setline(1707);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5407 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5407
  *var_ops = array5407;
  if (array5407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1709
  setline(1709);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_o = undefined;
// compilenode returning done
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_o2 = undefined;
// compilenode returning done
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_tmp2 = undefined;
// compilenode returning done
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1711
  setline(1711);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5408 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5409 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5408);
// compilenode returning call5409
// compilenode returning call5409
  *var_tmp = call5409;
  if (call5409 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1712
  setline(1712);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5410 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_terms
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5411 = callmethod(*var_terms, "push",
    1, partcv, params);
  gc_frame_end(callframe5410);
// compilenode returning call5411
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_prec = undefined;
// compilenode returning done
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1714
  setline(1714);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5412 = alloc_Boolean(1);
// compilenode returning bool5412
  *var_allarith = bool5412;
  if (bool5412 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5413 = alloc_Float64(0);
// compilenode returning num5413
  *var_opcount = num5413;
  if (num5413 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1716
  setline(1716);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5414 == NULL) {
    strlit5414 = alloc_String("");
    gc_root(strlit5414);
  }
// compilenode returning strlit5414
  *var_opdtype = strlit5414;
  if (strlit5414 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5415 = gc_frame_new();
  Object block5416 = alloc_Block(NULL, NULL, "parser", 1717);
  gc_frame_newslot(block5416);
  block_savedest(block5416);
  Object closure5417 = createclosure(3, "_apply");
setclosureframe(closure5417, stackframe);
  addtoclosure(closure5417, var_sym);
  addtoclosure(closure5417, var_statementToken);
  addtoclosure(closure5417, selfslot);
  struct UserObject *uo5417 = (struct UserObject*)block5416;
  uo5417->data[0] = (Object)closure5417;
  Method *meth_meth_parser__apply5417 = addmethod2pos(block5416, "_apply", &meth_parser__apply5417, 0);
int argcv_meth_parser__apply5417[] = {0};
meth_meth_parser__apply5417->type = alloc_MethodType(1, argcv_meth_parser__apply5417);
  meth_meth_parser__apply5417->definitionModule = modulename;
  meth_meth_parser__apply5417->definitionLine = 1711;
// compilenode returning block5416
  gc_frame_newslot(block5416);
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block5433 = alloc_Block(NULL, NULL, "parser", 1718);
  gc_frame_newslot(block5433);
  block_savedest(block5433);
  Object closure5434 = createclosure(17, "_apply");
setclosureframe(closure5434, stackframe);
  addtoclosure(closure5434, var_opcount);
  addtoclosure(closure5434, var_sym);
  addtoclosure(closure5434, var_o);
  addtoclosure(closure5434, var_prec);
  addtoclosure(closure5434, var_allarith);
  addtoclosure(closure5434, var_opdtype);
  addtoclosure(closure5434, var_errormessages);
  addtoclosure(closure5434, var_lastToken);
  addtoclosure(closure5434, var_ops);
  addtoclosure(closure5434, var_o2);
  addtoclosure(closure5434, var_terms);
  addtoclosure(closure5434, var_tmp2);
  addtoclosure(closure5434, var_tmp);
  addtoclosure(closure5434, var_ast);
  addtoclosure(closure5434, var_util);
  addtoclosure(closure5434, var_values);
  addtoclosure(closure5434, selfslot);
  struct UserObject *uo5434 = (struct UserObject*)block5433;
  uo5434->data[0] = (Object)closure5434;
  Method *meth_meth_parser__apply5434 = addmethod2pos(block5433, "_apply", &meth_parser__apply5434, 0);
int argcv_meth_parser__apply5434[] = {0};
meth_meth_parser__apply5434->type = alloc_MethodType(1, argcv_meth_parser__apply5434);
  meth_meth_parser__apply5434->definitionModule = modulename;
  meth_meth_parser__apply5434->definitionLine = 1718;
// compilenode returning block5433
  gc_frame_newslot(block5433);
  params[0] = block5416;
  params[1] = block5433;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5806 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5415);
// compilenode returning call5806
// Begin line 1827
  setline(1827);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5807 = gc_frame_new();
  Object block5808 = alloc_Block(NULL, NULL, "parser", 1827);
  gc_frame_newslot(block5808);
  block_savedest(block5808);
  Object closure5809 = createclosure(2, "_apply");
setclosureframe(closure5809, stackframe);
  addtoclosure(closure5809, var_ops);
  addtoclosure(closure5809, selfslot);
  struct UserObject *uo5809 = (struct UserObject*)block5808;
  uo5809->data[0] = (Object)closure5809;
  Method *meth_meth_parser__apply5809 = addmethod2pos(block5808, "_apply", &meth_parser__apply5809, 0);
int argcv_meth_parser__apply5809[] = {0};
meth_meth_parser__apply5809->type = alloc_MethodType(1, argcv_meth_parser__apply5809);
  meth_meth_parser__apply5809->definitionModule = modulename;
  meth_meth_parser__apply5809->definitionLine = 1824;
// compilenode returning block5808
  gc_frame_newslot(block5808);
  Object block5817 = alloc_Block(NULL, NULL, "parser", 1827);
  gc_frame_newslot(block5817);
  block_savedest(block5817);
  Object closure5818 = createclosure(7, "_apply");
setclosureframe(closure5818, stackframe);
  addtoclosure(closure5818, var_ops);
  addtoclosure(closure5818, var_o);
  addtoclosure(closure5818, var_terms);
  addtoclosure(closure5818, var_tmp2);
  addtoclosure(closure5818, var_tmp);
  addtoclosure(closure5818, var_ast);
  addtoclosure(closure5818, selfslot);
  struct UserObject *uo5818 = (struct UserObject*)block5817;
  uo5818->data[0] = (Object)closure5818;
  Method *meth_meth_parser__apply5818 = addmethod2pos(block5817, "_apply", &meth_parser__apply5818, 0);
int argcv_meth_parser__apply5818[] = {0};
meth_meth_parser__apply5818->type = alloc_MethodType(1, argcv_meth_parser__apply5818);
  meth_meth_parser__apply5818->definitionModule = modulename;
  meth_meth_parser__apply5818->definitionLine = 1827;
// compilenode returning block5817
  gc_frame_newslot(block5817);
  params[0] = block5808;
  params[1] = block5817;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5836 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5807);
// compilenode returning call5836
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5837 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5838 = callmethod(*var_terms, "pop",
    1, partcv, params);
  gc_frame_end(callframe5837);
// compilenode returning call5838
// compilenode returning call5838
  *var_tmp = call5838;
  if (call5838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1836
  setline(1836);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5840 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_values
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call5841 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5840);
// compilenode returning call5841
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1837
  setline(1837);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5844 = alloc_Float64(0);
// compilenode returning num5844
  int op_slot_right_5843 = gc_frame_newslot(num5844);
  int callframe5846 = gc_frame_new();
// compilenode returning *var_terms
  partcv[0] = 0;
  Object call5847 = callmethod(*var_terms, "size",
    1, partcv, params);
  gc_frame_end(callframe5846);
// compilenode returning call5847
// compilenode returning call5847
  int op_slot_left_5843 = gc_frame_newslot(call5847);
  params[0] = num5844;
  partcv[0] = 1;
  Object opresult5848 = callmethod(call5847, ">", 1, partcv, params);
// compilenode returning opresult5848
  Object if5842 = done;
  if (istrue(opresult5848)) {
// Begin line 1838
  setline(1838);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5849 = gc_frame_new();
  if (strlit5850 == NULL) {
    strlit5850 = alloc_String("Values left on term stack.");
    gc_root(strlit5850);
  }
// compilenode returning strlit5850
  gc_frame_newslot(strlit5850);
  int callframe5851 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5852 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5851);
// compilenode returning call5852
// compilenode returning call5852
  gc_frame_newslot(call5852);
  int callframe5853 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5854 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5853);
// compilenode returning call5854
// compilenode returning call5854
  gc_frame_newslot(call5854);
// compilenode returning *var_errormessages
  params[0] = strlit5850;
  params[1] = call5852;
  params[2] = call5854;
  partcv[0] = 1;
  partcv[1] = 2;
  Object call5855 = callmethod(*var_errormessages, "syntaxError()atPosition",
    2, partcv, params);
  gc_frame_end(callframe5849);
// compilenode returning call5855
    gc_frame_newslot(call5855);
    if5842 = call5855;
  } else {
  }
// compilenode returning if5842
    gc_frame_newslot(if5842);
    if5402 = if5842;
  } else {
  }
// compilenode returning if5402
  gc_frame_end(frame);
  return if5402;
}
Object meth_parser_dotrest5856(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotrest (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dotrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_lookuptarget = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "lookuptarget");
  Object *var_dro = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "dro");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
// Begin line 1874
  setline(1874);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5858 = gc_frame_new();
  if (strlit5859 == NULL) {
    strlit5859 = alloc_String("dot");
    gc_root(strlit5859);
  }
// compilenode returning strlit5859
  gc_frame_newslot(strlit5859);
  params[0] = strlit5859;
  partcv[0] = 1;
  Object call5860 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5858);
// compilenode returning call5860
  Object if5857 = done;
  if (istrue(call5860)) {
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5861 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5862 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5861);
// compilenode returning call5862
// compilenode returning call5862
  *var_lookuptarget = call5862;
  if (call5862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5863 = gc_frame_new();
  partcv[0] = 0;
  Object call5864 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5863);
// compilenode returning call5864
// Begin line 1873
  setline(1873);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1850
  setline(1850);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5866 = gc_frame_new();
  if (strlit5867 == NULL) {
    strlit5867 = alloc_String("identifier");
    gc_root(strlit5867);
  }
// compilenode returning strlit5867
  gc_frame_newslot(strlit5867);
  params[0] = strlit5867;
  partcv[0] = 1;
  Object call5868 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5866);
// compilenode returning call5868
  Object if5865 = done;
  if (istrue(call5868)) {
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5869 = gc_frame_new();
  int callframe5870 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5871 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe5870);
// compilenode returning call5871
// compilenode returning call5871
  gc_frame_newslot(call5871);
// compilenode returning *var_lookuptarget
  gc_frame_newslot(*var_lookuptarget);
  int callframe5872 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5873 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe5872);
// compilenode returning call5873
// compilenode returning call5873
  params[0] = call5871;
  params[1] = *var_lookuptarget;
  partcv[0] = 2;
  Object call5874 = callmethod(call5873, "new",
    1, partcv, params);
  gc_frame_end(callframe5869);
// compilenode returning call5874
  *var_dro = call5874;
  if (call5874 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5875 = gc_frame_new();
// compilenode returning *var_dro
  gc_frame_newslot(*var_dro);
// compilenode returning *var_values
  params[0] = *var_dro;
  partcv[0] = 1;
  Object call5876 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5875);
// compilenode returning call5876
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5877 = gc_frame_new();
  partcv[0] = 0;
  Object call5878 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5877);
// compilenode returning call5878
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5880 = gc_frame_new();
  if (strlit5881 == NULL) {
    strlit5881 = alloc_String("dot");
    gc_root(strlit5881);
  }
// compilenode returning strlit5881
  gc_frame_newslot(strlit5881);
  params[0] = strlit5881;
  partcv[0] = 1;
  Object call5882 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5880);
// compilenode returning call5882
  Object if5879 = done;
  if (istrue(call5882)) {
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5883 = gc_frame_new();
  partcv[0] = 0;
  Object call5884 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5883);
// compilenode returning call5884
    gc_frame_newslot(call5884);
    if5879 = call5884;
  } else {
// Begin line 1862
  setline(1862);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5887 = gc_frame_new();
  if (strlit5888 == NULL) {
    strlit5888 = alloc_String("lgeneric");
    gc_root(strlit5888);
  }
// compilenode returning strlit5888
  gc_frame_newslot(strlit5888);
  params[0] = strlit5888;
  partcv[0] = 1;
  Object call5889 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5887);
// compilenode returning call5889
  int op_slot_right_5886 = gc_frame_newslot(call5889);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5892 = gc_frame_new();
  if (strlit5893 == NULL) {
    strlit5893 = alloc_String("lsquare");
    gc_root(strlit5893);
  }
// compilenode returning strlit5893
  gc_frame_newslot(strlit5893);
  params[0] = strlit5893;
  partcv[0] = 1;
  Object call5894 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5892);
// compilenode returning call5894
  int op_slot_right_5891 = gc_frame_newslot(call5894);
  int callframe5897 = gc_frame_new();
  if (strlit5898 == NULL) {
    strlit5898 = alloc_String("string");
    gc_root(strlit5898);
  }
// compilenode returning strlit5898
  gc_frame_newslot(strlit5898);
  params[0] = strlit5898;
  partcv[0] = 1;
  Object call5899 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5897);
// compilenode returning call5899
  int op_slot_right_5896 = gc_frame_newslot(call5899);
  int callframe5902 = gc_frame_new();
  if (strlit5903 == NULL) {
    strlit5903 = alloc_String("num");
    gc_root(strlit5903);
  }
// compilenode returning strlit5903
  gc_frame_newslot(strlit5903);
  params[0] = strlit5903;
  partcv[0] = 1;
  Object call5904 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5902);
// compilenode returning call5904
  int op_slot_right_5901 = gc_frame_newslot(call5904);
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5907 = gc_frame_new();
  if (strlit5908 == NULL) {
    strlit5908 = alloc_String("lbrace");
    gc_root(strlit5908);
  }
// compilenode returning strlit5908
  gc_frame_newslot(strlit5908);
  params[0] = strlit5908;
  partcv[0] = 1;
  Object call5909 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5907);
// compilenode returning call5909
  int op_slot_right_5906 = gc_frame_newslot(call5909);
  int callframe5911 = gc_frame_new();
  if (strlit5912 == NULL) {
    strlit5912 = alloc_String("lparen");
    gc_root(strlit5912);
  }
// compilenode returning strlit5912
  gc_frame_newslot(strlit5912);
  params[0] = strlit5912;
  partcv[0] = 1;
  Object call5913 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5911);
// compilenode returning call5913
  int op_slot_left_5906 = gc_frame_newslot(call5913);
  params[0] = call5909;
  partcv[0] = 1;
  Object opresult5914 = callmethod(call5913, "||", 1, partcv, params);
// compilenode returning opresult5914
  int op_slot_left_5901 = gc_frame_newslot(opresult5914);
  params[0] = call5904;
  partcv[0] = 1;
  Object opresult5915 = callmethod(opresult5914, "||", 1, partcv, params);
// compilenode returning opresult5915
  int op_slot_left_5896 = gc_frame_newslot(opresult5915);
  params[0] = call5899;
  partcv[0] = 1;
  Object opresult5916 = callmethod(opresult5915, "||", 1, partcv, params);
// compilenode returning opresult5916
  int op_slot_left_5891 = gc_frame_newslot(opresult5916);
  params[0] = call5894;
  partcv[0] = 1;
  Object opresult5917 = callmethod(opresult5916, "||", 1, partcv, params);
// compilenode returning opresult5917
  int op_slot_left_5886 = gc_frame_newslot(opresult5917);
  params[0] = call5889;
  partcv[0] = 1;
  Object opresult5918 = callmethod(opresult5917, "||", 1, partcv, params);
// compilenode returning opresult5918
  Object if5885 = done;
  if (istrue(opresult5918)) {
// Begin line 1860
  setline(1860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5919 = gc_frame_new();
  partcv[0] = 0;
  Object call5920 = callmethodflags(self, "callrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5919);
// compilenode returning call5920
    gc_frame_newslot(call5920);
    if5885 = call5920;
  } else {
  }
// compilenode returning if5885
    gc_frame_newslot(if5885);
    if5879 = if5885;
  }
// compilenode returning if5879
    gc_frame_newslot(if5879);
    if5865 = if5879;
  } else {
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1863
  setline(1863);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5921 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5921
  *var_suggestions = array5921;
  if (array5921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1864
  setline(1864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5922 = gc_frame_new();
  int callframe5923 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5924 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5923);
// compilenode returning call5924
// compilenode returning call5924
  partcv[0] = 0;
  Object call5925 = callmethod(call5924, "new",
    1, partcv, params);
  gc_frame_end(callframe5922);
// compilenode returning call5925
// compilenode returning call5925
  *var_suggestion = call5925;
  if (call5925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1865
  setline(1865);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5926 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call5927 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe5926);
// compilenode returning call5927
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5928 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5929 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5928);
// compilenode returning call5929
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5930 = gc_frame_new();
  int callframe5931 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call5932 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe5931);
// compilenode returning call5932
// compilenode returning call5932
  partcv[0] = 0;
  Object call5933 = callmethod(call5932, "new",
    1, partcv, params);
  gc_frame_end(callframe5930);
// compilenode returning call5933
// compilenode returning call5933
  *var_suggestion = call5933;
  if (call5933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5935 = gc_frame_new();
  if (strlit5936 == NULL) {
    strlit5936 = alloc_String("""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit5936);
  }
// compilenode returning strlit5936
  gc_frame_newslot(strlit5936);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit5936;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5937 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe5935);
// compilenode returning call5937
// Begin line 1869
  setline(1869);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5938 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call5939 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe5938);
// compilenode returning call5939
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5940 = gc_frame_new();
  if (strlit5941 == NULL) {
    strlit5941 = alloc_String("A field or method name must follow a '.'.");
    gc_root(strlit5941);
  }
// compilenode returning strlit5941
  gc_frame_newslot(strlit5941);
// Begin line 1871
  setline(1871);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5942 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5943 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe5942);
// compilenode returning call5943
// compilenode returning call5943
  gc_frame_newslot(call5943);
  int callframe5944 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call5945 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5944);
// compilenode returning call5945
// compilenode returning call5945
  gc_frame_newslot(call5945);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit5941;
  params[1] = call5943;
  params[2] = call5945;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call5946 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe5940);
// compilenode returning call5946
    gc_frame_newslot(call5946);
    if5865 = call5946;
  }
// compilenode returning if5865
    gc_frame_newslot(if5865);
    if5857 = if5865;
  } else {
  }
// compilenode returning if5857
  gc_frame_end(frame);
  return if5857;
}
Object meth_parser__apply6012(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6013 = gc_frame_new();
  if (strlit6014 == NULL) {
    strlit6014 = alloc_String("identifier");
    gc_root(strlit6014);
  }
// compilenode returning strlit6014
  gc_frame_newslot(strlit6014);
  params[0] = strlit6014;
  partcv[0] = 1;
  Object call6015 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6013);
// compilenode returning call6015
  gc_frame_end(frame);
  return call6015;
}
Object meth_parser__apply6018(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_genericIdents = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1913
  setline(1913);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6019 = gc_frame_new();
  partcv[0] = 0;
  Object call6020 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6019);
// compilenode returning call6020
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6021 = gc_frame_new();
  int callframe6022 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6023 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6022);
// compilenode returning call6023
// compilenode returning call6023
  gc_frame_newslot(call6023);
// compilenode returning *var_genericIdents
  params[0] = call6023;
  partcv[0] = 1;
  Object call6024 = callmethod(*var_genericIdents, "push",
    1, partcv, params);
  gc_frame_end(callframe6021);
// compilenode returning call6024
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6026 = gc_frame_new();
  if (strlit6027 == NULL) {
    strlit6027 = alloc_String("comma");
    gc_root(strlit6027);
  }
// compilenode returning strlit6027
  gc_frame_newslot(strlit6027);
  params[0] = strlit6027;
  partcv[0] = 1;
  Object call6028 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6026);
// compilenode returning call6028
  Object if6025 = done;
  if (istrue(call6028)) {
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6029 = gc_frame_new();
  partcv[0] = 0;
  Object call6030 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6029);
// compilenode returning call6030
    gc_frame_newslot(call6030);
    if6025 = call6030;
  } else {
  }
// compilenode returning if6025
  gc_frame_end(frame);
  return if6025;
}
Object meth_parser__apply6093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6094 = gc_frame_new();
  partcv[0] = 0;
  Object call6095 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6094);
// compilenode returning call6095
  gc_frame_end(frame);
  return call6095;
}
Object meth_parser__apply6173(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6174 = gc_frame_new();
  partcv[0] = 0;
  Object call6175 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6174);
// compilenode returning call6175
  gc_frame_end(frame);
  return call6175;
}
Object meth_parser__apply6233(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6234 = gc_frame_new();
  if (strlit6235 == NULL) {
    strlit6235 = alloc_String("comma");
    gc_root(strlit6235);
  }
// compilenode returning strlit6235
  gc_frame_newslot(strlit6235);
  params[0] = strlit6235;
  partcv[0] = 1;
  Object call6236 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6234);
// compilenode returning call6236
  gc_frame_end(frame);
  return call6236;
}
Object meth_parser__apply6253(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6254 = gc_frame_new();
  partcv[0] = 0;
  Object call6255 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6254);
// compilenode returning call6255
  gc_frame_end(frame);
  return call6255;
}
Object meth_parser__apply6375(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6376 = gc_frame_new();
  partcv[0] = 0;
  Object call6377 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6376);
// compilenode returning call6377
  gc_frame_end(frame);
  return call6377;
}
Object meth_parser__apply6239(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1977
  setline(1977);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6240 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6241 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6240);
// compilenode returning call6241
// compilenode returning call6241
  *var_tmp = call6241;
  if (call6241 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1978
  setline(1978);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6243 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
  int callframe6244 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6245 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6244);
// compilenode returning call6245
// compilenode returning call6245
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6246 = callmethod(call6245, "push",
    1, partcv, params);
  gc_frame_end(callframe6243);
// compilenode returning call6246
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6247 = gc_frame_new();
  partcv[0] = 0;
  Object call6248 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6247);
// compilenode returning call6248
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6250 = gc_frame_new();
  int callframe6251 = gc_frame_new();
  Object block6252 = alloc_Block(NULL, NULL, "parser", 1980);
  gc_frame_newslot(block6252);
  block_savedest(block6252);
  Object closure6253 = createclosure(1, "_apply");
setclosureframe(closure6253, stackframe);
  addtoclosure(closure6253, selfslot);
  struct UserObject *uo6253 = (struct UserObject*)block6252;
  uo6253->data[0] = (Object)closure6253;
  Method *meth_meth_parser__apply6253 = addmethod2pos(block6252, "_apply", &meth_parser__apply6253, 0);
int argcv_meth_parser__apply6253[] = {0};
meth_meth_parser__apply6253->type = alloc_MethodType(1, argcv_meth_parser__apply6253);
  meth_meth_parser__apply6253->definitionModule = modulename;
  meth_meth_parser__apply6253->definitionLine = 1980;
// compilenode returning block6252
  gc_frame_newslot(block6252);
  params[0] = block6252;
  partcv[0] = 1;
  Object call6257 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6251);
// compilenode returning call6257
  partcv[0] = 0;
  Object call6258 = callmethod(call6257, "not",
    1, partcv, params);
  gc_frame_end(callframe6250);
// compilenode returning call6258
// compilenode returning call6258
  Object if6249 = done;
  if (istrue(call6258)) {
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1981
  setline(1981);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6259 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array6259
  *var_suggestions = array6259;
  if (array6259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6260 = gc_frame_new();
  int callframe6261 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6262 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6261);
// compilenode returning call6262
// compilenode returning call6262
  partcv[0] = 0;
  Object call6263 = callmethod(call6262, "new",
    1, partcv, params);
  gc_frame_end(callframe6260);
// compilenode returning call6263
// compilenode returning call6263
  *var_suggestion = call6263;
  if (call6263 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6264 = gc_frame_new();
  if (strlit6265 == NULL) {
    strlit6265 = alloc_String("rparen");
    gc_root(strlit6265);
  }
// compilenode returning strlit6265
  gc_frame_newslot(strlit6265);
  params[0] = strlit6265;
  partcv[0] = 1;
  Object call6266 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6264);
// compilenode returning call6266
  *var_nextTok = call6266;
  if (call6266 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_6268 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_6268 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6270 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult6270
  Object if6267 = done;
  if (istrue(opresult6270)) {
// Begin line 1985
  setline(1985);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6271 = gc_frame_new();
  if (strlit6272 == NULL) {
    strlit6272 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6272);
  }
// compilenode returning strlit6272
  gc_frame_newslot(strlit6272);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6272;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6273 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6271);
// compilenode returning call6273
    gc_frame_newslot(call6273);
    if6267 = call6273;
  } else {
// Begin line 1987
  setline(1987);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6274 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6275 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6276 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6275);
// compilenode returning call6276
// compilenode returning call6276
  gc_frame_newslot(call6276);
  Object bool6277 = alloc_Boolean(1);
// compilenode returning bool6277
  gc_frame_newslot(bool6277);
  Object bool6278 = alloc_Boolean(0);
// compilenode returning bool6278
  gc_frame_newslot(bool6278);
  if (strlit6279 == NULL) {
    strlit6279 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6279);
  }
// compilenode returning strlit6279
  gc_frame_newslot(strlit6279);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6276;
  params[2] = bool6277;
  params[3] = bool6278;
  params[4] = strlit6279;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6280 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6274);
// compilenode returning call6280
    gc_frame_newslot(call6280);
    if6267 = call6280;
  }
// compilenode returning if6267
// Begin line 1989
  setline(1989);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6281 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6282 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6281);
// compilenode returning call6282
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6283 = gc_frame_new();
  int callframe6284 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6285 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6284);
// compilenode returning call6285
// compilenode returning call6285
  partcv[0] = 0;
  Object call6286 = callmethod(call6285, "new",
    1, partcv, params);
  gc_frame_end(callframe6283);
// compilenode returning call6286
// compilenode returning call6286
  *var_suggestion = call6286;
  if (call6286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6288 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe6289 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6290 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6289);
// compilenode returning call6290
// compilenode returning call6290
  gc_frame_newslot(call6290);
  Object bool6291 = alloc_Boolean(1);
// compilenode returning bool6291
  gc_frame_newslot(bool6291);
  Object bool6292 = alloc_Boolean(0);
// compilenode returning bool6292
  gc_frame_newslot(bool6292);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call6290;
  params[2] = bool6291;
  params[3] = bool6292;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6293 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6288);
// compilenode returning call6293
// Begin line 1992
  setline(1992);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6294 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6295 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6294);
// compilenode returning call6295
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6296 = gc_frame_new();
  if (strlit6297 == NULL) {
    strlit6297 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit6297);
  }
// compilenode returning strlit6297
  gc_frame_newslot(strlit6297);
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6298 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6299 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6298);
// compilenode returning call6299
// compilenode returning call6299
  gc_frame_newslot(call6299);
  int callframe6300 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6301 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6300);
// compilenode returning call6301
// compilenode returning call6301
  gc_frame_newslot(call6301);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6297;
  params[1] = call6299;
  params[2] = call6301;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6302 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6296);
// compilenode returning call6302
    gc_frame_newslot(call6302);
    if6249 = call6302;
  } else {
  }
// compilenode returning if6249
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1997
  setline(1997);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6304 = gc_frame_new();
  if (strlit6305 == NULL) {
    strlit6305 = alloc_String("colon");
    gc_root(strlit6305);
  }
// compilenode returning strlit6305
  gc_frame_newslot(strlit6305);
  params[0] = strlit6305;
  partcv[0] = 1;
  Object call6306 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6304);
// compilenode returning call6306
  Object if6303 = done;
  if (istrue(call6306)) {
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1998
  setline(1998);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6307 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6308 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6307);
// compilenode returning call6308
// compilenode returning call6308
  *var_tmp = call6308;
  if (call6308 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6312 == NULL) {
    strlit6312 = alloc_String("identifier");
    gc_root(strlit6312);
  }
// compilenode returning strlit6312
  int op_slot_right_6311 = gc_frame_newslot(strlit6312);
  int callframe6314 = gc_frame_new();
// compilenode returning *var_tmp
  partcv[0] = 0;
  Object call6315 = callmethod(*var_tmp, "kind",
    1, partcv, params);
  gc_frame_end(callframe6314);
// compilenode returning call6315
// compilenode returning call6315
  int op_slot_left_6311 = gc_frame_newslot(call6315);
  params[0] = strlit6312;
  partcv[0] = 1;
  Object opresult6316 = callmethod(call6315, "!=", 1, partcv, params);
// compilenode returning opresult6316
  Object if6310 = done;
  if (istrue(opresult6316)) {
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6317 = gc_frame_new();
  int callframe6318 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6319 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6318);
// compilenode returning call6319
// compilenode returning call6319
  partcv[0] = 0;
  Object call6320 = callmethod(call6319, "new",
    1, partcv, params);
  gc_frame_end(callframe6317);
// compilenode returning call6320
// compilenode returning call6320
  *var_suggestion = call6320;
  if (call6320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6323 == NULL) {
    strlit6323 = alloc_String("identifier");
    gc_root(strlit6323);
  }
// compilenode returning strlit6323
  int op_slot_right_6322 = gc_frame_newslot(strlit6323);
  int callframe6325 = gc_frame_new();
  int callframe6326 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6327 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6326);
// compilenode returning call6327
// compilenode returning call6327
  partcv[0] = 0;
  Object call6328 = callmethod(call6327, "kind",
    1, partcv, params);
  gc_frame_end(callframe6325);
// compilenode returning call6328
// compilenode returning call6328
  int op_slot_left_6322 = gc_frame_newslot(call6328);
  params[0] = strlit6323;
  partcv[0] = 1;
  Object opresult6329 = callmethod(call6328, "==", 1, partcv, params);
// compilenode returning opresult6329
  Object if6321 = done;
  if (istrue(opresult6329)) {
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6330 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6331 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6332 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6331);
// compilenode returning call6332
// compilenode returning call6332
  gc_frame_newslot(call6332);
  Object bool6333 = alloc_Boolean(1);
// compilenode returning bool6333
  gc_frame_newslot(bool6333);
  Object bool6334 = alloc_Boolean(0);
// compilenode returning bool6334
  gc_frame_newslot(bool6334);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6332;
  params[2] = bool6333;
  params[3] = bool6334;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6335 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6330);
// compilenode returning call6335
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6336 = gc_frame_new();
  if (strlit6337 == NULL) {
    strlit6337 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6337);
  }
// compilenode returning strlit6337
  gc_frame_newslot(strlit6337);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6338 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6339 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6338);
// compilenode returning call6339
// compilenode returning call6339
  gc_frame_newslot(call6339);
  int callframe6340 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6341 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6340);
// compilenode returning call6341
// compilenode returning call6341
  gc_frame_newslot(call6341);
  Object num6343 = alloc_Float64(1);
// compilenode returning num6343
  int op_slot_right_6342 = gc_frame_newslot(num6343);
  int callframe6346 = gc_frame_new();
  int callframe6347 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6348 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6347);
// compilenode returning call6348
// compilenode returning call6348
  partcv[0] = 0;
  Object call6349 = callmethod(call6348, "size",
    1, partcv, params);
  gc_frame_end(callframe6346);
// compilenode returning call6349
// compilenode returning call6349
  int op_slot_right_6345 = gc_frame_newslot(call6349);
  int callframe6351 = gc_frame_new();
  int callframe6352 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6353 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6352);
// compilenode returning call6353
// compilenode returning call6353
  partcv[0] = 0;
  Object call6354 = callmethod(call6353, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6351);
// compilenode returning call6354
// compilenode returning call6354
  int op_slot_left_6345 = gc_frame_newslot(call6354);
  params[0] = call6349;
  partcv[0] = 1;
  Object sum6355 = callmethod(call6354, "+", 1, partcv, params);
// compilenode returning sum6355
  int op_slot_left_6342 = gc_frame_newslot(sum6355);
  params[0] = num6343;
  partcv[0] = 1;
  Object diff6356 = callmethod(sum6355, "-", 1, partcv, params);
// compilenode returning diff6356
  gc_frame_newslot(diff6356);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6337;
  params[1] = call6339;
  params[2] = call6341;
  params[3] = diff6356;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6357 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6336);
// compilenode returning call6357
    gc_frame_newslot(call6357);
    if6321 = call6357;
  } else {
// Begin line 2006
  setline(2006);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6358 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call6359 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe6358);
// compilenode returning call6359
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6360 = gc_frame_new();
  if (strlit6361 == NULL) {
    strlit6361 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6361);
  }
// compilenode returning strlit6361
  gc_frame_newslot(strlit6361);
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6362 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6363 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6362);
// compilenode returning call6363
// compilenode returning call6363
  gc_frame_newslot(call6363);
  int callframe6364 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6365 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6364);
// compilenode returning call6365
// compilenode returning call6365
  gc_frame_newslot(call6365);
  int callframe6366 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6367 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6366);
// compilenode returning call6367
// compilenode returning call6367
  gc_frame_newslot(call6367);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2007
  setline(2007);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6361;
  params[1] = call6363;
  params[2] = call6365;
  params[3] = call6367;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6368 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6360);
// compilenode returning call6368
    gc_frame_newslot(call6368);
    if6321 = call6368;
  }
// compilenode returning if6321
    gc_frame_newslot(if6321);
    if6310 = if6321;
  } else {
  }
// compilenode returning if6310
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6369 = gc_frame_new();
  partcv[0] = 0;
  Object call6370 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6369);
// compilenode returning call6370
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2012
  setline(2012);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6372 = gc_frame_new();
  int callframe6373 = gc_frame_new();
  Object block6374 = alloc_Block(NULL, NULL, "parser", 2012);
  gc_frame_newslot(block6374);
  block_savedest(block6374);
  Object closure6375 = createclosure(1, "_apply");
setclosureframe(closure6375, stackframe);
  addtoclosure(closure6375, selfslot);
  struct UserObject *uo6375 = (struct UserObject*)block6374;
  uo6375->data[0] = (Object)closure6375;
  Method *meth_meth_parser__apply6375 = addmethod2pos(block6374, "_apply", &meth_parser__apply6375, 0);
int argcv_meth_parser__apply6375[] = {0};
meth_meth_parser__apply6375->type = alloc_MethodType(1, argcv_meth_parser__apply6375);
  meth_meth_parser__apply6375->definitionModule = modulename;
  meth_meth_parser__apply6375->definitionLine = 2012;
// compilenode returning block6374
  gc_frame_newslot(block6374);
  params[0] = block6374;
  partcv[0] = 1;
  Object call6379 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6373);
// compilenode returning call6379
  partcv[0] = 0;
  Object call6380 = callmethod(call6379, "not",
    1, partcv, params);
  gc_frame_end(callframe6372);
// compilenode returning call6380
// compilenode returning call6380
  Object if6371 = done;
  if (istrue(call6380)) {
// Begin line 2013
  setline(2013);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6381 = gc_frame_new();
  partcv[0] = 0;
  Object call6382 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6381);
// compilenode returning call6382
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2014
  setline(2014);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6383 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array6383
  *var_suggestions = array6383;
  if (array6383 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6384 = gc_frame_new();
  int callframe6385 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6386 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6385);
// compilenode returning call6386
// compilenode returning call6386
  partcv[0] = 0;
  Object call6387 = callmethod(call6386, "new",
    1, partcv, params);
  gc_frame_end(callframe6384);
// compilenode returning call6387
// compilenode returning call6387
  *var_suggestion = call6387;
  if (call6387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6388 = gc_frame_new();
  if (strlit6389 == NULL) {
    strlit6389 = alloc_String("rparen");
    gc_root(strlit6389);
  }
// compilenode returning strlit6389
  gc_frame_newslot(strlit6389);
  params[0] = strlit6389;
  partcv[0] = 1;
  Object call6390 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6388);
// compilenode returning call6390
  *var_nextTok = call6390;
  if (call6390 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_6392 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_6392 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6394 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult6394
  Object if6391 = done;
  if (istrue(opresult6394)) {
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6395 = gc_frame_new();
  if (strlit6396 == NULL) {
    strlit6396 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6396);
  }
// compilenode returning strlit6396
  gc_frame_newslot(strlit6396);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6396;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6397 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6395);
// compilenode returning call6397
    gc_frame_newslot(call6397);
    if6391 = call6397;
  } else {
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6398 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6399 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6400 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6399);
// compilenode returning call6400
// compilenode returning call6400
  gc_frame_newslot(call6400);
  Object bool6401 = alloc_Boolean(1);
// compilenode returning bool6401
  gc_frame_newslot(bool6401);
  Object bool6402 = alloc_Boolean(0);
// compilenode returning bool6402
  gc_frame_newslot(bool6402);
  if (strlit6403 == NULL) {
    strlit6403 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6403);
  }
// compilenode returning strlit6403
  gc_frame_newslot(strlit6403);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6400;
  params[2] = bool6401;
  params[3] = bool6402;
  params[4] = strlit6403;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6404 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6398);
// compilenode returning call6404
    gc_frame_newslot(call6404);
    if6391 = call6404;
  }
// compilenode returning if6391
// Begin line 2022
  setline(2022);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6405 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6406 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6405);
// compilenode returning call6406
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2023
  setline(2023);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6407 = gc_frame_new();
  int callframe6408 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6409 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6408);
// compilenode returning call6409
// compilenode returning call6409
  partcv[0] = 0;
  Object call6410 = callmethod(call6409, "new",
    1, partcv, params);
  gc_frame_end(callframe6407);
// compilenode returning call6410
// compilenode returning call6410
  *var_suggestion = call6410;
  if (call6410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6412 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe6413 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6414 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6413);
// compilenode returning call6414
// compilenode returning call6414
  gc_frame_newslot(call6414);
  Object bool6415 = alloc_Boolean(1);
// compilenode returning bool6415
  gc_frame_newslot(bool6415);
  Object bool6416 = alloc_Boolean(0);
// compilenode returning bool6416
  gc_frame_newslot(bool6416);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call6414;
  params[2] = bool6415;
  params[3] = bool6416;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6417 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6412);
// compilenode returning call6417
// Begin line 2025
  setline(2025);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6418 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6419 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6418);
// compilenode returning call6419
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6420 = gc_frame_new();
  if (strlit6421 == NULL) {
    strlit6421 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6421);
  }
// compilenode returning strlit6421
  gc_frame_newslot(strlit6421);
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6422 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6423 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6422);
// compilenode returning call6423
// compilenode returning call6423
  gc_frame_newslot(call6423);
  int callframe6424 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6425 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6424);
// compilenode returning call6425
// compilenode returning call6425
  gc_frame_newslot(call6425);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2026
  setline(2026);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6421;
  params[1] = call6423;
  params[2] = call6425;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6426 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6420);
// compilenode returning call6426
    gc_frame_newslot(call6426);
    if6371 = call6426;
  } else {
  }
// compilenode returning if6371
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6427 = gc_frame_new();
// Begin line 2029
  setline(2029);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6428 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6429 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6428);
// compilenode returning call6429
// compilenode returning call6429
  gc_frame_newslot(call6429);
// compilenode returning *var_tmp
  params[0] = call6429;
  partcv[0] = 1;
  Object call6430 = callmethod(*var_tmp, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6427);
// compilenode returning call6430
// compilenode returning done
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6431 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_values
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6432 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6431);
// compilenode returning call6432
    gc_frame_newslot(call6432);
    if6303 = call6432;
  } else {
  }
// compilenode returning if6303
  gc_frame_end(frame);
  return if6303;
}
Object meth_parser__apply6098(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_part = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1941
  setline(1941);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6100 = gc_frame_new();
  if (strlit6101 == NULL) {
    strlit6101 = alloc_String("colon");
    gc_root(strlit6101);
  }
// compilenode returning strlit6101
  gc_frame_newslot(strlit6101);
  params[0] = strlit6101;
  partcv[0] = 1;
  Object call6102 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6100);
// compilenode returning call6102
  Object if6099 = done;
  if (istrue(call6102)) {
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1942
  setline(1942);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6103 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6104 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6103);
// compilenode returning call6104
// compilenode returning call6104
  *var_tmp = call6104;
  if (call6104 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1943
  setline(1943);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6108 == NULL) {
    strlit6108 = alloc_String("identifier");
    gc_root(strlit6108);
  }
// compilenode returning strlit6108
  int op_slot_right_6107 = gc_frame_newslot(strlit6108);
  int callframe6110 = gc_frame_new();
// compilenode returning *var_tmp
  partcv[0] = 0;
  Object call6111 = callmethod(*var_tmp, "kind",
    1, partcv, params);
  gc_frame_end(callframe6110);
// compilenode returning call6111
// compilenode returning call6111
  int op_slot_left_6107 = gc_frame_newslot(call6111);
  params[0] = strlit6108;
  partcv[0] = 1;
  Object opresult6112 = callmethod(call6111, "!=", 1, partcv, params);
// compilenode returning opresult6112
  Object if6106 = done;
  if (istrue(opresult6112)) {
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6113 = gc_frame_new();
  int callframe6114 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6115 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6114);
// compilenode returning call6115
// compilenode returning call6115
  partcv[0] = 0;
  Object call6116 = callmethod(call6115, "new",
    1, partcv, params);
  gc_frame_end(callframe6113);
// compilenode returning call6116
// compilenode returning call6116
  *var_suggestion = call6116;
  if (call6116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1954
  setline(1954);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6119 == NULL) {
    strlit6119 = alloc_String("identifier");
    gc_root(strlit6119);
  }
// compilenode returning strlit6119
  int op_slot_right_6118 = gc_frame_newslot(strlit6119);
  int callframe6121 = gc_frame_new();
  int callframe6122 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6123 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6122);
// compilenode returning call6123
// compilenode returning call6123
  partcv[0] = 0;
  Object call6124 = callmethod(call6123, "kind",
    1, partcv, params);
  gc_frame_end(callframe6121);
// compilenode returning call6124
// compilenode returning call6124
  int op_slot_left_6118 = gc_frame_newslot(call6124);
  params[0] = strlit6119;
  partcv[0] = 1;
  Object opresult6125 = callmethod(call6124, "==", 1, partcv, params);
// compilenode returning opresult6125
  Object if6117 = done;
  if (istrue(opresult6125)) {
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6126 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6127 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6128 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6127);
// compilenode returning call6128
// compilenode returning call6128
  gc_frame_newslot(call6128);
  Object bool6129 = alloc_Boolean(1);
// compilenode returning bool6129
  gc_frame_newslot(bool6129);
  Object bool6130 = alloc_Boolean(0);
// compilenode returning bool6130
  gc_frame_newslot(bool6130);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6128;
  params[2] = bool6129;
  params[3] = bool6130;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6131 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6126);
// compilenode returning call6131
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6132 = gc_frame_new();
  if (strlit6133 == NULL) {
    strlit6133 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6133);
  }
// compilenode returning strlit6133
  gc_frame_newslot(strlit6133);
// Begin line 1948
  setline(1948);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6134 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6135 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6134);
// compilenode returning call6135
// compilenode returning call6135
  gc_frame_newslot(call6135);
  int callframe6136 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6137 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6136);
// compilenode returning call6137
// compilenode returning call6137
  gc_frame_newslot(call6137);
  Object num6139 = alloc_Float64(1);
// compilenode returning num6139
  int op_slot_right_6138 = gc_frame_newslot(num6139);
  int callframe6142 = gc_frame_new();
  int callframe6143 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6144 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6143);
// compilenode returning call6144
// compilenode returning call6144
  partcv[0] = 0;
  Object call6145 = callmethod(call6144, "size",
    1, partcv, params);
  gc_frame_end(callframe6142);
// compilenode returning call6145
// compilenode returning call6145
  int op_slot_right_6141 = gc_frame_newslot(call6145);
  int callframe6147 = gc_frame_new();
  int callframe6148 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6149 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe6148);
// compilenode returning call6149
// compilenode returning call6149
  partcv[0] = 0;
  Object call6150 = callmethod(call6149, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6147);
// compilenode returning call6150
// compilenode returning call6150
  int op_slot_left_6141 = gc_frame_newslot(call6150);
  params[0] = call6145;
  partcv[0] = 1;
  Object sum6151 = callmethod(call6150, "+", 1, partcv, params);
// compilenode returning sum6151
  int op_slot_left_6138 = gc_frame_newslot(sum6151);
  params[0] = num6139;
  partcv[0] = 1;
  Object diff6152 = callmethod(sum6151, "-", 1, partcv, params);
// compilenode returning diff6152
  gc_frame_newslot(diff6152);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1947
  setline(1947);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6133;
  params[1] = call6135;
  params[2] = call6137;
  params[3] = diff6152;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6153 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6132);
// compilenode returning call6153
    gc_frame_newslot(call6153);
    if6117 = call6153;
  } else {
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6154 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool6155 = alloc_Boolean(1);
// compilenode returning bool6155
  gc_frame_newslot(bool6155);
  Object bool6156 = alloc_Boolean(0);
// compilenode returning bool6156
  gc_frame_newslot(bool6156);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool6155;
  params[2] = bool6156;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6157 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6154);
// compilenode returning call6157
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6158 = gc_frame_new();
  if (strlit6159 == NULL) {
    strlit6159 = alloc_String("Only variables and constants may be followed by a ':' and a type.");
    gc_root(strlit6159);
  }
// compilenode returning strlit6159
  gc_frame_newslot(strlit6159);
// Begin line 1952
  setline(1952);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6160 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6161 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6160);
// compilenode returning call6161
// compilenode returning call6161
  gc_frame_newslot(call6161);
  int callframe6162 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6163 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6162);
// compilenode returning call6163
// compilenode returning call6163
  gc_frame_newslot(call6163);
  int callframe6164 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6165 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6164);
// compilenode returning call6165
// compilenode returning call6165
  gc_frame_newslot(call6165);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 1951
  setline(1951);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6159;
  params[1] = call6161;
  params[2] = call6163;
  params[3] = call6165;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call6166 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6158);
// compilenode returning call6166
    gc_frame_newslot(call6166);
    if6117 = call6166;
  }
// compilenode returning if6117
    gc_frame_newslot(if6117);
    if6106 = if6117;
  } else {
  }
// compilenode returning if6106
// Begin line 1955
  setline(1955);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6167 = gc_frame_new();
  partcv[0] = 0;
  Object call6168 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6167);
// compilenode returning call6168
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6170 = gc_frame_new();
  int callframe6171 = gc_frame_new();
  Object block6172 = alloc_Block(NULL, NULL, "parser", 1956);
  gc_frame_newslot(block6172);
  block_savedest(block6172);
  Object closure6173 = createclosure(1, "_apply");
setclosureframe(closure6173, stackframe);
  addtoclosure(closure6173, selfslot);
  struct UserObject *uo6173 = (struct UserObject*)block6172;
  uo6173->data[0] = (Object)closure6173;
  Method *meth_meth_parser__apply6173 = addmethod2pos(block6172, "_apply", &meth_parser__apply6173, 0);
int argcv_meth_parser__apply6173[] = {0};
meth_meth_parser__apply6173->type = alloc_MethodType(1, argcv_meth_parser__apply6173);
  meth_meth_parser__apply6173->definitionModule = modulename;
  meth_meth_parser__apply6173->definitionLine = 1956;
// compilenode returning block6172
  gc_frame_newslot(block6172);
  params[0] = block6172;
  partcv[0] = 1;
  Object call6177 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6171);
// compilenode returning call6177
  partcv[0] = 0;
  Object call6178 = callmethod(call6177, "not",
    1, partcv, params);
  gc_frame_end(callframe6170);
// compilenode returning call6178
// compilenode returning call6178
  Object if6169 = done;
  if (istrue(call6178)) {
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6179 = gc_frame_new();
  partcv[0] = 0;
  Object call6180 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6179);
// compilenode returning call6180
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6181 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array6181
  *var_suggestions = array6181;
  if (array6181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6182 = gc_frame_new();
  int callframe6183 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6184 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6183);
// compilenode returning call6184
// compilenode returning call6184
  partcv[0] = 0;
  Object call6185 = callmethod(call6184, "new",
    1, partcv, params);
  gc_frame_end(callframe6182);
// compilenode returning call6185
// compilenode returning call6185
  *var_suggestion = call6185;
  if (call6185 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6186 = gc_frame_new();
  if (strlit6187 == NULL) {
    strlit6187 = alloc_String("rparen");
    gc_root(strlit6187);
  }
// compilenode returning strlit6187
  gc_frame_newslot(strlit6187);
  params[0] = strlit6187;
  partcv[0] = 1;
  Object call6188 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6186);
// compilenode returning call6188
  *var_nextTok = call6188;
  if (call6188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_6190 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_6190 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6192 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult6192
  Object if6189 = done;
  if (istrue(opresult6192)) {
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6193 = gc_frame_new();
  if (strlit6194 == NULL) {
    strlit6194 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6194);
  }
// compilenode returning strlit6194
  gc_frame_newslot(strlit6194);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6194;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6195 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6193);
// compilenode returning call6195
    gc_frame_newslot(call6195);
    if6189 = call6195;
  } else {
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6196 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6197 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6198 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6197);
// compilenode returning call6198
// compilenode returning call6198
  gc_frame_newslot(call6198);
  Object bool6199 = alloc_Boolean(1);
// compilenode returning bool6199
  gc_frame_newslot(bool6199);
  Object bool6200 = alloc_Boolean(0);
// compilenode returning bool6200
  gc_frame_newslot(bool6200);
  if (strlit6201 == NULL) {
    strlit6201 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit6201);
  }
// compilenode returning strlit6201
  gc_frame_newslot(strlit6201);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6198;
  params[2] = bool6199;
  params[3] = bool6200;
  params[4] = strlit6201;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6202 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6196);
// compilenode returning call6202
    gc_frame_newslot(call6202);
    if6189 = call6202;
  }
// compilenode returning if6189
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6203 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6204 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6203);
// compilenode returning call6204
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6205 = gc_frame_new();
  int callframe6206 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6207 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6206);
// compilenode returning call6207
// compilenode returning call6207
  partcv[0] = 0;
  Object call6208 = callmethod(call6207, "new",
    1, partcv, params);
  gc_frame_end(callframe6205);
// compilenode returning call6208
// compilenode returning call6208
  *var_suggestion = call6208;
  if (call6208 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6210 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe6211 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6212 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6211);
// compilenode returning call6212
// compilenode returning call6212
  gc_frame_newslot(call6212);
  Object bool6213 = alloc_Boolean(1);
// compilenode returning bool6213
  gc_frame_newslot(bool6213);
  Object bool6214 = alloc_Boolean(0);
// compilenode returning bool6214
  gc_frame_newslot(bool6214);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call6212;
  params[2] = bool6213;
  params[3] = bool6214;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6215 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6210);
// compilenode returning call6215
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6216 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6217 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6216);
// compilenode returning call6217
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6218 = gc_frame_new();
  if (strlit6219 == NULL) {
    strlit6219 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit6219);
  }
// compilenode returning strlit6219
  gc_frame_newslot(strlit6219);
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6220 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6221 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6220);
// compilenode returning call6221
// compilenode returning call6221
  gc_frame_newslot(call6221);
  int callframe6222 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6223 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6222);
// compilenode returning call6223
// compilenode returning call6223
  gc_frame_newslot(call6223);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6219;
  params[1] = call6221;
  params[2] = call6223;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6224 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6218);
// compilenode returning call6224
    gc_frame_newslot(call6224);
    if6169 = call6224;
  } else {
  }
// compilenode returning if6169
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6225 = gc_frame_new();
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6226 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6227 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6226);
// compilenode returning call6227
// compilenode returning call6227
  gc_frame_newslot(call6227);
// compilenode returning *var_tmp
  params[0] = call6227;
  partcv[0] = 1;
  Object call6228 = callmethod(*var_tmp, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe6225);
// compilenode returning call6228
// compilenode returning done
// Begin line 1974
  setline(1974);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6229 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_values
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6230 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6229);
// compilenode returning call6230
    gc_frame_newslot(call6230);
    if6099 = call6230;
  } else {
  }
// compilenode returning if6099
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6231 = gc_frame_new();
  Object block6232 = alloc_Block(NULL, NULL, "parser", 1976);
  gc_frame_newslot(block6232);
  block_savedest(block6232);
  Object closure6233 = createclosure(1, "_apply");
setclosureframe(closure6233, stackframe);
  addtoclosure(closure6233, selfslot);
  struct UserObject *uo6233 = (struct UserObject*)block6232;
  uo6233->data[0] = (Object)closure6233;
  Method *meth_meth_parser__apply6233 = addmethod2pos(block6232, "_apply", &meth_parser__apply6233, 0);
int argcv_meth_parser__apply6233[] = {0};
meth_meth_parser__apply6233->type = alloc_MethodType(1, argcv_meth_parser__apply6233);
  meth_meth_parser__apply6233->definitionModule = modulename;
  meth_meth_parser__apply6233->definitionLine = 1973;
// compilenode returning block6232
  gc_frame_newslot(block6232);
  Object block6238 = alloc_Block(NULL, NULL, "parser", 1976);
  gc_frame_newslot(block6238);
  block_savedest(block6238);
  Object closure6239 = createclosure(7, "_apply");
setclosureframe(closure6239, stackframe);
  addtoclosure(closure6239, var_values);
  addtoclosure(closure6239, var_tmp);
  addtoclosure(closure6239, var_part);
  addtoclosure(closure6239, var_errormessages);
  addtoclosure(closure6239, var_sym);
  addtoclosure(closure6239, var_lastToken);
  addtoclosure(closure6239, selfslot);
  struct UserObject *uo6239 = (struct UserObject*)block6238;
  uo6239->data[0] = (Object)closure6239;
  Method *meth_meth_parser__apply6239 = addmethod2pos(block6238, "_apply", &meth_parser__apply6239, 0);
int argcv_meth_parser__apply6239[] = {0};
meth_meth_parser__apply6239->type = alloc_MethodType(1, argcv_meth_parser__apply6239);
  meth_meth_parser__apply6239->definitionModule = modulename;
  meth_meth_parser__apply6239->definitionLine = 1973;
// compilenode returning block6238
  gc_frame_newslot(block6238);
  params[0] = block6232;
  params[1] = block6238;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6434 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6231);
// compilenode returning call6434
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2033
  setline(2033);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6435 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6436 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6435);
// compilenode returning call6436
// compilenode returning call6436
  *var_tmp = call6436;
  if (call6436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6438 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
  int callframe6439 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6440 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6439);
// compilenode returning call6440
// compilenode returning call6440
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6441 = callmethod(call6440, "push",
    1, partcv, params);
  gc_frame_end(callframe6438);
// compilenode returning call6441
  gc_frame_end(frame);
  return call6441;
}
Object meth_parser__apply6495(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6496 = gc_frame_new();
  if (strlit6497 == NULL) {
    strlit6497 = alloc_String("lbrace");
    gc_root(strlit6497);
  }
// compilenode returning strlit6497
  gc_frame_newslot(strlit6497);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6497;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6498 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6496);
// compilenode returning call6498
  gc_frame_end(frame);
  return call6498;
}
Object meth_parser__apply6581(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit6583 == NULL) {
    strlit6583 = alloc_String("member");
    gc_root(strlit6583);
  }
// compilenode returning strlit6583
  int op_slot_right_6582 = gc_frame_newslot(strlit6583);
  int callframe6585 = gc_frame_new();
// compilenode returning *var_root
  partcv[0] = 0;
  Object call6586 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6585);
// compilenode returning call6586
// compilenode returning call6586
  int op_slot_left_6582 = gc_frame_newslot(call6586);
  params[0] = strlit6583;
  partcv[0] = 1;
  Object opresult6587 = callmethod(call6586, "==", 1, partcv, params);
// compilenode returning opresult6587
  gc_frame_end(frame);
  return opresult6587;
}
Object meth_parser__apply6590(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_root = getfromclosure(closure, 0);
  Object *var_outroot = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2068
  setline(2068);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_root
  *var_outroot = *var_root;
  if (*var_root == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2070
  setline(2070);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2069
  setline(2069);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6592 = gc_frame_new();
// compilenode returning *var_root
  partcv[0] = 0;
  Object call6593 = callmethod(*var_root, "in",
    1, partcv, params);
  gc_frame_end(callframe6592);
// compilenode returning call6593
// compilenode returning call6593
  *var_root = call6593;
  if (call6593 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_callrest5947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(23, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_linenum = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_minIndentLevel = getfromclosure(closure, 5);
  Object *var_collections = getfromclosure(closure, 6);
  Object *var_errormessages = getfromclosure(closure, 7);
  Object *var_don_39_tTakeBlock = getfromclosure(closure, 8);
  Object *var_util = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callrest (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for callrest");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_meth = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "meth");
  Object *var_lnum = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lnum");
  Object *var_lpos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "lpos");
  Object *var_methn = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methn");
  Object *var_btok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "btok");
  Object *var_tmp = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "tmp");
  Object *var_ln = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "ln");
  Object *var_signature = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "signature");
  Object *var_part = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "part");
  Object *var_hadcall = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "hadcall");
  Object *var_tok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "tok");
  Object *var_startInd = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "startInd");
  Object *var_genericIdents = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "genericIdents");
  Object *var_startToken = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "startToken");
  Object *var_suggestion = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "suggestion");
  Object *var_suggestion2 = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "suggestion2");
  Object *var_suggestions = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "suggestions");
  Object *var_ar = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "ar");
  Object *var_root = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "root");
  Object *var_outroot = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "outroot");
  Object *var_meth_39_ = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "meth'");
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5950 = alloc_Float64(0);
// compilenode returning num5950
  int op_slot_right_5949 = gc_frame_newslot(num5950);
  int callframe5952 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5953 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe5952);
// compilenode returning call5953
// compilenode returning call5953
  int op_slot_left_5949 = gc_frame_newslot(call5953);
  params[0] = num5950;
  partcv[0] = 1;
  Object opresult5954 = callmethod(call5953, "==", 1, partcv, params);
// compilenode returning opresult5954
  Object if5948 = done;
  if (istrue(opresult5954)) {
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1881
  setline(1881);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5955 = alloc_Float64(0);
// compilenode returning num5955
  return num5955;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5948 = undefined;
  } else {
  }
// compilenode returning if5948
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5956 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call5957 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe5956);
// compilenode returning call5957
// compilenode returning call5957
  *var_meth = call5957;
  if (call5957 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1884
  setline(1884);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  *var_lnum = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5958 = alloc_Float64(1);
// compilenode returning num5958
  *var_lpos = num5958;
  if (num5958 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1886
  setline(1886);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5961 == NULL) {
    strlit5961 = alloc_String("identifier");
    gc_root(strlit5961);
  }
// compilenode returning strlit5961
  int op_slot_right_5960 = gc_frame_newslot(strlit5961);
  int callframe5963 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call5964 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5963);
// compilenode returning call5964
// compilenode returning call5964
  int op_slot_left_5960 = gc_frame_newslot(call5964);
  params[0] = strlit5961;
  partcv[0] = 1;
  Object opresult5965 = callmethod(call5964, "!=", 1, partcv, params);
// compilenode returning opresult5965
  Object if5959 = done;
  if (istrue(opresult5965)) {
// Begin line 1891
  setline(1891);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1887
  setline(1887);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5968 == NULL) {
    strlit5968 = alloc_String("member");
    gc_root(strlit5968);
  }
// compilenode returning strlit5968
  int op_slot_right_5967 = gc_frame_newslot(strlit5968);
  int callframe5970 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call5971 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5970);
// compilenode returning call5971
// compilenode returning call5971
  int op_slot_left_5967 = gc_frame_newslot(call5971);
  params[0] = strlit5968;
  partcv[0] = 1;
  Object opresult5972 = callmethod(call5971, "!=", 1, partcv, params);
// compilenode returning opresult5972
  Object if5966 = done;
  if (istrue(opresult5972)) {
// Begin line 1888
  setline(1888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5973 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call5974 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe5973);
// compilenode returning call5974
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num5975 = alloc_Float64(0);
// compilenode returning num5975
  return num5975;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if5966 = undefined;
  } else {
  }
// compilenode returning if5966
    gc_frame_newslot(if5966);
    if5959 = if5966;
  } else {
  }
// compilenode returning if5959
// Begin line 1896
  setline(1896);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit5978 == NULL) {
    strlit5978 = alloc_String("identifier");
    gc_root(strlit5978);
  }
// compilenode returning strlit5978
  int op_slot_right_5977 = gc_frame_newslot(strlit5978);
  int callframe5980 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call5981 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe5980);
// compilenode returning call5981
// compilenode returning call5981
  int op_slot_left_5977 = gc_frame_newslot(call5981);
  params[0] = strlit5978;
  partcv[0] = 1;
  Object opresult5982 = callmethod(call5981, "==", 1, partcv, params);
// compilenode returning opresult5982
  Object if5976 = done;
  if (istrue(opresult5982)) {
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5983 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call5984 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe5983);
// compilenode returning call5984
// compilenode returning call5984
  *var_lnum = call5984;
  if (call5984 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1894
  setline(1894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5986 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call5987 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe5986);
// compilenode returning call5987
// compilenode returning call5987
  *var_lpos = call5987;
  if (call5987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if5976 = done;
  } else {
  }
// compilenode returning if5976
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_methn = undefined;
// compilenode returning done
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1897
  setline(1897);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_tmp = undefined;
// compilenode returning done
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5989 = alloc_Boolean(0);
// compilenode returning bool5989
  *var_ln = bool5989;
  if (bool5989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array5990 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array5990
  *var_signature = array5990;
  if (array5990 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5991 = gc_frame_new();
  int callframe5992 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call5993 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe5992);
// compilenode returning call5993
// compilenode returning call5993
  partcv[0] = 0;
  Object call5994 = callmethod(call5993, "new",
    1, partcv, params);
  gc_frame_end(callframe5991);
// compilenode returning call5994
// compilenode returning call5994
  *var_part = call5994;
  if (call5994 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe5995 = gc_frame_new();
// compilenode returning *var_part
  gc_frame_newslot(*var_part);
// compilenode returning *var_signature
  params[0] = *var_part;
  partcv[0] = 1;
  Object call5996 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe5995);
// compilenode returning call5996
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5997 = alloc_Boolean(0);
// compilenode returning bool5997
  *var_hadcall = bool5997;
  if (bool5997 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1905
  setline(1905);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_startInd = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1906
  setline(1906);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool5998 = alloc_Boolean(0);
// compilenode returning bool5998
  *var_genericIdents = bool5998;
  if (bool5998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6000 = gc_frame_new();
  if (strlit6001 == NULL) {
    strlit6001 = alloc_String("lgeneric");
    gc_root(strlit6001);
  }
// compilenode returning strlit6001
  gc_frame_newslot(strlit6001);
  params[0] = strlit6001;
  partcv[0] = 1;
  Object call6002 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6000);
// compilenode returning call6002
  Object if5999 = done;
  if (istrue(call6002)) {
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_startToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6003 = gc_frame_new();
  partcv[0] = 0;
  Object call6004 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6003);
// compilenode returning call6004
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1911
  setline(1911);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6005 = gc_frame_new();
  int callframe6006 = gc_frame_new();
// compilenode returning *var_collections
  partcv[0] = 0;
  Object call6007 = callmethod(*var_collections, "list",
    1, partcv, params);
  gc_frame_end(callframe6006);
// compilenode returning call6007
// compilenode returning call6007
  partcv[0] = 0;
  Object call6008 = callmethod(call6007, "new",
    1, partcv, params);
  gc_frame_end(callframe6005);
// compilenode returning call6008
// compilenode returning call6008
  *var_genericIdents = call6008;
  if (call6008 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1912
  setline(1912);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6010 = gc_frame_new();
  Object block6011 = alloc_Block(NULL, NULL, "parser", 1912);
  gc_frame_newslot(block6011);
  block_savedest(block6011);
  Object closure6012 = createclosure(1, "_apply");
setclosureframe(closure6012, stackframe);
  addtoclosure(closure6012, selfslot);
  struct UserObject *uo6012 = (struct UserObject*)block6011;
  uo6012->data[0] = (Object)closure6012;
  Method *meth_meth_parser__apply6012 = addmethod2pos(block6011, "_apply", &meth_parser__apply6012, 0);
int argcv_meth_parser__apply6012[] = {0};
meth_meth_parser__apply6012->type = alloc_MethodType(1, argcv_meth_parser__apply6012);
  meth_meth_parser__apply6012->definitionModule = modulename;
  meth_meth_parser__apply6012->definitionLine = 1911;
// compilenode returning block6011
  gc_frame_newslot(block6011);
  Object block6017 = alloc_Block(NULL, NULL, "parser", 1912);
  gc_frame_newslot(block6017);
  block_savedest(block6017);
  Object closure6018 = createclosure(3, "_apply");
setclosureframe(closure6018, stackframe);
  addtoclosure(closure6018, var_values);
  addtoclosure(closure6018, var_genericIdents);
  addtoclosure(closure6018, selfslot);
  struct UserObject *uo6018 = (struct UserObject*)block6017;
  uo6018->data[0] = (Object)closure6018;
  Method *meth_meth_parser__apply6018 = addmethod2pos(block6017, "_apply", &meth_parser__apply6018, 0);
int argcv_meth_parser__apply6018[] = {0};
meth_meth_parser__apply6018->type = alloc_MethodType(1, argcv_meth_parser__apply6018);
  meth_meth_parser__apply6018->definitionModule = modulename;
  meth_meth_parser__apply6018->definitionLine = 1911;
// compilenode returning block6017
  gc_frame_newslot(block6017);
  params[0] = block6011;
  params[1] = block6017;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6032 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6010);
// compilenode returning call6032
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6035 == NULL) {
    strlit6035 = alloc_String("rgeneric");
    gc_root(strlit6035);
  }
// compilenode returning strlit6035
  int op_slot_right_6034 = gc_frame_newslot(strlit6035);
  int callframe6037 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6038 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6037);
// compilenode returning call6038
// compilenode returning call6038
  int op_slot_left_6034 = gc_frame_newslot(call6038);
  params[0] = strlit6035;
  partcv[0] = 1;
  Object opresult6039 = callmethod(call6038, "!=", 1, partcv, params);
// compilenode returning opresult6039
  Object if6033 = done;
  if (istrue(opresult6039)) {
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1920
  setline(1920);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6040 = gc_frame_new();
  int callframe6041 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6042 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6041);
// compilenode returning call6042
// compilenode returning call6042
  partcv[0] = 0;
  Object call6043 = callmethod(call6042, "new",
    1, partcv, params);
  gc_frame_end(callframe6040);
// compilenode returning call6043
// compilenode returning call6043
  *var_suggestion = call6043;
  if (call6043 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1921
  setline(1921);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6044 = gc_frame_new();
  if (strlit6045 == NULL) {
    strlit6045 = alloc_String(">");
    gc_root(strlit6045);
  }
// compilenode returning strlit6045
  gc_frame_newslot(strlit6045);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6045;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6046 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6044);
// compilenode returning call6046
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1922
  setline(1922);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6047 = gc_frame_new();
  int callframe6048 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6049 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6048);
// compilenode returning call6049
// compilenode returning call6049
  partcv[0] = 0;
  Object call6050 = callmethod(call6049, "new",
    1, partcv, params);
  gc_frame_end(callframe6047);
// compilenode returning call6050
// compilenode returning call6050
  *var_suggestion2 = call6050;
  if (call6050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6051 = gc_frame_new();
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String(" ");
    gc_root(strlit6052);
  }
// compilenode returning strlit6052
  gc_frame_newslot(strlit6052);
// compilenode returning *var_startToken
  gc_frame_newslot(*var_startToken);
// compilenode returning *var_suggestion2
  params[0] = strlit6052;
  params[1] = *var_startToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6053 = callmethod(*var_suggestion2, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe6051);
// compilenode returning call6053
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1924
  setline(1924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6054 = alloc_BuiltinList();
  gc_pause();
// compilenode returning *var_suggestion
  params[0] = *var_suggestion;
  partcv[0] = 1;
  callmethod(array6054, "push", 1, partcv, params);
// compilenode returning *var_suggestion2
  params[0] = *var_suggestion2;
  partcv[0] = 1;
  callmethod(array6054, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array6054
  *var_suggestions = array6054;
  if (array6054 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6055 = gc_frame_new();
  if (strlit6056 == NULL) {
    strlit6056 = alloc_String("A method request containing a '<' must have a matching '>', or the '<' operator must have a space before it.");
    gc_root(strlit6056);
  }
// compilenode returning strlit6056
  gc_frame_newslot(strlit6056);
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6057 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6058 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6057);
// compilenode returning call6058
// compilenode returning call6058
  gc_frame_newslot(call6058);
  int callframe6060 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6061 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6060);
// compilenode returning call6061
// compilenode returning call6061
  int op_slot_right_6059 = gc_frame_newslot(call6061);
  int callframe6063 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6064 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6063);
// compilenode returning call6064
// compilenode returning call6064
  int op_slot_left_6059 = gc_frame_newslot(call6064);
  params[0] = call6061;
  partcv[0] = 1;
  Object sum6065 = callmethod(call6064, "+", 1, partcv, params);
// compilenode returning sum6065
  gc_frame_newslot(sum6065);
// Begin line 1927
  setline(1927);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 1925
  setline(1925);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6056;
  params[1] = call6058;
  params[2] = sum6065;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6066 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6055);
// compilenode returning call6066
    gc_frame_newslot(call6066);
    if6033 = call6066;
  } else {
  }
// compilenode returning if6033
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6067 = gc_frame_new();
  partcv[0] = 0;
  Object call6068 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6067);
// compilenode returning call6068
    gc_frame_newslot(call6068);
    if5999 = call6068;
  } else {
  }
// compilenode returning if5999
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6070 = gc_frame_new();
  if (strlit6071 == NULL) {
    strlit6071 = alloc_String("lparen");
    gc_root(strlit6071);
  }
// compilenode returning strlit6071
  gc_frame_newslot(strlit6071);
  params[0] = strlit6071;
  partcv[0] = 1;
  Object call6072 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6070);
// compilenode returning call6072
  Object if6069 = done;
  if (istrue(call6072)) {
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6073 = gc_frame_new();
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6074 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6075 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6074);
// compilenode returning call6075
// compilenode returning call6075
  gc_frame_newslot(call6075);
// compilenode returning *var_part
  params[0] = call6075;
  partcv[0] = 1;
  Object call6076 = callmethod(*var_part, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6073);
// compilenode returning call6076
// compilenode returning done
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1932
  setline(1932);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6077 = gc_frame_new();
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6078 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6079 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6078);
// compilenode returning call6079
// compilenode returning call6079
  gc_frame_newslot(call6079);
// compilenode returning *var_part
  params[0] = call6079;
  partcv[0] = 1;
  Object call6080 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6077);
// compilenode returning call6080
// compilenode returning done
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1934
  setline(1934);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6082 = alloc_Boolean(1);
// compilenode returning bool6082
  *var_hadcall = bool6082;
  if (bool6082 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6084 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6085 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6084);
// compilenode returning call6085
// compilenode returning call6085
  *var_methn = call6085;
  if (call6085 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 1936
  setline(1936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6087 = gc_frame_new();
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methn
  gc_frame_newslot(*var_methn);
// compilenode returning *var_part
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call6088 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6087);
// compilenode returning call6088
// compilenode returning done
// Begin line 1938
  setline(1938);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6089 = gc_frame_new();
  partcv[0] = 0;
  Object call6090 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6089);
// compilenode returning call6090
// Begin line 1939
  setline(1939);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6091 = gc_frame_new();
  Object block6092 = alloc_Block(NULL, NULL, "parser", 1939);
  gc_frame_newslot(block6092);
  block_savedest(block6092);
  Object closure6093 = createclosure(1, "_apply");
setclosureframe(closure6093, stackframe);
  addtoclosure(closure6093, selfslot);
  struct UserObject *uo6093 = (struct UserObject*)block6092;
  uo6093->data[0] = (Object)closure6093;
  Method *meth_meth_parser__apply6093 = addmethod2pos(block6092, "_apply", &meth_parser__apply6093, 0);
int argcv_meth_parser__apply6093[] = {0};
meth_meth_parser__apply6093->type = alloc_MethodType(1, argcv_meth_parser__apply6093);
  meth_meth_parser__apply6093->definitionModule = modulename;
  meth_meth_parser__apply6093->definitionLine = 1936;
// compilenode returning block6092
  gc_frame_newslot(block6092);
  Object block6097 = alloc_Block(NULL, NULL, "parser", 1939);
  gc_frame_newslot(block6097);
  block_savedest(block6097);
  Object closure6098 = createclosure(7, "_apply");
setclosureframe(closure6098, stackframe);
  addtoclosure(closure6098, var_values);
  addtoclosure(closure6098, var_tmp);
  addtoclosure(closure6098, var_errormessages);
  addtoclosure(closure6098, var_sym);
  addtoclosure(closure6098, var_lastToken);
  addtoclosure(closure6098, var_part);
  addtoclosure(closure6098, selfslot);
  struct UserObject *uo6098 = (struct UserObject*)block6097;
  uo6098->data[0] = (Object)closure6098;
  Method *meth_meth_parser__apply6098 = addmethod2pos(block6097, "_apply", &meth_parser__apply6098, 0);
int argcv_meth_parser__apply6098[] = {0};
meth_meth_parser__apply6098->type = alloc_MethodType(1, argcv_meth_parser__apply6098);
  meth_meth_parser__apply6098->definitionModule = modulename;
  meth_meth_parser__apply6098->definitionLine = 1936;
// compilenode returning block6097
  gc_frame_newslot(block6097);
  params[0] = block6092;
  params[1] = block6097;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6443 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6091);
// compilenode returning call6443
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6446 == NULL) {
    strlit6446 = alloc_String("rparen");
    gc_root(strlit6446);
  }
// compilenode returning strlit6446
  int op_slot_right_6445 = gc_frame_newslot(strlit6446);
  int callframe6448 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6449 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6448);
// compilenode returning call6449
// compilenode returning call6449
  int op_slot_left_6445 = gc_frame_newslot(call6449);
  params[0] = strlit6446;
  partcv[0] = 1;
  Object opresult6450 = callmethod(call6449, "!=", 1, partcv, params);
// compilenode returning opresult6450
  Object if6444 = done;
  if (istrue(opresult6450)) {
// Begin line 2037
  setline(2037);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6451 = gc_frame_new();
  partcv[0] = 0;
  Object call6452 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6451);
// compilenode returning call6452
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6453 = gc_frame_new();
  int callframe6454 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6455 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6454);
// compilenode returning call6455
// compilenode returning call6455
  partcv[0] = 0;
  Object call6456 = callmethod(call6455, "new",
    1, partcv, params);
  gc_frame_end(callframe6453);
// compilenode returning call6456
// compilenode returning call6456
  *var_suggestion = call6456;
  if (call6456 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6457 = gc_frame_new();
  if (strlit6458 == NULL) {
    strlit6458 = alloc_String(")");
    gc_root(strlit6458);
  }
// compilenode returning strlit6458
  gc_frame_newslot(strlit6458);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6458;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6459 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6457);
// compilenode returning call6459
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6460 = gc_frame_new();
  if (strlit6461 == NULL) {
    strlit6461 = alloc_String("A method request beginning with a '(' must end with a ')'.");
    gc_root(strlit6461);
  }
// compilenode returning strlit6461
  gc_frame_newslot(strlit6461);
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6462 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6463 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe6462);
// compilenode returning call6463
// compilenode returning call6463
  gc_frame_newslot(call6463);
  int callframe6465 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6466 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe6465);
// compilenode returning call6466
// compilenode returning call6466
  int op_slot_right_6464 = gc_frame_newslot(call6466);
  int callframe6468 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call6469 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6468);
// compilenode returning call6469
// compilenode returning call6469
  int op_slot_left_6464 = gc_frame_newslot(call6469);
  params[0] = call6466;
  partcv[0] = 1;
  Object sum6470 = callmethod(call6469, "+", 1, partcv, params);
// compilenode returning sum6470
  gc_frame_newslot(sum6470);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2040
  setline(2040);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6461;
  params[1] = call6463;
  params[2] = sum6470;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6471 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6460);
// compilenode returning call6471
    gc_frame_newslot(call6471);
    if6444 = call6471;
  } else {
  }
// compilenode returning if6444
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6474 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6475 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe6474);
// compilenode returning call6475
// compilenode returning call6475
  int op_slot_right_6473 = gc_frame_newslot(call6475);
  int callframe6477 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6478 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6477);
// compilenode returning call6478
// compilenode returning call6478
  int op_slot_left_6473 = gc_frame_newslot(call6478);
  params[0] = call6475;
  partcv[0] = 1;
  Object opresult6479 = callmethod(call6478, "==", 1, partcv, params);
// compilenode returning opresult6479
  Object if6472 = done;
  if (istrue(opresult6479)) {
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2043
  setline(2043);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6480 = gc_frame_new();
// Begin line 2045
  setline(2045);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6482 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6483 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6482);
// compilenode returning call6483
// compilenode returning call6483
  int op_slot_right_6481 = gc_frame_newslot(call6483);
  int callframe6485 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6486 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6485);
// compilenode returning call6486
// compilenode returning call6486
  int op_slot_left_6481 = gc_frame_newslot(call6486);
  params[0] = call6483;
  partcv[0] = 1;
  Object diff6487 = callmethod(call6486, "-", 1, partcv, params);
// compilenode returning diff6487
  gc_frame_newslot(diff6487);
// compilenode returning *var_part
  params[0] = diff6487;
  partcv[0] = 1;
  Object call6488 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe6480);
// compilenode returning call6488
// compilenode returning done
    gc_frame_newslot(done);
    if6472 = done;
  } else {
  }
// compilenode returning if6472
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2046
  setline(2046);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  *var_ln = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2047
  setline(2047);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6490 = gc_frame_new();
  partcv[0] = 0;
  Object call6491 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6490);
// compilenode returning call6491
    gc_frame_newslot(call6491);
    if6069 = call6491;
  } else {
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2048
  setline(2048);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block6494 = alloc_Block(NULL, NULL, "parser", 2048);
  gc_frame_newslot(block6494);
  block_savedest(block6494);
  Object closure6495 = createclosure(2, "_apply");
setclosureframe(closure6495, stackframe);
  addtoclosure(closure6495, var_tok);
  addtoclosure(closure6495, selfslot);
  struct UserObject *uo6495 = (struct UserObject*)block6494;
  uo6495->data[0] = (Object)closure6495;
  Method *meth_meth_parser__apply6495 = addmethod2pos(block6494, "_apply", &meth_parser__apply6495, 0);
int argcv_meth_parser__apply6495[] = {0};
meth_meth_parser__apply6495->type = alloc_MethodType(1, argcv_meth_parser__apply6495);
  meth_meth_parser__apply6495->definitionModule = modulename;
  meth_meth_parser__apply6495->definitionLine = 2044;
// compilenode returning block6494
  int op_slot_right_6493 = gc_frame_newslot(block6494);
// compilenode returning *var_don_39_tTakeBlock
  int op_slot_left_6493 = gc_frame_newslot(*var_don_39_tTakeBlock);
  params[0] = block6494;
  partcv[0] = 1;
  Object opresult6501 = callmethod(*var_don_39_tTakeBlock, "&&", 1, partcv, params);
// compilenode returning opresult6501
  Object if6492 = done;
  if (istrue(opresult6501)) {
// Begin line 2049
  setline(2049);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6502 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6503 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6502);
// compilenode returning call6503
    gc_frame_newslot(call6503);
    if6492 = call6503;
  } else {
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2053
  setline(2053);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6509 == NULL) {
    strlit6509 = alloc_String("false");
    gc_root(strlit6509);
  }
// compilenode returning strlit6509
  int op_slot_right_6508 = gc_frame_newslot(strlit6509);
  int callframe6511 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6512 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6511);
// compilenode returning call6512
// compilenode returning call6512
  int op_slot_left_6508 = gc_frame_newslot(call6512);
  params[0] = strlit6509;
  partcv[0] = 1;
  Object opresult6513 = callmethod(call6512, "==", 1, partcv, params);
// compilenode returning opresult6513
  int op_slot_right_6507 = gc_frame_newslot(opresult6513);
// Begin line 2052
  setline(2052);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6516 == NULL) {
    strlit6516 = alloc_String("true");
    gc_root(strlit6516);
  }
// compilenode returning strlit6516
  int op_slot_right_6515 = gc_frame_newslot(strlit6516);
  int callframe6518 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6519 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6518);
// compilenode returning call6519
// compilenode returning call6519
  int op_slot_left_6515 = gc_frame_newslot(call6519);
  params[0] = strlit6516;
  partcv[0] = 1;
  Object opresult6520 = callmethod(call6519, "==", 1, partcv, params);
// compilenode returning opresult6520
  int op_slot_left_6507 = gc_frame_newslot(opresult6520);
  params[0] = opresult6513;
  partcv[0] = 1;
  Object opresult6521 = callmethod(opresult6520, "||", 1, partcv, params);
// compilenode returning opresult6521
  int op_slot_right_6506 = gc_frame_newslot(opresult6521);
  int callframe6523 = gc_frame_new();
  if (strlit6524 == NULL) {
    strlit6524 = alloc_String("identifier");
    gc_root(strlit6524);
  }
// compilenode returning strlit6524
  gc_frame_newslot(strlit6524);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6524;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6525 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6523);
// compilenode returning call6525
  int op_slot_left_6506 = gc_frame_newslot(call6525);
  params[0] = opresult6521;
  partcv[0] = 1;
  Object opresult6526 = callmethod(call6525, "&&", 1, partcv, params);
// compilenode returning opresult6526
  int op_slot_right_6505 = gc_frame_newslot(opresult6526);
// Begin line 2051
  setline(2051);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6529 = gc_frame_new();
  if (strlit6530 == NULL) {
    strlit6530 = alloc_String("lbrace");
    gc_root(strlit6530);
  }
// compilenode returning strlit6530
  gc_frame_newslot(strlit6530);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6530;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6531 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6529);
// compilenode returning call6531
  int op_slot_right_6528 = gc_frame_newslot(call6531);
// Begin line 2050
  setline(2050);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6534 = gc_frame_new();
  if (strlit6535 == NULL) {
    strlit6535 = alloc_String("num");
    gc_root(strlit6535);
  }
// compilenode returning strlit6535
  gc_frame_newslot(strlit6535);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6535;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6536 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6534);
// compilenode returning call6536
  int op_slot_right_6533 = gc_frame_newslot(call6536);
  int callframe6538 = gc_frame_new();
  if (strlit6539 == NULL) {
    strlit6539 = alloc_String("string");
    gc_root(strlit6539);
  }
// compilenode returning strlit6539
  gc_frame_newslot(strlit6539);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6539;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6540 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6538);
// compilenode returning call6540
  int op_slot_left_6533 = gc_frame_newslot(call6540);
  params[0] = call6536;
  partcv[0] = 1;
  Object opresult6541 = callmethod(call6540, "||", 1, partcv, params);
// compilenode returning opresult6541
  int op_slot_left_6528 = gc_frame_newslot(opresult6541);
  params[0] = call6531;
  partcv[0] = 1;
  Object opresult6542 = callmethod(opresult6541, "||", 1, partcv, params);
// compilenode returning opresult6542
  int op_slot_left_6505 = gc_frame_newslot(opresult6542);
  params[0] = opresult6526;
  partcv[0] = 1;
  Object opresult6543 = callmethod(opresult6542, "||", 1, partcv, params);
// compilenode returning opresult6543
  Object if6504 = done;
  if (istrue(opresult6543)) {
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2054
  setline(2054);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_tok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2055
  setline(2055);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6545 = alloc_Boolean(1);
// compilenode returning bool6545
  *var_hadcall = bool6545;
  if (bool6545 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6547 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6548 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6547);
// compilenode returning call6548
// compilenode returning call6548
  *var_methn = call6548;
  if (call6548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2056
  setline(2056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6550 = gc_frame_new();
// Begin line 2057
  setline(2057);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methn
  gc_frame_newslot(*var_methn);
// compilenode returning *var_part
  params[0] = *var_methn;
  partcv[0] = 1;
  Object call6551 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6550);
// compilenode returning call6551
// compilenode returning done
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2058
  setline(2058);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  *var_ln = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2059
  setline(2059);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6553 = gc_frame_new();
  partcv[0] = 0;
  Object call6554 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6553);
// compilenode returning call6554
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2060
  setline(2060);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6555 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6556 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6555);
// compilenode returning call6556
// compilenode returning call6556
  *var_ar = call6556;
  if (call6556 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2061
  setline(2061);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6557 = gc_frame_new();
// compilenode returning *var_ar
  gc_frame_newslot(*var_ar);
  int callframe6558 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6559 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6558);
// compilenode returning call6559
// compilenode returning call6559
  params[0] = *var_ar;
  partcv[0] = 1;
  Object call6560 = callmethod(call6559, "push",
    1, partcv, params);
  gc_frame_end(callframe6557);
// compilenode returning call6560
    gc_frame_newslot(call6560);
    if6504 = call6560;
  } else {
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2062
  setline(2062);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6563 == NULL) {
    strlit6563 = alloc_String("identifier");
    gc_root(strlit6563);
  }
// compilenode returning strlit6563
  int op_slot_right_6562 = gc_frame_newslot(strlit6563);
  int callframe6565 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6566 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6565);
// compilenode returning call6566
// compilenode returning call6566
  int op_slot_left_6562 = gc_frame_newslot(call6566);
  params[0] = strlit6563;
  partcv[0] = 1;
  Object opresult6567 = callmethod(call6566, "==", 1, partcv, params);
// compilenode returning opresult6567
  Object if6561 = done;
  if (istrue(opresult6567)) {
// Begin line 2063
  setline(2063);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6568 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6569 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6568);
// compilenode returning call6569
    gc_frame_newslot(call6569);
    if6561 = call6569;
  } else {
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2064
  setline(2064);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6572 == NULL) {
    strlit6572 = alloc_String("member");
    gc_root(strlit6572);
  }
// compilenode returning strlit6572
  int op_slot_right_6571 = gc_frame_newslot(strlit6572);
  int callframe6574 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6575 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6574);
// compilenode returning call6575
// compilenode returning call6575
  int op_slot_left_6571 = gc_frame_newslot(call6575);
  params[0] = strlit6572;
  partcv[0] = 1;
  Object opresult6576 = callmethod(call6575, "==", 1, partcv, params);
// compilenode returning opresult6576
  Object if6570 = done;
  if (istrue(opresult6576)) {
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2065
  setline(2065);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6577 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6578 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6577);
// compilenode returning call6578
// compilenode returning call6578
  *var_root = call6578;
  if (call6578 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2066
  setline(2066);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_meth
  *var_outroot = *var_meth;
  if (*var_meth == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2067
  setline(2067);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6579 = gc_frame_new();
  Object block6580 = alloc_Block(NULL, NULL, "parser", 2067);
  gc_frame_newslot(block6580);
  block_savedest(block6580);
  Object closure6581 = createclosure(2, "_apply");
setclosureframe(closure6581, stackframe);
  addtoclosure(closure6581, var_root);
  addtoclosure(closure6581, selfslot);
  struct UserObject *uo6581 = (struct UserObject*)block6580;
  uo6581->data[0] = (Object)closure6581;
  Method *meth_meth_parser__apply6581 = addmethod2pos(block6580, "_apply", &meth_parser__apply6581, 0);
int argcv_meth_parser__apply6581[] = {0};
meth_meth_parser__apply6581->type = alloc_MethodType(1, argcv_meth_parser__apply6581);
  meth_meth_parser__apply6581->definitionModule = modulename;
  meth_meth_parser__apply6581->definitionLine = 2065;
// compilenode returning block6580
  gc_frame_newslot(block6580);
  Object block6589 = alloc_Block(NULL, NULL, "parser", 2067);
  gc_frame_newslot(block6589);
  block_savedest(block6589);
  Object closure6590 = createclosure(3, "_apply");
setclosureframe(closure6590, stackframe);
  addtoclosure(closure6590, var_root);
  addtoclosure(closure6590, var_outroot);
  addtoclosure(closure6590, selfslot);
  struct UserObject *uo6590 = (struct UserObject*)block6589;
  uo6590->data[0] = (Object)closure6590;
  Method *meth_meth_parser__apply6590 = addmethod2pos(block6589, "_apply", &meth_parser__apply6590, 0);
int argcv_meth_parser__apply6590[] = {0};
meth_meth_parser__apply6590->type = alloc_MethodType(1, argcv_meth_parser__apply6590);
  meth_meth_parser__apply6590->definitionModule = modulename;
  meth_meth_parser__apply6590->definitionLine = 2067;
// compilenode returning block6589
  gc_frame_newslot(block6589);
  params[0] = block6580;
  params[1] = block6589;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6596 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6579);
// compilenode returning call6596
// Begin line 2076
  setline(2076);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2071
  setline(2071);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6599 == NULL) {
    strlit6599 = alloc_String("identifier");
    gc_root(strlit6599);
  }
// compilenode returning strlit6599
  int op_slot_right_6598 = gc_frame_newslot(strlit6599);
  int callframe6601 = gc_frame_new();
// compilenode returning *var_root
  partcv[0] = 0;
  Object call6602 = callmethod(*var_root, "kind",
    1, partcv, params);
  gc_frame_end(callframe6601);
// compilenode returning call6602
// compilenode returning call6602
  int op_slot_left_6598 = gc_frame_newslot(call6602);
  params[0] = strlit6599;
  partcv[0] = 1;
  Object opresult6603 = callmethod(call6602, "==", 1, partcv, params);
// compilenode returning opresult6603
  Object if6597 = done;
  if (istrue(opresult6603)) {
// Begin line 2072
  setline(2072);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6604 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6605 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6604);
// compilenode returning call6605
    gc_frame_newslot(call6605);
    if6597 = call6605;
  } else {
// Begin line 2074
  setline(2074);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6606 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6607 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6606);
// compilenode returning call6607
    gc_frame_newslot(call6607);
    if6597 = call6607;
  }
// compilenode returning if6597
    gc_frame_newslot(if6597);
    if6570 = if6597;
  } else {
// Begin line 2077
  setline(2077);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6608 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_values
  params[0] = *var_meth;
  partcv[0] = 1;
  Object call6609 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6608);
// compilenode returning call6609
    gc_frame_newslot(call6609);
    if6570 = call6609;
  }
// compilenode returning if6570
    gc_frame_newslot(if6570);
    if6561 = if6570;
  }
// compilenode returning if6561
    gc_frame_newslot(if6561);
    if6504 = if6561;
  }
// compilenode returning if6504
    gc_frame_newslot(if6504);
    if6492 = if6504;
  }
// compilenode returning if6492
    gc_frame_newslot(if6492);
    if6069 = if6492;
  }
// compilenode returning if6069
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2079
  setline(2079);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_hadcall
  Object if6610 = done;
  if (istrue(*var_hadcall)) {
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2080
  setline(2080);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6612 = gc_frame_new();
  if (strlit6613 == NULL) {
    strlit6613 = alloc_String("identifier");
    gc_root(strlit6613);
  }
// compilenode returning strlit6613
  gc_frame_newslot(strlit6613);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6613;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6614 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6612);
// compilenode returning call6614
  Object if6611 = done;
  if (istrue(call6614)) {
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6615 = gc_frame_new();
// compilenode returning *var_methn
  gc_frame_newslot(*var_methn);
  Object bool6616 = alloc_Boolean(0);
// compilenode returning bool6616
  gc_frame_newslot(bool6616);
  int callframe6617 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call6618 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe6617);
// compilenode returning call6618
// compilenode returning call6618
  params[0] = *var_methn;
  params[1] = bool6616;
  partcv[0] = 2;
  Object call6619 = callmethod(call6618, "new",
    1, partcv, params);
  gc_frame_end(callframe6615);
// compilenode returning call6619
  *var_meth_39_ = call6619;
  if (call6619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6620 = gc_frame_new();
// Begin line 2083
  setline(2083);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lnum
  gc_frame_newslot(*var_lnum);
// compilenode returning *var_meth_39_
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6621 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe6620);
// compilenode returning call6621
// compilenode returning done
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2082
  setline(2082);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6622 = gc_frame_new();
// Begin line 2084
  setline(2084);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lpos
  gc_frame_newslot(*var_lpos);
// compilenode returning *var_meth_39_
  params[0] = *var_lpos;
  partcv[0] = 1;
  Object call6623 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe6622);
// compilenode returning call6623
// compilenode returning done
// Begin line 2085
  setline(2085);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6624 = gc_frame_new();
// compilenode returning *var_meth_39_
  gc_frame_newslot(*var_meth_39_);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = *var_meth_39_;
  params[1] = *var_signature;
  params[2] = *var_tok;
  partcv[0] = 3;
  Object call6625 = callmethodflags(self, "callmprest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6624);
// compilenode returning call6625
  *var_methn = call6625;
  if (call6625 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2094
  setline(2094);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2086
  setline(2086);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6629 == NULL) {
    strlit6629 = alloc_String("member");
    gc_root(strlit6629);
  }
// compilenode returning strlit6629
  int op_slot_right_6628 = gc_frame_newslot(strlit6629);
  int callframe6631 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6632 = callmethod(*var_meth, "kind",
    1, partcv, params);
  gc_frame_end(callframe6631);
// compilenode returning call6632
// compilenode returning call6632
  int op_slot_left_6628 = gc_frame_newslot(call6632);
  params[0] = strlit6629;
  partcv[0] = 1;
  Object opresult6633 = callmethod(call6632, "==", 1, partcv, params);
// compilenode returning opresult6633
  Object if6627 = done;
  if (istrue(opresult6633)) {
// Begin line 2090
  setline(2090);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6634 = gc_frame_new();
  int callframe6635 = gc_frame_new();
// compilenode returning *var_methn
  partcv[0] = 0;
  Object call6636 = callmethod(*var_methn, "value",
    1, partcv, params);
  gc_frame_end(callframe6635);
// compilenode returning call6636
// compilenode returning call6636
  gc_frame_newslot(call6636);
  int callframe6637 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6638 = callmethod(*var_meth, "in",
    1, partcv, params);
  gc_frame_end(callframe6637);
// compilenode returning call6638
// compilenode returning call6638
  gc_frame_newslot(call6638);
  int callframe6639 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call6640 = callmethod(*var_ast, "memberNode",
    1, partcv, params);
  gc_frame_end(callframe6639);
// compilenode returning call6640
// compilenode returning call6640
  params[0] = call6636;
  params[1] = call6638;
  partcv[0] = 2;
  Object call6641 = callmethod(call6640, "new",
    1, partcv, params);
  gc_frame_end(callframe6634);
// compilenode returning call6641
  *var_meth = call6641;
  if (call6641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6627 = done;
  } else {
// Begin line 2093
  setline(2093);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2092
  setline(2092);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_methn
  *var_meth = *var_methn;
  if (*var_methn == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6627 = done;
  }
// compilenode returning if6627
    gc_frame_newslot(if6627);
    if6611 = if6627;
  } else {
  }
// compilenode returning if6611
// Begin line 2095
  setline(2095);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6644 = gc_frame_new();
// compilenode returning *var_lnum
  gc_frame_newslot(*var_lnum);
// compilenode returning *var_util
  params[0] = *var_lnum;
  partcv[0] = 1;
  Object call6645 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe6644);
// compilenode returning call6645
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6646 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
  int callframe6647 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call6648 = callmethod(*var_ast, "callNode",
    1, partcv, params);
  gc_frame_end(callframe6647);
// compilenode returning call6648
// compilenode returning call6648
  params[0] = *var_meth;
  params[1] = *var_signature;
  partcv[0] = 2;
  Object call6649 = callmethod(call6648, "new",
    1, partcv, params);
  gc_frame_end(callframe6646);
// compilenode returning call6649
  *var_tmp = call6649;
  if (call6649 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2096
  setline(2096);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6651 = gc_frame_new();
// Begin line 2097
  setline(2097);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_genericIdents
  gc_frame_newslot(*var_genericIdents);
// compilenode returning *var_tmp
  params[0] = *var_genericIdents;
  partcv[0] = 1;
  Object call6652 = callmethod(*var_tmp, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe6651);
// compilenode returning call6652
// compilenode returning done
// Begin line 2098
  setline(2098);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6653 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_values
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call6654 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe6653);
// compilenode returning call6654
    gc_frame_newslot(call6654);
    if6610 = call6654;
  } else {
  }
// compilenode returning if6610
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2100
  setline(2100);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_startInd
  *var_minIndentLevel = *var_startInd;
  if (*var_startInd == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2101
  setline(2101);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6656 = gc_frame_new();
  partcv[0] = 0;
  Object call6657 = callmethodflags(self, "dotrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6656);
// compilenode returning call6657
  gc_frame_end(frame);
  return call6657;
}
Object meth_parser__apply6665(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6667 = gc_frame_new();
  if (strlit6668 == NULL) {
    strlit6668 = alloc_String("identifier");
    gc_root(strlit6668);
  }
// compilenode returning strlit6668
  gc_frame_newslot(strlit6668);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  params[0] = strlit6668;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6669 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6667);
// compilenode returning call6669
  int op_slot_right_6666 = gc_frame_newslot(call6669);
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6671 = gc_frame_new();
  if (strlit6672 == NULL) {
    strlit6672 = alloc_String("identifier");
    gc_root(strlit6672);
  }
// compilenode returning strlit6672
  gc_frame_newslot(strlit6672);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6672;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6673 = callmethodflags(self, "accept()onLineOf", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6671);
// compilenode returning call6673
  int op_slot_left_6666 = gc_frame_newslot(call6673);
  params[0] = call6669;
  partcv[0] = 1;
  Object opresult6674 = callmethod(call6673, "||", 1, partcv, params);
// compilenode returning opresult6674
  gc_frame_end(frame);
  return opresult6674;
}
Object meth_parser__apply6898(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6899 = gc_frame_new();
  partcv[0] = 0;
  Object call6900 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6899);
// compilenode returning call6900
  gc_frame_end(frame);
  return call6900;
}
Object meth_parser__apply6950(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6951 = gc_frame_new();
  if (strlit6952 == NULL) {
    strlit6952 = alloc_String("comma");
    gc_root(strlit6952);
  }
// compilenode returning strlit6952
  gc_frame_newslot(strlit6952);
  params[0] = strlit6952;
  partcv[0] = 1;
  Object call6953 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6951);
// compilenode returning call6953
  gc_frame_end(frame);
  return call6953;
}
Object meth_parser__apply6970(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe6971 = gc_frame_new();
  partcv[0] = 0;
  Object call6972 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6971);
// compilenode returning call6972
  gc_frame_end(frame);
  return call6972;
}
Object meth_parser__apply6956(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_nxt = getfromclosure(closure, 1);
  Object *var_part = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2192
  setline(2192);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6957 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6958 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6957);
// compilenode returning call6958
// compilenode returning call6958
  *var_nxt = call6958;
  if (call6958 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2193
  setline(2193);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6960 = gc_frame_new();
// compilenode returning *var_nxt
  gc_frame_newslot(*var_nxt);
  int callframe6961 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call6962 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe6961);
// compilenode returning call6962
// compilenode returning call6962
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call6963 = callmethod(call6962, "push",
    1, partcv, params);
  gc_frame_end(callframe6960);
// compilenode returning call6963
// Begin line 2194
  setline(2194);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6964 = gc_frame_new();
  partcv[0] = 0;
  Object call6965 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6964);
// compilenode returning call6965
// Begin line 2211
  setline(2211);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2195
  setline(2195);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6967 = gc_frame_new();
  int callframe6968 = gc_frame_new();
  Object block6969 = alloc_Block(NULL, NULL, "parser", 2195);
  gc_frame_newslot(block6969);
  block_savedest(block6969);
  Object closure6970 = createclosure(1, "_apply");
setclosureframe(closure6970, stackframe);
  addtoclosure(closure6970, selfslot);
  struct UserObject *uo6970 = (struct UserObject*)block6969;
  uo6970->data[0] = (Object)closure6970;
  Method *meth_meth_parser__apply6970 = addmethod2pos(block6969, "_apply", &meth_parser__apply6970, 0);
int argcv_meth_parser__apply6970[] = {0};
meth_meth_parser__apply6970->type = alloc_MethodType(1, argcv_meth_parser__apply6970);
  meth_meth_parser__apply6970->definitionModule = modulename;
  meth_meth_parser__apply6970->definitionLine = 2195;
// compilenode returning block6969
  gc_frame_newslot(block6969);
  params[0] = block6969;
  partcv[0] = 1;
  Object call6974 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6968);
// compilenode returning call6974
  partcv[0] = 0;
  Object call6975 = callmethod(call6974, "not",
    1, partcv, params);
  gc_frame_end(callframe6967);
// compilenode returning call6975
// compilenode returning call6975
  Object if6966 = done;
  if (istrue(call6975)) {
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2196
  setline(2196);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6976 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array6976
  *var_suggestions = array6976;
  if (array6976 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2197
  setline(2197);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6977 = gc_frame_new();
  int callframe6978 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6979 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6978);
// compilenode returning call6979
// compilenode returning call6979
  partcv[0] = 0;
  Object call6980 = callmethod(call6979, "new",
    1, partcv, params);
  gc_frame_end(callframe6977);
// compilenode returning call6980
// compilenode returning call6980
  *var_suggestion = call6980;
  if (call6980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2198
  setline(2198);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6981 = gc_frame_new();
  if (strlit6982 == NULL) {
    strlit6982 = alloc_String("rparen");
    gc_root(strlit6982);
  }
// compilenode returning strlit6982
  gc_frame_newslot(strlit6982);
  params[0] = strlit6982;
  partcv[0] = 1;
  Object call6983 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6981);
// compilenode returning call6983
  *var_nextTok = call6983;
  if (call6983 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2199
  setline(2199);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_6985 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_6985 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6987 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult6987
  Object if6984 = done;
  if (istrue(opresult6987)) {
// Begin line 2200
  setline(2200);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6988 = gc_frame_new();
  if (strlit6989 == NULL) {
    strlit6989 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6989);
  }
// compilenode returning strlit6989
  gc_frame_newslot(strlit6989);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6989;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6990 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6988);
// compilenode returning call6990
    gc_frame_newslot(call6990);
    if6984 = call6990;
  } else {
// Begin line 2202
  setline(2202);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6991 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6992 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6993 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6992);
// compilenode returning call6993
// compilenode returning call6993
  gc_frame_newslot(call6993);
  Object bool6994 = alloc_Boolean(1);
// compilenode returning bool6994
  gc_frame_newslot(bool6994);
  Object bool6995 = alloc_Boolean(0);
// compilenode returning bool6995
  gc_frame_newslot(bool6995);
  if (strlit6996 == NULL) {
    strlit6996 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6996);
  }
// compilenode returning strlit6996
  gc_frame_newslot(strlit6996);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6993;
  params[2] = bool6994;
  params[3] = bool6995;
  params[4] = strlit6996;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6997 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6991);
// compilenode returning call6997
    gc_frame_newslot(call6997);
    if6984 = call6997;
  }
// compilenode returning if6984
// Begin line 2204
  setline(2204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6998 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6999 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6998);
// compilenode returning call6999
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2205
  setline(2205);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7000 = gc_frame_new();
  int callframe7001 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7002 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7001);
// compilenode returning call7002
// compilenode returning call7002
  partcv[0] = 0;
  Object call7003 = callmethod(call7002, "new",
    1, partcv, params);
  gc_frame_end(callframe7000);
// compilenode returning call7003
// compilenode returning call7003
  *var_suggestion = call7003;
  if (call7003 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2206
  setline(2206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7005 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe7006 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7007 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7006);
// compilenode returning call7007
// compilenode returning call7007
  gc_frame_newslot(call7007);
  Object bool7008 = alloc_Boolean(1);
// compilenode returning bool7008
  gc_frame_newslot(bool7008);
  Object bool7009 = alloc_Boolean(0);
// compilenode returning bool7009
  gc_frame_newslot(bool7009);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call7007;
  params[2] = bool7008;
  params[3] = bool7009;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7010 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7005);
// compilenode returning call7010
// Begin line 2207
  setline(2207);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7011 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7012 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7011);
// compilenode returning call7012
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7013 = gc_frame_new();
  if (strlit7014 == NULL) {
    strlit7014 = alloc_String("A method request must have an expression after a ','.");
    gc_root(strlit7014);
  }
// compilenode returning strlit7014
  gc_frame_newslot(strlit7014);
// Begin line 2209
  setline(2209);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7015 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7016 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7015);
// compilenode returning call7016
// compilenode returning call7016
  gc_frame_newslot(call7016);
  int callframe7017 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7018 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7017);
// compilenode returning call7018
// compilenode returning call7018
  gc_frame_newslot(call7018);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2208
  setline(2208);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7014;
  params[1] = call7016;
  params[2] = call7018;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7019 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7013);
// compilenode returning call7019
    gc_frame_newslot(call7019);
    if6966 = call7019;
  } else {
  }
// compilenode returning if6966
  gc_frame_end(frame);
  return if6966;
}
Object meth_parser__apply6677(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_part = getfromclosure(closure, 1);
  Object *var_signature = getfromclosure(closure, 2);
  Object *var_methname = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_nxt = getfromclosure(closure, 5);
  Object *var_errormessages = getfromclosure(closure, 6);
  Object *var_sym = getfromclosure(closure, 7);
  Object *var_lastToken = getfromclosure(closure, 8);
  Object *var_tok = getfromclosure(closure, 9);
  Object *var_lastline = getfromclosure(closure, 10);
  Object *var_ln = getfromclosure(closure, 11);
  Object self = *(getfromclosure(closure, 12));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_isTerm = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "isTerm");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_isEmpty = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "isEmpty");
  Object *var_suggestions = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestions");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2117
  setline(2117);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6678 = gc_frame_new();
  int callframe6679 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call6680 = callmethod(*var_ast, "callWithPart",
    1, partcv, params);
  gc_frame_end(callframe6679);
// compilenode returning call6680
// compilenode returning call6680
  partcv[0] = 0;
  Object call6681 = callmethod(call6680, "new",
    1, partcv, params);
  gc_frame_end(callframe6678);
// compilenode returning call6681
// compilenode returning call6681
  *var_part = call6681;
  if (call6681 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2118
  setline(2118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6683 = gc_frame_new();
// compilenode returning *var_part
  gc_frame_newslot(*var_part);
// compilenode returning *var_signature
  params[0] = *var_part;
  partcv[0] = 1;
  Object call6684 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe6683);
// compilenode returning call6684
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2119
  setline(2119);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6686 == NULL) {
    strlit6686 = alloc_String("()");
    gc_root(strlit6686);
  }
// compilenode returning strlit6686
  int op_slot_right_6685 = gc_frame_newslot(strlit6686);
// compilenode returning *var_methname
  int op_slot_left_6685 = gc_frame_newslot(*var_methname);
  params[0] = strlit6686;
  partcv[0] = 1;
  Object opresult6688 = callmethod(*var_methname, "++", 1, partcv, params);
// compilenode returning opresult6688
  *var_methname = opresult6688;
  if (opresult6688 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2120
  setline(2120);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6690 = gc_frame_new();
  partcv[0] = 0;
  Object call6691 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6690);
// compilenode returning call6691
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2121
  setline(2121);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6692 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call6693 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe6692);
// compilenode returning call6693
// compilenode returning call6693
  *var_nxt = call6693;
  if (call6693 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6696 = gc_frame_new();
// compilenode returning *var_nxt
  partcv[0] = 0;
  Object call6697 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6696);
// compilenode returning call6697
// compilenode returning call6697
  int op_slot_right_6695 = gc_frame_newslot(call6697);
// compilenode returning *var_methname
  int op_slot_left_6695 = gc_frame_newslot(*var_methname);
  params[0] = call6697;
  partcv[0] = 1;
  Object opresult6699 = callmethod(*var_methname, "++", 1, partcv, params);
// compilenode returning opresult6699
  *var_methname = opresult6699;
  if (opresult6699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2122
  setline(2122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6701 = gc_frame_new();
// Begin line 2123
  setline(2123);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6702 = gc_frame_new();
// compilenode returning *var_nxt
  partcv[0] = 0;
  Object call6703 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe6702);
// compilenode returning call6703
// compilenode returning call6703
  gc_frame_newslot(call6703);
// compilenode returning *var_part
  params[0] = call6703;
  partcv[0] = 1;
  Object call6704 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe6701);
// compilenode returning call6704
// compilenode returning done
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2124
  setline(2124);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6705 = alloc_Boolean(0);
// compilenode returning bool6705
  *var_isTerm = bool6705;
  if (bool6705 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2126
  setline(2126);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6708 = gc_frame_new();
  int callframe6709 = gc_frame_new();
  if (strlit6710 == NULL) {
    strlit6710 = alloc_String("num");
    gc_root(strlit6710);
  }
// compilenode returning strlit6710
  gc_frame_newslot(strlit6710);
  params[0] = strlit6710;
  partcv[0] = 1;
  Object call6711 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6709);
// compilenode returning call6711
  partcv[0] = 0;
  Object call6712 = callmethod(call6711, "not",
    1, partcv, params);
  gc_frame_end(callframe6708);
// compilenode returning call6712
// compilenode returning call6712
  int op_slot_right_6707 = gc_frame_newslot(call6712);
  int callframe6715 = gc_frame_new();
  int callframe6716 = gc_frame_new();
  if (strlit6717 == NULL) {
    strlit6717 = alloc_String("string");
    gc_root(strlit6717);
  }
// compilenode returning strlit6717
  gc_frame_newslot(strlit6717);
  params[0] = strlit6717;
  partcv[0] = 1;
  Object call6718 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6716);
// compilenode returning call6718
  partcv[0] = 0;
  Object call6719 = callmethod(call6718, "not",
    1, partcv, params);
  gc_frame_end(callframe6715);
// compilenode returning call6719
// compilenode returning call6719
  int op_slot_right_6714 = gc_frame_newslot(call6719);
// Begin line 2125
  setline(2125);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6722 = gc_frame_new();
  int callframe6723 = gc_frame_new();
  if (strlit6724 == NULL) {
    strlit6724 = alloc_String("lbrace");
    gc_root(strlit6724);
  }
// compilenode returning strlit6724
  gc_frame_newslot(strlit6724);
  params[0] = strlit6724;
  partcv[0] = 1;
  Object call6725 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6723);
// compilenode returning call6725
  partcv[0] = 0;
  Object call6726 = callmethod(call6725, "not",
    1, partcv, params);
  gc_frame_end(callframe6722);
// compilenode returning call6726
// compilenode returning call6726
  int op_slot_right_6721 = gc_frame_newslot(call6726);
  int callframe6728 = gc_frame_new();
  int callframe6729 = gc_frame_new();
  if (strlit6730 == NULL) {
    strlit6730 = alloc_String("lparen");
    gc_root(strlit6730);
  }
// compilenode returning strlit6730
  gc_frame_newslot(strlit6730);
  params[0] = strlit6730;
  partcv[0] = 1;
  Object call6731 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6729);
// compilenode returning call6731
  partcv[0] = 0;
  Object call6732 = callmethod(call6731, "not",
    1, partcv, params);
  gc_frame_end(callframe6728);
// compilenode returning call6732
// compilenode returning call6732
  int op_slot_left_6721 = gc_frame_newslot(call6732);
  params[0] = call6726;
  partcv[0] = 1;
  Object opresult6733 = callmethod(call6732, "&&", 1, partcv, params);
// compilenode returning opresult6733
  int op_slot_left_6714 = gc_frame_newslot(opresult6733);
  params[0] = call6719;
  partcv[0] = 1;
  Object opresult6734 = callmethod(opresult6733, "&&", 1, partcv, params);
// compilenode returning opresult6734
  int op_slot_left_6707 = gc_frame_newslot(opresult6734);
  params[0] = call6712;
  partcv[0] = 1;
  Object opresult6735 = callmethod(opresult6734, "&&", 1, partcv, params);
// compilenode returning opresult6735
  Object if6706 = done;
  if (istrue(opresult6735)) {
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2127
  setline(2127);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6736 = gc_frame_new();
  int callframe6737 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6738 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6737);
// compilenode returning call6738
// compilenode returning call6738
  partcv[0] = 0;
  Object call6739 = callmethod(call6738, "new",
    1, partcv, params);
  gc_frame_end(callframe6736);
// compilenode returning call6739
// compilenode returning call6739
  *var_suggestion = call6739;
  if (call6739 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2154
  setline(2154);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2128
  setline(2128);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6742 == NULL) {
    strlit6742 = alloc_String("identifier");
    gc_root(strlit6742);
  }
// compilenode returning strlit6742
  int op_slot_right_6741 = gc_frame_newslot(strlit6742);
  int callframe6744 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6745 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6744);
// compilenode returning call6745
// compilenode returning call6745
  int op_slot_left_6741 = gc_frame_newslot(call6745);
  params[0] = strlit6742;
  partcv[0] = 1;
  Object opresult6746 = callmethod(call6745, "==", 1, partcv, params);
// compilenode returning opresult6746
  Object if6740 = done;
  if (istrue(opresult6746)) {
// Begin line 2129
  setline(2129);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6747 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool6748 = alloc_Boolean(1);
// compilenode returning bool6748
  gc_frame_newslot(bool6748);
  Object bool6749 = alloc_Boolean(0);
// compilenode returning bool6749
  gc_frame_newslot(bool6749);
  if (strlit6751 == NULL) {
    strlit6751 = alloc_String(")");
    gc_root(strlit6751);
  }
// compilenode returning strlit6751
  int op_slot_right_6750 = gc_frame_newslot(strlit6751);
  int callframe6754 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6755 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6754);
// compilenode returning call6755
// compilenode returning call6755
  int op_slot_right_6753 = gc_frame_newslot(call6755);
  if (strlit6757 == NULL) {
    strlit6757 = alloc_String("(");
    gc_root(strlit6757);
  }
// compilenode returning strlit6757
  int op_slot_left_6753 = gc_frame_newslot(strlit6757);
  params[0] = call6755;
  partcv[0] = 1;
  Object opresult6758 = callmethod(strlit6757, "++", 1, partcv, params);
// compilenode returning opresult6758
  int op_slot_left_6750 = gc_frame_newslot(opresult6758);
  params[0] = strlit6751;
  partcv[0] = 1;
  Object opresult6759 = callmethod(opresult6758, "++", 1, partcv, params);
// compilenode returning opresult6759
  gc_frame_newslot(opresult6759);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool6748;
  params[2] = bool6749;
  params[3] = opresult6759;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6760 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6747);
// compilenode returning call6760
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2130
  setline(2130);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6763 == NULL) {
    strlit6763 = alloc_String("while()do");
    gc_root(strlit6763);
  }
// compilenode returning strlit6763
  int op_slot_right_6762 = gc_frame_newslot(strlit6763);
// compilenode returning *var_methname
  int op_slot_left_6762 = gc_frame_newslot(*var_methname);
  params[0] = strlit6763;
  partcv[0] = 1;
  Object opresult6765 = callmethod(*var_methname, "==", 1, partcv, params);
// compilenode returning opresult6765
  Object if6761 = done;
  if (istrue(opresult6765)) {
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6766 = gc_frame_new();
  if (strlit6767 == NULL) {
    strlit6767 = alloc_String("A while loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6767);
  }
// compilenode returning strlit6767
  gc_frame_newslot(strlit6767);
// Begin line 2132
  setline(2132);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6768 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6769 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6768);
// compilenode returning call6769
// compilenode returning call6769
  gc_frame_newslot(call6769);
  int callframe6770 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6771 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6770);
// compilenode returning call6771
// compilenode returning call6771
  gc_frame_newslot(call6771);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2131
  setline(2131);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6767;
  params[1] = call6769;
  params[2] = call6771;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6772 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6766);
// compilenode returning call6772
    gc_frame_newslot(call6772);
    if6761 = call6772;
  } else {
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2133
  setline(2133);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6775 == NULL) {
    strlit6775 = alloc_String("for()do");
    gc_root(strlit6775);
  }
// compilenode returning strlit6775
  int op_slot_right_6774 = gc_frame_newslot(strlit6775);
// compilenode returning *var_methname
  int op_slot_left_6774 = gc_frame_newslot(*var_methname);
  params[0] = strlit6775;
  partcv[0] = 1;
  Object opresult6777 = callmethod(*var_methname, "==", 1, partcv, params);
// compilenode returning opresult6777
  Object if6773 = done;
  if (istrue(opresult6777)) {
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6778 = gc_frame_new();
  if (strlit6779 == NULL) {
    strlit6779 = alloc_String("A for loop must have either a loop body in braces, or a block in parentheses.");
    gc_root(strlit6779);
  }
// compilenode returning strlit6779
  gc_frame_newslot(strlit6779);
// Begin line 2135
  setline(2135);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6780 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6781 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6780);
// compilenode returning call6781
// compilenode returning call6781
  gc_frame_newslot(call6781);
  int callframe6782 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6783 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6782);
// compilenode returning call6783
// compilenode returning call6783
  gc_frame_newslot(call6783);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2134
  setline(2134);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6779;
  params[1] = call6781;
  params[2] = call6783;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6784 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6778);
// compilenode returning call6784
    gc_frame_newslot(call6784);
    if6773 = call6784;
  } else {
  }
// compilenode returning if6773
    gc_frame_newslot(if6773);
    if6761 = if6773;
  }
// compilenode returning if6761
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6785 = gc_frame_new();
  if (strlit6786 == NULL) {
    strlit6786 = alloc_String("A multi-part method request must have parentheses around each part of the method.");
    gc_root(strlit6786);
  }
// compilenode returning strlit6786
  gc_frame_newslot(strlit6786);
// Begin line 2138
  setline(2138);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6787 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6788 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6787);
// compilenode returning call6788
// compilenode returning call6788
  gc_frame_newslot(call6788);
  int callframe6789 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6790 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6789);
// compilenode returning call6790
// compilenode returning call6790
  gc_frame_newslot(call6790);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2137
  setline(2137);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6786;
  params[1] = call6788;
  params[2] = call6790;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6791 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6785);
// compilenode returning call6791
    gc_frame_newslot(call6791);
    if6740 = call6791;
  } else {
// Begin line 2153
  setline(2153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2140
  setline(2140);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6794 == NULL) {
    strlit6794 = alloc_String("while()do");
    gc_root(strlit6794);
  }
// compilenode returning strlit6794
  int op_slot_right_6793 = gc_frame_newslot(strlit6794);
// compilenode returning *var_methname
  int op_slot_left_6793 = gc_frame_newslot(*var_methname);
  params[0] = strlit6794;
  partcv[0] = 1;
  Object opresult6796 = callmethod(*var_methname, "==", 1, partcv, params);
// compilenode returning opresult6796
  Object if6792 = done;
  if (istrue(opresult6796)) {
// Begin line 2141
  setline(2141);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6797 = gc_frame_new();
  if (strlit6798 == NULL) {
    strlit6798 = alloc_String(" {}");
    gc_root(strlit6798);
  }
// compilenode returning strlit6798
  gc_frame_newslot(strlit6798);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6798;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6799 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6797);
// compilenode returning call6799
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6800 = gc_frame_new();
  if (strlit6801 == NULL) {
    strlit6801 = alloc_String("A while loop must have a body.");
    gc_root(strlit6801);
  }
// compilenode returning strlit6801
  gc_frame_newslot(strlit6801);
// Begin line 2143
  setline(2143);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6802 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6803 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6802);
// compilenode returning call6803
// compilenode returning call6803
  gc_frame_newslot(call6803);
  int callframe6804 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6805 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6804);
// compilenode returning call6805
// compilenode returning call6805
  gc_frame_newslot(call6805);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2142
  setline(2142);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6801;
  params[1] = call6803;
  params[2] = call6805;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6806 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6800);
// compilenode returning call6806
    gc_frame_newslot(call6806);
    if6792 = call6806;
  } else {
// Begin line 2148
  setline(2148);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2144
  setline(2144);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6809 == NULL) {
    strlit6809 = alloc_String("for()do");
    gc_root(strlit6809);
  }
// compilenode returning strlit6809
  int op_slot_right_6808 = gc_frame_newslot(strlit6809);
// compilenode returning *var_methname
  int op_slot_left_6808 = gc_frame_newslot(*var_methname);
  params[0] = strlit6809;
  partcv[0] = 1;
  Object opresult6811 = callmethod(*var_methname, "==", 1, partcv, params);
// compilenode returning opresult6811
  Object if6807 = done;
  if (istrue(opresult6811)) {
// Begin line 2145
  setline(2145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6812 = gc_frame_new();
  if (strlit6813 == NULL) {
    strlit6813 = alloc_String(" {}");
    gc_root(strlit6813);
  }
// compilenode returning strlit6813
  gc_frame_newslot(strlit6813);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6813;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6814 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6812);
// compilenode returning call6814
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6815 = gc_frame_new();
  if (strlit6816 == NULL) {
    strlit6816 = alloc_String("A for loop must have a body.");
    gc_root(strlit6816);
  }
// compilenode returning strlit6816
  gc_frame_newslot(strlit6816);
// Begin line 2147
  setline(2147);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6817 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6818 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6817);
// compilenode returning call6818
// compilenode returning call6818
  gc_frame_newslot(call6818);
  int callframe6819 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6820 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6819);
// compilenode returning call6820
// compilenode returning call6820
  gc_frame_newslot(call6820);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2146
  setline(2146);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6816;
  params[1] = call6818;
  params[2] = call6820;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6821 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6815);
// compilenode returning call6821
    gc_frame_newslot(call6821);
    if6807 = call6821;
  } else {
// Begin line 2149
  setline(2149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6822 = gc_frame_new();
  if (strlit6823 == NULL) {
    strlit6823 = alloc_String("()");
    gc_root(strlit6823);
  }
// compilenode returning strlit6823
  gc_frame_newslot(strlit6823);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6823;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6824 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6822);
// compilenode returning call6824
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6825 = gc_frame_new();
  if (strlit6826 == NULL) {
    strlit6826 = alloc_String("A multi-part method request must end with '()'.");
    gc_root(strlit6826);
  }
// compilenode returning strlit6826
  gc_frame_newslot(strlit6826);
// Begin line 2151
  setline(2151);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6827 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6828 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6827);
// compilenode returning call6828
// compilenode returning call6828
  gc_frame_newslot(call6828);
  int callframe6829 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6830 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6829);
// compilenode returning call6830
// compilenode returning call6830
  gc_frame_newslot(call6830);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2150
  setline(2150);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6826;
  params[1] = call6828;
  params[2] = call6830;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6831 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe6825);
// compilenode returning call6831
    gc_frame_newslot(call6831);
    if6807 = call6831;
  }
// compilenode returning if6807
    gc_frame_newslot(if6807);
    if6792 = if6807;
  }
// compilenode returning if6792
    gc_frame_newslot(if6792);
    if6740 = if6792;
  }
// compilenode returning if6740
    gc_frame_newslot(if6740);
    if6706 = if6740;
  } else {
  }
// compilenode returning if6706
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2160
  setline(2160);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6837 == NULL) {
    strlit6837 = alloc_String("false");
    gc_root(strlit6837);
  }
// compilenode returning strlit6837
  int op_slot_right_6836 = gc_frame_newslot(strlit6837);
  int callframe6839 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6840 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6839);
// compilenode returning call6840
// compilenode returning call6840
  int op_slot_left_6836 = gc_frame_newslot(call6840);
  params[0] = strlit6837;
  partcv[0] = 1;
  Object opresult6841 = callmethod(call6840, "==", 1, partcv, params);
// compilenode returning opresult6841
  int op_slot_right_6835 = gc_frame_newslot(opresult6841);
// Begin line 2159
  setline(2159);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6844 == NULL) {
    strlit6844 = alloc_String("true");
    gc_root(strlit6844);
  }
// compilenode returning strlit6844
  int op_slot_right_6843 = gc_frame_newslot(strlit6844);
  int callframe6846 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6847 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe6846);
// compilenode returning call6847
// compilenode returning call6847
  int op_slot_left_6843 = gc_frame_newslot(call6847);
  params[0] = strlit6844;
  partcv[0] = 1;
  Object opresult6848 = callmethod(call6847, "==", 1, partcv, params);
// compilenode returning opresult6848
  int op_slot_left_6835 = gc_frame_newslot(opresult6848);
  params[0] = opresult6841;
  partcv[0] = 1;
  Object opresult6849 = callmethod(opresult6848, "||", 1, partcv, params);
// compilenode returning opresult6849
  int op_slot_right_6834 = gc_frame_newslot(opresult6849);
// Begin line 2158
  setline(2158);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6851 = gc_frame_new();
  if (strlit6852 == NULL) {
    strlit6852 = alloc_String("identifier");
    gc_root(strlit6852);
  }
// compilenode returning strlit6852
  gc_frame_newslot(strlit6852);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6852;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6853 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6851);
// compilenode returning call6853
  int op_slot_left_6834 = gc_frame_newslot(call6853);
  params[0] = opresult6849;
  partcv[0] = 1;
  Object opresult6854 = callmethod(call6853, "&&", 1, partcv, params);
// compilenode returning opresult6854
  int op_slot_right_6833 = gc_frame_newslot(opresult6854);
// Begin line 2157
  setline(2157);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6857 = gc_frame_new();
  if (strlit6858 == NULL) {
    strlit6858 = alloc_String("num");
    gc_root(strlit6858);
  }
// compilenode returning strlit6858
  gc_frame_newslot(strlit6858);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6858;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6859 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6857);
// compilenode returning call6859
  int op_slot_right_6856 = gc_frame_newslot(call6859);
// Begin line 2156
  setline(2156);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6862 = gc_frame_new();
  if (strlit6863 == NULL) {
    strlit6863 = alloc_String("string");
    gc_root(strlit6863);
  }
// compilenode returning strlit6863
  gc_frame_newslot(strlit6863);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6863;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6864 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6862);
// compilenode returning call6864
  int op_slot_right_6861 = gc_frame_newslot(call6864);
// Begin line 2155
  setline(2155);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6866 = gc_frame_new();
  if (strlit6867 == NULL) {
    strlit6867 = alloc_String("lbrace");
    gc_root(strlit6867);
  }
// compilenode returning strlit6867
  gc_frame_newslot(strlit6867);
// compilenode returning *var_tok
  gc_frame_newslot(*var_tok);
  params[0] = strlit6867;
  params[1] = *var_tok;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6868 = callmethodflags(self, "accept()onLineOfLastOr", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6866);
// compilenode returning call6868
  int op_slot_left_6861 = gc_frame_newslot(call6868);
  params[0] = call6864;
  partcv[0] = 1;
  Object opresult6869 = callmethod(call6868, "||", 1, partcv, params);
// compilenode returning opresult6869
  int op_slot_left_6856 = gc_frame_newslot(opresult6869);
  params[0] = call6859;
  partcv[0] = 1;
  Object opresult6870 = callmethod(opresult6869, "||", 1, partcv, params);
// compilenode returning opresult6870
  int op_slot_left_6833 = gc_frame_newslot(opresult6870);
  params[0] = opresult6854;
  partcv[0] = 1;
  Object opresult6871 = callmethod(opresult6870, "||", 1, partcv, params);
// compilenode returning opresult6871
  Object if6832 = done;
  if (istrue(opresult6871)) {
// Begin line 2162
  setline(2162);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2161
  setline(2161);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6872 = alloc_Boolean(1);
// compilenode returning bool6872
  *var_isTerm = bool6872;
  if (bool6872 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6832 = done;
  } else {
// Begin line 2163
  setline(2163);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6874 = gc_frame_new();
  partcv[0] = 0;
  Object call6875 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6874);
// compilenode returning call6875
    gc_frame_newslot(call6875);
    if6832 = call6875;
  }
// compilenode returning if6832
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2165
  setline(2165);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6876 = alloc_Boolean(0);
// compilenode returning bool6876
  *var_isEmpty = bool6876;
  if (bool6876 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2166
  setline(2166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6878 = gc_frame_new();
  if (strlit6879 == NULL) {
    strlit6879 = alloc_String("rparen");
    gc_root(strlit6879);
  }
// compilenode returning strlit6879
  gc_frame_newslot(strlit6879);
  params[0] = strlit6879;
  partcv[0] = 1;
  Object call6880 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6878);
// compilenode returning call6880
  Object if6877 = done;
  if (istrue(call6880)) {
// Begin line 2168
  setline(2168);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2167
  setline(2167);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool6881 = alloc_Boolean(1);
// compilenode returning bool6881
  *var_isEmpty = bool6881;
  if (bool6881 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if6877 = done;
  } else {
  }
// compilenode returning if6877
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2169
  setline(2169);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_isTerm
  Object if6883 = done;
  if (istrue(*var_isTerm)) {
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2170
  setline(2170);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastline
  *var_ln = *var_lastline;
  if (*var_lastline == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2171
  setline(2171);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6885 = gc_frame_new();
  partcv[0] = 0;
  Object call6886 = callmethodflags(self, "term", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6885);
// compilenode returning call6886
    gc_frame_newslot(call6886);
    if6883 = call6886;
  } else {
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2173
  setline(2173);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit6889 == NULL) {
    strlit6889 = alloc_String("rparen");
    gc_root(strlit6889);
  }
// compilenode returning strlit6889
  int op_slot_right_6888 = gc_frame_newslot(strlit6889);
  int callframe6891 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6892 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe6891);
// compilenode returning call6892
// compilenode returning call6892
  int op_slot_left_6888 = gc_frame_newslot(call6892);
  params[0] = strlit6889;
  partcv[0] = 1;
  Object opresult6893 = callmethod(call6892, "!=", 1, partcv, params);
// compilenode returning opresult6893
  Object if6887 = done;
  if (istrue(opresult6893)) {
// Begin line 2190
  setline(2190);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2174
  setline(2174);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6895 = gc_frame_new();
  int callframe6896 = gc_frame_new();
  Object block6897 = alloc_Block(NULL, NULL, "parser", 2174);
  gc_frame_newslot(block6897);
  block_savedest(block6897);
  Object closure6898 = createclosure(1, "_apply");
setclosureframe(closure6898, stackframe);
  addtoclosure(closure6898, selfslot);
  struct UserObject *uo6898 = (struct UserObject*)block6897;
  uo6898->data[0] = (Object)closure6898;
  Method *meth_meth_parser__apply6898 = addmethod2pos(block6897, "_apply", &meth_parser__apply6898, 0);
int argcv_meth_parser__apply6898[] = {0};
meth_meth_parser__apply6898->type = alloc_MethodType(1, argcv_meth_parser__apply6898);
  meth_meth_parser__apply6898->definitionModule = modulename;
  meth_meth_parser__apply6898->definitionLine = 2174;
// compilenode returning block6897
  gc_frame_newslot(block6897);
  params[0] = block6897;
  partcv[0] = 1;
  Object call6902 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6896);
// compilenode returning call6902
  partcv[0] = 0;
  Object call6903 = callmethod(call6902, "not",
    1, partcv, params);
  gc_frame_end(callframe6895);
// compilenode returning call6903
// compilenode returning call6903
  Object if6894 = done;
  if (istrue(call6903)) {
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2175
  setline(2175);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array6904 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array6904
  *var_suggestions = array6904;
  if (array6904 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2176
  setline(2176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6905 = gc_frame_new();
  int callframe6906 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6907 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6906);
// compilenode returning call6907
// compilenode returning call6907
  partcv[0] = 0;
  Object call6908 = callmethod(call6907, "new",
    1, partcv, params);
  gc_frame_end(callframe6905);
// compilenode returning call6908
// compilenode returning call6908
  *var_suggestion = call6908;
  if (call6908 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2177
  setline(2177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6909 = gc_frame_new();
  if (strlit6910 == NULL) {
    strlit6910 = alloc_String("rparen");
    gc_root(strlit6910);
  }
// compilenode returning strlit6910
  gc_frame_newslot(strlit6910);
  params[0] = strlit6910;
  partcv[0] = 1;
  Object call6911 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6909);
// compilenode returning call6911
  *var_nextTok = call6911;
  if (call6911 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2178
  setline(2178);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_6913 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_6913 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult6915 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult6915
  Object if6912 = done;
  if (istrue(opresult6915)) {
// Begin line 2179
  setline(2179);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6916 = gc_frame_new();
  if (strlit6917 == NULL) {
    strlit6917 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6917);
  }
// compilenode returning strlit6917
  gc_frame_newslot(strlit6917);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit6917;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call6918 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe6916);
// compilenode returning call6918
    gc_frame_newslot(call6918);
    if6912 = call6918;
  } else {
// Begin line 2181
  setline(2181);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6919 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6920 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6921 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6920);
// compilenode returning call6921
// compilenode returning call6921
  gc_frame_newslot(call6921);
  Object bool6922 = alloc_Boolean(1);
// compilenode returning bool6922
  gc_frame_newslot(bool6922);
  Object bool6923 = alloc_Boolean(0);
// compilenode returning bool6923
  gc_frame_newslot(bool6923);
  if (strlit6924 == NULL) {
    strlit6924 = alloc_String("""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit6924);
  }
// compilenode returning strlit6924
  gc_frame_newslot(strlit6924);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6921;
  params[2] = bool6922;
  params[3] = bool6923;
  params[4] = strlit6924;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call6925 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe6919);
// compilenode returning call6925
// Begin line 2182
  setline(2182);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6926 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6927 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6926);
// compilenode returning call6927
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2183
  setline(2183);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6928 = gc_frame_new();
  int callframe6929 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call6930 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe6929);
// compilenode returning call6930
// compilenode returning call6930
  partcv[0] = 0;
  Object call6931 = callmethod(call6930, "new",
    1, partcv, params);
  gc_frame_end(callframe6928);
// compilenode returning call6931
// compilenode returning call6931
  *var_suggestion = call6931;
  if (call6931 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2184
  setline(2184);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6933 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe6934 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call6935 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe6934);
// compilenode returning call6935
// compilenode returning call6935
  gc_frame_newslot(call6935);
  Object bool6936 = alloc_Boolean(1);
// compilenode returning bool6936
  gc_frame_newslot(bool6936);
  Object bool6937 = alloc_Boolean(0);
// compilenode returning bool6937
  gc_frame_newslot(bool6937);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call6935;
  params[2] = bool6936;
  params[3] = bool6937;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call6938 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe6933);
// compilenode returning call6938
    gc_frame_newslot(call6938);
    if6912 = call6938;
  }
// compilenode returning if6912
// Begin line 2186
  setline(2186);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6939 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call6940 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe6939);
// compilenode returning call6940
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6941 = gc_frame_new();
  if (strlit6942 == NULL) {
    strlit6942 = alloc_String("A method request must have an expression or a ')' after a '('.");
    gc_root(strlit6942);
  }
// compilenode returning strlit6942
  gc_frame_newslot(strlit6942);
// Begin line 2188
  setline(2188);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6943 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6944 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe6943);
// compilenode returning call6944
// compilenode returning call6944
  gc_frame_newslot(call6944);
  int callframe6945 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call6946 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6945);
// compilenode returning call6946
// compilenode returning call6946
  gc_frame_newslot(call6946);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2187
  setline(2187);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit6942;
  params[1] = call6944;
  params[2] = call6946;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call6947 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe6941);
// compilenode returning call6947
    gc_frame_newslot(call6947);
    if6894 = call6947;
  } else {
  }
// compilenode returning if6894
    gc_frame_newslot(if6894);
    if6887 = if6894;
  } else {
  }
// compilenode returning if6887
// Begin line 2191
  setline(2191);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6948 = gc_frame_new();
  Object block6949 = alloc_Block(NULL, NULL, "parser", 2191);
  gc_frame_newslot(block6949);
  block_savedest(block6949);
  Object closure6950 = createclosure(1, "_apply");
setclosureframe(closure6950, stackframe);
  addtoclosure(closure6950, selfslot);
  struct UserObject *uo6950 = (struct UserObject*)block6949;
  uo6950->data[0] = (Object)closure6950;
  Method *meth_meth_parser__apply6950 = addmethod2pos(block6949, "_apply", &meth_parser__apply6950, 0);
int argcv_meth_parser__apply6950[] = {0};
meth_meth_parser__apply6950->type = alloc_MethodType(1, argcv_meth_parser__apply6950);
  meth_meth_parser__apply6950->definitionModule = modulename;
  meth_meth_parser__apply6950->definitionLine = 2188;
// compilenode returning block6949
  gc_frame_newslot(block6949);
  Object block6955 = alloc_Block(NULL, NULL, "parser", 2191);
  gc_frame_newslot(block6955);
  block_savedest(block6955);
  Object closure6956 = createclosure(7, "_apply");
setclosureframe(closure6956, stackframe);
  addtoclosure(closure6956, var_values);
  addtoclosure(closure6956, var_nxt);
  addtoclosure(closure6956, var_part);
  addtoclosure(closure6956, var_errormessages);
  addtoclosure(closure6956, var_sym);
  addtoclosure(closure6956, var_lastToken);
  addtoclosure(closure6956, selfslot);
  struct UserObject *uo6956 = (struct UserObject*)block6955;
  uo6956->data[0] = (Object)closure6956;
  Method *meth_meth_parser__apply6956 = addmethod2pos(block6955, "_apply", &meth_parser__apply6956, 0);
int argcv_meth_parser__apply6956[] = {0};
meth_meth_parser__apply6956->type = alloc_MethodType(1, argcv_meth_parser__apply6956);
  meth_meth_parser__apply6956->definitionModule = modulename;
  meth_meth_parser__apply6956->definitionLine = 2188;
// compilenode returning block6955
  gc_frame_newslot(block6955);
  params[0] = block6949;
  params[1] = block6955;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7021 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6948);
// compilenode returning call7021
    gc_frame_newslot(call7021);
    if6883 = call7021;
  }
// compilenode returning if6883
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2213
  setline(2213);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7023 = gc_frame_new();
// compilenode returning *var_isEmpty
  partcv[0] = 0;
  Object call7024 = callmethod(*var_isEmpty, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7023);
// compilenode returning call7024
  Object if7022 = done;
  if (istrue(call7024)) {
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2214
  setline(2214);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7025 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7026 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7025);
// compilenode returning call7026
// compilenode returning call7026
  *var_nxt = call7026;
  if (call7026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2215
  setline(2215);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7028 = gc_frame_new();
// compilenode returning *var_nxt
  gc_frame_newslot(*var_nxt);
  int callframe7029 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call7030 = callmethod(*var_part, "args",
    1, partcv, params);
  gc_frame_end(callframe7029);
// compilenode returning call7030
// compilenode returning call7030
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call7031 = callmethod(call7030, "push",
    1, partcv, params);
  gc_frame_end(callframe7028);
// compilenode returning call7031
    gc_frame_newslot(call7031);
    if7022 = call7031;
  } else {
  }
// compilenode returning if7022
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2217
  setline(2217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7033 = gc_frame_new();
// compilenode returning *var_isTerm
  partcv[0] = 0;
  Object call7034 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7033);
// compilenode returning call7034
// compilenode returning call7034
  Object if7032 = done;
  if (istrue(call7034)) {
// Begin line 2225
  setline(2225);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2218
  setline(2218);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7037 == NULL) {
    strlit7037 = alloc_String("rparen");
    gc_root(strlit7037);
  }
// compilenode returning strlit7037
  int op_slot_right_7036 = gc_frame_newslot(strlit7037);
  int callframe7039 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7040 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7039);
// compilenode returning call7040
// compilenode returning call7040
  int op_slot_left_7036 = gc_frame_newslot(call7040);
  params[0] = strlit7037;
  partcv[0] = 1;
  Object opresult7041 = callmethod(call7040, "!=", 1, partcv, params);
// compilenode returning opresult7041
  Object if7035 = done;
  if (istrue(opresult7041)) {
// Begin line 2219
  setline(2219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7042 = gc_frame_new();
  partcv[0] = 0;
  Object call7043 = callmethodflags(self, "checkBadOperators", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7042);
// compilenode returning call7043
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2220
  setline(2220);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7044 = gc_frame_new();
  int callframe7045 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7046 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7045);
// compilenode returning call7046
// compilenode returning call7046
  partcv[0] = 0;
  Object call7047 = callmethod(call7046, "new",
    1, partcv, params);
  gc_frame_end(callframe7044);
// compilenode returning call7047
// compilenode returning call7047
  *var_suggestion = call7047;
  if (call7047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2221
  setline(2221);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7048 = gc_frame_new();
  if (strlit7049 == NULL) {
    strlit7049 = alloc_String(")");
    gc_root(strlit7049);
  }
// compilenode returning strlit7049
  gc_frame_newslot(strlit7049);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7049;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7050 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7048);
// compilenode returning call7050
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7051 = gc_frame_new();
  if (strlit7052 == NULL) {
    strlit7052 = alloc_String("A part of a multi-part method request beginning with a '(' must end with a ')'.");
    gc_root(strlit7052);
  }
// compilenode returning strlit7052
  gc_frame_newslot(strlit7052);
// Begin line 2223
  setline(2223);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7053 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7054 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7053);
// compilenode returning call7054
// compilenode returning call7054
  gc_frame_newslot(call7054);
  int callframe7056 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7057 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7056);
// compilenode returning call7057
// compilenode returning call7057
  int op_slot_right_7055 = gc_frame_newslot(call7057);
  int callframe7059 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7060 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7059);
// compilenode returning call7060
// compilenode returning call7060
  int op_slot_left_7055 = gc_frame_newslot(call7060);
  params[0] = call7057;
  partcv[0] = 1;
  Object sum7061 = callmethod(call7060, "+", 1, partcv, params);
// compilenode returning sum7061
  gc_frame_newslot(sum7061);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2222
  setline(2222);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7052;
  params[1] = call7054;
  params[2] = sum7061;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7062 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7051);
// compilenode returning call7062
    gc_frame_newslot(call7062);
    if7035 = call7062;
  } else {
  }
// compilenode returning if7035
    gc_frame_newslot(if7035);
    if7032 = if7035;
  } else {
  }
// compilenode returning if7032
// Begin line 2230
  setline(2230);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2226
  setline(2226);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7065 = gc_frame_new();
// compilenode returning *var_isTerm
  partcv[0] = 0;
  Object call7066 = callmethod(*var_isTerm, "not",
    1, partcv, params);
  gc_frame_end(callframe7065);
// compilenode returning call7066
// compilenode returning call7066
  int op_slot_right_7064 = gc_frame_newslot(call7066);
  int callframe7068 = gc_frame_new();
  if (strlit7069 == NULL) {
    strlit7069 = alloc_String("rparen");
    gc_root(strlit7069);
  }
// compilenode returning strlit7069
  gc_frame_newslot(strlit7069);
  params[0] = strlit7069;
  partcv[0] = 1;
  Object call7070 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7068);
// compilenode returning call7070
  int op_slot_left_7064 = gc_frame_newslot(call7070);
  params[0] = call7066;
  partcv[0] = 1;
  Object opresult7071 = callmethod(call7070, "&&", 1, partcv, params);
// compilenode returning opresult7071
  Object if7063 = done;
  if (istrue(opresult7071)) {
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2227
  setline(2227);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastline
  *var_ln = *var_lastline;
  if (*var_lastline == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2228
  setline(2228);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7073 = gc_frame_new();
  partcv[0] = 0;
  Object call7074 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7073);
// compilenode returning call7074
    gc_frame_newslot(call7074);
    if7063 = call7074;
  } else {
  }
// compilenode returning if7063
  gc_frame_end(frame);
  return if7063;
}
Object meth_parser_callmprest6658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "callmprest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_linenum = getfromclosure(closure, 0);
  Object *var_lastToken = getfromclosure(closure, 1);
  Object *var_ast = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_sym = getfromclosure(closure, 5);
  Object *var_lastline = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for callmprest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_meth = &(stackframe->slots[0]);
  *var_meth = args[curarg];
  curarg++;
  Object *var_signature = &(stackframe->slots[1]);
  *var_signature = args[curarg];
  curarg++;
  Object *var_tok = &(stackframe->slots[2]);
  *var_tok = args[curarg];
  curarg++;
if (argcv && argcv[0] > 3)
  gracedie("too many arguments for callmprest");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "methname");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
  Object *var_ln = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ln");
  Object *var_lp = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "lp");
  Object *var_part = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "part");
  Object *var_meth_39_ = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "meth'");
// Begin line 2109
  setline(2109);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2108
  setline(2108);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6659 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6660 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe6659);
// compilenode returning call6660
// compilenode returning call6660
  *var_methname = call6660;
  if (call6660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_nxt = undefined;
// compilenode returning done
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2110
  setline(2110);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  *var_ln = *var_linenum;
  if (*var_linenum == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2112
  setline(2112);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2111
  setline(2111);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe6661 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call6662 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe6661);
// compilenode returning call6662
// compilenode returning call6662
  *var_lp = call6662;
  if (call6662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2113
  setline(2113);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_part = undefined;
// compilenode returning done
  int callframe6663 = gc_frame_new();
  Object block6664 = alloc_Block(NULL, NULL, "parser", 2113);
  gc_frame_newslot(block6664);
  block_savedest(block6664);
  Object closure6665 = createclosure(3, "_apply");
setclosureframe(closure6665, stackframe);
  addtoclosure(closure6665, var_lastToken);
  addtoclosure(closure6665, var_tok);
  addtoclosure(closure6665, selfslot);
  struct UserObject *uo6665 = (struct UserObject*)block6664;
  uo6665->data[0] = (Object)closure6665;
  Method *meth_meth_parser__apply6665 = addmethod2pos(block6664, "_apply", &meth_parser__apply6665, 0);
int argcv_meth_parser__apply6665[] = {0};
meth_meth_parser__apply6665->type = alloc_MethodType(1, argcv_meth_parser__apply6665);
  meth_meth_parser__apply6665->definitionModule = modulename;
  meth_meth_parser__apply6665->definitionLine = 2111;
// compilenode returning block6664
  gc_frame_newslot(block6664);
// Begin line 2114
  setline(2114);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block6676 = alloc_Block(NULL, NULL, "parser", 2114);
  gc_frame_newslot(block6676);
  block_savedest(block6676);
  Object closure6677 = createclosure(13, "_apply");
setclosureframe(closure6677, stackframe);
  addtoclosure(closure6677, var_ast);
  addtoclosure(closure6677, var_part);
  addtoclosure(closure6677, var_signature);
  addtoclosure(closure6677, var_methname);
  addtoclosure(closure6677, var_values);
  addtoclosure(closure6677, var_nxt);
  addtoclosure(closure6677, var_errormessages);
  addtoclosure(closure6677, var_sym);
  addtoclosure(closure6677, var_lastToken);
  addtoclosure(closure6677, var_tok);
  addtoclosure(closure6677, var_lastline);
  addtoclosure(closure6677, var_ln);
  addtoclosure(closure6677, selfslot);
  struct UserObject *uo6677 = (struct UserObject*)block6676;
  uo6677->data[0] = (Object)closure6677;
  Method *meth_meth_parser__apply6677 = addmethod2pos(block6676, "_apply", &meth_parser__apply6677, 0);
int argcv_meth_parser__apply6677[] = {0};
meth_meth_parser__apply6677->type = alloc_MethodType(1, argcv_meth_parser__apply6677);
  meth_meth_parser__apply6677->definitionModule = modulename;
  meth_meth_parser__apply6677->definitionLine = 2111;
// compilenode returning block6676
  gc_frame_newslot(block6676);
  params[0] = block6664;
  params[1] = block6676;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7076 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6663);
// compilenode returning call7076
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7077 = gc_frame_new();
// compilenode returning *var_methname
  gc_frame_newslot(*var_methname);
  Object bool7078 = alloc_Boolean(0);
// compilenode returning bool7078
  gc_frame_newslot(bool7078);
  int callframe7079 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7080 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7079);
// compilenode returning call7080
// compilenode returning call7080
  params[0] = *var_methname;
  params[1] = bool7078;
  partcv[0] = 2;
  Object call7081 = callmethod(call7080, "new",
    1, partcv, params);
  gc_frame_end(callframe7077);
// compilenode returning call7081
  *var_meth_39_ = call7081;
  if (call7081 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2231
  setline(2231);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7082 = gc_frame_new();
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7083 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call7084 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe7083);
// compilenode returning call7084
// compilenode returning call7084
  gc_frame_newslot(call7084);
// compilenode returning *var_meth_39_
  params[0] = call7084;
  partcv[0] = 1;
  Object call7085 = callmethod(*var_meth_39_, "line:=",
    1, partcv, params);
  gc_frame_end(callframe7082);
// compilenode returning call7085
// compilenode returning done
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2232
  setline(2232);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7086 = gc_frame_new();
// Begin line 2233
  setline(2233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7087 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call7088 = callmethod(*var_meth, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7087);
// compilenode returning call7088
// compilenode returning call7088
  gc_frame_newslot(call7088);
// compilenode returning *var_meth_39_
  params[0] = call7088;
  partcv[0] = 1;
  Object call7089 = callmethod(*var_meth_39_, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe7086);
// compilenode returning call7089
// compilenode returning done
// Begin line 2234
  setline(2234);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_meth_39_
  gc_frame_end(frame);
  return *var_meth_39_;
}
Object meth_parser__apply7123(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2247
  setline(2247);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7126 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7127 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7126);
// compilenode returning call7127
// compilenode returning call7127
  int op_slot_right_7125 = gc_frame_newslot(call7127);
  int callframe7129 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call7130 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7129);
// compilenode returning call7130
// compilenode returning call7130
  int op_slot_left_7125 = gc_frame_newslot(call7130);
  params[0] = call7127;
  partcv[0] = 1;
  Object opresult7131 = callmethod(call7130, "==", 1, partcv, params);
// compilenode returning opresult7131
  int op_slot_right_7124 = gc_frame_newslot(opresult7131);
  if (strlit7135 == NULL) {
    strlit7135 = alloc_String("=");
    gc_root(strlit7135);
  }
// compilenode returning strlit7135
  int op_slot_right_7134 = gc_frame_newslot(strlit7135);
  int callframe7137 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call7138 = callmethod(*var_t, "value",
    1, partcv, params);
  gc_frame_end(callframe7137);
// compilenode returning call7138
// compilenode returning call7138
  int op_slot_left_7134 = gc_frame_newslot(call7138);
  params[0] = strlit7135;
  partcv[0] = 1;
  Object opresult7139 = callmethod(call7138, "==", 1, partcv, params);
// compilenode returning opresult7139
  int op_slot_right_7133 = gc_frame_newslot(opresult7139);
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7142 == NULL) {
    strlit7142 = alloc_String("op");
    gc_root(strlit7142);
  }
// compilenode returning strlit7142
  int op_slot_right_7141 = gc_frame_newslot(strlit7142);
  int callframe7144 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call7145 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7144);
// compilenode returning call7145
// compilenode returning call7145
  int op_slot_left_7141 = gc_frame_newslot(call7145);
  params[0] = strlit7142;
  partcv[0] = 1;
  Object opresult7146 = callmethod(call7145, "==", 1, partcv, params);
// compilenode returning opresult7146
  int op_slot_left_7133 = gc_frame_newslot(opresult7146);
  params[0] = opresult7139;
  partcv[0] = 1;
  Object opresult7147 = callmethod(opresult7146, "&&", 1, partcv, params);
// compilenode returning opresult7147
  int op_slot_left_7124 = gc_frame_newslot(opresult7147);
  params[0] = opresult7131;
  partcv[0] = 1;
  Object opresult7148 = callmethod(opresult7147, "&&", 1, partcv, params);
// compilenode returning opresult7148
  gc_frame_end(frame);
  return opresult7148;
}
Object meth_parser__apply7223(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe7224 = gc_frame_new();
  partcv[0] = 0;
  Object call7225 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7224);
// compilenode returning call7225
  gc_frame_end(frame);
  return call7225;
}
Object meth_parser__apply7349(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2311
  setline(2311);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7352 == NULL) {
    strlit7352 = alloc_String("confidential");
    gc_root(strlit7352);
  }
// compilenode returning strlit7352
  int op_slot_right_7351 = gc_frame_newslot(strlit7352);
  int callframe7354 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7355 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7354);
// compilenode returning call7355
// compilenode returning call7355
  int op_slot_left_7351 = gc_frame_newslot(call7355);
  params[0] = strlit7352;
  partcv[0] = 1;
  Object opresult7356 = callmethod(call7355, "==", 1, partcv, params);
// compilenode returning opresult7356
  int op_slot_right_7350 = gc_frame_newslot(opresult7356);
// Begin line 2310
  setline(2310);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7359 == NULL) {
    strlit7359 = alloc_String("public");
    gc_root(strlit7359);
  }
// compilenode returning strlit7359
  int op_slot_right_7358 = gc_frame_newslot(strlit7359);
  int callframe7361 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7362 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7361);
// compilenode returning call7362
// compilenode returning call7362
  int op_slot_left_7358 = gc_frame_newslot(call7362);
  params[0] = strlit7359;
  partcv[0] = 1;
  Object opresult7363 = callmethod(call7362, "==", 1, partcv, params);
// compilenode returning opresult7363
  int op_slot_left_7350 = gc_frame_newslot(opresult7363);
  params[0] = opresult7356;
  partcv[0] = 1;
  Object opresult7364 = callmethod(opresult7363, "||", 1, partcv, params);
// compilenode returning opresult7364
  gc_frame_end(frame);
  return opresult7364;
}
Object meth_parser__apply7378(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2316
  setline(2316);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7381 == NULL) {
    strlit7381 = alloc_String("writable");
    gc_root(strlit7381);
  }
// compilenode returning strlit7381
  int op_slot_right_7380 = gc_frame_newslot(strlit7381);
  int callframe7383 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7384 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7383);
// compilenode returning call7384
// compilenode returning call7384
  int op_slot_left_7380 = gc_frame_newslot(call7384);
  params[0] = strlit7381;
  partcv[0] = 1;
  Object opresult7385 = callmethod(call7384, "==", 1, partcv, params);
// compilenode returning opresult7385
  int op_slot_right_7379 = gc_frame_newslot(opresult7385);
// Begin line 2315
  setline(2315);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7388 == NULL) {
    strlit7388 = alloc_String("readable");
    gc_root(strlit7388);
  }
// compilenode returning strlit7388
  int op_slot_right_7387 = gc_frame_newslot(strlit7388);
  int callframe7390 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7391 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7390);
// compilenode returning call7391
// compilenode returning call7391
  int op_slot_left_7387 = gc_frame_newslot(call7391);
  params[0] = strlit7388;
  partcv[0] = 1;
  Object opresult7392 = callmethod(call7391, "==", 1, partcv, params);
// compilenode returning opresult7392
  int op_slot_left_7379 = gc_frame_newslot(opresult7392);
  params[0] = opresult7385;
  partcv[0] = 1;
  Object opresult7393 = callmethod(opresult7392, "||", 1, partcv, params);
// compilenode returning opresult7393
  gc_frame_end(frame);
  return opresult7393;
}
Object meth_parser__apply7345(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_hasVisibility = getfromclosure(closure, 0);
  Object *var_hasAccessibility = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7347 = gc_frame_new();
  Object block7348 = alloc_Block(NULL, NULL, "parser", 2309);
  gc_frame_newslot(block7348);
  block_savedest(block7348);
  Object closure7349 = createclosure(2, "_apply");
setclosureframe(closure7349, stackframe);
  addtoclosure(closure7349, var_a);
  addtoclosure(closure7349, selfslot);
  struct UserObject *uo7349 = (struct UserObject*)block7348;
  uo7349->data[0] = (Object)closure7349;
  Method *meth_meth_parser__apply7349 = addmethod2pos(block7348, "_apply", &meth_parser__apply7349, 0);
int argcv_meth_parser__apply7349[] = {0};
meth_meth_parser__apply7349->type = alloc_MethodType(1, argcv_meth_parser__apply7349);
  meth_meth_parser__apply7349->definitionModule = modulename;
  meth_meth_parser__apply7349->definitionLine = 2304;
// compilenode returning block7348
  gc_frame_newslot(block7348);
// Begin line 2309
  setline(2309);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7367 == NULL) {
    strlit7367 = alloc_String("identifier");
    gc_root(strlit7367);
  }
// compilenode returning strlit7367
  int op_slot_right_7366 = gc_frame_newslot(strlit7367);
  int callframe7369 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7370 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe7369);
// compilenode returning call7370
// compilenode returning call7370
  int op_slot_left_7366 = gc_frame_newslot(call7370);
  params[0] = strlit7367;
  partcv[0] = 1;
  Object opresult7371 = callmethod(call7370, "==", 1, partcv, params);
// compilenode returning opresult7371
  params[0] = block7348;
  partcv[0] = 1;
  Object call7372 = callmethod(opresult7371, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe7347);
// compilenode returning call7372
  Object if7346 = done;
  if (istrue(call7372)) {
// Begin line 2313
  setline(2313);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2312
  setline(2312);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7373 = alloc_Boolean(1);
// compilenode returning bool7373
  *var_hasVisibility = bool7373;
  if (bool7373 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7346 = done;
  } else {
  }
// compilenode returning if7346
// Begin line 2319
  setline(2319);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7376 = gc_frame_new();
  Object block7377 = alloc_Block(NULL, NULL, "parser", 2314);
  gc_frame_newslot(block7377);
  block_savedest(block7377);
  Object closure7378 = createclosure(2, "_apply");
setclosureframe(closure7378, stackframe);
  addtoclosure(closure7378, var_a);
  addtoclosure(closure7378, selfslot);
  struct UserObject *uo7378 = (struct UserObject*)block7377;
  uo7378->data[0] = (Object)closure7378;
  Method *meth_meth_parser__apply7378 = addmethod2pos(block7377, "_apply", &meth_parser__apply7378, 0);
int argcv_meth_parser__apply7378[] = {0};
meth_meth_parser__apply7378->type = alloc_MethodType(1, argcv_meth_parser__apply7378);
  meth_meth_parser__apply7378->definitionModule = modulename;
  meth_meth_parser__apply7378->definitionLine = 2309;
// compilenode returning block7377
  gc_frame_newslot(block7377);
// Begin line 2314
  setline(2314);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7396 == NULL) {
    strlit7396 = alloc_String("identifier");
    gc_root(strlit7396);
  }
// compilenode returning strlit7396
  int op_slot_right_7395 = gc_frame_newslot(strlit7396);
  int callframe7398 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7399 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe7398);
// compilenode returning call7399
// compilenode returning call7399
  int op_slot_left_7395 = gc_frame_newslot(call7399);
  params[0] = strlit7396;
  partcv[0] = 1;
  Object opresult7400 = callmethod(call7399, "==", 1, partcv, params);
// compilenode returning opresult7400
  params[0] = block7377;
  partcv[0] = 1;
  Object call7401 = callmethod(opresult7400, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe7376);
// compilenode returning call7401
  Object if7375 = done;
  if (istrue(call7401)) {
// Begin line 2318
  setline(2318);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2317
  setline(2317);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7402 = alloc_Boolean(1);
// compilenode returning bool7402
  *var_hasAccessibility = bool7402;
  if (bool7402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7375 = done;
  } else {
  }
// compilenode returning if7375
  gc_frame_end(frame);
  return if7375;
}
Object meth_parser_defdec7090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(19, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_defaultDefVisibility = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defdec (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for defdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_defTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "defTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_nextTok = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "nextTok");
  Object *var_suggestions = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "suggestions");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
  Object *var_hasVisibility = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "hasVisibility");
  Object *var_hasAccessibility = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "hasAccessibility");
// Begin line 2330
  setline(2330);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2239
  setline(2239);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7094 == NULL) {
    strlit7094 = alloc_String("def");
    gc_root(strlit7094);
  }
// compilenode returning strlit7094
  int op_slot_right_7093 = gc_frame_newslot(strlit7094);
  int callframe7096 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7097 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7096);
// compilenode returning call7097
// compilenode returning call7097
  int op_slot_left_7093 = gc_frame_newslot(call7097);
  params[0] = strlit7094;
  partcv[0] = 1;
  Object opresult7098 = callmethod(call7097, "==", 1, partcv, params);
// compilenode returning opresult7098
  int op_slot_right_7092 = gc_frame_newslot(opresult7098);
  int callframe7100 = gc_frame_new();
  if (strlit7101 == NULL) {
    strlit7101 = alloc_String("keyword");
    gc_root(strlit7101);
  }
// compilenode returning strlit7101
  gc_frame_newslot(strlit7101);
  params[0] = strlit7101;
  partcv[0] = 1;
  Object call7102 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7100);
// compilenode returning call7102
  int op_slot_left_7092 = gc_frame_newslot(call7102);
  params[0] = opresult7098;
  partcv[0] = 1;
  Object opresult7103 = callmethod(call7102, "&&", 1, partcv, params);
// compilenode returning opresult7103
  Object if7091 = done;
  if (istrue(opresult7103)) {
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2240
  setline(2240);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7104 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7105 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7104);
// compilenode returning call7105
// compilenode returning call7105
  *var_line = call7105;
  if (call7105 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2241
  setline(2241);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7106 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7107 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7106);
// compilenode returning call7107
// compilenode returning call7107
  *var_pos = call7107;
  if (call7107 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2242
  setline(2242);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_defTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2243
  setline(2243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7108 = gc_frame_new();
  partcv[0] = 0;
  Object call7109 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7108);
// compilenode returning call7109
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2244
  setline(2244);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7112 == NULL) {
    strlit7112 = alloc_String("identifier");
    gc_root(strlit7112);
  }
// compilenode returning strlit7112
  int op_slot_right_7111 = gc_frame_newslot(strlit7112);
  int callframe7114 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7115 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7114);
// compilenode returning call7115
// compilenode returning call7115
  int op_slot_left_7111 = gc_frame_newslot(call7115);
  params[0] = strlit7112;
  partcv[0] = 1;
  Object opresult7116 = callmethod(call7115, "!=", 1, partcv, params);
// compilenode returning opresult7116
  Object if7110 = done;
  if (istrue(opresult7116)) {
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2245
  setline(2245);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7117 = gc_frame_new();
  int callframe7118 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7119 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7118);
// compilenode returning call7119
// compilenode returning call7119
  partcv[0] = 0;
  Object call7120 = callmethod(call7119, "new",
    1, partcv, params);
  gc_frame_end(callframe7117);
// compilenode returning call7120
// compilenode returning call7120
  *var_suggestion = call7120;
  if (call7120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2246
  setline(2246);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7121 = gc_frame_new();
  Object block7122 = alloc_Block(NULL, NULL, "parser", 2246);
  gc_frame_newslot(block7122);
  block_savedest(block7122);
  Object closure7123 = createclosure(2, "_apply");
setclosureframe(closure7123, stackframe);
  addtoclosure(closure7123, var_sym);
  addtoclosure(closure7123, selfslot);
  struct UserObject *uo7123 = (struct UserObject*)block7122;
  uo7123->data[0] = (Object)closure7123;
  Method *meth_meth_parser__apply7123 = addmethod2pos(block7122, "_apply", &meth_parser__apply7123, 0);
int argcv_meth_parser__apply7123[] = {1};
meth_meth_parser__apply7123->type = alloc_MethodType(1, argcv_meth_parser__apply7123);
  meth_meth_parser__apply7123->definitionModule = modulename;
  meth_meth_parser__apply7123->definitionLine = 2245;
// compilenode returning block7122
  gc_frame_newslot(block7122);
  params[0] = block7122;
  partcv[0] = 1;
  Object call7150 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7121);
// compilenode returning call7150
  *var_nextToken = call7150;
  if (call7150 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2248
  setline(2248);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7153 = alloc_Boolean(0);
// compilenode returning bool7153
  int op_slot_right_7152 = gc_frame_newslot(bool7153);
// compilenode returning *var_nextToken
  int op_slot_left_7152 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7153;
  partcv[0] = 1;
  Object opresult7155 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compilenode returning opresult7155
  Object if7151 = done;
  if (istrue(opresult7155)) {
// Begin line 2249
  setline(2249);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7156 = gc_frame_new();
  if (strlit7157 == NULL) {
    strlit7157 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb"" =");
    gc_root(strlit7157);
  }
// compilenode returning strlit7157
  gc_frame_newslot(strlit7157);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7157;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7158 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7156);
// compilenode returning call7158
    gc_frame_newslot(call7158);
    if7151 = call7158;
  } else {
// Begin line 2252
  setline(2252);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2250
  setline(2250);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_7160 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextToken
  int op_slot_left_7160 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7162 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compilenode returning opresult7162
  Object if7159 = done;
  if (istrue(opresult7162)) {
// Begin line 2251
  setline(2251);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7163 = gc_frame_new();
  if (strlit7164 == NULL) {
    strlit7164 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7164);
  }
// compilenode returning strlit7164
  gc_frame_newslot(strlit7164);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7164;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7165 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7163);
// compilenode returning call7165
    gc_frame_newslot(call7165);
    if7159 = call7165;
  } else {
// Begin line 2253
  setline(2253);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7166 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe7167 = gc_frame_new();
// compilenode returning *var_nextToken
  partcv[0] = 0;
  Object call7168 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7167);
// compilenode returning call7168
// compilenode returning call7168
  gc_frame_newslot(call7168);
  Object bool7169 = alloc_Boolean(0);
// compilenode returning bool7169
  gc_frame_newslot(bool7169);
  Object bool7170 = alloc_Boolean(1);
// compilenode returning bool7170
  gc_frame_newslot(bool7170);
  if (strlit7171 == NULL) {
    strlit7171 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7171);
  }
// compilenode returning strlit7171
  gc_frame_newslot(strlit7171);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call7168;
  params[2] = bool7169;
  params[3] = bool7170;
  params[4] = strlit7171;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7172 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7166);
// compilenode returning call7172
    gc_frame_newslot(call7172);
    if7159 = call7172;
  }
// compilenode returning if7159
    gc_frame_newslot(if7159);
    if7151 = if7159;
  }
// compilenode returning if7151
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7173 = gc_frame_new();
  if (strlit7174 == NULL) {
    strlit7174 = alloc_String("A constant declaration must have a name, a '=', and a value after the 'def'.");
    gc_root(strlit7174);
  }
// compilenode returning strlit7174
  gc_frame_newslot(strlit7174);
// Begin line 2256
  setline(2256);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7175 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7176 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7175);
// compilenode returning call7176
// compilenode returning call7176
  gc_frame_newslot(call7176);
  int callframe7177 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7178 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7177);
// compilenode returning call7178
// compilenode returning call7178
  gc_frame_newslot(call7178);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2255
  setline(2255);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7174;
  params[1] = call7176;
  params[2] = call7178;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7179 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7173);
// compilenode returning call7179
    gc_frame_newslot(call7179);
    if7110 = call7179;
  } else {
  }
// compilenode returning if7110
// Begin line 2258
  setline(2258);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7180 = gc_frame_new();
  partcv[0] = 0;
  Object call7181 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7180);
// compilenode returning call7181
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2259
  setline(2259);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7182 = alloc_Boolean(0);
// compilenode returning bool7182
  *var_val = bool7182;
  if (bool7182 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2260
  setline(2260);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7183 = gc_frame_new();
  if (strlit7184 == NULL) {
    strlit7184 = alloc_String("Unknown");
    gc_root(strlit7184);
  }
// compilenode returning strlit7184
  gc_frame_newslot(strlit7184);
  Object bool7185 = alloc_Boolean(0);
// compilenode returning bool7185
  gc_frame_newslot(bool7185);
  int callframe7186 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7187 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7186);
// compilenode returning call7187
// compilenode returning call7187
  params[0] = strlit7184;
  params[1] = bool7185;
  partcv[0] = 2;
  Object call7188 = callmethod(call7187, "new",
    1, partcv, params);
  gc_frame_end(callframe7183);
// compilenode returning call7188
  *var_dtype = call7188;
  if (call7188 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2261
  setline(2261);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7189 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7190 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7189);
// compilenode returning call7190
// compilenode returning call7190
  *var_name = call7190;
  if (call7190 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2262
  setline(2262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7192 = gc_frame_new();
  if (strlit7193 == NULL) {
    strlit7193 = alloc_String("colon");
    gc_root(strlit7193);
  }
// compilenode returning strlit7193
  gc_frame_newslot(strlit7193);
  params[0] = strlit7193;
  partcv[0] = 1;
  Object call7194 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7192);
// compilenode returning call7194
  Object if7191 = done;
  if (istrue(call7194)) {
// Begin line 2263
  setline(2263);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7195 = gc_frame_new();
  partcv[0] = 0;
  Object call7196 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7195);
// compilenode returning call7196
// Begin line 2264
  setline(2264);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7197 = gc_frame_new();
  partcv[0] = 0;
  Object call7198 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7197);
// compilenode returning call7198
// Begin line 2266
  setline(2266);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2265
  setline(2265);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7199 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7200 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7199);
// compilenode returning call7200
// compilenode returning call7200
  *var_dtype = call7200;
  if (call7200 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7191 = done;
  } else {
  }
// compilenode returning if7191
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2267
  setline(2267);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7202 = gc_frame_new();
  partcv[0] = 0;
  Object call7203 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7202);
// compilenode returning call7203
  *var_anns = call7203;
  if (call7203 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2268
  setline(2268);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7207 == NULL) {
    strlit7207 = alloc_String("=");
    gc_root(strlit7207);
  }
// compilenode returning strlit7207
  int op_slot_right_7206 = gc_frame_newslot(strlit7207);
  int callframe7209 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7210 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7209);
// compilenode returning call7210
// compilenode returning call7210
  int op_slot_left_7206 = gc_frame_newslot(call7210);
  params[0] = strlit7207;
  partcv[0] = 1;
  Object opresult7211 = callmethod(call7210, "==", 1, partcv, params);
// compilenode returning opresult7211
  int op_slot_right_7205 = gc_frame_newslot(opresult7211);
  int callframe7213 = gc_frame_new();
  if (strlit7214 == NULL) {
    strlit7214 = alloc_String("op");
    gc_root(strlit7214);
  }
// compilenode returning strlit7214
  gc_frame_newslot(strlit7214);
  params[0] = strlit7214;
  partcv[0] = 1;
  Object call7215 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7213);
// compilenode returning call7215
  int op_slot_left_7205 = gc_frame_newslot(call7215);
  params[0] = opresult7211;
  partcv[0] = 1;
  Object opresult7216 = callmethod(call7215, "&&", 1, partcv, params);
// compilenode returning opresult7216
  Object if7204 = done;
  if (istrue(opresult7216)) {
// Begin line 2269
  setline(2269);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7217 = gc_frame_new();
  partcv[0] = 0;
  Object call7218 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7217);
// compilenode returning call7218
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2270
  setline(2270);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7220 = gc_frame_new();
  int callframe7221 = gc_frame_new();
  Object block7222 = alloc_Block(NULL, NULL, "parser", 2270);
  gc_frame_newslot(block7222);
  block_savedest(block7222);
  Object closure7223 = createclosure(1, "_apply");
setclosureframe(closure7223, stackframe);
  addtoclosure(closure7223, selfslot);
  struct UserObject *uo7223 = (struct UserObject*)block7222;
  uo7223->data[0] = (Object)closure7223;
  Method *meth_meth_parser__apply7223 = addmethod2pos(block7222, "_apply", &meth_parser__apply7223, 0);
int argcv_meth_parser__apply7223[] = {0};
meth_meth_parser__apply7223->type = alloc_MethodType(1, argcv_meth_parser__apply7223);
  meth_meth_parser__apply7223->definitionModule = modulename;
  meth_meth_parser__apply7223->definitionLine = 2270;
// compilenode returning block7222
  gc_frame_newslot(block7222);
  params[0] = block7222;
  partcv[0] = 1;
  Object call7227 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7221);
// compilenode returning call7227
  partcv[0] = 0;
  Object call7228 = callmethod(call7227, "not",
    1, partcv, params);
  gc_frame_end(callframe7220);
// compilenode returning call7228
// compilenode returning call7228
  Object if7219 = done;
  if (istrue(call7228)) {
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2271
  setline(2271);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7229 = gc_frame_new();
  int callframe7230 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7231 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7230);
// compilenode returning call7231
// compilenode returning call7231
  partcv[0] = 0;
  Object call7232 = callmethod(call7231, "new",
    1, partcv, params);
  gc_frame_end(callframe7229);
// compilenode returning call7232
// compilenode returning call7232
  *var_suggestion = call7232;
  if (call7232 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2272
  setline(2272);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7233 = gc_frame_new();
  partcv[0] = 0;
  Object call7234 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7233);
// compilenode returning call7234
  *var_nextTok = call7234;
  if (call7234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2273
  setline(2273);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_7236 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_7236 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7238 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult7238
  Object if7235 = done;
  if (istrue(opresult7238)) {
// Begin line 2274
  setline(2274);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7239 = gc_frame_new();
  if (strlit7240 == NULL) {
    strlit7240 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7240);
  }
// compilenode returning strlit7240
  gc_frame_newslot(strlit7240);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7240;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7241 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7239);
// compilenode returning call7241
    gc_frame_newslot(call7241);
    if7235 = call7241;
  } else {
// Begin line 2276
  setline(2276);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7242 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe7243 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7244 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7243);
// compilenode returning call7244
// compilenode returning call7244
  gc_frame_newslot(call7244);
  Object bool7245 = alloc_Boolean(1);
// compilenode returning bool7245
  gc_frame_newslot(bool7245);
  Object bool7246 = alloc_Boolean(0);
// compilenode returning bool7246
  gc_frame_newslot(bool7246);
  if (strlit7247 == NULL) {
    strlit7247 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7247);
  }
// compilenode returning strlit7247
  gc_frame_newslot(strlit7247);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call7244;
  params[2] = bool7245;
  params[3] = bool7246;
  params[4] = strlit7247;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7248 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7242);
// compilenode returning call7248
    gc_frame_newslot(call7248);
    if7235 = call7248;
  }
// compilenode returning if7235
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7249 = gc_frame_new();
  if (strlit7250 == NULL) {
    strlit7250 = alloc_String("A constant declaration must have a value after the '='.");
    gc_root(strlit7250);
  }
// compilenode returning strlit7250
  gc_frame_newslot(strlit7250);
// Begin line 2279
  setline(2279);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7251 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7252 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7251);
// compilenode returning call7252
// compilenode returning call7252
  gc_frame_newslot(call7252);
  int callframe7254 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7255 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7254);
// compilenode returning call7255
// compilenode returning call7255
  int op_slot_right_7253 = gc_frame_newslot(call7255);
  int callframe7257 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7258 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7257);
// compilenode returning call7258
// compilenode returning call7258
  int op_slot_left_7253 = gc_frame_newslot(call7258);
  params[0] = call7255;
  partcv[0] = 1;
  Object sum7259 = callmethod(call7258, "+", 1, partcv, params);
// compilenode returning sum7259
  gc_frame_newslot(sum7259);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2278
  setline(2278);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7250;
  params[1] = call7252;
  params[2] = sum7259;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7260 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7249);
// compilenode returning call7260
    gc_frame_newslot(call7260);
    if7219 = call7260;
  } else {
  }
// compilenode returning if7219
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2281
  setline(2281);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7261 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7262 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7261);
// compilenode returning call7262
// compilenode returning call7262
  *var_val = call7262;
  if (call7262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7204 = done;
  } else {
// Begin line 2292
  setline(2292);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2282
  setline(2282);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7265 = gc_frame_new();
  if (strlit7266 == NULL) {
    strlit7266 = alloc_String("bind");
    gc_root(strlit7266);
  }
// compilenode returning strlit7266
  gc_frame_newslot(strlit7266);
  params[0] = strlit7266;
  partcv[0] = 1;
  Object call7267 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7265);
// compilenode returning call7267
  Object if7264 = done;
  if (istrue(call7267)) {
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2283
  setline(2283);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7268 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7268
  *var_suggestions = array7268;
  if (array7268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2284
  setline(2284);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7269 = gc_frame_new();
  int callframe7270 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7271 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7270);
// compilenode returning call7271
// compilenode returning call7271
  partcv[0] = 0;
  Object call7272 = callmethod(call7271, "new",
    1, partcv, params);
  gc_frame_end(callframe7269);
// compilenode returning call7272
// compilenode returning call7272
  *var_suggestion = call7272;
  if (call7272 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2285
  setline(2285);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7273 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit7274 == NULL) {
    strlit7274 = alloc_String("=");
    gc_root(strlit7274);
  }
// compilenode returning strlit7274
  gc_frame_newslot(strlit7274);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit7274;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7275 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7273);
// compilenode returning call7275
// Begin line 2286
  setline(2286);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7276 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7277 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7276);
// compilenode returning call7277
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2287
  setline(2287);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7278 = gc_frame_new();
  int callframe7279 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7280 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7279);
// compilenode returning call7280
// compilenode returning call7280
  partcv[0] = 0;
  Object call7281 = callmethod(call7280, "new",
    1, partcv, params);
  gc_frame_end(callframe7278);
// compilenode returning call7281
// compilenode returning call7281
  *var_suggestion = call7281;
  if (call7281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2288
  setline(2288);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7283 = gc_frame_new();
// compilenode returning *var_defTok
  gc_frame_newslot(*var_defTok);
  if (strlit7284 == NULL) {
    strlit7284 = alloc_String("var");
    gc_root(strlit7284);
  }
// compilenode returning strlit7284
  gc_frame_newslot(strlit7284);
// compilenode returning *var_suggestion
  params[0] = *var_defTok;
  params[1] = strlit7284;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7285 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7283);
// compilenode returning call7285
// Begin line 2289
  setline(2289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7286 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7287 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7286);
// compilenode returning call7287
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7288 = gc_frame_new();
  if (strlit7289 == NULL) {
    strlit7289 = alloc_String("A constant declaration must use '=' instead of ':='. A variable declaration uses 'var' and ':='.");
    gc_root(strlit7289);
  }
// compilenode returning strlit7289
  gc_frame_newslot(strlit7289);
// Begin line 2291
  setline(2291);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7290 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7291 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7290);
// compilenode returning call7291
// compilenode returning call7291
  gc_frame_newslot(call7291);
  int callframe7292 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7293 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7292);
// compilenode returning call7293
// compilenode returning call7293
  gc_frame_newslot(call7293);
  Object num7295 = alloc_Float64(1);
// compilenode returning num7295
  int op_slot_right_7294 = gc_frame_newslot(num7295);
  int callframe7297 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7298 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7297);
// compilenode returning call7298
// compilenode returning call7298
  int op_slot_left_7294 = gc_frame_newslot(call7298);
  params[0] = num7295;
  partcv[0] = 1;
  Object sum7299 = callmethod(call7298, "+", 1, partcv, params);
// compilenode returning sum7299
  gc_frame_newslot(sum7299);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2290
  setline(2290);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7289;
  params[1] = call7291;
  params[2] = call7293;
  params[3] = sum7299;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7300 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7288);
// compilenode returning call7300
    gc_frame_newslot(call7300);
    if7264 = call7300;
  } else {
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2293
  setline(2293);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7301 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7301
  *var_suggestions = array7301;
  if (array7301 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2294
  setline(2294);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7302 = gc_frame_new();
  int callframe7303 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7304 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7303);
// compilenode returning call7304
// compilenode returning call7304
  partcv[0] = 0;
  Object call7305 = callmethod(call7304, "new",
    1, partcv, params);
  gc_frame_end(callframe7302);
// compilenode returning call7305
// compilenode returning call7305
  *var_suggestion = call7305;
  if (call7305 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2295
  setline(2295);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7306 = gc_frame_new();
  if (strlit7307 == NULL) {
    strlit7307 = alloc_String(" = ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7307);
  }
// compilenode returning strlit7307
  gc_frame_newslot(strlit7307);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7307;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7308 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7306);
// compilenode returning call7308
// Begin line 2296
  setline(2296);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7309 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7310 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7309);
// compilenode returning call7310
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2297
  setline(2297);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7311 = gc_frame_new();
  int callframe7312 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7313 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7312);
// compilenode returning call7313
// compilenode returning call7313
  partcv[0] = 0;
  Object call7314 = callmethod(call7313, "new",
    1, partcv, params);
  gc_frame_end(callframe7311);
// compilenode returning call7314
// compilenode returning call7314
  *var_suggestion = call7314;
  if (call7314 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2298
  setline(2298);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7316 = gc_frame_new();
// compilenode returning *var_defTok
  gc_frame_newslot(*var_defTok);
  if (strlit7317 == NULL) {
    strlit7317 = alloc_String("var");
    gc_root(strlit7317);
  }
// compilenode returning strlit7317
  gc_frame_newslot(strlit7317);
// compilenode returning *var_suggestion
  params[0] = *var_defTok;
  params[1] = strlit7317;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7318 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7316);
// compilenode returning call7318
// Begin line 2299
  setline(2299);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7319 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7320 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7319);
// compilenode returning call7320
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7321 = gc_frame_new();
// Begin line 2301
  setline(2301);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7323 == NULL) {
    strlit7323 = alloc_String("A variable declaration does not require a value and uses 'var' instead of 'def'.");
    gc_root(strlit7323);
  }
// compilenode returning strlit7323
  int op_slot_right_7322 = gc_frame_newslot(strlit7323);
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7325 == NULL) {
    strlit7325 = alloc_String("A constant declaration must have a '=' and a value after the name. ");
    gc_root(strlit7325);
  }
// compilenode returning strlit7325
  int op_slot_left_7322 = gc_frame_newslot(strlit7325);
  params[0] = strlit7323;
  partcv[0] = 1;
  Object opresult7326 = callmethod(strlit7325, "++", 1, partcv, params);
// compilenode returning opresult7326
  gc_frame_newslot(opresult7326);
// Begin line 2302
  setline(2302);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7327 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7328 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7327);
// compilenode returning call7328
// compilenode returning call7328
  gc_frame_newslot(call7328);
  int callframe7329 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7330 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7329);
// compilenode returning call7330
// compilenode returning call7330
  gc_frame_newslot(call7330);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2300
  setline(2300);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult7326;
  params[1] = call7328;
  params[2] = call7330;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7331 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7321);
// compilenode returning call7331
    gc_frame_newslot(call7331);
    if7264 = call7331;
  }
// compilenode returning if7264
    gc_frame_newslot(if7264);
    if7204 = if7264;
  }
// compilenode returning if7204
// Begin line 2304
  setline(2304);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7332 = gc_frame_new();
// compilenode returning *var_name
  gc_frame_newslot(*var_name);
// compilenode returning *var_val
  gc_frame_newslot(*var_val);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
  int callframe7333 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7334 = callmethod(*var_ast, "defDecNode",
    1, partcv, params);
  gc_frame_end(callframe7333);
// compilenode returning call7334
// compilenode returning call7334
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7335 = callmethod(call7334, "new",
    1, partcv, params);
  gc_frame_end(callframe7332);
// compilenode returning call7335
  *var_o = call7335;
  if (call7335 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2305
  setline(2305);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7336 = alloc_Boolean(0);
// compilenode returning bool7336
  *var_hasVisibility = bool7336;
  if (bool7336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2306
  setline(2306);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7337 = alloc_Boolean(0);
// compilenode returning bool7337
  *var_hasAccessibility = bool7337;
  if (bool7337 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2307
  setline(2307);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7340 = alloc_Boolean(0);
// compilenode returning bool7340
  int op_slot_right_7339 = gc_frame_newslot(bool7340);
// compilenode returning *var_anns
  int op_slot_left_7339 = gc_frame_newslot(*var_anns);
  params[0] = bool7340;
  partcv[0] = 1;
  Object opresult7342 = callmethod(*var_anns, "!=", 1, partcv, params);
// compilenode returning opresult7342
  Object if7338 = done;
  if (istrue(opresult7342)) {
// Begin line 2308
  setline(2308);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7343 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  Object block7344 = alloc_Block(NULL, NULL, "parser", 2308);
  gc_frame_newslot(block7344);
  block_savedest(block7344);
  Object closure7345 = createclosure(3, "_apply");
setclosureframe(closure7345, stackframe);
  addtoclosure(closure7345, var_hasVisibility);
  addtoclosure(closure7345, var_hasAccessibility);
  addtoclosure(closure7345, selfslot);
  struct UserObject *uo7345 = (struct UserObject*)block7344;
  uo7345->data[0] = (Object)closure7345;
  Method *meth_meth_parser__apply7345 = addmethod2pos(block7344, "_apply", &meth_parser__apply7345, 0);
int argcv_meth_parser__apply7345[] = {1};
meth_meth_parser__apply7345->type = alloc_MethodType(1, argcv_meth_parser__apply7345);
  meth_meth_parser__apply7345->definitionModule = modulename;
  meth_meth_parser__apply7345->definitionLine = 2304;
// compilenode returning block7344
  gc_frame_newslot(block7344);
  params[0] = *var_anns;
  params[1] = block7344;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7405 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7343);
// compilenode returning call7405
// Begin line 2320
  setline(2320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7406 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe7407 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call7408 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7407);
// compilenode returning call7408
// compilenode returning call7408
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7409 = callmethod(call7408, "extend",
    1, partcv, params);
  gc_frame_end(callframe7406);
// compilenode returning call7409
    gc_frame_newslot(call7409);
    if7338 = call7409;
  } else {
  }
// compilenode returning if7338
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2322
  setline(2322);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7412 = gc_frame_new();
// compilenode returning *var_hasAccessibility
  partcv[0] = 0;
  Object call7413 = callmethod(*var_hasAccessibility, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7412);
// compilenode returning call7413
  int op_slot_right_7411 = gc_frame_newslot(call7413);
  int callframe7415 = gc_frame_new();
// compilenode returning *var_hasVisibility
  partcv[0] = 0;
  Object call7416 = callmethod(*var_hasVisibility, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7415);
// compilenode returning call7416
  int op_slot_left_7411 = gc_frame_newslot(call7416);
  params[0] = call7413;
  partcv[0] = 1;
  Object opresult7417 = callmethod(call7416, "&&", 1, partcv, params);
// compilenode returning opresult7417
  Object if7410 = done;
  if (istrue(opresult7417)) {
// Begin line 2326
  setline(2326);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2323
  setline(2323);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7420 == NULL) {
    strlit7420 = alloc_String("public");
    gc_root(strlit7420);
  }
// compilenode returning strlit7420
  int op_slot_right_7419 = gc_frame_newslot(strlit7420);
// compilenode returning *var_defaultDefVisibility
  int op_slot_left_7419 = gc_frame_newslot(*var_defaultDefVisibility);
  params[0] = strlit7420;
  partcv[0] = 1;
  Object opresult7422 = callmethod(*var_defaultDefVisibility, "==", 1, partcv, params);
// compilenode returning opresult7422
  Object if7418 = done;
  if (istrue(opresult7422)) {
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7423 = gc_frame_new();
  int callframe7424 = gc_frame_new();
  if (strlit7425 == NULL) {
    strlit7425 = alloc_String("public");
    gc_root(strlit7425);
  }
// compilenode returning strlit7425
  gc_frame_newslot(strlit7425);
  Object bool7426 = alloc_Boolean(0);
// compilenode returning bool7426
  gc_frame_newslot(bool7426);
  int callframe7427 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7428 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7427);
// compilenode returning call7428
// compilenode returning call7428
  params[0] = strlit7425;
  params[1] = bool7426;
  partcv[0] = 2;
  Object call7429 = callmethod(call7428, "new",
    1, partcv, params);
  gc_frame_end(callframe7424);
// compilenode returning call7429
  gc_frame_newslot(call7429);
  int callframe7430 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call7431 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7430);
// compilenode returning call7431
// compilenode returning call7431
  params[0] = call7429;
  partcv[0] = 1;
  Object call7432 = callmethod(call7431, "push",
    1, partcv, params);
  gc_frame_end(callframe7423);
// compilenode returning call7432
    gc_frame_newslot(call7432);
    if7418 = call7432;
  } else {
  }
// compilenode returning if7418
    gc_frame_newslot(if7418);
    if7410 = if7418;
  } else {
  }
// compilenode returning if7410
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2324
  setline(2324);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7433 = gc_frame_new();
// Begin line 2327
  setline(2327);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defTok
  gc_frame_newslot(*var_defTok);
// compilenode returning *var_o
  params[0] = *var_defTok;
  partcv[0] = 1;
  Object call7434 = callmethod(*var_o, "startToken:=",
    1, partcv, params);
  gc_frame_end(callframe7433);
// compilenode returning call7434
// compilenode returning done
// Begin line 2328
  setline(2328);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7435 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7436 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7435);
// compilenode returning call7436
    gc_frame_newslot(call7436);
    if7091 = call7436;
  } else {
  }
// compilenode returning if7091
  gc_frame_end(frame);
  return if7091;
}
Object meth_parser__apply7470(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2342
  setline(2342);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7473 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7474 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7473);
// compilenode returning call7474
// compilenode returning call7474
  int op_slot_right_7472 = gc_frame_newslot(call7474);
  int callframe7476 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call7477 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe7476);
// compilenode returning call7477
// compilenode returning call7477
  int op_slot_left_7472 = gc_frame_newslot(call7477);
  params[0] = call7474;
  partcv[0] = 1;
  Object opresult7478 = callmethod(call7477, "==", 1, partcv, params);
// compilenode returning opresult7478
  int op_slot_right_7471 = gc_frame_newslot(opresult7478);
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7481 == NULL) {
    strlit7481 = alloc_String("bind");
    gc_root(strlit7481);
  }
// compilenode returning strlit7481
  int op_slot_right_7480 = gc_frame_newslot(strlit7481);
  int callframe7483 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call7484 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe7483);
// compilenode returning call7484
// compilenode returning call7484
  int op_slot_left_7480 = gc_frame_newslot(call7484);
  params[0] = strlit7481;
  partcv[0] = 1;
  Object opresult7485 = callmethod(call7484, "==", 1, partcv, params);
// compilenode returning opresult7485
  int op_slot_left_7471 = gc_frame_newslot(opresult7485);
  params[0] = opresult7478;
  partcv[0] = 1;
  Object opresult7486 = callmethod(opresult7485, "&&", 1, partcv, params);
// compilenode returning opresult7486
  gc_frame_end(frame);
  return opresult7486;
}
Object meth_parser__apply7492(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextToken = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var_sym
  int op_slot_right_7493 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextToken
  int op_slot_left_7493 = gc_frame_newslot(*var_nextToken);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7495 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compilenode returning opresult7495
  gc_frame_end(frame);
  return opresult7495;
}
Object meth_parser__apply7553(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe7554 = gc_frame_new();
  partcv[0] = 0;
  Object call7555 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7554);
// compilenode returning call7555
  gc_frame_end(frame);
  return call7555;
}
Object meth_parser__apply7673(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2402
  setline(2402);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7676 == NULL) {
    strlit7676 = alloc_String("confidential");
    gc_root(strlit7676);
  }
// compilenode returning strlit7676
  int op_slot_right_7675 = gc_frame_newslot(strlit7676);
  int callframe7678 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7679 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7678);
// compilenode returning call7679
// compilenode returning call7679
  int op_slot_left_7675 = gc_frame_newslot(call7679);
  params[0] = strlit7676;
  partcv[0] = 1;
  Object opresult7680 = callmethod(call7679, "==", 1, partcv, params);
// compilenode returning opresult7680
  int op_slot_right_7674 = gc_frame_newslot(opresult7680);
// Begin line 2401
  setline(2401);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7683 == NULL) {
    strlit7683 = alloc_String("public");
    gc_root(strlit7683);
  }
// compilenode returning strlit7683
  int op_slot_right_7682 = gc_frame_newslot(strlit7683);
  int callframe7685 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7686 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7685);
// compilenode returning call7686
// compilenode returning call7686
  int op_slot_left_7682 = gc_frame_newslot(call7686);
  params[0] = strlit7683;
  partcv[0] = 1;
  Object opresult7687 = callmethod(call7686, "==", 1, partcv, params);
// compilenode returning opresult7687
  int op_slot_left_7674 = gc_frame_newslot(opresult7687);
  params[0] = opresult7680;
  partcv[0] = 1;
  Object opresult7688 = callmethod(opresult7687, "||", 1, partcv, params);
// compilenode returning opresult7688
  gc_frame_end(frame);
  return opresult7688;
}
Object meth_parser__apply7702(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_a = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2407
  setline(2407);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7705 == NULL) {
    strlit7705 = alloc_String("writable");
    gc_root(strlit7705);
  }
// compilenode returning strlit7705
  int op_slot_right_7704 = gc_frame_newslot(strlit7705);
  int callframe7707 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7708 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7707);
// compilenode returning call7708
// compilenode returning call7708
  int op_slot_left_7704 = gc_frame_newslot(call7708);
  params[0] = strlit7705;
  partcv[0] = 1;
  Object opresult7709 = callmethod(call7708, "==", 1, partcv, params);
// compilenode returning opresult7709
  int op_slot_right_7703 = gc_frame_newslot(opresult7709);
// Begin line 2406
  setline(2406);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7712 == NULL) {
    strlit7712 = alloc_String("readable");
    gc_root(strlit7712);
  }
// compilenode returning strlit7712
  int op_slot_right_7711 = gc_frame_newslot(strlit7712);
  int callframe7714 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7715 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe7714);
// compilenode returning call7715
// compilenode returning call7715
  int op_slot_left_7711 = gc_frame_newslot(call7715);
  params[0] = strlit7712;
  partcv[0] = 1;
  Object opresult7716 = callmethod(call7715, "==", 1, partcv, params);
// compilenode returning opresult7716
  int op_slot_left_7703 = gc_frame_newslot(opresult7716);
  params[0] = opresult7709;
  partcv[0] = 1;
  Object opresult7717 = callmethod(opresult7716, "||", 1, partcv, params);
// compilenode returning opresult7717
  gc_frame_end(frame);
  return opresult7717;
}
Object meth_parser__apply7669(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_hasVisibility = getfromclosure(closure, 0);
  Object *var_hasAccessibility = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7671 = gc_frame_new();
  Object block7672 = alloc_Block(NULL, NULL, "parser", 2400);
  gc_frame_newslot(block7672);
  block_savedest(block7672);
  Object closure7673 = createclosure(2, "_apply");
setclosureframe(closure7673, stackframe);
  addtoclosure(closure7673, var_a);
  addtoclosure(closure7673, selfslot);
  struct UserObject *uo7673 = (struct UserObject*)block7672;
  uo7673->data[0] = (Object)closure7673;
  Method *meth_meth_parser__apply7673 = addmethod2pos(block7672, "_apply", &meth_parser__apply7673, 0);
int argcv_meth_parser__apply7673[] = {0};
meth_meth_parser__apply7673->type = alloc_MethodType(1, argcv_meth_parser__apply7673);
  meth_meth_parser__apply7673->definitionModule = modulename;
  meth_meth_parser__apply7673->definitionLine = 2395;
// compilenode returning block7672
  gc_frame_newslot(block7672);
// Begin line 2400
  setline(2400);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7691 == NULL) {
    strlit7691 = alloc_String("identifier");
    gc_root(strlit7691);
  }
// compilenode returning strlit7691
  int op_slot_right_7690 = gc_frame_newslot(strlit7691);
  int callframe7693 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7694 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe7693);
// compilenode returning call7694
// compilenode returning call7694
  int op_slot_left_7690 = gc_frame_newslot(call7694);
  params[0] = strlit7691;
  partcv[0] = 1;
  Object opresult7695 = callmethod(call7694, "==", 1, partcv, params);
// compilenode returning opresult7695
  params[0] = block7672;
  partcv[0] = 1;
  Object call7696 = callmethod(opresult7695, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe7671);
// compilenode returning call7696
  Object if7670 = done;
  if (istrue(call7696)) {
// Begin line 2404
  setline(2404);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2403
  setline(2403);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7697 = alloc_Boolean(1);
// compilenode returning bool7697
  *var_hasVisibility = bool7697;
  if (bool7697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7670 = done;
  } else {
  }
// compilenode returning if7670
// Begin line 2410
  setline(2410);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7700 = gc_frame_new();
  Object block7701 = alloc_Block(NULL, NULL, "parser", 2405);
  gc_frame_newslot(block7701);
  block_savedest(block7701);
  Object closure7702 = createclosure(2, "_apply");
setclosureframe(closure7702, stackframe);
  addtoclosure(closure7702, var_a);
  addtoclosure(closure7702, selfslot);
  struct UserObject *uo7702 = (struct UserObject*)block7701;
  uo7702->data[0] = (Object)closure7702;
  Method *meth_meth_parser__apply7702 = addmethod2pos(block7701, "_apply", &meth_parser__apply7702, 0);
int argcv_meth_parser__apply7702[] = {0};
meth_meth_parser__apply7702->type = alloc_MethodType(1, argcv_meth_parser__apply7702);
  meth_meth_parser__apply7702->definitionModule = modulename;
  meth_meth_parser__apply7702->definitionLine = 2400;
// compilenode returning block7701
  gc_frame_newslot(block7701);
// Begin line 2405
  setline(2405);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7720 == NULL) {
    strlit7720 = alloc_String("identifier");
    gc_root(strlit7720);
  }
// compilenode returning strlit7720
  int op_slot_right_7719 = gc_frame_newslot(strlit7720);
  int callframe7722 = gc_frame_new();
// compilenode returning *var_a
  partcv[0] = 0;
  Object call7723 = callmethod(*var_a, "kind",
    1, partcv, params);
  gc_frame_end(callframe7722);
// compilenode returning call7723
// compilenode returning call7723
  int op_slot_left_7719 = gc_frame_newslot(call7723);
  params[0] = strlit7720;
  partcv[0] = 1;
  Object opresult7724 = callmethod(call7723, "==", 1, partcv, params);
// compilenode returning opresult7724
  params[0] = block7701;
  partcv[0] = 1;
  Object call7725 = callmethod(opresult7724, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe7700);
// compilenode returning call7725
  Object if7699 = done;
  if (istrue(call7725)) {
// Begin line 2409
  setline(2409);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2408
  setline(2408);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7726 = alloc_Boolean(1);
// compilenode returning bool7726
  *var_hasAccessibility = bool7726;
  if (bool7726 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7699 = done;
  } else {
  }
// compilenode returning if7699
  gc_frame_end(frame);
  return if7699;
}
Object meth_parser_vardec7437(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "vardec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_defaultVarVisibility = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for vardec (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for vardec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "line");
  Object *var_pos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "pos");
  Object *var_varTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "varTok");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextToken = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextToken");
  Object *var_val = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "val");
  Object *var_dtype = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "dtype");
  Object *var_name = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "name");
  Object *var_anns = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "anns");
  Object *var_suggestions = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "suggestions");
  Object *var_nextTok = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "nextTok");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
  Object *var_hasVisibility = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "hasVisibility");
  Object *var_hasAccessibility = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "hasAccessibility");
// Begin line 2423
  setline(2423);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2334
  setline(2334);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7441 == NULL) {
    strlit7441 = alloc_String("var");
    gc_root(strlit7441);
  }
// compilenode returning strlit7441
  int op_slot_right_7440 = gc_frame_newslot(strlit7441);
  int callframe7443 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7444 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7443);
// compilenode returning call7444
// compilenode returning call7444
  int op_slot_left_7440 = gc_frame_newslot(call7444);
  params[0] = strlit7441;
  partcv[0] = 1;
  Object opresult7445 = callmethod(call7444, "==", 1, partcv, params);
// compilenode returning opresult7445
  int op_slot_right_7439 = gc_frame_newslot(opresult7445);
  int callframe7447 = gc_frame_new();
  if (strlit7448 == NULL) {
    strlit7448 = alloc_String("keyword");
    gc_root(strlit7448);
  }
// compilenode returning strlit7448
  gc_frame_newslot(strlit7448);
  params[0] = strlit7448;
  partcv[0] = 1;
  Object call7449 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7447);
// compilenode returning call7449
  int op_slot_left_7439 = gc_frame_newslot(call7449);
  params[0] = opresult7445;
  partcv[0] = 1;
  Object opresult7450 = callmethod(call7449, "&&", 1, partcv, params);
// compilenode returning opresult7450
  Object if7438 = done;
  if (istrue(opresult7450)) {
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2335
  setline(2335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7451 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7452 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7451);
// compilenode returning call7452
// compilenode returning call7452
  *var_line = call7452;
  if (call7452 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2336
  setline(2336);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7453 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7454 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7453);
// compilenode returning call7454
// compilenode returning call7454
  *var_pos = call7454;
  if (call7454 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2337
  setline(2337);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_varTok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2338
  setline(2338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7455 = gc_frame_new();
  partcv[0] = 0;
  Object call7456 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7455);
// compilenode returning call7456
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2339
  setline(2339);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7459 == NULL) {
    strlit7459 = alloc_String("identifier");
    gc_root(strlit7459);
  }
// compilenode returning strlit7459
  int op_slot_right_7458 = gc_frame_newslot(strlit7459);
  int callframe7461 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7462 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7461);
// compilenode returning call7462
// compilenode returning call7462
  int op_slot_left_7458 = gc_frame_newslot(call7462);
  params[0] = strlit7459;
  partcv[0] = 1;
  Object opresult7463 = callmethod(call7462, "!=", 1, partcv, params);
// compilenode returning opresult7463
  Object if7457 = done;
  if (istrue(opresult7463)) {
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2340
  setline(2340);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7464 = gc_frame_new();
  int callframe7465 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7466 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7465);
// compilenode returning call7466
// compilenode returning call7466
  partcv[0] = 0;
  Object call7467 = callmethod(call7466, "new",
    1, partcv, params);
  gc_frame_end(callframe7464);
// compilenode returning call7467
// compilenode returning call7467
  *var_suggestion = call7467;
  if (call7467 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2341
  setline(2341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7468 = gc_frame_new();
  Object block7469 = alloc_Block(NULL, NULL, "parser", 2341);
  gc_frame_newslot(block7469);
  block_savedest(block7469);
  Object closure7470 = createclosure(2, "_apply");
setclosureframe(closure7470, stackframe);
  addtoclosure(closure7470, var_sym);
  addtoclosure(closure7470, selfslot);
  struct UserObject *uo7470 = (struct UserObject*)block7469;
  uo7470->data[0] = (Object)closure7470;
  Method *meth_meth_parser__apply7470 = addmethod2pos(block7469, "_apply", &meth_parser__apply7470, 0);
int argcv_meth_parser__apply7470[] = {1};
meth_meth_parser__apply7470->type = alloc_MethodType(1, argcv_meth_parser__apply7470);
  meth_meth_parser__apply7470->definitionModule = modulename;
  meth_meth_parser__apply7470->definitionLine = 2340;
// compilenode returning block7469
  gc_frame_newslot(block7469);
  params[0] = block7469;
  partcv[0] = 1;
  Object call7488 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7468);
// compilenode returning call7488
  *var_nextToken = call7488;
  if (call7488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2343
  setline(2343);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7490 = gc_frame_new();
  Object block7491 = alloc_Block(NULL, NULL, "parser", 2343);
  gc_frame_newslot(block7491);
  block_savedest(block7491);
  Object closure7492 = createclosure(3, "_apply");
setclosureframe(closure7492, stackframe);
  addtoclosure(closure7492, var_sym);
  addtoclosure(closure7492, var_nextToken);
  addtoclosure(closure7492, selfslot);
  struct UserObject *uo7492 = (struct UserObject*)block7491;
  uo7492->data[0] = (Object)closure7492;
  Method *meth_meth_parser__apply7492 = addmethod2pos(block7491, "_apply", &meth_parser__apply7492, 0);
int argcv_meth_parser__apply7492[] = {0};
meth_meth_parser__apply7492->type = alloc_MethodType(1, argcv_meth_parser__apply7492);
  meth_meth_parser__apply7492->definitionModule = modulename;
  meth_meth_parser__apply7492->definitionLine = 2341;
// compilenode returning block7491
  gc_frame_newslot(block7491);
  Object bool7498 = alloc_Boolean(0);
// compilenode returning bool7498
  int op_slot_right_7497 = gc_frame_newslot(bool7498);
// compilenode returning *var_nextToken
  int op_slot_left_7497 = gc_frame_newslot(*var_nextToken);
  params[0] = bool7498;
  partcv[0] = 1;
  Object opresult7500 = callmethod(*var_nextToken, "==", 1, partcv, params);
// compilenode returning opresult7500
  params[0] = block7491;
  partcv[0] = 1;
  Object call7501 = callmethod(opresult7500, "orElse",
    1, partcv, params);
  gc_frame_end(callframe7490);
// compilenode returning call7501
  Object if7489 = done;
  if (istrue(call7501)) {
// Begin line 2344
  setline(2344);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7502 = gc_frame_new();
  if (strlit7503 == NULL) {
    strlit7503 = alloc_String(" ""\xc2""""\xab""name""\xc2""""\xbb""");
    gc_root(strlit7503);
  }
// compilenode returning strlit7503
  gc_frame_newslot(strlit7503);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7503;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7504 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7502);
// compilenode returning call7504
    gc_frame_newslot(call7504);
    if7489 = call7504;
  } else {
// Begin line 2346
  setline(2346);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7505 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe7506 = gc_frame_new();
// compilenode returning *var_nextToken
  partcv[0] = 0;
  Object call7507 = callmethod(*var_nextToken, "prev",
    1, partcv, params);
  gc_frame_end(callframe7506);
// compilenode returning call7507
// compilenode returning call7507
  gc_frame_newslot(call7507);
  Object bool7508 = alloc_Boolean(0);
// compilenode returning bool7508
  gc_frame_newslot(bool7508);
  Object bool7509 = alloc_Boolean(1);
// compilenode returning bool7509
  gc_frame_newslot(bool7509);
  if (strlit7510 == NULL) {
    strlit7510 = alloc_String("""\xc2""""\xab""name""\xc2""""\xbb"" ");
    gc_root(strlit7510);
  }
// compilenode returning strlit7510
  gc_frame_newslot(strlit7510);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call7507;
  params[2] = bool7508;
  params[3] = bool7509;
  params[4] = strlit7510;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7511 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7505);
// compilenode returning call7511
    gc_frame_newslot(call7511);
    if7489 = call7511;
  }
// compilenode returning if7489
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7512 = gc_frame_new();
  if (strlit7513 == NULL) {
    strlit7513 = alloc_String("A variable declaration must have a name after the 'var'.");
    gc_root(strlit7513);
  }
// compilenode returning strlit7513
  gc_frame_newslot(strlit7513);
// Begin line 2349
  setline(2349);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7514 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7515 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7514);
// compilenode returning call7515
// compilenode returning call7515
  gc_frame_newslot(call7515);
  int callframe7516 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7517 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7516);
// compilenode returning call7517
// compilenode returning call7517
  gc_frame_newslot(call7517);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2348
  setline(2348);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7513;
  params[1] = call7515;
  params[2] = call7517;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7518 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7512);
// compilenode returning call7518
    gc_frame_newslot(call7518);
    if7457 = call7518;
  } else {
  }
// compilenode returning if7457
// Begin line 2351
  setline(2351);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7519 = gc_frame_new();
  partcv[0] = 0;
  Object call7520 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7519);
// compilenode returning call7520
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2352
  setline(2352);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7521 = alloc_Boolean(0);
// compilenode returning bool7521
  *var_val = bool7521;
  if (bool7521 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2353
  setline(2353);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7522 = gc_frame_new();
  if (strlit7523 == NULL) {
    strlit7523 = alloc_String("Unknown");
    gc_root(strlit7523);
  }
// compilenode returning strlit7523
  gc_frame_newslot(strlit7523);
  Object bool7524 = alloc_Boolean(0);
// compilenode returning bool7524
  gc_frame_newslot(bool7524);
  int callframe7525 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7526 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7525);
// compilenode returning call7526
// compilenode returning call7526
  params[0] = strlit7523;
  params[1] = bool7524;
  partcv[0] = 2;
  Object call7527 = callmethod(call7526, "new",
    1, partcv, params);
  gc_frame_end(callframe7522);
// compilenode returning call7527
  *var_dtype = call7527;
  if (call7527 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2354
  setline(2354);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7528 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7529 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7528);
// compilenode returning call7529
// compilenode returning call7529
  *var_name = call7529;
  if (call7529 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2355
  setline(2355);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7531 = gc_frame_new();
  if (strlit7532 == NULL) {
    strlit7532 = alloc_String("colon");
    gc_root(strlit7532);
  }
// compilenode returning strlit7532
  gc_frame_newslot(strlit7532);
  params[0] = strlit7532;
  partcv[0] = 1;
  Object call7533 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7531);
// compilenode returning call7533
  Object if7530 = done;
  if (istrue(call7533)) {
// Begin line 2356
  setline(2356);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7534 = gc_frame_new();
  partcv[0] = 0;
  Object call7535 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7534);
// compilenode returning call7535
// Begin line 2357
  setline(2357);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7536 = gc_frame_new();
  partcv[0] = 0;
  Object call7537 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7536);
// compilenode returning call7537
// Begin line 2359
  setline(2359);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2358
  setline(2358);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7538 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7539 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7538);
// compilenode returning call7539
// compilenode returning call7539
  *var_dtype = call7539;
  if (call7539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7530 = done;
  } else {
  }
// compilenode returning if7530
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2360
  setline(2360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7541 = gc_frame_new();
  partcv[0] = 0;
  Object call7542 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7541);
// compilenode returning call7542
  *var_anns = call7542;
  if (call7542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2361
  setline(2361);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7544 = gc_frame_new();
  if (strlit7545 == NULL) {
    strlit7545 = alloc_String("bind");
    gc_root(strlit7545);
  }
// compilenode returning strlit7545
  gc_frame_newslot(strlit7545);
  params[0] = strlit7545;
  partcv[0] = 1;
  Object call7546 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7544);
// compilenode returning call7546
  Object if7543 = done;
  if (istrue(call7546)) {
// Begin line 2362
  setline(2362);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7547 = gc_frame_new();
  partcv[0] = 0;
  Object call7548 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7547);
// compilenode returning call7548
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2363
  setline(2363);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7550 = gc_frame_new();
  int callframe7551 = gc_frame_new();
  Object block7552 = alloc_Block(NULL, NULL, "parser", 2363);
  gc_frame_newslot(block7552);
  block_savedest(block7552);
  Object closure7553 = createclosure(1, "_apply");
setclosureframe(closure7553, stackframe);
  addtoclosure(closure7553, selfslot);
  struct UserObject *uo7553 = (struct UserObject*)block7552;
  uo7553->data[0] = (Object)closure7553;
  Method *meth_meth_parser__apply7553 = addmethod2pos(block7552, "_apply", &meth_parser__apply7553, 0);
int argcv_meth_parser__apply7553[] = {0};
meth_meth_parser__apply7553->type = alloc_MethodType(1, argcv_meth_parser__apply7553);
  meth_meth_parser__apply7553->definitionModule = modulename;
  meth_meth_parser__apply7553->definitionLine = 2363;
// compilenode returning block7552
  gc_frame_newslot(block7552);
  params[0] = block7552;
  partcv[0] = 1;
  Object call7557 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7551);
// compilenode returning call7557
  partcv[0] = 0;
  Object call7558 = callmethod(call7557, "not",
    1, partcv, params);
  gc_frame_end(callframe7550);
// compilenode returning call7558
// compilenode returning call7558
  Object if7549 = done;
  if (istrue(call7558)) {
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2364
  setline(2364);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7559 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7559
  *var_suggestions = array7559;
  if (array7559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2365
  setline(2365);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7560 = gc_frame_new();
  int callframe7561 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7562 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7561);
// compilenode returning call7562
// compilenode returning call7562
  partcv[0] = 0;
  Object call7563 = callmethod(call7562, "new",
    1, partcv, params);
  gc_frame_end(callframe7560);
// compilenode returning call7563
// compilenode returning call7563
  *var_suggestion = call7563;
  if (call7563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2366
  setline(2366);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7564 = gc_frame_new();
  partcv[0] = 0;
  Object call7565 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7564);
// compilenode returning call7565
  *var_nextTok = call7565;
  if (call7565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2367
  setline(2367);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_7567 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_7567 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7569 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult7569
  Object if7566 = done;
  if (istrue(opresult7569)) {
// Begin line 2368
  setline(2368);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7570 = gc_frame_new();
  if (strlit7571 == NULL) {
    strlit7571 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7571);
  }
// compilenode returning strlit7571
  gc_frame_newslot(strlit7571);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7571;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7572 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7570);
// compilenode returning call7572
    gc_frame_newslot(call7572);
    if7566 = call7572;
  } else {
// Begin line 2370
  setline(2370);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7573 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe7574 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7575 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7574);
// compilenode returning call7575
// compilenode returning call7575
  gc_frame_newslot(call7575);
  Object bool7576 = alloc_Boolean(1);
// compilenode returning bool7576
  gc_frame_newslot(bool7576);
  Object bool7577 = alloc_Boolean(0);
// compilenode returning bool7577
  gc_frame_newslot(bool7577);
  if (strlit7578 == NULL) {
    strlit7578 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7578);
  }
// compilenode returning strlit7578
  gc_frame_newslot(strlit7578);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call7575;
  params[2] = bool7576;
  params[3] = bool7577;
  params[4] = strlit7578;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7579 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7573);
// compilenode returning call7579
    gc_frame_newslot(call7579);
    if7566 = call7579;
  }
// compilenode returning if7566
// Begin line 2372
  setline(2372);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7580 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7581 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7580);
// compilenode returning call7581
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2373
  setline(2373);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7582 = gc_frame_new();
  int callframe7583 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7584 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7583);
// compilenode returning call7584
// compilenode returning call7584
  partcv[0] = 0;
  Object call7585 = callmethod(call7584, "new",
    1, partcv, params);
  gc_frame_end(callframe7582);
// compilenode returning call7585
// compilenode returning call7585
  *var_suggestion = call7585;
  if (call7585 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2374
  setline(2374);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7587 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe7588 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7589 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7588);
// compilenode returning call7589
// compilenode returning call7589
  gc_frame_newslot(call7589);
  Object bool7590 = alloc_Boolean(1);
// compilenode returning bool7590
  gc_frame_newslot(bool7590);
  Object bool7591 = alloc_Boolean(0);
// compilenode returning bool7591
  gc_frame_newslot(bool7591);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call7589;
  params[2] = bool7590;
  params[3] = bool7591;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7592 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7587);
// compilenode returning call7592
// Begin line 2375
  setline(2375);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7593 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7594 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7593);
// compilenode returning call7594
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7595 = gc_frame_new();
// Begin line 2377
  setline(2377);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7597 == NULL) {
    strlit7597 = alloc_String("A variable without a value can be declared with 'var' followed only by the variable name.");
    gc_root(strlit7597);
  }
// compilenode returning strlit7597
  int op_slot_right_7596 = gc_frame_newslot(strlit7597);
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7599 == NULL) {
    strlit7599 = alloc_String("A variable declaration must have a value after the ':='. ");
    gc_root(strlit7599);
  }
// compilenode returning strlit7599
  int op_slot_left_7596 = gc_frame_newslot(strlit7599);
  params[0] = strlit7597;
  partcv[0] = 1;
  Object opresult7600 = callmethod(strlit7599, "++", 1, partcv, params);
// compilenode returning opresult7600
  gc_frame_newslot(opresult7600);
// Begin line 2378
  setline(2378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7601 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7602 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7601);
// compilenode returning call7602
// compilenode returning call7602
  gc_frame_newslot(call7602);
  int callframe7604 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7605 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7604);
// compilenode returning call7605
// compilenode returning call7605
  int op_slot_right_7603 = gc_frame_newslot(call7605);
  int callframe7607 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7608 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7607);
// compilenode returning call7608
// compilenode returning call7608
  int op_slot_left_7603 = gc_frame_newslot(call7608);
  params[0] = call7605;
  partcv[0] = 1;
  Object sum7609 = callmethod(call7608, "+", 1, partcv, params);
// compilenode returning sum7609
  gc_frame_newslot(sum7609);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2376
  setline(2376);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult7600;
  params[1] = call7602;
  params[2] = sum7609;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7610 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7595);
// compilenode returning call7610
    gc_frame_newslot(call7610);
    if7549 = call7610;
  } else {
  }
// compilenode returning if7549
// Begin line 2381
  setline(2381);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2380
  setline(2380);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7611 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7612 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7611);
// compilenode returning call7612
// compilenode returning call7612
  *var_val = call7612;
  if (call7612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7543 = done;
  } else {
// Begin line 2394
  setline(2394);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2382
  setline(2382);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7617 == NULL) {
    strlit7617 = alloc_String("=");
    gc_root(strlit7617);
  }
// compilenode returning strlit7617
  int op_slot_right_7616 = gc_frame_newslot(strlit7617);
  int callframe7619 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7620 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7619);
// compilenode returning call7620
// compilenode returning call7620
  int op_slot_left_7616 = gc_frame_newslot(call7620);
  params[0] = strlit7617;
  partcv[0] = 1;
  Object opresult7621 = callmethod(call7620, "==", 1, partcv, params);
// compilenode returning opresult7621
  int op_slot_right_7615 = gc_frame_newslot(opresult7621);
  int callframe7623 = gc_frame_new();
  if (strlit7624 == NULL) {
    strlit7624 = alloc_String("op");
    gc_root(strlit7624);
  }
// compilenode returning strlit7624
  gc_frame_newslot(strlit7624);
  params[0] = strlit7624;
  partcv[0] = 1;
  Object call7625 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7623);
// compilenode returning call7625
  int op_slot_left_7615 = gc_frame_newslot(call7625);
  params[0] = opresult7621;
  partcv[0] = 1;
  Object opresult7626 = callmethod(call7625, "&&", 1, partcv, params);
// compilenode returning opresult7626
  Object if7614 = done;
  if (istrue(opresult7626)) {
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2383
  setline(2383);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7627 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7627
  *var_suggestions = array7627;
  if (array7627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2384
  setline(2384);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7628 = gc_frame_new();
  int callframe7629 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7630 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7629);
// compilenode returning call7630
// compilenode returning call7630
  partcv[0] = 0;
  Object call7631 = callmethod(call7630, "new",
    1, partcv, params);
  gc_frame_end(callframe7628);
// compilenode returning call7631
// compilenode returning call7631
  *var_suggestion = call7631;
  if (call7631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2385
  setline(2385);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7632 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit7633 == NULL) {
    strlit7633 = alloc_String(":=");
    gc_root(strlit7633);
  }
// compilenode returning strlit7633
  gc_frame_newslot(strlit7633);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit7633;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7634 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7632);
// compilenode returning call7634
// Begin line 2386
  setline(2386);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7635 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7636 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7635);
// compilenode returning call7636
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2387
  setline(2387);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7637 = gc_frame_new();
  int callframe7638 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7639 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7638);
// compilenode returning call7639
// compilenode returning call7639
  partcv[0] = 0;
  Object call7640 = callmethod(call7639, "new",
    1, partcv, params);
  gc_frame_end(callframe7637);
// compilenode returning call7640
// compilenode returning call7640
  *var_suggestion = call7640;
  if (call7640 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2388
  setline(2388);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7642 = gc_frame_new();
// compilenode returning *var_varTok
  gc_frame_newslot(*var_varTok);
  if (strlit7643 == NULL) {
    strlit7643 = alloc_String("def");
    gc_root(strlit7643);
  }
// compilenode returning strlit7643
  gc_frame_newslot(strlit7643);
// compilenode returning *var_suggestion
  params[0] = *var_varTok;
  params[1] = strlit7643;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7644 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7642);
// compilenode returning call7644
// Begin line 2389
  setline(2389);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7645 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7646 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7645);
// compilenode returning call7646
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7647 = gc_frame_new();
  if (strlit7648 == NULL) {
    strlit7648 = alloc_String("A variable declaration must use ':=' instead of '='. A constant declaration uses 'def' and '='.");
    gc_root(strlit7648);
  }
// compilenode returning strlit7648
  gc_frame_newslot(strlit7648);
// Begin line 2391
  setline(2391);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7649 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7650 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7649);
// compilenode returning call7650
// compilenode returning call7650
  gc_frame_newslot(call7650);
  int callframe7651 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7652 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7651);
// compilenode returning call7652
// compilenode returning call7652
  gc_frame_newslot(call7652);
  int callframe7653 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7654 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7653);
// compilenode returning call7654
// compilenode returning call7654
  gc_frame_newslot(call7654);
// Begin line 2392
  setline(2392);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2390
  setline(2390);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7648;
  params[1] = call7650;
  params[2] = call7652;
  params[3] = call7654;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call7655 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7647);
// compilenode returning call7655
    gc_frame_newslot(call7655);
    if7614 = call7655;
  } else {
  }
// compilenode returning if7614
    gc_frame_newslot(if7614);
    if7543 = if7614;
  }
// compilenode returning if7543
// Begin line 2395
  setline(2395);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7656 = gc_frame_new();
// compilenode returning *var_name
  gc_frame_newslot(*var_name);
// compilenode returning *var_val
  gc_frame_newslot(*var_val);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
  int callframe7657 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7658 = callmethod(*var_ast, "varDecNode",
    1, partcv, params);
  gc_frame_end(callframe7657);
// compilenode returning call7658
// compilenode returning call7658
  params[0] = *var_name;
  params[1] = *var_val;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call7659 = callmethod(call7658, "new",
    1, partcv, params);
  gc_frame_end(callframe7656);
// compilenode returning call7659
  *var_o = call7659;
  if (call7659 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2396
  setline(2396);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7660 = alloc_Boolean(0);
// compilenode returning bool7660
  *var_hasVisibility = bool7660;
  if (bool7660 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2397
  setline(2397);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7661 = alloc_Boolean(0);
// compilenode returning bool7661
  *var_hasAccessibility = bool7661;
  if (bool7661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2398
  setline(2398);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7664 = alloc_Boolean(0);
// compilenode returning bool7664
  int op_slot_right_7663 = gc_frame_newslot(bool7664);
// compilenode returning *var_anns
  int op_slot_left_7663 = gc_frame_newslot(*var_anns);
  params[0] = bool7664;
  partcv[0] = 1;
  Object opresult7666 = callmethod(*var_anns, "!=", 1, partcv, params);
// compilenode returning opresult7666
  Object if7662 = done;
  if (istrue(opresult7666)) {
// Begin line 2399
  setline(2399);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7667 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  Object block7668 = alloc_Block(NULL, NULL, "parser", 2399);
  gc_frame_newslot(block7668);
  block_savedest(block7668);
  Object closure7669 = createclosure(3, "_apply");
setclosureframe(closure7669, stackframe);
  addtoclosure(closure7669, var_hasVisibility);
  addtoclosure(closure7669, var_hasAccessibility);
  addtoclosure(closure7669, selfslot);
  struct UserObject *uo7669 = (struct UserObject*)block7668;
  uo7669->data[0] = (Object)closure7669;
  Method *meth_meth_parser__apply7669 = addmethod2pos(block7668, "_apply", &meth_parser__apply7669, 0);
int argcv_meth_parser__apply7669[] = {1};
meth_meth_parser__apply7669->type = alloc_MethodType(1, argcv_meth_parser__apply7669);
  meth_meth_parser__apply7669->definitionModule = modulename;
  meth_meth_parser__apply7669->definitionLine = 2395;
// compilenode returning block7668
  gc_frame_newslot(block7668);
  params[0] = *var_anns;
  params[1] = block7668;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7729 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7667);
// compilenode returning call7729
// Begin line 2411
  setline(2411);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7730 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe7731 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call7732 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7731);
// compilenode returning call7732
// compilenode returning call7732
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call7733 = callmethod(call7732, "extend",
    1, partcv, params);
  gc_frame_end(callframe7730);
// compilenode returning call7733
    gc_frame_newslot(call7733);
    if7662 = call7733;
  } else {
  }
// compilenode returning if7662
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2413
  setline(2413);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7736 = gc_frame_new();
// compilenode returning *var_hasAccessibility
  partcv[0] = 0;
  Object call7737 = callmethod(*var_hasAccessibility, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7736);
// compilenode returning call7737
  int op_slot_right_7735 = gc_frame_newslot(call7737);
  int callframe7739 = gc_frame_new();
// compilenode returning *var_hasVisibility
  partcv[0] = 0;
  Object call7740 = callmethod(*var_hasVisibility, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe7739);
// compilenode returning call7740
  int op_slot_left_7735 = gc_frame_newslot(call7740);
  params[0] = call7737;
  partcv[0] = 1;
  Object opresult7741 = callmethod(call7740, "&&", 1, partcv, params);
// compilenode returning opresult7741
  Object if7734 = done;
  if (istrue(opresult7741)) {
// Begin line 2420
  setline(2420);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2414
  setline(2414);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7744 == NULL) {
    strlit7744 = alloc_String("public");
    gc_root(strlit7744);
  }
// compilenode returning strlit7744
  int op_slot_right_7743 = gc_frame_newslot(strlit7744);
// compilenode returning *var_defaultVarVisibility
  int op_slot_left_7743 = gc_frame_newslot(*var_defaultVarVisibility);
  params[0] = strlit7744;
  partcv[0] = 1;
  Object opresult7746 = callmethod(*var_defaultVarVisibility, "==", 1, partcv, params);
// compilenode returning opresult7746
  Object if7742 = done;
  if (istrue(opresult7746)) {
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7747 = gc_frame_new();
  int callframe7748 = gc_frame_new();
  if (strlit7749 == NULL) {
    strlit7749 = alloc_String("readable");
    gc_root(strlit7749);
  }
// compilenode returning strlit7749
  gc_frame_newslot(strlit7749);
// Begin line 2416
  setline(2416);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7750 = alloc_Boolean(0);
// compilenode returning bool7750
  gc_frame_newslot(bool7750);
// Begin line 2415
  setline(2415);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7751 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7752 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7751);
// compilenode returning call7752
// compilenode returning call7752
  params[0] = strlit7749;
  params[1] = bool7750;
  partcv[0] = 2;
  Object call7753 = callmethod(call7752, "new",
    1, partcv, params);
  gc_frame_end(callframe7748);
// compilenode returning call7753
  gc_frame_newslot(call7753);
  int callframe7754 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call7755 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7754);
// compilenode returning call7755
// compilenode returning call7755
  params[0] = call7753;
  partcv[0] = 1;
  Object call7756 = callmethod(call7755, "push",
    1, partcv, params);
  gc_frame_end(callframe7747);
// compilenode returning call7756
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7757 = gc_frame_new();
  int callframe7758 = gc_frame_new();
  if (strlit7759 == NULL) {
    strlit7759 = alloc_String("writable");
    gc_root(strlit7759);
  }
// compilenode returning strlit7759
  gc_frame_newslot(strlit7759);
// Begin line 2418
  setline(2418);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool7760 = alloc_Boolean(0);
// compilenode returning bool7760
  gc_frame_newslot(bool7760);
// Begin line 2417
  setline(2417);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7761 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7762 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe7761);
// compilenode returning call7762
// compilenode returning call7762
  params[0] = strlit7759;
  params[1] = bool7760;
  partcv[0] = 2;
  Object call7763 = callmethod(call7762, "new",
    1, partcv, params);
  gc_frame_end(callframe7758);
// compilenode returning call7763
  gc_frame_newslot(call7763);
  int callframe7764 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call7765 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe7764);
// compilenode returning call7765
// compilenode returning call7765
  params[0] = call7763;
  partcv[0] = 1;
  Object call7766 = callmethod(call7765, "push",
    1, partcv, params);
  gc_frame_end(callframe7757);
// compilenode returning call7766
    gc_frame_newslot(call7766);
    if7742 = call7766;
  } else {
  }
// compilenode returning if7742
    gc_frame_newslot(if7742);
    if7734 = if7742;
  } else {
  }
// compilenode returning if7734
// Begin line 2421
  setline(2421);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7767 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7768 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7767);
// compilenode returning call7768
    gc_frame_newslot(call7768);
    if7438 = call7768;
  } else {
  }
// compilenode returning if7438
  gc_frame_end(frame);
  return if7438;
}
Object meth_parser__apply7779(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe7780 = gc_frame_new();
  partcv[0] = 0;
  Object call7781 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7780);
// compilenode returning call7781
  gc_frame_end(frame);
  return call7781;
}
Object meth_parser__apply7787(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe7788 = gc_frame_new();
  if (strlit7789 == NULL) {
    strlit7789 = alloc_String("comma");
    gc_root(strlit7789);
  }
// compilenode returning strlit7789
  gc_frame_newslot(strlit7789);
  params[0] = strlit7789;
  partcv[0] = 1;
  Object call7790 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7788);
// compilenode returning call7790
  gc_frame_end(frame);
  return call7790;
}
Object meth_parser__apply7805(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe7806 = gc_frame_new();
  partcv[0] = 0;
  Object call7807 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7806);
// compilenode returning call7807
  gc_frame_end(frame);
  return call7807;
}
Object meth_parser__apply7793(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2433
  setline(2433);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7794 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7795 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7794);
// compilenode returning call7795
// compilenode returning call7795
  *var_tmp = call7795;
  if (call7795 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2434
  setline(2434);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7797 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_params
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7798 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7797);
// compilenode returning call7798
// Begin line 2435
  setline(2435);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7799 = gc_frame_new();
  partcv[0] = 0;
  Object call7800 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7799);
// compilenode returning call7800
// Begin line 2452
  setline(2452);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2436
  setline(2436);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7802 = gc_frame_new();
  int callframe7803 = gc_frame_new();
  Object block7804 = alloc_Block(NULL, NULL, "parser", 2436);
  gc_frame_newslot(block7804);
  block_savedest(block7804);
  Object closure7805 = createclosure(1, "_apply");
setclosureframe(closure7805, stackframe);
  addtoclosure(closure7805, selfslot);
  struct UserObject *uo7805 = (struct UserObject*)block7804;
  uo7805->data[0] = (Object)closure7805;
  Method *meth_meth_parser__apply7805 = addmethod2pos(block7804, "_apply", &meth_parser__apply7805, 0);
int argcv_meth_parser__apply7805[] = {0};
meth_meth_parser__apply7805->type = alloc_MethodType(1, argcv_meth_parser__apply7805);
  meth_meth_parser__apply7805->definitionModule = modulename;
  meth_meth_parser__apply7805->definitionLine = 2436;
// compilenode returning block7804
  gc_frame_newslot(block7804);
  params[0] = block7804;
  partcv[0] = 1;
  Object call7809 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7803);
// compilenode returning call7809
  partcv[0] = 0;
  Object call7810 = callmethod(call7809, "not",
    1, partcv, params);
  gc_frame_end(callframe7802);
// compilenode returning call7810
// compilenode returning call7810
  Object if7801 = done;
  if (istrue(call7810)) {
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2437
  setline(2437);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7811 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7811
  *var_suggestions = array7811;
  if (array7811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2438
  setline(2438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7812 = gc_frame_new();
  int callframe7813 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7814 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7813);
// compilenode returning call7814
// compilenode returning call7814
  partcv[0] = 0;
  Object call7815 = callmethod(call7814, "new",
    1, partcv, params);
  gc_frame_end(callframe7812);
// compilenode returning call7815
// compilenode returning call7815
  *var_suggestion = call7815;
  if (call7815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2439
  setline(2439);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7816 = gc_frame_new();
  if (strlit7817 == NULL) {
    strlit7817 = alloc_String("rsquare");
    gc_root(strlit7817);
  }
// compilenode returning strlit7817
  gc_frame_newslot(strlit7817);
  params[0] = strlit7817;
  partcv[0] = 1;
  Object call7818 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7816);
// compilenode returning call7818
  *var_nextTok = call7818;
  if (call7818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2440
  setline(2440);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_7820 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_7820 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult7822 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult7822
  Object if7819 = done;
  if (istrue(opresult7822)) {
// Begin line 2441
  setline(2441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7823 = gc_frame_new();
  if (strlit7824 == NULL) {
    strlit7824 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7824);
  }
// compilenode returning strlit7824
  gc_frame_newslot(strlit7824);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7824;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7825 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7823);
// compilenode returning call7825
    gc_frame_newslot(call7825);
    if7819 = call7825;
  } else {
// Begin line 2443
  setline(2443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7826 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe7827 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7828 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7827);
// compilenode returning call7828
// compilenode returning call7828
  gc_frame_newslot(call7828);
  Object bool7829 = alloc_Boolean(1);
// compilenode returning bool7829
  gc_frame_newslot(bool7829);
  Object bool7830 = alloc_Boolean(0);
// compilenode returning bool7830
  gc_frame_newslot(bool7830);
  if (strlit7831 == NULL) {
    strlit7831 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit7831);
  }
// compilenode returning strlit7831
  gc_frame_newslot(strlit7831);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call7828;
  params[2] = bool7829;
  params[3] = bool7830;
  params[4] = strlit7831;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call7832 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe7826);
// compilenode returning call7832
    gc_frame_newslot(call7832);
    if7819 = call7832;
  }
// compilenode returning if7819
// Begin line 2445
  setline(2445);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7833 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7834 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7833);
// compilenode returning call7834
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2446
  setline(2446);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7835 = gc_frame_new();
  int callframe7836 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7837 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7836);
// compilenode returning call7837
// compilenode returning call7837
  partcv[0] = 0;
  Object call7838 = callmethod(call7837, "new",
    1, partcv, params);
  gc_frame_end(callframe7835);
// compilenode returning call7838
// compilenode returning call7838
  *var_suggestion = call7838;
  if (call7838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2447
  setline(2447);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7840 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe7841 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call7842 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe7841);
// compilenode returning call7842
// compilenode returning call7842
  gc_frame_newslot(call7842);
  Object bool7843 = alloc_Boolean(1);
// compilenode returning bool7843
  gc_frame_newslot(bool7843);
  Object bool7844 = alloc_Boolean(0);
// compilenode returning bool7844
  gc_frame_newslot(bool7844);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call7842;
  params[2] = bool7843;
  params[3] = bool7844;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call7845 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe7840);
// compilenode returning call7845
// Begin line 2448
  setline(2448);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7846 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call7847 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe7846);
// compilenode returning call7847
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7848 = gc_frame_new();
  if (strlit7849 == NULL) {
    strlit7849 = alloc_String("A list must contain zero or more valid expressions separated by commas.");
    gc_root(strlit7849);
  }
// compilenode returning strlit7849
  gc_frame_newslot(strlit7849);
// Begin line 2450
  setline(2450);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7850 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7851 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7850);
// compilenode returning call7851
// compilenode returning call7851
  gc_frame_newslot(call7851);
  int callframe7852 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7853 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7852);
// compilenode returning call7853
// compilenode returning call7853
  gc_frame_newslot(call7853);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2449
  setline(2449);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7849;
  params[1] = call7851;
  params[2] = call7853;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7854 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe7848);
// compilenode returning call7854
    gc_frame_newslot(call7854);
    if7801 = call7854;
  } else {
  }
// compilenode returning if7801
  gc_frame_end(frame);
  return if7801;
}
Object meth_parser__apply7784(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_tmp = getfromclosure(closure, 1);
  Object *var_params = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2432
  setline(2432);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7785 = gc_frame_new();
  Object block7786 = alloc_Block(NULL, NULL, "parser", 2432);
  gc_frame_newslot(block7786);
  block_savedest(block7786);
  Object closure7787 = createclosure(1, "_apply");
setclosureframe(closure7787, stackframe);
  addtoclosure(closure7787, selfslot);
  struct UserObject *uo7787 = (struct UserObject*)block7786;
  uo7787->data[0] = (Object)closure7787;
  Method *meth_meth_parser__apply7787 = addmethod2pos(block7786, "_apply", &meth_parser__apply7787, 0);
int argcv_meth_parser__apply7787[] = {0};
meth_meth_parser__apply7787->type = alloc_MethodType(1, argcv_meth_parser__apply7787);
  meth_meth_parser__apply7787->definitionModule = modulename;
  meth_meth_parser__apply7787->definitionLine = 2417;
// compilenode returning block7786
  gc_frame_newslot(block7786);
  Object block7792 = alloc_Block(NULL, NULL, "parser", 2432);
  gc_frame_newslot(block7792);
  block_savedest(block7792);
  Object closure7793 = createclosure(7, "_apply");
setclosureframe(closure7793, stackframe);
  addtoclosure(closure7793, var_values);
  addtoclosure(closure7793, var_tmp);
  addtoclosure(closure7793, var_params);
  addtoclosure(closure7793, var_errormessages);
  addtoclosure(closure7793, var_sym);
  addtoclosure(closure7793, var_lastToken);
  addtoclosure(closure7793, selfslot);
  struct UserObject *uo7793 = (struct UserObject*)block7792;
  uo7793->data[0] = (Object)closure7793;
  Method *meth_meth_parser__apply7793 = addmethod2pos(block7792, "_apply", &meth_parser__apply7793, 0);
int argcv_meth_parser__apply7793[] = {0};
meth_meth_parser__apply7793->type = alloc_MethodType(1, argcv_meth_parser__apply7793);
  meth_meth_parser__apply7793->definitionModule = modulename;
  meth_meth_parser__apply7793->definitionLine = 2417;
// compilenode returning block7792
  gc_frame_newslot(block7792);
  params[0] = block7786;
  params[1] = block7792;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7856 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7785);
// compilenode returning call7856
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2453
  setline(2453);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7857 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call7858 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe7857);
// compilenode returning call7858
// compilenode returning call7858
  *var_tmp = call7858;
  if (call7858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2454
  setline(2454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7860 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
// compilenode returning *var_params
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call7861 = callmethod(*var_params, "push",
    1, partcv, params);
  gc_frame_end(callframe7860);
// compilenode returning call7861
  gc_frame_end(frame);
  return call7861;
}
Object meth_parser_doarray7769(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doarray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doarray (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doarray");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_tmp = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "tmp");
  Object *var_params = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "params");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_o = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "o");
// Begin line 2466
  setline(2466);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2427
  setline(2427);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7771 = gc_frame_new();
  if (strlit7772 == NULL) {
    strlit7772 = alloc_String("lsquare");
    gc_root(strlit7772);
  }
// compilenode returning strlit7772
  gc_frame_newslot(strlit7772);
  params[0] = strlit7772;
  partcv[0] = 1;
  Object call7773 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7771);
// compilenode returning call7773
  Object if7770 = done;
  if (istrue(call7773)) {
// Begin line 2428
  setline(2428);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7774 = gc_frame_new();
  partcv[0] = 0;
  Object call7775 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7774);
// compilenode returning call7775
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_tmp = undefined;
// compilenode returning done
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2430
  setline(2430);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array7776 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array7776
  *var_params = array7776;
  if (array7776 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2431
  setline(2431);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7777 = gc_frame_new();
  Object block7778 = alloc_Block(NULL, NULL, "parser", 2431);
  gc_frame_newslot(block7778);
  block_savedest(block7778);
  Object closure7779 = createclosure(1, "_apply");
setclosureframe(closure7779, stackframe);
  addtoclosure(closure7779, selfslot);
  struct UserObject *uo7779 = (struct UserObject*)block7778;
  uo7779->data[0] = (Object)closure7779;
  Method *meth_meth_parser__apply7779 = addmethod2pos(block7778, "_apply", &meth_parser__apply7779, 0);
int argcv_meth_parser__apply7779[] = {0};
meth_meth_parser__apply7779->type = alloc_MethodType(1, argcv_meth_parser__apply7779);
  meth_meth_parser__apply7779->definitionModule = modulename;
  meth_meth_parser__apply7779->definitionLine = 2417;
// compilenode returning block7778
  gc_frame_newslot(block7778);
  Object block7783 = alloc_Block(NULL, NULL, "parser", 2431);
  gc_frame_newslot(block7783);
  block_savedest(block7783);
  Object closure7784 = createclosure(7, "_apply");
setclosureframe(closure7784, stackframe);
  addtoclosure(closure7784, var_values);
  addtoclosure(closure7784, var_tmp);
  addtoclosure(closure7784, var_params);
  addtoclosure(closure7784, var_errormessages);
  addtoclosure(closure7784, var_sym);
  addtoclosure(closure7784, var_lastToken);
  addtoclosure(closure7784, selfslot);
  struct UserObject *uo7784 = (struct UserObject*)block7783;
  uo7784->data[0] = (Object)closure7784;
  Method *meth_meth_parser__apply7784 = addmethod2pos(block7783, "_apply", &meth_parser__apply7784, 0);
int argcv_meth_parser__apply7784[] = {0};
meth_meth_parser__apply7784->type = alloc_MethodType(1, argcv_meth_parser__apply7784);
  meth_meth_parser__apply7784->definitionModule = modulename;
  meth_meth_parser__apply7784->definitionLine = 2417;
// compilenode returning block7783
  gc_frame_newslot(block7783);
  params[0] = block7778;
  params[1] = block7783;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7863 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7777);
// compilenode returning call7863
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2456
  setline(2456);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7866 == NULL) {
    strlit7866 = alloc_String("rsquare");
    gc_root(strlit7866);
  }
// compilenode returning strlit7866
  int op_slot_right_7865 = gc_frame_newslot(strlit7866);
  int callframe7868 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7869 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7868);
// compilenode returning call7869
// compilenode returning call7869
  int op_slot_left_7865 = gc_frame_newslot(call7869);
  params[0] = strlit7866;
  partcv[0] = 1;
  Object opresult7870 = callmethod(call7869, "!=", 1, partcv, params);
// compilenode returning opresult7870
  Object if7864 = done;
  if (istrue(opresult7870)) {
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2457
  setline(2457);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7871 = gc_frame_new();
  int callframe7872 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7873 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7872);
// compilenode returning call7873
// compilenode returning call7873
  partcv[0] = 0;
  Object call7874 = callmethod(call7873, "new",
    1, partcv, params);
  gc_frame_end(callframe7871);
// compilenode returning call7874
// compilenode returning call7874
  *var_suggestion = call7874;
  if (call7874 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2458
  setline(2458);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7875 = gc_frame_new();
  if (strlit7876 == NULL) {
    strlit7876 = alloc_String("]");
    gc_root(strlit7876);
  }
// compilenode returning strlit7876
  gc_frame_newslot(strlit7876);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7876;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7877 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7875);
// compilenode returning call7877
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7878 = gc_frame_new();
  if (strlit7879 == NULL) {
    strlit7879 = alloc_String("A list beginning with a '[' must end with a ']'.");
    gc_root(strlit7879);
  }
// compilenode returning strlit7879
  gc_frame_newslot(strlit7879);
// Begin line 2460
  setline(2460);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7880 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7881 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7880);
// compilenode returning call7881
// compilenode returning call7881
  gc_frame_newslot(call7881);
  int callframe7883 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7884 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7883);
// compilenode returning call7884
// compilenode returning call7884
  int op_slot_right_7882 = gc_frame_newslot(call7884);
  int callframe7886 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7887 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7886);
// compilenode returning call7887
// compilenode returning call7887
  int op_slot_left_7882 = gc_frame_newslot(call7887);
  params[0] = call7884;
  partcv[0] = 1;
  Object sum7888 = callmethod(call7887, "+", 1, partcv, params);
// compilenode returning sum7888
  gc_frame_newslot(sum7888);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2459
  setline(2459);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7879;
  params[1] = call7881;
  params[2] = sum7888;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7889 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7878);
// compilenode returning call7889
    gc_frame_newslot(call7889);
    if7864 = call7889;
  } else {
  }
// compilenode returning if7864
// Begin line 2462
  setline(2462);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7890 = gc_frame_new();
// compilenode returning *var_params
  gc_frame_newslot(*var_params);
  int callframe7891 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7892 = callmethod(*var_ast, "arrayNode",
    1, partcv, params);
  gc_frame_end(callframe7891);
// compilenode returning call7892
// compilenode returning call7892
  params[0] = *var_params;
  partcv[0] = 1;
  Object call7893 = callmethod(call7892, "new",
    1, partcv, params);
  gc_frame_end(callframe7890);
// compilenode returning call7893
  *var_o = call7893;
  if (call7893 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2463
  setline(2463);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7894 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call7895 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7894);
// compilenode returning call7895
// Begin line 2464
  setline(2464);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7896 = gc_frame_new();
  partcv[0] = 0;
  Object call7897 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7896);
// compilenode returning call7897
    gc_frame_newslot(call7897);
    if7770 = call7897;
  } else {
  }
// compilenode returning if7770
  gc_frame_end(frame);
  return if7770;
}
Object meth_parser_dodialect7898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dodialect");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_ast = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dodialect (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dodialect");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_errorPos = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "errorPos");
// Begin line 2488
  setline(2488);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2470
  setline(2470);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7902 == NULL) {
    strlit7902 = alloc_String("dialect");
    gc_root(strlit7902);
  }
// compilenode returning strlit7902
  int op_slot_right_7901 = gc_frame_newslot(strlit7902);
  int callframe7904 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7905 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7904);
// compilenode returning call7905
// compilenode returning call7905
  int op_slot_left_7901 = gc_frame_newslot(call7905);
  params[0] = strlit7902;
  partcv[0] = 1;
  Object opresult7906 = callmethod(call7905, "==", 1, partcv, params);
// compilenode returning opresult7906
  int op_slot_right_7900 = gc_frame_newslot(opresult7906);
  int callframe7908 = gc_frame_new();
  if (strlit7909 == NULL) {
    strlit7909 = alloc_String("keyword");
    gc_root(strlit7909);
  }
// compilenode returning strlit7909
  gc_frame_newslot(strlit7909);
  params[0] = strlit7909;
  partcv[0] = 1;
  Object call7910 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7908);
// compilenode returning call7910
  int op_slot_left_7900 = gc_frame_newslot(call7910);
  params[0] = opresult7906;
  partcv[0] = 1;
  Object opresult7911 = callmethod(call7910, "&&", 1, partcv, params);
// compilenode returning opresult7911
  Object if7899 = done;
  if (istrue(opresult7911)) {
// Begin line 2471
  setline(2471);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7912 = gc_frame_new();
  partcv[0] = 0;
  Object call7913 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7912);
// compilenode returning call7913
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2472
  setline(2472);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7916 == NULL) {
    strlit7916 = alloc_String("string");
    gc_root(strlit7916);
  }
// compilenode returning strlit7916
  int op_slot_right_7915 = gc_frame_newslot(strlit7916);
  int callframe7918 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7919 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7918);
// compilenode returning call7919
// compilenode returning call7919
  int op_slot_left_7915 = gc_frame_newslot(call7919);
  params[0] = strlit7916;
  partcv[0] = 1;
  Object opresult7920 = callmethod(call7919, "!=", 1, partcv, params);
// compilenode returning opresult7920
  Object if7914 = done;
  if (istrue(opresult7920)) {
// Begin line 2474
  setline(2474);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2473
  setline(2473);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7921 = gc_frame_new();
  int callframe7922 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call7923 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe7922);
// compilenode returning call7923
// compilenode returning call7923
  partcv[0] = 0;
  Object call7924 = callmethod(call7923, "new",
    1, partcv, params);
  gc_frame_end(callframe7921);
// compilenode returning call7924
// compilenode returning call7924
  *var_suggestion = call7924;
  if (call7924 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_errorPos = undefined;
// compilenode returning done
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2475
  setline(2475);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7928 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7929 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7928);
// compilenode returning call7929
// compilenode returning call7929
  int op_slot_right_7927 = gc_frame_newslot(call7929);
  int callframe7931 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7932 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe7931);
// compilenode returning call7932
// compilenode returning call7932
  int op_slot_left_7927 = gc_frame_newslot(call7932);
  params[0] = call7929;
  partcv[0] = 1;
  Object opresult7933 = callmethod(call7932, "==", 1, partcv, params);
// compilenode returning opresult7933
  int op_slot_right_7926 = gc_frame_newslot(opresult7933);
  if (strlit7936 == NULL) {
    strlit7936 = alloc_String("identifier");
    gc_root(strlit7936);
  }
// compilenode returning strlit7936
  int op_slot_right_7935 = gc_frame_newslot(strlit7936);
  int callframe7938 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7939 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe7938);
// compilenode returning call7939
// compilenode returning call7939
  int op_slot_left_7935 = gc_frame_newslot(call7939);
  params[0] = strlit7936;
  partcv[0] = 1;
  Object opresult7940 = callmethod(call7939, "==", 1, partcv, params);
// compilenode returning opresult7940
  int op_slot_left_7926 = gc_frame_newslot(opresult7940);
  params[0] = opresult7933;
  partcv[0] = 1;
  Object opresult7941 = callmethod(opresult7940, "&&", 1, partcv, params);
// compilenode returning opresult7941
  Object if7925 = done;
  if (istrue(opresult7941)) {
// Begin line 2476
  setline(2476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7942 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit7944 == NULL) {
    strlit7944 = alloc_String("""\x22""");
    gc_root(strlit7944);
  }
// compilenode returning strlit7944
  int op_slot_right_7943 = gc_frame_newslot(strlit7944);
  int callframe7947 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7948 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7947);
// compilenode returning call7948
// compilenode returning call7948
  int op_slot_right_7946 = gc_frame_newslot(call7948);
  if (strlit7950 == NULL) {
    strlit7950 = alloc_String("""\x22""");
    gc_root(strlit7950);
  }
// compilenode returning strlit7950
  int op_slot_left_7946 = gc_frame_newslot(strlit7950);
  params[0] = call7948;
  partcv[0] = 1;
  Object opresult7951 = callmethod(strlit7950, "++", 1, partcv, params);
// compilenode returning opresult7951
  int op_slot_left_7943 = gc_frame_newslot(opresult7951);
  params[0] = strlit7944;
  partcv[0] = 1;
  Object opresult7952 = callmethod(opresult7951, "++", 1, partcv, params);
// compilenode returning opresult7952
  gc_frame_newslot(opresult7952);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = opresult7952;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7953 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe7942);
// compilenode returning call7953
// Begin line 2478
  setline(2478);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2477
  setline(2477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7954 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7955 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7954);
// compilenode returning call7955
// compilenode returning call7955
  *var_errorPos = call7955;
  if (call7955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7925 = done;
  } else {
// Begin line 2479
  setline(2479);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7957 = gc_frame_new();
  if (strlit7958 == NULL) {
    strlit7958 = alloc_String(" ""\x22""""\xc2""""\xab""dialect name""\xc2""""\xbb""""\x22""");
    gc_root(strlit7958);
  }
// compilenode returning strlit7958
  gc_frame_newslot(strlit7958);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit7958;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call7959 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe7957);
// compilenode returning call7959
// Begin line 2481
  setline(2481);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2480
  setline(2480);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num7961 = alloc_Float64(1);
// compilenode returning num7961
  int op_slot_right_7960 = gc_frame_newslot(num7961);
  int callframe7964 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7965 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe7964);
// compilenode returning call7965
// compilenode returning call7965
  int op_slot_right_7963 = gc_frame_newslot(call7965);
  int callframe7967 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7968 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe7967);
// compilenode returning call7968
// compilenode returning call7968
  int op_slot_left_7963 = gc_frame_newslot(call7968);
  params[0] = call7965;
  partcv[0] = 1;
  Object sum7969 = callmethod(call7968, "+", 1, partcv, params);
// compilenode returning sum7969
  int op_slot_left_7960 = gc_frame_newslot(sum7969);
  params[0] = num7961;
  partcv[0] = 1;
  Object sum7970 = callmethod(sum7969, "+", 1, partcv, params);
// compilenode returning sum7970
  *var_errorPos = sum7970;
  if (sum7970 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if7925 = done;
  }
// compilenode returning if7925
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7972 = gc_frame_new();
  if (strlit7973 == NULL) {
    strlit7973 = alloc_String("A dialect statement must have the name of the dialect in quotes after the 'dialect'.");
    gc_root(strlit7973);
  }
// compilenode returning strlit7973
  gc_frame_newslot(strlit7973);
// Begin line 2483
  setline(2483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7974 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call7975 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe7974);
// compilenode returning call7975
// compilenode returning call7975
  gc_frame_newslot(call7975);
// compilenode returning *var_errorPos
  gc_frame_newslot(*var_errorPos);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2482
  setline(2482);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit7973;
  params[1] = call7975;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call7976 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe7972);
// compilenode returning call7976
    gc_frame_newslot(call7976);
    if7914 = call7976;
  } else {
  }
// compilenode returning if7914
// Begin line 2485
  setline(2485);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7977 = gc_frame_new();
  int callframe7978 = gc_frame_new();
  int callframe7979 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7980 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7979);
// compilenode returning call7980
// compilenode returning call7980
  gc_frame_newslot(call7980);
  int callframe7981 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call7982 = callmethod(*var_ast, "dialectNode",
    1, partcv, params);
  gc_frame_end(callframe7981);
// compilenode returning call7982
// compilenode returning call7982
  params[0] = call7980;
  partcv[0] = 1;
  Object call7983 = callmethod(call7982, "new",
    1, partcv, params);
  gc_frame_end(callframe7978);
// compilenode returning call7983
  gc_frame_newslot(call7983);
// compilenode returning *var_values
  params[0] = call7983;
  partcv[0] = 1;
  Object call7984 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe7977);
// compilenode returning call7984
// Begin line 2486
  setline(2486);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe7985 = gc_frame_new();
  partcv[0] = 0;
  Object call7986 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7985);
// compilenode returning call7986
    gc_frame_newslot(call7986);
    if7899 = call7986;
  } else {
  }
// compilenode returning if7899
  gc_frame_end(frame);
  return if7899;
}
Object meth_parser__apply8009(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8010 = gc_frame_new();
  partcv[0] = 0;
  Object call8011 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8010);
// compilenode returning call8011
  gc_frame_end(frame);
  return call8011;
}
Object meth_parser_inheritsdec7987(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 43, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "inheritsdec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for inheritsdec (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for inheritsdec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_nextTok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "nextTok");
  Object *var_tmp = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "tmp");
// Begin line 2514
  setline(2514);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2492
  setline(2492);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit7991 == NULL) {
    strlit7991 = alloc_String("inherits");
    gc_root(strlit7991);
  }
// compilenode returning strlit7991
  int op_slot_right_7990 = gc_frame_newslot(strlit7991);
  int callframe7993 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call7994 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe7993);
// compilenode returning call7994
// compilenode returning call7994
  int op_slot_left_7990 = gc_frame_newslot(call7994);
  params[0] = strlit7991;
  partcv[0] = 1;
  Object opresult7995 = callmethod(call7994, "==", 1, partcv, params);
// compilenode returning opresult7995
  int op_slot_right_7989 = gc_frame_newslot(opresult7995);
  int callframe7997 = gc_frame_new();
  if (strlit7998 == NULL) {
    strlit7998 = alloc_String("keyword");
    gc_root(strlit7998);
  }
// compilenode returning strlit7998
  gc_frame_newslot(strlit7998);
  params[0] = strlit7998;
  partcv[0] = 1;
  Object call7999 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe7997);
// compilenode returning call7999
  int op_slot_left_7989 = gc_frame_newslot(call7999);
  params[0] = opresult7995;
  partcv[0] = 1;
  Object opresult8000 = callmethod(call7999, "&&", 1, partcv, params);
// compilenode returning opresult8000
  Object if7988 = done;
  if (istrue(opresult8000)) {
// Begin line 2493
  setline(2493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8001 = gc_frame_new();
  partcv[0] = 0;
  Object call8002 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8001);
// compilenode returning call8002
// Begin line 2494
  setline(2494);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8003 = gc_frame_new();
  partcv[0] = 0;
  Object call8004 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8003);
// compilenode returning call8004
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2495
  setline(2495);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8006 = gc_frame_new();
  int callframe8007 = gc_frame_new();
  Object block8008 = alloc_Block(NULL, NULL, "parser", 2495);
  gc_frame_newslot(block8008);
  block_savedest(block8008);
  Object closure8009 = createclosure(1, "_apply");
setclosureframe(closure8009, stackframe);
  addtoclosure(closure8009, selfslot);
  struct UserObject *uo8009 = (struct UserObject*)block8008;
  uo8009->data[0] = (Object)closure8009;
  Method *meth_meth_parser__apply8009 = addmethod2pos(block8008, "_apply", &meth_parser__apply8009, 0);
int argcv_meth_parser__apply8009[] = {0};
meth_meth_parser__apply8009->type = alloc_MethodType(1, argcv_meth_parser__apply8009);
  meth_meth_parser__apply8009->definitionModule = modulename;
  meth_meth_parser__apply8009->definitionLine = 2495;
// compilenode returning block8008
  gc_frame_newslot(block8008);
  params[0] = block8008;
  partcv[0] = 1;
  Object call8013 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8007);
// compilenode returning call8013
  partcv[0] = 0;
  Object call8014 = callmethod(call8013, "not",
    1, partcv, params);
  gc_frame_end(callframe8006);
// compilenode returning call8014
// compilenode returning call8014
  Object if8005 = done;
  if (istrue(call8014)) {
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2496
  setline(2496);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8015 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8015
  *var_suggestions = array8015;
  if (array8015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2497
  setline(2497);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8016 = gc_frame_new();
  int callframe8017 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8018 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8017);
// compilenode returning call8018
// compilenode returning call8018
  partcv[0] = 0;
  Object call8019 = callmethod(call8018, "new",
    1, partcv, params);
  gc_frame_end(callframe8016);
// compilenode returning call8019
// compilenode returning call8019
  *var_suggestion = call8019;
  if (call8019 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2498
  setline(2498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8020 = gc_frame_new();
  if (strlit8021 == NULL) {
    strlit8021 = alloc_String("rsquare");
    gc_root(strlit8021);
  }
// compilenode returning strlit8021
  gc_frame_newslot(strlit8021);
  params[0] = strlit8021;
  partcv[0] = 1;
  Object call8022 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8020);
// compilenode returning call8022
  *var_nextTok = call8022;
  if (call8022 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2499
  setline(2499);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_8024 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_8024 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8026 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult8026
  Object if8023 = done;
  if (istrue(opresult8026)) {
// Begin line 2500
  setline(2500);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8027 = gc_frame_new();
  if (strlit8028 == NULL) {
    strlit8028 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit8028);
  }
// compilenode returning strlit8028
  gc_frame_newslot(strlit8028);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8028;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8029 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8027);
// compilenode returning call8029
    gc_frame_newslot(call8029);
    if8023 = call8029;
  } else {
// Begin line 2502
  setline(2502);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8030 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe8031 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call8032 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe8031);
// compilenode returning call8032
// compilenode returning call8032
  gc_frame_newslot(call8032);
  Object bool8033 = alloc_Boolean(1);
// compilenode returning bool8033
  gc_frame_newslot(bool8033);
  Object bool8034 = alloc_Boolean(0);
// compilenode returning bool8034
  gc_frame_newslot(bool8034);
  if (strlit8035 == NULL) {
    strlit8035 = alloc_String(" ""\xc2""""\xab""parent""\xc2""""\xbb""");
    gc_root(strlit8035);
  }
// compilenode returning strlit8035
  gc_frame_newslot(strlit8035);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call8032;
  params[2] = bool8033;
  params[3] = bool8034;
  params[4] = strlit8035;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call8036 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe8030);
// compilenode returning call8036
    gc_frame_newslot(call8036);
    if8023 = call8036;
  }
// compilenode returning if8023
// Begin line 2504
  setline(2504);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8037 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8038 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8037);
// compilenode returning call8038
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2505
  setline(2505);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8039 = gc_frame_new();
  int callframe8040 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8041 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8040);
// compilenode returning call8041
// compilenode returning call8041
  partcv[0] = 0;
  Object call8042 = callmethod(call8041, "new",
    1, partcv, params);
  gc_frame_end(callframe8039);
// compilenode returning call8042
// compilenode returning call8042
  *var_suggestion = call8042;
  if (call8042 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2506
  setline(2506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8044 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe8045 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call8046 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe8045);
// compilenode returning call8046
// compilenode returning call8046
  gc_frame_newslot(call8046);
  Object bool8047 = alloc_Boolean(1);
// compilenode returning bool8047
  gc_frame_newslot(bool8047);
  Object bool8048 = alloc_Boolean(0);
// compilenode returning bool8048
  gc_frame_newslot(bool8048);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call8046;
  params[2] = bool8047;
  params[3] = bool8048;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8049 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe8044);
// compilenode returning call8049
// Begin line 2507
  setline(2507);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8050 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8051 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8050);
// compilenode returning call8051
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8052 = gc_frame_new();
  if (strlit8053 == NULL) {
    strlit8053 = alloc_String("An inheritance statement must have the object being inherited from after the 'inherits'.");
    gc_root(strlit8053);
  }
// compilenode returning strlit8053
  gc_frame_newslot(strlit8053);
// Begin line 2509
  setline(2509);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8054 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8055 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8054);
// compilenode returning call8055
// compilenode returning call8055
  gc_frame_newslot(call8055);
  Object num8057 = alloc_Float64(1);
// compilenode returning num8057
  int op_slot_right_8056 = gc_frame_newslot(num8057);
  int callframe8060 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8061 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8060);
// compilenode returning call8061
// compilenode returning call8061
  int op_slot_right_8059 = gc_frame_newslot(call8061);
  int callframe8063 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8064 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8063);
// compilenode returning call8064
// compilenode returning call8064
  int op_slot_left_8059 = gc_frame_newslot(call8064);
  params[0] = call8061;
  partcv[0] = 1;
  Object sum8065 = callmethod(call8064, "+", 1, partcv, params);
// compilenode returning sum8065
  int op_slot_left_8056 = gc_frame_newslot(sum8065);
  params[0] = num8057;
  partcv[0] = 1;
  Object sum8066 = callmethod(sum8065, "+", 1, partcv, params);
// compilenode returning sum8066
  gc_frame_newslot(sum8066);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2508
  setline(2508);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8053;
  params[1] = call8055;
  params[2] = sum8066;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8067 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8052);
// compilenode returning call8067
    gc_frame_newslot(call8067);
    if8005 = call8067;
  } else {
  }
// compilenode returning if8005
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2511
  setline(2511);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8068 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8069 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8068);
// compilenode returning call8069
// compilenode returning call8069
  *var_tmp = call8069;
  if (call8069 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2512
  setline(2512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8070 = gc_frame_new();
  int callframe8071 = gc_frame_new();
// compilenode returning *var_tmp
  gc_frame_newslot(*var_tmp);
  int callframe8072 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8073 = callmethod(*var_ast, "inheritsNode",
    1, partcv, params);
  gc_frame_end(callframe8072);
// compilenode returning call8073
// compilenode returning call8073
  params[0] = *var_tmp;
  partcv[0] = 1;
  Object call8074 = callmethod(call8073, "new",
    1, partcv, params);
  gc_frame_end(callframe8071);
// compilenode returning call8074
  gc_frame_newslot(call8074);
// compilenode returning *var_values
  params[0] = call8074;
  partcv[0] = 1;
  Object call8075 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8070);
// compilenode returning call8075
    gc_frame_newslot(call8075);
    if7988 = call8075;
  } else {
  }
// compilenode returning if7988
  gc_frame_end(frame);
  return if7988;
}
Object meth_parser__apply8106(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit8108 == NULL) {
    strlit8108 = alloc_String("rbrace");
    gc_root(strlit8108);
  }
// compilenode returning strlit8108
  int op_slot_right_8107 = gc_frame_newslot(strlit8108);
  int callframe8110 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call8111 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe8110);
// compilenode returning call8111
// compilenode returning call8111
  int op_slot_left_8107 = gc_frame_newslot(call8111);
  params[0] = strlit8108;
  partcv[0] = 1;
  Object opresult8112 = callmethod(call8111, "==", 1, partcv, params);
// compilenode returning opresult8112
  gc_frame_end(frame);
  return opresult8112;
}
Object meth_parser__apply8174(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8175 = gc_frame_new();
  int callframe8176 = gc_frame_new();
  if (strlit8177 == NULL) {
    strlit8177 = alloc_String("rbrace");
    gc_root(strlit8177);
  }
// compilenode returning strlit8177
  gc_frame_newslot(strlit8177);
  params[0] = strlit8177;
  partcv[0] = 1;
  Object call8178 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8176);
// compilenode returning call8178
  partcv[0] = 0;
  Object call8179 = callmethod(call8178, "not",
    1, partcv, params);
  gc_frame_end(callframe8175);
// compilenode returning call8179
// compilenode returning call8179
  gc_frame_end(frame);
  return call8179;
}
Object meth_parser__apply8182(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_sz = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 2550
  setline(2550);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8183 = gc_frame_new();
  partcv[0] = 0;
  Object call8184 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8183);
// compilenode returning call8184
// Begin line 2551
  setline(2551);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8185 = gc_frame_new();
  partcv[0] = 0;
  Object call8186 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8185);
// compilenode returning call8186
// Begin line 2552
  setline(2552);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8187 = gc_frame_new();
  partcv[0] = 0;
  Object call8188 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8187);
// compilenode returning call8188
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2553
  setline(2553);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8191 == NULL) {
    strlit8191 = alloc_String("eof");
    gc_root(strlit8191);
  }
// compilenode returning strlit8191
  int op_slot_right_8190 = gc_frame_newslot(strlit8191);
  int callframe8193 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8194 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8193);
// compilenode returning call8194
// compilenode returning call8194
  int op_slot_left_8190 = gc_frame_newslot(call8194);
  params[0] = strlit8191;
  partcv[0] = 1;
  Object opresult8195 = callmethod(call8194, "==", 1, partcv, params);
// compilenode returning opresult8195
  Object if8189 = done;
  if (istrue(opresult8195)) {
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2554
  setline(2554);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8198 == NULL) {
    strlit8198 = alloc_String("rbrace");
    gc_root(strlit8198);
  }
// compilenode returning strlit8198
  int op_slot_right_8197 = gc_frame_newslot(strlit8198);
  int callframe8200 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8201 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8200);
// compilenode returning call8201
// compilenode returning call8201
  int op_slot_left_8197 = gc_frame_newslot(call8201);
  params[0] = strlit8198;
  partcv[0] = 1;
  Object opresult8202 = callmethod(call8201, "!=", 1, partcv, params);
// compilenode returning opresult8202
  Object if8196 = done;
  if (istrue(opresult8202)) {
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2555
  setline(2555);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8203 = gc_frame_new();
  int callframe8204 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8205 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8204);
// compilenode returning call8205
// compilenode returning call8205
  partcv[0] = 0;
  Object call8206 = callmethod(call8205, "new",
    1, partcv, params);
  gc_frame_end(callframe8203);
// compilenode returning call8206
// compilenode returning call8206
  *var_suggestion = call8206;
  if (call8206 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2556
  setline(2556);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8207 = gc_frame_new();
  if (strlit8208 == NULL) {
    strlit8208 = alloc_String("}");
    gc_root(strlit8208);
  }
// compilenode returning strlit8208
  gc_frame_newslot(strlit8208);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8208;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8209 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8207);
// compilenode returning call8209
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8210 = gc_frame_new();
  if (strlit8211 == NULL) {
    strlit8211 = alloc_String("An object must end with a '}'.");
    gc_root(strlit8211);
  }
// compilenode returning strlit8211
  gc_frame_newslot(strlit8211);
// Begin line 2558
  setline(2558);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8212 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8213 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8212);
// compilenode returning call8213
// compilenode returning call8213
  gc_frame_newslot(call8213);
  int callframe8215 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8216 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8215);
// compilenode returning call8216
// compilenode returning call8216
  int op_slot_right_8214 = gc_frame_newslot(call8216);
  int callframe8218 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8219 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8218);
// compilenode returning call8219
// compilenode returning call8219
  int op_slot_left_8214 = gc_frame_newslot(call8219);
  params[0] = call8216;
  partcv[0] = 1;
  Object sum8220 = callmethod(call8219, "+", 1, partcv, params);
// compilenode returning sum8220
  gc_frame_newslot(sum8220);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2557
  setline(2557);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8211;
  params[1] = call8213;
  params[2] = sum8220;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8221 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8210);
// compilenode returning call8221
    gc_frame_newslot(call8221);
    if8196 = call8221;
  } else {
  }
// compilenode returning if8196
    gc_frame_newslot(if8196);
    if8189 = if8196;
  } else {
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2560
  setline(2560);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8225 == NULL) {
    strlit8225 = alloc_String("semicolon");
    gc_root(strlit8225);
  }
// compilenode returning strlit8225
  int op_slot_right_8224 = gc_frame_newslot(strlit8225);
  int callframe8227 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8228 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe8227);
// compilenode returning call8228
// compilenode returning call8228
  int op_slot_left_8224 = gc_frame_newslot(call8228);
  params[0] = strlit8225;
  partcv[0] = 1;
  Object opresult8229 = callmethod(call8228, "!=", 1, partcv, params);
// compilenode returning opresult8229
  int op_slot_right_8223 = gc_frame_newslot(opresult8229);
// compilenode returning *var_sz
  int op_slot_right_8231 = gc_frame_newslot(*var_sz);
  int callframe8233 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8234 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8233);
// compilenode returning call8234
// compilenode returning call8234
  int op_slot_left_8231 = gc_frame_newslot(call8234);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult8235 = callmethod(call8234, "==", 1, partcv, params);
// compilenode returning opresult8235
  int op_slot_left_8223 = gc_frame_newslot(opresult8235);
  params[0] = opresult8229;
  partcv[0] = 1;
  Object opresult8236 = callmethod(opresult8235, "&&", 1, partcv, params);
// compilenode returning opresult8236
  Object if8222 = done;
  if (istrue(opresult8236)) {
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2561
  setline(2561);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8237 = gc_frame_new();
  int callframe8238 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8239 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8238);
// compilenode returning call8239
// compilenode returning call8239
  partcv[0] = 0;
  Object call8240 = callmethod(call8239, "new",
    1, partcv, params);
  gc_frame_end(callframe8237);
// compilenode returning call8240
// compilenode returning call8240
  *var_suggestion = call8240;
  if (call8240 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2562
  setline(2562);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8241 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8242 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8241);
// compilenode returning call8242
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8243 = gc_frame_new();
  if (strlit8244 == NULL) {
    strlit8244 = alloc_String("An object can only contain variable, constant, and method declarations; and statements.");
    gc_root(strlit8244);
  }
// compilenode returning strlit8244
  gc_frame_newslot(strlit8244);
// Begin line 2564
  setline(2564);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8245 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8246 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8245);
// compilenode returning call8246
// compilenode returning call8246
  gc_frame_newslot(call8246);
  int callframe8247 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8248 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8247);
// compilenode returning call8248
// compilenode returning call8248
  gc_frame_newslot(call8248);
  Object num8250 = alloc_Float64(1);
// compilenode returning num8250
  int op_slot_right_8249 = gc_frame_newslot(num8250);
  int callframe8253 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8254 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe8253);
// compilenode returning call8254
// compilenode returning call8254
  int op_slot_right_8252 = gc_frame_newslot(call8254);
  int callframe8256 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8257 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8256);
// compilenode returning call8257
// compilenode returning call8257
  int op_slot_left_8252 = gc_frame_newslot(call8257);
  params[0] = call8254;
  partcv[0] = 1;
  Object sum8258 = callmethod(call8257, "+", 1, partcv, params);
// compilenode returning sum8258
  int op_slot_left_8249 = gc_frame_newslot(sum8258);
  params[0] = num8250;
  partcv[0] = 1;
  Object diff8259 = callmethod(sum8258, "-", 1, partcv, params);
// compilenode returning diff8259
  gc_frame_newslot(diff8259);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2563
  setline(2563);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8244;
  params[1] = call8246;
  params[2] = call8248;
  params[3] = diff8259;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call8260 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8243);
// compilenode returning call8260
    gc_frame_newslot(call8260);
    if8222 = call8260;
  } else {
  }
// compilenode returning if8222
    gc_frame_newslot(if8222);
    if8189 = if8222;
  }
// compilenode returning if8189
// Begin line 2567
  setline(2567);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2566
  setline(2566);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8261 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8262 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8261);
// compilenode returning call8262
// compilenode returning call8262
  *var_sz = call8262;
  if (call8262 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8273(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit8275 == NULL) {
    strlit8275 = alloc_String("lbrace");
    gc_root(strlit8275);
  }
// compilenode returning strlit8275
  int op_slot_right_8274 = gc_frame_newslot(strlit8275);
  int callframe8277 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call8278 = callmethod(*var_n, "kind",
    1, partcv, params);
  gc_frame_end(callframe8277);
// compilenode returning call8278
// compilenode returning call8278
  int op_slot_left_8274 = gc_frame_newslot(call8278);
  params[0] = strlit8275;
  partcv[0] = 1;
  Object opresult8279 = callmethod(call8278, "!=", 1, partcv, params);
// compilenode returning opresult8279
  gc_frame_end(frame);
  return opresult8279;
}
Object meth_parser__apply8282(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_rbody = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2572
  setline(2572);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8283 = gc_frame_new();
// compilenode returning *var_n
  gc_frame_newslot(*var_n);
// compilenode returning *var_rbody
  params[0] = *var_n;
  partcv[0] = 1;
  Object call8284 = callmethod(*var_rbody, "push",
    1, partcv, params);
  gc_frame_end(callframe8283);
// compilenode returning call8284
// Begin line 2574
  setline(2574);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2573
  setline(2573);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8285 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8286 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8285);
// compilenode returning call8286
// compilenode returning call8286
  *var_n = call8286;
  if (call8286 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply8295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_rbody = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2578
  setline(2578);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8296 = gc_frame_new();
// compilenode returning *var_rbody
  partcv[0] = 0;
  Object call8297 = callmethod(*var_rbody, "pop",
    1, partcv, params);
  gc_frame_end(callframe8296);
// compilenode returning call8297
// compilenode returning call8297
  *var_p = call8297;
  if (call8297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2579
  setline(2579);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8298 = gc_frame_new();
// compilenode returning *var_p
  gc_frame_newslot(*var_p);
// compilenode returning *var_body
  params[0] = *var_p;
  partcv[0] = 1;
  Object call8299 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8298);
// compilenode returning call8299
  gc_frame_end(frame);
  return call8299;
}
Object meth_parser_doobject8076(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 44, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doobject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_values = getfromclosure(closure, 4);
  Object *var_statementToken = getfromclosure(closure, 5);
  Object *var_util = getfromclosure(closure, 6);
  Object *var_ast = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doobject (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doobject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_superclass = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "superclass");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_sz = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "sz");
  Object *var_rbody = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "rbody");
  Object *var_n = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "n");
  Object *var_body = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "body");
  Object *var_o = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "o");
// Begin line 2586
  setline(2586);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2519
  setline(2519);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8080 == NULL) {
    strlit8080 = alloc_String("object");
    gc_root(strlit8080);
  }
// compilenode returning strlit8080
  int op_slot_right_8079 = gc_frame_newslot(strlit8080);
  int callframe8082 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8083 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8082);
// compilenode returning call8083
// compilenode returning call8083
  int op_slot_left_8079 = gc_frame_newslot(call8083);
  params[0] = strlit8080;
  partcv[0] = 1;
  Object opresult8084 = callmethod(call8083, "==", 1, partcv, params);
// compilenode returning opresult8084
  int op_slot_right_8078 = gc_frame_newslot(opresult8084);
  int callframe8086 = gc_frame_new();
  if (strlit8087 == NULL) {
    strlit8087 = alloc_String("keyword");
    gc_root(strlit8087);
  }
// compilenode returning strlit8087
  gc_frame_newslot(strlit8087);
  params[0] = strlit8087;
  partcv[0] = 1;
  Object call8088 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8086);
// compilenode returning call8088
  int op_slot_left_8078 = gc_frame_newslot(call8088);
  params[0] = opresult8084;
  partcv[0] = 1;
  Object opresult8089 = callmethod(call8088, "&&", 1, partcv, params);
// compilenode returning opresult8089
  Object if8077 = done;
  if (istrue(opresult8089)) {
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2520
  setline(2520);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2521
  setline(2521);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2522
  setline(2522);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8090 = gc_frame_new();
  partcv[0] = 0;
  Object call8091 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8090);
// compilenode returning call8091
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2523
  setline(2523);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8092 = alloc_Boolean(0);
// compilenode returning bool8092
  *var_superclass = bool8092;
  if (bool8092 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2524
  setline(2524);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8095 == NULL) {
    strlit8095 = alloc_String("lbrace");
    gc_root(strlit8095);
  }
// compilenode returning strlit8095
  int op_slot_right_8094 = gc_frame_newslot(strlit8095);
  int callframe8097 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8098 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8097);
// compilenode returning call8098
// compilenode returning call8098
  int op_slot_left_8094 = gc_frame_newslot(call8098);
  params[0] = strlit8095;
  partcv[0] = 1;
  Object opresult8099 = callmethod(call8098, "!=", 1, partcv, params);
// compilenode returning opresult8099
  Object if8093 = done;
  if (istrue(opresult8099)) {
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2525
  setline(2525);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8100 = gc_frame_new();
  int callframe8101 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8102 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8101);
// compilenode returning call8102
// compilenode returning call8102
  partcv[0] = 0;
  Object call8103 = callmethod(call8102, "new",
    1, partcv, params);
  gc_frame_end(callframe8100);
// compilenode returning call8103
// compilenode returning call8103
  *var_suggestion = call8103;
  if (call8103 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2526
  setline(2526);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8104 = gc_frame_new();
  Object block8105 = alloc_Block(NULL, NULL, "parser", 2526);
  gc_frame_newslot(block8105);
  block_savedest(block8105);
  Object closure8106 = createclosure(1, "_apply");
setclosureframe(closure8106, stackframe);
  addtoclosure(closure8106, selfslot);
  struct UserObject *uo8106 = (struct UserObject*)block8105;
  uo8106->data[0] = (Object)closure8106;
  Method *meth_meth_parser__apply8106 = addmethod2pos(block8105, "_apply", &meth_parser__apply8106, 0);
int argcv_meth_parser__apply8106[] = {1};
meth_meth_parser__apply8106->type = alloc_MethodType(1, argcv_meth_parser__apply8106);
  meth_meth_parser__apply8106->definitionModule = modulename;
  meth_meth_parser__apply8106->definitionLine = 2525;
// compilenode returning block8105
  gc_frame_newslot(block8105);
  params[0] = block8105;
  partcv[0] = 1;
  Object call8114 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8104);
// compilenode returning call8114
  *var_nextTok = call8114;
  if (call8114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2527
  setline(2527);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8117 = alloc_Boolean(0);
// compilenode returning bool8117
  int op_slot_right_8116 = gc_frame_newslot(bool8117);
// compilenode returning *var_nextTok
  int op_slot_left_8116 = gc_frame_newslot(*var_nextTok);
  params[0] = bool8117;
  partcv[0] = 1;
  Object opresult8119 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult8119
  Object if8115 = done;
  if (istrue(opresult8119)) {
// Begin line 2528
  setline(2528);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8120 = gc_frame_new();
  if (strlit8121 == NULL) {
    strlit8121 = alloc_String(" {}");
    gc_root(strlit8121);
  }
// compilenode returning strlit8121
  gc_frame_newslot(strlit8121);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8121;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8122 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8120);
// compilenode returning call8122
    gc_frame_newslot(call8122);
    if8115 = call8122;
  } else {
// Begin line 2530
  setline(2530);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8123 = gc_frame_new();
  if (strlit8124 == NULL) {
    strlit8124 = alloc_String(" {");
    gc_root(strlit8124);
  }
// compilenode returning strlit8124
  gc_frame_newslot(strlit8124);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8124;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8125 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8123);
// compilenode returning call8125
    gc_frame_newslot(call8125);
    if8115 = call8125;
  }
// compilenode returning if8115
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8126 = gc_frame_new();
  if (strlit8127 == NULL) {
    strlit8127 = alloc_String("An object must have a '{' afer the 'object'.");
    gc_root(strlit8127);
  }
// compilenode returning strlit8127
  gc_frame_newslot(strlit8127);
// Begin line 2533
  setline(2533);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8128 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8129 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8128);
// compilenode returning call8129
// compilenode returning call8129
  gc_frame_newslot(call8129);
  int callframe8131 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8132 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8131);
// compilenode returning call8132
// compilenode returning call8132
  int op_slot_right_8130 = gc_frame_newslot(call8132);
  int callframe8134 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8135 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8134);
// compilenode returning call8135
// compilenode returning call8135
  int op_slot_left_8130 = gc_frame_newslot(call8135);
  params[0] = call8132;
  partcv[0] = 1;
  Object sum8136 = callmethod(call8135, "+", 1, partcv, params);
// compilenode returning sum8136
  gc_frame_newslot(sum8136);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2532
  setline(2532);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8127;
  params[1] = call8129;
  params[2] = sum8136;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8137 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8126);
// compilenode returning call8137
    gc_frame_newslot(call8137);
    if8093 = call8137;
  } else {
  }
// compilenode returning if8093
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8138 = gc_frame_new();
  Object inheritingObject8139 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8139 = alloc_userobj2(4,4, objclass8139);
  gc_frame_newslot(obj8139);
// OBJECT OUTER DEC outer
  adddatum2(obj8139, self, 0);
  addmethodreal(obj8139,"outer", &reader_parser_outer_8140);
  Object oldself8139 = self;
  struct StackFrameObject *oldstackframe8139 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8139);
  gc_frame_newslot((Object)stackframe);
  self = obj8139;
  Object *oldselfslot8139 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8139 = (*(struct UserObject *)self).data[0], lowerouter8139 = thisouter8139;
  if (inheritingObject8139) {
    struct UserObject *inho8139 = (struct UserObject *)inheritingObject8139;
    while (inho8139->super != GraceDefaultObject) inho8139 = (struct UserObject *)inho8139->super;
    inho8139->super = obj8139;
    self = inheritingObject8139;
    *selfslot = self;
    lowerouter8139 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8139;
  }
if (objclass8139 == NULL) {
  Method *reader8141 = addmethodrealflags(obj8139, "kind",&reader_parser_kind_8141, 0);
  Method *writer8141 = addmethodrealflags(obj8139, "kind:=",&writer_parser_kind_8141, 0);
  reader8141->definitionModule = modulename;
  writer8141->definitionModule = modulename;
  reader8141->definitionLine = 2537;
  writer8141->definitionLine = 2537;
}
obj8139->flags |= OFLAG_MUTABLE;
adddatum2(obj8139, alloc_Undefined(), 1);
if (objclass8139 == NULL) {
  Method *reader8142 = addmethodrealflags(obj8139, "register",&reader_parser_register_8142, 0);
  Method *writer8142 = addmethodrealflags(obj8139, "register:=",&writer_parser_register_8142, 0);
  reader8142->definitionModule = modulename;
  writer8142->definitionModule = modulename;
  reader8142->definitionLine = 2538;
  writer8142->definitionLine = 2538;
}
obj8139->flags |= OFLAG_MUTABLE;
adddatum2(obj8139, alloc_Undefined(), 2);
  sourceObject = obj8139;
// Begin line 2536
  setline(2536);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8143 == NULL) {
    strlit8143 = alloc_String("lbrace");
    gc_root(strlit8143);
  }
// compilenode returning strlit8143
  adddatum2(obj8139, strlit8143, 1);
  sourceObject = obj8139;
// Begin line 2537
  setline(2537);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8144 == NULL) {
    strlit8144 = alloc_String("");
    gc_root(strlit8144);
  }
// compilenode returning strlit8144
  adddatum2(obj8139, strlit8144, 2);
objclass8139 = obj8139->class;
  objclass8139->definitionModule = modulename;
  objclass8139->definitionLine = 2535;
  (*(struct UserObject *)self).data[0] = lowerouter8139;
  self = oldself8139;
  selfslot = oldselfslot8139;
  stackframe = oldstackframe8139;
// compilenode returning obj8139
  gc_frame_newslot(obj8139);
// Begin line 2535
  setline(2535);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  params[0] = obj8139;
  partcv[0] = 1;
  Object call8145 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8138);
// compilenode returning call8145
// Begin line 2539
  setline(2539);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8146 = gc_frame_new();
  partcv[0] = 0;
  Object call8147 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8146);
// compilenode returning call8147
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2540
  setline(2540);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8150 = gc_frame_new();
// compilenode returning *var_statementToken
  partcv[0] = 0;
  Object call8151 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8150);
// compilenode returning call8151
// compilenode returning call8151
  int op_slot_right_8149 = gc_frame_newslot(call8151);
  int callframe8153 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8154 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8153);
// compilenode returning call8154
// compilenode returning call8154
  int op_slot_left_8149 = gc_frame_newslot(call8154);
  params[0] = call8151;
  partcv[0] = 1;
  Object opresult8155 = callmethod(call8154, "==", 1, partcv, params);
// compilenode returning opresult8155
  Object if8148 = done;
  if (istrue(opresult8155)) {
// Begin line 2542
  setline(2542);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2541
  setline(2541);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8157 = alloc_Float64(1);
// compilenode returning num8157
  int op_slot_right_8156 = gc_frame_newslot(num8157);
  int callframe8159 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8160 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8159);
// compilenode returning call8160
// compilenode returning call8160
  int op_slot_left_8156 = gc_frame_newslot(call8160);
  params[0] = num8157;
  partcv[0] = 1;
  Object diff8161 = callmethod(call8160, "-", 1, partcv, params);
// compilenode returning diff8161
  *var_minIndentLevel = diff8161;
  if (diff8161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8148 = done;
  } else {
// Begin line 2544
  setline(2544);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2543
  setline(2543);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8164 = alloc_Float64(1);
// compilenode returning num8164
  int op_slot_right_8163 = gc_frame_newslot(num8164);
  int callframe8166 = gc_frame_new();
// compilenode returning *var_statementToken
  partcv[0] = 0;
  Object call8167 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8166);
// compilenode returning call8167
// compilenode returning call8167
  int op_slot_left_8163 = gc_frame_newslot(call8167);
  params[0] = num8164;
  partcv[0] = 1;
  Object sum8168 = callmethod(call8167, "+", 1, partcv, params);
// compilenode returning sum8168
  *var_minIndentLevel = sum8168;
  if (sum8168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8148 = done;
  }
// compilenode returning if8148
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2545
  setline(2545);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8170 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8171 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe8170);
// compilenode returning call8171
// compilenode returning call8171
  *var_sz = call8171;
  if (call8171 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2546
  setline(2546);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8172 = gc_frame_new();
  Object block8173 = alloc_Block(NULL, NULL, "parser", 2546);
  gc_frame_newslot(block8173);
  block_savedest(block8173);
  Object closure8174 = createclosure(1, "_apply");
setclosureframe(closure8174, stackframe);
  addtoclosure(closure8174, selfslot);
  struct UserObject *uo8174 = (struct UserObject*)block8173;
  uo8174->data[0] = (Object)closure8174;
  Method *meth_meth_parser__apply8174 = addmethod2pos(block8173, "_apply", &meth_parser__apply8174, 0);
int argcv_meth_parser__apply8174[] = {0};
meth_meth_parser__apply8174->type = alloc_MethodType(1, argcv_meth_parser__apply8174);
  meth_meth_parser__apply8174->definitionModule = modulename;
  meth_meth_parser__apply8174->definitionLine = 2545;
// compilenode returning block8173
  gc_frame_newslot(block8173);
  Object block8181 = alloc_Block(NULL, NULL, "parser", 2546);
  gc_frame_newslot(block8181);
  block_savedest(block8181);
  Object closure8182 = createclosure(6, "_apply");
setclosureframe(closure8182, stackframe);
  addtoclosure(closure8182, var_sym);
  addtoclosure(closure8182, var_errormessages);
  addtoclosure(closure8182, var_lastToken);
  addtoclosure(closure8182, var_sz);
  addtoclosure(closure8182, var_values);
  addtoclosure(closure8182, selfslot);
  struct UserObject *uo8182 = (struct UserObject*)block8181;
  uo8182->data[0] = (Object)closure8182;
  Method *meth_meth_parser__apply8182 = addmethod2pos(block8181, "_apply", &meth_parser__apply8182, 0);
int argcv_meth_parser__apply8182[] = {0};
meth_meth_parser__apply8182->type = alloc_MethodType(1, argcv_meth_parser__apply8182);
  meth_meth_parser__apply8182->definitionModule = modulename;
  meth_meth_parser__apply8182->definitionLine = 2546;
// compilenode returning block8181
  gc_frame_newslot(block8181);
  params[0] = block8173;
  params[1] = block8181;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8265 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8172);
// compilenode returning call8265
// Begin line 2568
  setline(2568);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8266 = gc_frame_new();
  partcv[0] = 0;
  Object call8267 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8266);
// compilenode returning call8267
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2569
  setline(2569);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8268 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8268
  *var_rbody = array8268;
  if (array8268 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2570
  setline(2570);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8269 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8270 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8269);
// compilenode returning call8270
// compilenode returning call8270
  *var_n = call8270;
  if (call8270 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2571
  setline(2571);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8271 = gc_frame_new();
  Object block8272 = alloc_Block(NULL, NULL, "parser", 2571);
  gc_frame_newslot(block8272);
  block_savedest(block8272);
  Object closure8273 = createclosure(2, "_apply");
setclosureframe(closure8273, stackframe);
  addtoclosure(closure8273, var_n);
  addtoclosure(closure8273, selfslot);
  struct UserObject *uo8273 = (struct UserObject*)block8272;
  uo8273->data[0] = (Object)closure8273;
  Method *meth_meth_parser__apply8273 = addmethod2pos(block8272, "_apply", &meth_parser__apply8273, 0);
int argcv_meth_parser__apply8273[] = {0};
meth_meth_parser__apply8273->type = alloc_MethodType(1, argcv_meth_parser__apply8273);
  meth_meth_parser__apply8273->definitionModule = modulename;
  meth_meth_parser__apply8273->definitionLine = 2570;
// compilenode returning block8272
  gc_frame_newslot(block8272);
  Object block8281 = alloc_Block(NULL, NULL, "parser", 2571);
  gc_frame_newslot(block8281);
  block_savedest(block8281);
  Object closure8282 = createclosure(4, "_apply");
setclosureframe(closure8282, stackframe);
  addtoclosure(closure8282, var_n);
  addtoclosure(closure8282, var_rbody);
  addtoclosure(closure8282, var_values);
  addtoclosure(closure8282, selfslot);
  struct UserObject *uo8282 = (struct UserObject*)block8281;
  uo8282->data[0] = (Object)closure8282;
  Method *meth_meth_parser__apply8282 = addmethod2pos(block8281, "_apply", &meth_parser__apply8282, 0);
int argcv_meth_parser__apply8282[] = {0};
meth_meth_parser__apply8282->type = alloc_MethodType(1, argcv_meth_parser__apply8282);
  meth_meth_parser__apply8282->definitionModule = modulename;
  meth_meth_parser__apply8282->definitionLine = 2571;
// compilenode returning block8281
  gc_frame_newslot(block8281);
  params[0] = block8272;
  params[1] = block8281;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8289 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8271);
// compilenode returning call8289
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2575
  setline(2575);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8290 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8290
  *var_body = array8290;
  if (array8290 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2576
  setline(2576);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8291 = gc_frame_new();
  int callframe8292 = gc_frame_new();
// compilenode returning *var_rbody
  partcv[0] = 0;
  Object call8293 = callmethod(*var_rbody, "indices",
    1, partcv, params);
  gc_frame_end(callframe8292);
// compilenode returning call8293
// compilenode returning call8293
  gc_frame_newslot(call8293);
  Object block8294 = alloc_Block(NULL, NULL, "parser", 2576);
  gc_frame_newslot(block8294);
  block_savedest(block8294);
  Object closure8295 = createclosure(3, "_apply");
setclosureframe(closure8295, stackframe);
  addtoclosure(closure8295, var_rbody);
  addtoclosure(closure8295, var_body);
  addtoclosure(closure8295, selfslot);
  struct UserObject *uo8295 = (struct UserObject*)block8294;
  uo8295->data[0] = (Object)closure8295;
  Method *meth_meth_parser__apply8295 = addmethod2pos(block8294, "_apply", &meth_parser__apply8295, 0);
int argcv_meth_parser__apply8295[] = {1};
meth_meth_parser__apply8295->type = alloc_MethodType(1, argcv_meth_parser__apply8295);
  meth_meth_parser__apply8295->definitionModule = modulename;
  meth_meth_parser__apply8295->definitionLine = 2576;
// compilenode returning block8294
  gc_frame_newslot(block8294);
  params[0] = call8293;
  params[1] = block8294;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8301 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8291);
// compilenode returning call8301
// Begin line 2581
  setline(2581);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8302 = gc_frame_new();
  int callframe8303 = gc_frame_new();
// compilenode returning *var_btok
  partcv[0] = 0;
  Object call8304 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8303);
// compilenode returning call8304
// compilenode returning call8304
  gc_frame_newslot(call8304);
// compilenode returning *var_util
  params[0] = call8304;
  partcv[0] = 1;
  Object call8305 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8302);
// compilenode returning call8305
// Begin line 2582
  setline(2582);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8306 = gc_frame_new();
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
// compilenode returning *var_superclass
  gc_frame_newslot(*var_superclass);
  int callframe8307 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8308 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8307);
// compilenode returning call8308
// compilenode returning call8308
  params[0] = *var_body;
  params[1] = *var_superclass;
  partcv[0] = 2;
  Object call8309 = callmethod(call8308, "new",
    1, partcv, params);
  gc_frame_end(callframe8306);
// compilenode returning call8309
  *var_o = call8309;
  if (call8309 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2583
  setline(2583);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8310 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8311 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8310);
// compilenode returning call8311
// Begin line 2585
  setline(2585);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2584
  setline(2584);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localMinIndentLevel
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8077 = done;
  } else {
  }
// compilenode returning if8077
  gc_frame_end(frame);
  return if8077;
}
Object meth_parser__apply8500(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8501 = gc_frame_new();
  int callframe8502 = gc_frame_new();
  if (strlit8503 == NULL) {
    strlit8503 = alloc_String("rbrace");
    gc_root(strlit8503);
  }
// compilenode returning strlit8503
  gc_frame_newslot(strlit8503);
  params[0] = strlit8503;
  partcv[0] = 1;
  Object call8504 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8502);
// compilenode returning call8504
  partcv[0] = 0;
  Object call8505 = callmethod(call8504, "not",
    1, partcv, params);
  gc_frame_end(callframe8501);
// compilenode returning call8505
// compilenode returning call8505
  gc_frame_end(frame);
  return call8505;
}
Object meth_parser__apply8511(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8512 = gc_frame_new();
  partcv[0] = 0;
  Object call8513 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8512);
// compilenode returning call8513
  gc_frame_end(frame);
  return call8513;
}
Object meth_parser__apply8516(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2651
  setline(2651);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8517 = gc_frame_new();
  int callframe8518 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8519 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8518);
// compilenode returning call8519
// compilenode returning call8519
  gc_frame_newslot(call8519);
// compilenode returning *var_body
  params[0] = call8519;
  partcv[0] = 1;
  Object call8520 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8517);
// compilenode returning call8520
  gc_frame_end(frame);
  return call8520;
}
Object meth_parser__apply8525(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8526 = gc_frame_new();
  partcv[0] = 0;
  Object call8527 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8526);
// compilenode returning call8527
  gc_frame_end(frame);
  return call8527;
}
Object meth_parser__apply8530(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2654
  setline(2654);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8531 = gc_frame_new();
  int callframe8532 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8533 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8532);
// compilenode returning call8533
// compilenode returning call8533
  gc_frame_newslot(call8533);
// compilenode returning *var_body
  params[0] = call8533;
  partcv[0] = 1;
  Object call8534 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8531);
// compilenode returning call8534
  gc_frame_end(frame);
  return call8534;
}
Object meth_parser__apply8539(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8540 = gc_frame_new();
  partcv[0] = 0;
  Object call8541 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8540);
// compilenode returning call8541
  gc_frame_end(frame);
  return call8541;
}
Object meth_parser__apply8544(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2657
  setline(2657);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8545 = gc_frame_new();
  int callframe8546 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8547 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8546);
// compilenode returning call8547
// compilenode returning call8547
  gc_frame_newslot(call8547);
// compilenode returning *var_body
  params[0] = call8547;
  partcv[0] = 1;
  Object call8548 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8545);
// compilenode returning call8548
  gc_frame_end(frame);
  return call8548;
}
Object meth_parser__apply8508(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2650
  setline(2650);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8509 = gc_frame_new();
  Object block8510 = alloc_Block(NULL, NULL, "parser", 2650);
  gc_frame_newslot(block8510);
  block_savedest(block8510);
  Object closure8511 = createclosure(1, "_apply");
setclosureframe(closure8511, stackframe);
  addtoclosure(closure8511, selfslot);
  struct UserObject *uo8511 = (struct UserObject*)block8510;
  uo8511->data[0] = (Object)closure8511;
  Method *meth_meth_parser__apply8511 = addmethod2pos(block8510, "_apply", &meth_parser__apply8511, 0);
int argcv_meth_parser__apply8511[] = {0};
meth_meth_parser__apply8511->type = alloc_MethodType(1, argcv_meth_parser__apply8511);
  meth_meth_parser__apply8511->definitionModule = modulename;
  meth_meth_parser__apply8511->definitionLine = 2649;
// compilenode returning block8510
  gc_frame_newslot(block8510);
  Object block8515 = alloc_Block(NULL, NULL, "parser", 2650);
  gc_frame_newslot(block8515);
  block_savedest(block8515);
  Object closure8516 = createclosure(3, "_apply");
setclosureframe(closure8516, stackframe);
  addtoclosure(closure8516, var_values);
  addtoclosure(closure8516, var_body);
  addtoclosure(closure8516, selfslot);
  struct UserObject *uo8516 = (struct UserObject*)block8515;
  uo8516->data[0] = (Object)closure8516;
  Method *meth_meth_parser__apply8516 = addmethod2pos(block8515, "_apply", &meth_parser__apply8516, 0);
int argcv_meth_parser__apply8516[] = {0};
meth_meth_parser__apply8516->type = alloc_MethodType(1, argcv_meth_parser__apply8516);
  meth_meth_parser__apply8516->definitionModule = modulename;
  meth_meth_parser__apply8516->definitionLine = 2649;
// compilenode returning block8515
  gc_frame_newslot(block8515);
  params[0] = block8510;
  params[1] = block8515;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8522 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8509);
// compilenode returning call8522
// Begin line 2653
  setline(2653);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8523 = gc_frame_new();
  Object block8524 = alloc_Block(NULL, NULL, "parser", 2653);
  gc_frame_newslot(block8524);
  block_savedest(block8524);
  Object closure8525 = createclosure(1, "_apply");
setclosureframe(closure8525, stackframe);
  addtoclosure(closure8525, selfslot);
  struct UserObject *uo8525 = (struct UserObject*)block8524;
  uo8525->data[0] = (Object)closure8525;
  Method *meth_meth_parser__apply8525 = addmethod2pos(block8524, "_apply", &meth_parser__apply8525, 0);
int argcv_meth_parser__apply8525[] = {0};
meth_meth_parser__apply8525->type = alloc_MethodType(1, argcv_meth_parser__apply8525);
  meth_meth_parser__apply8525->definitionModule = modulename;
  meth_meth_parser__apply8525->definitionLine = 2651;
// compilenode returning block8524
  gc_frame_newslot(block8524);
  Object block8529 = alloc_Block(NULL, NULL, "parser", 2653);
  gc_frame_newslot(block8529);
  block_savedest(block8529);
  Object closure8530 = createclosure(3, "_apply");
setclosureframe(closure8530, stackframe);
  addtoclosure(closure8530, var_values);
  addtoclosure(closure8530, var_body);
  addtoclosure(closure8530, selfslot);
  struct UserObject *uo8530 = (struct UserObject*)block8529;
  uo8530->data[0] = (Object)closure8530;
  Method *meth_meth_parser__apply8530 = addmethod2pos(block8529, "_apply", &meth_parser__apply8530, 0);
int argcv_meth_parser__apply8530[] = {0};
meth_meth_parser__apply8530->type = alloc_MethodType(1, argcv_meth_parser__apply8530);
  meth_meth_parser__apply8530->definitionModule = modulename;
  meth_meth_parser__apply8530->definitionLine = 2651;
// compilenode returning block8529
  gc_frame_newslot(block8529);
  params[0] = block8524;
  params[1] = block8529;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8536 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8523);
// compilenode returning call8536
// Begin line 2656
  setline(2656);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8537 = gc_frame_new();
  Object block8538 = alloc_Block(NULL, NULL, "parser", 2656);
  gc_frame_newslot(block8538);
  block_savedest(block8538);
  Object closure8539 = createclosure(1, "_apply");
setclosureframe(closure8539, stackframe);
  addtoclosure(closure8539, selfslot);
  struct UserObject *uo8539 = (struct UserObject*)block8538;
  uo8539->data[0] = (Object)closure8539;
  Method *meth_meth_parser__apply8539 = addmethod2pos(block8538, "_apply", &meth_parser__apply8539, 0);
int argcv_meth_parser__apply8539[] = {0};
meth_meth_parser__apply8539->type = alloc_MethodType(1, argcv_meth_parser__apply8539);
  meth_meth_parser__apply8539->definitionModule = modulename;
  meth_meth_parser__apply8539->definitionLine = 2654;
// compilenode returning block8538
  gc_frame_newslot(block8538);
  Object block8543 = alloc_Block(NULL, NULL, "parser", 2656);
  gc_frame_newslot(block8543);
  block_savedest(block8543);
  Object closure8544 = createclosure(3, "_apply");
setclosureframe(closure8544, stackframe);
  addtoclosure(closure8544, var_values);
  addtoclosure(closure8544, var_body);
  addtoclosure(closure8544, selfslot);
  struct UserObject *uo8544 = (struct UserObject*)block8543;
  uo8544->data[0] = (Object)closure8544;
  Method *meth_meth_parser__apply8544 = addmethod2pos(block8543, "_apply", &meth_parser__apply8544, 0);
int argcv_meth_parser__apply8544[] = {0};
meth_meth_parser__apply8544->type = alloc_MethodType(1, argcv_meth_parser__apply8544);
  meth_meth_parser__apply8544->definitionModule = modulename;
  meth_meth_parser__apply8544->definitionLine = 2654;
// compilenode returning block8543
  gc_frame_newslot(block8543);
  params[0] = block8538;
  params[1] = block8543;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8550 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8537);
// compilenode returning call8550
  gc_frame_end(frame);
  return call8550;
}
Object meth_parser_doclass8313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 45, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(15, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doclass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[6];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_tokens = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_statementToken = getfromclosure(closure, 6);
  Object *var_util = getfromclosure(closure, 7);
  Object *var_ast = getfromclosure(closure, 8);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doclass (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doclass");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_localMinIndentLevel = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "localMinIndentLevel");
  Object *var_suggestions = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestions");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_cname = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "cname");
  Object *var_s = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "s");
  Object *var_csig = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "csig");
  Object *var_constructorName = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "constructorName");
  Object *var_dtype = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "dtype");
  Object *var_anns = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "anns");
  Object *var_body = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "body");
  Object *var_o = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "o");
// Begin line 2680
  setline(2680);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2595
  setline(2595);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8317 == NULL) {
    strlit8317 = alloc_String("class");
    gc_root(strlit8317);
  }
// compilenode returning strlit8317
  int op_slot_right_8316 = gc_frame_newslot(strlit8317);
  int callframe8319 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8320 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8319);
// compilenode returning call8320
// compilenode returning call8320
  int op_slot_left_8316 = gc_frame_newslot(call8320);
  params[0] = strlit8317;
  partcv[0] = 1;
  Object opresult8321 = callmethod(call8320, "==", 1, partcv, params);
// compilenode returning opresult8321
  int op_slot_right_8315 = gc_frame_newslot(opresult8321);
  int callframe8323 = gc_frame_new();
  if (strlit8324 == NULL) {
    strlit8324 = alloc_String("keyword");
    gc_root(strlit8324);
  }
// compilenode returning strlit8324
  gc_frame_newslot(strlit8324);
  params[0] = strlit8324;
  partcv[0] = 1;
  Object call8325 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8323);
// compilenode returning call8325
  int op_slot_left_8315 = gc_frame_newslot(call8325);
  params[0] = opresult8321;
  partcv[0] = 1;
  Object opresult8326 = callmethod(call8325, "&&", 1, partcv, params);
// compilenode returning opresult8326
  Object if8314 = done;
  if (istrue(opresult8326)) {
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2596
  setline(2596);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2597
  setline(2597);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8327 = gc_frame_new();
  partcv[0] = 0;
  Object call8328 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8327);
// compilenode returning call8328
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2598
  setline(2598);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localMinIndentLevel = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2599
  setline(2599);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8331 == NULL) {
    strlit8331 = alloc_String("identifier");
    gc_root(strlit8331);
  }
// compilenode returning strlit8331
  int op_slot_right_8330 = gc_frame_newslot(strlit8331);
  int callframe8333 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8334 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8333);
// compilenode returning call8334
// compilenode returning call8334
  int op_slot_left_8330 = gc_frame_newslot(call8334);
  params[0] = strlit8331;
  partcv[0] = 1;
  Object opresult8335 = callmethod(call8334, "!=", 1, partcv, params);
// compilenode returning opresult8335
  Object if8329 = done;
  if (istrue(opresult8335)) {
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2600
  setline(2600);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8336 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8336
  *var_suggestions = array8336;
  if (array8336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2601
  setline(2601);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8339 == NULL) {
    strlit8339 = alloc_String("lbrace");
    gc_root(strlit8339);
  }
// compilenode returning strlit8339
  int op_slot_right_8338 = gc_frame_newslot(strlit8339);
  int callframe8341 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8342 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8341);
// compilenode returning call8342
// compilenode returning call8342
  int op_slot_left_8338 = gc_frame_newslot(call8342);
  params[0] = strlit8339;
  partcv[0] = 1;
  Object opresult8343 = callmethod(call8342, "==", 1, partcv, params);
// compilenode returning opresult8343
  Object if8337 = done;
  if (istrue(opresult8343)) {
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2602
  setline(2602);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8344 = gc_frame_new();
  int callframe8345 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8346 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8345);
// compilenode returning call8346
// compilenode returning call8346
  partcv[0] = 0;
  Object call8347 = callmethod(call8346, "new",
    1, partcv, params);
  gc_frame_end(callframe8344);
// compilenode returning call8347
// compilenode returning call8347
  *var_suggestion = call8347;
  if (call8347 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2603
  setline(2603);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8348 = gc_frame_new();
  if (strlit8349 == NULL) {
    strlit8349 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new");
    gc_root(strlit8349);
  }
// compilenode returning strlit8349
  gc_frame_newslot(strlit8349);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8349;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8350 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8348);
// compilenode returning call8350
// Begin line 2604
  setline(2604);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8351 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8352 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8351);
// compilenode returning call8352
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2605
  setline(2605);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8353 = gc_frame_new();
  int callframe8354 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8355 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8354);
// compilenode returning call8355
// compilenode returning call8355
  partcv[0] = 0;
  Object call8356 = callmethod(call8355, "new",
    1, partcv, params);
  gc_frame_end(callframe8353);
// compilenode returning call8356
// compilenode returning call8356
  *var_suggestion = call8356;
  if (call8356 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2606
  setline(2606);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8358 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  if (strlit8359 == NULL) {
    strlit8359 = alloc_String("object");
    gc_root(strlit8359);
  }
// compilenode returning strlit8359
  gc_frame_newslot(strlit8359);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = strlit8359;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8360 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8358);
// compilenode returning call8360
// Begin line 2607
  setline(2607);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8361 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8362 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8361);
// compilenode returning call8362
    gc_frame_newslot(call8362);
    if8337 = call8362;
  } else {
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2609
  setline(2609);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8363 = gc_frame_new();
  int callframe8364 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8365 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8364);
// compilenode returning call8365
// compilenode returning call8365
  partcv[0] = 0;
  Object call8366 = callmethod(call8365, "new",
    1, partcv, params);
  gc_frame_end(callframe8363);
// compilenode returning call8366
// compilenode returning call8366
  *var_suggestion = call8366;
  if (call8366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2610
  setline(2610);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8367 = gc_frame_new();
  if (strlit8368 == NULL) {
    strlit8368 = alloc_String(" ""\xc2""""\xab""class name""\xc2""""\xbb"".new {}");
    gc_root(strlit8368);
  }
// compilenode returning strlit8368
  gc_frame_newslot(strlit8368);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8368;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8369 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8367);
// compilenode returning call8369
// Begin line 2611
  setline(2611);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8370 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8371 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8370);
// compilenode returning call8371
    gc_frame_newslot(call8371);
    if8337 = call8371;
  }
// compilenode returning if8337
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8372 = gc_frame_new();
  if (strlit8373 == NULL) {
    strlit8373 = alloc_String("A class must have a name after the 'class'.");
    gc_root(strlit8373);
  }
// compilenode returning strlit8373
  gc_frame_newslot(strlit8373);
// Begin line 2614
  setline(2614);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8374 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8375 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8374);
// compilenode returning call8375
// compilenode returning call8375
  gc_frame_newslot(call8375);
  Object num8377 = alloc_Float64(1);
// compilenode returning num8377
  int op_slot_right_8376 = gc_frame_newslot(num8377);
  int callframe8380 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8381 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8380);
// compilenode returning call8381
// compilenode returning call8381
  int op_slot_right_8379 = gc_frame_newslot(call8381);
  int callframe8383 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8384 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8383);
// compilenode returning call8384
// compilenode returning call8384
  int op_slot_left_8379 = gc_frame_newslot(call8384);
  params[0] = call8381;
  partcv[0] = 1;
  Object sum8385 = callmethod(call8384, "+", 1, partcv, params);
// compilenode returning sum8385
  int op_slot_left_8376 = gc_frame_newslot(sum8385);
  params[0] = num8377;
  partcv[0] = 1;
  Object sum8386 = callmethod(sum8385, "+", 1, partcv, params);
// compilenode returning sum8386
  gc_frame_newslot(sum8386);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2613
  setline(2613);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8373;
  params[1] = call8375;
  params[2] = sum8386;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8387 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe8372);
// compilenode returning call8387
    gc_frame_newslot(call8387);
    if8329 = call8387;
  } else {
  }
// compilenode returning if8329
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2616
  setline(2616);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8390 == NULL) {
    strlit8390 = alloc_String("dot");
    gc_root(strlit8390);
  }
// compilenode returning strlit8390
  int op_slot_right_8389 = gc_frame_newslot(strlit8390);
  int callframe8392 = gc_frame_new();
  int callframe8393 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call8394 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe8393);
// compilenode returning call8394
// compilenode returning call8394
  partcv[0] = 0;
  Object call8395 = callmethod(call8394, "kind",
    1, partcv, params);
  gc_frame_end(callframe8392);
// compilenode returning call8395
// compilenode returning call8395
  int op_slot_left_8389 = gc_frame_newslot(call8395);
  params[0] = strlit8390;
  partcv[0] = 1;
  Object opresult8396 = callmethod(call8395, "==", 1, partcv, params);
// compilenode returning opresult8396
  Object if8388 = done;
struct StackFrameObject *iftmpstackframe8388 = stackframe;
  if (istrue(opresult8396)) {
stackframe = alloc_StackFrame(2, iftmpstackframe8388);
gc_frame_newslot((Object)stackframe);
  Object *var_cname_39_ = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "cname'");
// Begin line 2617
  setline(2617);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8397 = gc_frame_new();
  partcv[0] = 0;
  Object call8398 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8397);
// compilenode returning call8398
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2618
  setline(2618);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8399 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8400 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8399);
// compilenode returning call8400
// compilenode returning call8400
  *var_cname_39_ = call8400;
  if (call8400 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2619
  setline(2619);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8402 = gc_frame_new();
  int callframe8403 = gc_frame_new();
  if (strlit8404 == NULL) {
    strlit8404 = alloc_String("dot");
    gc_root(strlit8404);
  }
// compilenode returning strlit8404
  gc_frame_newslot(strlit8404);
  params[0] = strlit8404;
  partcv[0] = 1;
  Object call8405 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8403);
// compilenode returning call8405
  partcv[0] = 0;
  Object call8406 = callmethod(call8405, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8402);
// compilenode returning call8406
  Object if8401 = done;
  if (istrue(call8406)) {
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2620
  setline(2620);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8407 = gc_frame_new();
  int callframe8408 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8409 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8408);
// compilenode returning call8409
// compilenode returning call8409
  partcv[0] = 0;
  Object call8410 = callmethod(call8409, "new",
    1, partcv, params);
  gc_frame_end(callframe8407);
// compilenode returning call8410
// compilenode returning call8410
  *var_suggestion = call8410;
  if (call8410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2621
  setline(2621);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8411 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit8412 == NULL) {
    strlit8412 = alloc_String(".");
    gc_root(strlit8412);
  }
// compilenode returning strlit8412
  gc_frame_newslot(strlit8412);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit8412;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8413 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe8411);
// compilenode returning call8413
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8414 = gc_frame_new();
  if (strlit8415 == NULL) {
    strlit8415 = alloc_String("A class must have a dot after the object name.");
    gc_root(strlit8415);
  }
// compilenode returning strlit8415
  gc_frame_newslot(strlit8415);
// Begin line 2623
  setline(2623);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8416 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8417 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8416);
// compilenode returning call8417
// compilenode returning call8417
  gc_frame_newslot(call8417);
  Object num8419 = alloc_Float64(1);
// compilenode returning num8419
  int op_slot_right_8418 = gc_frame_newslot(num8419);
  int callframe8422 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8423 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8422);
// compilenode returning call8423
// compilenode returning call8423
  int op_slot_right_8421 = gc_frame_newslot(call8423);
  int callframe8425 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8426 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8425);
// compilenode returning call8426
// compilenode returning call8426
  int op_slot_left_8421 = gc_frame_newslot(call8426);
  params[0] = call8423;
  partcv[0] = 1;
  Object sum8427 = callmethod(call8426, "+", 1, partcv, params);
// compilenode returning sum8427
  int op_slot_left_8418 = gc_frame_newslot(sum8427);
  params[0] = num8419;
  partcv[0] = 1;
  Object sum8428 = callmethod(sum8427, "+", 1, partcv, params);
// compilenode returning sum8428
  gc_frame_newslot(sum8428);
// Begin line 2624
  setline(2624);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2622
  setline(2622);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8415;
  params[1] = call8417;
  params[2] = sum8428;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8429 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8414);
// compilenode returning call8429
    gc_frame_newslot(call8429);
    if8401 = call8429;
  } else {
  }
// compilenode returning if8401
// Begin line 2626
  setline(2626);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8430 = gc_frame_new();
  partcv[0] = 0;
  Object call8431 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8430);
// compilenode returning call8431
// Begin line 2627
  setline(2627);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cname_39_
    gc_frame_newslot(*var_cname_39_);
    if8388 = *var_cname_39_;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe8388);
gc_frame_newslot((Object)stackframe);
// Begin line 2629
  setline(2629);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8432 = alloc_Boolean(0);
// compilenode returning bool8432
    gc_frame_newslot(bool8432);
    if8388 = bool8432;
  }
stackframe = iftmpstackframe8388;
// compilenode returning if8388
  *var_cname = if8388;
  if (if8388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2631
  setline(2631);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8433 = gc_frame_new();
  Object bool8434 = alloc_Boolean(0);
// compilenode returning bool8434
  gc_frame_newslot(bool8434);
  params[0] = bool8434;
  partcv[0] = 1;
  Object call8435 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8433);
// compilenode returning call8435
  *var_s = call8435;
  if (call8435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2632
  setline(2632);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8436 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call8437 = callmethod(*var_s, "sig",
    1, partcv, params);
  gc_frame_end(callframe8436);
// compilenode returning call8437
// compilenode returning call8437
  *var_csig = call8437;
  if (call8437 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2633
  setline(2633);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8438 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call8439 = callmethod(*var_s, "m",
    1, partcv, params);
  gc_frame_end(callframe8438);
// compilenode returning call8439
// compilenode returning call8439
  *var_constructorName = call8439;
  if (call8439 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2634
  setline(2634);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8440 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call8441 = callmethod(*var_s, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8440);
// compilenode returning call8441
// compilenode returning call8441
  *var_dtype = call8441;
  if (call8441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2635
  setline(2635);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8442 = gc_frame_new();
  partcv[0] = 0;
  Object call8443 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8442);
// compilenode returning call8443
  *var_anns = call8443;
  if (call8443 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2636
  setline(2636);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8445 = gc_frame_new();
  int callframe8446 = gc_frame_new();
  if (strlit8447 == NULL) {
    strlit8447 = alloc_String("lbrace");
    gc_root(strlit8447);
  }
// compilenode returning strlit8447
  gc_frame_newslot(strlit8447);
  params[0] = strlit8447;
  partcv[0] = 1;
  Object call8448 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8446);
// compilenode returning call8448
  partcv[0] = 0;
  Object call8449 = callmethod(call8448, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8445);
// compilenode returning call8449
  Object if8444 = done;
  if (istrue(call8449)) {
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2637
  setline(2637);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8450 = gc_frame_new();
  int callframe8451 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8452 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8451);
// compilenode returning call8452
// compilenode returning call8452
  partcv[0] = 0;
  Object call8453 = callmethod(call8452, "new",
    1, partcv, params);
  gc_frame_end(callframe8450);
// compilenode returning call8453
// compilenode returning call8453
  *var_suggestion = call8453;
  if (call8453 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2638
  setline(2638);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8454 = gc_frame_new();
  if (strlit8455 == NULL) {
    strlit8455 = alloc_String(" {");
    gc_root(strlit8455);
  }
// compilenode returning strlit8455
  gc_frame_newslot(strlit8455);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8455;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8456 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8454);
// compilenode returning call8456
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8457 = gc_frame_new();
  if (strlit8458 == NULL) {
    strlit8458 = alloc_String("A class must have a '{' after the name.");
    gc_root(strlit8458);
  }
// compilenode returning strlit8458
  gc_frame_newslot(strlit8458);
// Begin line 2640
  setline(2640);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8459 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8460 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8459);
// compilenode returning call8460
// compilenode returning call8460
  gc_frame_newslot(call8460);
  Object num8462 = alloc_Float64(1);
// compilenode returning num8462
  int op_slot_right_8461 = gc_frame_newslot(num8462);
  int callframe8465 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8466 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8465);
// compilenode returning call8466
// compilenode returning call8466
  int op_slot_right_8464 = gc_frame_newslot(call8466);
  int callframe8468 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8469 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8468);
// compilenode returning call8469
// compilenode returning call8469
  int op_slot_left_8464 = gc_frame_newslot(call8469);
  params[0] = call8466;
  partcv[0] = 1;
  Object sum8470 = callmethod(call8469, "+", 1, partcv, params);
// compilenode returning sum8470
  int op_slot_left_8461 = gc_frame_newslot(sum8470);
  params[0] = num8462;
  partcv[0] = 1;
  Object sum8471 = callmethod(sum8470, "+", 1, partcv, params);
// compilenode returning sum8471
  gc_frame_newslot(sum8471);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2639
  setline(2639);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8458;
  params[1] = call8460;
  params[2] = sum8471;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8472 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8457);
// compilenode returning call8472
    gc_frame_newslot(call8472);
    if8444 = call8472;
  } else {
  }
// compilenode returning if8444
// Begin line 2642
  setline(2642);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8473 = gc_frame_new();
  partcv[0] = 0;
  Object call8474 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8473);
// compilenode returning call8474
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2643
  setline(2643);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8477 = gc_frame_new();
// compilenode returning *var_statementToken
  partcv[0] = 0;
  Object call8478 = callmethod(*var_statementToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8477);
// compilenode returning call8478
// compilenode returning call8478
  int op_slot_right_8476 = gc_frame_newslot(call8478);
  int callframe8480 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8481 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8480);
// compilenode returning call8481
// compilenode returning call8481
  int op_slot_left_8476 = gc_frame_newslot(call8481);
  params[0] = call8478;
  partcv[0] = 1;
  Object opresult8482 = callmethod(call8481, "==", 1, partcv, params);
// compilenode returning opresult8482
  Object if8475 = done;
  if (istrue(opresult8482)) {
// Begin line 2645
  setline(2645);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2644
  setline(2644);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8484 = alloc_Float64(1);
// compilenode returning num8484
  int op_slot_right_8483 = gc_frame_newslot(num8484);
  int callframe8486 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8487 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8486);
// compilenode returning call8487
// compilenode returning call8487
  int op_slot_left_8483 = gc_frame_newslot(call8487);
  params[0] = num8484;
  partcv[0] = 1;
  Object diff8488 = callmethod(call8487, "-", 1, partcv, params);
// compilenode returning diff8488
  *var_minIndentLevel = diff8488;
  if (diff8488 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8475 = done;
  } else {
// Begin line 2647
  setline(2647);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2646
  setline(2646);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8491 = alloc_Float64(1);
// compilenode returning num8491
  int op_slot_right_8490 = gc_frame_newslot(num8491);
  int callframe8493 = gc_frame_new();
// compilenode returning *var_statementToken
  partcv[0] = 0;
  Object call8494 = callmethod(*var_statementToken, "indent",
    1, partcv, params);
  gc_frame_end(callframe8493);
// compilenode returning call8494
// compilenode returning call8494
  int op_slot_left_8490 = gc_frame_newslot(call8494);
  params[0] = num8491;
  partcv[0] = 1;
  Object sum8495 = callmethod(call8494, "+", 1, partcv, params);
// compilenode returning sum8495
  *var_minIndentLevel = sum8495;
  if (sum8495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8475 = done;
  }
// compilenode returning if8475
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2648
  setline(2648);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8497 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8497
  *var_body = array8497;
  if (array8497 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2649
  setline(2649);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8498 = gc_frame_new();
  Object block8499 = alloc_Block(NULL, NULL, "parser", 2649);
  gc_frame_newslot(block8499);
  block_savedest(block8499);
  Object closure8500 = createclosure(1, "_apply");
setclosureframe(closure8500, stackframe);
  addtoclosure(closure8500, selfslot);
  struct UserObject *uo8500 = (struct UserObject*)block8499;
  uo8500->data[0] = (Object)closure8500;
  Method *meth_meth_parser__apply8500 = addmethod2pos(block8499, "_apply", &meth_parser__apply8500, 0);
int argcv_meth_parser__apply8500[] = {0};
meth_meth_parser__apply8500->type = alloc_MethodType(1, argcv_meth_parser__apply8500);
  meth_meth_parser__apply8500->definitionModule = modulename;
  meth_meth_parser__apply8500->definitionLine = 2646;
// compilenode returning block8499
  gc_frame_newslot(block8499);
  Object block8507 = alloc_Block(NULL, NULL, "parser", 2649);
  gc_frame_newslot(block8507);
  block_savedest(block8507);
  Object closure8508 = createclosure(3, "_apply");
setclosureframe(closure8508, stackframe);
  addtoclosure(closure8508, var_values);
  addtoclosure(closure8508, var_body);
  addtoclosure(closure8508, selfslot);
  struct UserObject *uo8508 = (struct UserObject*)block8507;
  uo8508->data[0] = (Object)closure8508;
  Method *meth_meth_parser__apply8508 = addmethod2pos(block8507, "_apply", &meth_parser__apply8508, 0);
int argcv_meth_parser__apply8508[] = {0};
meth_meth_parser__apply8508->type = alloc_MethodType(1, argcv_meth_parser__apply8508);
  meth_meth_parser__apply8508->definitionModule = modulename;
  meth_meth_parser__apply8508->definitionLine = 2649;
// compilenode returning block8507
  gc_frame_newslot(block8507);
  params[0] = block8499;
  params[1] = block8507;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8552 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8498);
// compilenode returning call8552
// Begin line 2660
  setline(2660);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8553 = gc_frame_new();
  partcv[0] = 0;
  Object call8554 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8553);
// compilenode returning call8554
// Begin line 2661
  setline(2661);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8555 = gc_frame_new();
  int callframe8556 = gc_frame_new();
// compilenode returning *var_btok
  partcv[0] = 0;
  Object call8557 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8556);
// compilenode returning call8557
// compilenode returning call8557
  gc_frame_newslot(call8557);
// compilenode returning *var_util
  params[0] = call8557;
  partcv[0] = 1;
  Object call8558 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8555);
// compilenode returning call8558
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2662
  setline(2662);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_cname
  int op_slot_right_8560 = gc_frame_newslot(*var_cname);
  Object bool8562 = alloc_Boolean(0);
// compilenode returning bool8562
  int op_slot_left_8560 = gc_frame_newslot(bool8562);
  params[0] = *var_cname;
  partcv[0] = 1;
  Object opresult8563 = callmethod(bool8562, "==", 1, partcv, params);
// compilenode returning opresult8563
  Object if8559 = done;
struct StackFrameObject *iftmpstackframe8559 = stackframe;
  if (istrue(opresult8563)) {
stackframe = alloc_StackFrame(0, iftmpstackframe8559);
gc_frame_newslot((Object)stackframe);
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8564 = gc_frame_new();
// compilenode returning *var_constructorName
  gc_frame_newslot(*var_constructorName);
// compilenode returning *var_csig
  gc_frame_newslot(*var_csig);
// Begin line 2664
  setline(2664);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8565 = alloc_BuiltinList();
  gc_pause();
  int callframe8566 = gc_frame_new();
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
  Object bool8567 = alloc_Boolean(0);
// compilenode returning bool8567
  gc_frame_newslot(bool8567);
  int callframe8568 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8569 = callmethod(*var_ast, "objectNode",
    1, partcv, params);
  gc_frame_end(callframe8568);
// compilenode returning call8569
// compilenode returning call8569
  params[0] = *var_body;
  params[1] = bool8567;
  partcv[0] = 2;
  Object call8570 = callmethod(call8569, "new",
    1, partcv, params);
  gc_frame_end(callframe8566);
// compilenode returning call8570
  params[0] = call8570;
  partcv[0] = 1;
  callmethod(array8565, "push", 1, partcv, params);
  gc_unpause();
// compilenode returning array8565
  gc_frame_newslot(array8565);
  Object bool8571 = alloc_Boolean(0);
// compilenode returning bool8571
  gc_frame_newslot(bool8571);
// Begin line 2663
  setline(2663);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8572 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8573 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8572);
// compilenode returning call8573
// compilenode returning call8573
  params[0] = *var_constructorName;
  params[1] = *var_csig;
  params[2] = array8565;
  params[3] = bool8571;
  partcv[0] = 4;
  Object call8574 = callmethod(call8573, "new",
    1, partcv, params);
  gc_frame_end(callframe8564);
// compilenode returning call8574
    gc_frame_newslot(call8574);
    if8559 = call8574;
  } else {
stackframe = alloc_StackFrame(0, iftmpstackframe8559);
gc_frame_newslot((Object)stackframe);
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8575 = gc_frame_new();
// compilenode returning *var_cname
  gc_frame_newslot(*var_cname);
// compilenode returning *var_csig
  gc_frame_newslot(*var_csig);
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
  Object bool8576 = alloc_Boolean(0);
// compilenode returning bool8576
  gc_frame_newslot(bool8576);
// compilenode returning *var_constructorName
  gc_frame_newslot(*var_constructorName);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
  int callframe8577 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8578 = callmethod(*var_ast, "classNode",
    1, partcv, params);
  gc_frame_end(callframe8577);
// compilenode returning call8578
// compilenode returning call8578
  params[0] = *var_cname;
  params[1] = *var_csig;
  params[2] = *var_body;
  params[3] = bool8576;
  params[4] = *var_constructorName;
  params[5] = *var_dtype;
  partcv[0] = 6;
  Object call8579 = callmethod(call8578, "new",
    1, partcv, params);
  gc_frame_end(callframe8575);
// compilenode returning call8579
    gc_frame_newslot(call8579);
    if8559 = call8579;
  }
stackframe = iftmpstackframe8559;
// compilenode returning if8559
  *var_o = if8559;
  if (if8559 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2666
  setline(2666);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8580 = gc_frame_new();
// Begin line 2668
  setline(2668);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8581 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call8582 = callmethod(*var_s, "generics",
    1, partcv, params);
  gc_frame_end(callframe8581);
// compilenode returning call8582
// compilenode returning call8582
  gc_frame_newslot(call8582);
// compilenode returning *var_o
  params[0] = call8582;
  partcv[0] = 1;
  Object call8583 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8580);
// compilenode returning call8583
// compilenode returning done
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2669
  setline(2669);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_anns
  int op_slot_right_8585 = gc_frame_newslot(*var_anns);
  Object bool8587 = alloc_Boolean(0);
// compilenode returning bool8587
  int op_slot_left_8585 = gc_frame_newslot(bool8587);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8588 = callmethod(bool8587, "!=", 1, partcv, params);
// compilenode returning opresult8588
  Object if8584 = done;
  if (istrue(opresult8588)) {
// Begin line 2670
  setline(2670);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8589 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe8590 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call8591 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8590);
// compilenode returning call8591
// compilenode returning call8591
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8592 = callmethod(call8591, "extend",
    1, partcv, params);
  gc_frame_end(callframe8589);
// compilenode returning call8592
    gc_frame_newslot(call8592);
    if8584 = call8592;
  } else {
// Begin line 2676
  setline(2676);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2672
  setline(2672);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8595 == NULL) {
    strlit8595 = alloc_String("confidential");
    gc_root(strlit8595);
  }
// compilenode returning strlit8595
  int op_slot_right_8594 = gc_frame_newslot(strlit8595);
// compilenode returning *var_defaultMethodVisibility
  int op_slot_left_8594 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8595;
  partcv[0] = 1;
  Object opresult8597 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compilenode returning opresult8597
  Object if8593 = done;
  if (istrue(opresult8597)) {
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8598 = gc_frame_new();
  int callframe8599 = gc_frame_new();
  if (strlit8600 == NULL) {
    strlit8600 = alloc_String("confidential");
    gc_root(strlit8600);
  }
// compilenode returning strlit8600
  gc_frame_newslot(strlit8600);
// Begin line 2674
  setline(2674);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8601 = alloc_Boolean(0);
// compilenode returning bool8601
  gc_frame_newslot(bool8601);
// Begin line 2673
  setline(2673);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8602 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8603 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8602);
// compilenode returning call8603
// compilenode returning call8603
  params[0] = strlit8600;
  params[1] = bool8601;
  partcv[0] = 2;
  Object call8604 = callmethod(call8603, "new",
    1, partcv, params);
  gc_frame_end(callframe8599);
// compilenode returning call8604
  gc_frame_newslot(call8604);
  int callframe8605 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call8606 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8605);
// compilenode returning call8606
// compilenode returning call8606
  params[0] = call8604;
  partcv[0] = 1;
  Object call8607 = callmethod(call8606, "push",
    1, partcv, params);
  gc_frame_end(callframe8598);
// compilenode returning call8607
    gc_frame_newslot(call8607);
    if8593 = call8607;
  } else {
  }
// compilenode returning if8593
    gc_frame_newslot(if8593);
    if8584 = if8593;
  }
// compilenode returning if8584
// Begin line 2677
  setline(2677);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8608 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8609 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8608);
// compilenode returning call8609
// Begin line 2679
  setline(2679);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2678
  setline(2678);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localMinIndentLevel
  *var_minIndentLevel = *var_localMinIndentLevel;
  if (*var_localMinIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8314 = done;
  } else {
  }
// compilenode returning if8314
  gc_frame_end(frame);
  return if8314;
}
Object meth_parser__apply8688(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit8690 == NULL) {
    strlit8690 = alloc_String("lbrace");
    gc_root(strlit8690);
  }
// compilenode returning strlit8690
  int op_slot_right_8689 = gc_frame_newslot(strlit8690);
  int callframe8692 = gc_frame_new();
// compilenode returning *var_s
  partcv[0] = 0;
  Object call8693 = callmethod(*var_s, "kind",
    1, partcv, params);
  gc_frame_end(callframe8692);
// compilenode returning call8693
// compilenode returning call8693
  int op_slot_left_8689 = gc_frame_newslot(call8693);
  params[0] = strlit8690;
  partcv[0] = 1;
  Object opresult8694 = callmethod(call8693, "!=", 1, partcv, params);
// compilenode returning opresult8694
  gc_frame_end(frame);
  return opresult8694;
}
Object meth_parser__apply8697(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_body = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2716
  setline(2716);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8698 = gc_frame_new();
// compilenode returning *var_s
  gc_frame_newslot(*var_s);
// compilenode returning *var_body
  params[0] = *var_s;
  partcv[0] = 1;
  Object call8699 = callmethod(*var_body, "push",
    1, partcv, params);
  gc_frame_end(callframe8698);
// compilenode returning call8699
// Begin line 2717
  setline(2717);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8700 = gc_frame_new();
  partcv[0] = 0;
  Object call8701 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8700);
// compilenode returning call8701
// Begin line 2719
  setline(2719);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2718
  setline(2718);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8702 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8703 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8702);
// compilenode returning call8703
// compilenode returning call8703
  *var_s = call8703;
  if (call8703 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_methoddec8611(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 46, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(18, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methoddec");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_minIndentLevel = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methoddec (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for methoddec");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_btok = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "btok");
  Object *var_stok = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "stok");
  Object *var_m = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "m");
  Object *var_meth = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "meth");
  Object *var_signature = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "signature");
  Object *var_dtype = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "dtype");
  Object *var_varargs = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "varargs");
  Object *var_generics = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "generics");
  Object *var_body = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "body");
  Object *var_localMin = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "localMin");
  Object *var_anns = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "anns");
  Object *var_s = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "s");
  Object *var_suggestion = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "suggestion");
  Object *var_closingBrace = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "closingBrace");
  Object *var_o = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "o");
// Begin line 2768
  setline(2768);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2684
  setline(2684);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8615 == NULL) {
    strlit8615 = alloc_String("method");
    gc_root(strlit8615);
  }
// compilenode returning strlit8615
  int op_slot_right_8614 = gc_frame_newslot(strlit8615);
  int callframe8617 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8618 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8617);
// compilenode returning call8618
// compilenode returning call8618
  int op_slot_left_8614 = gc_frame_newslot(call8618);
  params[0] = strlit8615;
  partcv[0] = 1;
  Object opresult8619 = callmethod(call8618, "==", 1, partcv, params);
// compilenode returning opresult8619
  int op_slot_right_8613 = gc_frame_newslot(opresult8619);
  int callframe8621 = gc_frame_new();
  if (strlit8622 == NULL) {
    strlit8622 = alloc_String("keyword");
    gc_root(strlit8622);
  }
// compilenode returning strlit8622
  gc_frame_newslot(strlit8622);
  params[0] = strlit8622;
  partcv[0] = 1;
  Object call8623 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8621);
// compilenode returning call8623
  int op_slot_left_8613 = gc_frame_newslot(call8623);
  params[0] = opresult8619;
  partcv[0] = 1;
  Object opresult8624 = callmethod(call8623, "&&", 1, partcv, params);
// compilenode returning opresult8624
  Object if8612 = done;
  if (istrue(opresult8624)) {
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2685
  setline(2685);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_btok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2686
  setline(2686);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8625 = gc_frame_new();
  partcv[0] = 0;
  Object call8626 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8625);
// compilenode returning call8626
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2687
  setline(2687);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_stok = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2688
  setline(2688);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8627 = gc_frame_new();
  partcv[0] = 0;
  Object call8628 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8627);
// compilenode returning call8628
// Begin line 2689
  setline(2689);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8629 = gc_frame_new();
  Object bool8630 = alloc_Boolean(0);
// compilenode returning bool8630
  gc_frame_newslot(bool8630);
  params[0] = bool8630;
  partcv[0] = 1;
  Object call8631 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8629);
// compilenode returning call8631
  *var_m = call8631;
  if (call8631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2690
  setline(2690);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8632 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call8633 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe8632);
// compilenode returning call8633
// compilenode returning call8633
  *var_meth = call8633;
  if (call8633 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2691
  setline(2691);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8634 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call8635 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe8634);
// compilenode returning call8635
// compilenode returning call8635
  *var_signature = call8635;
  if (call8635 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2692
  setline(2692);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8636 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call8637 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe8636);
// compilenode returning call8637
// compilenode returning call8637
  *var_dtype = call8637;
  if (call8637 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2693
  setline(2693);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8638 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call8639 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe8638);
// compilenode returning call8639
// compilenode returning call8639
  *var_varargs = call8639;
  if (call8639 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2694
  setline(2694);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8640 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call8641 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe8640);
// compilenode returning call8641
// compilenode returning call8641
  *var_generics = call8641;
  if (call8641 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2696
  setline(2696);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2695
  setline(2695);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8642 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8642
  *var_body = array8642;
  if (array8642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_localMin = undefined;
// compilenode returning done
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2697
  setline(2697);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8643 = gc_frame_new();
  partcv[0] = 0;
  Object call8644 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8643);
// compilenode returning call8644
  *var_anns = call8644;
  if (call8644 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2698
  setline(2698);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8646 = gc_frame_new();
  if (strlit8647 == NULL) {
    strlit8647 = alloc_String("lbrace");
    gc_root(strlit8647);
  }
// compilenode returning strlit8647
  gc_frame_newslot(strlit8647);
  params[0] = strlit8647;
  partcv[0] = 1;
  Object call8648 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8646);
// compilenode returning call8648
  Object if8645 = done;
  if (istrue(call8648)) {
// Begin line 2699
  setline(2699);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8649 = gc_frame_new();
  partcv[0] = 0;
  Object call8650 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8649);
// compilenode returning call8650
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2700
  setline(2700);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  *var_localMin = *var_minIndentLevel;
  if (*var_minIndentLevel == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2701
  setline(2701);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8654 = gc_frame_new();
// compilenode returning *var_stok
  partcv[0] = 0;
  Object call8655 = callmethod(*var_stok, "line",
    1, partcv, params);
  gc_frame_end(callframe8654);
// compilenode returning call8655
// compilenode returning call8655
  int op_slot_right_8653 = gc_frame_newslot(call8655);
  int callframe8657 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8658 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8657);
// compilenode returning call8658
// compilenode returning call8658
  int op_slot_left_8653 = gc_frame_newslot(call8658);
  params[0] = call8655;
  partcv[0] = 1;
  Object opresult8659 = callmethod(call8658, "==", 1, partcv, params);
// compilenode returning opresult8659
  Object if8652 = done;
  if (istrue(opresult8659)) {
// Begin line 2703
  setline(2703);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2702
  setline(2702);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8661 = alloc_Float64(1);
// compilenode returning num8661
  int op_slot_right_8660 = gc_frame_newslot(num8661);
  int callframe8663 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8664 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8663);
// compilenode returning call8664
// compilenode returning call8664
  int op_slot_left_8660 = gc_frame_newslot(call8664);
  params[0] = num8661;
  partcv[0] = 1;
  Object diff8665 = callmethod(call8664, "-", 1, partcv, params);
// compilenode returning diff8665
  *var_minIndentLevel = diff8665;
  if (diff8665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8652 = done;
  } else {
// Begin line 2705
  setline(2705);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2704
  setline(2704);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num8668 = alloc_Float64(1);
// compilenode returning num8668
  int op_slot_right_8667 = gc_frame_newslot(num8668);
  int callframe8670 = gc_frame_new();
// compilenode returning *var_stok
  partcv[0] = 0;
  Object call8671 = callmethod(*var_stok, "indent",
    1, partcv, params);
  gc_frame_end(callframe8670);
// compilenode returning call8671
// compilenode returning call8671
  int op_slot_left_8667 = gc_frame_newslot(call8671);
  params[0] = num8668;
  partcv[0] = 1;
  Object sum8672 = callmethod(call8671, "+", 1, partcv, params);
// compilenode returning sum8672
  *var_minIndentLevel = sum8672;
  if (sum8672 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8652 = done;
  }
// compilenode returning if8652
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8674 = gc_frame_new();
  Object inheritingObject8675 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj8675 = alloc_userobj2(4,4, objclass8675);
  gc_frame_newslot(obj8675);
// OBJECT OUTER DEC outer
  adddatum2(obj8675, self, 0);
  addmethodreal(obj8675,"outer", &reader_parser_outer_8676);
  Object oldself8675 = self;
  struct StackFrameObject *oldstackframe8675 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe8675);
  gc_frame_newslot((Object)stackframe);
  self = obj8675;
  Object *oldselfslot8675 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter8675 = (*(struct UserObject *)self).data[0], lowerouter8675 = thisouter8675;
  if (inheritingObject8675) {
    struct UserObject *inho8675 = (struct UserObject *)inheritingObject8675;
    while (inho8675->super != GraceDefaultObject) inho8675 = (struct UserObject *)inho8675->super;
    inho8675->super = obj8675;
    self = inheritingObject8675;
    *selfslot = self;
    lowerouter8675 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter8675;
  }
if (objclass8675 == NULL) {
  Method *reader8677 = addmethodrealflags(obj8675, "kind",&reader_parser_kind_8677, 0);
  Method *writer8677 = addmethodrealflags(obj8675, "kind:=",&writer_parser_kind_8677, 0);
  reader8677->definitionModule = modulename;
  writer8677->definitionModule = modulename;
  reader8677->definitionLine = 2708;
  writer8677->definitionLine = 2708;
}
obj8675->flags |= OFLAG_MUTABLE;
adddatum2(obj8675, alloc_Undefined(), 1);
if (objclass8675 == NULL) {
  Method *reader8678 = addmethodrealflags(obj8675, "register",&reader_parser_register_8678, 0);
  Method *writer8678 = addmethodrealflags(obj8675, "register:=",&writer_parser_register_8678, 0);
  reader8678->definitionModule = modulename;
  writer8678->definitionModule = modulename;
  reader8678->definitionLine = 2709;
  writer8678->definitionLine = 2709;
}
obj8675->flags |= OFLAG_MUTABLE;
adddatum2(obj8675, alloc_Undefined(), 2);
  sourceObject = obj8675;
// Begin line 2707
  setline(2707);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8679 == NULL) {
    strlit8679 = alloc_String("lbrace");
    gc_root(strlit8679);
  }
// compilenode returning strlit8679
  adddatum2(obj8675, strlit8679, 1);
  sourceObject = obj8675;
// Begin line 2708
  setline(2708);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8680 == NULL) {
    strlit8680 = alloc_String("");
    gc_root(strlit8680);
  }
// compilenode returning strlit8680
  adddatum2(obj8675, strlit8680, 2);
objclass8675 = obj8675->class;
  objclass8675->definitionModule = modulename;
  objclass8675->definitionLine = 2706;
  (*(struct UserObject *)self).data[0] = lowerouter8675;
  self = oldself8675;
  selfslot = oldselfslot8675;
  stackframe = oldstackframe8675;
// compilenode returning obj8675
  gc_frame_newslot(obj8675);
// Begin line 2706
  setline(2706);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  params[0] = obj8675;
  partcv[0] = 1;
  Object call8681 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8674);
// compilenode returning call8681
// Begin line 2710
  setline(2710);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8682 = gc_frame_new();
  partcv[0] = 0;
  Object call8683 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8682);
// compilenode returning call8683
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2711
  setline(2711);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8684 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8685 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8684);
// compilenode returning call8685
// compilenode returning call8685
  *var_s = call8685;
  if (call8685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2712
  setline(2712);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8686 = gc_frame_new();
  Object block8687 = alloc_Block(NULL, NULL, "parser", 2712);
  gc_frame_newslot(block8687);
  block_savedest(block8687);
  Object closure8688 = createclosure(2, "_apply");
setclosureframe(closure8688, stackframe);
  addtoclosure(closure8688, var_s);
  addtoclosure(closure8688, selfslot);
  struct UserObject *uo8688 = (struct UserObject*)block8687;
  uo8688->data[0] = (Object)closure8688;
  Method *meth_meth_parser__apply8688 = addmethod2pos(block8687, "_apply", &meth_parser__apply8688, 0);
int argcv_meth_parser__apply8688[] = {0};
meth_meth_parser__apply8688->type = alloc_MethodType(1, argcv_meth_parser__apply8688);
  meth_meth_parser__apply8688->definitionModule = modulename;
  meth_meth_parser__apply8688->definitionLine = 2711;
// compilenode returning block8687
  gc_frame_newslot(block8687);
  Object block8696 = alloc_Block(NULL, NULL, "parser", 2712);
  gc_frame_newslot(block8696);
  block_savedest(block8696);
  Object closure8697 = createclosure(4, "_apply");
setclosureframe(closure8697, stackframe);
  addtoclosure(closure8697, var_s);
  addtoclosure(closure8697, var_body);
  addtoclosure(closure8697, var_values);
  addtoclosure(closure8697, selfslot);
  struct UserObject *uo8697 = (struct UserObject*)block8696;
  uo8697->data[0] = (Object)closure8697;
  Method *meth_meth_parser__apply8697 = addmethod2pos(block8696, "_apply", &meth_parser__apply8697, 0);
int argcv_meth_parser__apply8697[] = {0};
meth_meth_parser__apply8697->type = alloc_MethodType(1, argcv_meth_parser__apply8697);
  meth_meth_parser__apply8697->definitionModule = modulename;
  meth_meth_parser__apply8697->definitionLine = 2712;
// compilenode returning block8696
  gc_frame_newslot(block8696);
  params[0] = block8687;
  params[1] = block8696;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8706 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8686);
// compilenode returning call8706
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2720
  setline(2720);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8709 == NULL) {
    strlit8709 = alloc_String("rbrace");
    gc_root(strlit8709);
  }
// compilenode returning strlit8709
  int op_slot_right_8708 = gc_frame_newslot(strlit8709);
  int callframe8711 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8712 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8711);
// compilenode returning call8712
// compilenode returning call8712
  int op_slot_left_8708 = gc_frame_newslot(call8712);
  params[0] = strlit8709;
  partcv[0] = 1;
  Object opresult8713 = callmethod(call8712, "!=", 1, partcv, params);
// compilenode returning opresult8713
  Object if8707 = done;
  if (istrue(opresult8713)) {
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2721
  setline(2721);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8714 = gc_frame_new();
  int callframe8715 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8716 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8715);
// compilenode returning call8716
// compilenode returning call8716
  partcv[0] = 0;
  Object call8717 = callmethod(call8716, "new",
    1, partcv, params);
  gc_frame_end(callframe8714);
// compilenode returning call8717
// compilenode returning call8717
  *var_suggestion = call8717;
  if (call8717 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2722
  setline(2722);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8718 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool8719 = alloc_Boolean(0);
// compilenode returning bool8719
  gc_frame_newslot(bool8719);
  params[0] = *var_btok;
  params[1] = bool8719;
  partcv[0] = 2;
  Object call8720 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8718);
// compilenode returning call8720
  *var_closingBrace = call8720;
  if (call8720 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2723
  setline(2723);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8723 = alloc_Boolean(0);
// compilenode returning bool8723
  int op_slot_right_8722 = gc_frame_newslot(bool8723);
  int callframe8725 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8726 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8725);
// compilenode returning call8726
// compilenode returning call8726
  int op_slot_left_8722 = gc_frame_newslot(call8726);
  params[0] = bool8723;
  partcv[0] = 1;
  Object opresult8727 = callmethod(call8726, "==", 1, partcv, params);
// compilenode returning opresult8727
  Object if8721 = done;
  if (istrue(opresult8727)) {
// Begin line 2729
  setline(2729);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2724
  setline(2724);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_8729 = gc_frame_newslot(*var_sym);
  int callframe8731 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8732 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8731);
// compilenode returning call8732
// compilenode returning call8732
  int op_slot_left_8729 = gc_frame_newslot(call8732);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult8733 = callmethod(call8732, "==", 1, partcv, params);
// compilenode returning opresult8733
  Object if8728 = done;
  if (istrue(opresult8733)) {
// Begin line 2725
  setline(2725);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8734 = gc_frame_new();
  if (strlit8735 == NULL) {
    strlit8735 = alloc_String("}");
    gc_root(strlit8735);
  }
// compilenode returning strlit8735
  gc_frame_newslot(strlit8735);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8735;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8736 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8734);
// compilenode returning call8736
    gc_frame_newslot(call8736);
    if8728 = call8736;
  } else {
// Begin line 2727
  setline(2727);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8737 = gc_frame_new();
  Object num8739 = alloc_Float64(0.1);
// compilenode returning num8739
  int op_slot_right_8738 = gc_frame_newslot(num8739);
  int callframe8741 = gc_frame_new();
  int callframe8742 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8743 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8742);
// compilenode returning call8743
// compilenode returning call8743
  partcv[0] = 0;
  Object call8744 = callmethod(call8743, "line",
    1, partcv, params);
  gc_frame_end(callframe8741);
// compilenode returning call8744
// compilenode returning call8744
  int op_slot_left_8738 = gc_frame_newslot(call8744);
  params[0] = num8739;
  partcv[0] = 1;
  Object sum8745 = callmethod(call8744, "+", 1, partcv, params);
// compilenode returning sum8745
  gc_frame_newslot(sum8745);
  if (strlit8746 == NULL) {
    strlit8746 = alloc_String("}");
    gc_root(strlit8746);
  }
// compilenode returning strlit8746
  gc_frame_newslot(strlit8746);
// compilenode returning *var_suggestion
  params[0] = sum8745;
  params[1] = strlit8746;
  partcv[0] = 2;
  Object call8747 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8737);
// compilenode returning call8747
    gc_frame_newslot(call8747);
    if8728 = call8747;
  }
// compilenode returning if8728
    gc_frame_newslot(if8728);
    if8721 = if8728;
  } else {
  }
// compilenode returning if8721
// Begin line 2730
  setline(2730);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8748 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call8749 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8748);
// compilenode returning call8749
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8750 = gc_frame_new();
  if (strlit8751 == NULL) {
    strlit8751 = alloc_String("A method must end with a '}'.");
    gc_root(strlit8751);
  }
// compilenode returning strlit8751
  gc_frame_newslot(strlit8751);
// Begin line 2732
  setline(2732);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8752 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8753 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8752);
// compilenode returning call8753
// compilenode returning call8753
  gc_frame_newslot(call8753);
  int callframe8754 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8755 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8754);
// compilenode returning call8755
// compilenode returning call8755
  gc_frame_newslot(call8755);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2731
  setline(2731);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8751;
  params[1] = call8753;
  params[2] = call8755;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8756 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8750);
// compilenode returning call8756
    gc_frame_newslot(call8756);
    if8707 = call8756;
  } else {
  }
// compilenode returning if8707
// Begin line 2734
  setline(2734);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8757 = gc_frame_new();
  partcv[0] = 0;
  Object call8758 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8757);
// compilenode returning call8758
// Begin line 2736
  setline(2736);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2735
  setline(2735);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_localMin
  *var_minIndentLevel = *var_localMin;
  if (*var_localMin == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if8645 = done;
  } else {
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2737
  setline(2737);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8760 = gc_frame_new();
  int callframe8761 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8762 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8761);
// compilenode returning call8762
// compilenode returning call8762
  partcv[0] = 0;
  Object call8763 = callmethod(call8762, "new",
    1, partcv, params);
  gc_frame_end(callframe8760);
// compilenode returning call8763
// compilenode returning call8763
  *var_suggestion = call8763;
  if (call8763 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2738
  setline(2738);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8764 = gc_frame_new();
// compilenode returning *var_btok
  gc_frame_newslot(*var_btok);
  Object bool8765 = alloc_Boolean(1);
// compilenode returning bool8765
  gc_frame_newslot(bool8765);
  params[0] = *var_btok;
  params[1] = bool8765;
  partcv[0] = 2;
  Object call8766 = callmethodflags(self, "findClosingBrace", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8764);
// compilenode returning call8766
  *var_closingBrace = call8766;
  if (call8766 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2739
  setline(2739);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8769 = alloc_Boolean(0);
// compilenode returning bool8769
  int op_slot_right_8768 = gc_frame_newslot(bool8769);
  int callframe8771 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8772 = callmethod(*var_closingBrace, "found",
    1, partcv, params);
  gc_frame_end(callframe8771);
// compilenode returning call8772
// compilenode returning call8772
  int op_slot_left_8768 = gc_frame_newslot(call8772);
  params[0] = bool8769;
  partcv[0] = 1;
  Object opresult8773 = callmethod(call8772, "==", 1, partcv, params);
// compilenode returning opresult8773
  Object if8767 = done;
  if (istrue(opresult8773)) {
// Begin line 2746
  setline(2746);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2740
  setline(2740);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  int op_slot_right_8775 = gc_frame_newslot(*var_lastToken);
  int callframe8777 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8778 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8777);
// compilenode returning call8778
// compilenode returning call8778
  int op_slot_left_8775 = gc_frame_newslot(call8778);
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object opresult8779 = callmethod(call8778, "==", 1, partcv, params);
// compilenode returning opresult8779
  Object if8774 = done;
  if (istrue(opresult8779)) {
// Begin line 2741
  setline(2741);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8780 = gc_frame_new();
  if (strlit8781 == NULL) {
    strlit8781 = alloc_String(" {}");
    gc_root(strlit8781);
  }
// compilenode returning strlit8781
  gc_frame_newslot(strlit8781);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool8782 = alloc_Boolean(1);
// compilenode returning bool8782
  gc_frame_newslot(bool8782);
// compilenode returning *var_suggestion
  params[0] = strlit8781;
  params[1] = *var_lastToken;
  params[2] = bool8782;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8783 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8780);
// compilenode returning call8783
    gc_frame_newslot(call8783);
    if8774 = call8783;
  } else {
// Begin line 2743
  setline(2743);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8784 = gc_frame_new();
  Object num8786 = alloc_Float64(0.1);
// compilenode returning num8786
  int op_slot_right_8785 = gc_frame_newslot(num8786);
  int callframe8788 = gc_frame_new();
  int callframe8789 = gc_frame_new();
// compilenode returning *var_closingBrace
  partcv[0] = 0;
  Object call8790 = callmethod(*var_closingBrace, "tok",
    1, partcv, params);
  gc_frame_end(callframe8789);
// compilenode returning call8790
// compilenode returning call8790
  partcv[0] = 0;
  Object call8791 = callmethod(call8790, "line",
    1, partcv, params);
  gc_frame_end(callframe8788);
// compilenode returning call8791
// compilenode returning call8791
  int op_slot_left_8785 = gc_frame_newslot(call8791);
  params[0] = num8786;
  partcv[0] = 1;
  Object sum8792 = callmethod(call8791, "+", 1, partcv, params);
// compilenode returning sum8792
  gc_frame_newslot(sum8792);
  if (strlit8793 == NULL) {
    strlit8793 = alloc_String("}");
    gc_root(strlit8793);
  }
// compilenode returning strlit8793
  gc_frame_newslot(strlit8793);
// compilenode returning *var_suggestion
  params[0] = sum8792;
  params[1] = strlit8793;
  partcv[0] = 2;
  Object call8794 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe8784);
// compilenode returning call8794
// Begin line 2744
  setline(2744);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8795 = gc_frame_new();
  if (strlit8796 == NULL) {
    strlit8796 = alloc_String(" {");
    gc_root(strlit8796);
  }
// compilenode returning strlit8796
  gc_frame_newslot(strlit8796);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool8797 = alloc_Boolean(1);
// compilenode returning bool8797
  gc_frame_newslot(bool8797);
// compilenode returning *var_suggestion
  params[0] = strlit8796;
  params[1] = *var_lastToken;
  params[2] = bool8797;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8798 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8795);
// compilenode returning call8798
    gc_frame_newslot(call8798);
    if8774 = call8798;
  }
// compilenode returning if8774
    gc_frame_newslot(if8774);
    if8767 = if8774;
  } else {
// Begin line 2747
  setline(2747);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8799 = gc_frame_new();
  if (strlit8800 == NULL) {
    strlit8800 = alloc_String(" {");
    gc_root(strlit8800);
  }
// compilenode returning strlit8800
  gc_frame_newslot(strlit8800);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool8801 = alloc_Boolean(1);
// compilenode returning bool8801
  gc_frame_newslot(bool8801);
// compilenode returning *var_suggestion
  params[0] = strlit8800;
  params[1] = *var_lastToken;
  params[2] = bool8801;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call8802 = callmethod(*var_suggestion, "insert()afterToken()andTrailingSpace",
    3, partcv, params);
  gc_frame_end(callframe8799);
// compilenode returning call8802
    gc_frame_newslot(call8802);
    if8767 = call8802;
  }
// compilenode returning if8767
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8803 = gc_frame_new();
  if (strlit8804 == NULL) {
    strlit8804 = alloc_String("A method must have a '{' after the name.");
    gc_root(strlit8804);
  }
// compilenode returning strlit8804
  gc_frame_newslot(strlit8804);
// Begin line 2750
  setline(2750);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8805 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8806 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe8805);
// compilenode returning call8806
// compilenode returning call8806
  gc_frame_newslot(call8806);
  int callframe8808 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8809 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe8808);
// compilenode returning call8809
// compilenode returning call8809
  int op_slot_right_8807 = gc_frame_newslot(call8809);
  int callframe8811 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call8812 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8811);
// compilenode returning call8812
// compilenode returning call8812
  int op_slot_left_8807 = gc_frame_newslot(call8812);
  params[0] = call8809;
  partcv[0] = 1;
  Object sum8813 = callmethod(call8812, "+", 1, partcv, params);
// compilenode returning sum8813
  gc_frame_newslot(sum8813);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2749
  setline(2749);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8804;
  params[1] = call8806;
  params[2] = sum8813;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8814 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8803);
// compilenode returning call8814
    gc_frame_newslot(call8814);
    if8645 = call8814;
  }
// compilenode returning if8645
// Begin line 2752
  setline(2752);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8815 = gc_frame_new();
  int callframe8816 = gc_frame_new();
// compilenode returning *var_btok
  partcv[0] = 0;
  Object call8817 = callmethod(*var_btok, "line",
    1, partcv, params);
  gc_frame_end(callframe8816);
// compilenode returning call8817
// compilenode returning call8817
  gc_frame_newslot(call8817);
// compilenode returning *var_util
  params[0] = call8817;
  partcv[0] = 1;
  Object call8818 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe8815);
// compilenode returning call8818
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8819 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
// compilenode returning *var_body
  gc_frame_newslot(*var_body);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
  int callframe8820 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8821 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe8820);
// compilenode returning call8821
// compilenode returning call8821
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = *var_body;
  params[3] = *var_dtype;
  partcv[0] = 4;
  Object call8822 = callmethod(call8821, "new",
    1, partcv, params);
  gc_frame_end(callframe8819);
// compilenode returning call8822
  *var_o = call8822;
  if (call8822 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2754
  setline(2754);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varargs
  Object if8823 = done;
  if (istrue(*var_varargs)) {
// Begin line 2756
  setline(2756);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8824 = gc_frame_new();
// Begin line 2755
  setline(2755);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8825 = alloc_Boolean(1);
// compilenode returning bool8825
  gc_frame_newslot(bool8825);
// compilenode returning *var_o
  params[0] = bool8825;
  partcv[0] = 1;
  Object call8826 = callmethod(*var_o, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe8824);
// compilenode returning call8826
// compilenode returning done
    gc_frame_newslot(done);
    if8823 = done;
  } else {
  }
// compilenode returning if8823
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2753
  setline(2753);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8827 = gc_frame_new();
// Begin line 2757
  setline(2757);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_generics
  gc_frame_newslot(*var_generics);
// compilenode returning *var_o
  params[0] = *var_generics;
  partcv[0] = 1;
  Object call8828 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe8827);
// compilenode returning call8828
// compilenode returning done
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2758
  setline(2758);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_anns
  int op_slot_right_8830 = gc_frame_newslot(*var_anns);
  Object bool8832 = alloc_Boolean(0);
// compilenode returning bool8832
  int op_slot_left_8830 = gc_frame_newslot(bool8832);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult8833 = callmethod(bool8832, "!=", 1, partcv, params);
// compilenode returning opresult8833
  Object if8829 = done;
  if (istrue(opresult8833)) {
// Begin line 2759
  setline(2759);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8834 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe8835 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call8836 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8835);
// compilenode returning call8836
// compilenode returning call8836
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call8837 = callmethod(call8836, "extend",
    1, partcv, params);
  gc_frame_end(callframe8834);
// compilenode returning call8837
    gc_frame_newslot(call8837);
    if8829 = call8837;
  } else {
// Begin line 2765
  setline(2765);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2761
  setline(2761);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8840 == NULL) {
    strlit8840 = alloc_String("confidential");
    gc_root(strlit8840);
  }
// compilenode returning strlit8840
  int op_slot_right_8839 = gc_frame_newslot(strlit8840);
// compilenode returning *var_defaultMethodVisibility
  int op_slot_left_8839 = gc_frame_newslot(*var_defaultMethodVisibility);
  params[0] = strlit8840;
  partcv[0] = 1;
  Object opresult8842 = callmethod(*var_defaultMethodVisibility, "==", 1, partcv, params);
// compilenode returning opresult8842
  Object if8838 = done;
  if (istrue(opresult8842)) {
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8843 = gc_frame_new();
  int callframe8844 = gc_frame_new();
  if (strlit8845 == NULL) {
    strlit8845 = alloc_String("confidential");
    gc_root(strlit8845);
  }
// compilenode returning strlit8845
  gc_frame_newslot(strlit8845);
// Begin line 2763
  setline(2763);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8846 = alloc_Boolean(0);
// compilenode returning bool8846
  gc_frame_newslot(bool8846);
// Begin line 2762
  setline(2762);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8847 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8848 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe8847);
// compilenode returning call8848
// compilenode returning call8848
  params[0] = strlit8845;
  params[1] = bool8846;
  partcv[0] = 2;
  Object call8849 = callmethod(call8848, "new",
    1, partcv, params);
  gc_frame_end(callframe8844);
// compilenode returning call8849
  gc_frame_newslot(call8849);
  int callframe8850 = gc_frame_new();
// compilenode returning *var_o
  partcv[0] = 0;
  Object call8851 = callmethod(*var_o, "annotations",
    1, partcv, params);
  gc_frame_end(callframe8850);
// compilenode returning call8851
// compilenode returning call8851
  params[0] = call8849;
  partcv[0] = 1;
  Object call8852 = callmethod(call8851, "push",
    1, partcv, params);
  gc_frame_end(callframe8843);
// compilenode returning call8852
    gc_frame_newslot(call8852);
    if8838 = call8852;
  } else {
  }
// compilenode returning if8838
    gc_frame_newslot(if8838);
    if8829 = if8838;
  }
// compilenode returning if8829
// Begin line 2766
  setline(2766);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8853 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call8854 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe8853);
// compilenode returning call8854
    gc_frame_newslot(call8854);
    if8612 = call8854;
  } else {
  }
// compilenode returning if8612
  gc_frame_end(frame);
  return if8612;
}
Object meth_parser__apply8864(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sameline = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe8866 = gc_frame_new();
  if (strlit8867 == NULL) {
    strlit8867 = alloc_String("identifier");
    gc_root(strlit8867);
  }
// compilenode returning strlit8867
  gc_frame_newslot(strlit8867);
  params[0] = strlit8867;
  partcv[0] = 1;
  Object call8868 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8866);
// compilenode returning call8868
  int op_slot_right_8865 = gc_frame_newslot(call8868);
  int callframe8871 = gc_frame_new();
  if (strlit8872 == NULL) {
    strlit8872 = alloc_String("identifier");
    gc_root(strlit8872);
  }
// compilenode returning strlit8872
  gc_frame_newslot(strlit8872);
  params[0] = strlit8872;
  partcv[0] = 1;
  Object call8873 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8871);
// compilenode returning call8873
  int op_slot_right_8870 = gc_frame_newslot(call8873);
  int callframe8875 = gc_frame_new();
// compilenode returning *var_sameline
  partcv[0] = 0;
  Object call8876 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe8875);
// compilenode returning call8876
  int op_slot_left_8870 = gc_frame_newslot(call8876);
  params[0] = call8873;
  partcv[0] = 1;
  Object opresult8877 = callmethod(call8876, "&&", 1, partcv, params);
// compilenode returning opresult8877
  int op_slot_left_8865 = gc_frame_newslot(opresult8877);
  params[0] = call8868;
  partcv[0] = 1;
  Object opresult8878 = callmethod(opresult8877, "||", 1, partcv, params);
// compilenode returning opresult8878
  gc_frame_end(frame);
  return opresult8878;
}
Object meth_parser__apply8932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8936 == NULL) {
    strlit8936 = alloc_String("*");
    gc_root(strlit8936);
  }
// compilenode returning strlit8936
  int op_slot_right_8935 = gc_frame_newslot(strlit8936);
  int callframe8938 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8939 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe8938);
// compilenode returning call8939
// compilenode returning call8939
  int op_slot_left_8935 = gc_frame_newslot(call8939);
  params[0] = strlit8936;
  partcv[0] = 1;
  Object opresult8940 = callmethod(call8939, "==", 1, partcv, params);
// compilenode returning opresult8940
  int op_slot_right_8934 = gc_frame_newslot(opresult8940);
  int callframe8942 = gc_frame_new();
  if (strlit8943 == NULL) {
    strlit8943 = alloc_String("op");
    gc_root(strlit8943);
  }
// compilenode returning strlit8943
  gc_frame_newslot(strlit8943);
  params[0] = strlit8943;
  partcv[0] = 1;
  Object call8944 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8942);
// compilenode returning call8944
  int op_slot_left_8934 = gc_frame_newslot(call8944);
  params[0] = opresult8940;
  partcv[0] = 1;
  Object opresult8945 = callmethod(call8944, "&&", 1, partcv, params);
// compilenode returning opresult8945
  int op_slot_right_8933 = gc_frame_newslot(opresult8945);
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8947 = gc_frame_new();
  if (strlit8948 == NULL) {
    strlit8948 = alloc_String("identifier");
    gc_root(strlit8948);
  }
// compilenode returning strlit8948
  gc_frame_newslot(strlit8948);
  params[0] = strlit8948;
  partcv[0] = 1;
  Object call8949 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8947);
// compilenode returning call8949
  int op_slot_left_8933 = gc_frame_newslot(call8949);
  params[0] = opresult8945;
  partcv[0] = 1;
  Object opresult8950 = callmethod(call8949, "||", 1, partcv, params);
// compilenode returning opresult8950
  gc_frame_end(frame);
  return opresult8950;
}
Object meth_parser__apply8953(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_vararg = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_comma = getfromclosure(closure, 4);
  Object *var_values = getfromclosure(closure, 5);
  Object *var_nxt = getfromclosure(closure, 6);
  Object *var_part = getfromclosure(closure, 7);
  Object *var_tm = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tp = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tp");
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2797
  setline(2797);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8955 = gc_frame_new();
  if (strlit8956 == NULL) {
    strlit8956 = alloc_String("op");
    gc_root(strlit8956);
  }
// compilenode returning strlit8956
  gc_frame_newslot(strlit8956);
  params[0] = strlit8956;
  partcv[0] = 1;
  Object call8957 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8955);
// compilenode returning call8957
  Object if8954 = done;
  if (istrue(call8957)) {
// Begin line 2798
  setline(2798);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8958 = gc_frame_new();
  partcv[0] = 0;
  Object call8959 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8958);
// compilenode returning call8959
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2799
  setline(2799);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8960 = alloc_Boolean(1);
// compilenode returning bool8960
  *var_vararg = bool8960;
  if (bool8960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2817
  setline(2817);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2800
  setline(2800);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8964 == NULL) {
    strlit8964 = alloc_String("identifier");
    gc_root(strlit8964);
  }
// compilenode returning strlit8964
  int op_slot_right_8963 = gc_frame_newslot(strlit8964);
  int callframe8966 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8967 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe8966);
// compilenode returning call8967
// compilenode returning call8967
  int op_slot_left_8963 = gc_frame_newslot(call8967);
  params[0] = strlit8964;
  partcv[0] = 1;
  Object opresult8968 = callmethod(call8967, "!=", 1, partcv, params);
// compilenode returning opresult8968
  Object if8962 = done;
  if (istrue(opresult8968)) {
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2801
  setline(2801);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array8969 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array8969
  *var_suggestions = array8969;
  if (array8969 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2802
  setline(2802);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8970 = gc_frame_new();
  int callframe8971 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8972 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8971);
// compilenode returning call8972
// compilenode returning call8972
  partcv[0] = 0;
  Object call8973 = callmethod(call8972, "new",
    1, partcv, params);
  gc_frame_end(callframe8970);
// compilenode returning call8973
// compilenode returning call8973
  *var_suggestion = call8973;
  if (call8973 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2803
  setline(2803);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8974 = gc_frame_new();
  if (strlit8975 == NULL) {
    strlit8975 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit8975);
  }
// compilenode returning strlit8975
  gc_frame_newslot(strlit8975);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8975;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8976 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8974);
// compilenode returning call8976
// Begin line 2804
  setline(2804);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8977 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8978 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8977);
// compilenode returning call8978
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2805
  setline(2805);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8981 = alloc_Boolean(0);
// compilenode returning bool8981
  int op_slot_right_8980 = gc_frame_newslot(bool8981);
// compilenode returning *var_comma
  int op_slot_left_8980 = gc_frame_newslot(*var_comma);
  params[0] = bool8981;
  partcv[0] = 1;
  Object opresult8983 = callmethod(*var_comma, "==", 1, partcv, params);
// compilenode returning opresult8983
  Object if8979 = done;
  if (istrue(opresult8983)) {
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2806
  setline(2806);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8984 = gc_frame_new();
  int callframe8985 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8986 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8985);
// compilenode returning call8986
// compilenode returning call8986
  partcv[0] = 0;
  Object call8987 = callmethod(call8986, "new",
    1, partcv, params);
  gc_frame_end(callframe8984);
// compilenode returning call8987
// compilenode returning call8987
  *var_suggestion = call8987;
  if (call8987 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2807
  setline(2807);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8989 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call8990 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe8989);
// compilenode returning call8990
// Begin line 2808
  setline(2808);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8991 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call8992 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe8991);
// compilenode returning call8992
    gc_frame_newslot(call8992);
    if8979 = call8992;
  } else {
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2810
  setline(2810);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8993 = gc_frame_new();
  int callframe8994 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8995 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8994);
// compilenode returning call8995
// compilenode returning call8995
  partcv[0] = 0;
  Object call8996 = callmethod(call8995, "new",
    1, partcv, params);
  gc_frame_end(callframe8993);
// compilenode returning call8996
// compilenode returning call8996
  *var_suggestion = call8996;
  if (call8996 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2811
  setline(2811);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8998 = gc_frame_new();
// compilenode returning *var_comma
  gc_frame_newslot(*var_comma);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call8999 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe8998);
// compilenode returning call8999
// Begin line 2812
  setline(2812);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9000 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9001 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9000);
// compilenode returning call9001
    gc_frame_newslot(call9001);
    if8979 = call9001;
  }
// compilenode returning if8979
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9002 = gc_frame_new();
  if (strlit9003 == NULL) {
    strlit9003 = alloc_String("A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.");
    gc_root(strlit9003);
  }
// compilenode returning strlit9003
  gc_frame_newslot(strlit9003);
// Begin line 2815
  setline(2815);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9004 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9005 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9004);
// compilenode returning call9005
// compilenode returning call9005
  gc_frame_newslot(call9005);
  int callframe9007 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9008 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9007);
// compilenode returning call9008
// compilenode returning call9008
  int op_slot_right_9006 = gc_frame_newslot(call9008);
  int callframe9010 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9011 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9010);
// compilenode returning call9011
// compilenode returning call9011
  int op_slot_left_9006 = gc_frame_newslot(call9011);
  params[0] = call9008;
  partcv[0] = 1;
  Object sum9012 = callmethod(call9011, "+", 1, partcv, params);
// compilenode returning sum9012
  gc_frame_newslot(sum9012);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2814
  setline(2814);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9003;
  params[1] = call9005;
  params[2] = sum9012;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9013 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9002);
// compilenode returning call9013
    gc_frame_newslot(call9013);
    if8962 = call9013;
  } else {
  }
// compilenode returning if8962
    gc_frame_newslot(if8962);
    if8954 = if8962;
  } else {
  }
// compilenode returning if8954
// Begin line 2818
  setline(2818);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9014 = gc_frame_new();
  partcv[0] = 0;
  Object call9015 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9014);
// compilenode returning call9015
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2819
  setline(2819);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9016 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9017 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9016);
// compilenode returning call9017
// compilenode returning call9017
  *var_nxt = call9017;
  if (call9017 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2820
  setline(2820);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9020 = gc_frame_new();
  if (strlit9021 == NULL) {
    strlit9021 = alloc_String("colon");
    gc_root(strlit9021);
  }
// compilenode returning strlit9021
  gc_frame_newslot(strlit9021);
  params[0] = strlit9021;
  partcv[0] = 1;
  Object call9022 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9020);
// compilenode returning call9022
  Object if9019 = done;
  if (istrue(call9022)) {
// Begin line 2821
  setline(2821);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9023 = gc_frame_new();
  partcv[0] = 0;
  Object call9024 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9023);
// compilenode returning call9024
// Begin line 2822
  setline(2822);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9025 = gc_frame_new();
  partcv[0] = 0;
  Object call9026 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9025);
// compilenode returning call9026
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9027 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9028 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9027);
// compilenode returning call9028
// compilenode returning call9028
  *var_tp = call9028;
  if (call9028 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2825
  setline(2825);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9029 = gc_frame_new();
// Begin line 2824
  setline(2824);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_tp
  gc_frame_newslot(*var_tp);
// compilenode returning *var_nxt
  params[0] = *var_tp;
  partcv[0] = 1;
  Object call9030 = callmethod(*var_nxt, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9029);
// compilenode returning call9030
// compilenode returning done
    gc_frame_newslot(done);
    if9019 = done;
  } else {
  }
// compilenode returning if9019
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2826
  setline(2826);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_vararg
  Object if9031 = done;
  if (istrue(*var_vararg)) {
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9032 = gc_frame_new();
// Begin line 2827
  setline(2827);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_nxt
  gc_frame_newslot(*var_nxt);
// compilenode returning *var_part
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9033 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9032);
// compilenode returning call9033
// compilenode returning done
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2823
  setline(2823);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9034 = gc_frame_new();
// Begin line 2828
  setline(2828);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9035 = alloc_Boolean(1);
// compilenode returning bool9035
  gc_frame_newslot(bool9035);
// compilenode returning *var_tm
  params[0] = bool9035;
  partcv[0] = 1;
  Object call9036 = callmethod(*var_tm, "varargs:=",
    1, partcv, params);
  gc_frame_end(callframe9034);
// compilenode returning call9036
// compilenode returning done
// Begin line 2835
  setline(2835);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2829
  setline(2829);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9039 == NULL) {
    strlit9039 = alloc_String("rparen");
    gc_root(strlit9039);
  }
// compilenode returning strlit9039
  int op_slot_right_9038 = gc_frame_newslot(strlit9039);
  int callframe9041 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9042 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9041);
// compilenode returning call9042
// compilenode returning call9042
  int op_slot_left_9038 = gc_frame_newslot(call9042);
  params[0] = strlit9039;
  partcv[0] = 1;
  Object opresult9043 = callmethod(call9042, "!=", 1, partcv, params);
// compilenode returning opresult9043
  Object if9037 = done;
  if (istrue(opresult9043)) {
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2830
  setline(2830);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9044 = gc_frame_new();
  int callframe9045 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9046 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9045);
// compilenode returning call9046
// compilenode returning call9046
  partcv[0] = 0;
  Object call9047 = callmethod(call9046, "new",
    1, partcv, params);
  gc_frame_end(callframe9044);
// compilenode returning call9047
// compilenode returning call9047
  *var_suggestion = call9047;
  if (call9047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2831
  setline(2831);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9048 = gc_frame_new();
  if (strlit9049 == NULL) {
    strlit9049 = alloc_String(")");
    gc_root(strlit9049);
  }
// compilenode returning strlit9049
  gc_frame_newslot(strlit9049);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9049;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9050 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9048);
// compilenode returning call9050
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9051 = gc_frame_new();
  if (strlit9052 == NULL) {
    strlit9052 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9052);
  }
// compilenode returning strlit9052
  gc_frame_newslot(strlit9052);
// Begin line 2833
  setline(2833);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9053 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9054 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9053);
// compilenode returning call9054
// compilenode returning call9054
  gc_frame_newslot(call9054);
  int callframe9056 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9057 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9056);
// compilenode returning call9057
// compilenode returning call9057
  int op_slot_right_9055 = gc_frame_newslot(call9057);
  int callframe9059 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9060 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9059);
// compilenode returning call9060
// compilenode returning call9060
  int op_slot_left_9055 = gc_frame_newslot(call9060);
  params[0] = call9057;
  partcv[0] = 1;
  Object sum9061 = callmethod(call9060, "+", 1, partcv, params);
// compilenode returning sum9061
  gc_frame_newslot(sum9061);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2832
  setline(2832);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9052;
  params[1] = call9054;
  params[2] = sum9061;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9062 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9051);
// compilenode returning call9062
    gc_frame_newslot(call9062);
    if9037 = call9062;
  } else {
  }
// compilenode returning if9037
    gc_frame_newslot(if9037);
    if9031 = if9037;
  } else {
// Begin line 2836
  setline(2836);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9063 = gc_frame_new();
// compilenode returning *var_nxt
  gc_frame_newslot(*var_nxt);
  int callframe9064 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9065 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9064);
// compilenode returning call9065
// compilenode returning call9065
  params[0] = *var_nxt;
  partcv[0] = 1;
  Object call9066 = callmethod(call9065, "push",
    1, partcv, params);
  gc_frame_end(callframe9063);
// compilenode returning call9066
    gc_frame_newslot(call9066);
    if9031 = call9066;
  }
// compilenode returning if9031
// Begin line 2842
  setline(2842);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2838
  setline(2838);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9068 = gc_frame_new();
  if (strlit9069 == NULL) {
    strlit9069 = alloc_String("comma");
    gc_root(strlit9069);
  }
// compilenode returning strlit9069
  gc_frame_newslot(strlit9069);
  params[0] = strlit9069;
  partcv[0] = 1;
  Object call9070 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9068);
// compilenode returning call9070
  Object if9067 = done;
  if (istrue(call9070)) {
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2839
  setline(2839);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2840
  setline(2840);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9072 = gc_frame_new();
  partcv[0] = 0;
  Object call9073 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9072);
// compilenode returning call9073
    gc_frame_newslot(call9073);
    if9067 = call9073;
  } else {
  }
// compilenode returning if9067
  gc_frame_end(frame);
  return if9067;
}
Object meth_parser__apply8881(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_methname = getfromclosure(closure, 0);
  Object *var_ast = getfromclosure(closure, 1);
  Object *var_values = getfromclosure(closure, 2);
  Object *var_nxt = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_tm = getfromclosure(closure, 7);
  Object *var_signature = getfromclosure(closure, 8);
  Object self = *(getfromclosure(closure, 9));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_part = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "part");
  Object *var_vararg = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "vararg");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_comma = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "comma");
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2780
  setline(2780);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit8883 == NULL) {
    strlit8883 = alloc_String("()");
    gc_root(strlit8883);
  }
// compilenode returning strlit8883
  int op_slot_right_8882 = gc_frame_newslot(strlit8883);
// compilenode returning *var_methname
  int op_slot_left_8882 = gc_frame_newslot(*var_methname);
  params[0] = strlit8883;
  partcv[0] = 1;
  Object opresult8885 = callmethod(*var_methname, "++", 1, partcv, params);
// compilenode returning opresult8885
  *var_methname = opresult8885;
  if (opresult8885 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2781
  setline(2781);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8887 = gc_frame_new();
  int callframe8888 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call8889 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe8888);
// compilenode returning call8889
// compilenode returning call8889
  partcv[0] = 0;
  Object call8890 = callmethod(call8889, "new",
    1, partcv, params);
  gc_frame_end(callframe8887);
// compilenode returning call8890
// compilenode returning call8890
  *var_part = call8890;
  if (call8890 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2782
  setline(2782);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8891 = gc_frame_new();
  partcv[0] = 0;
  Object call8892 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8891);
// compilenode returning call8892
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2783
  setline(2783);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8893 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call8894 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe8893);
// compilenode returning call8894
// compilenode returning call8894
  *var_nxt = call8894;
  if (call8894 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8897 = gc_frame_new();
// compilenode returning *var_nxt
  partcv[0] = 0;
  Object call8898 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8897);
// compilenode returning call8898
// compilenode returning call8898
  int op_slot_right_8896 = gc_frame_newslot(call8898);
// compilenode returning *var_methname
  int op_slot_left_8896 = gc_frame_newslot(*var_methname);
  params[0] = call8898;
  partcv[0] = 1;
  Object opresult8900 = callmethod(*var_methname, "++", 1, partcv, params);
// compilenode returning opresult8900
  *var_methname = opresult8900;
  if (opresult8900 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2784
  setline(2784);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8902 = gc_frame_new();
// Begin line 2785
  setline(2785);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8903 = gc_frame_new();
// compilenode returning *var_nxt
  partcv[0] = 0;
  Object call8904 = callmethod(*var_nxt, "value",
    1, partcv, params);
  gc_frame_end(callframe8903);
// compilenode returning call8904
// compilenode returning call8904
  gc_frame_newslot(call8904);
// compilenode returning *var_part
  params[0] = call8904;
  partcv[0] = 1;
  Object call8905 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe8902);
// compilenode returning call8905
// compilenode returning done
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2786
  setline(2786);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8906 = alloc_Boolean(0);
// compilenode returning bool8906
  *var_vararg = bool8906;
  if (bool8906 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2787
  setline(2787);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8908 = gc_frame_new();
  int callframe8909 = gc_frame_new();
  if (strlit8910 == NULL) {
    strlit8910 = alloc_String("lparen");
    gc_root(strlit8910);
  }
// compilenode returning strlit8910
  gc_frame_newslot(strlit8910);
  params[0] = strlit8910;
  partcv[0] = 1;
  Object call8911 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8909);
// compilenode returning call8911
  partcv[0] = 0;
  Object call8912 = callmethod(call8911, "not",
    1, partcv, params);
  gc_frame_end(callframe8908);
// compilenode returning call8912
// compilenode returning call8912
  Object if8907 = done;
  if (istrue(call8912)) {
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2788
  setline(2788);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8913 = gc_frame_new();
  int callframe8914 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call8915 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe8914);
// compilenode returning call8915
// compilenode returning call8915
  partcv[0] = 0;
  Object call8916 = callmethod(call8915, "new",
    1, partcv, params);
  gc_frame_end(callframe8913);
// compilenode returning call8916
// compilenode returning call8916
  *var_suggestion = call8916;
  if (call8916 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2789
  setline(2789);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8917 = gc_frame_new();
  if (strlit8918 == NULL) {
    strlit8918 = alloc_String("()");
    gc_root(strlit8918);
  }
// compilenode returning strlit8918
  gc_frame_newslot(strlit8918);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit8918;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call8919 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe8917);
// compilenode returning call8919
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8920 = gc_frame_new();
  if (strlit8921 == NULL) {
    strlit8921 = alloc_String("A multi-part method must have parentheses around each part of the method.");
    gc_root(strlit8921);
  }
// compilenode returning strlit8921
  gc_frame_newslot(strlit8921);
// Begin line 2791
  setline(2791);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8922 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8923 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe8922);
// compilenode returning call8923
// compilenode returning call8923
  gc_frame_newslot(call8923);
  int callframe8924 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call8925 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe8924);
// compilenode returning call8925
// compilenode returning call8925
  gc_frame_newslot(call8925);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2790
  setline(2790);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit8921;
  params[1] = call8923;
  params[2] = call8925;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call8926 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe8920);
// compilenode returning call8926
    gc_frame_newslot(call8926);
    if8907 = call8926;
  } else {
  }
// compilenode returning if8907
// Begin line 2793
  setline(2793);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8927 = gc_frame_new();
  partcv[0] = 0;
  Object call8928 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8927);
// compilenode returning call8928
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2794
  setline(2794);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool8929 = alloc_Boolean(0);
// compilenode returning bool8929
  *var_comma = bool8929;
  if (bool8929 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2795
  setline(2795);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8930 = gc_frame_new();
  Object block8931 = alloc_Block(NULL, NULL, "parser", 2795);
  gc_frame_newslot(block8931);
  block_savedest(block8931);
  Object closure8932 = createclosure(2, "_apply");
setclosureframe(closure8932, stackframe);
  addtoclosure(closure8932, var_sym);
  addtoclosure(closure8932, selfslot);
  struct UserObject *uo8932 = (struct UserObject*)block8931;
  uo8932->data[0] = (Object)closure8932;
  Method *meth_meth_parser__apply8932 = addmethod2pos(block8931, "_apply", &meth_parser__apply8932, 0);
int argcv_meth_parser__apply8932[] = {0};
meth_meth_parser__apply8932->type = alloc_MethodType(1, argcv_meth_parser__apply8932);
  meth_meth_parser__apply8932->definitionModule = modulename;
  meth_meth_parser__apply8932->definitionLine = 2791;
// compilenode returning block8931
  gc_frame_newslot(block8931);
// Begin line 2796
  setline(2796);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block8952 = alloc_Block(NULL, NULL, "parser", 2796);
  gc_frame_newslot(block8952);
  block_savedest(block8952);
  Object closure8953 = createclosure(10, "_apply");
setclosureframe(closure8953, stackframe);
  addtoclosure(closure8953, var_vararg);
  addtoclosure(closure8953, var_sym);
  addtoclosure(closure8953, var_errormessages);
  addtoclosure(closure8953, var_lastToken);
  addtoclosure(closure8953, var_comma);
  addtoclosure(closure8953, var_values);
  addtoclosure(closure8953, var_nxt);
  addtoclosure(closure8953, var_part);
  addtoclosure(closure8953, var_tm);
  addtoclosure(closure8953, selfslot);
  struct UserObject *uo8953 = (struct UserObject*)block8952;
  uo8953->data[0] = (Object)closure8953;
  Method *meth_meth_parser__apply8953 = addmethod2pos(block8952, "_apply", &meth_parser__apply8953, 0);
int argcv_meth_parser__apply8953[] = {0};
meth_meth_parser__apply8953->type = alloc_MethodType(1, argcv_meth_parser__apply8953);
  meth_meth_parser__apply8953->definitionModule = modulename;
  meth_meth_parser__apply8953->definitionLine = 2796;
// compilenode returning block8952
  gc_frame_newslot(block8952);
  params[0] = block8931;
  params[1] = block8952;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9075 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8930);
// compilenode returning call9075
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2843
  setline(2843);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9078 == NULL) {
    strlit9078 = alloc_String("rparen");
    gc_root(strlit9078);
  }
// compilenode returning strlit9078
  int op_slot_right_9077 = gc_frame_newslot(strlit9078);
  int callframe9080 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9081 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9080);
// compilenode returning call9081
// compilenode returning call9081
  int op_slot_left_9077 = gc_frame_newslot(call9081);
  params[0] = strlit9078;
  partcv[0] = 1;
  Object opresult9082 = callmethod(call9081, "!=", 1, partcv, params);
// compilenode returning opresult9082
  Object if9076 = done;
  if (istrue(opresult9082)) {
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2844
  setline(2844);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9083 = gc_frame_new();
  int callframe9084 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9085 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9084);
// compilenode returning call9085
// compilenode returning call9085
  partcv[0] = 0;
  Object call9086 = callmethod(call9085, "new",
    1, partcv, params);
  gc_frame_end(callframe9083);
// compilenode returning call9086
// compilenode returning call9086
  *var_suggestion = call9086;
  if (call9086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2845
  setline(2845);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9087 = gc_frame_new();
  if (strlit9088 == NULL) {
    strlit9088 = alloc_String(")");
    gc_root(strlit9088);
  }
// compilenode returning strlit9088
  gc_frame_newslot(strlit9088);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9088;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9089 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9087);
// compilenode returning call9089
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9090 = gc_frame_new();
  if (strlit9091 == NULL) {
    strlit9091 = alloc_String("A part of a multi-part method beginning with a '(' must end with a ')'.");
    gc_root(strlit9091);
  }
// compilenode returning strlit9091
  gc_frame_newslot(strlit9091);
// Begin line 2847
  setline(2847);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9092 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9093 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9092);
// compilenode returning call9093
// compilenode returning call9093
  gc_frame_newslot(call9093);
  int callframe9095 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9096 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9095);
// compilenode returning call9096
// compilenode returning call9096
  int op_slot_right_9094 = gc_frame_newslot(call9096);
  int callframe9098 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9099 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9098);
// compilenode returning call9099
// compilenode returning call9099
  int op_slot_left_9094 = gc_frame_newslot(call9099);
  params[0] = call9096;
  partcv[0] = 1;
  Object sum9100 = callmethod(call9099, "+", 1, partcv, params);
// compilenode returning sum9100
  gc_frame_newslot(sum9100);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2846
  setline(2846);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9091;
  params[1] = call9093;
  params[2] = sum9100;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9101 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9090);
// compilenode returning call9101
    gc_frame_newslot(call9101);
    if9076 = call9101;
  } else {
  }
// compilenode returning if9076
// Begin line 2849
  setline(2849);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9102 = gc_frame_new();
  partcv[0] = 0;
  Object call9103 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9102);
// compilenode returning call9103
// Begin line 2850
  setline(2850);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9104 = gc_frame_new();
// compilenode returning *var_part
  gc_frame_newslot(*var_part);
// compilenode returning *var_signature
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9105 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9104);
// compilenode returning call9105
  gc_frame_end(frame);
  return call9105;
}
Object meth_parser_parsempmndecrest8855(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 47, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parsempmndecrest");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_sym = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parsempmndecrest (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_tm = &(stackframe->slots[0]);
  *var_tm = args[curarg];
  curarg++;
  Object *var_sameline = &(stackframe->slots[1]);
  *var_sameline = args[curarg];
  curarg++;
if (argcv && argcv[0] > 2)
  gracedie("too many arguments for parsempmndecrest");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_methname = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "methname");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_nxt = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nxt");
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2776
  setline(2776);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8856 = gc_frame_new();
  int callframe8857 = gc_frame_new();
// compilenode returning *var_tm
  partcv[0] = 0;
  Object call8858 = callmethod(*var_tm, "value",
    1, partcv, params);
  gc_frame_end(callframe8857);
// compilenode returning call8858
// compilenode returning call8858
  partcv[0] = 0;
  Object call8859 = callmethod(call8858, "value",
    1, partcv, params);
  gc_frame_end(callframe8856);
// compilenode returning call8859
// compilenode returning call8859
  *var_methname = call8859;
  if (call8859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2778
  setline(2778);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2777
  setline(2777);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe8860 = gc_frame_new();
// compilenode returning *var_tm
  partcv[0] = 0;
  Object call8861 = callmethod(*var_tm, "signature",
    1, partcv, params);
  gc_frame_end(callframe8860);
// compilenode returning call8861
// compilenode returning call8861
  *var_signature = call8861;
  if (call8861 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2779
  setline(2779);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_nxt = undefined;
// compilenode returning done
  int callframe8862 = gc_frame_new();
  Object block8863 = alloc_Block(NULL, NULL, "parser", 2779);
  gc_frame_newslot(block8863);
  block_savedest(block8863);
  Object closure8864 = createclosure(2, "_apply");
setclosureframe(closure8864, stackframe);
  addtoclosure(closure8864, var_sameline);
  addtoclosure(closure8864, selfslot);
  struct UserObject *uo8864 = (struct UserObject*)block8863;
  uo8864->data[0] = (Object)closure8864;
  Method *meth_meth_parser__apply8864 = addmethod2pos(block8863, "_apply", &meth_parser__apply8864, 0);
int argcv_meth_parser__apply8864[] = {0};
meth_meth_parser__apply8864->type = alloc_MethodType(1, argcv_meth_parser__apply8864);
  meth_meth_parser__apply8864->definitionModule = modulename;
  meth_meth_parser__apply8864->definitionLine = 2777;
// compilenode returning block8863
  gc_frame_newslot(block8863);
  Object block8880 = alloc_Block(NULL, NULL, "parser", 2779);
  gc_frame_newslot(block8880);
  block_savedest(block8880);
  Object closure8881 = createclosure(10, "_apply");
setclosureframe(closure8881, stackframe);
  addtoclosure(closure8881, var_methname);
  addtoclosure(closure8881, var_ast);
  addtoclosure(closure8881, var_values);
  addtoclosure(closure8881, var_nxt);
  addtoclosure(closure8881, var_errormessages);
  addtoclosure(closure8881, var_lastToken);
  addtoclosure(closure8881, var_sym);
  addtoclosure(closure8881, var_tm);
  addtoclosure(closure8881, var_signature);
  addtoclosure(closure8881, selfslot);
  struct UserObject *uo8881 = (struct UserObject*)block8880;
  uo8881->data[0] = (Object)closure8881;
  Method *meth_meth_parser__apply8881 = addmethod2pos(block8880, "_apply", &meth_parser__apply8881, 0);
int argcv_meth_parser__apply8881[] = {0};
meth_meth_parser__apply8881->type = alloc_MethodType(1, argcv_meth_parser__apply8881);
  meth_meth_parser__apply8881->definitionModule = modulename;
  meth_meth_parser__apply8881->definitionLine = 2777;
// compilenode returning block8880
  gc_frame_newslot(block8880);
  params[0] = block8863;
  params[1] = block8880;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9107 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe8862);
// compilenode returning call9107
// Begin line 2852
  setline(2852);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9108 = gc_frame_new();
// compilenode returning *var_methname
  gc_frame_newslot(*var_methname);
  Object bool9109 = alloc_Boolean(0);
// compilenode returning bool9109
  gc_frame_newslot(bool9109);
  int callframe9110 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call9111 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe9110);
// compilenode returning call9111
// compilenode returning call9111
  params[0] = *var_methname;
  params[1] = bool9109;
  partcv[0] = 2;
  Object call9112 = callmethod(call9111, "new",
    1, partcv, params);
  gc_frame_end(callframe9108);
// compilenode returning call9112
  gc_frame_end(frame);
  return call9112;
}
Object meth_parser__apply9190(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit9192 == NULL) {
    strlit9192 = alloc_String("rsquare");
    gc_root(strlit9192);
  }
// compilenode returning strlit9192
  int op_slot_right_9191 = gc_frame_newslot(strlit9192);
  int callframe9194 = gc_frame_new();
  int callframe9195 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9196 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9195);
// compilenode returning call9196
// compilenode returning call9196
  partcv[0] = 0;
  Object call9197 = callmethod(call9196, "kind",
    1, partcv, params);
  gc_frame_end(callframe9194);
// compilenode returning call9197
// compilenode returning call9197
  int op_slot_left_9191 = gc_frame_newslot(call9197);
  params[0] = strlit9192;
  partcv[0] = 1;
  Object opresult9198 = callmethod(call9197, "==", 1, partcv, params);
// compilenode returning opresult9198
  gc_frame_end(frame);
  return opresult9198;
}
Object meth_parser__apply9314(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe9315 = gc_frame_new();
  if (strlit9316 == NULL) {
    strlit9316 = alloc_String("identifier");
    gc_root(strlit9316);
  }
// compilenode returning strlit9316
  gc_frame_newslot(strlit9316);
  params[0] = strlit9316;
  partcv[0] = 1;
  Object call9317 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9315);
// compilenode returning call9317
  gc_frame_end(frame);
  return call9317;
}
Object meth_parser__apply9320(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_genericIdents = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2899
  setline(2899);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9321 = gc_frame_new();
  partcv[0] = 0;
  Object call9322 = callmethodflags(self, "identifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9321);
// compilenode returning call9322
// Begin line 2900
  setline(2900);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9323 = gc_frame_new();
  int callframe9324 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9325 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9324);
// compilenode returning call9325
// compilenode returning call9325
  gc_frame_newslot(call9325);
// compilenode returning *var_genericIdents
  params[0] = call9325;
  partcv[0] = 1;
  Object call9326 = callmethod(*var_genericIdents, "push",
    1, partcv, params);
  gc_frame_end(callframe9323);
// compilenode returning call9326
// Begin line 2904
  setline(2904);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2901
  setline(2901);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9328 = gc_frame_new();
  if (strlit9329 == NULL) {
    strlit9329 = alloc_String("comma");
    gc_root(strlit9329);
  }
// compilenode returning strlit9329
  gc_frame_newslot(strlit9329);
  params[0] = strlit9329;
  partcv[0] = 1;
  Object call9330 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9328);
// compilenode returning call9330
  Object if9327 = done;
  if (istrue(call9330)) {
// Begin line 2902
  setline(2902);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9331 = gc_frame_new();
  partcv[0] = 0;
  Object call9332 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9331);
// compilenode returning call9332
    gc_frame_newslot(call9332);
    if9327 = call9332;
  } else {
  }
// compilenode returning if9327
  gc_frame_end(frame);
  return if9327;
}
Object meth_parser__apply9434(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9438 == NULL) {
    strlit9438 = alloc_String("*");
    gc_root(strlit9438);
  }
// compilenode returning strlit9438
  int op_slot_right_9437 = gc_frame_newslot(strlit9438);
  int callframe9440 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9441 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9440);
// compilenode returning call9441
// compilenode returning call9441
  int op_slot_left_9437 = gc_frame_newslot(call9441);
  params[0] = strlit9438;
  partcv[0] = 1;
  Object opresult9442 = callmethod(call9441, "==", 1, partcv, params);
// compilenode returning opresult9442
  int op_slot_right_9436 = gc_frame_newslot(opresult9442);
  int callframe9444 = gc_frame_new();
  if (strlit9445 == NULL) {
    strlit9445 = alloc_String("op");
    gc_root(strlit9445);
  }
// compilenode returning strlit9445
  gc_frame_newslot(strlit9445);
  params[0] = strlit9445;
  partcv[0] = 1;
  Object call9446 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9444);
// compilenode returning call9446
  int op_slot_left_9436 = gc_frame_newslot(call9446);
  params[0] = opresult9442;
  partcv[0] = 1;
  Object opresult9447 = callmethod(call9446, "&&", 1, partcv, params);
// compilenode returning opresult9447
  int op_slot_right_9435 = gc_frame_newslot(opresult9447);
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9449 = gc_frame_new();
  if (strlit9450 == NULL) {
    strlit9450 = alloc_String("identifier");
    gc_root(strlit9450);
  }
// compilenode returning strlit9450
  gc_frame_newslot(strlit9450);
  params[0] = strlit9450;
  partcv[0] = 1;
  Object call9451 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9449);
// compilenode returning call9451
  int op_slot_left_9435 = gc_frame_newslot(call9451);
  params[0] = opresult9447;
  partcv[0] = 1;
  Object opresult9452 = callmethod(call9451, "||", 1, partcv, params);
// compilenode returning opresult9452
  gc_frame_end(frame);
  return opresult9452;
}
Object meth_parser__apply9534(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe9535 = gc_frame_new();
  partcv[0] = 0;
  Object call9536 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9535);
// compilenode returning call9536
  gc_frame_end(frame);
  return call9536;
}
Object meth_parser__apply9590(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe9593 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9594 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9593);
// compilenode returning call9594
// compilenode returning call9594
  int op_slot_right_9592 = gc_frame_newslot(call9594);
  int callframe9596 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call9597 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9596);
// compilenode returning call9597
// compilenode returning call9597
  int op_slot_left_9592 = gc_frame_newslot(call9597);
  params[0] = call9594;
  partcv[0] = 1;
  Object opresult9598 = callmethod(call9597, "==", 1, partcv, params);
// compilenode returning opresult9598
  int op_slot_right_9591 = gc_frame_newslot(opresult9598);
  if (strlit9601 == NULL) {
    strlit9601 = alloc_String("rparen");
    gc_root(strlit9601);
  }
// compilenode returning strlit9601
  int op_slot_right_9600 = gc_frame_newslot(strlit9601);
  int callframe9603 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call9604 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9603);
// compilenode returning call9604
// compilenode returning call9604
  int op_slot_left_9600 = gc_frame_newslot(call9604);
  params[0] = strlit9601;
  partcv[0] = 1;
  Object opresult9605 = callmethod(call9604, "==", 1, partcv, params);
// compilenode returning opresult9605
  int op_slot_left_9591 = gc_frame_newslot(opresult9605);
  params[0] = opresult9598;
  partcv[0] = 1;
  Object opresult9606 = callmethod(opresult9605, "&&", 1, partcv, params);
// compilenode returning opresult9606
  gc_frame_end(frame);
  return opresult9606;
}
Object meth_parser__apply9455(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_comma = getfromclosure(closure, 3);
  Object *var_vararg = getfromclosure(closure, 4);
  Object *var_varargs = getfromclosure(closure, 5);
  Object *var_values = getfromclosure(closure, 6);
  Object *var_id = getfromclosure(closure, 7);
  Object *var_dtype = getfromclosure(closure, 8);
  Object *var_part = getfromclosure(closure, 9);
  Object *var_lparen = getfromclosure(closure, 10);
  Object self = *(getfromclosure(closure, 11));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_rparen = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "rparen");
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2935
  setline(2935);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9457 = gc_frame_new();
  if (strlit9458 == NULL) {
    strlit9458 = alloc_String("op");
    gc_root(strlit9458);
  }
// compilenode returning strlit9458
  gc_frame_newslot(strlit9458);
  params[0] = strlit9458;
  partcv[0] = 1;
  Object call9459 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9457);
// compilenode returning call9459
  Object if9456 = done;
  if (istrue(call9459)) {
// Begin line 2936
  setline(2936);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9460 = gc_frame_new();
  partcv[0] = 0;
  Object call9461 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9460);
// compilenode returning call9461
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2937
  setline(2937);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9464 == NULL) {
    strlit9464 = alloc_String("identifier");
    gc_root(strlit9464);
  }
// compilenode returning strlit9464
  int op_slot_right_9463 = gc_frame_newslot(strlit9464);
  int callframe9466 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9467 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9466);
// compilenode returning call9467
// compilenode returning call9467
  int op_slot_left_9463 = gc_frame_newslot(call9467);
  params[0] = strlit9464;
  partcv[0] = 1;
  Object opresult9468 = callmethod(call9467, "!=", 1, partcv, params);
// compilenode returning opresult9468
  Object if9462 = done;
  if (istrue(opresult9468)) {
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2938
  setline(2938);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9469 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9469
  *var_suggestions = array9469;
  if (array9469 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2939
  setline(2939);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9470 = gc_frame_new();
  int callframe9471 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9472 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9471);
// compilenode returning call9472
// compilenode returning call9472
  partcv[0] = 0;
  Object call9473 = callmethod(call9472, "new",
    1, partcv, params);
  gc_frame_end(callframe9470);
// compilenode returning call9473
// compilenode returning call9473
  *var_suggestion = call9473;
  if (call9473 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2940
  setline(2940);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9474 = gc_frame_new();
  if (strlit9475 == NULL) {
    strlit9475 = alloc_String("""\xc2""""\xab""parameter name""\xc2""""\xbb""");
    gc_root(strlit9475);
  }
// compilenode returning strlit9475
  gc_frame_newslot(strlit9475);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9475;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9476 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9474);
// compilenode returning call9476
// Begin line 2941
  setline(2941);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9477 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9478 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9477);
// compilenode returning call9478
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2942
  setline(2942);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9481 = alloc_Boolean(0);
// compilenode returning bool9481
  int op_slot_right_9480 = gc_frame_newslot(bool9481);
// compilenode returning *var_comma
  int op_slot_left_9480 = gc_frame_newslot(*var_comma);
  params[0] = bool9481;
  partcv[0] = 1;
  Object opresult9483 = callmethod(*var_comma, "==", 1, partcv, params);
// compilenode returning opresult9483
  Object if9479 = done;
  if (istrue(opresult9483)) {
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2943
  setline(2943);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9484 = gc_frame_new();
  int callframe9485 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9486 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9485);
// compilenode returning call9486
// compilenode returning call9486
  partcv[0] = 0;
  Object call9487 = callmethod(call9486, "new",
    1, partcv, params);
  gc_frame_end(callframe9484);
// compilenode returning call9487
// compilenode returning call9487
  *var_suggestion = call9487;
  if (call9487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2944
  setline(2944);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9489 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call9490 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9489);
// compilenode returning call9490
// Begin line 2945
  setline(2945);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9491 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9492 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9491);
// compilenode returning call9492
    gc_frame_newslot(call9492);
    if9479 = call9492;
  } else {
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2947
  setline(2947);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9493 = gc_frame_new();
  int callframe9494 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9495 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9494);
// compilenode returning call9495
// compilenode returning call9495
  partcv[0] = 0;
  Object call9496 = callmethod(call9495, "new",
    1, partcv, params);
  gc_frame_end(callframe9493);
// compilenode returning call9496
// compilenode returning call9496
  *var_suggestion = call9496;
  if (call9496 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2948
  setline(2948);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9498 = gc_frame_new();
// compilenode returning *var_comma
  gc_frame_newslot(*var_comma);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = *var_comma;
  params[1] = *var_lastToken;
  partcv[0] = 2;
  Object call9499 = callmethod(*var_suggestion, "deleteTokenRange",
    1, partcv, params);
  gc_frame_end(callframe9498);
// compilenode returning call9499
// Begin line 2949
  setline(2949);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9500 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9501 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9500);
// compilenode returning call9501
    gc_frame_newslot(call9501);
    if9479 = call9501;
  }
// compilenode returning if9479
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9502 = gc_frame_new();
  if (strlit9503 == NULL) {
    strlit9503 = alloc_String("A variable length parameter (a parameter beginning with a '*') must have a name after the '*'.");
    gc_root(strlit9503);
  }
// compilenode returning strlit9503
  gc_frame_newslot(strlit9503);
// Begin line 2952
  setline(2952);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9504 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9505 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9504);
// compilenode returning call9505
// compilenode returning call9505
  gc_frame_newslot(call9505);
  int callframe9507 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9508 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9507);
// compilenode returning call9508
// compilenode returning call9508
  int op_slot_right_9506 = gc_frame_newslot(call9508);
  int callframe9510 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9511 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9510);
// compilenode returning call9511
// compilenode returning call9511
  int op_slot_left_9506 = gc_frame_newslot(call9511);
  params[0] = call9508;
  partcv[0] = 1;
  Object sum9512 = callmethod(call9511, "+", 1, partcv, params);
// compilenode returning sum9512
  gc_frame_newslot(sum9512);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2951
  setline(2951);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9503;
  params[1] = call9505;
  params[2] = sum9512;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9513 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9502);
// compilenode returning call9513
    gc_frame_newslot(call9513);
    if9462 = call9513;
  } else {
  }
// compilenode returning if9462
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2954
  setline(2954);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9514 = alloc_Boolean(1);
// compilenode returning bool9514
  *var_vararg = bool9514;
  if (bool9514 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2956
  setline(2956);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2955
  setline(2955);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9516 = alloc_Boolean(1);
// compilenode returning bool9516
  *var_varargs = bool9516;
  if (bool9516 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9456 = done;
  } else {
  }
// compilenode returning if9456
// Begin line 2957
  setline(2957);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9518 = gc_frame_new();
  partcv[0] = 0;
  Object call9519 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9518);
// compilenode returning call9519
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2958
  setline(2958);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9520 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9521 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9520);
// compilenode returning call9521
// compilenode returning call9521
  *var_id = call9521;
  if (call9521 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2959
  setline(2959);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9523 = alloc_Boolean(0);
// compilenode returning bool9523
  *var_dtype = bool9523;
  if (bool9523 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2960
  setline(2960);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9526 = gc_frame_new();
  if (strlit9527 == NULL) {
    strlit9527 = alloc_String("colon");
    gc_root(strlit9527);
  }
// compilenode returning strlit9527
  gc_frame_newslot(strlit9527);
  params[0] = strlit9527;
  partcv[0] = 1;
  Object call9528 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9526);
// compilenode returning call9528
  Object if9525 = done;
  if (istrue(call9528)) {
// Begin line 2961
  setline(2961);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9529 = gc_frame_new();
  partcv[0] = 0;
  Object call9530 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9529);
// compilenode returning call9530
// Begin line 2976
  setline(2976);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2962
  setline(2962);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9532 = gc_frame_new();
  Object block9533 = alloc_Block(NULL, NULL, "parser", 2962);
  gc_frame_newslot(block9533);
  block_savedest(block9533);
  Object closure9534 = createclosure(1, "_apply");
setclosureframe(closure9534, stackframe);
  addtoclosure(closure9534, selfslot);
  struct UserObject *uo9534 = (struct UserObject*)block9533;
  uo9534->data[0] = (Object)closure9534;
  Method *meth_meth_parser__apply9534 = addmethod2pos(block9533, "_apply", &meth_parser__apply9534, 0);
int argcv_meth_parser__apply9534[] = {0};
meth_meth_parser__apply9534->type = alloc_MethodType(1, argcv_meth_parser__apply9534);
  meth_meth_parser__apply9534->definitionModule = modulename;
  meth_meth_parser__apply9534->definitionLine = 2958;
// compilenode returning block9533
  gc_frame_newslot(block9533);
  params[0] = block9533;
  partcv[0] = 1;
  Object call9538 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9532);
// compilenode returning call9538
  Object if9531 = done;
  if (istrue(call9538)) {
// Begin line 2964
  setline(2964);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2963
  setline(2963);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9539 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9540 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9539);
// compilenode returning call9540
// compilenode returning call9540
  *var_dtype = call9540;
  if (call9540 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9531 = done;
  } else {
// Begin line 2965
  setline(2965);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9542 = gc_frame_new();
  partcv[0] = 0;
  Object call9543 = callmethodflags(self, "checkBadAnonymousType", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9542);
// compilenode returning call9543
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2966
  setline(2966);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9544 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9544
  *var_suggestions = array9544;
  if (array9544 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2967
  setline(2967);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9545 = gc_frame_new();
  int callframe9546 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9547 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9546);
// compilenode returning call9547
// compilenode returning call9547
  partcv[0] = 0;
  Object call9548 = callmethod(call9547, "new",
    1, partcv, params);
  gc_frame_end(callframe9545);
// compilenode returning call9548
// compilenode returning call9548
  *var_suggestion = call9548;
  if (call9548 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2968
  setline(2968);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9549 = gc_frame_new();
  if (strlit9550 == NULL) {
    strlit9550 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit9550);
  }
// compilenode returning strlit9550
  gc_frame_newslot(strlit9550);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9550;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9551 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9549);
// compilenode returning call9551
// Begin line 2969
  setline(2969);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9552 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9553 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9552);
// compilenode returning call9553
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2970
  setline(2970);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9554 = gc_frame_new();
  int callframe9555 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9556 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9555);
// compilenode returning call9556
// compilenode returning call9556
  partcv[0] = 0;
  Object call9557 = callmethod(call9556, "new",
    1, partcv, params);
  gc_frame_end(callframe9554);
// compilenode returning call9557
// compilenode returning call9557
  *var_suggestion = call9557;
  if (call9557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2971
  setline(2971);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9559 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  Object bool9560 = alloc_Boolean(1);
// compilenode returning bool9560
  gc_frame_newslot(bool9560);
  Object bool9561 = alloc_Boolean(0);
// compilenode returning bool9561
  gc_frame_newslot(bool9561);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = bool9560;
  params[2] = bool9561;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9562 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9559);
// compilenode returning call9562
// Begin line 2972
  setline(2972);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9563 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9564 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9563);
// compilenode returning call9564
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9565 = gc_frame_new();
  if (strlit9566 == NULL) {
    strlit9566 = alloc_String("A type name or type expression must follow ':'.");
    gc_root(strlit9566);
  }
// compilenode returning strlit9566
  gc_frame_newslot(strlit9566);
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9567 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9568 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9567);
// compilenode returning call9568
// compilenode returning call9568
  gc_frame_newslot(call9568);
  int callframe9569 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9570 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9569);
// compilenode returning call9570
// compilenode returning call9570
  gc_frame_newslot(call9570);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2973
  setline(2973);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9566;
  params[1] = call9568;
  params[2] = call9570;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9571 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9565);
// compilenode returning call9571
    gc_frame_newslot(call9571);
    if9531 = call9571;
  }
// compilenode returning if9531
    gc_frame_newslot(if9531);
    if9525 = if9531;
  } else {
  }
// compilenode returning if9525
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9572 = gc_frame_new();
// Begin line 2977
  setline(2977);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
// compilenode returning *var_id
  params[0] = *var_dtype;
  partcv[0] = 1;
  Object call9573 = callmethod(*var_id, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe9572);
// compilenode returning call9573
// compilenode returning done
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2978
  setline(2978);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_vararg
  Object if9574 = done;
  if (istrue(*var_vararg)) {
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2974
  setline(2974);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9575 = gc_frame_new();
// Begin line 2979
  setline(2979);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_id
  gc_frame_newslot(*var_id);
// compilenode returning *var_part
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9576 = callmethod(*var_part, "vararg:=",
    1, partcv, params);
  gc_frame_end(callframe9575);
// compilenode returning call9576
// compilenode returning done
// Begin line 2994
  setline(2994);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2980
  setline(2980);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9579 == NULL) {
    strlit9579 = alloc_String("rparen");
    gc_root(strlit9579);
  }
// compilenode returning strlit9579
  int op_slot_right_9578 = gc_frame_newslot(strlit9579);
  int callframe9581 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9582 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9581);
// compilenode returning call9582
// compilenode returning call9582
  int op_slot_left_9578 = gc_frame_newslot(call9582);
  params[0] = strlit9579;
  partcv[0] = 1;
  Object opresult9583 = callmethod(call9582, "!=", 1, partcv, params);
// compilenode returning opresult9583
  Object if9577 = done;
  if (istrue(opresult9583)) {
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2981
  setline(2981);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9584 = gc_frame_new();
  int callframe9585 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9586 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9585);
// compilenode returning call9586
// compilenode returning call9586
  partcv[0] = 0;
  Object call9587 = callmethod(call9586, "new",
    1, partcv, params);
  gc_frame_end(callframe9584);
// compilenode returning call9587
// compilenode returning call9587
  *var_suggestion = call9587;
  if (call9587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2982
  setline(2982);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9588 = gc_frame_new();
  Object block9589 = alloc_Block(NULL, NULL, "parser", 2982);
  gc_frame_newslot(block9589);
  block_savedest(block9589);
  Object closure9590 = createclosure(2, "_apply");
setclosureframe(closure9590, stackframe);
  addtoclosure(closure9590, var_sym);
  addtoclosure(closure9590, selfslot);
  struct UserObject *uo9590 = (struct UserObject*)block9589;
  uo9590->data[0] = (Object)closure9590;
  Method *meth_meth_parser__apply9590 = addmethod2pos(block9589, "_apply", &meth_parser__apply9590, 0);
int argcv_meth_parser__apply9590[] = {1};
meth_meth_parser__apply9590->type = alloc_MethodType(1, argcv_meth_parser__apply9590);
  meth_meth_parser__apply9590->definitionModule = modulename;
  meth_meth_parser__apply9590->definitionLine = 2981;
// compilenode returning block9589
  gc_frame_newslot(block9589);
  params[0] = block9589;
  partcv[0] = 1;
  Object call9608 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9588);
// compilenode returning call9608
  *var_rparen = call9608;
  if (call9608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2993
  setline(2993);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2983
  setline(2983);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9612 = alloc_Boolean(0);
// compilenode returning bool9612
  int op_slot_right_9611 = gc_frame_newslot(bool9612);
// compilenode returning *var_rparen
  int op_slot_left_9611 = gc_frame_newslot(*var_rparen);
  params[0] = bool9612;
  partcv[0] = 1;
  Object opresult9614 = callmethod(*var_rparen, "!=", 1, partcv, params);
// compilenode returning opresult9614
  int op_slot_right_9610 = gc_frame_newslot(opresult9614);
  if (strlit9617 == NULL) {
    strlit9617 = alloc_String("comma");
    gc_root(strlit9617);
  }
// compilenode returning strlit9617
  int op_slot_right_9616 = gc_frame_newslot(strlit9617);
  int callframe9619 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9620 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9619);
// compilenode returning call9620
// compilenode returning call9620
  int op_slot_left_9616 = gc_frame_newslot(call9620);
  params[0] = strlit9617;
  partcv[0] = 1;
  Object opresult9621 = callmethod(call9620, "==", 1, partcv, params);
// compilenode returning opresult9621
  int op_slot_left_9610 = gc_frame_newslot(opresult9621);
  params[0] = opresult9614;
  partcv[0] = 1;
  Object opresult9622 = callmethod(opresult9621, "&&", 1, partcv, params);
// compilenode returning opresult9622
  Object if9609 = done;
  if (istrue(opresult9622)) {
// Begin line 2984
  setline(2984);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9623 = gc_frame_new();
  if (strlit9625 == NULL) {
    strlit9625 = alloc_String("");
    gc_root(strlit9625);
  }
// compilenode returning strlit9625
  int op_slot_right_9624 = gc_frame_newslot(strlit9625);
  int callframe9628 = gc_frame_new();
// compilenode returning *var_id
  partcv[0] = 0;
  Object call9629 = callmethod(*var_id, "value",
    1, partcv, params);
  gc_frame_end(callframe9628);
// compilenode returning call9629
// compilenode returning call9629
  int op_slot_right_9627 = gc_frame_newslot(call9629);
  if (strlit9631 == NULL) {
    strlit9631 = alloc_String(",*");
    gc_root(strlit9631);
  }
// compilenode returning strlit9631
  int op_slot_left_9627 = gc_frame_newslot(strlit9631);
  params[0] = call9629;
  partcv[0] = 1;
  Object opresult9632 = callmethod(strlit9631, "++", 1, partcv, params);
// compilenode returning opresult9632
  int op_slot_left_9624 = gc_frame_newslot(opresult9632);
  params[0] = strlit9625;
  partcv[0] = 1;
  Object opresult9633 = callmethod(opresult9632, "++", 1, partcv, params);
// compilenode returning opresult9633
  gc_frame_newslot(opresult9633);
// compilenode returning *var_rparen
  gc_frame_newslot(*var_rparen);
// compilenode returning *var_suggestion
  params[0] = opresult9633;
  params[1] = *var_rparen;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9634 = callmethod(*var_suggestion, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe9623);
// compilenode returning call9634
// Begin line 2985
  setline(2985);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9635 = gc_frame_new();
  int callframe9636 = gc_frame_new();
// compilenode returning *var_lparen
  partcv[0] = 0;
  Object call9637 = callmethod(*var_lparen, "next",
    1, partcv, params);
  gc_frame_end(callframe9636);
// compilenode returning call9637
// compilenode returning call9637
  gc_frame_newslot(call9637);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool9638 = alloc_Boolean(1);
// compilenode returning bool9638
  gc_frame_newslot(bool9638);
  Object bool9639 = alloc_Boolean(0);
// compilenode returning bool9639
  gc_frame_newslot(bool9639);
// compilenode returning *var_suggestion
  params[0] = call9637;
  params[1] = *var_sym;
  params[2] = bool9638;
  params[3] = bool9639;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call9640 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe9635);
// compilenode returning call9640
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9641 = gc_frame_new();
  if (strlit9642 == NULL) {
    strlit9642 = alloc_String("A variable length parameter (a parameter beginning with a '*') cannot have any more parameters after it.");
    gc_root(strlit9642);
  }
// compilenode returning strlit9642
  gc_frame_newslot(strlit9642);
// Begin line 2987
  setline(2987);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9643 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9644 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9643);
// compilenode returning call9644
// compilenode returning call9644
  gc_frame_newslot(call9644);
  int callframe9645 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9646 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9645);
// compilenode returning call9646
// compilenode returning call9646
  gc_frame_newslot(call9646);
  Object num9648 = alloc_Float64(1);
// compilenode returning num9648
  int op_slot_right_9647 = gc_frame_newslot(num9648);
  int callframe9650 = gc_frame_new();
// compilenode returning *var_rparen
  partcv[0] = 0;
  Object call9651 = callmethod(*var_rparen, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9650);
// compilenode returning call9651
// compilenode returning call9651
  int op_slot_left_9647 = gc_frame_newslot(call9651);
  params[0] = num9648;
  partcv[0] = 1;
  Object diff9652 = callmethod(call9651, "-", 1, partcv, params);
// compilenode returning diff9652
  gc_frame_newslot(diff9652);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2986
  setline(2986);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9642;
  params[1] = call9644;
  params[2] = call9646;
  params[3] = diff9652;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9653 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9641);
// compilenode returning call9653
    gc_frame_newslot(call9653);
    if9609 = call9653;
  } else {
// Begin line 2989
  setline(2989);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9654 = gc_frame_new();
  if (strlit9655 == NULL) {
    strlit9655 = alloc_String(")");
    gc_root(strlit9655);
  }
// compilenode returning strlit9655
  gc_frame_newslot(strlit9655);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9655;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9656 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9654);
// compilenode returning call9656
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9657 = gc_frame_new();
  if (strlit9658 == NULL) {
    strlit9658 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9658);
  }
// compilenode returning strlit9658
  gc_frame_newslot(strlit9658);
// Begin line 2991
  setline(2991);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9659 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9660 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9659);
// compilenode returning call9660
// compilenode returning call9660
  gc_frame_newslot(call9660);
  int callframe9662 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9663 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9662);
// compilenode returning call9663
// compilenode returning call9663
  int op_slot_right_9661 = gc_frame_newslot(call9663);
  int callframe9665 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9666 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9665);
// compilenode returning call9666
// compilenode returning call9666
  int op_slot_left_9661 = gc_frame_newslot(call9666);
  params[0] = call9663;
  partcv[0] = 1;
  Object sum9667 = callmethod(call9666, "+", 1, partcv, params);
// compilenode returning sum9667
  gc_frame_newslot(sum9667);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2990
  setline(2990);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9658;
  params[1] = call9660;
  params[2] = sum9667;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9668 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9657);
// compilenode returning call9668
    gc_frame_newslot(call9668);
    if9609 = call9668;
  }
// compilenode returning if9609
    gc_frame_newslot(if9609);
    if9577 = if9609;
  } else {
  }
// compilenode returning if9577
    gc_frame_newslot(if9577);
    if9574 = if9577;
  } else {
// Begin line 2995
  setline(2995);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9669 = gc_frame_new();
// compilenode returning *var_id
  gc_frame_newslot(*var_id);
  int callframe9670 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9671 = callmethod(*var_part, "params",
    1, partcv, params);
  gc_frame_end(callframe9670);
// compilenode returning call9671
// compilenode returning call9671
  params[0] = *var_id;
  partcv[0] = 1;
  Object call9672 = callmethod(call9671, "push",
    1, partcv, params);
  gc_frame_end(callframe9669);
// compilenode returning call9672
    gc_frame_newslot(call9672);
    if9574 = call9672;
  }
// compilenode returning if9574
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2997
  setline(2997);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9674 = gc_frame_new();
  if (strlit9675 == NULL) {
    strlit9675 = alloc_String("comma");
    gc_root(strlit9675);
  }
// compilenode returning strlit9675
  gc_frame_newslot(strlit9675);
  params[0] = strlit9675;
  partcv[0] = 1;
  Object call9676 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9674);
// compilenode returning call9676
  Object if9673 = done;
  if (istrue(call9676)) {
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2998
  setline(2998);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_comma = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2999
  setline(2999);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9678 = gc_frame_new();
  partcv[0] = 0;
  Object call9679 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9678);
// compilenode returning call9679
    gc_frame_newslot(call9679);
    if9673 = call9679;
  } else {
// Begin line 3008
  setline(3008);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3000
  setline(3000);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9682 == NULL) {
    strlit9682 = alloc_String("rparen");
    gc_root(strlit9682);
  }
// compilenode returning strlit9682
  int op_slot_right_9681 = gc_frame_newslot(strlit9682);
  int callframe9684 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9685 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9684);
// compilenode returning call9685
// compilenode returning call9685
  int op_slot_left_9681 = gc_frame_newslot(call9685);
  params[0] = strlit9682;
  partcv[0] = 1;
  Object opresult9686 = callmethod(call9685, "!=", 1, partcv, params);
// compilenode returning opresult9686
  Object if9680 = done;
  if (istrue(opresult9686)) {
// Begin line 3007
  setline(3007);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3001
  setline(3001);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9689 == NULL) {
    strlit9689 = alloc_String("rparen");
    gc_root(strlit9689);
  }
// compilenode returning strlit9689
  int op_slot_right_9688 = gc_frame_newslot(strlit9689);
  int callframe9691 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9692 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9691);
// compilenode returning call9692
// compilenode returning call9692
  int op_slot_left_9688 = gc_frame_newslot(call9692);
  params[0] = strlit9689;
  partcv[0] = 1;
  Object opresult9693 = callmethod(call9692, "!=", 1, partcv, params);
// compilenode returning opresult9693
  Object if9687 = done;
  if (istrue(opresult9693)) {
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3002
  setline(3002);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9694 = gc_frame_new();
  int callframe9695 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9696 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9695);
// compilenode returning call9696
// compilenode returning call9696
  partcv[0] = 0;
  Object call9697 = callmethod(call9696, "new",
    1, partcv, params);
  gc_frame_end(callframe9694);
// compilenode returning call9697
// compilenode returning call9697
  *var_suggestion = call9697;
  if (call9697 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3003
  setline(3003);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9698 = gc_frame_new();
  if (strlit9699 == NULL) {
    strlit9699 = alloc_String(")");
    gc_root(strlit9699);
  }
// compilenode returning strlit9699
  gc_frame_newslot(strlit9699);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9699;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9700 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9698);
// compilenode returning call9700
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9701 = gc_frame_new();
  if (strlit9702 == NULL) {
    strlit9702 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9702);
  }
// compilenode returning strlit9702
  gc_frame_newslot(strlit9702);
// Begin line 3005
  setline(3005);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9703 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9704 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9703);
// compilenode returning call9704
// compilenode returning call9704
  gc_frame_newslot(call9704);
  int callframe9706 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9707 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9706);
// compilenode returning call9707
// compilenode returning call9707
  int op_slot_right_9705 = gc_frame_newslot(call9707);
  int callframe9709 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9710 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9709);
// compilenode returning call9710
// compilenode returning call9710
  int op_slot_left_9705 = gc_frame_newslot(call9710);
  params[0] = call9707;
  partcv[0] = 1;
  Object sum9711 = callmethod(call9710, "+", 1, partcv, params);
// compilenode returning sum9711
  gc_frame_newslot(sum9711);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3004
  setline(3004);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9702;
  params[1] = call9704;
  params[2] = sum9711;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9712 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9701);
// compilenode returning call9712
    gc_frame_newslot(call9712);
    if9687 = call9712;
  } else {
  }
// compilenode returning if9687
    gc_frame_newslot(if9687);
    if9680 = if9687;
  } else {
  }
// compilenode returning if9680
    gc_frame_newslot(if9680);
    if9673 = if9680;
  }
// compilenode returning if9673
  gc_frame_end(frame);
  return if9673;
}
Object meth_parser__apply9728(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe9731 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9732 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9731);
// compilenode returning call9732
// compilenode returning call9732
  int op_slot_right_9730 = gc_frame_newslot(call9732);
  int callframe9734 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call9735 = callmethod(*var_t, "line",
    1, partcv, params);
  gc_frame_end(callframe9734);
// compilenode returning call9735
// compilenode returning call9735
  int op_slot_left_9730 = gc_frame_newslot(call9735);
  params[0] = call9732;
  partcv[0] = 1;
  Object opresult9736 = callmethod(call9735, "==", 1, partcv, params);
// compilenode returning opresult9736
  int op_slot_right_9729 = gc_frame_newslot(opresult9736);
  if (strlit9739 == NULL) {
    strlit9739 = alloc_String("rparen");
    gc_root(strlit9739);
  }
// compilenode returning strlit9739
  int op_slot_right_9738 = gc_frame_newslot(strlit9739);
  int callframe9741 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call9742 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe9741);
// compilenode returning call9742
// compilenode returning call9742
  int op_slot_left_9738 = gc_frame_newslot(call9742);
  params[0] = strlit9739;
  partcv[0] = 1;
  Object opresult9743 = callmethod(call9742, "==", 1, partcv, params);
// compilenode returning opresult9743
  int op_slot_left_9729 = gc_frame_newslot(opresult9743);
  params[0] = opresult9736;
  partcv[0] = 1;
  Object opresult9744 = callmethod(opresult9743, "&&", 1, partcv, params);
// compilenode returning opresult9744
  gc_frame_end(frame);
  return opresult9744;
}
Object meth_parser_methodsignature9113(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(21, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_genericIdents = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "genericIdents");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_varargs = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "varargs");
  Object *var_vararg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "vararg");
  Object *var_lparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "lparen");
  Object *var_id = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "id");
  Object *var_comma = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "comma");
  Object *var_rparen = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "rparen");
  Object *var_tm = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "tm");
  Object *var_o = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "o");
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9117 == NULL) {
    strlit9117 = alloc_String("lsquare");
    gc_root(strlit9117);
  }
// compilenode returning strlit9117
  int op_slot_right_9116 = gc_frame_newslot(strlit9117);
  int callframe9119 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9120 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9119);
// compilenode returning call9120
// compilenode returning call9120
  int op_slot_left_9116 = gc_frame_newslot(call9120);
  params[0] = strlit9117;
  partcv[0] = 1;
  Object opresult9121 = callmethod(call9120, "!=", 1, partcv, params);
// compilenode returning opresult9121
  int op_slot_right_9115 = gc_frame_newslot(opresult9121);
  if (strlit9125 == NULL) {
    strlit9125 = alloc_String("op");
    gc_root(strlit9125);
  }
// compilenode returning strlit9125
  int op_slot_right_9124 = gc_frame_newslot(strlit9125);
  int callframe9127 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9128 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compilenode returning call9128
// compilenode returning call9128
  int op_slot_left_9124 = gc_frame_newslot(call9128);
  params[0] = strlit9125;
  partcv[0] = 1;
  Object opresult9129 = callmethod(call9128, "!=", 1, partcv, params);
// compilenode returning opresult9129
  int op_slot_right_9123 = gc_frame_newslot(opresult9129);
  if (strlit9132 == NULL) {
    strlit9132 = alloc_String("identifier");
    gc_root(strlit9132);
  }
// compilenode returning strlit9132
  int op_slot_right_9131 = gc_frame_newslot(strlit9132);
  int callframe9134 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9135 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9134);
// compilenode returning call9135
// compilenode returning call9135
  int op_slot_left_9131 = gc_frame_newslot(call9135);
  params[0] = strlit9132;
  partcv[0] = 1;
  Object opresult9136 = callmethod(call9135, "!=", 1, partcv, params);
// compilenode returning opresult9136
  int op_slot_left_9123 = gc_frame_newslot(opresult9136);
  params[0] = opresult9129;
  partcv[0] = 1;
  Object opresult9137 = callmethod(opresult9136, "&&", 1, partcv, params);
// compilenode returning opresult9137
  int op_slot_left_9115 = gc_frame_newslot(opresult9137);
  params[0] = opresult9121;
  partcv[0] = 1;
  Object opresult9138 = callmethod(opresult9137, "&&", 1, partcv, params);
// compilenode returning opresult9138
  Object if9114 = done;
  if (istrue(opresult9138)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9139 = gc_frame_new();
  int callframe9140 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9141 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9140);
// compilenode returning call9141
// compilenode returning call9141
  partcv[0] = 0;
  Object call9142 = callmethod(call9141, "new",
    1, partcv, params);
  gc_frame_end(callframe9139);
// compilenode returning call9142
// compilenode returning call9142
  *var_suggestion = call9142;
  if (call9142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9143 = gc_frame_new();
  if (strlit9144 == NULL) {
    strlit9144 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit9144);
  }
// compilenode returning strlit9144
  gc_frame_newslot(strlit9144);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9144;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9145 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9143);
// compilenode returning call9145
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9146 = gc_frame_new();
  if (strlit9147 == NULL) {
    strlit9147 = alloc_String("A method name must either start with an identifier or '[]'.");
    gc_root(strlit9147);
  }
// compilenode returning strlit9147
  gc_frame_newslot(strlit9147);
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9148 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9149 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9148);
// compilenode returning call9149
// compilenode returning call9149
  gc_frame_newslot(call9149);
  int callframe9151 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9152 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9151);
// compilenode returning call9152
// compilenode returning call9152
  int op_slot_right_9150 = gc_frame_newslot(call9152);
  int callframe9154 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9155 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9154);
// compilenode returning call9155
// compilenode returning call9155
  int op_slot_left_9150 = gc_frame_newslot(call9155);
  params[0] = call9152;
  partcv[0] = 1;
  Object sum9156 = callmethod(call9155, "+", 1, partcv, params);
// compilenode returning sum9156
  gc_frame_newslot(sum9156);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9147;
  params[1] = call9149;
  params[2] = sum9156;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9157 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9146);
// compilenode returning call9157
    gc_frame_newslot(call9157);
    if9114 = call9157;
  } else {
  }
// compilenode returning if9114
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9158 = gc_frame_new();
  partcv[0] = 0;
  Object call9159 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9158);
// compilenode returning call9159
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9160 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9161 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9160);
// compilenode returning call9161
// compilenode returning call9161
  *var_meth = call9161;
  if (call9161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9162 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9162
  *var_signature = array9162;
  if (array9162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9163 = gc_frame_new();
  int callframe9164 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9165 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9164);
// compilenode returning call9165
// compilenode returning call9165
  gc_frame_newslot(call9165);
  int callframe9166 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call9167 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9166);
// compilenode returning call9167
// compilenode returning call9167
  params[0] = call9165;
  partcv[0] = 1;
  Object call9168 = callmethod(call9167, "new",
    1, partcv, params);
  gc_frame_end(callframe9163);
// compilenode returning call9168
  *var_part = call9168;
  if (call9168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9169 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9169
  *var_genericIdents = array9169;
  if (array9169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9170 = gc_frame_new();
// compilenode returning *var_part
  gc_frame_newslot(*var_part);
// compilenode returning *var_signature
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9171 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9170);
// compilenode returning call9171
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9174 == NULL) {
    strlit9174 = alloc_String("[");
    gc_root(strlit9174);
  }
// compilenode returning strlit9174
  int op_slot_right_9173 = gc_frame_newslot(strlit9174);
  int callframe9176 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9177 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9176);
// compilenode returning call9177
// compilenode returning call9177
  int op_slot_left_9173 = gc_frame_newslot(call9177);
  params[0] = strlit9174;
  partcv[0] = 1;
  Object opresult9178 = callmethod(call9177, "==", 1, partcv, params);
// compilenode returning opresult9178
  Object if9172 = done;
  if (istrue(opresult9178)) {
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9181 == NULL) {
    strlit9181 = alloc_String("rsquare");
    gc_root(strlit9181);
  }
// compilenode returning strlit9181
  int op_slot_right_9180 = gc_frame_newslot(strlit9181);
  int callframe9183 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9184 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9183);
// compilenode returning call9184
// compilenode returning call9184
  int op_slot_left_9180 = gc_frame_newslot(call9184);
  params[0] = strlit9181;
  partcv[0] = 1;
  Object opresult9185 = callmethod(call9184, "!=", 1, partcv, params);
// compilenode returning opresult9185
  Object if9179 = done;
  if (istrue(opresult9185)) {
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9188 = gc_frame_new();
  Object block9189 = alloc_Block(NULL, NULL, "parser", 2872);
  gc_frame_newslot(block9189);
  block_savedest(block9189);
  Object closure9190 = createclosure(2, "_apply");
setclosureframe(closure9190, stackframe);
  addtoclosure(closure9190, var_tokens);
  addtoclosure(closure9190, selfslot);
  struct UserObject *uo9190 = (struct UserObject*)block9189;
  uo9190->data[0] = (Object)closure9190;
  Method *meth_meth_parser__apply9190 = addmethod2pos(block9189, "_apply", &meth_parser__apply9190, 0);
int argcv_meth_parser__apply9190[] = {0};
meth_meth_parser__apply9190->type = alloc_MethodType(1, argcv_meth_parser__apply9190);
  meth_meth_parser__apply9190->definitionModule = modulename;
  meth_meth_parser__apply9190->definitionLine = 2870;
// compilenode returning block9189
  gc_frame_newslot(block9189);
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num9201 = alloc_Float64(0);
// compilenode returning num9201
  int op_slot_right_9200 = gc_frame_newslot(num9201);
  int callframe9203 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9204 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9203);
// compilenode returning call9204
// compilenode returning call9204
  int op_slot_left_9200 = gc_frame_newslot(call9204);
  params[0] = num9201;
  partcv[0] = 1;
  Object opresult9205 = callmethod(call9204, "==", 1, partcv, params);
// compilenode returning opresult9205
  params[0] = block9189;
  partcv[0] = 1;
  Object call9206 = callmethod(opresult9205, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9188);
// compilenode returning call9206
  int op_slot_right_9187 = gc_frame_newslot(call9206);
  if (strlit9209 == NULL) {
    strlit9209 = alloc_String("identifier");
    gc_root(strlit9209);
  }
// compilenode returning strlit9209
  int op_slot_right_9208 = gc_frame_newslot(strlit9209);
  int callframe9211 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9212 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9211);
// compilenode returning call9212
// compilenode returning call9212
  int op_slot_left_9208 = gc_frame_newslot(call9212);
  params[0] = strlit9209;
  partcv[0] = 1;
  Object opresult9213 = callmethod(call9212, "==", 1, partcv, params);
// compilenode returning opresult9213
  int op_slot_left_9187 = gc_frame_newslot(opresult9213);
  params[0] = call9206;
  partcv[0] = 1;
  Object opresult9214 = callmethod(opresult9213, "&&", 1, partcv, params);
// compilenode returning opresult9214
  Object if9186 = done;
  if (istrue(opresult9214)) {
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9215 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9215
  *var_suggestions = array9215;
  if (array9215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9216 = gc_frame_new();
  int callframe9217 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9218 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9217);
// compilenode returning call9218
// compilenode returning call9218
  partcv[0] = 0;
  Object call9219 = callmethod(call9218, "new",
    1, partcv, params);
  gc_frame_end(callframe9216);
// compilenode returning call9219
// compilenode returning call9219
  *var_suggestion = call9219;
  if (call9219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num9222 = alloc_Float64(0);
// compilenode returning num9222
  int op_slot_right_9221 = gc_frame_newslot(num9222);
  int callframe9224 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9225 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9224);
// compilenode returning call9225
// compilenode returning call9225
  int op_slot_left_9221 = gc_frame_newslot(call9225);
  params[0] = num9222;
  partcv[0] = 1;
  Object opresult9226 = callmethod(call9225, "==", 1, partcv, params);
// compilenode returning opresult9226
  Object if9220 = done;
  if (istrue(opresult9226)) {
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9227 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit9229 == NULL) {
    strlit9229 = alloc_String(")");
    gc_root(strlit9229);
  }
// compilenode returning strlit9229
  int op_slot_right_9228 = gc_frame_newslot(strlit9229);
  int callframe9232 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9233 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9232);
// compilenode returning call9233
// compilenode returning call9233
  int op_slot_right_9231 = gc_frame_newslot(call9233);
  if (strlit9235 == NULL) {
    strlit9235 = alloc_String("](");
    gc_root(strlit9235);
  }
// compilenode returning strlit9235
  int op_slot_left_9231 = gc_frame_newslot(strlit9235);
  params[0] = call9233;
  partcv[0] = 1;
  Object opresult9236 = callmethod(strlit9235, "++", 1, partcv, params);
// compilenode returning opresult9236
  int op_slot_left_9228 = gc_frame_newslot(opresult9236);
  params[0] = strlit9229;
  partcv[0] = 1;
  Object opresult9237 = callmethod(opresult9236, "++", 1, partcv, params);
// compilenode returning opresult9237
  gc_frame_newslot(opresult9237);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = opresult9237;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9238 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9227);
// compilenode returning call9238
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9239 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9240 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9239);
// compilenode returning call9240
    gc_frame_newslot(call9240);
    if9220 = call9240;
  } else {
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9243 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9244 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9243);
// compilenode returning call9244
// compilenode returning call9244
  int op_slot_right_9242 = gc_frame_newslot(call9244);
  int callframe9246 = gc_frame_new();
  int callframe9247 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9248 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9247);
// compilenode returning call9248
// compilenode returning call9248
  partcv[0] = 0;
  Object call9249 = callmethod(call9248, "line",
    1, partcv, params);
  gc_frame_end(callframe9246);
// compilenode returning call9249
// compilenode returning call9249
  int op_slot_left_9242 = gc_frame_newslot(call9249);
  params[0] = call9244;
  partcv[0] = 1;
  Object opresult9250 = callmethod(call9249, "==", 1, partcv, params);
// compilenode returning opresult9250
  Object if9241 = done;
  if (istrue(opresult9250)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9251 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe9252 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9253 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9252);
// compilenode returning call9253
// compilenode returning call9253
  gc_frame_newslot(call9253);
  if (strlit9255 == NULL) {
    strlit9255 = alloc_String(")");
    gc_root(strlit9255);
  }
// compilenode returning strlit9255
  int op_slot_right_9254 = gc_frame_newslot(strlit9255);
  int callframe9258 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9259 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9258);
// compilenode returning call9259
// compilenode returning call9259
  int op_slot_right_9257 = gc_frame_newslot(call9259);
  if (strlit9261 == NULL) {
    strlit9261 = alloc_String("](");
    gc_root(strlit9261);
  }
// compilenode returning strlit9261
  int op_slot_left_9257 = gc_frame_newslot(strlit9261);
  params[0] = call9259;
  partcv[0] = 1;
  Object opresult9262 = callmethod(strlit9261, "++", 1, partcv, params);
// compilenode returning opresult9262
  int op_slot_left_9254 = gc_frame_newslot(opresult9262);
  params[0] = strlit9255;
  partcv[0] = 1;
  Object opresult9263 = callmethod(opresult9262, "++", 1, partcv, params);
// compilenode returning opresult9263
  gc_frame_newslot(opresult9263);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call9253;
  params[2] = opresult9263;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9264 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9251);
// compilenode returning call9264
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9265 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9266 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9265);
// compilenode returning call9266
    gc_frame_newslot(call9266);
    if9241 = call9266;
  } else {
  }
// compilenode returning if9241
    gc_frame_newslot(if9241);
    if9220 = if9241;
  }
// compilenode returning if9220
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9267 = gc_frame_new();
  if (strlit9268 == NULL) {
    strlit9268 = alloc_String("A method name beginning with '[]' must have the parameter name in parentheses after the '[]'.");
    gc_root(strlit9268);
  }
// compilenode returning strlit9268
  gc_frame_newslot(strlit9268);
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9269 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9270 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9269);
// compilenode returning call9270
// compilenode returning call9270
  gc_frame_newslot(call9270);
  int callframe9272 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9273 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9272);
// compilenode returning call9273
// compilenode returning call9273
  int op_slot_right_9271 = gc_frame_newslot(call9273);
  int callframe9275 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9276 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9275);
// compilenode returning call9276
// compilenode returning call9276
  int op_slot_left_9271 = gc_frame_newslot(call9276);
  params[0] = call9273;
  partcv[0] = 1;
  Object sum9277 = callmethod(call9276, "+", 1, partcv, params);
// compilenode returning sum9277
  gc_frame_newslot(sum9277);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9268;
  params[1] = call9270;
  params[2] = sum9277;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9278 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9267);
// compilenode returning call9278
    gc_frame_newslot(call9278);
    if9186 = call9278;
  } else {
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9279 = gc_frame_new();
  int callframe9280 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9281 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9280);
// compilenode returning call9281
// compilenode returning call9281
  partcv[0] = 0;
  Object call9282 = callmethod(call9281, "new",
    1, partcv, params);
  gc_frame_end(callframe9279);
// compilenode returning call9282
// compilenode returning call9282
  *var_suggestion = call9282;
  if (call9282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9283 = gc_frame_new();
  if (strlit9284 == NULL) {
    strlit9284 = alloc_String("]");
    gc_root(strlit9284);
  }
// compilenode returning strlit9284
  gc_frame_newslot(strlit9284);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9284;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9285 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9283);
// compilenode returning call9285
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9286 = gc_frame_new();
  if (strlit9287 == NULL) {
    strlit9287 = alloc_String("A method name must either start with an identifier or '[]'.");
    gc_root(strlit9287);
  }
// compilenode returning strlit9287
  gc_frame_newslot(strlit9287);
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9288 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9289 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9288);
// compilenode returning call9289
// compilenode returning call9289
  gc_frame_newslot(call9289);
  int callframe9291 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9292 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9291);
// compilenode returning call9292
// compilenode returning call9292
  int op_slot_right_9290 = gc_frame_newslot(call9292);
  int callframe9294 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9295 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9294);
// compilenode returning call9295
// compilenode returning call9295
  int op_slot_left_9290 = gc_frame_newslot(call9295);
  params[0] = call9292;
  partcv[0] = 1;
  Object sum9296 = callmethod(call9295, "+", 1, partcv, params);
// compilenode returning sum9296
  gc_frame_newslot(sum9296);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9287;
  params[1] = call9289;
  params[2] = sum9296;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9297 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9286);
// compilenode returning call9297
    gc_frame_newslot(call9297);
    if9186 = call9297;
  }
// compilenode returning if9186
    gc_frame_newslot(if9186);
    if9179 = if9186;
  } else {
  }
// compilenode returning if9179
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9298 = gc_frame_new();
  partcv[0] = 0;
  Object call9299 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9298);
// compilenode returning call9299
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9300 = gc_frame_new();
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9301 == NULL) {
    strlit9301 = alloc_String("[]");
    gc_root(strlit9301);
  }
// compilenode returning strlit9301
  gc_frame_newslot(strlit9301);
// compilenode returning *var_meth
  params[0] = strlit9301;
  partcv[0] = 1;
  Object call9302 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9300);
// compilenode returning call9302
// compilenode returning done
    gc_frame_newslot(done);
    if9172 = done;
  } else {
  }
// compilenode returning if9172
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9304 = gc_frame_new();
  if (strlit9305 == NULL) {
    strlit9305 = alloc_String("lgeneric");
    gc_root(strlit9305);
  }
// compilenode returning strlit9305
  gc_frame_newslot(strlit9305);
  params[0] = strlit9305;
  partcv[0] = 1;
  Object call9306 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9304);
// compilenode returning call9306
  Object if9303 = done;
  if (istrue(call9306)) {
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9307 = gc_frame_new();
  partcv[0] = 0;
  Object call9308 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9307);
// compilenode returning call9308
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9309 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9310 = callmethod(*var_part, "generics",
    1, partcv, params);
  gc_frame_end(callframe9309);
// compilenode returning call9310
// compilenode returning call9310
  *var_genericIdents = call9310;
  if (call9310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9312 = gc_frame_new();
  Object block9313 = alloc_Block(NULL, NULL, "parser", 2898);
  gc_frame_newslot(block9313);
  block_savedest(block9313);
  Object closure9314 = createclosure(1, "_apply");
setclosureframe(closure9314, stackframe);
  addtoclosure(closure9314, selfslot);
  struct UserObject *uo9314 = (struct UserObject*)block9313;
  uo9314->data[0] = (Object)closure9314;
  Method *meth_meth_parser__apply9314 = addmethod2pos(block9313, "_apply", &meth_parser__apply9314, 0);
int argcv_meth_parser__apply9314[] = {0};
meth_meth_parser__apply9314->type = alloc_MethodType(1, argcv_meth_parser__apply9314);
  meth_meth_parser__apply9314->definitionModule = modulename;
  meth_meth_parser__apply9314->definitionLine = 2897;
// compilenode returning block9313
  gc_frame_newslot(block9313);
  Object block9319 = alloc_Block(NULL, NULL, "parser", 2898);
  gc_frame_newslot(block9319);
  block_savedest(block9319);
  Object closure9320 = createclosure(3, "_apply");
setclosureframe(closure9320, stackframe);
  addtoclosure(closure9320, var_values);
  addtoclosure(closure9320, var_genericIdents);
  addtoclosure(closure9320, selfslot);
  struct UserObject *uo9320 = (struct UserObject*)block9319;
  uo9320->data[0] = (Object)closure9320;
  Method *meth_meth_parser__apply9320 = addmethod2pos(block9319, "_apply", &meth_parser__apply9320, 0);
int argcv_meth_parser__apply9320[] = {0};
meth_meth_parser__apply9320->type = alloc_MethodType(1, argcv_meth_parser__apply9320);
  meth_meth_parser__apply9320->definitionModule = modulename;
  meth_meth_parser__apply9320->definitionLine = 2897;
// compilenode returning block9319
  gc_frame_newslot(block9319);
  params[0] = block9313;
  params[1] = block9319;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9334 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9312);
// compilenode returning call9334
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9337 == NULL) {
    strlit9337 = alloc_String("rgeneric");
    gc_root(strlit9337);
  }
// compilenode returning strlit9337
  int op_slot_right_9336 = gc_frame_newslot(strlit9337);
  int callframe9339 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9340 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9339);
// compilenode returning call9340
// compilenode returning call9340
  int op_slot_left_9336 = gc_frame_newslot(call9340);
  params[0] = strlit9337;
  partcv[0] = 1;
  Object opresult9341 = callmethod(call9340, "!=", 1, partcv, params);
// compilenode returning opresult9341
  Object if9335 = done;
  if (istrue(opresult9341)) {
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9342 = gc_frame_new();
  int callframe9343 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9344 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9343);
// compilenode returning call9344
// compilenode returning call9344
  partcv[0] = 0;
  Object call9345 = callmethod(call9344, "new",
    1, partcv, params);
  gc_frame_end(callframe9342);
// compilenode returning call9345
// compilenode returning call9345
  *var_suggestion = call9345;
  if (call9345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9346 = gc_frame_new();
  if (strlit9347 == NULL) {
    strlit9347 = alloc_String(">");
    gc_root(strlit9347);
  }
// compilenode returning strlit9347
  gc_frame_newslot(strlit9347);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9347;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9348 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9346);
// compilenode returning call9348
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9349 = gc_frame_new();
  if (strlit9350 == NULL) {
    strlit9350 = alloc_String("A type containing a '<' must end with a '>'.");
    gc_root(strlit9350);
  }
// compilenode returning strlit9350
  gc_frame_newslot(strlit9350);
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9351 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9352 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9351);
// compilenode returning call9352
// compilenode returning call9352
  gc_frame_newslot(call9352);
  int callframe9354 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9355 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9354);
// compilenode returning call9355
// compilenode returning call9355
  int op_slot_right_9353 = gc_frame_newslot(call9355);
  int callframe9357 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9358 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9357);
// compilenode returning call9358
// compilenode returning call9358
  int op_slot_left_9353 = gc_frame_newslot(call9358);
  params[0] = call9355;
  partcv[0] = 1;
  Object sum9359 = callmethod(call9358, "+", 1, partcv, params);
// compilenode returning sum9359
  gc_frame_newslot(sum9359);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9350;
  params[1] = call9352;
  params[2] = sum9359;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9360 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9349);
// compilenode returning call9360
    gc_frame_newslot(call9360);
    if9335 = call9360;
  } else {
  }
// compilenode returning if9335
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9361 = gc_frame_new();
  partcv[0] = 0;
  Object call9362 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9361);
// compilenode returning call9362
    gc_frame_newslot(call9362);
    if9303 = call9362;
  } else {
  }
// compilenode returning if9303
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9364 = gc_frame_new();
  if (strlit9365 == NULL) {
    strlit9365 = alloc_String("bind");
    gc_root(strlit9365);
  }
// compilenode returning strlit9365
  gc_frame_newslot(strlit9365);
  params[0] = strlit9365;
  partcv[0] = 1;
  Object call9366 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9364);
// compilenode returning call9366
  Object if9363 = done;
  if (istrue(call9366)) {
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9367 = gc_frame_new();
  partcv[0] = 0;
  Object call9368 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9367);
// compilenode returning call9368
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9369 = gc_frame_new();
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9371 == NULL) {
    strlit9371 = alloc_String(":=");
    gc_root(strlit9371);
  }
// compilenode returning strlit9371
  int op_slot_right_9370 = gc_frame_newslot(strlit9371);
  int callframe9373 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9374 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9373);
// compilenode returning call9374
// compilenode returning call9374
  int op_slot_left_9370 = gc_frame_newslot(call9374);
  params[0] = strlit9371;
  partcv[0] = 1;
  Object opresult9375 = callmethod(call9374, "++", 1, partcv, params);
// compilenode returning opresult9375
  gc_frame_newslot(opresult9375);
// compilenode returning *var_meth
  params[0] = opresult9375;
  partcv[0] = 1;
  Object call9376 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9369);
// compilenode returning call9376
// compilenode returning done
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9377 = gc_frame_new();
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9379 == NULL) {
    strlit9379 = alloc_String(":=");
    gc_root(strlit9379);
  }
// compilenode returning strlit9379
  int op_slot_right_9378 = gc_frame_newslot(strlit9379);
  int callframe9381 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9382 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9381);
// compilenode returning call9382
// compilenode returning call9382
  int op_slot_left_9378 = gc_frame_newslot(call9382);
  params[0] = strlit9379;
  partcv[0] = 1;
  Object opresult9383 = callmethod(call9382, "++", 1, partcv, params);
// compilenode returning opresult9383
  gc_frame_newslot(opresult9383);
// compilenode returning *var_part
  params[0] = opresult9383;
  partcv[0] = 1;
  Object call9384 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9377);
// compilenode returning call9384
// compilenode returning done
    gc_frame_newslot(done);
    if9363 = done;
  } else {
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9388 == NULL) {
    strlit9388 = alloc_String("prefix");
    gc_root(strlit9388);
  }
// compilenode returning strlit9388
  int op_slot_right_9387 = gc_frame_newslot(strlit9388);
  int callframe9390 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9391 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9390);
// compilenode returning call9391
// compilenode returning call9391
  int op_slot_left_9387 = gc_frame_newslot(call9391);
  params[0] = strlit9388;
  partcv[0] = 1;
  Object opresult9392 = callmethod(call9391, "==", 1, partcv, params);
// compilenode returning opresult9392
  int op_slot_right_9386 = gc_frame_newslot(opresult9392);
  int callframe9394 = gc_frame_new();
  if (strlit9395 == NULL) {
    strlit9395 = alloc_String("op");
    gc_root(strlit9395);
  }
// compilenode returning strlit9395
  gc_frame_newslot(strlit9395);
  params[0] = strlit9395;
  partcv[0] = 1;
  Object call9396 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9394);
// compilenode returning call9396
  int op_slot_left_9386 = gc_frame_newslot(call9396);
  params[0] = opresult9392;
  partcv[0] = 1;
  Object opresult9397 = callmethod(call9396, "&&", 1, partcv, params);
// compilenode returning opresult9397
  Object if9385 = done;
  if (istrue(opresult9397)) {
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9398 = gc_frame_new();
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9400 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9401 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9400);
// compilenode returning call9401
// compilenode returning call9401
  int op_slot_right_9399 = gc_frame_newslot(call9401);
  int callframe9403 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9404 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9403);
// compilenode returning call9404
// compilenode returning call9404
  int op_slot_left_9399 = gc_frame_newslot(call9404);
  params[0] = call9401;
  partcv[0] = 1;
  Object opresult9405 = callmethod(call9404, "++", 1, partcv, params);
// compilenode returning opresult9405
  gc_frame_newslot(opresult9405);
// compilenode returning *var_meth
  params[0] = opresult9405;
  partcv[0] = 1;
  Object call9406 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9398);
// compilenode returning call9406
// compilenode returning done
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9407 = gc_frame_new();
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9409 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9410 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9409);
// compilenode returning call9410
// compilenode returning call9410
  int op_slot_right_9408 = gc_frame_newslot(call9410);
  int callframe9412 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9413 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9412);
// compilenode returning call9413
// compilenode returning call9413
  int op_slot_left_9408 = gc_frame_newslot(call9413);
  params[0] = call9410;
  partcv[0] = 1;
  Object opresult9414 = callmethod(call9413, "++", 1, partcv, params);
// compilenode returning opresult9414
  gc_frame_newslot(opresult9414);
// compilenode returning *var_part
  params[0] = opresult9414;
  partcv[0] = 1;
  Object call9415 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9407);
// compilenode returning call9415
// compilenode returning done
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9416 = gc_frame_new();
  partcv[0] = 0;
  Object call9417 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9416);
// compilenode returning call9417
    gc_frame_newslot(call9417);
    if9385 = call9417;
  } else {
  }
// compilenode returning if9385
    gc_frame_newslot(if9385);
    if9363 = if9385;
  }
// compilenode returning if9363
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9418 = alloc_Boolean(0);
// compilenode returning bool9418
  *var_dtype = bool9418;
  if (bool9418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9419 = alloc_Boolean(0);
// compilenode returning bool9419
  *var_varargs = bool9419;
  if (bool9419 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9420 = alloc_Boolean(0);
// compilenode returning bool9420
  *var_vararg = bool9420;
  if (bool9420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9422 = gc_frame_new();
  if (strlit9423 == NULL) {
    strlit9423 = alloc_String("lparen");
    gc_root(strlit9423);
  }
// compilenode returning strlit9423
  gc_frame_newslot(strlit9423);
  params[0] = strlit9423;
  partcv[0] = 1;
  Object call9424 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9422);
// compilenode returning call9424
  Object if9421 = done;
  if (istrue(call9424)) {
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9425 = gc_frame_new();
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9426 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9427 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9426);
// compilenode returning call9427
// compilenode returning call9427
  gc_frame_newslot(call9427);
// compilenode returning *var_part
  params[0] = call9427;
  partcv[0] = 1;
  Object call9428 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9425);
// compilenode returning call9428
// compilenode returning done
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9429 = gc_frame_new();
  partcv[0] = 0;
  Object call9430 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9429);
// compilenode returning call9430
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_id = undefined;
// compilenode returning done
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9431 = alloc_Boolean(0);
// compilenode returning bool9431
  *var_comma = bool9431;
  if (bool9431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9432 = gc_frame_new();
  Object block9433 = alloc_Block(NULL, NULL, "parser", 2931);
  gc_frame_newslot(block9433);
  block_savedest(block9433);
  Object closure9434 = createclosure(2, "_apply");
setclosureframe(closure9434, stackframe);
  addtoclosure(closure9434, var_sym);
  addtoclosure(closure9434, selfslot);
  struct UserObject *uo9434 = (struct UserObject*)block9433;
  uo9434->data[0] = (Object)closure9434;
  Method *meth_meth_parser__apply9434 = addmethod2pos(block9433, "_apply", &meth_parser__apply9434, 0);
int argcv_meth_parser__apply9434[] = {0};
meth_meth_parser__apply9434->type = alloc_MethodType(1, argcv_meth_parser__apply9434);
  meth_meth_parser__apply9434->definitionModule = modulename;
  meth_meth_parser__apply9434->definitionLine = 2927;
// compilenode returning block9433
  gc_frame_newslot(block9433);
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block9454 = alloc_Block(NULL, NULL, "parser", 2932);
  gc_frame_newslot(block9454);
  block_savedest(block9454);
  Object closure9455 = createclosure(12, "_apply");
setclosureframe(closure9455, stackframe);
  addtoclosure(closure9455, var_sym);
  addtoclosure(closure9455, var_errormessages);
  addtoclosure(closure9455, var_lastToken);
  addtoclosure(closure9455, var_comma);
  addtoclosure(closure9455, var_vararg);
  addtoclosure(closure9455, var_varargs);
  addtoclosure(closure9455, var_values);
  addtoclosure(closure9455, var_id);
  addtoclosure(closure9455, var_dtype);
  addtoclosure(closure9455, var_part);
  addtoclosure(closure9455, var_lparen);
  addtoclosure(closure9455, selfslot);
  struct UserObject *uo9455 = (struct UserObject*)block9454;
  uo9455->data[0] = (Object)closure9455;
  Method *meth_meth_parser__apply9455 = addmethod2pos(block9454, "_apply", &meth_parser__apply9455, 0);
int argcv_meth_parser__apply9455[] = {0};
meth_meth_parser__apply9455->type = alloc_MethodType(1, argcv_meth_parser__apply9455);
  meth_meth_parser__apply9455->definitionModule = modulename;
  meth_meth_parser__apply9455->definitionLine = 2932;
// compilenode returning block9454
  gc_frame_newslot(block9454);
  params[0] = block9433;
  params[1] = block9454;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9714 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9432);
// compilenode returning call9714
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9717 == NULL) {
    strlit9717 = alloc_String("rparen");
    gc_root(strlit9717);
  }
// compilenode returning strlit9717
  int op_slot_right_9716 = gc_frame_newslot(strlit9717);
  int callframe9719 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9720 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9719);
// compilenode returning call9720
// compilenode returning call9720
  int op_slot_left_9716 = gc_frame_newslot(call9720);
  params[0] = strlit9717;
  partcv[0] = 1;
  Object opresult9721 = callmethod(call9720, "!=", 1, partcv, params);
// compilenode returning opresult9721
  Object if9715 = done;
  if (istrue(opresult9721)) {
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9722 = gc_frame_new();
  int callframe9723 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9724 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9723);
// compilenode returning call9724
// compilenode returning call9724
  partcv[0] = 0;
  Object call9725 = callmethod(call9724, "new",
    1, partcv, params);
  gc_frame_end(callframe9722);
// compilenode returning call9725
// compilenode returning call9725
  *var_suggestion = call9725;
  if (call9725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9726 = gc_frame_new();
  Object block9727 = alloc_Block(NULL, NULL, "parser", 3011);
  gc_frame_newslot(block9727);
  block_savedest(block9727);
  Object closure9728 = createclosure(2, "_apply");
setclosureframe(closure9728, stackframe);
  addtoclosure(closure9728, var_lastToken);
  addtoclosure(closure9728, selfslot);
  struct UserObject *uo9728 = (struct UserObject*)block9727;
  uo9728->data[0] = (Object)closure9728;
  Method *meth_meth_parser__apply9728 = addmethod2pos(block9727, "_apply", &meth_parser__apply9728, 0);
int argcv_meth_parser__apply9728[] = {1};
meth_meth_parser__apply9728->type = alloc_MethodType(1, argcv_meth_parser__apply9728);
  meth_meth_parser__apply9728->definitionModule = modulename;
  meth_meth_parser__apply9728->definitionLine = 3010;
// compilenode returning block9727
  gc_frame_newslot(block9727);
  params[0] = block9727;
  partcv[0] = 1;
  Object call9746 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9726);
// compilenode returning call9746
  *var_rparen = call9746;
  if (call9746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9749 = alloc_Boolean(0);
// compilenode returning bool9749
  int op_slot_right_9748 = gc_frame_newslot(bool9749);
// compilenode returning *var_rparen
  int op_slot_left_9748 = gc_frame_newslot(*var_rparen);
  params[0] = bool9749;
  partcv[0] = 1;
  Object opresult9751 = callmethod(*var_rparen, "==", 1, partcv, params);
// compilenode returning opresult9751
  Object if9747 = done;
  if (istrue(opresult9751)) {
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9752 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  if (strlit9753 == NULL) {
    strlit9753 = alloc_String(")");
    gc_root(strlit9753);
  }
// compilenode returning strlit9753
  gc_frame_newslot(strlit9753);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = strlit9753;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9754 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9752);
// compilenode returning call9754
    gc_frame_newslot(call9754);
    if9747 = call9754;
  } else {
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9755 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9756 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9755);
// compilenode returning call9756
    gc_frame_newslot(call9756);
    if9747 = call9756;
  }
// compilenode returning if9747
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9757 = gc_frame_new();
  if (strlit9758 == NULL) {
    strlit9758 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9758);
  }
// compilenode returning strlit9758
  gc_frame_newslot(strlit9758);
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9759 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9760 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9759);
// compilenode returning call9760
// compilenode returning call9760
  gc_frame_newslot(call9760);
  int callframe9761 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9762 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9761);
// compilenode returning call9762
// compilenode returning call9762
  gc_frame_newslot(call9762);
  int callframe9763 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9764 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compilenode returning call9764
// compilenode returning call9764
  gc_frame_newslot(call9764);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9758;
  params[1] = call9760;
  params[2] = call9762;
  params[3] = call9764;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9765 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9757);
// compilenode returning call9765
    gc_frame_newslot(call9765);
    if9715 = call9765;
  } else {
  }
// compilenode returning if9715
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9768 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9769 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9768);
// compilenode returning call9769
// compilenode returning call9769
  int op_slot_right_9767 = gc_frame_newslot(call9769);
  int callframe9771 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9772 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9771);
// compilenode returning call9772
// compilenode returning call9772
  int op_slot_left_9767 = gc_frame_newslot(call9772);
  params[0] = call9769;
  partcv[0] = 1;
  Object opresult9773 = callmethod(call9772, "==", 1, partcv, params);
// compilenode returning opresult9773
  Object if9766 = done;
  if (istrue(opresult9773)) {
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9774 = gc_frame_new();
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9776 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9777 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9776);
// compilenode returning call9777
// compilenode returning call9777
  int op_slot_right_9775 = gc_frame_newslot(call9777);
  int callframe9779 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9780 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9779);
// compilenode returning call9780
// compilenode returning call9780
  int op_slot_left_9775 = gc_frame_newslot(call9780);
  params[0] = call9777;
  partcv[0] = 1;
  Object diff9781 = callmethod(call9780, "-", 1, partcv, params);
// compilenode returning diff9781
  gc_frame_newslot(diff9781);
// compilenode returning *var_part
  params[0] = diff9781;
  partcv[0] = 1;
  Object call9782 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9774);
// compilenode returning call9782
// compilenode returning done
    gc_frame_newslot(done);
    if9766 = done;
  } else {
  }
// compilenode returning if9766
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9783 = gc_frame_new();
  partcv[0] = 0;
  Object call9784 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9783);
// compilenode returning call9784
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9787 = gc_frame_new();
  if (strlit9788 == NULL) {
    strlit9788 = alloc_String("identifier");
    gc_root(strlit9788);
  }
// compilenode returning strlit9788
  gc_frame_newslot(strlit9788);
  params[0] = strlit9788;
  partcv[0] = 1;
  Object call9789 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9787);
// compilenode returning call9789
  int op_slot_right_9786 = gc_frame_newslot(call9789);
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9792 = gc_frame_new();
  if (strlit9793 == NULL) {
    strlit9793 = alloc_String("identifier");
    gc_root(strlit9793);
  }
// compilenode returning strlit9793
  gc_frame_newslot(strlit9793);
  params[0] = strlit9793;
  partcv[0] = 1;
  Object call9794 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9792);
// compilenode returning call9794
  int op_slot_right_9791 = gc_frame_newslot(call9794);
  int callframe9796 = gc_frame_new();
// compilenode returning *var_sameline
  partcv[0] = 0;
  Object call9797 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9796);
// compilenode returning call9797
  int op_slot_left_9791 = gc_frame_newslot(call9797);
  params[0] = call9794;
  partcv[0] = 1;
  Object opresult9798 = callmethod(call9797, "&&", 1, partcv, params);
// compilenode returning opresult9798
  int op_slot_left_9786 = gc_frame_newslot(opresult9798);
  params[0] = call9789;
  partcv[0] = 1;
  Object opresult9799 = callmethod(opresult9798, "||", 1, partcv, params);
// compilenode returning opresult9799
  Object if9785 = done;
  if (istrue(opresult9799)) {
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9800 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
  Object array9801 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9801
  gc_frame_newslot(array9801);
  Object bool9802 = alloc_Boolean(0);
// compilenode returning bool9802
  gc_frame_newslot(bool9802);
  int callframe9803 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call9804 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9803);
// compilenode returning call9804
// compilenode returning call9804
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9801;
  params[3] = bool9802;
  partcv[0] = 4;
  Object call9805 = callmethod(call9804, "new",
    1, partcv, params);
  gc_frame_end(callframe9800);
// compilenode returning call9805
  *var_tm = call9805;
  if (call9805 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9806 = gc_frame_new();
// compilenode returning *var_tm
  gc_frame_newslot(*var_tm);
// compilenode returning *var_sameline
  gc_frame_newslot(*var_sameline);
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9807 = callmethodflags(self, "parsempmndecrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9806);
// compilenode returning call9807
  *var_meth = call9807;
  if (call9807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3030
  setline(3030);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9810 = gc_frame_new();
// compilenode returning *var_tm
  partcv[0] = 0;
  Object call9811 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe9810);
// compilenode returning call9811
// compilenode returning call9811
  int op_slot_right_9809 = gc_frame_newslot(call9811);
// compilenode returning *var_varargs
  int op_slot_left_9809 = gc_frame_newslot(*var_varargs);
  params[0] = call9811;
  partcv[0] = 1;
  Object opresult9813 = callmethod(*var_varargs, "||", 1, partcv, params);
// compilenode returning opresult9813
  *var_varargs = opresult9813;
  if (opresult9813 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9785 = done;
  } else {
  }
// compilenode returning if9785
    gc_frame_newslot(if9785);
    if9421 = if9785;
  } else {
  }
// compilenode returning if9421
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9816 = gc_frame_new();
  if (strlit9817 == NULL) {
    strlit9817 = alloc_String("arrow");
    gc_root(strlit9817);
  }
// compilenode returning strlit9817
  gc_frame_newslot(strlit9817);
  params[0] = strlit9817;
  partcv[0] = 1;
  Object call9818 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9816);
// compilenode returning call9818
  Object if9815 = done;
  if (istrue(call9818)) {
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9819 = gc_frame_new();
  partcv[0] = 0;
  Object call9820 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9819);
// compilenode returning call9820
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9821 = gc_frame_new();
  partcv[0] = 0;
  Object call9822 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9821);
// compilenode returning call9822
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9823 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9824 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9823);
// compilenode returning call9824
// compilenode returning call9824
  *var_dtype = call9824;
  if (call9824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9815 = done;
  } else {
// Begin line 3040
  setline(3040);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9826 = alloc_Boolean(0);
// compilenode returning bool9826
  *var_dtype = bool9826;
  if (bool9826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9815 = done;
  }
// compilenode returning if9815
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject9828 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9828 = alloc_userobj2(10,6, objclass9828);
  gc_frame_newslot(obj9828);
// OBJECT OUTER DEC outer
  adddatum2(obj9828, self, 0);
  addmethodreal(obj9828,"outer", &reader_parser_outer_9829);
  Object oldself9828 = self;
  struct StackFrameObject *oldstackframe9828 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9828);
  gc_frame_newslot((Object)stackframe);
  self = obj9828;
  Object *oldselfslot9828 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9828 = (*(struct UserObject *)self).data[0], lowerouter9828 = thisouter9828;
  if (inheritingObject9828) {
    struct UserObject *inho9828 = (struct UserObject *)inheritingObject9828;
    while (inho9828->super != GraceDefaultObject) inho9828 = (struct UserObject *)inho9828->super;
    inho9828->super = obj9828;
    self = inheritingObject9828;
    *selfslot = self;
    lowerouter9828 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9828;
  }
if (objclass9828 == NULL) {
  Method *reader9830 = addmethodrealflags(obj9828, "m",&reader_parser_m_9830, 0);
  Method *writer9830 = addmethodrealflags(obj9828, "m:=",&writer_parser_m_9830, 0);
  reader9830->definitionModule = modulename;
  writer9830->definitionModule = modulename;
  reader9830->definitionLine = 3043;
  writer9830->definitionLine = 3043;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 1);
if (objclass9828 == NULL) {
  Method *reader9831 = addmethodrealflags(obj9828, "sig",&reader_parser_sig_9831, 0);
  Method *writer9831 = addmethodrealflags(obj9828, "sig:=",&writer_parser_sig_9831, 0);
  reader9831->definitionModule = modulename;
  writer9831->definitionModule = modulename;
  reader9831->definitionLine = 3044;
  writer9831->definitionLine = 3044;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 2);
if (objclass9828 == NULL) {
  Method *reader9832 = addmethodrealflags(obj9828, "rtype",&reader_parser_rtype_9832, 0);
  Method *writer9832 = addmethodrealflags(obj9828, "rtype:=",&writer_parser_rtype_9832, 0);
  reader9832->definitionModule = modulename;
  writer9832->definitionModule = modulename;
  reader9832->definitionLine = 3045;
  writer9832->definitionLine = 3045;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 3);
if (objclass9828 == NULL) {
  Method *reader9833 = addmethodrealflags(obj9828, "v",&reader_parser_v_9833, 0);
  Method *writer9833 = addmethodrealflags(obj9828, "v:=",&writer_parser_v_9833, 0);
  reader9833->definitionModule = modulename;
  writer9833->definitionModule = modulename;
  reader9833->definitionLine = 3046;
  writer9833->definitionLine = 3046;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 4);
if (objclass9828 == NULL) {
  Method *reader9834 = addmethodrealflags(obj9828, "generics",&reader_parser_generics_9834, 0);
  Method *writer9834 = addmethodrealflags(obj9828, "generics:=",&writer_parser_generics_9834, 0);
  reader9834->definitionModule = modulename;
  writer9834->definitionModule = modulename;
  reader9834->definitionLine = 3047;
  writer9834->definitionLine = 3047;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 5);
  sourceObject = obj9828;
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_meth
  adddatum2(obj9828, *var_meth, 1);
  sourceObject = obj9828;
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature
  adddatum2(obj9828, *var_signature, 2);
  sourceObject = obj9828;
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype
  adddatum2(obj9828, *var_dtype, 3);
  sourceObject = obj9828;
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varargs
  adddatum2(obj9828, *var_varargs, 4);
  sourceObject = obj9828;
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_genericIdents
  adddatum2(obj9828, *var_genericIdents, 5);
objclass9828 = obj9828->class;
  objclass9828->definitionModule = modulename;
  objclass9828->definitionLine = 3041;
  (*(struct UserObject *)self).data[0] = lowerouter9828;
  self = oldself9828;
  selfslot = oldselfslot9828;
  stackframe = oldstackframe9828;
// compilenode returning obj9828
  *var_o = obj9828;
  if (obj9828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_o
  gc_frame_end(frame);
  return *var_o;
}
Object meth_parser_methodsignature9113_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 48, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(21, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "methodsignature()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for methodsignature (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sameline = &(stackframe->slots[0]);
  *var_sameline = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for methodsignature");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_meth = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "meth");
  Object *var_signature = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "signature");
  Object *var_part = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "part");
  Object *var_genericIdents = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "genericIdents");
  Object *var_suggestions = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestions");
  Object *var_dtype = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "dtype");
  Object *var_varargs = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "varargs");
  Object *var_vararg = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "vararg");
  Object *var_lparen = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "lparen");
  Object *var_id = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "id");
  Object *var_comma = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "comma");
  Object *var_rparen = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "rparen");
  Object *var_tm = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "tm");
  Object *var_o = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "o");
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2857
  setline(2857);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9117 == NULL) {
    strlit9117 = alloc_String("lsquare");
    gc_root(strlit9117);
  }
// compilenode returning strlit9117
  int op_slot_right_9116 = gc_frame_newslot(strlit9117);
  int callframe9119 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9120 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9119);
// compilenode returning call9120
// compilenode returning call9120
  int op_slot_left_9116 = gc_frame_newslot(call9120);
  params[0] = strlit9117;
  partcv[0] = 1;
  Object opresult9121 = callmethod(call9120, "!=", 1, partcv, params);
// compilenode returning opresult9121
  int op_slot_right_9115 = gc_frame_newslot(opresult9121);
  if (strlit9125 == NULL) {
    strlit9125 = alloc_String("op");
    gc_root(strlit9125);
  }
// compilenode returning strlit9125
  int op_slot_right_9124 = gc_frame_newslot(strlit9125);
  int callframe9127 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9128 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9127);
// compilenode returning call9128
// compilenode returning call9128
  int op_slot_left_9124 = gc_frame_newslot(call9128);
  params[0] = strlit9125;
  partcv[0] = 1;
  Object opresult9129 = callmethod(call9128, "!=", 1, partcv, params);
// compilenode returning opresult9129
  int op_slot_right_9123 = gc_frame_newslot(opresult9129);
  if (strlit9132 == NULL) {
    strlit9132 = alloc_String("identifier");
    gc_root(strlit9132);
  }
// compilenode returning strlit9132
  int op_slot_right_9131 = gc_frame_newslot(strlit9132);
  int callframe9134 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9135 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9134);
// compilenode returning call9135
// compilenode returning call9135
  int op_slot_left_9131 = gc_frame_newslot(call9135);
  params[0] = strlit9132;
  partcv[0] = 1;
  Object opresult9136 = callmethod(call9135, "!=", 1, partcv, params);
// compilenode returning opresult9136
  int op_slot_left_9123 = gc_frame_newslot(opresult9136);
  params[0] = opresult9129;
  partcv[0] = 1;
  Object opresult9137 = callmethod(opresult9136, "&&", 1, partcv, params);
// compilenode returning opresult9137
  int op_slot_left_9115 = gc_frame_newslot(opresult9137);
  params[0] = opresult9121;
  partcv[0] = 1;
  Object opresult9138 = callmethod(opresult9137, "&&", 1, partcv, params);
// compilenode returning opresult9138
  Object if9114 = done;
  if (istrue(opresult9138)) {
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2858
  setline(2858);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9139 = gc_frame_new();
  int callframe9140 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9141 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9140);
// compilenode returning call9141
// compilenode returning call9141
  partcv[0] = 0;
  Object call9142 = callmethod(call9141, "new",
    1, partcv, params);
  gc_frame_end(callframe9139);
// compilenode returning call9142
// compilenode returning call9142
  *var_suggestion = call9142;
  if (call9142 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2859
  setline(2859);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9143 = gc_frame_new();
  if (strlit9144 == NULL) {
    strlit9144 = alloc_String(" ""\xc2""""\xab""method name""\xc2""""\xbb""");
    gc_root(strlit9144);
  }
// compilenode returning strlit9144
  gc_frame_newslot(strlit9144);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9144;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9145 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9143);
// compilenode returning call9145
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9146 = gc_frame_new();
  if (strlit9147 == NULL) {
    strlit9147 = alloc_String("A method name must either start with an identifier or '[]'.");
    gc_root(strlit9147);
  }
// compilenode returning strlit9147
  gc_frame_newslot(strlit9147);
// Begin line 2861
  setline(2861);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9148 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9149 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9148);
// compilenode returning call9149
// compilenode returning call9149
  gc_frame_newslot(call9149);
  int callframe9151 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9152 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9151);
// compilenode returning call9152
// compilenode returning call9152
  int op_slot_right_9150 = gc_frame_newslot(call9152);
  int callframe9154 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9155 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9154);
// compilenode returning call9155
// compilenode returning call9155
  int op_slot_left_9150 = gc_frame_newslot(call9155);
  params[0] = call9152;
  partcv[0] = 1;
  Object sum9156 = callmethod(call9155, "+", 1, partcv, params);
// compilenode returning sum9156
  gc_frame_newslot(sum9156);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2860
  setline(2860);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9147;
  params[1] = call9149;
  params[2] = sum9156;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9157 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9146);
// compilenode returning call9157
    gc_frame_newslot(call9157);
    if9114 = call9157;
  } else {
  }
// compilenode returning if9114
// Begin line 2863
  setline(2863);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9158 = gc_frame_new();
  partcv[0] = 0;
  Object call9159 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9158);
// compilenode returning call9159
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2864
  setline(2864);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9160 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9161 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9160);
// compilenode returning call9161
// compilenode returning call9161
  *var_meth = call9161;
  if (call9161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2865
  setline(2865);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9162 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9162
  *var_signature = array9162;
  if (array9162 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2866
  setline(2866);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9163 = gc_frame_new();
  int callframe9164 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9165 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9164);
// compilenode returning call9165
// compilenode returning call9165
  gc_frame_newslot(call9165);
  int callframe9166 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call9167 = callmethod(*var_ast, "signaturePart",
    1, partcv, params);
  gc_frame_end(callframe9166);
// compilenode returning call9167
// compilenode returning call9167
  params[0] = call9165;
  partcv[0] = 1;
  Object call9168 = callmethod(call9167, "new",
    1, partcv, params);
  gc_frame_end(callframe9163);
// compilenode returning call9168
  *var_part = call9168;
  if (call9168 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2867
  setline(2867);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9169 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9169
  *var_genericIdents = array9169;
  if (array9169 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2868
  setline(2868);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9170 = gc_frame_new();
// compilenode returning *var_part
  gc_frame_newslot(*var_part);
// compilenode returning *var_signature
  params[0] = *var_part;
  partcv[0] = 1;
  Object call9171 = callmethod(*var_signature, "push",
    1, partcv, params);
  gc_frame_end(callframe9170);
// compilenode returning call9171
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2869
  setline(2869);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9174 == NULL) {
    strlit9174 = alloc_String("[");
    gc_root(strlit9174);
  }
// compilenode returning strlit9174
  int op_slot_right_9173 = gc_frame_newslot(strlit9174);
  int callframe9176 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9177 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9176);
// compilenode returning call9177
// compilenode returning call9177
  int op_slot_left_9173 = gc_frame_newslot(call9177);
  params[0] = strlit9174;
  partcv[0] = 1;
  Object opresult9178 = callmethod(call9177, "==", 1, partcv, params);
// compilenode returning opresult9178
  Object if9172 = done;
  if (istrue(opresult9178)) {
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2870
  setline(2870);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9181 == NULL) {
    strlit9181 = alloc_String("rsquare");
    gc_root(strlit9181);
  }
// compilenode returning strlit9181
  int op_slot_right_9180 = gc_frame_newslot(strlit9181);
  int callframe9183 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9184 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9183);
// compilenode returning call9184
// compilenode returning call9184
  int op_slot_left_9180 = gc_frame_newslot(call9184);
  params[0] = strlit9181;
  partcv[0] = 1;
  Object opresult9185 = callmethod(call9184, "!=", 1, partcv, params);
// compilenode returning opresult9185
  Object if9179 = done;
  if (istrue(opresult9185)) {
// Begin line 2890
  setline(2890);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2872
  setline(2872);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9188 = gc_frame_new();
  Object block9189 = alloc_Block(NULL, NULL, "parser", 2872);
  gc_frame_newslot(block9189);
  block_savedest(block9189);
  Object closure9190 = createclosure(2, "_apply");
setclosureframe(closure9190, stackframe);
  addtoclosure(closure9190, var_tokens);
  addtoclosure(closure9190, selfslot);
  struct UserObject *uo9190 = (struct UserObject*)block9189;
  uo9190->data[0] = (Object)closure9190;
  Method *meth_meth_parser__apply9190 = addmethod2pos(block9189, "_apply", &meth_parser__apply9190, 0);
int argcv_meth_parser__apply9190[] = {0};
meth_meth_parser__apply9190->type = alloc_MethodType(1, argcv_meth_parser__apply9190);
  meth_meth_parser__apply9190->definitionModule = modulename;
  meth_meth_parser__apply9190->definitionLine = 2870;
// compilenode returning block9189
  gc_frame_newslot(block9189);
// Begin line 2871
  setline(2871);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num9201 = alloc_Float64(0);
// compilenode returning num9201
  int op_slot_right_9200 = gc_frame_newslot(num9201);
  int callframe9203 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9204 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9203);
// compilenode returning call9204
// compilenode returning call9204
  int op_slot_left_9200 = gc_frame_newslot(call9204);
  params[0] = num9201;
  partcv[0] = 1;
  Object opresult9205 = callmethod(call9204, "==", 1, partcv, params);
// compilenode returning opresult9205
  params[0] = block9189;
  partcv[0] = 1;
  Object call9206 = callmethod(opresult9205, "orElse",
    1, partcv, params);
  gc_frame_end(callframe9188);
// compilenode returning call9206
  int op_slot_right_9187 = gc_frame_newslot(call9206);
  if (strlit9209 == NULL) {
    strlit9209 = alloc_String("identifier");
    gc_root(strlit9209);
  }
// compilenode returning strlit9209
  int op_slot_right_9208 = gc_frame_newslot(strlit9209);
  int callframe9211 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9212 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9211);
// compilenode returning call9212
// compilenode returning call9212
  int op_slot_left_9208 = gc_frame_newslot(call9212);
  params[0] = strlit9209;
  partcv[0] = 1;
  Object opresult9213 = callmethod(call9212, "==", 1, partcv, params);
// compilenode returning opresult9213
  int op_slot_left_9187 = gc_frame_newslot(opresult9213);
  params[0] = call9206;
  partcv[0] = 1;
  Object opresult9214 = callmethod(opresult9213, "&&", 1, partcv, params);
// compilenode returning opresult9214
  Object if9186 = done;
  if (istrue(opresult9214)) {
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2873
  setline(2873);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array9215 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9215
  *var_suggestions = array9215;
  if (array9215 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2874
  setline(2874);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9216 = gc_frame_new();
  int callframe9217 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9218 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9217);
// compilenode returning call9218
// compilenode returning call9218
  partcv[0] = 0;
  Object call9219 = callmethod(call9218, "new",
    1, partcv, params);
  gc_frame_end(callframe9216);
// compilenode returning call9219
// compilenode returning call9219
  *var_suggestion = call9219;
  if (call9219 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2875
  setline(2875);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num9222 = alloc_Float64(0);
// compilenode returning num9222
  int op_slot_right_9221 = gc_frame_newslot(num9222);
  int callframe9224 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9225 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe9224);
// compilenode returning call9225
// compilenode returning call9225
  int op_slot_left_9221 = gc_frame_newslot(call9225);
  params[0] = num9222;
  partcv[0] = 1;
  Object opresult9226 = callmethod(call9225, "==", 1, partcv, params);
// compilenode returning opresult9226
  Object if9220 = done;
  if (istrue(opresult9226)) {
// Begin line 2876
  setline(2876);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9227 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit9229 == NULL) {
    strlit9229 = alloc_String(")");
    gc_root(strlit9229);
  }
// compilenode returning strlit9229
  int op_slot_right_9228 = gc_frame_newslot(strlit9229);
  int callframe9232 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9233 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9232);
// compilenode returning call9233
// compilenode returning call9233
  int op_slot_right_9231 = gc_frame_newslot(call9233);
  if (strlit9235 == NULL) {
    strlit9235 = alloc_String("](");
    gc_root(strlit9235);
  }
// compilenode returning strlit9235
  int op_slot_left_9231 = gc_frame_newslot(strlit9235);
  params[0] = call9233;
  partcv[0] = 1;
  Object opresult9236 = callmethod(strlit9235, "++", 1, partcv, params);
// compilenode returning opresult9236
  int op_slot_left_9228 = gc_frame_newslot(opresult9236);
  params[0] = strlit9229;
  partcv[0] = 1;
  Object opresult9237 = callmethod(opresult9236, "++", 1, partcv, params);
// compilenode returning opresult9237
  gc_frame_newslot(opresult9237);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = opresult9237;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9238 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9227);
// compilenode returning call9238
// Begin line 2877
  setline(2877);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9239 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9240 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9239);
// compilenode returning call9240
    gc_frame_newslot(call9240);
    if9220 = call9240;
  } else {
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2878
  setline(2878);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9243 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9244 = callmethod(*var_meth, "line",
    1, partcv, params);
  gc_frame_end(callframe9243);
// compilenode returning call9244
// compilenode returning call9244
  int op_slot_right_9242 = gc_frame_newslot(call9244);
  int callframe9246 = gc_frame_new();
  int callframe9247 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9248 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9247);
// compilenode returning call9248
// compilenode returning call9248
  partcv[0] = 0;
  Object call9249 = callmethod(call9248, "line",
    1, partcv, params);
  gc_frame_end(callframe9246);
// compilenode returning call9249
// compilenode returning call9249
  int op_slot_left_9242 = gc_frame_newslot(call9249);
  params[0] = call9244;
  partcv[0] = 1;
  Object opresult9250 = callmethod(call9249, "==", 1, partcv, params);
// compilenode returning opresult9250
  Object if9241 = done;
  if (istrue(opresult9250)) {
// Begin line 2879
  setline(2879);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9251 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe9252 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call9253 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe9252);
// compilenode returning call9253
// compilenode returning call9253
  gc_frame_newslot(call9253);
  if (strlit9255 == NULL) {
    strlit9255 = alloc_String(")");
    gc_root(strlit9255);
  }
// compilenode returning strlit9255
  int op_slot_right_9254 = gc_frame_newslot(strlit9255);
  int callframe9258 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9259 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9258);
// compilenode returning call9259
// compilenode returning call9259
  int op_slot_right_9257 = gc_frame_newslot(call9259);
  if (strlit9261 == NULL) {
    strlit9261 = alloc_String("](");
    gc_root(strlit9261);
  }
// compilenode returning strlit9261
  int op_slot_left_9257 = gc_frame_newslot(strlit9261);
  params[0] = call9259;
  partcv[0] = 1;
  Object opresult9262 = callmethod(strlit9261, "++", 1, partcv, params);
// compilenode returning opresult9262
  int op_slot_left_9254 = gc_frame_newslot(opresult9262);
  params[0] = strlit9255;
  partcv[0] = 1;
  Object opresult9263 = callmethod(opresult9262, "++", 1, partcv, params);
// compilenode returning opresult9263
  gc_frame_newslot(opresult9263);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call9253;
  params[2] = opresult9263;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call9264 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe9251);
// compilenode returning call9264
// Begin line 2880
  setline(2880);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9265 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call9266 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe9265);
// compilenode returning call9266
    gc_frame_newslot(call9266);
    if9241 = call9266;
  } else {
  }
// compilenode returning if9241
    gc_frame_newslot(if9241);
    if9220 = if9241;
  }
// compilenode returning if9220
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9267 = gc_frame_new();
  if (strlit9268 == NULL) {
    strlit9268 = alloc_String("A method name beginning with '[]' must have the parameter name in parentheses after the '[]'.");
    gc_root(strlit9268);
  }
// compilenode returning strlit9268
  gc_frame_newslot(strlit9268);
// Begin line 2883
  setline(2883);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9269 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9270 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9269);
// compilenode returning call9270
// compilenode returning call9270
  gc_frame_newslot(call9270);
  int callframe9272 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9273 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9272);
// compilenode returning call9273
// compilenode returning call9273
  int op_slot_right_9271 = gc_frame_newslot(call9273);
  int callframe9275 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9276 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9275);
// compilenode returning call9276
// compilenode returning call9276
  int op_slot_left_9271 = gc_frame_newslot(call9276);
  params[0] = call9273;
  partcv[0] = 1;
  Object sum9277 = callmethod(call9276, "+", 1, partcv, params);
// compilenode returning sum9277
  gc_frame_newslot(sum9277);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 2882
  setline(2882);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9268;
  params[1] = call9270;
  params[2] = sum9277;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9278 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe9267);
// compilenode returning call9278
    gc_frame_newslot(call9278);
    if9186 = call9278;
  } else {
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2885
  setline(2885);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9279 = gc_frame_new();
  int callframe9280 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9281 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9280);
// compilenode returning call9281
// compilenode returning call9281
  partcv[0] = 0;
  Object call9282 = callmethod(call9281, "new",
    1, partcv, params);
  gc_frame_end(callframe9279);
// compilenode returning call9282
// compilenode returning call9282
  *var_suggestion = call9282;
  if (call9282 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2886
  setline(2886);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9283 = gc_frame_new();
  if (strlit9284 == NULL) {
    strlit9284 = alloc_String("]");
    gc_root(strlit9284);
  }
// compilenode returning strlit9284
  gc_frame_newslot(strlit9284);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9284;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9285 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9283);
// compilenode returning call9285
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9286 = gc_frame_new();
  if (strlit9287 == NULL) {
    strlit9287 = alloc_String("A method name must either start with an identifier or '[]'.");
    gc_root(strlit9287);
  }
// compilenode returning strlit9287
  gc_frame_newslot(strlit9287);
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9288 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9289 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9288);
// compilenode returning call9289
// compilenode returning call9289
  gc_frame_newslot(call9289);
  int callframe9291 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9292 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9291);
// compilenode returning call9292
// compilenode returning call9292
  int op_slot_right_9290 = gc_frame_newslot(call9292);
  int callframe9294 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9295 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9294);
// compilenode returning call9295
// compilenode returning call9295
  int op_slot_left_9290 = gc_frame_newslot(call9295);
  params[0] = call9292;
  partcv[0] = 1;
  Object sum9296 = callmethod(call9295, "+", 1, partcv, params);
// compilenode returning sum9296
  gc_frame_newslot(sum9296);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2887
  setline(2887);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9287;
  params[1] = call9289;
  params[2] = sum9296;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9297 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9286);
// compilenode returning call9297
    gc_frame_newslot(call9297);
    if9186 = call9297;
  }
// compilenode returning if9186
    gc_frame_newslot(if9186);
    if9179 = if9186;
  } else {
  }
// compilenode returning if9179
// Begin line 2891
  setline(2891);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9298 = gc_frame_new();
  partcv[0] = 0;
  Object call9299 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9298);
// compilenode returning call9299
// Begin line 2893
  setline(2893);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2888
  setline(2888);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9300 = gc_frame_new();
// Begin line 2892
  setline(2892);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9301 == NULL) {
    strlit9301 = alloc_String("[]");
    gc_root(strlit9301);
  }
// compilenode returning strlit9301
  gc_frame_newslot(strlit9301);
// compilenode returning *var_meth
  params[0] = strlit9301;
  partcv[0] = 1;
  Object call9302 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9300);
// compilenode returning call9302
// compilenode returning done
    gc_frame_newslot(done);
    if9172 = done;
  } else {
  }
// compilenode returning if9172
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2894
  setline(2894);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9304 = gc_frame_new();
  if (strlit9305 == NULL) {
    strlit9305 = alloc_String("lgeneric");
    gc_root(strlit9305);
  }
// compilenode returning strlit9305
  gc_frame_newslot(strlit9305);
  params[0] = strlit9305;
  partcv[0] = 1;
  Object call9306 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9304);
// compilenode returning call9306
  Object if9303 = done;
  if (istrue(call9306)) {
// Begin line 2896
  setline(2896);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9307 = gc_frame_new();
  partcv[0] = 0;
  Object call9308 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9307);
// compilenode returning call9308
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2897
  setline(2897);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9309 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9310 = callmethod(*var_part, "generics",
    1, partcv, params);
  gc_frame_end(callframe9309);
// compilenode returning call9310
// compilenode returning call9310
  *var_genericIdents = call9310;
  if (call9310 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2898
  setline(2898);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9312 = gc_frame_new();
  Object block9313 = alloc_Block(NULL, NULL, "parser", 2898);
  gc_frame_newslot(block9313);
  block_savedest(block9313);
  Object closure9314 = createclosure(1, "_apply");
setclosureframe(closure9314, stackframe);
  addtoclosure(closure9314, selfslot);
  struct UserObject *uo9314 = (struct UserObject*)block9313;
  uo9314->data[0] = (Object)closure9314;
  Method *meth_meth_parser__apply9314 = addmethod2pos(block9313, "_apply", &meth_parser__apply9314, 0);
int argcv_meth_parser__apply9314[] = {0};
meth_meth_parser__apply9314->type = alloc_MethodType(1, argcv_meth_parser__apply9314);
  meth_meth_parser__apply9314->definitionModule = modulename;
  meth_meth_parser__apply9314->definitionLine = 2897;
// compilenode returning block9313
  gc_frame_newslot(block9313);
  Object block9319 = alloc_Block(NULL, NULL, "parser", 2898);
  gc_frame_newslot(block9319);
  block_savedest(block9319);
  Object closure9320 = createclosure(3, "_apply");
setclosureframe(closure9320, stackframe);
  addtoclosure(closure9320, var_values);
  addtoclosure(closure9320, var_genericIdents);
  addtoclosure(closure9320, selfslot);
  struct UserObject *uo9320 = (struct UserObject*)block9319;
  uo9320->data[0] = (Object)closure9320;
  Method *meth_meth_parser__apply9320 = addmethod2pos(block9319, "_apply", &meth_parser__apply9320, 0);
int argcv_meth_parser__apply9320[] = {0};
meth_meth_parser__apply9320->type = alloc_MethodType(1, argcv_meth_parser__apply9320);
  meth_meth_parser__apply9320->definitionModule = modulename;
  meth_meth_parser__apply9320->definitionLine = 2897;
// compilenode returning block9319
  gc_frame_newslot(block9319);
  params[0] = block9313;
  params[1] = block9319;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9334 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9312);
// compilenode returning call9334
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2905
  setline(2905);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9337 == NULL) {
    strlit9337 = alloc_String("rgeneric");
    gc_root(strlit9337);
  }
// compilenode returning strlit9337
  int op_slot_right_9336 = gc_frame_newslot(strlit9337);
  int callframe9339 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9340 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9339);
// compilenode returning call9340
// compilenode returning call9340
  int op_slot_left_9336 = gc_frame_newslot(call9340);
  params[0] = strlit9337;
  partcv[0] = 1;
  Object opresult9341 = callmethod(call9340, "!=", 1, partcv, params);
// compilenode returning opresult9341
  Object if9335 = done;
  if (istrue(opresult9341)) {
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2906
  setline(2906);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9342 = gc_frame_new();
  int callframe9343 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9344 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9343);
// compilenode returning call9344
// compilenode returning call9344
  partcv[0] = 0;
  Object call9345 = callmethod(call9344, "new",
    1, partcv, params);
  gc_frame_end(callframe9342);
// compilenode returning call9345
// compilenode returning call9345
  *var_suggestion = call9345;
  if (call9345 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2907
  setline(2907);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9346 = gc_frame_new();
  if (strlit9347 == NULL) {
    strlit9347 = alloc_String(">");
    gc_root(strlit9347);
  }
// compilenode returning strlit9347
  gc_frame_newslot(strlit9347);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9347;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9348 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9346);
// compilenode returning call9348
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9349 = gc_frame_new();
  if (strlit9350 == NULL) {
    strlit9350 = alloc_String("A type containing a '<' must end with a '>'.");
    gc_root(strlit9350);
  }
// compilenode returning strlit9350
  gc_frame_newslot(strlit9350);
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9351 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9352 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9351);
// compilenode returning call9352
// compilenode returning call9352
  gc_frame_newslot(call9352);
  int callframe9354 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9355 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9354);
// compilenode returning call9355
// compilenode returning call9355
  int op_slot_right_9353 = gc_frame_newslot(call9355);
  int callframe9357 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9358 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9357);
// compilenode returning call9358
// compilenode returning call9358
  int op_slot_left_9353 = gc_frame_newslot(call9358);
  params[0] = call9355;
  partcv[0] = 1;
  Object sum9359 = callmethod(call9358, "+", 1, partcv, params);
// compilenode returning sum9359
  gc_frame_newslot(sum9359);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 2908
  setline(2908);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9350;
  params[1] = call9352;
  params[2] = sum9359;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9360 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9349);
// compilenode returning call9360
    gc_frame_newslot(call9360);
    if9335 = call9360;
  } else {
  }
// compilenode returning if9335
// Begin line 2911
  setline(2911);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9361 = gc_frame_new();
  partcv[0] = 0;
  Object call9362 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9361);
// compilenode returning call9362
    gc_frame_newslot(call9362);
    if9303 = call9362;
  } else {
  }
// compilenode returning if9303
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2913
  setline(2913);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9364 = gc_frame_new();
  if (strlit9365 == NULL) {
    strlit9365 = alloc_String("bind");
    gc_root(strlit9365);
  }
// compilenode returning strlit9365
  gc_frame_newslot(strlit9365);
  params[0] = strlit9365;
  partcv[0] = 1;
  Object call9366 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9364);
// compilenode returning call9366
  Object if9363 = done;
  if (istrue(call9366)) {
// Begin line 2914
  setline(2914);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9367 = gc_frame_new();
  partcv[0] = 0;
  Object call9368 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9367);
// compilenode returning call9368
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2909
  setline(2909);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9369 = gc_frame_new();
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9371 == NULL) {
    strlit9371 = alloc_String(":=");
    gc_root(strlit9371);
  }
// compilenode returning strlit9371
  int op_slot_right_9370 = gc_frame_newslot(strlit9371);
  int callframe9373 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9374 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9373);
// compilenode returning call9374
// compilenode returning call9374
  int op_slot_left_9370 = gc_frame_newslot(call9374);
  params[0] = strlit9371;
  partcv[0] = 1;
  Object opresult9375 = callmethod(call9374, "++", 1, partcv, params);
// compilenode returning opresult9375
  gc_frame_newslot(opresult9375);
// compilenode returning *var_meth
  params[0] = opresult9375;
  partcv[0] = 1;
  Object call9376 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9369);
// compilenode returning call9376
// compilenode returning done
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2915
  setline(2915);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9377 = gc_frame_new();
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2916
  setline(2916);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9379 == NULL) {
    strlit9379 = alloc_String(":=");
    gc_root(strlit9379);
  }
// compilenode returning strlit9379
  int op_slot_right_9378 = gc_frame_newslot(strlit9379);
  int callframe9381 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9382 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9381);
// compilenode returning call9382
// compilenode returning call9382
  int op_slot_left_9378 = gc_frame_newslot(call9382);
  params[0] = strlit9379;
  partcv[0] = 1;
  Object opresult9383 = callmethod(call9382, "++", 1, partcv, params);
// compilenode returning opresult9383
  gc_frame_newslot(opresult9383);
// compilenode returning *var_part
  params[0] = opresult9383;
  partcv[0] = 1;
  Object call9384 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9377);
// compilenode returning call9384
// compilenode returning done
    gc_frame_newslot(done);
    if9363 = done;
  } else {
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9388 == NULL) {
    strlit9388 = alloc_String("prefix");
    gc_root(strlit9388);
  }
// compilenode returning strlit9388
  int op_slot_right_9387 = gc_frame_newslot(strlit9388);
  int callframe9390 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9391 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9390);
// compilenode returning call9391
// compilenode returning call9391
  int op_slot_left_9387 = gc_frame_newslot(call9391);
  params[0] = strlit9388;
  partcv[0] = 1;
  Object opresult9392 = callmethod(call9391, "==", 1, partcv, params);
// compilenode returning opresult9392
  int op_slot_right_9386 = gc_frame_newslot(opresult9392);
  int callframe9394 = gc_frame_new();
  if (strlit9395 == NULL) {
    strlit9395 = alloc_String("op");
    gc_root(strlit9395);
  }
// compilenode returning strlit9395
  gc_frame_newslot(strlit9395);
  params[0] = strlit9395;
  partcv[0] = 1;
  Object call9396 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9394);
// compilenode returning call9396
  int op_slot_left_9386 = gc_frame_newslot(call9396);
  params[0] = opresult9392;
  partcv[0] = 1;
  Object opresult9397 = callmethod(call9396, "&&", 1, partcv, params);
// compilenode returning opresult9397
  Object if9385 = done;
  if (istrue(opresult9397)) {
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2917
  setline(2917);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9398 = gc_frame_new();
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9400 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9401 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9400);
// compilenode returning call9401
// compilenode returning call9401
  int op_slot_right_9399 = gc_frame_newslot(call9401);
  int callframe9403 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call9404 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe9403);
// compilenode returning call9404
// compilenode returning call9404
  int op_slot_left_9399 = gc_frame_newslot(call9404);
  params[0] = call9401;
  partcv[0] = 1;
  Object opresult9405 = callmethod(call9404, "++", 1, partcv, params);
// compilenode returning opresult9405
  gc_frame_newslot(opresult9405);
// compilenode returning *var_meth
  params[0] = opresult9405;
  partcv[0] = 1;
  Object call9406 = callmethod(*var_meth, "value:=",
    1, partcv, params);
  gc_frame_end(callframe9398);
// compilenode returning call9406
// compilenode returning done
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2918
  setline(2918);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9407 = gc_frame_new();
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9409 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9410 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9409);
// compilenode returning call9410
// compilenode returning call9410
  int op_slot_right_9408 = gc_frame_newslot(call9410);
  int callframe9412 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9413 = callmethod(*var_part, "name",
    1, partcv, params);
  gc_frame_end(callframe9412);
// compilenode returning call9413
// compilenode returning call9413
  int op_slot_left_9408 = gc_frame_newslot(call9413);
  params[0] = call9410;
  partcv[0] = 1;
  Object opresult9414 = callmethod(call9413, "++", 1, partcv, params);
// compilenode returning opresult9414
  gc_frame_newslot(opresult9414);
// compilenode returning *var_part
  params[0] = opresult9414;
  partcv[0] = 1;
  Object call9415 = callmethod(*var_part, "name:=",
    1, partcv, params);
  gc_frame_end(callframe9407);
// compilenode returning call9415
// compilenode returning done
// Begin line 2920
  setline(2920);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9416 = gc_frame_new();
  partcv[0] = 0;
  Object call9417 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9416);
// compilenode returning call9417
    gc_frame_newslot(call9417);
    if9385 = call9417;
  } else {
  }
// compilenode returning if9385
    gc_frame_newslot(if9385);
    if9363 = if9385;
  }
// compilenode returning if9363
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2922
  setline(2922);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9418 = alloc_Boolean(0);
// compilenode returning bool9418
  *var_dtype = bool9418;
  if (bool9418 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2923
  setline(2923);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9419 = alloc_Boolean(0);
// compilenode returning bool9419
  *var_varargs = bool9419;
  if (bool9419 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2924
  setline(2924);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9420 = alloc_Boolean(0);
// compilenode returning bool9420
  *var_vararg = bool9420;
  if (bool9420 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2925
  setline(2925);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9422 = gc_frame_new();
  if (strlit9423 == NULL) {
    strlit9423 = alloc_String("lparen");
    gc_root(strlit9423);
  }
// compilenode returning strlit9423
  gc_frame_newslot(strlit9423);
  params[0] = strlit9423;
  partcv[0] = 1;
  Object call9424 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9422);
// compilenode returning call9424
  Object if9421 = done;
  if (istrue(call9424)) {
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2926
  setline(2926);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_lparen = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2919
  setline(2919);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9425 = gc_frame_new();
// Begin line 2927
  setline(2927);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9426 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9427 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9426);
// compilenode returning call9427
// compilenode returning call9427
  gc_frame_newslot(call9427);
// compilenode returning *var_part
  params[0] = call9427;
  partcv[0] = 1;
  Object call9428 = callmethod(*var_part, "linePos:=",
    1, partcv, params);
  gc_frame_end(callframe9425);
// compilenode returning call9428
// compilenode returning done
// Begin line 2928
  setline(2928);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9429 = gc_frame_new();
  partcv[0] = 0;
  Object call9430 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9429);
// compilenode returning call9430
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_id = undefined;
// compilenode returning done
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 2930
  setline(2930);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9431 = alloc_Boolean(0);
// compilenode returning bool9431
  *var_comma = bool9431;
  if (bool9431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 2931
  setline(2931);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9432 = gc_frame_new();
  Object block9433 = alloc_Block(NULL, NULL, "parser", 2931);
  gc_frame_newslot(block9433);
  block_savedest(block9433);
  Object closure9434 = createclosure(2, "_apply");
setclosureframe(closure9434, stackframe);
  addtoclosure(closure9434, var_sym);
  addtoclosure(closure9434, selfslot);
  struct UserObject *uo9434 = (struct UserObject*)block9433;
  uo9434->data[0] = (Object)closure9434;
  Method *meth_meth_parser__apply9434 = addmethod2pos(block9433, "_apply", &meth_parser__apply9434, 0);
int argcv_meth_parser__apply9434[] = {0};
meth_meth_parser__apply9434->type = alloc_MethodType(1, argcv_meth_parser__apply9434);
  meth_meth_parser__apply9434->definitionModule = modulename;
  meth_meth_parser__apply9434->definitionLine = 2927;
// compilenode returning block9433
  gc_frame_newslot(block9433);
// Begin line 2932
  setline(2932);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object block9454 = alloc_Block(NULL, NULL, "parser", 2932);
  gc_frame_newslot(block9454);
  block_savedest(block9454);
  Object closure9455 = createclosure(12, "_apply");
setclosureframe(closure9455, stackframe);
  addtoclosure(closure9455, var_sym);
  addtoclosure(closure9455, var_errormessages);
  addtoclosure(closure9455, var_lastToken);
  addtoclosure(closure9455, var_comma);
  addtoclosure(closure9455, var_vararg);
  addtoclosure(closure9455, var_varargs);
  addtoclosure(closure9455, var_values);
  addtoclosure(closure9455, var_id);
  addtoclosure(closure9455, var_dtype);
  addtoclosure(closure9455, var_part);
  addtoclosure(closure9455, var_lparen);
  addtoclosure(closure9455, selfslot);
  struct UserObject *uo9455 = (struct UserObject*)block9454;
  uo9455->data[0] = (Object)closure9455;
  Method *meth_meth_parser__apply9455 = addmethod2pos(block9454, "_apply", &meth_parser__apply9455, 0);
int argcv_meth_parser__apply9455[] = {0};
meth_meth_parser__apply9455->type = alloc_MethodType(1, argcv_meth_parser__apply9455);
  meth_meth_parser__apply9455->definitionModule = modulename;
  meth_meth_parser__apply9455->definitionLine = 2932;
// compilenode returning block9454
  gc_frame_newslot(block9454);
  params[0] = block9433;
  params[1] = block9454;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9714 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9432);
// compilenode returning call9714
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3009
  setline(3009);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9717 == NULL) {
    strlit9717 = alloc_String("rparen");
    gc_root(strlit9717);
  }
// compilenode returning strlit9717
  int op_slot_right_9716 = gc_frame_newslot(strlit9717);
  int callframe9719 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9720 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9719);
// compilenode returning call9720
// compilenode returning call9720
  int op_slot_left_9716 = gc_frame_newslot(call9720);
  params[0] = strlit9717;
  partcv[0] = 1;
  Object opresult9721 = callmethod(call9720, "!=", 1, partcv, params);
// compilenode returning opresult9721
  Object if9715 = done;
  if (istrue(opresult9721)) {
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3010
  setline(3010);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9722 = gc_frame_new();
  int callframe9723 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9724 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9723);
// compilenode returning call9724
// compilenode returning call9724
  partcv[0] = 0;
  Object call9725 = callmethod(call9724, "new",
    1, partcv, params);
  gc_frame_end(callframe9722);
// compilenode returning call9725
// compilenode returning call9725
  *var_suggestion = call9725;
  if (call9725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3011
  setline(3011);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9726 = gc_frame_new();
  Object block9727 = alloc_Block(NULL, NULL, "parser", 3011);
  gc_frame_newslot(block9727);
  block_savedest(block9727);
  Object closure9728 = createclosure(2, "_apply");
setclosureframe(closure9728, stackframe);
  addtoclosure(closure9728, var_lastToken);
  addtoclosure(closure9728, selfslot);
  struct UserObject *uo9728 = (struct UserObject*)block9727;
  uo9728->data[0] = (Object)closure9728;
  Method *meth_meth_parser__apply9728 = addmethod2pos(block9727, "_apply", &meth_parser__apply9728, 0);
int argcv_meth_parser__apply9728[] = {1};
meth_meth_parser__apply9728->type = alloc_MethodType(1, argcv_meth_parser__apply9728);
  meth_meth_parser__apply9728->definitionModule = modulename;
  meth_meth_parser__apply9728->definitionLine = 3010;
// compilenode returning block9727
  gc_frame_newslot(block9727);
  params[0] = block9727;
  partcv[0] = 1;
  Object call9746 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9726);
// compilenode returning call9746
  *var_rparen = call9746;
  if (call9746 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3012
  setline(3012);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9749 = alloc_Boolean(0);
// compilenode returning bool9749
  int op_slot_right_9748 = gc_frame_newslot(bool9749);
// compilenode returning *var_rparen
  int op_slot_left_9748 = gc_frame_newslot(*var_rparen);
  params[0] = bool9749;
  partcv[0] = 1;
  Object opresult9751 = callmethod(*var_rparen, "==", 1, partcv, params);
// compilenode returning opresult9751
  Object if9747 = done;
  if (istrue(opresult9751)) {
// Begin line 3013
  setline(3013);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9752 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  if (strlit9753 == NULL) {
    strlit9753 = alloc_String(")");
    gc_root(strlit9753);
  }
// compilenode returning strlit9753
  gc_frame_newslot(strlit9753);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = strlit9753;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9754 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9752);
// compilenode returning call9754
    gc_frame_newslot(call9754);
    if9747 = call9754;
  } else {
// Begin line 3015
  setline(3015);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9755 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call9756 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe9755);
// compilenode returning call9756
    gc_frame_newslot(call9756);
    if9747 = call9756;
  }
// compilenode returning if9747
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9757 = gc_frame_new();
  if (strlit9758 == NULL) {
    strlit9758 = alloc_String("A part of a method beginning with a '(' must end with a ')'.");
    gc_root(strlit9758);
  }
// compilenode returning strlit9758
  gc_frame_newslot(strlit9758);
// Begin line 3018
  setline(3018);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9759 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9760 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9759);
// compilenode returning call9760
// compilenode returning call9760
  gc_frame_newslot(call9760);
  int callframe9761 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9762 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9761);
// compilenode returning call9762
// compilenode returning call9762
  gc_frame_newslot(call9762);
  int callframe9763 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9764 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9763);
// compilenode returning call9764
// compilenode returning call9764
  gc_frame_newslot(call9764);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3017
  setline(3017);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9758;
  params[1] = call9760;
  params[2] = call9762;
  params[3] = call9764;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call9765 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9757);
// compilenode returning call9765
    gc_frame_newslot(call9765);
    if9715 = call9765;
  } else {
  }
// compilenode returning if9715
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9768 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9769 = callmethod(*var_part, "line",
    1, partcv, params);
  gc_frame_end(callframe9768);
// compilenode returning call9769
// compilenode returning call9769
  int op_slot_right_9767 = gc_frame_newslot(call9769);
  int callframe9771 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9772 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9771);
// compilenode returning call9772
// compilenode returning call9772
  int op_slot_left_9767 = gc_frame_newslot(call9772);
  params[0] = call9769;
  partcv[0] = 1;
  Object opresult9773 = callmethod(call9772, "==", 1, partcv, params);
// compilenode returning opresult9773
  Object if9766 = done;
  if (istrue(opresult9773)) {
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3020
  setline(3020);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9774 = gc_frame_new();
// Begin line 3022
  setline(3022);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3021
  setline(3021);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9776 = gc_frame_new();
// compilenode returning *var_part
  partcv[0] = 0;
  Object call9777 = callmethod(*var_part, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9776);
// compilenode returning call9777
// compilenode returning call9777
  int op_slot_right_9775 = gc_frame_newslot(call9777);
  int callframe9779 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9780 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9779);
// compilenode returning call9780
// compilenode returning call9780
  int op_slot_left_9775 = gc_frame_newslot(call9780);
  params[0] = call9777;
  partcv[0] = 1;
  Object diff9781 = callmethod(call9780, "-", 1, partcv, params);
// compilenode returning diff9781
  gc_frame_newslot(diff9781);
// compilenode returning *var_part
  params[0] = diff9781;
  partcv[0] = 1;
  Object call9782 = callmethod(*var_part, "lineLength:=",
    1, partcv, params);
  gc_frame_end(callframe9774);
// compilenode returning call9782
// compilenode returning done
    gc_frame_newslot(done);
    if9766 = done;
  } else {
  }
// compilenode returning if9766
// Begin line 3023
  setline(3023);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9783 = gc_frame_new();
  partcv[0] = 0;
  Object call9784 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9783);
// compilenode returning call9784
// Begin line 3032
  setline(3032);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3025
  setline(3025);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9787 = gc_frame_new();
  if (strlit9788 == NULL) {
    strlit9788 = alloc_String("identifier");
    gc_root(strlit9788);
  }
// compilenode returning strlit9788
  gc_frame_newslot(strlit9788);
  params[0] = strlit9788;
  partcv[0] = 1;
  Object call9789 = callmethodflags(self, "acceptSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9787);
// compilenode returning call9789
  int op_slot_right_9786 = gc_frame_newslot(call9789);
// Begin line 3024
  setline(3024);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9792 = gc_frame_new();
  if (strlit9793 == NULL) {
    strlit9793 = alloc_String("identifier");
    gc_root(strlit9793);
  }
// compilenode returning strlit9793
  gc_frame_newslot(strlit9793);
  params[0] = strlit9793;
  partcv[0] = 1;
  Object call9794 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9792);
// compilenode returning call9794
  int op_slot_right_9791 = gc_frame_newslot(call9794);
  int callframe9796 = gc_frame_new();
// compilenode returning *var_sameline
  partcv[0] = 0;
  Object call9797 = callmethod(*var_sameline, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe9796);
// compilenode returning call9797
  int op_slot_left_9791 = gc_frame_newslot(call9797);
  params[0] = call9794;
  partcv[0] = 1;
  Object opresult9798 = callmethod(call9797, "&&", 1, partcv, params);
// compilenode returning opresult9798
  int op_slot_left_9786 = gc_frame_newslot(opresult9798);
  params[0] = call9789;
  partcv[0] = 1;
  Object opresult9799 = callmethod(opresult9798, "||", 1, partcv, params);
// compilenode returning opresult9799
  Object if9785 = done;
  if (istrue(opresult9799)) {
// Begin line 3028
  setline(3028);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9800 = gc_frame_new();
// compilenode returning *var_meth
  gc_frame_newslot(*var_meth);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
  Object array9801 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array9801
  gc_frame_newslot(array9801);
  Object bool9802 = alloc_Boolean(0);
// compilenode returning bool9802
  gc_frame_newslot(bool9802);
  int callframe9803 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call9804 = callmethod(*var_ast, "methodNode",
    1, partcv, params);
  gc_frame_end(callframe9803);
// compilenode returning call9804
// compilenode returning call9804
  params[0] = *var_meth;
  params[1] = *var_signature;
  params[2] = array9801;
  params[3] = bool9802;
  partcv[0] = 4;
  Object call9805 = callmethod(call9804, "new",
    1, partcv, params);
  gc_frame_end(callframe9800);
// compilenode returning call9805
  *var_tm = call9805;
  if (call9805 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3029
  setline(3029);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9806 = gc_frame_new();
// compilenode returning *var_tm
  gc_frame_newslot(*var_tm);
// compilenode returning *var_sameline
  gc_frame_newslot(*var_sameline);
  params[0] = *var_tm;
  params[1] = *var_sameline;
  partcv[0] = 2;
  Object call9807 = callmethodflags(self, "parsempmndecrest", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9806);
// compilenode returning call9807
  *var_meth = call9807;
  if (call9807 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3031
  setline(3031);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3030
  setline(3030);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9810 = gc_frame_new();
// compilenode returning *var_tm
  partcv[0] = 0;
  Object call9811 = callmethod(*var_tm, "varargs",
    1, partcv, params);
  gc_frame_end(callframe9810);
// compilenode returning call9811
// compilenode returning call9811
  int op_slot_right_9809 = gc_frame_newslot(call9811);
// compilenode returning *var_varargs
  int op_slot_left_9809 = gc_frame_newslot(*var_varargs);
  params[0] = call9811;
  partcv[0] = 1;
  Object opresult9813 = callmethod(*var_varargs, "||", 1, partcv, params);
// compilenode returning opresult9813
  *var_varargs = opresult9813;
  if (opresult9813 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9785 = done;
  } else {
  }
// compilenode returning if9785
    gc_frame_newslot(if9785);
    if9421 = if9785;
  } else {
  }
// compilenode returning if9421
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3033
  setline(3033);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9816 = gc_frame_new();
  if (strlit9817 == NULL) {
    strlit9817 = alloc_String("arrow");
    gc_root(strlit9817);
  }
// compilenode returning strlit9817
  gc_frame_newslot(strlit9817);
  params[0] = strlit9817;
  partcv[0] = 1;
  Object call9818 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9816);
// compilenode returning call9818
  Object if9815 = done;
  if (istrue(call9818)) {
// Begin line 3035
  setline(3035);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9819 = gc_frame_new();
  partcv[0] = 0;
  Object call9820 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9819);
// compilenode returning call9820
// Begin line 3036
  setline(3036);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9821 = gc_frame_new();
  partcv[0] = 0;
  Object call9822 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9821);
// compilenode returning call9822
// Begin line 3038
  setline(3038);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3037
  setline(3037);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9823 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9824 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9823);
// compilenode returning call9824
// compilenode returning call9824
  *var_dtype = call9824;
  if (call9824 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9815 = done;
  } else {
// Begin line 3040
  setline(3040);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3039
  setline(3039);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool9826 = alloc_Boolean(0);
// compilenode returning bool9826
  *var_dtype = bool9826;
  if (bool9826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9815 = done;
  }
// compilenode returning if9815
// Begin line 3041
  setline(3041);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject9828 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9828 = alloc_userobj2(10,6, objclass9828);
  gc_frame_newslot(obj9828);
// OBJECT OUTER DEC outer
  adddatum2(obj9828, self, 0);
  addmethodreal(obj9828,"outer", &reader_parser_outer_9829);
  Object oldself9828 = self;
  struct StackFrameObject *oldstackframe9828 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9828);
  gc_frame_newslot((Object)stackframe);
  self = obj9828;
  Object *oldselfslot9828 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9828 = (*(struct UserObject *)self).data[0], lowerouter9828 = thisouter9828;
  if (inheritingObject9828) {
    struct UserObject *inho9828 = (struct UserObject *)inheritingObject9828;
    while (inho9828->super != GraceDefaultObject) inho9828 = (struct UserObject *)inho9828->super;
    inho9828->super = obj9828;
    self = inheritingObject9828;
    *selfslot = self;
    lowerouter9828 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9828;
  }
if (objclass9828 == NULL) {
  Method *reader9830 = addmethodrealflags(obj9828, "m",&reader_parser_m_9830, 0);
  Method *writer9830 = addmethodrealflags(obj9828, "m:=",&writer_parser_m_9830, 0);
  reader9830->definitionModule = modulename;
  writer9830->definitionModule = modulename;
  reader9830->definitionLine = 3043;
  writer9830->definitionLine = 3043;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 1);
if (objclass9828 == NULL) {
  Method *reader9831 = addmethodrealflags(obj9828, "sig",&reader_parser_sig_9831, 0);
  Method *writer9831 = addmethodrealflags(obj9828, "sig:=",&writer_parser_sig_9831, 0);
  reader9831->definitionModule = modulename;
  writer9831->definitionModule = modulename;
  reader9831->definitionLine = 3044;
  writer9831->definitionLine = 3044;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 2);
if (objclass9828 == NULL) {
  Method *reader9832 = addmethodrealflags(obj9828, "rtype",&reader_parser_rtype_9832, 0);
  Method *writer9832 = addmethodrealflags(obj9828, "rtype:=",&writer_parser_rtype_9832, 0);
  reader9832->definitionModule = modulename;
  writer9832->definitionModule = modulename;
  reader9832->definitionLine = 3045;
  writer9832->definitionLine = 3045;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 3);
if (objclass9828 == NULL) {
  Method *reader9833 = addmethodrealflags(obj9828, "v",&reader_parser_v_9833, 0);
  Method *writer9833 = addmethodrealflags(obj9828, "v:=",&writer_parser_v_9833, 0);
  reader9833->definitionModule = modulename;
  writer9833->definitionModule = modulename;
  reader9833->definitionLine = 3046;
  writer9833->definitionLine = 3046;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 4);
if (objclass9828 == NULL) {
  Method *reader9834 = addmethodrealflags(obj9828, "generics",&reader_parser_generics_9834, 0);
  Method *writer9834 = addmethodrealflags(obj9828, "generics:=",&writer_parser_generics_9834, 0);
  reader9834->definitionModule = modulename;
  writer9834->definitionModule = modulename;
  reader9834->definitionLine = 3047;
  writer9834->definitionLine = 3047;
}
obj9828->flags |= OFLAG_MUTABLE;
adddatum2(obj9828, alloc_Undefined(), 5);
  sourceObject = obj9828;
// Begin line 3042
  setline(3042);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_meth
  adddatum2(obj9828, *var_meth, 1);
  sourceObject = obj9828;
// Begin line 3043
  setline(3043);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_signature
  adddatum2(obj9828, *var_signature, 2);
  sourceObject = obj9828;
// Begin line 3044
  setline(3044);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_dtype
  adddatum2(obj9828, *var_dtype, 3);
  sourceObject = obj9828;
// Begin line 3045
  setline(3045);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_varargs
  adddatum2(obj9828, *var_varargs, 4);
  sourceObject = obj9828;
// Begin line 3046
  setline(3046);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_genericIdents
  adddatum2(obj9828, *var_genericIdents, 5);
objclass9828 = obj9828->class;
  objclass9828->definitionModule = modulename;
  objclass9828->definitionLine = 3041;
  (*(struct UserObject *)self).data[0] = lowerouter9828;
  self = oldself9828;
  selfslot = oldselfslot9828;
  stackframe = oldstackframe9828;
// compilenode returning obj9828
  *var_o = obj9828;
  if (obj9828 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3048
  setline(3048);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_o
  gc_frame_end(frame);
  return *var_o;
}
Object meth_parser_doimport9836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 49, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doimport");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  Object *var_ast = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doimport (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doimport");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_importline = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "importline");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_errorPos = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "errorPos");
  Object *var_p = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "p");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3107
  setline(3107);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3054
  setline(3054);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9840 == NULL) {
    strlit9840 = alloc_String("import");
    gc_root(strlit9840);
  }
// compilenode returning strlit9840
  int op_slot_right_9839 = gc_frame_newslot(strlit9840);
  int callframe9842 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9843 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9842);
// compilenode returning call9843
// compilenode returning call9843
  int op_slot_left_9839 = gc_frame_newslot(call9843);
  params[0] = strlit9840;
  partcv[0] = 1;
  Object opresult9844 = callmethod(call9843, "==", 1, partcv, params);
// compilenode returning opresult9844
  int op_slot_right_9838 = gc_frame_newslot(opresult9844);
  int callframe9846 = gc_frame_new();
  if (strlit9847 == NULL) {
    strlit9847 = alloc_String("keyword");
    gc_root(strlit9847);
  }
// compilenode returning strlit9847
  gc_frame_newslot(strlit9847);
  params[0] = strlit9847;
  partcv[0] = 1;
  Object call9848 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9846);
// compilenode returning call9848
  int op_slot_left_9838 = gc_frame_newslot(call9848);
  params[0] = opresult9844;
  partcv[0] = 1;
  Object opresult9849 = callmethod(call9848, "&&", 1, partcv, params);
// compilenode returning opresult9849
  Object if9837 = done;
  if (istrue(opresult9849)) {
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3055
  setline(3055);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9850 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9851 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9850);
// compilenode returning call9851
// compilenode returning call9851
  *var_importline = call9851;
  if (call9851 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3056
  setline(3056);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9852 = gc_frame_new();
  partcv[0] = 0;
  Object call9853 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9852);
// compilenode returning call9853
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3057
  setline(3057);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9856 == NULL) {
    strlit9856 = alloc_String("string");
    gc_root(strlit9856);
  }
// compilenode returning strlit9856
  int op_slot_right_9855 = gc_frame_newslot(strlit9856);
  int callframe9858 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9859 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9858);
// compilenode returning call9859
// compilenode returning call9859
  int op_slot_left_9855 = gc_frame_newslot(call9859);
  params[0] = strlit9856;
  partcv[0] = 1;
  Object opresult9860 = callmethod(call9859, "!=", 1, partcv, params);
// compilenode returning opresult9860
  Object if9854 = done;
  if (istrue(opresult9860)) {
// Begin line 3059
  setline(3059);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3058
  setline(3058);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9861 = gc_frame_new();
  int callframe9862 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9863 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9862);
// compilenode returning call9863
// compilenode returning call9863
  partcv[0] = 0;
  Object call9864 = callmethod(call9863, "new",
    1, partcv, params);
  gc_frame_end(callframe9861);
// compilenode returning call9864
// compilenode returning call9864
  *var_suggestion = call9864;
  if (call9864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_errorPos = undefined;
// compilenode returning done
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3060
  setline(3060);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9868 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9869 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9868);
// compilenode returning call9869
// compilenode returning call9869
  int op_slot_right_9867 = gc_frame_newslot(call9869);
  int callframe9871 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9872 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9871);
// compilenode returning call9872
// compilenode returning call9872
  int op_slot_left_9867 = gc_frame_newslot(call9872);
  params[0] = call9869;
  partcv[0] = 1;
  Object opresult9873 = callmethod(call9872, "==", 1, partcv, params);
// compilenode returning opresult9873
  int op_slot_right_9866 = gc_frame_newslot(opresult9873);
  if (strlit9876 == NULL) {
    strlit9876 = alloc_String("identifier");
    gc_root(strlit9876);
  }
// compilenode returning strlit9876
  int op_slot_right_9875 = gc_frame_newslot(strlit9876);
  int callframe9878 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9879 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9878);
// compilenode returning call9879
// compilenode returning call9879
  int op_slot_left_9875 = gc_frame_newslot(call9879);
  params[0] = strlit9876;
  partcv[0] = 1;
  Object opresult9880 = callmethod(call9879, "==", 1, partcv, params);
// compilenode returning opresult9880
  int op_slot_left_9866 = gc_frame_newslot(opresult9880);
  params[0] = opresult9873;
  partcv[0] = 1;
  Object opresult9881 = callmethod(opresult9880, "&&", 1, partcv, params);
// compilenode returning opresult9881
  Object if9865 = done;
  if (istrue(opresult9881)) {
// Begin line 3061
  setline(3061);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9882 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit9884 == NULL) {
    strlit9884 = alloc_String("""\x22""");
    gc_root(strlit9884);
  }
// compilenode returning strlit9884
  int op_slot_right_9883 = gc_frame_newslot(strlit9884);
  int callframe9887 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9888 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9887);
// compilenode returning call9888
// compilenode returning call9888
  int op_slot_right_9886 = gc_frame_newslot(call9888);
  if (strlit9890 == NULL) {
    strlit9890 = alloc_String("""\x22""");
    gc_root(strlit9890);
  }
// compilenode returning strlit9890
  int op_slot_left_9886 = gc_frame_newslot(strlit9890);
  params[0] = call9888;
  partcv[0] = 1;
  Object opresult9891 = callmethod(strlit9890, "++", 1, partcv, params);
// compilenode returning opresult9891
  int op_slot_left_9883 = gc_frame_newslot(opresult9891);
  params[0] = strlit9884;
  partcv[0] = 1;
  Object opresult9892 = callmethod(opresult9891, "++", 1, partcv, params);
// compilenode returning opresult9892
  gc_frame_newslot(opresult9892);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = opresult9892;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9893 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe9882);
// compilenode returning call9893
// Begin line 3063
  setline(3063);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3062
  setline(3062);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9894 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9895 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9894);
// compilenode returning call9895
// compilenode returning call9895
  *var_errorPos = call9895;
  if (call9895 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9865 = done;
  } else {
// Begin line 3064
  setline(3064);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9897 = gc_frame_new();
  if (strlit9898 == NULL) {
    strlit9898 = alloc_String(" ""\x22""""\xc2""""\xab""module name""\xc2""""\xbb""""\x22""");
    gc_root(strlit9898);
  }
// compilenode returning strlit9898
  gc_frame_newslot(strlit9898);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9898;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9899 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9897);
// compilenode returning call9899
// Begin line 3066
  setline(3066);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3065
  setline(3065);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num9901 = alloc_Float64(1);
// compilenode returning num9901
  int op_slot_right_9900 = gc_frame_newslot(num9901);
  int callframe9904 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9905 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9904);
// compilenode returning call9905
// compilenode returning call9905
  int op_slot_right_9903 = gc_frame_newslot(call9905);
  int callframe9907 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9908 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9907);
// compilenode returning call9908
// compilenode returning call9908
  int op_slot_left_9903 = gc_frame_newslot(call9908);
  params[0] = call9905;
  partcv[0] = 1;
  Object sum9909 = callmethod(call9908, "+", 1, partcv, params);
// compilenode returning sum9909
  int op_slot_left_9900 = gc_frame_newslot(sum9909);
  params[0] = num9901;
  partcv[0] = 1;
  Object sum9910 = callmethod(sum9909, "+", 1, partcv, params);
// compilenode returning sum9910
  *var_errorPos = sum9910;
  if (sum9910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if9865 = done;
  }
// compilenode returning if9865
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9912 = gc_frame_new();
  if (strlit9913 == NULL) {
    strlit9913 = alloc_String("An import statement must have the name of the module in quotes, 'as', and an identifier after 'import'.");
    gc_root(strlit9913);
  }
// compilenode returning strlit9913
  gc_frame_newslot(strlit9913);
// Begin line 3068
  setline(3068);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9914 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9915 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9914);
// compilenode returning call9915
// compilenode returning call9915
  gc_frame_newslot(call9915);
// compilenode returning *var_errorPos
  gc_frame_newslot(*var_errorPos);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3067
  setline(3067);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9913;
  params[1] = call9915;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9916 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9912);
// compilenode returning call9916
    gc_frame_newslot(call9916);
    if9854 = call9916;
  } else {
  }
// compilenode returning if9854
// Begin line 3070
  setline(3070);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9917 = gc_frame_new();
  partcv[0] = 0;
  Object call9918 = callmethodflags(self, "pushstring", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9917);
// compilenode returning call9918
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3071
  setline(3071);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9919 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call9920 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe9919);
// compilenode returning call9920
// compilenode returning call9920
  *var_p = call9920;
  if (call9920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3072
  setline(3072);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9924 == NULL) {
    strlit9924 = alloc_String("as");
    gc_root(strlit9924);
  }
// compilenode returning strlit9924
  int op_slot_right_9923 = gc_frame_newslot(strlit9924);
  int callframe9926 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9927 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe9926);
// compilenode returning call9927
// compilenode returning call9927
  int op_slot_left_9923 = gc_frame_newslot(call9927);
  params[0] = strlit9924;
  partcv[0] = 1;
  Object opresult9928 = callmethod(call9927, "!=", 1, partcv, params);
// compilenode returning opresult9928
  int op_slot_right_9922 = gc_frame_newslot(opresult9928);
  if (strlit9931 == NULL) {
    strlit9931 = alloc_String("identifier");
    gc_root(strlit9931);
  }
// compilenode returning strlit9931
  int op_slot_right_9930 = gc_frame_newslot(strlit9931);
  int callframe9933 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9934 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9933);
// compilenode returning call9934
// compilenode returning call9934
  int op_slot_left_9930 = gc_frame_newslot(call9934);
  params[0] = strlit9931;
  partcv[0] = 1;
  Object opresult9935 = callmethod(call9934, "!=", 1, partcv, params);
// compilenode returning opresult9935
  int op_slot_left_9922 = gc_frame_newslot(opresult9935);
  params[0] = opresult9928;
  partcv[0] = 1;
  Object opresult9936 = callmethod(opresult9935, "||", 1, partcv, params);
// compilenode returning opresult9936
  Object if9921 = done;
  if (istrue(opresult9936)) {
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3073
  setline(3073);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9937 = gc_frame_new();
  int callframe9938 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call9939 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9938);
// compilenode returning call9939
// compilenode returning call9939
  partcv[0] = 0;
  Object call9940 = callmethod(call9939, "new",
    1, partcv, params);
  gc_frame_end(callframe9937);
// compilenode returning call9940
// compilenode returning call9940
  *var_suggestion = call9940;
  if (call9940 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3074
  setline(3074);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9944 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9945 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9944);
// compilenode returning call9945
// compilenode returning call9945
  int op_slot_right_9943 = gc_frame_newslot(call9945);
  int callframe9947 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9948 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe9947);
// compilenode returning call9948
// compilenode returning call9948
  int op_slot_left_9943 = gc_frame_newslot(call9948);
  params[0] = call9945;
  partcv[0] = 1;
  Object opresult9949 = callmethod(call9948, "==", 1, partcv, params);
// compilenode returning opresult9949
  int op_slot_right_9942 = gc_frame_newslot(opresult9949);
  if (strlit9952 == NULL) {
    strlit9952 = alloc_String("identifier");
    gc_root(strlit9952);
  }
// compilenode returning strlit9952
  int op_slot_right_9951 = gc_frame_newslot(strlit9952);
  int callframe9954 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9955 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9954);
// compilenode returning call9955
// compilenode returning call9955
  int op_slot_left_9951 = gc_frame_newslot(call9955);
  params[0] = strlit9952;
  partcv[0] = 1;
  Object opresult9956 = callmethod(call9955, "==", 1, partcv, params);
// compilenode returning opresult9956
  int op_slot_left_9942 = gc_frame_newslot(opresult9956);
  params[0] = opresult9949;
  partcv[0] = 1;
  Object opresult9957 = callmethod(opresult9956, "&&", 1, partcv, params);
// compilenode returning opresult9957
  Object if9941 = done;
  if (istrue(opresult9957)) {
// Begin line 3075
  setline(3075);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9958 = gc_frame_new();
  if (strlit9959 == NULL) {
    strlit9959 = alloc_String(" as");
    gc_root(strlit9959);
  }
// compilenode returning strlit9959
  gc_frame_newslot(strlit9959);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit9959;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9960 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9958);
// compilenode returning call9960
    gc_frame_newslot(call9960);
    if9941 = call9960;
  } else {
// Begin line 3077
  setline(3077);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9961 = gc_frame_new();
  if (strlit9963 == NULL) {
    strlit9963 = alloc_String("");
    gc_root(strlit9963);
  }
// compilenode returning strlit9963
  int op_slot_right_9962 = gc_frame_newslot(strlit9963);
  int callframe9966 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call9967 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe9966);
// compilenode returning call9967
// compilenode returning call9967
  int op_slot_right_9965 = gc_frame_newslot(call9967);
  if (strlit9969 == NULL) {
    strlit9969 = alloc_String(" as ");
    gc_root(strlit9969);
  }
// compilenode returning strlit9969
  int op_slot_left_9965 = gc_frame_newslot(strlit9969);
  params[0] = call9967;
  partcv[0] = 1;
  Object opresult9970 = callmethod(strlit9969, "++", 1, partcv, params);
// compilenode returning opresult9970
  int op_slot_left_9962 = gc_frame_newslot(opresult9970);
  params[0] = strlit9963;
  partcv[0] = 1;
  Object opresult9971 = callmethod(opresult9970, "++", 1, partcv, params);
// compilenode returning opresult9971
  gc_frame_newslot(opresult9971);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = opresult9971;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call9972 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe9961);
// compilenode returning call9972
    gc_frame_newslot(call9972);
    if9941 = call9972;
  }
// compilenode returning if9941
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9973 = gc_frame_new();
  if (strlit9974 == NULL) {
    strlit9974 = alloc_String("An import statement must have 'as', and an identifier after the name of the module in quotes.");
    gc_root(strlit9974);
  }
// compilenode returning strlit9974
  gc_frame_newslot(strlit9974);
// Begin line 3080
  setline(3080);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9975 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9976 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe9975);
// compilenode returning call9976
// compilenode returning call9976
  gc_frame_newslot(call9976);
  Object num9978 = alloc_Float64(1);
// compilenode returning num9978
  int op_slot_right_9977 = gc_frame_newslot(num9978);
  int callframe9981 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9982 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe9981);
// compilenode returning call9982
// compilenode returning call9982
  int op_slot_right_9980 = gc_frame_newslot(call9982);
  int callframe9984 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call9985 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe9984);
// compilenode returning call9985
// compilenode returning call9985
  int op_slot_left_9980 = gc_frame_newslot(call9985);
  params[0] = call9982;
  partcv[0] = 1;
  Object sum9986 = callmethod(call9985, "+", 1, partcv, params);
// compilenode returning sum9986
  int op_slot_left_9977 = gc_frame_newslot(sum9986);
  params[0] = num9978;
  partcv[0] = 1;
  Object sum9987 = callmethod(sum9986, "+", 1, partcv, params);
// compilenode returning sum9987
  gc_frame_newslot(sum9987);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3079
  setline(3079);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit9974;
  params[1] = call9976;
  params[2] = sum9987;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call9988 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe9973);
// compilenode returning call9988
    gc_frame_newslot(call9988);
    if9921 = call9988;
  } else {
  }
// compilenode returning if9921
// Begin line 3082
  setline(3082);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9989 = gc_frame_new();
  partcv[0] = 0;
  Object call9990 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe9989);
// compilenode returning call9990
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3083
  setline(3083);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit9993 == NULL) {
    strlit9993 = alloc_String("identifier");
    gc_root(strlit9993);
  }
// compilenode returning strlit9993
  int op_slot_right_9992 = gc_frame_newslot(strlit9993);
  int callframe9995 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call9996 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe9995);
// compilenode returning call9996
// compilenode returning call9996
  int op_slot_left_9992 = gc_frame_newslot(call9996);
  params[0] = strlit9993;
  partcv[0] = 1;
  Object opresult9997 = callmethod(call9996, "!=", 1, partcv, params);
// compilenode returning opresult9997
  Object if9991 = done;
  if (istrue(opresult9997)) {
// Begin line 3085
  setline(3085);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3084
  setline(3084);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe9998 = gc_frame_new();
  int callframe9999 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10000 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe9999);
// compilenode returning call10000
// compilenode returning call10000
  partcv[0] = 0;
  Object call10001 = callmethod(call10000, "new",
    1, partcv, params);
  gc_frame_end(callframe9998);
// compilenode returning call10001
// compilenode returning call10001
  *var_suggestion = call10001;
  if (call10001 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_errorPos = undefined;
// compilenode returning done
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3086
  setline(3086);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10005 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10006 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10005);
// compilenode returning call10006
// compilenode returning call10006
  int op_slot_right_10004 = gc_frame_newslot(call10006);
  int callframe10008 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10009 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10008);
// compilenode returning call10009
// compilenode returning call10009
  int op_slot_left_10004 = gc_frame_newslot(call10009);
  params[0] = call10006;
  partcv[0] = 1;
  Object opresult10010 = callmethod(call10009, "==", 1, partcv, params);
// compilenode returning opresult10010
  int op_slot_right_10003 = gc_frame_newslot(opresult10010);
  if (strlit10013 == NULL) {
    strlit10013 = alloc_String("string");
    gc_root(strlit10013);
  }
// compilenode returning strlit10013
  int op_slot_right_10012 = gc_frame_newslot(strlit10013);
  int callframe10015 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10016 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10015);
// compilenode returning call10016
// compilenode returning call10016
  int op_slot_left_10012 = gc_frame_newslot(call10016);
  params[0] = strlit10013;
  partcv[0] = 1;
  Object opresult10017 = callmethod(call10016, "==", 1, partcv, params);
// compilenode returning opresult10017
  int op_slot_left_10003 = gc_frame_newslot(opresult10017);
  params[0] = opresult10010;
  partcv[0] = 1;
  Object opresult10018 = callmethod(opresult10017, "&&", 1, partcv, params);
// compilenode returning opresult10018
  Object if10002 = done;
  if (istrue(opresult10018)) {
// Begin line 3087
  setline(3087);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10019 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit10021 == NULL) {
    strlit10021 = alloc_String("");
    gc_root(strlit10021);
  }
// compilenode returning strlit10021
  int op_slot_right_10020 = gc_frame_newslot(strlit10021);
  int callframe10024 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10025 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10024);
// compilenode returning call10025
// compilenode returning call10025
  int op_slot_right_10023 = gc_frame_newslot(call10025);
  if (strlit10027 == NULL) {
    strlit10027 = alloc_String("");
    gc_root(strlit10027);
  }
// compilenode returning strlit10027
  int op_slot_left_10023 = gc_frame_newslot(strlit10027);
  params[0] = call10025;
  partcv[0] = 1;
  Object opresult10028 = callmethod(strlit10027, "++", 1, partcv, params);
// compilenode returning opresult10028
  int op_slot_left_10020 = gc_frame_newslot(opresult10028);
  params[0] = strlit10021;
  partcv[0] = 1;
  Object opresult10029 = callmethod(opresult10028, "++", 1, partcv, params);
// compilenode returning opresult10029
  gc_frame_newslot(opresult10029);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = opresult10029;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10030 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10019);
// compilenode returning call10030
// Begin line 3089
  setline(3089);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3088
  setline(3088);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10031 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10032 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10031);
// compilenode returning call10032
// compilenode returning call10032
  *var_errorPos = call10032;
  if (call10032 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10002 = done;
  } else {
// Begin line 3090
  setline(3090);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10034 = gc_frame_new();
  if (strlit10036 == NULL) {
    strlit10036 = alloc_String("");
    gc_root(strlit10036);
  }
// compilenode returning strlit10036
  int op_slot_right_10035 = gc_frame_newslot(strlit10036);
  int callframe10039 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10040 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10039);
// compilenode returning call10040
// compilenode returning call10040
  int op_slot_right_10038 = gc_frame_newslot(call10040);
  if (strlit10042 == NULL) {
    strlit10042 = alloc_String(" ");
    gc_root(strlit10042);
  }
// compilenode returning strlit10042
  int op_slot_left_10038 = gc_frame_newslot(strlit10042);
  params[0] = call10040;
  partcv[0] = 1;
  Object opresult10043 = callmethod(strlit10042, "++", 1, partcv, params);
// compilenode returning opresult10043
  int op_slot_left_10035 = gc_frame_newslot(opresult10043);
  params[0] = strlit10036;
  partcv[0] = 1;
  Object opresult10044 = callmethod(opresult10043, "++", 1, partcv, params);
// compilenode returning opresult10044
  gc_frame_newslot(opresult10044);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = opresult10044;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10045 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10034);
// compilenode returning call10045
// Begin line 3092
  setline(3092);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3091
  setline(3091);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num10047 = alloc_Float64(1);
// compilenode returning num10047
  int op_slot_right_10046 = gc_frame_newslot(num10047);
  int callframe10050 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10051 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10050);
// compilenode returning call10051
// compilenode returning call10051
  int op_slot_right_10049 = gc_frame_newslot(call10051);
  int callframe10053 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10054 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10053);
// compilenode returning call10054
// compilenode returning call10054
  int op_slot_left_10049 = gc_frame_newslot(call10054);
  params[0] = call10051;
  partcv[0] = 1;
  Object sum10055 = callmethod(call10054, "+", 1, partcv, params);
// compilenode returning sum10055
  int op_slot_left_10046 = gc_frame_newslot(sum10055);
  params[0] = num10047;
  partcv[0] = 1;
  Object sum10056 = callmethod(sum10055, "+", 1, partcv, params);
// compilenode returning sum10056
  *var_errorPos = sum10056;
  if (sum10056 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10002 = done;
  }
// compilenode returning if10002
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10058 = gc_frame_new();
  if (strlit10059 == NULL) {
    strlit10059 = alloc_String("An import statement must have an identifier after 'as'.");
    gc_root(strlit10059);
  }
// compilenode returning strlit10059
  gc_frame_newslot(strlit10059);
// Begin line 3094
  setline(3094);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10060 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10061 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10060);
// compilenode returning call10061
// compilenode returning call10061
  gc_frame_newslot(call10061);
// compilenode returning *var_errorPos
  gc_frame_newslot(*var_errorPos);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3093
  setline(3093);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10059;
  params[1] = call10061;
  params[2] = *var_errorPos;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10062 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10058);
// compilenode returning call10062
    gc_frame_newslot(call10062);
    if9991 = call10062;
  } else {
  }
// compilenode returning if9991
// Begin line 3096
  setline(3096);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10063 = gc_frame_new();
  partcv[0] = 0;
  Object call10064 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10063);
// compilenode returning call10064
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3097
  setline(3097);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10065 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10066 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10065);
// compilenode returning call10066
// compilenode returning call10066
  *var_n = call10066;
  if (call10066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3098
  setline(3098);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10067 = gc_frame_new();
// compilenode returning *var_importline
  gc_frame_newslot(*var_importline);
// compilenode returning *var_util
  params[0] = *var_importline;
  partcv[0] = 1;
  Object call10068 = callmethod(*var_util, "setline",
    1, partcv, params);
  gc_frame_end(callframe10067);
// compilenode returning call10068
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10069 = gc_frame_new();
  int callframe10070 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10071 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10070);
// compilenode returning call10071
// compilenode returning call10071
  gc_frame_newslot(call10071);
  int callframe10072 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call10073 = callmethod(*var_n, "value",
    1, partcv, params);
  gc_frame_end(callframe10072);
// compilenode returning call10073
// compilenode returning call10073
  gc_frame_newslot(call10073);
  int callframe10074 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10075 = callmethod(*var_ast, "importNode",
    1, partcv, params);
  gc_frame_end(callframe10074);
// compilenode returning call10075
// compilenode returning call10075
  params[0] = call10071;
  params[1] = call10073;
  partcv[0] = 2;
  Object call10076 = callmethod(call10075, "new",
    1, partcv, params);
  gc_frame_end(callframe10069);
// compilenode returning call10076
  *var_o = call10076;
  if (call10076 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3100
  setline(3100);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10078 = gc_frame_new();
  if (strlit10079 == NULL) {
    strlit10079 = alloc_String("colon");
    gc_root(strlit10079);
  }
// compilenode returning strlit10079
  gc_frame_newslot(strlit10079);
  params[0] = strlit10079;
  partcv[0] = 1;
  Object call10080 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10078);
// compilenode returning call10080
  Object if10077 = done;
  if (istrue(call10080)) {
// Begin line 3101
  setline(3101);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10081 = gc_frame_new();
  partcv[0] = 0;
  Object call10082 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10081);
// compilenode returning call10082
// Begin line 3102
  setline(3102);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10083 = gc_frame_new();
  partcv[0] = 0;
  Object call10084 = callmethodflags(self, "dotypeterm", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10083);
// compilenode returning call10084
// Begin line 3104
  setline(3104);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3099
  setline(3099);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10085 = gc_frame_new();
// Begin line 3103
  setline(3103);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10086 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10087 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10086);
// compilenode returning call10087
// compilenode returning call10087
  gc_frame_newslot(call10087);
// compilenode returning *var_o
  params[0] = call10087;
  partcv[0] = 1;
  Object call10088 = callmethod(*var_o, "dtype:=",
    1, partcv, params);
  gc_frame_end(callframe10085);
// compilenode returning call10088
// compilenode returning done
    gc_frame_newslot(done);
    if10077 = done;
  } else {
  }
// compilenode returning if10077
// Begin line 3105
  setline(3105);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10089 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10090 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10089);
// compilenode returning call10090
    gc_frame_newslot(call10090);
    if9837 = call10090;
  } else {
  }
// compilenode returning if9837
  gc_frame_end(frame);
  return if9837;
}
Object meth_parser__apply10114(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10115 = gc_frame_new();
  partcv[0] = 0;
  Object call10116 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10115);
// compilenode returning call10116
  gc_frame_end(frame);
  return call10116;
}
Object meth_parser_doreturn10091(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 50, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doreturn");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doreturn (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doreturn");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_retval = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "retval");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_o = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "o");
// Begin line 3142
  setline(3142);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3112
  setline(3112);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10095 == NULL) {
    strlit10095 = alloc_String("return");
    gc_root(strlit10095);
  }
// compilenode returning strlit10095
  int op_slot_right_10094 = gc_frame_newslot(strlit10095);
  int callframe10097 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10098 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10097);
// compilenode returning call10098
// compilenode returning call10098
  int op_slot_left_10094 = gc_frame_newslot(call10098);
  params[0] = strlit10095;
  partcv[0] = 1;
  Object opresult10099 = callmethod(call10098, "==", 1, partcv, params);
// compilenode returning opresult10099
  int op_slot_right_10093 = gc_frame_newslot(opresult10099);
  int callframe10101 = gc_frame_new();
  if (strlit10102 == NULL) {
    strlit10102 = alloc_String("keyword");
    gc_root(strlit10102);
  }
// compilenode returning strlit10102
  gc_frame_newslot(strlit10102);
  params[0] = strlit10102;
  partcv[0] = 1;
  Object call10103 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10101);
// compilenode returning call10103
  int op_slot_left_10093 = gc_frame_newslot(call10103);
  params[0] = opresult10099;
  partcv[0] = 1;
  Object opresult10104 = callmethod(call10103, "&&", 1, partcv, params);
// compilenode returning opresult10104
  Object if10092 = done;
  if (istrue(opresult10104)) {
// Begin line 3113
  setline(3113);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10105 = gc_frame_new();
  partcv[0] = 0;
  Object call10106 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10105);
// compilenode returning call10106
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_retval = undefined;
// compilenode returning done
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3115
  setline(3115);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10108 = gc_frame_new();
  partcv[0] = 0;
  Object call10109 = callmethodflags(self, "tokenOnSameLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10108);
// compilenode returning call10109
  Object if10107 = done;
  if (istrue(call10109)) {
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3116
  setline(3116);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10111 = gc_frame_new();
  int callframe10112 = gc_frame_new();
  Object block10113 = alloc_Block(NULL, NULL, "parser", 3116);
  gc_frame_newslot(block10113);
  block_savedest(block10113);
  Object closure10114 = createclosure(1, "_apply");
setclosureframe(closure10114, stackframe);
  addtoclosure(closure10114, selfslot);
  struct UserObject *uo10114 = (struct UserObject*)block10113;
  uo10114->data[0] = (Object)closure10114;
  Method *meth_meth_parser__apply10114 = addmethod2pos(block10113, "_apply", &meth_parser__apply10114, 0);
int argcv_meth_parser__apply10114[] = {0};
meth_meth_parser__apply10114->type = alloc_MethodType(1, argcv_meth_parser__apply10114);
  meth_meth_parser__apply10114->definitionModule = modulename;
  meth_meth_parser__apply10114->definitionLine = 3116;
// compilenode returning block10113
  gc_frame_newslot(block10113);
  params[0] = block10113;
  partcv[0] = 1;
  Object call10118 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10112);
// compilenode returning call10118
  partcv[0] = 0;
  Object call10119 = callmethod(call10118, "not",
    1, partcv, params);
  gc_frame_end(callframe10111);
// compilenode returning call10119
// compilenode returning call10119
  Object if10110 = done;
  if (istrue(call10119)) {
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3117
  setline(3117);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10120 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10120
  *var_suggestions = array10120;
  if (array10120 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3118
  setline(3118);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10121 = gc_frame_new();
  int callframe10122 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10123 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10122);
// compilenode returning call10123
// compilenode returning call10123
  partcv[0] = 0;
  Object call10124 = callmethod(call10123, "new",
    1, partcv, params);
  gc_frame_end(callframe10121);
// compilenode returning call10124
// compilenode returning call10124
  *var_suggestion = call10124;
  if (call10124 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3119
  setline(3119);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10125 = gc_frame_new();
  if (strlit10126 == NULL) {
    strlit10126 = alloc_String("rbrace");
    gc_root(strlit10126);
  }
// compilenode returning strlit10126
  gc_frame_newslot(strlit10126);
  params[0] = strlit10126;
  partcv[0] = 1;
  Object call10127 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10125);
// compilenode returning call10127
  *var_nextTok = call10127;
  if (call10127 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3120
  setline(3120);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_10129 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_10129 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10131 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult10131
  Object if10128 = done;
  if (istrue(opresult10131)) {
// Begin line 3121
  setline(3121);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10132 = gc_frame_new();
  if (strlit10133 == NULL) {
    strlit10133 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10133);
  }
// compilenode returning strlit10133
  gc_frame_newslot(strlit10133);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit10133;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10134 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10132);
// compilenode returning call10134
// Begin line 3122
  setline(3122);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10135 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10136 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10135);
// compilenode returning call10136
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3123
  setline(3123);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10137 = gc_frame_new();
  int callframe10138 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10139 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10138);
// compilenode returning call10139
// compilenode returning call10139
  partcv[0] = 0;
  Object call10140 = callmethod(call10139, "new",
    1, partcv, params);
  gc_frame_end(callframe10137);
// compilenode returning call10140
// compilenode returning call10140
  *var_suggestion = call10140;
  if (call10140 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3124
  setline(3124);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10142 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool10143 = alloc_Boolean(1);
// compilenode returning bool10143
  gc_frame_newslot(bool10143);
  Object bool10144 = alloc_Boolean(0);
// compilenode returning bool10144
  gc_frame_newslot(bool10144);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool10143;
  params[2] = bool10144;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10145 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10142);
// compilenode returning call10145
    gc_frame_newslot(call10145);
    if10128 = call10145;
  } else {
// Begin line 3126
  setline(3126);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10146 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe10147 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call10148 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10147);
// compilenode returning call10148
// compilenode returning call10148
  gc_frame_newslot(call10148);
  Object bool10149 = alloc_Boolean(1);
// compilenode returning bool10149
  gc_frame_newslot(bool10149);
  Object bool10150 = alloc_Boolean(0);
// compilenode returning bool10150
  gc_frame_newslot(bool10150);
  if (strlit10151 == NULL) {
    strlit10151 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10151);
  }
// compilenode returning strlit10151
  gc_frame_newslot(strlit10151);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call10148;
  params[2] = bool10149;
  params[3] = bool10150;
  params[4] = strlit10151;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10152 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10146);
// compilenode returning call10152
// Begin line 3127
  setline(3127);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10153 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10154 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10153);
// compilenode returning call10154
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3128
  setline(3128);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10155 = gc_frame_new();
  int callframe10156 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10157 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10156);
// compilenode returning call10157
// compilenode returning call10157
  partcv[0] = 0;
  Object call10158 = callmethod(call10157, "new",
    1, partcv, params);
  gc_frame_end(callframe10155);
// compilenode returning call10158
// compilenode returning call10158
  *var_suggestion = call10158;
  if (call10158 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3129
  setline(3129);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10160 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe10161 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call10162 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10161);
// compilenode returning call10162
// compilenode returning call10162
  gc_frame_newslot(call10162);
  Object bool10163 = alloc_Boolean(1);
// compilenode returning bool10163
  gc_frame_newslot(bool10163);
  Object bool10164 = alloc_Boolean(0);
// compilenode returning bool10164
  gc_frame_newslot(bool10164);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call10162;
  params[2] = bool10163;
  params[3] = bool10164;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10165 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10160);
// compilenode returning call10165
    gc_frame_newslot(call10165);
    if10128 = call10165;
  }
// compilenode returning if10128
// Begin line 3131
  setline(3131);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10166 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10167 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10166);
// compilenode returning call10167
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10168 = gc_frame_new();
  if (strlit10169 == NULL) {
    strlit10169 = alloc_String("A return statement must have either an expression or a new-line after 'return'.");
    gc_root(strlit10169);
  }
// compilenode returning strlit10169
  gc_frame_newslot(strlit10169);
// Begin line 3133
  setline(3133);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10170 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10171 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10170);
// compilenode returning call10171
// compilenode returning call10171
  gc_frame_newslot(call10171);
  int callframe10172 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10173 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10172);
// compilenode returning call10173
// compilenode returning call10173
  gc_frame_newslot(call10173);
  Object num10175 = alloc_Float64(1);
// compilenode returning num10175
  int op_slot_right_10174 = gc_frame_newslot(num10175);
  int callframe10178 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10179 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe10178);
// compilenode returning call10179
// compilenode returning call10179
  int op_slot_right_10177 = gc_frame_newslot(call10179);
  int callframe10181 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10182 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10181);
// compilenode returning call10182
// compilenode returning call10182
  int op_slot_left_10177 = gc_frame_newslot(call10182);
  params[0] = call10179;
  partcv[0] = 1;
  Object sum10183 = callmethod(call10182, "+", 1, partcv, params);
// compilenode returning sum10183
  int op_slot_left_10174 = gc_frame_newslot(sum10183);
  params[0] = num10175;
  partcv[0] = 1;
  Object diff10184 = callmethod(sum10183, "-", 1, partcv, params);
// compilenode returning diff10184
  gc_frame_newslot(diff10184);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 3132
  setline(3132);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10169;
  params[1] = call10171;
  params[2] = call10173;
  params[3] = diff10184;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call10185 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10168);
// compilenode returning call10185
    gc_frame_newslot(call10185);
    if10110 = call10185;
  } else {
  }
// compilenode returning if10110
// Begin line 3136
  setline(3136);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3135
  setline(3135);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10186 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10187 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10186);
// compilenode returning call10187
// compilenode returning call10187
  *var_retval = call10187;
  if (call10187 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10107 = done;
  } else {
// Begin line 3137
  setline(3137);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10189 = gc_frame_new();
  if (strlit10190 == NULL) {
    strlit10190 = alloc_String("done");
    gc_root(strlit10190);
  }
// compilenode returning strlit10190
  gc_frame_newslot(strlit10190);
  Object bool10191 = alloc_Boolean(0);
// compilenode returning bool10191
  gc_frame_newslot(bool10191);
  int callframe10192 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10193 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10192);
// compilenode returning call10193
// compilenode returning call10193
  params[0] = strlit10190;
  params[1] = bool10191;
  partcv[0] = 2;
  Object call10194 = callmethod(call10193, "new",
    1, partcv, params);
  gc_frame_end(callframe10189);
// compilenode returning call10194
  *var_retval = call10194;
  if (call10194 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10107 = done;
  }
// compilenode returning if10107
// Begin line 3139
  setline(3139);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10196 = gc_frame_new();
// compilenode returning *var_retval
  gc_frame_newslot(*var_retval);
  int callframe10197 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10198 = callmethod(*var_ast, "returnNode",
    1, partcv, params);
  gc_frame_end(callframe10197);
// compilenode returning call10198
// compilenode returning call10198
  params[0] = *var_retval;
  partcv[0] = 1;
  Object call10199 = callmethod(call10198, "new",
    1, partcv, params);
  gc_frame_end(callframe10196);
// compilenode returning call10199
  *var_o = call10199;
  if (call10199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3140
  setline(3140);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10200 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10201 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10200);
// compilenode returning call10201
    gc_frame_newslot(call10201);
    if10092 = call10201;
  } else {
  }
// compilenode returning if10092
  gc_frame_end(frame);
  return if10092;
}
Object meth_parser_domethodtype10202(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 51, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(9, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "domethodtype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_ast = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_util = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for domethodtype (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for domethodtype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_m = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "m");
  Object *var_meth = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "meth");
  Object *var_signature = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "signature");
  Object *var_dtype = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "dtype");
  Object *var_varargs = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "varargs");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
  Object *var_suggestion = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "suggestion");
  Object *var_newLine = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "newLine");
// Begin line 3145
  setline(3145);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10203 = gc_frame_new();
  Object bool10204 = alloc_Boolean(1);
// compilenode returning bool10204
  gc_frame_newslot(bool10204);
  params[0] = bool10204;
  partcv[0] = 1;
  Object call10205 = callmethodflags(self, "methodsignature", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10203);
// compilenode returning call10205
  *var_m = call10205;
  if (call10205 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3146
  setline(3146);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10206 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call10207 = callmethod(*var_m, "m",
    1, partcv, params);
  gc_frame_end(callframe10206);
// compilenode returning call10207
// compilenode returning call10207
  *var_meth = call10207;
  if (call10207 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3147
  setline(3147);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10208 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call10209 = callmethod(*var_m, "sig",
    1, partcv, params);
  gc_frame_end(callframe10208);
// compilenode returning call10209
// compilenode returning call10209
  *var_signature = call10209;
  if (call10209 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3148
  setline(3148);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10210 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call10211 = callmethod(*var_m, "rtype",
    1, partcv, params);
  gc_frame_end(callframe10210);
// compilenode returning call10211
// compilenode returning call10211
  *var_dtype = call10211;
  if (call10211 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3149
  setline(3149);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10212 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call10213 = callmethod(*var_m, "v",
    1, partcv, params);
  gc_frame_end(callframe10212);
// compilenode returning call10213
// compilenode returning call10213
  *var_varargs = call10213;
  if (call10213 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3150
  setline(3150);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool10216 = alloc_Boolean(0);
// compilenode returning bool10216
  int op_slot_right_10215 = gc_frame_newslot(bool10216);
// compilenode returning *var_dtype
  int op_slot_left_10215 = gc_frame_newslot(*var_dtype);
  params[0] = bool10216;
  partcv[0] = 1;
  Object opresult10218 = callmethod(*var_dtype, "==", 1, partcv, params);
// compilenode returning opresult10218
  Object if10214 = done;
  if (istrue(opresult10218)) {
// Begin line 3151
  setline(3151);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10219 = gc_frame_new();
  if (strlit10220 == NULL) {
    strlit10220 = alloc_String("Done");
    gc_root(strlit10220);
  }
// compilenode returning strlit10220
  gc_frame_newslot(strlit10220);
  Object bool10221 = alloc_Boolean(0);
// compilenode returning bool10221
  gc_frame_newslot(bool10221);
  int callframe10222 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10223 = callmethod(*var_ast, "identifierNode",
    1, partcv, params);
  gc_frame_end(callframe10222);
// compilenode returning call10223
// compilenode returning call10223
  params[0] = strlit10220;
  params[1] = bool10221;
  partcv[0] = 2;
  Object call10224 = callmethod(call10223, "new",
    1, partcv, params);
  gc_frame_end(callframe10219);
// compilenode returning call10224
  *var_dtype = call10224;
  if (call10224 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10214 = done;
  } else {
  }
// compilenode returning if10214
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10226 = gc_frame_new();
  int callframe10227 = gc_frame_new();
// compilenode returning *var_meth
  partcv[0] = 0;
  Object call10228 = callmethod(*var_meth, "value",
    1, partcv, params);
  gc_frame_end(callframe10227);
// compilenode returning call10228
// compilenode returning call10228
  gc_frame_newslot(call10228);
// compilenode returning *var_signature
  gc_frame_newslot(*var_signature);
// compilenode returning *var_dtype
  gc_frame_newslot(*var_dtype);
  int callframe10229 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10230 = callmethod(*var_ast, "methodTypeNode",
    1, partcv, params);
  gc_frame_end(callframe10229);
// compilenode returning call10230
// compilenode returning call10230
  params[0] = call10228;
  params[1] = *var_signature;
  params[2] = *var_dtype;
  partcv[0] = 3;
  Object call10231 = callmethod(call10230, "new",
    1, partcv, params);
  gc_frame_end(callframe10226);
// compilenode returning call10231
  *var_o = call10231;
  if (call10231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3153
  setline(3153);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10232 = gc_frame_new();
// Begin line 3154
  setline(3154);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10233 = gc_frame_new();
// compilenode returning *var_m
  partcv[0] = 0;
  Object call10234 = callmethod(*var_m, "generics",
    1, partcv, params);
  gc_frame_end(callframe10233);
// compilenode returning call10234
// compilenode returning call10234
  gc_frame_newslot(call10234);
// compilenode returning *var_o
  params[0] = call10234;
  partcv[0] = 1;
  Object call10235 = callmethod(*var_o, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10232);
// compilenode returning call10235
// compilenode returning done
// Begin line 3155
  setline(3155);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10236 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call10237 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10236);
// compilenode returning call10237
// Begin line 3170
  setline(3170);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3156
  setline(3156);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10239 = gc_frame_new();
  if (strlit10240 == NULL) {
    strlit10240 = alloc_String("semicolon");
    gc_root(strlit10240);
  }
// compilenode returning strlit10240
  gc_frame_newslot(strlit10240);
  params[0] = strlit10240;
  partcv[0] = 1;
  Object call10241 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10239);
// compilenode returning call10241
  Object if10238 = done;
  if (istrue(call10241)) {
// Begin line 3157
  setline(3157);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10242 = gc_frame_new();
  partcv[0] = 0;
  Object call10243 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10242);
// compilenode returning call10243
    gc_frame_newslot(call10243);
    if10238 = call10243;
  } else {
// Begin line 3169
  setline(3169);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3159
  setline(3159);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10245 = gc_frame_new();
  int callframe10246 = gc_frame_new();
  if (strlit10247 == NULL) {
    strlit10247 = alloc_String("rbrace");
    gc_root(strlit10247);
  }
// compilenode returning strlit10247
  gc_frame_newslot(strlit10247);
  params[0] = strlit10247;
  partcv[0] = 1;
  Object call10248 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10246);
// compilenode returning call10248
  partcv[0] = 0;
  Object call10249 = callmethod(call10248, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10245);
// compilenode returning call10249
  Object if10244 = done;
  if (istrue(call10249)) {
// Begin line 3168
  setline(3168);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3160
  setline(3160);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10252 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10253 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10252);
// compilenode returning call10253
// compilenode returning call10253
  int op_slot_right_10251 = gc_frame_newslot(call10253);
  int callframe10255 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10256 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10255);
// compilenode returning call10256
// compilenode returning call10256
  int op_slot_left_10251 = gc_frame_newslot(call10256);
  params[0] = call10253;
  partcv[0] = 1;
  Object opresult10257 = callmethod(call10256, "==", 1, partcv, params);
// compilenode returning opresult10257
  Object if10250 = done;
  if (istrue(opresult10257)) {
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3161
  setline(3161);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10258 = gc_frame_new();
  int callframe10259 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10260 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10259);
// compilenode returning call10260
// compilenode returning call10260
  partcv[0] = 0;
  Object call10261 = callmethod(call10260, "new",
    1, partcv, params);
  gc_frame_end(callframe10258);
// compilenode returning call10261
// compilenode returning call10261
  *var_suggestion = call10261;
  if (call10261 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3162
  setline(3162);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10263 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10264 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10263);
// compilenode returning call10264
// compilenode returning call10264
  int op_slot_right_10262 = gc_frame_newslot(call10264);
  int callframe10266 = gc_frame_new();
  Object num10267 = alloc_Float64(1);
// compilenode returning num10267
  gc_frame_newslot(num10267);
  Object num10269 = alloc_Float64(1);
// compilenode returning num10269
  int op_slot_right_10268 = gc_frame_newslot(num10269);
  int callframe10271 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10272 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10271);
// compilenode returning call10272
// compilenode returning call10272
  int op_slot_left_10268 = gc_frame_newslot(call10272);
  params[0] = num10269;
  partcv[0] = 1;
  Object diff10273 = callmethod(call10272, "-", 1, partcv, params);
// compilenode returning diff10273
  gc_frame_newslot(diff10273);
  int callframe10274 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call10275 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe10274);
// compilenode returning call10275
// compilenode returning call10275
  int callframe10276 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10277 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10276);
// compilenode returning call10277
// compilenode returning call10277
  params[0] = call10277;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres10278 = callmethod(call10275, "[]", 1, partcv, params);
// compilenode returning idxres10278
  params[0] = num10267;
  params[1] = diff10273;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10279 = callmethod(idxres10278, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe10266);
// compilenode returning call10279
  int op_slot_left_10262 = gc_frame_newslot(call10279);
  params[0] = call10264;
  partcv[0] = 1;
  Object opresult10280 = callmethod(call10279, "++", 1, partcv, params);
// compilenode returning opresult10280
  *var_newLine = opresult10280;
  if (opresult10280 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3163
  setline(3163);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10281 = gc_frame_new();
  Object num10283 = alloc_Float64(0.1);
// compilenode returning num10283
  int op_slot_right_10282 = gc_frame_newslot(num10283);
  int callframe10285 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10286 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10285);
// compilenode returning call10286
// compilenode returning call10286
  int op_slot_left_10282 = gc_frame_newslot(call10286);
  params[0] = num10283;
  partcv[0] = 1;
  Object sum10287 = callmethod(call10286, "+", 1, partcv, params);
// compilenode returning sum10287
  gc_frame_newslot(sum10287);
// compilenode returning *var_newLine
  gc_frame_newslot(*var_newLine);
// compilenode returning *var_suggestion
  params[0] = sum10287;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call10288 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10281);
// compilenode returning call10288
// Begin line 3164
  setline(3164);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10289 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool10290 = alloc_Boolean(1);
// compilenode returning bool10290
  gc_frame_newslot(bool10290);
  Object bool10291 = alloc_Boolean(1);
// compilenode returning bool10291
  gc_frame_newslot(bool10291);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool10290;
  params[2] = bool10291;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10292 = callmethod(*var_suggestion, "deleteToken()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10289);
// compilenode returning call10292
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10293 = gc_frame_new();
  if (strlit10294 == NULL) {
    strlit10294 = alloc_String("Each method must be on a separate line in a type.");
    gc_root(strlit10294);
  }
// compilenode returning strlit10294
  gc_frame_newslot(strlit10294);
// Begin line 3166
  setline(3166);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10295 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10296 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10295);
// compilenode returning call10296
// compilenode returning call10296
  gc_frame_newslot(call10296);
  int callframe10297 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10298 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10297);
// compilenode returning call10298
// compilenode returning call10298
  gc_frame_newslot(call10298);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3165
  setline(3165);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10294;
  params[1] = call10296;
  params[2] = call10298;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10299 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10293);
// compilenode returning call10299
    gc_frame_newslot(call10299);
    if10250 = call10299;
  } else {
  }
// compilenode returning if10250
    gc_frame_newslot(if10250);
    if10244 = if10250;
  } else {
  }
// compilenode returning if10244
    gc_frame_newslot(if10244);
    if10238 = if10244;
  }
// compilenode returning if10238
  gc_frame_end(frame);
  return if10238;
}
Object meth_parser__apply10304(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit10306 == NULL) {
    strlit10306 = alloc_String("type");
    gc_root(strlit10306);
  }
// compilenode returning strlit10306
  int op_slot_right_10305 = gc_frame_newslot(strlit10306);
  int callframe10308 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10309 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10308);
// compilenode returning call10309
// compilenode returning call10309
  int op_slot_left_10305 = gc_frame_newslot(call10309);
  params[0] = strlit10306;
  partcv[0] = 1;
  Object opresult10310 = callmethod(call10309, "==", 1, partcv, params);
// compilenode returning opresult10310
  gc_frame_end(frame);
  return opresult10310;
}
Object meth_parser__apply10348(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10349 = gc_frame_new();
  int callframe10350 = gc_frame_new();
  if (strlit10351 == NULL) {
    strlit10351 = alloc_String("rbrace");
    gc_root(strlit10351);
  }
// compilenode returning strlit10351
  gc_frame_newslot(strlit10351);
  params[0] = strlit10351;
  partcv[0] = 1;
  Object call10352 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10350);
// compilenode returning call10352
  partcv[0] = 0;
  Object call10353 = callmethod(call10352, "not",
    1, partcv, params);
  gc_frame_end(callframe10349);
// compilenode returning call10353
// compilenode returning call10353
  gc_frame_end(frame);
  return call10353;
}
Object meth_parser__apply10356(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_methods = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3187
  setline(3187);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10357 = gc_frame_new();
  partcv[0] = 0;
  Object call10358 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10357);
// compilenode returning call10358
// Begin line 3188
  setline(3188);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10359 = gc_frame_new();
  int callframe10360 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10361 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10360);
// compilenode returning call10361
// compilenode returning call10361
  gc_frame_newslot(call10361);
// compilenode returning *var_methods
  params[0] = call10361;
  partcv[0] = 1;
  Object call10362 = callmethod(*var_methods, "push",
    1, partcv, params);
  gc_frame_end(callframe10359);
// compilenode returning call10362
  gc_frame_end(frame);
  return call10362;
}
Object meth_parser_doanontype10300(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 52, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "doanontype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_auto_count = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for doanontype (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for doanontype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_methods = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "methods");
  Object *var_mc = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "mc");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
// Begin line 3195
  setline(3195);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3174
  setline(3174);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10302 = gc_frame_new();
  Object block10303 = alloc_Block(NULL, NULL, "parser", 3174);
  gc_frame_newslot(block10303);
  block_savedest(block10303);
  Object closure10304 = createclosure(2, "_apply");
setclosureframe(closure10304, stackframe);
  addtoclosure(closure10304, var_sym);
  addtoclosure(closure10304, selfslot);
  struct UserObject *uo10304 = (struct UserObject*)block10303;
  uo10304->data[0] = (Object)closure10304;
  Method *meth_meth_parser__apply10304 = addmethod2pos(block10303, "_apply", &meth_parser__apply10304, 0);
int argcv_meth_parser__apply10304[] = {0};
meth_meth_parser__apply10304->type = alloc_MethodType(1, argcv_meth_parser__apply10304);
  meth_meth_parser__apply10304->definitionModule = modulename;
  meth_meth_parser__apply10304->definitionLine = 3166;
// compilenode returning block10303
  gc_frame_newslot(block10303);
  int callframe10312 = gc_frame_new();
  if (strlit10313 == NULL) {
    strlit10313 = alloc_String("keyword");
    gc_root(strlit10313);
  }
// compilenode returning strlit10313
  gc_frame_newslot(strlit10313);
  params[0] = strlit10313;
  partcv[0] = 1;
  Object call10314 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10312);
// compilenode returning call10314
  params[0] = block10303;
  partcv[0] = 1;
  Object call10315 = callmethod(call10314, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe10302);
// compilenode returning call10315
  Object if10301 = done;
  if (istrue(call10315)) {
// Begin line 3175
  setline(3175);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10316 = gc_frame_new();
  partcv[0] = 0;
  Object call10317 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10316);
// compilenode returning call10317
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3176
  setline(3176);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10319 = gc_frame_new();
  int callframe10320 = gc_frame_new();
  if (strlit10321 == NULL) {
    strlit10321 = alloc_String("lbrace");
    gc_root(strlit10321);
  }
// compilenode returning strlit10321
  gc_frame_newslot(strlit10321);
  params[0] = strlit10321;
  partcv[0] = 1;
  Object call10322 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10320);
// compilenode returning call10322
  partcv[0] = 0;
  Object call10323 = callmethod(call10322, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe10319);
// compilenode returning call10323
  Object if10318 = done;
  if (istrue(call10323)) {
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3177
  setline(3177);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10324 = gc_frame_new();
  int callframe10325 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10326 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10325);
// compilenode returning call10326
// compilenode returning call10326
  partcv[0] = 0;
  Object call10327 = callmethod(call10326, "new",
    1, partcv, params);
  gc_frame_end(callframe10324);
// compilenode returning call10327
// compilenode returning call10327
  *var_suggestion = call10327;
  if (call10327 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3178
  setline(3178);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10328 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  if (strlit10329 == NULL) {
    strlit10329 = alloc_String("{");
    gc_root(strlit10329);
  }
// compilenode returning strlit10329
  gc_frame_newslot(strlit10329);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = strlit10329;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10330 = callmethod(*var_suggestion, "replaceToken()with",
    2, partcv, params);
  gc_frame_end(callframe10328);
// compilenode returning call10330
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10331 = gc_frame_new();
  if (strlit10332 == NULL) {
    strlit10332 = alloc_String("Anonymous types must open with braces.");
    gc_root(strlit10332);
  }
// compilenode returning strlit10332
  gc_frame_newslot(strlit10332);
// Begin line 3180
  setline(3180);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10333 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10334 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10333);
// compilenode returning call10334
// compilenode returning call10334
  gc_frame_newslot(call10334);
  int callframe10335 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10336 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10335);
// compilenode returning call10336
// compilenode returning call10336
  gc_frame_newslot(call10336);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3179
  setline(3179);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10332;
  params[1] = call10334;
  params[2] = call10336;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10337 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10331);
// compilenode returning call10337
    gc_frame_newslot(call10337);
    if10318 = call10337;
  } else {
  }
// compilenode returning if10318
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3182
  setline(3182);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10338 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10338
  *var_methods = array10338;
  if (array10338 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3183
  setline(3183);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_auto_count
  *var_mc = *var_auto_count;
  if (*var_auto_count == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3184
  setline(3184);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num10340 = alloc_Float64(1);
// compilenode returning num10340
  int op_slot_right_10339 = gc_frame_newslot(num10340);
// compilenode returning *var_auto_count
  int op_slot_left_10339 = gc_frame_newslot(*var_auto_count);
  params[0] = num10340;
  partcv[0] = 1;
  Object sum10342 = callmethod(*var_auto_count, "+", 1, partcv, params);
// compilenode returning sum10342
  *var_auto_count = sum10342;
  if (sum10342 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3185
  setline(3185);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10344 = gc_frame_new();
  partcv[0] = 0;
  Object call10345 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10344);
// compilenode returning call10345
// Begin line 3186
  setline(3186);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10346 = gc_frame_new();
  Object block10347 = alloc_Block(NULL, NULL, "parser", 3186);
  gc_frame_newslot(block10347);
  block_savedest(block10347);
  Object closure10348 = createclosure(1, "_apply");
setclosureframe(closure10348, stackframe);
  addtoclosure(closure10348, selfslot);
  struct UserObject *uo10348 = (struct UserObject*)block10347;
  uo10348->data[0] = (Object)closure10348;
  Method *meth_meth_parser__apply10348 = addmethod2pos(block10347, "_apply", &meth_parser__apply10348, 0);
int argcv_meth_parser__apply10348[] = {0};
meth_meth_parser__apply10348->type = alloc_MethodType(1, argcv_meth_parser__apply10348);
  meth_meth_parser__apply10348->definitionModule = modulename;
  meth_meth_parser__apply10348->definitionLine = 3180;
// compilenode returning block10347
  gc_frame_newslot(block10347);
  Object block10355 = alloc_Block(NULL, NULL, "parser", 3186);
  gc_frame_newslot(block10355);
  block_savedest(block10355);
  Object closure10356 = createclosure(3, "_apply");
setclosureframe(closure10356, stackframe);
  addtoclosure(closure10356, var_values);
  addtoclosure(closure10356, var_methods);
  addtoclosure(closure10356, selfslot);
  struct UserObject *uo10356 = (struct UserObject*)block10355;
  uo10356->data[0] = (Object)closure10356;
  Method *meth_meth_parser__apply10356 = addmethod2pos(block10355, "_apply", &meth_parser__apply10356, 0);
int argcv_meth_parser__apply10356[] = {0};
meth_meth_parser__apply10356->type = alloc_MethodType(1, argcv_meth_parser__apply10356);
  meth_meth_parser__apply10356->definitionModule = modulename;
  meth_meth_parser__apply10356->definitionLine = 3186;
// compilenode returning block10355
  gc_frame_newslot(block10355);
  params[0] = block10347;
  params[1] = block10355;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10364 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10346);
// compilenode returning call10364
// Begin line 3190
  setline(3190);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10365 = gc_frame_new();
  partcv[0] = 0;
  Object call10366 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10365);
// compilenode returning call10366
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10367 = gc_frame_new();
  if (strlit10369 == NULL) {
    strlit10369 = alloc_String(">");
    gc_root(strlit10369);
  }
// compilenode returning strlit10369
  int op_slot_right_10368 = gc_frame_newslot(strlit10369);
// compilenode returning *var_mc
  int op_slot_right_10371 = gc_frame_newslot(*var_mc);
  if (strlit10373 == NULL) {
    strlit10373 = alloc_String("<Anon_");
    gc_root(strlit10373);
  }
// compilenode returning strlit10373
  int op_slot_left_10371 = gc_frame_newslot(strlit10373);
  params[0] = *var_mc;
  partcv[0] = 1;
  Object opresult10374 = callmethod(strlit10373, "++", 1, partcv, params);
// compilenode returning opresult10374
  int op_slot_left_10368 = gc_frame_newslot(opresult10374);
  params[0] = strlit10369;
  partcv[0] = 1;
  Object opresult10375 = callmethod(opresult10374, "++", 1, partcv, params);
// compilenode returning opresult10375
  gc_frame_newslot(opresult10375);
// compilenode returning *var_methods
  gc_frame_newslot(*var_methods);
  int callframe10376 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10377 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe10376);
// compilenode returning call10377
// compilenode returning call10377
  params[0] = opresult10375;
  params[1] = *var_methods;
  partcv[0] = 2;
  Object call10378 = callmethod(call10377, "new",
    1, partcv, params);
  gc_frame_end(callframe10367);
// compilenode returning call10378
  *var_t = call10378;
  if (call10378 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3191
  setline(3191);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10379 = gc_frame_new();
// Begin line 3192
  setline(3192);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool10380 = alloc_Boolean(1);
// compilenode returning bool10380
  gc_frame_newslot(bool10380);
// compilenode returning *var_t
  params[0] = bool10380;
  partcv[0] = 1;
  Object call10381 = callmethod(*var_t, "anonymous:=",
    1, partcv, params);
  gc_frame_end(callframe10379);
// compilenode returning call10381
// compilenode returning done
// Begin line 3193
  setline(3193);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10382 = gc_frame_new();
// compilenode returning *var_t
  gc_frame_newslot(*var_t);
// compilenode returning *var_values
  params[0] = *var_t;
  partcv[0] = 1;
  Object call10383 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10382);
// compilenode returning call10383
    gc_frame_newslot(call10383);
    if10301 = call10383;
  } else {
  }
// compilenode returning if10301
  gc_frame_end(frame);
  return if10301;
}
Object meth_parser__apply10474(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_t = &(stackframe->slots[0]);
  *var_t = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  if (strlit10476 == NULL) {
    strlit10476 = alloc_String("lbrace");
    gc_root(strlit10476);
  }
// compilenode returning strlit10476
  int op_slot_right_10475 = gc_frame_newslot(strlit10476);
  int callframe10478 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call10479 = callmethod(*var_t, "kind",
    1, partcv, params);
  gc_frame_end(callframe10478);
// compilenode returning call10479
// compilenode returning call10479
  int op_slot_left_10475 = gc_frame_newslot(call10479);
  params[0] = strlit10476;
  partcv[0] = 1;
  Object opresult10480 = callmethod(call10479, "==", 1, partcv, params);
// compilenode returning opresult10480
  gc_frame_end(frame);
  return opresult10480;
}
Object meth_parser__apply10486(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_nextTok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var_sym
  int op_slot_right_10487 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_10487 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10489 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult10489
  gc_frame_end(frame);
  return opresult10489;
}
Object meth_parser__apply10531(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10532 = gc_frame_new();
  int callframe10533 = gc_frame_new();
  if (strlit10534 == NULL) {
    strlit10534 = alloc_String("rbrace");
    gc_root(strlit10534);
  }
// compilenode returning strlit10534
  gc_frame_newslot(strlit10534);
  params[0] = strlit10534;
  partcv[0] = 1;
  Object call10535 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10533);
// compilenode returning call10535
  partcv[0] = 0;
  Object call10536 = callmethod(call10535, "not",
    1, partcv, params);
  gc_frame_end(callframe10532);
// compilenode returning call10536
// compilenode returning call10536
  gc_frame_end(frame);
  return call10536;
}
Object meth_parser__apply10539(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_methods = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3232
  setline(3232);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10540 = gc_frame_new();
  partcv[0] = 0;
  Object call10541 = callmethodflags(self, "domethodtype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10540);
// compilenode returning call10541
// Begin line 3233
  setline(3233);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10542 = gc_frame_new();
  int callframe10543 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10544 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10543);
// compilenode returning call10544
// compilenode returning call10544
  gc_frame_newslot(call10544);
// compilenode returning *var_methods
  params[0] = call10544;
  partcv[0] = 1;
  Object call10545 = callmethod(*var_methods, "push",
    1, partcv, params);
  gc_frame_end(callframe10542);
// compilenode returning call10545
  gc_frame_end(frame);
  return call10545;
}
Object meth_parser__apply10597(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_nt = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3250
  setline(3250);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10598 = gc_frame_new();
// compilenode returning *var_ut
  gc_frame_newslot(*var_ut);
  int callframe10599 = gc_frame_new();
// compilenode returning *var_nt
  partcv[0] = 0;
  Object call10600 = callmethod(*var_nt, "unionTypes",
    1, partcv, params);
  gc_frame_end(callframe10599);
// compilenode returning call10600
// compilenode returning call10600
  params[0] = *var_ut;
  partcv[0] = 1;
  Object call10601 = callmethod(call10600, "push",
    1, partcv, params);
  gc_frame_end(callframe10598);
// compilenode returning call10601
  gc_frame_end(frame);
  return call10601;
}
Object meth_parser__apply10608(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_nt = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ut = &(stackframe->slots[0]);
  *var_ut = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10609 = gc_frame_new();
// compilenode returning *var_ut
  gc_frame_newslot(*var_ut);
  int callframe10610 = gc_frame_new();
// compilenode returning *var_nt
  partcv[0] = 0;
  Object call10611 = callmethod(*var_nt, "intersectionTypes",
    1, partcv, params);
  gc_frame_end(callframe10610);
// compilenode returning call10611
// compilenode returning call10611
  params[0] = *var_ut;
  partcv[0] = 1;
  Object call10612 = callmethod(call10611, "push",
    1, partcv, params);
  gc_frame_end(callframe10609);
// compilenode returning call10612
  gc_frame_end(frame);
  return call10612;
}
Object meth_parser_dotype10384(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 53, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(11, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dotype");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_lastToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for dotype (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for dotype");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
  Object *var_p = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "p");
  Object *var_gens = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "gens");
  Object *var_anns = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "anns");
  Object *var_nextTok = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "nextTok");
  Object *var_methods = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "methods");
  Object *var_t = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "t");
  Object *var_ot = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "ot");
  Object *var_nt = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "nt");
// Begin line 3265
  setline(3265);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3198
  setline(3198);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10388 == NULL) {
    strlit10388 = alloc_String("type");
    gc_root(strlit10388);
  }
// compilenode returning strlit10388
  int op_slot_right_10387 = gc_frame_newslot(strlit10388);
  int callframe10390 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10391 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10390);
// compilenode returning call10391
// compilenode returning call10391
  int op_slot_left_10387 = gc_frame_newslot(call10391);
  params[0] = strlit10388;
  partcv[0] = 1;
  Object opresult10392 = callmethod(call10391, "==", 1, partcv, params);
// compilenode returning opresult10392
  int op_slot_right_10386 = gc_frame_newslot(opresult10392);
  int callframe10394 = gc_frame_new();
  if (strlit10395 == NULL) {
    strlit10395 = alloc_String("keyword");
    gc_root(strlit10395);
  }
// compilenode returning strlit10395
  gc_frame_newslot(strlit10395);
  params[0] = strlit10395;
  partcv[0] = 1;
  Object call10396 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10394);
// compilenode returning call10396
  int op_slot_left_10386 = gc_frame_newslot(call10396);
  params[0] = opresult10392;
  partcv[0] = 1;
  Object opresult10397 = callmethod(call10396, "&&", 1, partcv, params);
// compilenode returning opresult10397
  Object if10385 = done;
  if (istrue(opresult10397)) {
// Begin line 3199
  setline(3199);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10398 = gc_frame_new();
  partcv[0] = 0;
  Object call10399 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10398);
// compilenode returning call10399
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3200
  setline(3200);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10402 == NULL) {
    strlit10402 = alloc_String("identifier");
    gc_root(strlit10402);
  }
// compilenode returning strlit10402
  int op_slot_right_10401 = gc_frame_newslot(strlit10402);
  int callframe10404 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10405 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10404);
// compilenode returning call10405
// compilenode returning call10405
  int op_slot_left_10401 = gc_frame_newslot(call10405);
  params[0] = strlit10402;
  partcv[0] = 1;
  Object opresult10406 = callmethod(call10405, "!=", 1, partcv, params);
// compilenode returning opresult10406
  Object if10400 = done;
  if (istrue(opresult10406)) {
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3201
  setline(3201);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10407 = gc_frame_new();
  int callframe10408 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10409 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10408);
// compilenode returning call10409
// compilenode returning call10409
  partcv[0] = 0;
  Object call10410 = callmethod(call10409, "new",
    1, partcv, params);
  gc_frame_end(callframe10407);
// compilenode returning call10410
// compilenode returning call10410
  *var_suggestion = call10410;
  if (call10410 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3202
  setline(3202);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10411 = gc_frame_new();
  if (strlit10412 == NULL) {
    strlit10412 = alloc_String(" ""\xc2""""\xab""type name""\xc2""""\xbb""");
    gc_root(strlit10412);
  }
// compilenode returning strlit10412
  gc_frame_newslot(strlit10412);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit10412;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10413 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10411);
// compilenode returning call10413
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10414 = gc_frame_new();
  if (strlit10415 == NULL) {
    strlit10415 = alloc_String("A type declaration must have a name after the 'type'.");
    gc_root(strlit10415);
  }
// compilenode returning strlit10415
  gc_frame_newslot(strlit10415);
// Begin line 3204
  setline(3204);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10416 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10417 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10416);
// compilenode returning call10417
// compilenode returning call10417
  gc_frame_newslot(call10417);
  Object num10419 = alloc_Float64(1);
// compilenode returning num10419
  int op_slot_right_10418 = gc_frame_newslot(num10419);
  int callframe10422 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10423 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10422);
// compilenode returning call10423
// compilenode returning call10423
  int op_slot_right_10421 = gc_frame_newslot(call10423);
  int callframe10425 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10426 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10425);
// compilenode returning call10426
// compilenode returning call10426
  int op_slot_left_10421 = gc_frame_newslot(call10426);
  params[0] = call10423;
  partcv[0] = 1;
  Object sum10427 = callmethod(call10426, "+", 1, partcv, params);
// compilenode returning sum10427
  int op_slot_left_10418 = gc_frame_newslot(sum10427);
  params[0] = num10419;
  partcv[0] = 1;
  Object sum10428 = callmethod(sum10427, "+", 1, partcv, params);
// compilenode returning sum10428
  gc_frame_newslot(sum10428);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3203
  setline(3203);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10415;
  params[1] = call10417;
  params[2] = sum10428;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10429 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10414);
// compilenode returning call10429
    gc_frame_newslot(call10429);
    if10400 = call10429;
  } else {
  }
// compilenode returning if10400
// Begin line 3206
  setline(3206);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10430 = gc_frame_new();
  partcv[0] = 0;
  Object call10431 = callmethodflags(self, "pushidentifier", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10430);
// compilenode returning call10431
// Begin line 3207
  setline(3207);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10432 = gc_frame_new();
  partcv[0] = 0;
  Object call10433 = callmethodflags(self, "generic", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10432);
// compilenode returning call10433
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3208
  setline(3208);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10434 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10435 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10434);
// compilenode returning call10435
// compilenode returning call10435
  *var_p = call10435;
  if (call10435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3209
  setline(3209);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10436 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10436
  *var_gens = array10436;
  if (array10436 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3210
  setline(3210);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10439 == NULL) {
    strlit10439 = alloc_String("generic");
    gc_root(strlit10439);
  }
// compilenode returning strlit10439
  int op_slot_right_10438 = gc_frame_newslot(strlit10439);
  int callframe10441 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10442 = callmethod(*var_p, "kind",
    1, partcv, params);
  gc_frame_end(callframe10441);
// compilenode returning call10442
// compilenode returning call10442
  int op_slot_left_10438 = gc_frame_newslot(call10442);
  params[0] = strlit10439;
  partcv[0] = 1;
  Object opresult10443 = callmethod(call10442, "==", 1, partcv, params);
// compilenode returning opresult10443
  Object if10437 = done;
  if (istrue(opresult10443)) {
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3211
  setline(3211);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10444 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10445 = callmethod(*var_p, "params",
    1, partcv, params);
  gc_frame_end(callframe10444);
// compilenode returning call10445
// compilenode returning call10445
  *var_gens = call10445;
  if (call10445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3213
  setline(3213);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3212
  setline(3212);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10447 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10448 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10447);
// compilenode returning call10448
// compilenode returning call10448
  *var_p = call10448;
  if (call10448 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10437 = done;
  } else {
  }
// compilenode returning if10437
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3214
  setline(3214);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10450 = gc_frame_new();
  partcv[0] = 0;
  Object call10451 = callmethodflags(self, "doannotation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10450);
// compilenode returning call10451
  *var_anns = call10451;
  if (call10451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3215
  setline(3215);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10455 == NULL) {
    strlit10455 = alloc_String("=");
    gc_root(strlit10455);
  }
// compilenode returning strlit10455
  int op_slot_right_10454 = gc_frame_newslot(strlit10455);
  int callframe10457 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10458 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10457);
// compilenode returning call10458
// compilenode returning call10458
  int op_slot_left_10454 = gc_frame_newslot(call10458);
  params[0] = strlit10455;
  partcv[0] = 1;
  Object opresult10459 = callmethod(call10458, "!=", 1, partcv, params);
// compilenode returning opresult10459
  int op_slot_right_10453 = gc_frame_newslot(opresult10459);
  if (strlit10462 == NULL) {
    strlit10462 = alloc_String("op");
    gc_root(strlit10462);
  }
// compilenode returning strlit10462
  int op_slot_right_10461 = gc_frame_newslot(strlit10462);
  int callframe10464 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10465 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10464);
// compilenode returning call10465
// compilenode returning call10465
  int op_slot_left_10461 = gc_frame_newslot(call10465);
  params[0] = strlit10462;
  partcv[0] = 1;
  Object opresult10466 = callmethod(call10465, "!=", 1, partcv, params);
// compilenode returning opresult10466
  int op_slot_left_10453 = gc_frame_newslot(opresult10466);
  params[0] = opresult10459;
  partcv[0] = 1;
  Object opresult10467 = callmethod(opresult10466, "||", 1, partcv, params);
// compilenode returning opresult10467
  Object if10452 = done;
  if (istrue(opresult10467)) {
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3216
  setline(3216);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10468 = gc_frame_new();
  int callframe10469 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10470 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10469);
// compilenode returning call10470
// compilenode returning call10470
  partcv[0] = 0;
  Object call10471 = callmethod(call10470, "new",
    1, partcv, params);
  gc_frame_end(callframe10468);
// compilenode returning call10471
// compilenode returning call10471
  *var_suggestion = call10471;
  if (call10471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3217
  setline(3217);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10472 = gc_frame_new();
  Object block10473 = alloc_Block(NULL, NULL, "parser", 3217);
  gc_frame_newslot(block10473);
  block_savedest(block10473);
  Object closure10474 = createclosure(1, "_apply");
setclosureframe(closure10474, stackframe);
  addtoclosure(closure10474, selfslot);
  struct UserObject *uo10474 = (struct UserObject*)block10473;
  uo10474->data[0] = (Object)closure10474;
  Method *meth_meth_parser__apply10474 = addmethod2pos(block10473, "_apply", &meth_parser__apply10474, 0);
int argcv_meth_parser__apply10474[] = {1};
meth_meth_parser__apply10474->type = alloc_MethodType(1, argcv_meth_parser__apply10474);
  meth_meth_parser__apply10474->definitionModule = modulename;
  meth_meth_parser__apply10474->definitionLine = 3216;
// compilenode returning block10473
  gc_frame_newslot(block10473);
  params[0] = block10473;
  partcv[0] = 1;
  Object call10482 = callmethodflags(self, "findNextToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10472);
// compilenode returning call10482
  *var_nextTok = call10482;
  if (call10482 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3218
  setline(3218);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10484 = gc_frame_new();
  Object block10485 = alloc_Block(NULL, NULL, "parser", 3218);
  gc_frame_newslot(block10485);
  block_savedest(block10485);
  Object closure10486 = createclosure(3, "_apply");
setclosureframe(closure10486, stackframe);
  addtoclosure(closure10486, var_sym);
  addtoclosure(closure10486, var_nextTok);
  addtoclosure(closure10486, selfslot);
  struct UserObject *uo10486 = (struct UserObject*)block10485;
  uo10486->data[0] = (Object)closure10486;
  Method *meth_meth_parser__apply10486 = addmethod2pos(block10485, "_apply", &meth_parser__apply10486, 0);
int argcv_meth_parser__apply10486[] = {0};
meth_meth_parser__apply10486->type = alloc_MethodType(1, argcv_meth_parser__apply10486);
  meth_meth_parser__apply10486->definitionModule = modulename;
  meth_meth_parser__apply10486->definitionLine = 3217;
// compilenode returning block10485
  gc_frame_newslot(block10485);
  Object bool10492 = alloc_Boolean(0);
// compilenode returning bool10492
  int op_slot_right_10491 = gc_frame_newslot(bool10492);
// compilenode returning *var_nextTok
  int op_slot_left_10491 = gc_frame_newslot(*var_nextTok);
  params[0] = bool10492;
  partcv[0] = 1;
  Object opresult10494 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult10494
  params[0] = block10485;
  partcv[0] = 1;
  Object call10495 = callmethod(opresult10494, "orElse",
    1, partcv, params);
  gc_frame_end(callframe10484);
// compilenode returning call10495
  Object if10483 = done;
  if (istrue(call10495)) {
// Begin line 3219
  setline(3219);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10496 = gc_frame_new();
  if (strlit10497 == NULL) {
    strlit10497 = alloc_String(" =");
    gc_root(strlit10497);
  }
// compilenode returning strlit10497
  gc_frame_newslot(strlit10497);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit10497;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10498 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10496);
// compilenode returning call10498
    gc_frame_newslot(call10498);
    if10483 = call10498;
  } else {
// Begin line 3221
  setline(3221);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10499 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe10500 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call10501 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10500);
// compilenode returning call10501
// compilenode returning call10501
  gc_frame_newslot(call10501);
  if (strlit10502 == NULL) {
    strlit10502 = alloc_String("=");
    gc_root(strlit10502);
  }
// compilenode returning strlit10502
  gc_frame_newslot(strlit10502);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call10501;
  params[2] = strlit10502;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call10503 = callmethod(*var_suggestion, "replaceTokenRange()with",
    2, partcv, params);
  gc_frame_end(callframe10499);
// compilenode returning call10503
    gc_frame_newslot(call10503);
    if10483 = call10503;
  }
// compilenode returning if10483
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10504 = gc_frame_new();
  if (strlit10505 == NULL) {
    strlit10505 = alloc_String("A type declaration must have a '=' after the type name.");
    gc_root(strlit10505);
  }
// compilenode returning strlit10505
  gc_frame_newslot(strlit10505);
// Begin line 3224
  setline(3224);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10506 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10507 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe10506);
// compilenode returning call10507
// compilenode returning call10507
  gc_frame_newslot(call10507);
  Object num10509 = alloc_Float64(1);
// compilenode returning num10509
  int op_slot_right_10508 = gc_frame_newslot(num10509);
  int callframe10512 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10513 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe10512);
// compilenode returning call10513
// compilenode returning call10513
  int op_slot_right_10511 = gc_frame_newslot(call10513);
  int callframe10515 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call10516 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10515);
// compilenode returning call10516
// compilenode returning call10516
  int op_slot_left_10511 = gc_frame_newslot(call10516);
  params[0] = call10513;
  partcv[0] = 1;
  Object sum10517 = callmethod(call10516, "+", 1, partcv, params);
// compilenode returning sum10517
  int op_slot_left_10508 = gc_frame_newslot(sum10517);
  params[0] = num10509;
  partcv[0] = 1;
  Object sum10518 = callmethod(sum10517, "+", 1, partcv, params);
// compilenode returning sum10518
  gc_frame_newslot(sum10518);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3223
  setline(3223);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10505;
  params[1] = call10507;
  params[2] = sum10518;
  params[3] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10519 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe10504);
// compilenode returning call10519
    gc_frame_newslot(call10519);
    if10452 = call10519;
  } else {
  }
// compilenode returning if10452
// Begin line 3226
  setline(3226);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10520 = gc_frame_new();
  partcv[0] = 0;
  Object call10521 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10520);
// compilenode returning call10521
// Begin line 3229
  setline(3229);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3227
  setline(3227);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10522 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10522
  *var_methods = array10522;
  if (array10522 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3264
  setline(3264);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3229
  setline(3229);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10524 = gc_frame_new();
  if (strlit10525 == NULL) {
    strlit10525 = alloc_String("lbrace");
    gc_root(strlit10525);
  }
// compilenode returning strlit10525
  gc_frame_newslot(strlit10525);
  params[0] = strlit10525;
  partcv[0] = 1;
  Object call10526 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10524);
// compilenode returning call10526
  Object if10523 = done;
  if (istrue(call10526)) {
// Begin line 3230
  setline(3230);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10527 = gc_frame_new();
  partcv[0] = 0;
  Object call10528 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10527);
// compilenode returning call10528
// Begin line 3231
  setline(3231);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10529 = gc_frame_new();
  Object block10530 = alloc_Block(NULL, NULL, "parser", 3231);
  gc_frame_newslot(block10530);
  block_savedest(block10530);
  Object closure10531 = createclosure(1, "_apply");
setclosureframe(closure10531, stackframe);
  addtoclosure(closure10531, selfslot);
  struct UserObject *uo10531 = (struct UserObject*)block10530;
  uo10531->data[0] = (Object)closure10531;
  Method *meth_meth_parser__apply10531 = addmethod2pos(block10530, "_apply", &meth_parser__apply10531, 0);
int argcv_meth_parser__apply10531[] = {0};
meth_meth_parser__apply10531->type = alloc_MethodType(1, argcv_meth_parser__apply10531);
  meth_meth_parser__apply10531->definitionModule = modulename;
  meth_meth_parser__apply10531->definitionLine = 3224;
// compilenode returning block10530
  gc_frame_newslot(block10530);
  Object block10538 = alloc_Block(NULL, NULL, "parser", 3231);
  gc_frame_newslot(block10538);
  block_savedest(block10538);
  Object closure10539 = createclosure(3, "_apply");
setclosureframe(closure10539, stackframe);
  addtoclosure(closure10539, var_values);
  addtoclosure(closure10539, var_methods);
  addtoclosure(closure10539, selfslot);
  struct UserObject *uo10539 = (struct UserObject*)block10538;
  uo10539->data[0] = (Object)closure10539;
  Method *meth_meth_parser__apply10539 = addmethod2pos(block10538, "_apply", &meth_parser__apply10539, 0);
int argcv_meth_parser__apply10539[] = {0};
meth_meth_parser__apply10539->type = alloc_MethodType(1, argcv_meth_parser__apply10539);
  meth_meth_parser__apply10539->definitionModule = modulename;
  meth_meth_parser__apply10539->definitionLine = 3231;
// compilenode returning block10538
  gc_frame_newslot(block10538);
  params[0] = block10530;
  params[1] = block10538;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10547 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10529);
// compilenode returning call10547
// Begin line 3235
  setline(3235);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10548 = gc_frame_new();
  partcv[0] = 0;
  Object call10549 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10548);
// compilenode returning call10549
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10550 = gc_frame_new();
  int callframe10551 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10552 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10551);
// compilenode returning call10552
// compilenode returning call10552
  gc_frame_newslot(call10552);
// compilenode returning *var_methods
  gc_frame_newslot(*var_methods);
  int callframe10553 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10554 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe10553);
// compilenode returning call10554
// compilenode returning call10554
  params[0] = call10552;
  params[1] = *var_methods;
  partcv[0] = 2;
  Object call10555 = callmethod(call10554, "new",
    1, partcv, params);
  gc_frame_end(callframe10550);
// compilenode returning call10555
  *var_t = call10555;
  if (call10555 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3236
  setline(3236);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10556 = gc_frame_new();
// Begin line 3237
  setline(3237);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_gens
  gc_frame_newslot(*var_gens);
// compilenode returning *var_t
  params[0] = *var_gens;
  partcv[0] = 1;
  Object call10557 = callmethod(*var_t, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10556);
// compilenode returning call10557
// compilenode returning done
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3238
  setline(3238);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_anns
  int op_slot_right_10559 = gc_frame_newslot(*var_anns);
  Object bool10561 = alloc_Boolean(0);
// compilenode returning bool10561
  int op_slot_left_10559 = gc_frame_newslot(bool10561);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult10562 = callmethod(bool10561, "!=", 1, partcv, params);
// compilenode returning opresult10562
  Object if10558 = done;
  if (istrue(opresult10562)) {
// Begin line 3239
  setline(3239);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10563 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe10564 = gc_frame_new();
// compilenode returning *var_t
  partcv[0] = 0;
  Object call10565 = callmethod(*var_t, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10564);
// compilenode returning call10565
// compilenode returning call10565
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10566 = callmethod(call10565, "extend",
    1, partcv, params);
  gc_frame_end(callframe10563);
// compilenode returning call10566
    gc_frame_newslot(call10566);
    if10558 = call10566;
  } else {
  }
// compilenode returning if10558
// Begin line 3241
  setline(3241);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10567 = gc_frame_new();
// compilenode returning *var_t
  gc_frame_newslot(*var_t);
// compilenode returning *var_values
  params[0] = *var_t;
  partcv[0] = 1;
  Object call10568 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10567);
// compilenode returning call10568
    gc_frame_newslot(call10568);
    if10523 = call10568;
  } else {
// Begin line 3243
  setline(3243);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10569 = gc_frame_new();
  partcv[0] = 0;
  Object call10570 = callmethodflags(self, "dotyperef", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10569);
// compilenode returning call10570
// Begin line 3245
  setline(3245);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3244
  setline(3244);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10571 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10572 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10571);
// compilenode returning call10572
// compilenode returning call10572
  *var_ot = call10572;
  if (call10572 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_nt = undefined;
// compilenode returning done
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3246
  setline(3246);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10575 == NULL) {
    strlit10575 = alloc_String("type");
    gc_root(strlit10575);
  }
// compilenode returning strlit10575
  int op_slot_right_10574 = gc_frame_newslot(strlit10575);
  int callframe10577 = gc_frame_new();
// compilenode returning *var_ot
  partcv[0] = 0;
  Object call10578 = callmethod(*var_ot, "kind",
    1, partcv, params);
  gc_frame_end(callframe10577);
// compilenode returning call10578
// compilenode returning call10578
  int op_slot_left_10574 = gc_frame_newslot(call10578);
  params[0] = strlit10575;
  partcv[0] = 1;
  Object opresult10579 = callmethod(call10578, "==", 1, partcv, params);
// compilenode returning opresult10579
  Object if10573 = done;
  if (istrue(opresult10579)) {
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10580 = gc_frame_new();
  int callframe10581 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10582 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10581);
// compilenode returning call10582
// compilenode returning call10582
  gc_frame_newslot(call10582);
  int callframe10583 = gc_frame_new();
// compilenode returning *var_ot
  partcv[0] = 0;
  Object call10584 = callmethod(*var_ot, "methods",
    1, partcv, params);
  gc_frame_end(callframe10583);
// compilenode returning call10584
// compilenode returning call10584
  gc_frame_newslot(call10584);
  int callframe10585 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10586 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe10585);
// compilenode returning call10586
// compilenode returning call10586
  params[0] = call10582;
  params[1] = call10584;
  partcv[0] = 2;
  Object call10587 = callmethod(call10586, "new",
    1, partcv, params);
  gc_frame_end(callframe10580);
// compilenode returning call10587
  *var_nt = call10587;
  if (call10587 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3247
  setline(3247);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10589 = gc_frame_new();
// Begin line 3248
  setline(3248);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10590 = gc_frame_new();
// compilenode returning *var_nt
  partcv[0] = 0;
  Object call10591 = callmethod(*var_nt, "generics",
    1, partcv, params);
  gc_frame_end(callframe10590);
// compilenode returning call10591
// compilenode returning call10591
  gc_frame_newslot(call10591);
// compilenode returning *var_nt
  params[0] = call10591;
  partcv[0] = 1;
  Object call10592 = callmethod(*var_nt, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10589);
// compilenode returning call10592
// compilenode returning done
// Begin line 3249
  setline(3249);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10593 = gc_frame_new();
  int callframe10594 = gc_frame_new();
// compilenode returning *var_ot
  partcv[0] = 0;
  Object call10595 = callmethod(*var_ot, "unionTypes",
    1, partcv, params);
  gc_frame_end(callframe10594);
// compilenode returning call10595
// compilenode returning call10595
  gc_frame_newslot(call10595);
  Object block10596 = alloc_Block(NULL, NULL, "parser", 3249);
  gc_frame_newslot(block10596);
  block_savedest(block10596);
  Object closure10597 = createclosure(2, "_apply");
setclosureframe(closure10597, stackframe);
  addtoclosure(closure10597, var_nt);
  addtoclosure(closure10597, selfslot);
  struct UserObject *uo10597 = (struct UserObject*)block10596;
  uo10597->data[0] = (Object)closure10597;
  Method *meth_meth_parser__apply10597 = addmethod2pos(block10596, "_apply", &meth_parser__apply10597, 0);
int argcv_meth_parser__apply10597[] = {1};
meth_meth_parser__apply10597->type = alloc_MethodType(1, argcv_meth_parser__apply10597);
  meth_meth_parser__apply10597->definitionModule = modulename;
  meth_meth_parser__apply10597->definitionLine = 3249;
// compilenode returning block10596
  gc_frame_newslot(block10596);
  params[0] = call10595;
  params[1] = block10596;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10603 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10593);
// compilenode returning call10603
// Begin line 3252
  setline(3252);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10604 = gc_frame_new();
  int callframe10605 = gc_frame_new();
// compilenode returning *var_ot
  partcv[0] = 0;
  Object call10606 = callmethod(*var_ot, "intersectionTypes",
    1, partcv, params);
  gc_frame_end(callframe10605);
// compilenode returning call10606
// compilenode returning call10606
  gc_frame_newslot(call10606);
  Object block10607 = alloc_Block(NULL, NULL, "parser", 3252);
  gc_frame_newslot(block10607);
  block_savedest(block10607);
  Object closure10608 = createclosure(2, "_apply");
setclosureframe(closure10608, stackframe);
  addtoclosure(closure10608, var_nt);
  addtoclosure(closure10608, selfslot);
  struct UserObject *uo10608 = (struct UserObject*)block10607;
  uo10608->data[0] = (Object)closure10608;
  Method *meth_meth_parser__apply10608 = addmethod2pos(block10607, "_apply", &meth_parser__apply10608, 0);
int argcv_meth_parser__apply10608[] = {1};
meth_meth_parser__apply10608->type = alloc_MethodType(1, argcv_meth_parser__apply10608);
  meth_meth_parser__apply10608->definitionModule = modulename;
  meth_meth_parser__apply10608->definitionLine = 3252;
// compilenode returning block10607
  gc_frame_newslot(block10607);
  params[0] = call10606;
  params[1] = block10607;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10614 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10604);
// compilenode returning call10614
// Begin line 3256
  setline(3256);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3253
  setline(3253);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10615 = gc_frame_new();
// Begin line 3255
  setline(3255);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_gens
  gc_frame_newslot(*var_gens);
// compilenode returning *var_nt
  params[0] = *var_gens;
  partcv[0] = 1;
  Object call10616 = callmethod(*var_nt, "generics:=",
    1, partcv, params);
  gc_frame_end(callframe10615);
// compilenode returning call10616
// compilenode returning done
    gc_frame_newslot(done);
    if10573 = done;
  } else {
// Begin line 3257
  setline(3257);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10617 = gc_frame_new();
  int callframe10618 = gc_frame_new();
// compilenode returning *var_p
  partcv[0] = 0;
  Object call10619 = callmethod(*var_p, "value",
    1, partcv, params);
  gc_frame_end(callframe10618);
// compilenode returning call10619
// compilenode returning call10619
  gc_frame_newslot(call10619);
  Object array10620 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10620
  gc_frame_newslot(array10620);
  int callframe10621 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10622 = callmethod(*var_ast, "typeNode",
    1, partcv, params);
  gc_frame_end(callframe10621);
// compilenode returning call10622
// compilenode returning call10622
  params[0] = call10619;
  params[1] = array10620;
  partcv[0] = 2;
  Object call10623 = callmethod(call10622, "new",
    1, partcv, params);
  gc_frame_end(callframe10617);
// compilenode returning call10623
  *var_nt = call10623;
  if (call10623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10573 = done;
  }
// compilenode returning if10573
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3259
  setline(3259);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_anns
  int op_slot_right_10626 = gc_frame_newslot(*var_anns);
  Object bool10628 = alloc_Boolean(0);
// compilenode returning bool10628
  int op_slot_left_10626 = gc_frame_newslot(bool10628);
  params[0] = *var_anns;
  partcv[0] = 1;
  Object opresult10629 = callmethod(bool10628, "!=", 1, partcv, params);
// compilenode returning opresult10629
  Object if10625 = done;
  if (istrue(opresult10629)) {
// Begin line 3260
  setline(3260);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10630 = gc_frame_new();
// compilenode returning *var_anns
  gc_frame_newslot(*var_anns);
  int callframe10631 = gc_frame_new();
// compilenode returning *var_nt
  partcv[0] = 0;
  Object call10632 = callmethod(*var_nt, "annotations",
    1, partcv, params);
  gc_frame_end(callframe10631);
// compilenode returning call10632
// compilenode returning call10632
  params[0] = *var_anns;
  partcv[0] = 1;
  Object call10633 = callmethod(call10632, "extend",
    1, partcv, params);
  gc_frame_end(callframe10630);
// compilenode returning call10633
    gc_frame_newslot(call10633);
    if10625 = call10633;
  } else {
  }
// compilenode returning if10625
// Begin line 3262
  setline(3262);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10634 = gc_frame_new();
// compilenode returning *var_nt
  gc_frame_newslot(*var_nt);
// compilenode returning *var_values
  params[0] = *var_nt;
  partcv[0] = 1;
  Object call10635 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe10634);
// compilenode returning call10635
    gc_frame_newslot(call10635);
    if10523 = call10635;
  }
// compilenode returning if10523
    gc_frame_newslot(if10523);
    if10385 = if10523;
  } else {
  }
// compilenode returning if10385
  gc_frame_end(frame);
  return if10385;
}
Object meth_parser__apply10715(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[3];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_suggestion = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3281
  setline(3281);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10716 = gc_frame_new();
  if (strlit10717 == NULL) {
    strlit10717 = alloc_String(" ");
    gc_root(strlit10717);
  }
// compilenode returning strlit10717
  gc_frame_newslot(strlit10717);
  Object num10718 = alloc_Float64(1);
// compilenode returning num10718
  gc_frame_newslot(num10718);
  int callframe10719 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10720 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10719);
// compilenode returning call10720
// compilenode returning call10720
  gc_frame_newslot(call10720);
// compilenode returning *var_suggestion
  params[0] = strlit10717;
  params[1] = num10718;
  params[2] = call10720;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10721 = callmethod(*var_suggestion, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe10716);
// compilenode returning call10721
  gc_frame_end(frame);
  return call10721;
}
Object meth_parser__apply10733(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var_minIndentLevel
  int op_slot_right_10735 = gc_frame_newslot(*var_minIndentLevel);
  int callframe10737 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call10738 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10737);
// compilenode returning call10738
// compilenode returning call10738
  int op_slot_left_10735 = gc_frame_newslot(call10738);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10739 = callmethod(call10738, ">=", 1, partcv, params);
// compilenode returning opresult10739
  int op_slot_right_10734 = gc_frame_newslot(opresult10739);
  Object num10743 = alloc_Float64(1);
// compilenode returning num10743
  int op_slot_right_10742 = gc_frame_newslot(num10743);
  int callframe10745 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call10746 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10745);
// compilenode returning call10746
// compilenode returning call10746
  int op_slot_left_10742 = gc_frame_newslot(call10746);
  params[0] = num10743;
  partcv[0] = 1;
  Object sum10747 = callmethod(call10746, "+", 1, partcv, params);
// compilenode returning sum10747
  int op_slot_right_10741 = gc_frame_newslot(sum10747);
  int callframe10749 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call10750 = callmethod(*var_tok, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10749);
// compilenode returning call10750
// compilenode returning call10750
  int op_slot_left_10741 = gc_frame_newslot(call10750);
  params[0] = sum10747;
  partcv[0] = 1;
  Object opresult10751 = callmethod(call10750, "!=", 1, partcv, params);
// compilenode returning opresult10751
  int op_slot_left_10734 = gc_frame_newslot(opresult10751);
  params[0] = opresult10739;
  partcv[0] = 1;
  Object opresult10752 = callmethod(opresult10751, "||", 1, partcv, params);
// compilenode returning opresult10752
  gc_frame_end(frame);
  return opresult10752;
}
Object meth_parser__apply10755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tok = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10756 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call10757 = callmethod(*var_tok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10756);
// compilenode returning call10757
// compilenode returning call10757
  *var_tok = call10757;
  if (call10757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser__apply10770(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3291
  setline(3291);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3290
  setline(3290);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10772 == NULL) {
    strlit10772 = alloc_String(" ");
    gc_root(strlit10772);
  }
// compilenode returning strlit10772
  int op_slot_right_10771 = gc_frame_newslot(strlit10772);
// compilenode returning *var_line
  int op_slot_left_10771 = gc_frame_newslot(*var_line);
  params[0] = strlit10772;
  partcv[0] = 1;
  Object opresult10774 = callmethod(*var_line, "++", 1, partcv, params);
// compilenode returning opresult10774
  *var_line = opresult10774;
  if (opresult10774 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_checkIndent10636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 54, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[4];
  int partcv[3];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_minIndentLevel = getfromclosure(closure, 2);
  Object *var_errormessages = getfromclosure(closure, 3);
  Object *var_lastToken = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkIndent (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for checkIndent");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestions = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestions");
  Object *var_suggestion = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestion");
  Object *var_tok = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "tok");
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// Begin line 3301
  setline(3301);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3268
  setline(3268);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_indentFreePass
  Object if10637 = done;
  if (istrue(*var_indentFreePass)) {
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3269
  setline(3269);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool10638 = alloc_Boolean(0);
// compilenode returning bool10638
  *var_indentFreePass = bool10638;
  if (bool10638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10637 = done;
  } else {
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3270
  setline(3270);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10642 == NULL) {
    strlit10642 = alloc_String("semicolon");
    gc_root(strlit10642);
  }
// compilenode returning strlit10642
  int op_slot_right_10641 = gc_frame_newslot(strlit10642);
  int callframe10644 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10645 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10644);
// compilenode returning call10645
// compilenode returning call10645
  int op_slot_left_10641 = gc_frame_newslot(call10645);
  params[0] = strlit10642;
  partcv[0] = 1;
  Object opresult10646 = callmethod(call10645, "==", 1, partcv, params);
// compilenode returning opresult10646
  Object if10640 = done;
  if (istrue(opresult10646)) {
    gc_frame_newslot(done);
    if10640 = done;
  } else {
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3273
  setline(3273);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10650 == NULL) {
    strlit10650 = alloc_String("rsquare");
    gc_root(strlit10650);
  }
// compilenode returning strlit10650
  int op_slot_right_10649 = gc_frame_newslot(strlit10650);
  int callframe10652 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10653 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10652);
// compilenode returning call10653
// compilenode returning call10653
  int op_slot_left_10649 = gc_frame_newslot(call10653);
  params[0] = strlit10650;
  partcv[0] = 1;
  Object opresult10654 = callmethod(call10653, "==", 1, partcv, params);
// compilenode returning opresult10654
  int op_slot_right_10648 = gc_frame_newslot(opresult10654);
// Begin line 3272
  setline(3272);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10658 == NULL) {
    strlit10658 = alloc_String("rparen");
    gc_root(strlit10658);
  }
// compilenode returning strlit10658
  int op_slot_right_10657 = gc_frame_newslot(strlit10658);
  int callframe10660 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10661 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10660);
// compilenode returning call10661
// compilenode returning call10661
  int op_slot_left_10657 = gc_frame_newslot(call10661);
  params[0] = strlit10658;
  partcv[0] = 1;
  Object opresult10662 = callmethod(call10661, "==", 1, partcv, params);
// compilenode returning opresult10662
  int op_slot_right_10656 = gc_frame_newslot(opresult10662);
  if (strlit10665 == NULL) {
    strlit10665 = alloc_String("rbrace");
    gc_root(strlit10665);
  }
// compilenode returning strlit10665
  int op_slot_right_10664 = gc_frame_newslot(strlit10665);
  int callframe10667 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10668 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10667);
// compilenode returning call10668
// compilenode returning call10668
  int op_slot_left_10664 = gc_frame_newslot(call10668);
  params[0] = strlit10665;
  partcv[0] = 1;
  Object opresult10669 = callmethod(call10668, "==", 1, partcv, params);
// compilenode returning opresult10669
  int op_slot_left_10656 = gc_frame_newslot(opresult10669);
  params[0] = opresult10662;
  partcv[0] = 1;
  Object opresult10670 = callmethod(opresult10669, "||", 1, partcv, params);
// compilenode returning opresult10670
  int op_slot_left_10648 = gc_frame_newslot(opresult10670);
  params[0] = opresult10654;
  partcv[0] = 1;
  Object opresult10671 = callmethod(opresult10670, "||", 1, partcv, params);
// compilenode returning opresult10671
  Object if10647 = done;
  if (istrue(opresult10671)) {
    gc_frame_newslot(done);
    if10647 = done;
  } else {
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3275
  setline(3275);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10674 == NULL) {
    strlit10674 = alloc_String("eof");
    gc_root(strlit10674);
  }
// compilenode returning strlit10674
  int op_slot_right_10673 = gc_frame_newslot(strlit10674);
  int callframe10676 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10677 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe10676);
// compilenode returning call10677
// compilenode returning call10677
  int op_slot_left_10673 = gc_frame_newslot(call10677);
  params[0] = strlit10674;
  partcv[0] = 1;
  Object opresult10678 = callmethod(call10677, "==", 1, partcv, params);
// compilenode returning opresult10678
  Object if10672 = done;
  if (istrue(opresult10678)) {
    gc_frame_newslot(done);
    if10672 = done;
  } else {
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3276
  setline(3276);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  int op_slot_right_10680 = gc_frame_newslot(*var_minIndentLevel);
  int callframe10682 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10683 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10682);
// compilenode returning call10683
// compilenode returning call10683
  int op_slot_left_10680 = gc_frame_newslot(call10683);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10684 = callmethod(call10683, "<", 1, partcv, params);
// compilenode returning opresult10684
  Object if10679 = done;
  if (istrue(opresult10684)) {
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3277
  setline(3277);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  int op_slot_right_10686 = gc_frame_newslot(*var_minIndentLevel);
  Object num10689 = alloc_Float64(1);
// compilenode returning num10689
  int op_slot_right_10688 = gc_frame_newslot(num10689);
  int callframe10691 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10692 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10691);
// compilenode returning call10692
// compilenode returning call10692
  int op_slot_left_10688 = gc_frame_newslot(call10692);
  params[0] = num10689;
  partcv[0] = 1;
  Object diff10693 = callmethod(call10692, "-", 1, partcv, params);
// compilenode returning diff10693
  int op_slot_left_10686 = gc_frame_newslot(diff10693);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10694 = callmethod(diff10693, "!=", 1, partcv, params);
// compilenode returning opresult10694
  Object if10685 = done;
  if (istrue(opresult10694)) {
// Begin line 3279
  setline(3279);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3278
  setline(3278);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10695 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10695
  *var_suggestions = array10695;
  if (array10695 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3279
  setline(3279);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10696 = gc_frame_new();
  int callframe10697 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10698 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10697);
// compilenode returning call10698
// compilenode returning call10698
  partcv[0] = 0;
  Object call10699 = callmethod(call10698, "new",
    1, partcv, params);
  gc_frame_end(callframe10696);
// compilenode returning call10699
// compilenode returning call10699
  *var_suggestion = call10699;
  if (call10699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3280
  setline(3280);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10700 = gc_frame_new();
  Object num10704 = alloc_Float64(1);
// compilenode returning num10704
  int op_slot_right_10703 = gc_frame_newslot(num10704);
  int callframe10706 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10707 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10706);
// compilenode returning call10707
// compilenode returning call10707
  int op_slot_left_10703 = gc_frame_newslot(call10707);
  params[0] = num10704;
  partcv[0] = 1;
  Object diff10708 = callmethod(call10707, "-", 1, partcv, params);
// compilenode returning diff10708
  int op_slot_right_10702 = gc_frame_newslot(diff10708);
// compilenode returning *var_minIndentLevel
  int op_slot_left_10702 = gc_frame_newslot(*var_minIndentLevel);
  params[0] = diff10708;
  partcv[0] = 1;
  Object diff10710 = callmethod(*var_minIndentLevel, "-", 1, partcv, params);
// compilenode returning diff10710
  int op_slot_right_10701 = gc_frame_newslot(diff10710);
  Object num10712 = alloc_Float64(1);
// compilenode returning num10712
  int op_slot_left_10701 = gc_frame_newslot(num10712);
  params[0] = diff10710;
  partcv[0] = 1;
  Object opresult10713 = callmethod(num10712, "..", 1, partcv, params);
// compilenode returning opresult10713
  gc_frame_newslot(opresult10713);
  Object block10714 = alloc_Block(NULL, NULL, "parser", 3280);
  gc_frame_newslot(block10714);
  block_savedest(block10714);
  Object closure10715 = createclosure(3, "_apply");
setclosureframe(closure10715, stackframe);
  addtoclosure(closure10715, var_sym);
  addtoclosure(closure10715, var_suggestion);
  addtoclosure(closure10715, selfslot);
  struct UserObject *uo10715 = (struct UserObject*)block10714;
  uo10715->data[0] = (Object)closure10715;
  Method *meth_meth_parser__apply10715 = addmethod2pos(block10714, "_apply", &meth_parser__apply10715, 0);
int argcv_meth_parser__apply10715[] = {1};
meth_meth_parser__apply10715->type = alloc_MethodType(1, argcv_meth_parser__apply10715);
  meth_meth_parser__apply10715->definitionModule = modulename;
  meth_meth_parser__apply10715->definitionLine = 3280;
// compilenode returning block10714
  gc_frame_newslot(block10714);
  params[0] = opresult10713;
  params[1] = block10714;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10723 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10700);
// compilenode returning call10723
// Begin line 3283
  setline(3283);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10724 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10725 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10724);
// compilenode returning call10725
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3284
  setline(3284);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10726 = gc_frame_new();
  int callframe10727 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10728 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10727);
// compilenode returning call10728
// compilenode returning call10728
  partcv[0] = 0;
  Object call10729 = callmethod(call10728, "new",
    1, partcv, params);
  gc_frame_end(callframe10726);
// compilenode returning call10729
// compilenode returning call10729
  *var_suggestion = call10729;
  if (call10729 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3286
  setline(3286);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  *var_tok = *var_lastToken;
  if (*var_lastToken == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3287
  setline(3287);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10731 = gc_frame_new();
  Object block10732 = alloc_Block(NULL, NULL, "parser", 3287);
  gc_frame_newslot(block10732);
  block_savedest(block10732);
  Object closure10733 = createclosure(3, "_apply");
setclosureframe(closure10733, stackframe);
  addtoclosure(closure10733, var_minIndentLevel);
  addtoclosure(closure10733, var_tok);
  addtoclosure(closure10733, selfslot);
  struct UserObject *uo10733 = (struct UserObject*)block10732;
  uo10733->data[0] = (Object)closure10733;
  Method *meth_meth_parser__apply10733 = addmethod2pos(block10732, "_apply", &meth_parser__apply10733, 0);
int argcv_meth_parser__apply10733[] = {0};
meth_meth_parser__apply10733->type = alloc_MethodType(1, argcv_meth_parser__apply10733);
  meth_meth_parser__apply10733->definitionModule = modulename;
  meth_meth_parser__apply10733->definitionLine = 3284;
// compilenode returning block10732
  gc_frame_newslot(block10732);
  Object block10754 = alloc_Block(NULL, NULL, "parser", 3287);
  gc_frame_newslot(block10754);
  block_savedest(block10754);
  Object closure10755 = createclosure(2, "_apply");
setclosureframe(closure10755, stackframe);
  addtoclosure(closure10755, var_tok);
  addtoclosure(closure10755, selfslot);
  struct UserObject *uo10755 = (struct UserObject*)block10754;
  uo10755->data[0] = (Object)closure10755;
  Method *meth_meth_parser__apply10755 = addmethod2pos(block10754, "_apply", &meth_parser__apply10755, 0);
int argcv_meth_parser__apply10755[] = {0};
meth_meth_parser__apply10755->type = alloc_MethodType(1, argcv_meth_parser__apply10755);
  meth_meth_parser__apply10755->definitionModule = modulename;
  meth_meth_parser__apply10755->definitionLine = 3287;
// compilenode returning block10754
  gc_frame_newslot(block10754);
  params[0] = block10732;
  params[1] = block10754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10760 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10731);
// compilenode returning call10760
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3288
  setline(3288);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10761 == NULL) {
    strlit10761 = alloc_String("");
    gc_root(strlit10761);
  }
// compilenode returning strlit10761
  *var_line = strlit10761;
  if (strlit10761 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3289
  setline(3289);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10762 = gc_frame_new();
  int callframe10764 = gc_frame_new();
// compilenode returning *var_tok
  partcv[0] = 0;
  Object call10765 = callmethod(*var_tok, "indent",
    1, partcv, params);
  gc_frame_end(callframe10764);
// compilenode returning call10765
// compilenode returning call10765
  int op_slot_right_10763 = gc_frame_newslot(call10765);
  Object num10767 = alloc_Float64(1);
// compilenode returning num10767
  int op_slot_left_10763 = gc_frame_newslot(num10767);
  params[0] = call10765;
  partcv[0] = 1;
  Object opresult10768 = callmethod(num10767, "..", 1, partcv, params);
// compilenode returning opresult10768
  gc_frame_newslot(opresult10768);
  Object block10769 = alloc_Block(NULL, NULL, "parser", 3289);
  gc_frame_newslot(block10769);
  block_savedest(block10769);
  Object closure10770 = createclosure(2, "_apply");
setclosureframe(closure10770, stackframe);
  addtoclosure(closure10770, var_line);
  addtoclosure(closure10770, selfslot);
  struct UserObject *uo10770 = (struct UserObject*)block10769;
  uo10770->data[0] = (Object)closure10770;
  Method *meth_meth_parser__apply10770 = addmethod2pos(block10769, "_apply", &meth_parser__apply10770, 0);
int argcv_meth_parser__apply10770[] = {1};
meth_meth_parser__apply10770->type = alloc_MethodType(1, argcv_meth_parser__apply10770);
  meth_meth_parser__apply10770->definitionModule = modulename;
  meth_meth_parser__apply10770->definitionLine = 3289;
// compilenode returning block10769
  gc_frame_newslot(block10769);
  params[0] = opresult10768;
  params[1] = block10769;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10777 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10762);
// compilenode returning call10777
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3292
  setline(3292);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10779 == NULL) {
    strlit10779 = alloc_String("}");
    gc_root(strlit10779);
  }
// compilenode returning strlit10779
  int op_slot_right_10778 = gc_frame_newslot(strlit10779);
// compilenode returning *var_line
  int op_slot_left_10778 = gc_frame_newslot(*var_line);
  params[0] = strlit10779;
  partcv[0] = 1;
  Object opresult10781 = callmethod(*var_line, "++", 1, partcv, params);
// compilenode returning opresult10781
  *var_line = opresult10781;
  if (opresult10781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3293
  setline(3293);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10783 = gc_frame_new();
  Object num10785 = alloc_Float64(0.9);
// compilenode returning num10785
  int op_slot_right_10784 = gc_frame_newslot(num10785);
  int callframe10787 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10788 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10787);
// compilenode returning call10788
// compilenode returning call10788
  int op_slot_left_10784 = gc_frame_newslot(call10788);
  params[0] = num10785;
  partcv[0] = 1;
  Object diff10789 = callmethod(call10788, "-", 1, partcv, params);
// compilenode returning diff10789
  gc_frame_newslot(diff10789);
// compilenode returning *var_line
  gc_frame_newslot(*var_line);
// compilenode returning *var_suggestion
  params[0] = diff10789;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call10790 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe10783);
// compilenode returning call10790
// Begin line 3294
  setline(3294);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10791 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10792 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10791);
// compilenode returning call10792
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10793 = gc_frame_new();
  if (strlit10795 == NULL) {
    strlit10795 = alloc_String(". This is often caused by a missing '}'.");
    gc_root(strlit10795);
  }
// compilenode returning strlit10795
  int op_slot_right_10794 = gc_frame_newslot(strlit10795);
// compilenode returning *var_minIndentLevel
  int op_slot_right_10797 = gc_frame_newslot(*var_minIndentLevel);
  if (strlit10799 == NULL) {
    strlit10799 = alloc_String("The indentation for this line must be at least ");
    gc_root(strlit10799);
  }
// compilenode returning strlit10799
  int op_slot_left_10797 = gc_frame_newslot(strlit10799);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10800 = callmethod(strlit10799, "++", 1, partcv, params);
// compilenode returning opresult10800
  int op_slot_left_10794 = gc_frame_newslot(opresult10800);
  params[0] = strlit10795;
  partcv[0] = 1;
  Object opresult10801 = callmethod(opresult10800, "++", 1, partcv, params);
// compilenode returning opresult10801
  gc_frame_newslot(opresult10801);
// Begin line 3296
  setline(3296);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10802 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10803 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10802);
// compilenode returning call10803
// compilenode returning call10803
  gc_frame_newslot(call10803);
  int callframe10804 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10805 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10804);
// compilenode returning call10805
// compilenode returning call10805
  gc_frame_newslot(call10805);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 3295
  setline(3295);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = opresult10801;
  params[1] = call10803;
  params[2] = call10805;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10806 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10793);
// compilenode returning call10806
    gc_frame_newslot(call10806);
    if10685 = call10806;
  } else {
  }
// compilenode returning if10685
    gc_frame_newslot(if10685);
    if10679 = if10685;
  } else {
// Begin line 3301
  setline(3301);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3298
  setline(3298);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  int op_slot_right_10808 = gc_frame_newslot(*var_minIndentLevel);
  int callframe10810 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10811 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10810);
// compilenode returning call10811
// compilenode returning call10811
  int op_slot_left_10808 = gc_frame_newslot(call10811);
  params[0] = *var_minIndentLevel;
  partcv[0] = 1;
  Object opresult10812 = callmethod(call10811, ">", 1, partcv, params);
// compilenode returning opresult10812
  Object if10807 = done;
  if (istrue(opresult10812)) {
// Begin line 3300
  setline(3300);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3299
  setline(3299);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10813 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10814 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10813);
// compilenode returning call10814
// compilenode returning call10814
  *var_minIndentLevel = call10814;
  if (call10814 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if10807 = done;
  } else {
  }
// compilenode returning if10807
    gc_frame_newslot(if10807);
    if10679 = if10807;
  }
// compilenode returning if10679
    gc_frame_newslot(if10679);
    if10672 = if10679;
  }
// compilenode returning if10672
    gc_frame_newslot(if10672);
    if10647 = if10672;
  }
// compilenode returning if10647
    gc_frame_newslot(if10647);
    if10640 = if10647;
  }
// compilenode returning if10640
    gc_frame_newslot(if10640);
    if10637 = if10640;
  }
// compilenode returning if10637
  gc_frame_end(frame);
  return if10637;
}
Object meth_parser__apply10894(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10895 = gc_frame_new();
  partcv[0] = 0;
  Object call10896 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10895);
// compilenode returning call10896
  gc_frame_end(frame);
  return call10896;
}
Object meth_parser__apply10945(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  int callframe10946 = gc_frame_new();
  partcv[0] = 0;
  Object call10947 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10946);
// compilenode returning call10947
  gc_frame_end(frame);
  return call10947;
}
Object meth_parser__apply10899(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_values = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  Object *var_sym = getfromclosure(closure, 2);
  Object *var_lastToken = getfromclosure(closure, 3);
  Object *var_ast = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_dest = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "dest");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_suggestion = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "suggestion");
  Object *var_nextTok = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "nextTok");
  Object *var_val = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "val");
  Object *var_o = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "o");
// Begin line 3358
  setline(3358);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3335
  setline(3335);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10902 = gc_frame_new();
  if (strlit10903 == NULL) {
    strlit10903 = alloc_String("bind");
    gc_root(strlit10903);
  }
// compilenode returning strlit10903
  gc_frame_newslot(strlit10903);
  params[0] = strlit10903;
  partcv[0] = 1;
  Object call10904 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10902);
// compilenode returning call10904
  int op_slot_right_10901 = gc_frame_newslot(call10904);
// Begin line 3334
  setline(3334);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10908 == NULL) {
    strlit10908 = alloc_String("index");
    gc_root(strlit10908);
  }
// compilenode returning strlit10908
  int op_slot_right_10907 = gc_frame_newslot(strlit10908);
  int callframe10910 = gc_frame_new();
  int callframe10911 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10912 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10911);
// compilenode returning call10912
// compilenode returning call10912
  partcv[0] = 0;
  Object call10913 = callmethod(call10912, "kind",
    1, partcv, params);
  gc_frame_end(callframe10910);
// compilenode returning call10913
// compilenode returning call10913
  int op_slot_left_10907 = gc_frame_newslot(call10913);
  params[0] = strlit10908;
  partcv[0] = 1;
  Object opresult10914 = callmethod(call10913, "==", 1, partcv, params);
// compilenode returning opresult10914
  int op_slot_right_10906 = gc_frame_newslot(opresult10914);
// Begin line 3333
  setline(3333);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10918 == NULL) {
    strlit10918 = alloc_String("member");
    gc_root(strlit10918);
  }
// compilenode returning strlit10918
  int op_slot_right_10917 = gc_frame_newslot(strlit10918);
  int callframe10920 = gc_frame_new();
  int callframe10921 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10922 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10921);
// compilenode returning call10922
// compilenode returning call10922
  partcv[0] = 0;
  Object call10923 = callmethod(call10922, "kind",
    1, partcv, params);
  gc_frame_end(callframe10920);
// compilenode returning call10923
// compilenode returning call10923
  int op_slot_left_10917 = gc_frame_newslot(call10923);
  params[0] = strlit10918;
  partcv[0] = 1;
  Object opresult10924 = callmethod(call10923, "==", 1, partcv, params);
// compilenode returning opresult10924
  int op_slot_right_10916 = gc_frame_newslot(opresult10924);
// Begin line 3332
  setline(3332);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10927 == NULL) {
    strlit10927 = alloc_String("identifier");
    gc_root(strlit10927);
  }
// compilenode returning strlit10927
  int op_slot_right_10926 = gc_frame_newslot(strlit10927);
  int callframe10929 = gc_frame_new();
  int callframe10930 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10931 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe10930);
// compilenode returning call10931
// compilenode returning call10931
  partcv[0] = 0;
  Object call10932 = callmethod(call10931, "kind",
    1, partcv, params);
  gc_frame_end(callframe10929);
// compilenode returning call10932
// compilenode returning call10932
  int op_slot_left_10926 = gc_frame_newslot(call10932);
  params[0] = strlit10927;
  partcv[0] = 1;
  Object opresult10933 = callmethod(call10932, "==", 1, partcv, params);
// compilenode returning opresult10933
  int op_slot_left_10916 = gc_frame_newslot(opresult10933);
  params[0] = opresult10924;
  partcv[0] = 1;
  Object opresult10934 = callmethod(opresult10933, "||", 1, partcv, params);
// compilenode returning opresult10934
  int op_slot_left_10906 = gc_frame_newslot(opresult10934);
  params[0] = opresult10914;
  partcv[0] = 1;
  Object opresult10935 = callmethod(opresult10934, "||", 1, partcv, params);
// compilenode returning opresult10935
  int op_slot_left_10901 = gc_frame_newslot(opresult10935);
  params[0] = call10904;
  partcv[0] = 1;
  Object opresult10936 = callmethod(opresult10935, "&&", 1, partcv, params);
// compilenode returning opresult10936
  Object if10900 = done;
  if (istrue(opresult10936)) {
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3336
  setline(3336);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10937 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10938 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10937);
// compilenode returning call10938
// compilenode returning call10938
  *var_dest = call10938;
  if (call10938 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3337
  setline(3337);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10939 = gc_frame_new();
  partcv[0] = 0;
  Object call10940 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10939);
// compilenode returning call10940
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3338
  setline(3338);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10942 = gc_frame_new();
  int callframe10943 = gc_frame_new();
  Object block10944 = alloc_Block(NULL, NULL, "parser", 3338);
  gc_frame_newslot(block10944);
  block_savedest(block10944);
  Object closure10945 = createclosure(1, "_apply");
setclosureframe(closure10945, stackframe);
  addtoclosure(closure10945, selfslot);
  struct UserObject *uo10945 = (struct UserObject*)block10944;
  uo10945->data[0] = (Object)closure10945;
  Method *meth_meth_parser__apply10945 = addmethod2pos(block10944, "_apply", &meth_parser__apply10945, 0);
int argcv_meth_parser__apply10945[] = {0};
meth_meth_parser__apply10945->type = alloc_MethodType(1, argcv_meth_parser__apply10945);
  meth_meth_parser__apply10945->definitionModule = modulename;
  meth_meth_parser__apply10945->definitionLine = 3338;
// compilenode returning block10944
  gc_frame_newslot(block10944);
  params[0] = block10944;
  partcv[0] = 1;
  Object call10949 = callmethodflags(self, "didConsume", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10943);
// compilenode returning call10949
  partcv[0] = 0;
  Object call10950 = callmethod(call10949, "not",
    1, partcv, params);
  gc_frame_end(callframe10942);
// compilenode returning call10950
// compilenode returning call10950
  Object if10941 = done;
  if (istrue(call10950)) {
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3339
  setline(3339);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array10951 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array10951
  *var_suggestions = array10951;
  if (array10951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3341
  setline(3341);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3340
  setline(3340);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10952 = gc_frame_new();
  int callframe10953 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10954 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10953);
// compilenode returning call10954
// compilenode returning call10954
  partcv[0] = 0;
  Object call10955 = callmethod(call10954, "new",
    1, partcv, params);
  gc_frame_end(callframe10952);
// compilenode returning call10955
// compilenode returning call10955
  *var_suggestion = call10955;
  if (call10955 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3341
  setline(3341);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10956 = gc_frame_new();
  if (strlit10957 == NULL) {
    strlit10957 = alloc_String("rbrace");
    gc_root(strlit10957);
  }
// compilenode returning strlit10957
  gc_frame_newslot(strlit10957);
  params[0] = strlit10957;
  partcv[0] = 1;
  Object call10958 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10956);
// compilenode returning call10958
  *var_nextTok = call10958;
  if (call10958 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3342
  setline(3342);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_10960 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_10960 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult10962 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult10962
  Object if10959 = done;
  if (istrue(opresult10962)) {
// Begin line 3343
  setline(3343);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10963 = gc_frame_new();
  if (strlit10964 == NULL) {
    strlit10964 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10964);
  }
// compilenode returning strlit10964
  gc_frame_newslot(strlit10964);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_suggestion
  params[0] = strlit10964;
  params[1] = *var_lastToken;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call10965 = callmethod(*var_suggestion, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe10963);
// compilenode returning call10965
    gc_frame_newslot(call10965);
    if10959 = call10965;
  } else {
// Begin line 3345
  setline(3345);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10966 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe10967 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call10968 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10967);
// compilenode returning call10968
// compilenode returning call10968
  gc_frame_newslot(call10968);
  Object bool10969 = alloc_Boolean(1);
// compilenode returning bool10969
  gc_frame_newslot(bool10969);
  Object bool10970 = alloc_Boolean(0);
// compilenode returning bool10970
  gc_frame_newslot(bool10970);
  if (strlit10971 == NULL) {
    strlit10971 = alloc_String(" ""\xc2""""\xab""expression""\xc2""""\xbb""");
    gc_root(strlit10971);
  }
// compilenode returning strlit10971
  gc_frame_newslot(strlit10971);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call10968;
  params[2] = bool10969;
  params[3] = bool10970;
  params[4] = strlit10971;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call10972 = callmethod(*var_suggestion, "replaceTokenRange()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe10966);
// compilenode returning call10972
    gc_frame_newslot(call10972);
    if10959 = call10972;
  }
// compilenode returning if10959
// Begin line 3347
  setline(3347);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10973 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10974 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10973);
// compilenode returning call10974
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3348
  setline(3348);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10975 = gc_frame_new();
  int callframe10976 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call10977 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe10976);
// compilenode returning call10977
// compilenode returning call10977
  partcv[0] = 0;
  Object call10978 = callmethod(call10977, "new",
    1, partcv, params);
  gc_frame_end(callframe10975);
// compilenode returning call10978
// compilenode returning call10978
  *var_suggestion = call10978;
  if (call10978 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3349
  setline(3349);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10980 = gc_frame_new();
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
  int callframe10981 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call10982 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe10981);
// compilenode returning call10982
// compilenode returning call10982
  gc_frame_newslot(call10982);
  Object bool10983 = alloc_Boolean(1);
// compilenode returning bool10983
  gc_frame_newslot(bool10983);
  Object bool10984 = alloc_Boolean(0);
// compilenode returning bool10984
  gc_frame_newslot(bool10984);
// compilenode returning *var_suggestion
  params[0] = *var_lastToken;
  params[1] = call10982;
  params[2] = bool10983;
  params[3] = bool10984;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call10985 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe10980);
// compilenode returning call10985
// Begin line 3350
  setline(3350);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10986 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call10987 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe10986);
// compilenode returning call10987
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10988 = gc_frame_new();
  if (strlit10989 == NULL) {
    strlit10989 = alloc_String("A valid expression must follow ':='.");
    gc_root(strlit10989);
  }
// compilenode returning strlit10989
  gc_frame_newslot(strlit10989);
// Begin line 3352
  setline(3352);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10990 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10991 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe10990);
// compilenode returning call10991
// compilenode returning call10991
  gc_frame_newslot(call10991);
  int callframe10992 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10993 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe10992);
// compilenode returning call10993
// compilenode returning call10993
  gc_frame_newslot(call10993);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 3351
  setline(3351);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit10989;
  params[1] = call10991;
  params[2] = call10993;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call10994 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe10988);
// compilenode returning call10994
    gc_frame_newslot(call10994);
    if10941 = call10994;
  } else {
  }
// compilenode returning if10941
// Begin line 3355
  setline(3355);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3354
  setline(3354);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10995 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call10996 = callmethod(*var_values, "pop",
    1, partcv, params);
  gc_frame_end(callframe10995);
// compilenode returning call10996
// compilenode returning call10996
  *var_val = call10996;
  if (call10996 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3355
  setline(3355);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10997 = gc_frame_new();
// compilenode returning *var_dest
  gc_frame_newslot(*var_dest);
// compilenode returning *var_val
  gc_frame_newslot(*var_val);
  int callframe10998 = gc_frame_new();
// compilenode returning *var_ast
  partcv[0] = 0;
  Object call10999 = callmethod(*var_ast, "bindNode",
    1, partcv, params);
  gc_frame_end(callframe10998);
// compilenode returning call10999
// compilenode returning call10999
  params[0] = *var_dest;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call11000 = callmethod(call10999, "new",
    1, partcv, params);
  gc_frame_end(callframe10997);
// compilenode returning call11000
  *var_o = call11000;
  if (call11000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3356
  setline(3356);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11001 = gc_frame_new();
// compilenode returning *var_o
  gc_frame_newslot(*var_o);
// compilenode returning *var_values
  params[0] = *var_o;
  partcv[0] = 1;
  Object call11002 = callmethod(*var_values, "push",
    1, partcv, params);
  gc_frame_end(callframe11001);
// compilenode returning call11002
    gc_frame_newslot(call11002);
    if10900 = call11002;
  } else {
  }
// compilenode returning if10900
  gc_frame_end(frame);
  return if10900;
}
Object meth_parser_statement10816(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 55, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_statementIndent = getfromclosure(closure, 1);
  Object *var_statementToken = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_errormessages = getfromclosure(closure, 4);
  Object *var_lastToken = getfromclosure(closure, 5);
  Object *var_ast = getfromclosure(closure, 6);
  Object *var_indentFreePass = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statement (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for statement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_oldLine = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "oldLine");
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3309
  setline(3309);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10817 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10818 = callmethod(*var_sym, "indent",
    1, partcv, params);
  gc_frame_end(callframe10817);
// compilenode returning call10818
// compilenode returning call10818
  *var_statementIndent = call10818;
  if (call10818 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3311
  setline(3311);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3310
  setline(3310);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  *var_statementToken = *var_sym;
  if (*var_sym == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3311
  setline(3311);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10821 = gc_frame_new();
  partcv[0] = 0;
  Object call10822 = callmethodflags(self, "checkIndent", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10821);
// compilenode returning call10822
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3312
  setline(3312);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10824 = gc_frame_new();
  if (strlit10825 == NULL) {
    strlit10825 = alloc_String("keyword");
    gc_root(strlit10825);
  }
// compilenode returning strlit10825
  gc_frame_newslot(strlit10825);
  params[0] = strlit10825;
  partcv[0] = 1;
  Object call10826 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10824);
// compilenode returning call10826
  Object if10823 = done;
  if (istrue(call10826)) {
// Begin line 3330
  setline(3330);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3313
  setline(3313);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10829 == NULL) {
    strlit10829 = alloc_String("var");
    gc_root(strlit10829);
  }
// compilenode returning strlit10829
  int op_slot_right_10828 = gc_frame_newslot(strlit10829);
  int callframe10831 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10832 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10831);
// compilenode returning call10832
// compilenode returning call10832
  int op_slot_left_10828 = gc_frame_newslot(call10832);
  params[0] = strlit10829;
  partcv[0] = 1;
  Object opresult10833 = callmethod(call10832, "==", 1, partcv, params);
// compilenode returning opresult10833
  Object if10827 = done;
  if (istrue(opresult10833)) {
// Begin line 3314
  setline(3314);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10834 = gc_frame_new();
  partcv[0] = 0;
  Object call10835 = callmethodflags(self, "vardec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10834);
// compilenode returning call10835
    gc_frame_newslot(call10835);
    if10827 = call10835;
  } else {
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3315
  setline(3315);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10838 == NULL) {
    strlit10838 = alloc_String("def");
    gc_root(strlit10838);
  }
// compilenode returning strlit10838
  int op_slot_right_10837 = gc_frame_newslot(strlit10838);
  int callframe10840 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10841 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10840);
// compilenode returning call10841
// compilenode returning call10841
  int op_slot_left_10837 = gc_frame_newslot(call10841);
  params[0] = strlit10838;
  partcv[0] = 1;
  Object opresult10842 = callmethod(call10841, "==", 1, partcv, params);
// compilenode returning opresult10842
  Object if10836 = done;
  if (istrue(opresult10842)) {
// Begin line 3316
  setline(3316);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10843 = gc_frame_new();
  partcv[0] = 0;
  Object call10844 = callmethodflags(self, "defdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10843);
// compilenode returning call10844
    gc_frame_newslot(call10844);
    if10836 = call10844;
  } else {
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3317
  setline(3317);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10847 == NULL) {
    strlit10847 = alloc_String("import");
    gc_root(strlit10847);
  }
// compilenode returning strlit10847
  int op_slot_right_10846 = gc_frame_newslot(strlit10847);
  int callframe10849 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10850 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10849);
// compilenode returning call10850
// compilenode returning call10850
  int op_slot_left_10846 = gc_frame_newslot(call10850);
  params[0] = strlit10847;
  partcv[0] = 1;
  Object opresult10851 = callmethod(call10850, "==", 1, partcv, params);
// compilenode returning opresult10851
  Object if10845 = done;
  if (istrue(opresult10851)) {
// Begin line 3318
  setline(3318);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10852 = gc_frame_new();
  partcv[0] = 0;
  Object call10853 = callmethodflags(self, "doimport", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10852);
// compilenode returning call10853
    gc_frame_newslot(call10853);
    if10845 = call10853;
  } else {
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3319
  setline(3319);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10856 == NULL) {
    strlit10856 = alloc_String("dialect");
    gc_root(strlit10856);
  }
// compilenode returning strlit10856
  int op_slot_right_10855 = gc_frame_newslot(strlit10856);
  int callframe10858 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10859 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10858);
// compilenode returning call10859
// compilenode returning call10859
  int op_slot_left_10855 = gc_frame_newslot(call10859);
  params[0] = strlit10856;
  partcv[0] = 1;
  Object opresult10860 = callmethod(call10859, "==", 1, partcv, params);
// compilenode returning opresult10860
  Object if10854 = done;
  if (istrue(opresult10860)) {
// Begin line 3320
  setline(3320);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10861 = gc_frame_new();
  partcv[0] = 0;
  Object call10862 = callmethodflags(self, "dodialect", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10861);
// compilenode returning call10862
    gc_frame_newslot(call10862);
    if10854 = call10862;
  } else {
// Begin line 3323
  setline(3323);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3321
  setline(3321);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10865 == NULL) {
    strlit10865 = alloc_String("type");
    gc_root(strlit10865);
  }
// compilenode returning strlit10865
  int op_slot_right_10864 = gc_frame_newslot(strlit10865);
  int callframe10867 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10868 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10867);
// compilenode returning call10868
// compilenode returning call10868
  int op_slot_left_10864 = gc_frame_newslot(call10868);
  params[0] = strlit10865;
  partcv[0] = 1;
  Object opresult10869 = callmethod(call10868, "==", 1, partcv, params);
// compilenode returning opresult10869
  Object if10863 = done;
  if (istrue(opresult10869)) {
// Begin line 3322
  setline(3322);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10870 = gc_frame_new();
  partcv[0] = 0;
  Object call10871 = callmethodflags(self, "dotype", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10870);
// compilenode returning call10871
    gc_frame_newslot(call10871);
    if10863 = call10871;
  } else {
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3323
  setline(3323);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10874 == NULL) {
    strlit10874 = alloc_String("class");
    gc_root(strlit10874);
  }
// compilenode returning strlit10874
  int op_slot_right_10873 = gc_frame_newslot(strlit10874);
  int callframe10876 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10877 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10876);
// compilenode returning call10877
// compilenode returning call10877
  int op_slot_left_10873 = gc_frame_newslot(call10877);
  params[0] = strlit10874;
  partcv[0] = 1;
  Object opresult10878 = callmethod(call10877, "==", 1, partcv, params);
// compilenode returning opresult10878
  Object if10872 = done;
  if (istrue(opresult10878)) {
// Begin line 3324
  setline(3324);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10879 = gc_frame_new();
  partcv[0] = 0;
  Object call10880 = callmethodflags(self, "doclass", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10879);
// compilenode returning call10880
    gc_frame_newslot(call10880);
    if10872 = call10880;
  } else {
// Begin line 3327
  setline(3327);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3325
  setline(3325);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit10883 == NULL) {
    strlit10883 = alloc_String("return");
    gc_root(strlit10883);
  }
// compilenode returning strlit10883
  int op_slot_right_10882 = gc_frame_newslot(strlit10883);
  int callframe10885 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call10886 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe10885);
// compilenode returning call10886
// compilenode returning call10886
  int op_slot_left_10882 = gc_frame_newslot(call10886);
  params[0] = strlit10883;
  partcv[0] = 1;
  Object opresult10887 = callmethod(call10886, "==", 1, partcv, params);
// compilenode returning opresult10887
  Object if10881 = done;
  if (istrue(opresult10887)) {
// Begin line 3326
  setline(3326);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10888 = gc_frame_new();
  partcv[0] = 0;
  Object call10889 = callmethodflags(self, "doreturn", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10888);
// compilenode returning call10889
    gc_frame_newslot(call10889);
    if10881 = call10889;
  } else {
// Begin line 3328
  setline(3328);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10890 = gc_frame_new();
  partcv[0] = 0;
  Object call10891 = callmethodflags(self, "expression", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10890);
// compilenode returning call10891
    gc_frame_newslot(call10891);
    if10881 = call10891;
  }
// compilenode returning if10881
    gc_frame_newslot(if10881);
    if10872 = if10881;
  }
// compilenode returning if10872
    gc_frame_newslot(if10872);
    if10863 = if10872;
  }
// compilenode returning if10863
    gc_frame_newslot(if10863);
    if10854 = if10863;
  }
// compilenode returning if10854
    gc_frame_newslot(if10854);
    if10845 = if10854;
  }
// compilenode returning if10845
    gc_frame_newslot(if10845);
    if10836 = if10845;
  }
// compilenode returning if10836
    gc_frame_newslot(if10836);
    if10827 = if10836;
  }
// compilenode returning if10827
    gc_frame_newslot(if10827);
    if10823 = if10827;
  } else {
// Begin line 3331
  setline(3331);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe10892 = gc_frame_new();
  Object block10893 = alloc_Block(NULL, NULL, "parser", 3331);
  gc_frame_newslot(block10893);
  block_savedest(block10893);
  Object closure10894 = createclosure(1, "_apply");
setclosureframe(closure10894, stackframe);
  addtoclosure(closure10894, selfslot);
  struct UserObject *uo10894 = (struct UserObject*)block10893;
  uo10894->data[0] = (Object)closure10894;
  Method *meth_meth_parser__apply10894 = addmethod2pos(block10893, "_apply", &meth_parser__apply10894, 0);
int argcv_meth_parser__apply10894[] = {0};
meth_meth_parser__apply10894->type = alloc_MethodType(1, argcv_meth_parser__apply10894);
  meth_meth_parser__apply10894->definitionModule = modulename;
  meth_meth_parser__apply10894->definitionLine = 3325;
// compilenode returning block10893
  gc_frame_newslot(block10893);
  Object block10898 = alloc_Block(NULL, NULL, "parser", 3331);
  gc_frame_newslot(block10898);
  block_savedest(block10898);
  Object closure10899 = createclosure(6, "_apply");
setclosureframe(closure10899, stackframe);
  addtoclosure(closure10899, var_values);
  addtoclosure(closure10899, var_errormessages);
  addtoclosure(closure10899, var_sym);
  addtoclosure(closure10899, var_lastToken);
  addtoclosure(closure10899, var_ast);
  addtoclosure(closure10899, selfslot);
  struct UserObject *uo10899 = (struct UserObject*)block10898;
  uo10899->data[0] = (Object)closure10899;
  Method *meth_meth_parser__apply10899 = addmethod2pos(block10898, "_apply", &meth_parser__apply10899, 0);
int argcv_meth_parser__apply10899[] = {0};
meth_meth_parser__apply10899->type = alloc_MethodType(1, argcv_meth_parser__apply10899);
  meth_meth_parser__apply10899->definitionModule = modulename;
  meth_meth_parser__apply10899->definitionLine = 3325;
// compilenode returning block10898
  gc_frame_newslot(block10898);
  params[0] = block10893;
  params[1] = block10898;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11004 = callmethodflags(self, "ifConsume()then", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10892);
// compilenode returning call11004
    gc_frame_newslot(call11004);
    if10823 = call11004;
  }
// compilenode returning if10823
// Begin line 3363
  setline(3363);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3360
  setline(3360);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11006 = gc_frame_new();
  if (strlit11007 == NULL) {
    strlit11007 = alloc_String("eof");
    gc_root(strlit11007);
  }
// compilenode returning strlit11007
  gc_frame_newslot(strlit11007);
  params[0] = strlit11007;
  partcv[0] = 1;
  Object call11008 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11006);
// compilenode returning call11008
  Object if11005 = done;
  if (istrue(call11008)) {
// Begin line 3362
  setline(3362);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3361
  setline(3361);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11009 = alloc_Boolean(1);
// compilenode returning bool11009
  return bool11009;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if11005 = undefined;
  } else {
  }
// compilenode returning if11005
// Begin line 3372
  setline(3372);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3363
  setline(3363);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11011 = gc_frame_new();
  if (strlit11012 == NULL) {
    strlit11012 = alloc_String("semicolon");
    gc_root(strlit11012);
  }
// compilenode returning strlit11012
  gc_frame_newslot(strlit11012);
  params[0] = strlit11012;
  partcv[0] = 1;
  Object call11013 = callmethodflags(self, "accept", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11011);
// compilenode returning call11013
  Object if11010 = done;
  if (istrue(call11013)) {
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3364
  setline(3364);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11014 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11015 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11014);
// compilenode returning call11015
// compilenode returning call11015
  *var_oldLine = call11015;
  if (call11015 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3365
  setline(3365);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11016 = gc_frame_new();
  partcv[0] = 0;
  Object call11017 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11016);
// compilenode returning call11017
// Begin line 3369
  setline(3369);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3366
  setline(3366);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_oldLine
  int op_slot_right_11019 = gc_frame_newslot(*var_oldLine);
  int callframe11021 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11022 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11021);
// compilenode returning call11022
// compilenode returning call11022
  int op_slot_left_11019 = gc_frame_newslot(call11022);
  params[0] = *var_oldLine;
  partcv[0] = 1;
  Object opresult11023 = callmethod(call11022, "==", 1, partcv, params);
// compilenode returning opresult11023
  Object if11018 = done;
  if (istrue(opresult11023)) {
// Begin line 3368
  setline(3368);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3367
  setline(3367);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11024 = alloc_Boolean(1);
// compilenode returning bool11024
  *var_indentFreePass = bool11024;
  if (bool11024 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11018 = done;
  } else {
  }
// compilenode returning if11018
    gc_frame_newslot(if11018);
    if11010 = if11018;
  } else {
// Begin line 3370
  setline(3370);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11026 = gc_frame_new();
  partcv[0] = 0;
  Object call11027 = callmethodflags(self, "checkUnexpectedTokenAfterStatement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11026);
// compilenode returning call11027
    gc_frame_newslot(call11027);
    if11010 = call11027;
  }
// compilenode returning if11010
  gc_frame_end(frame);
  return if11010;
}
Object meth_parser_checkBadOperators11028(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 56, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadOperators");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadOperators (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for checkBadOperators");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3375
  setline(3375);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11031 == NULL) {
    strlit11031 = alloc_String("=");
    gc_root(strlit11031);
  }
// compilenode returning strlit11031
  int op_slot_right_11030 = gc_frame_newslot(strlit11031);
  int callframe11033 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11034 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11033);
// compilenode returning call11034
// compilenode returning call11034
  int op_slot_left_11030 = gc_frame_newslot(call11034);
  params[0] = strlit11031;
  partcv[0] = 1;
  Object opresult11035 = callmethod(call11034, "==", 1, partcv, params);
// compilenode returning opresult11035
  Object if11029 = done;
  if (istrue(opresult11035)) {
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3376
  setline(3376);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11036 = gc_frame_new();
  int callframe11037 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11038 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11037);
// compilenode returning call11038
// compilenode returning call11038
  partcv[0] = 0;
  Object call11039 = callmethod(call11038, "new",
    1, partcv, params);
  gc_frame_end(callframe11036);
// compilenode returning call11039
// compilenode returning call11039
  *var_sugg = call11039;
  if (call11039 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3377
  setline(3377);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11040 = gc_frame_new();
  if (strlit11041 == NULL) {
    strlit11041 = alloc_String("=");
    gc_root(strlit11041);
  }
// compilenode returning strlit11041
  gc_frame_newslot(strlit11041);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_sugg
  params[0] = strlit11041;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11042 = callmethod(*var_sugg, "insert()afterToken",
    2, partcv, params);
  gc_frame_end(callframe11040);
// compilenode returning call11042
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11043 = gc_frame_new();
  if (strlit11044 == NULL) {
    strlit11044 = alloc_String("Use '==' to test equality, not '='.");
    gc_root(strlit11044);
  }
// compilenode returning strlit11044
  gc_frame_newslot(strlit11044);
// Begin line 3379
  setline(3379);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11045 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11046 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11045);
// compilenode returning call11046
// compilenode returning call11046
  gc_frame_newslot(call11046);
  int callframe11047 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11048 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11047);
// compilenode returning call11048
// compilenode returning call11048
  gc_frame_newslot(call11048);
  int callframe11049 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11050 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11049);
// compilenode returning call11050
// compilenode returning call11050
  gc_frame_newslot(call11050);
// Begin line 3380
  setline(3380);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sugg
  gc_frame_newslot(*var_sugg);
// Begin line 3378
  setline(3378);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11044;
  params[1] = call11046;
  params[2] = call11048;
  params[3] = call11050;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11051 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11043);
// compilenode returning call11051
    gc_frame_newslot(call11051);
    if11029 = call11051;
  } else {
  }
// compilenode returning if11029
// Begin line 3389
  setline(3389);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3382
  setline(3382);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11054 == NULL) {
    strlit11054 = alloc_String("rgeneric");
    gc_root(strlit11054);
  }
// compilenode returning strlit11054
  int op_slot_right_11053 = gc_frame_newslot(strlit11054);
  int callframe11056 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11057 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11056);
// compilenode returning call11057
// compilenode returning call11057
  int op_slot_left_11053 = gc_frame_newslot(call11057);
  params[0] = strlit11054;
  partcv[0] = 1;
  Object opresult11058 = callmethod(call11057, "==", 1, partcv, params);
// compilenode returning opresult11058
  Object if11052 = done;
  if (istrue(opresult11058)) {
// Begin line 3384
  setline(3384);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3383
  setline(3383);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11059 = gc_frame_new();
  int callframe11060 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11061 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11060);
// compilenode returning call11061
// compilenode returning call11061
  partcv[0] = 0;
  Object call11062 = callmethod(call11061, "new",
    1, partcv, params);
  gc_frame_end(callframe11059);
// compilenode returning call11062
// compilenode returning call11062
  *var_sugg = call11062;
  if (call11062 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3384
  setline(3384);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11063 = gc_frame_new();
  if (strlit11064 == NULL) {
    strlit11064 = alloc_String(" ");
    gc_root(strlit11064);
  }
// compilenode returning strlit11064
  gc_frame_newslot(strlit11064);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_sugg
  params[0] = strlit11064;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11065 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11063);
// compilenode returning call11065
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11066 = gc_frame_new();
  if (strlit11067 == NULL) {
    strlit11067 = alloc_String("The '>' operator requires a space before it.");
    gc_root(strlit11067);
  }
// compilenode returning strlit11067
  gc_frame_newslot(strlit11067);
// Begin line 3386
  setline(3386);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11068 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11069 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11068);
// compilenode returning call11069
// compilenode returning call11069
  gc_frame_newslot(call11069);
  int callframe11070 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11071 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11070);
// compilenode returning call11071
// compilenode returning call11071
  gc_frame_newslot(call11071);
  int callframe11072 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11073 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11072);
// compilenode returning call11073
// compilenode returning call11073
  gc_frame_newslot(call11073);
// Begin line 3387
  setline(3387);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sugg
  gc_frame_newslot(*var_sugg);
// Begin line 3385
  setline(3385);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11067;
  params[1] = call11069;
  params[2] = call11071;
  params[3] = call11073;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11074 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11066);
// compilenode returning call11074
    gc_frame_newslot(call11074);
    if11052 = call11074;
  } else {
  }
// compilenode returning if11052
  gc_frame_end(frame);
  return if11052;
}
Object meth_parser_checkBadAnonymousType11075(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 57, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkBadAnonymousType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_errormessages = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkBadAnonymousType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for checkBadAnonymousType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
// Begin line 3399
  setline(3399);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3392
  setline(3392);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11078 == NULL) {
    strlit11078 = alloc_String("lbrace");
    gc_root(strlit11078);
  }
// compilenode returning strlit11078
  int op_slot_right_11077 = gc_frame_newslot(strlit11078);
  int callframe11080 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11081 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11080);
// compilenode returning call11081
// compilenode returning call11081
  int op_slot_left_11077 = gc_frame_newslot(call11081);
  params[0] = strlit11078;
  partcv[0] = 1;
  Object opresult11082 = callmethod(call11081, "==", 1, partcv, params);
// compilenode returning opresult11082
  Object if11076 = done;
  if (istrue(opresult11082)) {
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3393
  setline(3393);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11083 = gc_frame_new();
  int callframe11084 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11085 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11084);
// compilenode returning call11085
// compilenode returning call11085
  partcv[0] = 0;
  Object call11086 = callmethod(call11085, "new",
    1, partcv, params);
  gc_frame_end(callframe11083);
// compilenode returning call11086
// compilenode returning call11086
  *var_sugg = call11086;
  if (call11086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3394
  setline(3394);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11087 = gc_frame_new();
  if (strlit11088 == NULL) {
    strlit11088 = alloc_String("type ");
    gc_root(strlit11088);
  }
// compilenode returning strlit11088
  gc_frame_newslot(strlit11088);
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_sugg
  params[0] = strlit11088;
  params[1] = *var_sym;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11089 = callmethod(*var_sugg, "insert()beforeToken",
    2, partcv, params);
  gc_frame_end(callframe11087);
// compilenode returning call11089
// Begin line 3395
  setline(3395);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11090 = gc_frame_new();
  if (strlit11091 == NULL) {
    strlit11091 = alloc_String("Anonymous type literals must be written with the 'type' keyword'.");
    gc_root(strlit11091);
  }
// compilenode returning strlit11091
  gc_frame_newslot(strlit11091);
// Begin line 3396
  setline(3396);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11092 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11093 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11092);
// compilenode returning call11093
// compilenode returning call11093
  gc_frame_newslot(call11093);
  int callframe11094 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11095 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11094);
// compilenode returning call11095
// compilenode returning call11095
  gc_frame_newslot(call11095);
  int callframe11096 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11097 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11096);
// compilenode returning call11097
// compilenode returning call11097
  gc_frame_newslot(call11097);
// Begin line 3397
  setline(3397);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sugg
  gc_frame_newslot(*var_sugg);
// Begin line 3395
  setline(3395);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11091;
  params[1] = call11093;
  params[2] = call11095;
  params[3] = call11097;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11098 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11090);
// compilenode returning call11098
    gc_frame_newslot(call11098);
    if11076 = call11098;
  } else {
  }
// compilenode returning if11076
  gc_frame_end(frame);
  return if11076;
}
Object meth_parser__apply11206(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3432
  setline(3432);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3431
  setline(3431);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11208 == NULL) {
    strlit11208 = alloc_String("identifier");
    gc_root(strlit11208);
  }
// compilenode returning strlit11208
  int op_slot_right_11207 = gc_frame_newslot(strlit11208);
  int callframe11210 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11211 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11210);
// compilenode returning call11211
// compilenode returning call11211
  int op_slot_left_11207 = gc_frame_newslot(call11211);
  params[0] = strlit11208;
  partcv[0] = 1;
  Object opresult11212 = callmethod(call11211, "==", 1, partcv, params);
// compilenode returning opresult11212
  gc_frame_end(frame);
  return opresult11212;
}
Object meth_parser__apply11216(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3430
  setline(3430);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3429
  setline(3429);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11218 == NULL) {
    strlit11218 = alloc_String("member");
    gc_root(strlit11218);
  }
// compilenode returning strlit11218
  int op_slot_right_11217 = gc_frame_newslot(strlit11218);
  int callframe11220 = gc_frame_new();
  int callframe11221 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call11222 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11221);
// compilenode returning call11222
// compilenode returning call11222
  partcv[0] = 0;
  Object call11223 = callmethod(call11222, "kind",
    1, partcv, params);
  gc_frame_end(callframe11220);
// compilenode returning call11223
// compilenode returning call11223
  int op_slot_left_11217 = gc_frame_newslot(call11223);
  params[0] = strlit11218;
  partcv[0] = 1;
  Object opresult11224 = callmethod(call11223, "==", 1, partcv, params);
// compilenode returning opresult11224
  gc_frame_end(frame);
  return opresult11224;
}
Object meth_parser__apply11203(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 3430
  setline(3430);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11204 = gc_frame_new();
  Object block11205 = alloc_Block(NULL, NULL, "parser", 3430);
  gc_frame_newslot(block11205);
  block_savedest(block11205);
  Object closure11206 = createclosure(2, "_apply");
setclosureframe(closure11206, stackframe);
  addtoclosure(closure11206, var_sym);
  addtoclosure(closure11206, selfslot);
  struct UserObject *uo11206 = (struct UserObject*)block11205;
  uo11206->data[0] = (Object)closure11206;
  Method *meth_meth_parser__apply11206 = addmethod2pos(block11205, "_apply", &meth_parser__apply11206, 0);
int argcv_meth_parser__apply11206[] = {0};
meth_meth_parser__apply11206->type = alloc_MethodType(1, argcv_meth_parser__apply11206);
  meth_meth_parser__apply11206->definitionModule = modulename;
  meth_meth_parser__apply11206->definitionLine = 3424;
// compilenode returning block11205
  gc_frame_newslot(block11205);
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11214 = gc_frame_new();
  Object block11215 = alloc_Block(NULL, NULL, "parser", 3428);
  gc_frame_newslot(block11215);
  block_savedest(block11215);
  Object closure11216 = createclosure(2, "_apply");
setclosureframe(closure11216, stackframe);
  addtoclosure(closure11216, var_values);
  addtoclosure(closure11216, selfslot);
  struct UserObject *uo11216 = (struct UserObject*)block11215;
  uo11216->data[0] = (Object)closure11216;
  Method *meth_meth_parser__apply11216 = addmethod2pos(block11215, "_apply", &meth_parser__apply11216, 0);
int argcv_meth_parser__apply11216[] = {0};
meth_meth_parser__apply11216->type = alloc_MethodType(1, argcv_meth_parser__apply11216);
  meth_meth_parser__apply11216->definitionModule = modulename;
  meth_meth_parser__apply11216->definitionLine = 3431;
// compilenode returning block11215
  gc_frame_newslot(block11215);
// Begin line 3428
  setline(3428);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11227 == NULL) {
    strlit11227 = alloc_String("identifier");
    gc_root(strlit11227);
  }
// compilenode returning strlit11227
  int op_slot_right_11226 = gc_frame_newslot(strlit11227);
  int callframe11229 = gc_frame_new();
  int callframe11230 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call11231 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11230);
// compilenode returning call11231
// compilenode returning call11231
  partcv[0] = 0;
  Object call11232 = callmethod(call11231, "kind",
    1, partcv, params);
  gc_frame_end(callframe11229);
// compilenode returning call11232
// compilenode returning call11232
  int op_slot_left_11226 = gc_frame_newslot(call11232);
  params[0] = strlit11227;
  partcv[0] = 1;
  Object opresult11233 = callmethod(call11232, "==", 1, partcv, params);
// compilenode returning opresult11233
  params[0] = block11215;
  partcv[0] = 1;
  Object call11234 = callmethod(opresult11233, "orElse",
    1, partcv, params);
  gc_frame_end(callframe11214);
// compilenode returning call11234
  params[0] = block11205;
  partcv[0] = 1;
  Object call11235 = callmethod(call11234, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11204);
// compilenode returning call11235
  gc_frame_end(frame);
  return call11235;
}
Object meth_parser_checkUnexpectedTokenAfterStatement11099(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 58, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(10, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "checkUnexpectedTokenAfterStatement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[4];
  Object *var_lastToken = getfromclosure(closure, 0);
  Object *var_sym = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_values = getfromclosure(closure, 3);
  Object *var_util = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for checkUnexpectedTokenAfterStatement (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for checkUnexpectedTokenAfterStatement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sugg = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sugg");
  Object *var_suggestions = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "suggestions");
  Object *var_sugg2 = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "sugg2");
  Object *var_suggestion = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "suggestion");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_nextTok = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "nextTok");
  Object *var_newLine = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "newLine");
// Begin line 3468
  setline(3468);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3402
  setline(3402);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11102 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11103 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11102);
// compilenode returning call11103
// compilenode returning call11103
  int op_slot_right_11101 = gc_frame_newslot(call11103);
  int callframe11105 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11106 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11105);
// compilenode returning call11106
// compilenode returning call11106
  int op_slot_left_11101 = gc_frame_newslot(call11106);
  params[0] = call11103;
  partcv[0] = 1;
  Object opresult11107 = callmethod(call11106, "==", 1, partcv, params);
// compilenode returning opresult11107
  Object if11100 = done;
  if (istrue(opresult11107)) {
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3404
  setline(3404);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11111 == NULL) {
    strlit11111 = alloc_String("identifier");
    gc_root(strlit11111);
  }
// compilenode returning strlit11111
  int op_slot_right_11110 = gc_frame_newslot(strlit11111);
  int callframe11113 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11114 = callmethod(*var_lastToken, "kind",
    1, partcv, params);
  gc_frame_end(callframe11113);
// compilenode returning call11114
// compilenode returning call11114
  int op_slot_left_11110 = gc_frame_newslot(call11114);
  params[0] = strlit11111;
  partcv[0] = 1;
  Object opresult11115 = callmethod(call11114, "==", 1, partcv, params);
// compilenode returning opresult11115
  int op_slot_right_11109 = gc_frame_newslot(opresult11115);
// Begin line 3403
  setline(3403);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11119 == NULL) {
    strlit11119 = alloc_String("=");
    gc_root(strlit11119);
  }
// compilenode returning strlit11119
  int op_slot_right_11118 = gc_frame_newslot(strlit11119);
  int callframe11121 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11122 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11121);
// compilenode returning call11122
// compilenode returning call11122
  int op_slot_left_11118 = gc_frame_newslot(call11122);
  params[0] = strlit11119;
  partcv[0] = 1;
  Object opresult11123 = callmethod(call11122, "==", 1, partcv, params);
// compilenode returning opresult11123
  int op_slot_right_11117 = gc_frame_newslot(opresult11123);
  if (strlit11126 == NULL) {
    strlit11126 = alloc_String("op");
    gc_root(strlit11126);
  }
// compilenode returning strlit11126
  int op_slot_right_11125 = gc_frame_newslot(strlit11126);
  int callframe11128 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11129 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11128);
// compilenode returning call11129
// compilenode returning call11129
  int op_slot_left_11125 = gc_frame_newslot(call11129);
  params[0] = strlit11126;
  partcv[0] = 1;
  Object opresult11130 = callmethod(call11129, "==", 1, partcv, params);
// compilenode returning opresult11130
  int op_slot_left_11117 = gc_frame_newslot(opresult11130);
  params[0] = opresult11123;
  partcv[0] = 1;
  Object opresult11131 = callmethod(opresult11130, "&&", 1, partcv, params);
// compilenode returning opresult11131
  int op_slot_left_11109 = gc_frame_newslot(opresult11131);
  params[0] = opresult11115;
  partcv[0] = 1;
  Object opresult11132 = callmethod(opresult11131, "&&", 1, partcv, params);
// compilenode returning opresult11132
  Object if11108 = done;
  if (istrue(opresult11132)) {
// Begin line 3406
  setline(3406);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3405
  setline(3405);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11133 = gc_frame_new();
  int callframe11134 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11135 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11134);
// compilenode returning call11135
// compilenode returning call11135
  partcv[0] = 0;
  Object call11136 = callmethod(call11135, "new",
    1, partcv, params);
  gc_frame_end(callframe11133);
// compilenode returning call11136
// compilenode returning call11136
  *var_sugg = call11136;
  if (call11136 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3407
  setline(3407);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3406
  setline(3406);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11137 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11137
  *var_suggestions = array11137;
  if (array11137 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3407
  setline(3407);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11138 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool11139 = alloc_Boolean(0);
// compilenode returning bool11139
  gc_frame_newslot(bool11139);
  Object bool11140 = alloc_Boolean(0);
// compilenode returning bool11140
  gc_frame_newslot(bool11140);
  if (strlit11141 == NULL) {
    strlit11141 = alloc_String(":=");
    gc_root(strlit11141);
  }
// compilenode returning strlit11141
  gc_frame_newslot(strlit11141);
// compilenode returning *var_sugg
  params[0] = *var_sym;
  params[1] = bool11139;
  params[2] = bool11140;
  params[3] = strlit11141;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11142 = callmethod(*var_sugg, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11138);
// compilenode returning call11142
// Begin line 3408
  setline(3408);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11143 = gc_frame_new();
// compilenode returning *var_sugg
  gc_frame_newslot(*var_sugg);
// compilenode returning *var_suggestions
  params[0] = *var_sugg;
  partcv[0] = 1;
  Object call11144 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11143);
// compilenode returning call11144
// Begin line 3410
  setline(3410);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3409
  setline(3409);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11145 = gc_frame_new();
  int callframe11146 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11147 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11146);
// compilenode returning call11147
// compilenode returning call11147
  partcv[0] = 0;
  Object call11148 = callmethod(call11147, "new",
    1, partcv, params);
  gc_frame_end(callframe11145);
// compilenode returning call11148
// compilenode returning call11148
  *var_sugg2 = call11148;
  if (call11148 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3410
  setline(3410);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11149 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool11150 = alloc_Boolean(0);
// compilenode returning bool11150
  gc_frame_newslot(bool11150);
  Object bool11151 = alloc_Boolean(0);
// compilenode returning bool11151
  gc_frame_newslot(bool11151);
  if (strlit11152 == NULL) {
    strlit11152 = alloc_String("==");
    gc_root(strlit11152);
  }
// compilenode returning strlit11152
  gc_frame_newslot(strlit11152);
// compilenode returning *var_sugg2
  params[0] = *var_sym;
  params[1] = bool11150;
  params[2] = bool11151;
  params[3] = strlit11152;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11153 = callmethod(*var_sugg2, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11149);
// compilenode returning call11153
// Begin line 3411
  setline(3411);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11154 = gc_frame_new();
// compilenode returning *var_sugg2
  gc_frame_newslot(*var_sugg2);
// compilenode returning *var_suggestions
  params[0] = *var_sugg2;
  partcv[0] = 1;
  Object call11155 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11154);
// compilenode returning call11155
// Begin line 3412
  setline(3412);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11156 = gc_frame_new();
  if (strlit11157 == NULL) {
    strlit11157 = alloc_String("Assignment uses ':=', not '='.");
    gc_root(strlit11157);
  }
// compilenode returning strlit11157
  gc_frame_newslot(strlit11157);
// Begin line 3413
  setline(3413);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11158 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11159 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11158);
// compilenode returning call11159
// compilenode returning call11159
  gc_frame_newslot(call11159);
  int callframe11160 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11161 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11160);
// compilenode returning call11161
// compilenode returning call11161
  gc_frame_newslot(call11161);
  int callframe11162 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11163 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11162);
// compilenode returning call11163
// compilenode returning call11163
  gc_frame_newslot(call11163);
// Begin line 3414
  setline(3414);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 3412
  setline(3412);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11157;
  params[1] = call11159;
  params[2] = call11161;
  params[3] = call11163;
  params[4] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11164 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11156);
// compilenode returning call11164
    gc_frame_newslot(call11164);
    if11108 = call11164;
  } else {
  }
// compilenode returning if11108
// Begin line 3424
  setline(3424);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3416
  setline(3416);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11167 == NULL) {
    strlit11167 = alloc_String("rgeneric");
    gc_root(strlit11167);
  }
// compilenode returning strlit11167
  int op_slot_right_11166 = gc_frame_newslot(strlit11167);
  int callframe11169 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11170 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11169);
// compilenode returning call11170
// compilenode returning call11170
  int op_slot_left_11166 = gc_frame_newslot(call11170);
  params[0] = strlit11167;
  partcv[0] = 1;
  Object opresult11171 = callmethod(call11170, "==", 1, partcv, params);
// compilenode returning opresult11171
  Object if11165 = done;
  if (istrue(opresult11171)) {
// Begin line 3418
  setline(3418);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3417
  setline(3417);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11172 = gc_frame_new();
  int callframe11173 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11174 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11173);
// compilenode returning call11174
// compilenode returning call11174
  partcv[0] = 0;
  Object call11175 = callmethod(call11174, "new",
    1, partcv, params);
  gc_frame_end(callframe11172);
// compilenode returning call11175
// compilenode returning call11175
  *var_sugg = call11175;
  if (call11175 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3418
  setline(3418);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11176 = gc_frame_new();
  if (strlit11177 == NULL) {
    strlit11177 = alloc_String(" ");
    gc_root(strlit11177);
  }
// compilenode returning strlit11177
  gc_frame_newslot(strlit11177);
  int callframe11178 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11179 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11178);
// compilenode returning call11179
// compilenode returning call11179
  gc_frame_newslot(call11179);
  int callframe11180 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11181 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11180);
// compilenode returning call11181
// compilenode returning call11181
  gc_frame_newslot(call11181);
// compilenode returning *var_sugg
  params[0] = strlit11177;
  params[1] = call11179;
  params[2] = call11181;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11182 = callmethod(*var_sugg, "insert()atPosition()onLine",
    3, partcv, params);
  gc_frame_end(callframe11176);
// compilenode returning call11182
// Begin line 3419
  setline(3419);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11183 = gc_frame_new();
// Begin line 3420
  setline(3420);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11184 == NULL) {
    strlit11184 = alloc_String("The '>' operator must have a space before it.");
    gc_root(strlit11184);
  }
// compilenode returning strlit11184
  gc_frame_newslot(strlit11184);
// Begin line 3421
  setline(3421);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11185 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11186 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11185);
// compilenode returning call11186
// compilenode returning call11186
  gc_frame_newslot(call11186);
  int callframe11187 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11188 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11187);
// compilenode returning call11188
// compilenode returning call11188
  gc_frame_newslot(call11188);
  int callframe11189 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11190 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11189);
// compilenode returning call11190
// compilenode returning call11190
  gc_frame_newslot(call11190);
// Begin line 3422
  setline(3422);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sugg
  gc_frame_newslot(*var_sugg);
// Begin line 3419
  setline(3419);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11184;
  params[1] = call11186;
  params[2] = call11188;
  params[3] = call11190;
  params[4] = *var_sugg;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11191 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11183);
// compilenode returning call11191
    gc_frame_newslot(call11191);
    if11165 = call11191;
  } else {
  }
// compilenode returning if11165
// Begin line 3467
  setline(3467);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3424
  setline(3424);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11194 == NULL) {
    strlit11194 = alloc_String("rbrace");
    gc_root(strlit11194);
  }
// compilenode returning strlit11194
  int op_slot_right_11193 = gc_frame_newslot(strlit11194);
  int callframe11196 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11197 = callmethod(*var_sym, "kind",
    1, partcv, params);
  gc_frame_end(callframe11196);
// compilenode returning call11197
// compilenode returning call11197
  int op_slot_left_11193 = gc_frame_newslot(call11197);
  params[0] = strlit11194;
  partcv[0] = 1;
  Object opresult11198 = callmethod(call11197, "!=", 1, partcv, params);
// compilenode returning opresult11198
  Object if11192 = done;
  if (istrue(opresult11198)) {
// Begin line 3426
  setline(3426);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3425
  setline(3425);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11199 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11199
  *var_suggestions = array11199;
  if (array11199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_suggestion = undefined;
// compilenode returning done
// Begin line 3452
  setline(3452);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11201 = gc_frame_new();
  Object block11202 = alloc_Block(NULL, NULL, "parser", 3427);
  gc_frame_newslot(block11202);
  block_savedest(block11202);
  Object closure11203 = createclosure(3, "_apply");
setclosureframe(closure11203, stackframe);
  addtoclosure(closure11203, var_sym);
  addtoclosure(closure11203, var_values);
  addtoclosure(closure11203, selfslot);
  struct UserObject *uo11203 = (struct UserObject*)block11202;
  uo11203->data[0] = (Object)closure11203;
  Method *meth_meth_parser__apply11203 = addmethod2pos(block11202, "_apply", &meth_parser__apply11203, 0);
int argcv_meth_parser__apply11203[] = {0};
meth_meth_parser__apply11203->type = alloc_MethodType(1, argcv_meth_parser__apply11203);
  meth_meth_parser__apply11203->definitionModule = modulename;
  meth_meth_parser__apply11203->definitionLine = 3424;
// compilenode returning block11202
  gc_frame_newslot(block11202);
// Begin line 3427
  setline(3427);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11238 = alloc_Float64(0);
// compilenode returning num11238
  int op_slot_right_11237 = gc_frame_newslot(num11238);
  int callframe11240 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call11241 = callmethod(*var_values, "size",
    1, partcv, params);
  gc_frame_end(callframe11240);
// compilenode returning call11241
// compilenode returning call11241
  int op_slot_left_11237 = gc_frame_newslot(call11241);
  params[0] = num11238;
  partcv[0] = 1;
  Object opresult11242 = callmethod(call11241, ">", 1, partcv, params);
// compilenode returning opresult11242
  params[0] = block11202;
  partcv[0] = 1;
  Object call11243 = callmethod(opresult11242, "andAlso",
    1, partcv, params);
  gc_frame_end(callframe11201);
// compilenode returning call11243
  Object if11200 = done;
  if (istrue(call11243)) {
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3434
  setline(3434);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11244 = gc_frame_new();
  int callframe11245 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11246 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11245);
// compilenode returning call11246
// compilenode returning call11246
  partcv[0] = 0;
  Object call11247 = callmethod(call11246, "new",
    1, partcv, params);
  gc_frame_end(callframe11244);
// compilenode returning call11247
// compilenode returning call11247
  *var_suggestion = call11247;
  if (call11247 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3435
  setline(3435);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11249 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool11250 = alloc_Boolean(1);
// compilenode returning bool11250
  gc_frame_newslot(bool11250);
  Object bool11251 = alloc_Boolean(0);
// compilenode returning bool11251
  gc_frame_newslot(bool11251);
  if (strlit11253 == NULL) {
    strlit11253 = alloc_String(")");
    gc_root(strlit11253);
  }
// compilenode returning strlit11253
  int op_slot_right_11252 = gc_frame_newslot(strlit11253);
  int callframe11256 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11257 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11256);
// compilenode returning call11257
// compilenode returning call11257
  int op_slot_right_11255 = gc_frame_newslot(call11257);
  if (strlit11259 == NULL) {
    strlit11259 = alloc_String("(");
    gc_root(strlit11259);
  }
// compilenode returning strlit11259
  int op_slot_left_11255 = gc_frame_newslot(strlit11259);
  params[0] = call11257;
  partcv[0] = 1;
  Object opresult11260 = callmethod(strlit11259, "++", 1, partcv, params);
// compilenode returning opresult11260
  int op_slot_left_11252 = gc_frame_newslot(opresult11260);
  params[0] = strlit11253;
  partcv[0] = 1;
  Object opresult11261 = callmethod(opresult11260, "++", 1, partcv, params);
// compilenode returning opresult11261
  gc_frame_newslot(opresult11261);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool11250;
  params[2] = bool11251;
  params[3] = opresult11261;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11262 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11249);
// compilenode returning call11262
// Begin line 3436
  setline(3436);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11263 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11264 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11263);
// compilenode returning call11264
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3437
  setline(3437);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11267 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11268 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11267);
// compilenode returning call11268
// compilenode returning call11268
  int op_slot_right_11266 = gc_frame_newslot(call11268);
  Object bool11270 = alloc_Boolean(0);
// compilenode returning bool11270
  int op_slot_left_11266 = gc_frame_newslot(bool11270);
  params[0] = call11268;
  partcv[0] = 1;
  Object opresult11271 = callmethod(bool11270, "!=", 1, partcv, params);
// compilenode returning opresult11271
  Object if11265 = done;
  if (istrue(opresult11271)) {
// Begin line 3439
  setline(3439);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3438
  setline(3438);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11272 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11273 = callmethod(*var_sym, "next",
    1, partcv, params);
  gc_frame_end(callframe11272);
// compilenode returning call11273
// compilenode returning call11273
  *var_n = call11273;
  if (call11273 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3445
  setline(3445);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3439
  setline(3439);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11276 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11277 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11276);
// compilenode returning call11277
// compilenode returning call11277
  int op_slot_right_11275 = gc_frame_newslot(call11277);
  int callframe11279 = gc_frame_new();
// compilenode returning *var_n
  partcv[0] = 0;
  Object call11280 = callmethod(*var_n, "line",
    1, partcv, params);
  gc_frame_end(callframe11279);
// compilenode returning call11280
// compilenode returning call11280
  int op_slot_left_11275 = gc_frame_newslot(call11280);
  params[0] = call11277;
  partcv[0] = 1;
  Object opresult11281 = callmethod(call11280, "==", 1, partcv, params);
// compilenode returning opresult11281
  Object if11274 = done;
  if (istrue(opresult11281)) {
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3440
  setline(3440);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11282 = gc_frame_new();
  int callframe11283 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11284 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11283);
// compilenode returning call11284
// compilenode returning call11284
  partcv[0] = 0;
  Object call11285 = callmethod(call11284, "new",
    1, partcv, params);
  gc_frame_end(callframe11282);
// compilenode returning call11285
// compilenode returning call11285
  *var_suggestion = call11285;
  if (call11285 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3441
  setline(3441);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11287 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool11288 = alloc_Boolean(1);
// compilenode returning bool11288
  gc_frame_newslot(bool11288);
  Object bool11289 = alloc_Boolean(0);
// compilenode returning bool11289
  gc_frame_newslot(bool11289);
  if (strlit11291 == NULL) {
    strlit11291 = alloc_String("");
    gc_root(strlit11291);
  }
// compilenode returning strlit11291
  int op_slot_right_11290 = gc_frame_newslot(strlit11291);
  int callframe11294 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11295 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11294);
// compilenode returning call11295
// compilenode returning call11295
  int op_slot_right_11293 = gc_frame_newslot(call11295);
  if (strlit11297 == NULL) {
    strlit11297 = alloc_String("(");
    gc_root(strlit11297);
  }
// compilenode returning strlit11297
  int op_slot_left_11293 = gc_frame_newslot(strlit11297);
  params[0] = call11295;
  partcv[0] = 1;
  Object opresult11298 = callmethod(strlit11297, "++", 1, partcv, params);
// compilenode returning opresult11298
  int op_slot_left_11290 = gc_frame_newslot(opresult11298);
  params[0] = strlit11291;
  partcv[0] = 1;
  Object opresult11299 = callmethod(opresult11298, "++", 1, partcv, params);
// compilenode returning opresult11299
  gc_frame_newslot(opresult11299);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool11288;
  params[2] = bool11289;
  params[3] = opresult11299;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11300 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11287);
// compilenode returning call11300
// Begin line 3442
  setline(3442);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11301 = gc_frame_new();
  if (strlit11302 == NULL) {
    strlit11302 = alloc_String(")");
    gc_root(strlit11302);
  }
// compilenode returning strlit11302
  gc_frame_newslot(strlit11302);
  int callframe11303 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11304 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11303);
// compilenode returning call11304
// compilenode returning call11304
  gc_frame_newslot(call11304);
// compilenode returning *var_suggestion
  params[0] = strlit11302;
  params[1] = call11304;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11305 = callmethod(*var_suggestion, "append()onLine",
    2, partcv, params);
  gc_frame_end(callframe11301);
// compilenode returning call11305
// Begin line 3443
  setline(3443);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11306 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11307 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11306);
// compilenode returning call11307
    gc_frame_newslot(call11307);
    if11274 = call11307;
  } else {
  }
// compilenode returning if11274
    gc_frame_newslot(if11274);
    if11265 = if11274;
  } else {
  }
// compilenode returning if11265
// Begin line 3451
  setline(3451);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3446
  setline(3446);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11310 == NULL) {
    strlit11310 = alloc_String("identifier");
    gc_root(strlit11310);
  }
// compilenode returning strlit11310
  int op_slot_right_11309 = gc_frame_newslot(strlit11310);
  int callframe11312 = gc_frame_new();
  int callframe11313 = gc_frame_new();
// compilenode returning *var_values
  partcv[0] = 0;
  Object call11314 = callmethod(*var_values, "last",
    1, partcv, params);
  gc_frame_end(callframe11313);
// compilenode returning call11314
// compilenode returning call11314
  partcv[0] = 0;
  Object call11315 = callmethod(call11314, "kind",
    1, partcv, params);
  gc_frame_end(callframe11312);
// compilenode returning call11315
// compilenode returning call11315
  int op_slot_left_11309 = gc_frame_newslot(call11315);
  params[0] = strlit11310;
  partcv[0] = 1;
  Object opresult11316 = callmethod(call11315, "==", 1, partcv, params);
// compilenode returning opresult11316
  Object if11308 = done;
  if (istrue(opresult11316)) {
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3447
  setline(3447);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11317 = gc_frame_new();
  int callframe11318 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11319 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11318);
// compilenode returning call11319
// compilenode returning call11319
  partcv[0] = 0;
  Object call11320 = callmethod(call11319, "new",
    1, partcv, params);
  gc_frame_end(callframe11317);
// compilenode returning call11320
// compilenode returning call11320
  *var_suggestion = call11320;
  if (call11320 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3448
  setline(3448);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11322 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  Object bool11323 = alloc_Boolean(0);
// compilenode returning bool11323
  gc_frame_newslot(bool11323);
  Object bool11324 = alloc_Boolean(0);
// compilenode returning bool11324
  gc_frame_newslot(bool11324);
  if (strlit11326 == NULL) {
    strlit11326 = alloc_String("""\x22""");
    gc_root(strlit11326);
  }
// compilenode returning strlit11326
  int op_slot_right_11325 = gc_frame_newslot(strlit11326);
  int callframe11329 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11330 = callmethod(*var_sym, "value",
    1, partcv, params);
  gc_frame_end(callframe11329);
// compilenode returning call11330
// compilenode returning call11330
  int op_slot_right_11328 = gc_frame_newslot(call11330);
  if (strlit11332 == NULL) {
    strlit11332 = alloc_String("""\x22""");
    gc_root(strlit11332);
  }
// compilenode returning strlit11332
  int op_slot_left_11328 = gc_frame_newslot(strlit11332);
  params[0] = call11330;
  partcv[0] = 1;
  Object opresult11333 = callmethod(strlit11332, "++", 1, partcv, params);
// compilenode returning opresult11333
  int op_slot_left_11325 = gc_frame_newslot(opresult11333);
  params[0] = strlit11326;
  partcv[0] = 1;
  Object opresult11334 = callmethod(opresult11333, "++", 1, partcv, params);
// compilenode returning opresult11334
  gc_frame_newslot(opresult11334);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = bool11323;
  params[2] = bool11324;
  params[3] = opresult11334;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call11335 = callmethod(*var_suggestion, "replaceToken()leading()trailing()with",
    4, partcv, params);
  gc_frame_end(callframe11322);
// compilenode returning call11335
// Begin line 3449
  setline(3449);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11336 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11337 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11336);
// compilenode returning call11337
    gc_frame_newslot(call11337);
    if11308 = call11337;
  } else {
  }
// compilenode returning if11308
    gc_frame_newslot(if11308);
    if11200 = if11308;
  } else {
  }
// compilenode returning if11200
// Begin line 3452
  setline(3452);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11338 = gc_frame_new();
  if (strlit11339 == NULL) {
    strlit11339 = alloc_String("rbrace");
    gc_root(strlit11339);
  }
// compilenode returning strlit11339
  gc_frame_newslot(strlit11339);
  params[0] = strlit11339;
  partcv[0] = 1;
  Object call11340 = callmethodflags(self, "findNextValidToken", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11338);
// compilenode returning call11340
  *var_nextTok = call11340;
  if (call11340 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3453
  setline(3453);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  int op_slot_right_11342 = gc_frame_newslot(*var_sym);
// compilenode returning *var_nextTok
  int op_slot_left_11342 = gc_frame_newslot(*var_nextTok);
  params[0] = *var_sym;
  partcv[0] = 1;
  Object opresult11344 = callmethod(*var_nextTok, "==", 1, partcv, params);
// compilenode returning opresult11344
  Object if11341 = done;
  if (istrue(opresult11344)) {
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3454
  setline(3454);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11345 = gc_frame_new();
  int callframe11346 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11347 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11346);
// compilenode returning call11347
// compilenode returning call11347
  partcv[0] = 0;
  Object call11348 = callmethod(call11347, "new",
    1, partcv, params);
  gc_frame_end(callframe11345);
// compilenode returning call11348
// compilenode returning call11348
  *var_suggestion = call11348;
  if (call11348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3455
  setline(3455);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11350 = gc_frame_new();
  int callframe11351 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11352 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11351);
// compilenode returning call11352
// compilenode returning call11352
  gc_frame_newslot(call11352);
  int callframe11353 = gc_frame_new();
  Object num11354 = alloc_Float64(1);
// compilenode returning num11354
  gc_frame_newslot(num11354);
  Object num11356 = alloc_Float64(1);
// compilenode returning num11356
  int op_slot_right_11355 = gc_frame_newslot(num11356);
  int callframe11359 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11360 = callmethod(*var_lastToken, "size",
    1, partcv, params);
  gc_frame_end(callframe11359);
// compilenode returning call11360
// compilenode returning call11360
  int op_slot_right_11358 = gc_frame_newslot(call11360);
  int callframe11362 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11363 = callmethod(*var_lastToken, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11362);
// compilenode returning call11363
// compilenode returning call11363
  int op_slot_left_11358 = gc_frame_newslot(call11363);
  params[0] = call11360;
  partcv[0] = 1;
  Object sum11364 = callmethod(call11363, "+", 1, partcv, params);
// compilenode returning sum11364
  int op_slot_left_11355 = gc_frame_newslot(sum11364);
  params[0] = num11356;
  partcv[0] = 1;
  Object diff11365 = callmethod(sum11364, "-", 1, partcv, params);
// compilenode returning diff11365
  gc_frame_newslot(diff11365);
  int callframe11366 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11367 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11366);
// compilenode returning call11367
// compilenode returning call11367
  int callframe11368 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11369 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11368);
// compilenode returning call11369
// compilenode returning call11369
  params[0] = call11369;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11370 = callmethod(call11367, "[]", 1, partcv, params);
// compilenode returning idxres11370
  params[0] = num11354;
  params[1] = diff11365;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11371 = callmethod(idxres11370, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11353);
// compilenode returning call11371
  gc_frame_newslot(call11371);
// compilenode returning *var_suggestion
  params[0] = call11352;
  params[1] = call11371;
  partcv[0] = 2;
  Object call11372 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11350);
// compilenode returning call11372
// Begin line 3456
  setline(3456);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11373 = gc_frame_new();
  int callframe11374 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11375 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11374);
// compilenode returning call11375
// compilenode returning call11375
  gc_frame_newslot(call11375);
  int callframe11376 = gc_frame_new();
  int callframe11377 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11378 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11377);
// compilenode returning call11378
// compilenode returning call11378
  int callframe11379 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11380 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11379);
// compilenode returning call11380
// compilenode returning call11380
  params[0] = call11380;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11381 = callmethod(call11378, "[]", 1, partcv, params);
// compilenode returning idxres11381
  partcv[0] = 0;
  Object call11382 = callmethod(idxres11381, "size",
    1, partcv, params);
  gc_frame_end(callframe11376);
// compilenode returning call11382
// compilenode returning call11382
  gc_frame_newslot(call11382);
  int callframe11383 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11384 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11383);
// compilenode returning call11384
// compilenode returning call11384
  int callframe11385 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11386 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11385);
// compilenode returning call11386
// compilenode returning call11386
  params[0] = call11386;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11387 = callmethod(call11384, "[]", 1, partcv, params);
// compilenode returning idxres11387
  params[0] = call11375;
  params[1] = call11382;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11388 = callmethod(idxres11387, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe11373);
// compilenode returning call11388
  *var_newLine = call11388;
  if (call11388 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3457
  setline(3457);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11389 = gc_frame_new();
  Object num11391 = alloc_Float64(0.1);
// compilenode returning num11391
  int op_slot_right_11390 = gc_frame_newslot(num11391);
  int callframe11393 = gc_frame_new();
// compilenode returning *var_lastToken
  partcv[0] = 0;
  Object call11394 = callmethod(*var_lastToken, "line",
    1, partcv, params);
  gc_frame_end(callframe11393);
// compilenode returning call11394
// compilenode returning call11394
  int op_slot_left_11390 = gc_frame_newslot(call11394);
  params[0] = num11391;
  partcv[0] = 1;
  Object sum11395 = callmethod(call11394, "+", 1, partcv, params);
// compilenode returning sum11395
  gc_frame_newslot(sum11395);
// compilenode returning *var_newLine
  gc_frame_newslot(*var_newLine);
// compilenode returning *var_suggestion
  params[0] = sum11395;
  params[1] = *var_newLine;
  partcv[0] = 2;
  Object call11396 = callmethod(*var_suggestion, "addLine",
    1, partcv, params);
  gc_frame_end(callframe11389);
// compilenode returning call11396
// Begin line 3458
  setline(3458);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11397 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11398 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11397);
// compilenode returning call11398
    gc_frame_newslot(call11398);
    if11341 = call11398;
  } else {
// Begin line 3461
  setline(3461);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3460
  setline(3460);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11399 = gc_frame_new();
  int callframe11400 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11401 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11400);
// compilenode returning call11401
// compilenode returning call11401
  partcv[0] = 0;
  Object call11402 = callmethod(call11401, "new",
    1, partcv, params);
  gc_frame_end(callframe11399);
// compilenode returning call11402
// compilenode returning call11402
  *var_suggestion = call11402;
  if (call11402 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3461
  setline(3461);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11404 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
  int callframe11405 = gc_frame_new();
// compilenode returning *var_nextTok
  partcv[0] = 0;
  Object call11406 = callmethod(*var_nextTok, "prev",
    1, partcv, params);
  gc_frame_end(callframe11405);
// compilenode returning call11406
// compilenode returning call11406
  gc_frame_newslot(call11406);
  Object bool11407 = alloc_Boolean(1);
// compilenode returning bool11407
  gc_frame_newslot(bool11407);
  Object bool11408 = alloc_Boolean(0);
// compilenode returning bool11408
  gc_frame_newslot(bool11408);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  params[1] = call11406;
  params[2] = bool11407;
  params[3] = bool11408;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call11409 = callmethod(*var_suggestion, "deleteTokenRange()leading()trailing",
    3, partcv, params);
  gc_frame_end(callframe11404);
// compilenode returning call11409
// Begin line 3462
  setline(3462);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11410 = gc_frame_new();
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// compilenode returning *var_suggestions
  params[0] = *var_suggestion;
  partcv[0] = 1;
  Object call11411 = callmethod(*var_suggestions, "push",
    1, partcv, params);
  gc_frame_end(callframe11410);
// compilenode returning call11411
    gc_frame_newslot(call11411);
    if11341 = call11411;
  }
// compilenode returning if11341
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11412 = gc_frame_new();
  if (strlit11413 == NULL) {
    strlit11413 = alloc_String("Multiple statements must be separated by a newline or a semicolon. This is often caused by missing parentheses.");
    gc_root(strlit11413);
  }
// compilenode returning strlit11413
  gc_frame_newslot(strlit11413);
// Begin line 3465
  setline(3465);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11414 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11415 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11414);
// compilenode returning call11415
// compilenode returning call11415
  gc_frame_newslot(call11415);
  int callframe11416 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11417 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11416);
// compilenode returning call11417
// compilenode returning call11417
  gc_frame_newslot(call11417);
// compilenode returning *var_suggestions
  gc_frame_newslot(*var_suggestions);
// Begin line 3464
  setline(3464);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11413;
  params[1] = call11415;
  params[2] = call11417;
  params[3] = *var_suggestions;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call11418 = callmethod(*var_errormessages, "syntaxError()atPosition()withSuggestions",
    3, partcv, params);
  gc_frame_end(callframe11412);
// compilenode returning call11418
    gc_frame_newslot(call11418);
    if11192 = call11418;
  } else {
  }
// compilenode returning if11192
    gc_frame_newslot(if11192);
    if11100 = if11192;
  } else {
  }
// compilenode returning if11100
  gc_frame_end(frame);
  return if11100;
}
Object meth_parser__apply11545(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object num11547 = alloc_Float64(0);
// compilenode returning num11547
  int op_slot_right_11546 = gc_frame_newslot(num11547);
  int callframe11549 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11550 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11549);
// compilenode returning call11550
// compilenode returning call11550
  int op_slot_left_11546 = gc_frame_newslot(call11550);
  params[0] = num11547;
  partcv[0] = 1;
  Object opresult11551 = callmethod(call11550, ">", 1, partcv, params);
// compilenode returning opresult11551
  gc_frame_end(frame);
  return opresult11551;
}
Object meth_parser__apply11554(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[5];
  int partcv[3];
  Object *var_oldlength = getfromclosure(closure, 0);
  Object *var_tokens = getfromclosure(closure, 1);
  Object *var_errormessages = getfromclosure(closure, 2);
  Object *var_sym = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 3511
  setline(3511);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11555 = gc_frame_new();
  partcv[0] = 0;
  Object call11556 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11555);
// compilenode returning call11556
// Begin line 3512
  setline(3512);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11557 = gc_frame_new();
  partcv[0] = 0;
  Object call11558 = callmethodflags(self, "methoddec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11557);
// compilenode returning call11558
// Begin line 3513
  setline(3513);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11559 = gc_frame_new();
  partcv[0] = 0;
  Object call11560 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11559);
// compilenode returning call11560
// Begin line 3514
  setline(3514);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11561 = gc_frame_new();
  partcv[0] = 0;
  Object call11562 = callmethodflags(self, "inheritsdec", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11561);
// compilenode returning call11562
// Begin line 3515
  setline(3515);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11563 = gc_frame_new();
  partcv[0] = 0;
  Object call11564 = callmethodflags(self, "blank", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11563);
// compilenode returning call11564
// Begin line 3516
  setline(3516);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11565 = gc_frame_new();
  partcv[0] = 0;
  Object call11566 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11565);
// compilenode returning call11566
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3517
  setline(3517);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_oldlength
  int op_slot_right_11568 = gc_frame_newslot(*var_oldlength);
  int callframe11570 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11571 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11570);
// compilenode returning call11571
// compilenode returning call11571
  int op_slot_left_11568 = gc_frame_newslot(call11571);
  params[0] = *var_oldlength;
  partcv[0] = 1;
  Object opresult11572 = callmethod(call11571, "==", 1, partcv, params);
// compilenode returning opresult11572
  Object if11567 = done;
  if (istrue(opresult11572)) {
// Begin line 3519
  setline(3519);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3518
  setline(3518);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11573 = gc_frame_new();
  int callframe11574 = gc_frame_new();
// compilenode returning *var_errormessages
  partcv[0] = 0;
  Object call11575 = callmethod(*var_errormessages, "suggestion",
    1, partcv, params);
  gc_frame_end(callframe11574);
// compilenode returning call11575
// compilenode returning call11575
  partcv[0] = 0;
  Object call11576 = callmethod(call11575, "new",
    1, partcv, params);
  gc_frame_end(callframe11573);
// compilenode returning call11576
// compilenode returning call11576
  *var_suggestion = call11576;
  if (call11576 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3519
  setline(3519);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11577 = gc_frame_new();
// compilenode returning *var_sym
  gc_frame_newslot(*var_sym);
// compilenode returning *var_suggestion
  params[0] = *var_sym;
  partcv[0] = 1;
  Object call11578 = callmethod(*var_suggestion, "deleteToken",
    1, partcv, params);
  gc_frame_end(callframe11577);
// compilenode returning call11578
// Begin line 3520
  setline(3520);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11579 = gc_frame_new();
  if (strlit11580 == NULL) {
    strlit11580 = alloc_String("Invalid statement. This is often caused by an extra '}', ')', or ']'.");
    gc_root(strlit11580);
  }
// compilenode returning strlit11580
  gc_frame_newslot(strlit11580);
// Begin line 3521
  setline(3521);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11581 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11582 = callmethod(*var_sym, "line",
    1, partcv, params);
  gc_frame_end(callframe11581);
// compilenode returning call11582
// compilenode returning call11582
  gc_frame_newslot(call11582);
  int callframe11583 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11584 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11583);
// compilenode returning call11584
// compilenode returning call11584
  gc_frame_newslot(call11584);
  Object num11586 = alloc_Float64(1);
// compilenode returning num11586
  int op_slot_right_11585 = gc_frame_newslot(num11586);
  int callframe11589 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11590 = callmethod(*var_sym, "size",
    1, partcv, params);
  gc_frame_end(callframe11589);
// compilenode returning call11590
// compilenode returning call11590
  int op_slot_right_11588 = gc_frame_newslot(call11590);
  int callframe11592 = gc_frame_new();
// compilenode returning *var_sym
  partcv[0] = 0;
  Object call11593 = callmethod(*var_sym, "linePos",
    1, partcv, params);
  gc_frame_end(callframe11592);
// compilenode returning call11593
// compilenode returning call11593
  int op_slot_left_11588 = gc_frame_newslot(call11593);
  params[0] = call11590;
  partcv[0] = 1;
  Object sum11594 = callmethod(call11593, "+", 1, partcv, params);
// compilenode returning sum11594
  int op_slot_left_11585 = gc_frame_newslot(sum11594);
  params[0] = num11586;
  partcv[0] = 1;
  Object diff11595 = callmethod(sum11594, "-", 1, partcv, params);
// compilenode returning diff11595
  gc_frame_newslot(diff11595);
// compilenode returning *var_suggestion
  gc_frame_newslot(*var_suggestion);
// Begin line 3520
  setline(3520);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_errormessages
  params[0] = strlit11580;
  params[1] = call11582;
  params[2] = call11584;
  params[3] = diff11595;
  params[4] = *var_suggestion;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call11596 = callmethod(*var_errormessages, "syntaxError()atRange()withSuggestion",
    3, partcv, params);
  gc_frame_end(callframe11579);
// compilenode returning call11596
    gc_frame_newslot(call11596);
    if11567 = call11596;
  } else {
  }
// compilenode returning if11567
// Begin line 3524
  setline(3524);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11597 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11598 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11597);
// compilenode returning call11598
// compilenode returning call11598
  *var_oldlength = call11598;
  if (call11598 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_parse11419(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_defaultDefVisibility = getfromclosure(closure, 2);
  Object *var_defaultVarVisibility = getfromclosure(closure, 3);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_linenum = getfromclosure(closure, 8);
  Object *var_errormessages = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_oldlength = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldlength");
// Begin line 3473
  setline(3473);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11420 = gc_frame_new();
  if (strlit11421 == NULL) {
    strlit11421 = alloc_String("processing tokens.");
    gc_root(strlit11421);
  }
// compilenode returning strlit11421
  gc_frame_newslot(strlit11421);
// compilenode returning *var_util
  params[0] = strlit11421;
  partcv[0] = 1;
  Object call11422 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11420);
// compilenode returning call11422
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3474
  setline(3474);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11423 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11423
  *var_values = array11423;
  if (array11423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11426 = gc_frame_new();
  if (strlit11427 == NULL) {
    strlit11427 = alloc_String("DefaultVisibility");
    gc_root(strlit11427);
  }
// compilenode returning strlit11427
  gc_frame_newslot(strlit11427);
  int callframe11428 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11429 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11428);
// compilenode returning call11429
// compilenode returning call11429
  params[0] = strlit11427;
  partcv[0] = 1;
  Object call11430 = callmethod(call11429, "contains",
    1, partcv, params);
  gc_frame_end(callframe11426);
// compilenode returning call11430
  Object if11425 = done;
  if (istrue(call11430)) {
// Begin line 3476
  setline(3476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11431 = gc_frame_new();
  if (strlit11432 == NULL) {
    strlit11432 = alloc_String("DefaultVisibility");
    gc_root(strlit11432);
  }
// compilenode returning strlit11432
  gc_frame_newslot(strlit11432);
  int callframe11433 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11434 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11433);
// compilenode returning call11434
// compilenode returning call11434
  params[0] = strlit11432;
  partcv[0] = 1;
  Object call11435 = callmethod(call11434, "get",
    1, partcv, params);
  gc_frame_end(callframe11431);
// compilenode returning call11435
  *var_defaultDefVisibility = call11435;
  if (call11435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3477
  setline(3477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11437 = gc_frame_new();
  if (strlit11438 == NULL) {
    strlit11438 = alloc_String("DefaultVisibility");
    gc_root(strlit11438);
  }
// compilenode returning strlit11438
  gc_frame_newslot(strlit11438);
  int callframe11439 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11440 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11439);
// compilenode returning call11440
// compilenode returning call11440
  params[0] = strlit11438;
  partcv[0] = 1;
  Object call11441 = callmethod(call11440, "get",
    1, partcv, params);
  gc_frame_end(callframe11437);
// compilenode returning call11441
  *var_defaultVarVisibility = call11441;
  if (call11441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11443 = gc_frame_new();
  if (strlit11444 == NULL) {
    strlit11444 = alloc_String("DefaultVisibility");
    gc_root(strlit11444);
  }
// compilenode returning strlit11444
  gc_frame_newslot(strlit11444);
  int callframe11445 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11446 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11445);
// compilenode returning call11446
// compilenode returning call11446
  params[0] = strlit11444;
  partcv[0] = 1;
  Object call11447 = callmethod(call11446, "get",
    1, partcv, params);
  gc_frame_end(callframe11443);
// compilenode returning call11447
  *var_defaultMethodVisibility = call11447;
  if (call11447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11425 = done;
  } else {
  }
// compilenode returning if11425
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11450 = gc_frame_new();
  if (strlit11451 == NULL) {
    strlit11451 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11451);
  }
// compilenode returning strlit11451
  gc_frame_newslot(strlit11451);
  int callframe11452 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11453 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11452);
// compilenode returning call11453
// compilenode returning call11453
  params[0] = strlit11451;
  partcv[0] = 1;
  Object call11454 = callmethod(call11453, "contains",
    1, partcv, params);
  gc_frame_end(callframe11450);
// compilenode returning call11454
  Object if11449 = done;
  if (istrue(call11454)) {
// Begin line 3481
  setline(3481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11455 = gc_frame_new();
  if (strlit11456 == NULL) {
    strlit11456 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11456);
  }
// compilenode returning strlit11456
  gc_frame_newslot(strlit11456);
  int callframe11457 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11458 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11457);
// compilenode returning call11458
// compilenode returning call11458
  params[0] = strlit11456;
  partcv[0] = 1;
  Object call11459 = callmethod(call11458, "get",
    1, partcv, params);
  gc_frame_end(callframe11455);
// compilenode returning call11459
  *var_defaultDefVisibility = call11459;
  if (call11459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11449 = done;
  } else {
  }
// compilenode returning if11449
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11462 = gc_frame_new();
  if (strlit11463 == NULL) {
    strlit11463 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11463);
  }
// compilenode returning strlit11463
  gc_frame_newslot(strlit11463);
  int callframe11464 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11465 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11464);
// compilenode returning call11465
// compilenode returning call11465
  params[0] = strlit11463;
  partcv[0] = 1;
  Object call11466 = callmethod(call11465, "contains",
    1, partcv, params);
  gc_frame_end(callframe11462);
// compilenode returning call11466
  Object if11461 = done;
  if (istrue(call11466)) {
// Begin line 3484
  setline(3484);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11467 = gc_frame_new();
  if (strlit11468 == NULL) {
    strlit11468 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11468);
  }
// compilenode returning strlit11468
  gc_frame_newslot(strlit11468);
  int callframe11469 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11470 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11469);
// compilenode returning call11470
// compilenode returning call11470
  params[0] = strlit11468;
  partcv[0] = 1;
  Object call11471 = callmethod(call11470, "get",
    1, partcv, params);
  gc_frame_end(callframe11467);
// compilenode returning call11471
  *var_defaultVarVisibility = call11471;
  if (call11471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11461 = done;
  } else {
  }
// compilenode returning if11461
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11474 = gc_frame_new();
  if (strlit11475 == NULL) {
    strlit11475 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11475);
  }
// compilenode returning strlit11475
  gc_frame_newslot(strlit11475);
  int callframe11476 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11477 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11476);
// compilenode returning call11477
// compilenode returning call11477
  params[0] = strlit11475;
  partcv[0] = 1;
  Object call11478 = callmethod(call11477, "contains",
    1, partcv, params);
  gc_frame_end(callframe11474);
// compilenode returning call11478
  Object if11473 = done;
  if (istrue(call11478)) {
// Begin line 3487
  setline(3487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11479 = gc_frame_new();
  if (strlit11480 == NULL) {
    strlit11480 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11480);
  }
// compilenode returning strlit11480
  gc_frame_newslot(strlit11480);
  int callframe11481 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11482 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11481);
// compilenode returning call11482
// compilenode returning call11482
  params[0] = strlit11480;
  partcv[0] = 1;
  Object call11483 = callmethod(call11482, "get",
    1, partcv, params);
  gc_frame_end(callframe11479);
// compilenode returning call11483
  *var_defaultMethodVisibility = call11483;
  if (call11483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11473 = done;
  } else {
  }
// compilenode returning if11473
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11487 = alloc_Float64(0);
// compilenode returning num11487
  int op_slot_right_11486 = gc_frame_newslot(num11487);
  int callframe11489 = gc_frame_new();
// compilenode returning *var_toks
  partcv[0] = 0;
  Object call11490 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe11489);
// compilenode returning call11490
// compilenode returning call11490
  int op_slot_left_11486 = gc_frame_newslot(call11490);
  params[0] = num11487;
  partcv[0] = 1;
  Object opresult11491 = callmethod(call11490, "==", 1, partcv, params);
// compilenode returning opresult11491
  Object if11485 = done;
  if (istrue(opresult11491)) {
// Begin line 3491
  setline(3491);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11492 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11492
  return array11492;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if11485 = undefined;
  } else {
  }
// compilenode returning if11485
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_toks
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11494 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11495 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe11494);
// compilenode returning call11495
// compilenode returning call11495
  *var_sym = call11495;
  if (call11495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11497 = gc_frame_new();
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_sym
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call11498 = callmethod(*var_sym, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe11497);
// compilenode returning call11498
// compilenode returning done
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11499 = gc_frame_new();
  Object inheritingObject11500 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11500 = alloc_userobj2(15,9, objclass11500);
  gc_frame_newslot(obj11500);
// OBJECT OUTER DEC outer
  adddatum2(obj11500, self, 0);
  addmethodreal(obj11500,"outer", &reader_parser_outer_11501);
  Object oldself11500 = self;
  struct StackFrameObject *oldstackframe11500 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11500);
  gc_frame_newslot((Object)stackframe);
  self = obj11500;
  Object *oldselfslot11500 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11500 = (*(struct UserObject *)self).data[0], lowerouter11500 = thisouter11500;
  if (inheritingObject11500) {
    struct UserObject *inho11500 = (struct UserObject *)inheritingObject11500;
    while (inho11500->super != GraceDefaultObject) inho11500 = (struct UserObject *)inho11500->super;
    inho11500->super = obj11500;
    self = inheritingObject11500;
    *selfslot = self;
    lowerouter11500 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11500;
  }
if (objclass11500 == NULL) {
  Method *reader11502 = addmethodrealflags(obj11500, "kind",&reader_parser_kind_11502, 0);
  Method *writer11502 = addmethodrealflags(obj11500, "kind:=",&writer_parser_kind_11502, 0);
  reader11502->definitionModule = modulename;
  writer11502->definitionModule = modulename;
  reader11502->definitionLine = 3498;
  writer11502->definitionLine = 3498;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 1);
if (objclass11500 == NULL) {
  Method *reader11503 = addmethodrealflags(obj11500, "line",&reader_parser_line_11503, 0);
  Method *writer11503 = addmethodrealflags(obj11500, "line:=",&writer_parser_line_11503, 0);
  reader11503->definitionModule = modulename;
  writer11503->definitionModule = modulename;
  reader11503->definitionLine = 3499;
  writer11503->definitionLine = 3499;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 2);
if (objclass11500 == NULL) {
  Method *reader11504 = addmethodrealflags(obj11500, "linePos",&reader_parser_linePos_11504, 0);
  Method *writer11504 = addmethodrealflags(obj11500, "linePos:=",&writer_parser_linePos_11504, 0);
  reader11504->definitionModule = modulename;
  writer11504->definitionModule = modulename;
  reader11504->definitionLine = 3500;
  writer11504->definitionLine = 3500;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 3);
if (objclass11500 == NULL) {
  Method *reader11505 = addmethodrealflags(obj11500, "indent",&reader_parser_indent_11505, 0);
  Method *writer11505 = addmethodrealflags(obj11500, "indent:=",&writer_parser_indent_11505, 0);
  reader11505->definitionModule = modulename;
  writer11505->definitionModule = modulename;
  reader11505->definitionLine = 3501;
  writer11505->definitionLine = 3501;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 4);
if (objclass11500 == NULL) {
  Method *reader11506 = addmethodrealflags(obj11500, "value",&reader_parser_value_11506, 0);
  Method *writer11506 = addmethodrealflags(obj11500, "value:=",&writer_parser_value_11506, 0);
  reader11506->definitionModule = modulename;
  writer11506->definitionModule = modulename;
  reader11506->definitionLine = 3502;
  writer11506->definitionLine = 3502;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 5);
if (objclass11500 == NULL) {
  Method *reader11507 = addmethodrealflags(obj11500, "size",&reader_parser_size_11507, MFLAG_DEF);
  reader11507->definitionModule = modulename;
  reader11507->definitionLine = 3503;
}
adddatum2(obj11500, alloc_Undefined(), 6);
if (objclass11500 == NULL) {
  Method *reader11508 = addmethodrealflags(obj11500, "next",&reader_parser_next_11508, 0);
  Method *writer11508 = addmethodrealflags(obj11500, "next:=",&writer_parser_next_11508, 0);
  reader11508->definitionModule = modulename;
  writer11508->definitionModule = modulename;
  reader11508->definitionLine = 3504;
  writer11508->definitionLine = 3504;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 7);
if (objclass11500 == NULL) {
  Method *reader11509 = addmethodrealflags(obj11500, "prev",&reader_parser_prev_11509, 0);
  Method *writer11509 = addmethodrealflags(obj11500, "prev:=",&writer_parser_prev_11509, 0);
  reader11509->definitionModule = modulename;
  writer11509->definitionModule = modulename;
  reader11509->definitionLine = 3505;
  writer11509->definitionLine = 3505;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 8);
  sourceObject = obj11500;
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11510 == NULL) {
    strlit11510 = alloc_String("eof");
    gc_root(strlit11510);
  }
// compilenode returning strlit11510
  adddatum2(obj11500, strlit11510, 1);
  sourceObject = obj11500;
// Begin line 3498
  setline(3498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11511 = gc_frame_new();
  int callframe11512 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11513 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11512);
// compilenode returning call11513
// compilenode returning call11513
  partcv[0] = 0;
  Object call11514 = callmethod(call11513, "line",
    1, partcv, params);
  gc_frame_end(callframe11511);
// compilenode returning call11514
// compilenode returning call11514
  adddatum2(obj11500, call11514, 2);
  sourceObject = obj11500;
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3499
  setline(3499);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11516 = alloc_Float64(1);
// compilenode returning num11516
  int op_slot_right_11515 = gc_frame_newslot(num11516);
  int callframe11518 = gc_frame_new();
  int callframe11519 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11520 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11519);
// compilenode returning call11520
// compilenode returning call11520
  int callframe11521 = gc_frame_new();
  int callframe11522 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11523 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11522);
// compilenode returning call11523
// compilenode returning call11523
  partcv[0] = 0;
  Object call11524 = callmethod(call11523, "line",
    1, partcv, params);
  gc_frame_end(callframe11521);
// compilenode returning call11524
// compilenode returning call11524
  params[0] = call11524;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11525 = callmethod(call11520, "[]", 1, partcv, params);
// compilenode returning idxres11525
  partcv[0] = 0;
  Object call11526 = callmethod(idxres11525, "size",
    1, partcv, params);
  gc_frame_end(callframe11518);
// compilenode returning call11526
// compilenode returning call11526
  int op_slot_left_11515 = gc_frame_newslot(call11526);
  params[0] = num11516;
  partcv[0] = 1;
  Object sum11527 = callmethod(call11526, "+", 1, partcv, params);
// compilenode returning sum11527
  adddatum2(obj11500, sum11527, 3);
  sourceObject = obj11500;
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11528 = alloc_Float64(0);
// compilenode returning num11528
  adddatum2(obj11500, num11528, 4);
  sourceObject = obj11500;
// Begin line 3501
  setline(3501);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11529 == NULL) {
    strlit11529 = alloc_String("");
    gc_root(strlit11529);
  }
// compilenode returning strlit11529
  adddatum2(obj11500, strlit11529, 5);
  sourceObject = obj11500;
// Begin line 3502
  setline(3502);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11530 = alloc_Float64(0);
// compilenode returning num11530
  adddatum2(obj11500, num11530, 6);
  sourceObject = obj11500;
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11531 = alloc_Boolean(0);
// compilenode returning bool11531
  adddatum2(obj11500, bool11531, 7);
  sourceObject = obj11500;
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11532 = alloc_Boolean(0);
// compilenode returning bool11532
  adddatum2(obj11500, bool11532, 8);
objclass11500 = obj11500->class;
  objclass11500->definitionModule = modulename;
  objclass11500->definitionLine = 3496;
  (*(struct UserObject *)self).data[0] = lowerouter11500;
  self = oldself11500;
  selfslot = oldselfslot11500;
  stackframe = oldstackframe11500;
// compilenode returning obj11500
  gc_frame_newslot(obj11500);
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_tokens
  params[0] = obj11500;
  partcv[0] = 1;
  Object call11533 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe11499);
// compilenode returning call11533
// Begin line 3506
  setline(3506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11534 = gc_frame_new();
  if (strlit11535 == NULL) {
    strlit11535 = alloc_String("parsing.");
    gc_root(strlit11535);
  }
// compilenode returning strlit11535
  gc_frame_newslot(strlit11535);
// compilenode returning *var_util
  params[0] = strlit11535;
  partcv[0] = 1;
  Object call11536 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11534);
// compilenode returning call11536
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11537 = alloc_Float64(1);
// compilenode returning num11537
  *var_linenum = num11537;
  if (num11537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11539 = gc_frame_new();
  partcv[0] = 0;
  Object call11540 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11539);
// compilenode returning call11540
// Begin line 3510
  setline(3510);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3509
  setline(3509);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11541 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11542 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11541);
// compilenode returning call11542
// compilenode returning call11542
  *var_oldlength = call11542;
  if (call11542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3510
  setline(3510);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11543 = gc_frame_new();
  Object block11544 = alloc_Block(NULL, NULL, "parser", 3510);
  gc_frame_newslot(block11544);
  block_savedest(block11544);
  Object closure11545 = createclosure(2, "_apply");
setclosureframe(closure11545, stackframe);
  addtoclosure(closure11545, var_tokens);
  addtoclosure(closure11545, selfslot);
  struct UserObject *uo11545 = (struct UserObject*)block11544;
  uo11545->data[0] = (Object)closure11545;
  Method *meth_meth_parser__apply11545 = addmethod2pos(block11544, "_apply", &meth_parser__apply11545, 0);
int argcv_meth_parser__apply11545[] = {0};
meth_meth_parser__apply11545->type = alloc_MethodType(1, argcv_meth_parser__apply11545);
  meth_meth_parser__apply11545->definitionModule = modulename;
  meth_meth_parser__apply11545->definitionLine = 3509;
// compilenode returning block11544
  gc_frame_newslot(block11544);
  Object block11553 = alloc_Block(NULL, NULL, "parser", 3510);
  gc_frame_newslot(block11553);
  block_savedest(block11553);
  Object closure11554 = createclosure(5, "_apply");
setclosureframe(closure11554, stackframe);
  addtoclosure(closure11554, var_oldlength);
  addtoclosure(closure11554, var_tokens);
  addtoclosure(closure11554, var_errormessages);
  addtoclosure(closure11554, var_sym);
  addtoclosure(closure11554, selfslot);
  struct UserObject *uo11554 = (struct UserObject*)block11553;
  uo11554->data[0] = (Object)closure11554;
  Method *meth_meth_parser__apply11554 = addmethod2pos(block11553, "_apply", &meth_parser__apply11554, 0);
int argcv_meth_parser__apply11554[] = {0};
meth_meth_parser__apply11554->type = alloc_MethodType(1, argcv_meth_parser__apply11554);
  meth_meth_parser__apply11554->definitionModule = modulename;
  meth_meth_parser__apply11554->definitionLine = 3510;
// compilenode returning block11553
  gc_frame_newslot(block11553);
  params[0] = block11544;
  params[1] = block11553;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11601 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11543);
// compilenode returning call11601
// Begin line 3525
  setline(3525);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11602 = gc_frame_new();
  partcv[0] = 0;
  Object call11603 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11602);
// compilenode returning call11603
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_parse11419_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 59, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "parse()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[2];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_values = getfromclosure(closure, 1);
  Object *var_defaultDefVisibility = getfromclosure(closure, 2);
  Object *var_defaultVarVisibility = getfromclosure(closure, 3);
  Object *var_defaultMethodVisibility = getfromclosure(closure, 4);
  Object *var_tokens = getfromclosure(closure, 5);
  Object *var_sym = getfromclosure(closure, 6);
  Object *var_lastToken = getfromclosure(closure, 7);
  Object *var_linenum = getfromclosure(closure, 8);
  Object *var_errormessages = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for parse (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_toks = &(stackframe->slots[0]);
  *var_toks = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for parse");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_oldlength = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "oldlength");
// Begin line 3473
  setline(3473);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11420 = gc_frame_new();
  if (strlit11421 == NULL) {
    strlit11421 = alloc_String("processing tokens.");
    gc_root(strlit11421);
  }
// compilenode returning strlit11421
  gc_frame_newslot(strlit11421);
// compilenode returning *var_util
  params[0] = strlit11421;
  partcv[0] = 1;
  Object call11422 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11420);
// compilenode returning call11422
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3474
  setline(3474);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11423 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11423
  *var_values = array11423;
  if (array11423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3475
  setline(3475);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11426 = gc_frame_new();
  if (strlit11427 == NULL) {
    strlit11427 = alloc_String("DefaultVisibility");
    gc_root(strlit11427);
  }
// compilenode returning strlit11427
  gc_frame_newslot(strlit11427);
  int callframe11428 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11429 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11428);
// compilenode returning call11429
// compilenode returning call11429
  params[0] = strlit11427;
  partcv[0] = 1;
  Object call11430 = callmethod(call11429, "contains",
    1, partcv, params);
  gc_frame_end(callframe11426);
// compilenode returning call11430
  Object if11425 = done;
  if (istrue(call11430)) {
// Begin line 3476
  setline(3476);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11431 = gc_frame_new();
  if (strlit11432 == NULL) {
    strlit11432 = alloc_String("DefaultVisibility");
    gc_root(strlit11432);
  }
// compilenode returning strlit11432
  gc_frame_newslot(strlit11432);
  int callframe11433 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11434 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11433);
// compilenode returning call11434
// compilenode returning call11434
  params[0] = strlit11432;
  partcv[0] = 1;
  Object call11435 = callmethod(call11434, "get",
    1, partcv, params);
  gc_frame_end(callframe11431);
// compilenode returning call11435
  *var_defaultDefVisibility = call11435;
  if (call11435 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3477
  setline(3477);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11437 = gc_frame_new();
  if (strlit11438 == NULL) {
    strlit11438 = alloc_String("DefaultVisibility");
    gc_root(strlit11438);
  }
// compilenode returning strlit11438
  gc_frame_newslot(strlit11438);
  int callframe11439 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11440 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11439);
// compilenode returning call11440
// compilenode returning call11440
  params[0] = strlit11438;
  partcv[0] = 1;
  Object call11441 = callmethod(call11440, "get",
    1, partcv, params);
  gc_frame_end(callframe11437);
// compilenode returning call11441
  *var_defaultVarVisibility = call11441;
  if (call11441 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3478
  setline(3478);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11443 = gc_frame_new();
  if (strlit11444 == NULL) {
    strlit11444 = alloc_String("DefaultVisibility");
    gc_root(strlit11444);
  }
// compilenode returning strlit11444
  gc_frame_newslot(strlit11444);
  int callframe11445 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11446 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11445);
// compilenode returning call11446
// compilenode returning call11446
  params[0] = strlit11444;
  partcv[0] = 1;
  Object call11447 = callmethod(call11446, "get",
    1, partcv, params);
  gc_frame_end(callframe11443);
// compilenode returning call11447
  *var_defaultMethodVisibility = call11447;
  if (call11447 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11425 = done;
  } else {
  }
// compilenode returning if11425
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3480
  setline(3480);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11450 = gc_frame_new();
  if (strlit11451 == NULL) {
    strlit11451 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11451);
  }
// compilenode returning strlit11451
  gc_frame_newslot(strlit11451);
  int callframe11452 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11453 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11452);
// compilenode returning call11453
// compilenode returning call11453
  params[0] = strlit11451;
  partcv[0] = 1;
  Object call11454 = callmethod(call11453, "contains",
    1, partcv, params);
  gc_frame_end(callframe11450);
// compilenode returning call11454
  Object if11449 = done;
  if (istrue(call11454)) {
// Begin line 3481
  setline(3481);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11455 = gc_frame_new();
  if (strlit11456 == NULL) {
    strlit11456 = alloc_String("DefaultDefVisibility");
    gc_root(strlit11456);
  }
// compilenode returning strlit11456
  gc_frame_newslot(strlit11456);
  int callframe11457 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11458 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11457);
// compilenode returning call11458
// compilenode returning call11458
  params[0] = strlit11456;
  partcv[0] = 1;
  Object call11459 = callmethod(call11458, "get",
    1, partcv, params);
  gc_frame_end(callframe11455);
// compilenode returning call11459
  *var_defaultDefVisibility = call11459;
  if (call11459 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11449 = done;
  } else {
  }
// compilenode returning if11449
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3483
  setline(3483);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11462 = gc_frame_new();
  if (strlit11463 == NULL) {
    strlit11463 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11463);
  }
// compilenode returning strlit11463
  gc_frame_newslot(strlit11463);
  int callframe11464 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11465 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11464);
// compilenode returning call11465
// compilenode returning call11465
  params[0] = strlit11463;
  partcv[0] = 1;
  Object call11466 = callmethod(call11465, "contains",
    1, partcv, params);
  gc_frame_end(callframe11462);
// compilenode returning call11466
  Object if11461 = done;
  if (istrue(call11466)) {
// Begin line 3484
  setline(3484);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11467 = gc_frame_new();
  if (strlit11468 == NULL) {
    strlit11468 = alloc_String("DefaultVarVisibility");
    gc_root(strlit11468);
  }
// compilenode returning strlit11468
  gc_frame_newslot(strlit11468);
  int callframe11469 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11470 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11469);
// compilenode returning call11470
// compilenode returning call11470
  params[0] = strlit11468;
  partcv[0] = 1;
  Object call11471 = callmethod(call11470, "get",
    1, partcv, params);
  gc_frame_end(callframe11467);
// compilenode returning call11471
  *var_defaultVarVisibility = call11471;
  if (call11471 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11461 = done;
  } else {
  }
// compilenode returning if11461
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3486
  setline(3486);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11474 = gc_frame_new();
  if (strlit11475 == NULL) {
    strlit11475 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11475);
  }
// compilenode returning strlit11475
  gc_frame_newslot(strlit11475);
  int callframe11476 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11477 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11476);
// compilenode returning call11477
// compilenode returning call11477
  params[0] = strlit11475;
  partcv[0] = 1;
  Object call11478 = callmethod(call11477, "contains",
    1, partcv, params);
  gc_frame_end(callframe11474);
// compilenode returning call11478
  Object if11473 = done;
  if (istrue(call11478)) {
// Begin line 3487
  setline(3487);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11479 = gc_frame_new();
  if (strlit11480 == NULL) {
    strlit11480 = alloc_String("DefaultMethodVisibility");
    gc_root(strlit11480);
  }
// compilenode returning strlit11480
  gc_frame_newslot(strlit11480);
  int callframe11481 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11482 = callmethod(*var_util, "extensions",
    1, partcv, params);
  gc_frame_end(callframe11481);
// compilenode returning call11482
// compilenode returning call11482
  params[0] = strlit11480;
  partcv[0] = 1;
  Object call11483 = callmethod(call11482, "get",
    1, partcv, params);
  gc_frame_end(callframe11479);
// compilenode returning call11483
  *var_defaultMethodVisibility = call11483;
  if (call11483 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
    gc_frame_newslot(done);
    if11473 = done;
  } else {
  }
// compilenode returning if11473
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3489
  setline(3489);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11487 = alloc_Float64(0);
// compilenode returning num11487
  int op_slot_right_11486 = gc_frame_newslot(num11487);
  int callframe11489 = gc_frame_new();
// compilenode returning *var_toks
  partcv[0] = 0;
  Object call11490 = callmethod(*var_toks, "size",
    1, partcv, params);
  gc_frame_end(callframe11489);
// compilenode returning call11490
// compilenode returning call11490
  int op_slot_left_11486 = gc_frame_newslot(call11490);
  params[0] = num11487;
  partcv[0] = 1;
  Object opresult11491 = callmethod(call11490, "==", 1, partcv, params);
// compilenode returning opresult11491
  Object if11485 = done;
  if (istrue(opresult11491)) {
// Begin line 3491
  setline(3491);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3490
  setline(3490);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11492 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11492
  return array11492;
// compilenode returning undefined
    gc_frame_newslot(undefined);
    if11485 = undefined;
  } else {
  }
// compilenode returning if11485
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3492
  setline(3492);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_toks
  *var_tokens = *var_toks;
  if (*var_toks == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11494 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11495 = callmethod(*var_tokens, "first",
    1, partcv, params);
  gc_frame_end(callframe11494);
// compilenode returning call11495
// compilenode returning call11495
  *var_sym = call11495;
  if (call11495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3493
  setline(3493);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11497 = gc_frame_new();
// Begin line 3494
  setline(3494);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  gc_frame_newslot(*var_lastToken);
// compilenode returning *var_sym
  params[0] = *var_lastToken;
  partcv[0] = 1;
  Object call11498 = callmethod(*var_sym, "prev:=",
    1, partcv, params);
  gc_frame_end(callframe11497);
// compilenode returning call11498
// compilenode returning done
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11499 = gc_frame_new();
  Object inheritingObject11500 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11500 = alloc_userobj2(15,9, objclass11500);
  gc_frame_newslot(obj11500);
// OBJECT OUTER DEC outer
  adddatum2(obj11500, self, 0);
  addmethodreal(obj11500,"outer", &reader_parser_outer_11501);
  Object oldself11500 = self;
  struct StackFrameObject *oldstackframe11500 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11500);
  gc_frame_newslot((Object)stackframe);
  self = obj11500;
  Object *oldselfslot11500 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11500 = (*(struct UserObject *)self).data[0], lowerouter11500 = thisouter11500;
  if (inheritingObject11500) {
    struct UserObject *inho11500 = (struct UserObject *)inheritingObject11500;
    while (inho11500->super != GraceDefaultObject) inho11500 = (struct UserObject *)inho11500->super;
    inho11500->super = obj11500;
    self = inheritingObject11500;
    *selfslot = self;
    lowerouter11500 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11500;
  }
if (objclass11500 == NULL) {
  Method *reader11502 = addmethodrealflags(obj11500, "kind",&reader_parser_kind_11502, 0);
  Method *writer11502 = addmethodrealflags(obj11500, "kind:=",&writer_parser_kind_11502, 0);
  reader11502->definitionModule = modulename;
  writer11502->definitionModule = modulename;
  reader11502->definitionLine = 3498;
  writer11502->definitionLine = 3498;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 1);
if (objclass11500 == NULL) {
  Method *reader11503 = addmethodrealflags(obj11500, "line",&reader_parser_line_11503, 0);
  Method *writer11503 = addmethodrealflags(obj11500, "line:=",&writer_parser_line_11503, 0);
  reader11503->definitionModule = modulename;
  writer11503->definitionModule = modulename;
  reader11503->definitionLine = 3499;
  writer11503->definitionLine = 3499;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 2);
if (objclass11500 == NULL) {
  Method *reader11504 = addmethodrealflags(obj11500, "linePos",&reader_parser_linePos_11504, 0);
  Method *writer11504 = addmethodrealflags(obj11500, "linePos:=",&writer_parser_linePos_11504, 0);
  reader11504->definitionModule = modulename;
  writer11504->definitionModule = modulename;
  reader11504->definitionLine = 3500;
  writer11504->definitionLine = 3500;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 3);
if (objclass11500 == NULL) {
  Method *reader11505 = addmethodrealflags(obj11500, "indent",&reader_parser_indent_11505, 0);
  Method *writer11505 = addmethodrealflags(obj11500, "indent:=",&writer_parser_indent_11505, 0);
  reader11505->definitionModule = modulename;
  writer11505->definitionModule = modulename;
  reader11505->definitionLine = 3501;
  writer11505->definitionLine = 3501;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 4);
if (objclass11500 == NULL) {
  Method *reader11506 = addmethodrealflags(obj11500, "value",&reader_parser_value_11506, 0);
  Method *writer11506 = addmethodrealflags(obj11500, "value:=",&writer_parser_value_11506, 0);
  reader11506->definitionModule = modulename;
  writer11506->definitionModule = modulename;
  reader11506->definitionLine = 3502;
  writer11506->definitionLine = 3502;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 5);
if (objclass11500 == NULL) {
  Method *reader11507 = addmethodrealflags(obj11500, "size",&reader_parser_size_11507, MFLAG_DEF);
  reader11507->definitionModule = modulename;
  reader11507->definitionLine = 3503;
}
adddatum2(obj11500, alloc_Undefined(), 6);
if (objclass11500 == NULL) {
  Method *reader11508 = addmethodrealflags(obj11500, "next",&reader_parser_next_11508, 0);
  Method *writer11508 = addmethodrealflags(obj11500, "next:=",&writer_parser_next_11508, 0);
  reader11508->definitionModule = modulename;
  writer11508->definitionModule = modulename;
  reader11508->definitionLine = 3504;
  writer11508->definitionLine = 3504;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 7);
if (objclass11500 == NULL) {
  Method *reader11509 = addmethodrealflags(obj11500, "prev",&reader_parser_prev_11509, 0);
  Method *writer11509 = addmethodrealflags(obj11500, "prev:=",&writer_parser_prev_11509, 0);
  reader11509->definitionModule = modulename;
  writer11509->definitionModule = modulename;
  reader11509->definitionLine = 3505;
  writer11509->definitionLine = 3505;
}
obj11500->flags |= OFLAG_MUTABLE;
adddatum2(obj11500, alloc_Undefined(), 8);
  sourceObject = obj11500;
// Begin line 3497
  setline(3497);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11510 == NULL) {
    strlit11510 = alloc_String("eof");
    gc_root(strlit11510);
  }
// compilenode returning strlit11510
  adddatum2(obj11500, strlit11510, 1);
  sourceObject = obj11500;
// Begin line 3498
  setline(3498);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11511 = gc_frame_new();
  int callframe11512 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11513 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11512);
// compilenode returning call11513
// compilenode returning call11513
  partcv[0] = 0;
  Object call11514 = callmethod(call11513, "line",
    1, partcv, params);
  gc_frame_end(callframe11511);
// compilenode returning call11514
// compilenode returning call11514
  adddatum2(obj11500, call11514, 2);
  sourceObject = obj11500;
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3499
  setline(3499);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11516 = alloc_Float64(1);
// compilenode returning num11516
  int op_slot_right_11515 = gc_frame_newslot(num11516);
  int callframe11518 = gc_frame_new();
  int callframe11519 = gc_frame_new();
// compilenode returning *var_util
  partcv[0] = 0;
  Object call11520 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe11519);
// compilenode returning call11520
// compilenode returning call11520
  int callframe11521 = gc_frame_new();
  int callframe11522 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11523 = callmethod(*var_tokens, "last",
    1, partcv, params);
  gc_frame_end(callframe11522);
// compilenode returning call11523
// compilenode returning call11523
  partcv[0] = 0;
  Object call11524 = callmethod(call11523, "line",
    1, partcv, params);
  gc_frame_end(callframe11521);
// compilenode returning call11524
// compilenode returning call11524
  params[0] = call11524;
  gc_frame_newslot(params[0]);
  partcv[0] = 1;
  Object idxres11525 = callmethod(call11520, "[]", 1, partcv, params);
// compilenode returning idxres11525
  partcv[0] = 0;
  Object call11526 = callmethod(idxres11525, "size",
    1, partcv, params);
  gc_frame_end(callframe11518);
// compilenode returning call11526
// compilenode returning call11526
  int op_slot_left_11515 = gc_frame_newslot(call11526);
  params[0] = num11516;
  partcv[0] = 1;
  Object sum11527 = callmethod(call11526, "+", 1, partcv, params);
// compilenode returning sum11527
  adddatum2(obj11500, sum11527, 3);
  sourceObject = obj11500;
// Begin line 3500
  setline(3500);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11528 = alloc_Float64(0);
// compilenode returning num11528
  adddatum2(obj11500, num11528, 4);
  sourceObject = obj11500;
// Begin line 3501
  setline(3501);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11529 == NULL) {
    strlit11529 = alloc_String("");
    gc_root(strlit11529);
  }
// compilenode returning strlit11529
  adddatum2(obj11500, strlit11529, 5);
  sourceObject = obj11500;
// Begin line 3502
  setline(3502);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11530 = alloc_Float64(0);
// compilenode returning num11530
  adddatum2(obj11500, num11530, 6);
  sourceObject = obj11500;
// Begin line 3503
  setline(3503);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11531 = alloc_Boolean(0);
// compilenode returning bool11531
  adddatum2(obj11500, bool11531, 7);
  sourceObject = obj11500;
// Begin line 3504
  setline(3504);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11532 = alloc_Boolean(0);
// compilenode returning bool11532
  adddatum2(obj11500, bool11532, 8);
objclass11500 = obj11500->class;
  objclass11500->definitionModule = modulename;
  objclass11500->definitionLine = 3496;
  (*(struct UserObject *)self).data[0] = lowerouter11500;
  self = oldself11500;
  selfslot = oldselfslot11500;
  stackframe = oldstackframe11500;
// compilenode returning obj11500
  gc_frame_newslot(obj11500);
// Begin line 3496
  setline(3496);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_tokens
  params[0] = obj11500;
  partcv[0] = 1;
  Object call11533 = callmethod(*var_tokens, "push",
    1, partcv, params);
  gc_frame_end(callframe11499);
// compilenode returning call11533
// Begin line 3506
  setline(3506);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11534 = gc_frame_new();
  if (strlit11535 == NULL) {
    strlit11535 = alloc_String("parsing.");
    gc_root(strlit11535);
  }
// compilenode returning strlit11535
  gc_frame_newslot(strlit11535);
// compilenode returning *var_util
  params[0] = strlit11535;
  partcv[0] = 1;
  Object call11536 = callmethod(*var_util, "log_verbose",
    1, partcv, params);
  gc_frame_end(callframe11534);
// compilenode returning call11536
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3507
  setline(3507);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11537 = alloc_Float64(1);
// compilenode returning num11537
  *var_linenum = num11537;
  if (num11537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3508
  setline(3508);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11539 = gc_frame_new();
  partcv[0] = 0;
  Object call11540 = callmethodflags(self, "next", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11539);
// compilenode returning call11540
// Begin line 3510
  setline(3510);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 3509
  setline(3509);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11541 = gc_frame_new();
// compilenode returning *var_tokens
  partcv[0] = 0;
  Object call11542 = callmethod(*var_tokens, "size",
    1, partcv, params);
  gc_frame_end(callframe11541);
// compilenode returning call11542
// compilenode returning call11542
  *var_oldlength = call11542;
  if (call11542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
// Begin line 3510
  setline(3510);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11543 = gc_frame_new();
  Object block11544 = alloc_Block(NULL, NULL, "parser", 3510);
  gc_frame_newslot(block11544);
  block_savedest(block11544);
  Object closure11545 = createclosure(2, "_apply");
setclosureframe(closure11545, stackframe);
  addtoclosure(closure11545, var_tokens);
  addtoclosure(closure11545, selfslot);
  struct UserObject *uo11545 = (struct UserObject*)block11544;
  uo11545->data[0] = (Object)closure11545;
  Method *meth_meth_parser__apply11545 = addmethod2pos(block11544, "_apply", &meth_parser__apply11545, 0);
int argcv_meth_parser__apply11545[] = {0};
meth_meth_parser__apply11545->type = alloc_MethodType(1, argcv_meth_parser__apply11545);
  meth_meth_parser__apply11545->definitionModule = modulename;
  meth_meth_parser__apply11545->definitionLine = 3509;
// compilenode returning block11544
  gc_frame_newslot(block11544);
  Object block11553 = alloc_Block(NULL, NULL, "parser", 3510);
  gc_frame_newslot(block11553);
  block_savedest(block11553);
  Object closure11554 = createclosure(5, "_apply");
setclosureframe(closure11554, stackframe);
  addtoclosure(closure11554, var_oldlength);
  addtoclosure(closure11554, var_tokens);
  addtoclosure(closure11554, var_errormessages);
  addtoclosure(closure11554, var_sym);
  addtoclosure(closure11554, selfslot);
  struct UserObject *uo11554 = (struct UserObject*)block11553;
  uo11554->data[0] = (Object)closure11554;
  Method *meth_meth_parser__apply11554 = addmethod2pos(block11553, "_apply", &meth_parser__apply11554, 0);
int argcv_meth_parser__apply11554[] = {0};
meth_meth_parser__apply11554->type = alloc_MethodType(1, argcv_meth_parser__apply11554);
  meth_meth_parser__apply11554->definitionModule = modulename;
  meth_meth_parser__apply11554->definitionLine = 3510;
// compilenode returning block11553
  gc_frame_newslot(block11553);
  params[0] = block11544;
  params[1] = block11553;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call11601 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11543);
// compilenode returning call11601
// Begin line 3525
  setline(3525);
  setmodule(modulename);
  setsource(originalSourceLines);
  int callframe11602 = gc_frame_new();
  partcv[0] = 0;
  Object call11603 = callmethodflags(self, "statement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe11602);
// compilenode returning call11603
// Begin line 3526
  setline(3526);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_don_39_tBreak11606(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 60, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "don'tBreak");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_don_39_tBreak = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for don'tBreak (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[don'tBreak]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_don_39_tBreak
  gc_frame_end(frame);
  return *var_don_39_tBreak;
}
Object meth_parser_lastline11608(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 61, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastline");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastline = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastline (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[lastline]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastline
  gc_frame_end(frame);
  return *var_lastline;
}
Object meth_parser_lastline_58__61_11609(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 62, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastline:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastline = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastline:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[lastline:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_lastline = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_linenum11612(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 63, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "linenum");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_linenum = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linenum (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[linenum]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_linenum
  gc_frame_end(frame);
  return *var_linenum;
}
Object meth_parser_linenum_58__61_11613(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 64, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "linenum:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_linenum = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for linenum:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[linenum:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_linenum = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastIndent11616(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 65, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[lastIndent]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastIndent
  gc_frame_end(frame);
  return *var_lastIndent;
}
Object meth_parser_lastIndent_58__61_11617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 66, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[lastIndent:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_lastIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_indentFreePass11620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 67, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[indentFreePass]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_indentFreePass
  gc_frame_end(frame);
  return *var_indentFreePass;
}
Object meth_parser_indentFreePass_58__61_11621(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 68, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indentFreePass:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_indentFreePass = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for indentFreePass:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[indentFreePass:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_indentFreePass = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_minIndentLevel11624(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 69, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[minIndentLevel]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_minIndentLevel
  gc_frame_end(frame);
  return *var_minIndentLevel;
}
Object meth_parser_minIndentLevel_58__61_11625(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 70, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "minIndentLevel:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_minIndentLevel = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for minIndentLevel:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[minIndentLevel:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_minIndentLevel = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementIndent11628(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 71, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[statementIndent]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_statementIndent
  gc_frame_end(frame);
  return *var_statementIndent;
}
Object meth_parser_statementIndent_58__61_11629(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 72, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementIndent:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_statementIndent = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementIndent:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[statementIndent:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_statementIndent = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_statementToken11631(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 73, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[statementToken]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_statementToken
  gc_frame_end(frame);
  return *var_statementToken;
}
Object meth_parser_statementToken_58__61_11632(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 74, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "statementToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_statementToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for statementToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[statementToken:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_statementToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_tokens11635(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 75, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[tokens]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_tokens
  gc_frame_end(frame);
  return *var_tokens;
}
Object meth_parser_tokens_58__61_11636(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 76, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "tokens:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_tokens = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for tokens:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[tokens:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_tokens = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_values11639(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 77, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[values]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_values
  gc_frame_end(frame);
  return *var_values;
}
Object meth_parser_values_58__61_11640(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 78, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_values = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for values:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[values:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_values = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_auto_count11643(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 79, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[auto_count]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_auto_count
  gc_frame_end(frame);
  return *var_auto_count;
}
Object meth_parser_auto_count_58__61_11644(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 80, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "auto_count:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_auto_count = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for auto_count:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[auto_count:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_auto_count = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_don_39_tTakeBlock11647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 81, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "don'tTakeBlock");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_don_39_tTakeBlock = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for don'tTakeBlock (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[don'tTakeBlock]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_don_39_tTakeBlock
  gc_frame_end(frame);
  return *var_don_39_tTakeBlock;
}
Object meth_parser_don_39_tTakeBlock_58__61_11648(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 82, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "don'tTakeBlock:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_don_39_tTakeBlock = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for don'tTakeBlock:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[don'tTakeBlock:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_don_39_tTakeBlock = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_braceIsType11651(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 83, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[braceIsType]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_braceIsType
  gc_frame_end(frame);
  return *var_braceIsType;
}
Object meth_parser_braceIsType_58__61_11652(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 84, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "braceIsType:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_braceIsType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for braceIsType:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[braceIsType:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_braceIsType = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultDefVisibility11655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 85, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[defaultDefVisibility]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defaultDefVisibility
  gc_frame_end(frame);
  return *var_defaultDefVisibility;
}
Object meth_parser_defaultDefVisibility_58__61_11656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 86, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultDefVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_defaultDefVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultDefVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[defaultDefVisibility:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_defaultDefVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultVarVisibility11659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 87, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[defaultVarVisibility]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defaultVarVisibility
  gc_frame_end(frame);
  return *var_defaultVarVisibility;
}
Object meth_parser_defaultVarVisibility_58__61_11660(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 88, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultVarVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_defaultVarVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultVarVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[defaultVarVisibility:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_defaultVarVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_defaultMethodVisibility11663(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 89, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[defaultMethodVisibility]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_defaultMethodVisibility
  gc_frame_end(frame);
  return *var_defaultMethodVisibility;
}
Object meth_parser_defaultMethodVisibility_58__61_11664(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 90, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "defaultMethodVisibility:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_defaultMethodVisibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for defaultMethodVisibility:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[defaultMethodVisibility:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_defaultMethodVisibility = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_sym11666(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 91, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[sym]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_sym
  gc_frame_end(frame);
  return *var_sym;
}
Object meth_parser_sym_58__61_11667(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 92, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sym:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_sym = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for sym:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[sym:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_sym = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_lastToken11683(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 93, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[lastToken]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_lastToken
  gc_frame_end(frame);
  return *var_lastToken;
}
Object meth_parser_lastToken_58__61_11684(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 94, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lastToken:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_lastToken = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for lastToken:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[lastToken:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_lastToken = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object meth_parser_comment11687(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 95, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment (probably reflection error): got %i lists, expected 1.", nparts);
if (argcv && argcv[0] > 0)
  gracedie("too many arguments for <Identifier[comment]>");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning *var_comment
  gc_frame_end(frame);
  return *var_comment;
}
Object meth_parser_comment_58__61_11688(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 96, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "comment:=");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    gracedie("insufficient arguments to method");
  Object params[1];
  int partcv[1];
  Object *var_comment = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    gracedie("missing argument list for comment:= (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var__var_assign_tmp = &(stackframe->slots[0]);
  *var__var_assign_tmp = args[curarg];
  curarg++;
if (argcv && argcv[0] > 1)
  gracedie("too many arguments for <Identifier[comment:=]>");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// compilenode returning *var__var_assign_tmp
  *var_comment = *var__var_assign_tmp;
  if (*var__var_assign_tmp == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compilenode returning done
  gc_frame_end(frame);
  return done;
}
Object module_parser_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(101, 101);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<parser>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = grace_prelude();
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(101, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object params[1];
  int partcv[1];
Object *var_io = alloc_var();
Object *var_ast = alloc_var();
Object *var_util = alloc_var();
Object *var_collections = alloc_var();
Object *var_errormessages = alloc_var();
  Object *var_don_39_tBreak = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "don'tBreak");
  Object *var_lastline = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "lastline");
  Object *var_linenum = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "linenum");
  Object *var_lastIndent = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "lastIndent");
  Object *var_indentFreePass = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "indentFreePass");
  Object *var_minIndentLevel = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "minIndentLevel");
  Object *var_statementIndent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "statementIndent");
  Object *var_statementToken = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "statementToken");
  Object *var_tokens = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "tokens");
  Object *var_values = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "values");
  Object *var_auto_count = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "auto_count");
  Object *var_don_39_tTakeBlock = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "don'tTakeBlock");
  Object *var_braceIsType = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "braceIsType");
  Object *var_defaultDefVisibility = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "defaultDefVisibility");
  Object *var_defaultVarVisibility = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "defaultVarVisibility");
  Object *var_defaultMethodVisibility = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "defaultMethodVisibility");
  Object *var_sym = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "sym");
  Object *var_lastToken = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "lastToken");
  Object *var_comment = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "comment");
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure0 = createclosure(8, "next");
setclosureframe(closure0, stackframe);
  addtoclosure(closure0, var_sym);
  addtoclosure(closure0, var_lastToken);
  addtoclosure(closure0, var_tokens);
  addtoclosure(closure0, var_linenum);
  addtoclosure(closure0, var_lastline);
  addtoclosure(closure0, var_lastIndent);
  addtoclosure(closure0, var_comment);
  addtoclosure(closure0, var_util);
  struct UserObject *uo0 = (struct UserObject*)self;
  uo0->data[1] = (Object)closure0;
  Method *meth_meth_parser_next0 = addmethod2pos(self, "next", &meth_parser_next0, 1);
int argcv_meth_parser_next0[] = {0};
meth_meth_parser_next0->type = alloc_MethodType(1, argcv_meth_parser_next0);
  meth_meth_parser_next0->definitionModule = modulename;
  meth_meth_parser_next0->definitionLine = 40;
// compilenode returning 
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure94 = createclosure(2, "findNextToken");
setclosureframe(closure94, stackframe);
  addtoclosure(closure94, var_sym);
  addtoclosure(closure94, var_lastToken);
  struct UserObject *uo94 = (struct UserObject*)self;
  uo94->data[2] = (Object)closure94;
  Method *meth_meth_parser_findNextToken94 = addmethod2pos(self, "findNextToken", &meth_parser_findNextToken94, 2);
int argcv_meth_parser_findNextToken94[] = {1};
meth_meth_parser_findNextToken94->type = alloc_MethodType(1, argcv_meth_parser_findNextToken94);
  meth_meth_parser_findNextToken94->definitionModule = modulename;
  meth_meth_parser_findNextToken94->definitionLine = 69;
// compilenode returning 
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure139 = createclosure(1, "findNextTokenIndentedAt");
setclosureframe(closure139, stackframe);
  addtoclosure(closure139, var_sym);
  struct UserObject *uo139 = (struct UserObject*)self;
  uo139->data[3] = (Object)closure139;
  Method *meth_meth_parser_findNextTokenIndentedAt139 = addmethod2pos(self, "findNextTokenIndentedAt", &meth_parser_findNextTokenIndentedAt139, 3);
int argcv_meth_parser_findNextTokenIndentedAt139[] = {1};
meth_meth_parser_findNextTokenIndentedAt139->type = alloc_MethodType(1, argcv_meth_parser_findNextTokenIndentedAt139);
  meth_meth_parser_findNextTokenIndentedAt139->definitionModule = modulename;
  meth_meth_parser_findNextTokenIndentedAt139->definitionLine = 84;
// compilenode returning 
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure220 = createclosure(1, "findNextValidToken");
setclosureframe(closure220, stackframe);
  addtoclosure(closure220, var_sym);
  struct UserObject *uo220 = (struct UserObject*)self;
  uo220->data[4] = (Object)closure220;
  Method *meth_meth_parser_findNextValidToken220 = addmethod2pos(self, "findNextValidToken", &meth_parser_findNextValidToken220, 4);
int argcv_meth_parser_findNextValidToken220[] = {0};
meth_meth_parser_findNextValidToken220->type = alloc_MethodType(1, argcv_meth_parser_findNextValidToken220);
  meth_meth_parser_findNextValidToken220->definitionModule = modulename;
  meth_meth_parser_findNextValidToken220->definitionLine = 99;
// compilenode returning 
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure259 = createclosure(1, "findClosingBrace");
setclosureframe(closure259, stackframe);
  addtoclosure(closure259, var_sym);
  struct UserObject *uo259 = (struct UserObject*)self;
  uo259->data[5] = (Object)closure259;
  Method *meth_meth_parser_findClosingBrace259 = addmethod2pos(self, "findClosingBrace", &meth_parser_findClosingBrace259, 5);
int argcv_meth_parser_findClosingBrace259[] = {2};
meth_meth_parser_findClosingBrace259->type = alloc_MethodType(1, argcv_meth_parser_findClosingBrace259);
  meth_meth_parser_findClosingBrace259->definitionModule = modulename;
  meth_meth_parser_findClosingBrace259->definitionLine = 123;
  block_savedest(self);
  Object closure411 = createclosure(1, "findClosingBrace()object");
setclosureframe(closure411, stackframe);
  addtoclosure(closure411, var_sym);
  Method *meth_meth_parser_findClosingBrace259_object = addmethod2pos(self, "findClosingBrace()object", &meth_parser_findClosingBrace259_object, 5);
  meth_meth_parser_findClosingBrace259_object->definitionModule = modulename;
  meth_meth_parser_findClosingBrace259_object->definitionLine = 123;
// compilenode returning 
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure412 = createclosure(1, "accept");
setclosureframe(closure412, stackframe);
  addtoclosure(closure412, var_sym);
  struct UserObject *uo412 = (struct UserObject*)self;
  uo412->data[6] = (Object)closure412;
  Method *meth_meth_parser_accept412 = addmethod2pos(self, "accept", &meth_parser_accept412, 6);
int argcv_meth_parser_accept412[] = {1};
meth_meth_parser_accept412->type = alloc_MethodType(1, argcv_meth_parser_accept412);
  meth_meth_parser_accept412->definitionModule = modulename;
  meth_meth_parser_accept412->definitionLine = 159;
// compilenode returning 
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure418 = createclosure(3, "acceptSameLine");
setclosureframe(closure418, stackframe);
  addtoclosure(closure418, var_lastIndent);
  addtoclosure(closure418, var_sym);
  addtoclosure(closure418, var_lastline);
  struct UserObject *uo418 = (struct UserObject*)self;
  uo418->data[7] = (Object)closure418;
  Method *meth_meth_parser_acceptSameLine418 = addmethod2pos(self, "acceptSameLine", &meth_parser_acceptSameLine418, 7);
int argcv_meth_parser_acceptSameLine418[] = {1};
meth_meth_parser_acceptSameLine418->type = alloc_MethodType(1, argcv_meth_parser_acceptSameLine418);
  meth_meth_parser_acceptSameLine418->definitionModule = modulename;
  meth_meth_parser_acceptSameLine418->definitionLine = 166;
// compilenode returning 
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure440 = createclosure(1, "accept()onLineOf");
setclosureframe(closure440, stackframe);
  addtoclosure(closure440, var_sym);
  struct UserObject *uo440 = (struct UserObject*)self;
  uo440->data[8] = (Object)closure440;
  Method *meth_meth_parser_accept_40__41_onLineOf440 = addmethod2pos(self, "accept()onLineOf", &meth_parser_accept_40__41_onLineOf440, 8);
int argcv_meth_parser_accept_40__41_onLineOf440[] = {1, 1};
meth_meth_parser_accept_40__41_onLineOf440->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOf440);
  meth_meth_parser_accept_40__41_onLineOf440->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOf440->definitionLine = 173;
// compilenode returning 
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure466 = createclosure(2, "accept()onLineOfLastOr");
setclosureframe(closure466, stackframe);
  addtoclosure(closure466, var_sym);
  addtoclosure(closure466, var_lastToken);
  struct UserObject *uo466 = (struct UserObject*)self;
  uo466->data[9] = (Object)closure466;
  Method *meth_meth_parser_accept_40__41_onLineOfLastOr466 = addmethod2pos(self, "accept()onLineOfLastOr", &meth_parser_accept_40__41_onLineOfLastOr466, 9);
int argcv_meth_parser_accept_40__41_onLineOfLastOr466[] = {1, 1};
meth_meth_parser_accept_40__41_onLineOfLastOr466->type = alloc_MethodType(2, argcv_meth_parser_accept_40__41_onLineOfLastOr466);
  meth_meth_parser_accept_40__41_onLineOfLastOr466->definitionModule = modulename;
  meth_meth_parser_accept_40__41_onLineOfLastOr466->definitionLine = 179;
// compilenode returning 
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure502 = createclosure(3, "tokenOnSameLine");
setclosureframe(closure502, stackframe);
  addtoclosure(closure502, var_lastIndent);
  addtoclosure(closure502, var_sym);
  addtoclosure(closure502, var_lastline);
  struct UserObject *uo502 = (struct UserObject*)self;
  uo502->data[10] = (Object)closure502;
  Method *meth_meth_parser_tokenOnSameLine502 = addmethod2pos(self, "tokenOnSameLine", &meth_parser_tokenOnSameLine502, 10);
int argcv_meth_parser_tokenOnSameLine502[] = {0};
meth_meth_parser_tokenOnSameLine502->type = alloc_MethodType(1, argcv_meth_parser_tokenOnSameLine502);
  meth_meth_parser_tokenOnSameLine502->definitionModule = modulename;
  meth_meth_parser_tokenOnSameLine502->definitionLine = 184;
// compilenode returning 
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure516 = createclosure(1, "didConsume");
setclosureframe(closure516, stackframe);
  addtoclosure(closure516, var_tokens);
  struct UserObject *uo516 = (struct UserObject*)self;
  uo516->data[11] = (Object)closure516;
  Method *meth_meth_parser_didConsume516 = addmethod2pos(self, "didConsume", &meth_parser_didConsume516, 11);
int argcv_meth_parser_didConsume516[] = {1};
meth_meth_parser_didConsume516->type = alloc_MethodType(1, argcv_meth_parser_didConsume516);
  meth_meth_parser_didConsume516->definitionModule = modulename;
  meth_meth_parser_didConsume516->definitionLine = 188;
// compilenode returning 
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure526 = createclosure(1, "ifConsume()then");
setclosureframe(closure526, stackframe);
  addtoclosure(closure526, var_tokens);
  struct UserObject *uo526 = (struct UserObject*)self;
  uo526->data[12] = (Object)closure526;
  Method *meth_meth_parser_ifConsume_40__41_then526 = addmethod2pos(self, "ifConsume()then", &meth_parser_ifConsume_40__41_then526, 12);
int argcv_meth_parser_ifConsume_40__41_then526[] = {1, 1};
meth_meth_parser_ifConsume_40__41_then526->type = alloc_MethodType(2, argcv_meth_parser_ifConsume_40__41_then526);
  meth_meth_parser_ifConsume_40__41_then526->definitionModule = modulename;
  meth_meth_parser_ifConsume_40__41_then526->definitionLine = 194;
// compilenode returning 
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure539 = createclosure(3, "pushnum");
setclosureframe(closure539, stackframe);
  addtoclosure(closure539, var_sym);
  addtoclosure(closure539, var_ast);
  addtoclosure(closure539, var_values);
  struct UserObject *uo539 = (struct UserObject*)self;
  uo539->data[13] = (Object)closure539;
  Method *meth_meth_parser_pushnum539 = addmethod2pos(self, "pushnum", &meth_parser_pushnum539, 13);
int argcv_meth_parser_pushnum539[] = {0};
meth_meth_parser_pushnum539->type = alloc_MethodType(1, argcv_meth_parser_pushnum539);
  meth_meth_parser_pushnum539->definitionModule = modulename;
  meth_meth_parser_pushnum539->definitionLine = 203;
// compilenode returning 
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure550 = createclosure(3, "pushoctets");
setclosureframe(closure550, stackframe);
  addtoclosure(closure550, var_sym);
  addtoclosure(closure550, var_ast);
  addtoclosure(closure550, var_values);
  struct UserObject *uo550 = (struct UserObject*)self;
  uo550->data[14] = (Object)closure550;
  Method *meth_meth_parser_pushoctets550 = addmethod2pos(self, "pushoctets", &meth_parser_pushoctets550, 14);
int argcv_meth_parser_pushoctets550[] = {0};
meth_meth_parser_pushoctets550->type = alloc_MethodType(1, argcv_meth_parser_pushoctets550);
  meth_meth_parser_pushoctets550->definitionModule = modulename;
  meth_meth_parser_pushoctets550->definitionLine = 210;
// compilenode returning 
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure561 = createclosure(3, "pushstring");
setclosureframe(closure561, stackframe);
  addtoclosure(closure561, var_sym);
  addtoclosure(closure561, var_ast);
  addtoclosure(closure561, var_values);
  struct UserObject *uo561 = (struct UserObject*)self;
  uo561->data[15] = (Object)closure561;
  Method *meth_meth_parser_pushstring561 = addmethod2pos(self, "pushstring", &meth_parser_pushstring561, 15);
int argcv_meth_parser_pushstring561[] = {0};
meth_meth_parser_pushstring561->type = alloc_MethodType(1, argcv_meth_parser_pushstring561);
  meth_meth_parser_pushstring561->definitionModule = modulename;
  meth_meth_parser_pushstring561->definitionLine = 217;
// compilenode returning 
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure572 = createclosure(5, "pushidentifier");
setclosureframe(closure572, stackframe);
  addtoclosure(closure572, var_sym);
  addtoclosure(closure572, var_util);
  addtoclosure(closure572, var_ast);
  addtoclosure(closure572, var_auto_count);
  addtoclosure(closure572, var_values);
  struct UserObject *uo572 = (struct UserObject*)self;
  uo572->data[16] = (Object)closure572;
  Method *meth_meth_parser_pushidentifier572 = addmethod2pos(self, "pushidentifier", &meth_parser_pushidentifier572, 16);
int argcv_meth_parser_pushidentifier572[] = {0};
meth_meth_parser_pushidentifier572->type = alloc_MethodType(1, argcv_meth_parser_pushidentifier572);
  meth_meth_parser_pushidentifier572->definitionModule = modulename;
  meth_meth_parser_pushidentifier572->definitionLine = 225;
// compilenode returning 
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure609 = createclosure(2, "checkAnnotation");
setclosureframe(closure609, stackframe);
  addtoclosure(closure609, var_sym);
  addtoclosure(closure609, var_errormessages);
  struct UserObject *uo609 = (struct UserObject*)self;
  uo609->data[17] = (Object)closure609;
  Method *meth_meth_parser_checkAnnotation609 = addmethod2pos(self, "checkAnnotation", &meth_parser_checkAnnotation609, 17);
int argcv_meth_parser_checkAnnotation609[] = {1};
meth_meth_parser_checkAnnotation609->type = alloc_MethodType(1, argcv_meth_parser_checkAnnotation609);
  meth_meth_parser_checkAnnotation609->definitionModule = modulename;
  meth_meth_parser_checkAnnotation609->definitionLine = 236;
// compilenode returning 
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure698 = createclosure(6, "doannotation");
setclosureframe(closure698, stackframe);
  addtoclosure(closure698, var_sym);
  addtoclosure(closure698, var_collections);
  addtoclosure(closure698, var_don_39_tTakeBlock);
  addtoclosure(closure698, var_errormessages);
  addtoclosure(closure698, var_lastToken);
  addtoclosure(closure698, var_values);
  struct UserObject *uo698 = (struct UserObject*)self;
  uo698->data[18] = (Object)closure698;
  Method *meth_meth_parser_doannotation698 = addmethod2pos(self, "doannotation", &meth_parser_doannotation698, 18);
int argcv_meth_parser_doannotation698[] = {0};
meth_meth_parser_doannotation698->type = alloc_MethodType(1, argcv_meth_parser_doannotation698);
  meth_meth_parser_doannotation698->definitionModule = modulename;
  meth_meth_parser_doannotation698->definitionLine = 254;
// compilenode returning 
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure878 = createclosure(4, "blank");
setclosureframe(closure878, stackframe);
  addtoclosure(closure878, var_lastToken);
  addtoclosure(closure878, var_sym);
  addtoclosure(closure878, var_values);
  addtoclosure(closure878, var_ast);
  struct UserObject *uo878 = (struct UserObject*)self;
  uo878->data[19] = (Object)closure878;
  Method *meth_meth_parser_blank878 = addmethod2pos(self, "blank", &meth_parser_blank878, 19);
int argcv_meth_parser_blank878[] = {0};
meth_meth_parser_blank878->type = alloc_MethodType(1, argcv_meth_parser_blank878);
  meth_meth_parser_blank878->definitionModule = modulename;
  meth_meth_parser_blank878->definitionLine = 302;
// compilenode returning 
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure913 = createclosure(2, "dotypeterm");
setclosureframe(closure913, stackframe);
  addtoclosure(closure913, var_don_39_tTakeBlock);
  addtoclosure(closure913, var_sym);
  struct UserObject *uo913 = (struct UserObject*)self;
  uo913->data[20] = (Object)closure913;
  Method *meth_meth_parser_dotypeterm913 = addmethod2pos(self, "dotypeterm", &meth_parser_dotypeterm913, 20);
int argcv_meth_parser_dotypeterm913[] = {0};
meth_meth_parser_dotypeterm913->type = alloc_MethodType(1, argcv_meth_parser_dotypeterm913);
  meth_meth_parser_dotypeterm913->definitionModule = modulename;
  meth_meth_parser_dotypeterm913->definitionLine = 312;
// compilenode returning 
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure945 = createclosure(5, "dotyperef");
setclosureframe(closure945, stackframe);
  addtoclosure(closure945, var_errormessages);
  addtoclosure(closure945, var_lastToken);
  addtoclosure(closure945, var_sym);
  addtoclosure(closure945, var_values);
  addtoclosure(closure945, var_ast);
  struct UserObject *uo945 = (struct UserObject*)self;
  uo945->data[21] = (Object)closure945;
  Method *meth_meth_parser_dotyperef945 = addmethod2pos(self, "dotyperef", &meth_parser_dotyperef945, 21);
int argcv_meth_parser_dotyperef945[] = {0};
meth_meth_parser_dotyperef945->type = alloc_MethodType(1, argcv_meth_parser_dotyperef945);
  meth_meth_parser_dotyperef945->definitionModule = modulename;
  meth_meth_parser_dotyperef945->definitionLine = 326;
// compilenode returning 
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1261 = createclosure(11, "block");
setclosureframe(closure1261, stackframe);
  addtoclosure(closure1261, var_sym);
  addtoclosure(closure1261, var_statementIndent);
  addtoclosure(closure1261, var_statementToken);
  addtoclosure(closure1261, var_values);
  addtoclosure(closure1261, var_braceIsType);
  addtoclosure(closure1261, var_errormessages);
  addtoclosure(closure1261, var_lastToken);
  addtoclosure(closure1261, var_indentFreePass);
  addtoclosure(closure1261, var_ast);
  addtoclosure(closure1261, var_minIndentLevel);
  addtoclosure(closure1261, var_util);
  struct UserObject *uo1261 = (struct UserObject*)self;
  uo1261->data[22] = (Object)closure1261;
  Method *meth_meth_parser_block1261 = addmethod2pos(self, "block", &meth_parser_block1261, 22);
int argcv_meth_parser_block1261[] = {0};
meth_meth_parser_block1261->type = alloc_MethodType(1, argcv_meth_parser_block1261);
  meth_meth_parser_block1261->definitionModule = modulename;
  meth_meth_parser_block1261->definitionLine = 413;
// compilenode returning 
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure1776 = createclosure(8, "doif");
setclosureframe(closure1776, stackframe);
  addtoclosure(closure1776, var_sym);
  addtoclosure(closure1776, var_errormessages);
  addtoclosure(closure1776, var_lastToken);
  addtoclosure(closure1776, var_values);
  addtoclosure(closure1776, var_minIndentLevel);
  addtoclosure(closure1776, var_statementIndent);
  addtoclosure(closure1776, var_statementToken);
  addtoclosure(closure1776, var_ast);
  struct UserObject *uo1776 = (struct UserObject*)self;
  uo1776->data[23] = (Object)closure1776;
  Method *meth_meth_parser_doif1776 = addmethod2pos(self, "doif", &meth_parser_doif1776, 23);
int argcv_meth_parser_doif1776[] = {0};
meth_meth_parser_doif1776->type = alloc_MethodType(1, argcv_meth_parser_doif1776);
  meth_meth_parser_doif1776->definitionModule = modulename;
  meth_meth_parser_doif1776->definitionLine = 583;
// compilenode returning 
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3150 = createclosure(1, "identifier");
setclosureframe(closure3150, stackframe);
  addtoclosure(closure3150, var_sym);
  struct UserObject *uo3150 = (struct UserObject*)self;
  uo3150->data[24] = (Object)closure3150;
  Method *meth_meth_parser_identifier3150 = addmethod2pos(self, "identifier", &meth_parser_identifier3150, 24);
int argcv_meth_parser_identifier3150[] = {0};
meth_meth_parser_identifier3150->type = alloc_MethodType(1, argcv_meth_parser_identifier3150);
  meth_meth_parser_identifier3150->definitionModule = modulename;
  meth_meth_parser_identifier3150->definitionLine = 964;
// compilenode returning 
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3166 = createclosure(5, "prefixop");
setclosureframe(closure3166, stackframe);
  addtoclosure(closure3166, var_sym);
  addtoclosure(closure3166, var_errormessages);
  addtoclosure(closure3166, var_lastToken);
  addtoclosure(closure3166, var_values);
  addtoclosure(closure3166, var_ast);
  struct UserObject *uo3166 = (struct UserObject*)self;
  uo3166->data[25] = (Object)closure3166;
  Method *meth_meth_parser_prefixop3166 = addmethod2pos(self, "prefixop", &meth_parser_prefixop3166, 25);
int argcv_meth_parser_prefixop3166[] = {0};
meth_meth_parser_prefixop3166->type = alloc_MethodType(1, argcv_meth_parser_prefixop3166);
  meth_meth_parser_prefixop3166->definitionModule = modulename;
  meth_meth_parser_prefixop3166->definitionLine = 974;
// compilenode returning 
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3353 = createclosure(5, "generic");
setclosureframe(closure3353, stackframe);
  addtoclosure(closure3353, var_values);
  addtoclosure(closure3353, var_sym);
  addtoclosure(closure3353, var_errormessages);
  addtoclosure(closure3353, var_lastToken);
  addtoclosure(closure3353, var_ast);
  struct UserObject *uo3353 = (struct UserObject*)self;
  uo3353->data[26] = (Object)closure3353;
  Method *meth_meth_parser_generic3353 = addmethod2pos(self, "generic", &meth_parser_generic3353, 26);
int argcv_meth_parser_generic3353[] = {0};
meth_meth_parser_generic3353->type = alloc_MethodType(1, argcv_meth_parser_generic3353);
  meth_meth_parser_generic3353->definitionModule = modulename;
  meth_meth_parser_generic3353->definitionLine = 1031;
// compilenode returning 
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure3528 = createclosure(7, "trycatch");
setclosureframe(closure3528, stackframe);
  addtoclosure(closure3528, var_sym);
  addtoclosure(closure3528, var_minIndentLevel);
  addtoclosure(closure3528, var_errormessages);
  addtoclosure(closure3528, var_lastToken);
  addtoclosure(closure3528, var_values);
  addtoclosure(closure3528, var_tokens);
  addtoclosure(closure3528, var_ast);
  struct UserObject *uo3528 = (struct UserObject*)self;
  uo3528->data[27] = (Object)closure3528;
  Method *meth_meth_parser_trycatch3528 = addmethod2pos(self, "trycatch", &meth_parser_trycatch3528, 27);
int argcv_meth_parser_trycatch3528[] = {0};
meth_meth_parser_trycatch3528->type = alloc_MethodType(1, argcv_meth_parser_trycatch3528);
  meth_meth_parser_trycatch3528->definitionModule = modulename;
  meth_meth_parser_trycatch3528->definitionLine = 1088;
// compilenode returning 
// Begin line 1255
  setline(1255);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure4120 = createclosure(8, "catchcase");
setclosureframe(closure4120, stackframe);
  addtoclosure(closure4120, var_sym);
  addtoclosure(closure4120, var_minIndentLevel);
  addtoclosure(closure4120, var_util);
  addtoclosure(closure4120, var_errormessages);
  addtoclosure(closure4120, var_lastToken);
  addtoclosure(closure4120, var_values);
  addtoclosure(closure4120, var_tokens);
  addtoclosure(closure4120, var_ast);
  struct UserObject *uo4120 = (struct UserObject*)self;
  uo4120->data[28] = (Object)closure4120;
  Method *meth_meth_parser_catchcase4120 = addmethod2pos(self, "catchcase", &meth_parser_catchcase4120, 28);
int argcv_meth_parser_catchcase4120[] = {0};
meth_meth_parser_catchcase4120->type = alloc_MethodType(1, argcv_meth_parser_catchcase4120);
  meth_meth_parser_catchcase4120->definitionModule = modulename;
  meth_meth_parser_catchcase4120->definitionLine = 1255;
// compilenode returning 
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure4682 = createclosure(7, "matchcase");
setclosureframe(closure4682, stackframe);
  addtoclosure(closure4682, var_sym);
  addtoclosure(closure4682, var_minIndentLevel);
  addtoclosure(closure4682, var_errormessages);
  addtoclosure(closure4682, var_lastToken);
  addtoclosure(closure4682, var_values);
  addtoclosure(closure4682, var_tokens);
  addtoclosure(closure4682, var_ast);
  struct UserObject *uo4682 = (struct UserObject*)self;
  uo4682->data[29] = (Object)closure4682;
  Method *meth_meth_parser_matchcase4682 = addmethod2pos(self, "matchcase", &meth_parser_matchcase4682, 29);
int argcv_meth_parser_matchcase4682[] = {0};
meth_meth_parser_matchcase4682->type = alloc_MethodType(1, argcv_meth_parser_matchcase4682);
  meth_meth_parser_matchcase4682->definitionModule = modulename;
  meth_meth_parser_matchcase4682->definitionLine = 1416;
// compilenode returning 
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5049 = createclosure(1, "term");
setclosureframe(closure5049, stackframe);
  addtoclosure(closure5049, var_sym);
  struct UserObject *uo5049 = (struct UserObject*)self;
  uo5049->data[30] = (Object)closure5049;
  Method *meth_meth_parser_term5049 = addmethod2pos(self, "term", &meth_parser_term5049, 30);
int argcv_meth_parser_term5049[] = {0};
meth_meth_parser_term5049->type = alloc_MethodType(1, argcv_meth_parser_term5049);
  meth_meth_parser_term5049->definitionModule = modulename;
  meth_meth_parser_term5049->definitionLine = 1569;
// compilenode returning 
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5169 = createclosure(5, "expression");
setclosureframe(closure5169, stackframe);
  addtoclosure(closure5169, var_values);
  addtoclosure(closure5169, var_statementToken);
  addtoclosure(closure5169, var_sym);
  addtoclosure(closure5169, var_errormessages);
  addtoclosure(closure5169, var_lastToken);
  struct UserObject *uo5169 = (struct UserObject*)self;
  uo5169->data[31] = (Object)closure5169;
  Method *meth_meth_parser_expression5169 = addmethod2pos(self, "expression", &meth_parser_expression5169, 31);
int argcv_meth_parser_expression5169[] = {0};
meth_meth_parser_expression5169->type = alloc_MethodType(1, argcv_meth_parser_expression5169);
  meth_meth_parser_expression5169->definitionModule = modulename;
  meth_meth_parser_expression5169->definitionLine = 1602;
// compilenode returning 
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5264 = createclosure(5, "postfixsquare");
setclosureframe(closure5264, stackframe);
  addtoclosure(closure5264, var_values);
  addtoclosure(closure5264, var_errormessages);
  addtoclosure(closure5264, var_sym);
  addtoclosure(closure5264, var_lastToken);
  addtoclosure(closure5264, var_ast);
  struct UserObject *uo5264 = (struct UserObject*)self;
  uo5264->data[32] = (Object)closure5264;
  Method *meth_meth_parser_postfixsquare5264 = addmethod2pos(self, "postfixsquare", &meth_parser_postfixsquare5264, 32);
int argcv_meth_parser_postfixsquare5264[] = {0};
meth_meth_parser_postfixsquare5264->type = alloc_MethodType(1, argcv_meth_parser_postfixsquare5264);
  meth_meth_parser_postfixsquare5264->definitionModule = modulename;
  meth_meth_parser_postfixsquare5264->definitionLine = 1641;
// compilenode returning 
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo5374 = (struct UserObject*)self;
  uo5374->data[33] = emptyclosure;
  Method *meth_meth_parser_oprec5374 = addmethod2pos(self, "oprec", &meth_parser_oprec5374, 33);
int argcv_meth_parser_oprec5374[] = {1};
meth_meth_parser_oprec5374->type = alloc_MethodType(1, argcv_meth_parser_oprec5374);
  meth_meth_parser_oprec5374->definitionModule = modulename;
  meth_meth_parser_oprec5374->definitionLine = 1682;
// compilenode returning 
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
  struct UserObject *uo5388 = (struct UserObject*)self;
  uo5388->data[34] = emptyclosure;
  Method *meth_meth_parser_toprec5388 = addmethod2pos(self, "toprec", &meth_parser_toprec5388, 34);
int argcv_meth_parser_toprec5388[] = {1};
meth_meth_parser_toprec5388->type = alloc_MethodType(1, argcv_meth_parser_toprec5388);
  meth_meth_parser_toprec5388->definitionModule = modulename;
  meth_meth_parser_toprec5388->definitionLine = 1692;
// compilenode returning 
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5401 = createclosure(7, "expressionrest");
setclosureframe(closure5401, stackframe);
  addtoclosure(closure5401, var_values);
  addtoclosure(closure5401, var_sym);
  addtoclosure(closure5401, var_statementToken);
  addtoclosure(closure5401, var_errormessages);
  addtoclosure(closure5401, var_lastToken);
  addtoclosure(closure5401, var_ast);
  addtoclosure(closure5401, var_util);
  struct UserObject *uo5401 = (struct UserObject*)self;
  uo5401->data[35] = (Object)closure5401;
  Method *meth_meth_parser_expressionrest5401 = addmethod2pos(self, "expressionrest", &meth_parser_expressionrest5401, 35);
int argcv_meth_parser_expressionrest5401[] = {0};
meth_meth_parser_expressionrest5401->type = alloc_MethodType(1, argcv_meth_parser_expressionrest5401);
  meth_meth_parser_expressionrest5401->definitionModule = modulename;
  meth_meth_parser_expressionrest5401->definitionLine = 1704;
// compilenode returning 
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5856 = createclosure(5, "dotrest");
setclosureframe(closure5856, stackframe);
  addtoclosure(closure5856, var_values);
  addtoclosure(closure5856, var_sym);
  addtoclosure(closure5856, var_ast);
  addtoclosure(closure5856, var_errormessages);
  addtoclosure(closure5856, var_lastToken);
  struct UserObject *uo5856 = (struct UserObject*)self;
  uo5856->data[36] = (Object)closure5856;
  Method *meth_meth_parser_dotrest5856 = addmethod2pos(self, "dotrest", &meth_parser_dotrest5856, 36);
int argcv_meth_parser_dotrest5856[] = {0};
meth_meth_parser_dotrest5856->type = alloc_MethodType(1, argcv_meth_parser_dotrest5856);
  meth_meth_parser_dotrest5856->definitionModule = modulename;
  meth_meth_parser_dotrest5856->definitionLine = 1846;
// compilenode returning 
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure5947 = createclosure(10, "callrest");
setclosureframe(closure5947, stackframe);
  addtoclosure(closure5947, var_values);
  addtoclosure(closure5947, var_linenum);
  addtoclosure(closure5947, var_sym);
  addtoclosure(closure5947, var_ast);
  addtoclosure(closure5947, var_lastToken);
  addtoclosure(closure5947, var_minIndentLevel);
  addtoclosure(closure5947, var_collections);
  addtoclosure(closure5947, var_errormessages);
  addtoclosure(closure5947, var_don_39_tTakeBlock);
  addtoclosure(closure5947, var_util);
  struct UserObject *uo5947 = (struct UserObject*)self;
  uo5947->data[37] = (Object)closure5947;
  Method *meth_meth_parser_callrest5947 = addmethod2pos(self, "callrest", &meth_parser_callrest5947, 37);
int argcv_meth_parser_callrest5947[] = {0};
meth_meth_parser_callrest5947->type = alloc_MethodType(1, argcv_meth_parser_callrest5947);
  meth_meth_parser_callrest5947->definitionModule = modulename;
  meth_meth_parser_callrest5947->definitionLine = 1879;
// compilenode returning 
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure6658 = createclosure(7, "callmprest");
setclosureframe(closure6658, stackframe);
  addtoclosure(closure6658, var_linenum);
  addtoclosure(closure6658, var_lastToken);
  addtoclosure(closure6658, var_ast);
  addtoclosure(closure6658, var_values);
  addtoclosure(closure6658, var_errormessages);
  addtoclosure(closure6658, var_sym);
  addtoclosure(closure6658, var_lastline);
  struct UserObject *uo6658 = (struct UserObject*)self;
  uo6658->data[38] = (Object)closure6658;
  Method *meth_meth_parser_callmprest6658 = addmethod2pos(self, "callmprest", &meth_parser_callmprest6658, 38);
int argcv_meth_parser_callmprest6658[] = {3};
meth_meth_parser_callmprest6658->type = alloc_MethodType(1, argcv_meth_parser_callmprest6658);
  meth_meth_parser_callmprest6658->definitionModule = modulename;
  meth_meth_parser_callmprest6658->definitionLine = 2107;
// compilenode returning 
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7090 = createclosure(6, "defdec");
setclosureframe(closure7090, stackframe);
  addtoclosure(closure7090, var_sym);
  addtoclosure(closure7090, var_errormessages);
  addtoclosure(closure7090, var_lastToken);
  addtoclosure(closure7090, var_ast);
  addtoclosure(closure7090, var_values);
  addtoclosure(closure7090, var_defaultDefVisibility);
  struct UserObject *uo7090 = (struct UserObject*)self;
  uo7090->data[39] = (Object)closure7090;
  Method *meth_meth_parser_defdec7090 = addmethod2pos(self, "defdec", &meth_parser_defdec7090, 39);
int argcv_meth_parser_defdec7090[] = {0};
meth_meth_parser_defdec7090->type = alloc_MethodType(1, argcv_meth_parser_defdec7090);
  meth_meth_parser_defdec7090->definitionModule = modulename;
  meth_meth_parser_defdec7090->definitionLine = 2238;
// compilenode returning 
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7437 = createclosure(6, "vardec");
setclosureframe(closure7437, stackframe);
  addtoclosure(closure7437, var_sym);
  addtoclosure(closure7437, var_errormessages);
  addtoclosure(closure7437, var_lastToken);
  addtoclosure(closure7437, var_ast);
  addtoclosure(closure7437, var_values);
  addtoclosure(closure7437, var_defaultVarVisibility);
  struct UserObject *uo7437 = (struct UserObject*)self;
  uo7437->data[40] = (Object)closure7437;
  Method *meth_meth_parser_vardec7437 = addmethod2pos(self, "vardec", &meth_parser_vardec7437, 40);
int argcv_meth_parser_vardec7437[] = {0};
meth_meth_parser_vardec7437->type = alloc_MethodType(1, argcv_meth_parser_vardec7437);
  meth_meth_parser_vardec7437->definitionModule = modulename;
  meth_meth_parser_vardec7437->definitionLine = 2333;
// compilenode returning 
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7769 = createclosure(5, "doarray");
setclosureframe(closure7769, stackframe);
  addtoclosure(closure7769, var_values);
  addtoclosure(closure7769, var_errormessages);
  addtoclosure(closure7769, var_sym);
  addtoclosure(closure7769, var_lastToken);
  addtoclosure(closure7769, var_ast);
  struct UserObject *uo7769 = (struct UserObject*)self;
  uo7769->data[41] = (Object)closure7769;
  Method *meth_meth_parser_doarray7769 = addmethod2pos(self, "doarray", &meth_parser_doarray7769, 41);
int argcv_meth_parser_doarray7769[] = {0};
meth_meth_parser_doarray7769->type = alloc_MethodType(1, argcv_meth_parser_doarray7769);
  meth_meth_parser_doarray7769->definitionModule = modulename;
  meth_meth_parser_doarray7769->definitionLine = 2426;
// compilenode returning 
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7898 = createclosure(5, "dodialect");
setclosureframe(closure7898, stackframe);
  addtoclosure(closure7898, var_sym);
  addtoclosure(closure7898, var_errormessages);
  addtoclosure(closure7898, var_lastToken);
  addtoclosure(closure7898, var_ast);
  addtoclosure(closure7898, var_values);
  struct UserObject *uo7898 = (struct UserObject*)self;
  uo7898->data[42] = (Object)closure7898;
  Method *meth_meth_parser_dodialect7898 = addmethod2pos(self, "dodialect", &meth_parser_dodialect7898, 42);
int argcv_meth_parser_dodialect7898[] = {0};
meth_meth_parser_dodialect7898->type = alloc_MethodType(1, argcv_meth_parser_dodialect7898);
  meth_meth_parser_dodialect7898->definitionModule = modulename;
  meth_meth_parser_dodialect7898->definitionLine = 2469;
// compilenode returning 
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure7987 = createclosure(5, "inheritsdec");
setclosureframe(closure7987, stackframe);
  addtoclosure(closure7987, var_sym);
  addtoclosure(closure7987, var_errormessages);
  addtoclosure(closure7987, var_lastToken);
  addtoclosure(closure7987, var_values);
  addtoclosure(closure7987, var_ast);
  struct UserObject *uo7987 = (struct UserObject*)self;
  uo7987->data[43] = (Object)closure7987;
  Method *meth_meth_parser_inheritsdec7987 = addmethod2pos(self, "inheritsdec", &meth_parser_inheritsdec7987, 43);
int argcv_meth_parser_inheritsdec7987[] = {0};
meth_meth_parser_inheritsdec7987->type = alloc_MethodType(1, argcv_meth_parser_inheritsdec7987);
  meth_meth_parser_inheritsdec7987->definitionModule = modulename;
  meth_meth_parser_inheritsdec7987->definitionLine = 2491;
// compilenode returning 
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure8076 = createclosure(8, "doobject");
setclosureframe(closure8076, stackframe);
  addtoclosure(closure8076, var_sym);
  addtoclosure(closure8076, var_minIndentLevel);
  addtoclosure(closure8076, var_errormessages);
  addtoclosure(closure8076, var_lastToken);
  addtoclosure(closure8076, var_values);
  addtoclosure(closure8076, var_statementToken);
  addtoclosure(closure8076, var_util);
  addtoclosure(closure8076, var_ast);
  struct UserObject *uo8076 = (struct UserObject*)self;
  uo8076->data[44] = (Object)closure8076;
  Method *meth_meth_parser_doobject8076 = addmethod2pos(self, "doobject", &meth_parser_doobject8076, 44);
int argcv_meth_parser_doobject8076[] = {0};
meth_meth_parser_doobject8076->type = alloc_MethodType(1, argcv_meth_parser_doobject8076);
  meth_meth_parser_doobject8076->definitionModule = modulename;
  meth_meth_parser_doobject8076->definitionLine = 2517;
// compilenode returning 
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure8313 = createclosure(10, "doclass");
setclosureframe(closure8313, stackframe);
  addtoclosure(closure8313, var_sym);
  addtoclosure(closure8313, var_minIndentLevel);
  addtoclosure(closure8313, var_errormessages);
  addtoclosure(closure8313, var_lastToken);
  addtoclosure(closure8313, var_tokens);
  addtoclosure(closure8313, var_values);
  addtoclosure(closure8313, var_statementToken);
  addtoclosure(closure8313, var_util);
  addtoclosure(closure8313, var_ast);
  addtoclosure(closure8313, var_defaultMethodVisibility);
  struct UserObject *uo8313 = (struct UserObject*)self;
  uo8313->data[45] = (Object)closure8313;
  Method *meth_meth_parser_doclass8313 = addmethod2pos(self, "doclass", &meth_parser_doclass8313, 45);
int argcv_meth_parser_doclass8313[] = {0};
meth_meth_parser_doclass8313->type = alloc_MethodType(1, argcv_meth_parser_doclass8313);
  meth_meth_parser_doclass8313->definitionModule = modulename;
  meth_meth_parser_doclass8313->definitionLine = 2594;
// compilenode returning 
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure8611 = createclosure(8, "methoddec");
setclosureframe(closure8611, stackframe);
  addtoclosure(closure8611, var_sym);
  addtoclosure(closure8611, var_minIndentLevel);
  addtoclosure(closure8611, var_values);
  addtoclosure(closure8611, var_errormessages);
  addtoclosure(closure8611, var_lastToken);
  addtoclosure(closure8611, var_util);
  addtoclosure(closure8611, var_ast);
  addtoclosure(closure8611, var_defaultMethodVisibility);
  struct UserObject *uo8611 = (struct UserObject*)self;
  uo8611->data[46] = (Object)closure8611;
  Method *meth_meth_parser_methoddec8611 = addmethod2pos(self, "methoddec", &meth_parser_methoddec8611, 46);
int argcv_meth_parser_methoddec8611[] = {0};
meth_meth_parser_methoddec8611->type = alloc_MethodType(1, argcv_meth_parser_methoddec8611);
  meth_meth_parser_methoddec8611->definitionModule = modulename;
  meth_meth_parser_methoddec8611->definitionLine = 2683;
// compilenode returning 
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure8855 = createclosure(5, "parsempmndecrest");
setclosureframe(closure8855, stackframe);
  addtoclosure(closure8855, var_ast);
  addtoclosure(closure8855, var_values);
  addtoclosure(closure8855, var_errormessages);
  addtoclosure(closure8855, var_lastToken);
  addtoclosure(closure8855, var_sym);
  struct UserObject *uo8855 = (struct UserObject*)self;
  uo8855->data[47] = (Object)closure8855;
  Method *meth_meth_parser_parsempmndecrest8855 = addmethod2pos(self, "parsempmndecrest", &meth_parser_parsempmndecrest8855, 47);
int argcv_meth_parser_parsempmndecrest8855[] = {2};
meth_meth_parser_parsempmndecrest8855->type = alloc_MethodType(1, argcv_meth_parser_parsempmndecrest8855);
  meth_meth_parser_parsempmndecrest8855->definitionModule = modulename;
  meth_meth_parser_parsempmndecrest8855->definitionLine = 2775;
// compilenode returning 
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure9113 = createclosure(6, "methodsignature");
setclosureframe(closure9113, stackframe);
  addtoclosure(closure9113, var_sym);
  addtoclosure(closure9113, var_errormessages);
  addtoclosure(closure9113, var_lastToken);
  addtoclosure(closure9113, var_values);
  addtoclosure(closure9113, var_ast);
  addtoclosure(closure9113, var_tokens);
  struct UserObject *uo9113 = (struct UserObject*)self;
  uo9113->data[48] = (Object)closure9113;
  Method *meth_meth_parser_methodsignature9113 = addmethod2pos(self, "methodsignature", &meth_parser_methodsignature9113, 48);
int argcv_meth_parser_methodsignature9113[] = {1};
meth_meth_parser_methodsignature9113->type = alloc_MethodType(1, argcv_meth_parser_methodsignature9113);
  meth_meth_parser_methodsignature9113->definitionModule = modulename;
  meth_meth_parser_methodsignature9113->definitionLine = 2856;
  block_savedest(self);
  Object closure9835 = createclosure(6, "methodsignature()object");
setclosureframe(closure9835, stackframe);
  addtoclosure(closure9835, var_sym);
  addtoclosure(closure9835, var_errormessages);
  addtoclosure(closure9835, var_lastToken);
  addtoclosure(closure9835, var_values);
  addtoclosure(closure9835, var_ast);
  addtoclosure(closure9835, var_tokens);
  Method *meth_meth_parser_methodsignature9113_object = addmethod2pos(self, "methodsignature()object", &meth_parser_methodsignature9113_object, 48);
  meth_meth_parser_methodsignature9113_object->definitionModule = modulename;
  meth_meth_parser_methodsignature9113_object->definitionLine = 2856;
// compilenode returning 
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure9836 = createclosure(6, "doimport");
setclosureframe(closure9836, stackframe);
  addtoclosure(closure9836, var_sym);
  addtoclosure(closure9836, var_errormessages);
  addtoclosure(closure9836, var_lastToken);
  addtoclosure(closure9836, var_values);
  addtoclosure(closure9836, var_util);
  addtoclosure(closure9836, var_ast);
  struct UserObject *uo9836 = (struct UserObject*)self;
  uo9836->data[49] = (Object)closure9836;
  Method *meth_meth_parser_doimport9836 = addmethod2pos(self, "doimport", &meth_parser_doimport9836, 49);
int argcv_meth_parser_doimport9836[] = {0};
meth_meth_parser_doimport9836->type = alloc_MethodType(1, argcv_meth_parser_doimport9836);
  meth_meth_parser_doimport9836->definitionModule = modulename;
  meth_meth_parser_doimport9836->definitionLine = 3053;
// compilenode returning 
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10091 = createclosure(5, "doreturn");
setclosureframe(closure10091, stackframe);
  addtoclosure(closure10091, var_sym);
  addtoclosure(closure10091, var_errormessages);
  addtoclosure(closure10091, var_lastToken);
  addtoclosure(closure10091, var_values);
  addtoclosure(closure10091, var_ast);
  struct UserObject *uo10091 = (struct UserObject*)self;
  uo10091->data[50] = (Object)closure10091;
  Method *meth_meth_parser_doreturn10091 = addmethod2pos(self, "doreturn", &meth_parser_doreturn10091, 50);
int argcv_meth_parser_doreturn10091[] = {0};
meth_meth_parser_doreturn10091->type = alloc_MethodType(1, argcv_meth_parser_doreturn10091);
  meth_meth_parser_doreturn10091->definitionModule = modulename;
  meth_meth_parser_doreturn10091->definitionLine = 3111;
// compilenode returning 
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10202 = createclosure(6, "domethodtype");
setclosureframe(closure10202, stackframe);
  addtoclosure(closure10202, var_ast);
  addtoclosure(closure10202, var_values);
  addtoclosure(closure10202, var_sym);
  addtoclosure(closure10202, var_lastToken);
  addtoclosure(closure10202, var_errormessages);
  addtoclosure(closure10202, var_util);
  struct UserObject *uo10202 = (struct UserObject*)self;
  uo10202->data[51] = (Object)closure10202;
  Method *meth_meth_parser_domethodtype10202 = addmethod2pos(self, "domethodtype", &meth_parser_domethodtype10202, 51);
int argcv_meth_parser_domethodtype10202[] = {0};
meth_meth_parser_domethodtype10202->type = alloc_MethodType(1, argcv_meth_parser_domethodtype10202);
  meth_meth_parser_domethodtype10202->definitionModule = modulename;
  meth_meth_parser_domethodtype10202->definitionLine = 3144;
// compilenode returning 
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10300 = createclosure(5, "doanontype");
setclosureframe(closure10300, stackframe);
  addtoclosure(closure10300, var_sym);
  addtoclosure(closure10300, var_errormessages);
  addtoclosure(closure10300, var_auto_count);
  addtoclosure(closure10300, var_values);
  addtoclosure(closure10300, var_ast);
  struct UserObject *uo10300 = (struct UserObject*)self;
  uo10300->data[52] = (Object)closure10300;
  Method *meth_meth_parser_doanontype10300 = addmethod2pos(self, "doanontype", &meth_parser_doanontype10300, 52);
int argcv_meth_parser_doanontype10300[] = {0};
meth_meth_parser_doanontype10300->type = alloc_MethodType(1, argcv_meth_parser_doanontype10300);
  meth_meth_parser_doanontype10300->definitionModule = modulename;
  meth_meth_parser_doanontype10300->definitionLine = 3172;
// compilenode returning 
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10384 = createclosure(5, "dotype");
setclosureframe(closure10384, stackframe);
  addtoclosure(closure10384, var_sym);
  addtoclosure(closure10384, var_errormessages);
  addtoclosure(closure10384, var_lastToken);
  addtoclosure(closure10384, var_values);
  addtoclosure(closure10384, var_ast);
  struct UserObject *uo10384 = (struct UserObject*)self;
  uo10384->data[53] = (Object)closure10384;
  Method *meth_meth_parser_dotype10384 = addmethod2pos(self, "dotype", &meth_parser_dotype10384, 53);
int argcv_meth_parser_dotype10384[] = {0};
meth_meth_parser_dotype10384->type = alloc_MethodType(1, argcv_meth_parser_dotype10384);
  meth_meth_parser_dotype10384->definitionModule = modulename;
  meth_meth_parser_dotype10384->definitionLine = 3197;
// compilenode returning 
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10636 = createclosure(5, "checkIndent");
setclosureframe(closure10636, stackframe);
  addtoclosure(closure10636, var_indentFreePass);
  addtoclosure(closure10636, var_sym);
  addtoclosure(closure10636, var_minIndentLevel);
  addtoclosure(closure10636, var_errormessages);
  addtoclosure(closure10636, var_lastToken);
  struct UserObject *uo10636 = (struct UserObject*)self;
  uo10636->data[54] = (Object)closure10636;
  Method *meth_meth_parser_checkIndent10636 = addmethod2pos(self, "checkIndent", &meth_parser_checkIndent10636, 54);
int argcv_meth_parser_checkIndent10636[] = {0};
meth_meth_parser_checkIndent10636->type = alloc_MethodType(1, argcv_meth_parser_checkIndent10636);
  meth_meth_parser_checkIndent10636->definitionModule = modulename;
  meth_meth_parser_checkIndent10636->definitionLine = 3267;
// compilenode returning 
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure10816 = createclosure(8, "statement");
setclosureframe(closure10816, stackframe);
  addtoclosure(closure10816, var_sym);
  addtoclosure(closure10816, var_statementIndent);
  addtoclosure(closure10816, var_statementToken);
  addtoclosure(closure10816, var_values);
  addtoclosure(closure10816, var_errormessages);
  addtoclosure(closure10816, var_lastToken);
  addtoclosure(closure10816, var_ast);
  addtoclosure(closure10816, var_indentFreePass);
  struct UserObject *uo10816 = (struct UserObject*)self;
  uo10816->data[55] = (Object)closure10816;
  Method *meth_meth_parser_statement10816 = addmethod2pos(self, "statement", &meth_parser_statement10816, 55);
int argcv_meth_parser_statement10816[] = {0};
meth_meth_parser_statement10816->type = alloc_MethodType(1, argcv_meth_parser_statement10816);
  meth_meth_parser_statement10816->definitionModule = modulename;
  meth_meth_parser_statement10816->definitionLine = 3308;
// compilenode returning 
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11028 = createclosure(2, "checkBadOperators");
setclosureframe(closure11028, stackframe);
  addtoclosure(closure11028, var_sym);
  addtoclosure(closure11028, var_errormessages);
  struct UserObject *uo11028 = (struct UserObject*)self;
  uo11028->data[56] = (Object)closure11028;
  Method *meth_meth_parser_checkBadOperators11028 = addmethod2pos(self, "checkBadOperators", &meth_parser_checkBadOperators11028, 56);
int argcv_meth_parser_checkBadOperators11028[] = {0};
meth_meth_parser_checkBadOperators11028->type = alloc_MethodType(1, argcv_meth_parser_checkBadOperators11028);
  meth_meth_parser_checkBadOperators11028->definitionModule = modulename;
  meth_meth_parser_checkBadOperators11028->definitionLine = 3374;
// compilenode returning 
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11075 = createclosure(2, "checkBadAnonymousType");
setclosureframe(closure11075, stackframe);
  addtoclosure(closure11075, var_sym);
  addtoclosure(closure11075, var_errormessages);
  struct UserObject *uo11075 = (struct UserObject*)self;
  uo11075->data[57] = (Object)closure11075;
  Method *meth_meth_parser_checkBadAnonymousType11075 = addmethod2pos(self, "checkBadAnonymousType", &meth_parser_checkBadAnonymousType11075, 57);
int argcv_meth_parser_checkBadAnonymousType11075[] = {0};
meth_meth_parser_checkBadAnonymousType11075->type = alloc_MethodType(1, argcv_meth_parser_checkBadAnonymousType11075);
  meth_meth_parser_checkBadAnonymousType11075->definitionModule = modulename;
  meth_meth_parser_checkBadAnonymousType11075->definitionLine = 3391;
// compilenode returning 
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11099 = createclosure(5, "checkUnexpectedTokenAfterStatement");
setclosureframe(closure11099, stackframe);
  addtoclosure(closure11099, var_lastToken);
  addtoclosure(closure11099, var_sym);
  addtoclosure(closure11099, var_errormessages);
  addtoclosure(closure11099, var_values);
  addtoclosure(closure11099, var_util);
  struct UserObject *uo11099 = (struct UserObject*)self;
  uo11099->data[58] = (Object)closure11099;
  Method *meth_meth_parser_checkUnexpectedTokenAfterStatement11099 = addmethod2pos(self, "checkUnexpectedTokenAfterStatement", &meth_parser_checkUnexpectedTokenAfterStatement11099, 58);
int argcv_meth_parser_checkUnexpectedTokenAfterStatement11099[] = {0};
meth_meth_parser_checkUnexpectedTokenAfterStatement11099->type = alloc_MethodType(1, argcv_meth_parser_checkUnexpectedTokenAfterStatement11099);
  meth_meth_parser_checkUnexpectedTokenAfterStatement11099->definitionModule = modulename;
  meth_meth_parser_checkUnexpectedTokenAfterStatement11099->definitionLine = 3401;
// compilenode returning 
// Begin line 3472
  setline(3472);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11419 = createclosure(10, "parse");
setclosureframe(closure11419, stackframe);
  addtoclosure(closure11419, var_util);
  addtoclosure(closure11419, var_values);
  addtoclosure(closure11419, var_defaultDefVisibility);
  addtoclosure(closure11419, var_defaultVarVisibility);
  addtoclosure(closure11419, var_defaultMethodVisibility);
  addtoclosure(closure11419, var_tokens);
  addtoclosure(closure11419, var_sym);
  addtoclosure(closure11419, var_lastToken);
  addtoclosure(closure11419, var_linenum);
  addtoclosure(closure11419, var_errormessages);
  struct UserObject *uo11419 = (struct UserObject*)self;
  uo11419->data[59] = (Object)closure11419;
  Method *meth_meth_parser_parse11419 = addmethod2pos(self, "parse", &meth_parser_parse11419, 59);
int argcv_meth_parser_parse11419[] = {1};
meth_meth_parser_parse11419->type = alloc_MethodType(1, argcv_meth_parser_parse11419);
  meth_meth_parser_parse11419->definitionModule = modulename;
  meth_meth_parser_parse11419->definitionLine = 3472;
  block_savedest(self);
  Object closure11604 = createclosure(10, "parse()object");
setclosureframe(closure11604, stackframe);
  addtoclosure(closure11604, var_util);
  addtoclosure(closure11604, var_values);
  addtoclosure(closure11604, var_defaultDefVisibility);
  addtoclosure(closure11604, var_defaultVarVisibility);
  addtoclosure(closure11604, var_defaultMethodVisibility);
  addtoclosure(closure11604, var_tokens);
  addtoclosure(closure11604, var_sym);
  addtoclosure(closure11604, var_lastToken);
  addtoclosure(closure11604, var_linenum);
  addtoclosure(closure11604, var_errormessages);
  Method *meth_meth_parser_parse11419_object = addmethod2pos(self, "parse()object", &meth_parser_parse11419_object, 59);
  meth_meth_parser_parse11419_object->definitionModule = modulename;
  meth_meth_parser_parse11419_object->definitionLine = 3472;
// compilenode returning 
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compilenode returning done
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of ast as ast
  if (module_ast == NULL)
    module_ast = module_ast_init();
  *var_ast = module_ast;
// compilenode returning done
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of util as util
  if (module_util == NULL)
    module_util = module_util_init();
  *var_util = module_util;
// compilenode returning done
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of mgcollections as collections
  if (module_mgcollections == NULL)
    module_mgcollections = module_mgcollections_init();
  *var_collections = module_mgcollections;
// compilenode returning done
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// Import of errormessages as errormessages
  if (module_errormessages == NULL)
    module_errormessages = module_errormessages_init();
  *var_errormessages = module_errormessages;
// compilenode returning done
// compilenode returning 
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11605 = alloc_Boolean(1);
// compilenode returning bool11605
  *var_don_39_tBreak = bool11605;
  if (bool11605 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11606 = createclosure(1, "don'tBreak");
setclosureframe(closure11606, stackframe);
  addtoclosure(closure11606, var_don_39_tBreak);
  struct UserObject *uo11606 = (struct UserObject*)self;
  uo11606->data[60] = (Object)closure11606;
  Method *meth_meth_parser_don_39_tBreak11606 = addmethod2pos(self, "don'tBreak", &meth_parser_don_39_tBreak11606, 60);
int argcv_meth_parser_don_39_tBreak11606[] = {0};
meth_meth_parser_don_39_tBreak11606->type = alloc_MethodType(1, argcv_meth_parser_don_39_tBreak11606);
  meth_meth_parser_don_39_tBreak11606->definitionModule = modulename;
  meth_meth_parser_don_39_tBreak11606->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11607 = alloc_Float64(0);
// compilenode returning num11607
  *var_lastline = num11607;
  if (num11607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11608 = createclosure(1, "lastline");
setclosureframe(closure11608, stackframe);
  addtoclosure(closure11608, var_lastline);
  struct UserObject *uo11608 = (struct UserObject*)self;
  uo11608->data[61] = (Object)closure11608;
  Method *meth_meth_parser_lastline11608 = addmethod2pos(self, "lastline", &meth_parser_lastline11608, 61);
int argcv_meth_parser_lastline11608[] = {0};
meth_meth_parser_lastline11608->type = alloc_MethodType(1, argcv_meth_parser_lastline11608);
  meth_meth_parser_lastline11608->definitionModule = modulename;
  meth_meth_parser_lastline11608->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11609 = createclosure(1, "lastline:=");
setclosureframe(closure11609, stackframe);
  addtoclosure(closure11609, var_lastline);
  struct UserObject *uo11609 = (struct UserObject*)self;
  uo11609->data[62] = (Object)closure11609;
  Method *meth_meth_parser_lastline_58__61_11609 = addmethod2pos(self, "lastline:=", &meth_parser_lastline_58__61_11609, 62);
int argcv_meth_parser_lastline_58__61_11609[] = {1};
meth_meth_parser_lastline_58__61_11609->type = alloc_MethodType(1, argcv_meth_parser_lastline_58__61_11609);
  meth_meth_parser_lastline_58__61_11609->definitionModule = modulename;
  meth_meth_parser_lastline_58__61_11609->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11611 = alloc_Float64(0);
// compilenode returning num11611
  *var_linenum = num11611;
  if (num11611 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11612 = createclosure(1, "linenum");
setclosureframe(closure11612, stackframe);
  addtoclosure(closure11612, var_linenum);
  struct UserObject *uo11612 = (struct UserObject*)self;
  uo11612->data[63] = (Object)closure11612;
  Method *meth_meth_parser_linenum11612 = addmethod2pos(self, "linenum", &meth_parser_linenum11612, 63);
int argcv_meth_parser_linenum11612[] = {0};
meth_meth_parser_linenum11612->type = alloc_MethodType(1, argcv_meth_parser_linenum11612);
  meth_meth_parser_linenum11612->definitionModule = modulename;
  meth_meth_parser_linenum11612->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11613 = createclosure(1, "linenum:=");
setclosureframe(closure11613, stackframe);
  addtoclosure(closure11613, var_linenum);
  struct UserObject *uo11613 = (struct UserObject*)self;
  uo11613->data[64] = (Object)closure11613;
  Method *meth_meth_parser_linenum_58__61_11613 = addmethod2pos(self, "linenum:=", &meth_parser_linenum_58__61_11613, 64);
int argcv_meth_parser_linenum_58__61_11613[] = {1};
meth_meth_parser_linenum_58__61_11613->type = alloc_MethodType(1, argcv_meth_parser_linenum_58__61_11613);
  meth_meth_parser_linenum_58__61_11613->definitionModule = modulename;
  meth_meth_parser_linenum_58__61_11613->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11615 = alloc_Float64(0);
// compilenode returning num11615
  *var_lastIndent = num11615;
  if (num11615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11616 = createclosure(1, "lastIndent");
setclosureframe(closure11616, stackframe);
  addtoclosure(closure11616, var_lastIndent);
  struct UserObject *uo11616 = (struct UserObject*)self;
  uo11616->data[65] = (Object)closure11616;
  Method *meth_meth_parser_lastIndent11616 = addmethod2pos(self, "lastIndent", &meth_parser_lastIndent11616, 65);
int argcv_meth_parser_lastIndent11616[] = {0};
meth_meth_parser_lastIndent11616->type = alloc_MethodType(1, argcv_meth_parser_lastIndent11616);
  meth_meth_parser_lastIndent11616->definitionModule = modulename;
  meth_meth_parser_lastIndent11616->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11617 = createclosure(1, "lastIndent:=");
setclosureframe(closure11617, stackframe);
  addtoclosure(closure11617, var_lastIndent);
  struct UserObject *uo11617 = (struct UserObject*)self;
  uo11617->data[66] = (Object)closure11617;
  Method *meth_meth_parser_lastIndent_58__61_11617 = addmethod2pos(self, "lastIndent:=", &meth_parser_lastIndent_58__61_11617, 66);
int argcv_meth_parser_lastIndent_58__61_11617[] = {1};
meth_meth_parser_lastIndent_58__61_11617->type = alloc_MethodType(1, argcv_meth_parser_lastIndent_58__61_11617);
  meth_meth_parser_lastIndent_58__61_11617->definitionModule = modulename;
  meth_meth_parser_lastIndent_58__61_11617->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 12
  setline(12);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11619 = alloc_Boolean(0);
// compilenode returning bool11619
  *var_indentFreePass = bool11619;
  if (bool11619 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11620 = createclosure(1, "indentFreePass");
setclosureframe(closure11620, stackframe);
  addtoclosure(closure11620, var_indentFreePass);
  struct UserObject *uo11620 = (struct UserObject*)self;
  uo11620->data[67] = (Object)closure11620;
  Method *meth_meth_parser_indentFreePass11620 = addmethod2pos(self, "indentFreePass", &meth_parser_indentFreePass11620, 67);
int argcv_meth_parser_indentFreePass11620[] = {0};
meth_meth_parser_indentFreePass11620->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass11620);
  meth_meth_parser_indentFreePass11620->definitionModule = modulename;
  meth_meth_parser_indentFreePass11620->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11621 = createclosure(1, "indentFreePass:=");
setclosureframe(closure11621, stackframe);
  addtoclosure(closure11621, var_indentFreePass);
  struct UserObject *uo11621 = (struct UserObject*)self;
  uo11621->data[68] = (Object)closure11621;
  Method *meth_meth_parser_indentFreePass_58__61_11621 = addmethod2pos(self, "indentFreePass:=", &meth_parser_indentFreePass_58__61_11621, 68);
int argcv_meth_parser_indentFreePass_58__61_11621[] = {1};
meth_meth_parser_indentFreePass_58__61_11621->type = alloc_MethodType(1, argcv_meth_parser_indentFreePass_58__61_11621);
  meth_meth_parser_indentFreePass_58__61_11621->definitionModule = modulename;
  meth_meth_parser_indentFreePass_58__61_11621->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11623 = alloc_Float64(0);
// compilenode returning num11623
  *var_minIndentLevel = num11623;
  if (num11623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11624 = createclosure(1, "minIndentLevel");
setclosureframe(closure11624, stackframe);
  addtoclosure(closure11624, var_minIndentLevel);
  struct UserObject *uo11624 = (struct UserObject*)self;
  uo11624->data[69] = (Object)closure11624;
  Method *meth_meth_parser_minIndentLevel11624 = addmethod2pos(self, "minIndentLevel", &meth_parser_minIndentLevel11624, 69);
int argcv_meth_parser_minIndentLevel11624[] = {0};
meth_meth_parser_minIndentLevel11624->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel11624);
  meth_meth_parser_minIndentLevel11624->definitionModule = modulename;
  meth_meth_parser_minIndentLevel11624->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11625 = createclosure(1, "minIndentLevel:=");
setclosureframe(closure11625, stackframe);
  addtoclosure(closure11625, var_minIndentLevel);
  struct UserObject *uo11625 = (struct UserObject*)self;
  uo11625->data[70] = (Object)closure11625;
  Method *meth_meth_parser_minIndentLevel_58__61_11625 = addmethod2pos(self, "minIndentLevel:=", &meth_parser_minIndentLevel_58__61_11625, 70);
int argcv_meth_parser_minIndentLevel_58__61_11625[] = {1};
meth_meth_parser_minIndentLevel_58__61_11625->type = alloc_MethodType(1, argcv_meth_parser_minIndentLevel_58__61_11625);
  meth_meth_parser_minIndentLevel_58__61_11625->definitionModule = modulename;
  meth_meth_parser_minIndentLevel_58__61_11625->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 14
  setline(14);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11627 = alloc_Float64(0);
// compilenode returning num11627
  *var_statementIndent = num11627;
  if (num11627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11628 = createclosure(1, "statementIndent");
setclosureframe(closure11628, stackframe);
  addtoclosure(closure11628, var_statementIndent);
  struct UserObject *uo11628 = (struct UserObject*)self;
  uo11628->data[71] = (Object)closure11628;
  Method *meth_meth_parser_statementIndent11628 = addmethod2pos(self, "statementIndent", &meth_parser_statementIndent11628, 71);
int argcv_meth_parser_statementIndent11628[] = {0};
meth_meth_parser_statementIndent11628->type = alloc_MethodType(1, argcv_meth_parser_statementIndent11628);
  meth_meth_parser_statementIndent11628->definitionModule = modulename;
  meth_meth_parser_statementIndent11628->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11629 = createclosure(1, "statementIndent:=");
setclosureframe(closure11629, stackframe);
  addtoclosure(closure11629, var_statementIndent);
  struct UserObject *uo11629 = (struct UserObject*)self;
  uo11629->data[72] = (Object)closure11629;
  Method *meth_meth_parser_statementIndent_58__61_11629 = addmethod2pos(self, "statementIndent:=", &meth_parser_statementIndent_58__61_11629, 72);
int argcv_meth_parser_statementIndent_58__61_11629[] = {1};
meth_meth_parser_statementIndent_58__61_11629->type = alloc_MethodType(1, argcv_meth_parser_statementIndent_58__61_11629);
  meth_meth_parser_statementIndent_58__61_11629->definitionModule = modulename;
  meth_meth_parser_statementIndent_58__61_11629->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_statementToken = undefined;
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11631 = createclosure(1, "statementToken");
setclosureframe(closure11631, stackframe);
  addtoclosure(closure11631, var_statementToken);
  struct UserObject *uo11631 = (struct UserObject*)self;
  uo11631->data[73] = (Object)closure11631;
  Method *meth_meth_parser_statementToken11631 = addmethod2pos(self, "statementToken", &meth_parser_statementToken11631, 73);
int argcv_meth_parser_statementToken11631[] = {0};
meth_meth_parser_statementToken11631->type = alloc_MethodType(1, argcv_meth_parser_statementToken11631);
  meth_meth_parser_statementToken11631->definitionModule = modulename;
  meth_meth_parser_statementToken11631->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11632 = createclosure(1, "statementToken:=");
setclosureframe(closure11632, stackframe);
  addtoclosure(closure11632, var_statementToken);
  struct UserObject *uo11632 = (struct UserObject*)self;
  uo11632->data[74] = (Object)closure11632;
  Method *meth_meth_parser_statementToken_58__61_11632 = addmethod2pos(self, "statementToken:=", &meth_parser_statementToken_58__61_11632, 74);
int argcv_meth_parser_statementToken_58__61_11632[] = {1};
meth_meth_parser_statementToken_58__61_11632->type = alloc_MethodType(1, argcv_meth_parser_statementToken_58__61_11632);
  meth_meth_parser_statementToken_58__61_11632->definitionModule = modulename;
  meth_meth_parser_statementToken_58__61_11632->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11634 = alloc_Boolean(0);
// compilenode returning bool11634
  *var_tokens = bool11634;
  if (bool11634 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11635 = createclosure(1, "tokens");
setclosureframe(closure11635, stackframe);
  addtoclosure(closure11635, var_tokens);
  struct UserObject *uo11635 = (struct UserObject*)self;
  uo11635->data[75] = (Object)closure11635;
  Method *meth_meth_parser_tokens11635 = addmethod2pos(self, "tokens", &meth_parser_tokens11635, 75);
int argcv_meth_parser_tokens11635[] = {0};
meth_meth_parser_tokens11635->type = alloc_MethodType(1, argcv_meth_parser_tokens11635);
  meth_meth_parser_tokens11635->definitionModule = modulename;
  meth_meth_parser_tokens11635->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11636 = createclosure(1, "tokens:=");
setclosureframe(closure11636, stackframe);
  addtoclosure(closure11636, var_tokens);
  struct UserObject *uo11636 = (struct UserObject*)self;
  uo11636->data[76] = (Object)closure11636;
  Method *meth_meth_parser_tokens_58__61_11636 = addmethod2pos(self, "tokens:=", &meth_parser_tokens_58__61_11636, 76);
int argcv_meth_parser_tokens_58__61_11636[] = {1};
meth_meth_parser_tokens_58__61_11636->type = alloc_MethodType(1, argcv_meth_parser_tokens_58__61_11636);
  meth_meth_parser_tokens_58__61_11636->definitionModule = modulename;
  meth_meth_parser_tokens_58__61_11636->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 17
  setline(17);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object array11638 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compilenode returning array11638
  *var_values = array11638;
  if (array11638 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11639 = createclosure(1, "values");
setclosureframe(closure11639, stackframe);
  addtoclosure(closure11639, var_values);
  struct UserObject *uo11639 = (struct UserObject*)self;
  uo11639->data[77] = (Object)closure11639;
  Method *meth_meth_parser_values11639 = addmethod2pos(self, "values", &meth_parser_values11639, 77);
int argcv_meth_parser_values11639[] = {0};
meth_meth_parser_values11639->type = alloc_MethodType(1, argcv_meth_parser_values11639);
  meth_meth_parser_values11639->definitionModule = modulename;
  meth_meth_parser_values11639->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11640 = createclosure(1, "values:=");
setclosureframe(closure11640, stackframe);
  addtoclosure(closure11640, var_values);
  struct UserObject *uo11640 = (struct UserObject*)self;
  uo11640->data[78] = (Object)closure11640;
  Method *meth_meth_parser_values_58__61_11640 = addmethod2pos(self, "values:=", &meth_parser_values_58__61_11640, 78);
int argcv_meth_parser_values_58__61_11640[] = {1};
meth_meth_parser_values_58__61_11640->type = alloc_MethodType(1, argcv_meth_parser_values_58__61_11640);
  meth_meth_parser_values_58__61_11640->definitionModule = modulename;
  meth_meth_parser_values_58__61_11640->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 18
  setline(18);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11642 = alloc_Float64(0);
// compilenode returning num11642
  *var_auto_count = num11642;
  if (num11642 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11643 = createclosure(1, "auto_count");
setclosureframe(closure11643, stackframe);
  addtoclosure(closure11643, var_auto_count);
  struct UserObject *uo11643 = (struct UserObject*)self;
  uo11643->data[79] = (Object)closure11643;
  Method *meth_meth_parser_auto_count11643 = addmethod2pos(self, "auto_count", &meth_parser_auto_count11643, 79);
int argcv_meth_parser_auto_count11643[] = {0};
meth_meth_parser_auto_count11643->type = alloc_MethodType(1, argcv_meth_parser_auto_count11643);
  meth_meth_parser_auto_count11643->definitionModule = modulename;
  meth_meth_parser_auto_count11643->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11644 = createclosure(1, "auto_count:=");
setclosureframe(closure11644, stackframe);
  addtoclosure(closure11644, var_auto_count);
  struct UserObject *uo11644 = (struct UserObject*)self;
  uo11644->data[80] = (Object)closure11644;
  Method *meth_meth_parser_auto_count_58__61_11644 = addmethod2pos(self, "auto_count:=", &meth_parser_auto_count_58__61_11644, 80);
int argcv_meth_parser_auto_count_58__61_11644[] = {1};
meth_meth_parser_auto_count_58__61_11644->type = alloc_MethodType(1, argcv_meth_parser_auto_count_58__61_11644);
  meth_meth_parser_auto_count_58__61_11644->definitionModule = modulename;
  meth_meth_parser_auto_count_58__61_11644->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11646 = alloc_Boolean(0);
// compilenode returning bool11646
  *var_don_39_tTakeBlock = bool11646;
  if (bool11646 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11647 = createclosure(1, "don'tTakeBlock");
setclosureframe(closure11647, stackframe);
  addtoclosure(closure11647, var_don_39_tTakeBlock);
  struct UserObject *uo11647 = (struct UserObject*)self;
  uo11647->data[81] = (Object)closure11647;
  Method *meth_meth_parser_don_39_tTakeBlock11647 = addmethod2pos(self, "don'tTakeBlock", &meth_parser_don_39_tTakeBlock11647, 81);
int argcv_meth_parser_don_39_tTakeBlock11647[] = {0};
meth_meth_parser_don_39_tTakeBlock11647->type = alloc_MethodType(1, argcv_meth_parser_don_39_tTakeBlock11647);
  meth_meth_parser_don_39_tTakeBlock11647->definitionModule = modulename;
  meth_meth_parser_don_39_tTakeBlock11647->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11648 = createclosure(1, "don'tTakeBlock:=");
setclosureframe(closure11648, stackframe);
  addtoclosure(closure11648, var_don_39_tTakeBlock);
  struct UserObject *uo11648 = (struct UserObject*)self;
  uo11648->data[82] = (Object)closure11648;
  Method *meth_meth_parser_don_39_tTakeBlock_58__61_11648 = addmethod2pos(self, "don'tTakeBlock:=", &meth_parser_don_39_tTakeBlock_58__61_11648, 82);
int argcv_meth_parser_don_39_tTakeBlock_58__61_11648[] = {1};
meth_meth_parser_don_39_tTakeBlock_58__61_11648->type = alloc_MethodType(1, argcv_meth_parser_don_39_tTakeBlock_58__61_11648);
  meth_meth_parser_don_39_tTakeBlock_58__61_11648->definitionModule = modulename;
  meth_meth_parser_don_39_tTakeBlock_58__61_11648->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11650 = alloc_Boolean(0);
// compilenode returning bool11650
  *var_braceIsType = bool11650;
  if (bool11650 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11651 = createclosure(1, "braceIsType");
setclosureframe(closure11651, stackframe);
  addtoclosure(closure11651, var_braceIsType);
  struct UserObject *uo11651 = (struct UserObject*)self;
  uo11651->data[83] = (Object)closure11651;
  Method *meth_meth_parser_braceIsType11651 = addmethod2pos(self, "braceIsType", &meth_parser_braceIsType11651, 83);
int argcv_meth_parser_braceIsType11651[] = {0};
meth_meth_parser_braceIsType11651->type = alloc_MethodType(1, argcv_meth_parser_braceIsType11651);
  meth_meth_parser_braceIsType11651->definitionModule = modulename;
  meth_meth_parser_braceIsType11651->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11652 = createclosure(1, "braceIsType:=");
setclosureframe(closure11652, stackframe);
  addtoclosure(closure11652, var_braceIsType);
  struct UserObject *uo11652 = (struct UserObject*)self;
  uo11652->data[84] = (Object)closure11652;
  Method *meth_meth_parser_braceIsType_58__61_11652 = addmethod2pos(self, "braceIsType:=", &meth_parser_braceIsType_58__61_11652, 84);
int argcv_meth_parser_braceIsType_58__61_11652[] = {1};
meth_meth_parser_braceIsType_58__61_11652->type = alloc_MethodType(1, argcv_meth_parser_braceIsType_58__61_11652);
  meth_meth_parser_braceIsType_58__61_11652->definitionModule = modulename;
  meth_meth_parser_braceIsType_58__61_11652->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 21
  setline(21);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11654 == NULL) {
    strlit11654 = alloc_String("confidential");
    gc_root(strlit11654);
  }
// compilenode returning strlit11654
  *var_defaultDefVisibility = strlit11654;
  if (strlit11654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11655 = createclosure(1, "defaultDefVisibility");
setclosureframe(closure11655, stackframe);
  addtoclosure(closure11655, var_defaultDefVisibility);
  struct UserObject *uo11655 = (struct UserObject*)self;
  uo11655->data[85] = (Object)closure11655;
  Method *meth_meth_parser_defaultDefVisibility11655 = addmethod2pos(self, "defaultDefVisibility", &meth_parser_defaultDefVisibility11655, 85);
int argcv_meth_parser_defaultDefVisibility11655[] = {0};
meth_meth_parser_defaultDefVisibility11655->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility11655);
  meth_meth_parser_defaultDefVisibility11655->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility11655->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11656 = createclosure(1, "defaultDefVisibility:=");
setclosureframe(closure11656, stackframe);
  addtoclosure(closure11656, var_defaultDefVisibility);
  struct UserObject *uo11656 = (struct UserObject*)self;
  uo11656->data[86] = (Object)closure11656;
  Method *meth_meth_parser_defaultDefVisibility_58__61_11656 = addmethod2pos(self, "defaultDefVisibility:=", &meth_parser_defaultDefVisibility_58__61_11656, 86);
int argcv_meth_parser_defaultDefVisibility_58__61_11656[] = {1};
meth_meth_parser_defaultDefVisibility_58__61_11656->type = alloc_MethodType(1, argcv_meth_parser_defaultDefVisibility_58__61_11656);
  meth_meth_parser_defaultDefVisibility_58__61_11656->definitionModule = modulename;
  meth_meth_parser_defaultDefVisibility_58__61_11656->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 22
  setline(22);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11658 == NULL) {
    strlit11658 = alloc_String("confidential");
    gc_root(strlit11658);
  }
// compilenode returning strlit11658
  *var_defaultVarVisibility = strlit11658;
  if (strlit11658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11659 = createclosure(1, "defaultVarVisibility");
setclosureframe(closure11659, stackframe);
  addtoclosure(closure11659, var_defaultVarVisibility);
  struct UserObject *uo11659 = (struct UserObject*)self;
  uo11659->data[87] = (Object)closure11659;
  Method *meth_meth_parser_defaultVarVisibility11659 = addmethod2pos(self, "defaultVarVisibility", &meth_parser_defaultVarVisibility11659, 87);
int argcv_meth_parser_defaultVarVisibility11659[] = {0};
meth_meth_parser_defaultVarVisibility11659->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility11659);
  meth_meth_parser_defaultVarVisibility11659->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility11659->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11660 = createclosure(1, "defaultVarVisibility:=");
setclosureframe(closure11660, stackframe);
  addtoclosure(closure11660, var_defaultVarVisibility);
  struct UserObject *uo11660 = (struct UserObject*)self;
  uo11660->data[88] = (Object)closure11660;
  Method *meth_meth_parser_defaultVarVisibility_58__61_11660 = addmethod2pos(self, "defaultVarVisibility:=", &meth_parser_defaultVarVisibility_58__61_11660, 88);
int argcv_meth_parser_defaultVarVisibility_58__61_11660[] = {1};
meth_meth_parser_defaultVarVisibility_58__61_11660->type = alloc_MethodType(1, argcv_meth_parser_defaultVarVisibility_58__61_11660);
  meth_meth_parser_defaultVarVisibility_58__61_11660->definitionModule = modulename;
  meth_meth_parser_defaultVarVisibility_58__61_11660->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11662 == NULL) {
    strlit11662 = alloc_String("public");
    gc_root(strlit11662);
  }
// compilenode returning strlit11662
  *var_defaultMethodVisibility = strlit11662;
  if (strlit11662 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11663 = createclosure(1, "defaultMethodVisibility");
setclosureframe(closure11663, stackframe);
  addtoclosure(closure11663, var_defaultMethodVisibility);
  struct UserObject *uo11663 = (struct UserObject*)self;
  uo11663->data[89] = (Object)closure11663;
  Method *meth_meth_parser_defaultMethodVisibility11663 = addmethod2pos(self, "defaultMethodVisibility", &meth_parser_defaultMethodVisibility11663, 89);
int argcv_meth_parser_defaultMethodVisibility11663[] = {0};
meth_meth_parser_defaultMethodVisibility11663->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility11663);
  meth_meth_parser_defaultMethodVisibility11663->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility11663->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11664 = createclosure(1, "defaultMethodVisibility:=");
setclosureframe(closure11664, stackframe);
  addtoclosure(closure11664, var_defaultMethodVisibility);
  struct UserObject *uo11664 = (struct UserObject*)self;
  uo11664->data[90] = (Object)closure11664;
  Method *meth_meth_parser_defaultMethodVisibility_58__61_11664 = addmethod2pos(self, "defaultMethodVisibility:=", &meth_parser_defaultMethodVisibility_58__61_11664, 90);
int argcv_meth_parser_defaultMethodVisibility_58__61_11664[] = {1};
meth_meth_parser_defaultMethodVisibility_58__61_11664->type = alloc_MethodType(1, argcv_meth_parser_defaultMethodVisibility_58__61_11664);
  meth_meth_parser_defaultMethodVisibility_58__61_11664->definitionModule = modulename;
  meth_meth_parser_defaultMethodVisibility_58__61_11664->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
  *var_sym = undefined;
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11666 = createclosure(1, "sym");
setclosureframe(closure11666, stackframe);
  addtoclosure(closure11666, var_sym);
  struct UserObject *uo11666 = (struct UserObject*)self;
  uo11666->data[91] = (Object)closure11666;
  Method *meth_meth_parser_sym11666 = addmethod2pos(self, "sym", &meth_parser_sym11666, 91);
int argcv_meth_parser_sym11666[] = {0};
meth_meth_parser_sym11666->type = alloc_MethodType(1, argcv_meth_parser_sym11666);
  meth_meth_parser_sym11666->definitionModule = modulename;
  meth_meth_parser_sym11666->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11667 = createclosure(1, "sym:=");
setclosureframe(closure11667, stackframe);
  addtoclosure(closure11667, var_sym);
  struct UserObject *uo11667 = (struct UserObject*)self;
  uo11667->data[92] = (Object)closure11667;
  Method *meth_meth_parser_sym_58__61_11667 = addmethod2pos(self, "sym:=", &meth_parser_sym_58__61_11667, 92);
int argcv_meth_parser_sym_58__61_11667[] = {1};
meth_meth_parser_sym_58__61_11667->type = alloc_MethodType(1, argcv_meth_parser_sym_58__61_11667);
  meth_meth_parser_sym_58__61_11667->definitionModule = modulename;
  meth_meth_parser_sym_58__61_11667->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object inheritingObject11669 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj11669 = alloc_userobj2(11,7, objclass11669);
  gc_frame_newslot(obj11669);
// OBJECT OUTER DEC outer
  adddatum2(obj11669, self, 0);
  addmethodreal(obj11669,"outer", &reader_parser_outer_11670);
  Object oldself11669 = self;
  struct StackFrameObject *oldstackframe11669 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe11669);
  gc_frame_newslot((Object)stackframe);
  self = obj11669;
  Object *oldselfslot11669 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter11669 = (*(struct UserObject *)self).data[0], lowerouter11669 = thisouter11669;
  if (inheritingObject11669) {
    struct UserObject *inho11669 = (struct UserObject *)inheritingObject11669;
    while (inho11669->super != GraceDefaultObject) inho11669 = (struct UserObject *)inho11669->super;
    inho11669->super = obj11669;
    self = inheritingObject11669;
    *selfslot = self;
    lowerouter11669 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter11669;
  }
if (objclass11669 == NULL) {
  Method *reader11671 = addmethodrealflags(obj11669, "kind",&reader_parser_kind_11671, 0);
  Method *writer11671 = addmethodrealflags(obj11669, "kind:=",&writer_parser_kind_11671, 0);
  reader11671->definitionModule = modulename;
  writer11671->definitionModule = modulename;
  reader11671->definitionLine = 29;
  writer11671->definitionLine = 29;
}
obj11669->flags |= OFLAG_MUTABLE;
adddatum2(obj11669, alloc_Undefined(), 1);
if (objclass11669 == NULL) {
  Method *reader11672 = addmethodrealflags(obj11669, "line",&reader_parser_line_11672, 0);
  Method *writer11672 = addmethodrealflags(obj11669, "line:=",&writer_parser_line_11672, 0);
  reader11672->definitionModule = modulename;
  writer11672->definitionModule = modulename;
  reader11672->definitionLine = 30;
  writer11672->definitionLine = 30;
}
obj11669->flags |= OFLAG_MUTABLE;
adddatum2(obj11669, alloc_Undefined(), 2);
if (objclass11669 == NULL) {
  Method *reader11673 = addmethodrealflags(obj11669, "linePos",&reader_parser_linePos_11673, 0);
  Method *writer11673 = addmethodrealflags(obj11669, "linePos:=",&writer_parser_linePos_11673, 0);
  reader11673->definitionModule = modulename;
  writer11673->definitionModule = modulename;
  reader11673->definitionLine = 31;
  writer11673->definitionLine = 31;
}
obj11669->flags |= OFLAG_MUTABLE;
adddatum2(obj11669, alloc_Undefined(), 3);
if (objclass11669 == NULL) {
  Method *reader11674 = addmethodrealflags(obj11669, "indent",&reader_parser_indent_11674, 0);
  Method *writer11674 = addmethodrealflags(obj11669, "indent:=",&writer_parser_indent_11674, 0);
  reader11674->definitionModule = modulename;
  writer11674->definitionModule = modulename;
  reader11674->definitionLine = 32;
  writer11674->definitionLine = 32;
}
obj11669->flags |= OFLAG_MUTABLE;
adddatum2(obj11669, alloc_Undefined(), 4);
if (objclass11669 == NULL) {
  Method *reader11675 = addmethodrealflags(obj11669, "value",&reader_parser_value_11675, 0);
  Method *writer11675 = addmethodrealflags(obj11669, "value:=",&writer_parser_value_11675, 0);
  reader11675->definitionModule = modulename;
  writer11675->definitionModule = modulename;
  reader11675->definitionLine = 33;
  writer11675->definitionLine = 33;
}
obj11669->flags |= OFLAG_MUTABLE;
adddatum2(obj11669, alloc_Undefined(), 5);
if (objclass11669 == NULL) {
  Method *reader11676 = addmethodrealflags(obj11669, "size",&reader_parser_size_11676, MFLAG_DEF);
  reader11676->definitionModule = modulename;
  reader11676->definitionLine = 34;
}
adddatum2(obj11669, alloc_Undefined(), 6);
  sourceObject = obj11669;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11677 == NULL) {
    strlit11677 = alloc_String("start");
    gc_root(strlit11677);
  }
// compilenode returning strlit11677
  adddatum2(obj11669, strlit11677, 1);
  sourceObject = obj11669;
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11678 = alloc_Float64(1);
// compilenode returning num11678
  adddatum2(obj11669, num11678, 2);
  sourceObject = obj11669;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11679 = alloc_Float64(0);
// compilenode returning num11679
  adddatum2(obj11669, num11679, 3);
  sourceObject = obj11669;
// Begin line 31
  setline(31);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11680 = alloc_Float64(0);
// compilenode returning num11680
  adddatum2(obj11669, num11680, 4);
  sourceObject = obj11669;
// Begin line 32
  setline(32);
  setmodule(modulename);
  setsource(originalSourceLines);
  if (strlit11681 == NULL) {
    strlit11681 = alloc_String("");
    gc_root(strlit11681);
  }
// compilenode returning strlit11681
  adddatum2(obj11669, strlit11681, 5);
  sourceObject = obj11669;
// Begin line 33
  setline(33);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object num11682 = alloc_Float64(0);
// compilenode returning num11682
  adddatum2(obj11669, num11682, 6);
objclass11669 = obj11669->class;
  objclass11669->definitionModule = modulename;
  objclass11669->definitionLine = 27;
  (*(struct UserObject *)self).data[0] = lowerouter11669;
  self = oldself11669;
  selfslot = oldselfslot11669;
  stackframe = oldstackframe11669;
// compilenode returning obj11669
  *var_lastToken = obj11669;
  if (obj11669 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11683 = createclosure(1, "lastToken");
setclosureframe(closure11683, stackframe);
  addtoclosure(closure11683, var_lastToken);
  struct UserObject *uo11683 = (struct UserObject*)self;
  uo11683->data[93] = (Object)closure11683;
  Method *meth_meth_parser_lastToken11683 = addmethod2pos(self, "lastToken", &meth_parser_lastToken11683, 93);
int argcv_meth_parser_lastToken11683[] = {0};
meth_meth_parser_lastToken11683->type = alloc_MethodType(1, argcv_meth_parser_lastToken11683);
  meth_meth_parser_lastToken11683->definitionModule = modulename;
  meth_meth_parser_lastToken11683->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11684 = createclosure(1, "lastToken:=");
setclosureframe(closure11684, stackframe);
  addtoclosure(closure11684, var_lastToken);
  struct UserObject *uo11684 = (struct UserObject*)self;
  uo11684->data[94] = (Object)closure11684;
  Method *meth_meth_parser_lastToken_58__61_11684 = addmethod2pos(self, "lastToken:=", &meth_parser_lastToken_58__61_11684, 94);
int argcv_meth_parser_lastToken_58__61_11684[] = {1};
meth_meth_parser_lastToken_58__61_11684->type = alloc_MethodType(1, argcv_meth_parser_lastToken_58__61_11684);
  meth_meth_parser_lastToken_58__61_11684->definitionModule = modulename;
  meth_meth_parser_lastToken_58__61_11684->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// Begin line 36
  setline(36);
  setmodule(modulename);
  setsource(originalSourceLines);
  Object bool11686 = alloc_Boolean(0);
// compilenode returning bool11686
  *var_comment = bool11686;
  if (bool11686 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11687 = createclosure(1, "comment");
setclosureframe(closure11687, stackframe);
  addtoclosure(closure11687, var_comment);
  struct UserObject *uo11687 = (struct UserObject*)self;
  uo11687->data[95] = (Object)closure11687;
  Method *meth_meth_parser_comment11687 = addmethod2pos(self, "comment", &meth_parser_comment11687, 95);
int argcv_meth_parser_comment11687[] = {0};
meth_meth_parser_comment11687->type = alloc_MethodType(1, argcv_meth_parser_comment11687);
  meth_meth_parser_comment11687->definitionModule = modulename;
  meth_meth_parser_comment11687->definitionLine = 3523;
// compilenode returning 
// Begin line 3523
  setline(3523);
  setmodule(modulename);
  setsource(originalSourceLines);
  block_savedest(self);
  Object closure11688 = createclosure(1, "comment:=");
setclosureframe(closure11688, stackframe);
  addtoclosure(closure11688, var_comment);
  struct UserObject *uo11688 = (struct UserObject*)self;
  uo11688->data[96] = (Object)closure11688;
  Method *meth_meth_parser_comment_58__61_11688 = addmethod2pos(self, "comment:=", &meth_parser_comment_58__61_11688, 96);
int argcv_meth_parser_comment_58__61_11688[] = {1};
meth_meth_parser_comment_58__61_11688->type = alloc_MethodType(1, argcv_meth_parser_comment_58__61_11688);
  meth_meth_parser_comment_58__61_11688->definitionModule = modulename;
  meth_meth_parser_comment_58__61_11688->definitionLine = 3523;
// compilenode returning 
// compilenode returning done
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// compilenode returning 
// Begin line 69
  setline(69);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 84
  setline(84);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 188
  setline(188);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 203
  setline(203);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 210
  setline(210);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 326
  setline(326);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 583
  setline(583);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 974
  setline(974);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1569
  setline(1569);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1602
  setline(1602);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1692
  setline(1692);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1704
  setline(1704);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2107
  setline(2107);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2238
  setline(2238);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2333
  setline(2333);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2426
  setline(2426);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2469
  setline(2469);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2491
  setline(2491);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2517
  setline(2517);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2594
  setline(2594);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2683
  setline(2683);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2775
  setline(2775);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 2856
  setline(2856);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3053
  setline(3053);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3111
  setline(3111);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3144
  setline(3144);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3172
  setline(3172);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3197
  setline(3197);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3267
  setline(3267);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3308
  setline(3308);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3374
  setline(3374);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3391
  setline(3391);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
// Begin line 3401
  setline(3401);
  setmodule(modulename);
  setsource(originalSourceLines);
// compilenode returning 
  gc_frame_end(frame);
  return self;
}
